prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4487
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4487 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4487
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116283800801403921')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'sv'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4487)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113354'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4487)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4487)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4487)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4487)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4487)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4487)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.sv'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4487)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4487)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4487)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4487)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4487)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4487)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.sv'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4487)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4487)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4487)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4487)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4487)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4487)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.sv'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4487)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4487)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.sv'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4487)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4487)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.sv'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4487)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4487)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.sv'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4487)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4487)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4487)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.sv'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4487
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4487)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4487)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4487)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4487
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4487)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4487
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4487)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4487
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4487)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4487
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4487)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4487
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4487)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4487
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4487
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4487)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4487)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4487)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4487)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4487)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4487)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4487)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4487)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4487)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4487)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4487)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4487)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4487)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4487)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4487)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4487)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4487)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4487)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4487)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4487)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4487)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4487)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4487
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4487)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4487)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4487)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4487)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4487)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4487
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4487)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4487
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4487)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4487
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4487)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4487
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4487)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4487
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4487)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4487
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4487)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4487)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4487)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4487)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4487)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4487)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4487)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4487)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4487)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4487
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4487)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4487)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4487)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4487)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4487)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4487)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4487)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4487
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4487)
,p_page_name=>'winlov'
,p_page_title=>unistr('S\00F6k i dialogruta')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('S\00F6k')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('St\00E4ng')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('N\00E4sta &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; F\00F6reg\00E5ende')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Rad(er) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4487
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4487)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4487
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4487)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4487)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4487)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4487)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4487)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4487)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4487)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4487)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4487)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4487)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4487)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4487)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4487)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4487)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4487)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4487)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4487)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4487)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4487)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4487)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4487)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4487)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4487)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4487)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4487)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4487)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4487)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4487)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4487)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4487)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4487)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4487)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4487)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4487)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4487)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4487)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4487)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4487)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4487)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4487)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4487)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4487)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4487)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4487)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4487)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4487)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4487)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4487)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4487)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4487)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4487)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4487)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4487)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4487)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4487)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4487)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4487)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4487)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4487)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4487)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4487)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4487)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4487)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4487)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4487)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4487)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4487)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4487)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4487)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4487)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4487)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4487)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4487)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4487)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4487)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4487)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4487)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4487)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4487)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4487)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4487)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4487)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4487)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4487)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4487)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4487)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4487)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4487)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4487)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4487)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4487)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4487)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4487)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4487)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4487)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4487)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4487)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4487)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4487)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4487)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4487)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4487)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4487)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4487)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4487)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4487)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4487)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4487)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4487)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4487)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4487)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4487)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4487)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4487)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4487)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4487)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4487)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4487)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4487)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4487)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4487)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4487)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4487)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4487)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4487)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4487)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4487)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4487)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4487)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4487)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4487)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4487)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4487)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4487)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4487)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4487)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4487)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4487)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4487)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4487)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4487)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4487)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4487)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4487)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4487)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4487)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4487)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4487)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4487)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4487)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4487)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4487)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4487)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4487)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4487)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4487)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4487)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4487)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4487)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4487)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4487)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4487)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4487)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4487)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4487)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4487)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4487)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4487)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4487)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4487)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4487)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4487)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233638090402337)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'sv'
,p_message_text=>'Kolumn %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220758801402327)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'sv'
,p_message_text=>unistr('Administrat\00F6r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220613649402327)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarnamn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277997618402371)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Nekad \00E5tkomst')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237697390402340)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'sv'
,p_message_text=>'Ditt %0-konto har skapats.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223292465402329)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'sv'
,p_message_text=>unistr('Kontot \00E4r l\00E5st.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213101205402321)
,p_name=>'AM_PM'
,p_message_language=>'sv'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347505796402438)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4xla %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355616595402445)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'sv'
,p_message_text=>'(Aktiv)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325181622402421)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ajax-anropet returnerade serverfelet %0 f\00F6r %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255926409402354)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'sv'
,p_message_text=>'Applikationsaliaset "%0" kan inte konverteras till ett unikt applikations-id.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256096722402354)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Det finns ingen applikation med aliaset "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245671069402346)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-1816 Ov\00E4ntat fel vid konvertering av applikationsaliaset p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338553059402432)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Med kontrollsumman f\00F6r applikation f\00E5r du ett enkelt s\00E4tt att avg\00F6ra om samma applikation anv\00E4nds i flera arbetsytor. Du kan j\00E4mf\00F6ra kontrollsumman f\00F6r att avg\00F6ra om det finns en matchning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231449865402336)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid bearbetning av autentiseringsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216876153402324)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid bearbetning av autentiseringsfunktion.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380332291402464)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'sv'
,p_message_text=>unistr('Namnet p\00E5 tenant %0 som returnerades av Oracle Cloud Identity Management \00E4r inte beh\00F6rigt f\00F6r dom\00E4nen %1!<br/><a href="&LOGOUT_URL.">Logga in igen</a> och ange ett beh\00F6rigt tenantnamn eller \00E4ndra URL:en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214518843402322)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'sv'
,p_message_text=>unistr('Ditt konto "%0" har inte den utvecklingsbeh\00F6righet som kr\00E4vs (DB_DEVELOPER eller DB_ADMINISTRATOR)<br/>f\00F6r arbetsytan "%1"! <a href="&LOGOUT_URL.">Logga in igen</a> n\00E4r beh\00F6righeten har tillhandah\00E5llits.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213622865402321)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'sv'
,p_message_text=>unistr('Namnet p\00E5 tenant som returnerades av Oracle Cloud Identity Management har inte beh\00F6righet f\00F6r den aktuella arbetsytan!<br/><a href="&LOGOUT_URL.">Logga in igen</a> och ange ett beh\00F6rigt tenant-namn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214665828402322)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'sv'
,p_message_text=>unistr('Av s\00E4kerhetssk\00E4l till\00E5ts inte k\00F6rning av applikationer f\00F6r den h\00E4r arbetsytan via dom\00E4nen i URL:en.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231119682402335)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Be databasadministrat\00F6ren k\00F6ra $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231086781402335)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'sv'
,p_message_text=>unistr('SYS.DBMS_LDAP-paketet finns inte eller \00E4r ogiltigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230987636402335)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av redigering av LDAP-anv\00E4ndarfunktionen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231254739402335)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid bearbetning av LDAP-autentisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232068873402336)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel i argumentet p_flow_page f\00F6r proceduren login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231652888402336)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'sv'
,p_message_text=>'Ogiltig p_session i wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279599813402372)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'sv'
,p_message_text=>'Felaktigt utformat argument till wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231726918402336)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett null-anv\00E4ndarnamn \00F6verf\00F6rdes till inloggningsproceduren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220543324402326)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4nta <span id="apex_login_throttle_sec">%0</span> sekunder innan du loggar in igen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221884204402328)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Inloggningsf\00F6rs\00F6ket har blockerats.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277324718402370)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Hittar inte autentiseringen "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222162146402328)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00E4kerhetsgrupp-id \00E4r null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231536533402336)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid k\00F6rning av processen efter autentisering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231337273402336)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av processen f\00F6re autentisering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232590200402336)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00D6ppna URL:en i samma webbl\00E4sare som du initierade beg\00E4ran om att \00E5terst\00E4lla l\00F6senord i. Om du klickar p\00E5 URL:en f\00F6r att \00E5terst\00E4lla l\00F6senord och omdirigeras till'),
unistr('inloggningssidan initierar du beg\00E4ran om att \00E5terst\00E4lla l\00F6senord igen och l\00E4mnar'),
unistr('webbl\00E4saren \00F6ppen.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377853782402462)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'sv'
,p_message_text=>unistr('URL f\00F6r att \00E5terst\00E4lla l\00F6senord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214854404402322)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'sv'
,p_message_text=>'Resurshanterarkonsumentgrupp %0 har inte beviljats %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214996749402322)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nd DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP till att bevilja den saknade beh\00F6righeten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242975216402344)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av funktionen f\00F6r sessionsvaktpost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243032343402344)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av funktionen f\00F6r sessionsverifiering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243251544402345)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Be %0-administrat\00F6ren konfigurera motorn f\00F6r enkel inloggning f\00F6r Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252758329402352)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'sv'
,p_message_text=>unistr('Otill\00E5ten %0 i %1-token returnerades av sso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231915475402336)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'sv'
,p_message_text=>unistr('Redigera autentiseringsschemat och l\00E4gg till applikationens namn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252433841402351)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'sv'
,p_message_text=>unistr('Otill\00E5ten anropare av %0-procedur:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252614159402352)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'sv'
,p_message_text=>unistr('Otill\00E5ten appsession i urlc-token: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252283381402351)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'sv'
,p_message_text=>'Fel i portal_sso_redirect: Information om applikationsregistering saknas: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243191857402345)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'sv'
,p_message_text=>unistr('Paketet WWSEC_SSO_ENABLER_PRIVATE finns inte eller \00E4r ogiltigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115231866161402336)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittar inte namn p\00E5 registrerad partnerapplikation i autentiseringsschemat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252352917402351)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'sv'
,p_message_text=>'Registrera applikationen enligt beskrivningen i installationsguiden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243364105402345)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid bearbetning av SSO-autentisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352777813402442)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'sv'
,p_message_text=>unistr('Obeh\00F6rig URL: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242786466402344)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid bearbetning av autentisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214771484402322)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'sv'
,p_message_text=>unistr('Arbetsytan "%0" \00E4r inaktiv. Kontakta administrat\00F6ren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215143105402322)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'sv'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221516243402327)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tkomst nekad av applikationens s\00E4kerhetskontroll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221610750402327)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tkomst nekad av sidans s\00E4kerhetskontroll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221719681402328)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid bearbetning av auktorisering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285136741402376)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'sv'
,p_message_text=>unistr('Skapad med %0 med hj\00E4lp av %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285236779402376)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'sv'
,p_message_text=>unistr('k\00E4rlek')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343068619402435)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'sv'
,p_message_text=>unistr('H\00E4ndelsebeskrivning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342837759402435)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'sv'
,p_message_text=>'Slutdatum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343177066402435)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'sv'
,p_message_text=>unistr('H\00E4ndelse-id')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342707607402435)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'sv'
,p_message_text=>'Startdatum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342962164402435)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('H\00E4ndelserubrik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233506296402337)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel i kontrollsummeinneh\00E5ll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233473202402337)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel i kontrollsummeformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297412560402385)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'sv'
,p_message_text=>'Kopierat till Urklipp.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297140096402385)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r webbl\00E4saren saknar st\00F6d f\00F6r kopiering via en knapp eller meny. Prova med Ctrl+C eller Kommando+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285665164402377)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng meddelande')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341630780402434)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'sv'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336155664402430)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'sv'
,p_message_text=>'Aktuell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336065985402430)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'sv'
,p_message_text=>'Inledande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340257131402433)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara en giltig v\00E4rdef\00E4rg. Till exempel: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335935583402430)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj en f\00E4rg')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336236180402430)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4ndra f\00E4rgformat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375426604402460)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rdelista')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375541650402460)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6ppna lista f\00F6r: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355742506402445)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'sv'
,p_message_text=>unistr('(Slutf\00F6rd)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248065382402348)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'sv'
,p_message_text=>unistr('Kontakta applikationsadministrat\00F6ren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262452234402359)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kontakta applikationsadministrat\00F6ren.'),
unistr('Information om incidenten kan f\00E5s via fels\00F6knings-id "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340559093402433)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'sv'
,p_message_text=>'Korrigera felen innan du sparar.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286550647402377)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'sv'
,p_message_text=>'%0 matchningar hittades'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286487108402377)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'sv'
,p_message_text=>'Inga matchningar hittades'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356282588402445)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'sv'
,p_message_text=>unistr('Aktuellt f\00F6rlopp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340909744402433)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Filen som angetts i objektet %0 finns inte i APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329439332402425)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'sv'
,p_message_text=>unistr('Den aktuella versionen av data i databasen har \00E4ndrats sedan anv\00E4ndaren initierade uppdateringsprocessen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298511239402386)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'sv'
,p_message_text=>'Ladda inte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345538032402437)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rbearbetningsfel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345342494402437)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'sv'
,p_message_text=>'Infoga rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359422247402448)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Sekvens: \00C5tg\00E4rd')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345430777402437)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'sv'
,p_message_text=>'Uppdatera rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286908781402378)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'sv'
,p_message_text=>'Popupkalender: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209506713402317)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209674896402317)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345764069402437)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste ha ett v\00E4rde.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345697267402437)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara ett giltigt datum, till exempel %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213285795402321)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara mellan %0 och %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213304791402321)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste infalla p\00E5 eller efter %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213457279402321)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste infalla p\00E5 eller f\00F6re %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290490145402380)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# \00E4r h\00F6gre \00E4n det angivna h\00F6gsta datumet %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290882119402381)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'sv'
,p_message_text=>'#LABEL# matchar inte formatet %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290300212402380)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# \00E4r l\00E4gre \00E4n det angivna l\00E4gsta datumet %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290542103402380)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sv'
,p_message_text=>'#LABEL# ligger inte inom det giltiga intervallet %0 till %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290792999402380)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# ligger inte inom det giltiga \00E5rsintervallet %0 och %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340832656402433)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'sv'
,p_message_text=>'Avbryt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368081892402454)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370032105402456)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340637405402433)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'sv'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340771615402433)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'sv'
,p_message_text=>'Spara'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246911611402347)
,p_name=>'APEX.ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214316445402322)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6ljande fel intr\00E4ffade vid k\00F6rning av \00E5teranrop f\00F6r felhantering: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223034801402329)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett fel intr\00E4ffade vid formatering av felsidan: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215034789402322)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'sv'
,p_message_text=>'Internt fel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354893302402444)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kontakta administrat\00F6ren.'),
unistr('Information om incidenten \00E4r tillg\00E4nglig via fels\00F6knings-id "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349120507402440)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'sv'
,p_message_text=>unistr('Databasen \00E4r \00F6ppen f\00F6r skrivskyddad \00E5tkomst.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379741516402463)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'sv'
,p_message_text=>unistr('ORA-28353: Kunde inte \00F6ppna pl\00E5nboken. Applikationsdata \00E4r inte tillg\00E4ngliga just nu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349275524402440)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Sidan \00E4r inte tillg\00E4nglig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216791271402324)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'sv'
,p_message_text=>unistr('Teknisk information (endast synligt f\00F6r utvecklare)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312886797402397)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'sv'
,p_message_text=>'Felmeddelande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326758662402423)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rv\00E4ntat format: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293429639402382)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndare finns redan i \00E5tkomstkontrollistan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293364534402382)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'sv'
,p_message_text=>unistr('Bekr\00E4fta att f\00F6ljande %0 anv\00E4ndare l\00E4ggs till i \00E5tkomstkontrollistan f\00F6r <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293861486402383)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'sv'
,p_message_text=>unistr('Dubblettanv\00E4ndare finns')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293588978402383)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'sv'
,p_message_text=>'Snabel-a (@) saknas i e-postadressen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293671035402383)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'sv'
,p_message_text=>'Punkt (.) saknas i e-postadressen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293703011402383)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarnamnet \00E4r f\00F6r l\00E5ngt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294009176402383)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'sv'
,p_message_text=>unistr('Endast anv\00E4ndare som har definierats i applikationens \00E5tkomstkontrollista har \00E5tkomst till den h\00E4r applikationen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294173288402383)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('Ov\00E4ntat v\00E4rde f\00F6r \00E5tkomstkontrollinst\00E4llning: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293920242402383)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'sv'
,p_message_text=>unistr('Alla autentiserade anv\00E4ndare har \00E5tkomst till den h\00E4r applikationen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336760292402430)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'sv'
,p_message_text=>'Inaktiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336686418402430)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'sv'
,p_message_text=>'Aktiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336944146402430)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'sv'
,p_message_text=>unistr('%0: \00E4r inaktiv')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336884413402430)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'sv'
,p_message_text=>unistr('%0: \00E4r aktiv')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336533502402430)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'sv'
,p_message_text=>'ej identifierad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329618609402425)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'sv'
,p_message_text=>'Ladda ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286133445402377)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nt filter: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327225445402423)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'sv'
,p_message_text=>unistr('Till\00E4mpa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212110165402320)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'sv'
,p_message_text=>'Stapeldiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339923590402433)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vriga')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212230467402320)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'sv'
,p_message_text=>'Cirkeldiagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338645107402432)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'sv'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211945018402319)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Antal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327785719402423)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'sv'
,p_message_text=>'Rensa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327843799402423)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'sv'
,p_message_text=>'Rensa alla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327904232402423)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'sv'
,p_message_text=>'Rensa %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345140850402437)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'sv'
,p_message_text=>unistr('Kolumnen %1, som refereras av fasetten %0, \00E4r inte tillg\00E4nglig eller inte auktoriserad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202316861402311)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj vilka filter du vill visa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284313626402376)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'sv'
,p_message_text=>'%0 resultat'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284466958402376)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'sv'
,p_message_text=>'%0 valda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287018608402378)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'sv'
,p_message_text=>'Aktuella filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203840605402312)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'sv'
,p_message_text=>'Filterlista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343623334402435)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'sv'
,p_message_text=>unistr('Gr\00E4nsen f\00F6r unikt id (%0) har \00F6verskridits f\00F6r fasetten %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329224893402425)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('Fasetten %0 st\00F6ds inte f\00F6r kolumnerna DATE eller TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327369880402423)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'sv'
,p_message_text=>'Filtrera %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327461118402423)
,p_name=>'APEX.FS.GO'
,p_message_language=>'sv'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328850806402424)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'sv'
,p_message_text=>'lika med %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212906006402321)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'sv'
,p_message_text=>unistr('inneh\00E5ller %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212651043402320)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'sv'
,p_message_text=>unistr('st\00F6rre \00E4n %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212771712402320)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'sv'
,p_message_text=>unistr('st\00F6rre \00E4n eller lika med %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212447268402320)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'sv'
,p_message_text=>unistr('mindre \00E4n %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212531137402320)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'sv'
,p_message_text=>unistr('mindre \00E4n eller lika med %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212842284402320)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'sv'
,p_message_text=>unistr('b\00F6rjar med %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215360104402322)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('%0-datatypen (%1) st\00F6ds inte f\00F6r indataf\00E4ltsfasetten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205580536402314)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6r flerv\00E4rdesfasetter kr\00E4vs databaser av version 12.2 eller senare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329037964402424)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga s\00F6kkolumner har angetts f\00F6r fasetten %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202415622402311)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'sv'
,p_message_text=>'Fler filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284599067402376)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'sv'
,p_message_text=>unistr('Intervallets b\00F6rjan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328534869402424)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'sv'
,p_message_text=>'%0 till %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328644287402424)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6ver %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328716150402424)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'sv'
,p_message_text=>'Under %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284675608402376)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'sv'
,p_message_text=>'Intervallets slut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347449730402438)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rdelisteobjektet #%2 ("%1") f\00F6r intervallfasetten %0 \00E4r ogiltig (avgr\00E4nsaren "|" saknas).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328972882402424)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'sv'
,p_message_text=>unistr('Manuell inmatning av intervallfasetten %0 st\00F6ds inte f\00F6r n\00E4rvarande eftersom kolumnen \00E4r DATE eller TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328254495402424)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'sv'
,p_message_text=>'till'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212094165402320)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281152742402373)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327690889402423)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327579249402423)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328420665402424)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211853077402319)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'sv'
,p_message_text=>'Visa diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328035736402423)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'sv'
,p_message_text=>unistr('Visa f\00E4rre')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328166757402424)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'sv'
,p_message_text=>'Visa fler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115328393255402424)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 stj\00E4rnor eller fler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286046656402377)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'sv'
,p_message_text=>unistr('Filterf\00F6rslag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329144279402424)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('Textf\00E4ltfasetten %0 st\00F6ds f\00F6r n\00E4rvarande endast f\00F6r NUMBER-kolumner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202212605402311)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Totalt antal rader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345284219402437)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('%0-datatypen (%1) st\00F6ds inte f\00F6r fasetts\00F6kning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337137468402430)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('G\00E5 till felet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294758564402383)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Aggregera.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302378015402389)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'sv'
,p_message_text=>'Komprimera kontrollstopp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294839168402383)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Kontrollstopp.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302295515402389)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'sv'
,p_message_text=>'Expandera kontrollstopp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380990667402464)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Kolumn %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302020798402389)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'sv'
,p_message_text=>'%0 rader har tagits bort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372473445402458)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'sv'
,p_message_text=>'Dubblettidentitet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291778730402381)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rsta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295058337402384)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Grupprubrik.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294900737402384)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Rubrik.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291821769402381)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'sv'
,p_message_text=>'Sista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311897943402396)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'sv'
,p_message_text=>'Ladda fler rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291577683402381)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295197859402384)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'sv'
,p_message_text=>'Sidrader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291945354402381)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'sv'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292062779402381)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \2013 %1 av %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348067593402439)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'sv'
,p_message_text=>'Val av sida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291630650402381)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372216543402457)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'sv'
,p_message_text=>'Tillagd'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372382366402457)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4ndrad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380795496402464)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Rad: %0, kolumn: %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380826923402464)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>'Rad %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372160336402457)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'sv'
,p_message_text=>'Borttagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295371793402384)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'sv'
,p_message_text=>'Radrubrik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290959874402381)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 celler \00E4r valda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292197089402381)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'sv'
,p_message_text=>'%0 rader har valts'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332410187402427)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'sv'
,p_message_text=>'Markera alla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302139196402389)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'sv'
,p_message_text=>'Sidan %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295266430402384)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj rad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295497824402384)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'sv'
,p_message_text=>'Sorterad stigande %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295515915402384)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'sv'
,p_message_text=>'Sorterad fallande %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291044188402381)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'sv'
,p_message_text=>'Sortera i stigande ordning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291379144402381)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'sv'
,p_message_text=>'Sortera stigande %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291120174402381)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'sv'
,p_message_text=>'Sortera i fallande ordning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291437638402381)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'sv'
,p_message_text=>'Sortera fallande %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115291229458402381)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'sv'
,p_message_text=>'Sortera inte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301975253402389)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'sv'
,p_message_text=>'Totalsumma %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228351059402333)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('HTTP-beg\00E4ran till "%0" utf\00F6rdes inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369683123402455)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'sv'
,p_message_text=>unistr('Ruturvalslista %0 kolumner %1 rader. Anv\00E4nd piltangenterna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301810131402389)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj %0 listrader. Anv\00E4nd piltangenterna.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380525802402464)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'sv'
,p_message_text=>unistr('Interaktivt rutn\00E4t %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288678768402379)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tg\00E4rder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289662819402380)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289579477402379)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till rad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374032621402459)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'sv'
,p_message_text=>'Aggregera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359502240402448)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'sv'
,p_message_text=>'Aggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361254587402449)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'sv'
,p_message_text=>'Alla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317633847402401)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Alla textkolumner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318826359402402)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'sv'
,p_message_text=>'Alternativ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319955665402402)
,p_name=>'APEX.IG.AND'
,p_message_language=>'sv'
,p_message_text=>'och'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339304664402432)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'sv'
,p_message_text=>unistr('Ungef\00E4rligt antal unika')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375046497402459)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'sv'
,p_message_text=>unistr('Ungef\00E4rligt totalt antal unika')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358103986402447)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'sv'
,p_message_text=>'Area'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360064647402448)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'sv'
,p_message_text=>'Stigande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318903777402402)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Beh\00F6righet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374109233402459)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'sv'
,p_message_text=>'Automatiskt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339764383402432)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'sv'
,p_message_text=>'Genomsnitt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374778517402459)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vergripande genomsnitt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357665646402446)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Etikett f\00F6r axelrubrik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357836085402446)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'sv'
,p_message_text=>'Antal decimaler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357735855402446)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde f\00F6r axelrubrik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363863061402451)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Bakgrundsf\00E4rg')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358278090402447)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'sv'
,p_message_text=>'Stapel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314246226402398)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'sv'
,p_message_text=>'mellan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365080794402452)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'sv'
,p_message_text=>unistr('B\00E5da')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358394977402447)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'sv'
,p_message_text=>'Bubbla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289863153402380)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'sv'
,p_message_text=>'Avbryt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319857864402402)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'sv'
,p_message_text=>unistr('Skiftl\00E4gesk\00E4nslig')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375603924402460)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'sv'
,p_message_text=>unistr('(Skiftl\00E4gesk\00E4nslig)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346564759402438)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4ndringarna har sparats')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290260125402380)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4ndra vy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320999827402418)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'sv'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317421813402401)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Din fr\00E5ga \00F6verskrider det maximala antalet p\00E5 %0 datapunkter per diagram. Till\00E4mpa ett filter f\00F6r att minska antalet poster i din basfr\00E5ga.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288597447402379)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Diagramvy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295859408402384)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'sv'
,p_message_text=>'Rensa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357167302402446)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364018467402451)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00E4rger')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340133248402433)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rhandsgranska')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319229755402402)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Kolumn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288740584402379)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Kolumner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365854704402452)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Kolumnsyfte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319311738402402)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'sv'
,p_message_text=>'Komplex'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288987270402379)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ber\00E4kna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314840865402399)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'sv'
,p_message_text=>unistr('inneh\00E5ller')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321181955402418)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'sv'
,p_message_text=>'Kontrollstopp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295647290402384)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'sv'
,p_message_text=>'Kopiera till Urklipp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295768615402384)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'sv'
,p_message_text=>'Kopiera ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339175249402432)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'sv'
,p_message_text=>'Antal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339212072402432)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'sv'
,p_message_text=>'Antal unika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374964420402459)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'sv'
,p_message_text=>'Totalt antal unika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374898087402459)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'sv'
,p_message_text=>'Totalt antal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372580557402458)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'sv'
,p_message_text=>'Skapa %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317821000402401)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'sv'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365659093402452)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Datatyp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365284556402452)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'sv'
,p_message_text=>'Datum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346373435402438)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltigt datumv\00E4rde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315573883402399)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'sv'
,p_message_text=>'dagar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318514871402401)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('Standardinst\00E4llningar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318318180402401)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Standardtyp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289799104402380)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'sv'
,p_message_text=>'Ta bort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366864290402453)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'sv'
,p_message_text=>unistr('Vill du verkligen ta bort den h\00E4r rapporten?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322937208402420)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'sv'
,p_message_text=>'Ta bort rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321713705402419)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'sv'
,p_message_text=>'Ta bort rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360128743402448)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'sv'
,p_message_text=>'Fallande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320650376402418)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'sv'
,p_message_text=>'Detalj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288293323402379)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Detaljvy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348882273402440)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'sv'
,p_message_text=>'Riktning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320327225402403)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'sv'
,p_message_text=>'Inaktiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314962121402399)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'sv'
,p_message_text=>unistr('inneh\00E5ller inte')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315123698402399)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'sv'
,p_message_text=>unistr('b\00F6rjar inte med')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358466041402447)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'sv'
,p_message_text=>'Ring'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321381268402419)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'sv'
,p_message_text=>'Ladda ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220073053402326)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'sv'
,p_message_text=>'Endast data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367820550402454)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj format')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232642152402337)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'sv'
,p_message_text=>unistr('Nedladdningsformatet %0 \00E4r inte aktiverat.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360888388402449)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'sv'
,p_message_text=>'Dubblettaggregering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360945746402449)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'sv'
,p_message_text=>'Dubblettkontrollstopp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322809226402420)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'sv'
,p_message_text=>'Duplicera rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321655770402419)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'sv'
,p_message_text=>'Duplicerade rader'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289306591402379)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'sv'
,p_message_text=>'Redigera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359968370402448)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'sv'
,p_message_text=>'Redigera diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371492668402457)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>'Redigera grupp per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367448253402454)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'sv'
,p_message_text=>'Hemlig kopia (bcc)'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367675116402454)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'sv'
,p_message_text=>'Meddelande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367388919402453)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'sv'
,p_message_text=>'Kopia (cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367065171402453)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'sv'
,p_message_text=>'E-postmeddelande har skickats.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367542343402454)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4mne')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367267790402453)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'sv'
,p_message_text=>'Mottagare (till)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320062169402403)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'sv'
,p_message_text=>'Aktiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313212100402398)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'sv'
,p_message_text=>'lika med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366471767402453)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'sv'
,p_message_text=>'Exempel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320174905402403)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'sv'
,p_message_text=>'Uttryck'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366383694402453)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332354492402427)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'sv'
,p_message_text=>unistr('Fil f\00F6rberedd. Startar nedladdning.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115295982021402384)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'sv'
,p_message_text=>'Fyll'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297027900402385)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Fyll urval med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296903948402385)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'sv'
,p_message_text=>'Fyll urval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288835191402379)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'sv'
,p_message_text=>'Filtrera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319456698402402)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'sv'
,p_message_text=>'Filter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374408473402459)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'sv'
,p_message_text=>'Filtrera...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360313297402448)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rsta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289005112402379)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'sv'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317939045402401)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364934009402452)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'sv'
,p_message_text=>'Formatmask'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366776574402453)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'sv'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366687159402453)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'sv'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279412155402372)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'sv'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218776522402325)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'sv'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322583815402419)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E5s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320228538402403)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'sv'
,p_message_text=>'Funktioner och operatorer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358527560402447)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'sv'
,p_message_text=>'Tratt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339010131402432)
,p_name=>'APEX.IG.GO'
,p_message_language=>'sv'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313870141402398)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'sv'
,p_message_text=>unistr('st\00F6rre \00E4n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313963854402398)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'sv'
,p_message_text=>unistr('st\00F6rre \00E4n eller lika med')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320581301402418)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'sv'
,p_message_text=>unistr('Rutn\00E4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288051333402378)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('Rutn\00E4tsvy')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361196942402449)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'sv'
,p_message_text=>'Grupp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320770828402418)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>'Gruppera per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288378488402379)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Gruppera per-vy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365595486402452)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Villkorstyp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364405976402451)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'sv'
,p_message_text=>'Rubrik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364605067402451)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'sv'
,p_message_text=>'Rubrikjustering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374390694402459)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369883734402455)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Du kan infoga, uppdatera och ta bort data direkt i det interaktiva rutn\00E4tet.</p>'),
'',
unistr('<p>Infoga en ny rad genom att klicka p\00E5 knappen L\00E4gg till rad.</p>'),
'',
unistr('<p>Redigera befintliga data genom att dubbelklicka p\00E5 en cell. F\00F6r mer omfattande redigering klickar du p\00E5 Redigera f\00F6r att starta redigeringsl\00E4get. I redigeringsl\00E4get kan du redigera best\00E4mda celler genom att klicka en g\00E5ng eller anv\00E4nda tangentbord')
||'et.</p>',
'',
unistr('<p>Anv\00E4nd menyn \00C4ndra till att duplicera och ta bort rader. Du aktiverar menyn \00C4ndra genom att markera en eller flera rader med hj\00E4lp av kryssrutorna.</p>'),
'',
unistr('<p>Duplicera en vald rad genom att klicka p\00E5 menyn \00C4ndra och v\00E4lja Duplicera rader. Ta bort en rad genom att klicka p\00E5 menyn \00C4ndra och v\00E4lja Ta bort rad.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371949166402457)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'sv'
,p_message_text=>'Redigeringsfunktioner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372010509402457)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I ett interaktivt rutn\00E4t visas en upps\00E4ttning data i en anpassningsbar rapport som det g\00E5r att s\00F6ka i. Du kan utf\00F6ra ett flertal \00E5tg\00E4rder f\00F6r att begr\00E4nsa vilka poster som returneras och du kan \00E4ndra hur data visas.</p>'),
'',
unistr('<p>Med s\00F6kf\00E4ltet kan du filtrera de poster som returneras. Klicka p\00E5 \00C5tg\00E4rder f\00F6r att komma \00E5t ett flertal alternativ f\00F6r anpassning av rapportens layout och anv\00E4nd kolumnrubriksmenyerna p\00E5 de kolumner som visas.</p>'),
'',
unistr('<p>Anv\00E4nd rapportinst\00E4llningarna om du vill spara dina anpassningar av en rapport. Du kan ocks\00E5 ladda ned data fr\00E5n rapporten till en extern fil eller skicka dem via e-post till dig sj\00E4lv och andra.</p>'),
'',
unistr('<p>Mer information finns i "Anv\00E4nda interaktiva rutn\00E4t" i <em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371718520402457)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6versikt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369794198402455)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Du kan anpassa det interaktiva rutn\00E4tet f\00F6r att visa data p\00E5 ett flertal olika s\00E4tt med de inbyggda funktionerna.</p>'),
'',
unistr('<p>Anv\00E4nd kolumnrubrikmenyerna eller menyn \00C5tg\00E4rder f\00F6r att best\00E4mma vilka kolumner som ska visas, i vilken ordning de ska visas och f\00F6r att frysa kolumner. Du kan ocks\00E5 definiera olika datafilter och sortera de data som returneras.</p>'),
'',
unistr('<p>Anv\00E4nd knappen Visa (bredvid s\00F6kf\00E4ltet) till att komma \00E5t andra datavyer som kan ha definierats av applikationsutvecklaren. Du kan \00E4ven skapa ett diagram eller visa ett befintligt diagram.</p>  '),
'',
unistr('<p><em>Obs! Klicka p\00E5 <strong>Hj\00E4lp</strong> i dialogrutorna f\00F6r det interaktiva rutn\00E4tet om du vill ha mer ing\00E5ende information om den valda funktionen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371865088402457)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'sv'
,p_message_text=>'Rapporteringsfunktioner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321543560402419)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r interaktivt rutn\00E4t')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368606807402454)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du aggregera kolumner. Aggregerade v\00E4rden visas i slutet av alla data eller, om kontrollstopp har definierats, i slutet av varje stopp.</p>'),
'',
'<p><strong>Aggregeringslista</strong><br>',
'I aggregeringslistan visas definierade aggregeringar. Inaktivera en befintlig aggregering genom att avmarkera den.<br>',
unistr('Klicka p\00E5 L\00E4gg till ( &plus; ) f\00F6r att skapa en ny aggregering och p\00E5 ta bort ( &minus; ) f\00F6r att ta bort en befintlig aggregering.</p>'),
'',
unistr('<p><strong>Aggregeringsinst\00E4llningar</strong><br>'),
unistr('Anv\00E4nd formul\00E4ret till h\00F6ger till att definiera aggregeringen.<br>'),
unistr('V\00E4lj kolumnnamn och aggregeringstyp.<br>'),
unistr('Du kan \00E4ven ange en knappbeskrivning f\00F6r aggregeringen.<br>'),
unistr('Om du har definierat ett kontrollstopp kan du v\00E4lja <strong>Visa totalv\00E4rde</strong> s\00E5 visas totalt genomsnitt, totalsumma eller liknande v\00E4rde i slutet av alla data.</p>'),
'',
unistr('<p><em>Obs! \00D6ppna dialogrutan Aggregering via menyn \00C5tg\00E4rder eller genom att klicka p\00E5 kolumnrubriken och summan ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370850062402456)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r aggregering')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369367724402455)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du definiera ett diagram som visas som en separat datavy.<br>'),
unistr('V\00E4lj en diagramtyp och diagramattribut.</p>'),
'<p><strong>Diagramattribut</strong></br>',
unistr('De tillg\00E4ngliga diagramattributen varierar beroende p\00E5 diagramtyp.</p>'),
'<p>',
'<ul>',
unistr('  <li>V\00E4lj kolumnen som inneh\00E5ller v\00E4rdet f\00F6r attributet:'),
'    <ul>',
unistr('      <li>Etikett - texten f\00F6r alla datapunkter.</li>'),
unistr('      <li>V\00E4rde - data som ska plottas.</li>'),
unistr('      <li>Serier - anv\00E4nds till att definiera dynamiska fr\00E5gor med flera serier.</li>'),
unistr('      <li>\00D6ppning - det dagliga \00F6ppningspriset p\00E5 b\00F6rsen (endast b\00F6rskurs).</li>'),
unistr('      <li>St\00E4ngning - det dagliga st\00E4ngningspriset p\00E5 b\00F6rsen (endast b\00F6rskurs).</li>'),
unistr('      <li>H\00F6gt - det h\00F6ga v\00E4rdet (endast intervall och b\00F6rskurs).</li>'),
unistr('      <li>L\00E5gt - det l\00E5ga v\00E4rdet (endast intervall och b\00F6rskurs).</li>'),
unistr('      <li>Volym - den dagliga b\00F6rskursvolymen (endast b\00F6rskurs).</li>'),
unistr('      <li>M\00E5l - m\00E5lv\00E4rdet (endast tratt).</li>'),
unistr('      <li>X - v\00E4rdet f\00F6r x-axeln (endast bubbla och spridning).</li>'),
unistr('      <li>Y - v\00E4rdet f\00F6r y-axeln (bubbla och spridning).</li>'),
'      <li>Z - stapelbredden eller bubbelradien (endast stapel, bubbla och intervall).</li>',
'    </ul>',
'  </li>',
'  <li>Orientering - vertikal eller horisontell.</li>',
unistr('  <li>Aggregering - v\00E4lj hur diagramv\00E4rdena ska aggregeras.</li>'),
'  <li>Stapla - ange om dataobjekten ska staplas.</li>',
unistr('  <li>Sortera per - sortera per etikett eller v\00E4rde(n).'),
'    <ul>',
unistr('      <li>Riktning - sortera per stigande eller sjunkande v\00E4rden.</li>'),
unistr('      <li>Null-v\00E4rden - ange hur poster med null-v\00E4rden ska sorteras i relation till poster med icke-null-v\00E4rden.</li>'),
'    </ul>',
'  </li>',
'  <li>Antalet decimaler</li>',
unistr('  <li>Etikett f\00F6r axelrubrik</li>'),
unistr('  <li>V\00E4rde f\00F6r axelrubrik</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371280943402457)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r diagram')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368309449402454)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du v\00E4lja vilka kolumner som ska visas och i vilken ordning de ska visas.</p>'),
'',
unistr('<p>D\00F6lj en kolumn genom att avmarkera den.<br>'),
unistr('\00C4ndra ordningen p\00E5 kolumner genom att klicka p\00E5 Flytta upp ( &uarr; ) eller Flytta ned ( &darr; ).<br>'),
unistr('Anv\00E4nd listrutev\00E4ljaren till att lista alla kolumner, visade kolumner eller dolda kolumner.</p>'),
'',
unistr('<p>Du kan \00E4ven anv\00E4nda formul\00E4ret till att ange en kolumns minsta bredd i pixlar.</p>'),
'',
unistr('<p><em>Obs! Du kan ocks\00E5 \00E4ndra ordningen p\00E5 kolumner som visas genom att klicka p\00E5 skjutreglaget (i b\00F6rjan av kolumnrubriken) och dra kolumnen \00E5t v\00E4nster eller h\00F6ger. Du kan ocks\00E5 \00E4ndra kolumnbredden p\00E5 kolumner som visas genom att v\00E4lja kolumnavgr\00E4n')
||unistr('saren, mellan rubriker, och flytta den \00E5t v\00E4nster eller h\00F6ger.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371178687402456)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r kolumner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368763147402455)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du definiera ytterligare kolumner baserat p\00E5 matematiska ber\00E4kningar och funktionsber\00E4kningar som utf\00F6rs mot befintliga kolumner.</p>'),
'',
unistr('<p><strong>Ber\00E4kningslista</strong><br>'),
unistr('I ber\00E4kningslistan visas definierade ber\00E4kningar. Inaktivera en befintlig ber\00E4kning genom att avmarkera den.<br>'),
unistr('Klicka p\00E5 L\00E4gg till ( &plus; ) f\00F6r att l\00E4gga till en ny ber\00E4kning och p\00E5 Ta bort ( &minus; ) f\00F6r att ta bort en befintlig ber\00E4kning.</p>'),
'',
unistr('<p><strong>Ber\00E4kningsinst\00E4llningar</strong><br>'),
unistr('Anv\00E4nd formul\00E4ret till att definiera ber\00E4kningen.<br>'),
unistr('Ange kolumninformation som rubrik och etikett och v\00E4lj justeringsinst\00E4llningar.<br> '),
unistr('Anv\00E4nd textomr\00E5det Uttryck till att ange en eller flera kolumner och associerade funktioner f\00F6r ber\00E4kningen.<br>'),
unistr('V\00E4lj l\00E4mplig datatyp, och eventuellt en formatmask, f\00F6r den nya kolumnen.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370771491402456)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r ber\00E4kning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369076196402455)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du definiera ett kontrollstopp p\00E5 en eller flera kolumner.</p>'),
'',
'<p><strong>Lista med kontrollstopp</strong><br>',
'i listan med kontrollstopp visas definierade kontrollstopp. Inaktivera en befintlig kontrollstoppkolumn genom att avmarkera den.<br>',
unistr('Klicka p\00E5 L\00E4gg till ( &plus; ) f\00F6r att inkludera en ny kolumn i kontrollstoppet och p\00E5 Ta bort ( &minus; ) f\00F6r att ta bort en befintlig kolumn fr\00E5n kontrollstoppet.<br>'),
unistr('\00C4ndra ordning p\00E5 kolumner genom att klicka p\00E5 Flytta upp ( &uarr; ) och p\00E5 Flytta ned ( &darr; ) f\00F6r att flytta den valda kolumnen upp\00E5t eller ned\00E5t i relation till de andra kolumnerna.</p>'),
'',
unistr('<p><strong>Inst\00E4llningar f\00F6r kontrollstopp</strong><br>'),
unistr('Anv\00E4nd formul\00E4ret till att definiera kontrollstoppskolumnen.<br>'),
unistr('V\00E4lj en kontrollstoppskolumn, sorteringsriktning och hur null- kolumner (kolumner utan v\00E4rde) ska sorteras.</p>'),
'',
unistr('<p><em>Obs! N\00E4r du visar det interaktiva rutn\00E4tet kan du definiera ett kontrollstopp genom att klicka p\00E5 en kolumnrubrik och v\00E4lja ikonen f\00F6r kontrollstopp.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370430609402456)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r kontrollstopp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369211140402455)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du ladda ned alla aktuella rader till en extern fil. Filen inneh\00E5ller endast de kolumner som visas vid tillf\00E4llet, med de filter och sorteringar som anv\00E4nds p\00E5 dessa data.</p>'),
'',
unistr('<p>V\00E4lj filformat och klicka p\00E5 Ladda ned.<br>'),
unistr('Obs! Bland kommaavgr\00E4nsade v\00E4rden inkluderas inte textformatering som aggregeringar och kontrollstopp.</p>'),
'',
unistr('<p>Om du vill skicka filen via e-post v\00E4ljer du Skicka som e-post och anger e-postdetaljerna (mottagare, \00E4mne och meddelande).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370235469402456)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r nedladdning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368494676402454)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du konfigurera datafilter som begr\00E4nsar de returnerade raderna.</p>'),
'',
'<p><strong>Filterlista</strong><br>',
'I filterlistan visas definierade filter. Inaktivera ett befintligt filter genom att avmarkera det.<br>',
unistr('Klicka p\00E5 L\00E4gg till ( &plus; ) f\00F6r att skapa ett nytt filter och p\00E5 Ta bort ( &minus; ) f\00F6r att ta bort ett befintligt filter.</p>'),
'',
unistr('<p><strong>Filterinst\00E4llningar</strong><br>'),
unistr('Anv\00E4nd formul\00E4ret till att definiera filteregenskaperna.<br>'),
unistr('V\00E4lj l\00E4mplig filtertyp:<br>'),
'&nbsp;&nbsp;&nbsp;Rad - filtrera efter en term i valfri filtrerbar kolumn.<br>',
unistr('&nbsp;&nbsp;&nbsp;Kolumn - filtrera en best\00E4md kolumn efter operator och v\00E4rde.</p>'),
'',
unistr('<p><em>Obs! N\00E4r du visar det interaktiva rutn\00E4tet kan du definiera radfilter genom att skriva direkt i s\00F6kf\00E4ltet. Klicka p\00E5 V\00E4lj kolumner att s\00F6ka i f\00F6r att begr\00E4nsa s\00F6kningen till en best\00E4md kolumn. Du kan annars \00F6ppna en kolumnrubrikmeny och v\00E4lja ')
||unistr('ett v\00E4rde f\00F6r att skapa ett kolumnfilter.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371057060402456)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r filter')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368802193402455)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du visa data som de var vid en tidigare tidpunkt.</p>'),
unistr('<p>K\00F6r flashbackfr\00E5gan genom att ange antalet minuter i det f\00F6rflutna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370650563402456)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r flashback')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371303788402457)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r Gruppera per')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368902667402455)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du markera rader eller kolumner med data baserat p\00E5 det villkor som anges.</p>'),
'',
'<p><strong>Markeringslista</strong><br>',
'I markeringslistan visas definierade markeringar. Inaktivera en befintlig markering genom att avmarkera den.<br>',
unistr('Klicka p\00E5 L\00E4gg till ( &plus; ) f\00F6r att skapa en ny markering och p\00E5 Ta bort ( &minus; ) f\00F6r att ta bort en befintlig markering.</p>'),
'',
unistr('<p><strong>Inst\00E4llningar f\00F6r markeringar</strong><br>'),
unistr('Anv\00E4nd formul\00E4ret till att definiera egenskaperna f\00F6r markeringen.<br>'),
unistr('Ange namnet, v\00E4lj Rad eller Kolumn och v\00E4lj HTML-f\00E4rgkoder f\00F6r bakgrund och text.<br>'),
unistr('V\00E4lj l\00E4mplig <strong>villkorstyp</strong> f\00F6r att markera specifika data:<br>'),
'&nbsp;&nbsp;&nbsp;Rad - markera villkoret i valfri kolumn.<br>',
unistr('&nbsp;&nbsp;&nbsp;Kolumn - markera inom en specifik kolumn baserat p\00E5 operator och v\00E4rde som angetts.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370500585402456)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r markering')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369162367402455)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du spara \00E4ndringar du gjort i den aktuella rutn\00E4tslayouten och -konfigurationen.<br>'),
unistr('Applikationsutvecklare kan definiera flera alternativa rapportlayouter. N\00E4r det \00E4r till\00E5tet kan du och andra slutanv\00E4ndare spara en rapport som allm\00E4n, vilket g\00F6r rapporten tillg\00E4nglig f\00F6r alla som anv\00E4nder rutn\00E4tet. Du kan ocks\00E5 spara en rapport som')
||' en privat rapport som bara du kan visa.</p>',
unistr('<p>V\00E4lj bland de tillg\00E4ngliga typerna och ange ett namn p\00E5 rapporten.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370311622402456)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Hj\00E4lp f\00F6r rapport'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368586667402454)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>I den h\00E4r dialogrutan kan du st\00E4lla in visningsordningen.</p>'),
'',
'<p><strong>Sorteringslista</strong><br>',
'I dialogrutan Sortera visas en lista med konfigurerade sorteringsregler.<br>',
unistr('Klicka p\00E5 L\00E4gg till ( &plus; ) om du vill skapa en sorteringskolumn och p\00E5 Ta bort ( &minus; ) om du vill ta bort en sorteringskolumn.<br>'),
unistr('Klicka p\00E5 Flytta upp ( &uarr; ) och Flytta ned ( &darr; ) f\00F6r att flytta den valda sorteringskolumnen upp\00E5t eller ned\00E5t i relation till de andra sorteringskolumnerna.</p>'),
'',
unistr('<p><strong>Sorteringsinst\00E4llningar</strong><br>'),
unistr('V\00E4lj en sorteringskolumn, sorteringsriktningen och hur null-kolumner (kolumner utan v\00E4rde) ska ordnas.</p>'),
'',
'<p><em>Obs! Data kan sorteras per kolumner som inte visas, men alla kolumner kanske inte kan sorteras.</em><br>',
unistr('<em>Kolumner som visas kan sorteras genom att du trycker p\00E5 upp\00E5t- (stigande) eller ned\00E5tpilen (sjunkande) i slutet av kolumnrubrikerna. Om du vill l\00E4gga till en efterf\00F6ljande kolumn i en befintlig sortering trycker du ned skift-tangenten och klickar')
||unistr(' p\00E5 upp\00E5t- eller ned\00E5tpilen.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370971897402456)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r sortering')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115370152434402456)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r prenumeration')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322485992402419)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'sv'
,p_message_text=>unistr('D\00F6lj')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289280410402379)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'sv'
,p_message_text=>'Markera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357212649402446)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('H\00F6g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358087035402447)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'sv'
,p_message_text=>'Horisontellt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315484894402399)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'sv'
,p_message_text=>'timmar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320414707402403)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'sv'
,p_message_text=>'Ikon'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288124504402378)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Ikonvyn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313649383402398)
,p_name=>'APEX.IG.IN'
,p_message_language=>'sv'
,p_message_text=>'i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322015021402419)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'sv'
,p_message_text=>unistr('Inaktiv inst\00E4llning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322118905402419)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('Inaktiva inst\00E4llningar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329730486402425)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett internt fel intr\00E4ffade vid bearbetning av den interaktiva rutn\00E4tsbeg\00E4ran.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225597997402331)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('Kolumnfiltertypen "%0" st\00F6ds inte f\00F6r kolumnen "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369926684402455)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt datumformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344123033402436)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('Interaktivt rutn\00E4t har inte st\00F6d f\00F6r definition av ett filter p\00E5 kolumnen %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344072010402436)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r inte en giltig filtertyp f\00F6r definition av ett filter f\00F6r interaktivt rutn\00E4t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230688550402335)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt talformat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372695932402458)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig inst\00E4llning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372767229402458)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltiga inst\00E4llningar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363756115402451)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'sv'
,p_message_text=>unistr('Sortera per has konfigurerats till %0, men ingen kolumn har valts f\00F6r %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361048604402449)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltigt v\00E4rde')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356103244402445)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'sv'
,p_message_text=>'Visas inte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314467106402398)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'sv'
,p_message_text=>'i de senaste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314687009402399)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'sv'
,p_message_text=>'under kommande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313558636402398)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r inte tomt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313417231402398)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r tomt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364588015402451)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'sv'
,p_message_text=>'Etikett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356572648402445)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Etikett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360484273402448)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'sv'
,p_message_text=>'Sista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303700768402390)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'sv'
,p_message_text=>'Senaste dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303922335402390)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'sv'
,p_message_text=>'Senaste timmen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304448514402391)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'sv'
,p_message_text=>'Senaste minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303435700402390)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('Senaste m\00E5naden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303503766402390)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'sv'
,p_message_text=>'Senaste veckan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303688780402390)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'sv'
,p_message_text=>'Senaste %0 dagarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303836091402390)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'sv'
,p_message_text=>'Senaste %0 timmarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304542144402391)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'sv'
,p_message_text=>'Senaste %0 minuterna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304393849402391)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('Senaste %0 m\00E5naderna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304223005402391)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'sv'
,p_message_text=>'Senaste %0 veckorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303243237402390)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('Senaste %0 \00E5ren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303330373402390)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rra \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364729507402452)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'sv'
,p_message_text=>'Celljustering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364863168402452)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nd grupp f\00F6r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314096977402398)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'sv'
,p_message_text=>unistr('mindre \00E4n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314163819402398)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'sv'
,p_message_text=>unistr('mindre \00E4n eller lika med')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358690757402447)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'sv'
,p_message_text=>'Linje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358775403402447)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'sv'
,p_message_text=>'Linjediagram med yta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365175806402452)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'sv'
,p_message_text=>'Listtagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357326874402446)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E5g')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367701809402454)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'sv'
,p_message_text=>'Dela upp flera adresser med kommatecken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315282832402399)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'sv'
,p_message_text=>unistr('matchar regulj\00E4rt uttryck')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339666657402432)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'sv'
,p_message_text=>'Max'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375250957402460)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'sv'
,p_message_text=>unistr('Totalt h\00F6gst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339888742402433)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'sv'
,p_message_text=>'Median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375358195402460)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'sv'
,p_message_text=>'Total median'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339508447402432)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'sv'
,p_message_text=>'Min'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315395896402399)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'sv'
,p_message_text=>'minuter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340358379402433)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'sv'
,p_message_text=>'Minuter sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375132917402460)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'sv'
,p_message_text=>unistr('Totalt l\00E4gst')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315782923402399)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('m\00E5nader')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322377383402419)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Data inneh\00E5ller fler \00E4n %0 vilket \00F6verskrider det maximalt till\00E5tna antalet. Till\00E4mpa ytterligare filter f\00F6r att visa resultat.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349031969402440)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Regionens statiska id m\00E5ste anges eftersom sidan inneh\00E5ller flera interaktiva rutn\00E4t.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318489991402401)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'sv'
,p_message_text=>'Namn'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318617298402402)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Namngiven rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302611739402389)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta dag')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302410120402389)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta timmen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304696656402391)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta minut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302955530402390)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta m\00E5nad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302813536402390)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta vecka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302743690402390)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 dagarna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115302586828402389)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 timmarna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304719817402391)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 minuterna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304074986402391)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 m\00E5naderna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304156291402391)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 veckorna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303100508402390)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 \00E5ren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115303073514402390)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta \00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314326415402398)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'sv'
,p_message_text=>'inte mellan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313311702402398)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'sv'
,p_message_text=>'inte lika med'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379565548402463)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Regionen med id:t %0 \00E4r inte en interaktiv rutn\00E4tsregion eller finns inte i applikationen %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313712589402398)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'sv'
,p_message_text=>'inte i'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314585691402399)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'sv'
,p_message_text=>'inte i de senaste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115314754974402399)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('inte i n\00E4sta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322293617402419)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Inga data hittades'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360228066402448)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'sv'
,p_message_text=>'Null'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365379652402452)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'sv'
,p_message_text=>'Numerisk'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360524552402448)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'sv'
,p_message_text=>'Av'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360653759402448)
,p_name=>'APEX.IG.ON'
,p_message_language=>'sv'
,p_message_text=>unistr('P\00E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312586974402397)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'sv'
,p_message_text=>'1 minut sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368246938402454)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6ppna f\00E4rgv\00E4ljaren: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357086174402446)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6ppna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319557627402402)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'sv'
,p_message_text=>'Operator'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356401467402445)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'sv'
,p_message_text=>'Orientering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358867564402447)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'sv'
,p_message_text=>'Cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115320822125402418)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'sv'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115288402032402379)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Pivotvy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115368130150402454)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'sv'
,p_message_text=>unistr('Dela upp v\00E4rden med "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115358966237402447)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'sv'
,p_message_text=>unistr('Pol\00E4r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364280787402451)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'sv'
,p_message_text=>'Center'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364348871402451)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'sv'
,p_message_text=>'Slut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115364131251402451)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'sv'
,p_message_text=>'Start'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318783892402402)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'sv'
,p_message_text=>unistr('Prim\00E4r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319068679402402)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'sv'
,p_message_text=>unistr('Prim\00E4r standard')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335548058402429)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'sv'
,p_message_text=>unistr('Prim\00E4r rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217710258402324)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'sv'
,p_message_text=>unistr('Inkludera tillg\00E4nglighetstaggar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216472976402323)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'sv'
,p_message_text=>'Liggande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216527984402323)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E5ende ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216317343402323)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'sv'
,p_message_text=>'Sidorientering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216256440402323)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'sv'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216123041402323)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'sv'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217867439402324)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'sv'
,p_message_text=>'Anpassad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215946584402323)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'sv'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215882131402323)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'sv'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216088110402323)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'sv'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215740802402323)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'sv'
,p_message_text=>'Sidstorlek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205948425402314)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'sv'
,p_message_text=>'RTF-remsa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359088972402447)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'sv'
,p_message_text=>'Radar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359108748402447)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'sv'
,p_message_text=>'Intervall'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369441545402455)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rnya')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323072913402420)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rnya rad')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321855994402419)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rnya rader')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327036384402423)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Den interaktiva rutn\00E4tsregionen finns inte i applikationen %0, p\00E5 sidan %1 och i regionen %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289939474402380)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318160652402401)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'sv'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378777392402462)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'sv'
,p_message_text=>'Rapporten har tagits bort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378414755402462)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'sv'
,p_message_text=>unistr('Alternativ rapport har sparats f\00F6r alla anv\00E4ndare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378366934402462)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'sv'
,p_message_text=>unistr('Standardrapport har sparats f\00F6r alla anv\00E4ndare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378635967402462)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'sv'
,p_message_text=>'Privat rapport har sparats'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378588536402462)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'sv'
,p_message_text=>unistr('Offentlig rapport har sparats f\00F6r alla anv\00E4ndare')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115327154099402423)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Det sparade interaktiva rutn\00E4tet med namnet %0 finns inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312482494402397)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportdata f\00F6r %0 minuter sedan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312390184402397)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportdata f\00F6r 1 minut sedan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252013712402351)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapporten f\00F6r interaktivt rutn\00E4t finns inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371656754402457)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapport \2013 Redigera')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326921551402423)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Det sparade interaktiva rutn\00E4tet med id:t %0 finns inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115371515727402457)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapport \2013 Spara som')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290088797402380)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportinst\00E4llningar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379676095402463)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Det sparade interaktiva rutn\00E4tet med det statiska id:t %0 finns inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374577153402459)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Rapportvy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289189587402379)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323139195402420)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll \00E4ndringar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321962308402419)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll rader')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319179732402402)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'sv'
,p_message_text=>'Rad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318068956402401)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'sv'
,p_message_text=>'Rader per sida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379241752402463)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'sv'
,p_message_text=>unistr('Rad\00E5tg\00E4rder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380418858402464)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tg\00E4rder f\00F6r rad %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115289471484402379)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'sv'
,p_message_text=>'Spara'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332118478402427)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'sv'
,p_message_text=>'sparad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287620228402378)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'sv'
,p_message_text=>'Sparade rapporter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287787098402378)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'sv'
,p_message_text=>'Standard'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262270171402359)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'sv'
,p_message_text=>'Det finns redan en sparad rapport med namnet %0. Ange ett nytt namn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287893388402378)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'sv'
,p_message_text=>'Privat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287955400402378)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'sv'
,p_message_text=>unistr('Allm\00E4n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374201596402459)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'sv'
,p_message_text=>'Spara som'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321252242402418)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('Spara rapportinst\00E4llningar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359217698402447)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'sv'
,p_message_text=>'Spridning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287590804402378)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366568737402453)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k: Alla textkolumner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287459774402378)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k i: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365713797402452)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k: Full text')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312257703402397)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k efter "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355827220402445)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296093185402384)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'sv'
,p_message_text=>'Urval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348784090402439)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj 1 rad i den prim\00E4ra regionen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287322616402378)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj kolumner att s\00F6ka i')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378906512402462)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'sv'
,p_message_text=>unistr('Urvals\00E5tg\00E4rder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296264757402385)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'sv'
,p_message_text=>'Cellurval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296169852402384)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'sv'
,p_message_text=>'Radval'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367182340402453)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'sv'
,p_message_text=>'Skicka som e-post'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359630431402448)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Serie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285356934402376)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'sv'
,p_message_text=>'Visa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337918579402431)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('Visa totalv\00E4rde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322741333402420)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Enstaka rad-vy'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321046684402418)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'sv'
,p_message_text=>'Sortera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359742085402448)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'sv'
,p_message_text=>'Sortera per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379397775402463)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Du kan endast definiera en sort per kolumn.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379137263402463)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4ndringsmeny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115360773866402449)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'sv'
,p_message_text=>'Stack'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315030085402399)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'sv'
,p_message_text=>unistr('b\00F6rjar med')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359337485402447)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'sv'
,p_message_text=>'Lager'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280386183402373)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('Str\00E4ck ut kolumnbredder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115321483852402419)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'sv'
,p_message_text=>'Prenumeration'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115339452502402432)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'sv'
,p_message_text=>'Summa'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380634013402464)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'sv'
,p_message_text=>unistr('Interaktivt rutn\00E4t. Rapport: %0, vy: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115374661823402459)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'sv'
,p_message_text=>'Totalsumma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357512915402446)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363926589402451)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Textf\00E4rg')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290187080402380)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4xla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337892551402431)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'sv'
,p_message_text=>'Knappbeskrivning'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115318208222402401)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'sv'
,p_message_text=>'Typ'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115322668069402420)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E5s upp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319759608402402)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'sv'
,p_message_text=>'Enhet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366919190402453)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'sv'
,p_message_text=>unistr('Du har \00E4ndringar som inte har sparats. Vill du forts\00E4tta?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115319604771402402)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356611958402445)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361564957402449)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett v\00E4rde m\00E5ste anges.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346478215402438)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde (tidszon kan inte \00E4ndras)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365415494402452)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'sv'
,p_message_text=>'Text'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357947123402446)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'sv'
,p_message_text=>'Vertikalt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317759572402401)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'sv'
,p_message_text=>'Visa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355912812402445)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'sv'
,p_message_text=>'Visad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115357480009402446)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Volym'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315642017402399)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'sv'
,p_message_text=>'veckor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356084176402445)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'sv'
,p_message_text=>'Minsta kolumnbredd (pixlar)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306837973402393)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'sv'
,p_message_text=>'%0 mellan %1 och %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306506143402392)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306613467402392)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller inte %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284721500402376)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 b\00F6rjar inte med %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305321760402391)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'sv'
,p_message_text=>'%0 lika med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305576601402392)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 st\00F6rre \00E4n %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305615794402392)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 st\00F6rre \00E4n eller lika med %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306312857402392)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'sv'
,p_message_text=>'%0 i %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307515868402393)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'sv'
,p_message_text=>'%0 de senaste %1 dagarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307347979402393)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'sv'
,p_message_text=>'%0 de senaste %1 timmarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307142075402393)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sv'
,p_message_text=>'%0 de senaste %1 minuterna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307950364402393)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 de senaste %1 m\00E5naderna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307769139402393)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sv'
,p_message_text=>'%0 de senaste %1 veckorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308152810402394)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 de senaste %1 \00E5ren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307476236402393)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'sv'
,p_message_text=>'%0 den senaste dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307223094402393)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'sv'
,p_message_text=>'%0 den senaste timmen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307097872402393)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'sv'
,p_message_text=>'%0 den senaste minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307812730402393)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 den senaste m\00E5naden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115307689203402393)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'sv'
,p_message_text=>'%0 den senaste veckan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308097186402394)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 det senaste \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309964502402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sv'
,p_message_text=>'%0 de kommande %1 dagarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309782952402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sv'
,p_message_text=>'%0 de kommande %1 timmarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309585670402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sv'
,p_message_text=>'%0 de kommande %1 minuterna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310347090402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 de kommande %1 m\00E5naderna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310185851402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sv'
,p_message_text=>'%0 de kommande %1 veckorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310572842402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 de kommande %1 \00E5ren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309813212402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'sv'
,p_message_text=>'%0 den kommande dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309644875402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'sv'
,p_message_text=>'%0 den kommande timmen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309478642402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'sv'
,p_message_text=>'%0 den kommande minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310245734402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 den kommande m\00E5naden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310084364402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'sv'
,p_message_text=>'%0 den kommande veckan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310491826402395)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 det kommande \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306081222402392)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r inte tomt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305992385402392)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r tomt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305733571402392)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 mindre \00E4n %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305807495402392)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 mindre \00E4n eller lika med %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306153016402392)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'sv'
,p_message_text=>'%0 som %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306796700402393)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 matchar regulj\00E4rt uttryck %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312621226402397)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 minuter sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306987005402393)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'sv'
,p_message_text=>'%0 inte mellan %1 och %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305445839402392)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'sv'
,p_message_text=>'%0 inte lika med %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306426383402392)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'sv'
,p_message_text=>'%0 inte i %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308783569402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de senaste %1 dagarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308516632402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de senaste %1 timmarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308376116402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de senaste %1 minuterna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309164409402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte de senaste %1 m\00E5naderna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308962785402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de senaste %1 veckorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309381506402395)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte de senaste %1 \00E5ren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308651457402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den senaste dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308479333402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den senaste timmen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308266295402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den senaste minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309028960402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte den senaste m\00E5naden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115308802503402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den senaste veckan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115309283129402394)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte det senaste \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311184372402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de kommande %1 dagarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310946004402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de kommande %1 timmarna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310786731402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de kommande %1 minuterna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311519553402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte de kommande %1 m\00E5naderna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311332347402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'sv'
,p_message_text=>'%0 inte de kommande %1 veckorna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311703201402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte de kommande %1 \00E5ren')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311096646402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den kommande dagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310810190402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den kommande timmen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115310645582402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den kommande minuten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311448542402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte den kommande m\00E5naden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311238680402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'sv'
,p_message_text=>'%0 inte den kommande veckan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311658196402396)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inte det kommande \00E5ret')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115306256494402392)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'sv'
,p_message_text=>'%0 inte som %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313130122402397)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 b\00F6rjar med %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356740139402446)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315816007402399)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E5r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356895709402446)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356978282402446)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115365998287402452)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5ndag den 12 januari 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366033065402452)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'sv'
,p_message_text=>'Januari'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366121020402453)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'sv'
,p_message_text=>'16 timmar sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115366205253402453)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'sv'
,p_message_text=>'om 16 timmar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221289973402327)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig filtyp. Filtyper som st\00F6ds \00E4r %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348105630402439)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'sv'
,p_message_text=>unistr('Bl\00E4ddra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347815815402439)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347909025402439)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj filer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221096631402327)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('Dra och sl\00E4pp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221447604402327)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'sv'
,p_message_text=>unistr('Dra och sl\00E4pp filer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222692246402329)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj en fil eller sl\00E4pp en fil h\00E4r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222749738402329)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj filer eller sl\00E4pp dem h\00E4r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222808953402329)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj en fil eller sl\00E4pp en fil h\00E4r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222998989402329)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj filer eller sl\00E4pp dem h\00E4r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221355810402327)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'sv'
,p_message_text=>'%0 filer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221113303402327)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'sv'
,p_message_text=>unistr('Filen \00E4r f\00F6r stor. Maxstorleken f\00F6r filer \00E4r %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208926501402316)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Adress kr\00E4vs.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207822166402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'sv'
,p_message_text=>'Ort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208285088402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'sv'
,p_message_text=>'Landskod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207980614402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'sv'
,p_message_text=>'Husnummer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208802360402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'sv'
,p_message_text=>'Latitud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208736062402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'sv'
,p_message_text=>'Longitud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208693516402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'sv'
,p_message_text=>unistr('Visa p\00E5 kartan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208377680402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'sv'
,p_message_text=>unistr('Po\00E4ng')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208028953402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'sv'
,p_message_text=>'Postnummer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208155489402316)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'sv'
,p_message_text=>'Region'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207741591402315)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'sv'
,p_message_text=>'Gatuadress'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207692188402315)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'sv'
,p_message_text=>'Geokodningsresultat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220263821402326)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'sv'
,p_message_text=>'Med geokod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220379592402326)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'sv'
,p_message_text=>'Utan geokod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208581464402316)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'sv'
,p_message_text=>'Karta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115208438421402316)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Inga adresser hittades.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209011169402316)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 kr\00E4vs.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378864191402462)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lptext: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272299199402366)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'sv'
,p_message_text=>'Markerad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272387271402366)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'sv'
,p_message_text=>'Avmarkerad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218236636402325)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sv'
,p_message_text=>'#LABEL# ligger inte inom det giltiga intervallet %0 till %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218324093402325)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# \00E4r inte en multipel av %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217994216402324)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste matcha v\00E4rdena %0 och %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218120144402325)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Nej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296447770402385)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Av'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296511887402385)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'sv'
,p_message_text=>unistr('P\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218060716402325)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201422232402311)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till post')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330652572402426)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330756576402426)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201524608402311)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'sv'
,p_message_text=>'Valda poster'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334435618402428)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'sv'
,p_message_text=>'Avancerat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334724880402429)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'sv'
,p_message_text=>'Avbryt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334573867402429)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'sv'
,p_message_text=>'Gemensam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334876610402429)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'sv'
,p_message_text=>'Aktiva mallalternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335477072402429)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Mallalternativ \00E4r inte tillg\00E4ngliga eftersom den h\00E4r komponenten inte \00E4r \00E5tergiven p\00E5 sidan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334315086402428)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Inga mallalternativ hittades.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334653970402429)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'sv'
,p_message_text=>'Spara'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209934575402317)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'sv'
,p_message_text=>'Rensa cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211785766402319)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'sv'
,p_message_text=>unistr('Anpassade format \00E4r inte giltigt JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210277010402318)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'sv'
,p_message_text=>unistr('Verktyget Avst\00E5nd')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210086592402317)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'sv'
,p_message_text=>'Rita cirkel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202630870402311)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6r fasetts\00F6kning kr\00E4vs en datak\00E4lla p\00E5 regionniv\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205215661402314)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'sv'
,p_message_text=>'Aktuell plats'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206327451402314)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('Koordinaterna f\00F6r inledande position \00E4r ogiltiga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203783976402312)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Inledande position m\00E5ste vara en punktgeometri.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206197432402314)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'sv'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204728360402313)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'sv'
,p_message_text=>'Skikt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338064655402431)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'sv'
,p_message_text=>'Skikt: %0'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209394649402317)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'sv'
,p_message_text=>'Mappa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202590546402311)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'sv'
,p_message_text=>'Meddelanden'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206254725402314)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'sv'
,p_message_text=>'engelska mil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337079506402430)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Data inneh\00E5ller fler \00E4n %0 rader vilket \00F6verskrider det h\00F6gsta till\00E5tna antalet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204517424402313)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'sv'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Villkor</a> &nbsp;&nbsp; Kartdata &copy; 2017 H\00C4R')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203450801402312)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Datatypen SDO_GEOMETRY finns inte i den h\00E4r databasen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204619292402313)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'sv'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap-bidragsgivare </a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204814669402313)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'sv'
,p_message_text=>'Punkter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338185773402431)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 po\00E4ng')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210113612402317)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'sv'
,p_message_text=>unistr('Rektangul\00E4r zoom')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209854438402317)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205100095402313)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll lager till norr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285491052402376)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4xla till 2D-l\00E4ge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285551067402376)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4xla till 3D-l\00E4ge')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209730228402317)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4xla copyrightmeddelande')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210370837402318)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hela avst\00E5ndet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204976602402313)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'sv'
,p_message_text=>'Zooma in'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205042786402313)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'sv'
,p_message_text=>'Zooma ut'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332506122402427)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'sv'
,p_message_text=>'Fetstil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333482118402428)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'sv'
,p_message_text=>'Bild'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333072322402427)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'sv'
,p_message_text=>'Inline-kod'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346661240402438)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'sv'
,p_message_text=>'Infoga bild'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346740528402438)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'sv'
,p_message_text=>unistr('Infoga l\00E4nk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332660683402427)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'sv'
,p_message_text=>'Kursiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347367393402438)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4nk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333332929402428)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'sv'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333293614402428)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'sv'
,p_message_text=>'Sorterad lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332790835402427)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rhandsgranska')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332828048402427)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'sv'
,p_message_text=>unistr('Ingenting att f\00F6rhandsgranska')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332940231402427)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'sv'
,p_message_text=>'Genomstruken'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333132485402427)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'sv'
,p_message_text=>'Punktlista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312025387402397)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'sv'
,p_message_text=>'aktuell'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115369543391402455)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Mer...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115311988628402397)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'sv'
,p_message_text=>'Laddar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343717847402435)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'sv'
,p_message_text=>'Meddelande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317080457402400)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara ett tal som \00E4r mindre \00E4n eller lika med %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317179400402400)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara ett giltigt tal.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317296576402401)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'sv'
,p_message_text=>'#LABEL# matchar inte talformatet %0 (exempel: %1).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316988802402400)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara ett tal som \00E4r st\00F6rre \00E4n eller lika med %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316889871402400)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste vara ett tal mellan %0 och %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312191099402397)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'sv'
,p_message_text=>unistr('\00F6ppnas i ett nytt f\00F6nster')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265383992402361)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'sv'
,p_message_text=>'Sidan har redan skickats och kan inte skickas igen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247952566402348)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Applikationen "%0" sidan "%1" hittades inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281745375402374)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('#LABEL# m\00E5ste ha ett v\00E4rde.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225026643402331)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331057790402426)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330962206402426)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331235574402426)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331102068402426)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217183801402324)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'sv'
,p_message_text=>unistr('Ange en s\00F6kterm med minst %0 tecken.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286696324402377)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('Snabbmeny med v\00E4rden: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217234924402324)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'sv'
,p_message_text=>unistr('Ange en s\00F6kterm.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217030544402324)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'sv'
,p_message_text=>'Inga resultat hittades.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216963957402324)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304870503402391)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6kterm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330876508402426)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341545570402434)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'sv'
,p_message_text=>'Bearbetar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215567455402323)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till p\00E5 hemsidan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211533919402319)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Din enhet eller webbl\00E4sare verkar inte ha st\00F6d f\00F6r installationen av webbappar just nu.</p>'),
unistr('    <p class="a-pwaDialog-intro">Om den h\00E4r applikationen redan har installerats p\00E5 din enhet kan du \00F6ppna den fr\00E5n hemsk\00E4rmen.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211129637402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet. L\00E4gg till den p\00E5 din hemsk\00E4rm f\00F6r att anv\00E4nda den i fullsk\00E4rmsl\00E4ge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryck p\00E5 ikonen <strong>Meny</strong> l\00E4ngst ner i navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryck p\00E5 <strong>Installera</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryck p\00E5 <strong>L\00E4gg till</strong> f\00F6r att bekr\00E4fta</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211286845402319)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet som b\00E4st upplevs i Chrome eller Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryck p\00E5 ikonen <strong>Meny</strong> bredvid adressf\00E4ltet</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryck p\00E5 <strong>Installera</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210818076402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet som b\00E4st upplevs i Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryck p\00E5 ikonen <strong>Dela</strong> l\00E4ngst ner i navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryck p\00E5 <strong>\00D6ppna i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210558915402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet. L\00E4gg till den till din hemsk\00E4rm f\00F6r den b\00E4sta upplevelsen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryck p\00E5 ikonen <strong>Dela</strong> bredvid adressf\00E4ltet</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryck p\00E5 <strong>L\00E4gg till p\00E5 hemsk\00E4rm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryck p\00E5 <strong style="color:#007AE1;">L\00E4gg till</strong> f\00F6r att bekr\00E4fta</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210489381402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet. L\00E4gg till den till din hemsk\00E4rm f\00F6r den b\00E4sta upplevelsen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryck p\00E5 ikonen <strong>Dela</strong> l\00E4nst ner i navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Skrolla ner och tryck p\00E5 <strong>L\00E4gg till p\00E5 hemsk\00E4rm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryck p\00E5 <strong style="color:#007AE1;">L\00E4gg till</strong> f\00F6r att bekr\00E4fta</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205487744402314)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet. L\00E4gg till den till din hemsk\00E4rm f\00F6r den b\00E4sta upplevelsen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Tryck p\00E5 ikonen <strong>Mer</strong> bredvid adressf\00E4ltet</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Tryck p\00E5 <strong>L\00E4gg till p\00E5 hemsk\00E4rm</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Tryck p\00E5 <strong style="color:#007AE1;">L\00E4gg till</strong> f\00F6r att bekr\00E4fta</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210784819402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet. L\00E4gg till den till din hemsk\00E4rm f\00F6r den b\00E4sta upplevelsen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryck p\00E5 ikonen <strong>Dela</strong> bredvid adressf\00E4ltet</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryck p\00E5 <strong>\00D6ppna i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210699871402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet. L\00E4gg till den till din hemsk\00E4rm f\00F6r den b\00E4sta upplevelsen.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryck p\00E5 ikonen <strong>Dela</strong> l\00E4ngst ner i navigeringen</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Tryck p\00E5 <strong>\00D6ppna i Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211479035402319)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet som b\00E4st upplevs i Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox har i nul\00E4get inte st\00F6d f\00F6r webbappinstallationer.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115210936875402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet som b\00E4st upplevs i Chrome ller Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox har i nul\00E4get inte st\00F6d f\00F6r webbappinstallationer p\00E5 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211094339402318)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet som b\00E4st upplevs i Chrome ller Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari har i nul\00E4get inte st\00F6d f\00F6r webbappinstallationer p\00E5 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211308490402319)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Den h\00E4r webbplatsen har appfunktionalitet som b\00E4st upplevs i Chrome eller Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox har i nul\00E4get inte st\00F6d f\00F6r webbappinstallationer p\00E5 Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213885277402321)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>Kan inte ansluta</h1>',
unistr('    <p>Du m\00E5ste vara ansluten till Internet f\00F6r att anv\00E4nda den h\00E4r appen.</p>'),
'    <button type="button">Retry</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213760244402321)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'sv'
,p_message_text=>'Kan inte ansluta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353569167402443)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297982605402386)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'sv'
,p_message_text=>'Heldag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376803380402461)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'sv'
,p_message_text=>'Skicka inbjudan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376621681402461)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'sv'
,p_message_text=>'Alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299743868402387)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'sv'
,p_message_text=>unistr('Dagvy f\00F6r hela dagen ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299544363402387)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'sv'
,p_message_text=>unistr('Dagvy f\00F6r data med tid ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344422988402436)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'sv'
,p_message_text=>'Dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338856791402432)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'sv'
,p_message_text=>'Beskrivning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229493165402334)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'sv'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229262033402334)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'sv'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229163349402334)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'sv'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229344433402334)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'sv'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228845199402334)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'sv'
,p_message_text=>'Slutdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229067947402334)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'sv'
,p_message_text=>unistr('H\00E4ndelsenamn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376737770402461)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'sv'
,p_message_text=>'Inbjudan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344529674402436)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'sv'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344274251402436)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5nad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347004850402438)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361314074402449)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga h\00E4ndelser')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377037287402461)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'sv'
,p_message_text=>unistr('Redigera en befintlig h\00E4ndelse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376922260402461)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'sv'
,p_message_text=>'Skickar en inbjudan via e-post.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347155150402438)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355109859402444)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'sv'
,p_message_text=>'Skicka e-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354975692402444)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'sv'
,p_message_text=>'Skicka e-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377709169402462)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Alla f\00E4lt \00E4r obligatoriska.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377683593402461)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'sv'
,p_message_text=>'Skicka inbjudan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376528109402461)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4mne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355042431402444)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'sv'
,p_message_text=>'Till'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228968877402334)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'sv'
,p_message_text=>'Startdatum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352879489402443)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'sv'
,p_message_text=>unistr('Formul\00E4r p\00E5 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299392102402387)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'sv'
,p_message_text=>'Tid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347255950402438)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'sv'
,p_message_text=>'Idag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345080596402436)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'sv'
,p_message_text=>'Visa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344395150402436)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'sv'
,p_message_text=>'Vecka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299689531402387)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'sv'
,p_message_text=>unistr('Veckovy f\00F6r hela dagen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299426979402387)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'sv'
,p_message_text=>unistr('Veckovy f\00F6r data med tid')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344952934402436)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344690180402436)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Kolumner...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344752660402436)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'sv'
,p_message_text=>'Ladda fler...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276844010402370)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'sv'
,p_message_text=>'Tillbaka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223176568402329)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'sv'
,p_message_text=>'Ladda fler...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225269166402331)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115344841099402436)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'sv'
,p_message_text=>'Ladda fler...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346978462402438)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Regions-id:t %0 hittades inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225144681402331)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'sv'
,p_message_text=>'Inga data hittades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249260935402349)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte \00E5terst\00E4lla sidindelning av regioner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217459876402324)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid inst\00E4llning av sidindelning f\00F6r regioner.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338294601402431)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Kolumner...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346870635402438)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'sv'
,p_message_text=>unistr('Regionstypen %0 st\00F6ds inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217366820402324)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid \00E5tergivning av regionen "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281895390402374)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('#COLUMN_HEADER# m\00E5ste ha ett v\00E4rde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376151877402460)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'sv'
,p_message_text=>'%0, RTF-redigerare'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283980516402375)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'sv'
,p_message_text=>unistr('HTML-markeringen \00F6verskrider objektets maxl\00E4ngd (faktiskt antal %0, till\00E5tet antal %1 tecken)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343831705402436)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'sv'
,p_message_text=>'Ta bort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335607756402429)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'sv'
,p_message_text=>'Dubblett'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333996673402428)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'sv'
,p_message_text=>'Visade kolumner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333845556402428)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Exkludera nullv\00E4rden')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343916597402436)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297589486402385)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'sv'
,p_message_text=>'Flytta ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297685900402386)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'sv'
,p_message_text=>'Flytta upp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333688130402428)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334220459402428)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vriga kolumner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333748594402428)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334050458402428)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'sv'
,p_message_text=>'Rad %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334103420402428)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'sv'
,p_message_text=>'Rad %0 av %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335766379402429)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rnya')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335835817402429)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll \00E4ndringar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115333582719402428)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('Inst\00E4llningsmeny')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294525729402383)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Till exempel %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202063361402311)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'sv'
,p_message_text=>'Logga in igen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201919975402311)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'sv'
,p_message_text=>'Sessionen har avslutats'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202197993402311)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'sv'
,p_message_text=>unistr('Ut\00F6ka')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201757885402311)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'sv'
,p_message_text=>unistr('Sessionen l\00F6per ut den %0. Vill du f\00F6rl\00E4nga den?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201858224402311)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'sv'
,p_message_text=>unistr('Din session upph\00F6r den %0 och kan inte f\00F6rl\00E4ngas. Spara ditt arbete nu f\00F6r att inte f\00F6rlora n\00E5gra data.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354746701402444)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av rensningskod f\00F6r databassession.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247852864402348)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av konfigurationskod f\00F6r databassession.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115221954216402328)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'sv'
,p_message_text=>'Sessionen har avslutats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353669880402443)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng dialogrutan och klicka p\00E5 uppdateringsknappen i webbl\00E4saren f\00F6r att starta en ny session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372955363402458)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'sv'
,p_message_text=>unistr('Klicka <a href="%0">h\00E4r</a> f\00F6r att skapa en ny session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259547226402357)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'sv'
,p_message_text=>unistr('Sessionen \00E4r inte giltig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299001251402387)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga dynamiska roller kunde aktiveras i Real Application Security-sessionen f\00F6r anv\00E4ndaren "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245717334402346)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>'ERR-99900 Kunde inte skapa unikt sessions-id: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262013640402359)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vertr\00E4delse av skydd av sessionstillst\00E5nd: Det kan ha orsakats av manuell \00E4ndring av det skyddade sidobjektet %0. Om du \00E4r os\00E4ker p\00E5 vad som kan ha orsakat felet kontaktar du applikationsadministrat\00F6ren och ber om hj\00E4lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381190123402464)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vertr\00E4delse av sidskydd: Den kan ha orsakats av att en sida skickats som inte hade laddats klart eller av en manuell \00E4ndring av skyddade sidobjekt. Kontakta applikationsadministrat\00F6ren om du beh\00F6ver mer hj\00E4lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380190805402463)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller ett av de ogiltiga tecknen &<>"/;,*|=% eller --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380271948402464)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller ett eller flera ogiltiga tecken &<>"/;,*|=% eller -- eller en ny rad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379987311402463)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller ett specialtecken. Endast tecknen A-Z, 0-9 och blanksteg \00E4r till\00E5tna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115380073628402463)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller <, > eller ", vilka \00E4r ogiltiga tecken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224107049402330)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'sv'
,p_message_text=>unistr('Ingen kontrollsumma hade angetts f\00F6r att visa bearbetning f\00F6r en sida som kr\00E4ver en kontrollsumma n\00E4r ett eller flera v\00E4rden f\00F6r beg\00E4randen, cacherensning eller argument \00F6verf\00F6rs som parametrar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256968055402355)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vertr\00E4delse av skydd av sessionstillst\00E5nd: Det kan ha orsakats av manuell \00E4ndring av en URL som inneh\00E5ller en kontrollsumma eller anv\00E4ndning av en l\00E4nk med en felaktig eller saknad kontrollsumma. Om du \00E4r os\00E4ker p\00E5 vad som kan ha orsakat felet konta')
||unistr('ktar du applikationsadministrat\00F6ren och ber om hj\00E4lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115334937920402429)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng av h\00F6gkontrastl\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335096420402429)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00E4tt p\00E5 h\00F6gkontrastl\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253677264402352)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4ngst ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253804977402353)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'sv'
,p_message_text=>'Ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253974169402353)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'sv'
,p_message_text=>'Flytta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254005009402353)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'sv'
,p_message_text=>'Flytta alla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254158481402353)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254224211402353)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'sv'
,p_message_text=>'Ta bort alla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254337833402353)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253585702402352)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4ngst upp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253759058402352)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'sv'
,p_message_text=>'Upp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362684619402450)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363310065402450)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362541882402450)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363435059402451)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362340847402450)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363576477402451)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362907261402450)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363129185402450)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362406203402450)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363243066402450)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362775176402450)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363611776402451)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362884293402450)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115363078331402450)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>'om %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202955371402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'sv'
,p_message_text=>'[Rad]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203362685402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'sv'
,p_message_text=>'[Flera rader]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203198059402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'sv'
,p_message_text=>'[Flera punkter]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203541780402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'sv'
,p_message_text=>'[Flera polygoner]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203670605402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'sv'
,p_message_text=>'[Geometriobjekt]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202854172402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'sv'
,p_message_text=>'[Punkt (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203041027402312)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'sv'
,p_message_text=>'[Polygon]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280236345402373)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'sv'
,p_message_text=>'Komprimera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280176541402372)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326616386402422)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'sv'
,p_message_text=>unistr('Rensa bed\00F6mning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316562926402400)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'sv'
,p_message_text=>'%0 ligger inte inom det giltiga intervallet 1 - %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316647879402400)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r inte numeriskt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312715782402397)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'sv'
,p_message_text=>unistr('Meddelande om utf\00F6rande')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375884817402460)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375730393402460)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361413647402449)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'sv'
,p_message_text=>unistr('Verktygsf\00E4lt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376253614402460)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Expandera/komprimera navigering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376376471402460)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Expandera/komprimera sidkolumn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285959304402377)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Huvudnavigering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292980424402382)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'sv'
,p_message_text=>'1 dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292703957402382)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'sv'
,p_message_text=>'1 timme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293092604402382)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'sv'
,p_message_text=>'%0 dagar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292864961402382)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'sv'
,p_message_text=>'%0 timmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292686048402382)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'sv'
,p_message_text=>'%0 minuter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293202380402382)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'sv'
,p_message_text=>'%0 veckor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115293189803402382)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'sv'
,p_message_text=>'1 vecka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379486839402463)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'sv'
,p_message_text=>unistr('B\00F6rjan av sida')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241485104402343)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'sv'
,p_message_text=>'Aktiv'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215219830402322)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid bearbetning av beg\00E4ran.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294669863402383)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett v\00E4rde m\00E5ste anges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377531539402461)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4nta tills sidan har laddat klart och f\00F6rs\00F6k igen.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337730752402431)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'sv'
,p_message_text=>unistr('Det finns \00E4ndringar f\00F6r sidan som inte har sparats.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218603239402325)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'sv'
,p_message_text=>'Arbetsboken har inga aktiva arbetsblad.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218596303402325)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'sv'
,p_message_text=>'Arbetsboken har inte initierats.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218429052402325)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett internt fel intr\00E4ffade n\00E4r XLSX-filen skulle skapas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220935301402327)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'sv'
,p_message_text=>'Blad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352671845402442)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tg\00E4rder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270111267402365)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('Menyn \00C5tg\00E4rder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265816569402362)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till funktion')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265759549402361)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till Gruppera per kolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299988139402387)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till pivotkolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300041780402387)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4gg till radkolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240244241402342)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'sv'
,p_message_text=>'Aggregera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276348422402370)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'sv'
,p_message_text=>'Aggregering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257494707402355)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'sv'
,p_message_text=>'Genomsnitt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261765856402358)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'sv'
,p_message_text=>'Antal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257503890402355)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'sv'
,p_message_text=>'Max'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257770819402355)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'sv'
,p_message_text=>'Median'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257685451402355)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'sv'
,p_message_text=>'Min'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257339553402355)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'sv'
,p_message_text=>'Summa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258491903402356)
,p_name=>'APEXIR_ALL'
,p_message_language=>'sv'
,p_message_text=>'Alla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239553729402342)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Alla kolumner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222058477402328)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'sv'
,p_message_text=>'Alla rader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349637313402440)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'sv'
,p_message_text=>'Alternativ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351262383402441)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'sv'
,p_message_text=>'Alternativ standard: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252119894402351)
,p_name=>'APEXIR_AND'
,p_message_language=>'sv'
,p_message_text=>'och'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241647400402343)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'sv'
,p_message_text=>unistr('Till\00E4mpa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235322074402339)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'sv'
,p_message_text=>'Stigande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254969957402353)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'sv'
,p_message_text=>'Per den %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351823716402442)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'sv'
,p_message_text=>'Genomsnitt %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343208770402435)
,p_name=>'APEXIR_BAR'
,p_message_language=>'sv'
,p_message_text=>'Stapel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241041298402343)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'sv'
,p_message_text=>'mellan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234128073402338)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Bakgrundsf\00E4rg')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236001181402339)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'sv'
,p_message_text=>unistr('bl\00E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267788633402363)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4ngst ned')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236606428402340)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'sv'
,p_message_text=>'Avbryt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242574400402344)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'sv'
,p_message_text=>'Kategori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234098700402338)
,p_name=>'APEXIR_CELL'
,p_message_language=>'sv'
,p_message_text=>'Cell'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258377112402356)
,p_name=>'APEXIR_CHART'
,p_message_language=>'sv'
,p_message_text=>'Diagram'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268696453402364)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'sv'
,p_message_text=>'Initierar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115304926757402391)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Diagrametikett m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317333953402401)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Din fr\00E5ga \00F6verskrider det maximala antalet p\00E5 %0 datapunkter per diagram. Till\00E4mpa ett filter f\00F6r att minska antalet poster i din basfr\00E5ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316217169402400)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Det maximala antalet rader f\00F6r en Diagramfr\00E5ga begr\00E4nsar antalet rader i basfr\00E5gan, inte antalet rader som visas.  Din basfr\00E5ga \00F6verstiger det maximala antalet rader p\00E5 %0.  Till\00E4mpa ett filter f\00F6r att minska antalet poster i din basfr\00E5ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239644268402342)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Diagramtyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115312952869402397)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'sv'
,p_message_text=>'Markera alla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255303555402354)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj rapportformat')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262766360402359)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'sv'
,p_message_text=>'rensa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236550697402340)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Kolumn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273947703402368)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Kolumner'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346203073402437)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Filtrera...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264790573402361)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('Meny f\00F6r kolumnrubrik')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268464909402363)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'sv'
,p_message_text=>'Kolumninformation'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348541021402439)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Kolumnetikett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266155288402362)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'sv'
,p_message_text=>'Kolumn %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250240374402350)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'sv'
,p_message_text=>unistr('inneh\00E5ller')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251194471402351)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'sv'
,p_message_text=>unistr('inneh\00E5ller inte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235047670402338)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'sv'
,p_message_text=>'i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251303050402351)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r inte i de senaste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259892925402357)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r inte i n\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251263282402351)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r i den senaste')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259716093402357)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r i n\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234949044402338)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r inte null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234850887402338)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E4r null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234643609402338)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'sv'
,p_message_text=>'liknar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235106975402338)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'sv'
,p_message_text=>'inte i'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234766797402338)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'sv'
,p_message_text=>'liknar inte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250580130402350)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'sv'
,p_message_text=>unistr('matchar regulj\00E4rt uttryck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255283636402354)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Ber\00E4kning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115315945949402400)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'sv'
,p_message_text=>unistr('Ber\00E4kningsuttryck')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274240970402368)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'sv'
,p_message_text=>unistr('Skapa en ber\00E4kning med hj\00E4lp av kolumnalias.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274343194402368)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'sv'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274417846402368)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'sv'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274509389402368)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'sv'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220456298402326)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'sv'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259136789402356)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ber\00E4kna')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266728833402362)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'sv'
,p_message_text=>'Kontrollstopp'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269786676402364)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'sv'
,p_message_text=>'Kontrollstopp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354179958402444)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Kontrollera brytkolumner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217512712402324)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'sv'
,p_message_text=>'Antal unika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352324106402442)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'sv'
,p_message_text=>'Antal unika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352212892402442)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'sv'
,p_message_text=>'Antal %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324347137402421)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'sv'
,p_message_text=>'Dagligen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379012133402463)
,p_name=>'APEXIR_DATA'
,p_message_language=>'sv'
,p_message_text=>'Data'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268569500402364)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportdata f\00F6r %0 minuter sedan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342018689402434)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r datarutn\00E4t')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240308518402342)
,p_name=>'APEXIR_DATE'
,p_message_language=>'sv'
,p_message_text=>'Datum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272435059402366)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'sv'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349431716402440)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Standardrapporttyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236763572402340)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'sv'
,p_message_text=>'Ta bort'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240648243402343)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'sv'
,p_message_text=>unistr('Vill du verkligen ta bort de h\00E4r rapportinst\00E4llningarna?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335366800402429)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Ta bort standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266495550402362)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Ta bort rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235417403402339)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'sv'
,p_message_text=>'Fallande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242667532402344)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'sv'
,p_message_text=>'Beskrivning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264691122402361)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Enstaka rad-vy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272991346402367)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'sv'
,p_message_text=>'Riktning %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273801073402368)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'sv'
,p_message_text=>'Inaktiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236254022402339)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'sv'
,p_message_text=>'Visad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239476772402342)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Visade kolumner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272854577402367)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Visa i rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267617585402363)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'sv'
,p_message_text=>'Ned'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259231706402357)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'sv'
,p_message_text=>'Ladda ned'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272759312402367)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'sv'
,p_message_text=>'Visa inte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338751829402432)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'sv'
,p_message_text=>'Markering med samma villkor finns redan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354357174402444)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('Dubblettpivotkolumn. Pivotkolumnlistan m\00E5ste vara unik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354584564402444)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'sv'
,p_message_text=>'Redigera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268748590402364)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'sv'
,p_message_text=>unistr('Redigera diagraminst\00E4llningar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275313681402369)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'sv'
,p_message_text=>'Redigera diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275717723402369)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Redigera filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330164332402425)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>'Redigera grupp per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275624063402369)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'sv'
,p_message_text=>'Redigera markering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300233379402388)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'sv'
,p_message_text=>'Redigera pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349723007402440)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'sv'
,p_message_text=>'E-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228481842402333)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'sv'
,p_message_text=>'E-postadress'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350095324402440)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'sv'
,p_message_text=>'Hemlig kopia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350219855402441)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'sv'
,p_message_text=>'Text'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349976628402440)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'sv'
,p_message_text=>'Kopia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350798812402441)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'sv'
,p_message_text=>'Frekvens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232157591402336)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'sv'
,p_message_text=>unistr('E-post har inte konfigurerats f\00F6r den h\00E4r applikationen. Kontakta administrat\00F6ren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323607924402420)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('E-postadress m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350347905402441)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'sv'
,p_message_text=>'Se bifogad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350121748402440)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C4mne')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324656660402421)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('E-post\00E4mne m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349837671402440)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'sv'
,p_message_text=>'Till'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233823713402337)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'sv'
,p_message_text=>'Aktiv'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275590761402369)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'sv'
,p_message_text=>'Aktivera/avaktivera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275007687402369)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274613867402368)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'sv'
,p_message_text=>'Exempel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275424194402369)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'sv'
,p_message_text=>'Exempel:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239357712402342)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Exkludera nullv\00E4rden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276025838402369)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'sv'
,p_message_text=>'Expandera/komprimera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273649247402367)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'sv'
,p_message_text=>'Uttryck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258747422402356)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Filtrera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269651708402364)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'sv'
,p_message_text=>'Filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279968563402372)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'sv'
,p_message_text=>'Filteruttryck'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376472286402461)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'sv'
,p_message_text=>unistr('Filteruttrycket \00E4r f\00F6r l\00E5ngt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279893795402372)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Filtertyp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276287725402369)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj kolumner att s\00F6ka i')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259090354402356)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'sv'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273464836402367)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'sv'
,p_message_text=>unistr('En flashbackfr\00E5ga l\00E5ter dig visa data som fanns vid en tidigare tidpunkt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324029251402421)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Flashbackvaraktighet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325419264402422)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255132371402353)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'sv'
,p_message_text=>'Formatmask %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266356230402362)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>'Funktion'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274108357402368)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'sv'
,p_message_text=>'Funktioner %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349317004402440)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'sv'
,p_message_text=>'Funktioner/operatorer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266097360402362)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'sv'
,p_message_text=>'Funktion %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258585273402356)
,p_name=>'APEXIR_GO'
,p_message_language=>'sv'
,p_message_text=>'OK'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234389538402338)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'sv'
,p_message_text=>unistr('gr\00F6n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115217606281402324)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>'Gruppera per'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350414901402441)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Gruppera per kolumn %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305092214402391)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Gruppera per kolumn m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316142810402400)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Det maximala antalet rader f\00F6r en Gruppera per-fr\00E5ga begr\00E4nsar antalet rader i basfr\00E5gan, inte antalet rader som visas.  Din basfr\00E5ga \00F6verstiger det maximala antalet rader p\00E5 %0.  Till\00E4mpa ett filter f\00F6r att minska antalet poster i din basfr\00E5ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296735718402385)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'sv'
,p_message_text=>'Gruppera per-sortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354208511402444)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'sv'
,p_message_text=>unistr('Sorteringsordning f\00F6r Gruppera per')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239720473402342)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'sv'
,p_message_text=>'Horisontell kolumn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271375624402366)
,p_name=>'APEXIR_HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263143714402359)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Interaktiva rapporter l\00E5ter slutanv\00E4ndare anpassa rapporter. Anv\00E4ndare kan \00E4ndra layouten av rapportdata genom att v\00E4lja kolumner, till\00E4mpa filter, markera och sortera. Anv\00E4ndare kan \00E4ven definiera brytkolumner, aggregeringar, diagram, Gruppera per o')
||unistr('ch l\00E4gga till sina egna ber\00E4kningar. Anv\00E4ndare kan \00E4ven konfigurera en prenumeration s\00E5 att HTML-version av rapporten kan skickas via e-post till dem vid ett angivet intervall. Anv\00E4ndare kan skapa flera versioner av en rapport och spara dem som namng')
||unistr('ivna rapporter, antingen f\00F6r offentlig eller privat visning. '),
'<p/>',
unistr('De f\00F6ljande sektionerna sammanfattar s\00E4tt som du kan anpassa en interaktiv rapport. Se "Anv\00E4nda interaktiva rapporter" i <i>Oracle Application Express End User''s Guide</i></a> om du vill veta mer.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270277541402365)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tg\00E4rdsmenyn visas till h\00F6ger om S\00F6k-knappen i s\00F6kf\00E4ltet. Anv\00E4nd den h\00E4r menyn f\00F6r att anpassa en interaktiv rapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263931164402360)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Aggregeringar \00E4r matematiska ber\00E4kningar som utf\00F6rs mot en kolumn. Aggregeringar visas efter varje kontrollstop och i slutet av rapporten i kolumnen d\00E4r de \00E4r definierade. Alternativen inkluderar f\00F6ljande:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Aggregering</strong> l\00E5ter dig v\00E4lja en tidigare'),
'definierad aggregering att redigera.</li>',
unistr('<li><strong>Funktion</strong> \00E4r den funktion som ska utf\00F6ras (till exempel, SUM, MIN).</li>'),
unistr('<li><strong>Kolumn</strong> anv\00E4nds f\00F6r att v\00E4lja kolumnen d\00E4r den matematiska funktionen ska till\00E4mpas. Endast numeriska'),
'kolumner visas.</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264003910402360)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definiera ett diagram per sparad rapport. N\00E4r'),
unistr('detta har definierats kan du v\00E4xla mellan diagram- och rapportvyn med hj\00E4lp av vyikonerna i s\00F6kf\00E4ltet.'),
'Alternativen inkluderar:  ',
'<p>',
'</p><ul>',
'<li><strong>Diagramtyp</strong> identifierar diagramtypen som ska inkluderas.',
unistr('V\00E4lj mellan horisontell stapel, vertikal stapel, cirkel eller linje.</li>'),
unistr('<li><strong>Etikett</strong> l\00E5ter dig v\00E4lja kolumnen som ska anv\00E4ndas som etikett.</li>'),
unistr('<li><strong>Axelrubrik f\00F6r etiketten</strong> \00E4r titeln som visas p\00E5 axeln som \00E4r associerad med den valda kolumnen f\00F6r'),
unistr('etiketten. Detta \00E4r inte tillg\00E4ngligt f\00F6r cirkeldiagram.</li>'),
unistr('<li><strong>V\00E4rde</strong> l\00E5ter dig v\00E4lja kolumnen som ska anv\00E4ndas som v\00E4rde. Om din funktion '),
unistr('\00E4r en COUNT beh\00F6ver inte ett v\00E4rde v\00E4ljas.</li>'),
unistr('<li><strong>Axelrubrik f\00F6r v\00E4rde</strong> \00E4r titeln som visas p\00E5 axeln som \00E4r associerad med den valda kolumnen f\00F6r'),
unistr('V\00E4rde. Detta \00E4r inte tillg\00E4ngligt f\00F6r cirkeldiagram.</li>'),
unistr('<li><strong>Funktion</strong> \00E4r en valfri funktion som ska utf\00F6ras p\00E5 den valda kolumnen f\00F6r V\00E4rde.</li>'),
unistr('<li><strong>Sortera</strong> l\00E5ter dig sortera resultatupps\00E4ttningen.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263317723402360)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Att klicka p\00E5 n\00E5gon kolumnrubrik visar en kolumnrubrikmeny. Alternativen inkluderar f\00F6ljande:'),
'<p></p>',
'<ul>',
'<li>Ikonen <strong>Sortera i stigande ordning </strong> sorterar rapporten efter kolumn i stigande ordning.</li>',
'<li>Ikonen <strong>Sortera i fallande ordning</strong> sorterar rapporten efter kolumn i fallande ordning.</li>',
unistr('<li><strong>D\00F6lj kolumn</strong> d\00F6ljer kolumnen. Inte alla kolumner kan d\00F6ljas. Om en kolumn inte kan d\00F6ljas finns ingen ikon f\00F6r D\00F6lj kolumn.</li>'),
unistr('<li><strong>Brytkolumn</strong> skapar en brytgrupp p\00E5 kolumnen. Detta extraherar kolumnen ur rapporten som en huvudpost.</li>'),
unistr('<li><strong>Kolumninformation</strong> visar hj\00E4lptext om kolumnen, om s\00E5dan \00E4r tillg\00E4nglig.</li>'),
unistr('<li><strong>Textomr\00E5de</strong> anv\00E4nds f\00F6r att ange skiftl\00E4gesk\00E4nsliga s\00F6kkriterier'),
unistr('(jokertecken beh\00F6vs inte). Att ange ett v\00E4rde minskar listan av'),
unistr('v\00E4rden l\00E4ngst ner i menyn. Du kan sedan v\00E4lja ett v\00E4rde'),
unistr('l\00E4ngst ner och det valda v\00E4rdet visas som ett filter genom att anv\00E4nda "="'),
unistr('(till exempel, <code>kolumn= "ABC"</code>). Alternativt kan du klicka p\00E5 s\00F6kfunktionsikonen och ange ett v\00E4rde som ska skapas som ett filter med "LIKE"-modifieraren (till exempel <code>kolumn LIKE "%ABC%"</code>).</li>'),
unistr('<li><b>Lista av unika v\00E4rden</b> inneh\00E5ller de f\00F6rsta 500 unika'),
unistr('v\00E4rdena som uppfyller dina filterkriterier. Om kolumnen \00E4r ett datum visas en lista av datumintervall'),
unistr('ist\00E4llet. Om du v\00E4ljer ett v\00E4rde kommer ett filter att'),
unistr('skapas genom att anv\00E4nda "=" (till exempel, <code>kolumn = "ABC"</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263846684402360)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00E5ter dig l\00E4gga till ber\00E4knade kolumner i din rapport. Detta kan vara matematiska ber\00E4kningar (till exempel <code>NBR_HOURS/24</code>) eller Oracle'),
unistr('standardfunktioner som till\00E4mpas p\00E5 befintliga kolumner. Vissa visas som exempel och andra (t.ex. kan \00E4ven <code>TO_DATE)</code> anv\00E4ndas). Alternativen inkluderar f\00F6ljande:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Ber\00E4kning</strong> l\00E5ter dig v\00E4lja en tidigare definierad ber\00E4kning att redigera.</li>'),
unistr('<li><strong>Kolumnrubrik</strong> \00E4r kolumnrubriken f\00F6r den nya kolumnen.</li>'),
unistr('<li><strong>Formatmask</strong> \00E4r en Oracle-formatmask som ska till\00E4mpas mot kolumnen (till exempel S9999).</li>'),
unistr('<li><strong>Ber\00E4kning</strong> \00E4r ber\00E4kningen som ska utf\00F6ras. Inom ber\00E4kningen h\00E4nvisas kolumner genom att anv\00E4nda visningsalias.</li>'),
'</ul>',
unistr('<p>Under ber\00E4kning visas kolumnerna i din fr\00E5ga med'),
unistr('sina associerade alias. Att klicka p\00E5 kolumnnamnet eller alias inkluderar'),
unistr('dem i ber\00E4kningen. Bredvid Kolumner finns en knappsats. Den h\00E4r knappsatsen fungerar som'),
unistr('en genv\00E4g till ofta anv\00E4nda knappar. L\00E4ngst till h\00F6ger finns Funktioner.</p>'),
unistr('<p>F\00F6ljande exempelber\00E4kning demonstrerar hur total ers\00E4ttning visas:</p>'),
'<pre>CASE WHEN A = ''SALES'' AND B + C ELSE B END</pre>',
unistr('(d\00E4r A \00E4r ORGANIZATION, B \00E4r SALARY och C \00E4r COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270340852402365)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nds f\00F6r att skapa en brytgrupp p\00E5 en eller flera kolumner. Detta extraherar kolumnerna ur den interaktiva rapporten och visar dem som en masterpost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264510236402361)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6r att visa detaljerna f\00F6r en enstaka rad \00E5t g\00E5ngen klickar du p\00E5 ikonen f\00F6r enstaka rad-vy f\00F6r den rad du vill visa. Om den \00E4r tillg\00E4nglig kommer vyn f\00F6r enstaka rader alltid att vara den f\00F6rsta kolumnen. Beroende p\00E5 anpassningen f\00F6r den interaktiv')
||unistr('a rapporten kan vyn f\00F6r enstaka rader vara standardvyn eller en anpassad sida som till\00E5ter uppdateringar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264440302402360)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00E5ter den aktuella resultatupps\00E4ttningen laddas ned. Nedladdningsformaten'),
unistr('varierar beroende p\00E5 din installations- och rapportdefinition men'),
'kan inkludera CSV, HTML, Email, XLS, PDF eller RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263553075402360)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fokuserar rapporten genom att l\00E4gga till eller modifiera satsen <code>WHERE</code> p\00E5 fr\00E5gan. Du kan filtrera efter kolumn eller efter rad.  '),
unistr('<p>Om du filtrerar efter kolumn v\00E4ljer du en kolumn (det beh\00F6ver inte vara'),
unistr('en kolumn som visas), v\00E4lj en Oracle standardoperator (=, !=, ej i, mellan), och ange ett uttryck att j\00E4mf\00F6ra mot. Uttryck \00E4r skiftl\00E4gesk\00E4nsliga. Anv\00E4nd % som ett jokertecken (till exempel, <code>STATE_NAME'),
'som A%)</code>.</p>',
unistr('<p>Om du filtrerar efter rad kan du skapa komplexa <code>WHERE</code>-satser genom att anv\00E4nda'),
unistr('kolumnalias och Oracle-funktioner eller -operatorer (till exempel, <code>G = "VA" eller G = "CT"</code>, n\00E4r'),
unistr('<code>G</code> \00E4r alias f\00F6r <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264175625402360)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('En flashbackfr\00E5ga l\00E5ter dig visa data som fanns vid en tidigare'),
unistr('tidpunkt. Standardtiden f\00F6r en flashback \00E4r 3 timmar (eller 180'),
unistr('minuter) men den faktiska tiden kan variera f\00F6r varje databas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325332044402421)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Format l\00E5ter dig anpassa visningen av rapporten.'),
unistr('Format inneh\00E5ller f\00F6ljande undermenyer:</p>'),
'<ul><li>Sortera</li>',
'<li>Kontrollstopp</li>',
'<li>Markera</li>',
unistr('<li>Ber\00E4kna</li>'),
'<li>Aggregera</li>',
'<li>Diagram</li>',
'<li>Gruppera per</li>',
'<li>Pivot</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323526508402420)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definiera en Gruppera per f\00F6r varje sparad'),
unistr('rapport. N\00E4r det har definierats kan du v\00E4xla mellan vyerna Gruppera per och Rapport'),
unistr('genom att anv\00E4nda vyikonerna i s\00F6kf\00E4ltet. F\00F6r att skapa en Gruppera per-vy'),
unistr('v\00E4ljer du:'),
'<p></p><ul>',
'<li>kolumnen som ska grupperas</li>',
unistr('<li>kolumnerna som ska aggregeras tillsammans med funktionen som ska utf\00F6ras (genomsnitt, summa, antal, osv.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263798605402360)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>L\00E5ter dig definiera ett filter. Raderna som uppfyller filterkriterierna visas som markerade genom att anv\00E4nda egenskaper som \00E4r associerade med filtret. Alternativen inkluderar f\00F6ljande:</p>'),
'<ul>',
unistr('<li><strong>Namn</strong> anv\00E4nds endast f\00F6r visning.</li>'),
unistr('<li><strong>Sekvens</strong> identifierar sekvensen som regler utv\00E4rderas efter .</li>'),
unistr('<li><strong>Aktiv</strong> identifierar om en regel \00E4r aktiv eller inaktiv.</li>'),
'<li><strong>Markeringstyp</strong> identifierar om raden eller cellen ska',
unistr('markeras. Om Cell v\00E4ljs kommer kolumnen som h\00E4nvisas i'),
'Markeringsvillkor att markeras.</li>',
unistr('<li><strong>Bakgrundsf\00E4rg</strong> \00E4r den nya f\00E4rgen f\00F6r bakgrunden i det markerade omr\00E5det.</li>'),
unistr('<li><strong>Textf\00E4rg</strong> \00E4r den nya f\00E4rgen f\00F6r texten i det markerade omr\00E5det.</li>'),
'<li><strong>Markeringsvillkor</strong> definierar dina filtervillkor.</li>',
'</ul>',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201312894402310)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Du kan definiera en pivotvy per sparad rapport. N\00E4r det har definierats kan du v\00E4xla mellan pivot- och rapportvyerna genom att anv\00E4nda visningsikonerna i s\00F6kf\00E4ltet. F\00F6r att skapa en pivotvy v\00E4ljer du: '),
'<p></p>',
'<ul>',
'<li>kolumnerna som ska pivoteras </li>',
'<li>kolumnerna som ska visas som rader</li>',
unistr('<li>kolumnerna som ska aggregeras tillsammans med funktionen som ska utf\00F6ras (genomsnitt, summa, antal osv.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274840111402368)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Om du anpassar en interaktiv rapport visas rapportinst\00E4llningarna'),
unistr('under s\00F6kf\00E4ltet och ovanf\00F6r rapporten. Det h\00E4r omr\00E5det kan komprimeras och expanderas genom att anv\00E4nda ikonen till v\00E4nster.'),
'<p>',
unistr('F\00F6r varje rapportinst\00E4llning kan du:'),
'</p><ul>',
unistr('<li>Redigera en inst\00E4llning genom att klicka p\00E5 namnet.</li>'),
unistr('<li>Avaktivera/aktivera en inst\00E4llning genom att avmarkera eller markera kryssrutan Aktivera/avaktivera. Anv\00E4nd det h\00E4r alternativet f\00F6r att tempor\00E4rt sl\00E5 p\00E5 eller sl\00E5 av en inst\00E4llning.</li>'),
unistr('<li>Flytta bort en inst\00E4llning genom att klicka p\00E5 ikonen Flytta bort.</li>'),
'</ul>',
unistr('<p>Om du har skapat ett diagram, Gruppera per eller pivot kan du v\00E4xla mellan dem'),
unistr('och basrapporten med hj\00E4lp av l\00E4nkarna f\00F6r rapportvyn, diagramvyn, Gruppera per-vyn och pivotvyn'),
unistr('som visas till h\00F6ger. Om du visar diagram, Gruppera per eller pivot kan'),
unistr('du \00E4ven anv\00E4nda l\00E4nken Redigera f\00F6r att redigera inst\00E4llningarna.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264354114402360)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ller rapporten till standardinst\00E4llningarna och tar bort alla anpassningar du har gjort.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325608946402422)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'sv'
,p_message_text=>'Anger antalet poster som ska visas per sida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264298578402360)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sparar den anpassade rapporten f\00F6r framtida anv\00E4ndning. Du anger ett namn och beskrivning (valfritt) och kan g\00F6ra rapporten offentlig (vilket inneb\00E4r att alla anv\00E4ndare kan komma \00E5t den prim\00E4ra standardrapporten). Du kan spara fyra typer av intera')
||'ktiva rapporter:</p>',
'<ul>',
unistr('<li><strong>Prim\00E4r standard</strong> (endast utvecklare). Prim\00E4r standard \00E4r rapporten som inledningsvis visas. Prim\00E4ra standardrapporter kan inte d\00F6pas om eller tas bort.</li>'),
unistr('<li><strong>Alternativ rapport</strong> (endast utvecklare). L\00E5ter utvecklare skapa flera rapportlayouter. Endast utvecklare kan spara, d\00F6pa om eller ta bort en alternativ rapport.</li>'),
unistr('<li><strong>Offentlig rapport</strong> (slutanv\00E4ndare). Kan sparas, d\00F6pas om eller tas bort av slutanv\00E4ndaren som skapade den. Andra anv\00E4ndare kan visa och spara layouten som en annan rapport.</li>'),
unistr('<li><strong>Privat rapport</strong> (slutanv\00E4ndare). Endast slutanv\00E4ndaren som skapade rapporten kan visa, spara, d\00F6pa om eller ta bort rapporten.</li>'),
'</ul>',
unistr('<p>Om du sparar anpassade rapporter visas en rapportv\00E4ljare i s\00F6kf\00E4ltet till v\00E4nster om radv\00E4ljaren (om denna funktion \00E4r aktiv).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263281327402359)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6verst p\00E5 varje rapportsida finns en s\00F6kregion. Denna region (eller s\00F6kf\00E4lt) tillhandah\00E5ller f\00F6ljande funktioner:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326224699402422)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('<li><strong>\00C5tg\00E4rdsmenyn</strong> l\00E5ter dig anpassa en rapport. Se efterf\00F6ljande sektioner.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325755098402422)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'sv'
,p_message_text=>unistr('<li><strong>Ikonen V\00E4lj kolumner</strong> l\00E5ter dig identifiera vilka kolumner att s\00F6ka i (eller alla).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326077118402422)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'sv'
,p_message_text=>'<li><strong>Rapporter</strong> visar alternativa standardrapporter och sparade privata eller offentliga rapporter.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325959809402422)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'sv'
,p_message_text=>'<li><strong>Rader</strong> anger antalet poster som ska visas per sida.</li>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325870618402422)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Textomr\00E5de</strong> l\00E5ter dig ange skiftl\00E4gesk\00E4nsliga s\00F6kkriterier (jokertecken \00E4r underf\00F6rst\00E5dda).</li>'),
unistr('<li><strong>S\00F6k-knappen</strong> k\00F6r s\00F6kningen. Att trycka p\00E5 Enter k\00F6r \00E4ven s\00F6kningen n\00E4r mark\00F6ren \00E4r i s\00F6ktextomr\00E5det.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326127075402422)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('<li><strong>Vyikoner</strong> v\00E4xlar mellan vyerna Ikon, Rapport, Detalj, Diagram, Gruppera per och Pivot i rapporten om de har definierats.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342142186402434)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('<li><strong>Hantera</strong> l\00E5ter dig hantera egenskaperna, kolumnerna, raderna och visningshistoriken f\00F6r rapporten eller datarutn\00E4tet.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263492568402360)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nds f\00F6r att modifiera de kolumner som visas. Kolumnerna till h\00F6ger visas. Kolumnerna till v\00E4nster d\00F6ljs. Du kan ordna om de kolumner som visas genom att anv\00E4nda pilarna l\00E4ngst till h\00F6ger. Ber\00E4knade kolumner har prefix med <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263659728402360)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Anv\00E4nds f\00F6r att \00E4ndra kolumnerna som ska sorteras och fastst\00E4ller om'),
unistr('de ska sorteras i stigande eller fallande ordning. Du kan \00E4ven ange hur'),
unistr('<code>NULLs</code> ska hanteras. Standardinst\00E4llningen visar alltid <code>NULLs</code> sist eller visar dem alltid f\00F6rst. Den resulterande sorteringen visas till h\00F6ger om'),
'kolumnrubrikerna i rapporten.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323376685402420)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4r du l\00E4gger till en prenumeration anger du en e-postadress (eller flera e-postadresser, avgr\00E4nsade med kommatecken), e-post\00E4mne, frekvens och start- och slutdatum. De resulterande e-postmeddelandena inkluderar en HTML-version av den interaktiva rap')
||unistr('porten och inneh\00E5ller aktuella data med hj\00E4lp av rapportinst\00E4llningarna som var aktuella n\00E4r prenumerationen lades till.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341909101402434)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Datarutn\00E4t \00E4r egentligen redigerbara rapporter som \00E4r v\00E4ldigt anpassningsbara. Anv\00E4ndare kan \00E4ndra layouten f\00F6r rapportdata genom att v\00E4lja kolumner, till\00E4mpa filter, markera och sortera. Anv\00E4ndare kan \00E4ven definiera brytkolumner, aggregeringar, diag')
||unistr('ram, Gruppera per och l\00E4gga till sina egna ber\00E4kningar. Anv\00E4ndare kan skapa flera versioner av en rapport och spara dem som namngivna rapporter f\00F6r privat visning. '),
'<p/>',
unistr('Ett datarutn\00E4t kan anpassas med hj\00E4lp av s\00F6kf\00E4ltet, menyn \00C5tg\00E4rder, menyn Hantera eller menyn Kolumnrubrik.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353752396402443)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tg\00E4rdsmenyn visas till h\00F6ger om S\00F6k-knappen i s\00F6kf\00E4ltet. Anv\00E4nd den h\00E4r menyn f\00F6r att anpassa en datarutn\00E4tsrapport.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342479955402434)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'sv'
,p_message_text=>unistr('Sidan L\00E4gg till/redigera rad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342509666402435)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>F\00F6r att l\00E4gga till en rad i datarutn\00E4tet klickar du p\00E5 L\00E4gg till. F\00F6r att redigera detaljerna f\00F6r en rad klickar du p\00E5 ikonen Redigera rad (f\00F6rsta kolumnen) p\00E5 raden du vill redigera. Sidan L\00E4gg till/redigera rad visas och kolumnerna i datarutn\00E4te')
||'t visas. </p>',
'',
unistr('<p>N\00E4r du redigerar en rad kan du:</p>'),
'',
'<p><ul>',
'<li><strong>Ta bort</strong> raden.</li>',
unistr('<li><strong>Till\00E4mpa \00E4ndringar</strong> f\00F6r att spara \00E4ndringarna som har gjorts i raden.</li>'),
unistr('<li>I<strong>\00C5tg\00E4rder</strong>, kan du l\00E4gga till en rad, l\00E4gga till filer, anteckningar, l\00E4nkar eller taggar och granska historiken.</li>'),
unistr('<li>Navigera till <strong>N\00E4sta och f\00F6reg\00E5ende</strong> rader.</li>'),
unistr('<li>I <strong>Hantera</strong>, kan du ange kolumnegenskaper, kolumngrupper, valideringar och listor av v\00E4rden.</li>'),
'</ul></p>',
'',
unistr('<p>Regionen Anteckningar l\00E4ngst ner p\00E5 sidan visar alla filer, anteckningar, l\00E4nkar eller taggar som associeras med den aktuella raden.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353892294402443)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nds f\00F6r att skapa en brytgrupp p\00E5 en eller flera kolumner. Detta extraherar kolumnerna ur datarutn\00E4tet och visar dem som en masterpost.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342324462402434)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00E5ter den aktuella resultatupps\00E4ttningen laddas ned. Nedladdningsformaten'),
'inkluderar CSV, HTML, eller e-post.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353954677402443)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Om du anpassar en datarutn\00E4tsrapport visas rapportinst\00E4llningarna'),
unistr('under s\00F6kf\00E4ltet och ovanf\00F6r rapporten. Det h\00E4r omr\00E5det kan komprimeras och expanderas genom att anv\00E4nda ikonen till v\00E4nster.'),
'<p>',
unistr('F\00F6r varje rapportinst\00E4llning kan du:'),
'</p><ul>',
unistr('<li>Redigera en inst\00E4llning genom att klicka p\00E5 namnet.</li>'),
unistr('<li>Avaktivera/aktivera en inst\00E4llning genom att avmarkera eller markera kryssrutan Aktivera/avaktivera. Anv\00E4nd det h\00E4r alternativet f\00F6r att tempor\00E4rt sl\00E5 p\00E5 eller sl\00E5 av en inst\00E4llning.</li>'),
unistr('<li>Flytta bort en inst\00E4llning genom att klicka p\00E5 ikonen Flytta bort.</li>'),
'</ul>',
unistr('<p>Om du har skapat ett diagram eller Gruppera per kan du v\00E4xla mellan dem'),
unistr('och basrapporten med hj\00E4lp av l\00E4nkarna f\00F6r rapportvyn, diagramvyn och Gruppera per-vyn'),
unistr('som visas till h\00F6ger. Om du visar diagram eller Gruppera per kan'),
unistr('du \00E4ven anv\00E4nda l\00E4nken Redigera f\00F6r att redigera inst\00E4llningarna.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342211873402434)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sparar den anpassade rapportlayouten f\00F6r rutn\00E4tet f\00F6r framtida anv\00E4ndning. Du anger ett namn och beskrivning (valfritt). Du kan spara tre typer av rapportlayouter f\00F6r datarutn\00E4t:</p>'),
'<ul>',
unistr('<li><strong>Prim\00E4r standard</strong> (endast administrat\00F6rer). Prim\00E4r standard \00E4r layouten som inledningsvis visas. Prim\00E4ra standardrapporter kan inte d\00F6pas om eller tas bort.</li>'),
unistr('<li><strong>Alternativ rapport</strong> (endast administrat\00F6rer). L\00E5ter administrat\00F6rer skapa flera rapportlayouter. Endast administrat\00F6rer kan spara, d\00F6pa om eller ta bort en alternativ rapport.</li>'),
unistr('<li><strong>Privat rapport</strong> (alla anv\00E4ndare). Anv\00E4ndaren som skapade rapportlayouten kan visa, spara, d\00F6pa om eller ta bort rapporten.</li>'),
'</ul>',
unistr('<p>Om du sparar anpassade rapporten visas en rapportv\00E4ljare i s\00F6kf\00E4ltet till v\00E4nster om radv\00E4ljaren (om denna funktion \00E4r aktiv).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268348771402363)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('D\00F6lj kolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258912302402356)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'sv'
,p_message_text=>'Markera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269880196402364)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'sv'
,p_message_text=>'Markeringar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274998963402368)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'sv'
,p_message_text=>'Markera villkor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323955552402420)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'sv'
,p_message_text=>'Markeringsformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233908824402338)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Markera typ'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343476973402435)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'sv'
,p_message_text=>'Horisontellt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373095919402458)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'sv'
,p_message_text=>unistr('1 inaktiv inst\00E4llning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373166369402458)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inaktiva inst\00E4llningar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264946782402361)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp f\00F6r interaktiv rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275937366402369)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'sv'
,p_message_text=>'Ogiltig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269317690402364)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltigt ber\00E4kningsuttryck. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228724607402334)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'sv'
,p_message_text=>unistr('Slutdatumet m\00E5ste infalla efter startdatumet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283633443402375)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt filteruttryck. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351446243402441)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig filterfr\00E5ga')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373229682402458)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'sv'
,p_message_text=>unistr('1 ogiltig inst\00E4llning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373374833402458)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 ogiltiga inst\00E4llningar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324121400402421)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'sv'
,p_message_text=>'(i minuter)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341113941402433)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r i de senaste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341344955402434)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r i de kommande %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341272482402434)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r inte i de senaste %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341411492402434)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E4r inte i de kommande %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274066219402368)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'sv'
,p_message_text=>'Knappsats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240198426402342)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Etikett %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267934281402363)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Axelrubrik f\00F6r etikett')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260468239402357)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'sv'
,p_message_text=>'Senaste dagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260671956402358)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'sv'
,p_message_text=>'Senaste timmen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260132454402357)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('Senaste m\00E5naden')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260252745402357)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'sv'
,p_message_text=>'Senaste veckan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260393273402357)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'sv'
,p_message_text=>'Senaste %0 dagarna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260576490402357)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'sv'
,p_message_text=>'Senaste %0 timmarna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259943880402357)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('Senaste %0 \00E5ren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260016003402357)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rra \00E5ret')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240049577402342)
,p_name=>'APEXIR_LINE'
,p_message_language=>'sv'
,p_message_text=>'Linje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236834178402340)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'sv'
,p_message_text=>'Linjediagram med yta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351346043402441)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'sv'
,p_message_text=>'Mappa den'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268835097402364)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'sv'
,p_message_text=>unistr('Fr\00E5gan ber\00E4knas \00F6verskrida det maximala antalet till\00E5tna resurser. \00C4ndra dina rapportinst\00E4llningar och f\00F6rs\00F6k igen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251041295402350)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Det maximala antalet rader f\00F6r den h\00E4r rapporten \00E4r %0 rader.  Till\00E4mpa ett filter f\00F6r att minska antalet poster i din fr\00E5ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351912605402442)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'sv'
,p_message_text=>'Max %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352182404402442)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'sv'
,p_message_text=>'Median %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255031029402353)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 minuter sedan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352092020402442)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'sv'
,p_message_text=>'Min %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351063016402441)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5nad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324541388402421)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5natligen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267137509402362)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'sv'
,p_message_text=>'Flytta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267063260402362)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'sv'
,p_message_text=>'Flytta alla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378287509402462)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Regionens statiska id m\00E5ste anges eftersom sidan inneh\00E5ller flera interaktiva rapporter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235592864402339)
,p_name=>'APEXIR_NAME'
,p_message_language=>'sv'
,p_message_text=>'Namn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262939889402359)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'sv'
,p_message_text=>'Ny aggregering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373929946402459)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Ny kategori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115263008094402359)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Ny ber\00E4kning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257887774402355)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260942581402358)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta dag')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260762640402358)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta timmen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261291689402358)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta m\00E5nad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261124428402358)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta vecka')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261005873402358)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 dagarna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115260869101402358)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 timmarna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261489211402358)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta %0 \00E5ren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261375380402358)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235882494402339)
,p_name=>'APEXIR_NO'
,p_message_language=>'sv'
,p_message_text=>'Nej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276167431402369)
,p_name=>'APEXIR_NONE'
,p_message_language=>'sv'
,p_message_text=>'- Inget -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323744618402420)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'sv'
,p_message_text=>'Inte en giltig e-postadress.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272626950402367)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'sv'
,p_message_text=>unistr('Nulls alltid f\00F6rst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272556801402367)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'sv'
,p_message_text=>'Nulls alltid sist'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273091693402367)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'sv'
,p_message_text=>'Nullsortering %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269493061402364)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'sv'
,p_message_text=>unistr('Flashbacktid m\00E5ste vara numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269093576402364)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'sv'
,p_message_text=>unistr('Sekvensen m\00E5ste vara numerisk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273550014402367)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'sv'
,p_message_text=>'Operator'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234442126402338)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'sv'
,p_message_text=>'orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343394340402435)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'sv'
,p_message_text=>'Orientering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236379431402339)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'sv'
,p_message_text=>unistr('\00D6vrigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219140798402325)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'sv'
,p_message_text=>'Sidorientering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219860708402326)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'sv'
,p_message_text=>'Liggande'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219968902402326)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E5ende ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219007611402325)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'sv'
,p_message_text=>'Sidstorlek'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219612291402326)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'sv'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219528441402326)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'sv'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219783308402326)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'sv'
,p_message_text=>'Anpassad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219386653402326)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'sv'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219209785402325)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'sv'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115219493445402326)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'sv'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352454094402442)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'sv'
,p_message_text=>'Procent av totalt antal %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351635259402442)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'sv'
,p_message_text=>'Procent av totalsumma %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350619603402441)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'sv'
,p_message_text=>'Procent av totalt antal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350549600402441)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'sv'
,p_message_text=>'Procent av totalsumma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239957086402342)
,p_name=>'APEXIR_PIE'
,p_message_language=>'sv'
,p_message_text=>'Cirkel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299857260402387)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'sv'
,p_message_text=>'Pivot'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301351695402388)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Aggregering m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301553435402389)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'sv'
,p_message_text=>'Du kan inte aggregera en vald kolumn till en radkolumn.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300788140402388)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Pivotkolumner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300502187402388)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'sv'
,p_message_text=>'Pivotkolumn %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301152458402388)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Pivotkolumn m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201254165402310)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Det maximala antalet rader f\00F6r en pivotfr\00E5ga begr\00E4nsar antalet rader i basfr\00E5gan, inte antalet rader som visas. Din basfr\00E5ga \00F6verstiger det maximala antalet rader p\00E5 %0. Till\00E4mpa ett filter f\00F6r att minska antalet poster i din basfr\00E5ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301064348402388)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'sv'
,p_message_text=>'Pivotsortering'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270459125402365)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'sv'
,p_message_text=>unistr('Pivotkolumnen inneh\00E5ller f\00F6r m\00E5nga unika v\00E4rden \2013 pivot-SQL kan inte genereras.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323820353402420)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6rhandsgranska')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257955611402356)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115349555264402440)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'sv'
,p_message_text=>unistr('Prim\00E4r')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324802589402421)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'sv'
,p_message_text=>unistr('Prim\00E4r rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218969424402325)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Inkludera tillg\00E4nglighetstaggar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205879662402314)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'sv'
,p_message_text=>'RTF-remsa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282685602402374)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'sv'
,p_message_text=>'Privat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240554194402343)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'sv'
,p_message_text=>unistr('Allm\00E4n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236177378402339)
,p_name=>'APEXIR_RED'
,p_message_language=>'sv'
,p_message_text=>unistr('r\00F6d')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378168250402462)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Regionens statiska id %0 finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267200365402363)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267308950402363)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'sv'
,p_message_text=>'Ta bort alla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373422308402458)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266887634402362)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort kontrollstopp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266505584402362)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Ta bort filter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266616491402362)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373501131402458)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort Gruppera per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266989810402362)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort markering'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373666001402458)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'sv'
,p_message_text=>'Flytta bort pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354661560402444)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Ta bort rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335275773402429)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'sv'
,p_message_text=>unistr('Namn\00E4ndra standardrapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276422538402370)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'sv'
,p_message_text=>unistr('Namn\00E4ndra rapport')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258245998402356)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352542786402442)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'sv'
,p_message_text=>'Rapporter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232713582402337)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Sparad Interaktiv rapport med alias %0 finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282932281402375)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Rapporten finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232870543402337)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Sparat Interaktiv rapport-id %0 finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115274780682402368)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportinst\00E4llningar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255535223402354)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'sv'
,p_message_text=>'Rapportvy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259493618402357)
,p_name=>'APEXIR_RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240798342402343)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll rapport till standardinst\00E4llningarna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235956900402339)
,p_name=>'APEXIR_ROW'
,p_message_language=>'sv'
,p_message_text=>'Rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348648061402439)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'sv'
,p_message_text=>unistr('Du kan inte anv\00E4nda ROWID som den prim\00E4ra nyckelkolumnen f\00F6r en REST-datak\00E4lla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265981873402362)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'sv'
,p_message_text=>'Rader'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325582882402422)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'sv'
,p_message_text=>'Rader per sida'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300815992402388)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Radkolumner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300601378402388)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'sv'
,p_message_text=>'Radkolumn %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301285096402388)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Radkolumn m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301476421402389)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'sv'
,p_message_text=>unistr('Radkolumn m\00E5ste skilja sig fr\00E5n pivotkolumnen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280002092402372)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Radfilter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255620922402354)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'sv'
,p_message_text=>'Rad %0 av %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259646367402357)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'sv'
,p_message_text=>unistr('Radtext inneh\00E5ller')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235269247402339)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'sv'
,p_message_text=>'Spara'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270028198402365)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Sparad rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269900211402365)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'sv'
,p_message_text=>'Sparad rapport = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272130970402366)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'sv'
,p_message_text=>unistr('De aktuella rapportinst\00E4llningarna anv\00E4nds som standard f\00F6r alla anv\00E4ndare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115335172423402429)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Spara standardrapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115259343157402357)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Spara rapport'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373819918402459)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'sv'
,p_message_text=>'Spara rapport *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326540890402422)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115264826661402361)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6kf\00E4lt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115373760013402459)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k i: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332050392402427)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k efter rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316093265402400)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>'Valda kolumner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236989885402340)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj kolumn -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258653960402356)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj kolumner')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240433444402342)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj funktion -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265608021402361)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj Gruppera per kolumn -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300360333402388)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj pivotkolumn -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351545198402442)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj rad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300437973402388)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('- V\00E4lj radkolumn -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209100923402316)
,p_name=>'APEXIR_SEND'
,p_message_language=>'sv'
,p_message_text=>'Skicka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215465911402323)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'sv'
,p_message_text=>'Skicka som e-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235603085402339)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'sv'
,p_message_text=>'Sekvens'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258894935402356)
,p_name=>'APEXIR_SORT'
,p_message_language=>'sv'
,p_message_text=>'Sortera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268122165402363)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'sv'
,p_message_text=>'Sortera i stigande ordning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268299800402363)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'sv'
,p_message_text=>'Sortera i fallande ordning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354049370402443)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'sv'
,p_message_text=>'Sorteringsordning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262684830402359)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'sv'
,p_message_text=>'blanksteg'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273731088402368)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'sv'
,p_message_text=>'Status %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324260175402421)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'sv'
,p_message_text=>'Prenumeration'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350973745402441)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'sv'
,p_message_text=>'Slutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205349752402314)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'sv'
,p_message_text=>unistr('Hoppa \00F6ver om inga data hittades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115350810055402441)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'sv'
,p_message_text=>unistr('Startar fr\00E5n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351782801402442)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'sv'
,p_message_text=>'Summa %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341799975402434)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'sv'
,p_message_text=>unistr('Region = %0, Rapport = %1, Vy = %2, Visade rader b\00F6rjar p\00E5 = %3, Visade rader slutar p\00E5 = %4, Totalt antal rader = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262304501402359)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'sv'
,p_message_text=>unistr('Region = %0, Rapport = %1, Vy = %2, Visade rader b\00F6rjar p\00E5 = %3, Visade rader slutar p\00E5 = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234524400402338)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Textf\00E4rg')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251612207402351)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'sv'
,p_message_text=>'dagar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251567543402351)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'sv'
,p_message_text=>'timmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251466360402351)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'sv'
,p_message_text=>'minuter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251842277402351)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('m\00E5nader')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251701820402351)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'sv'
,p_message_text=>'veckor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115251951146402351)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115354479793402444)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4xla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267409709402363)
,p_name=>'APEXIR_TOP'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4ngst upp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347667967402439)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Ogrupperad kolumn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268980407402364)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'sv'
,p_message_text=>unistr('Markerat namn m\00E5ste vara unikt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239217706402342)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('datatypen st\00F6ds inte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267575966402363)
,p_name=>'APEXIR_UP'
,p_message_language=>'sv'
,p_message_text=>'Upp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269178289402364)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ange en giltig f\00E4rg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269225900402364)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'sv'
,p_message_text=>'Ange en giltig formatmask.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115236401134402339)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115268008920402363)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Axelrubrik f\00F6r v\00E4rde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275892454402369)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett v\00E4rde m\00E5ste anges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239862802402342)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'sv'
,p_message_text=>'Vertikal kolumn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115343528758402435)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'sv'
,p_message_text=>'Vertikalt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275132119402369)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'sv'
,p_message_text=>'Visa diagram'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330338299402425)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'sv'
,p_message_text=>'Visa detalj'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115375942047402460)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Rapporten har ingen definierad %0-vy.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330404278402425)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'sv'
,p_message_text=>'Visa Gruppera per'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330228319402425)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'sv'
,p_message_text=>'Visa ikoner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300156248402387)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'sv'
,p_message_text=>'Visa pivot'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115275227528402369)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Visa rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324406874402421)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'sv'
,p_message_text=>'Veckovis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258101059402356)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Aktuell rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353171950402443)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'sv'
,p_message_text=>'%0 dagar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353091182402443)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'sv'
,p_message_text=>'%0 timmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115352903938402443)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'sv'
,p_message_text=>'%0 minuter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353357500402443)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 m\00E5nader')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353267757402443)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'sv'
,p_message_text=>'%0 veckor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115353485386402443)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115351127215402441)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115234293431402338)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'sv'
,p_message_text=>'gul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115235711824402339)
,p_name=>'APEXIR_YES'
,p_message_language=>'sv'
,p_message_text=>'Ja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115267822342402363)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 inneh\00E5ller < or > som \00E4r ogiltiga tecken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115290657048402380)
,p_name=>'APEX_REGION'
,p_message_language=>'sv'
,p_message_text=>'Region'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115218831498402325)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'sv'
,p_message_text=>unistr('API-f\00F6rhandsvillkor \00F6vertr\00E4tt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238382145402341)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte h\00E4mta v\00E4rde f\00F6r Applikationsinst\00E4llningen %0 eftersom associerat byggalternativ \00E4r inaktivt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238278734402341)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte ange v\00E4rde f\00F6r Applikationsinst\00E4llningen %0 eftersom associerat byggalternativ \00E4r inaktivt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345924229402437)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rdet f\00F6r applikationsinst\00E4llningen %0 \00E4r ogiltigt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115345802575402437)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'sv'
,p_message_text=>unistr('Beg\00E4rd applikationsinst\00E4llning %0 har inte definierats')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346016090402437)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rdet f\00F6r applikationsinst\00E4llningen %0 f\00E5r inte vara null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226905198402332)
,p_name=>'BACK'
,p_message_language=>'sv'
,p_message_text=>'Tillbaka'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213952902402321)
,p_name=>'BUILDER'
,p_message_language=>'sv'
,p_message_text=>'Verktyg'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278024084402371)
,p_name=>'BUTTON LABEL'
,p_message_language=>'sv'
,p_message_text=>'Knappetikett'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213093936402321)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'sv'
,p_message_text=>unistr('CSS-klasser f\00F6r knapp')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242207645402344)
,p_name=>'BUTTON_ID'
,p_message_language=>'sv'
,p_message_text=>unistr('Genererat knapp-id kommer antingen att vara knappens statiska id om det \00E4r definierat, eller ett internt genererat id i formatet "B" || [internt knapp-id]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205785453402314)
,p_name=>'CANDLESTICK'
,p_message_language=>'sv'
,p_message_text=>'Candlestick'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287290665402378)
,p_name=>'CENTER'
,p_message_language=>'sv'
,p_message_text=>'Center'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237263992402340)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 Beg\00E4ran')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228668334402333)
,p_name=>'CHECK$'
,p_message_language=>'sv'
,p_message_text=>unistr('radv\00E4ljare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115347727092402439)
,p_name=>'CHECKED'
,p_message_language=>'sv'
,p_message_text=>'markerad'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323223034402420)
,p_name=>'COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Kolumn'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283781145402375)
,p_name=>'COMMENTS'
,p_message_language=>'sv'
,p_message_text=>'Kommentarer'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265283082402361)
,p_name=>'CONTINUE'
,p_message_language=>'sv'
,p_message_text=>unistr('Forts\00E4tt')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227214504402332)
,p_name=>'COPYRIGHT'
,p_message_language=>'sv'
,p_message_text=>unistr('Copyright & copy; %0, Oracle f\00F6rbeh\00E5ller sig samtliga r\00E4ttigheter.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270977392402365)
,p_name=>'COUNT'
,p_message_language=>'sv'
,p_message_text=>'Antal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277698517402371)
,p_name=>'CREATE'
,p_message_language=>'sv'
,p_message_text=>'Skapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329981445402425)
,p_name=>'CREATED'
,p_message_language=>'sv'
,p_message_text=>'Skapad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330072670402425)
,p_name=>'CREATED_BY'
,p_message_language=>'sv'
,p_message_text=>'Skapad av'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254844749402353)
,p_name=>'CREATED_ON'
,p_message_language=>'sv'
,p_message_text=>'Skapad den'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265400140402361)
,p_name=>'CUSTOM'
,p_message_language=>'sv'
,p_message_text=>'Anpassad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276697882402370)
,p_name=>'CUSTOMIZE'
,p_message_language=>'sv'
,p_message_text=>'Anpassa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278222334402371)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('Sidinst\00E4llningarna har \00E5terst\00E4llts f\00F6r anv\00E4ndaren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278376667402371)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'sv'
,p_message_text=>unistr('Inst\00E4llningarna har \00E4ndrats f\00F6r anv\00E4ndaren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278172429402371)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('Sidinst\00E4llningarna har \00E5terst\00E4llts f\00F6r anv\00E4ndaren %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241945956402344)
,p_name=>'DAILY'
,p_message_language=>'sv'
,p_message_text=>'Dagligen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115213513191402321)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('Den uppladdade filen \00E4r ogiltig eller har fel filtill\00E4gg.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237438022402340)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig v\00E4ljare f\00F6r XML eller JSON anv\00E4nds.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206780173402315)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataprofilen och den uppladdade filen inneh\00E5ller ingen m\00E5ltabellkolumn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292461162402382)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'sv'
,p_message_text=>'Inga data hittades i den uppladdade filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292555038402382)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'sv'
,p_message_text=>'Inga data hittades i arbetsbladet "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115212328771402320)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('Den angivna filen \00E4r inte en giltig XLSX-fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115202762366402311)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataladdning slutf\00F6rd: %0 rader har bearbetats.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203987298402312)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataladdning slutf\00F6rd: %0 rader har bearbetats med 1 fel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204290753402313)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataladdning slutf\00F6rd: %0 rader har bearbetats med %1 fel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204032108402313)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataladdning slutf\00F6rd: 1 rad har bearbetats.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207013991402315)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataladdning slutf\00F6rd: 1 rad har bearbetats med fel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204107334402313)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'sv'
,p_message_text=>unistr('Dataladdning slutf\00F6rd: 1 rad har bearbetats utan fel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297733995402386)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5lkolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297872106402386)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'sv'
,p_message_text=>unistr('K\00E4llkolumn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298652160402386)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Datum/talformat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362058839402450)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('Kunde inte h\00E4mta uppslagsv\00E4rdet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115330538308402426)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'sv'
,p_message_text=>'Data/tabellmappning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298784953402386)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'sv'
,p_message_text=>'Rad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294279764402383)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('Transformeringsregeln utf\00F6rdes inte')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270537288402365)
,p_name=>'DATE'
,p_message_language=>'sv'
,p_message_text=>'Datum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244644757402346)
,p_name=>'DAY'
,p_message_language=>'sv'
,p_message_text=>'dag'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244783876402346)
,p_name=>'DAYS'
,p_message_language=>'sv'
,p_message_text=>'dagar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283438948402375)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'sv'
,p_message_text=>unistr('Fels\00F6kning har inte aktiverats f\00F6r den h\00E4r applikationen.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115332251840402427)
,p_name=>'DEFAULT'
,p_message_language=>'sv'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245480605402346)
,p_name=>'DELETE'
,p_message_language=>'sv'
,p_message_text=>'ta bort'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115205603612402314)
,p_name=>'DIAL_PCT'
,p_message_language=>'sv'
,p_message_text=>'Visare (procent)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220162351402326)
,p_name=>'DOWNLOAD'
,p_message_language=>'sv'
,p_message_text=>'Ladda ned'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331399546402426)
,p_name=>'DUP_USER'
,p_message_language=>'sv'
,p_message_text=>unistr('Dubblettanv\00E4ndarnamn f\00F6rekommer i listan.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227783207402333)
,p_name=>'EDIT'
,p_message_language=>'sv'
,p_message_text=>'Redigera'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237183508402340)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'E-postadressen "%0" hittades inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222229336402328)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'sv'
,p_message_text=>'E-postmeddelandet skickades av %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331556960402426)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'sv'
,p_message_text=>unistr('E-postadressen \00E4r f\00F6r l\00E5ng. Gr\00E4nsen \00E4r 240 tecken.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265142421402361)
,p_name=>'ERROR'
,p_message_language=>'sv'
,p_message_text=>'Fel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294303563402383)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte konfigurera sidobjektets k\00E4llv\00E4rde f\00F6r partiell sidf\00F6rnyelseregion')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256683330402355)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'sv'
,p_message_text=>'Skapad av'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222517373402328)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet har upph\00F6rt')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115216637177402323)
,p_name=>'FILE_EMPTY'
,p_message_language=>'sv'
,p_message_text=>unistr('Filen \00E4r tom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296830196402385)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Storleken p\00E5 den uppladdade filen \00F6verskrider %0 Mbyte. Ladda upp en mindre fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224672678402330)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarautentiseringen utf\00F6rdes inte och en eller fler filer laddades inte upp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224733805402331)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r instansen till\00E5ter inte icke-autentiserade anv\00E4ndare att ladda upp filer.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277768499402371)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('1 fel har intr\00E4ffat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276962910402370)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 fel har intr\00E4ffat')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227113771402332)
,p_name=>'FORM_OF'
,p_message_language=>'sv'
,p_message_text=>'%0 av %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261882163402358)
,p_name=>'GO'
,p_message_language=>'sv'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361674316402449)
,p_name=>'HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hj\00E4lp')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214035918402321)
,p_name=>'HOME'
,p_message_language=>'sv'
,p_message_text=>'Hem'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244432409402345)
,p_name=>'HOUR'
,p_message_language=>'sv'
,p_message_text=>'timme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244516530402346)
,p_name=>'HOURS'
,p_message_language=>'sv'
,p_message_text=>'timmar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228594565402333)
,p_name=>'ICON'
,p_message_language=>'sv'
,p_message_text=>'Ikon %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278588030402371)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'sv'
,p_message_text=>'Ogiltiga inloggningsuppgifter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115378079308402462)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltigt v\00E4rde f\00F6r parameter: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273287045402367)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'sv'
,p_message_text=>unistr('Som standardinst\00E4llningar f\00F6r rapport')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273319448402367)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'sv'
,p_message_text=>'Som namngiven rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255702986402354)
,p_name=>'IR_ERROR'
,p_message_language=>'sv'
,p_message_text=>'%0 fel. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255418730402354)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte ber\00E4kna formul\00E4rnavigering. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233070305402337)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Interaktiv rapport hittades inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232441274402336)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Interaktiv rapportregion finns inte i applikationen %0, sida %1 och region %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115273126826402367)
,p_name=>'IR_STAR'
,p_message_language=>'sv'
,p_message_text=>unistr('Visas endast f\00F6r utvecklare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261574472402358)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportfr\00E5gan beh\00F6ver en unik nyckel f\00F6r att identifiera varje rad.  Den angivna nyckeln kan inte anv\00E4ndas f\00F6r den h\00E4r fr\00E5gan.  Definiera en unik nyckelkolumn. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261652802402358)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'sv'
,p_message_text=>unistr('Rapportfr\00E5gan beh\00F6ver en unik nyckel f\00F6r att identifiera varje rad.  Den angivna nyckeln kan inte anv\00E4ndas f\00F6r den h\00E4r fr\00E5gan.  Redigera rapportattributen f\00F6r att definiera en unik nyckelkolumn. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298906326402387)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298803288402386)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'sv'
,p_message_text=>unistr('Dra och sl\00E4pp filen h\00E4r eller')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227481918402333)
,p_name=>'ITEMS'
,p_message_language=>'sv'
,p_message_text=>'Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256869396402355)
,p_name=>'ITEM_VALUE'
,p_message_language=>'sv'
,p_message_text=>unistr('Objektv\00E4rde')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271268345402366)
,p_name=>'LABEL'
,p_message_language=>'sv'
,p_message_text=>'Etikett'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283378470402375)
,p_name=>'LANGUAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Spr\00E5k')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245177359402346)
,p_name=>'LAST'
,p_message_language=>'sv'
,p_message_text=>'senaste'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224599008402330)
,p_name=>'LENGTH'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00E4ngd')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277874013402371)
,p_name=>'LOGIN'
,p_message_language=>'sv'
,p_message_text=>'Logga in'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316416648402400)
,p_name=>'MANAGE'
,p_message_language=>'sv'
,p_message_text=>'Hantera'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381028018402464)
,p_name=>'MAXIMIZE'
,p_message_language=>'sv'
,p_message_text=>'Maximera'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244239679402345)
,p_name=>'MINUTE'
,p_message_language=>'sv'
,p_message_text=>'minut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244356935402345)
,p_name=>'MINUTES'
,p_message_language=>'sv'
,p_message_text=>'minuter'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331703432402426)
,p_name=>'MISSING_AT'
,p_message_language=>'sv'
,p_message_text=>'"@" saknas i e-postadressen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331914689402427)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'sv'
,p_message_text=>unistr('Varning: Ingen mall f\00F6r Dialogsia har definierats f\00F6r Dialogsidan %0 i applikationen %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331640053402426)
,p_name=>'MISSING_DOT'
,p_message_language=>'sv'
,p_message_text=>unistr('"." saknas i e-postadressdom\00E4nen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280852846402373)
,p_name=>'MODULE'
,p_message_language=>'sv'
,p_message_text=>'Modul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237908637402341)
,p_name=>'MONTH'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5nad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241755368402343)
,p_name=>'MONTHLY'
,p_message_language=>'sv'
,p_message_text=>unistr('M\00E5natligen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238066972402341)
,p_name=>'MONTHS'
,p_message_language=>'sv'
,p_message_text=>unistr('m\00E5nader')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270815848402365)
,p_name=>'MOVE'
,p_message_language=>'sv'
,p_message_text=>'Flytta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338336617402431)
,p_name=>'MOVE_FROM'
,p_message_language=>'sv'
,p_message_text=>unistr('Flytta fr\00E5n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338403032402431)
,p_name=>'MOVE_TO'
,p_message_language=>'sv'
,p_message_text=>'Flytta till'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115258048828402356)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'sv'
,p_message_text=>'Fel vid borttagning av flera rader: rad= %0, %1, %2'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257020732402355)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00E5r inte vara en offentlig anv\00E4ndare')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214278338402322)
,p_name=>'NAME'
,p_message_language=>'sv'
,p_message_text=>'Namn'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271026514402365)
,p_name=>'NEW'
,p_message_language=>'sv'
,p_message_text=>'Ny'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237717974402340)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'sv'
,p_message_text=>unistr('Du kan logga in p\00E5 %0 genom att g\00E5 till:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237837926402340)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'sv'
,p_message_text=>'Nytt %0-kontomeddelande'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361825184402449)
,p_name=>'NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280791202402373)
,p_name=>'NO'
,p_message_language=>'sv'
,p_message_text=>'Nej'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115376019914402460)
,p_name=>'NOBODY'
,p_message_language=>'sv'
,p_message_text=>'ingen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245590428402346)
,p_name=>'NOT'
,p_message_language=>'sv'
,p_message_text=>'Inte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286331165402377)
,p_name=>'NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>'Inte null'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257181841402355)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'sv'
,p_message_text=>'Inte %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276799009402370)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'sv'
,p_message_text=>'inga data hittades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285841732402377)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Ingen uppdateringsbar rapport hittades. Uppdatering av flera rader och borttagnings\00E5tg\00E4rder kan endast utf\00F6ras p\00E5 tabellformul\00E4r av typen "Uppdateringsbar rapport".')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286725833402377)
,p_name=>'OK'
,p_message_language=>'sv'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282468858402374)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'sv'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115379810400402463)
,p_name=>'ORA_06550'
,p_message_language=>'sv'
,p_message_text=>'ORA-06550: rad %0, kolumn %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329366990402425)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'sv'
,p_message_text=>unistr('Du anv\00E4nder en \00E4ldre version av webbl\00E4saren. Se Oracle Application Express Installation Guide f\00F6r en lista \00F6ver webbl\00E4sare som st\00F6ds.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230784717402335)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig radupps\00E4ttning har beg\00E4rts, k\00E4lldata f\00F6r rapporten har \00E4ndrats.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250857173402350)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett giltigt sidnummer m\00E5ste anges, till exempel p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254477610402353)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254533375402353)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'sv'
,p_message_text=>unistr('N\00E4sta upps\00E4ttning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254628902402353)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115254782144402353)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende upps\00E4ttning')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361794220402449)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj sidnumrering')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292340352402382)
,p_name=>'PASSWORD'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237021419402340)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'sv'
,p_message_text=>unistr('Ditt l\00F6senord f\00F6r %0 har \00E4ndrats.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226805934402332)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet \00E4r inte f\00F6renligt med den h\00E4r webbplatsens komplexitetsregler f\00F6r l\00F6senord.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225970731402331)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Det nya l\00F6senordet m\00E5ste skilja sig fr\00E5n det gamla l\00F6senordet med minst %0 tecken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226536976402332)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet f\00E5r inte inneh\00E5lla anv\00E4ndarnamnet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226747200402332)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet inneh\00E5ller ett f\00F6rbjudet simpelt ord.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226647406402332)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet f\00E5r inte inneh\00E5lla arbetsytenamn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225859778402331)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet m\00E5ste inneh\00E5lla minst %0 tecken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226005685402331)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet m\00E5ste inneh\00E5lla mins ett alfabetiskt tecken (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226471640402332)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet m\00E5ste inneh\00E5lla minst ett alfabetiskt tecken med gemener.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226113968402332)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet m\00E5ste inneh\00E5lla minst ett numeriskt tecken (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226267055402332)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet m\00E5ste inneh\00E5lla minst ett skiljetecken (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115226335710402332)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet m\00E5ste inneh\00E5lla minst ett alfabetiskt tecken med versaler.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237589722402340)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Meddelande om \00E5terst\00E4llning av l\00F6senord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224865532402331)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senordet kan inte anv\00E4ndas eftersom det har anv\00E4nts inom de senaste %0 dagarna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305194722402391)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'sv'
,p_message_text=>'Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115305265058402391)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'sv'
,p_message_text=>'Objekt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282251181402374)
,p_name=>'PERCENT'
,p_message_language=>'sv'
,p_message_text=>'Procent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252594704402352)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kontakta administrat\00F6ren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115361950369402449)
,p_name=>'PREVIOUS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6reg\00E5ende')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297393787402385)
,p_name=>'PRINT'
,p_message_language=>'sv'
,p_message_text=>'Skriv ut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281098682402373)
,p_name=>'PRIVILEGES'
,p_message_language=>'sv'
,p_message_text=>unistr('Beh\00F6righeter')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250914351402350)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'sv'
,p_message_text=>'Regionreferenser'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271198882402366)
,p_name=>'REPORT'
,p_message_language=>'sv'
,p_message_text=>'Rapport'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280987040402373)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'sv'
,p_message_text=>'Rapportperiod'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362118713402450)
,p_name=>'REPORT_LABEL'
,p_message_language=>'sv'
,p_message_text=>'Rapport: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281612968402374)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'sv'
,p_message_text=>'Rapportsumma'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230878070402335)
,p_name=>'RESET'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll sidnumrering')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256728584402355)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll sidnumrering')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285793222402377)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll l\00F6senord')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262503347402359)
,p_name=>'RESTORE'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5terst\00E4ll')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115294481648402383)
,p_name=>'RESULTS'
,p_message_language=>'sv'
,p_message_text=>'Resultat'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286881576402377)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'sv'
,p_message_text=>unistr('G\00E5 tillbaka till applikationen.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115287173638402378)
,p_name=>'RIGHT'
,p_message_language=>'sv'
,p_message_text=>unistr('H\00F6ger')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316754090402400)
,p_name=>'ROW'
,p_message_language=>'sv'
,p_message_text=>'Rad %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270718341402365)
,p_name=>'ROW_COUNT'
,p_message_language=>'sv'
,p_message_text=>'Antal rader'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115286269655402377)
,p_name=>'SAVE'
,p_message_language=>'sv'
,p_message_text=>'Spara'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282841438402374)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'sv'
,p_message_text=>'Alternativ standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283292333402375)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'sv'
,p_message_text=>'Beskrivning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282788615402374)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'sv'
,p_message_text=>unistr('Prim\00E4r standard')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283574025402375)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'sv'
,p_message_text=>unistr('Fler \00E4n %0 tillg\00E4ngliga rader. \00D6ka radv\00E4ljaren f\00F6r att visa fler rader.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348901241402440)
,p_name=>'SEARCH'
,p_message_language=>'sv'
,p_message_text=>unistr('S\00F6k')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244113984402345)
,p_name=>'SECONDS'
,p_message_language=>'sv'
,p_message_text=>'sekunder'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282338313402374)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'sv'
,p_message_text=>'Se bifogad'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340084738402433)
,p_name=>'SELECT_ROW'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lj rad')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282085359402374)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng av sk\00E4rml\00E4sarl\00E4ge')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282102998402374)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'sv'
,p_message_text=>unistr('Sl\00E5 p\00E5 sk\00E4rml\00E4sarl\00E4ge')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278498796402371)
,p_name=>'SHOW'
,p_message_language=>'sv'
,p_message_text=>'Visa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341892505402434)
,p_name=>'SHOW_ALL'
,p_message_language=>'sv'
,p_message_text=>'Visa alla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115367919522402454)
,p_name=>'SIGN_IN'
,p_message_language=>'sv'
,p_message_text=>'Logga in'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115317598730402401)
,p_name=>'SIGN_OUT'
,p_message_language=>'sv'
,p_message_text=>'Logga ut'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271702199402366)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 dagar sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278950973402372)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 dagar fr\00E5n nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271660066402366)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 timmar sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278898987402371)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 timmar fr\00E5n nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271503057402366)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 minuter sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278762748402371)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 minuter fr\00E5n nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271922519402366)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 m\00E5nader sedan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279153270402372)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 m\00E5nader fr\00E5n nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279340534402372)
,p_name=>'SINCE_NOW'
,p_message_language=>'sv'
,p_message_text=>'Nu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271424088402366)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 sekunder sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115278687114402371)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 sekunder fr\00E5n nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115271881510402366)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'sv'
,p_message_text=>'%0 veckor sedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279066906402372)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 veckor fr\00E5n nu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115272073207402366)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E5r sedan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279280092402372)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \00E5r fr\00E5n nu')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265567955402361)
,p_name=>'STANDARD'
,p_message_language=>'sv'
,p_message_text=>'Standard'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281999593402374)
,p_name=>'START_DATE'
,p_message_language=>'sv'
,p_message_text=>'Startdatum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222404899402328)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'sv'
,p_message_text=>unistr('Du har f\00E5tt det h\00E4r e-postmeddelandet fr\00E5n Interaktiv rapport-prenumerationen skapad av %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377179234402461)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'sv'
,p_message_text=>'Prenumerationer'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325220952402421)
,p_name=>'TAB'
,p_message_language=>'sv'
,p_message_text=>'Flik'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244015782402345)
,p_name=>'TITLE'
,p_message_language=>'sv'
,p_message_text=>'Titel'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227082190402332)
,p_name=>'TODAY'
,p_message_language=>'sv'
,p_message_text=>'Idag'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281576956402373)
,p_name=>'TOTAL'
,p_message_language=>'sv'
,p_message_text=>'Summa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228080333402333)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'sv'
,p_message_text=>unistr('Du kan markera h\00F6gst %0 kolumner.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206513004402314)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'sv'
,p_message_text=>'Komprimera alla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206853362402315)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'sv'
,p_message_text=>'Komprimera alla nedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206466352402314)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'sv'
,p_message_text=>'Expandera alla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206632737402315)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'sv'
,p_message_text=>'Expandera alla nedan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206942911402315)
,p_name=>'TREE.REPARENT'
,p_message_language=>'sv'
,p_message_text=>unistr('Ange ny \00F6verordning')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299150645402387)
,p_name=>'TREES'
,p_message_language=>'sv'
,p_message_text=>unistr('Tr\00E4d')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115342698629402435)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'sv'
,p_message_text=>'Obligatoriskt'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115266207418402362)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'sv'
,p_message_text=>unistr('Obeh\00F6rig')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115313031498402397)
,p_name=>'UNAVAILABLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ej tillg\00E4nglig')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279705483402372)
,p_name=>'UNKNOWN'
,p_message_language=>'sv'
,p_message_text=>unistr('Ok\00E4nt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223330037402329)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ett ok\00E4nt autentiseringsfel har uppst\00E5tt.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225336973402331)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'sv'
,p_message_text=>unistr('Om du inte l\00E4ngre vill f\00E5 e-postmeddelanden klickar du p\00E5 <a href="%0">s\00E4g upp prenumeration</a> f\00F6r att hantera din prenumeration.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115222306630402328)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'sv'
,p_message_text=>unistr('Om du inte l\00E4ngre vill f\00E5 e-postmeddelanden g\00E5r du till f\00F6ljande URL f\00F6r att hantera din prenumeration:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115257269159402355)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('datatypen st\00F6ds inte')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245372750402346)
,p_name=>'UPDATE'
,p_message_language=>'sv'
,p_message_text=>'uppdatera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243937578402345)
,p_name=>'UPDATED'
,p_message_language=>'sv'
,p_message_text=>'Uppdaterad'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250699250402350)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'sv'
,p_message_text=>unistr('Den beg\00E4rda URL:en har f\00F6rbjudits. Kontakta administrat\00F6ren.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115270647611402365)
,p_name=>'USER'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115292220430402382)
,p_name=>'USERNAME'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarnamn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331879708402427)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarnamnet \00E4r f\00F6r l\00E5ngt. Gr\00E4nsen \00E4r %0 tecken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277414147402370)
,p_name=>'USERS'
,p_message_language=>'sv'
,p_message_text=>unistr('anv\00E4ndare')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115331480795402426)
,p_name=>'USER_EXISTS'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarnamnet finns redan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115346121149402437)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Profilbild f\00F6r anv\00E4ndaren %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233790763402337)
,p_name=>'VALID'
,p_message_language=>'sv'
,p_message_text=>'Giltig'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227361629402332)
,p_name=>'VALIDATIONS'
,p_message_language=>'sv'
,p_message_text=>'Valideringar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283022084402375)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde m\00E5ste anges')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326445819402422)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde m\00E5ste anges f\00F6r %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252997438402352)
,p_name=>'VERTICAL'
,p_message_language=>'sv'
,p_message_text=>'vertikal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245279866402346)
,p_name=>'VIEW'
,p_message_language=>'sv'
,p_message_text=>'visa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277591764402370)
,p_name=>'VIEWS'
,p_message_language=>'sv'
,p_message_text=>'vyer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283814198402375)
,p_name=>'VIEW_ALL'
,p_message_language=>'sv'
,p_message_text=>'Visa alla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115265076275402361)
,p_name=>'WARNING'
,p_message_language=>'sv'
,p_message_text=>'Varning'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244823040402346)
,p_name=>'WEEK'
,p_message_language=>'sv'
,p_message_text=>'vecka'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241830498402344)
,p_name=>'WEEKLY'
,p_message_language=>'sv'
,p_message_text=>'Veckovis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115244920050402346)
,p_name=>'WEEKS'
,p_message_language=>'sv'
,p_message_text=>'veckor'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115283193751402375)
,p_name=>'WELCOME_USER'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4lkommen: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281348663402373)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittade ogiltigt v\00E4rde, kontrollera angivna data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281479008402373)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittade ogiltigt v\00E4rde, kontrollera angivna data.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224445599402330)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittade ogiltigt datav\00E4rde, kontrollera datumformatet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115281239969402373)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittade ogiltigt nummerv\00E4rde, kontrollera nummerformatet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233311913402337)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittade ogiltigt tidsst\00E4mpelsv\00E4rde, kontrollera tidsst\00E4mpelformatet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115255805489402354)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte binda "%0". Anv\00E4nd dubbla citattecken f\00F6r multibyte-objekt eller kontrollera att objektets l\00E4ngd \00E4r 30 byte eller mindre. Anv\00E4nd v() syntax f\00F6r referensobjekt som \00E4r l\00E4ngre \00E4n 30 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246384980402347)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tkomst nekad av %0-s\00E4kerhetskontroll')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248883219402349)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Applikationen \00E4r inte tillg\00E4nglig')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247218814402348)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'sv'
,p_message_text=>'ERR-1014 Applikationen hittades inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247358755402348)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'sv'
,p_message_text=>'applikation=%0  arbetsyta=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247730431402348)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tkomst till den h\00E4r applikationen \00E4r begr\00E4nsad, f\00F6rs\00F6k igen senare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247638395402348)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'sv'
,p_message_text=>unistr('\00C5tkomst till den h\00E4r applikationen \00E4r begr\00E4nsad till applikationsutvecklare, f\00F6rs\00F6k igen senare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246855966402347)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'sv'
,p_message_text=>'ERR-7744 Kan inte bearbeta grenen till funktionen returwebbadress.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246719049402347)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'sv'
,p_message_text=>'ERR-7744 Kan inte bearbeta grenen till funktionen retursida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247091512402347)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-1430 Anrop som visas fr\00E5n sidprocessen st\00F6ds inte: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248193484402348)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'sv'
,p_message_text=>'ERR-1018 Fel vid rensning av stegcache.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246588890402347)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-1005 Ok\00E4nd ber\00E4kningstyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247451722402348)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-1201 sessions-id har inte angetts f\00F6r anpassad autentisering.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247508009402348)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'sv'
,p_message_text=>'sida=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115247118852402347)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-7620 Kan inte fastst\00E4lla arbetsytan f\00F6r applikationen (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229573264402334)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'sv'
,p_message_text=>'Redigera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246294766402347)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'sv'
,p_message_text=>'ERR-1802 Kan inte hitta objekt-id "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245973766402347)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-1002 Kan inte hitta objekt-id f\00F6r objektet "%0" i applikationen "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246068235402347)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'sv'
,p_message_text=>unistr('Ov\00E4ntat fel, kan inte hitta objektnamnet p\00E5 applikations- eller sidniv\00E5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246405350402347)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Du befinner dig redan p\00E5 den f\00F6rsta datasidan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115261982771402359)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Objekt-id (%0) \00E4r inte ett definierat objekt p\00E5 den aktuella sidan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224008454402330)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'sv'
,p_message_text=>unistr('Objektet kan inte konfigureras genom att \00F6verf\00F6ra argument till applikationen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224391017402330)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'sv'
,p_message_text=>'(Ingen kontrollsumma har angetts)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223856709402330)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'sv'
,p_message_text=>unistr('Objektet kan konfigureras n\00E4r det \00E5tf\00F6ljs av en kontrollsumma med "anv\00E4ndarniv\00E5bokm\00E4rke".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223704412402330)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'sv'
,p_message_text=>unistr('Objektet kan konfigureras n\00E4r det \00E5tf\00F6ljs av en kontrollsumma med "applikationsniv\00E5bokm\00E4rke".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223954559402330)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'sv'
,p_message_text=>unistr('Objektet kan konfigureras n\00E4r det \00E5tf\00F6ljs av en kontrollsumma med "session".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223649164402330)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'sv'
,p_message_text=>'Objektet har inget skydd.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248229695402348)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'sv'
,p_message_text=>unistr('Ingen sidhj\00E4lp \00E4r tillg\00E4nglig.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115237367881402340)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'sv'
,p_message_text=>unistr('Arbetsytan %0 har inga beh\00F6righeter att tolka som schema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246685236402347)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-1010 F\00F6rgrena sidan f\00F6r att acceptera bearbetning av \00F6verskriden rekursionsgr\00E4ns. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224231987402330)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r sidan kan inte startas genom att anv\00E4nda en URL eller en GET eller POST till show-proceduren, den m\00E5ste anropas genom att anv\00E4nda typen "F\00F6rgrena till sida".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115300922622402388)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel uppstod n\00E4r ett icke-numeriskt v\00E4rde skulle sparas i objektet %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239085927402341)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'sv'
,p_message_text=>'Applikationens tolkningsschema "%0" finns inte i databasen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115239163020402341)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'sv'
,p_message_text=>unistr('Konton i den INTERNA arbetsytan kan endast anv\00E4ndas f\00F6r att komma \00E5t &PRODUCT_NAME. <a href="%0">Administrationstj\00E4nster</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245820938402347)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'sv'
,p_message_text=>'ERR-1029 Kan inte lagra sessionsinfo.  session=%0 item=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248979874402349)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte stoppa sp\00E5rning: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115246145426402347)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ov\00E4ntat fel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256136259402354)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'sv'
,p_message_text=>'Fel vid update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249036965402349)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Applikationen och sidan m\00E5ste anges f\00F6r att visa hj\00E4lp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115269585320402364)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Automatisering hittades inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250114202402350)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'sv'
,p_message_text=>'Rensade %0 sessioner.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209479995402317)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte k\00F6ra koden %0! Den st\00F6ds inte av databasen eller har inte aktiverats av instansparametern MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115209253550402317)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'sv'
,p_message_text=>unistr('Flerspr\00E5kig motor \00E4r inte tillg\00E4nglig i den h\00E4r databasversionen!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230045946402335)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Applikationssamlingsuppst\00E4llningen f\00E5r inte vara null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229880165402334)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Det angivna medlemsattributnumret %0 \00E4r ogiltigt. Attributnummer m\00E5ste vara mellan 1 och %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230339916402335)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'sv'
,p_message_text=>'Applikationssamlingen finns redan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230122506402335)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Samlingsnamnet f\00E5r inte vara null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230284144402335)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Samlingsnamnet f\00E5r inte vara l\00E4ngre \00E4n 255 tecken')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229648839402334)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Applikationssamlingen %0 finns inte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230460831402335)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'sv'
,p_message_text=>unistr('Mark\00F6ren \00E4r inte \00F6ppen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229726381402334)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Medlemssekvensen %0 finns inte i Applikationssamlingen %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115229901309402334)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'sv'
,p_message_text=>'Medlemssekvensen %0 finns inte i applikationssamlingen "%1"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301700574402389)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Den kryptografiska funktionen "%0" st\00F6ds inte av det h\00E4r systemet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355266254402444)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Tillg\00E4nglighet testad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249674751402349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'sv'
,p_message_text=>unistr('St\00E4ng')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249716475402349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'sv'
,p_message_text=>unistr('Anpassningsalternativ f\00F6r sida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249883313402350)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'sv'
,p_message_text=>'Standard'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249912933402350)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'sv'
,p_message_text=>'Visad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250046548402350)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'sv'
,p_message_text=>'Dold'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249456004402349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'sv'
,p_message_text=>unistr('Kontrollera regionerna du vill inkludera p\00E5 den h\00E4r sidan. Kontrollerade regioner kan inte visas om du inte \00E4r i r\00E4tt applikationskontext eller om du inte har r\00E4tt beh\00F6righeter.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249528503402349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r sidan \00E4r inte anpassningsbar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355503072402445)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'sv'
,p_message_text=>unistr('Du kan anpassa formatet f\00F6r den h\00E4r applikationen genom att \00E4ndra Temaformatet. V\00E4lj ett Temaformat fr\00E5n listan nedan och klicka p\00E5 Till\00E4mpa \00E4ndringar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115356317934402445)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'sv'
,p_message_text=>'Regionvisning'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355460669402445)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4nd applikationsstandard f\00F6r format')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115355383918402444)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'sv'
,p_message_text=>'Format '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298321310402386)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Kolumnindexet som refereras i det aggregerade %0 finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115201608713402311)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'sv'
,p_message_text=>unistr('CLOB-utdataformatet st\00F6ds inte f\00F6r formatet %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298092657402386)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'sv'
,p_message_text=>unistr('Kolumnbrytningen beh\00F6ver vara i b\00F6rjan av kolumnuppst\00E4llningen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298146544402386)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Kolumngruppens index som refereras i %0 finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115215649712402323)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'sv'
,p_message_text=>'exportera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115220848612402327)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'sv'
,p_message_text=>unistr('Exportformatet m\00E5ste vara XML och anv\00E4nda ORDS som utskriftsserver.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298460963402386)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Kolumnindexet som refereras i det markerade %0 finns inte.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214117225402322)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt exportformat: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115298299872402386)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>unistr('Det \00F6verordnade gruppindexet som refereras i %0 finns inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115323431355402420)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('Kolumnen %1 i tabellen %0 \00E4r en "GENERATED ALWAYS"-identitetskolumn. Se till att ingen k\00E4llkolumn \00E4r mappad till kolumnen %1 i dialogrutan Konfigurera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240868021402343)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'sv'
,p_message_text=>unistr('Angivet bekr\00E4ftelseintervall \00E4r f\00F6r l\00E5gt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115240950064402343)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga kolumner har angetts f\00F6r dataladdningen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242126877402344)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Hittade inga kolumner f\00F6r radv\00E4ljaren "%0". F\00F6rs\00F6k att automatiskt identifiera eller granska JSON-strukturen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250439599402350)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Inga arbetsblad hittades i XLSX-filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250387114402350)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'sv'
,p_message_text=>'Angivet arbetsblad finns inte i XLSX-filen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115230599417402335)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'sv'
,p_message_text=>unistr('Den aktuella versionen av data i databasen har \00E4ndrats sedan anv\00E4ndaren initierade uppdateringsprocessen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232911139402337)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'sv'
,p_message_text=>'Fel vid uppdatering av rapportkolumner: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337617274402431)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'sv'
,p_message_text=>'Kan inte konvertera %0 till SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277156053402370)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sv'
,p_message_text=>unistr('Kolumnen %0 som \00E4r av datatypen %1 kan inte konverteras till VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284186486402375)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Den angivna kolumnen "%0" f\00F6r attributet "%1" hittades inte i datak\00E4llan!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225402319402331)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'sv'
,p_message_text=>unistr('Filtypen %0 st\00F6ds inte f\00F6r kolumner med flera v\00E4rden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115341054110402433)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt "mellan"-filter.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207571831402315)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig typ av v\00E4rdelista har angetts.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207449413402315)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltig fr\00E5getyp. Fr\00E5getypen m\00E5ste vara Tabell, SQL-fr\00E5ga eller PL/SQL-funktion som returnera SQL-fr\00E5ga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277201135402370)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kunde inte tolka SQL-fr\00E5gan!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284291078402376)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Den angivna kolumnpositionen %0 f\00F6r attributet "%1" hittades inte i SQL-satsen!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115206026879402314)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'sv'
,p_message_text=>unistr('F\00F6r m\00E5nga objekt anv\00E4nds i filtret Flera v\00E4rden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284046151402375)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ingen kolumn har angetts f\00F6r attributet "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207301528402315)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('PL/SQL-funktionstexten returnerade inte ett v\00E4rde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115297259214402385)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'sv'
,p_message_text=>unistr('REST-datak\00E4llan inneh\00E5ller inte en \00E5tg\00E4rd f\00F6r att hantera den beg\00E4rda DML-\00E5tg\00E4rden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115203283641402312)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'sv'
,p_message_text=>unistr('Konverteringen fr\00E5n GeoJSON till SDO_GEOMETRY (kolumn %0) \00E4r inte tillg\00E4nglig i den h\00E4r databasen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204306444402313)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'sv'
,p_message_text=>unistr('SDO_GEOMETRY-konvertering (kolumn %0) st\00F6ds inte f\00F6r XML-datak\00E4llor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115211675143402319)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'sv'
,p_message_text=>unistr('Tecknet %0 st\00F6ds inte som avgr\00E4nsare f\00F6r flera v\00E4rden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115338903781402432)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r funktionen kan inte anv\00E4ndas i en fr\00E5gekontext.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115204405244402313)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>'Felmatchad kolumndatatyp.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207234591402315)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'sv'
,p_message_text=>unistr('Interna ORDS OUT-bindgr\00E4nser har \00F6verskridits. Minska antalet DML-rader.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115285021492402376)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('JSON-svaret fr\00E5n fj\00E4rrservern kan inte tolkas: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115207147496402315)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Ok\00E4nd eller felaktig kontexttyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115301687835402389)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r filtypen st\00F6ds inte av parsern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256218343402354)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Obeh\00F6rig \00E5tkomst (wwv_flow_api.set_credentials \00E4r ej konfigurerade).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233215136402337)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'sv'
,p_message_text=>'Arbetsytan har inte skapats eftersom den redan finns.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115233138727402337)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndargruppen har inte skapats eftersom den redan finns.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243451225402345)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'sv'
,p_message_text=>unistr('Dubblettanv\00E4ndarnamn hittades f\00F6r %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243597562402345)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid laddning av anv\00E4ndare. Misslyckades f\00F6r anv\00E4ndaren %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253416182402352)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Skulle ha laddat %0 anv\00E4ndare.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253236564402352)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'sv'
,p_message_text=>unistr('L\00F6senord')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253338133402352)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'sv'
,p_message_text=>unistr('Beh\00F6righeter')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253011903402352)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'sv'
,p_message_text=>unistr('Anv\00E4ndarnamn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329587251402425)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid \00E5tergivning av sidobjektet #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249122767402349)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte visa sidobjektet eftersom HTML-formul\00E4ret inte har \00F6ppnats \00E4n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115214471285402322)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid h\00E4mtning av standardv\00E4rden f\00F6r sidobjektet #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248464911402348)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel i objektpostber\00E4kning f\00F6r sidobjektet #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248349167402348)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid h\00E4mtning av objektk\00E4llv\00E4rdet f\00F6r sidobjektet #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228176387402333)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'sv'
,p_message_text=>unistr('Obeh\00F6rig \00E5tkomst.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248661036402349)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'sv'
,p_message_text=>unistr('JavaScript st\00F6ds inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248700837402349)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'sv'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115249391954402349)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte initiera fr\00E5gan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256580490402354)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Uppdatering av %0 st\00F6ds inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115250788972402350)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt objekt-id: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115277018748402370)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'sv'
,p_message_text=>unistr('Det finns ingen hj\00E4lp f\00F6r det h\00E4r objektet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241577138402343)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('Generering av diagramfr\00E5ga utf\00F6rdes inte. Kontrollera inst\00E4llningarna f\00F6r K\00E4lla och Kolumnmappning.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336363244402430)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'sv'
,p_message_text=>unistr('Bilagans storlek p\00E5 %0 Mbyte \00F6verskrider den maximala bilagestorleken p\00E5 %1 Mbyte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242427599402344)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'sv'
,p_message_text=>unistr('Ogiltigt v\00E4rde f\00F6r parametern p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115359832393402448)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'sv'
,p_message_text=>unistr('Du har \00F6verskridit det maximala antalet e-postmeddelanden per arbetsyta. Kontakta administrat\00F6ren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223447063402329)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'sv'
,p_message_text=>unistr('Den h\00E4r proceduren m\00E5ste anropas fr\00E5n en applikationssession.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242393811402344)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'sv'
,p_message_text=>unistr('Nullv\00E4rde har angetts f\00F6r parametern %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296328153402385)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'sv'
,p_message_text=>'E-postmallen "%0" hittades inte i applikationen %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115372809575402458)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Instansparametern SMTP_HOST_ADDRESS m\00E5ste konfigureras f\00F6r att skicka meddelanden.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242007576402344)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('Du m\00E5ste ange en meddelandemottagare f\00F6r att skicka ett meddelande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115362208085402450)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte uppr\00E4tta en SMTP-anslutning med den konfigurerade e-postservern.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115336433857402430)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'sv'
,p_message_text=>'Ogiltigt Ajax-anrop!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227871620402333)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga Ajax-funktioner har definierats f\00F6r insticksprogrammet %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326885796402423)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga k\00F6rningsfunktion har definierats f\00F6r insticksprogrammet %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227941274402333)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('Inga \00E5tergivningsfunktioner har definierats f\00F6r insticksprogrammet %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337389150402431)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('REST-datak\00E4llans insticksprogram "%0" inneh\00E5ller inte en "Kapacitet"-funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337264682402431)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('REST-datak\00E4llans insticksprogram "%0" inneh\00E5ller inte en DML-funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337431369402431)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('REST-datak\00E4llans insticksprogram "%0" inneh\00E5ller inte en K\00F6r-funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115337532970402431)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'sv'
,p_message_text=>unistr('REST-datak\00E4llans insticksprogram "%0" inneh\00E5ller inte en H\00E4mta-funktion.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225691795402331)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel i PLSQL-koden intr\00E4ffade vid bearbetning av insticksprogrammet.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232294930402336)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rde m\00E5ste anges.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262883475402359)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'sv'
,p_message_text=>'Datatypen %0 kan inte konverteras till VARCHAR2!'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348462847402439)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>unistr('Den angivna kolumnen "%0" f\00F6r attributet "%1" hittades inte i SQL-satsen!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324715220402421)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'sv'
,p_message_text=>unistr('En v\00E4rdelistfr\00E5ga (LOV) eller Namngiven v\00E4rdelista m\00E5ste anges f\00F6r %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115326358042402422)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel antal kolumner har valts i v\00E4rdelistans SQL-fr\00E5ga f\00F6r %0. Se exempel f\00F6r giltiga satser.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348210736402439)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'sv'
,p_message_text=>unistr('Ingen kolumn har angetts f\00F6r attributet "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377904526402462)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('Det angivna v\00E4rdet %0 f\00F6r attributet "%1" \00E4r inte numeriskt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115329807469402425)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 har en felaktig datatyp i SQL-satsen. Kolumn# %1 \00E4r %2 men %3 f\00F6rv\00E4ntas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115348397739402439)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'sv'
,p_message_text=>unistr('Den angivna kolumnen "%0" f\00F6r attributet "%1" har datatypen %2 men ska ha %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115224974693402331)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'sv'
,p_message_text=>'Hittar inte rapportlayouten.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284994116402376)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'sv'
,p_message_text=>unistr('Funktionen Ber\00E4kna summa kan inte anv\00E4ndas f\00F6r rapporter baserat p\00E5 en REST-datak\00E4lla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115248558932402349)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('ERR-2904 Kan inte ange genv\00E4gsv\00E4rde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115252868392402352)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel: Ok\00E4nd genv\00E4gstyp.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115242879086402344)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Kan inte h\00E4mta autentiseringsschema i applikationen %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115316331714402400)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'sv'
,p_message_text=>unistr('Detta klient-id finns redan f\00F6r den aktuella sessionen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115253175972402352)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'sv'
,p_message_text=>'E-post'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377353991402461)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'sv'
,p_message_text=>unistr('Autentiseringen utf\00F6rdes inte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115279666106402372)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'sv'
,p_message_text=>unistr('En eller flera cookies konfigurerade i apex_util.g_request_cookies inneh\00E5ller ett ogiltigt v\00E4rde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115262165816402359)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'sv'
,p_message_text=>unistr('Svaret fr\00E5n UDDI-registret var ogiltigt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115225722729402331)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'sv'
,p_message_text=>'Den angivna URL:en returnerade inte ett giltigt WSDL-dokument.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115228205943402333)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'sv'
,p_message_text=>unistr('WSDL-dokumentet inneh\00E5ller flera SOAP-bindningar. &PRODUCT_NAME. har endast st\00F6d f\00F6r WSDL:er med en SOAP-bindning. Klicka p\00E5 Skapa webbtj\00E4nstreferens manuellt f\00F6r att forts\00E4tta skapa en referens f\00F6r den h\00E4r tj\00E4nsten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115296625233402385)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'sv'
,p_message_text=>unistr('Svaret fr\00E5n tj\00E4nsten var inte XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377219753402461)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'sv'
,p_message_text=>unistr('OAuth-\00E5tkomsttoken \00E4r ogiltigt eller har upph\00F6rt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115340411579402433)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'sv'
,p_message_text=>unistr('Du har \00F6verskridit det maximala antalet webbtj\00E4nstf\00F6rfr\00E5gningar per arbetsyta. Kontakta administrat\00F6ren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115377443802402461)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'sv'
,p_message_text=>unistr('Servern svarade med OAuth-tokentyp som inte st\00F6ds.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227600818402333)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'sv'
,p_message_text=>unistr('WSDL-dokumentet inneh\00F6ll inte en bindning f\00F6r SOAP vilket kr\00E4vs f\00F6r att l\00E4gga till referensen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115223538833402330)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'sv'
,p_message_text=>unistr('Denna WSDL kr\00E4ver autentiseringsuppgifter. Ange anv\00E4ndarnamn och l\00F6senord nedan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115232344337402336)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'sv'
,p_message_text=>unistr('WSDL-dokumentet kunde inte tolkas av \00E5tergivningsmotorn. Klicka p\00E5 Skapa webbtj\00E4nstreferens manuellt f\00F6r att forts\00E4tta skapa en referens f\00F6r den h\00E4r tj\00E4nsten.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115299268204402387)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'sv'
,p_message_text=>'Kan inte bearbeta uppdatering.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115325022680402421)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rdelistan och visningskolumnen \00E4r samma!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115324937302402421)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'sv'
,p_message_text=>unistr('V\00E4rdelistan har ingen returkolumn.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256489785402354)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid h\00E4mtning av kolumnv\00E4rde: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280426814402373)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'sv'
,p_message_text=>unistr('Aktuella data i tabellform \00E4r f\00F6r gamla, k\00E4lldata har modifierats.<br/> Klicka <strong><a href="%0">h\00E4r</a></strong> f\00F6r att ignorera dina \00E4ndringar och ladda om data fr\00E5n databasen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238579782402341)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel vid fastst\00E4llande av sidnumreringsstr\00E4ng')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238451822402341)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kan inte fastst\00E4lla fr\00E5gerubriker:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238600352402341)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'sv'
,p_message_text=>unistr('fel intr\00E4ffade vid ers\00E4ttningar av rapportfot')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238794489402341)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('kunde inte tolka SQL-fr\00E5gan:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243772687402345)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'sv'
,p_message_text=>unistr('Minsta antal beg\00E4rda rader: %0, rader hittades men visades inte: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241224216402343)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'sv'
,p_message_text=>unistr('fr\00E5gekolumnen #%0 (%1) \00E4r ogiltig, kolumner som anv\00E4nder HTML beh\00F6ver aliasnamn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115256357915402354)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'sv'
,p_message_text=>unistr('Fel n\00E4r fr\00E5gerubriker skulle h\00E4mtas: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238835752402341)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rapportfel:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115276590261402370)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'sv'
,p_message_text=>'Sortera efter denna kolumn'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241371782402343)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'sv'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fr\00E5gan kan inte tolkas, kontrollera syntaxen i fr\00E5gan.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280560538402373)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'sv'
,p_message_text=>unistr('Detta formul\00E4r inneh\00E5ller \00E4ndringar som inte har sparats. Tryck p\00E5 "OK" f\00F6r att forts\00E4tta utan att spara \00E4ndringarna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115284810950402376)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'sv'
,p_message_text=>unistr('Sidnumreringsschema f\00F6r rapporten (%0) st\00F6ds inte med den valda datak\00E4llan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115241180488402343)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'sv'
,p_message_text=>unistr('fr\00E5gekolumnen #%0 (%1) \00E4r ogiltig, anv\00E4nd kolumnalias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243892852402345)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'sv'
,p_message_text=>unistr('rad(er) %0 \2013 %1 av mer \00E4n %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115282559230402374)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \2013 %1 av mer \00E4n %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115243663948402345)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'sv'
,p_message_text=>unistr('rad(er) %0 \2013 %1 av %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115227588945402333)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'sv'
,p_message_text=>unistr('%0 \2013 %1 av %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238931532402341)
,p_name=>'Y'
,p_message_language=>'sv'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115245023412402346)
,p_name=>'YEAR'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115238195375402341)
,p_name=>'YEARS'
,p_message_language=>'sv'
,p_message_text=>unistr('\00E5r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115280689944402373)
,p_name=>'YES'
,p_message_language=>'sv'
,p_message_text=>'Ja'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4487)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4487)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Skrivbord'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4487
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4487)
,p_name=>'Meddelanden'
,p_alias=>'MESSAGES'
,p_step_title=>'Meddelanden'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
