prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4493
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4493 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4493
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116283921220403941')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'th'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4493)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113354'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4493)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4493)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4493)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4493)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4493)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4493)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.th'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4493)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4493)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4493)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4493)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4493)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4493)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.th'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4493)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4493)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4493)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4493)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4493)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4493)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.th'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4493)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4493)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.th'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4493)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4493)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.th'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4493)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4493)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.th'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4493)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4493)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4493)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.th'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4493
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4493)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4493)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4493)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4493
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4493)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4493
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4493)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4493
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4493)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4493
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4493)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4493
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4493)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4493
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4493
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4493)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4493)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4493)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4493)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4493)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4493)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4493)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4493)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4493)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4493)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4493)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4493)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4493)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4493)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4493)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4493)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4493)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4493)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4493)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4493)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4493)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4493)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4493
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4493)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4493)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4493)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4493)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4493)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4493
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4493)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4493
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4493)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4493
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4493)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4493
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4493)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4493
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4493)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4493
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4493)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4493)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4493)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4493)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4493)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4493)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4493)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4493)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4493)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4493
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4493)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4493)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4493)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4493)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4493)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4493)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4493)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4493
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4493)
,p_page_name=>'winlov'
,p_page_title=>unistr('\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E04\0E49\0E19\0E2B\0E32')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\0E1B\0E34\0E14')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\0E16\0E31\0E14\0E44\0E1B &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\0E41\0E16\0E27 #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4493
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4493)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4493
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4493)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4493)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4493)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4493)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4493)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4493)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4493)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4493)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4493)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4493)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4493)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4493)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4493)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4493)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4493)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4493)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4493)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4493)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4493)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4493)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4493)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4493)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4493)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4493)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4493)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4493)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4493)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4493)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4493)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4493)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4493)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4493)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4493)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4493)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4493)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4493)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4493)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4493)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4493)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4493)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4493)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4493)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4493)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4493)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4493)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4493)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4493)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4493)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4493)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4493)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4493)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4493)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4493)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4493)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4493)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4493)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4493)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4493)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4493)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4493)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4493)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4493)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4493)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4493)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4493)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4493)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4493)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4493)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4493)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4493)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4493)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4493)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4493)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4493)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4493)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4493)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4493)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4493)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4493)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4493)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4493)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4493)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4493)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4493)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4493)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4493)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4493)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4493)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4493)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4493)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4493)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4493)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4493)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4493)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4493)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4493)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4493)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4493)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4493)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4493)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4493)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4493)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4493)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4493)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4493)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4493)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4493)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4493)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4493)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4493)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4493)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4493)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4493)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4493)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4493)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4493)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4493)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4493)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4493)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4493)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4493)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4493)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4493)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4493)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4493)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4493)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4493)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4493)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4493)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4493)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4493)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4493)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4493)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4493)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4493)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4493)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4493)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4493)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4493)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4493)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4493)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4493)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4493)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4493)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4493)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4493)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4493)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4493)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4493)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4493)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4493)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4493)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4493)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4493)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4493)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4493)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4493)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4493)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4493)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4493)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4493)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4493)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4493)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4493)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4493)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4493)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4493)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4493)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4493)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4493)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4493)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4493)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413656975402496)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400790504402486)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400675532402486)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457992363402530)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417697737402499)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E1A\0E31\0E0D\0E0A\0E35 %0 \0E02\0E2D\0E07\0E04\0E38\0E13\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403213409402488)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E0D\0E0A\0E35\0E19\0E35\0E49\0E25\0E47\0E2D\0E04\0E2D\0E22\0E39\0E48')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393145570402481)
,p_name=>'AM_PM'
,p_message_language=>'th'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527586088402586)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535651522402593)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'th'
,p_message_text=>unistr('(\0E43\0E0A\0E49\0E07\0E32\0E19)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505102269402567)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E01 Ajax \0E2A\0E48\0E07\0E04\0E37\0E19\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E2D\0E07\0E40\0E0B\0E34\0E23\0E4C\0E1F\0E40\0E27\0E2D\0E23\0E4C %0 \0E2A\0E33\0E2B\0E23\0E31\0E1A %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435980374402512)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E41\0E1B\0E25\0E07\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 "%0" \0E40\0E1B\0E47\0E19 ID \0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33\0E01\0E31\0E19\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436092971402512)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425600632402505)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1816 \0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E17\0E35\0E48\0E44\0E21\0E48\0E04\0E32\0E14\0E2B\0E21\0E32\0E22\0E02\0E13\0E30\0E41\0E1B\0E25\0E07\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 p_flow_alias_or_id (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518566566402579)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('Checksum \0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E40\0E1B\0E47\0E19\0E27\0E34\0E18\0E35\0E17\0E35\0E48\0E2A\0E30\0E14\0E27\0E01\0E43\0E19\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E27\0E48\0E32\0E21\0E35\0E01\0E32\0E23\0E43\0E0A\0E49\0E07\0E32\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E40\0E14\0E35\0E22\0E27\0E01\0E31\0E19\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E40\0E1B\0E23\0E35\0E22\0E1A\0E40\0E17\0E35\0E22\0E1A Checksum \0E19\0E35\0E49 \0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E27\0E48\0E32\0E21\0E35\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E15\0E23\0E07\0E01\0E31\0E19\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411498280402494)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396853376402484)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560397368402612)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E01\0E32\0E23\0E20\0E32\0E22\0E43\0E19 %0 \0E17\0E35\0E48\0E2A\0E48\0E07\0E04\0E37\0E19\0E42\0E14\0E22 Oracle Cloud Identity Management \0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E19\0E38\0E21\0E31\0E15\0E34\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E42\0E14\0E40\0E21\0E19 %1<br/>\0E42\0E1B\0E23\0E14<a href="&LOGOUT_URL.">\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19\0E43\0E2B\0E21\0E48</a> \0E41\0E25\0E30\0E23\0E30\0E1A\0E38\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E01\0E32\0E23\0E20\0E32\0E22\0E43\0E19\0E17\0E35\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E19\0E38\0E21\0E31\0E15\0E34\0E2B\0E23\0E37\0E2D\0E40\0E1B\0E25\0E35\0E48\0E22\0E19 URL \0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394509029402482)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E0D\0E0A\0E35 "%0" \0E02\0E2D\0E07\0E04\0E38\0E13\0E44\0E21\0E48\0E21\0E35\0E2A\0E34\0E17\0E18\0E34\0E4C\0E01\0E32\0E23\0E1E\0E31\0E12\0E19\0E32\0E17\0E35\0E48\0E08\0E33\0E40\0E1B\0E47\0E19 (DB_DEVELOPER \0E2B\0E23\0E37\0E2D DB_ADMINISTRATOR)<br/>\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19 "%1" \0E42\0E1B\0E23\0E14<a href="&LOGOUT_URL.">\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07</a>\0E2B\0E25\0E31\0E01\0E08\0E32\0E01\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38\0E2A\0E34\0E17\0E18\0E34\0E4C\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393624380402481)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E01\0E32\0E23\0E20\0E32\0E22\0E43\0E19\0E17\0E35\0E48\0E2A\0E48\0E07\0E04\0E37\0E19\0E42\0E14\0E22 Oracle Cloud Identity Management \0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E19\0E38\0E21\0E31\0E15\0E34\0E43\0E2B\0E49\0E43\0E0A\0E49\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19<br/>\0E42\0E1B\0E23\0E14<a href="&LOGOUT_URL.">\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19\0E43\0E2B\0E21\0E48</a> \0E41\0E25\0E30\0E23\0E30\0E1A\0E38\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E01\0E32\0E23\0E20\0E32\0E22\0E43\0E19\0E17\0E35\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E19\0E38\0E21\0E31\0E15\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394617976402482)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E37\0E48\0E2D\0E04\0E27\0E32\0E21\0E1B\0E25\0E2D\0E14\0E20\0E31\0E22 \0E08\0E36\0E07\0E44\0E21\0E48\0E2D\0E19\0E38\0E0D\0E32\0E15\0E43\0E2B\0E49\0E23\0E31\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E02\0E2D\0E07\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E19\0E35\0E49\0E1C\0E48\0E32\0E19\0E42\0E14\0E40\0E21\0E19\0E43\0E19 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411152145402494)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E02\0E2D DBA \0E02\0E2D\0E07\0E04\0E38\0E13\0E43\0E2B\0E49\0E23\0E31\0E19 $OH/rdbms/admin/catldap.sql')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411072021402494)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E41\0E1E\0E47\0E04\0E40\0E01\0E08 SYS.DBMS_LDAP \0E2B\0E23\0E37\0E2D\0E21\0E35\0E41\0E15\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410913178402494)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E41\0E01\0E49\0E44\0E02\0E1C\0E39\0E49\0E43\0E0A\0E49 LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411235785402494)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412073683402495)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E2D\0E32\0E23\0E4C\0E01\0E34\0E27\0E40\0E21\0E19\0E15\0E4C p_flow_page \0E16\0E36\0E07\0E42\0E1B\0E23\0E0B\0E35\0E40\0E08\0E2D\0E23\0E4C login_page')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411653424402494)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'th'
,p_message_text=>unistr('p_session \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E43\0E19 wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459530404402531)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E32\0E23\0E4C\0E01\0E34\0E27\0E40\0E21\0E19\0E15\0E4C\0E17\0E35\0E48\0E21\0E35\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411757869402494)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E1A\0E38\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25\0E43\0E2B\0E49\0E01\0E31\0E1A\0E42\0E1B\0E23\0E0B\0E35\0E40\0E08\0E2D\0E23\0E4C\0E01\0E32\0E23\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400542842402486)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E23\0E2D <span id="apex_login_throttle_sec">%0</span> \0E27\0E34\0E19\0E32\0E17\0E35 \0E40\0E1E\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E2A\0E39\0E48\0E23\0E30\0E1A\0E1A\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401829130402487)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19\0E16\0E39\0E01\0E1A\0E25\0E47\0E2D\0E04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457374133402529)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402139720402487)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'th'
,p_message_text=>unistr('ID \0E01\0E25\0E38\0E48\0E21\0E01\0E32\0E23\0E23\0E31\0E01\0E29\0E32\0E04\0E27\0E32\0E21\0E1B\0E25\0E2D\0E14\0E20\0E31\0E22\0E40\0E1B\0E47\0E19\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411596715402494)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E23\0E31\0E19\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E2B\0E25\0E31\0E07\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411303561402494)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E01\0E48\0E2D\0E19\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412541427402495)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E42\0E1B\0E23\0E14\0E40\0E1B\0E34\0E14 URL \0E43\0E19\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E40\0E14\0E35\0E22\0E27\0E01\0E31\0E19\0E01\0E31\0E1A\0E17\0E35\0E48\0E04\0E38\0E13\0E43\0E0A\0E49\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E04\0E33\0E02\0E2D\0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19 \0E2B\0E32\0E01\0E04\0E38\0E13\0E04\0E25\0E34\0E01 URL \0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E41\0E25\0E30\0E21\0E35\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E40\0E2A\0E49\0E19\0E17\0E32\0E07\0E44\0E1B\0E22\0E31\0E07'),
unistr('\0E40\0E1E\0E08\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19 \0E42\0E1B\0E23\0E14\0E40\0E23\0E34\0E48\0E21\0E01\0E32\0E23\0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07\0E41\0E25\0E30\0E40\0E1B\0E34\0E14\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E17\0E34\0E49\0E07\0E44\0E27\0E49')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557843091402610)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'th'
,p_message_text=>unistr('URL \0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394826388402482)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E25\0E38\0E48\0E21\0E1C\0E39\0E49\0E43\0E0A\0E49\0E42\0E1B\0E23\0E41\0E01\0E23\0E21\0E08\0E31\0E14\0E01\0E32\0E23\0E17\0E23\0E31\0E1E\0E22\0E32\0E01\0E23 %0 \0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394927373402482)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E43\0E0A\0E49 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \0E40\0E1E\0E37\0E48\0E2D\0E43\0E2B\0E49\0E2A\0E34\0E17\0E18\0E34\0E4C\0E17\0E35\0E48\0E02\0E32\0E14\0E2B\0E32\0E22\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422927485402503)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 Sentry \0E02\0E2D\0E07\0E40\0E0B\0E2A\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423060781402503)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E15\0E23\0E27\0E27\0E08\0E2A\0E2D\0E1A\0E40\0E0B\0E2A\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423220140402503)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E02\0E2D\0E43\0E2B\0E49\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A %0 \0E02\0E2D\0E07\0E04\0E38\0E13\0E04\0E2D\0E19\0E1F\0E34\0E40\0E01\0E2D\0E23\0E4C\0E40\0E2D\0E47\0E19\0E08\0E34\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A Oracle Application Server Single Sign-On')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432748488402510)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E43\0E19\0E42\0E17\0E40\0E04\0E47\0E19 %1 \0E17\0E35\0E48\0E2A\0E48\0E07\0E04\0E37\0E19\0E42\0E14\0E22 SSO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411941422402495)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E41\0E01\0E49\0E44\0E02\0E2A\0E04\0E35\0E21\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C\0E41\0E25\0E30\0E40\0E1E\0E34\0E48\0E21\0E0A\0E37\0E48\0E2D\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432482714402510)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E40\0E23\0E35\0E22\0E01\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E02\0E2D\0E07\0E42\0E1B\0E23\0E0B\0E35\0E40\0E08\0E2D\0E23\0E4C %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432654150402510)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E43\0E19\0E42\0E17\0E40\0E04\0E47\0E19 URLC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432232544402510)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19 portal_sso_redirect: \0E44\0E21\0E48\0E21\0E35\0E02\0E49\0E2D\0E21\0E39\0E25\0E01\0E32\0E23\0E23\0E35\0E08\0E34\0E2A\0E40\0E15\0E2D\0E23\0E4C\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423103409402503)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E41\0E1E\0E47\0E04\0E40\0E01\0E08 WWSEC_SSO_ENABLER_PRIVATE \0E2B\0E23\0E37\0E2D\0E21\0E35\0E41\0E15\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115411885019402495)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E0A\0E37\0E48\0E2D\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E23\0E48\0E27\0E21\0E01\0E31\0E19\0E17\0E35\0E48\0E23\0E35\0E08\0E34\0E2A\0E40\0E15\0E2D\0E23\0E4C\0E43\0E19\0E2A\0E04\0E35\0E21\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432309312402510)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E23\0E35\0E08\0E34\0E2A\0E40\0E15\0E2D\0E23\0E4C\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E15\0E32\0E21\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22\0E43\0E19\0E04\0E39\0E48\0E21\0E37\0E2D\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423367508402503)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C SSO')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532784865402590)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'th'
,p_message_text=>unistr('URL \0E17\0E35\0E48\0E44\0E21\0E48\0E21\0E35\0E2A\0E34\0E17\0E18\0E34\0E4C\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422745979402502)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394764158402482)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19 "%0" \0E21\0E35\0E2A\0E16\0E32\0E19\0E30\0E44\0E21\0E48\0E43\0E0A\0E49\0E07\0E32\0E19 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395192922402482)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'th'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401519333402487)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E16\0E39\0E01\0E1B\0E0F\0E34\0E40\0E2A\0E18\0E42\0E14\0E22\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E01\0E32\0E23\0E23\0E31\0E01\0E29\0E32\0E04\0E27\0E32\0E21\0E1B\0E25\0E2D\0E14\0E20\0E31\0E22\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401615320402487)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E16\0E39\0E01\0E1B\0E0F\0E34\0E40\0E2A\0E18\0E42\0E14\0E22\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E01\0E32\0E23\0E23\0E31\0E01\0E29\0E32\0E04\0E27\0E32\0E21\0E1B\0E25\0E2D\0E14\0E20\0E31\0E22\0E02\0E2D\0E07\0E40\0E1E\0E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401721333402487)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E01\0E32\0E23\0E43\0E2B\0E49\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465171090402535)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E14\0E49\0E27\0E22 %0 \0E42\0E14\0E22\0E43\0E0A\0E49 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465294054402535)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'th'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523068420402583)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22\0E2D\0E35\0E40\0E27\0E19\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522857825402582)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523154062402583)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'th'
,p_message_text=>unistr('ID \0E2D\0E35\0E40\0E27\0E19\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522731165402582)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522910717402583)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E2D\0E35\0E40\0E27\0E19\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413579520402496)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E01\0E31\0E1A\0E40\0E19\0E37\0E49\0E2D\0E2B\0E32 Checksum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413438991402496)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E01\0E31\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A Checksum')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477468187402545)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E31\0E14\0E25\0E2D\0E01\0E44\0E1B\0E22\0E31\0E07\0E04\0E25\0E34\0E1B\0E1A\0E2D\0E23\0E4C\0E14\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477180699402544)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E19\0E35\0E49\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E04\0E31\0E14\0E25\0E2D\0E01\0E08\0E32\0E01\0E1B\0E38\0E48\0E21\0E2B\0E23\0E37\0E2D\0E40\0E21\0E19\0E39 \0E25\0E2D\0E07 Ctrl+C \0E2B\0E23\0E37\0E2D Command+C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465628038402536)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14\0E01\0E32\0E23\0E41\0E08\0E49\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521602713402582)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E40\0E1B\0E23\0E35\0E22\0E1A\0E15\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516158457402577)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516061936402577)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E34\0E48\0E21\0E41\0E23\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520276369402581)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E2A\0E35\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515995306402577)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E2A\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516228246402577)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E2A\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555470699402608)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555522245402608)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14\0E23\0E32\0E22\0E01\0E32\0E23\0E2A\0E33\0E2B\0E23\0E31\0E1A: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535746976402593)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'th'
,p_message_text=>unistr('(\0E40\0E2A\0E23\0E47\0E08\0E2A\0E21\0E1A\0E39\0E23\0E13\0E4C)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428035643402506)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442419530402517)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13'),
unistr('\0E14\0E39\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E40\0E01\0E35\0E48\0E22\0E27\0E01\0E31\0E1A\0E40\0E2B\0E15\0E38\0E01\0E32\0E23\0E13\0E4C\0E19\0E35\0E49\0E1C\0E48\0E32\0E19 ID \0E14\0E35\0E1A\0E31\0E01 "%0"')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520595570402581)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E01\0E48\0E2D\0E19\0E17\0E35\0E48\0E08\0E30\0E1A\0E31\0E19\0E17\0E36\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466507816402536)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A %0 \0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466493589402536)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536287172402593)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E04\0E37\0E1A\0E2B\0E19\0E49\0E32\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520976478402581)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E43\0E19\0E23\0E32\0E22\0E01\0E32\0E23 %0 \0E43\0E19 APEX_APPLICATION_TEMP_FILES')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509487195402571)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E27\0E2D\0E23\0E4C\0E0A\0E31\0E19\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E21\0E35\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E15\0E31\0E49\0E07\0E41\0E15\0E48\0E15\0E2D\0E19\0E17\0E35\0E48\0E1C\0E39\0E49\0E43\0E0A\0E49\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E2D\0E31\0E1B\0E40\0E14\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478562380402546)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E15\0E49\0E2D\0E07\0E42\0E2B\0E25\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525583931402585)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E01\0E32\0E23\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E25\0E48\0E27\0E07\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525339163402584)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E23\0E01\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539406592402596)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E33\0E14\0E31\0E1A : \0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525431907402584)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E31\0E1B\0E40\0E14\0E15\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466952393402537)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E0F\0E34\0E17\0E34\0E19\0E1B\0E47\0E2D\0E1B\0E2D\0E31\0E1B: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389535949402478)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389672672402478)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525792863402585)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E21\0E35\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525619307402585)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E27\0E31\0E19\0E17\0E35\0E48\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393243609402481)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E2D\0E22\0E39\0E48\0E23\0E30\0E2B\0E27\0E48\0E32\0E07 %0 \0E41\0E25\0E30 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393311531402481)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E2D\0E22\0E39\0E48\0E2B\0E25\0E31\0E07\0E2B\0E23\0E37\0E2D\0E40\0E1B\0E47\0E19\0E27\0E31\0E19\0E40\0E14\0E35\0E22\0E27\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393450355402481)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E2D\0E22\0E39\0E48\0E01\0E48\0E2D\0E19\0E2B\0E23\0E37\0E2D\0E40\0E1B\0E47\0E19\0E27\0E31\0E19\0E40\0E14\0E35\0E22\0E27\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470477231402539)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E2D\0E22\0E39\0E48\0E2B\0E25\0E31\0E07\0E27\0E31\0E19\0E17\0E35\0E48\0E2A\0E39\0E07\0E2A\0E38\0E14\0E17\0E35\0E48\0E23\0E30\0E1A\0E38 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470800103402540)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E44\0E21\0E48\0E15\0E23\0E07\0E01\0E31\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470311971402539)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E2D\0E22\0E39\0E48\0E01\0E48\0E2D\0E19\0E27\0E31\0E19\0E17\0E35\0E48\0E02\0E31\0E49\0E19\0E15\0E48\0E33\0E17\0E35\0E48\0E23\0E30\0E1A\0E38 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470538358402539)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E48\0E27\0E07\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E08\0E32\0E01 %0 \0E16\0E36\0E07 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470783878402539)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E48\0E27\0E07\0E1B\0E35\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E08\0E32\0E01 %0 \0E16\0E36\0E07 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520825786402581)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E01\0E40\0E25\0E34\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548065970402603)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550091129402604)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520691469402581)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E01\0E25\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520783564402581)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426932794402506)
,p_name=>'APEX.ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394340957402482)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49\0E02\0E13\0E30\0E23\0E31\0E19\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E01\0E01\0E25\0E31\0E1A\0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E32\0E23\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403099728402488)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E2A\0E23\0E49\0E32\0E07\0E40\0E1E\0E08\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395003562402482)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E20\0E32\0E22\0E43\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534898935402592)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E02\0E2D\0E07\0E04\0E38\0E13'),
unistr('\0E14\0E39\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E40\0E01\0E35\0E48\0E22\0E27\0E01\0E31\0E1A\0E40\0E2B\0E15\0E38\0E01\0E32\0E23\0E13\0E4C\0E19\0E35\0E49\0E1C\0E48\0E32\0E19 ID \0E14\0E35\0E1A\0E31\0E01 "%0"')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529126845402587)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'th'
,p_message_text=>unistr('\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E1B\0E34\0E14\0E43\0E2B\0E49\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E41\0E1A\0E1A\0E2D\0E48\0E32\0E19\0E2D\0E22\0E48\0E32\0E07\0E40\0E14\0E35\0E22\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559732116402611)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'th'
,p_message_text=>unistr('ORA-28353: \0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E40\0E1B\0E34\0E14\0E27\0E2D\0E25\0E40\0E25\0E47\0E15\0E44\0E14\0E49 \0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E44\0E21\0E48\0E44\0E14\0E49\0E43\0E19\0E02\0E13\0E30\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529243258402587)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E2D\0E2D\0E20\0E31\0E22 \0E40\0E1E\0E08\0E19\0E35\0E49\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396774446402484)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E32\0E07\0E40\0E17\0E04\0E19\0E34\0E04 (\0E14\0E39\0E44\0E14\0E49\0E42\0E14\0E22\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492849235402556)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E41\0E2A\0E14\0E07\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506776762402569)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473439445402542)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E43\0E0A\0E49\0E2D\0E22\0E39\0E48\0E43\0E19\0E25\0E34\0E2A\0E15\0E4C\0E04\0E27\0E1A\0E04\0E38\0E21\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473381807402541)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E22\0E37\0E19\0E22\0E31\0E19\0E01\0E32\0E23\0E40\0E1E\0E34\0E48\0E21\0E1C\0E39\0E49\0E43\0E0A\0E49 %0 \0E23\0E32\0E22\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49\0E44\0E1B\0E22\0E31\0E07\0E25\0E34\0E2A\0E15\0E4C\0E04\0E27\0E1A\0E04\0E38\0E21\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49 <strong>%1</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473815124402542)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E1C\0E39\0E49\0E43\0E0A\0E49\0E0B\0E49\0E33\0E01\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473544841402542)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C\0E44\0E21\0E48\0E21\0E35\0E2A\0E31\0E0D\0E25\0E31\0E01\0E29\0E13\0E4C @')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473687307402542)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C\0E44\0E21\0E48\0E21\0E35\0E2A\0E31\0E0D\0E25\0E31\0E01\0E29\0E13\0E4C .')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473708900402542)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E22\0E32\0E27\0E40\0E01\0E34\0E19\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474090170402542)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E09\0E1E\0E32\0E30\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E43\0E19\0E25\0E34\0E2A\0E15\0E4C\0E04\0E27\0E1A\0E04\0E38\0E21\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19\0E17\0E35\0E48\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474177100402542)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E04\0E27\0E1A\0E04\0E38\0E21\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E04\0E32\0E14\0E04\0E34\0E14: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473967597402542)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516769061402577)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E34\0E01\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516640989402577)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516919704402577)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'th'
,p_message_text=>unistr('%0: \0E40\0E25\0E34\0E01\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516845831402577)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'th'
,p_message_text=>unistr('%0: \0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516556569402577)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E30\0E1A\0E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509602887402571)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466134967402536)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E43\0E0A\0E49 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507212707402569)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392119670402480)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E41\0E17\0E48\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519909383402580)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E37\0E48\0E19\0E46')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392296360402480)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E27\0E07\0E01\0E25\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518610222402579)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391955803402480)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507740804402569)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507838948402569)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507912197402569)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525118502402584)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %1 \0E17\0E35\0E48\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E42\0E14\0E22 Facet %0 \0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E19\0E38\0E21\0E31\0E15\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382335208402473)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E08\0E30\0E41\0E2A\0E14\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464331928402535)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464428866402535)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E41\0E25\0E49\0E27 %0 \0E23\0E32\0E22\0E01\0E32\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467002170402537)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383827800402474)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E25\0E34\0E2A\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523654521402583)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E19\0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33\0E01\0E31\0E19 (%0) \0E2A\0E33\0E2B\0E23\0E31\0E1A Facet %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509214391402571)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A Facet %0 \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C DATE \0E2B\0E23\0E37\0E2D TIMESTAMP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507351627402569)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507419518402569)
,p_name=>'APEX.FS.GO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508856063402570)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392975747402481)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392604805402481)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E01\0E01\0E27\0E48\0E32 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392747247402481)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E01\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392416063402480)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392525188402480)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392871967402481)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E14\0E49\0E27\0E22 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395382906402483)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25 %0 (%1) \0E2A\0E33\0E2B\0E23\0E31\0E1A Facet \0E02\0E2D\0E07\0E1F\0E34\0E25\0E14\0E4C\0E2D\0E34\0E19\0E1E\0E38\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385577414402475)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'th'
,p_message_text=>unistr('Facet \0E41\0E1A\0E1A\0E2B\0E25\0E32\0E22\0E04\0E48\0E32\0E15\0E49\0E2D\0E07\0E21\0E35\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25 12.2 \0E02\0E36\0E49\0E19\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509014578402571)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A Facet %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382472391402473)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464515853402535)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E0A\0E48\0E27\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508581374402570)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E16\0E36\0E07 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508676554402570)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E39\0E07\0E01\0E27\0E48\0E32 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508757903402570)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E48\0E33\0E01\0E27\0E48\0E32 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464690771402535)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E0A\0E48\0E27\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527492118402586)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32 #%2 ("%1") \0E2A\0E33\0E2B\0E23\0E31\0E1A Facet \0E0A\0E48\0E27\0E07 %0 \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 (\0E44\0E21\0E48\0E21\0E35\0E15\0E31\0E27\0E04\0E31\0E48\0E19 "|")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508992647402571)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E1B\0E49\0E2D\0E19\0E14\0E49\0E27\0E22\0E15\0E19\0E40\0E2D\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A Facet \0E0A\0E48\0E27\0E07 %0 \0E43\0E19\0E02\0E13\0E30\0E19\0E35\0E49 \0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1B\0E47\0E19 DATE \0E2B\0E23\0E37\0E2D TIMESTAMP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508236219402570)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E36\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392029284402480)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461170568402532)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507606201402569)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507554440402569)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508424426402570)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391827922402480)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508055931402570)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E19\0E49\0E2D\0E22\0E25\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508155450402570)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115508301646402570)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E14\0E32\0E27\0E02\0E36\0E49\0E19\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466074388402536)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E41\0E19\0E30\0E19\0E33\0E40\0E23\0E37\0E48\0E2D\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509126641402571)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2D\0E07\0E23\0E31\0E1A Facet \0E1F\0E34\0E25\0E14\0E4C\0E02\0E49\0E2D\0E04\0E27\0E32\0E21 %0 \0E40\0E09\0E1E\0E32\0E30\0E2A\0E33\0E2B\0E23\0E31\0E1A NUMBER \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382286069402473)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525221670402584)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25 %0 (%1) \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E41\0E1A\0E1A\0E43\0E0A\0E49 Facet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517187498402577)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1B\0E22\0E31\0E07\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474766534402543)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482363389402548)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E38\0E1A\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474891790402543)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482254545402548)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560933520402612)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482077097402548)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E16\0E27\0E41\0E25\0E49\0E27 %0 \0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552411982402606)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E09\0E1E\0E32\0E30\0E0B\0E49\0E33')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471726832402540)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E23\0E01\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475091491402543)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E02\0E2D\0E07\0E01\0E25\0E38\0E48\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474962413402543)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471824188402540)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E49\0E32\0E22\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491893761402555)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E2B\0E25\0E14\0E41\0E16\0E27\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471509938402540)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475162691402543)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27\0E02\0E2D\0E07\0E2B\0E19\0E49\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471983884402540)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'th'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472010071402540)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'th'
,p_message_text=>unistr('%0 - %1 \0E08\0E32\0E01 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528007779402586)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E40\0E1E\0E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471631923402540)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552247421402606)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552394423402606)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560752503402612)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0, \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560888576402612)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552187088402606)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475353207402543)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E02\0E2D\0E07\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470980180402540)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E44\0E27\0E49 %0 \0E40\0E0B\0E25\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472167645402541)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01 %0 \0E41\0E16\0E27\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512491302402574)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482160118402548)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E19\0E49\0E32 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475274533402543)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475451175402543)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01\0E41\0E25\0E49\0E27 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475557430402543)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22\0E41\0E25\0E49\0E27 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471092029402540)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471307195402540)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471189892402540)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471447051402540)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115471288737402540)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481996776402548)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E27\0E21 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408356228402492)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E02\0E2D HTTP \0E44\0E1B\0E22\0E31\0E07 "%0" \0E25\0E49\0E21\0E40\0E2B\0E25\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549609165402604)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E01\0E23\0E34\0E14 %0 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %1 \0E41\0E16\0E27 \0E43\0E0A\0E49\0E1B\0E38\0E48\0E21\0E25\0E39\0E01\0E28\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481842873402548)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01 %0 \0E41\0E16\0E27 \0E43\0E0A\0E49\0E1B\0E38\0E48\0E21\0E25\0E39\0E01\0E28\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560599569402612)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468657425402538)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469674376402539)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469512855402539)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554068748402607)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539501191402596)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541247238402597)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497633341402561)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498824212402562)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E33\0E23\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499908695402563)
,p_name=>'APEX.IG.AND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E25\0E30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519301280402580)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E1A\0E04\0E48\0E32\0E40\0E09\0E1E\0E32\0E30\0E42\0E14\0E22\0E1B\0E23\0E30\0E21\0E32\0E13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555012917402608)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E1A\0E04\0E48\0E32\0E40\0E09\0E1E\0E32\0E30\0E42\0E14\0E22\0E1B\0E23\0E30\0E21\0E32\0E13\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538141717402595)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540081466402596)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498943170402562)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554142102402607)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E31\0E15\0E42\0E19\0E21\0E31\0E15\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519796651402580)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E40\0E09\0E25\0E35\0E48\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554707015402608)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E40\0E09\0E25\0E35\0E48\0E22\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537600954402594)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537871156402595)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E33\0E41\0E2B\0E19\0E48\0E07\0E17\0E28\0E19\0E34\0E22\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537716296402595)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543898157402599)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E35\0E1E\0E37\0E49\0E19\0E2B\0E25\0E31\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538265107402595)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E48\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494252708402557)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E2B\0E27\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545004746402600)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E31\0E49\0E07\0E04\0E39\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538346080402595)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E1A\0E40\0E1A\0E34\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469847696402539)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E01\0E40\0E25\0E34\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499888196402563)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E23\0E07\0E15\0E32\0E21\0E15\0E31\0E27\0E1E\0E34\0E21\0E1E\0E4C\0E40\0E25\0E47\0E01\0E41\0E25\0E30\0E43\0E2B\0E0D\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555615931402608)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'th'
,p_message_text=>unistr('(\0E15\0E23\0E07\0E15\0E32\0E21\0E15\0E31\0E27\0E1E\0E34\0E21\0E1E\0E4C\0E40\0E25\0E47\0E01\0E41\0E25\0E30\0E43\0E2B\0E0D\0E48)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526533568402585)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470275810402539)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E27\0E34\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500972019402564)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497417836402561)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E2A\0E39\0E07\0E2A\0E38\0E14\0E02\0E2D\0E07\0E08\0E38\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48 %0 \0E15\0E48\0E2D\0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E04\0E38\0E13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468560454402538)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27\0E02\0E2D\0E07\0E41\0E1C\0E19\0E1C\0E31\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475815073402543)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537165935402594)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544009028402599)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520191244402580)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499266445402562)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468744295402538)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545863070402601)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E38\0E14\0E1B\0E23\0E30\0E2A\0E07\0E04\0E4C\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499368800402563)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E31\0E1A\0E0B\0E49\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468980027402538)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E19\0E27\0E13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494857921402558)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501168211402564)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475608705402543)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E31\0E14\0E25\0E2D\0E01\0E44\0E1B\0E22\0E31\0E07\0E04\0E25\0E34\0E1B\0E1A\0E2D\0E23\0E4C\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475713448402543)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E31\0E14\0E25\0E2D\0E01\0E25\0E07\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519176220402579)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519206080402580)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E1A\0E04\0E48\0E32\0E40\0E09\0E1E\0E32\0E30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554991243402608)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E1A\0E04\0E48\0E32\0E40\0E09\0E1E\0E32\0E30\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554809000402608)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552554181402606)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497856241402561)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545661734402601)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545282592402600)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526302888402585)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E27\0E31\0E19\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495569805402559)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498501975402562)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498302745402562)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469724017402539)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546816703402602)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E41\0E19\0E48\0E43\0E08\0E2B\0E23\0E37\0E2D\0E27\0E48\0E32\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502939000402565)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501709431402564)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540192396402597)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500693549402564)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468224519402538)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528867338402587)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E34\0E28\0E17\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500305614402563)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E34\0E01\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494934150402558)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495104805402558)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E02\0E36\0E49\0E19\0E15\0E49\0E19\0E14\0E49\0E27\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538450141402595)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E14\0E19\0E31\0E17')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501381764402564)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400096176402486)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E2D\0E22\0E48\0E32\0E07\0E40\0E14\0E35\0E22\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547886514402602)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E23\0E39\0E1B\0E41\0E1A\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412675256402495)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E43\0E0A\0E49\0E07\0E32\0E19\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540828956402597)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E17\0E35\0E48\0E0B\0E49\0E33\0E01\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540955390402597)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E17\0E35\0E48\0E0B\0E49\0E33\0E01\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502893397402565)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27\0E17\0E35\0E48\0E0B\0E49\0E33\0E01\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501648564402564)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E33\0E0B\0E49\0E33\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469329011402538)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539939726402596)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551447489402605)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547435351402602)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E33\0E40\0E19\0E32\0E25\0E31\0E1A\0E16\0E36\0E07 (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547649764402602)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547353381402602)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E33\0E40\0E19\0E32\0E16\0E36\0E07 (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547070032402602)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547513968402602)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547203466402602)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E23\0E31\0E1A (\0E16\0E36\0E07)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500093797402563)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493267389402557)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E17\0E48\0E32\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546404438402601)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500159440402563)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546337646402601)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512337280402574)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E15\0E23\0E35\0E22\0E21\0E44\0E1F\0E25\0E4C\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19 \0E01\0E33\0E25\0E31\0E07\0E40\0E23\0E34\0E48\0E21\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115475927462402544)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E15\0E34\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477039000402544)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E15\0E34\0E21\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E14\0E49\0E27\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476929984402544)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E15\0E34\0E21\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468893549402538)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499441870402563)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554473492402607)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540345429402597)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E23\0E01\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469061026402538)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497903391402561)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544900145402600)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E41\0E1B\0E25\0E07\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546718235402602)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'th'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546677629402601)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'th'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459460645402531)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'th'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398723924402485)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'th'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502527983402565)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E23\0E35\0E0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500221194402563)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E41\0E25\0E30\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538507227402595)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E01\0E23\0E27\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519051874402579)
,p_name=>'APEX.IG.GO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493888000402557)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E01\0E01\0E27\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493984371402557)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E01\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500576387402563)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E34\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468085426402537)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E34\0E14\0E27\0E34\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541156676402597)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E25\0E38\0E48\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500734450402564)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468318316402538)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545512171402601)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544435561402600)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544699629402600)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E27\0E32\0E07\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554378395402607)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549817060402604)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E41\0E17\0E23\0E01 \0E2D\0E31\0E1B\0E40\0E14\0E15 \0E41\0E25\0E30\0E25\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E14\0E49\0E42\0E14\0E22\0E15\0E23\0E07\0E20\0E32\0E22\0E43\0E19\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E19\0E35\0E49</p>'),
'',
unistr('<p>\0E41\0E17\0E23\0E01\0E41\0E16\0E27\0E43\0E2B\0E21\0E48\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E1B\0E38\0E48\0E21 \0E40\0E1E\0E34\0E48\0E21\0E41\0E16\0E27</p>'),
'',
unistr('<p>\0E41\0E01\0E49\0E44\0E02\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E14\0E31\0E1A\0E40\0E1A\0E34\0E25\0E04\0E25\0E34\0E01\0E17\0E35\0E48\0E40\0E0B\0E25\0E25\0E4C\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23 \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E07\0E32\0E19\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02\0E02\0E19\0E32\0E14\0E43\0E2B\0E0D\0E48 \0E43\0E2B\0E49\0E04\0E25\0E34\0E01 \0E41\0E01\0E49\0E44\0E02 \0E40\0E1E\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E2A\0E39\0E48\0E42\0E2B\0E21\0E14\0E41\0E01\0E49\0E44\0E02 \0E43\0E19\0E42\0E2B\0E21\0E14\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E04\0E25\0E34\0E01\0E40\0E1E\0E35\0E22\0E07\0E04\0E23\0E31\0E49\0E07\0E40\0E14\0E35\0E22\0E27\0E2B\0E23\0E37\0E2D\0E43\0E0A\0E49\0E41\0E1B\0E49\0E19\0E1E\0E34\0E21\0E1E\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E40\0E0B\0E25\0E25\0E4C\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E44\0E14\0E49</p>'),
'',
unistr('<p>\0E43\0E0A\0E49\0E40\0E21\0E19\0E39 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19 \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E2A\0E33\0E40\0E19\0E32\0E41\0E25\0E30\0E25\0E1A\0E41\0E16\0E27 \0E43\0E19\0E01\0E32\0E23\0E43\0E0A\0E49\0E07\0E32\0E19\0E40\0E21\0E19\0E39 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19 \0E43\0E2B\0E49\0E43\0E0A\0E49\0E0A\0E48\0E2D\0E07\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E40\0E1E\0E37\0E48\0E2D\0E40\0E25\0E37\0E2D\0E01\0E41\0E16\0E27\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E41\0E16\0E27</p>'),
'',
unistr('<p>\0E2A\0E23\0E49\0E32\0E07\0E2A\0E33\0E40\0E19\0E32\0E41\0E16\0E27\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E42\0E14\0E22\0E04\0E25\0E34\0E01\0E40\0E21\0E19\0E39 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19 \0E41\0E25\0E30\0E40\0E25\0E37\0E2D\0E01 \0E2A\0E23\0E49\0E32\0E07\0E2A\0E33\0E40\0E19\0E32\0E41\0E16\0E27 \0E25\0E1A\0E41\0E16\0E27\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E42\0E14\0E22\0E04\0E25\0E34\0E01\0E40\0E21\0E19\0E39 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19 \0E41\0E25\0E30\0E40\0E25\0E37\0E2D\0E01 \0E25\0E1A\0E41\0E16\0E27</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551979592402606)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E19\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552080222402606)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E08\0E30\0E41\0E2A\0E14\0E07\0E0A\0E38\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E04\0E49\0E19\0E2B\0E32\0E41\0E25\0E30\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E44\0E14\0E49 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E44\0E14\0E49\0E2B\0E25\0E32\0E22\0E41\0E1A\0E1A\0E40\0E1E\0E37\0E48\0E2D\0E08\0E33\0E01\0E31\0E14\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E17\0E35\0E48\0E2A\0E48\0E07\0E04\0E37\0E19 \0E41\0E25\0E30\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E27\0E34\0E18\0E35\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E02\0E49\0E2D\0E21\0E39\0E25</p>'),
'',
unistr('<p>\0E43\0E0A\0E49\0E1F\0E34\0E25\0E14\0E4C\0E04\0E49\0E19\0E2B\0E32\0E40\0E1E\0E37\0E48\0E2D\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E17\0E35\0E48\0E2A\0E48\0E07\0E04\0E37\0E19 \0E04\0E25\0E34\0E01 \0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23 \0E40\0E1E\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E15\0E48\0E32\0E07\0E46 \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19 \0E2B\0E23\0E37\0E2D\0E43\0E0A\0E49\0E40\0E21\0E19\0E39 \0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07</p>'),
'',
unistr('<p>\0E43\0E0A\0E49 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19 \0E40\0E1E\0E37\0E48\0E2D\0E1A\0E31\0E19\0E17\0E36\0E01\0E01\0E32\0E23\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E02\0E2D\0E07\0E04\0E38\0E13\0E25\0E07\0E43\0E19\0E23\0E32\0E22\0E07\0E32\0E19 \0E41\0E25\0E30\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E08\0E32\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E1B\0E22\0E31\0E07\0E44\0E1F\0E25\0E4C\0E20\0E32\0E22\0E19\0E2D\0E01\0E2B\0E23\0E37\0E2D\0E2A\0E48\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E16\0E36\0E07\0E15\0E31\0E27\0E04\0E38\0E13\0E40\0E2D\0E07\0E2B\0E23\0E37\0E2D\0E1C\0E39\0E49\0E2D\0E37\0E48\0E19</p>'),
'',
unistr('<p>\0E43\0E19\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E19\0E23\0E39\0E49\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21 \0E42\0E1B\0E23\0E14\0E14\0E39 "\0E01\0E32\0E23\0E43\0E0A\0E49\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A" \0E43\0E19 <em>\0E04\0E39\0E48\0E21\0E37\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49 Oracle Application Express</em>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551753681402605)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E20\0E32\0E1E\0E23\0E27\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549787190402604)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E40\0E1E\0E37\0E48\0E2D\0E41\0E2A\0E14\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E41\0E1A\0E1A\0E15\0E48\0E32\0E07\0E46 \0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E04\0E27\0E32\0E21\0E2A\0E32\0E21\0E32\0E23\0E16\0E20\0E32\0E22\0E43\0E19</p>'),
'',
unistr('<p>\0E43\0E0A\0E49\0E40\0E21\0E19\0E39\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2B\0E23\0E37\0E2D\0E40\0E21\0E19\0E39\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E27\0E48\0E32\0E08\0E30\0E41\0E2A\0E14\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E14 \0E43\0E19\0E25\0E33\0E14\0E31\0E1A\0E43\0E14 \0E41\0E25\0E49\0E27\0E1F\0E23\0E35\0E0B\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E19\0E2D\0E01\0E08\0E32\0E01\0E19\0E35\0E49 \0E04\0E38\0E13\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E15\0E48\0E32\0E07\0E46 \0E41\0E25\0E30\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E2A\0E48\0E07\0E04\0E37\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22</p>'),
'',
unistr('<p>\0E43\0E0A\0E49\0E1B\0E38\0E48\0E21\0E14\0E39 (\0E2D\0E22\0E39\0E48\0E15\0E34\0E14\0E01\0E31\0E1A\0E1F\0E34\0E25\0E14\0E4C\0E04\0E49\0E19\0E2B\0E32) \0E40\0E1E\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E27\0E34\0E27\0E02\0E49\0E2D\0E21\0E39\0E25\0E2D\0E37\0E48\0E19\0E46 \0E17\0E35\0E48\0E2D\0E32\0E08\0E01\0E33\0E2B\0E19\0E14\0E44\0E27\0E49\0E42\0E14\0E22\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 \0E41\0E25\0E30\0E04\0E38\0E13\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E23\0E49\0E32\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E2B\0E23\0E37\0E2D\0E14\0E39\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E44\0E14\0E49\0E14\0E49\0E27\0E22</p>  '),
'',
unistr('<p><em>\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: \0E04\0E25\0E34\0E01 <strong>\0E27\0E34\0E18\0E35\0E43\0E0A\0E49</strong> \0E43\0E19\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A \0E40\0E1E\0E37\0E48\0E2D\0E14\0E39\0E02\0E49\0E2D\0E21\0E39\0E25\0E42\0E14\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E40\0E01\0E35\0E48\0E22\0E27\0E01\0E31\0E1A\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551815852402606)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E19\0E01\0E32\0E23\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501582965402564)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548669158402603)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E04\0E48\0E32\0E17\0E35\0E48\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E08\0E30\0E41\0E2A\0E14\0E07\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25 \0E2B\0E23\0E37\0E2D\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E02\0E2D\0E07\0E41\0E15\0E48\0E25\0E30\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07 \0E2B\0E32\0E01\0E21\0E35\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21</p>'),
'',
unistr('<p><strong>\0E25\0E34\0E2A\0E15\0E4C\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21</strong><br>'),
unistr('\0E25\0E34\0E2A\0E15\0E4C\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E08\0E30\0E41\0E2A\0E14\0E07\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14 \0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E42\0E14\0E22\0E01\0E32\0E23\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E1E\0E34\0E48\0E21 ( &plus; ) \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E43\0E2B\0E21\0E48 \0E2B\0E23\0E37\0E2D \0E25\0E1A ( &minus; ) \0E40\0E1E\0E37\0E48\0E2D\0E22\0E49\0E32\0E22\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E2D\0E2D\0E01</p>'),
'',
unistr('<p><strong>\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21</strong><br>'),
unistr('\0E43\0E0A\0E49\0E1F\0E2D\0E23\0E4C\0E21\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21<br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E0A\0E37\0E48\0E2D\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E25\0E30\0E1B\0E23\0E30\0E40\0E20\0E17\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21<br>'),
unistr('\0E2B\0E23\0E37\0E2D\0E1B\0E49\0E2D\0E19\0E04\0E33\0E41\0E19\0E30\0E19\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E21\0E37\0E2D\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21<br>'),
unistr('\0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E14\0E49\0E01\0E33\0E2B\0E19\0E14\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21 \0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01 <strong>\0E41\0E2A\0E14\0E07\0E04\0E48\0E32\0E42\0E14\0E22\0E23\0E27\0E21</strong> \0E08\0E30\0E41\0E2A\0E14\0E07\0E04\0E48\0E32\0E40\0E09\0E25\0E35\0E48\0E22\0E42\0E14\0E22\0E23\0E27\0E21 \0E17\0E31\0E49\0E07\0E2B\0E21\0E14 \0E2B\0E23\0E37\0E2D\0E04\0E48\0E32\0E17\0E35\0E48\0E04\0E25\0E49\0E32\0E22\0E04\0E25\0E36\0E07\0E01\0E31\0E19\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25</p>'),
'',
unistr('<p><em>\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: \0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E43\0E19\0E40\0E21\0E19\0E39\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E2B\0E23\0E37\0E2D\0E42\0E14\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E41\0E25\0E30\0E1C\0E25\0E23\0E27\0E21\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C ( &sum; )</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550806704402605)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549360010402604)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E40\0E1B\0E47\0E19\0E27\0E34\0E27\0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E1A\0E1A\0E41\0E22\0E01\0E15\0E48\0E32\0E07\0E2B\0E32\0E01<br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E1B\0E23\0E30\0E40\0E20\0E17\0E41\0E25\0E30\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27\0E02\0E2D\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34</p>'),
unistr('<p><strong>\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27\0E02\0E2D\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34</strong></br>'),
unistr('\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27\0E02\0E2D\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E08\0E30\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E44\0E1B\0E15\0E32\0E21\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E2D\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34</p>'),
'<p>',
'<ul>',
unistr('  <li>\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E21\0E35\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27:'),
'    <ul>',
unistr('      <li>\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A - \0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E08\0E38\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E15\0E48\0E25\0E30\0E08\0E38\0E14</li>'),
unistr('      <li>\0E04\0E48\0E32 - \0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E08\0E30\0E1E\0E25\0E47\0E2D\0E15</li>'),
unistr('      <li>\0E0A\0E38\0E14 - \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E41\0E1A\0E1A\0E44\0E14\0E19\0E32\0E21\0E34\0E04\0E2B\0E25\0E32\0E22\0E0A\0E38\0E14\0E02\0E2D\0E07\0E04\0E38\0E13</li>'),
unistr('      <li>\0E40\0E1B\0E34\0E14 - \0E23\0E32\0E04\0E32\0E40\0E1B\0E34\0E14\0E2B\0E38\0E49\0E19\0E23\0E32\0E22\0E27\0E31\0E19 (\0E40\0E09\0E1E\0E32\0E30\0E2B\0E38\0E49\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>\0E1B\0E34\0E14 - \0E23\0E32\0E04\0E32\0E1B\0E34\0E14\0E2B\0E38\0E49\0E19\0E23\0E32\0E22\0E27\0E31\0E19 (\0E40\0E09\0E1E\0E32\0E30\0E2B\0E38\0E49\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>\0E2A\0E39\0E07 - \0E04\0E48\0E32\0E2A\0E39\0E07 (\0E40\0E09\0E1E\0E32\0E30\0E0A\0E48\0E27\0E07\0E41\0E25\0E30\0E2B\0E38\0E49\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>\0E15\0E48\0E33 - \0E04\0E48\0E32\0E15\0E48\0E33 (\0E40\0E09\0E1E\0E32\0E30\0E0A\0E48\0E27\0E07\0E41\0E25\0E30\0E2B\0E38\0E49\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>\0E27\0E2D\0E25\0E25\0E38\0E21 - \0E27\0E2D\0E25\0E25\0E38\0E21\0E02\0E2D\0E07\0E2B\0E38\0E49\0E19\0E23\0E32\0E22\0E27\0E31\0E19 (\0E40\0E09\0E1E\0E32\0E30\0E2B\0E38\0E49\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>\0E40\0E1B\0E49\0E32\0E2B\0E21\0E32\0E22 - \0E04\0E48\0E32\0E40\0E1B\0E49\0E32\0E2B\0E21\0E32\0E22 (\0E40\0E09\0E1E\0E32\0E30\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E02\0E32\0E22\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>X - \0E04\0E48\0E32\0E41\0E01\0E19 X (\0E40\0E09\0E1E\0E32\0E30\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E1A\0E31\0E1A\0E40\0E1A\0E34\0E25\0E41\0E25\0E30\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E01\0E23\0E30\0E08\0E32\0E22\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>Y - \0E04\0E48\0E32\0E41\0E01\0E19 Y (\0E40\0E09\0E1E\0E32\0E30\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E1A\0E31\0E1A\0E40\0E1A\0E34\0E25\0E41\0E25\0E30\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E01\0E23\0E30\0E08\0E32\0E22\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
unistr('      <li>Z - \0E04\0E27\0E32\0E21\0E01\0E27\0E49\0E32\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E41\0E17\0E48\0E07\0E41\0E25\0E30\0E23\0E31\0E28\0E21\0E35\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E1A\0E31\0E1A\0E40\0E1A\0E34\0E25 (\0E40\0E09\0E1E\0E32\0E30\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E41\0E17\0E48\0E07 \0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E1A\0E31\0E1A\0E40\0E1A\0E34\0E25 \0E41\0E25\0E30\0E0A\0E48\0E27\0E07\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19)</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0E01\0E32\0E23\0E08\0E31\0E14\0E41\0E19\0E27 - \0E41\0E19\0E27\0E15\0E31\0E49\0E07\0E2B\0E23\0E37\0E2D\0E41\0E19\0E27\0E19\0E2D\0E19</li>'),
unistr('  <li>\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21 - \0E40\0E25\0E37\0E2D\0E01\0E27\0E34\0E18\0E35\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E04\0E48\0E32\0E41\0E1C\0E19\0E20\0E39\0E21\0E34</li>'),
unistr('  <li>\0E2A\0E41\0E15\0E47\0E04 - \0E23\0E30\0E1A\0E38\0E27\0E48\0E32\0E08\0E30\0E0B\0E49\0E2D\0E19\0E23\0E32\0E22\0E01\0E32\0E23\0E02\0E49\0E2D\0E21\0E39\0E25\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48</li>'),
unistr('  <li>\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E32\0E21 - \0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E32\0E21\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A\0E2B\0E23\0E37\0E2D\0E04\0E48\0E32'),
'    <ul>',
unistr('      <li>\0E17\0E34\0E28\0E17\0E32\0E07 - \0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E32\0E21\0E04\0E48\0E32\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01\0E2B\0E23\0E37\0E2D\0E08\0E32\0E01\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22</li>'),
unistr('      <li>\0E19\0E31\0E25 - \0E23\0E30\0E1A\0E38\0E27\0E34\0E18\0E35\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E17\0E35\0E48\0E21\0E35\0E04\0E48\0E32\0E19\0E31\0E25\0E17\0E35\0E48\0E40\0E01\0E35\0E48\0E22\0E27\0E02\0E49\0E2D\0E07\0E01\0E31\0E1A\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E17\0E35\0E48\0E21\0E35\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0E15\0E33\0E41\0E2B\0E19\0E48\0E07\0E17\0E28\0E19\0E34\0E22\0E21</li>'),
unistr('  <li>\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A</li>'),
unistr('  <li>\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E04\0E48\0E32</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551289674402605)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548359316402603)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E40\0E25\0E37\0E2D\0E01\0E27\0E48\0E32\0E08\0E30\0E41\0E2A\0E14\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E14\0E41\0E25\0E30\0E43\0E19\0E25\0E33\0E14\0E31\0E1A\0E43\0E14</p>'),
'',
unistr('<p>\0E0B\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E42\0E14\0E22\0E01\0E32\0E23\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01<br>'),
unistr('\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E2B\0E21\0E48\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E40\0E25\0E37\0E48\0E2D\0E19\0E02\0E36\0E49\0E19 ( &uarr; ) \0E2B\0E23\0E37\0E2D\0E40\0E25\0E37\0E48\0E2D\0E19\0E25\0E07 ( &darr; )<br>'),
unistr('\0E43\0E0A\0E49\0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E41\0E1A\0E1A\0E14\0E23\0E2D\0E1B\0E14\0E32\0E27\0E19\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E41\0E2A\0E14\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E31\0E49\0E07\0E2B\0E21\0E14 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 \0E2B\0E23\0E37\0E2D\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E41\0E2A\0E14\0E07</p>'),
'',
unistr('<p>\0E2B\0E23\0E37\0E2D\0E43\0E0A\0E49\0E1F\0E2D\0E23\0E4C\0E21\0E40\0E1E\0E37\0E48\0E2D\0E23\0E30\0E1A\0E38\0E04\0E27\0E32\0E21\0E01\0E27\0E49\0E32\0E07\0E02\0E31\0E49\0E19\0E15\0E48\0E33\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1B\0E47\0E19\0E1E\0E34\0E01\0E40\0E0B\0E25</p>'),
'',
unistr('<p><em>\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: \0E19\0E2D\0E01\0E08\0E32\0E01\0E19\0E35\0E49 \0E04\0E38\0E13\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E2B\0E21\0E48\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E17\0E35\0E48\0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E32\0E23\0E01\0E32\0E23\0E25\0E32\0E01 (\0E17\0E35\0E48\0E08\0E38\0E14\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E02\0E2D\0E07\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C) \0E41\0E25\0E30\0E25\0E32\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E44\0E1B\0E17\0E32\0E07\0E0B\0E49\0E32\0E22\0E2B\0E23\0E37\0E2D\0E02\0E27\0E32 \0E41\0E25\0E30\0E22\0E31\0E07\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E04\0E27\0E32\0E21\0E01\0E27\0E49\0E32\0E07\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E15\0E31\0E27\0E04\0E31\0E48\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27 \0E41\0E25\0E49\0E27\0E40\0E25\0E37\0E48')
||unistr('\0E2D\0E19\0E44\0E1B\0E17\0E32\0E07\0E0B\0E49\0E32\0E22\0E2B\0E23\0E37\0E2D\0E02\0E27\0E32</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551168034402605)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548795077402603)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21\0E15\0E32\0E21\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E32\0E07\0E04\0E13\0E34\0E15\0E28\0E32\0E2A\0E15\0E23\0E4C\0E41\0E25\0E30\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48</p>'),
'',
unistr('<p><strong>\0E25\0E34\0E2A\0E15\0E4C\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13</strong><br>'),
unistr('\0E25\0E34\0E2A\0E15\0E4C\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E08\0E30\0E41\0E2A\0E14\0E07\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E44\0E27\0E49 \0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E42\0E14\0E22\0E01\0E32\0E23\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E1E\0E34\0E48\0E48\0E21 ( &plus; ) \0E40\0E1E\0E37\0E48\0E2D\0E40\0E1E\0E34\0E48\0E21\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E43\0E2B\0E21\0E48 \0E2B\0E23\0E37\0E2D \0E25\0E1A ( &minus; ) \0E40\0E1E\0E37\0E48\0E2D\0E22\0E49\0E32\0E22\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E2D\0E2D\0E01</p>'),
'',
unistr('<p><strong>\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13</strong><br>'),
unistr('\0E43\0E0A\0E49\0E1F\0E2D\0E23\0E4C\0E21\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13<br>'),
unistr('\0E1B\0E49\0E2D\0E19\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E40\0E0A\0E48\0E19 \0E2A\0E48\0E27\0E19\0E2B\0E31\0E27 \0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A \0E41\0E25\0E30\0E40\0E25\0E37\0E2D\0E01\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E08\0E31\0E14\0E41\0E19\0E27<br> '),
unistr('\0E43\0E0A\0E49\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E40\0E1E\0E37\0E48\0E2D\0E1B\0E49\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E25\0E30\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13<br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E41\0E25\0E30\0E01\0E32\0E23\0E1B\0E01\0E1B\0E34\0E14\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E2B\0E21\0E48</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550724113402605)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E04\0E33\0E19\0E27\0E13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549029409402603)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E23\0E32\0E22\0E01\0E32\0E23</p>'),
'',
unistr('<p><strong>\0E25\0E34\0E2A\0E15\0E4C\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21</strong><br>'),
unistr('\0E25\0E34\0E2A\0E15\0E4C\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E08\0E30\0E41\0E2A\0E14\0E07\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14 \0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E42\0E14\0E22\0E01\0E32\0E23\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E1E\0E34\0E48\0E48\0E21 ( &plus; ) \0E40\0E1E\0E37\0E48\0E2D\0E23\0E27\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E2B\0E21\0E48\0E43\0E19\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21 \0E2B\0E23\0E37\0E2D \0E25\0E1A ( &minus; ) \0E40\0E1E\0E37\0E48\0E2D\0E22\0E49\0E32\0E22\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E2D\0E2D\0E01\0E08\0E32\0E01\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21<br>'),
unistr('\0E43\0E19\0E01\0E32\0E23\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E2B\0E21\0E48 \0E43\0E19\0E04\0E25\0E34\0E01 \0E40\0E25\0E37\0E48\0E2D\0E19\0E02\0E36\0E49\0E19 ( &uarr; ) \0E2B\0E23\0E37\0E2D \0E40\0E25\0E37\0E48\0E2D\0E19\0E25\0E07 ( &darr; ) \0E40\0E1E\0E37\0E48\0E2D\0E40\0E25\0E37\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E02\0E36\0E49\0E19\0E2B\0E23\0E37\0E2D\0E25\0E07\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E37\0E48\0E19\0E46</p>'),
'',
unistr('<p><strong>\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21</strong><br>'),
unistr('\0E43\0E0A\0E49\0E1F\0E2D\0E23\0E4C\0E21\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21<br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21 \0E17\0E34\0E28\0E17\0E32\0E07\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07 \0E41\0E25\0E30\0E27\0E34\0E18\0E35\0E01\0E32\0E23\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E19\0E31\0E25 (\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E21\0E35\0E04\0E48\0E32)</p>'),
'',
unistr('<p><em>\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: \0E02\0E13\0E30\0E14\0E39\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E41\0E25\0E49\0E27\0E40\0E25\0E37\0E2D\0E01\0E44\0E2D\0E04\0E2D\0E19\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550465436402604)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549281869402603)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14\0E41\0E16\0E27\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E44\0E1B\0E22\0E31\0E07\0E44\0E1F\0E25\0E4C\0E20\0E32\0E22\0E19\0E2D\0E01 \0E44\0E1F\0E25\0E4C\0E08\0E30\0E21\0E35\0E40\0E09\0E1E\0E32\0E30\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E43\0E19\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19 \0E42\0E14\0E22\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E41\0E25\0E30\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E01\0E31\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25</p>'),
'',
unistr('<p>\0E40\0E25\0E37\0E2D\0E01\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E44\0E1F\0E25\0E4C\0E41\0E25\0E30\0E04\0E25\0E34\0E01 \0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14<br>'),
unistr('\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: CSV \0E08\0E30\0E44\0E21\0E48\0E23\0E27\0E21\0E01\0E32\0E23\0E08\0E31\0E14\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E02\0E49\0E2D\0E04\0E27\0E32\0E21 \0E40\0E0A\0E48\0E19 \0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E41\0E25\0E30\0E40\0E2A\0E49\0E19\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21</p>'),
'',
unistr('<p>\0E43\0E19\0E01\0E32\0E23\0E2A\0E48\0E07\0E44\0E1F\0E25\0E4C\0E17\0E32\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C \0E43\0E2B\0E49\0E40\0E25\0E37\0E2D\0E01 \0E2A\0E48\0E07\0E40\0E1B\0E47\0E19\0E2D\0E35\0E40\0E21\0E25\0E4C \0E41\0E25\0E30\0E1B\0E49\0E2D\0E19\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E2D\0E35\0E40\0E21\0E25\0E4C (\0E1C\0E39\0E49\0E23\0E31\0E1A \0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07 \0E41\0E25\0E30\0E02\0E49\0E2D\0E04\0E27\0E32\0E21)</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550273315402604)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14\0E44\0E1F\0E25\0E4C\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548482583402603)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E04\0E2D\0E19\0E1F\0E34\0E40\0E01\0E2D\0E23\0E4C\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E08\0E33\0E01\0E31\0E14\0E41\0E16\0E27\0E17\0E35\0E48\0E08\0E30\0E2A\0E48\0E07\0E04\0E37\0E19</p>'),
'',
unistr('<p><strong>\0E25\0E34\0E2A\0E15\0E4C\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C</strong><br>'),
unistr('\0E25\0E34\0E2A\0E15\0E4C\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E08\0E30\0E41\0E2A\0E14\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14 \0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E42\0E14\0E22\0E01\0E32\0E23\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E1E\0E34\0E48\0E21 ( &plus; ) \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E43\0E2B\0E21\0E48 \0E2B\0E23\0E37\0E2D \0E25\0E1A ( &minus; ) \0E40\0E1E\0E37\0E48\0E2D\0E22\0E49\0E32\0E22\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E2D\0E2D\0E01</p>'),
'',
unistr('<p><strong>\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C</strong><br>'),
unistr('\0E43\0E0A\0E49\0E1F\0E2D\0E23\0E4C\0E21\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C<br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E1B\0E23\0E30\0E40\0E20\0E17\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0E41\0E16\0E27 - \0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E14\0E46 \0E17\0E35\0E48\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E44\0E14\0E49<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C - \0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E09\0E1E\0E32\0E30\0E17\0E35\0E48\0E21\0E35\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C\0E41\0E25\0E30\0E04\0E48\0E32\0E17\0E35\0E48\0E23\0E30\0E1A\0E38</p>'),
'',
unistr('<p><em>\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: \0E02\0E13\0E30\0E14\0E39\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E41\0E16\0E27\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E1E\0E34\0E21\0E1E\0E4C\0E25\0E07\0E43\0E19\0E1F\0E34\0E25\0E14\0E4C \0E04\0E49\0E19\0E2B\0E32 \0E42\0E14\0E22\0E15\0E23\0E07 \0E04\0E25\0E34\0E01 \0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E04\0E49\0E19\0E2B\0E32 \0E40\0E1E\0E37\0E48\0E2D\0E08\0E33\0E01\0E31\0E14\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E43\0E2B\0E49\0E2D\0E22\0E39\0E48\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E09\0E1E\0E32\0E30 \0E2B\0E23\0E37\0E2D\0E40\0E1B\0E34\0E14\0E40\0E21\0E19\0E39 \0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E41\0E25\0E30\0E40\0E25\0E37\0E2D\0E01\0E04\0E48\0E32\0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551079515402605)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548803061402603)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E14\0E39\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E48\0E27\0E07\0E40\0E27\0E25\0E32\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32</p>'),
unistr('<p>\0E1B\0E49\0E2D\0E19\0E08\0E33\0E19\0E27\0E19\0E19\0E32\0E17\0E35\0E43\0E19\0E2D\0E14\0E35\0E15\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550658600402605)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551319756402605)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548901115402603)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E44\0E2E\0E44\0E25\0E15\0E4C\0E41\0E16\0E27\0E2B\0E23\0E37\0E2D\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E15\0E32\0E21\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E17\0E35\0E48\0E1B\0E49\0E2D\0E19</p>'),
'',
unistr('<p><strong>\0E25\0E34\0E2A\0E15\0E4C\0E44\0E2E\0E44\0E25\0E15\0E4C</strong><br>'),
unistr('\0E25\0E34\0E2A\0E15\0E4C\0E44\0E2E\0E44\0E25\0E15\0E4C\0E08\0E30\0E41\0E2A\0E14\0E07\0E44\0E2E\0E44\0E25\0E15\0E4C\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14 \0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E44\0E2E\0E44\0E25\0E15\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E42\0E14\0E22\0E01\0E32\0E23\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E1E\0E34\0E48\0E48\0E21 ( &plus; ) \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E44\0E2E\0E44\0E25\0E15\0E4C\0E43\0E2B\0E21\0E48 \0E2B\0E23\0E37\0E2D \0E25\0E1A ( &minus; ) \0E40\0E1E\0E37\0E48\0E2D\0E22\0E49\0E32\0E22\0E44\0E2E\0E44\0E25\0E15\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E2D\0E2D\0E01</p>'),
'',
unistr('<p><strong>\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E2E\0E44\0E25\0E15\0E4C</strong><br>'),
unistr('\0E43\0E0A\0E49\0E1F\0E2D\0E23\0E4C\0E21\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E44\0E2E\0E44\0E25\0E15\0E4C<br>'),
unistr('\0E1B\0E49\0E2D\0E19\0E0A\0E37\0E48\0E2D \0E40\0E25\0E37\0E2D\0E01\0E41\0E16\0E27\0E2B\0E23\0E37\0E2D\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E41\0E25\0E30\0E40\0E25\0E37\0E2D\0E01\0E23\0E2B\0E31\0E2A\0E2A\0E35 HTML \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1E\0E37\0E49\0E19\0E2B\0E25\0E31\0E07\0E41\0E25\0E30\0E02\0E49\0E2D\0E04\0E27\0E32\0E21<br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01<strong>\0E1B\0E23\0E30\0E40\0E20\0E17\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02</strong>\0E17\0E35\0E48\0E40\0E2B\0E21\0E32\0E30\0E2A\0E21\0E40\0E1E\0E37\0E48\0E2D\0E44\0E2E\0E44\0E25\0E15\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E09\0E1E\0E32\0E30:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0E41\0E16\0E27 - \0E44\0E2E\0E44\0E25\0E15\0E4C\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E14\0E46 \0E01\0E47\0E44\0E14\0E49<br>'),
unistr('&nbsp;&nbsp;&nbsp;\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C - \0E44\0E2E\0E44\0E25\0E15\0E4C\0E20\0E32\0E22\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E09\0E1E\0E32\0E30\0E15\0E32\0E21\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C\0E41\0E25\0E30\0E04\0E48\0E32\0E17\0E35\0E48\0E23\0E30\0E1A\0E38</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550524077402605)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E44\0E2E\0E44\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549179915402603)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E1A\0E31\0E19\0E17\0E36\0E01\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E02\0E2D\0E07\0E04\0E38\0E13\0E25\0E07\0E43\0E19\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E01\0E23\0E34\0E14\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E41\0E25\0E30\0E04\0E2D\0E19\0E1F\0E34\0E40\0E01\0E2D\0E40\0E23\0E0A\0E31\0E19<br>'),
unistr('\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E33\0E23\0E2D\0E07\0E44\0E14\0E49\0E2B\0E25\0E32\0E22\0E41\0E1A\0E1A \0E2B\0E32\0E01\0E21\0E35\0E2A\0E34\0E17\0E18\0E34\0E4C \0E04\0E38\0E13\0E41\0E25\0E30\0E1C\0E39\0E49\0E43\0E0A\0E49\0E23\0E32\0E22\0E2D\0E37\0E48\0E19\0E2A\0E32\0E21\0E32\0E23\0E16\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E1B\0E47\0E19\0E41\0E1A\0E1A\0E2A\0E48\0E27\0E19\0E01\0E25\0E32\0E07 \0E40\0E1E\0E37\0E48\0E2D\0E43\0E2B\0E49\0E1C\0E39\0E49\0E43\0E0A\0E49\0E2D\0E37\0E48\0E19\0E46 \0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E43\0E19\0E01\0E23\0E34\0E14\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E0A\0E49\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49 \0E41\0E25\0E30\0E04\0E38\0E13\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E1B\0E47\0E19\0E41\0E1A\0E1A\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25 \0E40\0E1E\0E37\0E48\0E2D\0E14\0E39\0E04\0E19\0E40\0E14\0E35\0E22\0E27\0E44\0E14\0E49\0E2D\0E35\0E01\0E14\0E49\0E27\0E22</p>'),
unistr('<p>\0E40\0E25\0E37\0E2D\0E01\0E08\0E32\0E01\0E1B\0E23\0E30\0E40\0E20\0E17\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E41\0E25\0E30\0E1B\0E49\0E2D\0E19\0E0A\0E37\0E48\0E2D\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550373188402604)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E23\0E32\0E22\0E07\0E32\0E19'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548501822402603)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E25\0E33\0E14\0E31\0E1A\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E1C\0E25</p>'),
'',
unistr('<p><strong>\0E25\0E34\0E2A\0E15\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07</strong><br>'),
unistr('\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E30\0E41\0E2A\0E14\0E07\0E25\0E34\0E2A\0E15\0E4C\0E02\0E2D\0E07\0E01\0E0E\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E17\0E35\0E48\0E04\0E2D\0E19\0E1F\0E34\0E40\0E01\0E2D\0E23\0E4C<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E1E\0E34\0E48\0E21 ( &plus; ) \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07 \0E2B\0E23\0E37\0E2D \0E25\0E1A ( &minus; ) \0E40\0E1E\0E37\0E48\0E2D\0E22\0E49\0E32\0E22\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E2D\0E2D\0E01<br>'),
unistr('\0E04\0E25\0E34\0E01 \0E40\0E25\0E37\0E48\0E2D\0E19\0E02\0E36\0E49\0E19 ( &uarr; ) \0E41\0E25\0E30 \0E40\0E25\0E37\0E48\0E2D\0E19\0E25\0E07 ( &darr; ) \0E40\0E1E\0E37\0E48\0E2D\0E40\0E25\0E37\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E02\0E36\0E49\0E19\0E41\0E25\0E30\0E25\0E07\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E2D\0E37\0E48\0E19\0E46</p>'),
'',
unistr('<p><strong>\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07</strong><br>'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07 \0E17\0E34\0E28\0E17\0E32\0E07\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07 \0E41\0E25\0E30\0E27\0E34\0E18\0E35\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E07\0E25\0E33\0E14\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E19\0E31\0E25 (\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E21\0E35\0E04\0E48\0E32)</p>'),
'',
unistr('<p><em>\0E2B\0E21\0E32\0E22\0E40\0E2B\0E15\0E38: \0E2A\0E32\0E21\0E32\0E23\0E16\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E14\0E49\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E41\0E2A\0E14\0E07 \0E2D\0E22\0E48\0E32\0E07\0E44\0E23\0E01\0E47\0E15\0E32\0E21 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E1A\0E32\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E32\0E08\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E44\0E21\0E48\0E44\0E14\0E49</em><br>'),
unistr('<em>\0E2A\0E32\0E21\0E32\0E23\0E16\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E01\0E14\0E17\0E35\0E48\0E25\0E39\0E01\0E28\0E23\0E02\0E36\0E49\0E19 (\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01) \0E2B\0E23\0E37\0E2D\0E25\0E07 (\0E08\0E32\0E01\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22) \0E17\0E35\0E48\0E2A\0E48\0E27\0E19\0E17\0E49\0E32\0E22\0E02\0E2D\0E07\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E43\0E19\0E01\0E32\0E23\0E40\0E1E\0E34\0E48\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E16\0E31\0E14\0E08\0E32\0E01\0E19\0E31\0E49\0E19\0E44\0E1B\0E22\0E31\0E07\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48 \0E43\0E2B\0E49\0E01\0E14\0E1B\0E38\0E48\0E21 Shift \0E04\0E49\0E32\0E07\0E44\0E27\0E49\0E41\0E25\0E30\0E04\0E25\0E34\0E01\0E25\0E39\0E01\0E28\0E23\0E02\0E36\0E49\0E19\0E2B\0E23\0E37\0E2D\0E25\0E07</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550983801402605)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115550198740402604)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502405323402565)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E48\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469279149402538)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E2E\0E44\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537259549402594)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E39\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538017360402595)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E19\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495411025402558)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500420977402563)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E2D\0E04\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468123271402537)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27\0E41\0E1A\0E1A\0E44\0E2D\0E04\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493685104402557)
,p_name=>'APEX.IG.IN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502016496402565)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E43\0E0A\0E49\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502184150402565)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E43\0E0A\0E49\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509739910402571)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E20\0E32\0E22\0E43\0E19\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E04\0E33\0E02\0E2D\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405522911402490)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E1B\0E23\0E30\0E40\0E20\0E17\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C "%0" \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549954540402604)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E27\0E31\0E19\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524120379402583)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524075334402583)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E43\0E0A\0E48\0E1B\0E23\0E30\0E40\0E20\0E17\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410697066402494)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E15\0E31\0E27\0E40\0E25\0E02\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552667123402606)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552747231402606)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543752974402599)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E32\0E21\0E40\0E1B\0E47\0E19 %0 \0E41\0E15\0E48\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541031532402597)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536104305402593)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1B\0E23\0E32\0E01\0E0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494401884402557)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E22\0E39\0E48\0E43\0E19\0E25\0E48\0E32\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494606765402558)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E22\0E39\0E48\0E43\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493511846402557)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E27\0E48\0E32\0E07\0E40\0E1B\0E25\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493412479402557)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E48\0E32\0E07\0E40\0E1B\0E25\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544544974402600)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536595252402594)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540413066402597)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E49\0E32\0E22\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483752699402549)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483932214402550)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484469044402550)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483468595402549)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483535667402549)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483680709402549)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483853624402550)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484579384402550)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484364496402550)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484245119402550)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483251463402549)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483321352402549)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544701768402600)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E40\0E0B\0E25\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544827939402600)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E01\0E25\0E38\0E48\0E21\0E2A\0E33\0E2B\0E23\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494096838402557)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494158632402557)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538609511402595)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2A\0E49\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538763709402595)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2A\0E49\0E19\0E17\0E35\0E48\0E21\0E35\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545142080402600)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'th'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537348446402594)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E48\0E33')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547733118402602)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E31\0E48\0E19\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C\0E14\0E49\0E27\0E22\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E04\0E2D\0E21\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495269477402558)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E23\0E07\0E01\0E31\0E1A\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E17\0E31\0E48\0E27\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519655142402580)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E39\0E07\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555209981402608)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E39\0E07\0E2A\0E38\0E14\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519829206402580)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E01\0E25\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555348844402608)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E36\0E48\0E07\0E01\0E25\0E32\0E07\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519515941402580)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E48\0E33\0E2A\0E38\0E14')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495352005402558)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520367921402581)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555105251402608)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E48\0E33\0E2A\0E38\0E14\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495700354402559)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502396453402565)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E21\0E35\0E40\0E01\0E34\0E19 %0 \0E41\0E16\0E27\0E0B\0E36\0E48\0E07\0E40\0E01\0E34\0E19\0E01\0E27\0E48\0E32\0E2A\0E39\0E07\0E2A\0E38\0E14\0E17\0E35\0E48\0E21\0E35\0E44\0E14\0E49 \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21\0E40\0E1E\0E37\0E48\0E2D\0E14\0E39\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529008668402587)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38 ID \0E41\0E1A\0E1A\0E2A\0E41\0E15\0E15\0E34\0E01\0E02\0E2D\0E07\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 \0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E40\0E1E\0E08\0E21\0E35\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E2B\0E25\0E32\0E22\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498432482402562)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498622091402562)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482681955402549)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482427403402548)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484666491402550)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482998658402549)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482835888402549)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482722380402549)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115482564620402549)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484738448402550)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484085891402550)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484119289402550)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483139431402549)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115483007112402549)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494313872402557)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E23\0E30\0E2B\0E27\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493324885402557)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E40\0E17\0E48\0E32\0E01\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559562230402611)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E35\0E48\0E21\0E35 ID %0 \0E44\0E21\0E48\0E43\0E0A\0E48\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493798107402557)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494534714402558)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E25\0E48\0E32\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115494715380402558)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502216157402565)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540220807402597)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545327864402600)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E40\0E25\0E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540531023402597)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540610417402597)
,p_name=>'APEX.IG.ON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492533862402556)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('1 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548236421402603)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E2A\0E35: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537050664402594)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499514234402563)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536458551402594)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E41\0E19\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538860024402595)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E07\0E01\0E25\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115500858116402564)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115468407268402538)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115548162515402603)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E31\0E48\0E19\0E04\0E48\0E32\0E14\0E49\0E27\0E22 "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115538959622402595)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1E\0E25\0E32\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544203749402600)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E36\0E48\0E07\0E01\0E25\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544387559402600)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115544183825402600)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498743416402562)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E25\0E31\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499057596402562)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515567554402576)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E2B\0E25\0E31\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397787543402484)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E27\0E21\0E41\0E17\0E47\0E01\0E02\0E2D\0E07\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396490929402483)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E19\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396585172402483)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E15\0E31\0E49\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396399752402483)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E41\0E19\0E27\0E40\0E1E\0E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396231151402483)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'th'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396188131402483)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'th'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397895656402484)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E2B\0E19\0E14\0E40\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395998603402483)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E0E\0E2B\0E21\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395865597402483)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E14\0E2B\0E21\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396011990402483)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'th'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395798891402483)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E19\0E32\0E14\0E02\0E2D\0E07\0E40\0E1E\0E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385963197402476)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E2D\0E14\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E17\0E35\0E48\0E21\0E35\0E23\0E39\0E1B\0E41\0E1A\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539099825402596)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E14\0E32\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539155708402596)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E48\0E27\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549470324402604)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E1F\0E23\0E0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503006984402565)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E1F\0E23\0E0A\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501805938402564)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E1F\0E23\0E0A\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507046034402569)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0, \0E40\0E1E\0E08 %1 \0E41\0E25\0E30\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469910669402539)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498106882402562)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558774125402611)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558464176402611)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E33\0E23\0E2D\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558306122402610)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558674651402611)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558583095402611)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E32\0E18\0E32\0E23\0E13\0E30\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115507171647402569)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E0A\0E37\0E48\0E2D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492465604402556)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E21\0E37\0E48\0E2D %0 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492331524402556)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E21\0E37\0E48\0E2D 1 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432066301402509)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551616378402605)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19 - \0E41\0E01\0E49\0E44\0E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506914833402569)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E17\0E35\0E48\0E21\0E35 ID %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115551535168402605)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19 - \0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E1B\0E47\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470040999402539)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559608040402611)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E17\0E35\0E48\0E21\0E35 ID \0E41\0E1A\0E1A\0E2A\0E41\0E15\0E15\0E34\0E01 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554507575402608)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469127036402538)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503185588402566)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E2D\0E19\0E01\0E25\0E31\0E1A\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501956761402564)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E2D\0E19\0E01\0E25\0E31\0E1A\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499110790402562)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498049228402561)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E15\0E48\0E2D\0E40\0E1E\0E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559239972402611)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E01\0E31\0E1A\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560451366402612)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E16\0E27 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115469497892402538)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512100455402574)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467643834402537)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E44\0E27\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467766887402537)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442214948402517)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E0A\0E37\0E48\0E2D %0 \0E41\0E25\0E49\0E27 \0E42\0E1B\0E23\0E14\0E1B\0E49\0E2D\0E19\0E0A\0E37\0E48\0E2D\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467800008402537)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467968658402537)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E32\0E18\0E32\0E23\0E13\0E30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554294372402607)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E1B\0E47\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501264964402564)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539276026402596)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E30\0E08\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467526122402537)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546582359402601)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32: \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467490494402537)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545778682402601)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32: \0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E40\0E15\0E47\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492208085402556)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32 ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535829907402593)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476079261402544)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528712642402587)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01 1 \0E41\0E16\0E27\0E43\0E19\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E2B\0E25\0E31\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467364353402537)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558935922402611)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476208786402544)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E40\0E0B\0E25\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476164710402544)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E41\0E16\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547188421402602)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E40\0E1B\0E47\0E19\0E2D\0E35\0E40\0E21\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539628832402596)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465395226402535)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517902718402578)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E04\0E48\0E32\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502780387402565)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E16\0E27\0E40\0E14\0E35\0E22\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501079756402564)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539787918402596)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559310328402611)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E44\0E14\0E49\0E2B\0E19\0E36\0E48\0E07\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E48\0E2D\0E2B\0E19\0E36\0E48\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559133371402611)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E19\0E39\0E40\0E1B\0E25\0E35\0E48\0E22\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115540714272402597)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E41\0E15\0E47\0E04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495092685402558)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E14\0E49\0E27\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539386520402596)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E38\0E49\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460394982402532)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22\0E04\0E27\0E32\0E21\0E01\0E27\0E49\0E32\0E07\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115501487618402564)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115519427571402580)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E25\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560637248402612)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E34\0E14\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A \0E23\0E32\0E22\0E07\0E32\0E19: %0, \0E21\0E38\0E21\0E21\0E2D\0E07: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115554605291402608)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E25\0E23\0E27\0E21\0E42\0E14\0E22\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537527760402594)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E49\0E32\0E2B\0E21\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543984498402599)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E35\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470160986402539)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517896018402578)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E41\0E19\0E30\0E19\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E21\0E37\0E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115498238507402562)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115502644048402565)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E01\0E40\0E25\0E34\0E01\0E01\0E32\0E23\0E1F\0E23\0E35\0E0B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499757993402563)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E19\0E48\0E27\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546942384402602)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E17\0E35\0E48\0E22\0E31\0E07\0E44\0E21\0E48\0E44\0E14\0E49\0E1A\0E31\0E19\0E17\0E36\0E01 \0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E15\0E48\0E2D\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115499665688402563)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536644138402594)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541572540402598)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526418822402585)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32 (\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E42\0E0B\0E19\0E40\0E27\0E25\0E32\0E44\0E21\0E48\0E44\0E14\0E49)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545481361402601)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537903379402595)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E15\0E31\0E49\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497770737402561)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535930776402593)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E1C\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115537415604402594)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E34\0E21\0E32\0E13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495658138402559)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536001722402593)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E01\0E27\0E49\0E32\0E07\0E15\0E48\0E33\0E2A\0E38\0E14\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C (\0E1E\0E34\0E01\0E40\0E0B\0E25)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486895849402552)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2D\0E22\0E39\0E48\0E23\0E30\0E2B\0E27\0E48\0E32\0E07 %1 \0E01\0E31\0E1A %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486507066402551)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486604310402552)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E21\0E35 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464787132402535)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E02\0E36\0E49\0E19\0E15\0E49\0E19\0E14\0E49\0E27\0E22 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485373707402551)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E17\0E48\0E32\0E01\0E31\0E1A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485531450402551)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E32\0E01\0E01\0E27\0E48\0E32 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485631329402551)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E32\0E01\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486373059402551)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487589408402552)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487382908402552)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487109591402552)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487926084402553)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487760884402552)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488180426402553)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E1B\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487455555402552)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487276180402552)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487006647402552)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487804223402552)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115487627407402552)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488031403402553)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E1B\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489962115402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489788047402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489590188402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E19\0E32\0E17\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490375546402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490165601402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490573239402555)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19 %1 \0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489841214402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489619276402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489492672402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E19\0E32\0E17\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490235345402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490052490402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490477207402554)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E43\0E19\0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486049828402551)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E27\0E48\0E32\0E07\0E40\0E1B\0E25\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485996142402551)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E48\0E32\0E07\0E40\0E1B\0E25\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485743039402551)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485838031402551)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486157644402551)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E2B\0E21\0E37\0E2D\0E19 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486724007402552)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E15\0E23\0E07\0E01\0E31\0E1A\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E17\0E31\0E48\0E27\0E44\0E1B %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492679078402556)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486982566402552)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E23\0E30\0E2B\0E27\0E48\0E32\0E07 %1 \0E01\0E31\0E1A %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485446906402551)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486494559402551)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488701339402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488580165402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488372028402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489197962402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488912816402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489328810402554)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E1B\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488656783402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488419264402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488240047402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489069074402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115488821004402553)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115489224138402554)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E1B\0E35\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491178621402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490908880402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490791299402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E19\0E32\0E17\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491511694402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491387959402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491783284402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491027735402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490817436402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115490627446402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E19\0E32\0E17\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491406978402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491295781402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491696891402555)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115486232435402551)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E40\0E2B\0E21\0E37\0E2D\0E19 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493155097402556)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E14\0E49\0E27\0E22 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536789422402594)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'th'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495858072402559)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536844208402594)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'th'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536990681402594)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'th'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115545934980402601)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E08\0E31\0E19\0E17\0E23\0E4C\0E17\0E35\0E48 12 \0E21\0E01\0E23\0E32\0E04\0E21 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546080308402601)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E01\0E23\0E32\0E04\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546120316402601)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'th'
,p_message_text=>unistr('16 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115546236497402601)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 16 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401225572402487)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E44\0E1F\0E25\0E4C\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E1B\0E23\0E30\0E40\0E20\0E17\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E04\0E37\0E2D %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528198167402587)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1A\0E23\0E32\0E2A\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527831622402586)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E44\0E1F\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527914823402586)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E44\0E1F\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401002845402487)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E32\0E01\0E41\0E25\0E30\0E27\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401472581402487)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E32\0E01\0E41\0E25\0E30\0E27\0E32\0E07\0E44\0E1F\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402670979402488)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E44\0E1F\0E25\0E4C\0E2B\0E23\0E37\0E2D\0E27\0E32\0E07\0E44\0E27\0E49\0E17\0E35\0E48\0E19\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402779093402488)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E2B\0E23\0E37\0E2D\0E27\0E32\0E07\0E44\0E1F\0E25\0E4C\0E44\0E27\0E49\0E17\0E35\0E48\0E19\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402872229402488)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E44\0E1F\0E25\0E4C\0E2B\0E23\0E37\0E2D\0E27\0E32\0E07\0E44\0E27\0E49\0E17\0E35\0E48\0E19\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402944897402488)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E2B\0E23\0E37\0E2D\0E27\0E32\0E07\0E44\0E1F\0E25\0E4C\0E44\0E27\0E49\0E17\0E35\0E48\0E19\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401301430402487)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E1F\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401134805402487)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E19\0E32\0E14\0E44\0E1F\0E25\0E4C\0E43\0E2B\0E0D\0E48\0E40\0E01\0E34\0E19\0E44\0E1B \0E02\0E19\0E32\0E14\0E44\0E1F\0E25\0E4C\0E2A\0E39\0E07\0E2A\0E38\0E14\0E04\0E37\0E2D %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388989036402478)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E21\0E35\0E17\0E35\0E48\0E2D\0E22\0E39\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387862945402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E37\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388279513402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1B\0E23\0E30\0E40\0E17\0E28')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387939129402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E49\0E32\0E19\0E40\0E25\0E02\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388850851402478)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E30\0E15\0E34\0E08\0E39\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388759388402478)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E2D\0E07\0E08\0E34\0E08\0E39\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388616885402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E1A\0E19\0E41\0E1C\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388391986402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E30\0E41\0E19\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388008085402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E44\0E1B\0E23\0E29\0E13\0E35\0E22\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388129177402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E31\0E10')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387717573402477)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E19\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387670110402477)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E23\0E2B\0E31\0E2A\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400254305402486)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E2B\0E19\0E14\0E1E\0E34\0E01\0E31\0E14\0E17\0E32\0E07\0E20\0E39\0E21\0E34\0E28\0E32\0E2A\0E15\0E23\0E4C\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400303377402486)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E31\0E07\0E44\0E21\0E48\0E01\0E33\0E2B\0E19\0E14\0E1E\0E34\0E01\0E31\0E14\0E17\0E32\0E07\0E20\0E39\0E21\0E34\0E28\0E32\0E2A\0E15\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388508603402477)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115388433320402477)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E17\0E35\0E48\0E2D\0E22\0E39\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389043093402478)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558856913402611)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E27\0E34\0E18\0E35\0E43\0E0A\0E49: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452264550402526)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452340251402526)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398264112402485)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E48\0E27\0E07\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E08\0E32\0E01 %0 \0E16\0E36\0E07 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398343747402485)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E44\0E21\0E48\0E43\0E0A\0E48\0E1C\0E25\0E04\0E39\0E13\0E02\0E2D\0E07 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397917651402484)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E15\0E23\0E07\0E01\0E31\0E1A\0E04\0E48\0E32 %0 \0E41\0E25\0E30 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398183639402485)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476427263402544)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476565368402544)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398059214402484)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381417452402472)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510676833402572)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510742343402572)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E2D\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381543912402472)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514469803402575)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E31\0E49\0E19\0E2A\0E39\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514769287402576)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E01\0E40\0E25\0E34\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514539281402575)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E31\0E48\0E27\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514800841402576)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E40\0E17\0E21\0E40\0E1E\0E25\0E17\0E44\0E25\0E1F\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515462240402576)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E07\0E32\0E19\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E40\0E17\0E21\0E40\0E1E\0E25\0E17\0E44\0E21\0E48\0E44\0E14\0E49 \0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E2D\0E07\0E04\0E4C\0E1B\0E23\0E30\0E01\0E2D\0E1A\0E19\0E35\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E41\0E2A\0E14\0E07\0E43\0E19\0E2B\0E19\0E49\0E32\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514367370402575)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E40\0E17\0E21\0E40\0E1E\0E25\0E17')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514675091402576)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389934722402479)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07\0E27\0E07\0E01\0E25\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391753792402480)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E44\0E15\0E25\0E4C\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E40\0E2D\0E07\0E44\0E21\0E48\0E43\0E0A\0E48 JSON \0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390276567402479)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E21\0E37\0E2D\0E23\0E30\0E22\0E30\0E17\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390038943402479)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E32\0E14\0E27\0E07\0E01\0E25\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382617559402473)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E41\0E1A\0E1A\0E21\0E35 Facet \0E15\0E49\0E2D\0E07\0E21\0E35\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E23\0E30\0E14\0E31\0E1A\0E20\0E39\0E21\0E34\0E20\0E32\0E04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385227492402475)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E33\0E41\0E2B\0E19\0E48\0E07\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386345352402476)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E34\0E01\0E31\0E14\0E15\0E33\0E41\0E2B\0E19\0E48\0E07\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383767739402474)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E33\0E41\0E2B\0E19\0E48\0E07\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E40\0E23\0E02\0E32\0E04\0E13\0E34\0E15\0E08\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386155125402476)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E21.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384778044402475)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E40\0E22\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518079556402578)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E40\0E22\0E2D\0E23\0E4C: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389392691402478)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E17\0E35\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382510760402473)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386219919402476)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517020655402577)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E21\0E35\0E40\0E01\0E34\0E19 %0 \0E41\0E16\0E27 \0E0B\0E36\0E48\0E07\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E2A\0E39\0E07\0E2A\0E38\0E14\0E17\0E35\0E48\0E2D\0E19\0E38\0E0D\0E32\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384578722402475)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02</a> &nbsp;&nbsp; \0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E1C\0E19\0E17\0E35\0E48 &copy; 2017 \0E17\0E35\0E48\0E19\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383488701402474)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25 SDO_GEOMETRY \0E43\0E0A\0E49\0E07\0E32\0E19\0E44\0E21\0E48\0E44\0E14\0E49\0E43\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384659212402475)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; \0E1C\0E39\0E49\0E43\0E2B\0E49\0E02\0E49\0E2D\0E21\0E39\0E25 OpenStreetMap </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384824873402475)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518136462402578)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E08\0E38\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390174445402479)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E39\0E21\0E23\0E39\0E1B\0E2A\0E35\0E48\0E40\0E2B\0E25\0E35\0E48\0E22\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389809813402478)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385195943402475)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E17\0E34\0E28\0E17\0E32\0E07\0E40\0E1B\0E47\0E19\0E17\0E34\0E28\0E40\0E2B\0E19\0E37\0E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465407951402535)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25\0E44\0E1B\0E22\0E31\0E07\0E42\0E2B\0E21\0E14 2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465539003402535)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25\0E44\0E1B\0E22\0E31\0E07\0E42\0E2B\0E21\0E14 3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389789175402478)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E01\0E35\0E48\0E22\0E27\0E01\0E31\0E1A\0E25\0E34\0E02\0E2A\0E34\0E17\0E18\0E34\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390331779402479)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E22\0E30\0E17\0E32\0E07\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384989661402475)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E39\0E21\0E40\0E02\0E49\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385042654402475)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E39\0E21\0E2D\0E2D\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512560097402574)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E19\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513496585402575)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E20\0E32\0E1E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513073821402574)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E2D\0E34\0E19\0E44\0E25\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526659978402585)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E23\0E01\0E23\0E39\0E1B\0E20\0E32\0E1E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526719549402585)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E23\0E01\0E25\0E34\0E07\0E04\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512667401402574)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E40\0E2D\0E35\0E22\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527339034402586)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E34\0E07\0E04\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513399332402575)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513242453402574)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E40\0E23\0E35\0E22\0E07\0E25\0E33\0E14\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512760160402574)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512894065402574)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E08\0E30\0E41\0E2A\0E14\0E07\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512983889402574)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E35\0E14\0E01\0E25\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513105543402574)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E23\0E35\0E22\0E07\0E25\0E33\0E14\0E31\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492094014402556)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115549504252402604)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115491903004402556)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E25\0E31\0E07\0E42\0E2B\0E25\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523740526402583)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E41\0E08\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497056461402560)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02\0E17\0E35\0E48\0E19\0E49\0E2D\0E22\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497123544402560)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497249917402561)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E44\0E21\0E48\0E15\0E23\0E07\0E01\0E31\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E15\0E31\0E27\0E40\0E25\0E02 %0 (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07: %1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496957657402560)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02\0E17\0E35\0E48\0E21\0E32\0E01\0E01\0E27\0E48\0E32\0E2B\0E23\0E37\0E2D\0E40\0E17\0E48\0E32\0E01\0E31\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496847103402560)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02\0E23\0E30\0E2B\0E27\0E48\0E32\0E07 %0 \0E16\0E36\0E07 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492147596402556)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14\0E43\0E19\0E27\0E34\0E19\0E42\0E14\0E27\0E4C\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445368452402520)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E01\0E32\0E23\0E2A\0E48\0E07\0E40\0E1E\0E08\0E19\0E35\0E49\0E41\0E25\0E49\0E27 \0E08\0E36\0E07\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E48\0E07\0E43\0E2B\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427946176402506)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 "%0" \0E40\0E1E\0E08 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461754498402533)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('#LABEL# \0E15\0E49\0E2D\0E07\0E21\0E35\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405071539402490)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511033204402573)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510955675402573)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511200130402573)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511169343402573)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397198542402484)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E2D\0E19\0E04\0E33\0E04\0E49\0E19\0E2B\0E32\0E17\0E35\0E48\0E22\0E32\0E27\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22 %0 \0E2D\0E31\0E01\0E02\0E23\0E30')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466636169402536)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E1B\0E47\0E2D\0E1B\0E2D\0E31\0E1B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397237266402484)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E2D\0E19\0E04\0E33\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397048744402484)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396989707402484)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484857116402550)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510811492402572)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521596698402581)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E25\0E31\0E07\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395507613402483)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E43\0E19\0E2B\0E19\0E49\0E32\0E08\0E2D\0E42\0E2E\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391539708402480)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E2D\0E38\0E1B\0E01\0E23\0E13\0E4C\0E2B\0E23\0E37\0E2D\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E02\0E2D\0E07\0E04\0E38\0E13\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07 Progressive Web Apps \0E43\0E19\0E02\0E13\0E30\0E19\0E35\0E49</p>'),
unistr('    <p class="a-pwaDialog-intro">\0E2B\0E32\0E01\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E44\0E14\0E49\0E15\0E34\0E14\0E15\0E31\0E49\0E07\0E43\0E19\0E2D\0E38\0E1B\0E01\0E23\0E13\0E4C\0E02\0E2D\0E07\0E04\0E38\0E13\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27 \0E43\0E2B\0E49\0E40\0E1B\0E34\0E14\0E08\0E32\0E01\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391100078402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B \0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01\0E40\0E1E\0E37\0E48\0E2D\0E43\0E0A\0E49\0E07\0E32\0E19\0E41\0E1A\0E1A\0E40\0E15\0E47\0E21\0E2B\0E19\0E49\0E32\0E08\0E2D</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E40\0E21\0E19\0E39</strong> \0E43\0E19\0E01\0E32\0E23\0E19\0E33\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0E41\0E15\0E30 <strong>\0E15\0E34\0E14\0E15\0E31\0E49\0E07</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0E41\0E15\0E30 <strong>\0E40\0E1E\0E34\0E48\0E21</strong> \0E40\0E1E\0E37\0E48\0E2D\0E22\0E37\0E19\0E22\0E31\0E19</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391287553402480)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14\0E43\0E19 Chrome \0E2B\0E23\0E37\0E2D Edge</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E40\0E21\0E19\0E39</strong> \0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E16\0E31\0E14\0E08\0E32\0E01\0E41\0E16\0E1A\0E17\0E35\0E48\0E2D\0E22\0E39\0E48</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0E41\0E15\0E30 <strong>\0E15\0E34\0E14\0E15\0E31\0E49\0E07</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390813791402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14\0E43\0E19 Safari</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E41\0E0A\0E23\0E4C</strong> \0E43\0E19\0E01\0E32\0E23\0E19\0E33\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0E41\0E15\0E30 <strong>\0E40\0E1B\0E34\0E14\0E43\0E19 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390526613402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B \0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E1A\0E1B\0E23\0E30\0E2A\0E1A\0E01\0E32\0E23\0E13\0E4C\0E17\0E35\0E48\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E41\0E0A\0E23\0E4C</strong> \0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E16\0E31\0E14\0E08\0E32\0E01\0E41\0E16\0E1A\0E17\0E35\0E48\0E2D\0E22\0E39\0E48</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0E41\0E15\0E30 <strong>\0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0E41\0E15\0E30 <strong style="color:#007AE1;">\0E40\0E1E\0E34\0E48\0E21</strong> \0E40\0E1E\0E37\0E48\0E2D\0E22\0E37\0E19\0E22\0E31\0E19</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390434548402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B \0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E1A\0E1B\0E23\0E30\0E2A\0E1A\0E01\0E32\0E23\0E13\0E4C\0E17\0E35\0E48\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E41\0E0A\0E23\0E4C</strong> \0E43\0E19\0E01\0E32\0E23\0E19\0E33\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0E40\0E25\0E37\0E48\0E2D\0E19\0E25\0E07\0E41\0E25\0E30\0E41\0E15\0E30 <strong>\0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0E41\0E15\0E30 <strong style="color:#007AE1;">\0E40\0E1E\0E34\0E48\0E21</strong> \0E40\0E1E\0E37\0E48\0E2D\0E22\0E37\0E19\0E22\0E31\0E19</p>'),
'    </div>',
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385498501402475)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B \0E40\0E1E\0E34\0E48\0E21\0E41\0E2D\0E1B\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E1A\0E1B\0E23\0E30\0E2A\0E1A\0E01\0E32\0E23\0E13\0E4C\0E17\0E35\0E48\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E40\0E1E\0E34\0E48\0E21</strong> \0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E16\0E31\0E14\0E08\0E32\0E01\0E41\0E16\0E1A\0E17\0E35\0E48\0E2D\0E22\0E39\0E48</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \0E41\0E15\0E30 <strong>\0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \0E41\0E15\0E30 <strong style="color:#007AE1;">\0E40\0E1E\0E34\0E48\0E21</strong> \0E40\0E1E\0E37\0E48\0E2D\0E22\0E37\0E19\0E22\0E31\0E19</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390789543402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B \0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E1A\0E1B\0E23\0E30\0E2A\0E1A\0E01\0E32\0E23\0E13\0E4C\0E17\0E35\0E48\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E41\0E0A\0E23\0E4C</strong> \0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E16\0E31\0E14\0E08\0E32\0E01\0E41\0E16\0E1A\0E17\0E35\0E48\0E2D\0E22\0E39\0E48</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0E41\0E15\0E30 <strong>\0E40\0E1B\0E34\0E14\0E43\0E19 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390623818402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B \0E40\0E1E\0E34\0E48\0E21\0E44\0E1B\0E22\0E31\0E07\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E1A\0E1B\0E23\0E30\0E2A\0E1A\0E01\0E32\0E23\0E13\0E4C\0E17\0E35\0E48\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0E41\0E15\0E30\0E44\0E2D\0E04\0E2D\0E19 <strong>\0E41\0E0A\0E23\0E4C</strong> \0E43\0E19\0E01\0E32\0E23\0E19\0E33\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\0E41\0E15\0E30 <strong>\0E40\0E1B\0E34\0E14\0E43\0E19 Safari</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391455912402480)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14\0E43\0E19 Chrome</p>'),
unistr('    <p class="a-pwaDialog-intro">\0E02\0E13\0E30\0E19\0E35\0E49 Firefox \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07\0E41\0E2D\0E1B\0E41\0E1A\0E1A\0E40\0E27\0E47\0E1A\0E43\0E19 Windows</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115390982485402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14\0E43\0E19 Chrome \0E2B\0E23\0E37\0E2D Edge</p>'),
unistr('    <p class="a-pwaDialog-intro">\0E02\0E13\0E30\0E19\0E35\0E49 Firefox \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07\0E41\0E2D\0E1B\0E41\0E1A\0E1A\0E40\0E27\0E47\0E1A\0E43\0E19 macOS</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391072997402479)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14\0E43\0E19 Chrome \0E2B\0E23\0E37\0E2D Edge</p>'),
unistr('    <p class="a-pwaDialog-intro">\0E02\0E13\0E30\0E19\0E35\0E49 Safari \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07\0E41\0E2D\0E1B\0E41\0E1A\0E1A\0E40\0E27\0E47\0E1A\0E43\0E19 macOS</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391369302402480)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0E40\0E27\0E47\0E1A\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E41\0E1A\0E1A\0E41\0E2D\0E1B\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E35\0E17\0E35\0E48\0E2A\0E38\0E14\0E43\0E19 Chrome \0E2B\0E23\0E37\0E2D Edge</p>'),
unistr('    <p class="a-pwaDialog-intro">\0E02\0E13\0E30\0E19\0E35\0E49 Firefox \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07\0E41\0E2D\0E1B\0E41\0E1A\0E1A\0E40\0E27\0E47\0E1A\0E43\0E19 Windows</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393808787402481)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\0E40\0E0A\0E37\0E48\0E2D\0E21\0E15\0E48\0E2D\0E44\0E21\0E48\0E44\0E14\0E49</h1>'),
unistr('    <p>\0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E21\0E35\0E01\0E32\0E23\0E40\0E0A\0E37\0E48\0E2D\0E21\0E15\0E48\0E2D\0E2D\0E34\0E19\0E40\0E15\0E2D\0E23\0E4C\0E40\0E19\0E47\0E15\0E40\0E1E\0E37\0E48\0E2D\0E43\0E0A\0E49\0E41\0E2D\0E1B\0E19\0E35\0E49</p>'),
unistr('    <button type="button">\0E25\0E2D\0E07\0E43\0E2B\0E21\0E48</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393730302402481)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0A\0E37\0E48\0E2D\0E21\0E15\0E48\0E2D\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533597803402591)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477938154402545)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E31\0E49\0E07\0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556858140402609)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E04\0E33\0E40\0E0A\0E34\0E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556686894402609)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479742848402546)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27\0E23\0E32\0E22\0E27\0E31\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E17\0E31\0E49\0E07\0E27\0E31\0E19 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479571273402546)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27\0E23\0E32\0E22\0E27\0E31\0E19\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E1E\0E23\0E49\0E2D\0E21\0E40\0E27\0E25\0E32 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524455214402584)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518876834402579)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409470528402493)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'th'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409288796402493)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'th'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409100583402493)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'th'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409392536402493)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'th'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408831593402492)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409082390402493)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E2D\0E35\0E40\0E27\0E19\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556750469402609)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E40\0E0A\0E34\0E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524523627402584)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E34\0E2A\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524211948402584)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527096310402586)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541306774402597)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E2D\0E35\0E40\0E27\0E19\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557056434402609)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E2D\0E35\0E40\0E27\0E19\0E15\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556920395402609)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E48\0E07\0E04\0E33\0E40\0E0A\0E34\0E0D\0E17\0E32\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527180806402586)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535151005402593)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534940509402592)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557730187402610)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E1B\0E49\0E2D\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E1F\0E34\0E25\0E14\0E4C\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557618754402610)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E04\0E33\0E40\0E0A\0E34\0E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556584392402609)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535085066402592)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E36\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408985358402492)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532817693402590)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E2D\0E23\0E4C\0E21\0E43\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479322008402546)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E27\0E25\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527282718402586)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525033219402584)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524366614402584)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479644838402546)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27\0E23\0E32\0E22\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E17\0E31\0E49\0E07\0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479485290402546)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E27\0E23\0E32\0E22\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E1E\0E23\0E49\0E2D\0E21\0E40\0E27\0E25\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524936586402584)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524698234402584)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524778884402584)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E2B\0E25\0E14\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456803329402529)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E2D\0E19\0E01\0E25\0E31\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403195681402488)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E2B\0E25\0E14\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405263254402490)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115524815656402584)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E2B\0E25\0E14\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526901472402586)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A ID \0E1E\0E37\0E49\0E19\0E17\0E35\0E48 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405177450402490)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429286860402507)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E2B\0E19\0E49\0E32\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397444459402484)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E2B\0E19\0E49\0E32\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518257993402578)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526837316402586)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E1B\0E23\0E30\0E40\0E20\0E17\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397393017402484)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 "#COMPONENT_NAME#"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461808970402533)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('#COLUMN_HEADER# \0E15\0E49\0E2D\0E07\0E21\0E35\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556113393402609)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('%0, \0E42\0E1B\0E23\0E41\0E01\0E23\0E21\0E41\0E01\0E49\0E44\0E02\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E17\0E35\0E48\0E21\0E35\0E23\0E39\0E1B\0E41\0E1A\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463930068402534)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E23\0E4C\0E04\0E2D\0E31\0E1B HTML \0E02\0E2D\0E07\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E17\0E35\0E48\0E21\0E35\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E40\0E01\0E34\0E19\0E04\0E27\0E32\0E21\0E22\0E32\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14\0E02\0E2D\0E07\0E23\0E32\0E22\0E01\0E32\0E23 (\0E15\0E32\0E21\0E08\0E23\0E34\0E07 %0, \0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49 %1 \0E2D\0E31\0E01\0E02\0E23\0E30)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523859089402583)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515639509402576)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E2A\0E33\0E40\0E19\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513959008402575)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513851311402575)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E27\0E21\0E04\0E48\0E32\0E19\0E31\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523968448402583)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477553837402545)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E25\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477698884402545)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E02\0E36\0E49\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513619926402575)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514206177402575)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E37\0E48\0E19\0E46')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513780459402575)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514083440402575)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514189350402575)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0 \0E08\0E32\0E01 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515713467402576)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E1F\0E23\0E0A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515806727402576)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E2D\0E19\0E01\0E25\0E31\0E1A\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115513548385402575)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E19\0E39\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474518912402542)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382053415402473)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E07\0E0A\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381963839402473)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E25\0E07\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382183310402473)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381760515402473)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E08\0E30\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E40\0E21\0E37\0E48\0E2D %0 \0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E02\0E22\0E32\0E22\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381824521402473)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E08\0E30\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E40\0E21\0E37\0E48\0E2D %0 \0E41\0E25\0E30\0E02\0E22\0E32\0E22\0E44\0E21\0E48\0E44\0E14\0E49 \0E42\0E1B\0E23\0E14\0E1A\0E31\0E19\0E17\0E36\0E01\0E07\0E32\0E19\0E40\0E1E\0E37\0E48\0E2D\0E44\0E21\0E48\0E43\0E2B\0E49\0E02\0E49\0E2D\0E21\0E39\0E25\0E2A\0E39\0E0D\0E2B\0E32\0E22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534757066402592)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E23\0E2B\0E31\0E2A\0E01\0E32\0E23\0E25\0E49\0E32\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E02\0E2D\0E07\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427862417402506)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E23\0E2B\0E31\0E2A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115401999008402487)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E25\0E07\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533627297402591)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E1B\0E34\0E14\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E19\0E35\0E49\0E41\0E25\0E30\0E01\0E14\0E1B\0E38\0E48\0E21\0E42\0E2B\0E25\0E14\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07\0E02\0E2D\0E07\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E23\0E31\0E1A\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552988386402606)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E25\0E34\0E01 <a href="%0">\0E17\0E35\0E48\0E19\0E35\0E48</a> \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439595805402515)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479028184402546)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E0A\0E49\0E07\0E32\0E19\0E1A\0E17\0E1A\0E32\0E17\0E41\0E1A\0E1A\0E44\0E14\0E19\0E32\0E21\0E34\0E04\0E43\0E19\0E40\0E0B\0E2A\0E0A\0E31\0E19 Real Application Security \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49 "%0"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425784901402505)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-99900 \0E2A\0E23\0E49\0E32\0E07 ID \0E40\0E0B\0E2A\0E0A\0E31\0E19\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33\0E01\0E31\0E19\0E44\0E21\0E48\0E44\0E14\0E49: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442006841402517)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E25\0E30\0E40\0E21\0E34\0E14\0E01\0E32\0E23\0E1B\0E49\0E2D\0E07\0E01\0E31\0E19\0E2A\0E16\0E32\0E19\0E30\0E40\0E0B\0E2A\0E0A\0E31\0E19: \0E01\0E23\0E13\0E35\0E19\0E35\0E49\0E2D\0E32\0E08\0E40\0E01\0E34\0E14\0E08\0E32\0E01\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08\0E17\0E35\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E1B\0E49\0E2D\0E07\0E01\0E31\0E19 %0 \0E14\0E49\0E27\0E22\0E15\0E19\0E40\0E2D\0E07 \0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E21\0E48\0E41\0E19\0E48\0E43\0E08\0E27\0E48\0E32\0E2A\0E32\0E40\0E2B\0E15\0E38\0E02\0E2D\0E07\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E19\0E35\0E49\0E04\0E37\0E2D\0E2D\0E30\0E44\0E23 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E02\0E2D\0E04\0E27\0E32\0E21\0E0A\0E48\0E27\0E22\0E40\0E2B\0E25\0E37\0E2D\0E08\0E32\0E01\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561164079402612)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E25\0E30\0E40\0E21\0E34\0E14\0E01\0E32\0E23\0E1B\0E49\0E2D\0E07\0E01\0E31\0E19\0E40\0E1E\0E08: \0E01\0E23\0E13\0E35\0E19\0E35\0E49\0E2D\0E32\0E08\0E40\0E01\0E34\0E14\0E08\0E32\0E01\0E01\0E32\0E23\0E2A\0E48\0E07\0E40\0E1E\0E08\0E17\0E35\0E48\0E22\0E31\0E07\0E42\0E2B\0E25\0E14\0E44\0E21\0E48\0E40\0E2A\0E23\0E47\0E08 \0E2B\0E23\0E37\0E2D\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08\0E17\0E35\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E1B\0E49\0E2D\0E07\0E01\0E31\0E19\0E14\0E49\0E27\0E22\0E15\0E19\0E40\0E2D\0E07 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E02\0E2D\0E04\0E27\0E32\0E21\0E0A\0E48\0E27\0E22\0E40\0E2B\0E25\0E37\0E2D\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21\0E08\0E32\0E01\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560133087402612)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E2D\0E22\0E48\0E32\0E07\0E43\0E14\0E2D\0E22\0E48\0E32\0E07\0E2B\0E19\0E36\0E48\0E07\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49 &<>"/;,*|=% \0E2B\0E23\0E37\0E2D --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560242035402612)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E2D\0E22\0E48\0E32\0E07\0E43\0E14\0E2D\0E22\0E48\0E32\0E07\0E2B\0E19\0E36\0E48\0E07\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49 &<>"/;,*|=% \0E2B\0E23\0E37\0E2D -- \0E2B\0E23\0E37\0E2D\0E1A\0E23\0E23\0E17\0E31\0E14\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559912068402612)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E1E\0E34\0E40\0E28\0E29 \0E43\0E0A\0E49\0E44\0E14\0E49\0E40\0E09\0E1E\0E32\0E30\0E2D\0E31\0E01\0E02\0E23\0E30 a-Z, 0-9 \0E41\0E25\0E30\0E0A\0E48\0E2D\0E07\0E27\0E48\0E32\0E07\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115560097164402612)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35 <, > \0E2B\0E23\0E37\0E2D " \0E0B\0E36\0E48\0E07\0E40\0E1B\0E47\0E19\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404107222402489)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38 Checksum \0E40\0E1E\0E37\0E48\0E2D\0E41\0E2A\0E14\0E07\0E01\0E32\0E23\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E40\0E1E\0E08\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E21\0E35 Checksum \0E40\0E21\0E37\0E48\0E2D\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38\0E04\0E48\0E32\0E04\0E33\0E02\0E2D \0E01\0E32\0E23\0E25\0E49\0E32\0E07\0E41\0E04\0E0A \0E2B\0E23\0E37\0E2D\0E2D\0E32\0E23\0E4C\0E01\0E34\0E27\0E40\0E21\0E19\0E15\0E4C\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E04\0E48\0E32\0E40\0E1B\0E47\0E19\0E1E\0E32\0E23\0E32\0E21\0E34\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436968258402513)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E25\0E30\0E40\0E21\0E34\0E14\0E01\0E32\0E23\0E1B\0E49\0E2D\0E07\0E01\0E31\0E19\0E2A\0E16\0E32\0E19\0E30\0E40\0E0B\0E2A\0E0A\0E31\0E19: \0E01\0E23\0E13\0E35\0E19\0E35\0E49\0E2D\0E32\0E08\0E40\0E01\0E34\0E14\0E08\0E32\0E01\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02 URL \0E17\0E35\0E48\0E21\0E35 Checksum \0E14\0E49\0E27\0E22\0E15\0E19\0E40\0E2D\0E07\0E2B\0E23\0E37\0E2D\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E43\0E0A\0E49\0E25\0E34\0E07\0E04\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E21\0E35 Checksum \0E2B\0E23\0E37\0E2D\0E21\0E35\0E41\0E15\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E21\0E48\0E41\0E19\0E48\0E43\0E08\0E27\0E48\0E32\0E2A\0E32\0E40\0E2B\0E15\0E38\0E02\0E2D\0E07\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E19\0E35\0E49\0E04\0E37\0E2D\0E2D\0E30\0E44\0E23 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E02\0E2D\0E04\0E27\0E32\0E21\0E0A\0E48\0E27\0E22\0E40\0E2B\0E25\0E37\0E2D\0E08\0E32\0E01\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115514996598402576)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14\0E42\0E2B\0E21\0E14\0E04\0E27\0E32\0E21\0E40\0E1B\0E23\0E35\0E22\0E1A\0E15\0E48\0E32\0E07\0E2A\0E39\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515049118402576)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14\0E42\0E2B\0E21\0E14\0E04\0E27\0E32\0E21\0E40\0E1B\0E23\0E35\0E22\0E1A\0E15\0E48\0E32\0E07\0E2A\0E39\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433638191402511)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E48\0E32\0E07\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433864479402511)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433999991402511)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434076174402511)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434163926402511)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E2D\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434288887402511)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E2D\0E2D\0E01\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434303029402511)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433596809402510)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E19\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433774753402511)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E36\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542638057402598)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'th'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543346124402599)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E27\0E31\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542569677402598)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'th'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543476962402599)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542380762402598)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'th'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543500709402599)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E19\0E32\0E17\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542925191402599)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E14\0E37\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543135615402599)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E40\0E14\0E37\0E2D\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542447164402598)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'th'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543214438402599)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E27\0E34\0E19\0E32\0E17\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542790478402599)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'th'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543615931402599)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542857856402599)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'th'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115543029010402599)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19 %0 \0E1B\0E35')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382911937402473)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E40\0E2A\0E49\0E19]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383322645402474)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E2B\0E25\0E32\0E22\0E40\0E2A\0E49\0E19]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383135892402474)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E2B\0E25\0E32\0E22\0E08\0E38\0E14]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383559954402474)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E23\0E39\0E1B\0E2B\0E25\0E32\0E22\0E40\0E2B\0E25\0E35\0E48\0E22\0E21\0E2B\0E25\0E32\0E22\0E23\0E39\0E1B]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383604529402474)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E2D\0E2D\0E1A\0E40\0E08\0E01\0E15\0E4C\0E40\0E23\0E02\0E32\0E04\0E13\0E34\0E15]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382817937402473)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E08\0E38\0E14 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383061664402473)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'th'
,p_message_text=>unistr('[\0E23\0E39\0E1B\0E2B\0E25\0E32\0E22\0E40\0E2B\0E25\0E35\0E48\0E22\0E21]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460229667402531)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E38\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460198088402531)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E35\0E22\0E01\0E04\0E37\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506631158402568)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07\0E01\0E32\0E23\0E43\0E2B\0E49\0E04\0E30\0E41\0E19\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496549329402560)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E0A\0E48\0E27\0E07\0E01\0E32\0E23\0E43\0E2B\0E49\0E04\0E30\0E41\0E19\0E19\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E08\0E32\0E01 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496649336402560)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E43\0E0A\0E48\0E15\0E31\0E27\0E40\0E25\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492776412402556)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E41\0E2A\0E14\0E07\0E27\0E48\0E32\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E2A\0E33\0E40\0E23\0E47\0E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555866271402609)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555726287402609)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541444917402598)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E1A\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E21\0E37\0E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556286724402609)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22/\0E22\0E38\0E1A\0E01\0E32\0E23\0E19\0E32\0E27\0E34\0E40\0E01\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556312247402609)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22/\0E22\0E38\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E14\0E49\0E32\0E19\0E02\0E49\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465936260402536)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E19\0E32\0E27\0E34\0E40\0E01\0E15\0E2B\0E25\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472936887402541)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'th'
,p_message_text=>unistr('1 \0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472769921402541)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('1 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473093383402541)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472824213402541)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472639104402541)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473256437402541)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115473116006402541)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('1 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559418533402611)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E19\0E2B\0E19\0E49\0E32')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421410103402502)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395226696402482)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E04\0E33\0E02\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474641490402543)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557549792402610)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E23\0E2D\0E08\0E19\0E2B\0E19\0E49\0E32\0E42\0E2B\0E25\0E14\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19\0E41\0E25\0E30\0E25\0E2D\0E07\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517747958402578)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E19\0E49\0E32\0E19\0E35\0E49\0E21\0E35\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E17\0E35\0E48\0E22\0E31\0E07\0E44\0E21\0E48\0E44\0E14\0E49\0E1A\0E31\0E19\0E17\0E36\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398626112402485)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E27\0E34\0E23\0E4C\0E01\0E1A\0E38\0E04\0E44\0E21\0E48\0E21\0E35\0E40\0E27\0E34\0E23\0E4C\0E01\0E0A\0E35\0E17\0E17\0E35\0E48\0E43\0E0A\0E49\0E07\0E32\0E19\0E2D\0E22\0E39\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398526980402485)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E40\0E27\0E34\0E23\0E4C\0E01\0E1A\0E38\0E04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398496846402485)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E20\0E32\0E22\0E43\0E19\0E02\0E13\0E30\0E2A\0E23\0E49\0E32\0E07\0E44\0E1F\0E25\0E4C XLSX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400959235402487)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E35\0E17')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532615091402590)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450104447402524)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E19\0E39\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445897762402521)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445768559402521)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479913670402547)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480038388402547)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E34\0E48\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420279787402501)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456352666402529)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437446273402513)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E40\0E09\0E25\0E35\0E48\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441768972402516)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437587156402513)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E39\0E07\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437760771402514)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E01\0E25\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437672778402513)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E48\0E33\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437379245402513)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E25\0E23\0E27\0E21 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438400766402514)
,p_name=>'APEXIR_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419572508402500)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402040819402487)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E38\0E01\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529682871402588)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E33\0E23\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531208523402589)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2A\0E33\0E23\0E2D\0E07:  %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432165511402509)
,p_name=>'APEXIR_AND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E25\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421680534402502)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415340710402497)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434937121402511)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E37\0E48\0E2D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531838775402590)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E40\0E09\0E25\0E35\0E48\0E22 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523252057402583)
,p_name=>'APEXIR_BAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E48\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421033914402501)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E2B\0E27\0E48\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414151132402496)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E35\0E1E\0E37\0E49\0E19\0E2B\0E25\0E31\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416026395402497)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E49\0E33\0E40\0E07\0E34\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447709182402522)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E48\0E32\0E07\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416613343402498)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E01\0E40\0E25\0E34\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422506226402502)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E19\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414021865402496)
,p_name=>'APEXIR_CELL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E25\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438306285402514)
,p_name=>'APEXIR_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448623556402523)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E25\0E31\0E07\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115484901828402550)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497388729402561)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E2A\0E39\0E07\0E2A\0E38\0E14\0E02\0E2D\0E07\0E08\0E38\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48 %0 \0E15\0E48\0E2D\0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496214056402559)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E08\0E30\0E08\0E33\0E01\0E31\0E14\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19 \0E44\0E21\0E48\0E43\0E0A\0E48\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07  '),
unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14 %0 \0E41\0E16\0E27 \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419658395402500)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115492969019402556)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435358345402512)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442783386402517)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416544513402498)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453941424402527)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526235788402585)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444736400402520)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E19\0E39\0E02\0E2D\0E07\0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448475435402523)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528529084402587)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446180492402521)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430208388402508)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431128865402509)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415000272402497)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431307463402509)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E25\0E48\0E32\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439880409402515)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431292246402509)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E22\0E39\0E48\0E43\0E19\0E25\0E48\0E32\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439762051402515)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E22\0E39\0E48\0E43\0E19\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414965287402497)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414862676402497)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E47\0E19\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414620160402496)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2B\0E21\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415111714402497)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414756070402497)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E40\0E2B\0E21\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430575115402508)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E23\0E07\0E01\0E31\0E1A\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E17\0E31\0E48\0E27\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435284992402512)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115495910521402559)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454202385402527)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E14\0E49\0E27\0E22\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454313289402527)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'th'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454439894402527)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'th'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454518757402527)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'th'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400449047402486)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'th'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439164841402515)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E19\0E27\0E13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446709533402522)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449778510402524)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534181058402591)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397500931402484)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E1A\0E04\0E48\0E32\0E40\0E09\0E1E\0E32\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532331806402590)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E1A\0E04\0E48\0E32\0E40\0E09\0E1E\0E32\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532230079402590)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504358005402567)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559028120402611)
,p_name=>'APEXIR_DATA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448560804402523)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E21\0E37\0E48\0E2D %0 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522023958402582)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420394828402501)
,p_name=>'APEXIR_DATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452470050402526)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529406905402588)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416735591402498)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420662095402501)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E25\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E2B\0E25\0E48\0E32\0E19\0E35\0E49\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515328222402576)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446453861402521)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415402565402497)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422619185402502)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444684599402520)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E16\0E27\0E40\0E14\0E35\0E22\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452993459402526)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E34\0E28\0E17\0E32\0E07 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453895229402527)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E34\0E01\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416258116402498)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E1C\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419429600402500)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452845278402526)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E43\0E19\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447630847402522)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439254325402515)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452709668402526)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E41\0E2A\0E14\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518749493402579)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E44\0E2E\0E44\0E25\0E15\0E4C\0E17\0E35\0E48\0E21\0E35\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E40\0E14\0E35\0E22\0E27\0E01\0E31\0E19\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534381539402592)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E33\0E2A\0E33\0E40\0E19\0E32\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07  \0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E0B\0E49\0E33\0E01\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534593368402592)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448789775402523)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455302391402528)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455703959402528)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510105562402572)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455612311402528)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E44\0E2E\0E44\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480203963402547)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529734678402588)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408447410402492)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530040191402588)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E33\0E40\0E19\0E32\0E25\0E31\0E1A\0E16\0E36\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530261811402588)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E19\0E37\0E49\0E2D\0E2B\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529968747402588)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E33\0E40\0E19\0E32\0E16\0E36\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530762051402589)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E16\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412102970402495)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32\0E2D\0E35\0E40\0E21\0E25\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503623613402566)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530305180402588)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E2A\0E34\0E48\0E07\0E17\0E35\0E48\0E41\0E19\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530127933402588)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504677739402567)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529855078402588)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E36\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413875361402496)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455551454402528)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E07\0E32\0E19/\0E40\0E25\0E34\0E01\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455068276402528)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454640520402527)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455453420402528)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419360494402500)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E27\0E21\0E04\0E48\0E32\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456064917402528)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22/\0E22\0E38\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453691971402527)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438788784402514)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449626510402524)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459987418402531)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556459573402609)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E22\0E32\0E27\0E40\0E01\0E34\0E19\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459891218402531)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456202786402529)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E04\0E49\0E19\0E2B\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439029084402514)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453418361402527)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E14\0E39\0E02\0E49\0E2D\0E21\0E39\0E25\0E15\0E32\0E21\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E43\0E19\0E08\0E38\0E14\0E40\0E27\0E25\0E32\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504095126402567)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E22\0E30\0E40\0E27\0E25\0E32\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505407322402568)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435100453402512)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E41\0E1B\0E25\0E07\0E04\0E48\0E32 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446341984402521)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454191626402527)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529332351402588)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 / \0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446017757402521)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438517100402514)
,p_name=>'APEXIR_GO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414389928402496)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E02\0E35\0E22\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115397687818402484)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530473097402588)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485099200402550)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496115486402559)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 \0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21 \0E08\0E30\0E08\0E33\0E01\0E31\0E14\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19 \0E44\0E21\0E48\0E43\0E0A\0E48\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07  \0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14 %0 \0E41\0E16\0E27 \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476748351402544)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534212050402591)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21\0E25\0E33\0E14\0E31\0E1A\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419771154402500)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E19\0E27\0E19\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451301421402525)
,p_name=>'APEXIR_HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443115530402517)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E08\0E30\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E1C\0E39\0E49\0E43\0E0A\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49 \0E1C\0E39\0E49\0E43\0E0A\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E31\0E1A\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C \0E44\0E2E\0E44\0E25\0E15\0E4C \0E41\0E25\0E30\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A \0E1C\0E39\0E49\0E43\0E0A\0E49\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E2B\0E22\0E38\0E14 \0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21 \0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21 \0E41\0E25\0E30\0E40\0E1E\0E34\0E48\0E21\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E40\0E2D\0E07\0E44\0E14\0E49 \0E1C\0E39\0E49\0E43\0E0A\0E49\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E15\0E31\0E49\0E07\0E01\0E32\0E23\0E2A')
||unistr('\0E21\0E31\0E04\0E23\0E23\0E31\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E1E\0E37\0E48\0E2D\0E43\0E2B\0E49\0E21\0E35\0E01\0E32\0E23\0E2A\0E48\0E07\0E40\0E27\0E2D\0E23\0E4C\0E0A\0E31\0E19 HTML \0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E1B\0E22\0E31\0E07\0E15\0E19\0E40\0E2D\0E07\0E15\0E32\0E21\0E23\0E30\0E22\0E30\0E40\0E27\0E25\0E32\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14 \0E1C\0E39\0E49\0E43\0E0A\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E23\0E49\0E32\0E07\0E2B\0E25\0E32\0E22\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E41\0E25\0E30\0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E1B\0E47\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D \0E44\0E27\0E49\0E14\0E39\0E41\0E1A\0E1A\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25\0E2B\0E23\0E37\0E2D\0E2A\0E32\0E18\0E32\0E23\0E13\0E30\0E44\0E14\0E49'),
'<p/>',
unistr('\0E2A\0E48\0E27\0E19\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49\0E08\0E30\0E2A\0E23\0E38\0E1B\0E27\0E34\0E18\0E35\0E01\0E32\0E23\0E17\0E35\0E48\0E04\0E38\0E13\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E44\0E14\0E49 \0E14\0E39\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E1E\0E34\0E48\0E21\0E40\0E15\0E34\0E21\0E17\0E35\0E48 "\0E01\0E32\0E23\0E43\0E0A\0E49\0E07\0E32\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A" \0E43\0E19 <i>\0E04\0E39\0E48\0E21\0E37\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E07\0E32\0E19 Oracle Application Express</i></a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450210205402524)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E19\0E39 ''\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23'' \0E08\0E30\0E1B\0E23\0E32\0E01\0E0F\0E02\0E36\0E49\0E19\0E17\0E35\0E48\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E02\0E2D\0E07\0E1B\0E38\0E48\0E21 ''\0E44\0E1B'' \0E43\0E19\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32 \0E43\0E0A\0E49\0E40\0E21\0E19\0E39\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443998766402519)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E04\0E37\0E2D\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E32\0E07\0E04\0E13\0E34\0E15\0E28\0E32\0E2A\0E15\0E23\0E4C\0E17\0E35\0E48\0E17\0E33\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E08\0E30\0E41\0E2A\0E14\0E07\0E02\0E36\0E49\0E19\0E2B\0E25\0E31\0E07\0E08\0E32\0E01\0E41\0E15\0E48\0E25\0E30\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21\0E41\0E25\0E30\0E17\0E35\0E48\0E08\0E38\0E14\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E23\0E32\0E22\0E07\0E32\0E19\0E20\0E32\0E22\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14 \0E42\0E14\0E22\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E21\0E35\0E14\0E31\0E07\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21</strong>\0E08\0E30\0E43\0E2B\0E49\0E04\0E38\0E13\0E40\0E25\0E37\0E2D\0E01\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21'),
unistr('\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E44\0E27\0E49\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19</strong>\0E04\0E37\0E2D\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E35\0E48\0E08\0E30\0E17\0E33 (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 SUM, MIN)</li>'),
unistr('<li><strong>\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</strong>\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E43\0E0A\0E49\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E32\0E07\0E04\0E13\0E34\0E15\0E28\0E32\0E2A\0E15\0E23\0E4C\0E14\0E49\0E27\0E22 \0E08\0E30\0E41\0E2A\0E14\0E07\0E40\0E09\0E1E\0E32\0E30'),
unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444056225402519)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E44\0E14\0E49\0E2B\0E19\0E36\0E48\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E15\0E48\0E2D\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E21\0E37\0E48\0E2D'),
unistr('\0E01\0E33\0E2B\0E19\0E14\0E41\0E25\0E49\0E27 \0E04\0E38\0E13\0E08\0E30\0E2A\0E25\0E31\0E1A\0E44\0E1B\0E21\0E32\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E27\0E34\0E27\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E41\0E25\0E30\0E27\0E34\0E27\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E44\0E2D\0E04\0E2D\0E19\0E27\0E34\0E27\0E43\0E19\0E41\0E16\0E1A\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32'),
unistr('\0E42\0E14\0E22\0E21\0E35\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>\0E1B\0E23\0E30\0E40\0E20\0E17\0E41\0E1C\0E19\0E20\0E39\0E21\0E34</strong>\0E23\0E30\0E1A\0E38\0E1B\0E23\0E30\0E40\0E20\0E17\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E17\0E35\0E48\0E08\0E30\0E23\0E27\0E21'),
unistr('\0E40\0E25\0E37\0E2D\0E01\0E08\0E32\0E01\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E41\0E17\0E48\0E07\0E41\0E19\0E27\0E19\0E2D\0E19 \0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E41\0E17\0E48\0E07\0E41\0E19\0E27\0E15\0E31\0E49\0E07 \0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E27\0E07\0E01\0E25\0E21 \0E2B\0E23\0E37\0E2D\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E40\0E2A\0E49\0E19</li>'),
unistr('<li><strong>\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A</strong> \0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E43\0E0A\0E49\0E40\0E1B\0E47\0E19\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A</li>'),
unistr('<li><strong>\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A</strong> \0E04\0E37\0E2D\0E0A\0E37\0E48\0E2D\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E1A\0E19\0E41\0E01\0E19\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E44\0E27\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A'),
unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A \0E0B\0E36\0E48\0E07\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E27\0E07\0E01\0E25\0E21</li>'),
unistr('<li><strong>\0E04\0E48\0E32</strong> \0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E43\0E0A\0E49\0E40\0E1B\0E47\0E19\0E04\0E48\0E32 \0E2B\0E32\0E01\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E02\0E2D\0E07\0E04\0E38\0E13'),
unistr('\0E40\0E1B\0E47\0E19 COUNT \0E44\0E21\0E48\0E08\0E33\0E40\0E1B\0E47\0E19\0E15\0E49\0E2D\0E07\0E40\0E25\0E37\0E2D\0E01\0E04\0E48\0E32</li>'),
unistr('<li><strong>\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E48\0E32</strong> \0E04\0E37\0E2D\0E0A\0E37\0E48\0E2D\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E1A\0E19\0E41\0E01\0E19\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E44\0E27\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A'),
unistr('\0E04\0E48\0E32 \0E0B\0E36\0E48\0E07\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E27\0E07\0E01\0E25\0E21</li>'),
unistr('<li><strong>\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19</strong> \0E04\0E37\0E2D\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E23\0E30\0E1A\0E38\0E43\0E2B\0E49\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E44\0E27\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E48\0E32\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07</strong> \0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E0A\0E38\0E14\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C\0E02\0E2D\0E07\0E04\0E38\0E13\0E44\0E14\0E49</li></ul>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443338684402518)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E15\0E23\0E07\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E14\0E46 \0E08\0E30\0E41\0E2A\0E14\0E07\0E40\0E21\0E19\0E39\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E42\0E14\0E22\0E21\0E35\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E04\0E37\0E2D:'),
'<p></p>',
'<ul>',
unistr('<li>\0E44\0E2D\0E04\0E2D\0E19<strong>\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01</strong>\0E08\0E30\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E19\0E41\0E1A\0E1A\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01</li>'),
unistr('<li>\0E44\0E2D\0E04\0E2D\0E19<strong>\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01</strong>\0E08\0E30\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E19\0E41\0E1A\0E1A\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22</li>'),
unistr('<li><strong>\0E0B\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</strong>\0E08\0E30\0E0B\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C  \0E1A\0E32\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E08\0E30\0E0B\0E48\0E2D\0E19\0E44\0E21\0E48\0E44\0E14\0E49  \0E2B\0E32\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E0B\0E48\0E2D\0E19\0E44\0E21\0E48\0E44\0E14\0E49 \0E01\0E47\0E08\0E30\0E44\0E21\0E48\0E21\0E35\0E44\0E2D\0E04\0E2D\0E19 \0E0B\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</li>'),
unistr('<li><strong>\0E41\0E22\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</strong>\0E08\0E30\0E2A\0E23\0E49\0E32\0E07\0E01\0E25\0E38\0E48\0E21\0E01\0E32\0E23\0E41\0E22\0E01\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C  \0E0B\0E36\0E48\0E07\0E08\0E30\0E14\0E36\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E2D\0E01\0E08\0E32\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E1B\0E47\0E19\0E40\0E23\0E23\0E04\0E2D\0E23\0E4C\0E14\0E2B\0E25\0E31\0E01</li>'),
unistr('<li><strong>\0E02\0E49\0E2D\0E21\0E39\0E25\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</strong>\0E08\0E30\0E41\0E2A\0E14\0E07\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E40\0E01\0E35\0E48\0E22\0E27\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E2B\0E32\0E01\0E21\0E35</li>'),
unistr('<li><strong>\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E02\0E49\0E2D\0E04\0E27\0E32\0E21</strong>\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E1B\0E49\0E2D\0E19\0E40\0E01\0E13\0E11\0E4C\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E41\0E1A\0E1A\0E04\0E33\0E19\0E36\0E07\0E16\0E36\0E07\0E15\0E31\0E27\0E1E\0E34\0E21\0E1E\0E4C'),
unistr('(\0E44\0E21\0E48\0E15\0E49\0E2D\0E07\0E43\0E0A\0E49\0E2A\0E31\0E0D\0E25\0E31\0E01\0E29\0E13\0E4C\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32) \0E01\0E32\0E23\0E1B\0E49\0E2D\0E19\0E04\0E48\0E32  \0E08\0E30\0E25\0E14\0E25\0E34\0E2A\0E15\0E4C\0E02\0E2D\0E07'),
unistr('\0E04\0E48\0E32\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E02\0E2D\0E07\0E40\0E21\0E19\0E39 \0E41\0E25\0E49\0E27\0E04\0E38\0E13\0E08\0E30\0E40\0E25\0E37\0E2D\0E01\0E04\0E48\0E32\0E08\0E32\0E01'),
unistr('\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E41\0E25\0E30\0E04\0E48\0E32\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E08\0E30\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E40\0E1B\0E47\0E19\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E14\0E49\0E27\0E22 ''='''),
unistr('(\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 <code>column = ''ABC''</code>) \0E2B\0E23\0E37\0E2D\0E04\0E38\0E13\0E08\0E30\0E04\0E25\0E34\0E01\0E44\0E2D\0E04\0E2D\0E19 Flashlight \0E41\0E25\0E30\0E1B\0E49\0E2D\0E19\0E04\0E48\0E32\0E17\0E35\0E48\0E08\0E30\0E2A\0E23\0E49\0E32\0E07\0E40\0E1B\0E47\0E19\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E14\0E49\0E27\0E22\0E42\0E21\0E14\0E34\0E1F\0E32\0E22\0E40\0E2D\0E2D\0E23\0E4C ''LIKE'''),
unistr(' (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 <code>column LIKE ''%ABC%''</code>)</li>'),
unistr('<li><b>\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33</b> \0E08\0E30\0E21\0E35\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33 500'),
unistr('\0E04\0E48\0E32\0E41\0E23\0E01\0E17\0E35\0E48\0E15\0E23\0E07\0E01\0E31\0E1A\0E40\0E01\0E13\0E11\0E4C\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E02\0E2D\0E07\0E04\0E38\0E13 \0E2B\0E32\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1B\0E47\0E19\0E27\0E31\0E19\0E17\0E35\0E48 \0E25\0E34\0E2A\0E15\0E4C\0E0A\0E48\0E27\0E07'),
unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E08\0E30\0E41\0E2A\0E14\0E07\0E02\0E36\0E49\0E19\0E21\0E32\0E41\0E17\0E19 I\0E2B\0E32\0E01\0E04\0E38\0E13\0E40\0E25\0E37\0E2D\0E01\0E04\0E48\0E32 \0E08\0E30\0E21\0E35\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C'),
unistr('\0E14\0E49\0E27\0E22 ''='' (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 <code>column = ''ABC''</code>)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443825848402519)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E40\0E1E\0E34\0E48\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E04\0E33\0E19\0E27\0E13\0E44\0E1B\0E22\0E31\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49 (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 <code>NBR_HOURS/24</code>) \0E2B\0E23\0E37\0E2D\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 Oracle'),
unistr('\0E41\0E1A\0E1A\0E21\0E32\0E15\0E23\0E10\0E32\0E19\0E17\0E35\0E48\0E43\0E0A\0E49\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27 \0E1A\0E32\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E08\0E30\0E41\0E2A\0E14\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E41\0E25\0E30\0E2D\0E37\0E48\0E19\0E46 (\0E40\0E0A\0E48\0E19 <code>TO_DATE)</code> \0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E0A\0E49\0E44\0E14\0E49\0E14\0E49\0E27\0E22) \0E42\0E14\0E22\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E21\0E35\0E14\0E31\0E07\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13</strong>\0E08\0E30\0E17\0E33\0E43\0E2B\0E49\0E04\0E38\0E13\0E40\0E25\0E37\0E2D\0E01\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E44\0E1B\0E41\0E25\0E49\0E27\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</strong>\0E04\0E37\0E2D\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E2B\0E21\0E48</li>'),
unistr('<li><strong>\0E01\0E32\0E23\0E41\0E1B\0E25\0E07\0E23\0E39\0E1B\0E41\0E1A\0E1A</strong> \0E04\0E37\0E2D\0E01\0E32\0E23\0E41\0E1B\0E25\0E07\0E23\0E39\0E1B\0E41\0E1A\0E1A Oracle \0E17\0E35\0E48\0E08\0E30\0E43\0E0A\0E49\0E01\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 S9999)</li>'),
unistr('<li><strong>\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13</strong>\0E04\0E37\0E2D\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E35\0E48\0E08\0E30\0E17\0E33 \0E20\0E32\0E22\0E43\0E19\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E08\0E30\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E14\0E49\0E27\0E22\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E17\0E35\0E48\0E41\0E2A\0E14\0E07</li>'),
'</ul>',
unistr('<p>\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E08\0E30\0E41\0E2A\0E14\0E07\0E14\0E49\0E27\0E22'),
unistr('\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07 \0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E0A\0E37\0E48\0E2D\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2B\0E23\0E37\0E2D\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E08\0E30\0E23\0E27\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C'),
unistr('\0E40\0E02\0E49\0E32\0E44\0E1B\0E43\0E19\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13 \0E16\0E31\0E14\0E08\0E32\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E04\0E37\0E2D\0E1B\0E38\0E48\0E21\0E01\0E14 \0E1B\0E38\0E48\0E21\0E01\0E14\0E19\0E35\0E49\0E08\0E30\0E17\0E33\0E2B\0E19\0E49\0E32\0E17\0E35\0E48\0E40\0E1B\0E47\0E19'),
unistr('\0E17\0E32\0E07\0E25\0E31\0E14\0E44\0E1B\0E22\0E31\0E07\0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E43\0E0A\0E49\0E1A\0E48\0E2D\0E22 \0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E2A\0E38\0E14\0E04\0E37\0E2D\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19</p>'),
unistr('<p>\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49\0E08\0E30\0E41\0E2A\0E14\0E07\0E43\0E2B\0E49\0E14\0E39\0E27\0E48\0E32\0E01\0E32\0E23\0E0A\0E14\0E40\0E0A\0E22\0E23\0E27\0E21\0E08\0E30\0E41\0E2A\0E14\0E07\0E2D\0E22\0E48\0E32\0E07\0E44\0E23:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\0E42\0E14\0E22 A \0E04\0E37\0E2D ORGANIZATION, B \0E04\0E37\0E2D SALARY \0E41\0E25\0E30 C \0E04\0E37\0E2D COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450380701402524)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E01\0E25\0E38\0E48\0E21\0E01\0E32\0E23\0E2B\0E22\0E38\0E14\0E43\0E19\0E2B\0E19\0E36\0E48\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2B\0E23\0E37\0E2D\0E2B\0E25\0E32\0E22\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E0B\0E36\0E48\0E07\0E08\0E30\0E14\0E36\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E2D\0E01\0E08\0E32\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E41\0E25\0E30\0E41\0E2A\0E14\0E07\0E40\0E1B\0E47\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E2B\0E25\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444557656402520)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E19\0E01\0E32\0E23\0E14\0E39\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E02\0E2D\0E07\0E41\0E16\0E27\0E40\0E14\0E35\0E22\0E27\0E17\0E35\0E25\0E30\0E41\0E16\0E27 \0E43\0E2B\0E49\0E04\0E25\0E34\0E01\0E44\0E2D\0E04\0E2D\0E19\0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E16\0E27\0E40\0E14\0E35\0E22\0E27\0E43\0E19\0E41\0E16\0E1A\0E17\0E35\0E48\0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E14\0E39 \0E2B\0E32\0E01\0E43\0E0A\0E49\0E44\0E14\0E49 \0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E16\0E27\0E40\0E14\0E35\0E22\0E27\0E08\0E30\0E40\0E1B\0E47\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E23\0E01\0E2A\0E38\0E14\0E40\0E2A\0E21\0E2D \0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E16\0E27\0E40\0E14\0E35\0E22\0E27\0E2D\0E32\0E08\0E40\0E1B\0E47\0E19\0E21\0E38\0E21\0E21\0E2D\0E07\0E21\0E32\0E15\0E23\0E10\0E32\0E19\0E2B\0E23\0E37\0E2D\0E40\0E1E\0E08\0E41\0E1A\0E1A\0E01\0E33\0E2B\0E19\0E14\0E40\0E2D\0E07\0E17\0E35\0E48\0E2D\0E32\0E08\0E2D\0E19\0E38\0E0D\0E32\0E15\0E43\0E2B\0E49\0E2D\0E31\0E1B\0E40\0E14\0E15\0E42\0E14\0E22\0E02\0E36\0E49\0E19\0E2D\0E22\0E39\0E48\0E01\0E31\0E1A\0E01\0E32\0E23\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444498353402520)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E43\0E0A\0E49\0E07\0E32\0E19\0E0A\0E38\0E14\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32\0E27\0E48\0E32\0E08\0E30\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14 \0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14'),
unistr('\0E08\0E30\0E41\0E15\0E01\0E15\0E48\0E32\0E07\0E01\0E31\0E19\0E44\0E1B\0E15\0E32\0E21\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07\0E02\0E2D\0E07\0E04\0E38\0E13\0E41\0E25\0E30\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E23\0E32\0E22\0E07\0E32\0E19 \0E41\0E15\0E48'),
unistr('\0E2D\0E32\0E08\0E23\0E27\0E21 CSV, HTML, \0E2D\0E35\0E40\0E21\0E25\0E4C, XLS, PDF \0E2B\0E23\0E37\0E2D RTF')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443562538402518)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E2B\0E32\0E08\0E38\0E14\0E21\0E38\0E48\0E07\0E40\0E19\0E49\0E19\0E43\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E1E\0E34\0E48\0E21\0E2B\0E23\0E37\0E2D\0E41\0E01\0E49\0E44\0E02\0E2A\0E48\0E27\0E19\0E02\0E2D\0E07\0E04\0E33\0E2A\0E31\0E48\0E07 <code>WHERE</code> \0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 \0E04\0E38\0E13\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E44\0E14\0E49\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2B\0E23\0E37\0E2D\0E15\0E32\0E21\0E41\0E16\0E27  '),
unistr('<p>\0E2B\0E32\0E01\0E04\0E38\0E13\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E43\0E2B\0E49\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C (\0E44\0E21\0E48\0E08\0E33\0E40\0E1B\0E47\0E19\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19'),
unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07) \0E40\0E25\0E37\0E2D\0E01\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C Oracle \0E21\0E32\0E15\0E23\0E10\0E32\0E19  (=, !=, not in, between) \0E41\0E25\0E30\0E1B\0E49\0E2D\0E19\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E40\0E1E\0E37\0E48\0E2D\0E40\0E1B\0E23\0E35\0E22\0E1A\0E40\0E17\0E35\0E22\0E1A \0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E08\0E30\0E15\0E23\0E07\0E15\0E32\0E21\0E15\0E31\0E27\0E1E\0E34\0E21\0E1E\0E4C\0E40\0E25\0E47\0E01\0E41\0E25\0E30\0E43\0E2B\0E0D\0E48 \0E43\0E0A\0E49 % \0E40\0E1B\0E47\0E19\0E2A\0E31\0E0D\0E25\0E31\0E01\0E29\0E13\0E4C\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 <code>STATE_NAME'),
'like A%)</code></p>',
unistr('<p>\0E2B\0E32\0E01\0E04\0E38\0E13\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E15\0E32\0E21\0E41\0E16\0E27 \0E04\0E38\0E13\0E08\0E30\0E2A\0E23\0E49\0E32\0E07\0E2A\0E48\0E27\0E19\0E02\0E2D\0E07\0E04\0E33\0E2A\0E31\0E48\0E07 <code>WHERE</code> \0E41\0E1A\0E1A\0E0B\0E31\0E1A\0E0B\0E49\0E2D\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22'),
unistr('\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E25\0E30\0E1F\0E31\0E07\0E1F\0E4C\0E0A\0E31\0E19\0E2B\0E23\0E37\0E2D\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C Oracle \0E43\0E14\0E46 (\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 <code>G = ''VA'' or G = ''CT''</code> \0E42\0E14\0E22'),
unistr('<code>G</code> \0E40\0E1B\0E47\0E19\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A <code>CUSTOMER_STATE</code>)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444183349402520)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E14\0E39\0E02\0E49\0E2D\0E21\0E39\0E25\0E15\0E32\0E21\0E17\0E35\0E48\0E21\0E35\0E2D\0E22\0E39\0E48\0E43\0E19\0E08\0E38\0E14\0E40\0E27\0E25\0E32\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32'),
unistr('\0E23\0E30\0E22\0E30\0E40\0E27\0E25\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E17\0E35\0E48\0E04\0E38\0E13\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04\0E44\0E14\0E49\0E04\0E37\0E2D 3 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07 (\0E2B\0E23\0E37\0E2D180'),
unistr('\0E19\0E32\0E17\0E35) \0E41\0E15\0E48\0E40\0E27\0E25\0E32\0E08\0E23\0E34\0E07\0E08\0E30\0E41\0E15\0E01\0E15\0E48\0E32\0E07\0E01\0E31\0E19\0E44\0E1B\0E15\0E32\0E21\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505362777402568)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E08\0E30\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E1C\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49'),
unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E08\0E30\0E21\0E35\0E40\0E21\0E19\0E39\0E22\0E48\0E2D\0E22\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49:</p>'),
unistr('<ul><li>\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07</li>'),
unistr('<li>\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21</li>'),
unistr('<li>\0E44\0E2E\0E44\0E25\0E15\0E4C</li>'),
unistr('<li>\0E04\0E33\0E19\0E27\0E13</li>'),
unistr('<li>\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21</li>'),
unistr('<li>\0E41\0E1C\0E19\0E20\0E39\0E21\0E34</li>'),
unistr('<li>\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21</li>'),
unistr('<li>\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503518189402566)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E21\0E38\0E21\0E21\0E2D\0E07\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21\0E2B\0E19\0E36\0E48\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E15\0E48\0E2D'),
unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E21\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E41\0E25\0E49\0E27 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E25\0E31\0E1A\0E44\0E1B\0E21\0E32\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E21\0E38\0E21\0E21\0E2D\0E07\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21'),
unistr('\0E41\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E44\0E2D\0E04\0E2D\0E19\0E21\0E38\0E21\0E21\0E2D\0E07\0E43\0E19\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32 \0E43\0E19\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E21\0E38\0E21\0E21\0E2D\0E07\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21'),
unistr('\0E43\0E2B\0E49\0E40\0E25\0E37\0E2D\0E01: '),
'<p></p><ul>',
unistr('<li>\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21</li>'),
unistr('<li>\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E1E\0E23\0E49\0E2D\0E21\0E01\0E31\0E1A\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E35\0E48\0E08\0E30\0E17\0E33 (\0E40\0E09\0E25\0E35\0E48\0E22 \0E23\0E27\0E21 \0E19\0E31\0E1A \0E2F\0E25\0E2F)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443759260402519)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E01\0E33\0E2B\0E19\0E14\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E44\0E14\0E49 \0E41\0E16\0E27\0E17\0E35\0E48\0E15\0E23\0E07\0E01\0E31\0E1A\0E40\0E01\0E13\0E11\0E4C\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E08\0E30\0E41\0E2A\0E14\0E07\0E40\0E1B\0E47\0E19\0E41\0E1A\0E1A\0E44\0E2E\0E44\0E25\0E15\0E4C\0E42\0E14\0E22\0E43\0E0A\0E49\0E04\0E38\0E13\0E25\0E31\0E01\0E29\0E13\0E30\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E01\0E31\0E1A\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C \0E42\0E14\0E22\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E21\0E35\0E14\0E31\0E07\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49:</p>'),
'<ul>',
unistr('<li><strong>\0E0A\0E37\0E48\0E2D</strong>\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E41\0E2A\0E14\0E07\0E2D\0E22\0E48\0E32\0E07\0E40\0E14\0E35\0E22\0E27</li>'),
unistr('<li><strong>\0E25\0E33\0E14\0E31\0E1A</strong>\0E08\0E30\0E23\0E30\0E1A\0E38\0E25\0E33\0E14\0E31\0E1A\0E17\0E35\0E48\0E01\0E0E\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E1B\0E23\0E30\0E40\0E21\0E34\0E19</li>'),
unistr('<li><strong>\0E43\0E0A\0E49\0E07\0E32\0E19</strong>\0E08\0E30\0E23\0E30\0E1A\0E38\0E27\0E48\0E32\0E01\0E0E\0E43\0E0A\0E49\0E07\0E32\0E19\0E2D\0E22\0E39\0E48\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48</li>'),
unistr('<li><strong>\0E1B\0E23\0E30\0E40\0E20\0E17\0E44\0E2E\0E44\0E25\0E15\0E4C</strong>\0E08\0E30\0E23\0E30\0E1A\0E38\0E27\0E48\0E32\0E41\0E16\0E27\0E2B\0E23\0E37\0E2D\0E40\0E0B\0E25\0E25\0E4C\0E08\0E30'),
unistr('\0E44\0E2E\0E44\0E25\0E15\0E4C\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48 \0E2B\0E32\0E01\0E40\0E25\0E37\0E2D\0E01\0E40\0E0B\0E25\0E25\0E4C \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E43\0E19'),
unistr('\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E44\0E2E\0E44\0E25\0E15\0E4C\0E08\0E30\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E44\0E2E\0E44\0E25\0E15\0E4C</li>'),
unistr('<li><strong>\0E2A\0E35\0E1E\0E37\0E49\0E19\0E2B\0E25\0E31\0E07</strong>\0E04\0E37\0E2D\0E2A\0E35\0E43\0E2B\0E21\0E48\0E02\0E2D\0E07\0E1E\0E37\0E49\0E19\0E2B\0E25\0E31\0E07\0E1A\0E23\0E34\0E40\0E27\0E13\0E17\0E35\0E48\0E44\0E2E\0E44\0E25\0E15\0E4C</li>'),
unistr('<li><strong>\0E2A\0E35\0E02\0E49\0E2D\0E04\0E27\0E32\0E21</strong>\0E04\0E37\0E2D\0E2A\0E35\0E43\0E2B\0E21\0E48\0E02\0E2D\0E07\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E43\0E19\0E1A\0E23\0E34\0E40\0E27\0E13\0E17\0E35\0E48\0E44\0E2E\0E44\0E25\0E15\0E4C</li>'),
unistr('<li><strong>\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E44\0E2E\0E44\0E25\0E15\0E4C</strong>  \0E08\0E30\0E01\0E33\0E2B\0E19\0E14\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E02\0E2D\0E07\0E04\0E38\0E13</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381383295402472)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E04\0E38\0E13\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E44\0E14\0E49\0E2B\0E19\0E36\0E48\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E15\0E48\0E2D\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E21\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E41\0E25\0E49\0E27 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E25\0E31\0E1A\0E44\0E1B\0E21\0E32\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E21\0E38\0E21\0E21\0E2D\0E07\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E41\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E44\0E2D\0E04\0E2D\0E19\0E21\0E38\0E21\0E21\0E2D\0E07\0E43\0E19\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32 \0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E21\0E38\0E21\0E21\0E2D\0E07\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07 \0E43\0E2B\0E49\0E40\0E25\0E37\0E2D\0E01: '),
'<p></p>',
'<ul>',
unistr('<li>\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07</li>'),
unistr('<li>\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E41\0E2A\0E14\0E07\0E40\0E1B\0E47\0E19\0E41\0E16\0E27</li>'),
unistr('<li>\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E1E\0E23\0E49\0E2D\0E21\0E01\0E31\0E1A\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E17\0E35\0E48\0E08\0E30\0E17\0E33 (\0E40\0E09\0E25\0E35\0E48\0E22 \0E23\0E27\0E21 \0E19\0E31\0E1A \0E2F\0E25\0E2F)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454878177402528)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E2B\0E32\0E01\0E04\0E38\0E13\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E08\0E30\0E41\0E2A\0E14\0E07'),
unistr('\0E02\0E36\0E49\0E19\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32\0E41\0E25\0E30\0E14\0E49\0E32\0E19\0E1A\0E19\0E23\0E32\0E22\0E07\0E32\0E19 \0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E19\0E35\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E22\0E48\0E2D\0E41\0E25\0E30\0E02\0E22\0E32\0E22\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E44\0E2D\0E04\0E2D\0E19\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E0B\0E49\0E32\0E22'),
'<p>',
unistr('\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E15\0E48\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19 \0E04\0E38\0E13\0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16:'),
'</p><ul>',
unistr('<li>\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E0A\0E37\0E48\0E2D</li>'),
unistr('<li>\0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E07\0E32\0E19/\0E43\0E0A\0E49\0E07\0E32\0E19\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E25\0E34\0E01\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E2B\0E23\0E37\0E2D\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E01\0E25\0E48\0E2D\0E07\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E43\0E0A\0E49\0E07\0E32\0E19/\0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E07\0E32\0E19 \0E43\0E0A\0E49\0E01\0E32\0E23\0E04\0E27\0E1A\0E04\0E38\0E21\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E1B\0E34\0E14\0E2B\0E23\0E37\0E2D\0E40\0E1B\0E34\0E14\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E0A\0E31\0E48\0E27\0E04\0E23\0E32\0E27</li>'),
unistr('<li>\0E25\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E44\0E2D\0E04\0E2D\0E19\0E25\0E1A</li>'),
'</ul>',
unistr('<p>\0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E14\0E49\0E2A\0E23\0E49\0E32\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21 \0E2B\0E23\0E37\0E2D\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07 \0E04\0E38\0E13\0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25\0E44\0E1B\0E21\0E32\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E2A\0E34\0E48\0E07\0E40\0E2B\0E25\0E48\0E32\0E19\0E35\0E49'),
unistr('\0E41\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E25\0E34\0E07\0E04\0E4C\0E21\0E38\0E21\0E21\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19 \0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E21\0E38\0E21\0E21\0E2D\0E07\0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21 \0E41\0E25\0E30\0E21\0E38\0E21\0E21\0E2D\0E07\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07'),
unistr('\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E2D\0E22\0E39\0E48\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32 \0E2B\0E32\0E01\0E04\0E38\0E13\0E01\0E33\0E25\0E31\0E07\0E14\0E39\0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21 \0E2B\0E23\0E37\0E2D\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07'),
unistr('\0E04\0E38\0E13\0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E0A\0E49\0E25\0E34\0E07\0E04\0E4C\0E41\0E01\0E49\0E44\0E02\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E14\0E49\0E14\0E49\0E27\0E22</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444389716402520)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E25\0E31\0E1A\0E40\0E1B\0E47\0E19\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C \0E25\0E1A\0E01\0E32\0E23\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E43\0E14\0E46 \0E17\0E35\0E48\0E04\0E38\0E13\0E44\0E14\0E49\0E17\0E33')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505688310402568)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E49\0E07\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E17\0E35\0E48\0E08\0E30\0E41\0E2A\0E14\0E07\0E15\0E48\0E2D\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444206818402520)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E40\0E1E\0E37\0E48\0E2D\0E43\0E0A\0E49\0E43\0E19\0E2D\0E19\0E32\0E04\0E15 \0E23\0E30\0E1A\0E38\0E0A\0E37\0E48\0E2D\0E41\0E25\0E30\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22\0E41\0E1A\0E1A\0E40\0E25\0E37\0E2D\0E01\0E44\0E14\0E49\0E41\0E25\0E30\0E43\0E2B\0E49\0E23\0E32\0E22\0E07\0E32\0E19\0E19\0E31\0E49\0E19\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E44\0E14\0E49\0E41\0E1A\0E1A\0E2A\0E32\0E18\0E32\0E23\0E13\0E30\0E44\0E14\0E49 (\0E42\0E14\0E22\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E17\0E35\0E48\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01\0E44\0E14\0E49) \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E44\0E14\0E49\0E2A\0E35\0E48\0E1B\0E23\0E30\0E40\0E20\0E17:</p>'),
'<ul>',
unistr('<li><strong>\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01</strong> (\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19) \0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01\0E04\0E37\0E2D\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E02\0E36\0E49\0E19\0E43\0E19\0E04\0E23\0E31\0E49\0E07\0E41\0E23\0E01 \0E23\0E32\0E22\0E07\0E32\0E19\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01\0E19\0E31\0E49\0E19\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D\0E2B\0E23\0E37\0E2D\0E25\0E1A\0E44\0E21\0E48\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E33\0E23\0E2D\0E07</strong> (\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19) \0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E2A\0E23\0E49\0E32\0E07\0E2B\0E25\0E32\0E22\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49 \0E21\0E35\0E40\0E09\0E1E\0E32\0E30\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D \0E2B\0E23\0E37\0E2D\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E33\0E23\0E2D\0E07\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E32\0E18\0E32\0E23\0E13\0E30</strong> (\0E1C\0E39\0E49\0E43\0E0A\0E49) \0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D \0E41\0E25\0E30\0E25\0E1A\0E44\0E14\0E49\0E42\0E14\0E22\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E2A\0E23\0E49\0E32\0E07 \0E1C\0E39\0E49\0E43\0E0A\0E49\0E2D\0E37\0E48\0E19\0E2A\0E32\0E21\0E32\0E23\0E16\0E14\0E39\0E41\0E25\0E30\0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E40\0E1B\0E47\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E2D\0E37\0E48\0E19\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25</strong> (\0E1C\0E39\0E49\0E43\0E0A\0E49) \0E21\0E35\0E40\0E09\0E1E\0E32\0E30\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E2A\0E23\0E49\0E32\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19\0E17\0E35\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E14\0E39 \0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D \0E2B\0E23\0E37\0E2D\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49</li>'),
'</ul>',
unistr('<p>\0E2B\0E32\0E01\0E04\0E38\0E13\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07 \0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E08\0E30\0E41\0E2A\0E14\0E07\0E02\0E36\0E49\0E19\0E43\0E19\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E0B\0E49\0E32\0E22\0E02\0E2D\0E07\0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E41\0E16\0E27 (\0E2B\0E32\0E01\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E43\0E0A\0E49\0E07\0E32\0E19\0E19\0E35\0E49\0E2D\0E22\0E39\0E48)</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443297466402517)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E49\0E32\0E19\0E1A\0E19\0E2A\0E38\0E14\0E02\0E2D\0E07\0E41\0E15\0E48\0E25\0E30\0E40\0E1E\0E08\0E23\0E32\0E22\0E07\0E32\0E19\0E04\0E37\0E2D\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E04\0E49\0E19\0E2B\0E32 \0E2A\0E48\0E27\0E19\0E19\0E35\0E49 (\0E2B\0E23\0E37\0E2D\0E17\0E35\0E48\0E40\0E23\0E35\0E22\0E01\0E27\0E48\0E32 \0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32) \0E08\0E30\0E21\0E35\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506297743402568)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('<li><strong>\0E40\0E21\0E19\0E39\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23</strong>\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49 \0E14\0E39\0E2A\0E48\0E27\0E19\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505784966402568)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'th'
,p_message_text=>unistr('<li><strong>\0E40\0E25\0E37\0E2D\0E01\0E44\0E2D\0E04\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C</strong>\0E08\0E30\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E23\0E30\0E1A\0E38\0E44\0E14\0E49\0E27\0E48\0E32\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E14\0E17\0E35\0E48\0E08\0E30\0E04\0E49\0E19\0E2B\0E32 (\0E2B\0E23\0E37\0E2D\0E17\0E31\0E49\0E07\0E2B\0E21\0E14)</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506036867402568)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'th'
,p_message_text=>unistr('<li><strong>\0E23\0E32\0E22\0E07\0E32\0E19</strong>\0E08\0E30\0E41\0E2A\0E14\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2A\0E33\0E23\0E2D\0E07\0E41\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25\0E2B\0E23\0E37\0E2D\0E2A\0E32\0E18\0E32\0E23\0E13\0E30\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505982937402568)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('<li><strong>\0E41\0E16\0E27</strong>\0E08\0E30\0E01\0E33\0E2B\0E19\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E15\0E48\0E2D\0E2B\0E19\0E49\0E32</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505887873402568)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E02\0E49\0E2D\0E04\0E27\0E32\0E21</strong>\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E1B\0E49\0E2D\0E19\0E40\0E01\0E13\0E11\0E4C\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E17\0E35\0E48\0E15\0E23\0E07\0E15\0E32\0E21\0E15\0E31\0E27\0E1E\0E34\0E21\0E1E\0E4C\0E40\0E25\0E47\0E01\0E41\0E25\0E30\0E43\0E2B\0E0D\0E48 (\0E2D\0E31\0E01\0E02\0E23\0E30\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E08\0E30\0E40\0E1B\0E47\0E19\0E41\0E1A\0E1A\0E42\0E14\0E22\0E19\0E31\0E22)</li>'),
unistr('<li><strong>\0E1B\0E38\0E48\0E21\0E44\0E1B</strong>\0E08\0E30\0E40\0E23\0E34\0E48\0E21\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32 \0E01\0E32\0E23\0E01\0E14\0E1B\0E38\0E48\0E21 Enter \0E08\0E30\0E40\0E23\0E34\0E48\0E21\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E40\0E0A\0E48\0E19\0E01\0E31\0E19\0E40\0E21\0E37\0E48\0E2D\0E40\0E04\0E2D\0E23\0E4C\0E40\0E0B\0E2D\0E23\0E4C\0E2D\0E22\0E39\0E48\0E43\0E19\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506192293402568)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('<li><strong>\0E44\0E2D\0E04\0E2D\0E19\0E21\0E38\0E21\0E21\0E2D\0E07</strong>\0E08\0E30\0E2A\0E25\0E31\0E1A\0E44\0E1B\0E21\0E32\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E21\0E38\0E21\0E21\0E2D\0E07\0E44\0E2D\0E04\0E2D\0E19, \0E23\0E32\0E22\0E07\0E32\0E19, \0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14, \0E41\0E1C\0E19\0E20\0E39\0E21\0E34, \0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21 \0E41\0E25\0E30\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E2B\0E32\0E01\0E21\0E35\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E44\0E27\0E49</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522189800402582)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'th'
,p_message_text=>unistr('<li><strong>\0E08\0E31\0E14\0E01\0E32\0E23</strong>\0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E04\0E38\0E13\0E08\0E31\0E14\0E01\0E32\0E23\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E41\0E16\0E27 \0E41\0E25\0E30\0E14\0E39\0E1B\0E23\0E30\0E27\0E31\0E15\0E34\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E2B\0E23\0E37\0E2D\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E14\0E49</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443414637402518)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E08\0E30\0E41\0E2A\0E14\0E07 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E0B\0E49\0E32\0E22\0E08\0E30\0E16\0E39\0E01\0E0B\0E48\0E2D\0E19 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E43\0E2B\0E21\0E48\0E14\0E49\0E27\0E22\0E25\0E39\0E01\0E28\0E23\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E2A\0E38\0E14 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E04\0E33\0E19\0E27\0E13\0E08\0E30\0E02\0E36\0E49\0E19\0E15\0E49\0E19\0E14\0E49\0E27\0E22 <strong>**</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443637600402518)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E08\0E30\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E41\0E25\0E30\0E01\0E33\0E2B\0E19\0E14\0E27\0E48\0E32'),
unistr('\0E08\0E30\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E41\0E1A\0E1A\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01\0E2B\0E23\0E37\0E2D\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22 \0E04\0E38\0E13\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E23\0E30\0E1A\0E38\0E44\0E14\0E49\0E27\0E48\0E32\0E08\0E30\0E08\0E31\0E14\0E01\0E32\0E23\0E01\0E31\0E1A'),
unistr('<code>NULLs</code> \0E2D\0E22\0E48\0E32\0E07\0E44\0E23 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E08\0E30\0E41\0E2A\0E14\0E07 <code>NULLs</code> \0E17\0E49\0E32\0E22\0E2A\0E38\0E14\0E2B\0E23\0E37\0E2D\0E41\0E23\0E01\0E2A\0E38\0E14 \0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E30\0E41\0E2A\0E14\0E07\0E2D\0E22\0E39\0E48\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E02\0E2D\0E07'),
unistr('\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E19\0E23\0E32\0E22\0E07\0E32\0E19</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503331587402566)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E37\0E48\0E2D\0E04\0E38\0E13\0E40\0E1E\0E34\0E48\0E21\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23 \0E04\0E38\0E13\0E08\0E30\0E23\0E30\0E1A\0E38\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C (\0E2B\0E23\0E37\0E2D\0E2B\0E25\0E32\0E22\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C\0E17\0E35\0E48\0E04\0E31\0E48\0E19\0E14\0E49\0E27\0E22\0E04\0E2D\0E21\0E21\0E32), \0E2B\0E31\0E27\0E40\0E23\0E37\0E48\0E2D\0E07\0E2D\0E35\0E40\0E21\0E25\0E4C, \0E04\0E27\0E32\0E21\0E16\0E35\0E48 \0E41\0E25\0E30\0E27\0E31\0E19\0E17\0E35\0E48\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E41\0E25\0E30\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14 \0E2D\0E35\0E40\0E21\0E25\0E4C\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C\0E08\0E30\0E23\0E27\0E21\0E16\0E36\0E07\0E40\0E27\0E2D\0E23\0E4C\0E0A\0E31\0E19 HTML \0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E21\0E35\0E02\0E49\0E2D\0E21\0E39\0E25\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E15\0E32\0E21\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E43\0E0A\0E49\0E40\0E21\0E37\0E48\0E2D\0E40\0E1E\0E34\0E48\0E21\0E01\0E32\0E23\0E2A\0E21\0E31\0E04')
||unistr('\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521981308402582)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E04\0E37\0E2D\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E41\0E01\0E49\0E44\0E02\0E44\0E14\0E49\0E17\0E35\0E48\0E1B\0E23\0E31\0E1A\0E41\0E01\0E49\0E44\0E14\0E49\0E2B\0E25\0E32\0E01\0E2B\0E25\0E32\0E22  \0E1C\0E39\0E49\0E43\0E0A\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C \0E44\0E2E\0E44\0E25\0E15\0E4C \0E41\0E25\0E30\0E08\0E31\0E14\0E25\0E33\0E14\0E31\0E1A \0E1C\0E39\0E49\0E43\0E0A\0E49\0E22\0E31\0E07\0E2A\0E32\0E21\0E32\0E23\0E16\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E2B\0E22\0E38\0E14 \0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21 \0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21 \0E41\0E25\0E30\0E40\0E1E\0E34\0E48\0E21\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E40\0E2D\0E07\0E44\0E14\0E49 \0E1C\0E39\0E49\0E43\0E0A\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E23\0E49\0E32\0E07')
||unistr('\0E2B\0E25\0E32\0E22\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E41\0E25\0E30\0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E1B\0E47\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D\0E44\0E27\0E49\0E14\0E39\0E41\0E1A\0E1A\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25\0E44\0E14\0E49'),
'<p/>',
unistr('\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E44\0E14\0E49\0E42\0E14\0E22\0E43\0E0A\0E49\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32 \0E40\0E21\0E19\0E39\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23 \0E40\0E21\0E19\0E39\0E08\0E31\0E14\0E01\0E32\0E23 \0E2B\0E23\0E37\0E2D\0E40\0E21\0E19\0E39\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533716454402591)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E21\0E19\0E39 ''\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23'' \0E08\0E30\0E1B\0E23\0E32\0E01\0E0F\0E02\0E36\0E49\0E19\0E17\0E35\0E48\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32\0E02\0E2D\0E07\0E1B\0E38\0E48\0E21 ''\0E44\0E1B'' \0E43\0E19\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32 \0E43\0E0A\0E49\0E40\0E21\0E19\0E39\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522473567402582)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E08\0E40\0E1E\0E34\0E48\0E21 / \0E41\0E01\0E49\0E44\0E02\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522594187402582)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E04\0E25\0E34\0E01\0E40\0E1E\0E34\0E48\0E21\0E41\0E16\0E27\0E40\0E1E\0E37\0E48\0E2D\0E40\0E1E\0E34\0E48\0E21\0E41\0E16\0E27\0E44\0E1B\0E22\0E31\0E07\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25 \0E04\0E25\0E34\0E01\0E44\0E2D\0E04\0E2D\0E19\0E41\0E01\0E49\0E44\0E02\0E41\0E16\0E27 (\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E23\0E01) \0E43\0E19\0E41\0E16\0E27\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E41\0E01\0E49\0E44\0E02\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14\0E02\0E2D\0E07\0E41\0E16\0E27 \0E2B\0E19\0E49\0E32\0E40\0E1E\0E34\0E48\0E21/\0E41\0E01\0E49\0E44\0E02\0E41\0E16\0E27\0E08\0E30\0E1B\0E23\0E32\0E01\0E0E\0E02\0E36\0E49\0E19\0E41\0E25\0E30\0E41\0E2A\0E14\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E02\0E2D\0E07\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25</p>'),
'',
unistr('<p>\0E02\0E13\0E30\0E41\0E01\0E49\0E44\0E02\0E41\0E16\0E27 \0E04\0E38\0E13\0E08\0E30\0E17\0E33\0E2A\0E34\0E48\0E07\0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49\0E44\0E14\0E49:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\0E25\0E1A</strong>\0E41\0E16\0E27</li>'),
unistr('<li><strong>\0E43\0E0A\0E49\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07</strong>\0E40\0E1E\0E37\0E48\0E2D\0E1A\0E31\0E19\0E17\0E36\0E01\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E17\0E35\0E48\0E17\0E33\0E01\0E31\0E1A\0E41\0E16\0E27</li>'),
unistr('<li>\0E20\0E32\0E22\0E43\0E19<strong>\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23</strong> \0E40\0E1E\0E34\0E48\0E21\0E41\0E16\0E27, \0E40\0E1E\0E34\0E48\0E21\0E44\0E1F\0E25\0E4C, \0E1A\0E31\0E19\0E17\0E36\0E01, \0E25\0E34\0E07\0E04\0E4C \0E2B\0E23\0E37\0E2D\0E41\0E17\0E47\0E01 \0E41\0E25\0E30\0E15\0E23\0E27\0E08\0E14\0E39\0E1B\0E23\0E30\0E27\0E31\0E15\0E34</li>'),
unistr('<li>\0E44\0E1B\0E22\0E31\0E07\0E41\0E16\0E27<strong>\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32\0E41\0E25\0E30\0E16\0E31\0E14\0E44\0E1B</strong></li>'),
unistr('<li>\0E20\0E32\0E22\0E43\0E19<strong>\0E08\0E31\0E14\0E01\0E32\0E23</strong> \0E01\0E33\0E2B\0E19\0E14\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C, \0E01\0E25\0E38\0E48\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C, \0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A \0E41\0E25\0E30\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32</li>'),
'</ul></p>',
'',
unistr('<p>\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E22\0E48\0E2D\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E02\0E2D\0E07\0E2B\0E19\0E49\0E32\0E08\0E30\0E41\0E2A\0E14\0E07\0E44\0E1F\0E25\0E4C, \0E1A\0E31\0E19\0E17\0E36\0E01, \0E25\0E34\0E07\0E04\0E4C \0E2B\0E23\0E37\0E2D\0E41\0E17\0E47\0E01\0E43\0E14\0E46 \0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E01\0E31\0E1A\0E41\0E16\0E27\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533867526402591)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E2A\0E23\0E49\0E32\0E07\0E01\0E25\0E38\0E48\0E21\0E01\0E32\0E23\0E2B\0E22\0E38\0E14\0E43\0E19\0E2B\0E19\0E36\0E48\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2B\0E23\0E37\0E2D\0E2B\0E25\0E32\0E22\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C \0E0B\0E36\0E48\0E07\0E08\0E30\0E14\0E36\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2D\0E2D\0E01\0E08\0E32\0E01\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E25\0E30\0E41\0E2A\0E14\0E07\0E40\0E1B\0E47\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E2B\0E25\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522314782402582)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E43\0E0A\0E49\0E07\0E32\0E19\0E0A\0E38\0E14\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32\0E27\0E48\0E32\0E08\0E30\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14 \0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14'),
unistr('\0E23\0E27\0E21\0E16\0E36\0E07 CSV, HTML \0E2B\0E23\0E37\0E2D\0E2D\0E35\0E40\0E21\0E25\0E4C')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533977342402591)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E2B\0E32\0E01\0E04\0E38\0E13\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E08\0E30\0E41\0E2A\0E14\0E07'),
unistr('\0E02\0E36\0E49\0E19\0E17\0E35\0E48\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32\0E41\0E25\0E30\0E14\0E49\0E32\0E19\0E1A\0E19\0E23\0E32\0E22\0E07\0E32\0E19 \0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E19\0E35\0E49\0E2A\0E32\0E21\0E32\0E23\0E16\0E22\0E48\0E2D\0E41\0E25\0E30\0E02\0E22\0E32\0E22\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E44\0E2D\0E04\0E2D\0E19\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E0B\0E49\0E32\0E22'),
'<p>',
unistr('\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E15\0E48\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19 \0E04\0E38\0E13\0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16:'),
'</p><ul>',
unistr('<li>\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E0A\0E37\0E48\0E2D</li>'),
unistr('<li>\0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E07\0E32\0E19/\0E43\0E0A\0E49\0E07\0E32\0E19\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E25\0E34\0E01\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E2B\0E23\0E37\0E2D\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E01\0E25\0E48\0E2D\0E07\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E43\0E0A\0E49\0E07\0E32\0E19/\0E40\0E25\0E34\0E01\0E43\0E0A\0E49\0E07\0E32\0E19 \0E43\0E0A\0E49\0E01\0E32\0E23\0E04\0E27\0E1A\0E04\0E38\0E21\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E1B\0E34\0E14\0E2B\0E23\0E37\0E2D\0E40\0E1B\0E34\0E14\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E0A\0E31\0E48\0E27\0E04\0E23\0E32\0E27</li>'),
unistr('<li>\0E25\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E04\0E25\0E34\0E01\0E44\0E2D\0E04\0E2D\0E19\0E25\0E1A</li>'),
'</ul>',
unistr('<p>\0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E14\0E49\0E2A\0E23\0E49\0E32\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E2B\0E23\0E37\0E2D\0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21 \0E04\0E38\0E13\0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25\0E44\0E1B\0E21\0E32\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E2A\0E34\0E48\0E07\0E40\0E2B\0E25\0E48\0E32\0E19\0E35\0E49'),
unistr('\0E41\0E25\0E30\0E23\0E32\0E22\0E07\0E32\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19\0E44\0E14\0E49\0E14\0E49\0E27\0E22\0E25\0E34\0E07\0E04\0E4C\0E21\0E38\0E21\0E21\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19 \0E21\0E38\0E21\0E21\0E2D\0E07\0E41\0E1C\0E19\0E20\0E39\0E21\0E34 \0E41\0E25\0E30\0E21\0E38\0E21\0E21\0E2D\0E07\0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21'),
unistr('\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E2D\0E22\0E39\0E48\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E02\0E27\0E32 \0E2B\0E32\0E01\0E04\0E38\0E13\0E01\0E33\0E25\0E31\0E07\0E14\0E39\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E2B\0E23\0E37\0E2D\0E01\0E32\0E23\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21'),
unistr('\0E04\0E38\0E13\0E08\0E30\0E2A\0E32\0E21\0E32\0E23\0E16\0E43\0E0A\0E49\0E25\0E34\0E07\0E04\0E4C\0E41\0E01\0E49\0E44\0E02\0E40\0E1E\0E37\0E48\0E2D\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E44\0E14\0E49\0E14\0E49\0E27\0E22</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522273427402582)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E40\0E1E\0E37\0E48\0E2D\0E43\0E0A\0E49\0E43\0E19\0E2D\0E19\0E32\0E04\0E15 \0E23\0E30\0E1A\0E38\0E0A\0E37\0E48\0E2D\0E41\0E25\0E30\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22\0E41\0E1A\0E1A\0E40\0E25\0E37\0E2D\0E01\0E44\0E14\0E49 \0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E1A\0E31\0E19\0E17\0E36\0E01\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E23\0E34\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E14\0E49\0E2A\0E32\0E21\0E1B\0E23\0E30\0E40\0E20\0E17:</p>'),
'<ul>',
unistr('<li><strong>\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01</strong> (\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19) \0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01\0E04\0E37\0E2D\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E17\0E35\0E48\0E41\0E2A\0E14\0E07\0E02\0E36\0E49\0E19\0E43\0E19\0E04\0E23\0E31\0E49\0E07\0E41\0E23\0E01 \0E23\0E32\0E22\0E07\0E32\0E19\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01\0E19\0E31\0E49\0E19\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D\0E2B\0E23\0E37\0E2D\0E25\0E1A\0E44\0E21\0E48\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E33\0E23\0E2D\0E07</strong> (\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19) \0E0A\0E48\0E27\0E22\0E43\0E2B\0E49\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E2A\0E23\0E49\0E32\0E07\0E2B\0E25\0E32\0E22\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49 \0E21\0E35\0E40\0E09\0E1E\0E32\0E30\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D \0E2B\0E23\0E37\0E2D\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E33\0E23\0E2D\0E07\0E44\0E14\0E49</li>'),
unistr('<li><strong>\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25</strong> (\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E31\0E49\0E07\0E2B\0E21\0E14) \0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E2A\0E23\0E49\0E32\0E07\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E2A\0E32\0E21\0E32\0E23\0E16\0E14\0E39 \0E1A\0E31\0E19\0E17\0E36\0E01 \0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D \0E2B\0E23\0E37\0E2D\0E25\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E14\0E49</li>'),
'</ul>',
unistr('<p>\0E2B\0E32\0E01\0E04\0E38\0E13\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07 \0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E23\0E32\0E22\0E07\0E32\0E19\0E08\0E30\0E41\0E2A\0E14\0E07\0E02\0E36\0E49\0E19\0E43\0E19\0E41\0E16\0E1A\0E04\0E49\0E19\0E2B\0E32\0E17\0E32\0E07\0E14\0E49\0E32\0E19\0E0B\0E49\0E32\0E22\0E02\0E2D\0E07\0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E41\0E16\0E27 (\0E2B\0E32\0E01\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E43\0E0A\0E49\0E07\0E32\0E19\0E19\0E35\0E49\0E2D\0E22\0E39\0E48)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448337428402523)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E48\0E2D\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438997827402514)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E2E\0E44\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449882769402524)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E2E\0E44\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454903519402528)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E44\0E2E\0E44\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503972980402566)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E44\0E15\0E25\0E4C\0E44\0E2E\0E44\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413911030402496)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E44\0E2E\0E44\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523465912402583)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E19\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553082379402606)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'th'
,p_message_text=>unistr('1 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553184324402607)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444942688402520)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455980462402528)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449338570402523)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408778430402492)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E15\0E49\0E2D\0E07\0E2D\0E22\0E39\0E48\0E2B\0E25\0E31\0E07\0E27\0E31\0E19\0E17\0E35\0E48\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463629935402534)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E40\0E1E\0E23\0E2A\0E0A\0E31\0E19\0E02\0E2D\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531468915402589)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553279841402607)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'th'
,p_message_text=>unistr('1 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553366393402607)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504162962402567)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('(\0E40\0E1B\0E47\0E19\0E19\0E32\0E17\0E35)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521115160402581)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521317560402581)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521223482402581)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521456955402581)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E43\0E19 %1 \0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454065762402527)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E38\0E48\0E21\0E01\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420106146402501)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447987707402522)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440412119402515)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440623558402516)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440193508402515)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440233171402515)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440338749402515)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440551314402515)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439955607402515)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440019048402515)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420097695402501)
,p_name=>'APEXIR_LINE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2A\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416852927402498)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2A\0E49\0E19\0E17\0E35\0E48\0E21\0E35\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531398911402589)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E21\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448827316402523)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E32\0E14\0E27\0E48\0E32\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E08\0E30\0E40\0E01\0E34\0E14\0E17\0E23\0E31\0E1E\0E22\0E32\0E01\0E23\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E2A\0E39\0E07\0E2A\0E38\0E14  \0E42\0E1B\0E23\0E14\0E41\0E01\0E49\0E44\0E02\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E41\0E25\0E30\0E25\0E2D\0E07\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431090308402509)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E19\0E35\0E49\0E04\0E37\0E2D %0 \0E41\0E16\0E27  \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531992224402590)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E39\0E07\0E2A\0E38\0E14 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532134249402590)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E01\0E25\0E32\0E07 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435020946402512)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532049614402590)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E48\0E33\0E2A\0E38\0E14 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531069662402589)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504589733402567)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447142044402522)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447047256402522)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558285794402610)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38 ID \0E2A\0E41\0E15\0E15\0E34\0E01\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 \0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E40\0E1E\0E08\0E21\0E35\0E2B\0E25\0E32\0E22\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415548450402497)
,p_name=>'APEXIR_NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442993534402517)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553996747402607)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E19\0E34\0E14\0E43\0E2B\0E21\0E48')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115443099577402517)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437836400402514)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440976016402516)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440713139402516)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441204906402516)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441127753402516)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441063342402516)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115440853313402516)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441413368402516)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441386031402516)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415811295402497)
,p_name=>'APEXIR_NO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456113570402528)
,p_name=>'APEXIR_NONE'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E44\0E21\0E48\0E21\0E35 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503779038402566)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E43\0E0A\0E48\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452609929402526)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E25\0E2D\0E22\0E39\0E48\0E2B\0E19\0E49\0E32\0E2A\0E38\0E14\0E40\0E2A\0E21\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452599772402526)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E31\0E25\0E2D\0E22\0E39\0E48\0E2B\0E25\0E31\0E07\0E2A\0E38\0E14\0E40\0E2A\0E21\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453044528402526)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E19\0E31\0E25 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449430613402524)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E27\0E25\0E32\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449083715402523)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E33\0E14\0E31\0E1A\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453529549402527)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E2D\0E40\0E1B\0E2D\0E40\0E23\0E40\0E15\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414461799402496)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E49\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523309742402583)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E41\0E19\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416328286402498)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E37\0E48\0E19\0E46')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399120369402485)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E14\0E41\0E19\0E27\0E40\0E1E\0E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399806765402486)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E19\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399928268402486)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E15\0E31\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399001198402485)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E19\0E32\0E14\0E02\0E2D\0E07\0E40\0E1E\0E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399638843402486)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'th'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399513105402486)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'th'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399708792402486)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E2B\0E19\0E14\0E40\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399386741402485)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E0E\0E2B\0E21\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399233322402485)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E14\0E2B\0E21\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115399448440402485)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'th'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532495428402590)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E2D\0E23\0E4C\0E40\0E0B\0E47\0E19\0E15\0E4C\0E02\0E2D\0E07\0E08\0E33\0E19\0E27\0E19\0E17\0E31\0E49\0E07\0E2B\0E21\0E14 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531601217402589)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E2D\0E23\0E4C\0E40\0E0B\0E47\0E19\0E15\0E4C\0E02\0E2D\0E07\0E22\0E2D\0E14\0E23\0E27\0E21\0E17\0E31\0E49\0E07\0E2B\0E21\0E14 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530696038402588)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E2D\0E23\0E4C\0E40\0E0B\0E47\0E19\0E15\0E4C\0E02\0E2D\0E07\0E08\0E33\0E19\0E27\0E19\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530596496402588)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E2D\0E23\0E4C\0E40\0E0B\0E47\0E19\0E15\0E4C\0E02\0E2D\0E07\0E22\0E2D\0E14\0E23\0E27\0E21\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419984660402500)
,p_name=>'APEXIR_PIE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E07\0E01\0E25\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479805227402547)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481354978402548)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481570616402548)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21\0E43\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E40\0E1B\0E47\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480768849402547)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480548961402547)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481149536402548)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381293454402472)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E08\0E30\0E08\0E33\0E01\0E31\0E14\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19 \0E44\0E21\0E48\0E43\0E0A\0E48\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 \0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19\0E02\0E2D\0E07\0E04\0E38\0E13\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E2A\0E39\0E07\0E2A\0E38\0E14 %0 \0E41\0E16\0E27 \0E42\0E1B\0E23\0E14\0E43\0E0A\0E49\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E40\0E1E\0E37\0E48\0E2D\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E40\0E23\0E04\0E04\0E2D\0E23\0E4C\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E1E\0E37\0E49\0E19\0E10\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481031964402547)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450418745402524)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E21\0E35\0E2B\0E25\0E32\0E22\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E2D\0E22\0E39\0E48\0E15\0E34\0E14\0E01\0E31\0E19\0E40\0E01\0E34\0E19\0E44\0E1B - \0E2A\0E23\0E49\0E32\0E07 SQL \0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503840880402566)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437959638402514)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115529550337402588)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E25\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504844497402567)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E2B\0E25\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398920344402485)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E27\0E21\0E41\0E17\0E47\0E01\0E02\0E2D\0E07\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385811862402475)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E2D\0E14\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E17\0E35\0E48\0E21\0E35\0E23\0E39\0E1B\0E41\0E1A\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462620565402533)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E27\0E19\0E1A\0E38\0E04\0E04\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420579357402501)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E32\0E18\0E32\0E23\0E13\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416109830402498)
,p_name=>'APEXIR_RED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E14\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558149590402610)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('ID \0E2A\0E41\0E15\0E15\0E34\0E01\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 %0 \0E44\0E21\0E48\0E21\0E35\0E2D\0E22\0E39\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447278004402522)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447397202402522)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553492617402607)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446877168402522)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E04\0E27\0E1A\0E04\0E38\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446542910402521)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E2D\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446615610402521)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E41\0E1F\0E25\0E0A\0E41\0E1A\0E47\0E04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553574615402607)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446919485402522)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E44\0E2E\0E44\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553653080402607)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534663615402592)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E23\0E32\0E22\0E07\0E32\0E19\0E2D\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515297212402576)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456454655402529)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438212132402514)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532594826402590)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412713238402495)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462971140402533)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412874353402495)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 ID %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115454756505402527)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435595980402512)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E38\0E21\0E21\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439492045402515)
,p_name=>'APEXIR_RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420714985402501)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E37\0E19\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E1B\0E47\0E19\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415993274402497)
,p_name=>'APEXIR_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528633057402587)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E43\0E0A\0E49 ROWID \0E40\0E1B\0E47\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E04\0E35\0E22\0E4C\0E2B\0E25\0E31\0E01\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST \0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445921092402521)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505555368402568)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27\0E15\0E48\0E2D\0E40\0E1E\0E08')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480851884402547)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480671154402547)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481278235402548)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481435999402548)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27\0E15\0E49\0E2D\0E07\0E15\0E48\0E32\0E07\0E08\0E32\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460086963402531)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E02\0E2D\0E07\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435673515402512)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0 \0E08\0E32\0E01 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439623401402515)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E02\0E2D\0E07\0E41\0E16\0E27\0E21\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415243431402497)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450028229402524)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449972016402524)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E1A\0E31\0E19\0E17\0E36\0E01 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452107890402526)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E08\0E30\0E16\0E39\0E01\0E19\0E33\0E44\0E1B\0E43\0E0A\0E49\0E40\0E1B\0E47\0E19\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115515193195402576)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115439309606402515)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553834880402607)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01\0E23\0E32\0E22\0E07\0E32\0E19 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506572121402568)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115444804661402520)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E1A\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115553786166402607)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512073003402574)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496096471402559)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416938164402498)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438675277402514)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420495329402501)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445694999402521)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480363006402547)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531543883402589)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480452584402547)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('- \0E40\0E25\0E37\0E2D\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E16\0E27 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389167351402478)
,p_name=>'APEXIR_SEND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395480999402483)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E48\0E07\0E40\0E1B\0E47\0E19\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415697088402497)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E33\0E14\0E31\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438893992402514)
,p_name=>'APEXIR_SORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448142803402523)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E19\0E49\0E2D\0E22\0E44\0E1B\0E21\0E32\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448296966402523)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E08\0E32\0E01\0E21\0E32\0E01\0E44\0E1B\0E19\0E49\0E2D\0E22')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534084482402591)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E33\0E14\0E31\0E1A\0E01\0E32\0E23\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442637578402517)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E48\0E2D\0E07\0E27\0E48\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453771756402527)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E16\0E32\0E19\0E30 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504202084402567)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530944851402589)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E17\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385357891402475)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E32\0E21\0E2B\0E32\0E01\0E44\0E21\0E48\0E1E\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115530821710402589)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E34\0E48\0E21\0E08\0E32\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531796176402590)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E25\0E23\0E27\0E21 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521731625402582)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 = %0, \0E23\0E32\0E22\0E07\0E32\0E19 = %1, \0E21\0E38\0E21\0E21\0E2D\0E07 = %2, \0E08\0E38\0E14\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 = %3, \0E08\0E38\0E14\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 = %4, \0E41\0E16\0E27\0E23\0E27\0E21 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442349129402517)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 = %0, \0E23\0E32\0E22\0E07\0E32\0E19 = %1, \0E21\0E38\0E21\0E21\0E2D\0E07 = %2, \0E08\0E38\0E14\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 = %3, \0E08\0E38\0E14\0E2A\0E34\0E49\0E19\0E2A\0E38\0E14\0E41\0E16\0E27\0E17\0E35\0E48\0E41\0E2A\0E14\0E07 = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414547459402496)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E35\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431632246402509)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431560957402509)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431400034402509)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431838594402509)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431766664402509)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115431929474402509)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115534453379402592)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E47\0E2D\0E01\0E40\0E01\0E34\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447421799402522)
,p_name=>'APEXIR_TOP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E19\0E2A\0E38\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527635511402586)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448985018402523)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E44\0E2E\0E44\0E25\0E15\0E4C\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E0B\0E49\0E33\0E01\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419244013402500)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447528415402522)
,p_name=>'APEXIR_UP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E36\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449170692402523)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E1B\0E49\0E2D\0E19\0E2A\0E35\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449269698402523)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E1B\0E49\0E2D\0E19\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E41\0E1B\0E25\0E07\0E04\0E48\0E32\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115416447699402498)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115448003993402522)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E41\0E01\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455845082402528)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419866483402500)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E41\0E19\0E27\0E15\0E31\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115523501345402583)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E15\0E31\0E49\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455195720402528)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E41\0E1C\0E19\0E20\0E39\0E21\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510395090402572)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E23\0E32\0E22\0E25\0E30\0E40\0E2D\0E35\0E22\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115555980368402609)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E44\0E21\0E48\0E21\0E35\0E21\0E38\0E21\0E21\0E2D\0E07 %0 \0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E44\0E27\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510446787402572)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E08\0E31\0E14\0E01\0E25\0E38\0E48\0E21\0E15\0E32\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510256516402572)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E2D\0E04\0E2D\0E19\0E21\0E38\0E21\0E21\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480118684402547)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E08\0E38\0E14\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115455287359402528)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504408462402567)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438160494402514)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533193837402591)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533016529402591)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115532928473402590)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533382987402591)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533222210402591)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115533462629402591)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115531121458402589)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115414276643402496)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2B\0E25\0E37\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115415776012402497)
,p_name=>'APEXIR_YES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115447818182402522)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35 < \0E2B\0E23\0E37\0E2D > \0E0B\0E36\0E48\0E07\0E40\0E1B\0E47\0E19\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115470601888402539)
,p_name=>'APEX_REGION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115398837482402485)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E30\0E40\0E21\0E34\0E14\0E40\0E07\0E37\0E48\0E2D\0E19\0E44\0E02\0E25\0E48\0E27\0E07\0E2B\0E19\0E49\0E32\0E02\0E2D\0E07 API')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418354201402499)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E31\0E1A\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0 \0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E23\0E38\0E48\0E19\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E44\0E21\0E48\0E44\0E14\0E49\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418215122402499)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0 \0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E23\0E38\0E48\0E19\0E17\0E35\0E48\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E44\0E21\0E48\0E44\0E14\0E49\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525918467402585)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0 \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115525853329402585)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E01\0E33\0E2B\0E19\0E14\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E17\0E35\0E48\0E02\0E2D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526005308402585)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0 \0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E15\0E31\0E49\0E07\0E40\0E1B\0E47\0E19\0E04\0E48\0E32\0E19\0E31\0E25')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406974944402491)
,p_name=>'BACK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E2D\0E19\0E01\0E25\0E31\0E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393927102402481)
,p_name=>'BUILDER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E2A\0E23\0E49\0E32\0E07')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458054820402530)
,p_name=>'BUTTON LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A\0E1B\0E38\0E48\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393024329402481)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E25\0E32\0E2A CSS \0E1B\0E38\0E48\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422237487402502)
,p_name=>'BUTTON_ID'
,p_message_language=>'th'
,p_message_text=>unistr('ID \0E1B\0E38\0E48\0E21\0E17\0E35\0E48\0E2A\0E23\0E49\0E32\0E07\0E08\0E30\0E40\0E1B\0E47\0E19 ID \0E2A\0E41\0E15\0E15\0E34\0E01\0E02\0E2D\0E07\0E1B\0E38\0E48\0E21 \0E2B\0E32\0E01\0E01\0E33\0E2B\0E19\0E14\0E44\0E27\0E49 \0E2B\0E32\0E01\0E44\0E21\0E48\0E44\0E14\0E49\0E01\0E33\0E2B\0E19\0E14 \0E08\0E30\0E40\0E1B\0E47\0E19 ID \0E2A\0E23\0E49\0E32\0E07\0E20\0E32\0E22\0E43\0E19\0E43\0E19\0E23\0E39\0E1B\0E41\0E1A\0E1A ''B'' || [Internal Button ID]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385783652402475)
,p_name=>'CANDLESTICK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E48\0E07\0E40\0E17\0E35\0E22\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467229587402537)
,p_name=>'CENTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E36\0E48\0E07\0E01\0E25\0E32\0E07')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417247628402498)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E02\0E2D %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408687540402492)
,p_name=>'CHECK$'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E35\0E40\0E25\0E47\0E04\0E40\0E15\0E2D\0E23\0E4C\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115527724640402586)
,p_name=>'CHECKED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E33\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503205629402566)
,p_name=>'COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463733083402534)
,p_name=>'COMMENTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E40\0E2B\0E47\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445222967402520)
,p_name=>'CONTINUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E15\0E48\0E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407203138402491)
,p_name=>'COPYRIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E34\0E02\0E2A\0E34\0E17\0E18\0E34\0E4C &copy; %0, \0E2A\0E07\0E27\0E19\0E25\0E34\0E02\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450972472402525)
,p_name=>'COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457646289402530)
,p_name=>'CREATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509910106402572)
,p_name=>'CREATED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E40\0E21\0E37\0E48\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510051431402572)
,p_name=>'CREATED_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E42\0E14\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434856586402511)
,p_name=>'CREATED_ON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E40\0E21\0E37\0E48\0E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445448641402521)
,p_name=>'CUSTOM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E2B\0E19\0E14\0E40\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456605184402529)
,p_name=>'CUSTOMIZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458291431402530)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E1E\0E08\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49 %0 \0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458305322402530)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49 %0 \0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458174080402530)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E1E\0E08\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49 %0 \0E41\0E25\0E49\0E27')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421929402402502)
,p_name=>'DAILY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E27\0E31\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115393588205402481)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E2B\0E23\0E37\0E2D\0E21\0E35\0E19\0E32\0E21\0E2A\0E01\0E38\0E25\0E1C\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417487683402499)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C XML \0E2B\0E23\0E37\0E2D JSON \0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386736285402476)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E44\0E1F\0E25\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E25\0E30\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14\0E44\0E21\0E48\0E21\0E35\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E15\0E32\0E23\0E32\0E07\0E40\0E1B\0E49\0E32\0E2B\0E21\0E32\0E22\0E43\0E14\0E46')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472445550402541)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472598253402541)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E40\0E27\0E34\0E23\0E4C\0E01\0E0A\0E35\0E17 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115392367223402480)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E44\0E21\0E48\0E43\0E0A\0E48\0E44\0E1F\0E25\0E4C XLSX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115382700132402473)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19: \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 %0 \0E41\0E16\0E27\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383974625402474)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19: \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 %0 \0E41\0E16\0E27\0E41\0E25\0E49\0E27\0E42\0E14\0E22\0E21\0E35 1 \0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384233116402474)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19: \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 %0 \0E41\0E16\0E27\0E41\0E25\0E49\0E27\0E42\0E14\0E22\0E21\0E35 %1 \0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384030151402474)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19: \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 1 \0E41\0E16\0E27\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387037889402476)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19: \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 1 \0E41\0E16\0E27\0E41\0E25\0E49\0E27\0E42\0E14\0E22\0E21\0E35\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384116989402474)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E2A\0E23\0E47\0E08\0E2A\0E34\0E49\0E19: \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 1 \0E41\0E16\0E27\0E41\0E25\0E49\0E27\0E42\0E14\0E22\0E44\0E21\0E48\0E21\0E35\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477774730402545)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E1B\0E49\0E32\0E2B\0E21\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477899283402545)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E21\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478685388402546)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E27\0E31\0E19\0E17\0E35\0E48 / \0E15\0E31\0E27\0E40\0E25\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542092628402598)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E01\0E04\0E48\0E32\0E01\0E32\0E23\0E04\0E49\0E19\0E2B\0E32\0E25\0E49\0E21\0E40\0E2B\0E25\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115510576994402572)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E21\0E1B\0E02\0E49\0E2D\0E21\0E39\0E25 / \0E15\0E32\0E23\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478757716402546)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474293858402542)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E0E\0E01\0E32\0E23\0E41\0E1B\0E25\0E07\0E25\0E49\0E21\0E40\0E2B\0E25\0E27')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450579683402524)
,p_name=>'DATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424660155402504)
,p_name=>'DAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424753479402504)
,p_name=>'DAYS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463447483402534)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E14\0E35\0E1A\0E31\0E01\0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E1B\0E34\0E14\0E43\0E0A\0E49\0E07\0E32\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115512241860402574)
,p_name=>'DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425493501402505)
,p_name=>'DELETE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115385671286402475)
,p_name=>'DIAL_PCT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E19\0E49\0E32\0E1B\0E31\0E14 (\0E40\0E1B\0E2D\0E23\0E4C\0E40\0E0B\0E47\0E19\0E15\0E4C)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400140803402486)
,p_name=>'DOWNLOAD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E32\0E27\0E19\0E4C\0E42\0E2B\0E25\0E14')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511354498402573)
,p_name=>'DUP_USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E0B\0E49\0E33\0E43\0E19\0E23\0E32\0E22\0E0A\0E37\0E48\0E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407714323402492)
,p_name=>'EDIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417194663402498)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402218207402487)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E35\0E40\0E21\0E25\0E4C\0E19\0E35\0E49\0E2A\0E48\0E07\0E42\0E14\0E22 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511509999402573)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C\0E22\0E32\0E27\0E40\0E01\0E34\0E19\0E44\0E1B  \0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E04\0E37\0E2D 240 \0E2D\0E31\0E01\0E02\0E23\0E30')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445118895402520)
,p_name=>'ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474318351402542)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32\0E17\0E35\0E48\0E21\0E32\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E01\0E32\0E23\0E23\0E35\0E40\0E1F\0E23\0E0A\0E40\0E1E\0E08\0E1A\0E32\0E07\0E2A\0E48\0E27\0E19\0E44\0E21\0E48\0E44\0E14\0E49')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436656098402513)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E23\0E49\0E32\0E07\0E42\0E14\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402558079402488)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E2B\0E21\0E14\0E2D\0E32\0E22\0E38\0E41\0E25\0E49\0E27')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115396616401402483)
,p_name=>'FILE_EMPTY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1F\0E25\0E4C\0E27\0E48\0E32\0E07\0E40\0E1B\0E25\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476852441402544)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14\0E02\0E19\0E32\0E14\0E43\0E2B\0E0D\0E48\0E40\0E01\0E34\0E19 %0 MB \0E42\0E1B\0E23\0E14\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E02\0E19\0E32\0E14\0E40\0E25\0E47\0E01\0E01\0E27\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404689000402489)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C\0E1C\0E39\0E49\0E43\0E0A\0E49\0E25\0E49\0E21\0E40\0E2B\0E25\0E27\0E41\0E25\0E30\0E44\0E21\0E48\0E44\0E14\0E49\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14\0E44\0E1F\0E25\0E4C\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404725094402489)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E34\0E19\0E2A\0E41\0E15\0E19\0E0B\0E4C\0E19\0E35\0E49\0E44\0E21\0E48\0E2D\0E19\0E38\0E0D\0E32\0E15\0E43\0E2B\0E49\0E1C\0E39\0E49\0E43\0E0A\0E49\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E19\0E38\0E21\0E31\0E15\0E34\0E2D\0E31\0E1B\0E42\0E2B\0E25\0E14\0E44\0E1F\0E25\0E4C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457790623402530)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14 1 \0E23\0E32\0E22\0E01\0E32\0E23')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456975086402529)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14 %0 \0E23\0E32\0E22\0E01\0E32\0E23')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407122617402491)
,p_name=>'FORM_OF'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E08\0E32\0E01 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441897022402516)
,p_name=>'GO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E1B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541612850402598)
,p_name=>'HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394076681402482)
,p_name=>'HOME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E19\0E49\0E32\0E2B\0E25\0E31\0E01')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424419594402504)
,p_name=>'HOUR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424515297402504)
,p_name=>'HOURS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E31\0E48\0E27\0E42\0E21\0E07')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408582557402492)
,p_name=>'ICON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E2D\0E04\0E2D\0E19 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458528755402530)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E41\0E25\0E30\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E02\0E2D\0E07\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115558047905402610)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1E\0E32\0E23\0E32\0E21\0E34\0E40\0E15\0E2D\0E23\0E4C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453229499402526)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E32\0E21\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453320438402526)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E32\0E21\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435742822402512)
,p_name=>'IR_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435457328402512)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E19\0E27\0E13\0E01\0E32\0E23\0E19\0E33\0E17\0E32\0E07\0E1F\0E2D\0E23\0E4C\0E21\0E44\0E21\0E48\0E44\0E14\0E49: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413005625402495)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E42\0E15\0E49\0E15\0E2D\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412463838402495)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E23\0E32\0E22\0E07\0E32\0E19\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0, \0E40\0E1E\0E08 %1 \0E41\0E25\0E30\0E1E\0E37\0E49\0E19\0E17\0E35\0E48 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115453186865402526)
,p_name=>'IR_STAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441554422402516)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33\0E40\0E1E\0E37\0E48\0E2D\0E23\0E30\0E1A\0E38\0E41\0E15\0E48\0E25\0E30\0E41\0E16\0E27  \0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E19\0E35\0E49  \0E42\0E1B\0E23\0E14\0E01\0E33\0E2B\0E19\0E14\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441620670402516)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E23\0E32\0E22\0E07\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33\0E40\0E1E\0E37\0E48\0E2D\0E23\0E30\0E1A\0E38\0E41\0E15\0E48\0E25\0E30\0E41\0E16\0E27  \0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E19\0E35\0E49  \0E42\0E1B\0E23\0E14\0E41\0E01\0E49\0E44\0E02\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27\0E23\0E32\0E22\0E07\0E32\0E19\0E40\0E1E\0E37\0E48\0E2D\0E01\0E33\0E2B\0E19\0E14\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E04\0E35\0E22\0E4C\0E17\0E35\0E48\0E44\0E21\0E48\0E0B\0E49\0E33 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478958368402546)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E44\0E1F\0E25\0E4C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478858879402546)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E32\0E01\0E41\0E25\0E30\0E27\0E32\0E07\0E44\0E1F\0E25\0E4C\0E17\0E35\0E48\0E19\0E35\0E48\0E2B\0E23\0E37\0E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407436694402491)
,p_name=>'ITEMS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436814252402513)
,p_name=>'ITEM_VALUE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E02\0E2D\0E07\0E23\0E32\0E22\0E01\0E32\0E23')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451201715402525)
,p_name=>'LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E49\0E32\0E22\0E01\0E33\0E01\0E31\0E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463302070402534)
,p_name=>'LANGUAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E20\0E32\0E29\0E32')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425118210402504)
,p_name=>'LAST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E38\0E14\0E17\0E49\0E32\0E22')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404507119402489)
,p_name=>'LENGTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E32\0E21\0E22\0E32\0E27')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457822294402530)
,p_name=>'LOGIN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E47\0E2D\0E01\0E2D\0E34\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496498789402560)
,p_name=>'MANAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E01\0E32\0E23')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561047653402612)
,p_name=>'MAXIMIZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E19\0E32\0E14\0E43\0E2B\0E0D\0E48\0E2A\0E38\0E14')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424217767402504)
,p_name=>'MINUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424354284402504)
,p_name=>'MINUTES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E19\0E32\0E17\0E35')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511777567402573)
,p_name=>'MISSING_AT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35 "@" \0E43\0E19\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511915908402574)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E40\0E15\0E37\0E2D\0E19: \0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E40\0E17\0E21\0E40\0E1E\0E25\0E17\0E2B\0E19\0E49\0E32\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E2B\0E19\0E49\0E32\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01 %0 \0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511690081402573)
,p_name=>'MISSING_DOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35 "." \0E43\0E19\0E42\0E14\0E40\0E21\0E19\0E17\0E35\0E48\0E2D\0E22\0E39\0E48\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460840368402532)
,p_name=>'MODULE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E21\0E14\0E39\0E25')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417943483402499)
,p_name=>'MONTH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421727185402502)
,p_name=>'MONTHLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E40\0E14\0E37\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418055775402499)
,p_name=>'MONTHS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E14\0E37\0E2D\0E19')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450891644402525)
,p_name=>'MOVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518327891402579)
,p_name=>'MOVE_FROM'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E08\0E32\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518432141402579)
,p_name=>'MOVE_TO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E49\0E32\0E22\0E44\0E1B\0E17\0E35\0E48')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115438051611402514)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E25\0E1A\0E2B\0E25\0E32\0E22\0E41\0E16\0E27: row= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437004850402513)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E1C\0E39\0E49\0E43\0E0A\0E49\0E2A\0E32\0E18\0E32\0E23\0E13\0E30')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394265845402482)
,p_name=>'NAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451054446402525)
,p_name=>'NEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E2B\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417756535402499)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E40\0E02\0E49\0E32\0E2A\0E39\0E48\0E23\0E30\0E1A\0E1A %0 \0E44\0E14\0E49\0E42\0E14\0E22\0E44\0E1B\0E17\0E35\0E48:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417875048402499)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E08\0E49\0E07\0E1A\0E31\0E0D\0E0A\0E35 %0 \0E43\0E2B\0E21\0E48')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541810068402598)
,p_name=>'NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460766183402532)
,p_name=>'NO'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115556050349402609)
,p_name=>'NOBODY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E43\0E04\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425535719402505)
,p_name=>'NOT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E43\0E0A\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466339744402536)
,p_name=>'NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437111089402513)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E43\0E0A\0E48 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456784583402529)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465881153402536)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E2D\0E31\0E1B\0E40\0E14\0E15\0E44\0E14\0E49 \0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E2B\0E25\0E32\0E22\0E41\0E16\0E27\0E17\0E35\0E48\0E2D\0E31\0E1B\0E40\0E14\0E15\0E41\0E25\0E30\0E25\0E1A\0E19\0E31\0E49\0E19\0E17\0E33\0E44\0E14\0E49\0E1A\0E19\0E1F\0E2D\0E23\0E4C\0E21\0E15\0E32\0E23\0E32\0E07\0E1B\0E23\0E30\0E40\0E20\0E17 ''\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E2D\0E31\0E1B\0E40\0E14\0E15\0E44\0E14\0E49'' \0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466746717402536)
,p_name=>'OK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E01\0E25\0E07')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462444296402533)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'th'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115559830060402612)
,p_name=>'ORA_06550'
,p_message_language=>'th'
,p_message_text=>unistr('ORA-06550: \0E1A\0E23\0E23\0E17\0E31\0E14 %0, \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509359433402571)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E01\0E33\0E25\0E31\0E07\0E43\0E0A\0E49\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E17\0E35\0E48\0E40\0E01\0E48\0E32\0E40\0E01\0E34\0E19\0E44\0E1B \0E14\0E39\0E25\0E34\0E2A\0E15\0E4C\0E40\0E1A\0E23\0E32\0E40\0E0B\0E2D\0E23\0E4C\0E17\0E35\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E44\0E14\0E49\0E17\0E35\0E48\0E04\0E39\0E48\0E21\0E37\0E2D\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E31\0E49\0E07 Oracle Application Express')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410703220402494)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E2D\0E0A\0E38\0E14\0E41\0E16\0E27\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E21\0E32\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19\0E16\0E39\0E01\0E41\0E01\0E49\0E44\0E02')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430828742402509)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E40\0E25\0E02\0E17\0E35\0E48\0E2B\0E19\0E49\0E32\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E40\0E0A\0E48\0E19 p?n=1234')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434431893402511)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434556387402511)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E38\0E14\0E16\0E31\0E14\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434637334402511)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115434766953402511)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E38\0E14\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541745230402598)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472395480402541)
,p_name=>'PASSWORD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417078971402498)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A %0 \0E02\0E2D\0E07\0E04\0E38\0E13\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406874681402491)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E44\0E21\0E48\0E15\0E23\0E07\0E01\0E31\0E1A\0E01\0E0E\0E04\0E27\0E32\0E21\0E0B\0E31\0E1A\0E0B\0E49\0E2D\0E19\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E02\0E2D\0E07\0E44\0E0B\0E15\0E4C\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405986911402490)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E43\0E2B\0E21\0E48\0E04\0E27\0E23\0E41\0E15\0E01\0E15\0E48\0E32\0E07\0E08\0E32\0E01\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E40\0E14\0E34\0E21\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22 %0 \0E2D\0E31\0E01\0E02\0E23\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406592995402491)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406705155402491)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E21\0E35\0E04\0E33\0E41\0E1A\0E1A\0E07\0E48\0E32\0E22\0E17\0E35\0E48\0E2B\0E49\0E32\0E21\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406619385402491)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405800917402490)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22 %0 \0E15\0E31\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406051273402490)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E2D\0E31\0E01\0E29\0E23\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E15\0E31\0E27 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406464938402491)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E2D\0E31\0E01\0E29\0E23\0E1E\0E34\0E21\0E1E\0E4C\0E40\0E25\0E47\0E01\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E15\0E31\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406153561402490)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E15\0E31\0E27 (0123456789)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406248350402491)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E40\0E04\0E23\0E37\0E48\0E2D\0E07\0E2B\0E21\0E32\0E22\0E27\0E23\0E23\0E04\0E15\0E2D\0E19\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E15\0E31\0E27 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115406325903402491)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E2D\0E31\0E01\0E02\0E23\0E30\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E2D\0E31\0E01\0E29\0E23\0E1E\0E34\0E21\0E1E\0E4C\0E43\0E2B\0E0D\0E48\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E15\0E31\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417538162402499)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E08\0E49\0E07\0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404803674402489)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E21\0E35\0E01\0E32\0E23\0E43\0E0A\0E49\0E41\0E25\0E49\0E27\0E20\0E32\0E22\0E43\0E19 %0 \0E27\0E31\0E19\0E17\0E35\0E48\0E1C\0E48\0E32\0E19\0E21\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485141387402550)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115485295180402551)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462275348402533)
,p_name=>'PERCENT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E2D\0E23\0E4C\0E40\0E0B\0E47\0E19\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432564304402510)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115541991116402598)
,p_name=>'PREVIOUS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E48\0E2D\0E19\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477398980402545)
,p_name=>'PRINT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E34\0E21\0E1E\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461059202402532)
,p_name=>'PRIVILEGES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430948261402509)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451182887402525)
,p_name=>'REPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460933295402532)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E22\0E30\0E40\0E27\0E25\0E32\0E01\0E32\0E23\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542145216402598)
,p_name=>'REPORT_LABEL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E07\0E32\0E19: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461616665402532)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E2D\0E14\0E23\0E27\0E21\0E02\0E2D\0E07\0E23\0E32\0E22\0E07\0E32\0E19')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410804789402494)
,p_name=>'RESET'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436780957402513)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465731800402536)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E35\0E40\0E0B\0E47\0E15\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442577428402517)
,p_name=>'RESTORE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E23\0E35\0E22\0E01\0E04\0E37\0E19')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115474461524402542)
,p_name=>'RESULTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E25\0E25\0E31\0E1E\0E18\0E4C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466853771402536)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E25\0E31\0E1A\0E2A\0E39\0E48\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115467135365402537)
,p_name=>'RIGHT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E27\0E32')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496795345402560)
,p_name=>'ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450727337402525)
,p_name=>'ROW_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115466221990402536)
,p_name=>'SAVE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E19\0E17\0E36\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462823565402533)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2A\0E33\0E23\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463230671402534)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E2D\0E18\0E34\0E1A\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462787137402533)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E2B\0E25\0E31\0E01')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463502270402534)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E41\0E16\0E27\0E17\0E35\0E48\0E43\0E0A\0E49\0E44\0E14\0E49\0E21\0E32\0E01\0E01\0E27\0E48\0E32 %0 \0E41\0E16\0E27 \0E40\0E1E\0E34\0E48\0E21\0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E41\0E16\0E27\0E40\0E1E\0E37\0E48\0E2D\0E14\0E39\0E41\0E16\0E27\0E40\0E1E\0E34\0E48\0E21')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528984550402587)
,p_name=>'SEARCH'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E49\0E19\0E2B\0E32')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424144937402504)
,p_name=>'SECONDS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E34\0E19\0E32\0E17\0E35')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462318071402533)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E2A\0E34\0E48\0E07\0E17\0E35\0E48\0E41\0E19\0E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520054921402580)
,p_name=>'SELECT_ROW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E37\0E2D\0E01\0E41\0E16\0E27')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462023089402533)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14\0E42\0E2B\0E21\0E14\0E15\0E31\0E27\0E2D\0E48\0E32\0E19\0E2B\0E19\0E49\0E32\0E08\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462157996402533)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E34\0E14\0E42\0E2B\0E21\0E14\0E15\0E31\0E27\0E2D\0E48\0E32\0E19\0E2B\0E19\0E49\0E32\0E08\0E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458443225402530)
,p_name=>'SHOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521896694402582)
,p_name=>'SHOW_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115547968487402602)
,p_name=>'SIGN_IN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E07\0E0A\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115497522970402561)
,p_name=>'SIGN_OUT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E2D\0E01\0E08\0E32\0E01\0E23\0E30\0E1A\0E1A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451713048402525)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458900328402531)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E31\0E19\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451634662402525)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458867161402530)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E0A\0E31\0E48\0E27\0E42\0E21\0E07\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451549463402525)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458779781402530)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E19\0E32\0E17\0E35\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451903129402525)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E14\0E37\0E2D\0E19\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459124198402531)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E40\0E14\0E37\0E2D\0E19\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459398598402531)
,p_name=>'SINCE_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E13\0E30\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451483844402525)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E34\0E19\0E32\0E17\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115458697550402530)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E27\0E34\0E19\0E32\0E17\0E35\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115451802955402525)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459073675402531)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115452055307402526)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35\0E17\0E35\0E48\0E41\0E25\0E49\0E27')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459220907402531)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E1B\0E35\0E08\0E32\0E01\0E15\0E2D\0E19\0E19\0E35\0E49')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445571505402521)
,p_name=>'STANDARD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E32\0E15\0E23\0E10\0E32\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461967439402533)
,p_name=>'START_DATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E17\0E35\0E48\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402498048402488)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E44\0E14\0E49\0E23\0E31\0E1A\0E2D\0E35\0E40\0E21\0E25\0E4C\0E19\0E35\0E49\0E08\0E32\0E01\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23\0E23\0E31\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E23\0E32\0E22\0E07\0E32\0E19\0E41\0E1A\0E1A\0E42\0E15\0E49\0E15\0E2D\0E1A\0E17\0E35\0E48\0E2A\0E23\0E49\0E32\0E07\0E42\0E14\0E22 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557112983402610)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505297462402567)
,p_name=>'TAB'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E17\0E47\0E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424000884402503)
,p_name=>'TITLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407008099402491)
,p_name=>'TODAY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E27\0E31\0E19\0E19\0E35\0E49')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461527946402532)
,p_name=>'TOTAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E2D\0E14\0E23\0E27\0E21')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408090085402492)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E40\0E25\0E37\0E2D\0E01\0E44\0E14\0E49\0E2A\0E39\0E07\0E2A\0E38\0E14 %0 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386581514402476)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E38\0E1A\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386896126402476)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E38\0E1A\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386413606402476)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386699584402476)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E22\0E32\0E22\0E17\0E31\0E49\0E07\0E2B\0E21\0E14\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386921178402476)
,p_name=>'TREE.REPARENT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E23\0E32\0E22\0E01\0E32\0E23\0E2B\0E25\0E31\0E01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479129112402546)
,p_name=>'TREES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E23\0E35')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115522665881402582)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115446280809402521)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115493015070402556)
,p_name=>'UNAVAILABLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459782802402531)
,p_name=>'UNKNOWN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E39\0E49\0E08\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403345408402488)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E01\0E32\0E23\0E23\0E31\0E1A\0E23\0E2D\0E07\0E17\0E35\0E48\0E44\0E21\0E48\0E23\0E39\0E49\0E08\0E31\0E01')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405337082402490)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E21\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E23\0E31\0E1A\0E2D\0E35\0E40\0E21\0E25\0E4C \0E42\0E1B\0E23\0E14\0E04\0E25\0E34\0E01<a href="%0">\0E40\0E25\0E34\0E01\0E2A\0E21\0E31\0E04\0E23</a>\0E40\0E1E\0E37\0E48\0E2D\0E08\0E31\0E14\0E01\0E32\0E23\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23\0E23\0E31\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E02\0E2D\0E07\0E04\0E38\0E13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115402384963402488)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E21\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E23\0E31\0E1A\0E2D\0E35\0E40\0E21\0E25\0E4C \0E42\0E1B\0E23\0E14\0E44\0E1B\0E17\0E35\0E48 URL \0E15\0E48\0E2D\0E44\0E1B\0E19\0E35\0E49\0E40\0E1E\0E37\0E48\0E2D\0E08\0E31\0E14\0E01\0E32\0E23\0E01\0E32\0E23\0E2A\0E21\0E31\0E04\0E23\0E23\0E31\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E02\0E2D\0E07\0E04\0E38\0E13:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115437207986402513)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425384572402504)
,p_name=>'UPDATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E31\0E1B\0E40\0E14\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423953325402503)
,p_name=>'UPDATED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E31\0E1B\0E40\0E14\0E15\0E41\0E25\0E49\0E27')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430682784402508)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'th'
,p_message_text=>unistr('URL \0E17\0E35\0E48\0E02\0E2D\0E16\0E39\0E01\0E2B\0E49\0E32\0E21\0E43\0E0A\0E49\0E07\0E32\0E19 \0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A\0E02\0E2D\0E07\0E04\0E38\0E13')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115450633670402524)
,p_name=>'USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115472266694402541)
,p_name=>'USERNAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511825233402573)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E22\0E32\0E27\0E40\0E01\0E34\0E19\0E44\0E1B \0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E04\0E37\0E2D %0 \0E2D\0E31\0E01\0E02\0E23\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457414311402529)
,p_name=>'USERS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1C\0E39\0E49\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115511405970402573)
,p_name=>'USER_EXISTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E19\0E35\0E49\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115526193675402585)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E20\0E32\0E1E\0E42\0E1B\0E23\0E44\0E1F\0E25\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413799705402496)
,p_name=>'VALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407393019402491)
,p_name=>'VALIDATIONS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463032861402534)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506495999402568)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432909482402510)
,p_name=>'VERTICAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E19\0E27\0E15\0E31\0E49\0E07')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425299825402504)
,p_name=>'VIEW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457559663402530)
,p_name=>'VIEWS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463808062402534)
,p_name=>'VIEW_ALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E39\0E17\0E31\0E49\0E07\0E2B\0E21\0E14')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115445056377402520)
,p_name=>'WARNING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E33\0E40\0E15\0E37\0E2D\0E19')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424806061402504)
,p_name=>'WEEK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421858869402502)
,p_name=>'WEEKLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115424925257402504)
,p_name=>'WEEKS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E31\0E1B\0E14\0E32\0E2B\0E4C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115463158790402534)
,p_name=>'WELCOME_USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E34\0E19\0E14\0E35\0E15\0E49\0E2D\0E19\0E23\0E31\0E1A: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461342451402532)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E1B\0E49\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461469873402532)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E1B\0E49\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404433683402489)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A\0E04\0E48\0E32\0E27\0E31\0E19\0E17\0E35\0E48\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E27\0E31\0E19\0E17\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115461215125402532)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A\0E04\0E48\0E32\0E15\0E31\0E27\0E40\0E25\0E02\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E15\0E31\0E27\0E40\0E25\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413332182402496)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A\0E04\0E48\0E32\0E40\0E27\0E25\0E32\0E23\0E30\0E1A\0E1A\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E40\0E27\0E25\0E32\0E23\0E30\0E1A\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115435846371402512)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07 "%0" \0E44\0E21\0E48\0E44\0E14\0E49 \0E43\0E0A\0E49\0E2D\0E31\0E0D\0E1B\0E23\0E30\0E01\0E32\0E28\0E04\0E39\0E48\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E01\0E32\0E23\0E02\0E19\0E32\0E14\0E2B\0E25\0E32\0E22\0E44\0E1A\0E15\0E4C\0E2B\0E23\0E37\0E2D\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E27\0E48\0E32\0E04\0E27\0E32\0E21\0E22\0E32\0E27\0E02\0E2D\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E44\0E21\0E48\0E40\0E01\0E34\0E19 30 \0E44\0E1A\0E15\0E4C \0E43\0E0A\0E49\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E04\0E33\0E2A\0E31\0E48\0E07 v() \0E40\0E1E\0E37\0E48\0E2D\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E22\0E32\0E27\0E01\0E27\0E48\0E32 30 \0E44\0E1A\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426360519402505)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E16\0E39\0E01\0E1B\0E0F\0E34\0E40\0E2A\0E18\0E42\0E14\0E22\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E04\0E27\0E32\0E21\0E1B\0E25\0E2D\0E14\0E20\0E31\0E22 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428859504402507)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E44\0E21\0E48\0E1E\0E23\0E49\0E2D\0E21\0E43\0E0A\0E49\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427211133402506)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1014 \0E44\0E21\0E48\0E1E\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427377752402506)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'th'
,p_message_text=>'application=%0  workspace=%1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427796420402506)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E16\0E39\0E01\0E08\0E33\0E01\0E31\0E14\0E2D\0E22\0E39\0E48 \0E42\0E1B\0E23\0E14\0E25\0E2D\0E07\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07\0E43\0E19\0E20\0E32\0E22\0E2B\0E25\0E31\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427600182402506)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E08\0E33\0E01\0E31\0E14\0E40\0E09\0E1E\0E32\0E30\0E1C\0E39\0E49\0E1E\0E31\0E12\0E19\0E32\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19 \0E42\0E1B\0E23\0E14\0E25\0E2D\0E07\0E2D\0E35\0E01\0E04\0E23\0E31\0E49\0E07\0E43\0E19\0E20\0E32\0E22\0E2B\0E25\0E31\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426825837402506)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-7744 \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25 URL \0E01\0E32\0E23\0E01\0E25\0E31\0E1A\0E04\0E37\0E19\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E2A\0E23\0E49\0E32\0E07\0E2A\0E32\0E02\0E32\0E44\0E1B\0E22\0E31\0E07\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426738807402505)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-7744 \0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E40\0E1E\0E08\0E01\0E32\0E23\0E01\0E25\0E31\0E1A\0E04\0E37\0E19\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E2A\0E23\0E49\0E32\0E07\0E2A\0E32\0E02\0E32\0E44\0E1B\0E22\0E31\0E07\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427013631402506)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1430 \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E01\0E43\0E0A\0E49\0E40\0E1E\0E37\0E48\0E2D\0E41\0E2A\0E14\0E07\0E1C\0E25\0E08\0E32\0E01\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E02\0E2D\0E07\0E40\0E1E\0E08: G_FLOW_STEP_ID (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428123570402507)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1018 \0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E01\0E32\0E23\0E25\0E49\0E32\0E07\0E41\0E04\0E0A\0E02\0E31\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426556612402505)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1005 \0E1B\0E23\0E30\0E40\0E20\0E17\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E17\0E35\0E48\0E44\0E21\0E48\0E23\0E39\0E49\0E08\0E31\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427445656402506)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1201 \0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32 ID \0E40\0E0B\0E2A\0E0A\0E31\0E19\0E43\0E19\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C\0E41\0E1A\0E1A\0E01\0E33\0E2B\0E19\0E14\0E40\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427519095402506)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'th'
,p_message_text=>'page=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115427180885402506)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-7620 \0E01\0E33\0E2B\0E19\0E14\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 (%0) \0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409505778402493)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E01\0E49\0E44\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426277893402505)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1802 \0E44\0E21\0E48\0E1E\0E1A ID \0E23\0E32\0E22\0E01\0E32\0E23 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425950937402505)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1002 \0E44\0E21\0E48\0E1E\0E1A ID \0E23\0E32\0E22\0E01\0E32\0E23\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E01\0E32\0E23 "%0" \0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426087586402505)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E17\0E35\0E48\0E44\0E21\0E48\0E04\0E32\0E14\0E04\0E34\0E14 \0E44\0E21\0E48\0E1E\0E1A\0E0A\0E37\0E48\0E2D\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E23\0E30\0E14\0E31\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E2B\0E23\0E37\0E2D\0E40\0E1E\0E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426472513402505)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E2D\0E22\0E39\0E48\0E43\0E19\0E2B\0E19\0E49\0E32\0E41\0E23\0E01\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115441990834402517)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23 ID (%0) \0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E23\0E32\0E22\0E01\0E32\0E23\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E43\0E19\0E40\0E1E\0E08\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404007103402489)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E2D\0E32\0E08\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E2A\0E48\0E07\0E15\0E48\0E2D\0E2D\0E32\0E23\0E4C\0E01\0E34\0E27\0E40\0E21\0E19\0E15\0E4C\0E44\0E1B\0E22\0E31\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404354153402489)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'th'
,p_message_text=>unistr('(\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38 checksum)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403832626402489)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E2D\0E32\0E08\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E21\0E37\0E48\0E2D\0E21\0E35 checksum "\0E1A\0E38\0E04\0E21\0E32\0E23\0E4C\0E04\0E23\0E30\0E14\0E31\0E1A\0E1C\0E39\0E49\0E43\0E0A\0E49"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403799432402489)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E2D\0E32\0E08\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E21\0E37\0E48\0E2D\0E21\0E35 checksum "\0E1A\0E38\0E04\0E21\0E32\0E23\0E4C\0E04\0E23\0E30\0E14\0E31\0E1A\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403951914402489)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E2D\0E32\0E08\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E40\0E21\0E37\0E48\0E2D\0E21\0E35 checksum "\0E40\0E0B\0E2A\0E0A\0E31\0E19"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403686571402489)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E1B\0E49\0E2D\0E07\0E01\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428255261402507)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E27\0E34\0E18\0E35\0E43\0E0A\0E49\0E40\0E1E\0E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115417330380402498)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19 %0 \0E44\0E21\0E48\0E21\0E35\0E2A\0E34\0E17\0E18\0E34\0E4C\0E17\0E35\0E48\0E08\0E30\0E1E\0E32\0E23\0E4C\0E0B\0E40\0E1B\0E47\0E19\0E2A\0E01\0E35\0E21\0E32 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426652331402505)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1010 \0E40\0E01\0E34\0E19\0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E01\0E32\0E23\0E27\0E19\0E0B\0E49\0E33\0E01\0E32\0E23\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E01\0E32\0E23\0E22\0E2D\0E21\0E23\0E31\0E1A\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E2A\0E32\0E02\0E32\0E44\0E1B\0E22\0E31\0E07\0E40\0E1E\0E08 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404266534402489)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E08\0E19\0E35\0E49\0E40\0E23\0E35\0E22\0E01\0E43\0E0A\0E49\0E14\0E49\0E27\0E22 URL \0E2B\0E23\0E37\0E2D GET or POST \0E44\0E1B\0E22\0E31\0E07\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E44\0E21\0E48\0E44\0E14\0E49 \0E15\0E49\0E2D\0E07\0E40\0E23\0E35\0E22\0E01\0E43\0E0A\0E49\0E14\0E49\0E27\0E22\0E1B\0E23\0E30\0E40\0E20\0E17\0E2A\0E32\0E02\0E32 "\0E2A\0E23\0E49\0E32\0E07\0E2A\0E32\0E02\0E32\0E44\0E1B\0E22\0E31\0E07\0E40\0E1E\0E08"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115480944848402547)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E1A\0E31\0E19\0E17\0E36\0E01\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E43\0E0A\0E48\0E15\0E31\0E27\0E40\0E25\0E02\0E43\0E19\0E23\0E32\0E22\0E01\0E32\0E23 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419043389402500)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E2A\0E04\0E35\0E21\0E32\0E01\0E32\0E23\0E1E\0E32\0E23\0E4C\0E0B\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 "%0" \0E43\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115419143952402500)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1A\0E31\0E0D\0E0A\0E35\0E43\0E19\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19 INTERNAL \0E43\0E0A\0E49\0E44\0E14\0E49\0E40\0E1E\0E37\0E48\0E2D\0E40\0E02\0E49\0E32\0E43\0E0A\0E49 &PRODUCT_NAME. \0E40\0E17\0E48\0E32\0E19\0E31\0E49\0E19 <a href="%0">\0E1A\0E23\0E34\0E01\0E32\0E23\0E01\0E32\0E23\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425831805402505)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-1029 \0E40\0E01\0E47\0E1A\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E44\0E21\0E48\0E44\0E14\0E49  session=%0 item=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428911517402507)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2B\0E22\0E38\0E14\0E01\0E32\0E23\0E15\0E34\0E14\0E15\0E32\0E21\0E44\0E21\0E48\0E44\0E14\0E49: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115426191314402505)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E17\0E35\0E48\0E44\0E21\0E48\0E04\0E32\0E14\0E04\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436102444402512)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19 update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429086392402507)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E41\0E25\0E30\0E40\0E1E\0E08\0E40\0E1E\0E37\0E48\0E2D\0E14\0E39\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115449581199402524)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E2D\0E31\0E15\0E42\0E19\0E21\0E31\0E15\0E34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430128210402508)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E49\0E32\0E07 %0 \0E40\0E0B\0E2A\0E0A\0E31\0E19\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389408178402478)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E31\0E19\0E23\0E2B\0E31\0E2A %0 \0E44\0E21\0E48\0E44\0E14\0E49! \0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E2B\0E23\0E37\0E2D\0E1E\0E32\0E23\0E32\0E21\0E34\0E40\0E15\0E2D\0E23\0E4C\0E2D\0E34\0E19\0E2A\0E41\0E15\0E19\0E0B\0E4C MLE_LANGUAGES \0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E1B\0E34\0E14\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115389293288402478)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'th'
,p_message_text=>unistr('Multi Lingual Engine \0E44\0E21\0E48\0E1E\0E23\0E49\0E2D\0E21\0E43\0E0A\0E49\0E07\0E32\0E19\0E43\0E19\0E40\0E27\0E2D\0E23\0E4C\0E0A\0E31\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E19\0E35\0E49!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410098539402493)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E32\0E40\0E23\0E22\0E4C\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409857800402493)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E25\0E02\0E17\0E35\0E48\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27\0E2A\0E21\0E32\0E0A\0E34\0E01\0E17\0E35\0E48\0E23\0E30\0E1A\0E38 %0\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07  \0E40\0E25\0E02\0E17\0E35\0E48\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27\0E15\0E49\0E2D\0E07\0E2D\0E22\0E39\0E48\0E23\0E30\0E2B\0E27\0E48\0E32\0E07 1 \0E41\0E25\0E30 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410341627402493)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410100845402493)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410291098402493)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E15\0E49\0E2D\0E07\0E44\0E21\0E48\0E22\0E32\0E27\0E40\0E01\0E34\0E19 255 \0E2D\0E31\0E01\0E02\0E23\0E30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409684679402493)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410464313402494)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E22\0E31\0E07\0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E1B\0E34\0E14\0E40\0E04\0E2D\0E23\0E4C\0E40\0E0B\0E2D\0E23\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409734382402493)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E44\0E21\0E48\0E21\0E35\0E25\0E33\0E14\0E31\0E1A\0E2A\0E21\0E32\0E0A\0E34\0E01 %0 \0E43\0E19\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115409951551402493)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E25\0E33\0E14\0E31\0E1A\0E2A\0E21\0E32\0E0A\0E34\0E01 %0 \0E43\0E19\0E04\0E2D\0E25\0E40\0E25\0E47\0E01\0E0A\0E31\0E19\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481739828402548)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E1A\0E1A\0E19\0E35\0E49\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E23\0E2B\0E31\0E2A "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535257037402593)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E14\0E2A\0E2D\0E1A\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E07\0E32\0E19\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429607495402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429712838402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E31\0E27\0E40\0E25\0E37\0E2D\0E01\0E01\0E32\0E23\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E40\0E1E\0E08')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429895964402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429908041402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E1C\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430004179402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0B\0E48\0E2D\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429466083402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E35\0E48\0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E23\0E27\0E21\0E43\0E19\0E2B\0E19\0E49\0E32\0E19\0E35\0E49  \0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E35\0E48\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2D\0E32\0E08\0E44\0E21\0E48\0E41\0E2A\0E14\0E07\0E2B\0E32\0E01\0E04\0E38\0E13\0E44\0E21\0E48\0E44\0E14\0E49\0E2D\0E22\0E39\0E48\0E43\0E19\0E1A\0E23\0E34\0E1A\0E17\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E17\0E35\0E48\0E40\0E2B\0E21\0E32\0E30\0E2A\0E21\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48\0E21\0E35\0E2A\0E34\0E17\0E18\0E34\0E4C\0E17\0E35\0E48\0E40\0E2B\0E21\0E32\0E30\0E2A\0E21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429547961402508)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E1E\0E08\0E19\0E35\0E49\0E1B\0E23\0E31\0E1A\0E41\0E15\0E48\0E07\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535505822402593)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E31\0E1A\0E25\0E31\0E01\0E29\0E13\0E30\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19\0E19\0E35\0E49\0E15\0E32\0E21\0E17\0E35\0E48\0E15\0E49\0E2D\0E07\0E01\0E32\0E23\0E14\0E49\0E27\0E22\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E2A\0E44\0E15\0E25\0E4C\0E18\0E35\0E21 \0E42\0E1B\0E23\0E14\0E40\0E25\0E37\0E2D\0E01\0E2A\0E44\0E15\0E25\0E4C\0E18\0E35\0E21\0E08\0E32\0E01\0E23\0E32\0E22\0E01\0E32\0E23\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07\0E41\0E25\0E30\0E04\0E25\0E34\0E01\0E43\0E0A\0E49\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115536378902402594)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E1C\0E25\0E1E\0E37\0E49\0E19\0E17\0E35\0E48')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535476773402593)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E2A\0E44\0E15\0E25\0E4C\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E02\0E2D\0E07\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115535398719402593)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E25\0E31\0E01\0E29\0E13\0E30 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478389203402545)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E14\0E31\0E0A\0E19\0E35\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E43\0E19\0E01\0E32\0E23\0E2A\0E23\0E38\0E1B\0E23\0E27\0E21 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115381692504402472)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E32\0E15\0E4C\0E1E\0E38\0E15 CLOB \0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E23\0E2D\0E07\0E23\0E31\0E1A\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478031577402545)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E22\0E01\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E15\0E49\0E2D\0E07\0E2D\0E22\0E39\0E48\0E17\0E35\0E48\0E08\0E38\0E14\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E02\0E2D\0E07\0E2D\0E32\0E40\0E23\0E22\0E4C\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478118878402545)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E14\0E31\0E0A\0E19\0E35\0E01\0E25\0E38\0E48\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E43\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115395624433402483)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E1B\0E2D\0E23\0E4C\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115400878668402486)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E1B\0E2D\0E23\0E4C\0E15\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19 XML \0E42\0E14\0E22\0E43\0E0A\0E49 ORDS \0E40\0E1B\0E47\0E19\0E40\0E0B\0E34\0E23\0E4C\0E1F\0E40\0E27\0E2D\0E23\0E4C\0E01\0E32\0E23\0E1E\0E34\0E21\0E1E\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478440416402545)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E14\0E31\0E0A\0E19\0E35\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E43\0E19\0E44\0E2E\0E44\0E25\0E15\0E4C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394142288402482)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E01\0E32\0E23\0E40\0E2D\0E47\0E01\0E0B\0E4C\0E1B\0E2D\0E23\0E4C\0E15\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115478280301402545)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E14\0E31\0E0A\0E19\0E35\0E01\0E25\0E38\0E48\0E21\0E2B\0E25\0E31\0E01\0E17\0E35\0E48\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E43\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115503486494402566)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %1 \0E02\0E2D\0E07\0E15\0E32\0E23\0E32\0E07 %0 \0E40\0E1B\0E47\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E02\0E49\0E2D\0E21\0E39\0E25\0E40\0E09\0E1E\0E32\0E30 "GENERATED ALWAYS" \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E27\0E48\0E32\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E41\0E21\0E1B\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E21\0E32\0E44\0E1B\0E22\0E31\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %1 \0E43\0E19\0E44\0E14\0E2D\0E30\0E25\0E47\0E2D\0E01\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420836549402501)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E48\0E27\0E07\0E40\0E27\0E25\0E32\0E04\0E2D\0E21\0E21\0E34\0E15\0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E15\0E48\0E33\0E40\0E01\0E34\0E19\0E44\0E1B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115420905414402501)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422115486402502)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E43\0E19\0E0B\0E35\0E40\0E25\0E04\0E40\0E15\0E2D\0E23\0E4C\0E41\0E16\0E27 "%0" \0E25\0E2D\0E07\0E15\0E23\0E27\0E08\0E2B\0E32\0E42\0E14\0E22\0E2D\0E31\0E15\0E42\0E19\0E21\0E31\0E15\0E34\0E2B\0E23\0E37\0E2D\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E42\0E04\0E23\0E07\0E2A\0E23\0E49\0E32\0E07 JSON')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430477295402508)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E40\0E27\0E34\0E23\0E4C\0E01\0E0A\0E35\0E17\0E43\0E19\0E44\0E1F\0E25\0E4C XLSX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430346600402508)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E40\0E27\0E34\0E23\0E4C\0E01\0E0A\0E35\0E17\0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E43\0E19\0E44\0E1F\0E25\0E4C XLSX')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115410510324402494)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E27\0E2D\0E23\0E4C\0E0A\0E31\0E19\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E02\0E2D\0E07\0E02\0E49\0E2D\0E21\0E39\0E25\0E43\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E44\0E14\0E49\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E44\0E1B\0E15\0E31\0E49\0E07\0E41\0E15\0E48\0E15\0E2D\0E19\0E17\0E35\0E48\0E1C\0E39\0E49\0E43\0E0A\0E49\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E2D\0E31\0E1B\0E40\0E14\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412992278402495)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E2D\0E31\0E1B\0E40\0E14\0E15\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E23\0E32\0E22\0E07\0E32\0E19: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517664234402578)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E41\0E1B\0E25\0E07\0E04\0E48\0E32 %0 \0E40\0E1B\0E47\0E19 SDO_GEOMETRY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457143863402529)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0 \0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25 %1 \0E41\0E1B\0E25\0E07\0E40\0E1B\0E47\0E19 VARCHAR2 \0E44\0E21\0E48\0E44\0E14\0E49!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464141799402534)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C "%0" \0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%1" \0E43\0E19\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405488982402490)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E1B\0E23\0E30\0E40\0E20\0E17\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C %0 \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2B\0E25\0E32\0E22\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115521089298402581)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C "\0E23\0E30\0E2B\0E27\0E48\0E32\0E07" \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387574298402477)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E30\0E1A\0E38\0E1B\0E23\0E30\0E40\0E20\0E17\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387411770402477)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E1B\0E23\0E30\0E40\0E20\0E17\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19\0E15\0E32\0E23\0E32\0E07 \0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 SQL \0E2B\0E23\0E37\0E2D\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 PL/SQL \0E04\0E37\0E19\0E04\0E48\0E32\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457284061402529)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E1E\0E32\0E23\0E4C\0E0B SQL \0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E25\0E49\0E21\0E40\0E2B\0E25\0E27!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464231802402534)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E15\0E33\0E41\0E2B\0E19\0E48\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0 \0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%1" \0E43\0E19\0E04\0E33\0E2A\0E31\0E48\0E07 SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115386068922402476)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E2B\0E25\0E32\0E22\0E2D\0E22\0E48\0E32\0E07\0E40\0E01\0E34\0E19\0E44\0E1B\0E43\0E19\0E1F\0E34\0E25\0E40\0E15\0E2D\0E23\0E4C\0E41\0E1A\0E1A\0E2B\0E25\0E32\0E22\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464021363402534)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387347023402477)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E19\0E37\0E49\0E2D\0E2B\0E32\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 PL/SQL \0E44\0E21\0E48\0E44\0E14\0E49\0E04\0E37\0E19\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115477273552402545)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST \0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E40\0E1E\0E37\0E48\0E2D\0E08\0E31\0E14\0E01\0E32\0E23\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23 DML \0E17\0E35\0E48\0E02\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115383277586402474)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1B\0E25\0E07 GeoJSON \0E40\0E1B\0E47\0E19 SDO_GEOMETRY (\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0) \0E43\0E0A\0E49\0E07\0E32\0E19\0E44\0E21\0E48\0E44\0E14\0E49\0E43\0E19\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384301783402474)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E41\0E1B\0E25\0E07 SDO_GEOMETRY (\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C %0) \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115391600239402480)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E31\0E01\0E02\0E23\0E30 %0 \0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E23\0E2D\0E07\0E23\0E31\0E1A\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E2D\0E31\0E01\0E29\0E23\0E04\0E31\0E48\0E19\0E2B\0E25\0E32\0E22\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115518957119402579)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E49\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E19\0E35\0E49\0E43\0E19\0E1A\0E23\0E34\0E1A\0E17\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115384470861402474)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E08\0E31\0E1A\0E04\0E39\0E48\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E44\0E21\0E48\0E15\0E23\0E07\0E01\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387211074402476)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E19\0E02\0E35\0E14\0E08\0E33\0E01\0E31\0E14\0E01\0E32\0E23\0E1C\0E39\0E01\0E21\0E31\0E14 ORDS OUT \0E20\0E32\0E22\0E43\0E19 \0E42\0E1B\0E23\0E14\0E25\0E14\0E08\0E33\0E19\0E27\0E19\0E41\0E16\0E27 DML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115465094632402535)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E1E\0E32\0E23\0E4C\0E0B\0E01\0E32\0E23\0E15\0E2D\0E1A\0E01\0E25\0E31\0E1A JSON \0E08\0E32\0E01\0E40\0E0B\0E34\0E23\0E4C\0E1F\0E40\0E27\0E2D\0E23\0E4C\0E23\0E30\0E22\0E30\0E44\0E01\0E25\0E44\0E21\0E48\0E44\0E14\0E49: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115387103944402476)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E1A\0E23\0E34\0E1A\0E17\0E17\0E35\0E48\0E44\0E21\0E48\0E17\0E23\0E32\0E1A\0E2B\0E23\0E37\0E2D\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115481677631402548)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E32\0E23\0E4C\0E40\0E0B\0E2D\0E23\0E4C\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E44\0E1F\0E25\0E4C\0E1B\0E23\0E30\0E40\0E20\0E17\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436233811402512)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C (\0E44\0E21\0E48\0E44\0E14\0E49\0E15\0E31\0E49\0E07 wwv_flow_api.set_credentials)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413295483402496)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E23\0E49\0E32\0E07\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E21\0E35\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115413161954402495)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E23\0E49\0E32\0E07\0E01\0E25\0E38\0E48\0E21\0E1C\0E39\0E49\0E43\0E0A\0E49\0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E21\0E35\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423402746402503)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E1A\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E0B\0E49\0E33\0E01\0E31\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423549452402503)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E42\0E2B\0E25\0E14\0E1C\0E39\0E49\0E43\0E0A\0E49 \0E25\0E49\0E21\0E40\0E2B\0E25\0E27\0E17\0E35\0E48\0E1C\0E39\0E49\0E43\0E0A\0E49 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433402171402510)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E27\0E23\0E08\0E30\0E44\0E14\0E49\0E42\0E2B\0E25\0E14\0E1C\0E39\0E49\0E43\0E0A\0E49 %0 \0E23\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433251320402510)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433380342402510)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E34\0E17\0E18\0E34\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433032085402510)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509530508402571)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E41\0E2A\0E14\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08 #COMPONENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429150518402507)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E2A\0E14\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08\0E44\0E21\0E48\0E44\0E14\0E49\0E40\0E19\0E37\0E48\0E2D\0E07\0E08\0E32\0E01\0E1F\0E2D\0E23\0E4C\0E21 HTML \0E22\0E31\0E07\0E44\0E21\0E48\0E40\0E1B\0E34\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115394401651402482)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E04\0E33\0E19\0E27\0E13\0E04\0E48\0E32\0E14\0E35\0E1F\0E2D\0E25\0E15\0E4C\0E23\0E32\0E22\0E01\0E32\0E23\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08 #COMPONENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428433556402507)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E01\0E32\0E23\0E04\0E33\0E19\0E27\0E13\0E42\0E1E\0E2A\0E15\0E4C\0E23\0E32\0E22\0E01\0E32\0E23\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08 #COMPONENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428344141402507)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E04\0E33\0E19\0E27\0E13\0E04\0E48\0E32\0E17\0E35\0E48\0E21\0E32\0E23\0E32\0E22\0E01\0E32\0E23\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E01\0E32\0E23\0E40\0E1E\0E08 #COMPONENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408161439402492)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E31\0E1A\0E2D\0E19\0E38\0E0D\0E32\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428685593402507)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E08\0E32\0E27\0E32\0E2A\0E04\0E23\0E34\0E1B\0E15\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428727429402507)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115429382854402507)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E40\0E23\0E34\0E48\0E21\0E15\0E49\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436544462402513)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E32\0E23\0E2D\0E31\0E1B\0E40\0E14\0E15 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115430791756402508)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ID \0E23\0E32\0E22\0E01\0E32\0E23\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115457010060402529)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E19\0E35\0E49\0E44\0E21\0E48\0E21\0E35\0E27\0E34\0E18\0E35\0E43\0E0A\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421551952402502)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E41\0E1C\0E19\0E20\0E39\0E21\0E34\0E25\0E49\0E21\0E40\0E2B\0E25\0E27 \0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E01\0E32\0E23\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E01\0E32\0E23\0E41\0E21\0E1B\0E17\0E35\0E48\0E21\0E32\0E41\0E25\0E30\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516393161402577)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E34\0E48\0E07\0E17\0E35\0E48\0E41\0E19\0E1A\0E02\0E19\0E32\0E14 %0 MB \0E40\0E01\0E34\0E19\0E02\0E19\0E32\0E14\0E2A\0E34\0E48\0E07\0E17\0E35\0E48\0E41\0E19\0E1A\0E2A\0E39\0E07\0E2A\0E38\0E14\0E17\0E35\0E48 %1 MB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422484708402502)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1E\0E32\0E23\0E32\0E21\0E34\0E40\0E15\0E2D\0E23\0E4C p_mail_id \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115539801252402596)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E21\0E35\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E2D\0E35\0E40\0E21\0E25\0E4C\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E2A\0E39\0E07\0E2A\0E38\0E14\0E15\0E48\0E2D\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E41\0E25\0E49\0E27 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403423241402488)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E23\0E30\0E1A\0E27\0E19\0E01\0E32\0E23\0E19\0E35\0E49\0E15\0E49\0E2D\0E07\0E40\0E23\0E35\0E22\0E01\0E43\0E0A\0E49\0E08\0E32\0E01\0E20\0E32\0E22\0E43\0E19\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422384260402502)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35\0E01\0E32\0E23\0E23\0E30\0E1A\0E38\0E04\0E48\0E32\0E17\0E35\0E48\0E40\0E1B\0E47\0E19\0E19\0E31\0E25\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1E\0E32\0E23\0E32\0E21\0E34\0E40\0E15\0E2D\0E23\0E4C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476369674402544)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E40\0E17\0E21\0E40\0E1E\0E25\0E17\0E2D\0E35\0E40\0E21\0E25\0E4C "%0" \0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115552883485402606)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1E\0E32\0E23\0E32\0E21\0E34\0E40\0E15\0E2D\0E23\0E4C\0E2D\0E34\0E19\0E2A\0E41\0E15\0E19\0E0B\0E4C SMTP_HOST_ADDRESS \0E15\0E49\0E2D\0E07\0E15\0E31\0E49\0E07\0E40\0E1B\0E47\0E19\0E2A\0E48\0E07\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422001904402502)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E1C\0E39\0E49\0E23\0E31\0E1A\0E02\0E49\0E2D\0E04\0E27\0E32\0E21\0E40\0E1E\0E37\0E48\0E2D\0E2A\0E48\0E07\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115542200004402598)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E40\0E0A\0E37\0E48\0E2D\0E21\0E15\0E48\0E2D SMTP \0E44\0E1B\0E22\0E31\0E07\0E40\0E0B\0E34\0E23\0E4C\0E1F\0E40\0E27\0E2D\0E23\0E4C\0E2D\0E35\0E40\0E21\0E25\0E4C\0E17\0E35\0E48\0E01\0E33\0E2B\0E19\0E14\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115516499572402577)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E40\0E23\0E35\0E22\0E01\0E43\0E0A\0E49 Ajax \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407896220402492)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 Ajax \0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506883235402569)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E17\0E33\0E07\0E32\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407985740402492)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E41\0E2A\0E14\0E07\0E1C\0E25\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517376043402578)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST "%0" \0E44\0E21\0E48\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 "\0E02\0E35\0E14\0E04\0E27\0E32\0E21\0E2A\0E32\0E21\0E32\0E23\0E16"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517263513402577)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST "%0" \0E44\0E21\0E48\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19 DML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517441037402578)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST "%0" \0E44\0E21\0E48\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E01\0E32\0E23\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115517559869402578)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST "%0" \0E44\0E21\0E48\0E21\0E35\0E1F\0E31\0E07\0E01\0E4C\0E0A\0E31\0E19\0E14\0E36\0E07\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405655024402490)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E23\0E2B\0E31\0E2A PLSQL \0E23\0E30\0E2B\0E27\0E48\0E32\0E07\0E01\0E32\0E23\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E1B\0E25\0E31\0E4A\0E01\0E2D\0E34\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412270019402495)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E04\0E48\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442837301402517)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25 %0 \0E41\0E1B\0E25\0E07\0E40\0E1B\0E47\0E19 VARCHAR2 \0E44\0E21\0E48\0E44\0E14\0E49!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528456078402587)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C "%0" \0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%1" \0E43\0E19\0E04\0E33\0E2A\0E31\0E48\0E07 SQL!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504751865402567)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E15\0E49\0E2D\0E07\0E23\0E30\0E1A\0E38\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32 (LOV) \0E2B\0E23\0E37\0E2D\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E17\0E35\0E48\0E21\0E35\0E0A\0E37\0E48\0E2D\0E2A\0E33\0E2B\0E23\0E31\0E1A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115506367061402568)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E33\0E19\0E27\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01\0E1C\0E34\0E14\0E43\0E19\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 SQL \0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E2A\0E33\0E2B\0E23\0E31\0E1A %0 \0E14\0E39\0E15\0E31\0E27\0E2D\0E22\0E48\0E32\0E07\0E02\0E2D\0E07\0E04\0E33\0E2A\0E31\0E48\0E07\0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528241291402587)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E44\0E14\0E49\0E23\0E30\0E1A\0E38\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557913261402610)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E48\0E32 %0 \0E17\0E35\0E48\0E1B\0E49\0E2D\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%1" \0E44\0E21\0E48\0E40\0E1B\0E47\0E19\0E15\0E31\0E27\0E40\0E25\0E02')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115509871594402571)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('%0 \0E21\0E35\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E1C\0E34\0E14\0E43\0E19\0E04\0E33\0E2A\0E31\0E48\0E07 SQL Column# %1 \0E04\0E37\0E2D %2 \0E41\0E15\0E48\0E15\0E49\0E2D\0E07\0E40\0E1B\0E47\0E19 %3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115528333191402587)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C "%0" \0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E41\0E2D\0E17\0E17\0E23\0E34\0E1A\0E34\0E27 "%1" \0E21\0E35\0E1B\0E23\0E30\0E40\0E20\0E17\0E02\0E49\0E2D\0E21\0E39\0E25 %2 \0E41\0E15\0E48\0E04\0E27\0E23\0E21\0E35 %3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115404900988402489)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E1E\0E1A\0E40\0E25\0E22\0E4C\0E40\0E2D\0E32\0E15\0E4C\0E23\0E32\0E22\0E07\0E32\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464931933402535)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E2A\0E21\0E1A\0E31\0E15\0E34\0E04\0E33\0E19\0E27\0E13\0E1C\0E25\0E23\0E27\0E21\0E43\0E0A\0E49\0E44\0E21\0E48\0E44\0E14\0E49\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E23\0E32\0E22\0E07\0E32\0E19\0E17\0E35\0E48\0E21\0E32\0E08\0E32\0E01\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25 REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115428547106402507)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('ERR-2904 \0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E17\0E32\0E07\0E25\0E31\0E14\0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115432808752402510)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14: \0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E23\0E30\0E1A\0E38\0E1B\0E23\0E30\0E40\0E20\0E17\0E17\0E32\0E07\0E25\0E31\0E14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115422881146402503)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E14\0E36\0E07\0E02\0E49\0E2D\0E21\0E39\0E25 authentication_scheme \0E43\0E19\0E41\0E2D\0E1B\0E1E\0E25\0E34\0E40\0E04\0E0A\0E31\0E19 %0 \0E44\0E21\0E48\0E44\0E14\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115496311029402560)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E21\0E35 ID \0E01\0E32\0E23\0E04\0E23\0E2D\0E1A\0E04\0E23\0E2D\0E07\0E2D\0E22\0E39\0E48\0E41\0E25\0E49\0E27\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E40\0E0B\0E2A\0E0A\0E31\0E19\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115433194901402510)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E35\0E40\0E21\0E25\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557373506402610)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E2A\0E34\0E17\0E18\0E34\0E4C\0E25\0E49\0E21\0E40\0E2B\0E25\0E27')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115459668041402531)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2D\0E22\0E48\0E32\0E07\0E19\0E49\0E2D\0E22\0E2B\0E19\0E36\0E48\0E07\0E04\0E38\0E01\0E01\0E35\0E49\0E17\0E35\0E48\0E15\0E31\0E49\0E07\0E04\0E48\0E32\0E43\0E19 apex_util.g_request_cookies \0E21\0E35\0E04\0E48\0E32\0E17\0E35\0E48\0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115442154325402517)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E2D\0E1A\0E01\0E25\0E31\0E1A\0E08\0E32\0E01\0E23\0E35\0E08\0E34\0E2A\0E15\0E23\0E35 UDDI \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115405704152402490)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'th'
,p_message_text=>unistr('URL \0E17\0E35\0E48\0E23\0E30\0E1A\0E38\0E44\0E21\0E48\0E44\0E14\0E49\0E04\0E37\0E19\0E04\0E48\0E32\0E40\0E2D\0E01\0E2A\0E32\0E23 WSDL \0E17\0E35\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115408286515402492)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E01\0E2A\0E32\0E23 WSDL \0E21\0E35\0E2B\0E25\0E32\0E22\0E01\0E32\0E23\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07 SOAP &PRODUCT_NAME. \0E23\0E2D\0E07\0E23\0E31\0E1A\0E40\0E09\0E1E\0E32\0E30 WSDL \0E17\0E35\0E48\0E21\0E35\0E01\0E32\0E23\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07 SOAP \0E40\0E14\0E35\0E22\0E27 \0E04\0E25\0E34\0E01 ''\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E40\0E27\0E47\0E1A\0E40\0E0B\0E2D\0E23\0E4C\0E27\0E34\0E2A\0E14\0E49\0E27\0E22\0E15\0E19\0E40\0E2D\0E07'' \0E40\0E1E\0E37\0E48\0E2D\0E17\0E33\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1A\0E23\0E34\0E01\0E32\0E23\0E19\0E35\0E49\0E15\0E48\0E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115476663805402544)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'th'
,p_message_text=>unistr('\0E01\0E32\0E23\0E15\0E2D\0E1A\0E01\0E25\0E31\0E1A\0E08\0E32\0E01\0E1A\0E23\0E34\0E01\0E32\0E23\0E44\0E21\0E48\0E43\0E0A\0E48 XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557202370402610)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E42\0E17\0E40\0E04\0E47\0E19\0E01\0E32\0E23\0E40\0E02\0E49\0E32\0E43\0E0A\0E49 OAuth \0E43\0E0A\0E49\0E07\0E32\0E19\0E44\0E21\0E48\0E44\0E14\0E49\0E2B\0E23\0E37\0E2D\0E2B\0E21\0E14\0E2D\0E32\0E22\0E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115520420684402581)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E38\0E13\0E21\0E35\0E04\0E33\0E02\0E2D\0E40\0E27\0E47\0E1A\0E40\0E0B\0E2D\0E23\0E4C\0E27\0E34\0E2A\0E40\0E01\0E34\0E19\0E08\0E33\0E19\0E27\0E19\0E2A\0E39\0E07\0E2A\0E38\0E14\0E15\0E48\0E2D\0E1E\0E37\0E49\0E19\0E17\0E35\0E48\0E17\0E33\0E07\0E32\0E19\0E41\0E25\0E49\0E27 \0E42\0E1B\0E23\0E14\0E15\0E34\0E14\0E15\0E48\0E2D\0E1C\0E39\0E49\0E14\0E39\0E41\0E25\0E23\0E30\0E1A\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115557406682402610)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E0B\0E34\0E23\0E4C\0E1F\0E40\0E27\0E2D\0E23\0E4C\0E15\0E2D\0E1A\0E01\0E25\0E31\0E1A\0E14\0E49\0E27\0E22\0E1B\0E23\0E30\0E40\0E20\0E17\0E42\0E17\0E40\0E04\0E47\0E19 OAuth \0E17\0E35\0E48\0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407619076402492)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E01\0E2A\0E32\0E23 WSDL\0E44\0E21\0E48\0E21\0E35\0E01\0E32\0E23\0E40\0E0A\0E37\0E48\0E2D\0E21\0E42\0E22\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A SOAP \0E0B\0E36\0E48\0E07\0E08\0E33\0E40\0E1B\0E47\0E19\0E15\0E49\0E2D\0E07\0E21\0E35\0E40\0E1E\0E37\0E48\0E2D\0E40\0E1E\0E34\0E48\0E21\0E01\0E32\0E23\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115403576804402488)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'th'
,p_message_text=>unistr('WSDL \0E19\0E35\0E49\0E15\0E49\0E2D\0E07\0E21\0E35\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E41\0E25\0E30\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E01\0E32\0E23\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A \0E42\0E1B\0E23\0E14\0E23\0E30\0E1A\0E38\0E0A\0E37\0E48\0E2D\0E1C\0E39\0E49\0E43\0E0A\0E49\0E41\0E25\0E30\0E23\0E2B\0E31\0E2A\0E1C\0E48\0E32\0E19\0E14\0E49\0E32\0E19\0E25\0E48\0E32\0E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115412370688402495)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E2D\0E47\0E19\0E08\0E34\0E19\0E01\0E32\0E23\0E41\0E2A\0E14\0E07\0E1C\0E25\0E44\0E21\0E48\0E40\0E02\0E49\0E32\0E43\0E08\0E40\0E2D\0E01\0E2A\0E32\0E23 WSDL \0E04\0E25\0E34\0E01 ''\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E40\0E27\0E47\0E1A\0E40\0E0B\0E2D\0E23\0E4C\0E27\0E34\0E2A\0E14\0E49\0E27\0E22\0E15\0E19\0E40\0E2D\0E07'' \0E40\0E1E\0E37\0E48\0E2D\0E17\0E33\0E01\0E32\0E23\0E2A\0E23\0E49\0E32\0E07\0E01\0E32\0E23\0E2D\0E49\0E32\0E07\0E2D\0E34\0E07\0E2A\0E33\0E2B\0E23\0E31\0E1A\0E1A\0E23\0E34\0E01\0E32\0E23\0E19\0E35\0E49\0E15\0E48\0E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115479238400402546)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E44\0E21\0E48\0E2A\0E32\0E21\0E32\0E23\0E16\0E1B\0E23\0E30\0E21\0E27\0E25\0E1C\0E25\0E2D\0E31\0E1B\0E40\0E14\0E15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115505010449402567)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E48\0E07\0E04\0E37\0E19\0E41\0E25\0E30\0E41\0E2A\0E14\0E07\0E02\0E2D\0E07\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E40\0E1B\0E47\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E40\0E14\0E35\0E22\0E27\0E01\0E31\0E19!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115504961296402567)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E23\0E32\0E22\0E01\0E32\0E23\0E04\0E48\0E32\0E44\0E21\0E48\0E21\0E35\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E2A\0E48\0E07\0E04\0E37\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436462221402513)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E14\0E36\0E07\0E04\0E48\0E32\0E02\0E2D\0E07\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460440777402532)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'th'
,p_message_text=>unistr('\0E02\0E49\0E2D\0E21\0E39\0E25\0E1F\0E2D\0E23\0E4C\0E21\0E15\0E32\0E23\0E32\0E07\0E1B\0E31\0E08\0E08\0E38\0E1A\0E31\0E19\0E40\0E01\0E48\0E32\0E40\0E01\0E34\0E19\0E44\0E1B \0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E21\0E32\0E44\0E14\0E49\0E21\0E35\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E41\0E25\0E49\0E27<br/> \0E04\0E25\0E34\0E01<strong><a href="%0">\0E17\0E35\0E48\0E19\0E35\0E48</a></strong> \0E40\0E1E\0E37\0E48\0E2D\0E25\0E30\0E17\0E34\0E49\0E07\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E02\0E2D\0E07\0E04\0E38\0E13\0E41\0E25\0E30\0E42\0E2B\0E25\0E14\0E02\0E49\0E2D\0E21\0E39\0E25\0E08\0E32\0E01\0E10\0E32\0E19\0E02\0E49\0E2D\0E21\0E39\0E25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418518055402499)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E43\0E19\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E2A\0E15\0E23\0E34\0E07\0E01\0E32\0E23\0E41\0E1A\0E48\0E07\0E2B\0E19\0E49\0E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418481902402499)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E01\0E33\0E2B\0E19\0E14\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E44\0E21\0E48\0E44\0E14\0E49:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418655668402499)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E23\0E32\0E22\0E07\0E32\0E19\0E01\0E32\0E23\0E41\0E17\0E19\0E17\0E35\0E48\0E2A\0E48\0E27\0E19\0E17\0E49\0E32\0E22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418712234402500)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E1E\0E32\0E23\0E4C\0E0B\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 SQL \0E25\0E49\0E21\0E40\0E2B\0E25\0E27:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423753292402503)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27\0E02\0E31\0E49\0E19\0E15\0E48\0E33\0E17\0E35\0E48\0E02\0E2D: %0, \0E41\0E16\0E27\0E17\0E35\0E48\0E1E\0E1A\0E41\0E15\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E41\0E2A\0E14\0E07: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421254469402501)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 #%0 (%1) \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E17\0E35\0E48\0E43\0E0A\0E49 HTML \0E15\0E49\0E2D\0E07\0E21\0E35\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115436398980402513)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E40\0E01\0E34\0E14\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14\0E02\0E13\0E30\0E40\0E23\0E35\0E22\0E01\0E2A\0E48\0E27\0E19\0E2B\0E31\0E27\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418855465402500)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0E23\0E32\0E22\0E07\0E32\0E19\0E02\0E49\0E2D\0E1C\0E34\0E14\0E1E\0E25\0E32\0E14:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115456510145402529)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'th'
,p_message_text=>unistr('\0E08\0E31\0E14\0E40\0E23\0E35\0E22\0E07\0E15\0E32\0E21\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E19\0E35\0E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421381329402501)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'th'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0E1E\0E32\0E23\0E4C\0E0B\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19\0E44\0E21\0E48\0E44\0E14\0E49 \0E42\0E1B\0E23\0E14\0E15\0E23\0E27\0E08\0E2A\0E2D\0E1A\0E23\0E39\0E1B\0E41\0E1A\0E1A\0E04\0E33\0E2A\0E31\0E48\0E07\0E02\0E2D\0E07\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460512544402532)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1F\0E2D\0E23\0E4C\0E21\0E19\0E35\0E49\0E21\0E35\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E17\0E35\0E48\0E44\0E21\0E48\0E44\0E14\0E49\0E1A\0E31\0E19\0E17\0E36\0E01 \0E04\0E25\0E34\0E01 "\0E15\0E01\0E25\0E07" \0E40\0E1E\0E37\0E48\0E2D\0E14\0E33\0E40\0E19\0E34\0E19\0E01\0E32\0E23\0E15\0E48\0E2D\0E42\0E14\0E22\0E44\0E21\0E48\0E1A\0E31\0E19\0E17\0E36\0E01\0E01\0E32\0E23\0E40\0E1B\0E25\0E35\0E48\0E22\0E19\0E41\0E1B\0E25\0E07\0E02\0E2D\0E07\0E04\0E38\0E13 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115464895820402535)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'th'
,p_message_text=>unistr('\0E2A\0E04\0E35\0E21\0E01\0E32\0E23\0E01\0E33\0E2B\0E19\0E14\0E2B\0E19\0E49\0E32\0E23\0E32\0E22\0E07\0E32\0E19 (%0) \0E44\0E21\0E48\0E23\0E2D\0E07\0E23\0E31\0E1A\0E01\0E31\0E1A\0E17\0E35\0E48\0E21\0E32\0E02\0E49\0E2D\0E21\0E39\0E25\0E17\0E35\0E48\0E40\0E25\0E37\0E2D\0E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115421119631402501)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C\0E01\0E32\0E23\0E2A\0E37\0E1A\0E04\0E49\0E19 #%0 (%1) \0E44\0E21\0E48\0E16\0E39\0E01\0E15\0E49\0E2D\0E07 \0E43\0E2B\0E49\0E43\0E0A\0E49\0E0A\0E37\0E48\0E2D\0E41\0E17\0E19\0E04\0E2D\0E25\0E31\0E21\0E19\0E4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423854906402503)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0 - %1 \0E08\0E32\0E01\0E21\0E32\0E01\0E01\0E27\0E48\0E32 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115462574862402533)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'th'
,p_message_text=>unistr('%0 - %1 \0E08\0E32\0E01\0E21\0E32\0E01\0E01\0E27\0E48\0E32 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115423634162402503)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'th'
,p_message_text=>unistr('\0E41\0E16\0E27 %0 - %1 \0E08\0E32\0E01 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115407589053402491)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'th'
,p_message_text=>unistr('%0 - %1 \0E08\0E32\0E01 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418944530402500)
,p_name=>'Y'
,p_message_language=>'th'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115425070237402504)
,p_name=>'YEAR'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115418108941402499)
,p_name=>'YEARS'
,p_message_language=>'th'
,p_message_text=>unistr('\0E1B\0E35')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115460677346402532)
,p_name=>'YES'
,p_message_language=>'th'
,p_message_text=>unistr('\0E43\0E0A\0E48')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4493)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4493)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\0E40\0E14\0E2A\0E01\0E4C\0E17\0E47\0E2D\0E1B')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4493
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4493)
,p_name=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\0E02\0E49\0E2D\0E04\0E27\0E32\0E21')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
