prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4488
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4488 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4488
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116284001832403960')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'tr'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4488)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113354'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4488)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4488)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4488)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4488)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4488)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4488)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.tr'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4488)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4488)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4488)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4488)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4488)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4488)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.tr'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4488)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4488)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4488)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4488)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4488)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4488)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.tr'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4488)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4488)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.tr'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4488)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4488)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.tr'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4488)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4488)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.tr'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4488)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4488)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4488)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.tr'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4488
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4488)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4488)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4488)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4488
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4488)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4488
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4488)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4488
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4488)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4488
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4488)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4488
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4488)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4488
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4488
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4488)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4488)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4488)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4488)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4488)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4488)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4488)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4488)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4488)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4488)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4488)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4488)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4488)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4488)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4488)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4488)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4488)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4488)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4488)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4488)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4488)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4488)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4488
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4488)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4488)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4488)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4488)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4488)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4488
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4488)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4488
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4488)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4488
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4488)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4488
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4488)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4488
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4488)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4488
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4488)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4488)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4488)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4488)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4488)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4488)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4488)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4488)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4488)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4488
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4488)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4488)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4488)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4488)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4488)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4488)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4488)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4488
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4488)
,p_page_name=>'winlov'
,p_page_title=>unistr('\0130leti\015Fim Kutusunu Ara')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Ara'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Kapat'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\0130leri &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \00D6nceki')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">Sat\0131r(lar) #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4488
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4488)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4488
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4488)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4488)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4488)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4488)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4488)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4488)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4488)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4488)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4488)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4488)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4488)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4488)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4488)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4488)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4488)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4488)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4488)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4488)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4488)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4488)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4488)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4488)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4488)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4488)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4488)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4488)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4488)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4488)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4488)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4488)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4488)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4488)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4488)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4488)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4488)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4488)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4488)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4488)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4488)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4488)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4488)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4488)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4488)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4488)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4488)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4488)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4488)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4488)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4488)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4488)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4488)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4488)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4488)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4488)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4488)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4488)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4488)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4488)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4488)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4488)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4488)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4488)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4488)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4488)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4488)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4488)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4488)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4488)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4488)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4488)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4488)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4488)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4488)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4488)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4488)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4488)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4488)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4488)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4488)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4488)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4488)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4488)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4488)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4488)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4488)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4488)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4488)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4488)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4488)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4488)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4488)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4488)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4488)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4488)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4488)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4488)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4488)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4488)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4488)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4488)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4488)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4488)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4488)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4488)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4488)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4488)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4488)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4488)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4488)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4488)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4488)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4488)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4488)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4488)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4488)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4488)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4488)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4488)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4488)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4488)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4488)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4488)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4488)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4488)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4488)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4488)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4488)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4488)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4488)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4488)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4488)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4488)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4488)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4488)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4488)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4488)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4488)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4488)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4488)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4488)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4488)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4488)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4488)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4488)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4488)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4488)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4488)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4488)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4488)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4488)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4488)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4488)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4488)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4488)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4488)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4488)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4488)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4488)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4488)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4488)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4488)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4488)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4488)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4488)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4488)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4488)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4488)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4488)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4488)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4488)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4488)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4488)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593608602402645)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580782662402635)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00F6netici')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580603595402635)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 Ad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637977155402679)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Fim Reddedildi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597683325402648)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 hesab\0131n\0131z olu\015Fturuldu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583298291402637)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'tr'
,p_message_text=>'Hesap kilitli.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573186596402629)
,p_name=>'AM_PM'
,p_message_language=>'tr'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707507993402731)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7i\015F Yap %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715693632402737)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'tr'
,p_message_text=>'(Etkin)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685164641402714)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ajax \00E7a\011Fr\0131s\0131, %1 i\00E7in %0 sunucu hatas\0131n\0131 d\00F6nd\00FCrd\00FC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615932649402662)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama di\011Fer ad\0131 "%0", benzersiz uygulama No olarak d\00F6n\00FC\015Ft\00FCr\00FClemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616086612402662)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" di\011Fer ad\0131na sahip uygulama mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605612139402654)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1816 Uygulama di\011Fer ad\0131 p_flow_alias_or_id (%0) d\00F6n\00FC\015Ft\00FCr\00FCl\00FCrken beklenmeyen hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698513532402724)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama sa\011Flama toplam\0131, ayn\0131 uygulaman\0131n \00E7al\0131\015Fma alanlar\0131nda devreye al\0131n\0131p al\0131nmad\0131\011F\0131n\0131 belirlemenin kolay bir yoludur. E\015Fle\015Fme olup olmad\0131\011F\0131n\0131 belirlemek i\00E7in bu sa\011Flama toplam\0131n\0131 kar\015F\0131la\015Ft\0131rabilirsiniz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591432682402643)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama fonksiyonu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576832797402632)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama fonksiyonu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740314187402755)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'tr'
,p_message_text=>unistr('Oracle Bulut Kimlik Y\00F6netimi taraf\0131ndan d\00F6nd\00FCr\00FClen Ge\00E7ici Kullan\0131c\0131 Ad\0131 %0, etki alan\0131 %1 i\00E7in yetkilendirilmemi\015F!<br/>L\00FCtfen <a href="&LOGOUT_URL.">yeniden oturum a\00E7\0131n</a> ve yetkilendirilmi\015F bir ge\00E7ici kullan\0131c\0131 ad\0131 belirtin veya URL''nizi de\011Fi\015Ftiri')
||'n.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574591933402631)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'tr'
,p_message_text=>unistr('Hesab\0131n\0131z "%0" \00E7al\0131\015Fma alan\0131 "%1" i\00E7in gerekli geli\015Ftirme yetkilerine (DB_DEVELOPER veya DB_ADMINISTRATOR)<br/>sahip de\011Fil! L\00FCtfen yetkiler sa\011Fland\0131ktan sonra <a href="&LOGOUT_URL.">tekrar oturum a\00E7\0131n</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573652708402630)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Oracle Bulut Kimlik Y\00F6netimi taraf\0131ndan d\00F6nd\00FCr\00FClen Ge\00E7ici Kullan\0131c\0131 Ad\0131 ge\00E7erli \00E7al\0131\015Fma alan\0131 i\00E7in yetkilendirilmemi\015F!<br/>L\00FCtfen <a href="&LOGOUT_URL.">yeniden oturum a\00E7\0131n</a> ve yetkilendirilmi\015F bir ge\00E7ici kullan\0131c\0131 ad\0131 belirtin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574692419402631)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCvenlik nedeniyle URL''deki etki alan\0131 yoluyla bu \00E7al\0131\015Fma alan\0131 uygulamalar\0131n\0131n \00E7al\0131\015Ft\0131r\0131lmalar\0131na izin verilmez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591162966402643)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen veritaban\0131 y\00F6neticinizden $OH/rdbms/admin/catldap.sql komutunu \00E7al\0131\015Ft\0131rmas\0131n\0131 isteyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591092484402643)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'tr'
,p_message_text=>unistr('SYS.DBMS_LDAP paketi mevcut de\011Fil veya ge\00E7ersiz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590928423402643)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenleme LDAP (Hafif Dizin Eri\015Fimi \0130leti\015Fim Kural\0131) kullan\0131c\0131 fonksiyonu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591293889402643)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('LDAP (Hafif Dizin Eri\015Fimi \0130leti\015Fim Kural\0131) do\011Frulamas\0131 i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592009986402644)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'tr'
,p_message_text=>unistr('login_page prosed\00FCr\00FCne ili\015Fkin p_flow_page ba\011F\0131ms\0131z de\011Fi\015Fkeninde hata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591689468402644)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'tr'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1 i\00E7inde ge\00E7ersiz p_session.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639506543402680)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'tr'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2 i\00E7in hatal\0131 ba\011F\0131ms\0131z de\011Fi\015Fken.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591789706402644)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum a\00E7ma prosed\00FCr\00FCne bo\015F kullan\0131c\0131 ad\0131 iletildi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580510505402635)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen tekrar oturum a\00E7mak i\00E7in <span id="apex_login_throttle_sec">%0</span> saniye bekleyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581802322402636)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum a\00E7ma denemesi engellendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637305728402678)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama "%0" bulunamad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582188628402636)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCvenlik grubu No bo\015F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591583798402643)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama sonras\0131 i\015Flemi y\00FCr\00FCt\00FCl\00FCrken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591334813402643)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama \00F6ncesi i\015Flemi i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592541842402644)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00FCtfen URL''yi Parola S\0131f\0131rlama iste\011Fini ba\015Flatt\0131\011F\0131n\0131z taray\0131c\0131da a\00E7\0131n. Parola S\0131f\0131rlama URL''sine t\0131klarsan\0131z ve oturum a\00E7ma sayfas\0131na y\00F6nlendirilirseniz'),
unistr('l\00FCtfen Parola S\0131f\0131rlama''y\0131 tekrar ba\015Flat\0131n ve taray\0131c\0131y\0131'),
unistr('a\00E7\0131k b\0131rak\0131n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737809398402753)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola S\0131f\0131rlama URL''si')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574840168402631)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 Kaynak Y\00F6neticisi t\00FCketici grubu, %1 i\00E7in yetkilendirilmemi\015F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574912690402631)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen eksik yetkiyi sa\011Flamak \00FCzere DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP kullan\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602920428402652)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum sentry fonksiyonu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603098035402652)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum do\011Frulama fonksiyonu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603297122402652)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen %0 y\00F6neticinizden Oracle Uygulama Sunucusu Tek Ad\0131ml\0131 Oturum A\00E7ma i\00E7in motoru konfig\00FCre etmesini isteyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612727956402659)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'tr'
,p_message_text=>unistr('%1 belirtecinde tek ad\0131ml\0131 oturum a\00E7ma taraf\0131ndan ge\00E7ersiz %0 d\00F6nd\00FCr\00FCld\00FC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591922390402644)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen do\011Frulama \015Femas\0131n\0131 d\00FCzenleyin ve uygulama ad\0131n\0131 ekleyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612476509402659)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 prosed\00FCr\00FC i\00E7in \00E7a\011Fr\0131y\0131 yapan ge\00E7ersiz:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612666983402659)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('urlc belirtecinde ge\00E7ersiz uygulama oturumu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612288881402659)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'tr'
,p_message_text=>unistr('portal_sso_redirect i\00E7inde hata: eksik uygulama kay\0131t bilgileri: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603169127402652)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'tr'
,p_message_text=>unistr('WWSEC_SSO_ENABLER_PRIVATE paketi mevcut de\011Fil veya ge\00E7ersiz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115591865580402644)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama \015Femas\0131nda kay\0131tl\0131 ortak uygulama ad\0131 bulunam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612385300402659)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen bu uygulamay\0131 kurulum k\0131lavuzunda a\00E7\0131kland\0131\011F\0131 gibi kaydedin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603349373402652)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('SSO (Tek Ad\0131ml\0131 Oturum A\00E7ma) do\011Frulamas\0131 i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712775400402734)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'tr'
,p_message_text=>unistr('Yetkilendirilmemi\015F URL: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602781239402652)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulama i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574731561402631)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma alan\0131 "%0" etkin de\011Fil. Y\00F6neticiniz ile ileti\015Fime ge\00E7in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575104923402631)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'tr'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581523525402636)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Fim, Uygulama g\00FCvenlik kontrol\00FC taraf\0131ndan reddedildi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581654251402636)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Fim, Sayfa g\00FCvenlik kontrol\00FC taraf\0131ndan reddedildi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581775392402636)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Yetkilendirme i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645146163402684)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'tr'
,p_message_text=>unistr('%1 kullan\0131larak %0 ile olu\015Fturuldu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645273360402684)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'tr'
,p_message_text=>'sevgi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703055789402727)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkinlik A\00E7\0131klamas\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702817116402727)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'tr'
,p_message_text=>unistr('Biti\015F Tarihi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703132228402727)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'tr'
,p_message_text=>'Etkinlik No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702707246402727)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7 Tarihi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702990585402727)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkinlik Ba\015Fl\0131\011F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593523985402645)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Sa\011Flama toplam\0131 i\00E7erik hatas\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593437735402645)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Sa\011Flama toplam\0131 format hatas\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657464992402693)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'tr'
,p_message_text=>unistr('Panoya kopyaland\0131.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657179894402693)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu taray\0131c\0131, bir d\00FC\011Fme veya men\00FCden kopyalamay\0131 desteklemiyor. Ctrl+C veya Command+C deneyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645642907402684)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'tr'
,p_message_text=>'Bildirimi Kapat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701682455402726)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'tr'
,p_message_text=>'Kontrast'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696161148402722)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696029897402722)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700240617402725)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# ge\00E7erli bir renk olmal\0131d\0131r. \00D6rnek :%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695945328402722)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir renk se\00E7in')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696284734402722)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Renk format\0131n\0131 de\011Fi\015Ftir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735448190402752)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Ferler Listesi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735508153402752)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eunun i\00E7in listeyi a\00E7: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715735871402737)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'tr'
,p_message_text=>unistr('(Tamamland\0131)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608052627402656)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama y\00F6neticiniz ile ileti\015Fime ge\00E7in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622437775402667)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uygulama y\00F6neticiniz ile ileti\015Fime ge\00E7in.'),
unistr('Bu vaka ile ilgili detaylara hata ay\0131klama no "%0" yoluyla ula\015F\0131labilir.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700592710402726)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'tr'
,p_message_text=>unistr('Kaydetmeden \00F6nce hatalar\0131 d\00FCzeltin.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646581581402685)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 e\015Fle\015Fme bulundu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646453625402685)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'tr'
,p_message_text=>unistr('E\015Fle\015Fme bulunamad\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716264490402737)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli \0130lerleme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700954480402726)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00F6\011Fesinde belirtilen dosya, APEX_APPLICATION_TEMP_FILES i\00E7inde mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689474396402718)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'tr'
,p_message_text=>unistr('Veritaban\0131ndaki verilerin mevcut s\00FCr\00FCm\00FC, kullan\0131c\0131n\0131n g\00FCncelleme i\015Flemini ba\015Flatmas\0131ndan bu yana de\011Fi\015Fti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658519155402694)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCkleme Yapma')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705580729402729)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6n i\015Fleme hatas\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705361529402729)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r ekle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719400117402739)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ra Eylemi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705490995402729)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r\0131 g\00FCncelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646951042402685)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7\0131lan Takvim Men\00FCs\00FC: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569567329402627)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569673669402627)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705709993402729)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# bir de\011Fere sahip olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705698546402729)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# ge\00E7erli bir tarih olmal\0131d\0131r, \00F6rne\011Fin %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573298304402630)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# %0 ile %1 aras\0131nda olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573392014402630)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, %0 tarihinde veya bu tarihten sonra olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573477370402630)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, %0 tarihinde veya bu tarihten \00F6nce olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650416425402688)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, belirtilen %0 maksimum tarihinden sonrad\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650840183402688)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# %0 format\0131yla e\015Fle\015Fmiyor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650311419402688)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, belirtilen %0 minimum tarihinden \00F6ncedir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650553696402688)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, ge\00E7erli %0 - %1 aral\0131\011F\0131nda de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650774096402688)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, ge\00E7erli%0 - %1 y\0131l aral\0131\011F\0131nda de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700896418402726)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ptal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728067360402746)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'tr'
,p_message_text=>'Kapat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730041354402748)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yard\0131m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700627853402726)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'tr'
,p_message_text=>'Tamam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700799803402726)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'tr'
,p_message_text=>'Kaydet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606964086402655)
,p_name=>'APEX.ERROR'
,p_message_language=>'tr'
,p_message_text=>'Hata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574381415402630)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('Hata i\015Flemeyi geri \00E7a\011F\0131rma y\00FCr\00FCt\00FCl\00FCrken \015Fu hata olu\015Ftu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583080673402637)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Hata sayfas\0131 boyan\0131rken hata olu\015Ftu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575038545402631)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'tr'
,p_message_text=>'Dahili Hata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714808832402736)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Y\00F6neticiniz ile ileti\015Fime ge\00E7in.'),
unistr('Bu vaka ile ilgili detaylara hata ay\0131klama no "%0" yoluyla ula\015F\0131labilir.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709145807402732)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'tr'
,p_message_text=>unistr('Veritaban\0131 sadece salt okunur eri\015Fim i\00E7in a\00E7\0131k.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739714102402755)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'tr'
,p_message_text=>unistr('ORA-28353: Anahtar c\00FCdan a\00E7\0131lamad\0131. Uygulama verilerine mevcut durumda eri\015Filemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709250858402732)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu sayfa kullan\0131lam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576774505402632)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'tr'
,p_message_text=>unistr('Teknik Bilgiler (yaln\0131zca geli\015Ftiriciler taraf\0131ndan g\00F6r\00FClebilir)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672801906402705)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'tr'
,p_message_text=>unistr('Hata Mesaj\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686782428402716)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'tr'
,p_message_text=>'Beklenen format: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653497945402690)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 zaten Eri\015Fim Kontrol Listesinde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653366030402690)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen a\015Fa\011F\0131daki %0 kullan\0131c\0131n\0131n <strong>%1</strong> eri\015Fim kontrol listesine eklendi\011Fini teyit edin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653859978402691)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'tr'
,p_message_text=>unistr('Tekrarlanan kullan\0131c\0131 mevcut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653560447402691)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta adresinde (@) i\015Fareti eksik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653697042402691)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'tr'
,p_message_text=>'E-posta adresinde nokta (.) eksik.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653700240402691)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 ad\0131 \00E7ok uzun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654097670402691)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'tr'
,p_message_text=>unistr('Yaln\0131zca uygulama eri\015Fim kontrol listesinde tan\0131mlanan kullan\0131c\0131lar bu uygulamaya eri\015Febilir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654118887402691)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('Beklenmeyen Eri\015Fim Kontrol\00FC Ayar De\011Feri :%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653972665402691)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulanm\0131\015F t\00FCm kullan\0131c\0131lar bu uygulamaya eri\015Febilir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696736502402723)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'tr'
,p_message_text=>unistr('Devre d\0131\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696676205402723)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'tr'
,p_message_text=>'Etkin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696925033402723)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0: Devre D\0131\015F\0131 B\0131rak\0131ld\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696862682402723)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0: Etkinle\015Ftirildi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696533182402723)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'tr'
,p_message_text=>unistr('tan\0131mlanmad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689687532402718)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ndir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646171478402685)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 Filtresi Uyguland\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687209862402716)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'tr'
,p_message_text=>'Uygula'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572118949402629)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7ubuk Grafik')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699919787402725)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'tr'
,p_message_text=>unistr('Di\011Ferleri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572215939402629)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'tr'
,p_message_text=>'Pasta Grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698634252402724)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'tr'
,p_message_text=>'Grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571916815402629)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Say\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687703627402716)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'tr'
,p_message_text=>'Temizle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687843425402716)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Temizle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687905821402716)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00F6\011Fesini temizle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705122258402729)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'tr'
,p_message_text=>unistr('Faset %0 taraf\0131ndan referans g\00F6sterilen s\00FCtun %1 kullan\0131lam\0131yor veya yetkilendirilmemi\015F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562310199402621)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6sterilecek Filtreleri se\00E7in')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644361355402683)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonu\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644495028402684)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 se\00E7ildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647054784402686)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'tr'
,p_message_text=>'Mevcut filtreler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563877196402622)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'tr'
,p_message_text=>'Filtre listesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703654499402728)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'tr'
,p_message_text=>unistr('Farkl\0131 de\011Fer s\0131n\0131r\0131 (%0), faset %1 i\00E7in a\015F\0131ld\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689240887402717)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Faset %0, DATE veya TIMESTAMP s\00FCtunlar i\00E7in desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687353234402716)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00F6\011Fesini filtrele')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687424592402716)
,p_name=>'APEX.FS.GO'
,p_message_language=>'tr'
,p_message_text=>'Git'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688822527402717)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('e\015Fittir %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572976889402629)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7erir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572617913402629)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'tr'
,p_message_text=>unistr('bundan b\00FCy\00FCkt\00FCr: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572793518402629)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'tr'
,p_message_text=>unistr('bundan b\00FCy\00FCk veya e\015Fittir: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572401233402629)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'tr'
,p_message_text=>unistr('bundan k\00FC\00E7\00FCkt\00FCr: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572581026402629)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'tr'
,p_message_text=>unistr('bundan k\00FC\00E7\00FCk veya e\015Fittir: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572829771402629)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \0130le ba\015Flar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575324983402631)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 veri tipi (%1), Giri\015F Alan\0131 faset i\00E7in desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565579868402624)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7ok De\011Ferli fasetler, 12.2 veya daha y\00FCksek veritabanlar\0131n\0131 gerektirir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689062538402717)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'tr'
,p_message_text=>unistr('Faset %0 i\00E7in sa\011Flanan arama s\00FCtunu yok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562415687402621)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'tr'
,p_message_text=>'Daha Fazla Filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644588389402684)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'tr'
,p_message_text=>unistr('Aral\0131k Ba\015Flang\0131c\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688586122402717)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'tr'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688678364402717)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 de\011Ferinin \00FCzerinde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688717341402717)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 de\011Ferinin alt\0131nda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644666655402684)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'tr'
,p_message_text=>unistr('Aral\0131k Sonu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707499469402731)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Ferler Listesi \00F6\011Fesi #%2 ("%1") aral\0131k faseti %0 i\00E7in ge\00E7ersiz ("|" ay\0131r\0131c\0131s\0131 eksik).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688908911402717)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun DATE veya TIMESTAMP oldu\011Fu i\00E7in Aral\0131k faseti %0 i\00E7in Manuel Giri\015F mevcut durumda desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688228935402717)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'tr'
,p_message_text=>'-'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572049040402629)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafi\011Fi Kald\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641111124402681)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131f\0131rla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687695214402716)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Ara'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687551541402716)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'tr'
,p_message_text=>'Ara...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688449278402717)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'tr'
,p_message_text=>unistr('- Se\00E7 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571815746402629)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafi\011Fi G\00F6ster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688072347402716)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'tr'
,p_message_text=>unistr('Daha Az G\00F6ster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688191966402717)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'tr'
,p_message_text=>unistr('Daha Fazla G\00F6ster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115688305054402717)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 y\0131ld\0131z ve yukar\0131s\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646026355402685)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'tr'
,p_message_text=>unistr('Filtre \00F6nerileri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689199112402717)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Metin Alan\0131 faset %0 mevcut durumda sadece NUMBER s\00FCtunlar i\00E7in destekleniyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562287599402621)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam Sat\0131r Say\0131s\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705251797402729)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 veri tipi (%1), fasetli arama i\00E7in desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697108927402723)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'tr'
,p_message_text=>'Hataya git'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654724658402691)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Birle\015Ftir.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662375408402697)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'tr'
,p_message_text=>'Kontrol kesmesini daralt'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654816213402691)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>'Kontrol kesmesi.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662292325402697)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'tr'
,p_message_text=>unistr('Kontrol kesmesini geni\015Flet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740939414402756)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662041826402697)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sat\0131r silindi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732488531402749)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'tr'
,p_message_text=>'Tekrarlanan kimlik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651752861402689)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130lk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655070913402692)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Grup \00FCstbilgisi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654997306402692)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00DCstbilgi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651852932402689)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'tr'
,p_message_text=>'Son'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671805914402705)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'tr'
,p_message_text=>unistr('Daha Fazla Sat\0131r Y\00FCkle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651598615402689)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655197706402692)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa sat\0131rlar\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651935373402689)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'tr'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652052380402689)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'tr'
,p_message_text=>'%0 - %1 / %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708034149402731)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa Se\00E7imi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651638826402689)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'tr'
,p_message_text=>'Geri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732274400402749)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'tr'
,p_message_text=>'Eklendi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732306044402749)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fi\015Ftirildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740747172402756)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r %0, S\00FCtun %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740869062402756)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732101357402749)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'tr'
,p_message_text=>'Silindi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655366050402692)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r \00FCstbilgisi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650922096402688)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 h\00FCcre se\00E7ildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652139424402689)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sat\0131r se\00E7ildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692449327402720)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662131564402697)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'tr'
,p_message_text=>'Sayfa %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655230240402692)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655419949402692)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Artan D\00FCzende S\0131raland\0131 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655584978402692)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Azalan D\00FCzende S\0131raland\0131 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651051051402689)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Artan D\00FCzende S\0131rala')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651304451402689)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'tr'
,p_message_text=>unistr('Artan D\00FCzende S\0131rala %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651194260402689)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Azalan D\00FCzende S\0131rala')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651420141402689)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'tr'
,p_message_text=>unistr('Azalan D\00FCzende S\0131rala %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115651251284402689)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralama Yapma')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661995307402697)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'tr'
,p_message_text=>'Toplam %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588377115402641)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" i\00E7in HTTP iste\011Fi ba\015Far\0131s\0131z oldu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729686833402747)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'tr'
,p_message_text=>unistr('Grid Se\00E7imi Liste %0 s\00FCtun %1 sat\0131r. Ok tu\015Flar\0131n\0131 kullan\0131n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661801754402697)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'tr'
,p_message_text=>unistr('Liste %0 sat\0131rlar\0131n\0131 se\00E7in. Ok tu\015Flar\0131n\0131 kullan\0131n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740526526402755)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Grid %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648610063402687)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'tr'
,p_message_text=>'Eylemler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649614315402688)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'tr'
,p_message_text=>'Ekle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649504195402687)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Ekle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734002652402751)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Birle\015Ftir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719566919402739)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'tr'
,p_message_text=>'Toplama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721233527402741)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677697676402709)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm Metin S\00FCtunlar\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678863356402710)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'tr'
,p_message_text=>'Alternatif'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679996950402711)
,p_name=>'APEX.IG.AND'
,p_message_language=>'tr'
,p_message_text=>'ve'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699394501402725)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'tr'
,p_message_text=>unistr('Farkl\0131 Olanlar\0131 Yakla\015F\0131k Say')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735014982402751)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'tr'
,p_message_text=>unistr('Genel Yakla\015F\0131k Say\0131m Fark\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718182891402738)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'tr'
,p_message_text=>'Alan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720055092402740)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'tr'
,p_message_text=>'Artan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678900653402710)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'tr'
,p_message_text=>'Yetkilendirme'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734179447402751)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'tr'
,p_message_text=>'Otomatik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699706606402725)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'tr'
,p_message_text=>'Ortalama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734756566402751)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'tr'
,p_message_text=>'Genel Ortalama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717614762402738)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Etiket Ekseni Ba\015Fl\0131\011F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717864169402738)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'tr'
,p_message_text=>unistr('Ondal\0131k Basamaklar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717737499402738)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer Ekseni Ba\015Fl\0131\011F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723840064402743)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'tr'
,p_message_text=>'Arka Plan Rengi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718294473402738)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7ubuk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674275423402706)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'tr'
,p_message_text=>unistr('aras\0131nda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725065358402744)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'tr'
,p_message_text=>unistr('Her \0130kisi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718363861402739)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kabarc\0131k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649898267402688)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ptal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679868620402710)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00FCy\00FCk/K\00FC\00E7\00FCk Harf Duyarl\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735604801402752)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'tr'
,p_message_text=>unistr('(B\00FCy\00FCk/K\00FC\00E7\00FCk Harf Duyarl\0131)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706542020402730)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fi\015Fiklikler kaydedildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650287941402688)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCn\00FCm\00FC De\011Fi\015Ftir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680931844402711)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'tr'
,p_message_text=>'Grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677494097402709)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sorgunuz grafik ba\015F\0131na maksimum %0 veri noktas\0131n\0131 a\015F\0131yor. L\00FCtfen temel sorgunuzdaki kay\0131tlar\0131n say\0131s\0131n\0131 azaltmak i\00E7in bir filtre uygulay\0131n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648507850402687)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655854142402692)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'tr'
,p_message_text=>'Temizle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717186749402738)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Kapat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724040246402743)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'tr'
,p_message_text=>'Renkler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700148329402725)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nizleme')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679239283402710)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648750705402687)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725821635402744)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Amac\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679346661402710)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'tr'
,p_message_text=>unistr('Karma\015F\0131k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648954151402687)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'tr'
,p_message_text=>'Hesapla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674856111402707)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7erir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681195450402711)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'tr'
,p_message_text=>'Kontrol Kesmesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655616079402692)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'tr'
,p_message_text=>'Panoya Kopyala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655787174402692)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'tr'
,p_message_text=>'Kopyala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699137655402725)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'tr'
,p_message_text=>'Say'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699217848402725)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'tr'
,p_message_text=>unistr('Farkl\0131 Olanlar\0131 Say')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734992654402751)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'tr'
,p_message_text=>unistr('Genel Say\0131m Fark\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734856563402751)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'tr'
,p_message_text=>unistr('Genel Say\0131m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732582725402749)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 Olu\015Ftur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677873607402709)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'tr'
,p_message_text=>'Veri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725617682402744)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri T\00FCr\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725257818402744)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'tr'
,p_message_text=>'Tarih'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706395121402730)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Tarih De\011Feri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675560999402707)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00FCnler')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678579718402709)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ayar \00D6nde\011Ferleri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678331380402709)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCr \00D6nde\011Feri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649789079402688)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'tr'
,p_message_text=>'Sil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726833744402745)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu raporu silmek istedi\011Finize emin misiniz?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682935250402713)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r\0131 Sil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681734282402712)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131rlar\0131 Sil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720130774402740)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'tr'
,p_message_text=>'Azalan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680651283402711)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'tr'
,p_message_text=>'Detail'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648253159402686)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Detay G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708818603402732)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00F6n')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680324314402711)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'tr'
,p_message_text=>unistr('Devre d\0131\015F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674933201402707)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7ermez')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675100663402707)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Fununla ba\015Flamaz:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718472394402739)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'tr'
,p_message_text=>'Halka'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681356966402712)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ndir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580029942402635)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'tr'
,p_message_text=>'Sadece Veri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727827598402746)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('Format Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592697418402644)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ndirme Format %0 etkin de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720894478402740)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Tekrarlanan Birle\015Ftirme')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720956858402741)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'tr'
,p_message_text=>'Tekrarlanan Kontrol Kesmesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682868135402713)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r\0131 \00C7o\011Falt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681656898402712)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Tekrarlanan Sat\0131rlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649333575402687)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719993885402740)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik D\00FCzenle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731445820402749)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Grup D\00FCzenleme \00D6l\00E7\00FCt\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727440540402746)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'tr'
,p_message_text=>unistr('Kapal\0131 Kopya (gizli)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727693349402746)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'tr'
,p_message_text=>'Mesaj'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727354689402745)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'tr'
,p_message_text=>'Kopya (bilgi)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727043007402745)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta g\00F6nderildi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727545145402746)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'tr'
,p_message_text=>'Konu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727202917402745)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'tr'
,p_message_text=>unistr('Al\0131c\0131 (Kime)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680076317402711)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'tr'
,p_message_text=>'Etkin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673207126402706)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'tr'
,p_message_text=>unistr('e\015Fittir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726442068402745)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6rnek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680152242402711)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130fade')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726308458402745)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692395720402720)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya haz\0131rland\0131. \0130ndirme i\015Flemi ba\015Flat\0131l\0131yor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115655915571402692)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'tr'
,p_message_text=>'Doldur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657035881402693)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7imi \015Fununla doldur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656996694402693)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7imi Doldur')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648843114402687)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'tr'
,p_message_text=>'Filtre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679490639402710)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'tr'
,p_message_text=>'Filtreler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734482611402751)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'tr'
,p_message_text=>'Filtrele...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720399511402740)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130lk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649084320402687)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'tr'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677965171402709)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'tr'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724946467402744)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'tr'
,p_message_text=>'Format Maskesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726726656402745)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'tr'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726660576402745)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'tr'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639415464402680)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'tr'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578771409402634)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'tr'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682508392402712)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'tr'
,p_message_text=>'Dondur'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680248836402711)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'tr'
,p_message_text=>unistr('Fonksiyonlar ve \0130\015Fle\00E7ler')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718547168402739)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'tr'
,p_message_text=>'Huni'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699014631402724)
,p_name=>'APEX.IG.GO'
,p_message_language=>'tr'
,p_message_text=>'Git'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673828175402706)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'tr'
,p_message_text=>unistr('b\00FCy\00FCkt\00FCr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673902918402706)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'tr'
,p_message_text=>unistr('b\00FCy\00FCkt\00FCr veya e\015Fittir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680567771402711)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'tr'
,p_message_text=>'Grid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648027707402686)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('K\0131lavuz G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721171965402741)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'tr'
,p_message_text=>'Grup'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680789221402711)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Gruplama \00D6l\00E7\00FCt\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648360463402687)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCn\00FCme G\00F6re Grupland\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725586659402744)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ko\015Ful T\00FCr\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724485651402743)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Fl\0131k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724649234402743)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Fl\0131k Hizalama')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734369539402751)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yard\0131m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729840029402747)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Verileri do\011Frudan bu etkile\015Fimli grid i\00E7inde ekleyebilir, g\00FCncelleyebilir ve silebilirsiniz.</p>'),
'',
unistr('<p>Sat\0131r Ekle d\00FC\011Fmesine t\0131klayarak yeni bir s\00FCtun ekleyin.</p>'),
'',
unistr('<p>Belirli bir h\00FCcreye \00E7ift t\0131klayarak mevcut verileri d\00FCzenleyin. Daha kapsaml\0131 d\00FCzenleme i\015Fleri i\00E7in d\00FCzenleme moduna girmek \00FCzere D\00FCzenle''ye t\0131klay\0131n. D\00FCzenleme modunda tek t\0131klama yapabilir veya belirli h\00FCcreleri d\00FCzenlemek i\00E7in klavyeyi kullanab')
||'ilirsiniz.</p>',
'',
unistr('<p>Sat\0131rlar\0131 kopyalamak ve silmek i\00E7in De\011Fi\015Ftir men\00FCs\00FCn\00FC kullan\0131n. De\011Fi\015Ftir men\00FCs\00FCn\00FC etkinle\015Ftirmek i\00E7in bir veya daha fazla sat\0131r se\00E7mek \00FCzere onay kutular\0131n\0131 kullan\0131n.</p>'),
'',
unistr('<p>De\011Fi\015Ftir men\00FCs\00FCne t\0131klayarak ve Sat\0131r Kopyala''y\0131 se\00E7erek se\00E7ili bir sat\0131r\0131 kopyalay\0131n. De\011Fi\015Ftir men\00FCs\00FCne t\0131klayarak ve Sat\0131r Sil'' se\00E7erek se\00E7ili bir sat\0131r\0131 silin.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731926058402749)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenleme Yetenekleri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732006395402749)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Etkile\015Fimli bir grid, arama yap\0131labilen, uyarlanabilir bir rapordaki veri k\00FCmesini temsil eder. D\00F6nen kay\0131t say\0131s\0131n\0131 s\0131n\0131rland\0131rmak ve verilerin g\00F6r\00FCnt\00FClenme bi\00E7imini de\011Fi\015Ftirmek i\00E7in farkl\0131 i\015Flemler ger\00E7ekle\015Ftirebilirsiniz.</p>'),
'',
unistr('<p>D\00F6nen kay\0131t say\0131s\0131n\0131 filtrelemek i\00E7in Arama alan\0131n\0131 kullan\0131n. Rapor yerle\015Fimini de\011Fi\015Ftirmek i\00E7in farkl\0131 se\00E7eneklere eri\015Fmek \00FCzere Eylemler''e t\0131klay\0131n veya g\00F6r\00FCnt\00FClenen s\00FCtunlardaki S\00FCtun Ba\015Fl\0131\011F\0131 men\00FClerini kullan\0131n.</p>'),
'',
unistr('<p>Rapora ili\015Fkin \00F6zelle\015Ftirmelerinizi kaydetmek i\00E7in Rapor Ayarlar\0131''n\0131 kullan\0131n. Ayr\0131ca rapor verilerini harici bir dosyaya indirebilir veya verileri kendinize veya ba\015Fkalar\0131na e-posta ile g\00F6nderebilirsiniz.</p>'),
'',
unistr('<p>Daha fazla bilgi edinmek i\00E7in, <em>Oracle Application Express Son Kullan\0131c\0131 K\0131lavuzu</em> i\00E7indeki "Etkile\015Fimli Grid Kullanma" b\00F6l\00FCm\00FCne bak\0131n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731777783402749)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'tr'
,p_message_text=>unistr('Genel Bak\0131\015F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729727853402747)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Yerle\015Fik yetenekleri kullanarak verileri farkl\0131 \015Fekillerde g\00F6r\00FCnt\00FClemek i\00E7in etkile\015Fimli grid''i \00F6zelle\015Ftirebilirsiniz.</p>'),
'',
unistr('<p>Hangi s\00FCtunlar\0131n g\00F6r\00FCnt\00FCleneceklerini, s\00FCtunlar\0131n hangi s\0131rada g\00F6r\00FCnt\00FCleneceklerini belirlemek i\00E7in S\00FCtun Ba\015Fl\0131\011F\0131 men\00FClerini kullan\0131n ve s\00FCtunlar\0131 dondurun. Ayr\0131ca \00E7e\015Fitli veri filtreleri de tan\0131mlayabilir ve d\00F6nen verileri s\0131ralayabilirsiniz.</p>'),
'',
unistr('<p>Uygulama geli\015Ftirici taraf\0131ndan tan\0131mlanm\0131\015F olabilen di\011Fer veri g\00F6r\00FCn\00FCmlerine eri\015Fmek i\00E7in G\00F6r\00FCnt\00FCle d\00FC\011Fmesini (Arama alan\0131n\0131n yan\0131nda) kullan\0131n. Ayr\0131ca bir grafik olu\015Fturabilir veya mevcut bir grafi\011Fi g\00F6r\00FCnt\00FCleyebilirsiniz.</p>'),
'',
unistr('<p><em>Not: Se\00E7ilen fonksiyon ile ilgili daha detayl\0131 bilgileri elde etmek i\00E7in etkile\015Fimli grid ileti\015Fim kutusundaki <strong>Yard\0131m</strong> ba\011Flant\0131s\0131na t\0131klay\0131n.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731834753402749)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'tr'
,p_message_text=>'Raporlama Yetenekleri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681546801402712)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Grid Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728651694402746)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00FCtunlar\0131 birle\015Ftirmek i\00E7in bu ileti\015Fim kutusunu kullan\0131n. Birle\015Ftirilmi\015F de\011Ferler verilerin alt\0131nda veya Kontrol Kesmeleri tan\0131mlanm\0131\015Fsa her kesmenin alt\0131nda g\00F6r\00FCnt\00FClenir.</p>'),
'',
unistr('<p><strong>Birle\015Ftirme Listesi</strong><br>'),
unistr('Birle\015Ftirme listesi tan\0131ml\0131 birle\015Ftirmeleri g\00F6r\00FCnt\00FCler. Mevcut bir birle\015Ftirmenin se\00E7imini kald\0131rarak birle\015Ftirmeyi devre d\0131\015F\0131 b\0131rak\0131n.<br>'),
unistr('Yeni bir birle\015Ftirme eklemek i\00E7in Ekle''ye ( &plus; ) veya mevcut bir birle\015Ftirmeyi kald\0131rmak i\00E7in Sil''e ( &minus; ) t\0131klay\0131n.</p>'),
'',
unistr('<p><strong>Birle\015Ftirme Ayarlar\0131</strong><br>'),
unistr('Birle\015Ftirmeyi tan\0131mlamak i\00E7in sa\011Fdaki formu kullan\0131n.<br>'),
unistr('S\00FCtun ad\0131n\0131 ve Birle\015Ftirme tipini se\00E7in.<br>'),
unistr('\0130ste\011Fe ba\011Fl\0131 olarak, birle\015Ftirme i\00E7in bir ara\00E7 ipucu girin.<br>'),
unistr('Bir Kontrol Kesmesi tan\0131mlad\0131ysan\0131z <strong>Genel De\011Feri G\00F6ster</strong> se\00E7ilmesi genel ortalamay\0131, toplam\0131 veya benzer de\011Feri verilerin alt k\0131sm\0131nda g\00F6r\00FCnt\00FCler.</p>'),
'',
unistr('<p><em>Not: Birle\015Ftirme ileti\015Fim kutusuna Eylemler men\00FCs\00FCnden veya s\00FCtun ba\015Fl\0131\011F\0131na ve toplama ( &sum; ) t\0131klayarak eri\015Fin.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730884109402748)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplama Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729302090402747)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ayr\0131 bir veri g\00F6r\00FCn\00FCm\00FC olarak g\00F6r\00FCnt\00FClenen bir grafik tan\0131mlamak i\00E7in bu ileti\015Fim kutusunu kullan\0131n.<br>'),
unistr('Bir grafik Tipi ve grafik \00F6zellikleri se\00E7in.</p>'),
unistr('<p><strong>Grafik \00D6zellikleri</strong></br>'),
unistr('Kullan\0131labilir grafik \00F6zellikleri, grafik tipine g\00F6re de\011Fi\015Fir.</p>'),
'<p>',
'<ul>',
unistr('  <li>\00D6zelli\011Fin de\011Ferini i\00E7eren s\00FCtunu se\00E7in:'),
'    <ul>',
unistr('      <li>Etiket - Her veri noktas\0131 i\00E7in metin.</li>'),
unistr('      <li>De\011Fer - Grafi\011Fi \00E7izilecek veriler.</li>'),
unistr('      <li>Seri - \00C7ok serili dinamik sorgunuzu tan\0131mlamak i\00E7in.</li>'),
unistr('      <li>A\00E7\0131l\0131\015F - G\00FCnl\00FCk stok a\00E7\0131l\0131\015F fiyat\0131 (sadece Stok).</li>'),
unistr('      <li>Kapan\0131\015F - G\00FCnl\00FCk stok kapan\0131\015F fiyat\0131 (sadece Stok).</li>'),
unistr('      <li>Y\00FCksek - Y\00FCksek de\011Fer (sadece Aral\0131k ve Stok).</li>'),
unistr('      <li>D\00FC\015F\00FCk - D\00FC\015F\00FCk de\011Fer (sadece Aral\0131k ve Stok).</li>'),
unistr('      <li>Hacim - G\00FCnl\00FCk stok hacmi (sadece Stok).</li>'),
unistr('      <li>Hedef - Hedef de\011Fer (sadece Huni).</li>'),
unistr('      <li>X - X ekseni de\011Feri (sadece Kabarc\0131k ve Noktal\0131).</li>'),
unistr('      <li>Y - Y ekseni de\011Feri (sadece Kabarc\0131k ve Noktal\0131).</li>'),
unistr('      <li>Z - \00C7ubuk geni\015Fli\011Fi veya kabarc\0131k \00E7ap\0131 (sadece \00C7ubuk, Kabarc\0131k ve Aral\0131k).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Y\00F6nelim - Dikey veya yatay.</li>'),
unistr('  <li>Birle\015Ftirme - Grafik de\011Ferlerinin nas\0131l birle\015Ftirilece\011Fini se\00E7in.</li>'),
unistr('  <li>Y\0131\011F\0131n - Veri \00F6\011Felerinin y\0131\011F\0131l\0131 olup olmayaca\011F\0131n\0131 belirleyin.</li>'),
unistr('  <li>S\0131ralama \00D6l\00E7\00FCt\00FC - Etikete veya de\011Ferlere g\00F6re s\0131ralay\0131n.'),
'    <ul>',
unistr('      <li>Y\00F6n - Artan veya azalan de\011Ferlere g\00F6re s\0131ralay\0131n.</li>'),
unistr('      <li>De\011Fer atanmam\0131\015F kay\0131tlar - De\011Fer atanmam\0131\015F kay\0131tlar\0131n de\011Fersiz b\0131rak\0131lmam\0131\015F kay\0131tlara g\00F6re nas\0131l s\0131ralanaca\011F\0131n\0131 belirleyin.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>Ondal\0131k Basamaklar</li>'),
unistr('  <li>Etiket Ekseni Ba\015Fl\0131\011F\0131</li>'),
unistr('  <li>De\011Fer Ekseni Ba\015Fl\0131\011F\0131</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731277504402748)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728396123402746)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Hangi s\00FCtunlar\0131n g\00F6r\00FCnt\00FClenece\011Fini ve hangi s\0131rada g\00F6r\00FCnt\00FCleneceklerini se\00E7mek i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
'',
unistr('<p>Bir s\00FCtunun se\00E7imini kald\0131rarak s\00FCtunu gizleyin.<br>'),
unistr('Yukar\0131 Ta\015F\0131 ( &uarr; ) veya A\015Fa\011F\0131 Ta\015F\0131 ( &darr; ) ba\011Flant\0131lar\0131n\0131 kullanarak s\00FCtunlar\0131 yeniden s\0131ralay\0131n.<br>'),
unistr('T\00FCm s\00FCtunlar\0131, G\00F6r\00FCnt\00FClenen s\00FCtunlar\0131 veya G\00F6r\00FCnt\00FClenmeyen s\00FCtunlar\0131 listelemek i\00E7in a\015Fa\011F\0131 a\00E7\0131lan se\00E7iciyi kullan\0131n.</p>'),
'',
unistr('<p>\0130ste\011Fe ba\011Fl\0131 olarak, s\00FCtunun minimum geni\015Fli\011Fini piksel olarak belirtmek i\00E7in formu kullan\0131n.</p>'),
'',
unistr('<p><em>Not: Ayr\0131ca, g\00F6r\00FCnt\00FClenen s\00FCtunlar\0131 s\00FCr\00FCkleme tutamac\0131na t\0131klayarak (s\00FCtun ba\015Fl\0131\011F\0131n\0131n ba\015F\0131nda) ve s\00FCtunu sola veya sa\011Fa s\00FCr\00FCkleyerek de yeniden s\0131ralayabilirsiniz. Ayr\0131ca, g\00F6r\00FCnt\00FClenen s\00FCtunlar\0131n s\00FCtun geni\015Fli\011Fini, ba\015Fl\0131klar aras\0131ndaki s\00FCtun a')
||unistr('y\0131r\0131c\0131s\0131n\0131 se\00E7erek ve sola veya sa\011Fa ta\015F\0131yarak da de\011Fi\015Ftirebilirsiniz.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731192469402748)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunlar Yard\0131m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728788949402747)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mevcut s\00FCtunlar i\00E7in ger\00E7ekle\015Ftirilen matematiksel ve fonksiyonel hesaplamalar\0131 esas alarak ek s\00FCtunlar tan\0131mlamak i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
'',
'<p><strong>Hesaplama Listesi</strong><br>',
unistr('Hesaplama listesi tan\0131ml\0131 hesaplamalar\0131 g\00F6r\00FCnt\00FCler. Mevcut bir hesaplaman\0131n se\00E7imini kald\0131rarak hesaplamay\0131 devre d\0131\015F\0131 b\0131rak\0131n.<br>'),
unistr('Yeni bir hesaplama eklemek i\00E7in Ekle''ye ( &plus; ) veya mevcut bir hesaplamay\0131 kald\0131rmak i\00E7in Sil''e ( &minus; ) t\0131klay\0131n.</p>'),
'',
unistr('<p><strong>Hesaplama Ayarlar\0131</strong><br>'),
unistr('Hesaplamay\0131 tan\0131mlamak i\00E7in formu kullan\0131n.<br>'),
unistr('Ba\015Fl\0131k, etiket gibi s\00FCtun detaylar\0131n\0131 girin ve hizalama ayarlar\0131n\0131 se\00E7in.<br> '),
unistr('Hesaplama i\00E7in ili\015Fkili fonksiyonlar\0131 ve s\00FCtunlar\0131 girmek \00FCzere \0130fade metin alan\0131n\0131 kullan\0131n.<br>'),
unistr('Yeni s\00FCtun i\00E7in uygun veri tipini ve iste\011Fe ba\011Fl\0131 olarak bir format maskesi se\00E7in.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730767325402748)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Hesaplama Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729078131402747)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bir veya daha fazla s\00FCtunda kontrol kesmesi tan\0131mlamak i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
'',
'<p><strong>Kontrol Kesmesi Listesi</strong><br>',
unistr('Kontrol Kesmesi listesi, tan\0131ml\0131 kontrol kesmelerini g\00F6r\00FCnt\00FCler. Mevcut bir kontrol sekmesinin se\00E7imini kald\0131rarak kesmeyi devre d\0131\015F\0131 b\0131rak\0131n.<br>'),
unistr('Kontrol kesmesine yeni bir s\00FCtun dahil etmek i\00E7in Ekle''ye ( &plus; ) veya kontrol kesmesinden mevcut bir s\00FCtunu kald\0131rmak i\00E7in Sil''e ( &minus; ) t\0131klay\0131n.<br>'),
unistr('S\00FCtunlar\0131 yeniden s\0131raland\0131rmak i\00E7in se\00E7ilen s\00FCtunu di\011Fer s\00FCtunlara g\00F6re yukar\0131 ve a\015Fa\011F\0131 ta\015F\0131mak \00FCzere Yukar\0131 Ta\015F\0131 ( &uarr; ) veya A\015Fa\011F\0131 Ta\015F\0131 ( &darr; ) ba\011Flant\0131lar\0131na t\0131klay\0131n.</p>'),
'',
unistr('<p><strong>Kontrol Kesmesi Ayarlar\0131</strong><br>'),
unistr('Kontrol kesmesi s\00FCtununu tan\0131mlamak i\00E7in formu kullan\0131n.<br>'),
unistr('Kontrol kesmesi s\00FCtunu, s\0131ralama y\00F6n\00FC ve bo\015F s\00FCtunlar\0131n (de\011Fer i\00E7ermeyen s\00FCtunlar) nas\0131l s\0131ralanaca\011F\0131n\0131 se\00E7in.</p>'),
'',
unistr('<p><em>Not: Etkile\015Fimli bir grid g\00F6r\00FCnt\00FClenirken bir S\00FCtun Ba\015Fl\0131\011F\0131na t\0131klayarak ve kontrol kesmesi simgesini se\00E7erek bir kontrol kesmesi tan\0131mlayabilirsiniz.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730475355402748)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kontrol Kesmesi Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729239265402747)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>T\00FCm ge\00E7erli sat\0131rlar\0131 harici bir dosyaya indirmek i\00E7in bu ileti\015Fim kutusunu kullan\0131n. Dosya, verilere uygulanan filtreleri ve s\0131ralamalar\0131 kullanarak sadece mevcut durumda g\00F6r\00FCnt\00FClenen s\00FCtunlar\0131 i\00E7erir.</p>'),
'',
unistr('<p>Dosya format\0131n\0131 se\00E7in ve \0130ndir''e t\0131klay\0131n.<br>'),
unistr('Not: CSV, birle\015Ftirmeler veya kontrol kesmeleri gibi metin formatlama i\00E7ermez.</p>'),
'',
unistr('<p>Dosyay\0131 e-posta ile g\00F6ndermek i\00E7in E-Posta Olarak G\00F6nder''i se\00E7in ve e-posta detaylar\0131n\0131 girin (Kime, Konu ve Mesaj).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730244199402748)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ndirme Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728463116402746)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>D\00F6nen sat\0131r say\0131s\0131n\0131 s\0131n\0131rlayan veri filtrelerini konfig\00FCre etmek i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
'',
'<p><strong>Filtre Listesi</strong><br>',
unistr('Filtre listesi tan\0131ml\0131 filtreleri g\00F6r\00FCnt\00FCler. Mevcut bir filtrenin se\00E7imini kald\0131rarak filtreyi devre d\0131\015F\0131 b\0131rak\0131n.<br>'),
unistr('Yeni bir filtre olu\015Fturmak i\00E7in Ekle''ye ( &plus; ) t\0131klay\0131n veya mevcut bir filtreyi kald\0131rmak i\00E7in Sil''e ( &minus; ) t\0131klay\0131n.</p>'),
'',
unistr('<p><strong>Filtre Ayarlar\0131</strong><br>'),
unistr('Filtre niteliklerini tan\0131mlamak \00FCzere formu kullan\0131n.<br>'),
unistr('Uygun filtre tipini se\00E7in:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sat\0131r - filtrelenebilir herhangi bir s\00FCtunda bir ifade i\00E7in filtreleyin.<br>'),
unistr('&nbsp;&nbsp;&nbsp;S\00FCtun - belirli bir s\00FCtunu belirtilen bir i\015Fle\00E7 ve de\011Fer ile filtreleyin.</p>'),
'',
unistr('<p><em>Not: Etkile\015Fimli grid g\00F6r\00FCnt\00FClenirken do\011Frudan Arama alan\0131na yazarak sat\0131r filtrelerini tan\0131mlayabilirsiniz. Aramay\0131 belirli bir s\00FCtun ile s\0131n\0131rland\0131rmak i\00E7in Aranacak S\00FCtunlar\0131 Se\00E7''e t\0131klay\0131n. Alternatif olarak bir S\00FCtun Ba\015Fl\0131\011F\0131 men\00FCs\00FC a\00E7\0131n v')
||unistr('e bir s\00FCtun filtresi olu\015Fturmak i\00E7in bir de\011Fer se\00E7in.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731016918402748)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Filtreleme Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728856101402747)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Verileri \00F6nceki bir zaman noktas\0131nda mevcut olduklar\0131 gibi g\00F6r\00FCnt\00FClemek i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
unistr('<p>Flashback sorgusunu y\00FCr\00FCtmek i\00E7in ge\00E7mi\015Fteki dakika say\0131s\0131n\0131 girin.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730612580402748)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Flashback Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731365233402749)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Grup \00D6l\00E7\00FCt\00FC Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728930493402747)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Girilen ko\015Fulu esas alarak veri sat\0131rlar\0131n\0131 veya s\00FCtunlar\0131n\0131 vurgulamak i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
'',
'<p><strong>Vurgu Listesi</strong><br>',
unistr('Vurgu listesi, tan\0131ml\0131 vurgular\0131 g\00F6r\00FCnt\00FCler. Mevcut bir vurgunun se\00E7imini kald\0131rarak vurguyu devre d\0131\015F\0131 b\0131rak\0131n.<br>'),
unistr('Yeni bir vurgu olu\015Fturmak i\00E7in Ekle''ye ( &plus; ) t\0131klay\0131n veya mevcut bir vurguyu kald\0131rmak i\00E7in Sil''e ( &minus; ) t\0131klay\0131n.</p>'),
'',
unistr('<p><strong>Vurgu Ayarlar\0131</strong><br>'),
unistr('Vurgu niteliklerini tan\0131mlamak i\00E7in formu kullan\0131n.<br>'),
unistr('Ad\0131 girin, Sat\0131r veya S\00FCtun se\00E7in ve arka plan ve metin i\00E7in HTML renk kodlar\0131n\0131 se\00E7in.<br>'),
unistr('Belirli verileri vurgulamak \00FCzere uygun <strong>Ko\015Ful Tipi</strong>''ni se\00E7in:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Sat\0131r - ifadeyi herhangi bir s\00FCtunda vurgulay\0131n.<br>'),
unistr('&nbsp;&nbsp;&nbsp;S\00FCtun - belirtilen i\015Fleci ve de\011Feri esas alarak belirli bir s\00FCtunda vurgulay\0131n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730507064402748)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Vurgulama Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729140453402747)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ge\00E7erli grid yerle\015Fimi ve konfig\00FCrasyonu i\00E7in yapt\0131\011F\0131n\0131z de\011Fi\015Fiklikleri kaydetmek i\00E7in bu ileti\015Fim kutusunu kullan\0131n.<br>'),
unistr('Uygulama geli\015Ftiriciler birden fazla alternatif rapor yerle\015Fimi tan\0131mlayabilir. \0130zin verilen yerlerde siz ve di\011Fer son kullan\0131c\0131lar bir raporu Genel olarak kaydedebilir ve bu raporu grid''in t\00FCm son kullan\0131c\0131lar\0131 taraf\0131ndan kullan\0131labilir duruma getir')
||unistr('ir. Bir raporu ayr\0131ca sadece sizin g\00F6r\00FCnt\00FCleyebilece\011Finiz bi\00E7imde \00D6zel rapor olarak da kaydedebilirsiniz.</p>'),
unistr('<p>Kullan\0131labilir tipler aras\0131ndan se\00E7im yap\0131n ve kaydedilmi\015F rapor i\00E7in bir ad girin.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730348405402748)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Rapor Yard\0131m\0131'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728581251402746)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>G\00F6r\00FCnt\00FCleme s\0131ras\0131n\0131 belirlemek i\00E7in bu ileti\015Fim kutusunu kullan\0131n.</p>'),
'',
unistr('<p><strong>S\0131ralama Listesi</strong><br>'),
unistr('S\0131ralama ileti\015Fim kutusu, konfig\00FCre edilen s\0131ralama kurallar\0131n\0131n bir listesini g\00F6r\00FCnt\00FCler.<br>'),
unistr('S\0131ralama s\00FCtunu olu\015Fturmak i\00E7in Ekle''ye ( &plus; ) veya bir s\0131ralama s\00FCtununu kald\0131rmak i\00E7in Sil''e ( &minus; ) t\0131klay\0131n.<br>'),
unistr('Se\00E7ili s\0131ralama s\00FCtununu di\011Fer s\0131ralama s\00FCtunlar\0131na g\00F6re yukar\0131 ve a\015Fa\011F\0131 ta\015F\0131mak i\00E7in Yukar\0131 Ta\015F\0131 ( &uarr; ) ve A\015Fa\011F\0131 Ta\015F\0131 ( &darr; ) ba\011Flant\0131lar\0131na t\0131klay\0131n.</p>'),
'',
unistr('<p><strong>S\0131ralama Ayarlar\0131</strong><br>'),
unistr('Bir s\0131ralama s\00FCtunu, s\0131ralama y\00F6n\00FC ve bo\015F s\00FCtunlar\0131n (de\011Feri olmayan s\00FCtunlar) nas\0131l s\0131ralanacaklar\0131n\0131 se\00E7in.</p>'),
'',
unistr('<p><em>Not: Veriler g\00F6r\00FCnt\00FClenmeyen s\00FCtunlara g\00F6re s\0131ralanabilir ancak t\00FCm s\00FCtunlar s\0131ralanabilir olmayabilir.</em><br>'),
unistr('<em>G\00F6r\00FCnt\00FClenen s\00FCtunlar s\00FCtun ba\015Fl\0131klar\0131n\0131n sonundaki yukar\0131 (artan) veya a\015Fa\011F\0131 (azalan) oklar\0131na bas\0131larak s\0131ralanabilir. Mevcut bir s\0131ralamaya sonradan bir s\00FCtun eklemek i\00E7in Shift tu\015Funa bas\0131n ve yukar\0131 veya a\015Fa\011F\0131 okuna t\0131klay\0131n.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730976641402748)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralama Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115730107418402748)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Abonelik Yard\0131m\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682429659402712)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'tr'
,p_message_text=>'Gizle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649215765402687)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'tr'
,p_message_text=>'Vurgula'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717212282402738)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCksek')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718019085402738)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'tr'
,p_message_text=>'Yatay'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675481505402707)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'tr'
,p_message_text=>'saatler'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680469050402711)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'tr'
,p_message_text=>'Simge'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648149232402686)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Simge G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673647416402706)
,p_name=>'APEX.IG.IN'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682012589402712)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'tr'
,p_message_text=>'Etkin Olmayan Ayar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682192183402712)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>'Etkin Olmayan Ayarlar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689718619402718)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Grid iste\011Fi i\015Flenirken dahili bir hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585523142402639)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Filtre Tipi "%0", s\00FCtun "%1" i\00E7in desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729940226402747)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Tarih Format\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704188197402728)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Grid, %0 s\00FCtununda bir filtre tan\0131mlamay\0131 desteklemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704067006402728)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0, Etkile\015Fimli Grid filtresi tan\0131mlamak i\00E7in ge\00E7erli bir filtre tipi de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590680053402643)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Say\0131 Format\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732633179402749)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Ayar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732796335402750)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Ayarlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723748682402743)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralama \00D6l\00E7\00FCt\00FC %0 olarak ayarland\0131, ancak %0 i\00E7in hi\00E7bir s\00FCtun se\00E7ilmedi.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721075816402741)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz De\011Fer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716132687402737)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenmiyor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674458542402706)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Fu zaman diliminde:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674613269402707)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'tr'
,p_message_text=>'gelecek'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673529255402706)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('bo\015F de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673441980402706)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('bo\015F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724522583402743)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'tr'
,p_message_text=>'Etiket'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716591896402737)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Etiket'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720430195402740)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'tr'
,p_message_text=>'Son'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663791388402698)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Son G\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663954667402698)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'tr'
,p_message_text=>'Son Saat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664430170402699)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'tr'
,p_message_text=>'Son Dakika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663448866402698)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en Ay')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663557927402698)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en Hafta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663682714402698)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('Son %0 G\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663889492402698)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'tr'
,p_message_text=>'Son %0 Saat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664507346402699)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'tr'
,p_message_text=>'Son %0 Dakika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664366328402699)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'tr'
,p_message_text=>'Son %0 Ay'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664269695402699)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'tr'
,p_message_text=>'Son %0 Hafta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663224483402698)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en %0 Y\0131l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663365617402698)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en Y\0131l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724715033402744)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'tr'
,p_message_text=>unistr('H\00FCcre Hizalama')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724866624402744)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'tr'
,p_message_text=>unistr('Grubu \015Eunun i\00E7in Kullan')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674055188402706)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'tr'
,p_message_text=>unistr('k\00FC\00E7\00FCkt\00FCr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674189207402706)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'tr'
,p_message_text=>unistr('k\00FC\00E7\00FCkt\00FCr veya e\015Fittir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718655222402739)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7izgi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718752568402739)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'tr'
,p_message_text=>unistr('Alan\0131 Olan \00C7izgi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725155202402744)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'tr'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717302568402738)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FC\015F\00FCk')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727713069402746)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7oklu adresleri virg\00FClle ay\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675215291402707)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('d\00FCzenli ifadeyi e\015Fle\015Ftirir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699664503402725)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'tr'
,p_message_text=>'Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735294372402751)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'tr'
,p_message_text=>'Genel Maksimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699879054402725)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'tr'
,p_message_text=>'Orta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735350856402752)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'tr'
,p_message_text=>'Genel Orta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699525186402725)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'tr'
,p_message_text=>'Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675394341402707)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'tr'
,p_message_text=>'dakikalar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700394461402725)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('Dakika \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735179432402751)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'tr'
,p_message_text=>'Genel Minimum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675725450402707)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'tr'
,p_message_text=>'aylar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682390871402712)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Veriler, izin verilen maksimum de\011Feri a\015Fan %0''dan fazla sat\0131r i\00E7eriyor. Sonu\00E7lar\0131 g\00F6r\00FCnt\00FClemek i\00E7in l\00FCtfen ek filtreler uygulay\0131n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709044890402732)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge Statik No, sayfa birden fazla Etkile\015Fimli Grid i\00E7erdi\011Finden belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678435132402709)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'tr'
,p_message_text=>'Ad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678693816402710)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Adland\0131r\0131lm\0131\015F Rapor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662669572402697)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki G\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662406634402697)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Saat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664632493402699)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Dakika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662922581402698)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Ay'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662872171402698)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Hafta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662737693402698)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki %0 G\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115662582301402697)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'tr'
,p_message_text=>'Sonraki %0 Saat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664720108402699)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'tr'
,p_message_text=>'Sonraki %0 Dakika'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664007446402699)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'tr'
,p_message_text=>'Sonraki %0 Ay'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664152764402699)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'tr'
,p_message_text=>'Sonraki %0 Hafta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663193221402698)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki %0 Y\0131l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115663064191402698)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki Y\0131l')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674304517402706)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'tr'
,p_message_text=>unistr('aras\0131nda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673351276402706)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'tr'
,p_message_text=>unistr('e\015Fit de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739594100402755)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 No''lu b\00F6lge \0130nteraktif Grid b\00F6lgesi de\011Fil veya %1 uygulamas\0131nda mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673729305402706)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7inde de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674571242402707)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Fu zaman diliminde de\011Fil:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115674783025402707)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('sonrakinde de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682216754402712)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri bulunamad\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720288156402740)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015Flar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725390718402744)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'tr'
,p_message_text=>unistr('Say\0131sal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720503180402740)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'tr'
,p_message_text=>unistr('Kapal\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720677009402740)
,p_name=>'APEX.IG.ON'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7\0131k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672570150402705)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('1 dakika \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728263344402746)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'tr'
,p_message_text=>unistr('Renk Se\00E7iciyi A\00E7: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717033436402738)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679539054402710)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130\015Fle\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716452639402737)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00F6nlendirme')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718802732402739)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'tr'
,p_message_text=>'Pasta grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115680856665402711)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115648497604402687)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115728144240402746)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" ile de\011Ferleri ay\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115718944958402739)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'tr'
,p_message_text=>'Polar Grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724231601402743)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'tr'
,p_message_text=>'Orta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724354574402743)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'tr'
,p_message_text=>unistr('Biti\015F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115724136299402743)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678728285402710)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'tr'
,p_message_text=>'Birincil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679092656402710)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('Birincil \00D6nde\011Fer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695590594402722)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Birincil Rapor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577724402402633)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Filebilirlik Etiketlerini Dahil Et')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576462199402632)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'tr'
,p_message_text=>'Yatay'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576593848402632)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'tr'
,p_message_text=>'Dikey'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576334762402632)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa y\00F6n\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576234453402632)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'tr'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576118915402632)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'tr'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577853428402633)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575965628402632)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'tr'
,p_message_text=>'Yasal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575808901402632)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'tr'
,p_message_text=>'Mektup'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576075036402632)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'tr'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575733025402631)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'tr'
,p_message_text=>'Sayfa boyutu'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565931484402624)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'tr'
,p_message_text=>unistr('Zengin Metni Kald\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719059097402739)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'tr'
,p_message_text=>'Radar Grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719177022402739)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Aral\0131k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729474021402747)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'tr'
,p_message_text=>'Yenile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683084594402713)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r\0131 Yenile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681836133402712)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131rlar\0131 Yenile')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687045640402716)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Grid b\00F6lgesi, uygulama %0, sayfa % 1 ve b\00F6lge %2 i\00E7inde yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649921249402688)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00F6\011Fesini kald\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678119119402709)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'tr'
,p_message_text=>'Rapor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738735358402754)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'tr'
,p_message_text=>'Rapor silindi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738475453402754)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm kullan\0131c\0131lar i\00E7in alternatif rapor kaydedildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738397756402754)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor \00F6nde\011Feri t\00FCm kullan\0131c\0131lar i\00E7in kaydedildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738651524402754)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel rapor kaydedildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738519613402754)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm kullan\0131c\0131lar i\00E7in genel rapor kaydedildi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115687115032402716)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 adl\0131 kaydedilmi\015F Etkile\015Fimli Grid mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672497613402705)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 dakika \00F6ncesinden itibaren verileri raporla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672305066402705)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('1 dakika \00F6ncesinden itibaren verileri raporla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612032821402659)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimle Grid Rapor mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731610547402749)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor- D\00FCzenle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686926256402716)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 No''lu kaydedilmi\015F Etkile\015Fimli Grid mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115731553788402749)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor- Farkl\0131 Kaydet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650023164402688)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor Ayarlar\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739617126402755)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 statik No''ya sahip kaydedilmi\015F Etkile\015Fimli Grid mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734579045402751)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649169764402687)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131f\0131rla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683139948402713)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fi\015Fiklikleri Geri Al')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681958567402712)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131rlar\0131 Geri Al')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679106167402710)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678033768402709)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r / Sayfa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739236382402754)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Eylemleri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740427153402755)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sat\0131r\0131 i\00E7in eylemler')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115649429035402687)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'tr'
,p_message_text=>'Kaydet'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692102387402719)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'tr'
,p_message_text=>'kaydedildi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647674181402686)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Kay\0131tl\0131 Raporlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647759840402686)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nde\011Fer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622257481402666)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 adl\0131 kaydedilmi\015F bir rapor zaten mevcut. Yeni bir ad girin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647888490402686)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647990387402686)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'tr'
,p_message_text=>'Genel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734226605402751)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'tr'
,p_message_text=>unistr('Farkl\0131 Kaydet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681242917402711)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor Ayarlar\0131n\0131 Kaydet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719248256402739)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Sa\00E7\0131l\0131m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647509801402686)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'tr'
,p_message_text=>'Ara'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726532181402745)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Arama: T\00FCm Metin S\00FCtunlar\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647480118402686)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Ara: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725791152402744)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'tr'
,p_message_text=>'Arama: Tam Metin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672222957402705)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'tr'
,p_message_text=>'Ara - ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715820329402737)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'tr'
,p_message_text=>unistr('- Se\00E7 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656056295402692)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7im')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708786906402731)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Ana b\00F6lgede 1 sat\0131r se\00E7in')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647374363402686)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'tr'
,p_message_text=>unistr('Aranacak s\00FCtunlar\0131 se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738990260402754)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7im Eylemleri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656207648402693)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'tr'
,p_message_text=>unistr('H\00FCcre Se\00E7imi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656155350402692)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Se\00E7imi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727176821402745)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta olarak g\00F6nder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719646661402740)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Seri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645360004402684)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6ster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697932027402724)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam De\011Feri G\00F6ster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682769617402713)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Tek Sat\0131r G\00F6r\00FCn\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681017703402711)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131rala')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719780939402740)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralama \00D6l\00E7\00FCt\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739320915402755)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun ba\015F\0131na yaln\0131zca bir s\0131ralama tan\0131mlayabilirsiniz.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739113558402754)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fi\015Fiklik Men\00FCs\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115720794874402740)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\0131\011F\0131n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675068016402707)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'tr'
,p_message_text=>unistr('ile ba\015Flar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719329368402739)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'tr'
,p_message_text=>unistr('Stok Grafi\011Fi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640380238402680)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Geni\015Fliklerini Geni\015Flet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115681485096402712)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'tr'
,p_message_text=>'Abonelik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115699430664402725)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'tr'
,p_message_text=>'Toplam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740608303402755)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Grid. Rapor: %0, G\00F6r\00FCn\00FCm: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115734664198402751)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'tr'
,p_message_text=>'Genel Toplam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717543688402738)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Hedef'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723946972402743)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'tr'
,p_message_text=>'Metin Rengi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650113457402688)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7i\015F Yap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697842689402724)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'tr'
,p_message_text=>unistr('Ara\00E7 \0130pucu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115678276324402709)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCr')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115682675613402713)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'tr'
,p_message_text=>unistr('Donma Stat\00FCs\00FCn\00FC Kald\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679797249402710)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'tr'
,p_message_text=>'Birim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726930910402745)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'tr'
,p_message_text=>unistr('Kaydedilmemi\015F de\011Fi\015Fiklikler var. Devam etmek istiyor musunuz?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115679623248402710)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716697937402737)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721500663402741)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir de\011Fer gerekli.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706479401402730)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer (saat dilimi de\011Fi\015Ftirilemez)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725438802402744)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'tr'
,p_message_text=>'Metin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717982193402738)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'tr'
,p_message_text=>'Dikey'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677767686402709)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FCle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715932778402737)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115717493128402738)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Hacim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675676794402707)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'tr'
,p_message_text=>'haftalar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716095486402737)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'tr'
,p_message_text=>unistr('Minimum S\00FCtun Geni\015Fli\011Fi (Piksel)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666883740402701)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 %1 ile %2 aras\0131nda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666525182402700)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7erir %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666603708402701)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0, %1 i\00E7ermiyor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644725315402684)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \015Fununla ba\015Flamaz: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665388786402700)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 e\015Fittir %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665508671402700)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 b\00FCy\00FCkt\00FCr %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665644071402700)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 b\00FCy\00FCkt\00FCr veya e\015Fittir %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666387147402700)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%1 i\00E7inde %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667506056402701)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('Son %1 g\00FCn i\00E7inde %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667395267402701)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'tr'
,p_message_text=>unistr('Son %1 saat i\00E7inde %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667114310402701)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'tr'
,p_message_text=>'Son %1 dakikada %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667940359402702)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'tr'
,p_message_text=>'Son %1 ayda %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667768968402701)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'tr'
,p_message_text=>'Son %1 haftada %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668110609402702)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('Son %1 y\0131lda %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667489212402701)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Son g\00FCn %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667216767402701)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'tr'
,p_message_text=>'Son saatte %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667020362402701)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'tr'
,p_message_text=>'Son dakikada %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667824294402701)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'tr'
,p_message_text=>'Son bir ayda %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115667656297402701)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en hafta %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668081610402702)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en y\0131l %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669935110402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ertesi %1 g\00FCnde %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669781247402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki %1 saat i\00E7inde %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669543935402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'tr'
,p_message_text=>'Sonraki % 1 dakikada %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670307362402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'tr'
,p_message_text=>'Gelecek %1ayda %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670156960402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'tr'
,p_message_text=>'Gelecek %1 haftada %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670556307402704)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('Gelecek %1 y\0131lda %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669880683402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Ertesi g\00FCn %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669625357402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'tr'
,p_message_text=>'Sonraki saatte %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669412624402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'tr'
,p_message_text=>'Sonraki dakikada %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670282647402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'tr'
,p_message_text=>'Gelecek ay %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670036302402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'tr'
,p_message_text=>'Gelecek hafta %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670455388402703)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Gelecek y\0131l %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666062073402700)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 bo\015F de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665940390402700)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 bo\015F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665745398402700)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 k\00FC\00E7\00FCkt\00FCr %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665882248402700)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 k\00FC\00E7\00FCkt\00FCr veya e\015Fittir %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666147192402700)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'tr'
,p_message_text=>'%0 benzer %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666773052402701)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 d\00FCzenli ifadeyle e\015Fle\015Fir %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672660109402705)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 dakika \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666968012402701)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 %1 ile %2 aras\0131nda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665467002402700)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 e\015Fit de\011Fildir %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666442110402700)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%1 i\00E7inde de\011Fil %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668714782402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 g\00FCnde de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668590251402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 saatte de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668329799402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 dakikada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669150913402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 ayda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668944955402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 haftada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669366650402703)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 y\0131lda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668671952402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son g\00FCn de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668441104402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son bir saatte de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668250384402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son dakikada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669041008402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son bir ayda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115668878450402702)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son bir haftada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115669260325402703)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son bir y\0131lda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671191712402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonraki %1 g\00FCnde de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670926778402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonraki %1 saatte de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670728073402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonraki %1 dakikada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671597033402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 gelecek %1 ayda de\011Fil ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671387113402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 gelecek %1 haftada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671731125402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 gelecek %1 y\0131lda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671029685402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 ertesi g\00FCn de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670877229402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonraki saatte de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115670699236402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 bir dakikada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671494749402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 gelecek ayda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671212890402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 gelecek haftada de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671697582402704)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 gelecek y\0131lda de\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115666210668402700)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'tr'
,p_message_text=>'%0 benzemez %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673198303402705)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \015Fununla ba\015Flar: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716720237402737)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675872780402707)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('y\0131llar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716832944402737)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716931046402738)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115725923584402744)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'tr'
,p_message_text=>'12 Ocak 2016, Pazartesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726029509402744)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'tr'
,p_message_text=>'Ocak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726115733402745)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'tr'
,p_message_text=>unistr('16 saat \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115726205475402745)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'tr'
,p_message_text=>unistr('16 saat i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581275109402636)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz dosya tipi. Desteklenen dosya t\00FCr\00FC %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708107744402731)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6z At')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707849262402731)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707981495402731)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosyalar\0131 Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581057476402636)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCr\00FCkle ve B\0131rak')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581441246402636)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosyalar\0131 S\00FCr\00FCkle ve B\0131rak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582657829402637)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir dosya se\00E7in veya buraya bir dosya b\0131rak\0131n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582779015402637)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya se\00E7in veya buraya b\0131rak\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582855617402637)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir dosya se\00E7in veya buraya bir dosya b\0131rak\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582941654402637)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya se\00E7in veya buraya b\0131rak\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581347377402636)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'tr'
,p_message_text=>'%0 dosya'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581133640402636)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya \00E7ok b\00FCy\00FCk. Maksimum dosya boyutu %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568974745402626)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>'Adres gerekli.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567838232402625)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eehir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568230352402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'tr'
,p_message_text=>unistr('\00DClke Kodu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567998734402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'tr'
,p_message_text=>unistr('Bina Numaras\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568844781402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'tr'
,p_message_text=>'Enlem'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568748917402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'tr'
,p_message_text=>'Boylam'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568615131402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'tr'
,p_message_text=>unistr('Haritada G\00F6ster')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568345892402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'tr'
,p_message_text=>'Puan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568023348402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'tr'
,p_message_text=>'Posta Kodu'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568106301402626)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'tr'
,p_message_text=>'Durum'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567793970402625)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'tr'
,p_message_text=>'Sokak'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567619829402625)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Co\011Frafi Kodlama Sonu\00E7lar\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580218827402635)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'tr'
,p_message_text=>unistr('Co\011Frafi Kodlu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580322165402635)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'tr'
,p_message_text=>unistr('Co\011Frafi Kodlu De\011Fil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568573300402626)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'tr'
,p_message_text=>'Harita'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115568437439402626)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Adres bulunamad\0131.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569043848402626)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'tr'
,p_message_text=>'%0 gerekli.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738876282402754)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Yard\0131m Metni: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632260764402674)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130\015Faretlendi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632379089402674)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130\015Fareti Kald\0131r\0131ld\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578295360402633)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, ge\00E7erli %0 - %1 aral\0131\011F\0131nda de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578319949402633)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, %0 kat\0131 de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577985119402633)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, %0 ve %1 de\011Ferleri ile e\015Fle\015Fmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578152237402633)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Hay\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656424457402693)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Kapal\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656530033402693)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7\0131k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578048763402633)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Evet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561413877402621)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'tr'
,p_message_text=>unistr('Giri\015F Ekle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690665730402718)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'tr'
,p_message_text=>'Ekle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690727206402718)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561564679402621)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7ilen giri\015Fler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694448827402721)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'tr'
,p_message_text=>unistr('Geli\015Fmi\015F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694790854402721)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ptal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694522683402721)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'tr'
,p_message_text=>'Ortak'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694810275402721)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'tr'
,p_message_text=>unistr('Canl\0131 \015Eablon Se\00E7enekleri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695404992402722)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eablon Se\00E7enekleri kullan\0131lamaz \00E7\00FCnk\00FC bu bile\015Fen sayfada g\00F6r\00FCnt\00FClenmez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694366104402721)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eablon Se\00E7enekleri bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694687295402721)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'tr'
,p_message_text=>'Kaydet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569965862402627)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7emberi Temizle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571704696402628)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel Stiller, ge\00E7erli JSON de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570288007402627)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'tr'
,p_message_text=>unistr('Uzakl\0131k Arac\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570047106402627)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Daire \00C7iz')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562626296402622)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'tr'
,p_message_text=>unistr('Fasetli Arama, b\00F6lge d\00FCzeyinde Veri Kayna\011F\0131 gerektirir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565211695402624)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli Konum')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566305434402624)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7 konumu koordinatlar\0131 ge\00E7ersiz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563713008402622)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130lk konum bir geometrik nokta olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566134234402624)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'tr'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564764968402623)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'tr'
,p_message_text=>'Katman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698034111402724)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'tr'
,p_message_text=>'Katman: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569353731402627)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'tr'
,p_message_text=>unistr('E\015Fle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562511600402621)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'tr'
,p_message_text=>'Mesajlar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566281937402624)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'tr'
,p_message_text=>'mil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697021405402723)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Veriler, izin verilen maksimum de\011Feri a\015Fan %0''dan fazla sat\0131r i\00E7eriyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564575917402623)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Ko\015Fullar</a> &nbsp;&nbsp; Verileri e\015Fle &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563429073402622)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'tr'
,p_message_text=>unistr('SDO_GEOMETRY veri tipi, bu veritaban\0131nda kullan\0131lamaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564601345402623)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap katk\0131da bulunanlar </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564896547402623)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'tr'
,p_message_text=>'Noktalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698154392402724)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'tr'
,p_message_text=>'%0 Puan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570140951402627)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'tr'
,p_message_text=>unistr('Dikd\00F6rtgen Yak\0131nla\015Ft\0131rma')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569852552402627)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kald\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565160202402623)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'tr'
,p_message_text=>unistr('Kuzey Yukar\0131da Olacak \015Eekilde Ayarla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645483165402684)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'tr'
,p_message_text=>unistr('2B moda ge\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645553750402684)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'tr'
,p_message_text=>unistr('3B moda ge\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569712150402627)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('Telif Hakk\0131 Bildirimine Ge\00E7i\015F Yap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570340218402627)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam Uzakl\0131k')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564984174402623)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'tr'
,p_message_text=>unistr('Yak\0131nla\015Ft\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565055452402623)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'tr'
,p_message_text=>unistr('Uzakla\015Ft\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692556050402720)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'tr'
,p_message_text=>unistr('Kal\0131n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693484189402720)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'tr'
,p_message_text=>'Resim'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693025712402720)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r \0130\00E7i Kod')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706687143402730)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'tr'
,p_message_text=>'Resim Ekle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706710111402730)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\011Flant\0131 Ekle')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692637339402720)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130talik')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707378349402731)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\011Flant\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693322291402720)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'tr'
,p_message_text=>'Liste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693217013402720)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenlenmi\015F Liste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692713407402720)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nizleme')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692887463402720)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nizleme Yap\0131lacak \00D6\011Fe Yok')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692934099402720)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'tr'
,p_message_text=>unistr('\00DCzeri \00C7izili')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693108474402720)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenlenmemi\015F Liste')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672047878402705)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('ge\00E7erli')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115729514976402747)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Daha Fazla...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115671952874402705)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCkleniyor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703741076402728)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'tr'
,p_message_text=>unistr('Bildirim Mesaj\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677061679402708)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, %0 de\011Ferine e\015Fit veya daha k\00FC\00E7\00FCk bir say\0131 olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677170978402708)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# ge\00E7erli bir say\0131 olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677262803402708)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, say\0131 format\0131 %0 ile e\015Flemiyor (\00D6rnek: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676936958402708)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL#, de\011Ferine e\015Fit veya bundan daha b\00FCy\00FCk bir say\0131 olmal\0131d\0131r%0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676813663402708)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# %0 ile %1 aras\0131nda bir say\0131 olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672174899402705)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'tr'
,p_message_text=>unistr('yeni pencerede a\00E7\0131l\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625336501402669)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu sayfa zaten g\00F6nderilmi\015F ve tekrar g\00F6nderilemez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607985322402656)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama "%0" Sayfa "%1" bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641760901402681)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('#LABEL# bir de\011Fere sahip olmal\0131d\0131r.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585045882402639)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'tr'
,p_message_text=>'Ara'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691030228402719)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'tr'
,p_message_text=>'Kapat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690959592402719)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'tr'
,p_message_text=>'Bul%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691285979402719)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691110654402719)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577108542402633)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'tr'
,p_message_text=>'En az %0 karakterlik bir arama terimi girin.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646645203402685)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Ferler A\00E7\0131lan Listesi: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577267417402633)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'tr'
,p_message_text=>'Arama terimi girin.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577011978402632)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonu\00E7 bulunamad\0131.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576905469402632)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00F6\011Fesini kald\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664825735402699)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'tr'
,p_message_text=>'Arama Terimi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690898649402719)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'tr'
,p_message_text=>'Ara'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701571021402726)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130\015Fleniyor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575509049402631)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'tr'
,p_message_text=>'Ana Ekrana Ekle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571561173402628)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Cihaz\0131n\0131z veya taray\0131c\0131n\0131z \015Fu anda A\015Famal\0131 Web Uygulamalar\0131n\0131n y\00FCklenmesini desteklemiyor.</p>'),
unistr('    <p class="a-pwaDialog-intro">Bu uygulama zaten cihaz\0131n\0131zda y\00FCkl\00FCyse, ana ekran\0131n\0131zdan a\00E7\0131n.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571149416402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi uygulama fonksiyonelli\011Fine sahiptir. Tam ekranda kullanmak i\00E7in ana ekran\0131n\0131za ekleyin.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Alt gezinme i\00E7erisindeki <strong>Men\00FC</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>Y\00FCkle</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText"> \00F6\011Fesine dokunun 3. Onaylamak i\00E7in <strong>Ekle</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571240901402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi, Chrome veya Edge''de en iyi \015Fekilde deneyimlenen uygulama fonksiyonelli\011Fine sahiptir.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Adres \00E7ubu\011Funun yan\0131nda bulunan <strong>Men\00FC</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>Y\00FCkle</strong></p> \00F6\011Fesine dokunun'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570861718402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi, Safari''de en iyi \015Fekilde deneyimlenen uygulama fonksiyonelli\011Fine sahiptir.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Alt gezinme i\00E7erisindeki <strong>Payla\015F</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2.<strong>Safari''de A\00E7</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570549097402627)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi uygulama fonksiyonelli\011Fine sahiptir. En iyi deneyim i\00E7in ana ekran\0131n\0131za ekleyin.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Adres \00E7ubu\011Funun yan\0131nda bulunan <strong>Payla\015F</strong> simgesine sokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>Ana Ekrana Ekle</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Teyit etmek i\00E7in <strong style="color:#007AE1;">Ekle</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570492025402627)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi uygulama fonksiyonelli\011Fine sahiptir. En iyi deneyim i\00E7in ana ekran\0131n\0131za ekleyin.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Alt gezinme i\00E7erisindeki <strong>Payla\015F</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. A\015Fa\011F\0131 kayd\0131r\0131n ve <strong>Ana Ekrana Ekle</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText"> \00F6\011Fesine dokunun 3. Onaylamak i\00E7in <strong style="color:#007AE1;">Ekle</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565410438402624)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi uygulama fonksiyonelli\011Fine sahiptir. En iyi deneyim i\00E7in ana ekran\0131n\0131za ekleyin.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Adres \00E7ubu\011Funun yan\0131nda bulunan <strong>Daha fazla</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. <strong>Ana Ekrana Ekle</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. Onaylamak i\00E7in <strong style="color:#007AE1;">Ekle</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570736132402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi uygulama fonksiyonelli\011Fine sahiptir. En iyi deneyim i\00E7in ana ekran\0131n\0131za ekleyin.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Adres \00E7ubu\011Funun yan\0131nda bulunan <strong>Payla\015F</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText"><strong>Safari''de A\00E7</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570683771402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi uygulama fonksiyonelli\011Fine sahiptir. En iyi deneyim i\00E7in ana ekran\0131n\0131za ekleyin.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Alt gezinme i\00E7erisindeki bulunan <strong>Payla\015F</strong> simgesine dokunun</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText"><strong>Safari''de A\00E7</strong> \00F6\011Fesine dokunun</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571499992402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi, Chrome''da en iyi \015Fekilde deneyimlenen uygulama fonksiyonelli\011Fine sahiptir.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \015Fu anda Windows''ta web uygulamalar\0131n\0131n y\00FCklenmesini desteklemez.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115570900816402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi, Chrome veya Edge''de en iyi \015Fekilde deneyimlenen uygulama fonksiyonelli\011Fine sahiptir.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox mevcut durumda macOS''ta web uygulamalar\0131n\0131n y\00FCklenmesini desteklemez.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571051779402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi, Chrome veya Edge''de en iyi \015Fekilde deneyimlenen uygulama fonksiyonelli\011Fine sahiptir.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari mevcut durumda macOS''ta web uygulamalar\0131n\0131n y\00FCklenmesini desteklemez.</p>'),
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571326781402628)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Bu web sitesi, Chrome veya Edge''de en iyi \015Fekilde deneyimlenen uygulama fonksiyonelli\011Fine sahiptir.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \015Fu anda Windows''ta web uygulamalar\0131n\0131n y\00FCklenmesini desteklemez.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573852691402630)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>Ba\011Flanam\0131yor</h1>'),
unistr('    <p>Bu uygulamay\0131 kullanabilmek i\00E7in bir internet ba\011Flant\0131s\0131na ihtiyac\0131n\0131z var.</p>'),
'    <button type="button">Yeniden dene</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573733809402630)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\011Flanam\0131yor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713511935402735)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'tr'
,p_message_text=>'Ekle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657946042402694)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm G\00FCn S\00FCren')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736835969402753)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'tr'
,p_message_text=>unistr('Davet G\00F6nder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736620789402752)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7enekler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659784058402695)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm g\00FCn i\00E7in g\00FCnl\00FCk g\00F6r\00FCn\00FCm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659524343402695)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'tr'
,p_message_text=>unistr('Zaman olan veriler i\00E7in g\00FCnl\00FCk g\00F6r\00FCn\00FCm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704499037402728)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698845451402724)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7\0131klama')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589434311402642)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'tr'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589218166402642)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'tr'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589162160402642)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'tr'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589359325402642)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'tr'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588842177402641)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Biti\015F Tarihi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589017326402642)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkinlik Ad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736711441402753)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'tr'
,p_message_text=>'Davet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704540164402728)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'tr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704263018402728)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'tr'
,p_message_text=>'Ay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707010071402730)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721396185402741)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'tr'
,p_message_text=>'Etkinlik Yok'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737099732402753)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'tr'
,p_message_text=>unistr('Mevcut bir Etkinli\011Fi d\00FCzenleyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736918408402753)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'tr'
,p_message_text=>unistr('E-Posta yoluyla Davet G\00F6nderme.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707143020402730)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715138618402736)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'tr'
,p_message_text=>unistr('E-Posta G\00F6nder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714954567402736)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'tr'
,p_message_text=>unistr('E-Posta G\00F6nder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737701347402753)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm alanlar gereklidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737623194402753)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Davet G\00F6nder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736567118402752)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'tr'
,p_message_text=>'Konu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715028568402736)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'tr'
,p_message_text=>'Kime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588923016402641)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7 Tarihi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712883293402734)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00FCzerinde olu\015Ftur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659370890402695)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'tr'
,p_message_text=>'Zaman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707295962402730)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Bug\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705038489402729)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704390185402728)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'tr'
,p_message_text=>'Hafta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659643746402695)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm g\00FCn i\00E7in haftal\0131k g\00F6r\00FCn\00FCm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659445962402695)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'tr'
,p_message_text=>unistr('Zaman olan veriler i\00E7in haftal\0131k g\00F6r\00FCn\00FCm')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704961484402729)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704664802402729)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunlar...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704728767402729)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'tr'
,p_message_text=>unistr('Daha fazlas\0131n\0131 y\00FCkle...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636815476402678)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583117685402637)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'tr'
,p_message_text=>unistr('Daha fazlas\0131n\0131 y\00FCkle...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585231424402639)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'tr'
,p_message_text=>'Ara...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115704819932402729)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'tr'
,p_message_text=>unistr('Daha fazlas\0131n\0131 y\00FCkle...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706972878402730)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge No %0 bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585161037402639)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri Bulunamad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609214741402657)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge sayfa numaralama s\0131f\0131rlanam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577496416402633)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge sayfa numaralama ayarlan\0131rken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698250236402724)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunlar...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706875068402730)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge Tipi %0 desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577390618402633)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('"#COMPONENT_NAME#" b\00F6lgesi i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641864402402681)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('#COLUMN_HEADER# bir de\011Fere sahip olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736124713402752)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0, zengin metin d\00FCzenleyicisi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643970962402683)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'tr'
,p_message_text=>unistr('Zengin Metin HTML i\015Faretleme dili \00F6\011Fenin maksimum uzunlu\011Funu a\015F\0131yor (fiili %0, izin verilen %1 karakter)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703893806402728)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'tr'
,p_message_text=>'Sil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695632079402722)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'tr'
,p_message_text=>'Tekrarlanan'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693992526402721)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenen S\00FCtunlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693827220402721)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015F De\011Ferleri Hari\00E7 Tut')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703904028402728)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'tr'
,p_message_text=>'Ekle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657597724402694)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'tr'
,p_message_text=>unistr('A\015Fa\011F\0131 Ta\015F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657669217402694)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yukar\0131 Ta\015F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693679492402721)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694212565402721)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Di\011Fer S\00FCtunlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693780586402721)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'tr'
,p_message_text=>'Geri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694051904402721)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694131056402721)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r %0 / %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695737030402722)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'tr'
,p_message_text=>'Yenile'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695866005402722)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fi\015Fiklikleri Geri Al')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115693560645402720)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('Ayarlar Men\00FCs\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654524986402691)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6rne\011Fin, %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562072368402621)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Tekrar Giri\015F Yap')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561954598402621)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'tr'
,p_message_text=>'Oturumunuz sona erdi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562159445402621)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'tr'
,p_message_text=>'Uzat'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561760840402621)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'tr'
,p_message_text=>'Oturumunuz %0 saatinde sona erecek. Uzatmak ister misiniz?'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561843464402621)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturumunuz %0 saatinde sona erecek ve uzat\0131lamaz. Herhangi bir veriyi kaybetmemek i\00E7in l\00FCtfen \015Fimdi herhangi bir \00E7al\0131\015Fmay\0131 kaydedin')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714713170402736)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Veritaban\0131 oturumu temizleme kodu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607862299402656)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Veritaban\0131 oturumu kurulum kodu i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115581981483402636)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'tr'
,p_message_text=>'Oturumunuz sona erdi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713692021402735)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen yeni bir oturum elde etmek i\00E7in bu ileti\015Fim kutusunu kapat\0131n ve taray\0131c\0131n\0131z\0131n yeniden y\00FCkleme d\00FC\011Fmesine bas\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732956778402750)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('Yeni bir oturum olu\015Fturmak i\00E7in <a href="%0">buraya</a> t\0131klay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619525747402664)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum Ge\00E7erli De\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659066439402695)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" kullan\0131c\0131s\0131 i\00E7in Ger\00E7ek Uygulama G\00FCvenli\011Fi oturumunda etkinle\015Ftirilebilen Dinamik Rol yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605712946402654)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-99900 Benzersiz oturum No olu\015Fturulamad\0131: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622028568402666)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum durumunu koruma ihlali: Bunun nedeni, %0 korumal\0131 sayfa \00F6\011Fesinin manuel olarak de\011Fi\015Ftirilmesi olabilir. Bu hataya neyin yol a\00E7t\0131\011F\0131ndan emin de\011Filseniz yard\0131m i\00E7in l\00FCtfen uygulama y\00F6neticisi ile ileti\015Fime ge\00E7in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741149872402756)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa koruma ihlali. Bu, hen\00FCz y\00FCklenmesi tamamlanmayan bir sayfan\0131n g\00F6nderilmesinden veya korumal\0131 sayfa \00F6\011Felerinin manuel olarak de\011Fi\015Ftirilmelerinden kaynaklan\0131yor olabilir. Daha fazla yard\0131m i\00E7in l\00FCtfen uygulama y\00F6neticiniz ile ileti\015Fime ge\00E7in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740178626402755)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \015Fu ge\00E7ersiz karakterlerden birini i\00E7eriyor: &<>"/;,*|=% veya --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740243434402755)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \015Fu ge\00E7ersiz karakterlerden birini i\00E7eriyor: &<>"/;,*|=% veya -- veya yeni sat\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739933475402755)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00F6zel karakterler i\00E7eriyor. Sadece a-Z, 0-9 karakterlerine ve bo\015Fluklara izin verilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115740033807402755)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 ge\00E7ersiz karakterler olan <, > veya " i\00E7eriyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584162824402638)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir veya daha fazla istek, \00F6nbellek temizleme veya ba\011F\0131ms\0131z de\011Fi\015Fken de\011Feri parametre olarak iletildi\011Finde sa\011Flama toplam\0131 gerektiren bir sayfa i\00E7in i\015Fleme g\00F6stermek \00FCzere sa\011Flama toplam\0131 sa\011Flanmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616943176402662)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum durumunu koruma ihlali: Bunun nedeni, sa\011Flama toplam\0131 i\00E7eren bir URL''nin manuel olarak de\011Fi\015Ftirilmesi veya yanl\0131\015F veya eksik sa\011Flama toplam\0131 olan bir ba\011Flant\0131n\0131n kullan\0131lmas\0131 olabilir. Bu hataya neyin yol a\00E7t\0131\011F\0131ndan emin de\011Filseniz yard\0131m i\00E7in')
||unistr(' l\00FCtfen uygulama y\00F6neticisi ile ileti\015Fime ge\00E7in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115694921430402721)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCksek Kontrast Modunu Kapal\0131 Olarak Ayarla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695049793402722)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCksek Kontrast Modunu A\00E7\0131k Olarak Ayarla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613644172402660)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'tr'
,p_message_text=>'Alt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613899584402660)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'tr'
,p_message_text=>unistr('A\015Fa\011F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613911368402660)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ta\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614035918402660)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Ta\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614100178402660)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614208188402660)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614397532402660)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131f\0131rla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613588764402660)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'tr'
,p_message_text=>unistr('\00DCst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613721858402660)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yukar\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722602650402742)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723392810402742)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0g i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722531302402742)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723414159402743)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 saat i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722368366402742)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723531965402743)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0d i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722992024402742)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0ay'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723151938402742)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0ay i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722416046402742)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723225791402742)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0s i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722710715402742)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723640808402743)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0h i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722872270402742)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'tr'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115723007000402742)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 y\0131l i\00E7inde')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562956861402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'tr'
,p_message_text=>unistr('[\00C7izgi]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563316206402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'tr'
,p_message_text=>unistr('[Birden \00C7ok Sat\0131r]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563159633402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'tr'
,p_message_text=>unistr('[Birden \00C7ok Nokta]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563551374402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'tr'
,p_message_text=>unistr('[Birden \00C7ok \00C7okgen]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563679062402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'tr'
,p_message_text=>'[Geometri Nesnesi]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562851183402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'tr'
,p_message_text=>'[Nokta (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563012143402622)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'tr'
,p_message_text=>unistr('[\00C7okgen]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640254554402680)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'tr'
,p_message_text=>'Daralt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640152442402680)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Geri Y\00FCkle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686618869402715)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'tr'
,p_message_text=>unistr('Puanlamay\0131 Temizle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676534781402708)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0, ge\00E7erli 1 - %1 puanlama aral\0131\011F\0131nda de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676636674402708)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 say\0131sal de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672796259402705)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Far\0131 Mesaj\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735851793402752)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735772898402752)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'tr'
,p_message_text=>'Geri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721455868402741)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ara\00E7 \00C7ubu\011Fu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736275131402752)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Gezinmeyi Geni\015Flet/Daralt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736382901402752)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Yan S\00FCtunu Geni\015Flet/Daralt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645908170402685)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Ana Gezinme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652913195402690)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('1 g\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652713904402690)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'tr'
,p_message_text=>'1 saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653038019402690)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 g\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652873216402690)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'tr'
,p_message_text=>'%0 saat'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652640732402690)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'tr'
,p_message_text=>'%0 dakika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653258865402690)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'tr'
,p_message_text=>'%0 hafta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115653181929402690)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'tr'
,p_message_text=>'1 hafta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739472798402755)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa ba\015F\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601441738402651)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'tr'
,p_message_text=>'Etkin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575203717402631)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130stek i\015Flenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654607325402691)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer Gerekli')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737578701402753)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen sayfan\0131n tamamen y\00FCklenmesini bekleyin ve yeniden deneyin.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697716972402723)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu sayfada kaydedilmemi\015F de\011Fi\015Fiklikler var.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578639551402634)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma kitab\0131, etkin \00E7al\0131\015Fma sayfas\0131 i\00E7ermiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578598161402634)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma kitab\0131 ba\015Flat\0131lmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578451837402634)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('XLSX dosyas\0131 olu\015Fturulurken dahili hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580961021402636)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'tr'
,p_message_text=>'Sayfa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712624793402734)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'tr'
,p_message_text=>'Eylemler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630128502402672)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('Eylemler Men\00FCs\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625828200402669)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>'Fonksiyon Ekle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625790834402669)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtuna G\00F6re Grup Ekle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659985402402695)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet S\00FCtunu Ekle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660056472402695)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r S\00FCtunu Ekle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600219499402650)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Birle\015Ftir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636380405402677)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'tr'
,p_message_text=>'Toplama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617477941402663)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'tr'
,p_message_text=>'Ortalama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621776985402666)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Say\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617508709402663)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'tr'
,p_message_text=>'Maksimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617741132402663)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'tr'
,p_message_text=>'Orta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617671910402663)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'tr'
,p_message_text=>'Minimum'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617313095402663)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'tr'
,p_message_text=>'Toplam %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618445178402664)
,p_name=>'APEXIR_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599576344402650)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm S\00FCtunlar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582021024402636)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm Sat\0131rlar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709608498402732)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'tr'
,p_message_text=>'Alternatif'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711293685402733)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Alternatif \00D6nde\011Fer: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612186262402659)
,p_name=>'APEXIR_AND'
,p_message_language=>'tr'
,p_message_text=>'ve'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601655860402651)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'tr'
,p_message_text=>'Uygula'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595388318402646)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'tr'
,p_message_text=>'Artan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614929703402661)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7 tarihi %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711863211402734)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'tr'
,p_message_text=>'Ortalama %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703214914402727)
,p_name=>'APEXIR_BAR'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7ubuk')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601019879402651)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'tr'
,p_message_text=>unistr('aras\0131nda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594119641402645)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'tr'
,p_message_text=>'Arka Plan Rengi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596047484402647)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'tr'
,p_message_text=>'mavi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627784448402671)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'tr'
,p_message_text=>'Alt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596699693402647)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ptal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602562819402652)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'tr'
,p_message_text=>'Kategori'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594090322402645)
,p_name=>'APEXIR_CELL'
,p_message_language=>'tr'
,p_message_text=>unistr('H\00FCcre')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618386705402664)
,p_name=>'APEXIR_CHART'
,p_message_language=>'tr'
,p_message_text=>'Grafik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628694093402671)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flat\0131l\0131yor...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115664986248402699)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>'Grafik etiketi belirtilmelidir.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677399392402709)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sorgunuz grafik ba\015F\0131na maksimum %0 veri noktas\0131n\0131 a\015F\0131yor. L\00FCtfen temel sorgunuzdaki kay\0131tlar\0131n say\0131s\0131n\0131 azaltmak i\00E7in bir filtre uygulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676254652402708)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Bir Grafik sorgusu i\00E7in maksimum sat\0131r say\0131s\0131, g\00F6r\00FCnt\00FClenen sat\0131r say\0131s\0131n\0131 de\011Fil, temel sorgudaki sat\0131r say\0131s\0131n\0131 s\0131n\0131rlar.  '),
unistr('Temel sorgunuz maksimum %0 sat\0131r say\0131s\0131n\0131 a\015F\0131yor. L\00FCtfen temel sorgunuzdaki kay\0131t say\0131s\0131n\0131 azaltmak i\00E7in bir filtre uygulay\0131n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599632144402650)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik T\00FCr\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115672902489402705)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC \0130\015Faretle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615366315402661)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor format\0131 se\00E7in')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622756214402667)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'tr'
,p_message_text=>'temizle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596552036402647)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633909134402675)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunlar')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706228006402730)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'tr'
,p_message_text=>'Filtrele...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624706356402668)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Ba\015Fl\0131\011F\0131 Men\00FCs\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628495349402671)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Bilgileri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708525329402731)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Etiketi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626145140402669)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610249448402657)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7erir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611199544402658)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7ermez')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595008898402646)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7inde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611347350402658)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Fu zaman diliminde de\011Fil:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619827173402665)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('sonrakinde de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611280171402658)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Fu zaman diliminde:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619749066402665)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'tr'
,p_message_text=>'sonrakinde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594964535402646)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('bo\015F de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594802830402646)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('bo\015F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594665855402646)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'tr'
,p_message_text=>'benzer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595132163402646)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'tr'
,p_message_text=>unistr('i\00E7inde de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594771536402646)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'tr'
,p_message_text=>'benzemez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610591974402658)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'tr'
,p_message_text=>unistr('d\00FCzenli ifadeyi e\015Fle\015Ftirir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615247423402661)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'tr'
,p_message_text=>'Hesaplama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115675980710402708)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('Hesaplama \0130fadesi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634228526402676)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun di\011Fer adlar\0131n\0131 kullanarak bir hesaplama olu\015Fturun.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634319685402676)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'tr'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634470803402676)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'tr'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634535177402676)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'tr'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580453132402635)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'tr'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619164069402664)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'tr'
,p_message_text=>'Hesapla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626738350402670)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'tr'
,p_message_text=>'Kontrol Kesmesi'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629714662402672)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'tr'
,p_message_text=>'Kontrol Kesmeleri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714194402402735)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Kesme S\00FCtunlar\0131n\0131 Kontrol Et')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577573110402633)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'tr'
,p_message_text=>unistr('Farkl\0131 Olanlar\0131 Say')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712308142402734)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'tr'
,p_message_text=>unistr('Farkl\0131 Olanlar\0131 Say')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712200173402734)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'tr'
,p_message_text=>unistr('Say\0131 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684324282402714)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCnl\00FCk')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739084722402754)
,p_name=>'APEXIR_DATA'
,p_message_language=>'tr'
,p_message_text=>'Veri'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628571071402671)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 dakika \00F6ncesinden itibaren verileri raporla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702065801402727)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri Gridi Yard\0131m\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600314333402650)
,p_name=>'APEXIR_DATE'
,p_message_language=>'tr'
,p_message_text=>'Tarih'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632414494402674)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nde\011Fer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709411917402732)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor T\00FCr\00FC \00D6nde\011Feri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596741428402647)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'tr'
,p_message_text=>'Sil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600625071402650)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu rapor ayarlar\0131n\0131 silmek istiyor musunuz?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695300648402722)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor \00D6nde\011Ferini Sil')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626425511402670)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Raporu Sil'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595425574402646)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'tr'
,p_message_text=>'Azalan'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602697659402652)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7\0131klama')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624650466402668)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Tek Sat\0131r G\00F6r\00FCn\00FCm\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632960524402675)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00F6n%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633877173402675)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'tr'
,p_message_text=>unistr('Devre d\0131\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596249036402647)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599467555402649)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenen S\00FCtunlar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632831482402675)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporda G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627652293402671)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'tr'
,p_message_text=>unistr('A\015Fa\011F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619252118402664)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ndir')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632746118402675)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FCleme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698768124402724)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'tr'
,p_message_text=>unistr('Ayn\0131 ko\015Fula sahip vurgulama zaten mevcut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714362965402736)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Tekrarlanan \00F6zet s\00FCtun. \00D6zet s\00FCtun listesi benzersiz olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714515422402736)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628737947402671)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik Ayarlar\0131n\0131 D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635385003402677)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635786775402677)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Filtre D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690183086402718)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Grup D\00FCzenleme \00D6l\00E7\00FCt\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635647647402677)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('Vurgulamay\0131 D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660201952402696)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zeti D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709792818402732)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'tr'
,p_message_text=>'E-Posta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588463622402641)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'tr'
,p_message_text=>'E-Posta Adresi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710099636402732)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'tr'
,p_message_text=>'Gizli bilgi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710257486402733)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'tr'
,p_message_text=>'Ana Metin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709912787402732)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'tr'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710736714402733)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131kl\0131k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592173569402644)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta bu uygulama i\00E7in konfig\00FCre edilmemi\015F. L\00FCtfen y\00F6neticinize ba\015Fvurun.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683609864402713)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>'E-Posta Adresi belirtilmelidir.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710362847402733)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'tr'
,p_message_text=>unistr('Eke bak\0131n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710186178402732)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'tr'
,p_message_text=>'Konu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684617841402714)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>'E-Posta Konusu belirtilmelidir.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709849823402732)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'tr'
,p_message_text=>'Kime'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593811286402645)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'tr'
,p_message_text=>'Etkin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635524160402677)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkinle\015Ftir/Devre D\0131\015F\0131 B\0131rak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635061095402676)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'tr'
,p_message_text=>'Hata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634613467402676)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6rnekler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635406908402677)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6rnekler:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599318590402649)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015F De\011Ferleri Hari\00E7 Tut')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636060779402677)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'tr'
,p_message_text=>unistr('Geni\015Flet/Daralt')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633680066402675)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130fade')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618723024402664)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'tr'
,p_message_text=>'Filtrele'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629685844402672)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'tr'
,p_message_text=>'Filtreler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639979924402680)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130fadeyi Filtrele')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736418875402752)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'tr'
,p_message_text=>unistr('Filtre ifadesi \00E7ok uzun.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639822076402680)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Filtre T\00FCr\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636262025402677)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'tr'
,p_message_text=>unistr('Aranacak s\00FCtunlar\0131 se\00E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619012867402664)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'tr'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633426397402675)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir flashback sorgusu, verileri \00F6nceki bir zaman noktas\0131nda var oldu\011Fu gibi g\00F6r\00FCnt\00FClemenizi sa\011Flar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684095410402714)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('Flashback S\00FCresi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685449675402715)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'tr'
,p_message_text=>'Format'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615166818402661)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'tr'
,p_message_text=>'Format Maskesi %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626348358402670)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>'Fonksiyon'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634192357402676)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'tr'
,p_message_text=>'Fonksiyonlar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709318257402732)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'tr'
,p_message_text=>unistr('Fonksiyonlar / \0130\015Fle\00E7ler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626038917402669)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'tr'
,p_message_text=>'Fonksiyon %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618510146402664)
,p_name=>'APEXIR_GO'
,p_message_language=>'tr'
,p_message_text=>'Git'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594333978402646)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'tr'
,p_message_text=>unistr('ye\015Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115577622579402633)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Gruplama \00D6l\00E7\00FCt\00FC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710490173402733)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtuna G\00F6re Grupla: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665018652402699)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtuna g\00F6re grup belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676187731402708)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir Gruplama \00D6l\00E7\00FCt\00FC Sorgusu i\00E7in maksimum sat\0131r say\0131s\0131, g\00F6r\00FCnt\00FClenen sat\0131r say\0131s\0131n\0131 de\011Fil, temel sorgudaki sat\0131r say\0131s\0131n\0131 s\0131n\0131rlar. Temel sorgunuz maksimum %0 sat\0131r say\0131s\0131n\0131 a\015F\0131yor. L\00FCtfen temel sorgunuzdaki kay\0131t say\0131s\0131n\0131 azaltmak i\00E7in bir filtre uy')
||unistr('gulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656748769402693)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralamaya G\00F6re Grupland\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714205142402736)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralama D\00FCzenine G\00F6re Grupla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599793871402650)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Yatay S\00FCtun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631378830402673)
,p_name=>'APEXIR_HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yard\0131m')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623183319402667)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Etkile\015Fimli raporlar, son kullan\0131c\0131lar\0131n raporlar\0131 \00F6zelle\015Ftirmesini sa\011Flar. Kullan\0131c\0131lar s\00FCtunlar\0131 se\00E7erek, filtreleri uygulayarak, vurgulayarak ve s\0131ralayarak rapor verilerinin yerle\015Fimini de\011Fi\015Ftirebilir. Kullan\0131c\0131lar ayr\0131ca kesintileri, birle\015Ftirme')
||unistr('leri, grafikleri, grupland\0131rmalar\0131 da tan\0131mlayabilir ve kendi hesaplamalar\0131n\0131 ekleyebilir. Kullan\0131c\0131lar ayr\0131ca bir abonelik ayarlayabilir, b\00F6ylece raporun bir HTML s\00FCr\00FCm\00FC belirlenen bir aral\0131kta kendilerine e - postayla g\00F6nderilecektir. Kullan\0131c\0131lar,')
||unistr(' genel veya \00F6zel g\00F6r\00FCnt\00FCleme i\00E7in bir raporun birden fazla varyasyonunu olu\015Fturabilir ve adland\0131r\0131lm\0131\015F raporlar olarak kaydedebilir. '),
'<p/>',
unistr('A\015Fa\011F\0131daki b\00F6l\00FCmler, etkile\015Fimli bir raporu \00F6zelle\015Ftirmenin yollar\0131n\0131 \00F6zetlemektedir. Daha fazla bilgi edinmek i\00E7in, bkz."Etkile\015Fimli Raporlar\0131n Kullan\0131m\0131", <i>Oracle Application Express Son Kullan\0131c\0131 K\0131lavuzu</i></a>.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630215238402673)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('Eylemler men\00FCs\00FC, Arama \00E7ubu\011Fundaki Git d\00FC\011Fmesinin sa\011F taraf\0131nda g\00F6r\00FCn\00FCr. Etkile\015Fimli bir raporu \00F6zelle\015Ftirmek i\00E7in bu men\00FCy\00FC kullan\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623944676402668)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Toplamlar, bir s\00FCtuna kar\015F\0131 yap\0131lan matematiksel hesaplamalard\0131r. Toplamlar her kontrol kesmesinden sonra g\00F6r\00FCnt\00FClenir ve raporun sonunda tan\0131ml\0131 olduklar\0131 s\00FCtunun i\00E7inde yer al\0131r. Se\00E7enekler \015Funlar\0131 i\00E7erir:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Toplam</strong> d\00FCzenlemek \00FCzere \00F6nceden tan\0131mlanm\0131\015F'),
unistr('bir toplam se\00E7menizi sa\011Flar.</li>'),
unistr('<li><strong>Fonksiyon</strong>ger\00E7ekle\015Ftirilecek fonksiyondur (\00F6rne\011Fin, SUM, MIN).</li>'),
unistr('<li><strong>S\00FCtun</strong> matematiksel fonksiyonu uygulamak \00FCzere s\00FCtun se\00E7mek i\00E7in kullan\0131l\0131r. Sadece say\0131sal'),
unistr('s\00FCtunlar g\00F6r\00FCnt\00FClenir.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624008129402668)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kaydedilen her rapor i\00E7in bir grafik tan\0131mlayabilirsiniz. Tan\0131mland\0131ktan'),
unistr('sonra, Arama \00E7ubu\011Fundaki g\00F6r\00FCn\00FCm simgelerini kullanarak grafik ve rapor g\00F6r\00FCn\00FCmleri aras\0131nda ge\00E7i\015F yapabilirsiniz.'),
unistr('Se\00E7enekler \015Funlar\0131 i\00E7erir:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>Grafik Tipi</strong> dahil edilecek grafik tipini tan\0131mlar.'),
unistr('Yatay \00E7ubuk, dikey \00E7ubuk, pasta grafik veya sat\0131r aras\0131ndan se\00E7im yap\0131n.</li>'),
unistr('<li><strong>Etiket</strong> etiket olarak kullan\0131lacak s\00FCtunu se\00E7menizi sa\011Flar.</li>'),
unistr('<li><strong>Etiket Ekseni Ba\015Fl\0131\011F\0131</strong> Etiket i\00E7in se\00E7ilen s\00FCtunla ili\015Fkili eksende g\00F6r\00FCnt\00FClenen'),
unistr('ba\015Fl\0131kt\0131r. Bu, pasta grafik i\00E7in kullan\0131lamaz.</li>'),
unistr('<li><strong>De\011Fer</strong> de\011Fer olarak kullan\0131lacak s\00FCtunu se\00E7menizi sa\011Flar. Fonksiyonunuz'),
unistr('bir SAYI ise, De\011Fer se\00E7ilmesine gerek yoktur.</li>'),
unistr('<li><strong>De\011Fer Ekseni Ba\015Fl\0131\011F\0131</strong> De\011Fer i\00E7in se\00E7ilen s\00FCtunla ili\015Fkili eksende g\00F6r\00FCnt\00FClenenler'),
unistr('ba\015Fl\0131kt\0131r. Bu, pasta grafik i\00E7in kullan\0131lamaz.</li>'),
unistr('<li><strong>Fonksiyon</strong> De\011Fer i\00E7in se\00E7ilen s\00FCtunda ger\00E7ekle\015Ftirilecek iste\011Fe ba\011Fl\0131 bir fonksiyondur.</li>'),
unistr('<li><strong>S\0131rala</strong> sonu\00E7 k\00FCmenizi s\0131ralaman\0131za olanak sa\011Flar.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623319462402667)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Herhangi bir s\00FCtun ba\015Fl\0131\011F\0131na t\0131kland\0131\011F\0131nda s\00FCtun ba\015Fl\0131\011F\0131 men\00FCs\00FC g\00F6r\00FCn\00FCr.Se\00E7enekler \015Funlar\0131 i\00E7erir:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Artan D\00FCzende S\0131rala</strong> simgesi raporu artan s\0131rayla s\00FCtuna g\00F6re s\0131ralar.</li>'),
unistr('<li><strong>Azalan D\00FCzende S\0131rala</strong> simgesi raporu azalan s\0131rada s\00FCtuna g\00F6re s\0131ralar.</li>'),
unistr('<li><strong>S\00FCtunu Gizle</strong> simgesi s\00FCtunu gizler.  T\00FCm s\00FCtunlar gizlenemez. Bir s\00FCtun gizlenemiyorsa, S\00FCtunu Gizle simgesi mevcut olmayacakt\0131r.</li>'),
unistr('<li><strong>Kesme S\00FCtunu</strong> s\00FCtun \00FCzerinde bir kesme grubu olu\015Fturur. Bu, s\00FCtunu ana kay\0131t olarak rapordan \00E7\0131kar\0131r.</li>'),
unistr('<li><strong>S\00FCtun Bilgisi</strong> varsa s\00FCtunla ilgili yard\0131m metnini g\00F6r\00FCnt\00FCler.</li>'),
unistr('<li><strong>Metin Alan\0131</strong> b\00FCy\00FCk/k\00FC\00E7\00FCk harf duyars\0131z arama kriterlerini girmek i\00E7in kullan\0131l\0131r'),
unistr('(joker karakterlere gerek yoktur). Bir de\011Fer girilmesi'),
unistr('men\00FCn\00FCn alt\0131ndaki de\011Fer listesini azalt\0131r. Daha sonra alt k\0131s\0131mdan'),
unistr('bir de\011Fer se\00E7ebilirsiniz ve se\00E7ilen de\011Fer ''='''),
unistr('kullan\0131larak bir filtre olarak olu\015Fturulur(\00F6rne\011Fin, <code>s\00FCtun= ''ABC''</code>). Alternatif olarak, El Feneri simgesine t\0131klayabilir ve ''LIKE'' de\011Fi\015Ftiricisi ile filtre olarak olu\015Fturulacak bir de\011Fer girebilirsiniz.'),
unistr(' (\00D6rne\011Fin, <code>s\00FCtun LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>Benzersiz De\011Ferler Listesi</b> filtre kriterlerinizi kar\015F\0131layan ilk 500'),
unistr('benzersiz de\011Feri i\00E7erir. S\00FCtun bir tarih ise, bunun yerine'),
unistr('tarih aral\0131klar\0131n\0131n bir listesi g\00F6r\00FCnt\00FClenir. Bir de\011Fer se\00E7erseniz, ''=''  kullan\0131larak bir filtre olu\015Fturulur (\00F6rne\011Fin, <code>s\00FCtun= ''ABC''</code>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623812176402668)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Raporunuza hesaplanm\0131\015F s\00FCtunlar eklemenizi sa\011Flar. Bunlar matematiksel hesaplamalar (\00F6rne\011Fin, <code>NBR_HOURS/24</code>) veya mevcut s\00FCtunlara uygulanan standart Oracle'),
unistr('fonksiyonlar\0131 olabilir. Baz\0131lar\0131 \00F6rnek olarak g\00F6r\00FCnt\00FClenirken, di\011Ferleri (\00F6r. <code>TO_DATE)</code> de kullan\0131labilir). Se\00E7enekler \015Funlar\0131 i\00E7erir:'),
'<p></p>',
'<ul>',
unistr('<li><strong>Hesaplama</strong> d\00FCzenlemek i\00E7in \00F6nceden tan\0131mlanm\0131\015F bir hesaplama se\00E7menizi sa\011Flar.</li>'),
unistr('<li><strong>S\00FCtun Ba\015Fl\0131\011F\0131</strong> yeni s\00FCtunun s\00FCtun ba\015Fl\0131\011F\0131d\0131r.</li>'),
unistr('<li><strong>Format Maskesi</strong>s\00FCtun kar\015F\0131s\0131nda uygulanacak bir Oracle formatl\0131 maskedir (\00F6rne\011Fin,S9999).</li>'),
unistr('<li><strong>Hesaplama</strong> ger\00E7ekle\015Ftirilecek hesaplamad\0131r. Hesaplama i\00E7inde, s\00FCtunlara g\00F6r\00FCnt\00FClenen di\011Fer adlar kullan\0131larak referansta bulunulur.</li>'),
'</ul>',
unistr('<p>Hesaplaman\0131n alt\0131nda, sorgunuzdaki s\00FCtunlar'),
unistr('ili\015Fkili di\011Fer adlar\0131yla birlikte g\00F6r\00FCnt\00FClenir. S\00FCtun ad\0131na veya di\011Fer ada t\0131kland\0131\011F\0131nda'),
unistr('bunlar Hesaplamaya dahil edilir. S\00FCtunlar\0131n yan\0131nda bir tu\015F tak\0131m\0131 bulunur. Bu tu\015F tak\0131m\0131'),
unistr('yayg\0131n olarak kullan\0131lan tu\015Flara k\0131sayol fonksiyonu g\00F6r\00FCr. En sa\011Fda Fonksiyonlar bulunur.</p>'),
unistr('<p>A\015Fa\011F\0131daki \00F6rnek hesaplama, toplam telafinin nas\0131l g\00F6r\00FCnt\00FClenece\011Fini g\00F6stermektedir:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(burada A KURULU\015ETUR, B MAA\015E ve C ise KOM\0130SYONDUR)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630354793402673)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir veya birden fazla s\00FCtunda bir kesme grubu olu\015Fturmak \00FCzere kullan\0131l\0131r. Bu, s\00FCtunlar\0131 etkile\015Fimli rapordan \00E7\0131kar\0131r ve ana kay\0131t olarak g\00F6r\00FCnt\00FCler.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624538928402668)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir seferde tek bir sat\0131r\0131n ayr\0131nt\0131lar\0131n\0131 g\00F6r\00FCnt\00FClemek i\00E7in, g\00F6r\00FCnt\00FClemek istedi\011Finiz sat\0131rdaki tek sat\0131r g\00F6r\00FCn\00FCm simgesine t\0131klay\0131n. Varsa, tek sat\0131r g\00F6r\00FCn\00FCm\00FC her zaman ilk s\00FCtun olacakt\0131r. Etkile\015Fimli raporun \00F6zelle\015Ftirilmesine ba\011Fl\0131 olarak, tek sa')
||unistr('t\0131rl\0131 g\00F6r\00FCn\00FCm standart g\00F6r\00FCn\00FCm veya g\00FCncellemeye izin verebilecek \00F6zel bir sayfa olabilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624442777402668)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ge\00E7erli sonu\00E7 k\00FCmesinin indirilmesini sa\011Flar. \0130ndirme formatlar\0131'),
unistr('kurulumunuza ve rapor tan\0131m\0131n\0131za ba\011Fl\0131 olarak de\011Fi\015Fir, ancak'),
unistr('CSV, HTML, E-posta, XLS, PDF veya RTF i\00E7erebilir.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623542023402667)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sorguya <code>WHERE</code> yant\00FCmcesini ekleyerek veya de\011Fi\015Ftirerek rapora odaklan\0131r. Bir s\00FCtunda veya sat\0131ra g\00F6re filtreleyebilirsiniz.  '),
unistr('<p>S\00FCtuna g\00F6re filtre uygularsan\0131z, bir s\00FCtun se\00E7in (g\00F6r\00FCnt\00FClenen s\00FCtun'),
unistr('olmas\0131 gerekmez), standart bir Oracle i\015Fleci se\00E7in (=, !=, i\00E7inde de\011Fil, aras\0131nda), kar\015F\0131la\015Ft\0131rmak i\00E7in bir ifade girin. \0130fadeler b\00FCy\00FCk k\00FC\00E7\00FCk harf duyarl\0131d\0131r. Joker karakter olarak % kullan\0131n (\00F6rne\011Fin, <code>STATE_NAME'),
'%A gibi)</code>.</p>',
unistr('<p>Sat\0131ra g\00F6re filtre uygularsan\0131z, karma\015F\0131k <code>WHERE</code> yant\00FCmcelerini s\00FCtun di\011Fer adlar\0131n\0131 ve herhangi bir Oracle fonksiyon veya i\015Flecini kullanarak olu\015Fturabilirsiniz (\00F6rne\011Fin, <code>G = ''VA'' veya G = ''CT''</code>, burada'),
unistr('<code>G</code>, <code>CUSTOMER_STATE</code> i\00E7in di\011Fer add\0131r).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624119528402668)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Flashback sorgusu, verileri \00F6nceki bir zaman noktas\0131nda oldu\011Fu gibi g\00F6r\00FCnt\00FClemenizi'),
unistr('sa\011Flar. Flashback yapabilece\011Finiz s\00FCre miktar\0131 \00F6nde\011Feri  3 saattir (veya 180 '),
unistr('dakika) ancak ger\00E7ek miktar her veritaban\0131 i\00E7in farkl\0131 olacakt\0131r.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685320139402715)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Format, raporun g\00F6r\00FCn\00FCm\00FCn\00FC \00F6zelle\015Ftirmenizi sa\011Flar..'),
unistr('Bi\00E7im \015Fu alt men\00FCy\00FC i\00E7erir:</p>'),
unistr('<ul><li>S\0131rala</li>'),
'<li>Kontrol Kesmesi</li>',
'<li>Vurgula</li>',
'<li>Hesapla</li>',
'<li>Topla</li>',
'<li>Grafik</li>',
unistr('<li>Grup \00D6l\00E7\00FCt\00FC</li>'),
unistr('<li>\00D6zet</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683531380402713)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kaydedilen rapor ba\015F\0131na bir Grup \00D6l\00E7\00FCt\00FC g\00F6r\00FCn\00FCm\00FC'),
unistr('tan\0131mlayabilirsiniz. Tan\0131mland\0131ktan sonra, grup aras\0131nda ge\00E7i\015F yapabilir ve'),
unistr('Arama \00E7ubu\011Fundaki g\00F6r\00FCn\00FCm simgelerini kullanarak g\00F6r\00FCn\00FCmleri bildirebilirsiniz. Grup \00D6l\00E7\00FCt\00FC g\00F6r\00FCn\00FCm\00FC olu\015Fturmak i\00E7in,'),
unistr('\015Funlar\0131 se\00E7ebilirsiniz:'),
'<p></p><ul>',
unistr('<li>gruplanacak s\00FCtunlar</li>'),
unistr('<li>ger\00E7ekle\015Ftirilecek fonksiyonla birlikte toplanacak s\00FCtunlar (ortalama, toplam, say\0131, vb.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623792967402668)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Filtre tan\0131mlaman\0131z\0131 sa\011Flar. Filtre kriterlerini kar\015F\0131layan sat\0131rlar, filtreyle ili\015Fkili \00F6zellikler kullan\0131larak vurgulanm\0131\015F olarak g\00F6r\00FCnt\00FClenir. Se\00E7enekler \015Funlar\0131 i\00E7erir:</p>'),
'<ul>',
unistr('<li><strong>Ad</strong> sadece g\00F6r\00FCn\00FCm i\00E7in kullan\0131l\0131r.</li>'),
unistr('<li><strong>S\0131ra</strong>kurallar\0131n de\011Ferlendirildi\011Fi s\0131ray\0131 tan\0131mlar.</li>'),
unistr('<li><strong>Etkin</strong>bir kural\0131n etkin veya devre d\0131\015F\0131 olup olmad\0131\011F\0131n\0131 tan\0131mlar.</li>'),
unistr('<li><strong>Vurgulama T\00FCr\00FC</strong> sat\0131r\0131n m\0131 yoksa h\00FCcrenin mi vurgulanmas\0131 gerekti\011Fini belirler. H\00FCcre se\00E7ilirse, Vurgu Ko\015Fulunda'),
unistr('belirtilen s\00FCtun vurgulan\0131r.</li>'),
unistr('<li><strong>Arka Plan Rengi</strong> vurgulanan alan\0131n arka plan\0131na ili\015Fkin yeni renktir.</li>'),
unistr('<li><strong>Metin Rengi</strong> vurgulanan alandaki metine ili\015Fkin yeni renktir.</li>'),
unistr('<li><strong>Vurgulama Ko\015Fulu</strong> filtrenizin ko\015Fulunu tan\0131mlar.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561371005402621)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Kaydedilen rapor ba\015F\0131na bir \00D6zet g\00F6r\00FCn\00FCm\00FC tan\0131mlayabilirsiniz. Tan\0131mland\0131ktan sonra, Arama \00E7ubu\011Fundaki g\00F6r\00FCn\00FCm simgelerini kullanarak \00F6zet ve rapor g\00F6r\00FCn\00FCmleri aras\0131nda ge\00E7i\015F yapabilirsiniz. Bir \00D6zet g\00F6r\00FCn\00FCm\00FC olu\015Fturmak i\00E7in \015Funlar\0131 se\00E7ersiniz '),
'<p></p>',
'<ul>',
unistr('<li>\00F6zetlenecek s\00FCtunlar</li>'),
unistr('<li>sat\0131r olarak g\00F6sterilecek s\00FCtunlar</li>'),
unistr('<li>ger\00E7ekle\015Ftirilecek fonksiyonla birlikte toplanacak s\00FCtunlar (ortalama, toplam, say\0131, vb.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634883623402676)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Etkile\015Fimli bir raporu \00F6zelle\015Ftirirseniz, rapor ayarlar\0131'),
unistr('Arama \00E7ubu\011Funun alt\0131nda ve raporun \00FCst\00FCnde g\00F6r\00FCnt\00FClenir. Bu alan soldaki simge kullan\0131larak daralt\0131labilir ve geni\015Fletilebilir.'),
'<p>',
unistr('Her rapor ayar\0131 i\00E7in:'),
'</p><ul>',
unistr('<li>Ada t\0131klayarak bir ayar\0131 d\00FCzenleyebilirsiniz.</li>'),
unistr('<li>Etkinle\015Ftir/Devre D\0131\015F\0131 B\0131rak onay kutusunun i\015Faretini kald\0131rarak veya i\015Faretleyerek bir ayar\0131 devre d\0131\015F\0131 b\0131rakabilirsiniz/etkinle\015Ftirebilirsiniz. Bir ayar\0131 ge\00E7ici olarak kapat\0131p a\00E7mak i\00E7in bu kontrol\00FC kullan\0131n.</li>'),
unistr('<li>Kald\0131r simgesine t\0131klayarak bir ayar\0131 kald\0131rabilirsiniz.</li>'),
'</ul>',
unistr('<p>Bir grafik, gruplama \00F6l\00E7\00FCt\00FC veya \00F6zet olu\015Fturduysan\0131z, sa\011Fda g\00F6sterilen'),
unistr('Rapor G\00F6r\00FCn\00FCm\00FC, Grafik G\00F6r\00FCn\00FCm\00FC, Gruplama \00D6l\00E7\00FCt\00FC G\00F6r\00FCn\00FCm\00FC ve \00D6zet G\00F6r\00FCn\00FCm\00FC'),
unistr('ba\011Flant\0131lar\0131n\0131 kullanarak bunlar ve temel rapor aras\0131nda ge\00E7i\015F yapabilirsiniz. Grafik, gruplama \00F6l\00E7\00FCt\00FC veya \00F6zet g\00F6r\00FCn\00FCm\00FCndeyseniz,'),
unistr('ayarlar\0131 d\00FCzenlemek i\00E7in D\00FCzenle ba\011Flant\0131s\0131n\0131 da kullanabilirsiniz.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624342618402668)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('Yapt\0131\011F\0131n\0131z t\00FCm \00F6zelle\015Ftirmeleri kald\0131rarak raporu ayar \00F6nde\011Ferine geri s\0131f\0131rlar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685640650402715)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa ba\015F\0131na g\00F6r\00FCnt\00FClenecek kay\0131tlar\0131n say\0131s\0131n\0131 ayarlar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624202707402668)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00D6zelle\015Ftirilmi\015F raporu ileride kullanmak \00FCzere kaydeder. Bir ad ve iste\011Fe ba\011Fl\0131 a\00E7\0131klama sa\011Flar ve raporu herkese a\00E7\0131k hale getirebilirsiniz (yani, birincil rapor \00F6nde\011Ferine eri\015Febilen t\00FCm kullan\0131c\0131lar). D\00F6rt t\00FCr etkile\015Fimli rapor kaydedebilirsini')
||'z:</p>',
'<ul>',
unistr('<li><strong>Birincil \00D6nde\011Fer</strong> (Sadece Geli\015Ftirici). Birincil \00D6nde\011Fer, ba\015Flang\0131\00E7ta g\00F6r\00FCnt\00FClenen rapordur. Birincil \00D6nde\011Fer raporlar\0131 yeniden adland\0131r\0131lamaz veya silinemez.</li>'),
unistr('<li><strong>Alternatif Rapor</strong> (Sadece Geli\015Ftirici). Geli\015Ftiricilerin birden fazla rapor d\00FCzeni olu\015Fturmas\0131n\0131 sa\011Flar. Sadece geli\015Ftiriciler bir Alternatif Raporu kaydedebilir, yeniden adland\0131rabilir veya silebilir.</li>'),
unistr('<li><strong>Genel Rapor</strong> (Son kullan\0131c\0131). Olu\015Fturan son kullan\0131c\0131 taraf\0131ndan kaydedilebilir, yeniden adland\0131r\0131labilir veya silinebilir. Di\011Fer kullan\0131c\0131lar d\00FCzeni ba\015Fka bir rapor olarak g\00F6r\00FCnt\00FCleyebilir ve kaydedebilir.</li>'),
unistr('<li><strong>\00D6zel Rapor</strong> (Son kullan\0131c\0131). Yaln\0131zca raporu olu\015Fturan son kullan\0131c\0131 raporu g\00F6r\00FCnt\00FCleyebilir, kaydedebilir, yeniden adland\0131rabilir veya silebilir.</li>'),
'</ul>',
unistr('<p>\00D6zelle\015Ftirilmi\015F raporlar\0131 kaydederseniz, Sat\0131r se\00E7icinin solundaki Arama \00E7ubu\011Funda bir Rapor se\00E7ici g\00F6r\00FCnt\00FClenir (bu \00F6zellik etkinle\015Ftirilmi\015Fse).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623241445402667)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Her rapor sayfas\0131n\0131n \00FCst k\0131sm\0131nda bir arama b\00F6lgesi bulunur. Bu b\00F6lge (veya Arama \00E7ubu\011Fu) a\015Fa\011F\0131daki \00F6zellikleri sa\011Flar:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686274186402715)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('<li><strong>Eylemler Men\00FCs\00FC</strong> bir raporu \00F6zelle\015Ftirmenize olanak sa\011Flar. A\015Fa\011F\0131daki b\00F6l\00FCmlere bak\0131n.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685776401402715)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'tr'
,p_message_text=>unistr('<li><strong>S\00FCtunlar\0131 se\00E7 simgesi</strong>, hangi s\00FCtunu arayaca\011F\0131n\0131z\0131 (veya t\00FCm\00FCn\00FC) belirlemenizi sa\011Flar.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686023924402715)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'tr'
,p_message_text=>unistr('<li><strong>Raporlar</strong> alternatif \00F6nde\011Feri ve kaydedilmi\015F \00F6zel veya genel raporu g\00F6r\00FCnt\00FCler.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685963197402715)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('<li><strong>Sat\0131rlar</strong> sayfa ba\015F\0131na g\00F6r\00FCnt\00FClenecek kay\0131tlar\0131n say\0131s\0131n\0131 ayarlar.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685808525402715)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>Metin alan\0131</strong>, b\00FCy\00FCk/k\00FC\00E7\00FCk harf duyars\0131z arama kriterlerini girmenizi sa\011Flar (joker karakterler dolayl\0131d\0131r).</li>'),
unistr('<li><strong>Git d\00FC\011Fmesi</strong> aramay\0131 y\00FCr\00FCt\00FCr. Enter tu\015Funa bas\0131ld\0131\011F\0131nda, imle\00E7 arama metni alan\0131nda oldu\011Funda arama da ger\00E7ekle\015Ftirilir.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686165077402715)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('<li><strong>G\00F6r\00FCn\00FCm Simgeleri</strong> tan\0131mlanm\0131\015Fsa, simge, rapor, detay, grafik, grup \00F6l\00E7\00FCt\00FC ve rapor \00F6zet g\00F6r\00FCn\00FCmleri aras\0131nda ge\00E7i\015F yapar.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702192946402727)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('<li><strong>Y\00F6net</strong> rapor veya veri gridi i\00E7in \00F6zellikleri, s\00FCtunlar\0131, sat\0131rlar\0131 y\00F6netmenizi ve ge\00E7mi\015Fi g\00F6r\00FCnt\00FClemenizi sa\011Flar.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623423947402667)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenen s\00FCtunlar\0131 de\011Fi\015Ftirmek i\00E7in kullan\0131l\0131r. Sa\011F ekrandaki s\00FCtunlar. Soldaki s\00FCtunlar gizlidir. En sa\011Fdaki oklar\0131 kullanarak g\00F6r\00FCnt\00FClenen s\00FCtunlar\0131 yeniden s\0131ralayabilirsiniz. Hesaplanan s\00FCtunlara <strong>**</strong> \00F6n eki yerle\015Ftirilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623648385402668)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00FCtunlar\0131 s\0131ralamak i\00E7in de\011Fi\015Ftirmek ve artan veya eksilen'),
unistr(' s\0131rayla s\0131ralan\0131p s\0131ralanmayaca\011F\0131n\0131 belirlemek i\00E7in kullan\0131l\0131r. Ayr\0131ca'),
unistr('<code>NULLs</code> kodunun nas\0131l kullan\0131laca\011F\0131n\0131 da belirtebilirsiniz. Ayar \00F6nde\011Feri <code>NULLs</code> kodlar\0131n\0131 her zaman en son veya her zaman ilk olarak g\00F6r\00FCnt\00FCler. Elde edilen s\0131ralama, rapordaki s\00FCtun'),
unistr('ba\015Fl\0131klar\0131n\0131n sa\011F\0131nda g\00F6r\00FCnt\00FClenir.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683349308402713)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir abonelik ekledi\011Finizde, bir e-posta adresi (veya virg\00FClle ayr\0131lm\0131\015F birden fazla e-posta adresi), e-posta konusu, s\0131kl\0131k ve ba\015Flang\0131\00E7 ve biti\015F tarihleri sa\011Flars\0131n\0131z. Ortaya \00E7\0131kan e-postalar, abonelik eklendi\011Finde mevcut olan rapor ayar\0131n\0131 kullanar')
||unistr('ak mevcut verileri i\00E7eren etkile\015Fimli raporun bir HTML s\00FCr\00FCm\00FCn\00FC i\00E7erir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701933731402727)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Veri gridleri temelde olduk\00E7a \00F6zelle\015Ftirilebilir olan d\00FCzenlenebilir raporlard\0131r. Kullan\0131c\0131lar s\00FCtunlar\0131 se\00E7erek, filtreleri uygulayarak, vurgulayarak ve s\0131ralayarak rapor verilerinin d\00FCzenini de\011Fi\015Ftirebilirler. Kullan\0131c\0131lar ayr\0131ca kesmeleri, toplama')
||unistr('lar\0131, grafikleri, grup \00F6l\00E7\00FCtlerini de tan\0131mlayabilir ve kendi hesaplamalar\0131n\0131 ekleyebilir. Kullan\0131c\0131lar, \00F6zel g\00F6r\00FCnt\00FCleme i\00E7in bir raporun birden fazla varyasyonunu olu\015Fturabilir ve bunlar\0131 adland\0131r\0131lm\0131\015F raporlar olarak kaydedebilir. '),
'<p/>',
unistr('Bir Veri gridi, Arama \00E7ubu\011Fu, Eylemler men\00FCs\00FC, Y\00F6net men\00FCs\00FC veya S\00FCtun Ba\015Fl\0131\011F\0131 men\00FCs\00FC kullan\0131larak \00F6zelle\015Ftirilebilir.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713740137402735)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'tr'
,p_message_text=>unistr('Eylemler men\00FCs\00FC, Arama \00E7ubu\011Fundaki Git d\00FC\011Fmesinin sa\011F taraf\0131nda g\00F6r\00FCn\00FCr. Veri grid raporunu \00F6zelle\015Ftirmek i\00E7in bu men\00FCy\00FC kullan\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702461923402727)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Ekle/D\00FCzenle Sayfas\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702583300402727)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Veri gridine sat\0131r eklemek i\00E7in Sat\0131r Ekle''ye t\0131klay\0131n. Bir sat\0131r\0131n ayr\0131nt\0131lar\0131n\0131 d\00FCzenlemek i\00E7in, d\00FCzenlemek istedi\011Finiz sat\0131rdaki sat\0131r simgesine (ilk s\00FCtun) t\0131klay\0131n. Veri gridinin s\00FCtunlar\0131n\0131 g\00F6steren Sat\0131r Ekle/D\00FCzenle sayfas\0131 g\00F6r\00FCnt\00FClenir. <')
||'/p>',
'',
unistr('<p>Bir sat\0131r\0131 d\00FCzenlerken:</p>'),
'',
'<p><ul>',
unistr('<li><strong>Sat\0131r\0131</strong> silebilirsiniz.</li>'),
unistr('<li><strong>De\011Fi\015Fiklikleri Uygula</strong> se\00E7ene\011Fini kullanarak sat\0131ra uygulanan de\011Fi\015Fiklikleri kaydedebilirsiniz.</li>'),
unistr('<li><strong>Eylemler</strong> i\00E7erisinde, sat\0131r ekleyebilir, dosya, not, ba\011Flant\0131 veya etiket ekleyebilir ve ge\00E7mi\015Fi inceleyebilirsiniz.</li>'),
unistr('<li>\0130leri ve Geri<strong> se\00E7ene\011Fi ile sat\0131rlarda</strong> gezinebilirsiniz.</li>'),
unistr('<li><strong>Y\00F6net</strong> i\00E7erisinde, s\00FCtun \00F6zelliklerini, s\00FCtun gruplar\0131n\0131, do\011Frulamalar\0131 ve de\011Fer listelerini ayarlayabilirsiniz.</li>'),
'</ul></p>',
'',
unistr('<p>Sayfan\0131n alt k\0131sm\0131ndaki Ek A\00E7\0131klamalar b\00F6lgesi, ge\00E7erli sat\0131rla ili\015Fkili t\00FCm dosyalar\0131, notlar\0131, ba\011Flant\0131lar\0131 veya etiketleri g\00F6r\00FCnt\00FCler.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713812282402735)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir veya birden fazla s\00FCtunda bir kesme grubu olu\015Fturmak \00FCzere kullan\0131l\0131r. Bu, s\00FCtunlar\0131 veri gridinden \00E7\0131kar\0131r ve ana kay\0131t olarak g\00F6r\00FCnt\00FCler.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702301765402727)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ge\00E7erli sonu\00E7 k\00FCmesinin indirilmesini sa\011Flar. \0130ndirme formatlar\0131 aras\0131nda'),
unistr('CSV, HTML veya E-posta yer al\0131r.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713966805402735)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Etkile\015Fimli bir raporu \00F6zelle\015Ftirirseniz, rapor ayarlar\0131'),
unistr('Arama \00E7ubu\011Funun alt\0131nda ve raporun \00FCst\00FCnde g\00F6r\00FCnt\00FClenir. Bu alan soldaki simge kullan\0131larak daralt\0131labilir ve geni\015Fletilebilir.'),
'<p>',
unistr('Her rapor ayar\0131 i\00E7in:'),
'</p><ul>',
unistr('<li>Ada t\0131klayarak bir ayar\0131 d\00FCzenleyebilirsiniz.</li>'),
unistr('<li>Etkinle\015Ftir/Devre D\0131\015F\0131 B\0131rak onay kutusunun i\015Faretini kald\0131rarak veya i\015Faretleyerek bir ayar\0131 devre d\0131\015F\0131 b\0131rakabilirsiniz/etkinle\015Ftirebilirsiniz. Bir ayar\0131 ge\00E7ici olarak kapat\0131p a\00E7mak i\00E7in bu kontrol\00FC kullan\0131n.</li>'),
unistr('<li>Kald\0131r simgesine t\0131klayarak bir ayar\0131 kald\0131rabilirsiniz.</li>'),
'</ul>',
unistr('<p>Bir grafik veya gruplama \00F6l\00E7\00FCt\00FC olu\015Fturduysan\0131z, sa\011Fda g\00F6sterilen'),
unistr('Rapor G\00F6r\00FCn\00FCm\00FC, Grafik G\00F6r\00FCn\00FCm\00FC ve Gruplama \00D6l\00E7\00FCt\00FC G\00F6r\00FCn\00FCm\00FC '),
unistr('ba\011Flant\0131lar\0131n\0131 kullanarak bunlar ve temel rapor aras\0131nda ge\00E7i\015F yapabilirsiniz. Grafik veya gruplama \00F6l\00E7\00FCt\00FC g\00F6r\00FCn\00FCm\00FCndeyseniz'),
unistr('ayarlar\0131 d\00FCzenlemek i\00E7in D\00FCzenle ba\011Flant\0131s\0131n\0131 da kullanabilirsiniz.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702243301402727)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Daha sonra kullanmak i\00E7in \00F6zelle\015Ftirilmi\015F veri gridi rapor yerle\015Fimini kaydeder. Bir ad ve iste\011Fe ba\011Fl\0131 a\00E7\0131klama sa\011Flars\0131n\0131z. \00DC\00E7 t\00FCr veri gridi rapor d\00FCzenini kaydedebilirsiniz:</p>'),
'<ul>',
unistr('<li><strong>Birincil \00D6nde\011Fer</strong> (Sadece \00D6nde\011Fer). Birincil \00D6nde\011Fer, ba\015Flang\0131\00E7ta g\00F6r\00FCnt\00FClenen yerle\015Fimdir. Birincil \00D6nde\011Fer raporlar\0131 yeniden adland\0131r\0131lamaz veya silinemez.</li>'),
unistr('<li><strong>Alternatif Rapor</strong> (Sadece Y\00F6netici). Y\00F6neticilerin birden fazla rapor yerle\015Fimi olu\015Fturmas\0131n\0131 sa\011Flar. Yaln\0131zca y\00F6neticiler bir Alternatif Raporu kaydedebilir, yeniden adland\0131rabilir veya silebilir.</li>'),
unistr('<li><strong>\00D6zel Rapor</strong> (T\00FCm Kullan\0131c\0131lar). Rapor yerle\015Fimini olu\015Fturan kullan\0131c\0131 raporu g\00F6r\00FCnt\00FCleyebilir, kaydedebilir, yeniden adland\0131rabilir veya silebilir.</li>'),
'</ul>',
unistr('<p>\00D6zelle\015Ftirilmi\015F raporlar\0131 kaydederseniz, Sat\0131r se\00E7icinin solundaki Arama \00E7ubu\011Funda bir Rapor se\00E7ici g\00F6r\00FCnt\00FClenir (bu \00F6zellik etkinle\015Ftirilmi\015Fse).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628387165402671)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunu Gizle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618954250402664)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'tr'
,p_message_text=>'Vurgula'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629843670402672)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'tr'
,p_message_text=>'Vurgulamalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634976169402676)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'tr'
,p_message_text=>unistr('Vurgulama Ko\015Fulu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683929372402713)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'tr'
,p_message_text=>'Vurgulama Stili'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593911386402645)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Vurgulama T\00FCr\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703452718402728)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'tr'
,p_message_text=>'Yatay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733009524402750)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'tr'
,p_message_text=>'1 etkin olmayan ayar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733167706402750)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>'%0 etkin olmayan ayar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624939951402669)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli Rapor Yard\0131m\0131')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635914491402677)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629325868402672)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz hesaplama ifadesi .%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588715523402641)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Biti\015F tarihi ba\015Flang\0131\00E7 tarihinden b\00FCy\00FCk olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643603100402683)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz filtre ifadesi. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711450336402733)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz filtre sorgusu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733266360402750)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'tr'
,p_message_text=>unistr('1 ge\00E7ersiz ayar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733337147402750)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 ge\00E7ersiz ayar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684113133402714)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'tr'
,p_message_text=>'(dakika olarak)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701152312402726)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 i\00E7inde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701342076402726)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonraki %1 i\00E7inde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701267468402726)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 son %1 i\00E7inde de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701451449402726)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 sonraki %1 i\00E7inde de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634099447402675)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'tr'
,p_message_text=>unistr('Tu\015F Tak\0131m\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600113025402650)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Etiket %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627938436402671)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Etiket i\00E7in Eksen Ba\015Fl\0131\011F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620468621402665)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Son G\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620641091402665)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'tr'
,p_message_text=>'Son Saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620122175402665)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en Ay')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620228692402665)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en Hafta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620317493402665)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('Son %0 G\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620525170402665)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'tr'
,p_message_text=>'Son %0 Saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619944145402665)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en %0 Y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620089997402665)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7en Y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600026126402650)
,p_name=>'APEXIR_LINE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596830595402647)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'tr'
,p_message_text=>unistr('Alan\0131 Olan \00C7izgi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711324202402733)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'tr'
,p_message_text=>unistr('E\015Fle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628843646402672)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'tr'
,p_message_text=>unistr('Sorgunun izin verilen maksimum kaynaklar\0131 a\015Ft\0131\011F\0131 tahmin ediliyor.  L\00FCtfen rapor ayarlar\0131n\0131z\0131 de\011Fi\015Ftirin ve tekrar deneyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611069774402658)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu rapor i\00E7in maksimum sat\0131r say\0131s\0131 %0 sat\0131rd\0131r. L\00FCtfen sorgunuzdaki kay\0131tlar\0131n say\0131s\0131n\0131 azaltmak i\00E7in bir filtre uygulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711935310402734)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'tr'
,p_message_text=>'Maksimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712112022402734)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'tr'
,p_message_text=>'Orta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615083325402661)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 dakika \00F6nce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712063191402734)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'tr'
,p_message_text=>'Minimum %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711002747402733)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'tr'
,p_message_text=>'Ay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684537158402714)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'tr'
,p_message_text=>unistr('Ayl\0131k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627105718402670)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ta\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627024944402670)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Ta\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738215055402754)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge Statik No, sayfa birden fazla etkile\015Fimli rapor i\00E7erdi\011Finden belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595509586402647)
,p_name=>'APEXIR_NAME'
,p_message_language=>'tr'
,p_message_text=>'Ad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622954178402667)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Yeni Birle\015Ftirme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733976428402750)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Yeni Kategori'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115623062829402667)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'tr'
,p_message_text=>'Yeni Hesaplama'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617871300402663)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620944303402665)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki G\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620736713402665)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621205987402666)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Ay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621162310402666)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'tr'
,p_message_text=>'Sonraki Hafta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621055390402666)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki %0 G\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115620812165402665)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'tr'
,p_message_text=>'Sonraki %0 Saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621426704402666)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki %0 Y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621381820402666)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki Y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595877641402647)
,p_name=>'APEXIR_NO'
,p_message_language=>'tr'
,p_message_text=>unistr('Hay\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636194893402677)
,p_name=>'APEXIR_NONE'
,p_message_language=>'tr'
,p_message_text=>unistr('- Hi\00E7biri -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683745772402713)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli bir e-posta adresi de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632662080402674)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015Flar Her Zaman \00D6nce')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632541234402674)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015Flar Her zaman En Son')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633045636402675)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015F S\0131ralama %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629498120402672)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'tr'
,p_message_text=>unistr('Flashback s\00FCresi say\0131sal olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629094964402672)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ra say\0131sal olmal\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633557524402675)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130\015Fle\00E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594482128402646)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'tr'
,p_message_text=>'turuncu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703347146402728)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00F6nlendirme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596345217402647)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'tr'
,p_message_text=>unistr('Di\011Fer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579142618402634)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa y\00F6n\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579807235402635)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'tr'
,p_message_text=>'Yatay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579967181402635)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'tr'
,p_message_text=>'Dikey'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579022664402634)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'tr'
,p_message_text=>'Sayfa boyutu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579627635402634)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'tr'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579558014402634)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'tr'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579720416402635)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579324961402634)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'tr'
,p_message_text=>'Yasal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579294569402634)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'tr'
,p_message_text=>'Mektup'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115579407367402634)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'tr'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712493965402734)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam Say\0131 Y\00FCzdesi %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711686375402734)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam Y\00FCzdesi %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710608714402733)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam Say\0131 Y\00FCzdesi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710553144402733)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'tr'
,p_message_text=>unistr('Toplam Y\00FCzdesi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599914781402650)
,p_name=>'APEXIR_PIE'
,p_message_language=>'tr'
,p_message_text=>'Pasta grafik'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659875897402695)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661362163402696)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>'Toplam belirtilmelidir.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661553120402697)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r s\00FCtunu olarak se\00E7ilen bir s\00FCtunda birle\015Ftiremezsiniz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660799565402696)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet S\00FCtunlar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660543396402696)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet S\00FCtunu %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661117603402696)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet s\00FCtunu belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561292146402620)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Bir \00D6zet sorgusu i\00E7in maksimum sat\0131r say\0131s\0131, g\00F6r\00FCnt\00FClenen sat\0131r say\0131s\0131n\0131 de\011Fil, temel sorgudaki sat\0131r say\0131s\0131n\0131 s\0131n\0131rlar. Temel sorgunuz maksimum %0 sat\0131r say\0131s\0131n\0131 a\015F\0131yor. L\00FCtfen temel sorgunuzdaki kay\0131t say\0131s\0131n\0131 azaltmak i\00E7in bir filtre uygulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661040276402696)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet S\0131ralamas\0131')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630415333402673)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zet s\00FCtun \00E7ok fazla farkl\0131 de\011Fer i\00E7eriyor - \00F6zet SQL olu\015Fturulam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683844192402713)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nizleme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617954780402663)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115709512531402732)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'tr'
,p_message_text=>'Birincil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684854634402714)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Birincil Rapor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578994326402634)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Filebilirlik Etiketlerini Dahil Et')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565847601402624)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Zengin Metni Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642695782402682)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600599204402650)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'tr'
,p_message_text=>'Genel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596150991402647)
,p_name=>'APEXIR_RED'
,p_message_language=>'tr'
,p_message_text=>unistr('k\0131rm\0131z\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738161542402754)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge Statik No %0 mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627241871402670)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627381454402670)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733451484402750)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafi\011Fi Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626849054402670)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'tr'
,p_message_text=>unistr('Kontrol Kesmesini Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626527016402670)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Filtreyi Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626689482402670)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'tr'
,p_message_text=>unistr('Flashback''i Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733562665402750)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Grup \00D6l\00E7\00FCt\00FCn\00FC Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626976073402670)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('Vurgulamay\0131 Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733655772402750)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zeti Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714681803402736)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporu Kald\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695287987402722)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor \00D6nde\011Ferini Yeniden Adland\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636435775402677)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporu Yeniden Adland\0131r')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618252562402663)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Rapor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712552891402734)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'tr'
,p_message_text=>'Raporlar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592757722402644)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 di\011Fer ad\0131yla kaydedilmi\015F Etkile\015Fimli rapor mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642994647402682)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592835261402644)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Kaydedilmi\015F Etkile\015Fimli Rapor Kimli\011Fi %0 mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115634729747402676)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor Ayarlar\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615518770402661)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor G\00F6r\00FCn\00FCm\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619456057402664)
,p_name=>'APEXIR_RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131f\0131rla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600788611402650)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporu ayar \00F6nde\011Ferine geri y\00FCkleyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595973565402647)
,p_name=>'APEXIR_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708697368402731)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131 i\00E7in birincil anahtar s\00FCtun olarak ROWID kullanamazs\0131n\0131z.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625952072402669)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131rlar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685527412402715)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r / Sayfa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660845639402696)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r S\00FCtunlar\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660694865402696)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r S\00FCtunu %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661266159402696)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r s\00FCtunu belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661489935402697)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r s\00FCtunu \00F6zet s\00FCtunundan farkl\0131 olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640078345402680)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Filtresi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615699491402661)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r %0 / %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619695022402664)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r metni i\00E7erir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595238748402646)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'tr'
,p_message_text=>'Kaydet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630031830402672)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Kaydedilen Rapor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629953207402672)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'tr'
,p_message_text=>'Kaydedilen Rapor= "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632128421402674)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli rapor ayarlar\0131, t\00FCm kullan\0131c\0131lar i\00E7in \00F6nde\011Fer olarak kullan\0131lacakt\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115695146873402722)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Varsay\0131lan Raporu Kaydet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115619358719402664)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Raporu Kaydet'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733864340402750)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'tr'
,p_message_text=>'Raporu Kaydet*'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686549788402715)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'tr'
,p_message_text=>'Ara'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115624897682402668)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Arama \00C7ubu\011Fu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115733715737402750)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'tr'
,p_message_text=>'Ara: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692090374402719)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'tr'
,p_message_text=>'Arama Raporu'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676039651402708)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Se\00E7ilen S\00FCtunlar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596946805402648)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('- S\00FCtun Se\00E7in -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618666887402664)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtunlar\0131 Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600424503402650)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('- Fonksiyon Se\00E7in -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625642693402669)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('- S\00FCtuna G\00F6re Grup Se\00E7 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660348737402696)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('- \00D6zet S\00FCtunu Se\00E7 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711553377402734)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Se\00E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660478346402696)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('- Sat\0131r S\00FCtunu Se\00E7 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569158775402626)
,p_name=>'APEXIR_SEND'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6nder')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575458302402631)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta olarak g\00F6nder')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595665935402647)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618825155402664)
,p_name=>'APEXIR_SORT'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131rala')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628108589402671)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Artan D\00FCzende S\0131rala')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628277122402671)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Azalan D\00FCzende S\0131rala')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714052544402735)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'tr'
,p_message_text=>unistr('S\0131ralama D\00FCzeni')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622608818402667)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'tr'
,p_message_text=>unistr('ara \00E7ubu\011Fu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633782692402675)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'tr'
,p_message_text=>unistr('Stat\00FC %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684263560402714)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'tr'
,p_message_text=>'Abonelik'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710941391402733)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'tr'
,p_message_text=>unistr('Biti\015F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565305086402624)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'tr'
,p_message_text=>'Veri Bulunmazsa Atla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115710866169402733)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711742959402734)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'tr'
,p_message_text=>'Toplam %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701701222402726)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge= %0, Rapor= %1, G\00F6r\00FCnt\00FCleme= %2, G\00F6r\00FCnt\00FClenen Sat\0131r Ba\015Flang\0131c\0131 = %3, G\00F6r\00FCnt\00FClenen Sat\0131r Sonu = %4, Toplam Sat\0131r Say\0131s\0131 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622328209402667)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge= %0, Rapor= %1, G\00F6r\00FCnt\00FCleme= %2, G\00F6r\00FCnt\00FClenen Sat\0131r Ba\015Flang\0131c\0131 = %3, G\00F6r\00FCnt\00FClenen Sat\0131r Sonu = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594563382402646)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'tr'
,p_message_text=>'Metin Rengi'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611682218402659)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00FCnler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611544525402658)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'tr'
,p_message_text=>'saatler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611404822402658)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'tr'
,p_message_text=>'dakikalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611887960402659)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'tr'
,p_message_text=>'aylar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611755418402659)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'tr'
,p_message_text=>'haftalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115611923069402659)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('y\0131llar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115714481799402736)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7i\015F Yap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627413077402670)
,p_name=>'APEXIR_TOP'
,p_message_language=>'tr'
,p_message_text=>unistr('\00DCst')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707602128402731)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Gruplanmam\0131\015F S\00FCtun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628948103402672)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Vurgulama Ad\0131 benzersiz olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599208450402649)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('desteklenmeyen veri t\00FCr\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627579356402671)
,p_name=>'APEXIR_UP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yukar\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629182588402672)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen ge\00E7erli bir renk girin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629284823402672)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen ge\00E7erli bir format maskesi girin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115596460115402647)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115628027989402671)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer i\00E7in Eksen Ba\015Fl\0131\011F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635877206402677)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer Gerekli')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599848213402650)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Dikey S\00FCtun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115703511130402728)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'tr'
,p_message_text=>'Dikey'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635188570402676)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafi\011Fi G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690334114402718)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'tr'
,p_message_text=>unistr('Detay\0131 G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115735969418402752)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporda tan\0131mlanm\0131\015F %0 g\00F6r\00FCn\00FCm yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690494422402718)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Gruplama \00D6l\00E7\00FCt\00FCn\00FC G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690277740402718)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'tr'
,p_message_text=>unistr('Simgeleri G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660142831402696)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zeti G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115635207745402676)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporu G\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684429935402714)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'tr'
,p_message_text=>unistr('Haftal\0131k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618103075402663)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma Raporu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713127437402735)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 g\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713012705402735)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'tr'
,p_message_text=>'%0 saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115712920141402735)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'tr'
,p_message_text=>'%0 dakika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713302217402735)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'tr'
,p_message_text=>'%0 ay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713284334402735)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'tr'
,p_message_text=>'%0 hafta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115713448630402735)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115711107613402733)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115594209120402646)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'tr'
,p_message_text=>unistr('sar\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115595753846402647)
,p_name=>'APEXIR_YES'
,p_message_language=>'tr'
,p_message_text=>'Evet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115627836820402671)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 ge\00E7ersiz karakterler olan < veya > i\00E7eriyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115650698230402688)
,p_name=>'APEX_REGION'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115578801418402634)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'tr'
,p_message_text=>unistr('API \00F6n ko\015Fulu ihlal edildi')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598326391402649)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130li\015Fkili olu\015Fturma se\00E7ene\011Fi devre d\0131\015F\0131 b\0131rak\0131ld\0131\011F\0131 i\00E7in %0 Uygulama Ayar\0131 de\011Feri al\0131nam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598218939402649)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130li\015Fkili olu\015Fturma se\00E7ene\011Fi devre d\0131\015F\0131 b\0131rak\0131ld\0131\011F\0131 i\00E7in %0 Uygulama Ayar\0131 de\011Feri ayarlanam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705903177402729)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama Ayar\0131 %0 de\011Feri ge\00E7ersiz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115705898228402729)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130stenen Uygulama Ayar\0131 %0 tan\0131mlanmam\0131\015F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706004867402730)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama Ayar\0131 %0 bo\015F bir de\011Fere ayarlanamaz')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586981871402640)
,p_name=>'BACK'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573927987402630)
,p_name=>'BUILDER'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Fturucu')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638068754402679)
,p_name=>'BUTTON LABEL'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FC\011Fme Etiketi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573025189402629)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FC\011Fme Basamakl\0131 Stil Sayfalar\0131 S\0131n\0131flar\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602291462402651)
,p_name=>'BUTTON_ID'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Fturulan d\00FC\011Fme no, tan\0131ml\0131ysa d\00FC\011Fmenin Statik No''su olacak veya tan\0131ml\0131 de\011Filse, ''B'' format\0131nda dahili olarak olu\015Fturulmu\015F bir no olacakt\0131r || [Dahili D\00FC\011Fme No]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565730871402624)
,p_name=>'CANDLESTICK'
,p_message_language=>'tr'
,p_message_text=>'Mum'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647299573402686)
,p_name=>'CENTER'
,p_message_language=>'tr'
,p_message_text=>'Orta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597238026402648)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \0130stek')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588676755402641)
,p_name=>'CHECK$'
,p_message_language=>'tr'
,p_message_text=>unistr('sat\0131r se\00E7ici')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115707795866402731)
,p_name=>'CHECKED'
,p_message_language=>'tr'
,p_message_text=>unistr('i\015Faretli')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683266194402713)
,p_name=>'COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643749991402683)
,p_name=>'COMMENTS'
,p_message_language=>'tr'
,p_message_text=>'Yorumlar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625282070402669)
,p_name=>'CONTINUE'
,p_message_language=>'tr'
,p_message_text=>'Devam et'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587289434402640)
,p_name=>'COPYRIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('Telif Hakk\0131 &copy; %0, T\00FCm haklar\0131 sakl\0131d\0131r.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630906051402673)
,p_name=>'COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Say\0131')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637635271402678)
,p_name=>'CREATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Ftur')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689975995402718)
,p_name=>'CREATED'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Fturuldu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690072914402718)
,p_name=>'CREATED_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Fturan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614811937402661)
,p_name=>'CREATED_ON'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Fturma Tarihi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625477865402669)
,p_name=>'CUSTOM'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zel')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636616059402678)
,p_name=>'CUSTOMIZE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6zelle\015Ftir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638232759402679)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 kullan\0131c\0131s\0131 i\00E7in sayfa tercihleri s\0131f\0131rland\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638326274402679)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 kullan\0131c\0131s\0131 i\00E7in tercihler de\011Fi\015Ftirildi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638169058402679)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 kullan\0131c\0131s\0131 i\00E7in sayfa tercihleri s\0131f\0131rland\0131.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601984182402651)
,p_name=>'DAILY'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCnl\00FCk')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115573546648402630)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kar\015F\0131ya y\00FCklenen dosya ge\00E7ersiz veya yanl\0131\015F dosya uzant\0131s\0131na sahip.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597462091402648)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz XML veya JSON se\00E7ici kullan\0131ld\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566734625402625)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri profili ve y\00FCklenen dosya herhangi bir hedef tablo s\00FCtunu i\00E7ermez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652445512402690)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCklenen dosyada herhangi bir veri bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652584132402690)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0"\00E7al\0131\015Fma sayfas\0131nda herhangi bir veri bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115572317248402629)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('Belirtilen dosya XLSX dosyas\0131 de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115562771599402622)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme tamamland\0131: %0 sat\0131r i\015Flendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563948621402623)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme tamamland\0131: %0 sat\0131r 1 hatayla i\015Flendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564261046402623)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme tamamland\0131: %0 sat\0131r %1 hatas\0131yla i\015Flendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564097704402623)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme tamamland\0131: 1 sat\0131r i\015Flendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567004040402625)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme tamamland\0131: 1 sat\0131r hata ile i\015Flendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564123313402623)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme tamamland\0131: 1 sat\0131r hatas\0131z i\015Flendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657701986402694)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'tr'
,p_message_text=>unistr('Hedef S\00FCtun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657895444402694)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'tr'
,p_message_text=>unistr('Kaynak S\00FCtun')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658633739402694)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('Tarih / Say\0131 Format\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722003456402741)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('Arama de\011Feri geri al\0131namad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115690549853402718)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya / Tablo E\015Fleme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658738815402694)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654292514402691)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00F6n\00FC\015F\00FCm kural\0131 ba\015Far\0131s\0131z oldu')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630553388402673)
,p_name=>'DATE'
,p_message_language=>'tr'
,p_message_text=>'Tarih'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604606004402653)
,p_name=>'DAY'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00FCn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604714155402653)
,p_name=>'DAYS'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00FCnler')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643474072402683)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu uygulama i\00E7in hata ay\0131klama etkin de\011Fil.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115692214840402720)
,p_name=>'DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nde\011Fer')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605486535402654)
,p_name=>'DELETE'
,p_message_language=>'tr'
,p_message_text=>'sil'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115565670938402624)
,p_name=>'DIAL_PCT'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6sterge Grafi\011Fi (Y\00FCzde)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580122103402635)
,p_name=>'DOWNLOAD'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130ndir')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691320270402719)
,p_name=>'DUP_USER'
,p_message_language=>'tr'
,p_message_text=>unistr('Listede Tekrarlanan Kullan\0131c\0131 Ad\0131.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587793932402641)
,p_name=>'EDIT'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenle')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597117637402648)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" e-posta adresi bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582268500402636)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu e-posta %0 taraf\0131ndan g\00F6nderildi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691592097402719)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta adresi \00E7ok uzun. S\0131n\0131r 240 karakterdir.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625125142402669)
,p_name=>'ERROR'
,p_message_language=>'tr'
,p_message_text=>'Hata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654319978402691)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'tr'
,p_message_text=>unistr('K\0131smi sayfa yenileme b\00F6lgesi i\00E7in sayfa \00F6\011Fesi kaynak de\011Feri ayarlanamad\0131')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616683513402662)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('Olu\015Fturan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582587761402637)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('Parolan\0131n S\00FCresi Doldu')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115576656602402632)
,p_name=>'FILE_EMPTY'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya bo\015F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656842751402693)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCklenen dosyan\0131n boyutu %0 MB''\0131n \00FCzerindeydi. L\00FCtfen daha k\00FC\00E7\00FCk bir dosya y\00FCkleyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584610337402638)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 kimlik do\011Frulamas\0131 ba\015Far\0131s\0131z oldu ve bir veya daha fazla dosya y\00FCklenemedi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584700631402638)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu an, kimli\011Fi do\011Frulanmam\0131\015F kullan\0131c\0131lar\0131n dosya y\00FCklemesine izin vermez.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637731280402678)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('1 hata olu\015Ftu')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636900465402678)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 hata olu\015Ftu')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587114429402640)
,p_name=>'FORM_OF'
,p_message_language=>'tr'
,p_message_text=>'%0 / %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621810289402666)
,p_name=>'GO'
,p_message_language=>'tr'
,p_message_text=>'Git'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721620921402741)
,p_name=>'HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Yard\0131m')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574082581402630)
,p_name=>'HOME'
,p_message_language=>'tr'
,p_message_text=>unistr('Giri\015F')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604416798402653)
,p_name=>'HOUR'
,p_message_language=>'tr'
,p_message_text=>'saat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604557084402653)
,p_name=>'HOURS'
,p_message_language=>'tr'
,p_message_text=>'saatler'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588564381402641)
,p_name=>'ICON'
,p_message_language=>'tr'
,p_message_text=>'Simge%0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638586436402679)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Oturum A\00E7ma Kimlik Bilgileri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115738048260402754)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'tr'
,p_message_text=>unistr('Parametre i\00E7in ge\00E7ersiz de\011Fer: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633228488402675)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor Ayar\0131 \00D6nde\011Ferleri Olarak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633315253402675)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('Adland\0131r\0131lm\0131\015F Rapor Olarak')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615793554402662)
,p_name=>'IR_ERROR'
,p_message_language=>'tr'
,p_message_text=>'%0 hata. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615426172402661)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Form gezinmesi hesaplanam\0131yor .%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593065186402645)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli rapor bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592442958402644)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Etkile\015Fimli rapor b\00F6lgesi %0, sayfa % 1 ve b\00F6lge %2 uygulamas\0131nda yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115633185582402675)
,p_name=>'IR_STAR'
,p_message_language=>'tr'
,p_message_text=>unistr('Yaln\0131zca geli\015Ftiriciler i\00E7in g\00F6r\00FCnt\00FClenir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621556156402666)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor sorgusunun her sat\0131r\0131 tan\0131mlamak i\00E7in benzersiz bir anahtara ihtiyac\0131 vard\0131r. Verilen anahtar bu sorguda kullan\0131lamaz. L\00FCtfen benzersiz bir anahtar s\00FCtun tan\0131mlay\0131n .%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621668130402666)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor sorgusunun her sat\0131r\0131 tan\0131mlamak i\00E7in benzersiz bir anahtara ihtiyac\0131 vard\0131r. Verilen anahtar bu sorguda kullan\0131lamaz. L\00FCtfen benzersiz bir anahtar s\00FCtun tan\0131mlamak i\00E7in rapor \00F6zniteliklerini d\00FCzenleyin. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658928099402695)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosya Se\00E7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658861254402695)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'tr'
,p_message_text=>unistr('Dosyay\0131 buraya s\00FCr\00FCkleyip b\0131rak\0131n veya')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587490665402640)
,p_name=>'ITEMS'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Feler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616866062402662)
,p_name=>'ITEM_VALUE'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Fe De\011Feri')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631266496402673)
,p_name=>'LABEL'
,p_message_language=>'tr'
,p_message_text=>'Etiket'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643312817402683)
,p_name=>'LANGUAGE'
,p_message_language=>'tr'
,p_message_text=>'Dil'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605124763402654)
,p_name=>'LAST'
,p_message_language=>'tr'
,p_message_text=>'son'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584592547402638)
,p_name=>'LENGTH'
,p_message_language=>'tr'
,p_message_text=>'Uzunluk'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637873885402678)
,p_name=>'LOGIN'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum A\00E7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676408978402708)
,p_name=>'MANAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00F6net')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741023688402756)
,p_name=>'MAXIMIZE'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00FCy\00FCt')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604214864402653)
,p_name=>'MINUTE'
,p_message_language=>'tr'
,p_message_text=>'dakika'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604312883402653)
,p_name=>'MINUTES'
,p_message_language=>'tr'
,p_message_text=>'dakikalar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691721389402719)
,p_name=>'MISSING_AT'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta Adresi etki alan\0131nda "@" eksik.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691991259402719)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'tr'
,p_message_text=>unistr('Uyar\0131 :%1 uygulamas\0131nda %0 ileti\015Fim sayfas\0131 i\00E7in hi\00E7bir \0130leti\015Fim Sayfas\0131 \015Fablonu tan\0131mlanmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691616363402719)
,p_name=>'MISSING_DOT'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta Adresi etki alan\0131nda "." eksik.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640803365402681)
,p_name=>'MODULE'
,p_message_language=>'tr'
,p_message_text=>unistr('Mod\00FCl')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597953058402648)
,p_name=>'MONTH'
,p_message_language=>'tr'
,p_message_text=>'Ay'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601771302402651)
,p_name=>'MONTHLY'
,p_message_language=>'tr'
,p_message_text=>unistr('Ayl\0131k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598045071402648)
,p_name=>'MONTHS'
,p_message_language=>'tr'
,p_message_text=>'aylar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630817126402673)
,p_name=>'MOVE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ta\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698363734402724)
,p_name=>'MOVE_FROM'
,p_message_language=>'tr'
,p_message_text=>unistr('Buradan ta\015F\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698403230402724)
,p_name=>'MOVE_TO'
,p_message_language=>'tr'
,p_message_text=>unistr('Buraya ta\015F\0131')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115618095196402663)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7oklu sat\0131r silme i\015Fleminde hata: sat\0131r=% 0 ,%1 ,%2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617043450402662)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'tr'
,p_message_text=>unistr('Genel Kullan\0131c\0131 Olmamal\0131')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574289885402630)
,p_name=>'NAME'
,p_message_language=>'tr'
,p_message_text=>'Ad'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631038093402673)
,p_name=>'NEW'
,p_message_language=>'tr'
,p_message_text=>'Yeni'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597788726402648)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Euraya giderek %0 adresinde oturum a\00E7abilirsiniz:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597880137402648)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'tr'
,p_message_text=>'Yeni %0 Hesap Bildirimi'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721875431402741)
,p_name=>'NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640701700402681)
,p_name=>'NO'
,p_message_language=>'tr'
,p_message_text=>unistr('Hay\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115736081004402752)
,p_name=>'NOBODY'
,p_message_language=>'tr'
,p_message_text=>unistr('hi\00E7 kimse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605576431402654)
,p_name=>'NOT'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646377830402685)
,p_name=>'NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Bo\015F De\011Fildir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617182005402663)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 De\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636707959402678)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('veri bulunamad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645811147402685)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCncellenebilir rapor bulunamad\0131. \00C7oklu sat\0131r g\00FCncelleme ve silme i\015Flemleri yaln\0131zca ''G\00FCncellenebilir Rapor'' t\00FCr\00FCndeki tablo bi\00E7imlerinde ger\00E7ekle\015Ftirilebilir.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646733439402685)
,p_name=>'OK'
,p_message_language=>'tr'
,p_message_text=>'Tamam'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642473564402682)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'tr'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115739851467402755)
,p_name=>'ORA_06550'
,p_message_language=>'tr'
,p_message_text=>unistr('ORA-06550: sat\0131r %0, s\00FCtun %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689322743402717)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'tr'
,p_message_text=>unistr('Eski bir web taray\0131c\0131s\0131 kullan\0131yorsunuz. Desteklenen taray\0131c\0131lar\0131n bir listesi i\00E7in l\00FCtfen Oracle Application Express Y\00FCkleme K\0131lavuzu''na ba\015Fvurun.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590757915402643)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz sat\0131r k\00FCmesi istendi, raporun kaynak verileri de\011Fi\015Ftirildi.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610847199402658)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli bir sayfa numaras\0131 belirtilmelidir, \00F6rne\011Fin p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614472350402661)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130leri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614591772402661)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonraki K\00FCme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614690437402661)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115614759203402661)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nceki K\00FCme')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721739513402741)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa Numaralamay\0131 Se\00E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652383675402690)
,p_name=>'PASSWORD'
,p_message_language=>'tr'
,p_message_text=>'Parola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597088284402648)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7in parolan\0131z de\011Fi\015Ftirildi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586806257402640)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola, bu sitenin parola zorluk d\00FCzeyi kurallar\0131na uymuyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585901112402639)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Yeni parolan\0131n eski parolaya g\00F6re en az %0 karakteri farkl\0131 olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586536832402640)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola kullan\0131c\0131 ad\0131 i\00E7ermemelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586757421402640)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola yasaklanm\0131\015F basit bir s\00F6zc\00FCk i\00E7eriyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586667529402640)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola, \00E7al\0131\015Fma alan\0131 ad\0131 i\00E7ermemelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585877519402639)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola en az %0 karakter uzunlu\011Funda olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586020362402639)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola en az bir alfabetik karakter (%0) i\00E7ermelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586413482402640)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola en az bir k\00FC\00E7\00FCk harf i\00E7ermelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586122326402639)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola en az bir say\0131sal karakter (0123456789) i\00E7ermelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586215198402639)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola en az bir noktalama karakteri (%0) i\00E7ermelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115586371562402640)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola en az bir b\00FCy\00FCk harf i\00E7ermelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597518685402648)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola S\0131f\0131rlama Bildirimi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584806174402638)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Parola son %0 g\00FCn i\00E7inde kullan\0131ld\0131\011F\0131 i\00E7in kullan\0131lamaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665156885402699)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Feler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115665226974402699)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Fe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642258003402682)
,p_name=>'PERCENT'
,p_message_language=>'tr'
,p_message_text=>unistr('Y\00FCzde')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612542931402659)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'tr'
,p_message_text=>unistr('L\00FCtfen y\00F6netici ile ileti\015Fime ge\00E7in.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115721955517402741)
,p_name=>'PREVIOUS'
,p_message_language=>'tr'
,p_message_text=>'Geri'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657304808402693)
,p_name=>'PRINT'
,p_message_language=>'tr'
,p_message_text=>unistr('Yazd\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641090716402681)
,p_name=>'PRIVILEGES'
,p_message_language=>'tr'
,p_message_text=>'Yetkiler'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610928550402658)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge Ba\015Fvurular\0131')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631152221402673)
,p_name=>'REPORT'
,p_message_language=>'tr'
,p_message_text=>'Rapor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640943761402681)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'tr'
,p_message_text=>unistr('Raporlama D\00F6nemi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722173112402741)
,p_name=>'REPORT_LABEL'
,p_message_language=>'tr'
,p_message_text=>'Rapor: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641655063402681)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor Toplam\0131')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590848860402643)
,p_name=>'RESET'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa Numaralamay\0131 S\0131f\0131rla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616784052402662)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa Numaralamay\0131 S\0131f\0131rla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645730066402685)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'tr'
,p_message_text=>unistr('Parolay\0131 S\0131f\0131rla')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622545091402667)
,p_name=>'RESTORE'
,p_message_language=>'tr'
,p_message_text=>unistr('Geri Y\00FCkle')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115654409074402691)
,p_name=>'RESULTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Sonu\00E7lar')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646821602402685)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulamaya geri d\00F6n.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115647155741402686)
,p_name=>'RIGHT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sa\011F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676793616402708)
,p_name=>'ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630781833402673)
,p_name=>'ROW_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Say\0131s\0131')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115646248277402685)
,p_name=>'SAVE'
,p_message_language=>'tr'
,p_message_text=>'Kaydet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642820373402682)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('Alternatif \00D6nde\011Fer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643275204402683)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'tr'
,p_message_text=>unistr('A\00E7\0131klama')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642784340402682)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('Birincil \00D6nde\011Fer')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643548617402683)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'tr'
,p_message_text=>unistr('%0''dan fazla sat\0131r kullan\0131labilir. Daha fazla sat\0131r g\00F6r\00FCnt\00FClemek i\00E7in sat\0131r se\00E7iciyi art\0131r\0131n.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708919368402732)
,p_name=>'SEARCH'
,p_message_language=>'tr'
,p_message_text=>'Ara'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604117591402653)
,p_name=>'SECONDS'
,p_message_language=>'tr'
,p_message_text=>'saniye'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642364005402682)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'tr'
,p_message_text=>unistr('Eke bak\0131n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700074416402725)
,p_name=>'SELECT_ROW'
,p_message_language=>'tr'
,p_message_text=>unistr('Sat\0131r Se\00E7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642043003402682)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'tr'
,p_message_text=>unistr('Ekran Okuyucu Modunu Kapal\0131 Olarak Ayarla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642176323402682)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'tr'
,p_message_text=>unistr('Ekran Okuyucu Modunu A\00E7\0131k Olarak Ayarla')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638406937402679)
,p_name=>'SHOW'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6ster')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701840572402726)
,p_name=>'SHOW_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC G\00F6ster')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115727910216402746)
,p_name=>'SIGN_IN'
,p_message_language=>'tr'
,p_message_text=>unistr('Oturum A\00E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115677576795402709)
,p_name=>'SIGN_OUT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7\0131k\0131\015F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631769429402674)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 g\00FCn \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638941549402679)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 g\00FCn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631642043402674)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 saat \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638853660402679)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 saat')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631510893402674)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 dakika \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638711300402679)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 dakika')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631908330402674)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 ay \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639184035402679)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 ay')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639320434402680)
,p_name=>'SINCE_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eimdi')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631457538402673)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 saniye \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115638630340402679)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 saniye')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115631848511402674)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 hafta \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639074456402679)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 hafta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115632072847402674)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 y\0131l \00F6nce')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639280548402680)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'tr'
,p_message_text=>unistr('\015Eu andan itibaren %0 y\0131l')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625547943402669)
,p_name=>'STANDARD'
,p_message_language=>'tr'
,p_message_text=>'Standart'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641983025402682)
,p_name=>'START_DATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Flang\0131\00E7 Tarihi')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582417414402637)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 taraf\0131ndan olu\015Fturulan Etkile\015Fimli rapor aboneli\011Finden bu e-postay\0131 al\0131yorsunuz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737195807402753)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'tr'
,p_message_text=>'Abonelikler'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685285302402714)
,p_name=>'TAB'
,p_message_language=>'tr'
,p_message_text=>'Sekme'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604066578402653)
,p_name=>'TITLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ba\015Fl\0131k')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587050271402640)
,p_name=>'TODAY'
,p_message_language=>'tr'
,p_message_text=>unistr('Bug\00FCn')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641598022402681)
,p_name=>'TOTAL'
,p_message_language=>'tr'
,p_message_text=>'Toplam'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588031860402641)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'tr'
,p_message_text=>unistr('Maksimum %0 s\00FCtun se\00E7ilebilir.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566571779402625)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Daralt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566887421402625)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'tr'
,p_message_text=>unistr('Alttakilerin T\00FCm\00FCn\00FC Daralt')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566485977402624)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC Geni\015Flet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566628061402625)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'tr'
,p_message_text=>unistr('Alttakilerin T\00FCm\00FCn\00FC Geni\015Flet')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566981889402625)
,p_name=>'TREE.REPARENT'
,p_message_language=>'tr'
,p_message_text=>unistr('Yeniden \00DCst \00D6\011Fe Ata')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659189376402695)
,p_name=>'TREES'
,p_message_language=>'tr'
,p_message_text=>unistr('A\011Fa\00E7lar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115702692177402727)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'tr'
,p_message_text=>'Gerekli'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115626294986402670)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'tr'
,p_message_text=>'Yetkisiz'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115673052747402705)
,p_name=>'UNAVAILABLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131lamaz')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639721754402680)
,p_name=>'UNKNOWN'
,p_message_language=>'tr'
,p_message_text=>'Bilinmeyen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583318231402637)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('Tan\0131nmayan bir kimlik do\011Frulama hatas\0131 olu\015Ftu.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585305522402639)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'tr'
,p_message_text=>unistr('Art\0131k e-posta almak istemiyorsan\0131z, l\00FCtfen aboneli\011Finizi y\00F6netmek i\00E7in <a href="%0">abonelikten \00E7\0131k</a> \00F6\011Fesine t\0131klay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115582390114402637)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Art\0131k e-posta almak istemiyorsan\0131z aboneli\011Finizi y\00F6netmek i\00E7in l\00FCtfen a\015Fa\011F\0131daki URL''ye gidin:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115617221732402663)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('desteklenmeyen veri t\00FCr\00FC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605335308402654)
,p_name=>'UPDATE'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00FCncelle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603974113402653)
,p_name=>'UPDATED'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCncellendi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610690809402658)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130stenen URL yasakland\0131. Y\00F6neticinizle ileti\015Fime ge\00E7in.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115630643323402673)
,p_name=>'USER'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115652296231402690)
,p_name=>'USERNAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 Ad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691874155402719)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 ad\0131 \00E7ok uzun. Limit %0 karakterdir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637433071402678)
,p_name=>'USERS'
,p_message_language=>'tr'
,p_message_text=>unistr('kullan\0131c\0131lar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115691440796402719)
,p_name=>'USER_EXISTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 ad\0131 zaten mevcut.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115706144743402730)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 kullan\0131c\0131s\0131 i\00E7in profil resmi')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593754643402645)
,p_name=>'VALID'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587320526402640)
,p_name=>'VALIDATIONS'
,p_message_language=>'tr'
,p_message_text=>unistr('Do\011Frulamalar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643088992402682)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer belirtilmelidir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686499123402715)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer %0 i\00E7in belirtilmelidir')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612980574402659)
,p_name=>'VERTICAL'
,p_message_language=>'tr'
,p_message_text=>'dikey'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605288806402654)
,p_name=>'VIEW'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00F6r\00FCnt\00FCle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637540188402678)
,p_name=>'VIEWS'
,p_message_language=>'tr'
,p_message_text=>unistr('g\00F6r\00FCn\00FCmler')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643882201402683)
,p_name=>'VIEW_ALL'
,p_message_language=>'tr'
,p_message_text=>unistr('T\00FCm\00FCn\00FC G\00F6r\00FCnt\00FCle')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115625035133402669)
,p_name=>'WARNING'
,p_message_language=>'tr'
,p_message_text=>unistr('Uyar\0131')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604832134402653)
,p_name=>'WEEK'
,p_message_language=>'tr'
,p_message_text=>'hafta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601868337402651)
,p_name=>'WEEKLY'
,p_message_language=>'tr'
,p_message_text=>unistr('Haftal\0131k')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115604902295402654)
,p_name=>'WEEKS'
,p_message_language=>'tr'
,p_message_text=>'haftalar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115643122346402683)
,p_name=>'WELCOME_USER'
,p_message_language=>'tr'
,p_message_text=>unistr('Ho\015F Geldiniz: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641333755402681)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz de\011Fer bulundu, l\00FCtfen girilen verileri do\011Frulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641478857402681)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz de\011Fer bulundu, l\00FCtfen girilen verileri do\011Frulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584472933402638)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz tarih de\011Feri bulundu, l\00FCtfen tarih format\0131n\0131 do\011Frulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115641278155402681)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz say\0131 de\011Feri bulundu, l\00FCtfen say\0131 format\0131n\0131 do\011Frulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593340781402645)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz zaman damgas\0131 de\011Feri bulundu, l\00FCtfen zaman damgas\0131 format\0131n\0131 do\011Frulay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115615882695402662)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" ba\011Flanam\0131yor. \00C7oklu bayt \00F6\011Feleri i\00E7in \00E7ift t\0131rnak i\015Fareti kullan\0131n veya \00F6\011Fenin uzunlu\011Funun 30 bayt veya daha az oldu\011Funu do\011Frulay\0131n. 30 bayttan uzun \00F6\011Felere ba\015Fvurmak i\00E7in v() s\00F6zdizimini kullan\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606388520402655)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Fim %0 g\00FCvenlik kontrol\00FC taraf\0131ndan reddedildi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608815343402656)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama Kullan\0131lam\0131yor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607214120402655)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1014 Uygulama bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607305057402655)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('uygulama=%0 \00E7al\0131\015Fma alan\0131=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607725543402656)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu uygulamaya eri\015Fim s\0131n\0131rl\0131d\0131r, l\00FCtfen daha sonra tekrar deneyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607671419402656)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu uygulamaya eri\015Fim uygulama geli\015Ftiricileri ile s\0131n\0131rl\0131d\0131r, l\00FCtfen daha sonra tekrar deneyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606803780402655)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-7744 Fonksiyona dalland\0131rma d\00F6n\00FC\015F URL''si i\015Flenemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606701248402655)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-7744 Fonksiyona dalland\0131rma d\00F6n\00FC\015F sayfas\0131 i\015Flenemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607044116402655)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1430 Sayfadan g\00F6sterme \00E7a\011Fr\0131s\0131 i\015Flemi desteklenmiyor: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608141767402656)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1018 Ad\0131m \00F6nbelle\011Fi temizlenirken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606510205402655)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1005 Bilinmeyen hesaplama t\00FCr\00FC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607409491402655)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1201 oturum no''su \00F6zel kimlik do\011Frulamada ayarlanmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607524312402655)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'tr'
,p_message_text=>'sayfa=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115607186993402655)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-7620 Uygulama i\00E7in \00E7al\0131\015Fma alan\0131 belirlenemedi (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589533407402642)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'tr'
,p_message_text=>unistr('D\00FCzenle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606232745402655)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1802 "%0"\00F6\011Fe no bulunamad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605944279402654)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1002 "%1"uygulamas\0131nda "%0" \00F6gesi i\00E7in \00F6\011Fe no bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606013280402654)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'tr'
,p_message_text=>unistr('Beklenmeyen hata, uygulama veya sayfa d\00FCzeyinde \00F6\011Fe ad\0131 bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606486478402655)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Zaten ilk veri sayfas\0131ndas\0131n\0131z.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115621974489402666)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Fe No (%0), ge\00E7erli sayfada tan\0131mlanm\0131\015F bir \00F6\011Fe de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584039385402638)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Fe, ba\011F\0131ms\0131z de\011Fi\015Fkenlerin uygulamaya aktar\0131lmas\0131yla ayarlanamayabilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584366492402638)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'tr'
,p_message_text=>unistr('(Sa\011Flama toplam\0131 sa\011Flanmad\0131)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583802837402638)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Feye, "kullan\0131c\0131 d\00FCzeyinde yer imi" sa\011Flama toplam\0131 e\015Flik etti\011Finde ayarlanabilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583766590402638)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Fe, bir "uygulama d\00FCzeyi yer imi" sa\011Flama toplam\0131 ile birlikte ayarlanabilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583940027402638)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Feye bir "oturum" sa\011Flama toplam\0131 e\015Flik etti\011Finde ayarlanabilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583653577402638)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6\011Fenin korumas\0131 yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608237802402656)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa yard\0131m\0131 kullan\0131lam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115597354458402648)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 \00E7al\0131\015Fma alan\0131n\0131n %1 \015Femas\0131 olarak ayr\0131\015Ft\0131rma yetkisi yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606667377402655)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1010 Sayfaya dalland\0131rma kabul i\015Flemi yineleme limiti a\015F\0131ld\0131. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584207237402638)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu sayfa bir URL kullan\0131larak veya g\00F6sterim prosed\00FCr\00FCne bir GET veya POST kullan\0131larak \00E7a\011Fr\0131lamaz, bir "Sayfaya Dalland\0131rma" dalland\0131rma t\00FCr\00FC kullan\0131larak \00E7a\011Fr\0131lmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115660953250402696)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Say\0131sal olmayan de\011Fer %0 \00F6\011Fesine kaydedilmeye \00E7al\0131\015F\0131l\0131rken hata olu\015Ftu. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599064312402649)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulaman\0131n ayr\0131\015Ft\0131rma \015Femas\0131 "%0" veritaban\0131nda mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115599133649402649)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'tr'
,p_message_text=>unistr('DAH\0130L\0130 \00E7al\0131\015Fma alan\0131ndaki hesaplar sadece &PRODUCT_NAME. \00FCr\00FCn\00FCne eri\015Fmek i\00E7in kullan\0131labilir. <a href="%0">Y\00F6netim Hizmetleri</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605841021402654)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-1029 Oturum bilgileri kaydedilemedi. oturum=%0 \00F6\011Fe=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608910590402657)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130z durdurulam\0131yor :%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115606173160402654)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'tr'
,p_message_text=>'Beklenmeyen hata'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616185550402662)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('update_substitution_cache i\00E7inde hata olu\015Ftu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609056750402657)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Yard\0131m\0131 g\00F6r\00FCnt\00FClemek i\00E7in uygulama ve sayfa sa\011Flanmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115629571149402672)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Otomasyon bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610148007402657)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'tr'
,p_message_text=>'%0 oturum temizlendi.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569405060402627)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 kodu \00E7al\0131\015Ft\0131r\0131lam\0131yor! Veritaban\0131 taraf\0131ndan desteklenmiyor veya MLE_LANGUAGES an parametresi taraf\0131ndan etkinle\015Ftirilmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115569200113402627)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7ok Dilli Motor bu veritaban\0131 s\00FCr\00FCm\00FCnde mevcut de\011Fil!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590065298402642)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama koleksiyonu dizisi bo\015F olmamal\0131d\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589884003402642)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Belirtilen \00FCye \00F6zniteli\011Fi numaras\0131 %0 ge\00E7ersiz. \00D6znitelik numaras\0131 1 ile %1 aras\0131nda olmal\0131d\0131r')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590333484402642)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'tr'
,p_message_text=>'Uygulama koleksiyonu mevcut'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590118306402642)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('Koleksiyon ad\0131 bo\015F olamaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590208793402642)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'tr'
,p_message_text=>unistr('Koleksiyon ad\0131 255 karakterden uzun olamaz')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589629127402642)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama koleksiyonu %0 mevcut de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590419914402643)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130mle\00E7 hen\00FCz a\00E7\0131k de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589748571402642)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 \00FCye s\0131ras\0131 %1 uygulama koleksiyonunda mevcut de\011Fil'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115589933101402642)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('\00DCye s\0131ras\0131 %0, "%1"uygulama koleksiyonunda mevcut de\011Fil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661737212402697)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>'"%0" kriptografik fonksiyonu bu sistemde desteklenmiyor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715273184402736)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Eri\015Filebilirlik Test Edildi')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609613974402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'tr'
,p_message_text=>'Kapat'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609704949402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa \00D6zelle\015Ftirme Se\00E7enekleri')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609895777402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'tr'
,p_message_text=>unistr('\00D6nde\011Fer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609956692402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCnt\00FClenen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610050123402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'tr'
,p_message_text=>'Gizlenen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609437252402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu sayfaya dahil etmek istedi\011Finiz b\00F6lgeleri kontrol edin. Uygun uygulama ba\011Flam\0131nda de\011Filseniz veya uygun yetkileriniz yoksa, i\015Faretli b\00F6lgeler g\00F6r\00FCnt\00FClenmeyebilir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609585900402657)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu sayfa \00F6zelle\015Ftirilemez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715536768402736)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'tr'
,p_message_text=>unistr('Tema Stilini de\011Fi\015Ftirerek bu uygulaman\0131n g\00F6r\00FCn\00FCm\00FCn\00FC ki\015Fiselle\015Ftirebilirsiniz. L\00FCtfen a\015Fa\011F\0131daki listeden bir Tema Stili se\00E7in ve De\011Fi\015Fiklikleri Uygula se\00E7ene\011Fine t\0131klay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115716305433402737)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'tr'
,p_message_text=>unistr('B\00F6lge G\00F6r\00FCnt\00FCs\00FC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715444739402736)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'tr'
,p_message_text=>unistr('Uygulama Stili \00D6nde\011Ferlerini Kullan')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115715308460402736)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00F6r\00FCn\00FC\015F ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658367809402694)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 toplam\0131nda referans al\0131nan s\00FCtun dizini mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115561698513402621)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'tr'
,p_message_text=>unistr('CLOB \00E7\0131kt\0131s\0131 %0 format\0131 i\00E7in desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658019344402694)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun sonunun s\00FCtun dizisinin ba\015F\0131nda olmas\0131 gerekir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658146855402694)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7inde referans al\0131nan s\00FCtun grubu dizini mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115575687811402631)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'tr'
,p_message_text=>unistr('d\0131\015Fa aktarma dosyas\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115580850258402635)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'tr'
,p_message_text=>unistr('D\0131\015Fa aktarma format\0131 XML olmal\0131, Yazd\0131rma Sunucusu olarak Oracle Temsili Durum Transferi kullan\0131lmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658452422402694)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 vurgulamas\0131nda ba\015Fvurulan s\00FCtun dizini mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574153779402630)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz D\0131\015Fa Aktarma Format\0131: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115658243968402694)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7inde referans al\0131nan \00FCst grup dizini mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115683478334402713)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 tablosunun %1 s\00FCtunu bir "GENERATED ALWAYS" kimlik s\00FCtunudur. L\00FCtfen Konfig\00FCre Et ileti\015Fim kutusundaki %1 s\00FCtununa hi\00E7bir kaynak s\00FCtununun e\015Flenmedi\011Finden emin olun.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600889769402650)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'tr'
,p_message_text=>unistr('Belirtilen kaydetme aral\0131\011F\0131 \00E7ok d\00FC\015F\00FCk.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115600948863402651)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'tr'
,p_message_text=>unistr('Veri y\00FCkleme i\00E7in herhangi bir s\00FCtun sa\011Flanmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602196004402651)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" sat\0131r se\00E7icisi i\00E7in s\00FCtun bulunamad\0131. JSON yap\0131s\0131n\0131 otomatik olarak alg\0131lamay\0131 veya incelemeyi deneyin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610403775402658)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('XLSX dosyas\0131nda \00E7al\0131\015Fma sayfas\0131 bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610374201402658)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'tr'
,p_message_text=>unistr('Belirtilen \00E7al\0131\015Fma sayfas\0131 XLSX dosyas\0131nda mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115590553849402643)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'tr'
,p_message_text=>unistr('Veritaban\0131ndaki verilerin mevcut s\00FCr\00FCm\00FC, kullan\0131c\0131n\0131n g\00FCncelleme i\015Flemini ba\015Flatmas\0131ndan bu yana de\011Fi\015Fti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592950059402644)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor s\00FCtunlar\0131 g\00FCncellenirken hata olu\015Ftu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697630017402723)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 SDO_GEOMETRY''e d\00F6n\00FC\015Ft\00FCr\00FClemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637144265402678)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'tr'
,p_message_text=>unistr('%1 veri t\00FCr\00FCndeki %0 s\00FCtunu VARCHAR2''ye d\00F6n\00FC\015Ft\00FCr\00FClemiyor!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644194335402683)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('"%1" \00F6zniteli\011Fi i\00E7in belirtilen "%0" s\00FCtunu veri kayna\011F\0131nda bulunamad\0131!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585401522402639)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 filtre t\00FCr\00FC \00E7ok de\011Ferli s\00FCtunlar i\00E7in desteklenmez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115701055363402726)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz "aras\0131nda" filtresi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567511132402625)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz De\011Ferler Listesi t\00FCr\00FC belirlendi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567406568402625)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz sorgu t\00FCr\00FC. Sorgu t\00FCr\00FC Tablo, SQL sorgusu veya SQL Sorgusunu d\00F6nd\00FCren PL/SQL Fonksiyonu olmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637244909402678)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL sorgusu ayr\0131\015Ft\0131r\0131lamad\0131!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644247203402683)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('"%1" \00F6zniteli\011Fi i\00E7in belirtilen s\00FCtun konumu %0 SQL ifadesinde bulunamad\0131!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115566063305402624)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7ok De\011Ferli filtrede \00E7ok fazla \00F6\011Fe kullan\0131l\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644064345402683)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" \00F6zniteli\011Fi i\00E7in s\00FCtun belirtilmedi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567331160402625)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('PL/SQL fonksiyon g\00F6vdesi bir de\011Fer d\00F6nd\00FCrmedi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115657217487402693)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131, istenen DML eylemini i\015Flemek \00FCzere bir \0130\015Flem i\00E7ermez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115563202848402622)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'tr'
,p_message_text=>unistr('GeoJSON - SDO_GEOMETRY d\00F6n\00FC\015F\00FCm\00FC (s\00FCtun %0) bu veritaban\0131nda kullan\0131lamaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564352066402623)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'tr'
,p_message_text=>unistr('SDO_GEOMETRY d\00F6n\00FC\015F\00FCm\00FC (%0 s\00FCtunu) XML veri kaynaklar\0131 i\00E7in desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115571683486402628)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 karakteri \00E7ok de\011Ferli bir ay\0131r\0131c\0131 olarak desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115698902733402724)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu fonksiyon, Sorgu Ba\011Flam\0131nda kullan\0131lamaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115564442241402623)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun Veri T\00FCr\00FC uyu\015Fmazl\0131\011F\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567284097402625)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'tr'
,p_message_text=>unistr('Dahili ORDS OUT Ba\011Flama limitleri a\015F\0131ld\0131. L\00FCtfen DML sat\0131rlar\0131n\0131n miktar\0131n\0131 azalt\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115645057618402684)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Uzak sunucudan gelen JSON cevab\0131 ayr\0131\015Ft\0131r\0131lamad\0131: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115567173423402625)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Bilinmeyen veya yanl\0131\015F ba\011Flam t\00FCr\00FC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115661623425402697)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu dosya t\00FCr\00FC ayr\0131\015Ft\0131r\0131c\0131 taraf\0131ndan desteklenmiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616274360402662)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Yetkisiz eri\015Fim (wwv_flow_api.set_credentials ayarlanmad\0131).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593262356402645)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma alan\0131 zaten var oldu\011Fu i\00E7in olu\015Fturulmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115593197867402645)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 grubu zaten var oldu\011Fundan olu\015Fturulmad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603407930402652)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7in tekrarlanan kullan\0131c\0131 ad\0131 bulundu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603579486402653)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131lar y\00FCklenirken hata olu\015Ftu. %0 kullan\0131c\0131s\0131 ba\015Far\0131s\0131z oldu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613465980402660)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 kullan\0131c\0131 y\00FCklenecekti.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613264766402660)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'tr'
,p_message_text=>'Parola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613304297402660)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'tr'
,p_message_text=>'Yetkiler'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613048647402660)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'tr'
,p_message_text=>unistr('Kullan\0131c\0131 ad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689525162402718)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('#COMPONENT_NAME# sayfa \00F6\011Fesi olu\015Fturulurken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609162461402657)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('HTML formu hen\00FCz a\00E7\0131lmad\0131\011F\0131ndan sayfa \00F6\011Fesi g\00F6r\00FCnt\00FClenemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115574403477402630)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa \00F6\011Fesi i\00E7in varsay\0131lan de\011Fer hesaplan\0131rken hata olu\015Ftu #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608415418402656)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('#COMPONENT_NAME# sayfa \00F6\011Fesi i\00E7in \00F6\011Fe sonras\0131 hesaplamada hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608310797402656)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('#COMPONENT_NAME# sayfa \00F6\011Fesi i\00E7in varsay\0131lan de\011Fer hesaplan\0131rken hata olu\015Ftu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588158295402641)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'tr'
,p_message_text=>unistr('Yetkisiz eri\015Fim.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608619443402656)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'tr'
,p_message_text=>'JavaScript desteklenmiyor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608707254402656)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'tr'
,p_message_text=>'Liste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115609342245402657)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'tr'
,p_message_text=>unistr('Sorgu ba\015Flat\0131lam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616552066402662)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 g\00FCncellemesi desteklenmiyor.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115610773387402658)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz \00F6\011Fe no:%0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115637000194402678)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu \00F6\011Fe i\00E7in yard\0131m mevcut de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601566895402651)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('Grafik sorgusu olu\015Fturulamad\0131. Kaynak ve S\00FCtun E\015Fleme ayarlar\0131n\0131 kontrol edin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696339518402722)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 MB boyutunun eki maksimum %1 MB eki boyutunu a\015F\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602419642402652)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'tr'
,p_message_text=>unistr('P_mail_id parametresi i\00E7in ge\00E7ersiz de\011Fer: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115719845956402740)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma alan\0131 ba\015F\0131na maksimum e-posta iletisi say\0131s\0131n\0131 a\015Ft\0131n\0131z. L\00FCtfen y\00F6neticinize ula\015F\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583453001402637)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu prosed\00FCr bir uygulama oturumu i\00E7inde ba\015Flat\0131lmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602382075402652)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 parametresi i\00E7in bo\015F de\011Fer girildi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656304182402693)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('%1 uygulamas\0131nda "%0" e-posta \015Fablonu bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115732866836402750)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('SMTP_HOST_ADDRESS an\0131 parametresi posta g\00F6ndermek i\00E7in ayarlanmal\0131d\0131r.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602005112402651)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('E-posta g\00F6ndermek i\00E7in bir mesaj al\0131c\0131s\0131 girmelisiniz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115722262135402742)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'tr'
,p_message_text=>unistr('Konfig\00FCre edilmi\015F e-posta sunucusuyla SMTP ba\011Flant\0131s\0131 kurulam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115696442338402723)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7ersiz Ajax \00E7a\011Fr\0131s\0131!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587865494402641)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 eklentisi i\00E7in Ajax fonksiyonu tan\0131mlanmad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686833394402716)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 eklentisi i\00E7in y\00FCr\00FCtme fonksiyonu tan\0131mlanmad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587932473402641)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 eklentisi i\00E7in i\015Fleme fonksiyonu tan\0131mlanmad\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697323955402723)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131 Eklentisi "%0" bir "Yetenekler" fonksiyonu i\00E7ermez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697273597402723)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131 Eklentisi "%0"bir DML fonksiyonu i\00E7ermez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697439782402723)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131 Eklentisi "%0" y\00FCr\00FCtme fonksiyonu i\00E7ermez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115697569737402723)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131 Eklentisi "%0" bir alma fonksiyonu i\00E7ermez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585617751402639)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Eklenti i\015Fleme s\0131ras\0131nda y\00FCkseltilen PLSQL kodunda hata.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592201659402644)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622826466402667)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 veri t\00FCr\00FC VARCHAR2''ye d\00F6n\00FC\015Ft\00FCr\00FClemez!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708428424402731)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('"%1" \00F6zniteli\011Fi i\00E7in belirtilen "%0" s\00FCtunu SQL ifadesinde bulunamad\0131!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684750887402714)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7in bir de\011Fer listesi (LOV) sorgusu veya Adland\0131r\0131lm\0131\015F de\011Fer listesi belirtilmelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115686375995402715)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 i\00E7in De\011Fer Listesi SQL sorgusunda yanl\0131\015F say\0131da s\00FCtun se\00E7ildi. Ge\00E7erli ifadeler i\00E7in \00F6rneklere bak\0131n\0131z.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708213588402731)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'tr'
,p_message_text=>unistr('"%0" \00F6zniteli\011Fi i\00E7in s\00FCtun belirtilmedi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737958966402753)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('"%1" \00F6zniteli\011Fi i\00E7in girilen %0 de\011Feri say\0131sal de\011Fil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115689884928402718)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('%0, SQL ifadesinde yanl\0131\015F bir veri t\00FCr\00FCne sahip. #%1 s\00FCtunu %2, ancak %3 bekleniyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115708319935402731)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'tr'
,p_message_text=>unistr('"%1" \00F6zniteli\011Fi i\00E7in belirtilen "%0" s\00FCtunu %2 veri t\00FCr\00FCne sahip ancak %3 i\00E7ermelidir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115584934162402639)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor yerle\015Fimi bulunamad\0131.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644920727402684)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'tr'
,p_message_text=>unistr('REST Veri Kayna\011F\0131na dayal\0131 raporlar i\00E7in Hesaplama Toplam\0131 \00F6zelli\011Fi kullan\0131lamaz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115608552939402656)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('ERR-2904 K\0131sayol de\011Feri ayarlanam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115612891108402659)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Hata: Bilinmeyen k\0131sayol t\00FCr\00FC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115602825718402652)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('%0 uygulamas\0131nda authentication_scheme al\0131nam\0131yor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115676337105402708)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'tr'
,p_message_text=>unistr('Mevcut oturum i\00E7in ge\00E7ici kullan\0131c\0131 no zaten var.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115613125920402660)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'tr'
,p_message_text=>'E-Posta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737367826402753)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'tr'
,p_message_text=>unistr('Kimlik do\011Frulama ba\015Far\0131s\0131z oldu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115639656133402680)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'tr'
,p_message_text=>unistr('Apex_util.g_request_cookies i\00E7inde ayarlanan bir veya daha fazla \00E7erez ge\00E7ersiz bir de\011Fer i\00E7eriyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115622106531402666)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'tr'
,p_message_text=>unistr('UDDI kay\0131t defterinden gelen cevap ge\00E7ersiz.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115585799944402639)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'tr'
,p_message_text=>unistr('Sa\011Flanan URL ge\00E7erli bir WSDL dok\00FCman\0131 d\00F6nd\00FCrmedi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115588248500402641)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'tr'
,p_message_text=>unistr('WSDL dok\00FCman\0131 birden fazla SOAP ba\011Flay\0131c\0131s\0131 i\00E7erir. &PRODUCT_NAME. sadece bir SOAP ba\011Flay\0131c\0131s\0131na sahip WSDL''leri destekler. Bu servise y\00F6nelik referans olu\015Fturmaya devam etmek \00FCzere Manuel Olarak Web Hizmetleri Referans\0131 Olu\015Ftur''a t\0131klay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115656665115402693)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'tr'
,p_message_text=>unistr('Hizmetten gelen cevap XML de\011Fildi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737242378402753)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'tr'
,p_message_text=>unistr('OAuth eri\015Fim belirteci mevcut de\011Fil veya s\00FCresi dolmu\015F.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115700499721402725)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'tr'
,p_message_text=>unistr('\00C7al\0131\015Fma alan\0131 ba\015F\0131na maksimum web hizmeti talebi say\0131s\0131n\0131 a\015Ft\0131n\0131z. L\00FCtfen y\00F6neticinize ula\015F\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115737481999402753)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'tr'
,p_message_text=>unistr('Sunucu desteklenmeyen OAuth belirteci t\00FCr\00FC ile yan\0131t verdi.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587669266402641)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'tr'
,p_message_text=>unistr('WSDL dok\00FCman\0131, referans eklemek \00FCzere gerekli olan SOAP i\00E7in bir ba\011Flay\0131c\0131 i\00E7ermiyordu.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115583566976402637)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu WSDL kimlik do\011Frulama bilgileri gerektirir. L\00FCtfen kullan\0131c\0131 ad\0131n\0131 ve parolay\0131 a\015Fa\011F\0131ya girin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115592380680402644)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'tr'
,p_message_text=>unistr('WSDL dok\00FCman\0131 i\015Fleme motoru taraf\0131ndan anla\015F\0131lamad\0131. Bu servise y\00F6nelik referans olu\015Fturmaya devam etmek \00FCzere Manuel Olarak Web Hizmetleri Referans\0131 Olu\015Ftur''a t\0131klay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115659278909402695)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'tr'
,p_message_text=>unistr('G\00FCncelleme ger\00E7ekle\015Ftirilemiyor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115685025450402714)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer Listesi d\00F6nd\00FCrme ile ekran s\00FCtunu ayn\0131!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115684976467402714)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('De\011Fer Listesinin bir d\00F6nd\00FCrme s\00FCtunu yok.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616430826402662)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('S\00FCtun de\011Feri al\0131n\0131rken hata olu\015Ftu :%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640449890402680)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'tr'
,p_message_text=>unistr('Ge\00E7erli tablo formu verileri \00E7ok eski; kaynak veriler de\011Fi\015Ftirildi.<br/> De\011Fi\015Fiklikleri g\00F6z ard\0131 etmek ve verileri veritaban\0131ndan yeniden y\00FCklemek i\00E7in <strong><a href="%0">buraya</a></strong> t\0131klay\0131n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598571940402649)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'tr'
,p_message_text=>unistr('Sayfa numaralama dizesini belirleme hatas\0131')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598490157402649)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('sorgu ba\015Fl\0131klar\0131 al\0131nam\0131yor:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598677482402649)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'tr'
,p_message_text=>unistr('rapor alt bilgisi de\011Fi\015Fikliklerini ger\00E7ekle\015Ftirirken hata olu\015Ftu')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598733216402649)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL sorgusu ayr\0131\015Ft\0131r\0131lamad\0131:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603702805402653)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'tr'
,p_message_text=>unistr('\0130stenen minimum sat\0131r: %0, sat\0131rlar bulundu ancak g\00F6r\00FCnt\00FClenmedi: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601262125402651)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'tr'
,p_message_text=>unistr('sorgu s\00FCtunu #%0 (%1) ge\00E7ersiz, HTML kullanan s\00FCtunlar\0131n di\011Fer adlara ihtiyac\0131 var')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115616366762402662)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'tr'
,p_message_text=>unistr('Sorgu ba\015Fl\0131klar\0131 al\0131n\0131rken hata olu\015Ftu: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598854032402649)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('rapor hatas\0131:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115636552616402677)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu s\00FCtuna g\00F6re s\0131rala')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601342807402651)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'tr'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sorgu ayr\0131\015Ft\0131r\0131lam\0131yor, l\00FCtfen sorgunuzun s\00F6zdizimini kontrol edin.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640568502402681)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'tr'
,p_message_text=>unistr('Bu form kaydedilmemi\015F de\011Fi\015Fiklikler i\00E7eriyor. De\011Fi\015Fikliklerinizi kaydetmeden devam etmek i\00E7in "Tamam" \00F6\011Fesine bas\0131n. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115644817976402684)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'tr'
,p_message_text=>unistr('Rapor sayfa numaraland\0131rma \015Femas\0131 (%0) se\00E7ilen veri kayna\011F\0131yla desteklenmez.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115601100628402651)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'tr'
,p_message_text=>unistr('sorgu s\00FCtunu #%0 (%1) ge\00E7ersiz, s\00FCtun di\011Fer ad\0131n\0131 kullan\0131n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603842635402653)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'tr'
,p_message_text=>unistr('sat\0131r(lar) %0 - %1 / %2''den fazla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115642570978402682)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'tr'
,p_message_text=>'%0 - %1 / %2''den fazla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115603655639402653)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'tr'
,p_message_text=>unistr('sat\0131r(lar) %0 - %1 / %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115587580002402640)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'tr'
,p_message_text=>'%0 - %1 / %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598923917402649)
,p_name=>'Y'
,p_message_language=>'tr'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115605023654402654)
,p_name=>'YEAR'
,p_message_language=>'tr'
,p_message_text=>unistr('y\0131l')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115598105009402648)
,p_name=>'YEARS'
,p_message_language=>'tr'
,p_message_text=>unistr('y\0131llar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115640640555402681)
,p_name=>'YES'
,p_message_language=>'tr'
,p_message_text=>'Evet'
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4488)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4488)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('Masa\00FCst\00FC')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4488
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4488)
,p_name=>'Mesajlar'
,p_alias=>'MESSAGES'
,p_step_title=>'Mesajlar'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
