prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4417
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4417 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4417
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110306001825364452')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'zh-cn'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4417)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112719'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4417)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4417)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\6CE8\9500')
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>unistr('\4ECE Application Express \6CE8\9500')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('\6CE8\9500 \79BB\5F00 \9000\51FA :q')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4417)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\5728\7535\5B50\8868\683C\4E0A\521B\5EFA\5E94\7528\7A0B\5E8F')
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>unistr('\5BFC\5165 Excel \6216 csv \6587\4EF6\5E76\521B\5EFA\5E94\7528\7A0B\5E8F')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('excel csv xsl xslx \7535\5B50\8868\683C \6570\636E \7C98\8D34 \52A0\8F7D \5BFC\5165')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4417)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Oracle APEX \4E3B\76EE\5F55')
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>unistr('\4E3B\9875\5F00\59CB')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4417)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('\6D4F\89C8\5B57\4F53 APEX \56FE\6807')
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('\6D4F\89C8\5B57\4F53 APEX \56FE\6807\3001\6DFB\52A0\4FEE\9970\7B26\4EE5\53CA\590D\5236\6240\9700\7684 CSS \6216 HTML\3002')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('\56FE\6807 \5B57\4F53 apex \5E93 \56FE\5F62')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4417)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4417)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\5BFC\51FA\5E94\7528\7A0B\5E8F')
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>unistr('\5C06\5E94\7528\7A0B\5E8F {APP_ID} \5BFC\51FA\4E3A SQL \6587\4EF6')
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4417)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\672A\7528\5217\8868')
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4417)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4417)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4417)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4417)
,p_theme_id=>1
,p_name=>'One Level Tabs.zh-cn'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4417)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4417)
,p_theme_id=>1
,p_name=>'Printer Friendly.zh-cn'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4417)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4417)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4417)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4417)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4417)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4417)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4417)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4417)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4417)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4417)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4417)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4417)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4417)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4417)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>unistr('\201C\641C\7D22\201D\5BF9\8BDD\6846')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>unistr('\641C\7D22')
,p_close_button_text=>unistr('\5173\95ED')
,p_next_button_text=>unistr('\4E0B\4E00\6B65 >')
,p_prev_button_text=>unistr('< \4E0A\4E00\6B65')
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>unistr('<br /><div style="padding:2px; font-size:8pt;">\884C #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4417)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4417)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4417)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547504285311974)
,p_name=>'2DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549630437311976)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \67F1\72B6\56FE\6298\7EBF\56FE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547649549311974)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \5706\73AF\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549464626311976)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \5806\53E0\6C34\5E73\67F1\72B6\56FE (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547786526311974)
,p_name=>'2DLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \6298\7EBF\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547818177311975)
,p_name=>'2DPIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \997C\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549201581311976)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \5806\53E0\67F1\72B6\56FE (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547948011311975)
,p_name=>'3DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \67F1\72B6\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549546401311976)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \5806\53E0\6C34\5E73\67F1\72B6\56FE (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548039435311975)
,p_name=>'3DPIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \997C\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549370655311976)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \5806\53E0\67F1\72B6\56FE (\767E\5206\6BD4)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317452556312579)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\63D2\5165\5C5E\6027\5B57\5178\4E2D\7684 0 \4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317289179312579)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\66F4\65B0\7684 0 \4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317632564312579)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\66F4\65B0\5C5E\6027\5B57\5178\7684 0 \4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318094373312579)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\63D2\5165\5C5E\6027\5B57\5178\4E2D\7684 0 \4E2A\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318249427312579)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\66F4\65B0\5C5E\6027\5B57\5178\7684 0 \4E2A\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317102919312579)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\8981\66F4\65B0\7684 %0 \4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317820901312579)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\66F4\65B0\7684 0 \4E2A\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317374196312579)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\8981\63D2\5165\5C5E\6027\5B57\5178\4E2D\7684 %0 \4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317518424312579)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\8981\66F4\65B0\5C5E\6027\5B57\5178\7684 %0 \4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317914260312579)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\8981\63D2\5165\5C5E\6027\5B57\5178\4E2D\7684 %0 \4E2A\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317767428312579)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\8981\66F4\65B0\7684 %0 \4E2A\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318195988312579)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\8981\66F4\65B0\5C5E\6027\5B57\5178\7684 %0 \4E2A\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109806363312411)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095074097312399)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<span class="fielddata">\7531\4E8E\533A\57DF\5E8F\5217\4E0D\662F\552F\4E00\7684, \65E0\6CD5\91CD\65B0\6392\5E8F\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095163047312399)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<span class="fielddata">\7531\4E8E\6309\94AE\5E8F\5217\4E0D\662F\552F\4E00\7684, \65E0\6CD5\91CD\65B0\6392\5E8F\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095280924312399)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<span class="fielddata">\7531\4E8E\5BFC\822A\680F\5E8F\5217\4E0D\662F\552F\4E00\7684, \65E0\6CD5\91CD\65B0\6392\5E8F\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095380674312399)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<span class="fielddata">\7531\4E8E\533A\57DF\9879\5E8F\5217\4E0D\662F\552F\4E00\7684, \65E0\6CD5\91CD\65B0\6392\5E8F\3002</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164252591312454)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678936330312076)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5E94\7528\7A0B\5E8F: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068511662312378)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\65E5\671F\683C\5F0F\65E0\6548\3002\65E5\5386\8981\6C42\65E5\671F\683C\5F0F\4E3A YYYYMMDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114575401312414)
,p_name=>'4000_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164313173312454)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A ID')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958945890312291)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\521B\5EFA\7684\65B0\65B9\6848\7684\540D\79F0\3002\4F9D\6B21\9009\62E9\6B64\65B9\6848\7684\5BC6\7801, \9ED8\8BA4\8868\7A7A\95F4\548C\4E34\65F6\8868\7A7A\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959041065312291)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\73B0\6709\65B9\6848\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959106689312291)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210\540E\FF0C\5355\51FB<strong>\4E0B\4E00\6B65</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829264887312192)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\8868\7A7A\95F4\548C\5173\8054\7684\6570\636E\6587\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829106629312192)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\6570\636E\5E93\7528\6237: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693041061312875)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\6D3B\52A8\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541194707311969)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \540C\6B65\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541947817311970)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952851908312286)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6D3B\52A8\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591735781312010)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\8BBF\95EE\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952310084312286)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952435401312286)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\65F6\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952121715312286)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954617817312288)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \547D\4EE4\5904\7406\5668\5386\53F2\8BB0\5F55\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954594335312288)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\6587\4EF6\6267\884C\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954447793312288)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\6587\4EF6\6267\884C\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954744885312288)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \6863\6848\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956476872312289)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F52\6863\65E5\5FD7\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956580014312289)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\65E5\5FD7\7F16\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956635001312289)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\65E5\5FD7\65F6\95F4\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957219205312290)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DDD\4E0B\4E00\6B21\65E5\5FD7\5207\6362\7684\65F6\95F4 (\5C0F\65F6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956813387312290)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95F4\9694\5929\6570 (\5E38\91CF)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957127960312290)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\5212\7684\4E0B\4E00\6B21\65E5\5FD7\5207\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957502478312290)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6D3B\52A8\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957776400312290)
,p_name=>'4050_71_CLICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\8FDB\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958591876312291)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \547D\4EE4\5904\7406\5668\5386\53F2\8BB0\5F55\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958450941312291)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\6587\4EF6\6267\884C\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958259209312291)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\6587\4EF6\6267\884C\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958671790312291)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \6863\6848\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958749193312291)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A %1 \62E5\6709 %2 \4E2A\5E94\7528\7A0B\5E8F\548C %3 \4E2A\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958871896312291)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\51FB\8BA1\6570\65E5\5FD7\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139982692312435)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\4EA7\529B\548C\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140068681312435)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B Websheet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139200679312434)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\8BA1\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886397185312235)
,p_name=>'4350_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886463810312236)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5E94\7528\7A0B\5E8F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606250529312021)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Database Express Edition 2 Day DBA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606388706312021)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Database Express Edition 2 Day Developer Guide\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606144536312021)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Express 2 \5929\901F\6210\548C\5F00\53D1\8005\6307\5357\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606439053312021)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Database Express Edition 2 Day Plus Java Developer Guide\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606562589312021)
,p_name=>'4500 800 HD NET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Database Express Edition 2 Day Plus .NET Developer Guide\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606604710312021)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Database Express Edition 2 Day Plus PHP Developer\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606732833312021)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA8\8BBA\5E38\89C1\7684\65E5\5E38\7BA1\7406\4EFB\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606850650312022)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E\5982\4F55\5229\7528 Oracle Database Express Edition \5F00\53D1\73AF\5883\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606932237312022)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\4E00\7CFB\5217\8BF4\660E\5982\4F55\6784\5EFA\4EE5\6570\636E\5E93\4E3A\4E2D\5FC3\7684 Web \5E94\7528\7A0B\5E8F\7684\6559\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607191330312022)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\6587\6863\63D0\4F9B\7684\6559\7A0B\8BF4\660E\5982\4F55\4F7F\7528 Java \548C JDB \6765\8FDE\63A5\5230 Oracle Database XE, \5E76\6F14\793A\5982\4F55\4F7F\7528\5B83\4EEC\6765\5F00\53D1\4E00\4E2A\53EF\8BBF\95EE\548C\4FEE\6539\6570\636E\7684\7B80\5355 Java \5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607215065312022)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\6587\6863\8BF4\660E Oracle Data Provider for .NET \548C Oracle Developer Tools for Visual Studio .NET \7684\4E3B\8981\529F\80FD\3002\5B83\5C06\6307\5BFC\60A8\8FDB\884C\5B89\88C5\548C\914D\7F6E, \8BF4\660E\5982\4F55\4F7F\7528 Oracle Data Provider for .NET \548C Oracle Developer Tools for Visual Studio .NET \6784\5EFA\57FA\672C\5E94\7528\7A0B\5E8F, \4EE5\53CA\5982\4F55\521B\5EFA\548C\4F7F\7528 PL/SQL \53CA .NET \5B58\50A8\8FC7\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607044994312022)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\6587\6863\63D0\4F9B\7684\6559\7A0B\8BF4\660E\5982\4F55\4E0B\8F7D\548C\5B89\88C5 Apache \53CA Zend Core PHP \9A71\52A8\7A0B\5E8F, \4ECB\7ECD\5982\4F55\4F7F\7528 PHP \6765\8FDE\63A5\5230 Oracle Database XE, \5E76\6F14\793A\5982\4F55\4F7F\7528 PHP \6765\5F00\53D1\4E00\4E2A\53EF\8BBF\95EE\548C\4FEE\6539\6570\636E\7684\7B80\5355\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577799037311999)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577629874311999)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577912085311999)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009592365312332)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578369032311999)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578450216311999)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577858868311999)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578254248311999)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578084197311999)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578169061311999)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\987A\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580956435312001)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8054\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574793402311996)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\6B64\5904\53EF\9009\62E9\8981\8054\63A5\7684\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581369797312002)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\591A\53EF\4EE5\9009\62E9 60 \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574674723311996)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574584760311995)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A/\9690\85CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581095511312001)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573501122311995)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \7684\7ED3\679C, \8FD0\884C %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829891845312193)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\539F\59CB\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588759738312008)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\524D %0 \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037110560312353)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037062989312352)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'zh-cn'
,p_message_text=>'KB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036934548312352)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'zh-cn'
,p_message_text=>'MB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609559556312024)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6784\5EFA\5668\4F7F\7528\7528\6237\754C\9762\9ED8\8BA4\8BBE\7F6E\6765\586B\5145\533A\57DF\548C\9879\5C5E\6027\7684\521D\59CB\503C, \4EE5\4FBF\5728\4E00\4E2A\5E94\7528\7A0B\5E8F\7684\591A\4E2A\9875\6216\591A\4E2A\5E94\7528\7A0B\5E8F\4E4B\95F4\4FDD\6301\4E00\81F4\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639655451312046)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\8981\6C42\542F\7528 cookie\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639536348312046)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\8981\6C42\542F\7528 JavaScript\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066868612312377)
,p_name=>'ABOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760308425312927)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\786E\8BA4\5C06\4EE5\4E0B %0 \4E2A\7528\6237\6DFB\52A0\5230\5DE5\4F5C\533A\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078301127312385)
,p_name=>'ACCEPTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63A5\53D7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046403371312360)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\8BBF\95EE\6027\5206\914D\4EBA\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044545222312358)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\8BBF\95EE\6027\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046857609312360)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\8BBF\95EE\6027\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811299411312974)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6D4B\8BD5\53EF\8BBF\95EE\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720077315312108)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586327139312006)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\7BA1\7406\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998765229312324)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103662210312406)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\7ED9\5E94\7528\7A0B\5E8F\7BA1\7406\5458\7684\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586572532312006)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587102765312006)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587092975312006)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\5C06\5982\4F55\63A7\5236\5BF9\6B64\5E94\7528\7A0B\5E8F\7684\8BBF\95EE\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588173249312007)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5904\7406\201C\8BBE\7F6E\5E94\7528\7A0B\5E8F\6A21\5F0F\201D\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588223420312007)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6A21\5F0F\5DF2\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720411380312108)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\4E0D\80FD\5220\9664\81EA\8EAB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720506846312108)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\65E0\6CD5\5220\9664\81EA\5DF1\7684\7BA1\7406\5458\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586427497312006)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998630009312324)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\63D0\4F9B\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998898288312324)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D21\732E\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103742824312406)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\7ED9\5E94\7528\7A0B\5E8F\8D21\732E\8005\7684\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039354000312354)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\4EE5\4E0B\5E94\7528\7A0B\5E8F\8BBE\7F6E\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998935536312325)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\4EE5\4E0B\5E94\7528\7A0B\5E8F\8BBF\95EE\89D2\8272\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603784359312019)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\4EE5\4E0B\6388\6743\65B9\6848\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659522329312062)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\8BBF\95EE\63A7\5236\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659481508312061)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\8BBF\95EE\63A7\5236\8868\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721818476312109)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\4E0D\80FD\8F93\5165\91CD\590D\7684\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720108889312108)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236 - \7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587813315312007)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0D\533A\5206\5927\5C0F\5199\7684\67E5\8BE2\6807\51C6, \7136\540E\6309<strong>\5F00\59CB</strong>\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587943655312007)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\5E94\7528\7A0B\5E8F\7BA1\7406\6A21\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587751839312007)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\66F4\6539\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587441585312007)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586698422312006)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6240\6709\5185\5BB9\5177\6709\5B8C\5168\8BBF\95EE\6743\9650, \4E0D\4F7F\7528\8BBF\95EE\63A7\5236\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586725251312006)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\9650\7684\8BBF\95EE\6743\9650\3002\4EC5\5141\8BB8\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\5B9A\4E49\7684\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586860901312006)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\9650\516C\5171\8BFB\53D6\3002\901A\8FC7\8BBF\95EE\63A7\5236\5217\8868\63A7\5236\7F16\8F91\548C\7BA1\7406\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586984402312006)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\9650\7BA1\7406\8BBF\95EE\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588074750312007)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6267\884C\6240\5C1D\8BD5\64CD\4F5C\7684\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587608841312007)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039260593312354)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BFB\8005\6743\5229')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039191156312354)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BFB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103812547312406)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\7ED9\5E94\7528\7A0B\5E8F\8BFB\8005\7684\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604596832312020)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\4E0E\6B64\5E94\7528\7A0B\5E8F\9A8C\8BC1\65B9\6848\5BF9\5E94\7684\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587219194312006)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5E94\7528\7A0B\5E8F\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685613367312081)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\8BBF\95EE\63A7\5236\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999011407312325)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\73B0\6709\8BBF\95EE\63A7\5236\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604448629312020)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\73B0\6709\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603624646312019)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\73B0\6709\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720207751312108)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236 - \67E5\770B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607492623312022)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293151855312559)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237\83DC\5355')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027011757312345)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027231397312345)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\8BA4, \65E0\64CD\4F5C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087738364312394)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696360300312878)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696460591312878)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\76D1\89C6\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695925079312878)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0/\4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696272107312878)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695160529312877)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\5185\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695882338312878)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\89E3 (\6587\4EF6, \6807\8BB0, \6CE8\91CA)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694806657312877)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\8BBF\95EE\63A7\5236\5217\8868\7684 Application Express \5E10\6237\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694786668312877)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\8BBF\95EE\63A7\5236\5217\8868\7684\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695551776312877)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91 SQL \8BBF\95EE\548C\5EFA\8BAE\7684\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699542703312880)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7ECF\8FC7\5E94\7528\7A0B\5E8F\7684\9A8C\8BC1\540E, \8BBF\95EE\63A7\5236\5C06\6307\5B9A\7528\6237\53EF\5728\8BE5\5E94\7528\7A0B\5E8F\4E2D\6267\884C\54EA\4E9B\64CD\4F5C\3002\4E0B\8868\6839\636E\6B64\5E94\7528\7A0B\5E8F\4E2D\6B63\5728\4F7F\7528\7684\9A8C\8BC1\6765\6807\8BC6\4E0D\540C\7C7B\578B\7684\7528\6237\5C06\5177\6709\54EA\4E9B\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696543766312878)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\8BBF\95EE\63A7\5236\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695674476312877)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\548C\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695369210312877)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\5E94\7528\7A0B\5E8F\5C5E\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312612550312575)
,p_name=>'ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694256830312876)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\64CD\4F5C\201D\83DC\5355\8BBE\7F6E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615973013312028)
,p_name=>'ACTIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006037742312330)
,p_name=>'ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047743595312361)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6D3B\52A8\6982\8981'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248346818312521)
,p_name=>'ADDED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690698085312874)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6DFB\52A0\5230\6E05\9664\5217\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305559226312569)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\9644\52A0\4FE1\606F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965876841312296)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956222245312289)
,p_name=>'ADD_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153526389312445)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795408521312165)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7EA6\675F\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954368411312288)
,p_name=>'ADD_MORE...'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\66F4\591A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020122703312340)
,p_name=>'ADD_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158674614312449)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7528\6237\754C\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162124613312452)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309 %0 MB \8C03\6574\9884\914D\7A7A\95F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953045855312287)
,p_name=>'ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541876010311970)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5E1C\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541659820311970)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\73AF\5883\6807\5E1C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541722234311970)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5E1C\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961019235312293)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5E1C\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599848037312016)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047540621312361)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959732409312292)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\63D0\4F9B\7BA1\7406\5458\7535\5B50\90AE\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112073371312413)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\8BBF\95EE\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622317512312033)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622604878312033)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622724576312034)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D28\91CF\4FDD\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622450397312033)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622801955312034)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7528\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622546436312033)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217002816312496)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 "%1" \662F\53D7\4FDD\62A4\7684, \65E0\6CD5\901A\8FC7 Ajax \8C03\7528\8FDB\884C\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217110415312496)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 "%1" \662F\53D7\4FDD\62A4\7684, \65E0\6CD5\901A\8FC7 Ajax \8C03\7528\8FDB\884C\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246413614312520)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 "%1" \662F\53D7\4FDD\62A4\7684, \65E0\6CD5\901A\8FC7 Ajax \8C03\7528\8FDB\884C\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648755819312053)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F3A\5C11 SYS \65B9\6848\524D\7F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352759214312607)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('WWV_FLOW API \4F7F\7528\60C5\51B5 (\6539\7528 APEX API)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303022532312567)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6E90 SQL \8BED\53E5\4E2D\4E0D\5B58\5728\5217 %0!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632455474312041)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868\5217%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630139574312039)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610418518312024)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6E90 SQL \8BED\53E5\4E2D\4E0D\5B58\5728\5217 %0!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382849778312630)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\683C\5F0F\8868\5355\5217%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630205631312039)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\80FD\4F5C\4E3A\5E94\7528\7A0B\5E8F\6216\9875\9879\540D\79F0\8FDB\884C\5F15\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765483961312931)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('AJAX \56DE\8C03\5E94\7528\7A0B\5E8F\5904\7406\4E0D\53D7\6388\6743\65B9\6848\4FDD\62A4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765082766312931)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0D\53D7\6388\6743\65B9\6848\4FDD\62A4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631153983312040)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\9875%1 (\5728\5E94\7528\7A0B\5E8F%0\4E2D) \672A\5B9A\4E49\6388\6743\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766700935312932)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\7684\6388\6743\4E0D\540C\4E8E\7236\9875 %0 \7684\6388\6743 "%1"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631296517312040)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\9875\4E0A\7684\6388\6743 "%0" \4E0D\540C\4E8E "%1"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629784022312039)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629641899312039)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6267\884C\7ED1\5B9A\53D8\91CF\8BED\6CD5\68C0\67E5\3002\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629861233312039)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528\7ED1\5B9A\53D8\91CF\8BED\6CD5\5F15\7528%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631863961312040)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\5206\652F\524D\7684\65E0\6761\4EF6\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764841867312931)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\5305\542B\5BC6\7801\9879\7684\9875, \8BF7\5C06\201C\81EA\52A8\5B8C\6210\201D\8BBE\7F6E\4E3A "\6253\5F00"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764989054312931)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"\9AD8\901F\7F13\5B58" \5141\8BB8\6D4F\89C8\5668\9AD8\901F\7F13\5B58\654F\611F\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564526980312777)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"\5D4C\5165\5230\6846\67B6\4E2D" \4F1A\4F7F\5E94\7528\7A0B\5E8F\6613\906D\5230\70B9\51FB\52AB\6301\7684\653B\51FB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564631336312777)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"HTML \8F6C\4E49\6A21\5F0F" \53EA\5BF9\4E00\7EC4\6709\9650\7684\5B57\7B26\8FDB\884C\8F6C\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553144094311979)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5E94\8F6C\4E49\7279\6B8A\5B57\7B26\FF0C\4EE5\907F\514D\8DE8\7AD9\70B9\811A\672C\7F16\5199 (Cross-Site-Scripting, XSS) \653B\51FB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571644627312782)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP\201C\5F15\7528\65B9\201D\8BF7\6C42\6807\5934\53EF\80FD\4F1A\5C06\654F\611F\7684\4F1A\8BDD\4FE1\606F\6CC4\9732\7ED9\7B2C\4E09\65B9\3002'),
unistr('\5E94\7528\7A0B\5E8F\5E94\5C06\201C\5F15\7528\65B9\7B56\7565\201D\8BBE\7F6E\4E3A "strict-origin"\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569213459311991)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BF9\4E8E\5728\52A8\6001\64CD\4F5C (%0) \4E2D\5F15\7528\7684\6309\94AE, \5728\6309\94AE\5C5E\6027\4E2D\53D1\73B0 ID\3002'),
'',
unistr('\5982\679C\5728\6309\94AE\5C5E\6027\4E2D\5B9A\4E49\4E86\67D0\4E2A ID, \5C06\5BFC\81F4\5F15\7528\8BE5\6309\94AE\7684\52A8\6001\64CD\4F5C\4E0D\8D77\4F5C\7528\3002\8BF7\8003\8651\5220\9664\6B64 ID, \56E0\4E3A\9ED8\8BA4\60C5\51B5\4E0B, \6309\94AE\5C06\751F\6210 ID\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569359182311991)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6309\94AE\6A21\677F\7531\8FD9\6837\7684\6309\94AE\4F7F\7528: \8BE5\6309\94AE\672C\8EAB\5728\672A\5305\542B #BUTTON_ID# \66FF\6362\5B57\7B26\4E32\7684\52A8\6001\64CD\4F5C (%0) \4E2D\5F15\7528\3002'),
'',
unistr('\6A21\677F:'),
'%1',
'',
unistr('\8BF7\8003\8651\5411\6B64\6A21\677F\6DFB\52A0 #BUTTON_ID# \66FF\6362\5B57\7B26\4E32, \6216\8005\5C06\8BE5\6309\94AE\6A21\677F\66F4\6539\4E3A\5305\542B #BUTTON_ID# \66FF\6362\5B57\7B26\4E32\7684\6309\94AE\6A21\677F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572646834311994)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\5728\52A8\6001\64CD\4F5C (%0) \4E2D\5F15\7528\7684\6309\94AE, \6309\94AE ''\64CD\4F5C'' \4E0D\662F ''\7531\52A8\6001\64CD\4F5C\5B9A\4E49''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578789000311999)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE (%0) \7684 ''\64CD\4F5C'' \4E3A ''\7531\52A8\6001\64CD\4F5C\5B9A\4E49'', \4F46\4E0D\5B58\5728\5F15\7528\6B64\6309\94AE\7684\76F8\5E94\52A8\6001\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630829816312040)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9AD8\901F\7F13\5B58\9875%0\4E0D\662F\5F53\524D\9875\6216\76EE\6807\9875%1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629591985312039)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738651704312911)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5C5E\6027\503C\5DF2\8FC7\65F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741139643312913)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\7EC4\4EF6\7C7B\578B\5DF2\8FC7\65F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217241222312496)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Ajax \8C03\7528\4E2D\7684\53D7\4FDD\62A4\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648655068312053)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE3\7801\5F02\5473 (APEX \5185\90E8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627630214312037)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879, \9875\9879, \5217\6216\4EA4\4E92\5F0F\62A5\8868\8FC7\6EE4\5668\7684\58F0\660E\6027\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764799322312931)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627343968312037)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\7ED1\5B9A\53D8\91CF\8BED\6CD5\7684\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628774788312038)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\5206\652F\524D\7684\65E0\6761\4EF6\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765273196312931)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5668\5B89\5168\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569167690311991)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\4E0E\52A8\6001\64CD\4F5C\4E0D\517C\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578595018311999)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C\548C\6309\94AE\4E4B\95F4\7684\5F15\7528\4E0D\4E00\81F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627970542312037)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\7B49\4E8E\76EE\6807\6216\5F53\524D\9875\7684\9AD8\901F\7F13\5B58\9875\7684\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627203820312037)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5217\8BED\6CD5\7684\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738561282312911)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\65F6\7684\5C5E\6027\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628239120312038)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6, DML, MR* \5904\7406\6709\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628632789312038)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786C\7F16\7801\7684\5E94\7528\7A0B\5E8F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024300023312343)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\5177\6709\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111801095312412)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6709\9875\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136025952312432)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5B9A\4E49\4E86\56FE\50CF\66FF\4EE3\6587\672C\7684\56FE\50CF\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564385048312776)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\9501\5B9A\7684\5E94\7528\7A0B\5E8F\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627406989312037)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\88AB\5F15\7528\9879\4F4D\4E8E\5F53\524D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627574378312037)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\88AB\5F15\7528\9879\662F\76EE\6807\9875\7684\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112529207312413)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\672A\5BFC\81F4\610F\5916\7684\4E0A\4E0B\6587\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113247630312413)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\5177\6709\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628908921312038)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\6216\8868\683C\5F0F\8868\5355\5217\540D\7684\957F\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627780890312037)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\7B26\4E32\4E2D\7684\9875\9879\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627896626312037)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\88AB\5F15\7528\9875\7684\9875\7801\5DF2\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112134379312413)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5177\6709\884C\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629107179312038)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5177\6709\9ED8\8BA4\987A\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765345481312931)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\72B6\6001\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628352015312038)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362\8BED\6CD5\4F7F\7528\4E0D\5F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627185493312037)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\66FF\6362\8BED\6CD5\7684\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628134007312038)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\5C06\4E3A\5F53\524D\7EC4\4EF6\8BBE\7F6E\76EE\6807\9875\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112316749312413)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\4E86\4E3B\9898\6837\5F0F\7684\53EF\8BBF\95EE\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207140104312488)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\5305\542B\517C\5BB9\6027 JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628812091312038)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\7684\76F8\5173\9879\6216\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628052047312038)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\6709\6548 SQL \6216 PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628532656312038)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1 Clob \5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107628474072312038)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \8BED\53E5\4E2D\4F7F\7528\7684 V \51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629021522312038)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5728\6309\4E0B\6309\94AE\65F6\201D\4E2D\5F15\7528\6309\94AE\5DF2\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631478519312040)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8BD1\9519\8BEF - %0\8BED\53E5: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631706796312040)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5305\542B\786C\7F16\7801\503C\5F62\5F0F\7684\5F53\524D\5E94\7528\7A0B\5E8F ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024264518312343)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\5E2E\52A9\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111977383312412)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\6CA1\6709\9875\6807\9898\3002\6709\610F\4E49\7684\9875\6807\9898\5BF9\4E8E\53EF\8BBF\95EE\6027\975E\5E38\91CD\8981, \8FD9\53EF\5E2E\52A9\7528\6237\4E86\89E3\5F53\524D\9875\7684\5185\5BB9\548C\7528\9014\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136182103312432)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9879\7F3A\5C11\56FE\50CF\6240\9700\7684\66FF\4EE3\6587\672C\3002\7528\4E8E\6B64\7528\9014\7684\826F\597D\6587\672C\5E94\8BE5\5145\5206\63CF\8FF0\4E86\56FE\50CF\7684\5185\5BB9, \540C\65F6\4E0D\5E94\91CD\590D\5728\56FE\50CF\4E0A\4E0B\6587\7684\9875\4E2D\53EF\89C1\7684\4EFB\4F55\4FE1\606F (\4EE5\907F\514D\53EF\80FD\7684\91CD\590D)\3002\6CE8: \5982\679C\56FE\50CF\7531\7528\6237\63D0\4F9B, \5219\56FE\50CF\66FF\4EE3\6587\672C\4E5F\5E94\7531\7528\6237\63D0\4F9B, \8BF7\63D0\4F9B\5408\9002\7684\6307\5357\4EE5\5E2E\52A9\7528\6237\63D0\4F9B\9AD8\8D28\91CF\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564417361312777)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"\8FD0\884C\65F6 API \4F7F\7528\60C5\51B5" \5141\8BB8\4FEE\6539\5E94\7528\7A0B\5E8F\548C\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629955061312039)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\662F\9875%1\4E0A\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630073066312039)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\662F\76EE\6807\9875%1\4E0A\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112681725312413)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\7684 ''\9009\5B9A\5185\5BB9\7684\9875\64CD\4F5C'' \8BBE\7F6E\4F1A\5BFC\81F4\610F\5916\66F4\6539\7528\6237\7684\4E0A\4E0B\6587\3002\8BF7\8003\8651\5207\6362\4E3A ''\65E0'', \8FD9\6837\5C31\6CA1\6709\4E0A\4E0B\6587\66F4\6539\5E76\4F7F\7528\52A8\6001\64CD\4F5C\6216\7EA7\8054 LOV (\9700\8981\505C\7559\5728\76F8\540C\9875\65F6) \66FF\6362\529F\80FD\3002\6B64\5916, \8BF7\8003\8651\4E3A\7528\6237\63D0\4F9B\4E00\4E9B\4FE1\606F, \8FD9\6837\7528\6237\53EF\4EE5\77E5\9053\5C06\53D1\751F\4EC0\4E48\64CD\4F5C, \4F8B\5982, \5728\6807\7B7E\4E2D\6DFB\52A0 ''\542F\52A8\65B0\9875''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135915987312432)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\5B9A\4E49\9879\7684\6807\7B7E\3002\5982\679C\504F\597D\4E0D\663E\793A\53EF\89C1\7684\6807\7B7E, \60A8\4ECD\5E94\5B9A\4E49\6807\7B7E, \7136\540E\9009\62E9 ''\9690\85CF'' \6807\7B7E\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113316766312414)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5B9A\4E49\4E86 ''\503C\5360\4F4D\7B26'' \503C, \800C\4E0D\662F\6807\7B7E\3002\5360\4F4D\7B26\6587\672C\4E0D\5E94\5355\7EAF\7528\4E8E\6807\8BB0\9879, \56E0\4E3A\8FD9\4F1A\5BFC\81F4\53EF\8BBF\95EE\6027\95EE\9898\3002\4E3A\4E86\5B9E\73B0\66F4\597D\7684\53EF\8BBF\95EE\6027, \5E94\8BE5\5B9A\4E49\9879\6807\7B7E\3002\5982\679C\504F\597D\4E0D\663E\793A\53EF\89C1\7684\6807\7B7E, \60A8\4ECD\5E94\5B9A\4E49\6807\7B7E, \7136\540E\9009\62E9 ''\9690\85CF'' \6807\7B7E\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632156068312041)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0\7684\957F\5EA6\4E3A %0 \4E2A\5B57\7B26, \4F46\6700\5927\957F\5EA6\5E94\4E3A 30 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630335192312039)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\53EF\80FD\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630432846312039)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\53EF\80FD\4E0D\662F\9875\6216\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630762117312040)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9AD8\901F\7F13\5B58\9875%1 (\5728\5E94\7528\7A0B\5E8F%0\4E2D) \4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630562622312039)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630616708312039)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\9875%1 (\5728\5E94\7528\7A0B\5E8F%0\4E2D) \4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039485639312354)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5217\5207\6362\533A\57DF\6CA1\6709\5C06\201C\7528\4F5C\884C\6807\9898\201D\5C5E\6027\8BBE\7F6E\4E3A\201C\662F\201D\7684\5217\3002\884C\6807\9898\5217\5E94\8BE5\662F\80FD\591F\6700\597D\5730\786E\5B9A\5F53\524D\884C\7684\5217\FF08\4F8B\5982\FF0C\5BA2\6237\4FE1\606F\62A5\8868\4E2D\7684\5BA2\6237\540D\79F0\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039574166312354)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\91CD\6392\533A\57DF\6CA1\6709\5C06\201C\7528\4F5C\884C\6807\9898\201D\5C5E\6027\8BBE\7F6E\4E3A\201C\662F\201D\7684\5217\3002\884C\6807\9898\5217\5E94\8BE5\662F\80FD\591F\6700\597D\5730\786E\5B9A\5F53\524D\884C\7684\5217\FF08\4F8B\5982\FF0C\5BA2\6237\4FE1\606F\62A5\8868\4E2D\7684\5BA2\6237\540D\79F0\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112232935312413)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8868\683C\5F0F\8868\5355\533A\57DF\6CA1\6709\5C06 "\7528\4F5C\884C\6807\9898" \5C5E\6027\8BBE\7F6E\4E3A\201C\662F\201D\7684\5217\3002\884C\6807\9898\5217\5E94\8BE5\662F\80FD\591F\6700\597D\5730\786E\5B9A\5F53\524D\884C\7684\5217 (\4F8B\5982, \5BA2\6237\4FE1\606F\8868\4E2D\7684\5BA2\6237\540D\79F0)\3002\7136\540E, \6B64\4FE1\606F\5728\5448\73B0\8868\683C\5F0F\8868\8FBE\65F6\4F7F\7528, \7528\4E8E\4E3A\6BCF\884C\7684\8868\5355\5B57\6BB5\63D0\4F9B\552F\4E00\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632399456312041)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\6CA1\6709\9ED8\8BA4\987A\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564721295312777)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"\4E66\7B7E\6563\5217\51FD\6570" \8BBE\7F6E\4E3A\65E7\7B97\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564818024312777)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"\4F1A\8BDD\72B6\6001\4FDD\62A4" \5DF2\7981\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765114610312931)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E26\6709\63D0\53D6\5904\7406\7684\9875\4E0A, \5E94\4F7F\7528\201C\9875\8BBF\95EE\4FDD\62A4\201D\5E76\5BF9\60A8\901A\8FC7 URL \4F20\9012\7684\9879\542F\7528\4FDD\62A4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601997235312018)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5305\542B\672A\901A\8FC7 APEX_UTIL.PREPARE_URL \4F20\9012\7684 "f?p" URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631511749312040)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\6D4B\5230\53EF\80FD\7684 SQL \6CE8\5165\3002\5C06\5728 SQL, PL/SQL \4EE3\7801\6216\5904\7406\8868\540D\4E2D\901A\8FC7\66FF\6362\8BED\6CD5\4F7F\7528%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629306432312039)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629403552312039)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528\66FF\6362\8BED\6CD5\5F15\7528%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631359043312040)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\9875%1 (\5728\5E94\7528\7A0B\5E8F%0\4E2D) \5B9A\4E49\4E86\6388\6743\65B9\6848, \4F46\5F53\524D\7EC4\4EF6\672A\5B9A\4E49\6388\6743\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112440126312413)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5F53\524D\7684\4E3B\9898\6837\5F0F\672A\7ECF\8FC7\53EF\8BBF\95EE\6027\6D4B\8BD5\3002\8BF7\5207\6362\5230\5C06\201C\5DF2\6D4B\8BD5\53EF\8BBF\95EE\6027\201D\8BBE\7F6E\4E3A\201C\662F\201D\7684\4E3B\9898\6837\5F0F, \6216\8005, \5982\679C\60A8\5F53\524D\7684\4E3B\9898\6837\5F0F\5DF2\7ECF\8FC7\6D4B\8BD5, \8BF7\5728\201C\4E3B\9898\6D4B\8BD5\201D\4E0B\5C06\5176\201C\5DF2\6D4B\8BD5\53EF\8BBF\95EE\6027\201D\5C5E\6027\8BBE\7F6E\4E3A\201C\662F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207369453312488)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\5305\542B jQuery \8FC1\79FB\3002jQuery \8FC1\79FB\5728\8FC1\79FB\5230\8F83\65B0\7248\672C\7684 jQuery \65F6\FF0C\53EF\6062\590D\5220\9664\7684 API \4EE5\53CA\5728\4F7F\7528\4E86\5DF2\5220\9664\6216\5DF2\8FC7\65F6\7684 API \65F6\5728\6D4F\89C8\5668\63A7\5236\53F0\4E2D\663E\793A\8B66\544A\FF0C\4ECE\800C\63D0\4F9B\5E2E\52A9\3002\8FD9\4F1A\5728\5E94\7528\7A0B\5E8F\4E2D\6BCF\9875\4E0A\5305\62EC\989D\5916\7684 JavaScript \6587\4EF6\3002\4E3A\5E2E\52A9\6D88\9664\8FD9\4E9B\5185\5BB9\FF0C\8BF7\67E5\770B jQuery \8FC1\79FB\5347\7EA7\6307\5357\FF0C\4E86\89E3\5E94\8BE5\66F4\6539\7684 API \7684\8BE6\7EC6\4FE1\606F\FF0C\7136\540E\5728\786E\4FE1\4E0D\518D\4F9D\8D56\4E8E\4EFB\4F55\8FD9\4E9B API \65F6\FF0C\5C06\201C\5305\542B jQuery \8FC1\79FB\201D\8BBE\7F6E\4E3A\201C\5426\201D\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207234871312488)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\5305\62EC\5DF2\8FC7\65F6\6216\5DF2\53D6\6D88\652F\6301\7684 JavaScript \51FD\6570\3002\8FD9\4F1A\5728\5E94\7528\7A0B\5E8F\7684\6BCF\9875\4E0A\5305\542B\989D\5916\7684 JavaScript \6587\4EF6\3002\4E3A\5E2E\52A9\6D88\9664\8FD9\4E9B\5185\5BB9, \8BF7\68C0\67E5\53D1\884C\8BF4\660E\4E2D ''\5DF2\8FC7\65F6\529F\80FD'' \90E8\5206, \5728\5176\4E2D\53EF\4EE5\627E\5230\6709\5173\5982\4F55\68C0\67E5\4E0E\5DF2\8FC7\65F6\6216\5DF2\53D6\6D88\652F\6301\51FD\6570\7684\76F8\5173\6027\7684\8BF4\660E, \7136\540E\8FDB\884C\5904\7406\4EE5\4E0D\5728\5E94\7528\7A0B\5E8F\4E2D\5305\62EC\8FD9\4E9B\5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632049355312041)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\76F8\5173\9879\6216\5217, \4F46 "\9519\8BEF\6D88\606F\663E\793A\4F4D\7F6E" \9700\8981\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631945466312040)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F8\5173\9879\6216\5217\4E0D\7B49\4E8E\9A8C\8BC1\8868\8FBE\5F0F 1 \4E2D\6307\5B9A\7684 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107630932918312040)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8BD1\9519\8BEF - %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631067592312040)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49 SQL \6216 PL/SQL \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107629279901312038)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D85\8FC7 32767 \4E2A\3002\53EA\68C0\67E5\524D 32767 \4E2A\3002\957F\5EA6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107631625612312040)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \8BED\53E5\4E2D\5305\542B V/NV/DV \51FD\6570\8C03\7528 (\53EF\80FD\5B58\5728\6027\80FD\95EE\9898)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632262445312041)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\7684\6309\94AE\4E0D\518D\5B58\5728\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011930793312334)
,p_name=>'AFTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E4B\540E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959213366312291)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F3A\5C11\534F\8BAE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753359774312133)
,p_name=>'ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355585387312609)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\5E94\7528\7A0B\5E8F\6784\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296993212312562)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5141\8BB8\5B89\88C5\751F\4EA7\529B\548C\793A\4F8B\5E94\7528\7A0B\5E8F\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198755143312481)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\4F7F\7528 RESTful \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355624166312609)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\4F7F\7528 SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355814848312609)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\4F7F\7528\5C0F\7EC4\5F00\53D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355432216312609)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\6E05\9664\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355740757312609)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8 Websheet \5F00\53D1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772574041312148)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589763744312008)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \5168\90E8 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589586054312008)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\7C7B\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589874731312008)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \6240\6709\7C7B\522B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358176741312611)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137526184312433)
,p_name=>'ALL_RELEASES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\53D1\884C\7248')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776906777312151)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\9759\6001\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775593140312150)
,p_name=>'ALL_THEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376287524312625)
,p_name=>'ALL_TYPES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376680819312625)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \6240\6709\7C7B\578B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772668002312148)
,p_name=>'ALL_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\7528\6237')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760591448312928)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\5177\6709 APEX \5E10\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750453589312920)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\4E2D\5DF2\5B58\5728\7528\6237')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716853932312894)
,p_name=>'ALWAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026865732312345)
,p_name=>'ANALYSIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026998839312345)
,p_name=>'ANALYZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309 %0 \8FDB\884C\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154567911312446)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 %0 \65B9\6CD5\5206\6790')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774419308312149)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533F\540D\5757')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635549212312043)
,p_name=>'ANSWERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B54\6848')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601617371312018)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\4EFB\4F55\5F00\53D1\8005)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802550513312967)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\66F4\6539:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802499712312967)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806529809312970)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'zh-cn'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802600000312967)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\91CF\FF1A ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559279102312773)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\7981\6B62 API \8C03\7528\3002'),
unistr('\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002'),
unistr('\901A\8FC7\8C03\8BD5 ID "%0" \63D0\4F9B\6709\5173\6B64\610F\5916\4E8B\4EF6\7684\8BE6\7EC6\4FE1\606F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660835685312063)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \7248\672C %1 \4E2D\5DF2\53D6\6D88\652F\6301 API \8C03\7528 "%0"\3002\901A\8FC7\8C03\8BD5 ID "%2" \63D0\4F9B\6709\5173\6B64\610F\5916\4E8B\4EF6\7684\8BE6\7EC6\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036726762312352)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\4E2D\4E0D\5B58\5728 #LABEL#\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313950432312576)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9875\5C5E\6027 "\63D0\4EA4\65F6\91CD\65B0\52A0\8F7D" \8BBE\7F6E\4E3A "\4EC5\6210\529F\65F6", \5219\4E0D\652F\6301\201C\4EC5\663E\793A\5206\652F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778674977312152)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\5206\652F\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567922344311990)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\8BA1\7B97\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758731702312137)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\6761\4EF6\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810264033312177)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\7684\6761\4EF6\7C7B\578B "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563992616311987)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\6D4F\89C8\9879 %0 \5FC5\987B\4F7F\7528 APEX_APPLICATION_TEMP_FILES \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541357733311969)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5408\5E76\201D\52A0\8F7D\7C7B\578B\4E0D\652F\6301\52A0\8F7D\5230\96C6\5408\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694534367312877)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5408\5E76\201D\52A0\8F7D\7C7B\578B\8981\6C42\6570\636E\6982\8981\6587\4EF6\4E2D\81F3\5C11\6709\4E00\4E2A\4E3B\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694364396312876)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BF9\52A0\8F7D\6E90 SQL \67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790\FF1A%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694429451312877)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\6E90 SQL \67E5\8BE2\5FC5\987B\8FD4\56DE VARCHAR2\3001CLOB \6216 BLOB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971609874312301)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6210\529F\5448\73B0\5E94\7528\7A0B\5E8F %0 \5BF9\8BDD\6846\9875 %1\3002\8BF7\786E\4FDD\5728\9875 %1 \4E0A\4F7F\7528\7684\9875\6A21\677F\7684\6A21\677F\7C7B\578B\4E3A "\5BF9\8BDD\6846\9875", \4E14\5B9A\4E49\4E86\9002\5F53\7684 JavaScript \5BF9\8BDD\6846\521D\59CB\5316, \5BF9\8BDD\6846\5173\95ED\548C\5BF9\8BDD\6846\53D6\6D88\4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791591066312958)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7248\6743\6240\6709 (c) %0, \4FDD\7559\6240\6709\6743\5229\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792366335312959)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791450663312958)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\4E00\5C01\7CFB\7EDF\751F\6210\7684\90AE\4EF6\3002\8BF7\52FF\56DE\590D\6B64\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799984795312965)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73AF\5883')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810570581312973)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Express \7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792978325312959)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5165\95E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791651879312958)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\597D, %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792626174312959)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800089345312965)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\963B\6B62\5DE5\4F5C\533A\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792884619312959)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4E0B\9762\7684\6309\94AE\5E76\6309\7167\5C4F\5E55\4E0A\7684\8BF4\660E\64CD\4F5C\53EF\9632\6B62\6E05\9664\60A8\7684\5DE5\4F5C\533A\3002\5982\679C\60A8\5728 %0 \5929\5185\672A\91C7\53D6\64CD\4F5C, \7CFB\7EDF\5C06\81EA\52A8\5220\9664\60A8\7684\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799772616312965)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\60A8\4E0D\518D\9700\8981\6B64\5DE5\4F5C\533A, \5219\65E0\9700\91C7\53D6\4EFB\4F55\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800296364312965)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5373\5C06\6E05\9664\60A8\7684\5DE5\4F5C\533A!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799571644312965)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\533A %0 \663E\793A\6700\8FD1\6CA1\6709\4EFB\4F55\6D3B\52A8\FF0C\5E76\4E14\5373\5C06\6E05\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799487985312965)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A! \5373\5C06\6E05\9664\60A8\7684\5DE5\4F5C\533A "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799880303312965)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800524956312965)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5B8C\6210\5DE5\4F5C\533A\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800390239312965)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\533A "%0" \5DF2\51C6\5907\5C31\7EEA!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800627845312965)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6279\51C6\60A8\7684\5DE5\4F5C\533A "%0"!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800456832312965)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\62D2\7EDD\60A8\7684\5DE5\4F5C\533A\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792248117312959)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800125840312965)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792137550312959)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791756318312958)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\8BF7\6C42\5DF2\88AB\6279\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792415968312959)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4EE5\4E0B\6309\94AE\53EF\4EE5\5B8C\6210\5BA1\6279\8FC7\7A0B\5E76\8BBE\7F6E\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791959335312959)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\533A\8BF7\6C42\5DF2\88AB\6279\51C6!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792588024312959)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4E0B\9762\7684\6309\94AE\4EE5\5F00\59CB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792792612312959)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\533A\5DF2\51C6\5907\5C31\7EEA!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791857571312959)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\8BF7\6C42\5DF2\88AB\62D2\7EDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108792054359312959)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62B1\6B49, \60A8\7684\5DE5\4F5C\533A\8BF7\6C42\5DF2\88AB\62D2\7EDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568353334311990)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9875\5C5E\6027\201C\63D0\4EA4\65F6\91CD\65B0\52A0\8F7D\201D\8BBE\7F6E\4E3A\201C\4EC5\6210\529F\65F6\201D\FF0C\5219\4E0D\652F\6301\4E0B\8F7D\3002\8BF7\5C06\9875\5C5E\6027\201C\63D0\4EA4\65F6\91CD\65B0\52A0\8F7D\201D\66F4\6539\4E3A\201C\59CB\7EC8\201D\6216\4F7F\7528\201C\9875\7709\4E4B\524D\201D\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102173879312405)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6392\961F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102229269312405)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\53D1\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598133041312015)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598258938312015)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\89E3\51B3\53CD\9988\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598363461312015)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937361309312275)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\7EC4 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772359880312937)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6587\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680268701312077)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('HTTP \6807\5934 %0 \88AB\53D1\9001\4E86\4E24\6B21\FF0C\8FD9\53EF\80FD\662F\4E00\4E2A\653B\51FB\3002'),
'<ul>',
unistr('<li>\7B2C 1 \4E2A\503C\FF1A"%1"</li>'),
unistr('<li>\7B2C 2 \4E2A\503C\FF1A"%2"</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717420236312106)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\652F\6301\5FC5\987B\4E3A STANDARD\3001ADVANCED\3001APEX_LISTENER\3001AOP \6216 NONE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717591927312106)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\9884\914D\7684\7B2C\4E00\4E2A\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620828008312032)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID \65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136976870312432)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613137402312026)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\662F\96F6\6216\6B63\6574\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717645441312106)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7AEF\53E3\53F7\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164695792312454)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605 ID \65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717753181312106)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Wallet \8DEF\5F84\683C\5F0F\5FC5\987B\4E3A\201Cfile:<filesystempath>\201D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796693236312166)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796546618312166)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A ID \65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821914284312186)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\4E0D\80FD\5927\4E8E %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732364343312117)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F8B\53C2\6570 "%0" \7684\503C "%1" \4E0E\6B63\5219\8868\8FBE\5F0F "%2" \4E0D\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732286646312117)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F8B\53C2\6570 "%0" \5FC5\987B\6709\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717804548312106)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5B9E\4F8B\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160748218312451)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568048358311990)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\4EC5\7528\4E8E\9488\5BF9\5DE5\4F5C\533A\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\8FDB\884C\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353173002312607)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\4EC5\7528\4E8E\9488\5BF9\5DE5\4F5C\533A\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\8FDB\884C\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246357946312520)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\4EC5\7528\4E8E\9488\5BF9\5DE5\4F5C\533A\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\8FDB\884C\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652334455312056)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\4EC5\7528\4E8E\9488\5BF9\5DE5\4F5C\533A\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\8FDB\884C\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875517955312227)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\4EC5\7528\4E8E\9488\5BF9\5DE5\4F5C\533A\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\8FDB\884C\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160653532312451)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\4EC5\7528\4E8E\9488\5BF9\5DE5\4F5C\533A\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\8FDB\884C\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719768588312107)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\670D\52A1\5668\534F\8BAE\5FC5\987B\4E3A http \6216 https')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719814891312108)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719951834312108)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\662F\53D7\9650\5236\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593244654312011)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593013305312011)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\4E0D\518D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397999370312642)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794846754312165)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724994532312900)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598663718312015)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595169475312013)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\52A0\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595098982312012)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598716470312015)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980116497312307)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\6B64\95EE\9898 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569755760311992)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569588588311991)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9E\8981\5220\9664\6B64\8BC4\8BBA?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382375403312630)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\95EE\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579402648312000)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9E\8981\5220\9664\6B64\95EE\9898\FF1F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596795730312014)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595682006312013)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569618114311992)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510462607312734)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6CE8\91CA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510531116312734)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\95EE\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593842713312012)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5DE5\4F5C\533A\4E2D\4E0D\5B58\5728\6307\5B9A\7684\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594209917312012)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\5220\9664\6CE8\91CA\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594150007312012)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6CE8\91CA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594422023312012)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594580345312012)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\5C06\95EE\9898\6807\8BB0\4E3A\5F85\5220\9664\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593933712312012)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5DE5\4F5C\533A\4E2D\6216\63D0\4F9B\7684\5E94\7528\7A0B\5E8F\4E2D\4E0D\5B58\5728\6307\5B9A\7684\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594319591312012)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\65E0\6743\5220\9664\6B64\6CE8\91CA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594650728312012)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\65E0\6743\5220\9664\6B64\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594095003312012)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\65E0\6743\66F4\6539\6B64\6CE8\91CA\7684\53EF\89C1\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603932145312807)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6587\4EF6\5927\5C0F\65F6\51FA\73B0\95EE\9898\3002\8BF7\4E0E\7CFB\7EDF\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603892805312807)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4E2D\4E00\4E2A\6587\4EF6\5927\4E8E\6700\5927\6587\4EF6\5927\5C0F %0 \5B57\8282\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603735796312807)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\4EF6\5927\4E8E\6700\5927\6587\4EF6\5927\5C0F %0 \5B57\8282\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569895911311992)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596587951312014)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595444668312013)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592802962312011)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7CFB\7EDF\4E2D\672A\627E\5230\7684\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542240727311970)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7528\6237\6DFB\52A0\9996\9009\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595207233312013)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\52A0\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594946075312012)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\89E3\51B3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728883156312903)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596274731312013)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7A7A\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596092401312013)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4E2D\4E00\4E2A\6587\4EF6\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594868410312012)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\89E3\51B3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597333637312014)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C38\4E45\5220\9664\6240\9009\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383277644312631)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597204133312014)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6062\590D\6240\9009\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595352490312013)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\54CD\5E94\6A21\677F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596154765312013)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\592A\5927\FF0C\65E0\6CD5\4E0A\8F7D\3002<br>\6587\4EF6\5FC5\987B\5C0F\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596472363312014)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\7684\6587\4EF6\7C7B\578B\4E3A\FF1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578858278312787)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\54CD\5E94\6A21\677F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595900984312013)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\4EF6\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596327880312013)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\662F\652F\6301\7684\6587\4EF6\7C7B\578B\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325731623312585)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'zh-cn'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326388884312586)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325893048312585)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6539\8FDB\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325979586312586)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326224671312586)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326150002312586)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6027\80FD\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326028794312586)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\95EE\9898 ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326446734312586)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57F9\8BAD\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327143232312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326835467312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'zh-cn'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326989301312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C/JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326699475312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327252111312587)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8\7CFB\7EDF\96C6\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326759656312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \96C6\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327047981312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108326546263312586)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'zh-cn'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325608184312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\7ED9\95EE\9898\7684\7C7B\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324764691312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325547489312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EE\9898\5F71\54CD\7684\529F\80FD\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324816674312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325488959312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\7ED9\95EE\9898\7684\91CD\8981\6027\7EA7\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324906615312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\8981\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325369460312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E3\51B3\95EE\9898\6240\9700\7684\5DE5\4F5C\91CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325050395312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325248510312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EE\9898\5904\7406\8FDB\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108325108274312585)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327675917312587)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79EF\538B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327305660312587)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E25\91CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327476096312587)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327524968312587)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327776894312587)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4E0D\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327862938312587)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F7B\677E\4FEE\590D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328088452312587)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\91CF\5F00\53D1\5DE5\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108327948927312587)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C\5DE5\4F5C\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328407838312588)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4FEE\590D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328500947312588)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328278615312587)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\66F4\591A\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328314438312587)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\7B49\5F85\7B2C\4E09\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328153705312587)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338665196312596)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\6B64\6807\7B7E\7EC4\FF0C\56E0\4E3A\5B83\7684\4E00\4E2A\6216\591A\4E2A\6210\5458\5206\914D\7ED9\67D0\4E2A\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598463336312015)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107594733292312012)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6807\8BB0\4EE5\4E0B\9879\7684\91CD\590D\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382724877312630)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\4EBA\5458')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382645299312630)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383130996312631)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CC\7A0B\7891')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382509987312630)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592648592312011)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328935684312588)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE3\7801\51BB\7ED3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329199188312588)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\53D1\884C\7248')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329019502312588)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('UI \51BB\7ED3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597106703312014)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5411 %1 \6DFB\52A0\4E86\6CE8\91CA (%2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541222181311969)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346233920312602)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A %1 \4E2D\7684\95EE\9898\7F16\53F7 %0 \5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603642630312807)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1A\672A\5B9A\4E49\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598513206312015)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595842948312013)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593346567312011)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593154030312011)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0D\518D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722410493312898)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398013360312642)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592960478312011)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4ECE\4EE5\4E0B\9879\4E2D\5220\9664\5E94\7528\7A0B\5E8F\548C\9875\5173\8054')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593605817312011)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697140856312879)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\8981\5C06\5F53\524D\6CE8\91CA\66FF\6362\4E3A\6B64\6A21\677F\FF1F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699145152312880)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\597D\FF01'),
'',
unistr('\8FD9\662F\60A8\7684\7B2C\4E00\4E2A\95EE\9898\FF01\60A8\53EF\4EE5\521B\5EFA\95EE\9898\4EE5\8DDF\8E2A\60A8\7684\6240\6709 APEX \9879\76EE\7684\4EFB\52A1\3001\529F\80FD\3001Bug \548C\53CD\9988\FF01\60A8\53EF\4EE5\5411\95EE\9898\6DFB\52A0\6807\7B7E\3001\6DFB\52A0\5206\914D\4EBA\5458\3001\8BBE\7F6E\91CC\7A0B\7891\FF0C\751A\81F3\53EF\4EE5\4F7F\7528 Markdown \7CBE\7B80\8BED\6CD5\5E94\7528\683C\5F0F\FF01'),
'',
unistr('\4E0B\9762\662F\53EF\4EE5\4F7F\7528 Markdown \6267\884C\7684\64CD\4F5C\7684\5FEB\901F\793A\4F8B\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699086118312880)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B22\8FCE\4F7F\7528 Oracle APEX \4E2D\7684\5C0F\7EC4\5F00\53D1\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398143222312642)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593729612312011)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\72B6\6001\8BBE\7F6E\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570079077311992)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698925019312880)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\66F4\591A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593494727312011)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604047368312807)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A %1 \4E2D\7684 %0 \6709 %2 \4E2A\65B0\901A\77E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322296780312583)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\8BB0\5F55 Bug \7684\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322120134312582)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Bug \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322082344312582)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\9884\671F\884C\4E3A**'),
unistr('- \544A\8BC9\6211\4EEC\60A8\8BA4\4E3A\5E94\8BE5\53D1\751F\7684\60C5\51B5\3002'),
'',
'',
unistr('**\5F53\524D\884C\4E3A**'),
unistr('- \544A\8BC9\6211\4EEC\53D1\751F\7684\60C5\51B5\3002'),
'',
'',
unistr('**\53D7\5F71\54CD\5BF9\8C61**'),
unistr('- \544A\8BC9\6211\4EEC\53D7\5F71\54CD\7684\4EBA\5458/\5185\5BB9\3002'),
'',
unistr('**\53EF\80FD\7684\89E3\51B3\65B9\6848**'),
unistr('- \5982\679C\53EF\4EE5\FF0C\8BF7\5BF9\60A8\4F1A\5982\4F55\4FEE\590D\6B64 Bug \63D0\4F9B\5EFA\8BAE\3002'),
'',
unistr('**\518D\73B0\6B65\9AA4**'),
unistr('- \63D0\4F9B\4E00\7EC4\6E05\6670\7684\518D\73B0\6B65\9AA4\FF0C\5305\62EC\5C4F\5E55\5FEB\7167\548C\4EE3\7801\7247\6BB5\FF08\5982\679C\9002\7528\FF09\3002'),
'1.',
'2.',
'3.',
'',
unistr('**\4E0A\4E0B\6587**'),
unistr('- Bug \53D1\751F\65F6\60A8\6B63\5728\5C1D\8BD5\5B8C\6210\7684\5185\5BB9\3002Bug \4EC5\5728\7279\5B9A\6761\4EF6\4E0B\53D1\751F\6216\5728\4E00\5929\4E2D\7684\7279\5B9A\65F6\95F4\53D1\751F\7B49\3002'),
'',
unistr('**\73AF\5883**'),
'',
unistr('- \7248\672C\FF1A'),
unistr('- \5E73\53F0\FF1A'),
unistr('- \5B50\7CFB\7EDF\FF1A'),
'',
'______',
'',
unistr('_**\6CE8\FF1A**\8981\5C06\95EE\9898\4E0E\5E94\7528\7A0B\5E8F\548C/\6216\9875\5173\8054\FF0C\8BF7\5148\8BB0\5F55\8BE5\95EE\9898\FF0C\7136\540E\4F7F\7528**\64CD\4F5C**\4E0B\62C9\5217\8868\6765\5173\8054\5E94\7528\7A0B\5E8F\548C\9875\3002_')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323355039312583)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\51FA Bug\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323224487312583)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\51FA Bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323451486312583)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\5728\9002\5F53\7684\5916\90E8\7CFB\7EDF\4E2D\5F52\6863 **Bug**\3002'),
'',
unistr('- Bug \8DDF\8E2A\7CFB\7EDF\FF1A'),
unistr('- Bug ID\FF1A'),
unistr('- Bug \7684 URL\FF1A'),
'',
unistr('\6CE8\91CA\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322451111312583)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\8BB0\5F55\529F\80FD\8BF7\6C42\7684\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322346293312583)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\8BF7\6C42\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322508495312583)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\529F\80FD\6982\8981**'),
unistr(' - \63D0\4F9B\4E00\6BB5\6709\5173\529F\80FD\8BF7\6C42\7684\4E00\822C\6982\89C8\3002'),
'',
'',
unistr('**\4E0A\4E0B\6587**'),
unistr(' - \6B64\8BF7\6C42\662F\5426\4E0E\7279\5B9A\60C5\51B5\6216\8FC7\7A0B\76F8\5173\FF1F\4F8B\5982\FF0C\201C\5728 [...] \65F6\FF0C\6211\603B\662F\9047\5230\95EE\9898\201D'),
'',
'',
unistr(' - \8BF7\63D0\4F9B\4EFB\4F55\652F\6301\4FE1\606F\FF0C\5305\62EC\5C4F\5E55\5FEB\7167\548C\7528\4F8B\7B49\3002'),
'',
'',
unistr('**\9996\9009\89E3\51B3\65B9\6848**'),
unistr('- \6E05\695A\5730\63CF\8FF0\60A8\5E0C\671B\770B\5230\7684\5B9E\65BD\5185\5BB9\3002'),
'',
'',
unistr('**\66FF\4EE3\89E3\51B3\65B9\6848**'),
unistr('- \63CF\8FF0\8003\8651\7684\66FF\4EE3\89E3\51B3\65B9\6848\6216\529F\80FD\FF0C\6216\8005\4F7F\7528\7684\89E3\51B3\65B9\6CD5\3002'),
'',
'',
'______',
unistr('_**\6CE8\FF1A**\8981\5C06\95EE\9898\4E0E\5E94\7528\7A0B\5E8F\548C/\6216\9875\5173\8054\FF0C\8BF7\5148\8BB0\5F55\8BE5\95EE\9898\FF0C\7136\540E\4F7F\7528**\64CD\4F5C**\4E0B\62C9\5217\8868\6765\5173\8054\5E94\7528\7A0B\5E8F\548C\9875\3002_')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323628622312584)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5F52\6863\529F\80FD\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323546308312584)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5F52\6863\529F\80FD\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323786707312584)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\5728\9002\5F53\7684\5916\90E8\7CFB\7EDF\4E2D\5F52\6863**\529F\80FD\8BF7\6C42**\3002'),
'',
unistr('- \529F\80FD\8DDF\8E2A\7CFB\7EDF\FF1A'),
unistr('- \529F\80FD ID\FF1A'),
unistr('- \529F\80FD\5B9A\4E49\7684 URL\FF1A'),
'',
unistr('\6CE8\91CA\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324530994312584)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\540E\7EED\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324487610312584)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\540E\7EED\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324665566312584)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8BF7\6267\884C\4EE5\4E0B\64CD\4F5C\FF1A'),
'',
'1.',
'2.',
'3.',
'4.',
'',
unistr('\6CE8\91CA\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322772506312583)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\63D0\51FA\8FC7\7A0B\95EE\9898\7684\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322639617312583)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\4E3B\9898 ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322896742312583)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\95EE\9898**'),
unistr('- \5C3D\53EF\80FD\7B80\660E\5730\9648\8FF0\60A8\7684\95EE\9898\6216\8BF7\6C42\3002'),
'',
unistr('**\4E00\822C\4E0A\4E0B\6587**'),
unistr('- \60A8\5C1D\8BD5\6267\884C\4EC0\4E48\64CD\4F5C\FF1F'),
'',
'',
unistr('- \60A8\662F\5426\5728\5176\4ED6\4EC0\4E48\5730\65B9\67E5\627E\8FC7\6216\60A8\8054\7CFB\8FC7\5176\4ED6\4EC0\4E48\4EBA\6765\67E5\627E\7B54\6848\FF1F'),
'',
'',
unistr('**\73AF\5883** '),
unistr('\6B64\95EE\9898\662F\5426\4E0E\73AF\5883\3001\7F16\7A0B\8BED\8A00\6216\5176\4ED6\65B9\9762\7279\5B9A\76F8\5173\FF1F'),
'',
'______',
unistr('_**\6CE8\FF1A**\8981\5C06\95EE\9898\4E0E\5E94\7528\7A0B\5E8F\548C/\6216\9875\5173\8054\FF0C\8BF7\5148\8BB0\5F55\8BE5\95EE\9898\FF0C\7136\540E\4F7F\7528**\64CD\4F5C**\4E0B\62C9\5217\8868\6765\5173\8054\5E94\7528\7A0B\5E8F\548C\9875\3002_')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324233129312584)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\8003\5DF2\77E5\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324152876312584)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\77E5\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324390123312584)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7ECF\8FC7\590D\67E5\FF0C\786E\5B9A\8FD9\662F\5DF2\77E5\95EE\9898\FF0C\8BF7\53C2\89C1\4EE5\4E0B\8BE6\7EC6\4FE1\606F\3002'),
'',
unistr('- Bug \8DDF\8E2A\7CFB\7EDF\FF1A'),
unistr('- Bug ID\FF1A'),
unistr('- Bug \7684 URL\FF1A'),
'',
unistr('\6CE8\91CA\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323949213312584)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\66F4\591A\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323837438312584)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\66F4\591A\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108324054571312584)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**\6B64\95EE\9898\9700\8981\66F4\591A\4FE1\606F\FF1A**'),
'',
unistr('\8BF7\63D0\4F9B\4E0B\9762\8981\6C42\7684\4FE1\606F\3002\5982\679C\6CA1\6709\6B64\4FE1\606F\FF0C\5C06\5F88\96BE\5BF9\95EE\9898\8FDB\884C\9274\522B\5206\7C7B\5E76\8FDB\4E00\6B65\89E3\51B3\95EE\9898\3002'),
'',
'',
unistr('\6CE8\91CA\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323044836312583)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4E0D\5BF9\6B64\95EE\9898\8FDB\884C\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108322953683312583)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108323103687312583)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7ECF\8FC7\4ED4\7EC6\8003\8651\540E\FF0C**\5C06\4E0D\5BF9\6B64\95EE\9898\91C7\53D6\8FDB\4E00\6B65\64CD\4F5C**\3002'),
'',
unistr('\6CE8\91CA\FF1A')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596820419312014)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595741956312013)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592513503312010)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347371156312602)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06\9644\4EF6 %0 \6DFB\52A0\5230 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346336561312602)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06 %0 \6DFB\52A0\5230 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347976316312603)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06 %0 \6DFB\52A0\5230 %1				')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346538774312602)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06 %0 \5206\914D\7ED9 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346904053312602)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06 %0 \4E0E %1 \5173\8054')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597049037312014)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\4E86 %0 \7684\6CE8\91CA	(%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794722538312165)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7F16\8F91\95EE\9898 %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347829833312603)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\95EE\9898\5DF2\88AB\9690\85CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346745679312602)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06 %0 \6807\8BB0\4E3A %1 \7684\91CD\590D\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347745574312603)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6253\5F00 %0\FF0C\6253\5F00\8005\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347482567312603)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\4ECE %1 \4E2D\5220\9664\9644\4EF6 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346470155312602)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\4ECE %1 \4E2D\5220\9664 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348002734312603)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\4ECE %1 \4E2D\5220\9664 %0 			')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347517001312603)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\5C06 %0 \7684\72B6\6001\8BBE\7F6E\4E3A %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347118301312602)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \5DF2\8BA2\9605 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346653759312602)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \5DF2\4ECE %1 \53D6\6D88\5206\914D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347020608312602)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \5DF2\4ECE %0 \5220\9664\5E94\7528\7A0B\5E8F\548C\9875\5173\8054')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346869397312602)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5C06 %0 \53D6\6D88\6807\8BB0\4E3A\91CD\590D %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347282545312602)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \5DF2\53D6\6D88\8BA2\9605 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108347687845312603)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \5DF2\7531 %2 \6807\8BB0\4E3A %0 \7684\91CD\590D\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592718508312011)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569921649311992)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\9690\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107593594302312011)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382441165312630)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596691792312014)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Zip \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107595571911312013)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Zip \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553864039311979)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\662F\5DF2\8FDB\884C\5730\7406\7F16\7801\7684\5730\5740\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692111673312875)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\9879 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582516699312790)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6821\9A8C\548C\63D0\4F9B\4E86\4E00\79CD\7B80\5355\7684\65B9\6CD5\6765\786E\5B9A\540C\4E00\9875\662F\5426\90E8\7F72\5728\5176\4ED6\4F4D\7F6E\3002\60A8\53EF\4EE5\6BD4\8F83\6B64\6821\9A8C\548C\4EE5\786E\5B9A\662F\5426\5B58\5728\5339\914D\3002	\5BF9\6B64\9875\4E0A\4F7F\7528\7684\5171\4EAB\7EC4\4EF6\7684\66F4\6539\4E0D\4F1A\53CD\6620\5728\6B64\6821\9A8C\548C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738137879312910)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737911579312910)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738014143312910)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570508012311992)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5141\8BB8\4F7F\7528\5177\6709\4E00\79CD\5B57\4F53\7684\7D27\51D1\5B57\4F53\683C\5F0F (Compact Font Format, CFF) \5B57\4F53\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570651325311992)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5141\8BB8\4F7F\7528\5177\6709\4E00\79CD\9876\7EA7 DICT \7684\7D27\51D1\5B57\4F53\683C\5F0F (Compact Font Format, CFF) \5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570714624311992)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5141\8BB8\4F7F\7528\5177\6709\7C7B\578B 2 CharString \683C\5F0F\7684\7D27\51D1\5B57\4F53\683C\5F0F (Compact Font Format, CFF) \5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582950746312003)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\8BE5\5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582818888312003)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\652F\6301\683C\5F0F 4 \548C 12 cmap \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583202047312003)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\65B9\5411\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583022242312003)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5 PDF \672A\521D\59CB\5316\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582708981312003)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8BE5\5B57\4F53\4E2D\672A\627E\5230\6709\6548\7684 cmap \5B50\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583162044312003)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5 PDF \6CA1\6709\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018170027312339)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA PDF \6587\4EF6\65F6\51FA\73B0\5185\90E8\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588588112312007)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 "%0" \5206\914D\4E86\65E0\6548\FF08\975E\591A\884C\FF09\53EF\7F16\8F91\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576653845311998)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246184995312520)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230 Web \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783902732312156)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\8FDB\7A0B\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603277845312019)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7531\4E8E\6570\636E\5E93\4F1A\8BDD\8D44\6E90\9650\5236, Application Express \65E0\6CD5\5904\7406\8BF7\6C42\3002\8BF7\7A0D\540E\91CD\8BD5\3002'),
'<p/>',
unistr('\901A\8FC7\8C03\8BD5 ID "%0" \63D0\4F9B\6709\5173\6B64\610F\5916\4E8B\4EF6\7684\8BE6\7EC6\4FE1\606F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577444592311998)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\7F72\5E94\7528\7A0B\5E8F\65F6\51FA\73B0\4EE5\4E0B\9519\8BEF\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580150205312001)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \5DF2\6210\529F\90E8\7F72\5230\8FDC\7A0B\670D\52A1\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583814463312004)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \5DF2\6210\529F\4F5C\4E3A %1 \90E8\7F72\5230\8FDC\7A0B\670D\52A1\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218383095312497)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL \670D\52A1\7684\9A8C\8BC1\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603591432312019)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25\3002\503C\5217\8868\4F7F\7528\542F\7528 REST \7684 SQL \6570\636E\6E90\FF0C\4F46\5B83\5F15\7528\7684 Web \8EAB\4EFD\8BC1\660E\65E0\6548\FF0C\56E0\800C\963B\6B62\60A8\7F16\8F91\6B64 LOV \7684\5217\4FE1\606F\3002\8BF7\68C0\67E5\7528\4E8E\9A8C\8BC1\7684\8EAB\4EFD\8BC1\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724668058312900)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\4FE1\5931\8D25\3002\8C03\7528\503C\5217\8868\5F15\7528\7684\542F\7528 REST \7684 SQL \6570\636E\6E90\65F6\51FA\73B0\95EE\9898\FF0C\56E0\6B64\60A8\65E0\6CD5\7F16\8F91\8BE5 LOV \7684\5217\4FE1\606F\3002\8BF7\68C0\67E5\542F\7528 REST \7684 SQL \6570\636E\6E90\662F\5426\6B63\5E38\5DE5\4F5C\FF0C\4EE5\53CA\5BF9\5E94\7684\9A8C\8BC1\8EAB\4EFD\8BC1\660E\662F\5426\6B63\786E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219690369312498)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B\670D\52A1\5668\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194420418312478)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6240\6307\5B9A\542F\7528 REST \7684 SQL \5B9E\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800227203312169)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\5668\5DF2\5C06\91CD\5B9A\5411\53D1\9001\5230\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094750203312399)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8BED\53E5\7684\957F\5EA6\8D85\8FC7\4E86 32,767 \5B57\8282\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113441307312414)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\60A8\597D, Application Express! \60A8\4EE5 #USER# \7684\8EAB\4EFD\8FDE\63A5\3002'),
unistr('\672C\5730\6570\636E\5E93\65F6\95F4\6233\4E3A: #SYSDATE#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338580460312596)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\7F16\8F91\5DE5\4F5C\533A\7684\9ED8\8BA4\65B9\6848\7684\522B\540D\3002\8BBE\7F6E\6B64\522B\540D\8FD8\5C06\66F4\6539\5DE5\4F5C\533A\7EA7\522B\7684\8DEF\5F84\524D\7F00\3002\8FD9\5C06\5F71\54CD\60A8\53EF\80FD\5B9A\4E49\7684\4EFB\4F55\57FA\4E8E APEX \7684 RESTful \670D\52A1\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092480971312397)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329802811312589)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329920695312589)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5E94\7528\7A0B\5E8F\5B9E\7528\7A0B\5E8F \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337330589312595)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\9875')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337207521312595)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\201C\5171\4EAB\7EC4\4EF6\201D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330049623312589)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6784\5EFA\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330182437312589)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6784\5EFA\5668\4EFB\52A1 > ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330292000312589)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330340611312589)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5E94\7528\7A0B\5E8F\9879 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330496758312589)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\903B\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330520874312589)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330694594312589)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5B89\5168\9A8C\8BC1\65B9\6848 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330794493312589)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330898872312589)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5B89\5168\6388\6743\65B9\6848 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108330903359312590)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331083681312590)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \9762\5305\5C51 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331193606312590)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331266529312590)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \6784\5EFA\9009\9879 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331311252312590)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331446958312590)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \7EC4\4EF6\8BBE\7F6E \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331556556312590)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331671795312590)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5E94\7528\7A0B\5E8F\8BA1\7B97 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331785732312590)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331890951312590)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108331909239312590)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332026880312590)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332195203312591)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332261000312591)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332349962312591)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332448326312591)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA Web \8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332523525312591)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332614046312591)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \6570\636E\52A0\8F7D\5B9A\4E49 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332709207312591)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332805821312591)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108332914619312591)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333005786312591)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333152512312591)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \62A5\8868\5E03\5C40 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333222731312591)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7 Web \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333356936312591)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \65E7 Web \670D\52A1 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333445541312592)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333541289312592)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \7ECF\5178\5BFC\822A\5217\8868 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333699087312592)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333749808312592)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \503C\5217\8868 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333854951312592)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108333966222312592)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334088224312592)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334153338312592)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \63D2\4EF6 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334227801312592)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334327696312592)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5E94\7528\7A0B\5E8F\5904\7406 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334442232312592)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334573545312592)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \62A5\8868\67E5\8BE2 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334617357312593)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334746017312593)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334806274312593)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \542F\7528 REST \7684 SQL \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108334910146312593)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335003723312593)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\72B6\6001\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335160903312593)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5E94\7528\7A0B\5E8F\72B6\6001\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335397602312593)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335430361312593)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335571276312593)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335610360312593)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5FEB\6377\65B9\5F0F \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335717289312593)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\FF08\65E7\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335890387312593)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335905589312594)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C UI \6A21\677F \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336006148312594)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336147776312594)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C UI \4E3B\9898 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336266771312594)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336384503312594)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336481799312594)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C \5B89\5168 Web \8EAB\4EFD\8BC1\660E \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336503743312594)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336648280312594)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\FF1A\5171\4EAB\7EC4\4EF6 \005C REST \6570\636E\6E90 \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336715988312594)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336822513312594)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108336921782312594)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \5DE5\4F5C\5BA4\4E2D\521B\5EFA %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337022707312594)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\7F16\8F91\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337182857312595)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\4EFB\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795934685312962)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879 %0 \57FA\4E8E\6570\636E\5E93\5217, \4F46\5C5E\6027 ''\4F7F\7528\7684\6E90'' \8BBE\7F6E\4E3A ''\4EC5\5F53\4F1A\8BDD\72B6\6001\4E2D\7684\5F53\524D\503C\4E3A\7A7A\65F6''\3002\8FD9\975E\5E38\5371\9669, \5E76\4E14\53EF\80FD\5BFC\81F4\5728\67E5\770B\548C\4FDD\5B58\591A\4E2A\8BB0\5F55\65F6\610F\5916\5730\8986\76D6\6570\636E\3002\5C06 ''\4F7F\7528\7684\6E90'' \59CB\7EC8\8BBE\7F6E\4E3A ''\59CB\7EC8\66FF\6362\4F1A\8BDD\72B6\6001\4E2D\7684\4EFB\4F55\73B0\6709\503C''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733250703312907)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\6B62\8BBF\95EE\4F1A\8BDD\72B6\6001, \5DF2\963B\6B62\5C1D\8BD5\8BFB\53D6/\5199\5165\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616629930312029)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5904\7406\8FC7\7A0B\4E2D\5C1D\8BD5\4FDD\5B58\5904\4E8E\4F1A\8BDD\72B6\6001\7684\9879 %0, \9879\5177\6709\201C\4EC5\5185\90E8\201D\4FDD\62A4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609462769312023)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A5\53D7\5904\7406\8FC7\7A0B\4E2D\5C1D\8BD5\4FDD\5B58\5904\4E8E\4F1A\8BDD\72B6\6001\7684\9879 %0, \9879\5177\6709\201C\4EC5\5185\90E8\201D\4FDD\62A4, \6216\8005\4E0D\662F\53EF\4EE5\6295\9012\7684\8868\5355\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609299291312023)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6839\636E\8BF7\6C42, \6E05\9664\9AD8\901F\7F13\5B58, \53C2\6570\540D\548C\53C2\6570\503C\8BA1\7B97\7684\6821\9A8C\548C (%0) \4E0E\4F20\9012\5230\663E\793A\8FC7\7A0B\4E2D\7684\6821\9A8C\548C (%1) \4E0D\5339\914D\3002'),
'',
unistr('\6CE8: \6700\7EC8\7528\6237\5C06\5F97\5230\4E0D\540C\7684\9519\8BEF\6D88\606F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608776102312023)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\663E\793A\5904\7406\8FC7\7A0B\4E2D\5C1D\8BD5\4FDD\5B58\5904\4E8E\4F1A\8BDD\72B6\6001\7684\9879 %0\3002\9879\4FDD\62A4\7EA7\522B\4E3A:'),
'  %1',
'',
unistr('\672A\4F20\5165\6821\9A8C\548C, \6216\8005\4F20\5165\7684\6821\9A8C\548C\5E94\8BE5\9002\5408\4FDD\62A4\7EA7\522B\4E3A "%2" \7684\9879\3002'),
'',
unistr('\6CE8: \6700\7EC8\7528\6237\5C06\5F97\5230\4E0D\540C\7684\9519\8BEF\6D88\606F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783756073312156)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1022 \65E0\6CD5\4FDD\5B58\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553373936311979)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06 SDO_GEOMETRY \503C\8F6C\6362\4E3A GeoJSON\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550858020311977)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06\6587\672C\8F6C\6362\4E3A SDO_GEOMETRY \5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552065500311978)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5305\542B\6709\6548\7684 GeoJSON\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567666977311990)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\5217 #COMPONENT_NAME# \7684\9ED8\8BA4\503C\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568520385311991)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\201C\591A\884C\5220\9664\201D\8FDB\7A0B\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810737625312177)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6821\9A8C\548C\5217 ("FCS") \662F\5FC5\9700\7684, \4F46\672A\63D0\4F9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810913891312177)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\63D0\4F9B\4E3B\952E\503C, \81F3\5C11\5FC5\987B\63D0\4F9B\4E00\884C\624D\80FD\8FDB\884C\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811706184312178)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6807\8BC6\7684\6B21\7EA7\952E\5217\63D0\4F9B\6B21\7EA7\952E\5217\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951314065312285)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8868\683C\5F0F\8868\5355\4E2D\672A\627E\5230\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810681572312177)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A\4E3B\952E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811641851312178)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\7684\6B21\7EA7\952E\5217\4E0D\5728\67E5\8BE2\7684\9009\62E9\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810520936312177)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810496116312177)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A\8868\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831696959312194)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\201C\591A\884C\66F4\65B0\201D\8FDB\7A0B\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591858733312010)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\590D\5236\5E94\7528\7A0B\5E8F "%1" \4E2D\7684\4E3B\9898 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789448986312957)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BFC\5165\7684\4E3B\9898\4E0E\5F53\524D\4E3B\9898\4E0D\517C\5BB9\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771560061312936)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\53F7\65E0\6548\6216\8005\4E3B\9898\4E0D\662F\5F53\524D UI \4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732350887312906)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\5C42\6B21\9700\8981\4E3B\952E\5217\548C\7236\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732464368312906)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8BA1\7B97\5C42\6B21\65F6\FF0C\9700\8981\8282\70B9\7EA7\522B\5217\548C\8282\70B9\72B6\6001\5217\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750765575312920)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509750099312733)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724293845312111)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6697\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724314132312111)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509692646312733)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F7B\91CF\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153158045312445)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\4ECE\4E0B\9762\7684\5217\8868\4E2D\9009\62E9\7528\6237\754C\9762:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155424557312447)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 - \7528\6237\754C\9762\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694903443312089)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6388\6743\8BBF\95EE (\672A\8BBE\7F6E\5B89\5168\7EC4\5305\53D8\91CF)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695365478312089)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\63D0\53D6\67E5\627E\7528\6237\4FE1\606F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681101216312078)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \9700\8981 ADMIN \6743\9650\624D\80FD\6267\884C\6B64\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695279659312089)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \672A\63D0\4F9B\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651043023312055)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\672A\83B7\6388\6743\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695184169312089)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610184277312024)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1 "%0" \5206\914D\4E86\65E0\6548\FF08\975E\591A\884C\FF09\53EF\7F16\8F91\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783849922312156)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9A8C\8BC1\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733607049312907)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \65E0\6CD5\4ECE\4EE5\4E0B\7C7B\578B\7684\54CD\5E94\6570\636E\8BA1\7B97\6570\636E\6982\8981\6587\4EF6\FF1A%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200389971312483)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200260087312483)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720202071312896)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\8868\8FBE\5F0F\4E0D\662F\6709\6548\7684 JSON\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713447830312891)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle REST Data Services \4E0D\652F\6301\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092360125312397)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9875 URL \53C2\6570 "%0" \4E0E REST \6E90\53C2\6570\51B2\7A81\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195273955312479)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 200: \6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195380823312479)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 201: \5DF2\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194730268312478)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 400: \8BF7\6C42\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194536481312478)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 401: \672A\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194880337312478)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 403: \7981\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194678994312478)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 404: \672A\627E\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194993593312478)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 405: \4E0D\5141\8BB8\4F7F\7528\6B64\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552626335311978)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 407\FF1A\9700\8981\4EE3\7406\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552993537311979)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 409\FF1A\51B2\7A81')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552709174311978)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 412\FF1A\524D\7F6E\6761\4EF6\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552815424311978)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 428\FF1A\9700\8981\524D\7F6E\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195056531312479)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 500: \5185\90E8\670D\52A1\5668\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195159017312479)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 502: \7F51\5173\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734029354312907)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 503\FF1A\670D\52A1\4E0D\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734159263312907)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP 504\FF1A\7F51\5173\8D85\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576236702312785)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\8FD4\56DE\4E86 HTTP \9519\8BEF\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194325112312478)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230 REST \6570\636E\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750144584312131)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\9009\62E9\5668 "%0" \672A\9009\62E9\8981\89C6\4E3A\8868\7684\5BF9\8C61\6570\7EC4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750274543312131)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\9009\62E9\5668 "%0" \672A\9009\62E9\8981\89C6\4E3A\5355\884C\7684\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555896090311981)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8D85\8FC7 REST \6570\636E\6E90\901F\7387\9650\5236\FF08%1 \79D2\5185 %0 \4E2A\8BF7\6C42\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544886622311972)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8D85\8FC7 REST \6570\636E\6E90\901F\7387\9650\5236\FF08%1 \79D2\5185 %0 \4E2A\8BF7\6C42\FF09\FF0C\5E76\4E14\6240\9700\7B49\5F85\65F6\95F4\592A\957F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576136793312785)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B\4E3A "%1" \7684\5FC5\9700 REST \6E90\8F93\5165\53C2\6570 "%0" \5FC5\987B\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494167756312720)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\54CD\5E94\6B63\6587\592A\5927, \65E0\6CD5\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159564171312450)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7 ORDS REST \670D\52A1\4F7F\7528\5C0F\56FA\5B9A\9875\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559454459311984)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- \6B64 API \8C03\7528\901A\8FC7\6267\884C ALTER TABLE \8BED\53E5\5C06\8868\5217'),
unistr('-- \52A8\6001\540C\6B65\5230 REST \6570\636E\6E90\7684\6570\636E\6982\8981\6587\4EF6\3002'),
unistr('-- \5982\679C\65E0\6CD5\4F7F\7528 ALTER TABLE \66F4\6539\5217\6570\636E\7C7B\578B\FF0C'),
unistr('-- \5C06\5F15\53D1\9519\8BEF\6D88\606F\3002'),
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558335645311983)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\81EA\52A8\5E94\7528\6570\636E\6982\8981\6587\4EF6\66F4\6539\FF0C\5FC5\987B\624B\52A8\8C03\6574\672C\5730\8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559555685311984)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- \81EA %0 \5F00\59CB\FF0C\6B64\64CD\4F5C\5C06\6267\884C\FF1A'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557536442311982)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5408\5E76\540C\6B65\65B9\6CD5\9700\8981\5728\6570\636E\6982\8981\6587\4EF6\4E2D\5B9A\4E49\4E3B\952E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557863226311982)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5730\8868\548C\6570\636E\6982\8981\6587\4EF6\6CA1\6709\516C\7528\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544405932311972)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4E2D\6B62\4F5C\4E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558088184311983)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558152075311983)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B8C\6574\FF08\5DF2\8D85\8FC7\8BF7\6C42\9650\5236\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558239178311983)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\5DF2\5728\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545343348311973)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545447456311973)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8C03\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557922717311982)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557623750311982)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\6B65\6B65\9AA4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557705044311982)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\FF08\65B0\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042489327312357)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113591180312414)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\6240\6709 REST \6E90\6570\636E\65F6\8D85\65F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089428799312395)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\7684\672C\5730 SQL \8FC7\6EE4\5668\9700\8981\5BF9 REST \670D\52A1\53D1\51FA\8FC7\591A\7684\201C\4E0B\4E00\9875\201D\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159489224312450)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7 ORDS REST \670D\52A1\7684\56FA\5B9A\9875\5927\5C0F\672A\77E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865859706312220)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\7BA1\7406\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840309448312201)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861954735312217)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6CE8\91CA\6389')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846401019312205)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846787392312205)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847143752312206)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847252079312206)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847382922312206)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846129235312205)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846262739312205)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846372903312205)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846076362312205)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835337926312197)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846596619312205)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\9009\5B9A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846651122312205)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846869766312206)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835126659312197)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835800101312197)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107846969321312206)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835507134312197)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835493040312197)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835288490312197)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835687850312197)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835776110312197)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847420283312206)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847008073312206)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840231211312200)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859473559312215)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851802023312209)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840064965312200)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850813151312209)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5C0F\65F6\7EDF\8BA1\7684\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850108221312208)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839956784312200)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839157722312200)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849724146312208)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849134442312207)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850790348312209)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E0B\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848096232312206)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847719599312206)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850004027312208)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838931800312200)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848890335312207)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851788839312209)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849456197312207)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839051141312200)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851682267312209)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847543966312206)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839646619312200)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839457617312200)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5F52\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852065456312209)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F52\6863\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850590931312208)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6574\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849334052312207)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IR \641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848155041312207)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848420096312207)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849637029312208)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\957F\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849898617312208)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\65F6\4E2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851224787312209)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851346247312209)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849572309312208)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\77ED\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851134767312209)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'zh-cn'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849245303312207)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850628017312208)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\73B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848995952312207)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850969563312209)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849017789312207)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848572315312207)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850222019312208)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850446175312208)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\5206\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851409264312209)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E  \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839596352312200)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BC4\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851951311312209)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\539F\56E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839770449312200)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\54CD\5E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851074246312209)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\53D6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839348670312200)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8C03\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839269302312200)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847692270312206)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107851550917312209)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848779648312207)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107850317142312208)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847927343312206)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107847872475312206)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848624518312207)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848370970312207)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107839809046312200)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\4EE3\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107848259077312207)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107849949418312208)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\6743\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832541995312195)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\5DF2\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845471519312205)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\53D6\6D88\201D\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845909045312205)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845506715312205)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6309\94AE - \5BF9\8BDD\6846\5DF2\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845696447312205)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\62A5\8868 - \5BF9\8BDD\6846\5DF2\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845774167312205)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845806730312205)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835028308312197)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\5B57\7B26\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834648688312196)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858202179312214)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\542F\7528\8BBF\95EE\63A7\5236\65F6\FF0C\7BA1\7406\5458\53EF\4EE5\9650\5236\5DF2\9A8C\8BC1\7528\6237\5BF9\7279\5B9A\5E94\7528\7A0B\5E8F\529F\80FD\7684\8BBF\95EE\6743\9650\3002\6B64\5E94\7528\7A0B\5E8F\652F\6301\4EE5\4E0B 3 \79CD\89D2\8272\FF1A\8BFB\8005\3001\5185\5BB9\63D0\4F9B\8005\548C\7BA1\7406\5458\3002</p>'),
'<ul>',
unistr('  <li><strong>\8BFB\8005</strong>\5177\6709\6240\6709\4FE1\606F\7684\53EA\8BFB\8BBF\95EE\6743\9650\FF0C\8FD8\53EF\4EE5\67E5\770B\62A5\8868\3002</li>'),
unistr('  <li><strong>\5185\5BB9\63D0\4F9B\8005</strong>\53EF\4EE5\521B\5EFA\FF0C\7F16\8F91\548C\5220\9664\4FE1\606F\4EE5\53CA\67E5\770B\62A5\8868\3002</li>'),
unistr('  <li><strong>\7BA1\7406\5458</strong>\FF0C\9664\4E86\5185\5BB9\63D0\4F9B\8005\7684\529F\80FD\4E4B\5916\FF0C\8FD8\53EF\4EE5\6267\884C\5E94\7528\7A0B\5E8F\7684\914D\7F6E\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858056416312214)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\4F55\5DF2\9A8C\8BC1\7528\6237\90FD\53EF\4EE5\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858112923312214)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6240\6709\7528\6237\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\5B9A\4E49, \5219\9009\62E9<strong>\5426</strong>\3002\5982\679C\6B64\5E94\7528\7A0B\5E8F\4E2D\8FD8\4F1A\4F7F\7528\4E0D\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\7684\5DF2\9A8C\8BC1\7528\6237, \5219\9009\62E9 <strong>\662F</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856394929312213)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F\7528\7684\65E5\671F/\6570\5B57\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856455258312213)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\662F\63D0\4F9B\5B9A\5236\683C\5F0F\63A9\7801\8FD8\662F\4F7F\7528\6807\51C6\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858841143312215)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857814815312214)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856598565312213)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\5B57\7B26\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855321288312212)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5E76\7C98\8D34\5E26\5206\9694\7B26\7684\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856683999312213)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D27\5E01\7B26\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856711243312213)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6570\636E\4E2D\5305\542B\56FD\9645\8D27\5E01\7B26\53F7, \8BF7\5728\6B64\5904\8F93\5165\3002\4F8B\5982, \5982\679C\6570\636E\4E2D\5305\542B "&euro;1,234.56" \6216 "&yen;1,234.56", \8BF7\8F93\5165 "&euro;" \6216 "&yen;"\3002\5426\5219, \5C06\65E0\6CD5\6B63\786E\52A0\8F7D\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855034371312212)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857021630312213)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\6570\70B9\7B26\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857179054312213)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0F\6570\70B9\5B57\7B26\5C06\6570\5B57\7684\6574\6570\90E8\5206\548C\5C0F\6570\90E8\5206\5206\9694\5F00\6765\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\4EFB\4F55\5B57\7B26\4F5C\4E3A\5C0F\6570\70B9\5B57\7B26\3002\6240\6307\5B9A\7684\5B57\7B26\5FC5\987B\4E3A\5355\5B57\8282\5B57\7B26, \5E76\4E14\5C0F\6570\70B9\5B57\7B26\4E0D\80FD\4E0E\7EC4\5206\9694\7B26\76F8\540C\3002\6B64\5B57\7B26\53EF\4EE5\4E3A\7A7A\683C, \4F46\4E0D\80FD\4E3A\6570\5B57\5B57\7B26\6216\4EE5\4E0B\5B57\7B26\4E4B\4E00:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\53F7 (+)</li>'),
unistr('<li>\8FDE\5B57\53F7 (-)</li> '),
unistr('<li>\5C0F\4E8E\53F7 (<)</li>'),
unistr('<li>\5927\4E8E\53F7 (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834287080312196)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858909724312215)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855672785312212)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C01\95ED\7B26 (\53EF\9009)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834599410312196)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5206\9694\7B26\3002\60A8\53EF\4EE5\4F7F\7528\6B64\5B57\7B26\6807\8BB0\6570\636E\503C\7684\8D77\59CB\548C\7EC8\6B62\754C\9650\3002\5982\679C\60A8\6307\5B9A\4E86\5206\9694\7B26\FF0C\6570\636E\5DE5\4F5C\5BA4\5C06\5FFD\7565\6570\636E\503C\8D77\59CB\548C\7EC8\6B62\754C\9650\524D\9762\51FA\73B0\7684\7A7A\683C\3002\60A8\8FD8\53EF\4EE5\4F7F\7528\6B64\9009\9879\5C06\6570\636E\503C\653E\5728\6307\5B9A\7684\5206\9694\7B26\4E2D\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858775843312215)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F53\9A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856060858312212)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5931\8D25\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834766895312196)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859099870312215)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5F52\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855103175312212)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855232980312212)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4E0A\8F7D\7684\6587\4EF6\7684\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855755138312212)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6570\636E\7684\7B2C\4E00\884C\4E2D\5305\542B\5217\540D, \8BF7\9009\4E2D\6B64\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856895166312213)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5206\9694\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856924333312213)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7EC4\5206\9694\7B26\662F\5206\9694\6574\6570\7EC4\7684\5B57\7B26, \4F8B\5982, \7528\6765\8868\793A\5343\4F4D\548C\767E\4E07\4F4D\7684\5B57\7B26\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\4EFB\4F55\5B57\7B26\4F5C\4E3A\7EC4\5206\9694\7B26\3002\6240\6307\5B9A\7684\5B57\7B26\5FC5\987B\4E3A\5355\5B57\8282\5B57\7B26, \5E76\4E14\7EC4\5206\9694\7B26\4E0D\80FD\4E0E\5C0F\6570\70B9\5B57\7B26\76F8\540C\3002\6B64\5B57\7B26\53EF\4EE5\4E3A\7A7A\683C, \4F46\4E0D\80FD\4E3A\6570\5B57\5B57\7B26\6216\4EE5\4E0B\5B57\7B26\4E4B\4E00:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\53F7 (+)</li>'),
unistr('<li>\8FDE\5B57\53F7 (-)</li> '),
unistr('<li>\5C0F\4E8E\53F7 (<)</li>'),
unistr('<li>\5927\4E8E\53F7 (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855892879312212)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D2\5165\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834863001312196)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834476168312196)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859143894312215)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BC4\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854806829312212)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BB0\4F4F\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854900989312212)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\9009\4E2D\6B64\590D\9009\6846\FF0C\5219\5E94\7528\7A0B\5E8F\4F1A\5C06\60A8\7684\7528\6237\540D\4FDD\5B58\5728\540D\4E3A "LOGIN_USERNAME_COOKIE" \7684\6301\4E45\6D4F\89C8\5668 cookie \4E2D\3002'),
unistr('\5728\60A8\4E0B\6B21\8F6C\5230\767B\5F55\9875\65F6\FF0C'),
unistr('\7528\6237\540D\5B57\6BB5\5C06\81EA\52A8\4F7F\7528\6B64\503C\586B\5145\3002'),
'</p>',
'<p>',
unistr('\5982\679C\53D6\6D88\9009\4E2D\6B64\590D\9009\6846\FF0C\5E76\4E14\60A8\7684\7528\6237\540D\5DF2\4FDD\5B58\5728 Cookie \4E2D\FF0C'),
unistr('\5219\5E94\7528\7A0B\5E8F\5C06\4F7F\7528\7A7A\7684\503C\6765\8986\76D6\5B83\3002'),
unistr('\60A8\8FD8\53EF\4EE5\4F7F\7528\6D4F\89C8\5668\7684\5F00\53D1\8005\5DE5\5177\6765\5F7B\5E95\5220\9664 Cookie\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859232683312215)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\54CD\5E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856170356312213)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6210\4E3A\7ECF\8FC7\590D\67E5\7684\884C, \8BF7\6267\884C\4EE5\4E0B\64CD\4F5C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834058015312196)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834172513312196)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855411750312212)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855553890312212)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\5217\5206\9694\7B26\3002\4F7F\7528 <code>\005Ct</code> \4EE3\8868\5236\8868\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107856230774312213)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6570\636E\52A0\8F7D\7684\9AD8\7EA7\8BBE\7F6E: \8D27\5E01\7B26\53F7, \5C0F\6570\70B9\5B57\7B26, \6587\4EF6\7F16\7801\6216\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857992770312214)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834949798312197)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857520332312214)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\4E3B\9898\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857602475312214)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9009\4E2D, \5219\6700\7EC8\7528\6237\53EF\4EE5\4F7F\7528\201C\5B9A\5236\201D\94FE\63A5\9009\62E9\81EA\5DF1\7684\4E3B\9898\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857352901312213)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\684C\9762\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857458535312214)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\4E3B\9898\6837\5F0F\5E94\7528\5230\6240\6709\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857270131312213)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107855922401312212)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107834384858312196)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858356096312214)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858549355312214)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4EE5\9017\53F7, \5206\53F7\6216\7A7A\683C\5206\9694\7684\7528\6237\540D\3002\5C06\81EA\52A8\5FFD\7565\73B0\6709\7528\6237\540D\6216\91CD\590D\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858492786312214)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5904\8F93\5165\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107858619082312214)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859377396312215)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\4EE3\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107857797235312214)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837089891312198)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836971297312198)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861683165312217)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836810109312198)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837234087312198)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837171785312198)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861500590312217)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837376711312198)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861495406312217)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861702702312217)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836714990312198)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861891826312217)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837599025312198)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837626127312199)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837487713312198)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859659017312215)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\7684\62A5\8868\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861119026312216)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860590358312216)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\56FE\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861331936312216)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859894147312215)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5E76\7C98\8D34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860191308312216)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5E94\7528\7A0B\5E8F\6807\51C6\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860242328312216)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\4E0A\8F7D\7684\5217\63D0\4F9B\5B9A\5236\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860649530312216)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860312543312216)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859921495312215)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\884C\5177\6709\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860909650312216)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D1F\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860875366312216)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861004678312216)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107861239162312216)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860787870312216)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860466347312216)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\62A5\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107860014696312216)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9AD8\7EA7\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859746433312215)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\6587\4EF6, \4EE5\9017\53F7\5206\9694\7684 *.csv \683C\5F0F\6216\5236\8868\7B26\5206\9694\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863786749312218)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838263138312199)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237 - \6B65\9AA4 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838494320312199)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863337555312218)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863486240312218)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5E94\7528\7A0B\5E8F\6240\6709\8005 (\7BA1\7406\5458) \53EF\4EE5\4F7F\7528\7BA1\7406\9875\6765\914D\7F6E\5E94\7528\7A0B\5E8F\548C\7EF4\62A4\5728\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528\7684\901A\7528\6570\636E\3002'),
unistr('\901A\8FC7\9009\62E9\4E00\4E2A\53EF\7528\8BBE\7F6E, \7BA1\7406\5458\53EF\4EE5\6F5C\5728\5730\66F4\6539\5982\4F55\663E\793A\5E94\7528\7A0B\5E8F\548C/\6216\53EF\4F9B\6700\7EC8\7528\6237\4F7F\7528\7684\529F\80FD\3002</p>'),
unistr('<p>\6B64\9875\5E94\4EC5\9650\7BA1\7406\5458\8BBF\95EE\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863982240312218)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864096416312219)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\81EA\52A8\5316\65E5\5FD7\7684\4EA4\4E92\5F0F\62A5\8868\3002</p>'),
unistr('<p>\68C0\67E5\6709\5173\4EE5\524D\7684\81EA\52A8\5316\6267\884C\7684\5DF2\8BB0\5F55\4FE1\606F\3002\65E5\5FD7\4E2D\5305\542B\5F00\59CB\548C\7ED3\675F\65F6\95F4\6233\FF0C\4EE5\53CA\6709\5173\5DF2\5904\7406\884C\FF08\6210\529F\7684\884C\548C\6709\9519\8BEF\7684\884C\FF09\7684\8BE6\7EC6\4FE1\606F\3002\7EC6\5316\5230\201C\6D88\606F\201D\53EF\67E5\770B\6709\5173\5DF2\5904\7406\884C\7684\5355\4E2A\6D88\606F\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863635667312218)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\914D\7F6E\8BBE\7F6E\53EF\4EE5\8BA9\7279\5B9A\529F\80FD\5BF9\6700\7EC8\7528\6237\53EF\7528 (\542F\7528) \6216\4E0D\53EF\7528 (\7981\7528) \3002</p>'),
unistr('<p>\5982\679C\7279\5B9A\529F\80FD\672A\5B8C\5168\51C6\5907\597D, \6216\8005\9700\8981\4E34\65F6\5220\9664, \8BF7\5355\51FB<strong>\7981\7528</strong>\3002'),
unistr('\5982\679C\5E94\4F7F\5176\53EF\7528, \5219\53EA\9700\5355\51FB<strong>\542F\7528</strong>\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \6B64\5904\6240\505A\7684\66F4\6539\4E0D\4F1A\4F53\73B0\5728\5F53\524D\6B63\5728\8FD0\884C\5E94\7528\7A0B\5E8F\7684\5355\4E2A\6700\7EC8\7528\6237\8EAB\4E0A\3002\5728\6700\7EC8\7528\6237\6CE8\9500\5E76\767B\5F55\56DE\4E4B\540E, \5C06\8C03\7528\4FEE\8BA2\540E\7684\529F\80FD\8BBE\7F6E\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865085094312219)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865104926312219)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\4EFB\4F55\5DF2\9A8C\8BC1\7528\6237\9009\62E9\76F8\5E94\7684\9009\9879\3002<br>'),
unistr('\9009\62E9<strong>\5426</strong>\53EF\63D0\9AD8\5E94\7528\7A0B\5E8F\7684\5B89\5168\6027, \56E0\4E3A\53EA\6709\6307\5B9A\7528\6237\53EF\4EE5\8BBF\95EE\5E94\7528\7A0B\5E8F\3002'),
unistr('\4F46\662F, \5982\679C\5E94\7528\7A0B\5E8F\6709\5927\91CF\7528\6237\7FA4, \5219\7EF4\62A4\7528\6237\4F1A\975E\5E38\7E41\91CD, \60A8\53EF\80FD\4F1A\504F\597D\9009\62E9<strong>\662F</strong>\5E76\4EC5\8F93\5165\5E94\7528\7A0B\5E8F\7BA1\7406\5458, \4E5F\8BB8\5305\62EC\5185\5BB9\63D0\4F9B\8005\3002<br>'),
unistr('\5982\679C\60A8\9009\62E9<strong>\662F</strong>, \5219\8FD8\5FC5\987B\9009\62E9\5982\4F55\5904\7406\672A\5305\62EC\5728\7528\6237\5217\8868\4E2D\7684\7528\6237\3002</p>'),
unistr('<p>\9009\62E9\5FC5\9700\7684\7535\5B50\90AE\4EF6\5730\5740, \6216\8005\4F7F\7528\4EFB\610F\5B57\6BCD\6570\5B57\503C\7684\7528\6237\540D\3002<br>'),
unistr('\901A\5E38, \5982\679C\5E94\7528\7A0B\5E8F\4F7F\7528 (\6216\5C06\914D\7F6E\4E3A\4F7F\7528) \96C6\4E2D\9A8C\8BC1\65B9\6848, \4F8B\5982 Oracle Access Manager \6216 SSO, \5219\5E94\8BE5\5C06\6B64\8BBE\7F6E\8BBE\7F6E\4E3A<strong>\7535\5B50\90AE\4EF6\5730\5740</strong>\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \6B64\5E94\7528\7A0B\5E8F\652F\6301\4EE5\4E0B 3 \79CD\8BBF\95EE\7EA7\522B: \8BFB\8005, \5185\5BB9\63D0\4F9B\8005\548C\7BA1\7406\5458\3002'),
'<ul>',
unistr('  <li><strong>\8BFB\8005</strong>\5177\6709\6240\6709\4FE1\606F\7684\53EA\8BFB\8BBF\95EE\6743\9650, \8FD8\53EF\4EE5\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\5185\5BB9\63D0\4F9B\8005</strong>\53EF\4EE5\521B\5EFA, \7F16\8F91\548C\5220\9664\4FE1\606F\53CA\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\7BA1\7406\5458</strong>\9664\4E86\5185\5BB9\63D0\4F9B\8005\7684\529F\80FD\4E4B\5916, \8FD8\53EF\4EE5\901A\8FC7\8BBF\95EE\5E94\7528\7A0B\5E8F\7684\201C\7BA1\7406\201D\90E8\5206\6267\884C\5E94\7528\7A0B\5E8F\7684\914D\7F6E\3002</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864590323312219)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9519\8BEF\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864671096312219)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\8BE5\5E94\7528\7A0B\5E8F\8BB0\5F55\7684\6240\6709\610F\5916\9519\8BEF\7684\4EA4\4E92\5F0F\62A5\544A\3002</p>'),
unistr('<p>\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865308174312219)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865453429312220)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865570527312220)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p><strong>\542F\7528\9644\4EF6</strong> - \5982\679C\4E3A\201C\662F\201D\FF0C\5219\7528\6237\53EF\4EE5\4E0A\8F7D\9644\4EF6\4EE5\4FBF\4E3A\5176\53CD\9988\63D0\4F9B\4F9D\636E\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838372959312199)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838039975312199)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837747514312199)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862448708312217)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB\5E94\7528\7A0B\5E8F\4E2D\4EFB\610F\9875\4E0A\5BFC\822A\680F\4E2D\7684\201C\53CD\9988\201D\56FE\6807 (<span class="fa fa-comment-o" aria-hidden="true"></span>), \53EF\4EE5\5411\5E94\7528\7A0B\5E8F\7BA1\7406\5458\63D0\4F9B\53CD\9988\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862206013312217)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8FD9\662F\5E94\7528\7A0B\5E8F\7684\4E3B\9875\3002\5355\51FB\5361\7247\53EF\8BBF\95EE\5E94\7528\7A0B\5E8F\4E2D\7684\4E0D\540C\9875, \6216\8005\4F7F\7528\9875\4FA7\9762\7684\5BFC\822A\83DC\5355\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862827300312218)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB\5BFC\822A\680F\4E2D\7684\540D\79F0\4E0B\62C9\5217\8868\53EF\6CE8\9500\5E94\7528\7A0B\5E8F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862709821312218)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB\5BFC\822A\680F\4E2D\7684\7528\6237\83DC\5355 (<span class="fa fa-user" aria-hidden="true"></span>) \53EF\66F4\65B0\65F6\533A\9996\9009\9879, \4EE5\53CA\6CE8\9500\5E94\7528\7A0B\5E8F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862171232312217)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862399576312217)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8FD9\662F\5E94\7528\7A0B\5E8F\7684\4E3B\9875\3002\5355\51FB\5361\7247\53EF\8BBF\95EE\5E94\7528\7A0B\5E8F\4E2D\7684\4E0D\540C\9875, \6216\8005\4F7F\7528\9875\9876\90E8\7684\5BFC\822A\83DC\5355\3002</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862695709312217)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5355\51FB\5BFC\822A\680F (\9875\53F3\4E0A\89D2) \4E2D\7684\7528\6237\83DC\5355 (<span class="fa fa-user" aria-hidden="true"></span>) \53EF\8BBF\95EE\60A8\7684\7528\6237\6982\8981\4FE1\606F, \4EE5\53CA\6CE8\9500\5E94\7528\7A0B\5E8F\3002<br>'),
unistr('\5355\51FB<strong>\67E5\770B\6211\7684\6982\8981\4FE1\606F</strong>\65F6, \53EF\4EE5\968F\540E\5355\51FB<strong>\66F4\65B0\6982\8981\4FE1\606F</strong>\6765\8F93\5165\4E2A\4EBA\8BE6\7EC6\4FE1\606F\548C\4E0A\8F7D\76F8\7247\6216\5934\50CF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862573091312217)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5355\51FB\5BFC\822A\680F\4E2D\7684\7528\6237\83DC\5355 (<span class="fa fa-user" aria-hidden="true"></span>) \53EF\8BBF\95EE\60A8\7684\7528\6237\6982\8981\4FE1\606F, \66F4\65B0\65F6\533A\9996\9009\9879, \4EE5\53CA\6CE8\9500\5E94\7528\7A0B\5E8F\3002<br>'),
unistr('\5355\51FB<strong>\67E5\770B\6211\7684\6982\8981\4FE1\606F</strong>\65F6, \53EF\4EE5\968F\540E\5355\51FB<strong>\66F4\65B0\6982\8981\4FE1\606F</strong>\6765\8F93\5165\4E2A\4EBA\8BE6\7EC6\4FE1\606F\548C\4E0A\8F7D\7167\7247\6216\5934\50CF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863083167312218)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53EF\4EE5\76F4\63A5\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E2D\63D2\5165\3001\66F4\65B0\548C\5220\9664\6570\636E\3002<br>'),
unistr('  \5355\51FB\201C\6DFB\52A0\884C\201D\6309\94AE\53EF\63D2\5165\65B0\884C\3002<br>'),
unistr('  \53CC\51FB\5355\5143\FF0C\6216\8005\5355\51FB<strong>\7F16\8F91</strong>\6309\94AE\53EF\66F4\65B0\6570\636E\503C\FF0C\4E0E\5728\7535\5B50\8868\683C\4E2D\7F16\8F91\6570\636E\7C7B\4F3C\3002</p>'),
'',
unistr('<p>\4F7F\7528\4F4D\4E8E\62A5\8868\9876\90E8\7684\201C\884C\64CD\4F5C\201D\83DC\5355 (<span class="fa fa-bars" aria-hidden="true"></span>) \53EF\590D\5236\3001\5220\9664\3001\5237\65B0\6216\8FD8\539F\9009\5B9A\884C\3002<br> '),
unistr('  \4F7F\7528\4F4D\4E8E\5404\884C\4E0A\7684\201C\884C\64CD\4F5C\201D\83DC\5355\8FD8\53EF\4EE5\8BBF\95EE\5355\884C\89C6\56FE\6216\6DFB\52A0\65B0\884C\3002</p>'),
'',
unistr('<p>\8981\67E5\627E\6570\636E\FF0C\8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\FF0C\6216\8005\5355\51FB\5217\6807\9898\4EE5\9650\5236\8FD4\56DE\7684\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\4EE5\6267\884C\591A\79CD\529F\80FD\3002\8FD9\5305\62EC\9009\62E9\663E\793A/\9690\85CF\7684\5217\53CA\5176\663E\793A\5E8F\5217\FF0C\4EE5\53CA\591A\79CD\6570\636E\548C\683C\5F0F\529F\80FD\3002\8FD8\53EF\4F7F\7528\56FE\8868\9009\9879\5B9A\4E49\6570\636E\7684\5176\4ED6\89C6\56FE\3002</p>'),
'',
unistr('<p>\5982\679C\8981\4FDD\5B58\5B9A\5236\8BBE\7F6E\FF0C\8BF7\9009\62E9\62A5\8868\FF0C\6216\8005\5355\51FB\4E0B\8F7D\4EE5\5378\8F7D\6570\636E\3002<p>'),
'',
unistr('<p>\6709\5173\5176\4ED6\4FE1\606F\FF0C\8BF7\5355\51FB\4F4D\4E8E\201C\64CD\4F5C\201D\83DC\5355\5E95\90E8\7684\201C\5E2E\52A9\201D\3002</p> '),
'',
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\7F51\683C\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863162475312218)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8981\67E5\627E\6570\636E, \8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD, \6216\8005\5355\51FB\5217\6807\9898\4EE5\9650\5236\8FD4\56DE\7684\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\4EE5\6267\884C\591A\79CD\529F\80FD\3002\8FD9\5305\62EC\9009\62E9\663E\793A/\9690\85CF\7684\5217\53CA\5176\663E\793A\987A\5E8F, \4EE5\53CA\591A\79CD\6570\636E\548C\683C\5F0F\529F\80FD\3002\8FD8\53EF\4F7F\7528\56FE\8868\9009\9879\5B9A\4E49\6570\636E\7684\5176\4ED6\89C6\56FE\3002</p>'),
'',
unistr('<p>\5982\679C\8981\4FDD\5B58\5B9A\5236\8BBE\7F6E, \8BF7\9009\62E9\62A5\544A, \6216\8005\5355\51FB\4E0B\8F7D\4EE5\5378\8F7D\6570\636E\3002<p>'),
'<br>',
unistr('<p>\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\5355\51FB\4F4D\4E8E\201C\64CD\4F5C\201D\83DC\5355\5E95\90E8\7684\201C\5E2E\52A9\201D\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862915865312218)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8981\67E5\627E\6570\636E\FF0C\8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\FF0C\6216\8005\5355\51FB\5217\6807\9898\4EE5\9650\5236\8FD4\56DE\7684\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\4EE5\6267\884C\591A\79CD\529F\80FD\3002\8FD9\5305\62EC\9009\62E9\663E\793A/\9690\85CF\7684\5217\53CA\5176\663E\793A\987A\5E8F\FF0C\4EE5\53CA\591A\79CD\6570\636E\548C\683C\5F0F\529F\80FD\3002\8FD8\53EF\4EE5\4F7F\7528\56FE\8868\3001\5206\7EC4\65B9\5F0F\548C\900F\89C6\9009\9879\5B9A\4E49\6570\636E\7684\5176\4ED6\89C6\56FE\3002</p>'),
'',
unistr('<p>\5982\679C\8981\4FDD\5B58\5B9A\5236\8BBE\7F6E\FF0C\8BF7\9009\62E9\62A5\8868\FF0C\6216\8005\5355\51FB\4E0B\8F7D\4EE5\5378\8F7D\6570\636E\3002\5728\8981\5B9A\671F\53D1\9001\6570\636E\7684\8BA2\9605\4E0B\8F93\5165\7535\5B50\90AE\4EF6\5730\5740\548C\65F6\95F4\8303\56F4\3002<p>'),
'',
unistr('<p>\6709\5173\5176\4ED6\4FE1\606F\FF0C\8BF7\5355\51FB\4F4D\4E8E\201C\64CD\4F5C\201D\83DC\5355\5E95\90E8\7684\201C\5E2E\52A9\201D\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\8868\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837850623312199)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107837918258312199)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 - \767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864765132312219)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865698389312220)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865719596312220)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6700\7EC8\7528\6237\53EF\4EE5\5728\5E94\7528\7A0B\5E8F\4E2D\7684\4EFB\610F\666E\901A\9875\4E0A\8F93\5165\53CD\9988\3002</p>'),
unistr('<p>\6B64\62A5\544A\663E\793A\8F93\5165\7684\53CD\9988, \7BA1\7406\5458\8F93\5165\7684\4EFB\4F55\56DE\590D, \4EE5\53CA\53CD\9988\7684\72B6\6001\3002</p>'),
unistr('<p>\5355\51FB\7F16\8F91\56FE\6807 (\9EC4\8272\94C5\7B14) \53EF\8F93\5165\54CD\5E94\6216\66F4\65B0\53CD\9988\72B6\6001\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \5982\679C\5DF2\7ECF\5B9A\4E49\4E86\53CD\9988\6536\4EF6\4EBA, \5219\53CD\9988\63D0\4EA4\8FD8\5C06\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001\5230\53CD\9988\6536\4EF6\4EBA\5217\8868\4E2D\7684\7535\5B50\90AE\4EF6\5730\5740\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864886083312219)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\7528\6237\8BBF\95EE\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864972518312219)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\663E\793A\5E94\7528\7A0B\5E8F\7528\6237\548C\6240\6388\4E88\8BBF\95EE\7EA7\522B\7684\62A5\544A\3002</p>'),
unistr('<p>\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002<br>'),
unistr('\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>'),
unistr('<p>\5355\51FB\201C\7F16\8F91\201D\56FE\6807 (\9EC4\8272\94C5\7B14) \53EF\7F16\8F91\7528\6237\8BE6\7EC6\4FE1\606F\548C\8BBF\95EE\7EA7\522B, \6216\8005\5220\9664\7528\6237\3002</p>'),
unistr('<p>\5355\51FB\4F4D\4E8E\62A5\544A\9876\90E8\7684<strong>\6DFB\52A0\7528\6237</strong>\53EF\6DFB\52A0\65B0\7528\6237\53CA\5176\8BBF\95EE\7EA7\522B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865288915312219)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\8868\5355\53EF\8F93\5165\7528\6237, \5176\7535\5B50\90AE\4EF6\5730\5740\5E76\8BBE\7F6E\5176\8BBF\95EE\7EA7\522B\3002'),
unistr('\5728<em>\914D\7F6E\8BBF\95EE\63A7\5236</em>\4E0B\5B9A\4E49\7684\8BBE\7F6E\5C06\786E\5B9A\7528\6237\540D\662F\5FC5\987B\4E3A\7535\5B50\90AE\4EF6\5730\5740, \8FD8\662F\53EF\4EE5\4E3A\4EFB\610F\5B57\6BCD\6570\5B57\6761\76EE\3002</p>'),
unistr('<p>\6B64\5E94\7528\7A0B\5E8F\652F\6301\4EE5\4E0B 3 \79CD\8BBF\95EE\7EA7\522B: \8BFB\8005, \5185\5BB9\63D0\4F9B\8005\548C\7BA1\7406\5458\3002</p>'),
'<ul>',
unistr('  <li><strong>\8BFB\8005</strong>\5177\6709\6240\6709\4FE1\606F\7684\53EA\8BFB\8BBF\95EE\6743\9650, \8FD8\53EF\4EE5\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\5185\5BB9\63D0\4F9B\8005</strong>\53EF\4EE5\521B\5EFA, \7F16\8F91\548C\5220\9664\4FE1\606F\4EE5\53CA\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\7BA1\7406\5458</strong>\9664\4E86\5185\5BB9\63D0\4F9B\8005\7684\529F\80FD\4E4B\5916, \8FD8\53EF\4EE5\901A\8FC7\8BBF\95EE\5E94\7528\7A0B\5E8F\7684\201C\7BA1\7406\201D\90E8\5206\6267\884C\5E94\7528\7A0B\5E8F\7684\914D\7F6E\3002</li>'),
'</ul>',
unistr('<p>\7F16\8F91\73B0\6709\7528\6237\65F6, \60A8\53EF\4EE5\9501\5B9A\5176\5E10\6237, \8FD9\5C06\963B\6B62\8BE5\7528\6237\8BBF\95EE\5E94\7528\7A0B\5E8F\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong>   \5982\679C\4F7F\7528 Oracle Application Express \5E10\6237, \5219\5DE5\4F5C\533A\7BA1\7406\5458\8FD8\5FC5\987B\5C06\6B64\5904\8F93\5165\7684\7528\6237\5B9A\4E49\4E3A\6700\7EC8\7528\6237, \7BA1\7406\5458\4E5F\53EF\4EE5\8BBE\7F6E\5176\5BC6\7801\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863283458312218)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\62A5\8868\9875\663E\793A\9875\8FB9\680F\9009\62E9\5668\4E2D\7684\4E3B\8BB0\5F55\3002'),
unistr('  \9009\62E9\4E00\6761\8BB0\5F55\53EF\67E5\770B\5B9A\4E49\7684\4E3B\8BB0\5F55\548C\4EFB\4F55\8BE6\7EC6\4FE1\606F\8BB0\5F55\3002<br> '),
unistr('  \5355\51FB\7F16\8F91\56FE\6807 (<span class="fa fa-pencil-square-o" aria-hidden="true"></span>) \53EF\7F16\8F91\4E3B\8BB0\5F55\3002'),
unistr('  \5BF9\4E8E\8BE6\7EC6\4FE1\606F\8BB0\5F55, \5355\51FB\6BCF\884C\5F00\5934\7684\94C5\7B14\53EF\7F16\8F91\76F8\5E94\8BB0\5F55\3002</p>'),
unistr('<p>\8981\9650\5236\5728\9009\62E9\5668\4E2D\663E\793A\7684\6570\636E, \8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\3002</p>'),
'',
unistr('<p>\8981\6DFB\52A0\65B0\7684\4E3B\8BB0\5F55, \8BF7\5355\51FB\6B64\9875\9876\90E8\7684<strong>\521B\5EFA</strong>\3002'),
unistr('  \5BF9\4E8E\8BE6\7EC6\4FE1\606F\8BB0\5F55, \5355\51FB\8BE6\7EC6\4FE1\606F\533A\57DF\9876\90E8\7684\52A0\53F7\56FE\6807 (+) \53EF\6DFB\52A0\8BE6\7EC6\4FE1\606F\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB\6B64\9875\9876\90E8\7684<strong>\91CD\7F6E</strong>\53EF\5C06\6B64\9875\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E, \5E76\5220\9664\4EE5\524D\5B9A\4E49\7684\4EFB\4F55\641C\7D22\8BCD\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864327754312219)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864455021312219)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\9875\6027\80FD\548C\53D7\6B22\8FCE\7A0B\5EA6\7684\4EA4\4E92\5F0F\62A5\544A\3002\62A5\544A\6309\7167<strong>\52A0\6743\6027\80FD</strong>\6392\5E8F, \8BE5\503C\901A\8FC7\5C06\7528\65F6\4E2D\503C\4E0E\9875\8BBF\95EE\91CF\76F8\4E58\5F97\5230\3002</p>'),
unistr('<p>\5982\679C\9700\8981, \53EF\5728\9875\9876\90E8\9009\62E9\62A5\544A\65F6\95F4\8303\56F4 (\9ED8\8BA4\503C = 1 \5929)\3002<br>'),
unistr('\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864153813312219)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107864224429312219)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\6700\8FD1\9875\8BBF\95EE\91CF\7684\4EA4\4E92\5F0F\62A5\544A\3002</p>'),
unistr('<p>\5982\679C\9700\8981, \53EF\5728\9875\9876\90E8\9009\62E9\62A5\544A\65F6\95F4\8303\56F4 (\9ED8\8BA4\503C = 1 \5929)\3002<br>'),
unistr('\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863516388312218)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\4E8E\663E\793A\5E94\7528\7A0B\5E8F\7684\9ED8\8BA4\989C\8272\65B9\6848\3002</p>'),
unistr('<p>\5982\679C\9009\4E2D\4E86<strong>\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\4E3B\9898\6837\5F0F</strong>, \5219\6BCF\4E2A\6700\7EC8\7528\6237\5355\51FB\4E3B\9875\5DE6\4E0B\89D2\7684<em>\5B9A\5236</em>\94FE\63A5, \4ECE\53EF\7528\4E3B\9898\6837\5F0F\4E2D\9009\62E9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838127708312199)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5E38\8BBF\95EE\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107863820717312218)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\62A5\544A\548C\56FE\8868\53EF\67E5\770B\6307\5B9A\65F6\95F4\8303\56F4\5185\5177\6709\6700\591A\9875\8BBF\95EE\91CF\7684\7528\6237\3002</p>'),
unistr('<p>\9009\62E9\62A5\544A\65F6\95F4\8303\56F4 (\9ED8\8BA4\503C = 1 \5929) \5E76\5728\9875\9876\90E8\7684\62A5\544A\548C\56FE\8868\56FE\6807\4E4B\95F4\9009\62E9\3002</p>'),
unistr('<p>\5BF9\4E8E\4EA4\4E92\5F0F\62A5\544A, \4F7F\7528\641C\7D22\5B57\6BB5, \6216\8005\9009\62E9<strong>\7528\6237</strong>\5217\6807\9898\6765\9009\62E9\7279\5B9A\7528\6237\3002\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\6267\884C\591A\79CD\529F\80FD, \4F8B\5982\663E\793A/\9690\85CF\5217, \6BCF\9875\884C\6570, \7B5B\9009\5668\7B49\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854207644312211)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\7528\6237\6DFB\52A0\5230\8BBF\95EE\63A7\5236\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854378886312211)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6DFB\52A0\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852564504312210)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9875\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836105873312197)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854194556312211)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\96C6\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836473655312198)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836524397312198)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\5DF2\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854074460312211)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\8868\5355 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854757285312212)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\6587\4EF6 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853795684312211)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\65E5\5FD7\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853089565312210)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852429667312210)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\7528\6237\540D Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852114066312210)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 - \4FDD\5B58\4EA4\4E92\5F0F\7F51\683C\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853986164312211)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\8868\5355 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852916059312210)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5DF2\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836261571312197)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853131674312210)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\80FD\52A0\8F7D\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836375767312198)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56DE\590D\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107835917675312197)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852235840312210)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\62A5\8868\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836053144312197)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853896608312211)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\8BBF\95EE\63A7\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853554244312211)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853652096312211)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\914D\7F6E\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854608461312211)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852318166312210)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\7528\6237\540D Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854417046312211)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107854510359312211)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852687899312210)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 #MRD_COUNT# \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852753468312210)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5E94\7528\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107852835199312210)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0 #MRU_COUNT# \884C, \5DF2\63D2\5165 #MRI_COUNT# \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853444609312210)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\6700\7EC8\7528\6237\6837\5F0F\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107836602350312198)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\5E94\7528\7A0B\5E8F\5916\89C2\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853250267312210)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107853317715312210)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\5E94\7528\7A0B\5E8F\5916\89C2\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842962887312203)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842865181312203)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844660970312204)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843043365312203)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ACL \4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842679045312202)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833685243312196)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842409899312202)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844416803312204)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832780469312195)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841597136312201)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833597115312195)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842322771312202)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842749137312202)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833012316312195)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841992167312202)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25\7684\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842030868312202)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\7528\6237\66F4\6539\7684\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841850849312202)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5411\5BFC\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833355264312195)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\62A5\8868\7684\6700\5927\884C\6570\662F %0 \884C\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\60A8\7684\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833207144312195)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843466766312203)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844848341312204)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F02\5E38\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843106456312203)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833967729312196)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844146572312203)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845349543312204)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9879\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833182050312195)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E %0 \7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845261907312204)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\9879\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843636105312203)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\5C0F\65F6\9875\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841745030312202)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843501206312203)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843236285312203)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843942467312203)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\65B0\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844060410312203)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842193223312202)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844520717312204)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843706687312203)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\6D3B\8DC3\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833467138312195)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832948731312195)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842276821312202)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845010770312204)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\6709\6548\7528\6237 - \9875\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107845161850312204)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\6709\6548\7684\65B0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843809650312203)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\8FD1\7684\9519\8BEF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832875243312195)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\663E\793A\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833755187312196)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832667289312195)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844252378312204)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5E38\8BBF\95EE\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844388802312204)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\5C42\7528\6237\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107833873984312196)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6DFB\52A0\7684 %0 \4E2A\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107843388110312203)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\8BA1\6570\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107842588417312202)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844981112312204)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\6709\6548\7528\6237 - \9875\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107844772227312204)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5BFC\5BB9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841623732312202)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5BFC\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107862043745312217)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107859522196312215)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9E\8981\9000\51FA\6B64\9875\800C\4E0D\8FDB\884C\4FDD\5B58?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840116853312200)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \884C\5DF2\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841345473312201)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3\5C11\9700\8981\4E00\4E2A\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841459405312201)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\63D0\4F9B\53CD\9988\6216\60A8\7684\4F53\9A8C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841165266312201)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4ECE\7BA1\7406\5458\4E2D\5220\9664\81EA\5DF1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841231805312201)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\65E0\6CD5\5220\9664\81EA\5DF1\7684\7BA1\7406\5458\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840649381312201)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\662F\6709\6548\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840411275312201)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840516201312201)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840784639312201)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\662F\6709\6548\65F6\95F4\6233\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838724447312199)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5FC5\987B\662F\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840948353312201)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107840887337312201)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107841032452312201)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\65F6\95F4\6233\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838538677312199)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \975E\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838670546312199)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5FC5\987B\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107838897192312199)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5FC5\987B\662F\6709\6548\65F6\95F4\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756010921312924)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\52A8\6001\64CD\4F5C ''#COMPONENT_NAME#'' \6307\5B9A\7684\4EA4\4E92\5F0F\7F51\683C\5217 ''%0'' \4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756246571312924)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 ''%0'' \5728\6267\884C\884C\9501\5B9A\65F6\5F15\53D1\4E86 ''%1''\3002\5F53\5904\7406\5728\590D\6742\89C6\56FE\4E0A\4F7F\7528 instead-of \89E6\53D1\5668\53D1\51FA SELECT FOR UPDATE \7528\4E8E\9501\5B9A\884C\65F6, \4F1A\51FA\73B0\6B64\9519\8BEF\3002\8BF7\5C06\5904\7406\5C5E\6027 ''\9501\5B9A\884C'' \8BBE\7F6E\4E3A\201C\5426\201D\6216\201CPL/SQL \4EE3\7801\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756150933312924)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 ''%0'' \5728\6267\884C DML \547D\4EE4\65F6\5F15\53D1\4E86 ''%1''\3002\5F53\5217\57FA\4E8E\805A\96C6\6216 SQL \8868\8FBE\5F0F\65F6\4F1A\51FA\73B0\6B64\9519\8BEF\3002\8BF7\5C06\5217\5C5E\6027 ''\4EC5\67E5\8BE2'' \8BBE\7F6E\4E3A\201C\662F\201D\4EE5\4ECE INSERT \548C UPDATE \8BED\53E5\4E2D\6392\9664\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377856549312626)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\4ECE\5217 ''%0'' \4E0D\5305\542B\503C\3002\8BF7\786E\4FDD\5BF9\4E3B\533A\57DF\6267\884C\76F8\5E94\5904\7406\4E4B\540E\6267\884C ''%1'' \5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738351565312910)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\4EA4\4E92\5F0F\7F51\683C ''%0'' \7684\4E3B\5217, \800C\6B64\5217\662F\4E3B\4ECE\5173\7CFB\6240\5FC5\9700\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152738273312445)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\4EA4\4E92\5F0F\7F51\683C ''%0'' \7684\4E3B\952E\5217, \800C\6B64\5217\662F\7F16\8F91\6216\4E3B\4ECE\5173\7CFB\6240\5FC5\9700\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715775002312893)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\53EF\7F16\8F91\7684\4EA4\4E92\5F0F\7F51\683C, \9875\5C5E\6027 ''\63D0\4EA4\65F6\91CD\65B0\52A0\8F7D'' \5FC5\987B\8BBE\7F6E\4E3A ''\4EC5\6210\529F\65F6''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686708631312870)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE3\7801\7F16\8F91\5668: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686864583312871)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\53E0 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686967342312871)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272\9009\62E9\5668\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687047954312871)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\7EC4\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687122108312871)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\FF08\9519\8BEF\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687253688312871)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686646040312870)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687397786312871)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\7ED3\679C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687415373312871)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\7ED3\679C\3002\8BF7\5C1D\8BD5\5355\51FB\4E0A\9762\7684\201C\5168\90E8\663E\793A\201D\6309\94AE\6765\641C\7D22\6240\6709\5C5E\6027\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687564925312871)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\5C5E\6027')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687657024312871)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\FF08\65E0\6548\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687751625312871)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687862704312871)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108687929238312871)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\7EC4\4EF6\6CA1\6709\5171\540C\7684\5C5E\6027\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689177646312872)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\672A\9009\62E9\7EC4\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688023380312872)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688107497312872)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Pin \7B5B\9009\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688221703312872)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\901F\9009\53D6\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688376885312872)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688446739312872)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688571312312872)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688682320312872)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688717273312872)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' (\503C\662F\53D8\5316\7684)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688858233312872)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108688986028312872)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\FF08\8B66\544A\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689056429312872)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715822019312893)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\8868\683C\5F0F\8868\5355, \9875\5C5E\6027 ''\63D0\4EA4\65F6\91CD\65B0\52A0\8F7D'' \5FC5\987B\8BBE\7F6E\4E3A ''\59CB\7EC8''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495480748312722)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\9875\5305\542B\591A\4E2A\4EA4\4E92\5F0F\7F51\683C\FF0C\5FC5\987B\6307\5B9A\533A\57DF\9759\6001 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720666130312108)
,p_name=>'APEXIR_3D'
,p_message_language=>'zh-cn'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831128957312194)
,p_name=>'APEXIR_ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313361086312576)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970113326312300)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6\663E\793A\5728\6BCF\4E2A\63A7\5236\5206\6BB5\4E4B\540E\548C\62A5\8868\7684\7ED3\5C3E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886063319312235)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831586767312194)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713561479312891)
,p_name=>'APEXIR_AREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311173356312574)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED1\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831807282312194)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937713396312275)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745785211312916)
,p_name=>'APEXIR_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866080527312220)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\9009\5B9A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970477809312300)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\8981\6267\884C\6B64\5220\9664\64CD\4F5C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949403126312284)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720875937312108)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698532944312091)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\73AF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570107786311992)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720779448312108)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \4E0D\805A\96C6 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696786565312878)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\66FF\4EE3\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949394714312284)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970257621312300)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6267\884C\95EA\56DE\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300437761312565)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311286164312574)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7070\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698399425312091)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A, \5F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246222093312520)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\524D\7F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302211082312566)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5355\51FB<a href=''%0''>\6B64\5904</a>\4EE5\7BA1\7406\8BA2\9605\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971068422312300)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716448575312105)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \65B0\7C7B\522B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866162460312220)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\805A\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794259185312164)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5217\4FE1\606F\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866292051312220)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\8BA1\7B97\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745640406312916)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \65E0\7ED3\675F\65E5\671F -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799379453312964)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\9009\62E9\5176\4ED6\884C\5217\3002\884C\5217\4E2D\7684 HTML \8868\8FBE\5F0F\6216\94FE\63A5\5305\542B\5B9A\4E49\4E3A\900F\89C6\5217\6216\805A\96C6\5217\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831284783312194)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199967353312482)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\4E2D\7684\663E\793A\5217\6570\8FBE\5230\4E86\9650\5236\503C\3002\8BF7\5728\201C\64CD\4F5C\201D\83DC\5355\4E0B\5355\51FB\201C\9009\62E9\5217\201D\4EE5\6700\5C0F\5316\62A5\8868\663E\793A\5217\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805445733312173)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569462687311991)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\4E2D\7684\663E\793A\5217\6570\8FBE\5230\4E86\9650\5236\503C\3002\8BF7\5728\201C\64CD\4F5C\201D\83DC\5355\4E0B\5355\51FB\201C\9009\62E9\5217\201D\4EE5\6700\5C0F\5316\62A5\8868\663E\793A\5217\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107865934610312220)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53E6\5B58\4E3A\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698437143312091)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\7C7B\522B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971104524312300)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\5217\5C06\6DFB\52A0\524D\7F00 **\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745568189312916)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\6392\5E8F\5217 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970942553312300)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E00\4E2A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745458661312916)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300369837312565)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\5355\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970368876312300)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947668293312283)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\9898\5FC5\987B\552F\4E00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745863498312916)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566794886311989)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \7BA1\7406\670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697067821312879)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5E94\7528\7A0B\5E8F\914D\7F6E\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009325925312332)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\4E0B\6570\636E\5E93\5BF9\8C61\5C06%0\5230\6240\9009\65B9\6848\4E2D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009422532312332)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F%0\4EE5\4E0B\6570\636E\5E93\5BF9\8C61:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384532667312632)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384630824312632)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6EDA\52A8\5230\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572860788311994)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696692037312878)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164484240312454)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749849525312919)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\5BF9\7B49\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699921837312881)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\521B\5EFA\7684\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700123196312881)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8868\4E2D\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700375600312881)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319308881312580)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318626521312580)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5728 <strong>%0</strong> \65B9\6848\4E2D\521B\5EFA\8FD9\4E9B\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700466707312881)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\4E9B\5BF9\8C61\5DF2\5B58\5728\4E8E <strong>%0</strong> \65B9\6848\4E2D\5E76\7531\5176\4ED6\5DE5\4F5C\533A\4F7F\7528\3002\5982\679C\7EE7\7EED, \5219\7531 <strong>%0</strong> \62E5\6709\7684\73B0\6709 Websheet \5BF9\8C61\4E5F\5C06\4E0E\6B64\5DE5\4F5C\533A\76F8\5173\8054\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700558171312881)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\9009\62E9\8981\7528\4E8E\8FD9\4E9B\5BF9\8C61\7684\65B9\6848:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700692106312881)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F\7528\7684\73B0\6709\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701478337312882)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\901A\8FC7\4EE5\4E0B\4FE1\606F\91CD\7528 Websheet \6570\636E\5E93\5BF9\8C61\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318785805312580)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\66F4\613F\610F\5728\65B0\65B9\6848\4E2D\521B\5EFA Websheet \5BF9\8C61, \8BF7\4F7F\7528<a href=%0>\8BF7\6C42\6570\636E\5E93\65B9\6848</a>\5411\5BFC\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318854374312580)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\8FD0\884C Websheets, \9700\8981\4EE5\4E0B\5BF9\8C61:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318978547312580)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F7F\7528\4EE5\4E0B\4FE1\606F\521B\5EFA Websheet \6570\636E\5E93\5BF9\8C61\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319070427312580)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\521B\5EFA\7684\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319130082312580)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\5220\9664 Websheet \6570\636E\5E93\5BF9\8C61\3002\8FD9\5C06\5728\5DE5\4F5C\533A\4E2D\5220\9664 Websheet \6570\636E\5E93\5BF9\8C61\4EE5\53CA\5305\542B Websheet \7EC4\4EF6\7684\5185\90E8\6570\636E\3002\662F\5426\7EE7\7EED?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319461882312580)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\66F4\6B63\4EE5\4E0B\65E0\6548\5BF9\8C61\624D\80FD\6B63\5E38\8FD0\884C Websheets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700096326312881)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5373\5C06\5220\9664\6B64\5DE5\4F5C\533A\7684 Websheet \5B9A\4E49\3002Websheet \6570\636E\5E93\5BF9\8C61\540C\65F6\7531\5176\4ED6\5DE5\4F5C\533A\4F7F\7528, \56E0\6B64\4E0D\4F1A\5220\9664\3002\4E0E\6B64\5DE5\4F5C\533A\5173\8054\7684\8BB0\5F55\5C06\88AB\5220\9664\3002\662F\5426\7EE7\7EED?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319541410312580)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319671490312581)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319299313312580)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699888165312881)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F\7528\7684\73B0\6709\5BF9\8C61')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622129121312033)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622009631312033)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158277631312449)
,p_name=>'APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219205973312498)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6784\5EFA\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073998929312382)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076767400312384)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074077096312382)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005046362312329)
,p_name=>'APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139566619312434)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048129314312361)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086166634312392)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084264129312390)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5DF2\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566539042311989)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5F00\53D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085119697312391)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044963580312359)
,p_name=>'APPLICATION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7F16\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944882354312280)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID \662F\4FDD\7559\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944733194312280)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID \5FC5\987B\662F\6B63\6574\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359568612312612)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114245206312414)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648056244312053)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616929972312029)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086064930312392)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749496850312919)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195925046312479)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8986\76D6 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083723985312390)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749396181312919)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723400143312110)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083996464312390)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159890431312450)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581629632312002)
,p_name=>'APPLICATION_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032509480312349)
,p_name=>'APPROVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6279\51C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090314970312396)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751973934312921)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614837751312028)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614977769312028)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\4EA7\529B\6216\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111188254312412)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B Websheet')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614749661312027)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032031009312349)
,p_name=>'ARCHIVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5F52\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617255068312029)
,p_name=>'ARCHIVELOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7\5F52\6863: \6253\5F00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868120117312222)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\5FC5\987B\5177\6709\6821\9A8C\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955748106312289)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955910841312289)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\7C7B\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026260782312344)
,p_name=>'ASAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C3D\5FEB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023517575312342)
,p_name=>'ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721087865312108)
,p_name=>'ASSIGNEE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\4EBA\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771618729312936)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777027647312151)
,p_name=>'ASSOCIATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\8054\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722690801312110)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\8054\7684\529F\80FD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053349721312365)
,p_name=>'ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779454775312942)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\98CE\9669')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748525864312129)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\7684\5B9A\5236\9A8C\8BC1\9009\9879\5C06\88AB\8FC1\79FB\5230\9A8C\8BC1\65B9\6848\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748079861312129)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9A8C\8BC1\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748401182312129)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748136087312129)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748391500312129)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748284555312129)
,p_name=>'AUTH.NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753510551312133)
,p_name=>'AUTHENTICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074987535312383)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074622333312383)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768574850312145)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\5220\9664\5E94\7528\7A0B\5E8F %0 \4E2D\7684\9A8C\8BC1\65B9\6848\3002\5982\679C\6B64\5E94\7528\7A0B\5E8F\5F53\524D\672A\4F7F\7528 SCHEME \9A8C\8BC1\6216\5982\679C\65B9\6848\4E0D\662F\5F53\524D\9A8C\8BC1\65B9\6848, \5219\5220\9664\8BE5\65B9\6848\4E0D\4F1A\5BF9\6B64\5E94\7528\7A0B\5E8F\7684\64CD\4F5C\9020\6210\5F71\54CD\3002\5982\679C\6B64\5E94\7528\7A0B\5E8F\4F7F\7528 SCHEME \9A8C\8BC1, \5E76\4E14\8BE5\65B9\6848\662F\5F53\524D\9A8C\8BC1\65B9\6848, \5219\6B64\5E94\7528\7A0B\5E8F\5C06\7EE7\7EED\4F7F\7528 SCHEME \9A8C\8BC1\8FD0\884C, \4F46\662F\7528\9ED8\8BA4\9A8C\8BC1\65B9\6848\8FD0\884C\3002\6B64\64CD\4F5C\5C06\4F7F\7528\5E26\6709 "\5F00\95E8" \8EAB\4EFD\8BC1\660E\9A8C\8BC1 (\5373\5141\8BB8\4EFB\4F55\4EBA\8FD0\884C\6B64\5E94\7528\7A0B\5E8F) \7684\5185\7F6E\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770541805312146)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\8BBE\4E3A\5F53\524D\201D\6309\94AE\53EF\4F7F\5E94\7528\7A0B\5E8F\4F7F\7528\6B64\9A8C\8BC1\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246595187312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \5E10\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563189485311986)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246620945312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246951766312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246799152312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E10\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508360094312732)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP \6807\5934\53D8\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247164675312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246894102312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \76EE\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247038610312520)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\95E8\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541000465311969)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SAML \767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591667586312010)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793E\4EA4\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115291527312415)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074556827312383)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563204884311986)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581822195312002)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581916064312002)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937468284312275)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\89D2\8272\6216\7EC4\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937518998312275)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\89D2\8272\6216\7EC4\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582052346312002)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9879\503C\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582102499312002)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \7684\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582251980312002)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \7684\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582368501312003)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9879\503C\4E0D\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582483516312003)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582543862312003)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9996\9009\9879\503C\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107582653540312003)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9996\9009\9879\503C\4E0D\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633708391312042)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\6B21\9875\8BBF\95EE\6C42\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633898543312042)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\4F1A\8BDD\6C42\503C\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585556843312005)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237\5DF2\5931\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585452603312005)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585835545312005)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D85\8FC7\4E86\6700\5927\767B\5F55\5C1D\8BD5\6B21\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585971268312005)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\7684\5185\90E8\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585772912312005)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\6B21\4F7F\7528\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585646643312005)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\4E0D\6B63\786E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585209636312005)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38, \6210\529F\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585382596312005)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\7684\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680144949312077)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\7684\5DE5\4F5C\533A\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690298137312085)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\7684\5DE5\4F5C\533A\540D\79F0: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811232795312178)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\8BED\53E5\4E0D\9002\7528\3002\6240\6709\8BED\53E5\90FD\81EA\52A8\63D0\4EA4\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509348435312733)
,p_name=>'AUTOMATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509411151312733)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\64CD\4F5C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140199013312435)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\914D\6A21\5F0F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560726159311985)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A\9879')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161687117312452)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7528\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589971525312008)
,p_name=>'AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296570724312562)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\53EF\7528\4E8E\5F00\53D1\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296433542312562)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7\5F00\53D1\8005\5DE5\5177\680F\53EF\7528')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048972299312362)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\5448\73B0\65F6\95F4 (\79D2)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030456062312348)
,p_name=>'BAR_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348282217312603)
,p_name=>'BASIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603872209312019)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\672C\5F00\53D1\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011882521312334)
,p_name=>'BEFORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754749267312923)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5217\8868\6761\76EE\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770737722312936)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A\4E4B\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077838578312385)
,p_name=>'BIND_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED1\5B9A\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077268888312385)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED1\5B9A\53D8\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077337222312385)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED1\5B9A\53D8\91CF\6807\7B7E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091809321312397)
,p_name=>'BLACK_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED1\8272\6587\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567145931311990)
,p_name=>'BLANK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\767D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052557308312365)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197642271312481)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615834332312028)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198002116312481)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197727852312481)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197882101312481)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197981585312481)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053518662312365)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053088303312365)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0\7684 BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052434081312365)
,p_name=>'BLOB_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091769378312397)
,p_name=>'BLUE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5170\8272\6587\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068947920312378)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637501767312045)
,p_name=>'BRANCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832075256312194)
,p_name=>'BREADCRUMB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012588313312335)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012628226312335)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\957F\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832143397312194)
,p_name=>'BREADCRUMBS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100612135312404)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114442201312414)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945192633312281)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020047100312340)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694118190312088)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\9762\5305\5C51\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015117151312336)
,p_name=>'BROWSE_ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\6D4F\89C8\201D\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014951805312336)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5305')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955570476312289)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546837523311974)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543173507311971)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591400075312010)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5907\4EFD\5E94\7528\7A0B\5E8F\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543209661311971)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543444268311971)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591143234312009)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4ECE\4FEE\8BA2 %1 \8FD8\539F\5E94\7528\7A0B\5E8F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543026089311971)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353931932312608)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5C5E\6027\FF1A\5DF2\4FEE\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097241062312401)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544152511311972)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544228661311972)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545861576311973)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545985137311973)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543339895311971)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546119415311973)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546097489311973)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097099011312401)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508211004312732)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508144275312732)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FEE\6539 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508068860312732)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\65B0\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544529053311972)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551024863311977)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547312506311974)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555284749311980)
,p_name=>'BU.DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555317424311980)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544765406311972)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591570453312010)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FDB\884C\5E94\7528\7A0B\5E8F\5907\4EFD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546414880311973)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097487156312401)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\5907\4EFD\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096974349312401)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543581521311971)
,p_name=>'BU.LISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546382780311973)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591273054312009)
,p_name=>'BU.LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543850166311971)
,p_name=>'BU.LOVS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546710257311974)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LOV \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550934177311977)
,p_name=>'BU.MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555165362311980)
,p_name=>'BU.MODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FEE\6539 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544011154311972)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097103386312401)
,p_name=>'BU.NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA %0 \9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545726476311973)
,p_name=>'BU.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507999208312732)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507835286312732)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FEE\6539 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507781039312732)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\65B0\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543910366311972)
,p_name=>'BU.PLUGINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546246351311973)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551206336311977)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547122374311974)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546666903311974)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052202201312364)
,p_name=>'BU.RESTORED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F\7684\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581511458312002)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4ECE\5907\4EFD\4FEE\8BA2 %0 \8FD8\539F\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545216497311973)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547069821311974)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544628856311972)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544988737311972)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5E94\7528\7A0B\5E8F\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545062235311972)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5DE5\4F5C\533A\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588449392312007)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\6982\8981\4E0D\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546541688311974)
,p_name=>'BU.TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545175809311972)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543750861311971)
,p_name=>'BU.THEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107546942698311974)
,p_name=>'BU.TREES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591324173312010)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107543610862311971)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\5C5E\6027')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107544322426311972)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547268212311974)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551182685311977)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571023599311993)
,p_name=>'BUFFER CACHE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F13\51B2\533A\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026755665312345)
,p_name=>'BUG'
,p_message_language=>'zh-cn'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050012173312363)
,p_name=>'BUGS'
,p_message_language=>'zh-cn'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071454064312380)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5206\914D Bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108606445312410)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5206\914D Bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599698568312016)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5173\95ED Bug (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377171056312626)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5173\95ED Bug \767E\5206\6BD4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108738644312410)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5206\914D Bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108830726312410)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4FEE\590D\5B8C\6210\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377573194312626)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Bug: %1 \4E2A\5DF2\5173\95ED, \5171 %0 \4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776071444312940)
,p_name=>'BUG_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>'Bug: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065127396312375)
,p_name=>'BUILD QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EFA\7ACB\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554977887311980)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554894362311980)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554720840311980)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555037208311980)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554629408311980)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159258399312450)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156667958312448)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\4E0D\652F\6301]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355998912312609)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760711149312139)
,p_name=>'BUILD_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206276090312488)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774747216312939)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\72B6\6001: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207028098312488)
,p_name=>'BUILD_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102589142312405)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\5728\62A5\8868\6A21\677F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011156593312334)
,p_name=>'BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199372501312482)
,p_name=>'BUTTON.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579208787312000)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\6309\94AE\7684\6309\94AE\5C5E\6027\4E0D\80FD\5305\542B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579153842312000)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\6309\94AE\7684\64CD\4F5C\5FC5\987B\8BBE\7F6E\4E3A ''\7531\52A8\6001\64CD\4F5C\5B9A\4E49''')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579376730312000)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\6309\94AE\4F7F\7528\7684 ''\6309\94AE\6A21\677F'' \672A\5305\542B #BUTTON_ID# \66FF\6362\5B57\7B26\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199155203312482)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637794935312045)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616451592312029)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\62A5\8868\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614580010312027)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9664\975E\201C\6309\94AE\8BF7\6C42\6E90\7C7B\578B\201D\4E3A "\603B\4E3A\7A7A\503C", \5426\5219\5FC5\987B\4E3A\6240\6709\201C\6309\94AE\8BF7\6C42\6E90\7C7B\578B\201D\6307\5B9A\201C\6309\94AE\8BF7\6C42\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615292777312028)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\6309\94AE\8BF7\6C42\6E90\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637894636312045)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A URL \76EE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581225307312002)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\64CD\4F5C\4E3A ''\7531\52A8\6001\64CD\4F5C\5B9A\4E49'' \65F6, \6309\94AE\5C5E\6027\4E0D\80FD\5305\542B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638919097312046)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639061673312046)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638844378312046)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581154675312002)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\6309\94AE\6837\5F0F\4E3A ''\57FA\4E8E\6A21\677F\7684\6309\94AE'' \4E14\64CD\4F5C\4E3A ''\7531\52A8\6001\64CD\4F5C\5B9A\4E49'' \65F6, \6240\9009\6309\94AE\6A21\677F\5FC5\987B\5305\542B #BUTTON_ID# \66FF\6362\5B57\7B26\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107569053379311991)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\6309\94AE, \56E0\4E3A\5728\52A8\6001\64CD\4F5C (\9875: %0, \52A8\6001\64CD\4F5C: ''%1'', \64CD\4F5C: ''%2'', \5C5E\6027: ''\53D7\5F71\54CD\7684\5143\7D20'') \4E2D\5F15\7528\4E86\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568928690311991)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\6309\94AE, \56E0\4E3A\5728\52A8\6001\64CD\4F5C (\9875: %0, \52A8\6001\64CD\4F5C: ''%1'', \5C5E\6027: ''\65F6\95F4'') \4E2D\5F15\7528\4E86\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199286952312482)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195442042312479)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\5728 "onclick" \5C5E\6027\4E2D\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198633618312481)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\5728 "href" \5C5E\6027\4E2D\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637612944312045)
,p_name=>'BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078277962312385)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774590733312939)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082559157312389)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634928158312043)
,p_name=>'BYTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\8282')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026380749312344)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7\4E0B\4E00\4E2A\8865\4E01\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026451210312344)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7\4E0B\4E00\4E2A\53D1\884C\7248')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849153097313003)
,p_name=>'CA.ABOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815489155312977)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5173\4E8E\201D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815367699312977)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5305\542B\201C\5173\4E8E\6B64\5E94\7528\7A0B\5E8F\201D\9875\FF0C\5176\4E2D\63D0\4F9B\5E94\7528\7A0B\5E8F\7684\63CF\8FF0\3001\5E94\7528\7A0B\5E8F\7248\672C\548C\9875\8BA1\6570\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738351065312121)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\5BB9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849308461313003)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5173\4E8E\201D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849468868313004)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\5173\6B64\5E94\7528\7A0B\5E8F\7684\6587\672C\53EF\4EE5\653E\7F6E\5728\6B64\5904\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849032076313003)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E\6B64\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860283372313012)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E\6B64\9884\89C8\53D1\884C\7248')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698252710312091)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4ECE\7BA1\7406\5458\4E2D\5220\9664\81EA\5DF1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698160881312091)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\65E0\6CD5\5220\9664\81EA\5DF1\7684\7BA1\7406\5458\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815753008312977)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851623193313005)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841110038312997)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814141530312976)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\57FA\4E8E\89D2\8272\7684\7528\6237\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815878652312977)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\5E94\7528\7A0B\5E8F\4E2D\52A0\5165\57FA\4E8E\89D2\8272\7684\7528\6237\9A8C\8BC1\3002'),
unistr('\7528\6237\53EF\4EE5\5B9A\4E49\4E3A\7BA1\7406\5458, \5185\5BB9\63D0\4F9B\8005\6216\8BFB\8005\3002'),
unistr('\7136\540E, \60A8\53EF\4EE5\76F4\63A5\5C06\5E94\7528\7A0B\5E8F\4E2D\5404\7EC4\4EF6 (\4F8B\5982\9875, \83DC\5355\6761\76EE, \533A\57DF, \5217, \9879, \6309\94AE\7B49) \7684\4E0D\540C\8BBF\95EE\6743\9650\5B9A\4E49\5230\4E0D\540C\89D2\8272\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\7BA1\7406\9875\533A\57DF, \5E26\6709\8BBF\95EE\63A7\5236\529F\80FD\7684\94FE\63A5</li>'),
unistr('<li>\7528\6237\8868, \7528\4E8E\7BA1\7406\8BBF\95EE\63A7\5236</li>'),
unistr('<li>\914D\7F6E\9875, \7528\4E8E\8BBE\7F6E\5DF2\9A8C\8BC1\7528\6237\7684\8BBF\95EE\7EA7\522B</li>'),
unistr('<li>\914D\7F6E\9875, \7528\4E8E\6307\5B9A\7528\6237\540D\662F\5426\4E3A\7535\5B50\90AE\4EF6\5730\5740</li>'),
unistr('<li>\7BA1\7406\7528\6237\8BBF\95EE\9875, \7528\4E8E\62A5\544A\548C\7F16\8F91\7528\6237\8BBF\95EE\6743\9650</li>'),
unistr('<li>\6DFB\52A0\7528\6237\9875, \80FD\591F\6DFB\52A0\5355\4E2A\7528\6237</li>'),
unistr('<li>\6DFB\52A0\591A\4E2A\7528\6237\9875, \80FD\591F\6DFB\52A0\591A\4E2A\7528\6237 (\4EC5\9650\7535\5B50\90AE\4EF6\7528\6237\540D)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840052306312996)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840767414312997)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\89D2\8272 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669835317312069)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840189313312996)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697755665312091)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851411786313005)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ACL \4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852135861313006)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650\4E0D\8DB3, \7528\6237\4E0D\662F\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852266442313006)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\65E0\6743\67E5\770B\6B64\5E94\7528\7A0B\5E8F, \53EF\80FD\662F\56E0\4E3A\672A\6388\4E88\8BBF\95EE\6743\9650, \6216\8005\60A8\7684\5E10\6237\5DF2\9501\5B9A\3002\8BF7\4E0E\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852396605313006)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650\4E0D\8DB3, \7528\6237\4E0D\662F\5185\5BB9\63D0\4F9B\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841881669312998)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\8BBF\95EE\63A7\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846589144313001)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\6309\94AE HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845429580313000)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845554223313001)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848188549313003)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\94FE\63A5 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833604923312991)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5DF2\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839144357312995)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5C0F\65F6\7EDF\8BA1\7684\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872331645313021)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815934720312977)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815164393312977)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\7528\6237\6D3B\52A8\548C\9519\8BEF\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816032680312977)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5305\542B\6709\5173\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\6D3B\52A8\7684\8BB8\591A\62A5\8868\3002\786E\5B9A\6700\6D3B\8DC3\7684\7528\6237\3001\4F7F\7528\6700\591A\7684\9875\3001\9875\6027\80FD\548C\5F15\53D1\7684\9519\8BEF\FF0C\4EE5\66F4\597D\5730\7406\89E3\5982\4F55\5229\7528\60A8\7684\5E94\7528\7A0B\5E8F\4EE5\53CA\6539\8FDB\65B9\9762\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6\FF1A'),
'<ul>',
unistr('<li>\6700\5E38\8BBF\95EE\7684\7528\6237\62A5\8868</li>'),
unistr('<li>\5E94\7528\7A0B\5E8F\9519\8BEF\65E5\5FD7\62A5\8868</li>'),
unistr('<li>\6309\9875\7EDF\8BA1\7684\9875\6027\80FD\3001\6D3B\52A8\548C\6027\80FD</li>'),
unistr('<li>\6309\9875\7EDF\8BA1\7684\5E94\7528\7A0B\5E8F\6D3B\52A8\62A5\8868</li>'),
unistr('<li>\9875\8BBF\95EE\91CF\8BE6\7EC6\4FE1\606F\62A5\8868</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062108561312373)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\9645\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851388219313005)
,p_name=>'CA.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846730313313001)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863213456313014)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237 - \6B65\9AA4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849642939313004)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\65B0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832666005312990)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738298958312910)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840851981312997)
,p_name=>'CA.ADD.USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863690312313014)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817512060312978)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\6DFB\52A0\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818075539312979)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB<strong>\6DFB\52A0\9875</strong>\53EF\5C06\9875\6DFB\52A0\5230\5E94\7528\7A0B\5E8F\3002\7136\540E\FF0C\9009\62E9\9875\7C7B\578B\FF08\4F8B\5982\7A7A\767D\3001\56FE\8868\3001\8868\5355\3001\62A5\8868\7B49\FF09\5E76\5B9A\4E49\5176\5C5E\6027\3002\8FD8\53EF\80FD\9700\8981\6307\5B9A\6709\6548\7684\8868\6216\89C6\56FE\FF0C\6216\8005\4F7F\7528 SQL \5DE5\4F5C\5BA4\5728\5DE5\4F5C\533A\4E2D\51C6\5907\6570\636E\5E93\5BF9\8C61\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847597379313002)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061424097312372)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\52A0\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840514630312997)
,p_name=>'CA.ADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820735958312981)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821373090312981)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\6B64\5E94\7528\7A0B\5E8F\7684\5DF2\9A8C\8BC1\7528\6237\7684\8BBF\95EE\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819811832312980)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820886223312981)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822519296312982)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821238658312981)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094607741312399)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194296916312478)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856133948313009)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856227555313009)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819476566312980)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819555832312980)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\9ED8\8BA4\5E94\7528\7A0B\5E8F\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819194043312980)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819056979312980)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\6216\7981\7528\5E94\7528\7A0B\5E8F\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820126223312981)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9519\8BEF\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820242252312981)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\544A\6B64\5E94\7528\7A0B\5E8F\8BB0\5F55\7684\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819651923312980)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819748087312980)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5E94\7528\7A0B\5E8F\540D\79F0\548C\7B80\8981\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819227927312980)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819387163312980)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\5E94\7528\7A0B\5E8F\66F4\65B0\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818779309312979)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821104625312981)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D21\732E\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871131030313020)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871012522313020)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\5E94\7528\7A0B\5E8F\6D3B\52A8\5EA6\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824250660312984)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\65F6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824307456312984)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\6B64\5E94\7528\7A0B\5E8F\7684\9ED8\8BA4\65F6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822089428312982)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824465453312984)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824534381312984)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\662F\5426\5E94\53D1\9001\7535\5B50\90AE\4EF6, \5982\679C\53D1\9001, \5E94\56DE\590D\7ED9\8C01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821575001312982)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821839049312982)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821917133312982)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\662F\5426\5E94\5141\8BB8\9644\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821655741312982)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821752032312982)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\544A\5E94\7528\7A0B\5E8F\7528\6237\63D0\4EA4\7684\6240\6709\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822186492312982)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822216476312982)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\6B64\5E94\7528\7A0B\5E8F\4F7F\7528\7684\7535\5B50\90AE\4EF6\6A21\677F HTML \548C CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818845598312980)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818943226312980)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9875\4E0A\663E\793A\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856898833313009)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738979278312911)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739072802312911)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\8BE5\5E94\7528\7A0B\5E8F\8BB0\5F55\7684\81EA\52A8\5316\6267\884C\548C\6D88\606F\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820347507312981)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820427609312981)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5E94\7528\7A0B\5E8F\9875\62A5\544A\6D3B\52A8\548C\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820501421312981)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820665781312981)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\7528\6237\62A5\544A\6BCF\6B21\9875\8BBF\95EE\FF0C\5305\62EC\8BBF\95EE\65F6\95F4\548C\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821094867312981)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BFB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864371963313015)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864433654313015)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\6B64\5E94\7528\7A0B\5E8F\53D1\9001\57FA\4E8E\6A21\677F\7684\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108819988691312980)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5E38\8BBF\95EE\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820069974312980)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\7528\6237\6C47\603B\7684\9875\8BBF\95EE\91CF\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108820929495312981)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108821417895312982)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8BBF\95EE\63A7\5236\8BBE\7F6E\548C\7981\7528\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822349575312982)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822492087312982)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6B64\5E94\7528\7A0B\5E8F\53D1\9001\7684\7535\5B50\90AE\4EF6\7684\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829935732312193)
,p_name=>'CA.ADVANCED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\9AD8\7EA7</strong> - \5C55\5F00\53EF\67E5\770B\9AD8\7EA7\9009\9879\3002'),
'    <ul>',
unistr('      <li><strong>\8BBE\7F6E\4E3A\4E3B\9875</strong> - \4F7F\6B64\9875\6210\4E3A\5E94\7528\7A0B\5E8F\7684\4E3B\9875\3002<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\5C06\66F4\65B0\4EE5\524D\5B9A\4E49\4E3A\4E3B\9875\7684\4EFB\610F\9875\3002</li>'),
unistr('      <li><strong>\8BBE\7F6E\4E3A\7BA1\7406\9875</strong> - \5728\201C\7BA1\7406\201D\4E0B\65B9\6DFB\52A0\6B64\9875\FF0C\800C\4E0D\662F\4F5C\4E3A\5E94\7528\7A0B\5E8F\4E2D\7684\6B63\5E38\9875\3002\53EF\901A\8FC7\5355\51FB\4E3B\83DC\5355\4E2D\7684\201C\7BA1\7406\201D\FF0C\7136\540E\4ECE\201C\5E94\7528\7A0B\5E8F\7BA1\7406\201D\5217\8868\4E2D\9009\62E9\6765\8FDB\884C\8BBF\95EE\3002<br>'),
unistr('        <em><strong>\6CE8\FF1A</strong>\67D0\9875\4E0D\80FD\540C\65F6\4E3A\4E3B\9875\548C\201C\7BA1\7406\201D\4E0B\65B9\7684\9875\3002</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>\9875\5E2E\52A9</strong> - \8F93\5165\8981\6DFB\52A0\5230\9875\7684\201C\5E2E\52A9\6587\672C\201D\4E2D\7684\6587\672C\3002</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717014728312105)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\9AD8\7EA7</strong> - \5C55\5F00\4EE5\67E5\770B\9AD8\7EA7\9009\9879\3002'),
'    <ul>',
unistr('      <li><strong>\9875\5E2E\52A9</strong> - \8F93\5165\8981\6DFB\52A0\5230\9875\201C\5E2E\52A9\6587\672C\201D\7684\6587\672C\3002</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857271181313010)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857396166313010)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8BBE\7F6E\5176\4ED6\5B9A\4E49, \5B89\5168\548C\5168\7403\5316\8BBE\7F6E\3002\53EF\5728\521B\5EFA\5E94\7528\7A0B\5E8F\65F6\5E94\7528\8FD9\4E9B\8BBE\7F6E, \8FD8\53EF\5728\521B\5EFA\5E94\7528\7A0B\5E8F\540E\7F16\8F91\8FD9\4E9B\8BBE\7F6E\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859297080313011)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\9605\8BFB\6BCF\4E2A\8BBE\7F6E\7684\9879\5E2E\52A9 (<span class="fa fa-question-circle" aria-hidden="true"></span>)\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865025005313015)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846465404313001)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\540E HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849546058313004)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845650285313001)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\9009\62E9\9000\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055092558312367)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\5728\53D7\9650\6A21\5F0F\4E0B\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839077554312995)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9519\8BEF\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834974566312992)
,p_name=>'CA.APP.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105063902312407)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\8FD8\662F\7981\7528\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105142444312407)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\4E0D\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\7684\7528\6237\FF0C\5728\901A\8FC7\9A8C\8BC1\540E\5411\5176\6307\5B9A\7684\9ED8\8BA4\8BBF\95EE\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835341082312993)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\5E94\7528\7A0B\5E8F\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835147659312992)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\8981\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835285508312992)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5904\8F93\5165\7684\6587\672C\663E\793A\5728\5E94\7528\7A0B\5E8F\4E3B\9875\4E0A\7684\5E94\7528\7A0B\5E8F\540D\79F0\4E0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824639784312984)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824722999312984)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5B9A\4E49\9ED8\8BA4\5E94\7528\7A0B\5E8F\989C\8272\65B9\6848 (\4E3B\9898\6837\5F0F, \5176\4E2D\786E\5B9A\4E86\5BFC\822A) \4EE5\53CA\7528\4E8E\5E94\7528\7A0B\5E8F\7684\56FE\6807\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844195358312999)
,p_name=>'CA.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831207606312989)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825252850312985)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825380115312985)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB<strong>\9009\62E9\65B0\56FE\6807</strong>\53EF\9009\62E9\56FE\6807\989C\8272\548C\53EF\7528\56FE\6807\4E4B\4E00\3002\6240\505A\9009\62E9\5C06\663E\793A\5728\5E94\7528\7A0B\5E8F\7684\4E3B\9875\4E0A\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825619144312985)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825734587312985)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\5E94\7528\7A0B\5E8F\552F\4E00\7684\6570\5B57\6807\8BC6\7B26\3002\9ED8\8BA4\60C5\51B5\4E0B\6B64\5B57\6BB5\5305\542B\81EA\52A8\751F\6210\7684\6807\8BC6\7B26\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844735808313000)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836919483312994)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815522842312977)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814481679312976)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5E94\7528\7A0B\5E8F\540D\79F0\548C\7B80\8981\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815627208312977)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\5E94\7528\7A0B\5E8F\7BA1\7406\5458\66F4\65B0\5404\79CD\8BBE\7F6E, \4F8B\5982\5E94\7528\7A0B\5E8F\540D\79F0\548C\8BF4\660E, \9ED8\8BA4\65F6\533A\7B49\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\7BA1\7406\9875\5217\8868\6761\76EE\548C\8868\5355</li>'),
unistr('<li>\80FD\591F\8BBE\7F6E\5E94\7528\7A0B\5E8F\540D\79F0</li>'),
unistr('<li>\80FD\591F\8BBE\7F6E\4E3B\9875\4E3B\89C6\89C9\533A\57DF\5B50\6807\9898</li>'),
unistr('<li>\80FD\591F\8BBE\7F6E\53CD\9988\6536\4EF6\4EBA (\4F7F\7528\53CD\9988\65F6)</li>'),
unistr('<li>\80FD\591F\8BBE\7F6E\5E94\7528\7A0B\5E8F\9ED8\8BA4\65F6\533A</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870105661313019)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871910733313021)
,p_name=>'CA.APPLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873739026313022)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5E94\7528\5E94\7528\7A0B\5E8F\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830409064312989)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871734626313020)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192398386312476)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\521B\5EFA\5E94\7528\7A0B\5E8F\5411\5BFC %0 \521B\5EFA\7684\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193666122312477)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875900250313023)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931801809312271)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876045007313023)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931782267312271)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872067580313021)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4E3A\6B64 %0 \5B9A\4E49\4E86\5C5E\6027\9ED8\8BA4\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841208264312997)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\4F55\5DF2\9A8C\8BC1\7528\6237\90FD\53EF\4EE5\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826420154312986)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826517999312986)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\9009\62E9\7528\6237\9A8C\8BC1\5230\5E94\7528\7A0B\5E8F\7684\65B9\5F0F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057714501312369)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739653593312911)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837678355312994)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102391336312405)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\4F5C\4E1A\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932541600312271)
,p_name=>'CA.BCC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864988673313015)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846348251313001)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\524D HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847879790313002)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\524D\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823103139312983)
,p_name=>'CA.BLANK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7A7A\767D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823230511312983)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\7A7A\767D\9875\4F5C\4E3A\5360\4F4D\7B26\3002\5728\521B\5EFA\5E94\7528\7A0B\5E8F\4E4B\540E\FF0C\53EF\4EE5\4ECE\9875\8BBE\8BA1\5668\76F4\63A5\5728\9875\4E0A\521B\5EFA\533A\57DF\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('<!--  <li><strong>\5305\62EC\9875\5BFC\822A</strong> - \9009\4E2D\6B64\9009\9879\53EF\663E\793A\5728\5E94\7528\7A0B\5E8F\4E2D\5B9A\4E49\7684\6240\6709\5176\4ED6\9875\7684\5361\7247\5217\8868\3002<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\6B64\9009\9879\901A\5E38\5728\5E94\7528\7A0B\5E8F\4E3B\9875\4E0A\4F7F\7528\3002</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856576313313009)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\84DD\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856689254313009)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\84DD\56FE\4EE5 JSON \683C\5F0F\5217\51FA\5E94\7528\7A0B\5E8F\5B9A\4E49\3002</p>'),
unistr('<p>\5F53\9996\6B21\8FDB\5165\6B64\5C4F\5E55\65F6, \5F53\524D\5E94\7528\7A0B\5E8F\5B9A\4E49\4F1A\8F6C\6362\4E3A JSON \6587\6863\5E76\663E\793A\3002\60A8\53EF\4EE5\7F16\8F91\6B64\6587\6863\4EE5\66F4\65B0\5E94\7528\7A0B\5E8F\5C5E\6027, \7136\540E\5355\51FB<strong>\5E94\7528\84DD\56FE</strong>\4EE5\66F4\6539\5F53\524D\5E94\7528\7A0B\5E8F\8BE6\7EC6\4FE1\606F\3002</p>'),
'<p>&nbsp;</p>',
unistr('<p>\5982\679C\60A8\9700\8981\521B\5EFA\5927\91CF\7684\7C7B\4F3C\9875, \53EF\590D\5236\4E00\9875\7684\76F8\5173 JSON \4EE3\7801, \591A\6B21\7C98\8D34\5E76\5BF9 JSON \7A0D\505A\8C03\6574, \8FD9\79CD\65B9\6CD5\8981\6BD4\9488\5BF9\6BCF\4E00\9875\624B\52A8\4F7F\7528<strong>\6DFB\52A0\9875</strong>\5FEB\5F97\591A\3002</p>'),
unistr('<p>\5355\51FB<strong>\52A0\8F7D\4EE5\524D\7684\84DD\56FE</strong>\53EF\5C06\84DD\56FE\66FF\6362\4E3A\4EE5\524D\6240\751F\6210\5E94\7528\7A0B\5E8F\4E2D\7684\5B9A\4E49\3002\8FD9\6837, \60A8\53EF\4EE5\975E\5E38\8F7B\677E\5730\8FED\4EE3\5E94\7528\7A0B\5E8F\8BBE\8BA1, \65B9\6CD5\662F\6DFB\52A0\5176\4ED6\9875, \66F4\6539\529F\80FD, \6216\8C03\6574\8BBE\7F6E, \7136\540E\518D\91CD\65B0\751F\6210\5E94\7528\7A0B\5E8F\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845262147313000)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587 1 \6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845380196313000)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587 2 \6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865322905313016)
,p_name=>'CA.BOTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831654068312990)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\7BA1\7406\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828540297312192)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831397383312989)
,p_name=>'CA.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823890491312984)
,p_name=>'CA.CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\65E5\5386\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823923677312984)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\65E5\5386\7684\9875\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\8868\6216\89C6\56FE</strong>\FF08\5FC5\9700\FF09- \4E3A\65E5\5386\9009\62E9\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('  <li><strong>\663E\793A\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\5728\65E5\5386\4E8B\4EF6\4E2D\663E\793A\7684\5217\3002</li>'),
unistr('  <li><strong>\5F00\59CB\65E5\671F\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\65E5\5386\4E8B\4EF6\5F00\59CB\65E5\671F\7684\65E5\671F\5217\3002</li>'),
unistr('  <li><strong>\7ED3\675F\65E5\671F\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\65E5\5386\4E8B\4EF6\7ED3\675F\65E5\671F\7684\65E5\671F\5217\3002<br>'),
unistr('      &nbsp;&nbsp;&nbsp;\5982\679C\6307\5B9A\4E86\7ED3\675F\65E5\671F\FF0C\5219\5C06\663E\793A\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6\3002</li>'),
unistr('  <li><strong>\663E\793A\65F6\95F4</strong> - \9009\62E9<strong>\662F</strong>\53EF\663E\793A\4E8B\4EF6\7684\65F6\95F4\90E8\5206\FF0C\8FD8\542F\7528\6BCF\5468\548C\6BCF\65E5\65E5\5386\89C6\56FE\3002\9009\62E9<strong>\5426</strong>\4EE5\4EC5\663E\793A\4E8B\4EF6\7684\65E5\671F\3002</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830368458312989)
,p_name=>'CA.CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832232172312990)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\53D6\6D88\201D\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809551572312176)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842140446312998)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\65E0\6CD5\4ECE\81EA\5DF1\7684\8BB0\5F55\4E2D\5220\9664\7BA1\7406\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872949590313021)
,p_name=>'CA.CARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\5361\7247\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872801503313021)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\5361\7247\7684\9875\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\8868\6216\89C6\56FE</strong>\FF08\5FC5\9700\FF09- \4E3A\65E5\5386\9009\62E9\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('  <li><strong>\5361\7247\6807\9898</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\9009\62E9\7528\4F5C\5361\7247\6807\9898\7684\5217\3002</li>'),
unistr('  <li><strong>\63CF\8FF0\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\5361\7247\63CF\8FF0\7684\5217\3002</li>'),
unistr('  <li><strong>\9644\52A0\6587\672C\5217</strong> - \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\5361\7247\7684\8F85\52A9\63CF\8FF0\7684\5217\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871415767313020)
,p_name=>'CA.CARDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871563810313020)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932613233312271)
,p_name=>'CA.CC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6284\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193006106312477)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822925787312983)
,p_name=>'CA.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\56FE\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823094217312983)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\9762\79EF\56FE\3001\6761\5F62\56FE\3001\7EBF\5F62\56FE\6216\997C\56FE\7684\9875\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\56FE\8868\7C7B\578B</strong> - \9009\62E9\8981\663E\793A\7684\56FE\8868\7C7B\578B [<strong>\9762\79EF\56FE</strong>\3001<strong>\6761\5F62\56FE</strong>\3001<strong>\7EBF\5F62\56FE</strong>\3001<strong>\997C\56FE</strong>]\3002</li>'),
unistr('  <li><strong>\8868\6216\89C6\56FE</strong>\FF08\5FC5\9700\FF09- \9009\62E9\56FE\8868\7684\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('  <li><strong>\6807\7B7E\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\56FE\8868\6807\7B7E\7684\5217\3002</li>'),
unistr('  <li><strong>\503C\805A\96C6</strong> - \9009\62E9\5E94\5982\4F55\663E\793A\6216\805A\96C6\503C\5217<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\5217\503C\3001\603B\548C\3001\8BA1\6570]\3002</li>'),
unistr('  <li><strong>\503C\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8BA1\7B97\6240\663E\793A\56FE\8868\503C\65F6\4F7F\7528\7684\8868\6216\89C6\56FE\4E2D\9009\62E9\6570\503C\5217\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823341507312983)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<h3>\793A\4F8B</h3>'),
unistr('<p>\67E5\770B\6709\5173\5982\4F55\4F7F\7528\4E0D\540C<strong>\6C47\603B</strong>\7C7B\578B\7684\793A\4F8B:</p>'),
unistr('<p><strong>\793A\4F8B 1:</strong> \663E\793A\5458\5DE5\56FE\8868, \5E76\663E\793A\6BCF\4F4D\5458\5DE5\7684\7ECF\7406\5458\5DE5\7F16\53F7\3002'),
'<code><ul>',
unistr('  <li>\8868\6216\89C6\56FE - \9009\62E9\201CEMP\201D\3002</li>'),
unistr('  <li>\6807\7B7E\5217 - \9009\62E9\201CENAME\201D\3002</li>'),
unistr('  <li>\6C47\603B - \9009\62E9<u><strong>\5217\503C</strong></u>\3002</li>'),
unistr('  <li>\503C\5217 - \9009\62E9\201CMGR\201D\3002</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\793A\4F8B 2:</strong> \663E\793A\5458\5DE5\5217\8868, \5E76\663E\793A\6BCF\79CD\5DE5\4F5C\7684\603B\85AA\6C34\3002'),
'<code><ul>',
unistr('  <li>\8868\6216\89C6\56FE - \9009\62E9\201CEMP\201D\3002</li>'),
unistr('  <li>\6807\7B7E\5217 - \9009\62E9\201CJOB\201D\3002</li>'),
unistr('  <li>\6C47\603B - \9009\62E9<u><strong>\603B\548C</strong></u>\3002</li>'),
unistr('  <li>\503C\5217 - \9009\62E9\201CSAL\201D\3002</li>'),
'</ul></code>',
'</p>',
unistr('<p><strong>\793A\4F8B 3:</strong> \663E\793A\5458\5DE5\56FE\8868, \5E76\663E\793A\5404\90E8\95E8\7684\5458\5DE5\6570\3002'),
'<code><ul>',
unistr('  <li>\8868\6216\89C6\56FE - \9009\62E9\201CEMP\201D\3002</li>'),
unistr('  <li>\6807\7B7E\5217 - \9009\62E9\201CDEPTNO\201D\3002</li>'),
unistr('  <li>\6C47\603B - \9009\62E9<u><strong>\8BA1\6570</strong></u>\3002</li>'),
unistr('  <li>\503C\5217 - \9009\62E9\201CEMPNO\201D\3002</li>'),
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059715134312371)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876100690313024)
,p_name=>'CA.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697646042312091)
,p_name=>'CA.CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874122559313022)
,p_name=>'CA.COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851137723313005)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851218929313005)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838579753312995)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869967384313019)
,p_name=>'CA.COMMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836203330312993)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841001485312997)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831447358312989)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831508678312990)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5E94\7528\7A0B\5E8F\7684\5916\89C2\7531\4E3B\9898\6837\5F0F\5B9A\4E49\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834890263312992)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\914D\7F6E\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816778557312978)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815091416312976)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\6216\7981\7528\5E94\7528\7A0B\5E8F\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816808578312978)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\5E94\7528\7A0B\5E8F\7BA1\7406\5458\542F\7528\6216\7981\7528\5E94\7528\7A0B\5E8F\4E2D\7684\7279\5B9A\529F\80FD\3002\5982\679C\60A8\9009\62E9\7684\4E00\4E9B\529F\80FD\9700\8981\989D\5916\7684\5F00\53D1\5DE5\4F5C\624D\80FD\4F9B\6700\7EC8\7528\6237\4F7F\7528\FF0C\5219\6B64\529F\80FD\975E\5E38\6709\7528\3002<br>'),
unistr('\6B64\529F\80FD\8FD8\53EF\4EE5\6269\5C55\5230\5E94\7528\7A0B\5E8F\7279\5B9A\529F\80FD\3002\5982\679C\5F00\53D1\8005\5B9A\4E49\4E86\989D\5916\7684\6784\5EFA\9009\9879\5E76\5728\5E94\7528\7A0B\5E8F\4E2D\5C06\5176\4E0E\7279\5B9A\529F\80FD\5173\8054\FF0C\5219\53EF\4EE5\5C06\5176\6DFB\52A0\5230\7BA1\7406\5458\7684\914D\7F6E\8BBE\7F6E\4E2D\3002\4F8B\5982\FF0C\5728\5BA2\6237\8DDF\8E2A\7A0B\5E8F\5E94\7528\7A0B\5E8F\4E2D\FF0C\7BA1\7406\5458\53EF\4EE5\542F\7528\6216\7981\7528\8054\7CFB\4EBA\3001\6570\636E\52A0\8F7D\3001\5730\7406\4F4D\7F6E\7B49\6B64\7C7B\529F\80FD\3002'),
'</p>',
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6\FF1A'),
'<ul>',
unistr('<li>\5141\8BB8\542F\7528\548C\7981\7528\5E94\7528\7A0B\5E8F\529F\80FD</li>'),
unistr('<li>\4F7F\7528\6B64\529F\80FD\9488\5BF9\6BCF\4E2A\90E8\7F72\6709\9009\62E9\5730\542F\7528\529F\80FD</li>'),
unistr('<li>\652F\6301\5BF9\76F8\5173\7684\5E94\7528\7A0B\5E8F\8BBE\7F6E\5206\7EC4</li>'),
unistr('<li>\5141\8BB8\5E94\7528\7A0B\5E8F\5F00\53D1\8005\4F7F\7528\6784\5EFA\9009\9879\63A7\5236\7EC4\4EF6</li>'),
unistr('<li>\53EF\4ECE\7BA1\7406\9875\4F7F\7528</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054677286312366)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDE\63A5\8EAB\4EFD\8BC1\660E\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054711902312366)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDE\63A5\8EAB\4EFD\8BC1\660E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721181822312897)
,p_name=>'CA.CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E0B\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841516322312997)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D21\732E\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061659593312372)
,p_name=>'CA.CPU.USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CPU \5360\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850015531313004)
,p_name=>'CA.CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855152726313008)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7BA1\7406\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852773203313006)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853854597313007)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853102636313006)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853797460313007)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853901702313007)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\8FDB\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730256648312904)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\5E94\7528\7A0B\5E8F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860052961313012)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103595950312406)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853393784313007)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854150629313007)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7A7A\767D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853299048313006)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854590263313008)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65E5\5386\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866344334313016)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\5361\7247\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854332082313007)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\56FE\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854857554313008)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7ECF\5178\62A5\544A\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854490626313007)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9762\677F\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852675952313006)
,p_name=>'CA.CREATE.END'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873631147313022)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5206\9762\641C\7D22\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855417812313008)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870983628313020)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\5DF2\7B5B\9009\5185\5BB9\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854296166313007)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8868\5355\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852852676313006)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5168\5C40\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855026772313008)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4E3B\9875\5BFC\822A\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854973617313008)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4EA4\4E92\5F0F\7F51\683C\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854746078313008)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4EA4\4E92\5F0F\62A5\544A\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564129448311987)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\5730\56FE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859766936313011)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\4E3B\4ECE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853549616313007)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856783492313009)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855310423313008)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855273724313008)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C %0 \7684\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854684778313008)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\62A5\544A\548C\8868\5355\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859976382313012)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\4FDD\5B58\84DD\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853656623313007)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108854023002313007)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563873136311987)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\667A\80FD\7B5B\9009\5668\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852572039313006)
,p_name=>'CA.CREATE.START'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852909418313006)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\652F\6301\5BF9\8C61\811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853463293313007)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6587\672C\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866425401313017)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\65F6\95F4\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873876230313022)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\5411\5BFC\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834127875312992)
,p_name=>'CA.CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834289644312992)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822696287312983)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521B\5EFA\5E94\7528\7A0B\5E8F ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055370192312367)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8EAB\4EFD\8BC1\660E\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061514684312372)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8EAB\4EFD\8BC1\660E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834744589312992)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855704646313008)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144565565312438)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5B9A\5236\4E3B\9898')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144635946312438)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5207\6362\5411\5BFC\4EE5\4F7F\7528\5B9A\5236\4E3B\9898\800C\4E0D\662F\901A\7528\4E3B\9898\3002</p>'),
'',
unistr('<p>\4E3A\5E94\7528\7A0B\5E8F\9009\62E9\5DE5\4F5C\533A\4E3B\9898\3002\5982\679C\4E3B\9898\652F\6301\4E3B\9898\6837\5F0F\FF0C\5219\8FD8\53EF\4EE5\9009\62E9\6837\5F0F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809206529312176)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\4E3B\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856386922313009)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\9762\677F\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720179736312896)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856401640313009)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\5177\6709\591A\4E2A\56FE\8868\7684\9762\677F\9875\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
unistr('<p>\5404\56FE\8868\FF08\56FE\8868 1\3001\56FE\8868 2\3001\56FE\8868 3 \548C\56FE\8868 4\FF09\9ED8\8BA4\4E3A\4E0D\540C\7684\56FE\8868\7C7B\578B\4E14\57FA\4E8E<em>\793A\4F8B\6570\636E</em>\3002'),
unistr('  \56E0\6B64\FF0C\65E0\9700\8F93\5165\4EFB\4F55\8BE6\7EC6\4FE1\606F\5373\53EF\6DFB\52A0\6B64\9875\3002'),
unistr('  \4E0D\8FC7\FF0C\53EF\4EE5\5B9A\5236\6BCF\4E2A\56FE\8868\FF0C\5C06\9ED8\8BA4\503C\66FF\6362\4E3A\60A8\81EA\5DF1\7684\9009\62E9\9879\3002<br>'),
unistr('  \8981\5B9A\5236\56FE\8868\FF0C\8BF7\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\56FE\8868\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\56FE\8868\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\56FE\8868\7C7B\578B</strong> - \9009\62E9\8981\663E\793A\7684\56FE\8868\7C7B\578B [<strong>\9762\79EF\56FE</strong>\3001<strong>\6761\5F62\56FE</strong>\3001<strong>\7EBF\5F62\56FE</strong>\3001<strong>\997C\56FE</strong>]\3002</li>'),
unistr('  <li><strong>\8868\6216\89C6\56FE</strong>\FF08\5FC5\9700\FF09- \9009\62E9\56FE\8868\7684\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('  <li><strong>\6807\7B7E\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\56FE\8868\6807\7B7E\7684\5217\3002</li>'),
unistr('  <li><strong>\503C\805A\96C6</strong> - \9009\62E9\5E94\5982\4F55\663E\793A\6216\805A\96C6\503C\5217<br>'),
unistr('      &nbsp;&nbsp;&nbsp;[\5217\503C\3001\603B\548C\3001\8BA1\6570]\3002</li>'),
unistr('  <li><strong>\503C\5217</strong>\FF08\5FC5\9700\FF09- \4ECE\8BA1\7B97\6240\663E\793A\56FE\8868\503C\65F6\4F7F\7528\7684\8868\6216\89C6\56FE\4E2D\9009\62E9\6570\503C\5217\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867061103313017)
,p_name=>'CA.DATATYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868166304313018)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835424008312993)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\65F6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835573036312993)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\9ED8\8BA4\65F6\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857157976313009)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5C5E\6027\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857468617313010)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5229\7528\6B64 JSON \6587\6863, \53EF\4EE5\5BF9\62A5\544A\548C\8868\5355\5217\540D, \683C\5F0F\63A9\7801\7B49\7684\751F\6210\64CD\4F5C\8FDB\884C\7EC6\7C92\5EA6\63A7\5236\3002\60A8\8FD8\53EF\4EE5\5B9A\4E49\503C\5217\8868\548C\5176\4ED6\5171\4EAB\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873402135313022)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873536367313022)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6DFB\52A0\503C\5217\8868 (LOV) \5C5E\6027\3002LOV \53EF\7528\4E8E\8868\5217\5B9A\4E49\4E2D\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027:'),
'  <ul>',
unistr('    <li><strong>\540D\79F0</strong> (\5FC5\9700) - \8F93\5165\503C\5217\8868\7684\540D\79F0\3002</li>'),
unistr('    <li><strong>\7C7B\578B</strong> - \9009\62E9\503C\5217\8868\7684\7C7B\578B [\7ED3\6784\5316, \52A8\6001, \9759\6001]\3002<br>'),
unistr('      \5BF9\4E8E<u>\7ED3\6784\5316</u>\7C7B\578B - '),
'      <ul>',
unistr('          <li><strong>\8868</strong> (\5FC5\9700) - \9009\62E9\503C\5217\8868\8981\57FA\4E8E\7684\8868\6216\89C6\56FE\3002</li>'),
unistr('          <li><strong>\663E\793A\5217</strong> (\5FC5\9700) - \9009\62E9\5411\6700\7EC8\7528\6237\663E\793A\7684\5217\3002</li>'),
unistr('          <li><strong>\5173\952E\5B57\5217</strong> (\5FC5\9700) - \9009\62E9\8FD4\56DE\7684\5217\503C\3002\8FD9\901A\5E38\662F\8868\7684\4E3B\952E\3002</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \5BF9\4E8E<u>\52A8\6001</u>\7C7B\578B -'),
'      <ul>',
unistr('          <li><strong>SQL \67E5\8BE2</strong> (\5FC5\9700) - \8F93\5165\8FD4\56DE\4E24\4E2A\503C (\663E\793A\503C\548C\8FD4\56DE\503C) \7684\6709\6548 SQL \9009\62E9\8BED\53E5\3002</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      \5BF9\4E8E<u>\9759\6001</u>\7C7B\578B -'),
'      <ul>',
unistr('          <li><strong>\9759\6001\503C\5217\8868</strong> (\5FC5\9700) - \8F93\5165\6709\6548\7684\9759\6001\5217\8868, \683C\5F0F\4E3A:'),
'          <ul>',
unistr('            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>\5217\8868\6309\8F93\5165\7684\987A\5E8F\663E\793A</li>'),
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>\5217\8868\6309\5B57\6BCD\987A\5E8F\6392\5E8F</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>\663E\793A\503C\548C\8FD4\56DE\503C\76F8\540C</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874695526313022)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874792125313023)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7F16\8F91\6240\6709\62A5\8868\7684\5C5E\6027\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027:'),
'  <ul>',
unistr('    <li><strong>\6BCF\9875\884C\6570</strong> - \8F93\5165\9ED8\8BA4\60C5\51B5\4E0B\663E\793A\7684\62A5\8868\884C\6570\3002</li>'),
unistr('    <li><strong>\5206\9875\65B9\6CD5</strong> - \9009\62E9\5C06\5982\4F55\663E\793A\62A5\8868\9875\7801\3002</li>'),
unistr('    <li><strong>\6570\503C\683C\5F0F\63A9\7801</strong> - \8F93\5165\5E94\7528\5230\6570\5B57\5217\548C\9879\7684\683C\5F0F\63A9\7801\3002</li>'),
unistr('    <li><strong>\65E5\671F\683C\5F0F\63A9\7801</strong> - \8F93\5165\5E94\7528\5230\65E5\671F\5217\548C\9879\7684\683C\5F0F\63A9\7801\3002</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874475688313022)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874262056313022)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874366684313022)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7F16\8F91\9009\5B9A\8868\5217\7684\5C5E\6027\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027:'),
'  <ul>',
unistr('    <li><strong>\8868</strong> (\4EC5\663E\793A) - \5173\8054\7684\8868\3002</li>'),
unistr('    <li><strong>\5217</strong> (\4EC5\663E\793A) - \9488\5BF9\5176\5B9A\4E49\5C5E\6027\7684\5217\3002</li>'),
unistr('    <li><strong>\6807\7B7E</strong> - \8F93\5165\5728\62A5\8868\6807\9898\548C\8868\5355\6807\7B7E\4E2D\4F7F\7528\7684\6807\7B7E\3002</li>'),
unistr('    <li><strong>\8868\5355\63A7\4EF6</strong> - \9009\62E9\5728\8868\5355\4E0A\4F7F\7528\7684\9879\7C7B\578B\3002</li>'),
unistr('    <li><strong>\503C\5217\8868</strong> - \9009\62E9\73B0\6709\503C\5217\8868, \4EE5\7528\4E8E\76F8\5E94\5730\663E\793A\7528\6237\53CB\597D\7684\540D\79F0\3002</li>'),
unistr('    <li><strong>\683C\5F0F\63A9\7801</strong> - \6839\636E\5217\7C7B\578B\8F93\5165\76F8\5E94\7684\683C\5F0F\63A9\7801 (\6587\672C, \6570\5B57, \65E5\671F\7B49)\3002</li>'),
unistr('    <li><strong>\9759\6001\9ED8\8BA4\503C</strong> - \8F93\5165\5217\7684\6587\672C\9ED8\8BA4\503C\3002</li>'),
unistr('    <li><strong>\5305\62EC\5728\8868\5355\4E0A</strong> - \5982\679C\5217\5E94\5305\62EC\5728\8868\5355\4E0A, \5219\5355\51FB\201C\662F\201D\3002</li>'),
unistr('    <li><strong>\5305\62EC\5728\62A5\8868\4E0A</strong> - \5982\679C\5217\5E94\5305\62EC\5728\62A5\8868\4E0A, \5219\5355\51FB\201C\662F\201D\3002</li>'),
unistr('    <li><strong>\5FC5\9700</strong> - \5982\679C\8868\5355\4E0A\7684\6B64\5217\4E2D\5FC5\987B\8F93\5165\6570\636E, \5219\5355\51FB\201C\662F\201D\3002</li>'),
unistr('    <li><strong>\5E2E\52A9</strong> - \8F93\5165\6DFB\52A0\5230\9879\5E2E\52A9\5C5E\6027\4E2D\7684\5E2E\52A9\6587\672C\3002</li>'),
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874572969313022)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7F16\8F91\9009\5B9A\8868\5217\7684\5C5E\6027\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027:'),
'  <ul>',
unistr('    <li><strong>\8868</strong> (\4EC5\663E\793A) - \5173\8054\7684\8868\3002</li>'),
unistr('    <li><strong>\6807\7B7E, \5355\6570</strong> (\5FC5\9700) - \8F93\5165\5728\8868\5355\9875\4E0A\4F7F\7528\7684\6807\7B7E\3002</li>'),
unistr('    <li><strong>\6807\7B7E, \590D\6570</strong> (\5FC5\9700) - \8F93\5165\5728\533A\57DF\6807\9898\548C\9875\540D\4E2D\4F7F\7528\7684\6807\7B7E\3002</li>'),
unistr('    <li><strong>\4E3B\663E\793A\5217</strong> - \9009\62E9\8981\663E\793A\7684\7B2C\4E00\5217, \4F8B\5982\5728\5361\7247\533A\57DF\4E2D\3002</li>'),
unistr('    <li><strong>\6B21\663E\793A\5217</strong> - \9009\62E9\8981\663E\793A\7684\7B2C\4E8C\5217, \4F8B\5982\5728\5361\7247\533A\57DF\4E2D\3002</li>'),
unistr('    <li><strong>\4E3B\952E\5217</strong> - \4E3A\8868\9009\62E9\552F\4E00\4E3B\952E\5217\3002</li>'),
unistr('    <li><strong>\8BF4\660E</strong> - \4E3A\8868\8F93\5165\8BF4\660E\3002</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055185841312367)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EF6\8FDF\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868766479313018)
,p_name=>'CA.DEFINITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852457376313006)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\5B8C\6210\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832724840312990)
,p_name=>'CA.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108852082588313006)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\8981\6267\884C\6B64\5220\9664\64CD\4F5C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818362388312979)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9E\8981\5220\9664\6B64\9875?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842532330312998)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\7167\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833428440312991)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850634067313005)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850503552313004)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831717234312990)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\684C\9762\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831815549312990)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\4E3B\9898\6837\5F0F\5E94\7528\5230\6240\6709\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055594043312367)
,p_name=>'CA.DESTINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055673302312367)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809358955312176)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847060731313002)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6D3E\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865517839313016)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\662F\5426\5E94\4ECE\7535\5B50\90AE\4EF6\6846\67B6\53D1\51FA\7535\5B50\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833260544312991)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833171754312991)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833323595312991)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867297276313017)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836804718312994)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850103595313004)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857032151313009)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\52A8\4EE5\5BF9\9875\91CD\65B0\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830060606312193)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>\7EC6\5316\94FE\63A5</strong> - \5C55\5F00\53EF\67E5\770B\7528\4E8E\5B9A\4E49\7EC6\5316\94FE\63A5\7684\5C5E\6027\3002'),
'&nbsp;<br>',
unistr('    <em><strong>\6CE8\FF1A</strong>\53EA\6709\5728\5F53\524D\9875\57FA\4E8E\8868\6216\89C6\56FE\4E14\62A5\8868\7C7B\578B\4E3A\201C\4EA4\4E92\5F0F\62A5\8868\201D\FF0C\5E76\4E14\5DF2\7ECF\5B9A\4E49\4E86\62A5\8868\FF08\4EA4\4E92\5F0F\62A5\8868\FF09\6216\4E3B\4ECE\9875\65F6\FF0C\624D\4F1A\663E\793A\201C\7EC6\5316\94FE\63A5\201D\3002</em>'),
'  <ul>',
unistr('    <li><strong>\94FE\63A5\5217</strong> - \9009\62E9\5C06\5728\62A5\8868\4E2D\66F4\6539\4E3A\94FE\63A5\5217\7684\5217\3002</li>'),
unistr('    <li><strong>\94FE\63A5\5173\952E\5B57</strong> - \9009\62E9\7528\4E8E\6307\5B9A\94FE\63A5\5230\7684\9875\4E2D\7279\5B9A\8BB0\5F55\7684\94FE\63A5\5173\952E\5B57\FF08\5916\952E\FF09\5217\3002</li>'),
unistr('    <li><strong>\94FE\63A5\5230\9875</strong> - \9009\62E9\94FE\63A5\5C06\5BFC\822A\5230\7684\62A5\8868\9875\6216\8868\5355\9875\3002</li>'),
unistr('    <li><strong>\76EE\6807\5173\952E\5B57</strong> - \4ECE\62A5\8868\9875\FF08\94FE\63A5\5C06\5BFC\822A\5230\8BE5\9875\FF09\6240\57FA\4E8E\7684\8868\4E2D\9009\62E9\76EE\6807\5173\952E\5B57\FF08\4E3B\952E\FF09\5217\3002'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835951691312993)
,p_name=>'CA.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818570257312979)
,p_name=>'CA.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6846\67B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865122086313016)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875195399313023)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818463377312979)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\529F\80FD\7528\4E8E\914D\7F6E\548C\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818642712312979)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5305\62EC\4ECE\5E94\7528\7A0B\5E8F\53D1\9001\7535\5B50\90AE\4EF6\7684\529F\80FD\3002\4F7F\7528\793A\4F8B\7535\5B50\90AE\4EF6\6A21\677F\5411\7528\6237\53D1\9001\4E13\4E1A\5916\89C2\7684\7535\5B50\90AE\4EF6\3002\53D1\51FA\7684\7535\5B50\90AE\4EF6\6709\8BB0\5F55, \8FD9\6837\7BA1\7406\5458\53EF\4EE5\8DDF\8E2A\7535\5B50\90AE\4EF6\6D3B\52A8\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\53EF\6269\5C55\7684 HTML \7535\5B50\90AE\4EF6\6A21\677F\7CFB\7EDF</li>'),
unistr('<li>\7528\4E8E\901A\8FC7 APEX \7A0B\5E8F\5305\53D1\9001\90AE\4EF6\7684 PL/SQL \7A0B\5E8F\5305</li>'),
unistr('<li>\7535\5B50\90AE\4EF6\6D3B\52A8\548C\72B6\6001\7684\65E5\5FD7\8BB0\5F55</li>'),
unistr('<li>\7528\4E8E\7BA1\7406\6A21\677F\7684\7BA1\7406 UI</li>'),
unistr('<li>\7528\4E8E\67E5\770B\7535\5B50\90AE\4EF6\65E5\5FD7\7684\7BA1\7406 UI</li>'),
unistr('<li>\7528\4E8E\53D1\9001\7535\5B50\90AE\4EF6\7684\7BA1\7406 UI</li>'),
'</ul>',
'</p>',
unistr('<p><em>\6CE8: \5728\9009\4E2D\4E86\201C\53CD\9988\201D\65F6\542F\7528\6B64\529F\80FD</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870829716313020)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846090877313001)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875778078313023)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\7535\5B50\90AE\4EF6\8BBE\7F6E\8BE6\7EC6\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875209382313023)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\4EF6\4EBA\5730\5740\4E0D\662F\6709\6548\7684\7535\5B50\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866705196313017)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\4EF6\4EBA\5730\5740\4E0D\662F\6709\6548\7684\7535\5B50\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865980827313016)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5904\7406\7535\5B50\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932931887312272)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105262149312407)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\5173\6392\961F\7B49\5F85\53D1\9001\7684\6240\6709\7535\5B50\90AE\4EF6\548C\6240\6709\5DF2\53D1\9001\7535\5B50\90AE\4EF6\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846958174313002)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847326562313002)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\7535\5B50\90AE\4EF6\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871268239313020)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847409924313002)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F\8BE6\7EC6\8D44\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353648822312607)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#SERVICE_NAME# \7684\5DF2\8C03\5EA6\505C\673A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151959505312444)
,p_name=>'CA.EMAIL2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845915495313001)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7684\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875316017313023)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060696202312372)
,p_name=>'CA.ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057893746312369)
,p_name=>'CA.END.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848033779313002)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\540E\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739313814312911)
,p_name=>'CA.ENDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863007256313014)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5904\8F93\5165\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836556251312993)
,p_name=>'CA.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838863333312995)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\5411\540E\8DDF\8E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838778817312995)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838095685312995)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062371575312373)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061355926312372)
,p_name=>'CA.ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739517835312911)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058239578312370)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058322955312370)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\961F\5217\4EE3\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058488002312370)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\961F\5217\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058541388312370)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\961F\5217\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058149838312370)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\89C4\5219')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863322968313014)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F02\5E38\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876291462313024)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F53\9A8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060354947312371)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834508180312992)
,p_name=>'CA.FEATURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509116462312733)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509209418312733)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193400230312477)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\7528\6237\6DFB\52A0\5230\8BBF\95EE\63A7\5236\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193261406312477)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\81F3\4E0B\4E00\6B65')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193311803312477)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\96C6\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193155779312477)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\6539\6700\540E\4E00\4E2A\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508875275312733)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192910060312477)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509090534312733)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\539F\56E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193519585312477)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3\5C11\9700\8981\4E00\4E2A\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193803150312478)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\6587\4EF6 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192482245312476)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192561968312477)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\6700\7EC8\7528\6237\6837\5F0F\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508901454312733)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822761096312983)
,p_name=>'CA.FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108822821720312983)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\4E9B\529F\80FD\63D0\4F9B\4E86\5E94\7528\7A0B\5E8F\7EA7\522B\7684\529F\80FD\FF0C\901A\5E38\5BF9\6BCF\4E2A\5E94\7528\7A0B\5E8F\6DFB\52A0\4E00\6B21\3002\9009\62E9\8981\5305\62EC\5728\5E94\7528\7A0B\5E8F\4E2D\7684\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816660985312978)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814618506312976)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\7528\6237\63D0\4F9B\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816516260312978)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\6700\7EC8\7528\6237\63D0\4F9B\5C06\5E38\89C4\6CE8\91CA\53D1\9001\56DE\5E94\7528\7A0B\5E8F\7BA1\7406\5458\548C\5F00\53D1\4EBA\5458\7684\673A\5236\3002\5E16\5B50\4E2D\5305\62EC\6709\7528\7684\4F1A\8BDD\72B6\6001\4FE1\606F, \7528\4E8E\5E2E\52A9\786E\5B9A\6700\7EC8\7528\6237\53D1\9001\53CD\9988\7684\4F4D\7F6E\3002\63D0\4F9B\8FD9\79CD\7B80\5355\7684\53CD\9988\5FAA\73AF\53EF\6539\8FDB\7528\6237\793E\533A\4E0E\5E94\7528\7A0B\5E8F\6240\6709\8005\4E4B\95F4\7684\4EA4\6D41, \8FD9\4F1A\5E26\6765\7528\6237\6EE1\610F\5EA6\7684\663E\8457\6539\5584\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\6700\7EC8\7528\6237\53EF\4EE5\901A\8FC7\5355\51FB\5BFC\822A\680F\56FE\6807\7559\4E0B\53CD\9988\610F\89C1</li>'),
unistr('<li>\7528\4E8E\67E5\770B\548C\66F4\65B0\53CD\9988\7684\7BA1\7406\62A5\544A</li>'),
unistr('<li>\53CD\9988\5C06\6536\96C6\7528\6237, \65E5\671F\548C\65F6\95F4\4EE5\53CA\7528\6237\4EE3\7406\4FE1\606F</li>'),
'</ul>',
'</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876627186313024)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\63D0\4F9B\53CD\9988\6216\60A8\7684\4F53\9A8C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875621816313023)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875086869313023)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844013422312999)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\53CD\9988\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875879586313023)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057966464312369)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\76D1\89C6\5668\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058072511312370)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\76D1\89C6\5668\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716131442312105)
,p_name=>'CA.FILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5F52\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716231318312105)
,p_name=>'CA.FILED.BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F52\6863\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871302454313020)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B5B\9009\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848480482313003)
,p_name=>'CA.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874071251313022)
,p_name=>'CA.FINISH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842707536312998)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054940900312367)
,p_name=>'CA.FLAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824164308312984)
,p_name=>'CA.FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\8868\5355\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824016441312984)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\8868\5355\9875\4EE5\5141\8BB8\6700\7EC8\7528\6237\7EF4\62A4\6570\636E\7684\9875\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\8868</strong>\FF08\5FC5\9700\FF09- \4E3A\8868\5355\9009\62E9\8868\3002</li>'),
unistr('<li><strong>\5305\62EC\62A5\8868</strong>\FF08\5FC5\9700\FF09- \9009\62E9\6B64\9009\9879\53EF\521B\5EFA\62A5\8868\548C\8868\5355\3002\7B2C\4E00\9875\662F\4EA4\4E92\5F0F\62A5\8868\3002\6BCF\884C\63D0\4F9B\6307\5411\4E00\4E2A\8868\5355\7684\94FE\63A5\FF0C\7528\6237\53EF\5728\5176\4E2D\66F4\65B0\8BB0\5F55\3002</li>'),
'  &nbsp;<br>',
unistr('<li><strong>\9AD8\7EA7</strong> - \5C55\5F00\53EF\67E5\770B\9AD8\7EA7\9009\9879\3002'),
'     <ul>',
unistr('      <li><strong>\9875\5E2E\52A9</strong> - \8F93\5165\8981\6DFB\52A0\5230\9875\7684\201C\5E2E\52A9\6587\672C\201D\4E2D\7684\6587\672C\3002</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828687466312192)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9879\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850305229313004)
,p_name=>'CA.FORM.ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E %0 \7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862852662313014)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\7C7B\578B\4E0D\662F\6709\6548\7684\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869212091313019)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868279810313018)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\63A7\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833920229312991)
,p_name=>'CA.FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847156483313002)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\4EF6\4EBA\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870716304313020)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('"\53D1\4EF6\4EBA\5730\5740" \7535\5B50\90AE\4EF6\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866649964313017)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\4EF6\4EBA\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866592444313017)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\4EF6\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559501187312773)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837436993312994)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6574\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846101139313001)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6574\6A21\677F HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867795756313017)
,p_name=>'CA.FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817077272312978)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814871252312976)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\5E94\7528\7A0B\5E8F\641C\7D22\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816920039312978)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\6700\7EC8\7528\6237\5728\5E94\7528\7A0B\5E8F\4E2D\7684\4E3B\8981\8868\6216\89C6\56FE\4E2D\641C\7D22\6587\672C\3002\9AD8\7EA7\641C\7D22\9875\5305\542B\7B5B\9009\5668, \4F7F\5F97\6700\7EC8\7528\6237\53EF\4EE5\8F7B\677E\5730\7F29\5C0F\7ED3\679C\8303\56F4\3002<br>'),
unistr('\8FD9\6B3E\975E\5E38\5F3A\5927\7684\529F\80FD\65E0\9700\4EFB\4F55\5F00\53D1\5DE5\4F5C\6765\5B9A\4E49 SQL (\57FA\4E8E\63D0\4F9B\7684\793A\4F8B)\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\5728\6807\9898\680F\4E2D\663E\793A\641C\7D22\56FE\6807</li>'),
unistr('<li>\5305\62EC\5177\6709\4FA7\8FB9\680F\7B5B\9009\5668\7684\8BE6\7EC6\641C\7D22\7ED3\679C\9875</li>'),
unistr('<li>\9700\8981\5F00\53D1\4EBA\5458\5B9E\65BD SQL \6765\5B9A\4E49\5E94\7528\7A0B\5E8F\641C\7D22</li>'),
unistr('<li>\5305\62EC\7528\4E8E\8BF4\660E\7684\793A\4F8B\6570\636E</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059601251312371)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\552F\4E00 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192079239312476)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\9875 - \684C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809458465312176)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\7BA1\7406\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823680380312983)
,p_name=>'CA.GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\4EA4\4E92\5F0F\7F51\683C\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823756155312983)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\4EA4\4E92\5F0F\7F51\683C\7684\9875\FF0C\8FD9\79CD\7F51\683C\7C7B\4F3C\4E8E\7535\5B50\8868\683C\3002\5728\53EF\4EE5\8FDB\884C\7F16\8F91\65F6\FF0C\7528\6237\53EF\76F4\63A5\5728\9875\4E0A\7F16\8F91\591A\884C\FF08\5373\FF0C\5728\542F\7528\4E86\201C\5141\8BB8\7F16\8F91\201D\65F6\FF09\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\67E5\8BE2\7C7B\578B</strong> - \9009\62E9\62A5\8868\7684\6E90 [<strong>\8868\6216\89C6\56FE</strong>\6216 <strong>SQL \67E5\8BE2</strong>]\3002<br>'),
unistr('    <strong>\8868\6216\89C6\56FE</strong>\FF1A'),
'    <ul>',
unistr('      <li><strong>\8868\6216\89C6\56FE</strong>\FF08\5FC5\9700\FF09- \9009\62E9\7F51\683C\7684\6570\636E\5E93\5BF9\8C61\3002</li>'),
'    </ul>',
unistr('    <strong>SQL \67E5\8BE2</strong>\FF1A'),
'    <ul>',
unistr('      <li><strong>SQL \67E5\8BE2</strong>\FF08\5FC5\9700\FF09- \8F93\5165\8FD4\56DE\552F\4E00\5217\7684\6709\6548 SQL \8BED\53E5\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\7F51\683C\7C7B\578B</strong> - \9009\62E9\7528\6237\662F\5426\53EF\5728\7F51\683C\4E2D\7F16\8F91\884C [<strong>\5141\8BB8\7F16\8F91</strong>\6216<strong>\53EA\8BFB</strong>]\3002\8981\542F\7528\7F16\8F91\529F\80FD\FF0C\8BF7\9009\62E9<strong>\5141\8BB8\7F16\8F91</strong>\3002</li>'),
'  &nbsp;<br>',
unistr('  <em><strong>\8B66\544A\FF1A</strong>\5982\679C\9009\62E9 <strong>SQL \67E5\8BE2</strong>\67E5\8BE2\7C7B\578B\4EE5\53CA<strong>\5141\8BB8\7F16\8F91</strong>\7F51\683C\7C7B\578B\FF0C\5E76\4E14\67E5\8BE2\8054\63A5\4E86\4E24\4E2A\6216\591A\4E2A\8868\FF0C\5219\5728\7528\6237\5C1D\8BD5\548C\66F4\65B0\8BB0\5F55\65F6\FF0C\751F\6210\7684\4EA4\4E92\5F0F\7F51\683C\5C06\5931\8D25\3002'),
unistr('\6B64\5916\FF0C\5982\679C\9009\62E9<strong>\5141\8BB8\7F16\8F91</strong>\7F51\683C\7C7B\578B\5E76\4E14\67E5\8BE2\FF08\6216\9009\62E9\4E86\201C\8868\6216\89C6\56FE\201D\FF09\4F7F\7528\65E0\6CD5\66F4\65B0\7684\89C6\56FE\FF0C\5219\5728\7528\6237\5C1D\8BD5\548C\66F4\65B0\8BB0\5F55\65F6\FF0C\751F\6210\7684\4EA4\4E92\5F0F\7F51\683C\5C06\5931\8D25\3002</em><br>'),
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848964156313003)
,p_name=>'CA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739186108312911)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\81EA\52A8\5316\65E5\5FD7\7684\4EA4\4E92\5F0F\62A5\8868\3002</p>'),
unistr('<p>\68C0\67E5\6709\5173\4EE5\524D\7684\81EA\52A8\5316\6267\884C\7684\5DF2\8BB0\5F55\4FE1\606F\3002\65E5\5FD7\4E2D\5305\542B\5F00\59CB\548C\7ED3\675F\65F6\95F4\6233\FF0C\4EE5\53CA\6709\5173\5DF2\5904\7406\884C\FF08\6210\529F\7684\884C\548C\6709\9519\8BEF\7684\884C\FF09\7684\8BE6\7EC6\4FE1\606F\3002\7EC6\5316\5230\201C\6D88\606F\201D\53EF\67E5\770B\6709\5173\5DF2\5904\7406\884C\7684\5355\4E2A\6D88\606F\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841328802312997)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6240\6709\7528\6237\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\5B9A\4E49, \5219\9009\62E9<strong>\5426</strong>\3002\5982\679C\6B64\5E94\7528\7A0B\5E8F\4E2D\8FD8\4F1A\4F7F\7528\4E0D\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\7684\5DF2\9A8C\8BC1\7528\6237, \5219\9009\62E9 <strong>\662F</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835057339312992)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5904\8F93\5165\7684\6587\672C\5728\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528, \6700\663E\773C\7684\662F\5728\6BCF\9875\7684\5DE6\4E0A\89D2\3002\7BA1\7406\5458\8FDB\884C\66F4\6539\4E4B\540E, \66F4\6539\5C06\7ACB\5373\751F\6548, \4F46\5176\4ED6\7528\6237\53EA\6709\5728\83B7\53D6\65B0\4F1A\8BDD (\4F8B\5982, \4E0B\6B21\767B\5F55) \65F6\624D\4F1A\770B\5230\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829641147312988)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB\5E94\7528\7A0B\5E8F\4E2D\4EFB\610F\9875\4E0A\5BFC\822A\680F\4E2D\7684\201C\53CD\9988\201D\56FE\6807 (<span class="fa fa-comment-o" aria-hidden="true"></span>), \53EF\4EE5\5411\5E94\7528\7A0B\5E8F\7BA1\7406\5458\63D0\4F9B\53CD\9988\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829371288312988)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8FD9\662F\5E94\7528\7A0B\5E8F\7684\4E3B\9875\3002\5355\51FB\5361\7247\53EF\8BBF\95EE\5E94\7528\7A0B\5E8F\4E2D\7684\4E0D\540C\9875, \6216\8005\4F7F\7528\9875\4FA7\9762\7684\5BFC\822A\83DC\5355\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829500767312988)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8FD9\662F\5E94\7528\7A0B\5E8F\7684\4E3B\9875\3002\5355\51FB\5361\7247\53EF\8BBF\95EE\5E94\7528\7A0B\5E8F\4E2D\7684\4E0D\540C\9875, \6216\8005\4F7F\7528\9875\9876\90E8\7684\5BFC\822A\83DC\5355\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829723202312988)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5728\6B64\9875\4E0A\7684<strong>\641C\7D22\5E94\7528\7A0B\5E8F</strong>\5B57\6BB5\4E2D\8F93\5165\641C\7D22\8BCD, \6216\8005\5728\4EFB\610F\9875\7684\5BFC\822A\680F\4E2D\5355\51FB\201C\641C\7D22\201D\56FE\6807 (<span class="fa fa-search" aria-hidden="true"></span>), \641C\7D22\5E94\7528\7A0B\5E8F\4E2D\7684\8BCD\8BED\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830044471312988)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB\5BFC\822A\680F\4E2D\7684\540D\79F0\4E0B\62C9\5217\8868\53EF\6CE8\9500\5E94\7528\7A0B\5E8F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829949083312988)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB\5BFC\822A\680F\4E2D\7684\7528\6237\83DC\5355 (<span class="fa fa-user" aria-hidden="true"></span>) \53EF\66F4\65B0\65F6\533A\9996\9009\9879, \4EE5\53CA\6CE8\9500\5E94\7528\7A0B\5E8F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829479404312988)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830133870312988)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5355\51FB\5BFC\822A\680F (\9875\53F3\4E0A\89D2) \4E2D\7684\7528\6237\83DC\5355 (<span class="fa fa-user" aria-hidden="true"></span>) \53EF\8BBF\95EE\60A8\7684\7528\6237\6982\8981\4FE1\606F, \4EE5\53CA\6CE8\9500\5E94\7528\7A0B\5E8F\3002<br>'),
unistr('\5355\51FB<strong>\67E5\770B\6211\7684\6982\8981\4FE1\606F</strong>\65F6, \53EF\4EE5\968F\540E\5355\51FB<strong>\66F4\65B0\6982\8981\4FE1\606F</strong>\6765\8F93\5165\4E2A\4EBA\8BE6\7EC6\4FE1\606F\548C\4E0A\8F7D\76F8\7247\6216\5934\50CF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829810342312988)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5355\51FB\5BFC\822A\680F\4E2D\7684\7528\6237\83DC\5355 (<span class="fa fa-user" aria-hidden="true"></span>) \53EF\8BBF\95EE\60A8\7684\7528\6237\6982\8981\4FE1\606F, \66F4\65B0\65F6\533A\9996\9009\9879, \4EE5\53CA\6CE8\9500\5E94\7528\7A0B\5E8F\3002<br>'),
unistr('\5355\51FB<strong>\67E5\770B\6211\7684\6982\8981\4FE1\606F</strong>\65F6, \53EF\4EE5\968F\540E\5355\51FB<strong>\66F4\65B0\6982\8981\4FE1\606F</strong>\6765\8F93\5165\4E2A\4EBA\8BE6\7EC6\4FE1\606F\548C\4E0A\8F7D\7167\7247\6216\5934\50CF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855917545313009)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8981\67E5\627E\6570\636E, \8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD, \6216\8005\5355\51FB\5217\6807\9898\4EE5\9650\5236\8FD4\56DE\7684\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\4EE5\6267\884C\591A\79CD\529F\80FD\3002\8FD9\5305\62EC\9009\62E9\663E\793A/\9690\85CF\7684\5217\53CA\5176\663E\793A\987A\5E8F, \4EE5\53CA\591A\79CD\6570\636E\548C\683C\5F0F\529F\80FD\3002\8FD8\53EF\4F7F\7528\56FE\8868\9009\9879\5B9A\4E49\6570\636E\7684\5176\4ED6\89C6\56FE\3002</p>'),
'',
unistr('<p>\5982\679C\8981\4FDD\5B58\5B9A\5236\8BBE\7F6E, \8BF7\9009\62E9\62A5\544A, \6216\8005\5355\51FB\4E0B\8F7D\4EE5\5378\8F7D\6570\636E\3002<p>'),
'<br>',
unistr('<p>\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\5355\51FB\4F4D\4E8E\201C\64CD\4F5C\201D\83DC\5355\5E95\90E8\7684\201C\5E2E\52A9\201D\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855867521313009)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53EF\4EE5\76F4\63A5\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E2D\63D2\5165\3001\66F4\65B0\548C\5220\9664\6570\636E\3002<br>'),
unistr('  \5355\51FB\201C\6DFB\52A0\884C\201D\6309\94AE\53EF\63D2\5165\65B0\884C\3002<br>'),
unistr('  \53CC\51FB\5355\5143\FF0C\6216\8005\5355\51FB<strong>\7F16\8F91</strong>\6309\94AE\53EF\66F4\65B0\6570\636E\503C\FF0C\4E0E\5728\7535\5B50\8868\683C\4E2D\7F16\8F91\6570\636E\7C7B\4F3C\3002</p>'),
'',
unistr('<p>\4F7F\7528\4F4D\4E8E\62A5\8868\9876\90E8\7684\201C\884C\64CD\4F5C\201D\83DC\5355 (<span class="fa fa-bars" aria-hidden="true"></span>) \53EF\590D\5236\3001\5220\9664\3001\5237\65B0\6216\8FD8\539F\9009\5B9A\884C\3002<br> '),
unistr('  \4F7F\7528\4F4D\4E8E\5404\884C\4E0A\7684\201C\884C\64CD\4F5C\201D\83DC\5355\8FD8\53EF\4EE5\8BBF\95EE\5355\884C\89C6\56FE\6216\6DFB\52A0\65B0\884C\3002</p>'),
'',
unistr('<p>\8981\67E5\627E\6570\636E\FF0C\8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\FF0C\6216\8005\5355\51FB\5217\6807\9898\4EE5\9650\5236\8FD4\56DE\7684\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\4EE5\6267\884C\591A\79CD\529F\80FD\3002\8FD9\5305\62EC\9009\62E9\663E\793A/\9690\85CF\7684\5217\53CA\5176\663E\793A\5E8F\5217\FF0C\4EE5\53CA\591A\79CD\6570\636E\548C\683C\5F0F\529F\80FD\3002\8FD8\53EF\4F7F\7528\56FE\8868\9009\9879\5B9A\4E49\6570\636E\7684\5176\4ED6\89C6\56FE\3002</p>'),
'',
unistr('<p>\5982\679C\8981\4FDD\5B58\5B9A\5236\8BBE\7F6E\FF0C\8BF7\9009\62E9\62A5\8868\FF0C\6216\8005\5355\51FB\4E0B\8F7D\4EE5\5378\8F7D\6570\636E\3002<p>'),
'',
unistr('<p>\6709\5173\5176\4ED6\4FE1\606F\FF0C\8BF7\5355\51FB\4F4D\4E8E\201C\64CD\4F5C\201D\83DC\5355\5E95\90E8\7684\201C\5E2E\52A9\201D\3002</p> '),
'',
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\7F51\683C\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829273079312988)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8981\67E5\627E\6570\636E\FF0C\8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\FF0C\6216\8005\5355\51FB\5217\6807\9898\4EE5\9650\5236\8FD4\56DE\7684\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\4EE5\6267\884C\591A\79CD\529F\80FD\3002\8FD9\5305\62EC\9009\62E9\663E\793A/\9690\85CF\7684\5217\53CA\5176\663E\793A\987A\5E8F\FF0C\4EE5\53CA\591A\79CD\6570\636E\548C\683C\5F0F\529F\80FD\3002\8FD8\53EF\4EE5\4F7F\7528\56FE\8868\3001\5206\7EC4\65B9\5F0F\548C\900F\89C6\9009\9879\5B9A\4E49\6570\636E\7684\5176\4ED6\89C6\56FE\3002</p>'),
'',
unistr('<p>\5982\679C\8981\4FDD\5B58\5B9A\5236\8BBE\7F6E\FF0C\8BF7\9009\62E9\62A5\8868\FF0C\6216\8005\5355\51FB\4E0B\8F7D\4EE5\5378\8F7D\6570\636E\3002\5728\8981\5B9A\671F\53D1\9001\6570\636E\7684\8BA2\9605\4E0B\8F93\5165\7535\5B50\90AE\4EF6\5730\5740\548C\65F6\95F4\8303\56F4\3002<p>'),
'',
unistr('<p>\6709\5173\5176\4ED6\4FE1\606F\FF0C\8BF7\5355\51FB\4F4D\4E8E\201C\64CD\4F5C\201D\83DC\5355\5E95\90E8\7684\201C\5E2E\52A9\201D\3002</p>'),
'',
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\8868\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863896178313015)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\62A5\8868\9875\663E\793A\9875\8FB9\680F\9009\62E9\5668\4E2D\7684\4E3B\8BB0\5F55\3002'),
unistr('  \9009\62E9\4E00\6761\8BB0\5F55\53EF\67E5\770B\5B9A\4E49\7684\4E3B\8BB0\5F55\548C\4EFB\4F55\8BE6\7EC6\4FE1\606F\8BB0\5F55\3002<br> '),
unistr('  \5355\51FB\7F16\8F91\56FE\6807 (<span class="fa fa-pencil-square-o" aria-hidden="true"></span>) \53EF\7F16\8F91\4E3B\8BB0\5F55\3002'),
unistr('  \5BF9\4E8E\8BE6\7EC6\4FE1\606F\8BB0\5F55, \5355\51FB\6BCF\884C\5F00\5934\7684\94C5\7B14\53EF\7F16\8F91\76F8\5E94\8BB0\5F55\3002</p>'),
unistr('<p>\8981\9650\5236\5728\9009\62E9\5668\4E2D\663E\793A\7684\6570\636E, \8BF7\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\3002</p>'),
'',
unistr('<p>\8981\6DFB\52A0\65B0\7684\4E3B\8BB0\5F55, \8BF7\5355\51FB\6B64\9875\9876\90E8\7684<strong>\521B\5EFA</strong>\3002'),
unistr('  \5BF9\4E8E\8BE6\7EC6\4FE1\606F\8BB0\5F55, \5355\51FB\8BE6\7EC6\4FE1\606F\533A\57DF\9876\90E8\7684\52A0\53F7\56FE\6807 (+) \53EF\6DFB\52A0\8BE6\7EC6\4FE1\606F\8BB0\5F55\3002</p>'),
'',
unistr('<p>\5355\51FB\6B64\9875\9876\90E8\7684<strong>\91CD\7F6E</strong>\53EF\5C06\6B64\9875\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E, \5E76\5220\9664\4EE5\524D\5B9A\4E49\7684\4EFB\4F55\641C\7D22\8BCD\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827284287312986)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5E94\7528\7A0B\5E8F\6240\6709\8005 (\7BA1\7406\5458) \53EF\4EE5\4F7F\7528\7BA1\7406\9875\6765\914D\7F6E\5E94\7528\7A0B\5E8F\548C\7EF4\62A4\5728\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528\7684\901A\7528\6570\636E\3002'),
unistr('\901A\8FC7\9009\62E9\4E00\4E2A\53EF\7528\8BBE\7F6E, \7BA1\7406\5458\53EF\4EE5\6F5C\5728\5730\66F4\6539\5982\4F55\663E\793A\5E94\7528\7A0B\5E8F\548C/\6216\53EF\4F9B\6700\7EC8\7528\6237\4F7F\7528\7684\529F\80FD\3002</p>'),
unistr('<p>\6B64\9875\5E94\4EC5\9650\7BA1\7406\5458\8BBF\95EE\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828437537312987)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\4EFB\4F55\5DF2\9A8C\8BC1\7528\6237\9009\62E9\76F8\5E94\7684\9009\9879\3002<br>'),
unistr('\9009\62E9<strong>\5426</strong>\53EF\63D0\9AD8\5E94\7528\7A0B\5E8F\7684\5B89\5168\6027, \56E0\4E3A\53EA\6709\6307\5B9A\7528\6237\53EF\4EE5\8BBF\95EE\5E94\7528\7A0B\5E8F\3002'),
unistr('\4F46\662F, \5982\679C\5E94\7528\7A0B\5E8F\6709\5927\91CF\7528\6237\7FA4, \5219\7EF4\62A4\7528\6237\4F1A\975E\5E38\7E41\91CD, \60A8\53EF\80FD\4F1A\504F\597D\9009\62E9<strong>\662F</strong>\5E76\4EC5\8F93\5165\5E94\7528\7A0B\5E8F\7BA1\7406\5458, \4E5F\8BB8\5305\62EC\5185\5BB9\63D0\4F9B\8005\3002<br>'),
unistr('\5982\679C\60A8\9009\62E9<strong>\662F</strong>, \5219\8FD8\5FC5\987B\9009\62E9\5982\4F55\5904\7406\672A\5305\62EC\5728\7528\6237\5217\8868\4E2D\7684\7528\6237\3002</p>'),
unistr('<p>\9009\62E9\5FC5\9700\7684\7535\5B50\90AE\4EF6\5730\5740, \6216\8005\4F7F\7528\4EFB\610F\5B57\6BCD\6570\5B57\503C\7684\7528\6237\540D\3002<br>'),
unistr('\901A\5E38, \5982\679C\5E94\7528\7A0B\5E8F\4F7F\7528 (\6216\5C06\914D\7F6E\4E3A\4F7F\7528) \96C6\4E2D\9A8C\8BC1\65B9\6848, \4F8B\5982 Oracle Access Manager \6216 SSO, \5219\5E94\8BE5\5C06\6B64\8BBE\7F6E\8BBE\7F6E\4E3A<strong>\7535\5B50\90AE\4EF6\5730\5740</strong>\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \6B64\5E94\7528\7A0B\5E8F\652F\6301\4EE5\4E0B 3 \79CD\8BBF\95EE\7EA7\522B: \8BFB\8005, \5185\5BB9\63D0\4F9B\8005\548C\7BA1\7406\5458\3002'),
'<ul>',
unistr('  <li><strong>\8BFB\8005</strong>\5177\6709\6240\6709\4FE1\606F\7684\53EA\8BFB\8BBF\95EE\6743\9650, \8FD8\53EF\4EE5\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\5185\5BB9\63D0\4F9B\8005</strong>\53EF\4EE5\521B\5EFA, \7F16\8F91\548C\5220\9664\4FE1\606F\53CA\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\7BA1\7406\5458</strong>\9664\4E86\5185\5BB9\63D0\4F9B\8005\7684\529F\80FD\4E4B\5916, \8FD8\53EF\4EE5\901A\8FC7\8BBF\95EE\5E94\7528\7A0B\5E8F\7684\201C\7BA1\7406\201D\90E8\5206\6267\884C\5E94\7528\7A0B\5E8F\7684\914D\7F6E\3002</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828649278312987)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\8868\5355\53EF\8F93\5165\7528\6237, \5176\7535\5B50\90AE\4EF6\5730\5740\5E76\8BBE\7F6E\5176\8BBF\95EE\7EA7\522B\3002'),
unistr('\5728<em>\914D\7F6E\8BBF\95EE\63A7\5236</em>\4E0B\5B9A\4E49\7684\8BBE\7F6E\5C06\786E\5B9A\7528\6237\540D\662F\5FC5\987B\4E3A\7535\5B50\90AE\4EF6\5730\5740, \8FD8\662F\53EF\4EE5\4E3A\4EFB\610F\5B57\6BCD\6570\5B57\6761\76EE\3002</p>'),
unistr('<p>\6B64\5E94\7528\7A0B\5E8F\652F\6301\4EE5\4E0B 3 \79CD\8BBF\95EE\7EA7\522B: \8BFB\8005, \5185\5BB9\63D0\4F9B\8005\548C\7BA1\7406\5458\3002</p>'),
'<ul>',
unistr('  <li><strong>\8BFB\8005</strong>\5177\6709\6240\6709\4FE1\606F\7684\53EA\8BFB\8BBF\95EE\6743\9650, \8FD8\53EF\4EE5\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\5185\5BB9\63D0\4F9B\8005</strong>\53EF\4EE5\521B\5EFA, \7F16\8F91\548C\5220\9664\4FE1\606F\4EE5\53CA\67E5\770B\62A5\544A\3002</li>'),
unistr('  <li><strong>\7BA1\7406\5458</strong>\9664\4E86\5185\5BB9\63D0\4F9B\8005\7684\529F\80FD\4E4B\5916, \8FD8\53EF\4EE5\901A\8FC7\8BBF\95EE\5E94\7528\7A0B\5E8F\7684\201C\7BA1\7406\201D\90E8\5206\6267\884C\5E94\7528\7A0B\5E8F\7684\914D\7F6E\3002</li>'),
'</ul>',
unistr('<p>\7F16\8F91\73B0\6709\7528\6237\65F6, \60A8\53EF\4EE5\9501\5B9A\5176\5E10\6237, \8FD9\5C06\963B\6B62\8BE5\7528\6237\8BBF\95EE\5E94\7528\7A0B\5E8F\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong>   \5982\679C\4F7F\7528 Oracle Application Express \5E10\6237, \5219\5DE5\4F5C\533A\7BA1\7406\5458\8FD8\5FC5\987B\5C06\6B64\5904\8F93\5165\7684\7528\6237\5B9A\4E49\4E3A\6700\7EC8\7528\6237, \7BA1\7406\5458\4E5F\53EF\4EE5\8BBE\7F6E\5176\5BC6\7801\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828534799312987)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\663E\793A\5E94\7528\7A0B\5E8F\7528\6237\548C\6240\6388\4E88\8BBF\95EE\7EA7\522B\7684\62A5\544A\3002</p>'),
unistr('<p>\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002<br>'),
unistr('\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>'),
unistr('<p>\5355\51FB\201C\7F16\8F91\201D\56FE\6807 (\9EC4\8272\94C5\7B14) \53EF\7F16\8F91\7528\6237\8BE6\7EC6\4FE1\606F\548C\8BBF\95EE\7EA7\522B, \6216\8005\5220\9664\7528\6237\3002</p>'),
unistr('<p>\5355\51FB\4F4D\4E8E\62A5\544A\9876\90E8\7684<strong>\6DFB\52A0\7528\6237</strong>\53EF\6DFB\52A0\65B0\7528\6237\53CA\5176\8BBF\95EE\7EA7\522B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842029873312998)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\542F\7528\8BBF\95EE\63A7\5236\65F6\FF0C\7BA1\7406\5458\53EF\4EE5\9650\5236\5DF2\9A8C\8BC1\7528\6237\5BF9\7279\5B9A\5E94\7528\7A0B\5E8F\529F\80FD\7684\8BBF\95EE\6743\9650\3002\6B64\5E94\7528\7A0B\5E8F\652F\6301\4EE5\4E0B 3 \79CD\89D2\8272\FF1A\8BFB\8005\3001\5185\5BB9\63D0\4F9B\8005\548C\7BA1\7406\5458\3002</p>'),
'<ul>',
unistr('  <li><strong>\8BFB\8005</strong>\5177\6709\6240\6709\4FE1\606F\7684\53EA\8BFB\8BBF\95EE\6743\9650\FF0C\8FD8\53EF\4EE5\67E5\770B\62A5\8868\3002</li>'),
unistr('  <li><strong>\5185\5BB9\63D0\4F9B\8005</strong>\53EF\4EE5\521B\5EFA\FF0C\7F16\8F91\548C\5220\9664\4FE1\606F\4EE5\53CA\67E5\770B\62A5\8868\3002</li>'),
unistr('  <li><strong>\7BA1\7406\5458</strong>\FF0C\9664\4E86\5185\5BB9\63D0\4F9B\8005\7684\529F\80FD\4E4B\5916\FF0C\8FD8\53EF\4EE5\6267\884C\5E94\7528\7A0B\5E8F\7684\914D\7F6E\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862950657313014)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4EE5\9017\53F7, \5206\53F7\6216\7A7A\683C\5206\9694\7684\7528\6237\540D\3002\5C06\81EA\52A8\5FFD\7565\73B0\6709\7528\6237\540D\6216\91CD\590D\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827476294312986)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\914D\7F6E\8BBE\7F6E\53EF\4EE5\8BA9\7279\5B9A\529F\80FD\5BF9\6700\7EC8\7528\6237\53EF\7528 (\542F\7528) \6216\4E0D\53EF\7528 (\7981\7528) \3002</p>'),
unistr('<p>\5982\679C\7279\5B9A\529F\80FD\672A\5B8C\5168\51C6\5907\597D, \6216\8005\9700\8981\4E34\65F6\5220\9664, \8BF7\5355\51FB<strong>\7981\7528</strong>\3002'),
unistr('\5982\679C\5E94\4F7F\5176\53EF\7528, \5219\53EA\9700\5355\51FB<strong>\542F\7528</strong>\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \6B64\5904\6240\505A\7684\66F4\6539\4E0D\4F1A\4F53\73B0\5728\5F53\524D\6B63\5728\8FD0\884C\5E94\7528\7A0B\5E8F\7684\5355\4E2A\6700\7EC8\7528\6237\8EAB\4E0A\3002\5728\6700\7EC8\7528\6237\6CE8\9500\5E76\767B\5F55\56DE\4E4B\540E, \5C06\8C03\7528\4FEE\8BA2\540E\7684\529F\80FD\8BBE\7F6E\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827585217312986)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\4E8E\663E\793A\5E94\7528\7A0B\5E8F\7684\9ED8\8BA4\989C\8272\65B9\6848\3002</p>'),
unistr('<p>\5982\679C\9009\4E2D\4E86<strong>\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\4E3B\9898\6837\5F0F</strong>, \5219\6BCF\4E2A\6700\7EC8\7528\6237\5355\51FB\4E3B\9875\5DE6\4E0B\89D2\7684<em>\5B9A\5236</em>\94FE\63A5, \4ECE\53EF\7528\4E3B\9898\6837\5F0F\4E2D\9009\62E9\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828102741312987)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\8BE5\5E94\7528\7A0B\5E8F\8BB0\5F55\7684\6240\6709\610F\5916\9519\8BEF\7684\4EA4\4E92\5F0F\62A5\544A\3002</p>'),
unistr('<p>\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828057892312987)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\62A5\544A\548C\56FE\8868\53EF\67E5\770B\6307\5B9A\65F6\95F4\8303\56F4\5185\5177\6709\6700\591A\9875\8BBF\95EE\91CF\7684\7528\6237\3002</p>'),
unistr('<p>\9009\62E9\62A5\544A\65F6\95F4\8303\56F4 (\9ED8\8BA4\503C = 1 \5929) \5E76\5728\9875\9876\90E8\7684\62A5\544A\548C\56FE\8868\56FE\6807\4E4B\95F4\9009\62E9\3002</p>'),
unistr('<p>\5BF9\4E8E\4EA4\4E92\5F0F\62A5\544A, \4F7F\7528\641C\7D22\5B57\6BB5, \6216\8005\9009\62E9<strong>\7528\6237</strong>\5217\6807\9898\6765\9009\62E9\7279\5B9A\7528\6237\3002\5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\6267\884C\591A\79CD\529F\80FD, \4F8B\5982\663E\793A/\9690\85CF\5217, \6BCF\9875\884C\6570, \7B5B\9009\5668\7B49\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828244797312987)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\9875\6027\80FD\548C\53D7\6B22\8FCE\7A0B\5EA6\7684\4EA4\4E92\5F0F\62A5\544A\3002\62A5\544A\6309\7167<strong>\52A0\6743\6027\80FD</strong>\6392\5E8F, \8BE5\503C\901A\8FC7\5C06\7528\65F6\4E2D\503C\4E0E\9875\8BBF\95EE\91CF\76F8\4E58\5F97\5230\3002</p>'),
unistr('<p>\5982\679C\9700\8981, \53EF\5728\9875\9876\90E8\9009\62E9\62A5\544A\65F6\95F4\8303\56F4 (\9ED8\8BA4\503C = 1 \5929)\3002<br>'),
unistr('\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828361108312987)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\63D0\4F9B\6700\8FD1\9875\8BBF\95EE\91CF\7684\4EA4\4E92\5F0F\62A5\544A\3002</p>'),
unistr('<p>\5982\679C\9700\8981, \53EF\5728\9875\9876\90E8\9009\62E9\62A5\544A\65F6\95F4\8303\56F4 (\9ED8\8BA4\503C = 1 \5929)\3002<br>'),
unistr('\5355\51FB\5217\6807\9898\53EF\6392\5E8F\548C\7B5B\9009\6570\636E, \5355\51FB<strong>\64CD\4F5C</strong>\6309\94AE\53EF\5B9A\5236\5217\663E\793A\4EE5\53CA\591A\79CD\5176\4ED6\7684\9AD8\7EA7\529F\80FD\3002\5355\51FB<strong>\91CD\7F6E</strong>\6309\94AE\53EF\5C06\4EA4\4E92\5F0F\62A5\544A\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827325345312986)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\6D3B\52A8\65F6, \901A\77E5\663E\793A\5728\4E3B\9875\4E0A\3002</p>'),
unistr('<p>\6B64\62A5\544A\663E\793A\5B9A\4E49\7684\901A\77E5\4EE5\53CA\663E\793A\901A\77E5\7684\65F6\6BB5\3002</p>'),
unistr('<p>\5355\51FB\201C\7F16\8F91\201D\56FE\6807 (\9EC4\8272\94C5\7B14) \53EF\7F16\8F91\73B0\6709\901A\77E5, \5355\51FB<strong>\6DFB\52A0\901A\77E5</strong>\53EF\63D2\5165\65B0\901A\77E5\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827621687312987)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\5E94\7528\7A0B\5E8F\8F93\5165\5E94\7528\7A0B\5E8F\540D\79F0\548C\7B80\8981\8BF4\660E\3002</p>'),
unistr('<p>\5E94\7528\7A0B\5E8F\540D\79F0\663E\793A\5728\4E3B\9875\4E0A\3002\7B80\8981\8BF4\660E\663E\793A\5728\5E94\7528\7A0B\5E8F\540D\79F0\4E0B\65B9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827820064312987)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6700\7EC8\7528\6237\53EF\4EE5\5728\5E94\7528\7A0B\5E8F\4E2D\7684\4EFB\610F\666E\901A\9875\4E0A\8F93\5165\53CD\9988\3002</p>'),
unistr('<p>\6B64\62A5\544A\663E\793A\8F93\5165\7684\53CD\9988, \7BA1\7406\5458\8F93\5165\7684\4EFB\4F55\56DE\590D, \4EE5\53CA\53CD\9988\7684\72B6\6001\3002</p>'),
unistr('<p>\5355\51FB\7F16\8F91\56FE\6807 (\9EC4\8272\94C5\7B14) \53EF\8F93\5165\54CD\5E94\6216\66F4\65B0\53CD\9988\72B6\6001\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \5982\679C\5DF2\7ECF\5B9A\4E49\4E86\53CD\9988\6536\4EF6\4EBA, \5219\53CD\9988\63D0\4EA4\8FD8\5C06\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001\5230\53CD\9988\6536\4EF6\4EBA\5217\8868\4E2D\7684\7535\5B50\90AE\4EF6\5730\5740\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843950544312999)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\4EE5\9017\53F7\5206\9694\7684\7535\5B50\90AE\4EF6\5730\5740\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827964933312987)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p><strong>\542F\7528\9644\4EF6</strong> - \5982\679C\4E3A\201C\662F\201D\FF0C\5219\7528\6237\53EF\4EE5\4E0A\8F7D\9644\4EF6\4EE5\4FBF\4E3A\5176\53CD\9988\63D0\4F9B\4F9D\636E\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828983482312988)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\5217\51FA\6240\5B9A\4E49\7684\7535\5B50\90AE\4EF6\6A21\677F\4EE5\53CA\8FD9\4E9B\6A21\677F\5728\6240\53D1\9001\7535\5B50\90AE\4EF6\4E2D\7684\5F15\7528\6B21\6570\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828739161312987)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9875\5217\51FA\53D1\9001\7684\7535\5B50\90AE\4EF6\3002</p>'),
unistr('<p>\5355\51FB\201C\653E\5927\955C\201D\56FE\6807\53EF\67E5\770B\6240\53D1\9001\7535\5B50\90AE\4EF6\7684\8BE6\7EC6\4FE1\606F\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108828851128312987)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4EE5\4E0B\5B57\6BB5\4EE5\5B9A\4E49\7535\5B50\90AE\4EF6\6A21\677F:</p>'),
'<ul>',
unistr('  <li><strong>\6A21\677F\540D\79F0</strong> (\5FC5\9700) - \4E3A\6A21\677F\8F93\5165\6709\610F\4E49\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>HTML \6A21\677F</strong> (\5FC5\9700) - \8F93\5165 HTML \4EE3\7801, \8FD9\4E9B\4EE3\7801\7528\4E8E\6784\5EFA\53D1\9001\7ED9\6536\4EF6\4EBA\7684\7535\5B50\90AE\4EF6\4EE5\4F20\9001\57FA\4E8E HTML \7684\7535\5B50\90AE\4EF6\3002'),
unistr('    \66FF\4EE3\503C\5305\62EC:'),
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong> - \5C06\66FF\6362\4E3A\5E94\7528\7A0B\5E8F\7684\540D\79F0</li>'),
unistr('        <li><strong>#BODY1#</strong> - \5C06\66FF\6362\4E3A\4F7F\7528 p_body1_text \4F20\5165\7684\503C</li> '),
unistr('        <li><strong>#TABLE#</strong> - \5C06\66FF\6362\4E3A\4F7F\7528 as p_table_content \4F20\5165\7684\503C (\4F7F\7528\8868\6253\5F00 HTML, \8868\884C HTML \548C\8868\5173\95ED HTML)</li> '),
unistr('        <li><strong>#BODY2#</strong> - \5C06\66FF\6362\4E3A\4F7F\7528 p_body2_text \4F20\5165\7684\503C</li> '),
unistr('        <li><strong>#ACTION#</strong> - \5C06\66FF\6362\4E3A\4F7F\7528 p_action_label \548C p_action_link \4F20\5165\7684\503C (\4F7F\7528\64CD\4F5C\94FE\63A5\6A21\677F)</li>'),
'     </ul></li>',
unistr('  <li><strong>\7EAF\6587\672C\6A21\677F</strong> (\5FC5\9700) - \8F93\5165\7528\4E8E\6784\5EFA\7535\5B50\90AE\4EF6\7684\7EAF\6587\672C, \8BE5\7535\5B50\90AE\4EF6\53D1\9001\7ED9\4E0D\63A5\53D7\57FA\4E8E HTML \7684\7535\5B50\90AE\4EF6\7684\6536\4EF6\4EBA\3002\8FD9\4F7F\7528\4E0E HTML \6A21\677F\76F8\540C\7684\66FF\4EE3\9879, \53EA\662F #TABLE# \548C #ACTION# \5C06\5448\73B0\4E3A\7EAF\6587\672C\3002</li>'),
'<ul>',
unistr('<p>\4F7F\7528\5176\4ED6 HTML \6A21\677F\53EF\5B9E\73B0\66F4\9AD8\7EA7\7684\7535\5B50\90AE\4EF6\3002\8FD9\4E9B\9879\5305\62EC:</p>'),
'<ul>',
unistr('  <li><strong>\884C\4E4B\524D</strong> - \8F93\5165\7528\4E8E\66FF\6362 HTML \6A21\677F\4E2D\7684 #TABLE# \7684 HTML\3002\4EC5\5728\4F20\9012\4E86 p_table_content \65F6\4F7F\7528\3002</li>'),
unistr('  <li><strong>\884C\6A21\677F</strong> - \8F93\5165\7528\4E8E\5448\73B0\5404\4E2A\8868\884C\7684 HTML\3002\8FD9\5305\62EC\884C\6253\5F00/\5173\95ED\548C\6570\636E\6253\5F00/\5173\95ED (\4F7F\7528 #LABEL# \548C #VALUE# \66FF\4EE3\9879)\3002\4EC5\5728\4F20\9012\4E86 p_table_content \65F6\4F7F\7528\3002</li>'),
unistr('  <li><strong>\884C\4E4B\540E</strong> - \8F93\5165\7528\4E8E\5173\95ED\8868\6216 div \7684 HTML\3002\4EC5\5728\4F20\9012\4E86 p_table_content \65F6\4F7F\7528\3002</li>'),
unistr('  <li><strong>\64CD\4F5C\94FE\63A5 HTML</strong> - \8F93\5165\7528\4E8E\66FF\6362 HTML \6A21\677F\4E2D\7684 #ACTION# \7684 HTML\3002\5B83\5E94\5305\542B #ACTION_LINK# \548C #ACTION_TEXT#\3002\4EC5\5728\4F20\9012\4E86 p_action_label \548C p_action_link \65F6\4F7F\7528\3002</li>'),
'</ul>',
unistr('<p><em><strong>\6CE8:</strong> \53EF\4F7F\7528<strong>\9ED8\8BA4\6A21\677F</strong>\4E2D\7684\6761\76EE\4F5C\4E3A\5F00\53D1\60A8\81EA\5DF1\6A21\677F\7684\793A\4F8B\3002\9ED8\8BA4\6A21\677F\4F7F\7528\60A8\53EF\80FD\5E0C\671B, \4E5F\53EF\80FD\4E0D\5E0C\671B\5305\62EC\5230\81EA\5DF1\7535\5B50\90AE\4EF6\6A21\677F\4E2D\7684\6240\6709\66FF\4EE3\53D8\91CF\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829052699312988)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\901A\8FC7\9009\62E9<strong>\5206\53D1\7535\5B50\90AE\4EF6</strong>\9009\9879\4E4B\4E00\6765\5141\8BB8\6216\7981\6B62\53D1\9001\7535\5B50\90AE\4EF6\3002</p>'),
unistr('<p>\5728<strong>\7535\5B50\90AE\4EF6\53D1\9001\81EA</strong>\4E2D, \8F93\5165\5E94\7528\7A0B\5E8F\95EE\9898\4E3B\8981\8054\7CFB\4EBA\7684\7535\5B50\90AE\4EF6\5730\5740\3002\5F53\4F7F\7528\7535\5B50\90AE\4EF6\529F\80FD\65F6, \53EF\4EE5\4F7F\7528\6216\8986\76D6\6B64\503C\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847299697313002)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\5C06\7528\4E8E\53D1\9001\7535\5B50\90AE\4EF6\7684\53D1\4EF6\4EBA\5730\5740\3002\5F53\4F7F\7528\7535\5B50\90AE\4EF6\529F\80FD\65F6, \53EF\4EE5\8986\76D6\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864543296313015)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\586B\5145\4EE5\4E0B\9879\5E76\5355\51FB [\53D1\9001\7535\5B50\90AE\4EF6]\3002\53D1\9001\7684\6240\6709\7535\5B50\90AE\4EF6\90FD\4F1A\8BB0\5F55\5728\7535\5B50\90AE\4EF6\65E5\5FD7\4E2D\3002'),
'    <ul>',
unistr('        <li><strong>\53D1\4EF6\4EBA</strong> - \5982\679C\5728\201C\7535\5B50\90AE\4EF6\8BBE\7F6E\201D\5185\8BBE\7F6E\4E86 "\53D1\4EF6\4EBA\5730\5740", \5219\8BE5\7535\5B50\90AE\4EF6\5730\5740\5C06\662F\7528\4E8E\53D1\4EF6\4EBA\7684\9009\9879\3002\5982\679C\6B64\5E94\7528\7A0B\5E8F\4F7F\7528\7535\5B50\90AE\4EF6\5730\5740\4F5C\4E3A\7528\6237\540D, \5219\60A8\53EF\4EE5\9009\62E9\4ECE\60A8\7684\7535\5B50\90AE\4EF6\53D1\9001\7535\5B50\90AE\4EF6\3002\6700\540E,\201C\53D1\9001\81EA\201D\59CB\7EC8\53EF\4EE5\4E0E\201C\53D1\9001\5230\201D\76F8\540C\3002</li>'),
unistr('        <li><strong>\53D1\9001\5230</strong> - \5982\679C\6B64\5E94\7528\7A0B\5E8F\4F7F\7528\7535\5B50\90AE\4EF6\5730\5740\4F5C\4E3A\7528\6237\540D, \5219\53EF\4EE5\9009\62E9\5C06\7535\5B50\90AE\4EF6\53D1\9001\5230\7535\5B50\90AE\4EF6\5730\5740\548C/\6216\7528\6237\3002</li>'),
unistr('        <li><strong>\7535\5B50\90AE\4EF6\5730\5740</strong> - \7528\4E8E\63A5\6536\7535\5B50\90AE\4EF6\7684\7535\5B50\90AE\4EF6\5730\5740\7684\9017\53F7\5206\9694\5217\8868\3002\5C06\4E0D\4F1A\5305\62EC\90A3\4E9B\786E\5B9A\65E0\6548\7684\7535\5B50\90AE\4EF6\5730\5740\3002</li>'),
unistr('        <li><strong>\89D2\8272</strong> - \5C06\7535\5B50\90AE\4EF6\53D1\9001\5230\9009\5B9A\89D2\8272\7684\6240\6709\7528\6237\6216\53D1\9001\5230\5B9A\4E49\7684\6240\6709\7528\6237\3002\9009\62E9\5217\8868\5305\62EC\89D2\8272\5217\8868\4EE5\53CA\76F8\5E94\89D2\8272\5185\7528\6237\7684\8BA1\6570\3002</li>'),
unistr('        <li><strong>\6A21\677F</strong> - \9009\62E9\7528\4E8E\521B\5EFA\7535\5B50\90AE\4EF6\6B63\6587\7684\7535\5B50\90AE\4EF6\6A21\677F\3002</li>'),
unistr('        <li><strong>\4E3B\9898</strong> - \7535\5B50\90AE\4EF6\7684\4E3B\9898\3002</li>'),
unistr('        <li><strong>\7535\5B50\90AE\4EF6\6B63\6587</strong> - \8981\4F5C\4E3A\7535\5B50\90AE\4EF6\6B63\6587\5305\62EC\7684\6587\672C\3002</li>'),
unistr('        <li><strong>\5141\8BB8\9009\62E9\9000\51FA</strong> - \5373\4F7F\7528\6237\9009\62E9\4E0D\63A5\6536\7535\5B50\90AE\4EF6, \4ECD\4F1A\53D1\9001\67D0\4E9B\7535\5B50\90AE\4EF6\3002\8FD9\4E9B\7535\5B50\90AE\4EF6\5305\62EC\505C\673A\6D88\606F\7B49\3002\6B64\6807\8BB0\786E\5B9A\662F\5E94\5141\8BB8\9009\62E9\4E0D\53D1\9001\6B64\7535\5B50\90AE\4EF6, \8FD8\662F\5E94\53D1\9001\6B64\7535\5B50\90AE\4EF6\800C\4E0D\8003\8651\7528\6237\7684\9996\9009\9879\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866271337313016)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\586B\5145\4EE5\4E0B\9879\5E76\5355\51FB [\53D1\9001\7535\5B50\90AE\4EF6]\3002\53D1\9001\7684\6240\6709\7535\5B50\90AE\4EF6\90FD\4F1A\8BB0\5F55\5728\7535\5B50\90AE\4EF6\65E5\5FD7\4E2D\3002'),
'    <ul>',
unistr('        <li><strong>\53D1\4EF6\4EBA</strong> - \5982\679C\5728\201C\7535\5B50\90AE\4EF6\8BBE\7F6E\201D\5185\8BBE\7F6E\4E86 "\53D1\4EF6\4EBA\5730\5740", \5219\8BE5\7535\5B50\90AE\4EF6\5730\5740\5C06\662F\7528\4E8E\53D1\4EF6\4EBA\7684\9009\9879\3002\5426\5219,\201C\53D1\9001\81EA\201D\59CB\7EC8\53EF\4EE5\4E0E\201C\53D1\9001\5230\201D\76F8\540C\3002</li>'),
unistr('        <li><strong>\7535\5B50\90AE\4EF6\5730\5740</strong> - \7528\4E8E\63A5\6536\7535\5B50\90AE\4EF6\7684\7535\5B50\90AE\4EF6\5730\5740\7684\9017\53F7\5206\9694\5217\8868\3002\5C06\4E0D\4F1A\5305\62EC\90A3\4E9B\786E\5B9A\65E0\6548\7684\7535\5B50\90AE\4EF6\5730\5740\3002</li>'),
unistr('        <li><strong>\6A21\677F</strong> - \9009\62E9\7528\4E8E\521B\5EFA\7535\5B50\90AE\4EF6\6B63\6587\7684\7535\5B50\90AE\4EF6\6A21\677F\3002</li>'),
unistr('        <li><strong>\4E3B\9898</strong> - \7535\5B50\90AE\4EF6\7684\4E3B\9898\3002</li>'),
unistr('        <li><strong>\7535\5B50\90AE\4EF6\6B63\6587</strong> - \8981\4F5C\4E3A\7535\5B50\90AE\4EF6\6B63\6587\5305\62EC\7684\6587\672C\3002</li>'),
unistr('        <li><strong>\5141\8BB8\9009\62E9\9000\51FA</strong> - \5373\4F7F\7528\6237\9009\62E9\4E0D\63A5\6536\7535\5B50\90AE\4EF6, \4ECD\4F1A\53D1\9001\67D0\4E9B\7535\5B50\90AE\4EF6\3002\8FD9\4E9B\7535\5B50\90AE\4EF6\5305\62EC\505C\673A\6D88\606F\7B49\3002\6B64\6807\8BB0\786E\5B9A\662F\5E94\5141\8BB8\9009\62E9\4E0D\53D1\9001\6B64\7535\5B50\90AE\4EF6, \8FD8\662F\5E94\53D1\9001\6B64\7535\5B50\90AE\4EF6\800C\4E0D\8003\8651\7528\6237\7684\9996\9009\9879\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827721109312987)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\5E94\7528\7A0B\5E8F\6240\6709\7528\6237\7684\9ED8\8BA4\65F6\533A\3002</p>'),
unistr('<p>\5355\4E2A\7528\6237\53EF\4EE5\901A\8FC7\5355\51FB\5176\7528\6237\540D (\53F3\4E0A\89D2) \5E76\9009\62E9<strong>\9996\9009\9879</strong>\6765\8986\76D6\6B64\8BBE\7F6E\3002\6B64\5916, \7528\6237\53EF\4EE5\5355\51FB\663E\793A\5728\4E3B\9875\5E95\90E8\7684\65F6\533A\94FE\63A5\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843692636312999)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\65E0\6CD5\76F4\63A5\901A\8FC7 UI \8BBF\95EE\3002\5B83\7528\4E8E\534F\52A9\6982\8981\4FE1\606F\76F8\7247\4E0B\8F7D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843322984312999)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\201C\7528\6237\6982\8981\4FE1\606F\201D\9875\53EF\4EE5\5728\4E00\4E2A\6613\7528\7684\5C4F\5E55\4E0A\67E5\770B\7528\6237\7684\76F8\5173\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843021746312999)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\4E0A\8F7D\65B9\5F62\7684\76F8\7247, \5426\5219\76F8\7247\4F1A\53D8\5F62\3002\9996\9009\56FE\50CF\5927\5C0F\4E3A 250x250 \50CF\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108829161826312988)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\8868\5355\53EF\4EE5\66F4\65B0\4E2A\4EBA\8BE6\7EC6\4FE1\606F\548C\4E0A\8F7D\76F8\7247\6216\5934\50CF\3002</p>'),
unistr('<p>\8981\4E0A\8F7D\56FE\50CF, \8BF7\5355\51FB<strong>\6D4F\89C8</strong>\6216\5C06\56FE\50CF\62D6\653E\5230\6309\94AE\4E0A\3002<br>'),
unistr('\8BF7\4E0A\8F7D\6B63\65B9\5F62\7684\76F8\7247, \5426\5219\76F8\7247\4F1A\53D8\5F62\3002\9996\9009\56FE\50CF\5927\5C0F\4E3A 250x250 \50CF\7D20\3002</p>'),
unistr('<p>\5355\51FB<strong>\5220\9664\76F8\7247</strong>\53EF\5220\9664\56FE\50CF\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849274283313003)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\6B64\9875\53EF\4EE5\8BBF\95EE\6240\6709\5E94\7528\7A0B\5E8F\5E2E\52A9\6587\672C\3002"\6587\6863" \533A\57DF\4E2D\7684\94FE\63A5\63D0\4F9B\4E86\6709\5173\5E94\7528\7A0B\5E8F\7279\8272\548C\529F\80FD\7684\66F4\591A\6DF1\5165\8BF4\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830225553312989)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\9875\4E0A\53EF\4EE5\4E3A\5E10\6237\8BBE\7F6E\5E94\7528\7A0B\5E8F\9996\9009\9879\3002\9996\9009\9879\53EF\5F71\54CD\5E94\7528\7A0B\5E8F\7684\591A\4E2A\65B9\9762, \4F8B\5982\65F6\533A\3002\5355\51FB\9879\7EA7\522B\7684\5E2E\52A9\56FE\6807\53EF\4EE5\4E86\89E3\5404\9996\9009\9879\7684\4F5C\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933034583312272)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6B64\62A5\544A\663E\793A\6392\961F\7B49\5F85\53D1\9001\7684\6240\6709\7535\5B50\90AE\4EF6\4EE5\53CA\5DF2\7ECF\53D1\9001\7684\7535\5B50\90AE\4EF6\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054520589312366)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6B64\62A5\8868\5305\62EC\9009\5B9A\8981\7531\8BE5\5E94\7528\7A0B\5E8F\76D1\89C6\7684\6240\6709\4F5C\4E1A\3002\53EF\4EE5\901A\8FC7\5355\51FB\4F5C\4E1A\540D\79F0\6765\67E5\770B\5404\4E2A\4F5C\4E1A\7684\8BE6\7EC6\4FE1\606F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061180684312372)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6B64\62A5\8868\5305\62EC\6709\5173\9009\5B9A\8981\7531\8BE5\5E94\7528\7A0B\5E8F\76D1\89C6\7684\4F5C\4E1A\7684\8FD0\884C\8BE6\7EC6\4FE1\606F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814562978312976)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\201C\5173\4E8E\6B64\5E94\7528\7A0B\5E8F\201D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830993299312989)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\4E0D\5E0C\671B\63A5\6536\6765\81EA\6B64\5E94\7528\7A0B\5E8F\7684\7535\5B50\90AE\4EF6, \5219\5C06\6B64\9009\9879\8BBE\7F6E\4E3A\201C\5426\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864012421313015)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\641C\7D22\5BF9\8BDD\6846\4E2D\8F93\5165\641C\7D22\8BCD\5E76\5355\51FB<strong>\641C\7D22</strong>\3002<br>'),
unistr('\5355\51FB\4EFB\610F\7ED3\679C\6807\9898\53EF\5BFC\822A\5230\8BE5\7279\5B9A\8BB0\5F55\3002</p>'),
unistr('<p>\8981\9650\5236\641C\7D22, \8BF7\53D6\6D88\9009\4E2D\4E00\4E2A\6216\591A\4E2A\6E90, \8FD9\5C06\4ECE\641C\7D22\7ED3\679C\4E2D\5220\9664\8BE5\62A5\544A\3002</p>'),
unistr('<p>\5355\51FB<strong>\91CD\7F6E</strong>\53EF\5220\9664\5F53\524D\641C\7D22\8BCD\5E76\9009\4E2D\6240\6709\6E90\3002</p> ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830745441312989)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5728\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528\7684\9996\9009\65F6\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828938813312192)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\9879\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850826371313005)
,p_name=>'CA.HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856963125313009)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872245683313021)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\5C0F\65F6\9875\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932147186312271)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6B63\6587\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847687728313002)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844389318313000)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FDB\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868463708313018)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\5728\8868\5355\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868304405313018)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\5728\62A5\8868\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108853038295313006)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\652F\6301\5BF9\8C61\811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055248114312367)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F8B ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056413116312368)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F8B\6EDE\7559')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826738898312986)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B22\8FCE\4F7F\7528\8FD9\79CD\53EA\652F\6301\4E91\9884\89C8\7684\5168\65B0\6539\8FDB\65B9\6CD5\6765\521B\5EFA\5177\6709\66F4\5B8C\5907\529F\80FD\7684\5E94\7528\7A0B\5E8F\3002\6807\51C6\7684\201C\521B\5EFA\5E94\7528\7A0B\5E8F\201D\5411\5BFC\53EA\5141\8BB8\60A8\9009\62E9\8981\751F\6210\7684\9875, \800C\6B64\5411\5BFC\8FD8\53EF\4EE5\5C06\591A\79CD\989D\5916\529F\80FD\5FEB\901F\9884\52A0\8F7D\5230\5E94\7528\7A0B\5E8F\4E2D\3002</p>'),
unistr('<p>\4F7F\7528\6B64\5411\5BFC\751F\6210\7684\5E94\7528\7A0B\5E8F\53EF\83B7\5F97\5B8C\6574\7684\652F\6301, \5E76\4E14\8FD8\53EF\4EE5\5305\62EC\6240\9009\529F\80FD\7684\652F\6301\5BF9\8C61, \4F8B\5982\8BBF\95EE\63A7\5236, \7535\5B50\90AE\4EF6\6846\67B6, \53CD\9988\7B49\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826925713312986)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9996\5148\8F93\5165\5E94\7528\7A0B\5E8F\540D\79F0\3002\63A5\4E0B\6765\5C06\4E00\9875\6216\591A\9875\6DFB\52A0\5230\5E94\7528\7A0B\5E8F\3002\9009\4E2D\8981\5305\62EC\7684\529F\80FD\3002\9009\62E9\5E94\7528\7A0B\5E8F\7684\5916\89C2, \7136\540E\67E5\770B\8BBE\7F6E\3002<br>'),
unistr('\4E5F\5C31\662F\5355\51FB<strong>\521B\5EFA\5E94\7528\7A0B\5E8F</strong>\5C31\53EF\4EE5\5F00\59CB!</p>'),
unistr('<p>\5355\51FB<strong>\67E5\770B\84DD\56FE</strong>\4EE5\91CD\7528\4EE5\524D\6240\751F\6210\5E94\7528\7A0B\5E8F\4E2D\7684\6A21\578B\6216\5FEB\901F\590D\5236\9875\3002</p>'),
unistr('<p><em><strong>\6CE8:</strong> \5404\4E2A\90E8\5206\548C\5404\4E2A ''\6DFB\52A0\9875'' \5305\62EC\8BE6\7EC6\7684\5E2E\52A9, \53EF\4E3A\60A8\63D0\4F9B\8FDB\4E00\6B65\6307\5BFC\3002</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826859861312986)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\4F55\4F7F\7528\672C\5411\5BFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860441096313012)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E0B\9762\5217\51FA\4E86\53D1\884C\65F6\5B58\5728\7684\91CD\5927\95EE\9898:'),
'<ol>',
unistr('  <li>\201C\4ECE\84DD\56FE\521B\5EFA\5E94\7528\7A0B\5E8F\201D\5411\5BFC\672A\7FFB\8BD1\3002</li>'),
unistr('  <li>\901A\8FC7\6B64\5411\5BFC\751F\6210\7684\5DF2\7FFB\8BD1\5E94\7528\7A0B\5E8F\4EC5\662F\90E8\5206\7FFB\8BD1\7684\3002</li>'),
unistr('  <li>\62A5\544A\7EC6\5316\4EC5\5141\8BB8\4E00\4E2A\7EC6\5316\5217\3002</li>'),
unistr('  <li>\65E0\6CD5\751F\6210\7B5B\9009\62A5\544A\9875\3002</li>'),
unistr('  <li>\7535\5B50\90AE\4EF6\529F\80FD\63D0\4F9B\4F4E\7EA7\522B API, \4F46\5C1A\672A\5305\62EC\8F83\9AD8\7EA7\522B\7684\7535\5B50\90AE\4EF6\529F\80FD\3002</li>'),
unistr('  <li>\4ECE\5F15\7528\7F3A\5C11\8868\7684\84DD\56FE\751F\6210\5E94\7528\7A0B\5E8F\7684\64CD\4F5C\5C06\975E\6B63\5E38\5931\8D25\3002</li>'),
unistr('  <li>\9AD8\7EA7\8BBE\7F6E - \672A\5411\751F\6210\7684\5E94\7528\7A0B\5E8F\5E94\7528\65E5\671F\683C\5F0F\3002</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860393551313012)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\77E5\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827121674312986)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53D1\5E03\65F6\95F4: %0\3002</p>'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108827022616312986)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826642372312986)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4ECE\84DD\56FE\521B\5EFA\5E94\7528\7A0B\5E8F\201D\5411\5BFC {\4EC5\4E91\9884\89C8}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838299116312995)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IP \5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836417448312993)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IR \641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839432237312996)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IR \641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866852197313017)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059293338312371)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060756592312372)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059875115312371)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\521B\5EFA\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060996869312372)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057441250312369)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054457400312366)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094562849312399)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\652F\6301\6B64\5E94\7528\7A0B\5E8F\7684\4F5C\4E1A\7684\72B6\6001\548C\8FD0\884C\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061013043312372)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\8FD0\884C\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059933571312371)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060042669312371)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\5B50\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059322564312371)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056030622312367)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\6743\91CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867384502313017)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\952E\5B57\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869145681313018)
,p_name=>'CA.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867664925313017)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869308673313019)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\590D\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869083598313018)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5355\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825835776312985)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825988243312985)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\5E94\7528\7A0B\5E8F\7684\4E3B\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859802935313012)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\4E3B\8BED\8A00\8868\793A\7528\4E8E\663E\793A\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\4E2D\751F\6210\7684\9875\548C\7EC4\4EF6\7684\8BED\8A00\3002\5982\679C\9009\62E9\591A\79CD\7FFB\8BD1, \6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\5448\73B0\8FD0\884C\65F6\5E94\7528\7A0B\5E8F\6240\7528\7684\8BED\8A00\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192264522312476)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842834952312998)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060187654312371)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\8FD0\884C\6301\7EED\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060215014312371)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872690171313021)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\65B0\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868557652313018)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863902452313015)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\84DD\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062513086312373)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062675326312373)
,p_name=>'CA.LOG.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056798361312368)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\8BB0\5F55\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739914929312912)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830170611312193)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>\67E5\627E\5217</strong> - \5C55\5F00\53EF\67E5\770B\7528\4E8E\5B9A\4E49\5BF9\5176\4ED6\8868\7684\67E5\627E\7684\5C5E\6027\3002\4F7F\7528\201C\67E5\627E\5217\201D\53EF\4F7F\7528\663E\793A\5217\66FF\6362\6807\8BC6\7B26\FF0C\4F8B\5982\663E\793A\90E8\95E8\540D\79F0\800C\4E0D\662F\90E8\95E8\7F16\53F7\3002<br>'),
unistr('<em><strong>\6CE8\FF1A</strong>\53EA\6709\5728\5F53\524D\9875\57FA\4E8E\8868\6216\89C6\56FE\5E76\4E14\5177\6709\5BF9\5176\4ED6\8868\7684\5916\952E\7EA6\675F\6761\4EF6\65F6\FF0C\624D\4F1A\663E\793A\201C\67E5\627E\5217\201D\3002'),
'  <ul>',
unistr('    <li><strong>\67E5\627E\5173\952E\5B57</strong> - \9009\62E9\8981\66F4\6539\4E3A\7528\4E8E\8F93\51FA\663E\793A\5217\7684\5217\3002</li>'),
unistr('    <li><strong>\663E\793A\5217</strong> - \9009\62E9\8981\663E\793A\7684\5217\FF08\4ECE\67E5\627E\8868\4E2D\FF09\3002</li>'),
'    &nbsp;<br>',
unistr('    <em><strong>\6CE8\FF1A</strong>\53EA\9009\62E9\5177\6709\5BF9\5176\4ED6\8868\7684\5F15\7528\7684\5217\FF08\4F7F\7528\5916\952E\FF09\3002</em></li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846859604313002)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844824527313000)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840963005312997)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\7528\6237\8BBF\95EE\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873273546313021)
,p_name=>'CA.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\4E3B\4ECE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873391109313022)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\4E00\4E2A\9875\FF0C\5728\5176\4E2D\663E\793A\4E3B\4ECE\9875\4EE5\5141\8BB8\6700\7EC8\7528\6237\67E5\770B\548C\7EF4\62A4\6570\636E\3002<br>'),
'&nbsp;</p>',
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\9875\7C7B\578B</strong> - \9009\62E9\9875\7684\7C7B\578B [\5E76\6392\3001\5806\53E0]\3002<br>'),
unistr('    <strong>\5E76\6392</strong>\FF1A<br>'),
unistr('<em>\5229\7528\7F16\6392\5E03\5C40\548C\5305\542B\6A21\5F0F\7F16\8F91\7A97\53E3\7684\62A5\8868\533A\57DF\7684\5355\9875\4E3B\4ECE\3002</em>'),
'    <ul>',
unistr('      <li><strong>\8868</strong>\FF08\5FC5\9700\FF09- \4E3A\9875\9009\62E9\4E3B\8868\3002</li>'),
unistr('      <li><strong>\4E3B\663E\793A\5217</strong>\FF08\5FC5\9700\FF09- \9009\62E9\8981\5728\4E3B\8BB0\5F55\5217\8868\4E2D\663E\793A\7684\5217\3002</li>'),
unistr('      <li><strong>\6B21\663E\793A\5217</strong>\FF08\5FC5\9700\FF09- \9009\62E9\8981\5728\4E3B\8BB0\5F55\5217\8868\4E2D\7684\4E3B\663E\793A\5217\4E0B\65B9\663E\793A\7684\8BF4\660E\6027\5217\3002</li>'),
unistr('      <li><strong>\4ECE\8868 1</strong>\FF08\5FC5\9700\FF09- \4E3A\9875\9009\62E9\7B2C\4E00\4E2A\4ECE\8868\3002</li>'),
unistr('      <li><strong>\4ECE\8868 2</strong> - \4E3A\9875\9009\62E9\7B2C\4E8C\4E2A\4ECE\8868\3002</li>'),
unistr('      <li><strong>\4ECE\8868 3</strong> - \4E3A\9875\9009\62E9\7B2C\4E09\4E2A\4ECE\8868\3002</li>'),
unistr('      <li><strong>\4ECE\8868 4</strong> - \4E3A\9875\9009\62E9\7B2C\56DB\4E2A\4ECE\8868\3002</li>'),
'    </ul>',
unistr('   <strong>\5806\53E0</strong>\FF1A<br>'),
unistr('<em>\5229\7528\53EF\7F16\8F91\4EA4\4E92\5F0F\7F51\683C\7684\5355\9875\4E3B\4ECE\3002</em>'),
'    <ul>',
unistr('      <li><strong>\8868</strong>\FF08\5FC5\9700\FF09- \4E3A\53EF\7F16\8F91\7684\4EA4\4E92\5F0F\7F51\683C\9009\62E9\4E3B\8868\3002</li>'),
unistr('      <li><strong>\4ECE\8868</strong>\FF08\5FC5\9700\FF09- \4E3A\9875\9009\62E9\4ECE\8868\3002</li>'),
unistr('      <em><strong>\6CE8\FF1A</strong>\4F7F\7528\5411\5BFC\53EA\80FD\6DFB\52A0\4E00\4E2A\4ECE\8868\FF08\53EF\7F16\8F91\7684\4EA4\4E92\5F0F\7F51\683C\FF09\3002\53EF\5728\751F\6210\540E\8F7B\677E\5730\6DFB\52A0\5176\4ED6\4ECE\8868\3002</em>'),
'    </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192103085312476)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837117925312994)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\957F\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057201675312369)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5931\8D25\6B21\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056832848312368)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\957F\8FD0\884C\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057358219312369)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\8FD0\884C\6B21\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867583469313017)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870558246313019)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861185567313012)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861556950313013)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861077943313012)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861902751313013)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862001161313013)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\503C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861285598313013)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860660809313012)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860514636313012)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861665204313013)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860920855313012)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860853062313012)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861427209313013)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5DF2\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861348828313013)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5DF2\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860785975313012)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861753533313013)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108861804067313013)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836602609312994)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\65F6\4E2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845718302313001)
,p_name=>'CA.MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739743755312912)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870010797313019)
,p_name=>'CA.METRIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EA6\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837550257312994)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\77ED\7528\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840383656312996)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8\7535\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836127446312993)
,p_name=>'CA.MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849920612313004)
,p_name=>'CA.MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839514887312996)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'zh-cn'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872467037313021)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\6D3B\8DC3\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830224237312193)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4E2A\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830331414312193)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\68C0\67E5\4E00\4E2A\6216\591A\4E2A\8868\540D\6216\89C6\56FE\540D\79F0\3002\6B64\5916\FF0C\5355\51FB\6807\9898\4E2D\7684\590D\9009\6846\53EF\4EE5\9009\62E9\6216\53D6\6D88\9009\62E9\5217\51FA\7684\6240\6709\6570\636E\5E93\5BF9\8C61\3002</p>'),
unistr('<p>\5C06\4E3A\6BCF\4E2A\9009\4E2D\7684\6570\636E\5E93\5BF9\8C61\6DFB\52A0\5177\6709\4EA4\4E92\5F0F\62A5\8868\7684\9875\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833553204312991)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\65F6\95F4\6233\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869815253313019)
,p_name=>'CA.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825093117312984)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825183000312985)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\5728\5E94\7528\7A0B\5E8F\4FA7\9762\8FD8\662F\9876\90E8\663E\793A\83DC\5355\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876574295313024)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D1F\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876452340313024)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862551354313014)
,p_name=>'CA.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057074733312368)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\6B21\8FD0\884C\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055925948312367)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('NLS \73AF\5883')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144972747312439)
,p_name=>'CA.NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844466186313000)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108856073696313009)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6B64\9875\7684\5E2E\52A9\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829075389312192)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\6709\6548\7528\6237 - \9875\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863559854313014)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\6709\6548\7684\65B0\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859620516313011)
,p_name=>'CA.NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840682934312997)
,p_name=>'CA.NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816109958312977)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814962212312976)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9875\4E0A\663E\793A\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816238207312977)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\5E94\7528\7A0B\5E8F\7BA1\7406\5458\6307\5B9A\5728\5E94\7528\7A0B\5E8F\4E3B\9875\4E0A\5411\6240\6709\6700\7EC8\7528\6237\663E\793A\7684\9884\8B66\FF08\9EC4\8272\FF09\6216\9519\8BEF\FF08\7EA2\8272\FF09\3002\6B64\529F\80FD\5BF9\4E8E\5411\6700\7EC8\7528\6237\793E\533A\4F20\9012\91CD\8981\4FE1\606F\975E\5E38\6709\7528\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6\FF1A<ul>'),
unistr('<li>\80FD\591F\5B9A\4E49\901A\77E5</li>'),
unistr('<li>\5728\5E94\7528\7A0B\5E8F\4E3B\9875\4E0A\663E\793A\901A\77E5</li>'),
unistr('<li>\80FD\591F\63A7\5236\663E\793A\901A\77E5\7684\65F6\95F4\7A97\53E3</li>'),
unistr('<li>\652F\6301\6309\7C7B\578B\5BF9\901A\77E5\8FDB\884C\989C\8272\7F16\7801</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832829114312991)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836358069312993)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059179567312371)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\7684\6570\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055710751312367)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868047240313018)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837805740312994)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\73B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876796145313024)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9664\975E\6709\5176\4ED6\7BA1\7406\5458, \5426\5219\60A8\65E0\6CD5\6267\884C\6B64\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844695554313000)
,p_name=>'CA.OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817622064312979)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\7EC4\7EC7\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817936550312979)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6309\7167\60A8\5E0C\671B\5728\5E94\7528\7A0B\5E8F\4E2D\663E\793A\7684\987A\5E8F\6765\6392\5217\9875\3002<br>'),
unistr('\8981\5728\5217\8868\4E2D\5BF9\9875\8FDB\884C\91CD\65B0\6392\5E8F\FF0C\8BF7\5355\51FB\5E76\6309\4F4F\6BCF\4E2A\9875\5217\8868\5C3E\90E8\7684<em>\62D6\52A8\4EE5\5BF9\9875\91CD\65B0\6392\5E8F</em>\56FE\6807 (<span class="fa fa-bars" aria-hidden="true"></span>)\FF0C\7136\540E\5411\4E0A\6216\5411\4E0B\62D6\653E\76F8\5E94\9875\3002</p>'),
unistr('<p>\4E3B\9875\59CB\7EC8\4F18\5148\663E\793A\FF0C\4E0D\80FD\8FDB\884C\91CD\65B0\6392\5E8F\3002<br>'),
unistr('\7BA1\7406\9875\59CB\7EC8\663E\793A\5728\5217\8868\5E95\90E8\FF0C\987A\5E8F\5C06\6307\660E\8FD9\4E9B\9875\5728\201C\7BA1\7406\201D\9875\4E0A\7684\201C\5E94\7528\7A0B\5E8F\7BA1\7406\201D\5217\8868\4E2D\7684\663E\793A\987A\5E8F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061265495312372)
,p_name=>'CA.OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062478546312373)
,p_name=>'CA.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836061629312993)
,p_name=>'CA.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839240227312996)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851798516313005)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838330306312995)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193971139312478)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\4E3B\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194189176312478)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835628887312993)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851040444313005)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837730449312994)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862672843313014)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7C7B\578B "%0" \4E0D\662F\6709\6548\7684\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837038542312994)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818101222312979)
,p_name=>'CA.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108818240090312979)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B9A\4E49\8981\5305\62EC\5728\521D\59CB\5E94\7528\7A0B\5E8F\4E2D\7684\9875\3002\5FC5\987B\81F3\5C11\5148\5B9A\4E49\4E00\9875\FF0C\7136\540E\624D\80FD\521B\5EFA\5E94\7528\7A0B\5E8F\3002</p>'),
unistr('<p>\60A8\53EF\4EE5\4F7F\7528\6B64\5411\5BFC\521B\5EFA\4EFB\610F\6570\91CF\7684\9875\6765\7F16\5199\51FA\5E94\7528\7A0B\5E8F\3002\521B\5EFA\5E94\7528\7A0B\5E8F\4E4B\540E\FF0C\4F7F\7528\201C\521B\5EFA\9875\201D\5411\5BFC\53EF\6DFB\52A0\66F4\591A\9875\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867998388313018)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9875\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837388632312994)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\5206\9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843164181312999)
,p_name=>'CA.PHOTO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7167\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843727510312999)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\7167\7247\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843289830312999)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7167\7247\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842991784312998)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7167\7247\4E0A\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739858693312912)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E  \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847720550313002)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108876328799313024)
,p_name=>'CA.POSITIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830590486312989)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873908427313022)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868620838313018)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869545314313019)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869660027313019)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\7236\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837943552312995)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831135447312989)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\7535\5B50\90AE\4EF6\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108193705722312477)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740063429312912)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\65E5\5FD7\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832345661312990)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\5E94\7528\7A0B\5E8F\5916\89C2\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831067192312989)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\65F6\533A\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843592272312999)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6982\8981\4FE1\606F\76F8\7247\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059400951312371)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059552800312371)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572407666311994)
,p_name=>'CA.PWA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\6E10\8FDB\5F0F Web \5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572328718311994)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\60A8\7684\5E94\7528\7A0B\5E8F\53EF\4EE5\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572503048311994)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6E10\8FDB\5F0F Web \5E94\7528\7A0B\5E8F\662F\8BBE\8BA1\4E3A\529F\80FD\5F3A\5927\3001\53EF\9760\4E14\53EF\5B89\88C5\7684 Web \5E94\7528\7A0B\5E8F\3002\6E10\8FDB\5F0F Web \5E94\7528\7A0B\5E8F\611F\89C9\5C31\50CF\662F\7279\5B9A\4E8E\5E73\53F0\7684\5E94\7528\7A0B\5E8F\3002 </p>'),
unistr('<p>\542F\7528\6B64\9009\9879\5C06\FF1A</p>'),
'<ul>',
unistr('<li>\6DFB\52A0\4E00\4E2A\65B0\7684\5BFC\822A\680F\6761\76EE\FF1A\5B89\88C5\5E94\7528\7A0B\5E8F</li>'),
unistr('<li>\5141\8BB8\7528\6237\5728\8BBE\5907\4E0A\5B89\88C5\6B64 APEX \5E94\7528\7A0B\5E8F</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568450268311991)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868901854313018)
,p_name=>'CA.QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056213788312368)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\53D1\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697955063312091)
,p_name=>'CA.RATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BC4\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841461205312997)
,p_name=>'CA.READERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BFB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830827302312989)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A5\6536\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872541137313021)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\8FD1\7684\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508613942312732)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508721048312732)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833078871312991)
,p_name=>'CA.RED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846660270313001)
,p_name=>'CA.REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192893155312477)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\7BA1\7406\9875')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810117442312177)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5BF9\8BDD\6846\5173\95ED\65F6\5237\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108194062828312478)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832568145312990)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832456715312990)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9879\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838486887312995)
,p_name=>'CA.REGION.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850407509313004)
,p_name=>'CA.RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817735648312979)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5220\9664\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817834297312979)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB<strong>\7F16\8F91</strong>\53EF\9009\62E9\9875, \7136\540E\5355\51FB<strong>\5220\9664\9875</strong>\53EF\4ECE\5E94\7528\7A0B\5E8F\4E2D\5220\9664\9875\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060882014312372)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\95F4\9694 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932715506312271)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56DE\590D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823560365312983)
,p_name=>'CA.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\62A5\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108823477073312983)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\4EA4\4E92\5F0F\62A5\8868\6216\7ECF\5178\62A5\8868\7684\9875\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\67E5\8BE2\7C7B\578B</strong> - \9009\62E9\62A5\8868\7684\6E90 [<strong>\8868\6216\89C6\56FE</strong>\6216 <strong>SQL \67E5\8BE2</strong>]\FF1A<br>'),
unistr('    <strong>\8868\6216\89C6\56FE</strong>\FF1A'),
'    <ul>',
unistr('      <li>\8868\6216\89C6\56FE\FF08\5FC5\9700\FF09- \9009\62E9\62A5\8868\7684\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('      <li>\5305\62EC\8868\5355 - \9009\62E9\6B64\9879\53EF\5305\62EC\94FE\63A5\7684\8868\5355\9875\FF0C\4EE5\5141\8BB8\7528\6237\7EF4\62A4\8868\503C\3002</li>'),
'    </ul>',
unistr('    <strong>SQL \67E5\8BE2</strong>\FF1A'),
'    <ul>',
unistr('      <li>SQL \67E5\8BE2\FF08\5FC5\9700\FF09- \8F93\5165\8FD4\56DE\552F\4E00\5217\7684\6709\6548 SQL \8BED\53E5\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>\62A5\8868\7C7B\578B</strong> - \9009\62E9\62A5\8868\7684\7C7B\578B\FF08<strong>\4EA4\4E92\5F0F\62A5\8868</strong>\6216<strong>\7ECF\5178\62A5\8868</strong>\FF09\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108815236970312977)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\8868\5355\7684 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697865096312879)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871669875313020)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870213298313019)
,p_name=>'CA.REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062252256312373)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\7684\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870469863313019)
,p_name=>'CA.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848525478313003)
,p_name=>'CA.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844536823313000)
,p_name=>'CA.RESOLVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844298998313000)
,p_name=>'CA.RESPONSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\54CD\5E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057537593312369)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\73B0\6545\969C\65F6\91CD\65B0\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057602715312369)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6062\590D\65F6\91CD\65B0\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054850722312366)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\91CD\65B0\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108057113896312368)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\8BD5\6B21\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865411217313016)
,p_name=>'CA.ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838613904312995)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108847918011313002)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864883583313015)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6A21\677F HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866143113313016)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839323049312996)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\53D6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867814616313018)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060412928312372)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062055123312373)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\6301\7EED\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056956469312368)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\5EA6\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058963085312370)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\5EA6\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108059076759312370)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\5EA6\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058889765312370)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\5EA6\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826034407312985)
,p_name=>'CA.SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826185307312985)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\9009\62E9\5C06\8981\5728\6B64\6570\636E\5E93\4E2D\4F7F\7528\7684\6570\636E\5E93\5BF9\8C61\5B58\50A8\5230\7684\6570\636E\5E93\65B9\6848\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866999165313017)
,p_name=>'CA.SCOPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848661276313003)
,p_name=>'CA.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848781327313003)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848804886313003)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\641C\7D22\201D\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108871819645313020)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855550433313008)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B64\9875\57FA\4E8E\79F0\4E3A\201C\5DF2\641C\7D22\8868\201D\7684\5171\4EAB\7EC4\4EF6\5217\8868\3002'),
'',
unistr('\6700\521D\4ECE\201C\521B\5EFA\5E94\7528\7A0B\5E8F\201D\5411\5BFC\751F\6210\7684\6240\6709\4EA4\4E92\5F0F\62A5\544A\9875\90FD\5C06\81EA\52A8\6DFB\52A0\5230\6B64\5217\8868\4E2D\3002'),
unistr('\8981\5C06\60A8\81EA\5DF1\7684\8868\6DFB\52A0\5230\6B64\5217\8868\5E76\5BFC\822A\5230\5171\4EAB\7EC4\4EF6, \8BF7\9009\62E9\201C\5217\8868\201D, \7136\540E\5355\51FB\201C\5DF2\641C\7D22\8868\201D\3002'),
unistr('  \8F93\5165\4EE5\4E0B\5C5E\6027:'),
unistr('    \6761\76EE: \5217\8868\6761\76EE\6807\7B7E - \8F93\5165\8868\7684\663E\793A\540D\79F0\3002'),
unistr('    \76EE\6807: \9875 - \9009\62E9\8981\5BFC\822A\5230\7684\76F8\5E94\9875 (\9996\9009\4EA4\4E92\5F0F\62A5\544A)'),
unistr('    \76EE\6807: \6E05\9664\9AD8\901F\7F13\5B58 - \8F93\5165\4EFB\4F55\9700\8981\6E05\9664\7684\9875 (\901A\5E38\7F16\53F7\4E0E\201C\9875\201D\4E0B\65B9\8F93\5165\7684\76F8\540C)\3002'),
unistr('       \5982\679C\5BFC\822A\5230\4EA4\4E92\5F0F\62A5\544A\9875, \5219\6DFB\52A0 CIR,RIR \4EE5\6E05\9664\4EFB\4F55\73B0\6709\7684\7B5B\9009\5668\7B49\3002'),
unistr('    \76EE\6807: \8BBE\7F6E\8FD9\4E9B\9879 - \9009\62E9 (\6216\8F93\5165) \8981\586B\5145\7684\76F8\5E94\9875\9879\3002'),
unistr('       \5982\679C\5BFC\822A\5230\4EA4\4E92\5F0F\62A5\544A\9875, \5219\8F93\5165 IR_[COLUMN_NAME]\3002'),
unistr('    \76EE\6807: \4F7F\7528\8FD9\4E9B\503C - \8F93\5165 =PK='),
unistr('    \7528\6237\5B9A\4E49\7684\5C5E\6027: 1 - \8F93\5165\8981\641C\7D22\7684\5927\5199\8868\540D\3002'),
unistr('    \7528\6237\5B9A\4E49\7684\5C5E\6027: 2 - \8F93\5165\5927\5199\7684\4E3B\5217\540D\3002'),
unistr('    \7528\6237\5B9A\4E49\7684\5C5E\6027: 3 (\53EF\9009) - \8981\641C\7D22\7684\5217\7684\9017\53F7\5206\9694\5217\8868\3002'),
unistr('       \5982\679C\672A\6307\5B9A\4EFB\4F55\5217, \5219\641C\7D22\6240\6709\6587\672C (varchar2) \548C\5B57\7B26\5927\5BF9\8C61 (clob) \5217\3002'),
'',
unistr('\6CE8: \4EC5\5F53\5217\51FA\4E86\591A\4E2A\8868\65F6, \624D\4F1A\5411\7528\6237\663E\793A\8981\641C\7D22\7684\53EF\7528\8868\7684\5217\8868\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848327526313003)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869476133313019)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B21\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108844908769313000)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932021092312271)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932408638312271)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931901426312271)
,p_name=>'CA.SEND.END'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932371527312271)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875492601313023)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108875549007313023)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\6536\5230\65B0\53CD\9988\65F6\662F\5426\5E94\53D1\9001\7535\5B50\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872155012313021)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864600255313015)
,p_name=>'CA.SEND.TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850201395313004)
,p_name=>'CA.SERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061967667312373)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867196708313017)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\72B6\6001\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825405616312985)
,p_name=>'CA.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108825595116312985)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\5728\5E94\7528\7A0B\5E8F\751F\6210\4E2D\4F7F\7528\7684\8BBE\7F6E\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849840802313004)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809666168312176)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A/\9690\85CF\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850924376313005)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\65F6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108850746399313005)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851915703313006)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061833676312373)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5C5E PID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055808527312367)
,p_name=>'CA.SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862701258313014)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90\7C7B\578B\4E0D\662F\6709\6548\7684\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108855647417313008)
,p_name=>'CA.SOURCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058785208312370)
,p_name=>'CA.START.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739285812312911)
,p_name=>'CA.STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108060535131312372)
,p_name=>'CA.STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870302476313019)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834677288312992)
,p_name=>'CA.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056516739312368)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7A97\53E3\5173\95ED\65F6\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056679921312368)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\50A8\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845161123313000)
,p_name=>'CA.SUBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843843632312999)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108739426004312911)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108867493021313017)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EFA\8BAE\7684\53EF\89C6\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859350575313011)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859413194313011)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5411\5B89\88C5\811A\672C\4E2D\8F93\5165\4EE3\7801\FF0C\8BE5\4EE3\7801\901A\5E38\7528\4E8E\521B\5EFA\6216\64CD\4F5C\6570\636E\5E93\5BF9\8C61\6216\8005\5BF9\73B0\6709\8BB0\5F55\6267\884C\63D2\5165/\66F4\65B0/\5220\9664\64CD\4F5C\3002\5411\5378\8F7D\811A\672C\4E2D\8F93\5165\4EE3\7801\FF0C\8BE5\4EE3\7801\901A\5E38\7528\4E8E\79FB\9664\FF08\5220\9664\FF09\6570\636E\5E93\5BF9\8C61\3002\8FD9\4E9B\811A\672C\5C06\5408\5E76\5230\652F\6301\5BF9\8C61\4E2D\FF0C\4EE5\4FBF\5728\5BFC\51FA\5E94\7528\7A0B\5E8F\65F6\FF0C\5728\6D4B\8BD5\548C\751F\4EA7\73AF\5883\4E2D\6267\884C\8FD9\4E9B\76F8\540C\7684\66F4\65B0\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859539065313011)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5411\5B89\88C5\811A\672C\4E2D\8F93\5165\6709\6548\7684 SQL \548C/\6216 PL/SQL \8BED\53E5, \8FD9\4E9B\8BED\53E5\5728\5BFC\5165\5E94\7528\7A0B\5E8F\65F6\8FD0\884C\3002</p>'),
unistr('<p>\5982\679C\60A8\5E0C\671B\8FD9\4E9B\8BED\53E5\4E5F\5728\5F53\524D\73AF\5883\4E2D\8FD0\884C, \800C\4E0D\4EC5\4EC5\5728\5C06\5E94\7528\7A0B\5E8F\5BFC\5165\5230\5176\4ED6\73AF\5883\65F6\8FD0\884C, \8BF7\5355\51FB<strong>\521B\5EFA\5E94\7528\7A0B\5E8F\65F6\8FD0\884C</strong>\3002</p>'),
unistr('<p>\5411\5378\8F7D\811A\672C\4E2D\8F93\5165\6709\6548\7684 SQL \548C/\6216 PL/SQL \8BED\53E5, \8FD9\4E9B\8BED\53E5\5728\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\5220\9664\5E94\7528\7A0B\5E8F\65F6\8FD0\884C\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056160516312367)
,p_name=>'CA.SYSTEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108868870529313018)
,p_name=>'CA.TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826233742312985)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6846\67B6\5BF9\8C61\524D\7F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108826339854312985)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7531\5E94\7528\7A0B\5E8F\4F7F\7528\7684\5BF9\8C61\524D\7F00\3002\4E00\4E9B\529F\80FD\5C06\6B64\524D\7F00\6DFB\52A0\5230\5176\521B\5EFA\7684\6570\636E\5E93\5BF9\8C61 (\5305\62EC\7A0B\5E8F\5305\548C\8868)\3002</p>'),
unistr('<p>\8B66\544A: \786E\4FDD\8F93\5165\672A\7531\5176\4ED6\5E94\7528\7A0B\5E8F\4F7F\7528\7684\552F\4E00\524D\7F00\3002\5982\679C\4E0D\552F\4E00, \5728\521B\5EFA\65F6\5E94\7528\7A0B\5E8F\53EF\80FD\5F15\53D1\9519\8BEF\5E76\4E14\65E0\6CD5\6B63\5E38\5DE5\4F5C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108869782270313019)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864789418313015)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108848258579313003)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6A21\677F\540D\5DF2\5728\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845050219313000)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833796544312991)
,p_name=>'CA.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932211811312271)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\6B63\6587\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108846235137313001)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' \6587\672C\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108831982951312990)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\4E3B\9898\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832108141312990)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9009\4E2D, \5219\6700\7EC8\7528\6237\53EF\4EE5\4F7F\7528\201C\5B9A\5236\201D\94FE\63A5\9009\62E9\81EA\5DF1\7684\4E3B\9898\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832022614312990)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816315069312978)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814799957312976)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\9ED8\8BA4\5E94\7528\7A0B\5E8F\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108816477774312978)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\7BA1\7406\5458\4E3A\5E94\7528\7A0B\5E8F\9009\62E9\9ED8\8BA4\989C\8272\65B9\6848\FF08\4E3B\9898\6837\5F0F\FF09\3002\7BA1\7406\5458\8FD8\53EF\4EE5\9009\62E9\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\81EA\5DF1\7684\4E3B\9898\6837\5F0F\3002\6700\7EC8\7528\6237\53EA\9700\5355\51FB\4F4D\4E8E\4E3B\9875\5E95\90E8\7684<em>\5B9A\5236</em>\6309\94AE\FF0C\5373\53EF\4ECE\53EF\7528\4E3B\9898\6837\5F0F\4E2D\9009\62E9\3002\4F8B\5982\FF0C\5177\6709\89C6\529B\969C\788D\7684\7528\6237\53EF\80FD\4F1A\504F\597D\989C\8272\5BF9\6BD4\5EA6\9AD8\5F97\591A\7684 <em>Vista</em> \4E3B\9898\6837\5F0F\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6\FF1A'),
'<ul>',
unistr('<li>\5141\8BB8\7BA1\7406\5458\5B9A\4E49\9ED8\8BA4\4E3B\9898\6837\5F0F</li>'),
unistr('<li>\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\5404\79CD\4E3B\9898\6837\5F0F</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824848334312984)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108824947540312984)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\4E8E\663E\793A\5E94\7528\7A0B\5E8F\7684\9ED8\8BA4\4E3B\9898\6837\5F0F\3002</p>'),
unistr('<p>\8BE5\6837\5F0F\53EF\76F4\63A5\66F4\6539\4E3A\5176\4ED6\9884\5B9A\4E49\7684\6837\5F0F\FF0C\6216\8005\5728\751F\6210\4E4B\540E\4FEE\6539\3002\8981\66F4\6539\6837\5F0F\FF0C\8BF7\8FD0\884C\5E94\7528\7A0B\5E8F\FF0C\7136\540E\5355\51FB\5F00\53D1\8005\5DE5\5177\680F\4E2D\7684<strong>\4E3B\9898\6EDA\52A8\6761</strong>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838993557312995)
,p_name=>'CA.TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108830694740312989)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817446370312978)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\533A\652F\6301')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814326670312976)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\9ED8\8BA4\65F6\533A\548C\7528\6237\65F6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817130066312978)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\6700\7EC8\7528\6237\8BBE\7F6E\5176\672C\5730\65F6\533A\3002\5982\679C\5E94\7528\7A0B\5E8F\8868\4F7F\7528\80FD\591F\8BC6\522B\65F6\533A\7684\65E5\671F\7C7B\578B (\4F8B\5982\5E26\6709\672C\5730\65F6\533A\7684\65F6\95F4\6233), \4EE5\4FBF\62A5\544A\548C\6570\636E\6761\76EE\53CD\6620\7528\6237\6240\5728\7684\4F4D\7F6E, \5219\8FD9\975E\5E38\91CD\8981\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\5141\8BB8\7BA1\7406\5458\8BBE\7F6E\9ED8\8BA4\65F6\533A</li>'),
unistr('<li>\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\5176\65F6\533A\9996\9009\9879</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108872705971313021)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873053936313021)
,p_name=>'CA.TIMELINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\65F6\95F4\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108873141145313021)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\663E\793A\65F6\95F4\8868\7684\9875\FF0C\8FD9\5BF9\4E8E\663E\793A\66F4\65B0\5C24\4E3A\6709\7528\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\9875\540D</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\8868\6216\89C6\56FE</strong>\FF08\5FC5\9700\FF09- \4E3A\65F6\95F4\8868\9009\62E9\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('  <li><strong>\7528\6237\540D</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\4E3A\65F6\95F4\8868\6761\76EE\663E\793A\7684\7528\6237\7684\5217\3002</li>'),
unistr('  <li><strong>\65E5\671F</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\65F6\95F4\8868\6761\76EE\7684\65E5\671F\7684\5217\3002</li>'),
unistr('  <li><strong><strong>\4E8B\4EF6\540D</strong>\FF08\5FC5\9700\FF09- \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\65F6\95F4\8868\6761\76EE\7684\6807\9898\7684\5217\3002</li>'),
unistr('  <li><strong>\63CF\8FF0</strong> - \4ECE\8868\6216\89C6\56FE\4E2D\9009\62E9\7528\4F5C\65F6\95F4\8868\6761\76EE\63CF\8FF0\7684\5217\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835837137312993)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840472334312997)
,p_name=>'CA.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107932803052312271)
,p_name=>'CA.TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\4EF6\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839696681312996)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5E38\8BBF\95EE\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839700555312996)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\5C42\7528\6237\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108837251304312994)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841645254312997)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D\7684\7528\6237\7684\9ED8\8BA4\89D2\8272\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108833897041312991)
,p_name=>'CA.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144321938312438)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\9ED8\8BA4\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144458052312438)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\7528\6237\754C\9762\8BBE\7F6E\7684\9ED8\8BA4\503C\FF08\4F8B\5982\6BCF\9875\884C\6570\FF09\FF0C\5E76\6DFB\52A0\503C\5B9A\4E49\5217\8868\3002\5F53\5728\5E94\7528\7A0B\5E8F\4E2D\751F\6210\7EC4\4EF6\65F6\4F7F\7528\8FD9\4E9B\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834060121312992)
,p_name=>'CA.UNTIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192658158312477)
,p_name=>'CA.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108843422849312999)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\6982\8981\6587\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834369175312992)
,p_name=>'CA.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108834404220312992)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108835720636312993)
,p_name=>'CA.USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862247538313013)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237 - \6B65\9AA4 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862316356313013)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237 - \6B65\9AA4 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862480644313014)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\591A\4E2A\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108838154981312995)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\4EE3\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851508463313005)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\8BA1\6570\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839938865312996)
,p_name=>'CA.USER.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842411129312998)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\6982\8981\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817350679312978)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\6982\8981\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814218005312976)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\7528\6237\66F4\65B0\5176\6982\8981\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108817246817312978)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5141\8BB8\6700\7EC8\7528\6237\8F93\5165\6709\5173\81EA\5DF1\7684\8BE6\7EC6\4FE1\606F, \5305\62EC\7167\7247\6216\5934\50CF, \7528\4E8E\4E2A\6027\5316\5176\5E10\6237\3002</p>'),
unistr('<p>\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<ul>',
unistr('<li>\4F9B\6700\7EC8\7528\6237\8BBE\7F6E\5176\6982\8981\4FE1\606F\7684\8BBE\7F6E\9875</li>'),
unistr('<li>\80FD\591F\4E0A\8F7D\7167\7247/\5934\50CF</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842655559312998)
,p_name=>'CA.USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841768801312998)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863126589313014)
,p_name=>'CA.USERNAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151897980312444)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863794596313015)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6DFB\52A0\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865255106313016)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\89D2\8272\663E\793A\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108845883999313001)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5305\542B\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108863476237313014)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6DFB\52A0\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108841993108312998)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\7528\6237\540D\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828880461312192)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\6709\6548\7528\6237 - \9875\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857578989313010)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID \5DF2\5B58\5728, \6216\8005\662F\4E3A\5176\4ED6\5E94\7528\7A0B\5E8F\4FDD\7559\7684 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099184075312402)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\5E94\7528\7A0B\5E8F\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865883022313016)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\63D0\4F9B\8981\5C06\7535\5B50\90AE\4EF6\53D1\9001\5230\7684\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865658781313016)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\63D0\4F9B\7535\5B50\90AE\4EF6\5730\5740, \6216\8005\9009\62E9\4E00\7EC4\8981\5C06\7535\5B50\90AE\4EF6\53D1\9001\7ED9\7684\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108865753935313016)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\4E00\7EC4\8981\5C06\7535\5B50\90AE\4EF6\53D1\9001\7ED9\7684\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857644187313010)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\524D\7F00\4E0D\80FD\8D85\8FC7\516D\4E2A\5B57\7B26, \5FC5\987B\4EE5\5B57\6BCD\5F00\5934, \5E76\4E14\53EA\80FD\5305\542B\5B57\6BCD, \6570\5B57\548C\4E0B\5212\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857798172313010)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\4E0D\540C\7684\8868\524D\7F00\3002\4EE5\4E0B\6570\636E\5E93\5BF9\8C61\5DF2\5B58\5728: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842312835312998)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\4E0D\662F\6709\6548\7684\7535\5B50\90AE\4EF6\5730\5740\683C\5F0F\3002\8BF7\6CE8\610F\4EE5\4E0B\5E94\7528\7A0B\5E8F\7528\6237\540D\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108842247586312998)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\7535\5B50\90AE\4EF6\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108839847086312996)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108860160072313012)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\84DD\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108849730761313004)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108866043736313016)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108851805801313005)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6211\7684\6982\8981\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108836709257312994)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\6743\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108870620078313020)
,p_name=>'CA.WIDTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874884729313023)
,p_name=>'CA.WIZARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5411\5BFC\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828732010312192)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5BFC\5BB9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108874988488313023)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\521B\5EFA\7528\4F5C\5411\5BFC\7684\9875\96C6\5408\3002\901A\5E38\4F7F\7528\5411\5BFC\5728\591A\4E2A\6B65\9AA4\4E2D\8F93\5165\6570\636E\3002</p>'),
unistr('<p>\8F93\5165\4EE5\4E0B\5C5E\6027\FF1A</p>'),
'<ul>',
unistr('  <li><strong>\5411\5BFC\540D\79F0</strong>\FF08\5FC5\9700\FF09- \8F93\5165\6B64\9875\7684\540D\79F0\3002</li>'),
unistr('  <li><strong>\8BBE\7F6E\56FE\6807</strong> - \9009\62E9\5728\5BFC\822A\83DC\5355\4E2D\4E3A\6B64\9875\663E\793A\7684\56FE\6807\3002</li>'),
unistr('  <li><strong>\9875\6A21\5F0F</strong>\FF08\5FC5\9700\FF09- \9009\62E9\5411\5BFC\6B65\9AA4\5C06\663E\793A\4E3A\6A21\5F0F\9875\8FD8\662F\6B63\5E38\9875\3002\9009\62E9<strong>\6A21\5F0F\9875</strong>\6216\8005<strong>\5B8C\6574\9875</strong>\3002</li>'),
unistr('  <li><strong>\6B65\9AA4 1 ... 8</strong> - \4E3A\5411\5BFC\7684\6B65\9AA4\8F93\5165\9875\540D\3002<br><em><strong>\6CE8\FF1A</strong>\5F53\4E3A\4E4B\524D\7684\6BCF\4E2A\6B65\9AA4\8F93\5165\540D\79F0\540E\FF0C\5C06\663E\793A\6B65\9AA4 5 - 8\3002</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108840215438312996)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\7535\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108832964358312991)
,p_name=>'CA.YELLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144812294312439)
,p_name=>'CA.YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697869275312091)
,p_name=>'CACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601080771312017)
,p_name=>'CACHE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7684\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588671735312007)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\6570\636E\529F\80FD\5DF2\7981\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573612633311995)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6570\636E\529F\80FD\5DF2\7981\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573708201311995)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\6570\636E\529F\80FD\5DF2\7981\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726536546312113)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726491841312112)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612878258312026)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F7B\677E\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630703725312827)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\65E5\5386\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562115797311986)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\7684\65E5\5386\5F39\51FA\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693536923312088)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\65E5\5386\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083193931312390)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612762684312026)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946190974312281)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\4ECE\5E94\7528\7A0B\5E8F %0 \548C\6A21\677F ID %1 \8FDB\884C\590D\5236\65F6\672A\627E\5230\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084562720312391)
,p_name=>'CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568652078311991)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316585733312578)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\6837\5F0F\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163922131312454)
,p_name=>'CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741032162312913)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079817573312387)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\6570\636E\5E93\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079625883312386)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293321268312559)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\5DE5\4F5C\533A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053196974312365)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\7B26\96C6\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774759429312149)
,p_name=>'CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557423132311982)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\56FE\8868\67E5\8BE2\65E0\6548: %0<br><br>'),
unistr('\8BF7\4F7F\7528\4EE5\4E0B\8BED\6CD5:'),
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
unistr('<tr><td>LABEL</td><td>\6761\5F62\56FE\5BF9\5E94\7684\6587\672C</td></tr>'),
unistr('<tr><td>VALUE</td><td>\5B9A\4E49\6761\5F62\56FE\5927\5C0F\7684\6570\5B57\5217</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722314566312109)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\56FE\8868\67E5\8BE2\65E0\6548\3002<br /><br />\8BF7\4F7F\7528\4EE5\4E0B\8BED\6CD5: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>\5B9A\4E49\4EEA\8868\76D8\503C\7684\6570\5B57\5217\3002</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>\5B9A\4E49\6700\5927\4EEA\8868\76D8\503C\7684\6570\5B57\5217\3002</td>'),
'</tr>',
'<tr>',
unistr('<td>LOW (\53EF\9009)</td>'),
unistr('<td>\5B9A\4E49\4EE5\524D\6700\5C0F\4EEA\8868\76D8\503C\7684\6570\5B57\5217\3002</td>'),
'</tr>',
'<tr>',
unistr('<td>HIGH (\53EF\9009)</td>'),
unistr('<td>\5B9A\4E49\4EE5\524D\6700\5927\4EEA\8868\76D8\503C\7684\6570\5B57\5217\3002</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789130871312160)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\56FE\8868\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557361290311982)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\5BF9 SQL \67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790!'),
'<p>%0</p>',
unistr('\67D0\4E9B\67E5\8BE2\53EA\80FD\5728\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\6267\884C\3002\5982\679C\67E5\8BE2\7684\8BED\6CD5\6B63\786E, \53EF\4EE5\4E0D\7ECF\9A8C\8BC1\800C\4FDD\5B58\5B83 (\8BF7\53C2\9605\67E5\8BE2\6E90\4E0B\9762\7684\9009\9879)\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780683943312950)
,p_name=>'CHART_DEGREES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030616969312348)
,p_name=>'CHART_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589156387312008)
,p_name=>'CHART_SERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076332879312384)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \7684\56FE\8868\7CFB\5217\9519\8BEF %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685376503312081)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\56FE\8868\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034497659312351)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \5E94\7528\7A0B\5E8F\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867526935312221)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \4F1A\8BDD\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867464722312221)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \7528\6237\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867306176312221)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \5E94\7528\7A0B\5E8F\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781424336312951)
,p_name=>'CHECK_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\9009\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019967563312340)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022693385312342)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721166803312109)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020395309312340)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\6811')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018294874312339)
,p_name=>'CLEAN_UP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9875')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583932886312004)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\547D\4EE4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027574486312345)
,p_name=>'CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073158694312381)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8FC7\53BB 7 \5929\5185\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826294302312190)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\7A97\53E3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561689535312774)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857823424313010)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858885542313011)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858766633313011)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5B8C\6210')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686431569312870)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\8FDB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858112344313010)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\8FDB\5927\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858348905313010)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5236\8868\7B26\63D2\5165\7A7A\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561744602312774)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 %0 \4E0D\5B58\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562846257312775)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\5730\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562767003312775)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5F53 >100 \884C\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108862110459313013)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\6784\5EFA\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858966433313011)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\505A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858564750313011)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858440799313010)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\884C\53F7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108857958595313010)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6807\5C3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562643004312775)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5EFA\8BAE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858264292313010)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5236\8868\7B26\5927\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858086886313010)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562556311312775)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562441134312775)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED1\6697')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562236384312775)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5BF9\6BD4\5EA6\9ED1\6697')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562335839312775)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\660E\4EAE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562140998312775)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\6362\4EE3\7801\5927\5C0F\5199')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859074648313011)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561937453312775)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562078049312775)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108858640718313011)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108859132101313011)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561832894312775)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7A7A\683C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965387121312296)
,p_name=>'COLLAPSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\53E0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107596906334312014)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\8272\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786337253312158)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\62DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785974937312158)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8865\5145')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786563492312158)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8865\5145\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786424919312158)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\97F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786000804312158)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\79BB\8865\5145')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786219120312158)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56DB\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786138306312158)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E09\5206')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774394208312938)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\540D\79F0: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957841970312290)
,p_name=>'COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146047523312440)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\901A\8FC7\9A8C\8BC1\7684\7528\6237\53EF\4EE5\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146173148312440)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\6709\5728\5E94\7528\7A0B\5E8F\8BBF\95EE\63A7\5236\5217\8868\4E2D\5B9A\4E49\7684\7528\6237\53EF\4EE5\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146202868312440)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\610F\5916\7684\8BBF\95EE\63A7\5236\5217\8868\8BBE\7F6E\503C\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590083268312009)
,p_name=>'COMING_SOON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\7A0D\5019')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958312965312291)
,p_name=>'COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827399302312191)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8BD1\5931\8D25, \884C <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158573321312449)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8BD1\5931\8D25, \884C %0 (%2) \4E0E\7F16\8BD1\9519\8BEF\76F8\5173\8054\7684\884C\53F7\4E0E\7B2C\4E00\4E2A BEGIN \8BED\53E5\6709\5173\3002\8FD9\4EC5\5F71\54CD\6570\636E\5E93\89E6\53D1\5668\7684\7F16\8BD1\3002<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827276101312190)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\7F16\8BD1 PL/SQL \4EE3\7801 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024980334312343)
,p_name=>'COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031995284312349)
,p_name=>'COMPLETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038805663312354)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210/\65E0\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073665276312382)
,p_name=>'COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201717825312484)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392700549312638)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\672A\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688973709312084)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772071905312937)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637408939312045)
,p_name=>'COMPUTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095826670312400)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7EC4\4EF6\5DF2\6210\529F\5B89\88C5\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827811680312191)
,p_name=>'CONDITIONAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943581548312280)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017721950312338)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749389476312130)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748720185312130)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748891048312130)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217=\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748904231312130)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108562952270312775)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749496396312130)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749504515312130)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749199535312130)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749279897312130)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0D\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749030608312130)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42=e1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760423577312139)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6\7C7B\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980785309312308)
,p_name=>'CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549875613311976)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\4ECE\9875\FF08\4E24\9875\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549732339311976)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\4ECE\9875\FF08\4E09\9875\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735248942312119)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\9645\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024769828312343)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5217\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024835072312343)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F\7528\7684\805A\96C6\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732644749312117)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746122296312128)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746220125312128)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746020969312127)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643043063312049)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\62A5\544A\7684\7ED3\679C\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643185281312049)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\62A5\544A\7684\7ED3\679C\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746342660312128)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199814188312482)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949064155312284)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735068251312119)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \6309\94AE\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734962617312119)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \6309\94AE\663E\793A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570322935311992)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\6DFB\52A0\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570217628311992)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\62D6\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148331079312441)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199638856312482)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\53D6\6D88\201D\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191781616312476)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\5206\5927\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825752497312189)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\66F4\6539\4EA4\4E92\5F0F\62A5\8868\67E5\8BE2\3002\5982\679C\5220\9664\67E5\8BE2\4E2D\7684\4EFB\4F55\5217, \5219\5C06\7981\7528\73B0\6709\8FC7\6EE4\5668, \7A81\51FA\663E\793A\89C4\5219\4EE5\53CA\5F15\7528\8FD9\4E9B\5217\7684\5176\4ED6\62A5\8868\8BBE\7F6E\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736187070312120)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\5750\6807\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084940009312391)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EEA\8868\76D8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085010079312391)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EEA\8868\76D8 (\6247\9762\5F0F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736898139312120)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737088033312120)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736392711312120)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736991687312120)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736002997312120)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736277254312120)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737135471312121)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6563\70B9\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736691455312120)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736504559312120)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736449571312120)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107736757850312120)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643242733312049)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E34\65F6\7ED3\679C\96C6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733479663312118)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948877838312283)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111556582312412)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148571441312442)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745721217312127)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5217\6807\9898\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869736075312223)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\590D\5236\5177\6709\4EE5\4E0B\5C5E\6027\7684\5E94\7528\7A0B\5E8F\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744366231312126)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\590D\5236\5177\6709\4EE5\4E0B\5C5E\6027\7684\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733924666312118)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\65B0\9009\9879\5361\96C6 "%0", \5E76\7531\6B64\9875\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745998986312127)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\5E94\7528\7A0B\5E8F\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738432813312122)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\65E5\5386\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741617402312124)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\7EC6\5316\62A5\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794557315312165)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\4EA4\4E92\5F0F\62A5\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744653374312126)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\62A5\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753084123312922)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\4F7F\7528\4E0E\5F53\524D\5DE5\4F5C\533A\4E2D\73B0\6709\6570\636E\5E93\5E94\7528\7A0B\5E8F\76F8\540C\7684 ID \521B\5EFA\6570\636E\5E93\5E94\7528\7A0B\5E8F\3002\5C06\5220\9664\73B0\6709\6570\636E\5E93\5E94\7528\7A0B\5E8F, \7136\540E\66FF\6362\4E3A\65B0\6570\636E\5E93\5E94\7528\7A0B\5E8F\3002\8BF7\786E\8BA4\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108438720312410)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\8868\5355\9875\548C\5217\8868\89C6\56FE\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024471210312343)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\8868\5355\548C\5E26\6709\5206\6790\9875\7684\62A5\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738002292312121)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\57FA\4E8E SQL \67E5\8BE2\7684\8868\5355\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737994086312121)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\57FA\4E8E\5B58\50A8\8FC7\7A0B\7684\8868\5355\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737822858312121)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\57FA\4E8E\8868\7684\8868\5355\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613593168312027)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\4F7F\7528\4EE5\4E0B\5C5E\6027\5728 Web \670D\52A1\5F15\7528\9875\4E0A\521B\5EFA\8868\5355\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653712600312057)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\4F7F\7528\4EE5\4E0B\5C5E\6027\5728 Web \670D\52A1\5F15\7528\9875\4E0A\521B\5EFA\8868\5355\548C\62A5\8868\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052036746312364)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\5730\56FE\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107547406238311974)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\4F7F\7528\4EE5\4E0B\5C5E\6027\521B\5EFA\4E3B\4ECE\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739679763312123)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\9762\5305\5C51\533A\57DF\548C\9762\5305\5C51\9009\9879\3002\8BF7\786E\8BA4\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030715487312348)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737659719312121)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802098772312967)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802176661312967)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740494168312123)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\8868\5355\9875\548C\62A5\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748983097312919)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744424572312126)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\62A5\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738189904312121)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684 HTML \6761\5F62\56FE\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744032968312126)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\6982\8981\9875\3002\6309 "\6DFB\52A0\66F4\591A" \6309\94AE\53EF\4ECE\5176\4ED6\9875\548C/\6216\533A\57DF\6DFB\52A0\9644\52A0\9879\3002\6309 "\5B8C\6210" \6309\94AE\53EF\521B\5EFA\6982\8981\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738248907312121)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684 SVG \56FE\8868\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737533792312121)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\8868\683C\5F0F\8868\5355\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738705171312122)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\6811\9875\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737756727312121)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684\5411\5BFC\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752964177312922)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\4F7F\7528\4E0E\5F53\524D\5DE5\4F5C\533A\4E2D\73B0\6709 Websheet \5E94\7528\7A0B\5E8F\76F8\540C\7684 ID \521B\5EFA Websheet \5E94\7528\7A0B\5E8F\3002\5C06\5220\9664\73B0\6709 Websheet \5E94\7528\7A0B\5E8F, \7136\540E\66FF\6362\4E3A\65B0 Websheet \5E94\7528\7A0B\5E8F\3002\8BF7\786E\8BA4\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945531421312281)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689679746312873)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760066251312927)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F7F\7528\73B0\6709\8868\67E5\627E\548C\8F6C\6362\89C4\5219\91CD\65B0\521B\5EFA\6B64\6570\636E\52A0\8F7D\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191898277312476)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738575829312122)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030812707312348)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\7684\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737466450312121)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742355071312125)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE %0 \663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550221255311976)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743991141312126)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9762\5305\5C51\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743195571312125)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8868 %0 \7684\6392\5E8F\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741838601312124)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9875 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550136662311976)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742121979312124)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8868\540D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741970623312124)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599\9009\9879\5361\6807\7B7E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148802598312442)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735546134312119)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111269685312412)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111326641312412)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\5217 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739821777312123)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809689923312972)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809758084312972)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9875\9762\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935418361312273)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSV \8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936140883312274)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936740163312274)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\5217\6807\9898\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982694718312309)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\4E2A\533A\57DF\5C06\6DFB\52A0\5230\73B0\6709\7684\7BA1\7406\9875\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148498545312441)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740921816312124)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741068282312124)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741240470312124)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9875\9009\9879\5361\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741116160312124)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9875\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030930844312348)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\5171\4EAB\7EC4\4EF6\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377708785312626)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\5B9A\5236\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550444569311977)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\5305\542B\4E3B\62A5\8868?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743622507312126)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734792596312119)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734867816312119)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F\9ED8\8BA4\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613704610312027)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643474534312049)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643303181312049)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\533A\57DF\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737263742312121)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734569022312119)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148792610312442)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147638258312441)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\5173\952E\5B57\5217 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147796246312441)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\952E\5B57\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147866883312441)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\952E\5B57\5217 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738642704312122)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111401707312412)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148693329312442)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550570581311977)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\4ECE\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550013593311976)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550313402311977)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\4E3B\8BB0\5F55\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549912721311976)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948969211312284)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5217\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945354798312281)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801681579312170)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740131448312123)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743789609312126)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6839')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739901000312123)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740237357312123)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616292608312029)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\5C06 HTML \56FE\8868\5347\7EA7\5230\65B0 HTML5 \56FE\8868\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768664002312934)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\5C06 jsTree \5347\7EA7\5230\65B0\6811\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726338474312112)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5C06\6839\636E\4EE5\4E0B\9650\5236\5347\7EA7 SVG \56FE\8868:  '),
'<ul>',
'<li>',
unistr('\53EA\8FC1\79FB\5728\8F74\683C\5F0F\5B57\7B26\4E32\4E2D\5B9A\4E49\7684\6570\5B57\683C\5F0F\3002\5FFD\7565\65E5\671F\548C\65F6\95F4\683C\5F0F\3002'),
'</li>',
'<li>',
unistr('\5C06\8FC1\79FB\5305\542B\4EE5\4E0B\5185\5BB9\7684\6570\5B57\683C\5F0F\5143\7D20:'),
'<br />',
unistr('0,9,D,G,, (\9017\53F7),. (\53E5\70B9),$,C,L,FM'),
'</li>',
'<li>',
unistr('Flash \56FE\8868\4E2D\6BCF\4E2A\7CFB\5217\7684\6807\7B7E\6D3E\751F\81EA\6BCF\4E2A\7CFB\5217\7684\5217\522B\540D\3002'),
unistr('\8FD9\4E0E SVG \56FE\8868\4E0D\540C, SVG \56FE\8868\4E2D\6BCF\4E2A\7CFB\5217\7684\6807\7B7E\6D3E\751F\81EA\7CFB\5217\540D\79F0\5C5E\6027\3002'),
'</li>',
'<li>',
unistr('Flash \4EEA\8868\76D8\56FE\8868\663E\793A\5B9E\9645\503C\800C\4E0D\662F\767E\5206\6BD4\3002'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690337500312085)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\5C06 SVG \56FE\8868\5347\7EA7\5230 HTML5 \56FE\8868\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748765115312918)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746648817312128)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360058731312612)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042266967312356)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6DFB\52A0\65B0\7BA1\7406\9875\FF0C\9875\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825931406312190)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735313394312119)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199491704312482)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4E0B\4E00\6B65\201D\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733812876312118)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\9875\9009\62E9\9009\9879\5361\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734424405312118)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613825806312027)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735755379312119)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732797821312117)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746437190312128)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732896683312117)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733769615312118)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742272562312125)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740393437312123)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743812014312126)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9762\5305\5C51\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742424675312125)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\8868\6392\5E8F\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741703246312124)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742097325312124)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\8868\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734328381312118)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734265985312118)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825676462312189)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\65B9\6848\8FDB\884C\8BED\6CD5\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832337562312195)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\5206\9875\5237\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199533733312482)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4E0A\4E00\6B65\201D\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733617850312118)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741339491312124)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945600780312281)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949167000312284)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\94FE\63A5\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945752034312281)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735664023312119)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945479406312281)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734637583312119)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732958258312117)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739785798312123)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825829204312189)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741457758312124)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965439515312296)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5B9E\65BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740503290312123)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740604303312123)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740806525312123)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9875\9009\9879\5361\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740732136312123)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9875\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643653290312049)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643523739312049)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\533A\57DF\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744731764312126)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646124545312051)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7248\672C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744943293312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C: HTML (\6807\51C6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745278950312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C: \5916\89C2 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745370468312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C: \5916\89C2 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825434356312189)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C: \5916\89C2 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825510412312189)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C: \5916\89C2 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644166401312050)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C: \5916\89C2 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745042783312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4: \5782\76F4\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745499446312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA: CSV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745507904312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA: XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745173365312127)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4: \5782\76F4\62A5\8868, \5916\89C2 1 (\5305\542B\7A7A\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825225122312189)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4: \5782\76F4\62A5\8868, \5916\89C2 2 (\4E0D\542B\7A7A\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825372355312189)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4: \5782\76F4\62A5\8868, \5916\89C2 2 (\5305\542B\7A7A\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148989920312442)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C4\5219\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149150246312442)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149204639312442)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C4\5219\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588885601312008)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8BF7\6C42\8FD0\884C\4EE5\4E0B\811A\672C\3002\8BF7\786E\8BA4\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107740054796312123)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744833861312127)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735942253312120)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832253636312194)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980386463312307)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\591A\9875\FF0C\4ECE\4EE5\4E0B\9875\5F00\59CB\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735802407312120)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\50A8\8FC7\7A0B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827178696312190)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\50A8\8FC7\7A0B\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199745172312482)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5B8C\6210\201D\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764035768312930)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735169894312119)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EFA\8BAE\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024546507312343)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868/\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024666349312343)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5217\6C47\603B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210889706312491)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\67E5\627E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733308115312118)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733257772312118)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310912669312574)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\6362\89C4\5219')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149316370312442)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\6362\89C4\5219')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826158654312190)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868/\89C6\56FE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826073257312190)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868/\89C6\56FE\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746561656312128)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734101191312118)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A, \9009\9879\5361\96C6\4FE1\606F\4E0D\5B8C\6574\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733162058312117)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744594158312126)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733043292312117)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745642228312127)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739357055312122)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5E26\6709\5F39\51FA\5F0F\503C\5217\8868\7684\65B0\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739093244312122)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738874710312122)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739299351312122)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739405317312122)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739188166312122)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107739533613312122)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107738916623312122)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746743615312128)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746808825312128)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272\548C\68D5\8910\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107746988669312128)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747045898312128)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D77\519B\84DD\548C\7070\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747166108312128)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A44\6984\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747220765312128)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6817\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747343284312129)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\84DD\8272\548C\68D5\8910\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747451357312129)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747563503312129)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107733543682312118)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\66F4\65B0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107737355902312121)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107734063238312118)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5C06\4F7F\7528\73B0\6709\9009\9879\5361\96C6 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613609577312027)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\5F15\7528, \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107741516334312124)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Where \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015052796312336)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\786E\8BA4\201D\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025348928312344)
,p_name=>'CONFIRMED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025657036312344)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531 QA \786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945965662312281)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945851633312281)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\683C\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053212210312365)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085963213312392)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5904\7406\5185\5BB9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864153122313015)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D21\732E\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778725680312942)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\9759\6001 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825025769312189)
,p_name=>'COPY_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690134055312085)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\590D\5236\60A8\7684\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804475766312172)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C copy_button %0 >> %1 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870318084312223)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5BF9\8C61\5B9A\4E49\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665236327312066)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109255585312410)
,p_name=>'COPY_FEATURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\529F\80FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869998654312223)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250842063312524)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\6A21\677F\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870066601312223)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693975511312088)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804878092312173)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C copy_named_lov %0 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804798789312173)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\503C\5217\8868 ID "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804634192312172)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868 ID "%0" \4E0D\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090768144312396)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090850695312396)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5230\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089812327312395)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\6388\6743 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089764098312395)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\5217\8868 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089607542312395)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\503C\5217\8868 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154012083312446)
,p_name=>'COPY_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06 %0 \590D\5236\5230\8868 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870174551312223)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5230\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870224186312223)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5230\540D\79F0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776805718312151)
,p_name=>'CORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6838\5FC3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219822019312498)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219912920312498)
,p_name=>'CREATE OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108992867312410)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB 7 \5929\5185\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665336998312066)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\5E94\7528\7A0B\5E8F\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692499771312875)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('K \7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692221174312875)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \548C 3D \67F1\72B6\56FE, \6761\5F62\56FE\548C\5806\53E0\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692951137312875)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EEA\8868\76D8\548C\4EEA\8868\76D8 (\767E\5206\6BD4) \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692364225312875)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \548C 3D \997C\56FE\548C\5706\73AF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692646483312875)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\76EE\7518\7279\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692859326312875)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \548C 3D \8303\56F4\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692796663312875)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D44\6E90\7518\7279\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692561685312875)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6563\70B9\6807\8BB0\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770204533312146)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'zh-cn'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770034601312146)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\7BAD\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770151154312146)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\7BAD\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769831111312146)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769987399312146)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770319495312146)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'zh-cn'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770418263312146)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\89C8\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109624941312411)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4E0B\9762\7684\201C\6388\4E88\6743\9650\201D\6309\94AE\53EF\5C06\8FD9\4E9B\6743\9650\7ACB\5373\6388\4E88 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109417111312410)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \6CA1\6709 CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE \6216 CREATE PROCEDURE \6743\9650, \65E0\6CD5\5B89\88C5\6F14\793A\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109548806312411)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 \6CA1\6709\5BF9 CTX_DOC \548C CTX_DDL \7684\6267\884C\6743\9650, \65E0\6CD5\5B89\88C5\201C\603B\7EDF\5C31\804C\6F14\8BF4\201D\6F14\793A\3002 \8BF7\4EE5\7279\6743\7528\6237\8EAB\4EFD\6267\884C\4EE5\4E0B\6388\6743: '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353459886312607)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6309\94AE - \5BF9\8BDD\6846\5DF2\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586229672312006)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\52A8\6001\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826946977312190)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\52A8\6001\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564222712311987)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603331867312019)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E10\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244511092312518)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110002029312411)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'zh-cn'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748809640312919)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244652350312518)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244200186312518)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244304881312518)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\5C42\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110171573312411)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\6B21\767B\5165 (SSO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244448425312518)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E24\5C42\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665109152312066)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\7535\5B50\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558800168311983)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6240\9009\9875\6A21\677F\4E2D\5305\542B\5168\5C40\9875\7EC4\4EF6\533A\57DF\7684\663E\793A\70B9, \5219\6240\6709\9875\4E0A\90FD\5C06\663E\793A\8FD9\4E9B\7EC4\4EF6\3002\53EF\4EE5\4F7F\7528\201C\6709\6761\4EF6\663E\793A\201D\5C5E\6027\6765\9690\85CF\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795563829312165)
,p_name=>'CREATE_INDEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968810780312298)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\76F8\5173\8054\7684\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776556676312151)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65B0\7684\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771986190312147)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\521B\5EFA\8868\5411\5BFC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771486671312147)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5305')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771347513312147)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "%1" \65B9\6848\4E2D\5DF2\521B\5EFA\5305 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772064478312147)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8868 "%0" \5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771899714312147)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771608933312147)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771758311312147)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL&nbsp;\5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771530091312147)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767157524312144)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\4EFB\4F55\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766714131312143)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767001448312144)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766827938312143)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766992200312143)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\53EF\8BBE\7F6E\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764890530312142)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764972153312142)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771269092312147)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771045496312147)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770916746312147)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770639063312146)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7ECF\5728 SQL \811A\672C\8D44\6599\6863\6848\5E93\4E2D\521B\5EFA\4E86\8868 %0 \7684\521B\5EFA\8868\811A\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770747362312146)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\811A\672C\8D44\6599\6863\6848\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107771173417312147)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL&nbsp;\5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107770891732312146)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200440970312483)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\683C\5F0F\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766647145312932)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5F85\529E\4E8B\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154683917312446)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\89E6\53D1\5668 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100900588312404)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \6570\636E\5E93\5BF9\8C61\5DF2\521B\5EFA\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108055410720312367)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8EAB\4EFD\8BC1\660E\6240\6709\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019825941312340)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943266996312279)
,p_name=>'CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012311761312334)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012037289312334)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8868\5355\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786686973312158)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9879\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012193800312334)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9879\6807\8BC6\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012238693312334)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9879\6807\7B7E\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067999416312377)
,p_name=>'CURRENT TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753296141312133)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760079503312138)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\6620\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293591137312559)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7528\4E8E\4E00\4E2A\5C06\5F53\524D\5B57\6BB5\5305\88C5\5230\201C\6807\7B7E\548C\9879\4E4B\524D\201D\5C5E\6027\4E2D\7684\5BB9\5668\5143\7D20\7684 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771394558312936)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9879\5E2E\52A9\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721737800312109)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759101074312138)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036624778312352)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5305\542B\4EFB\4F55\9879\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007919228312331)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567509719312779)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585123117312005)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\5DF2\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800311924312169)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2D\51FA\73B0\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721925758312109)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4EFB\4F55\5B57\7B26\4E32\4EE5\7528\4F5C\6B64\4F1A\8BDD\7684\7528\6237\6807\8BC6\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722017661312109)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\60A8\7684 %0 \7528\6237\540D\548C\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722148673312109)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\6237\540D\548C\5BC6\7801\4EE5\4F9B LDAP \4E3B\673A\9A8C\8BC1: %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722227504312109)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6570\636E\5E93\65B9\6848\7528\6237\540D\548C\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378005235312627)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383055849312631)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382988967312630)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155537664312447)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\771F\64CD\4F5C\4E3A\4F7F\7528\8BBE\7F6E\7C7B\578B\7684 SQL \8BED\53E5\8BBE\7F6E\503C\65F6, \9700\8981\6309 SQL \8BED\53E5\7684\5217\987A\5E8F\5B9A\4E49\53D7\5F71\54CD\7684\5143\7D20\3002\60A8\5B9A\4E49\7684 SQL \8BED\53E5\4E3A:</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953182215312287)
,p_name=>'DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219475705312498)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808271683312175)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709 %0 \5217\5747\5DF2\81EA\52A8\6620\5C04\5230 %1 \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809020572312176)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868 <code>%0</code> \4E2D\7684\6570\636E\5DF2\9644\52A0 <b id="incompl_success_row_count"></b> \4E2A\65B0\884C\3002\5DF2\62D2\7EDD <b class="u-danger-text" id="incompl_fail_row_count"></b> \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808686482312176)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868 <code>%0</code> \4E2D\7684\6570\636E\5DF2\9644\52A0 <b id="success_row_count"></b> \4E2A\65B0\884C\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808856428312176)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868 <code>%0</code> \4E2D\7684\6570\636E\5DF2\9644\52A0 <b id="err_success_row_count"></b> \4E2A\65B0\884C\3002\5DF2\62D2\7EDD <b class="u-danger-text" id="err_fail_row_count"></b> \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561332054311985)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555912461311981)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\5217\6620\5C04\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598954216312015)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\5DF2\4FDD\5B58\FF01')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560980698311985)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6982\8981\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561004790311985)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6982\8981\6587\4EF6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560383715311984)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808334543312175)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5B9A\4E49\5217\6620\5C04\FF0C\4EE5\4FBF\5C06\6B64\6570\636E\6620\5C04\5230 %0 \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560898565311985)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561260701311985)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6587\4EF6\62D6\653E\5728\6B64\5904\6216\8005')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561104630311985)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\7684\683C\5F0F csv\3001xlsx\3001txt\3001xml\3001json')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217404205312496)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\4F5C\4E1A\6267\884C\5DF2\610F\5916\505C\6B62\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160382062312451)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A %0 \4E2D\7684\6570\636E\52A0\8F7D\4F5C\4E1A\FF1A\52A0\8F7D\5230\8868 %1 \4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560563479311984)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\52A0\8F7D\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808486518312175)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6709 %0 \5217\FF08\5171 %1 \5217\FF09\81EA\52A8\6620\5C04\5230 %2 \8868\3002\8BF7\914D\7F6E\5269\4F59\7684 %3 \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198520220312481)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C98\8D34\7684\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809101466312176)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868 <code>%0</code> \4E2D\7684\6570\636E\88AB <b id="incompl_success_row_count"></b> \4E2A\65B0\884C\66FF\6362\3002\5DF2\62D2\7EDD <b class="u-danger-text" id="incompl_fail_row_count"></b> \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808701551312176)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868 <code>%0</code> \4E2D\7684\6570\636E\88AB <b id="success_row_count"></b> \4E2A\65B0\884C\66FF\6362\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808985479312176)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868 <code>%0</code> \4E2D\7684\6570\636E\88AB <b id="err_success_row_count"></b> \4E2A\65B0\884C\66FF\6362\3002\5DF2\62D2\7EDD <b class="u-danger-text" id="err_fail_row_count"></b> \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808512466312175)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\9009\62E9\8981\52A0\8F7D\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541419086311970)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\7684\683C\5F0F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560432223311984)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560618327311984)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('XLSX \5DE5\4F5C\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760785327312928)
,p_name=>'DATABASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220057453312498)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\6D4F\89C8\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705812361312885)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B\6570\636E\5E93\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760892122312928)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604876706312020)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620442358312032)
,p_name=>'DATABASE_APPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095634397312400)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F <strong>%0</strong> \5DF2\6210\529F\5B89\88C5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998311643312324)
,p_name=>'DATABASE_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047835040312361)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5BF9\8C61\7C7B\578B\7EDF\8BA1\7684\6570\636E\5E93\5BF9\8C61\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051029295312363)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\89D2\8272\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616196382312029)
,p_name=>'DATABASE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149806152312443)
,p_name=>'DATA_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695766534312878)
,p_name=>'DATA_GRIDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696126831312878)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682643546312867)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\9AD8\7EA7\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695842945312089)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F\7528\7684\65E5\671F/\6570\5B57\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695990496312089)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\662F\63D0\4F9B\5B9A\5236\683C\5F0F\63A9\7801\8FD8\662F\4F7F\7528\6807\51C6\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616536414312029)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\5B57\7B26\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209255653312490)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093728557312398)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348667126312603)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5DF2\6210\529F\4E0A\8F7D\5230\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354186859312608)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5E76\7C98\8D34')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343029153312599)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5E76\7C98\8D34\5E26\5206\9694\7B26\7684\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725169625312900)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D27\5E01\7B26\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725282050312900)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6570\636E\4E2D\5305\542B\56FD\9645\8D27\5E01\7B26\53F7, \8BF7\5728\6B64\5904\8F93\5165\3002\4F8B\5982, \5982\679C\6570\636E\4E2D\5305\542B "&euro;1,234.56" \6216 "&yen;1,234.56", \8BF7\8F93\5165 "&euro;" \6216 "&yen;"\3002\5426\5219, \5C06\65E0\6CD5\6B63\786E\52A0\8F7D\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621216351312032)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682740960312867)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5E94\7528\7A0B\5E8F\6807\51C6\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682814267312867)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\4E0A\8F7D\7684\5217\63D0\4F9B\5B9A\5236\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726453261312901)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C0F\6570\70B9\5B57\7B26\5C06\6570\5B57\7684\6574\6570\90E8\5206\548C\5C0F\6570\90E8\5206\5206\9694\5F00\6765\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\4EFB\4F55\5B57\7B26\4F5C\4E3A\5C0F\6570\70B9\5B57\7B26\3002\6240\6307\5B9A\7684\5B57\7B26\5FC5\987B\4E3A\5355\5B57\8282\5B57\7B26, \5E76\4E14\5C0F\6570\70B9\5B57\7B26\4E0D\80FD\4E0E\7EC4\5206\9694\7B26\76F8\540C\3002\6B64\5B57\7B26\53EF\4EE5\4E3A\7A7A\683C, \4F46\4E0D\80FD\4E3A\6570\5B57\5B57\7B26\6216\4EE5\4E0B\5B57\7B26\4E4B\4E00:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\53F7 (+)</li>'),
unistr('<li>\8FDE\5B57\53F7 (-)</li> '),
unistr('<li>\5C0F\4E8E\53F7 (<)</li>'),
unistr('<li>\5927\4E8E\53F7 (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725521850312901)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\6570\70B9\7B26\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724403656312111)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\4E3A %0 \8868\5217\5B9A\4E49\4E86\7EC4\5206\9694\7B26\FF0C\5219\9700\8981\5C0F\6570\70B9\7B26\53F7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093974430312398)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160474685312451)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4E2A\6E90\5217\6620\5C04\5230 %0 \8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491878977312719)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5931\8D25\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707250206312886)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25\7684\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724704889312900)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4E0A\8F7D\7684\6587\4EF6\7684\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351282621312605)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\884C\5177\6709\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724832596312900)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6570\636E\7684\7B2C\4E00\884C\4E2D\5305\542B\5217\540D, \8BF7\9009\4E2D\6B64\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725084170312900)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\7403\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725463933312901)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7EC4\5206\9694\7B26\662F\5206\9694\6574\6570\7EC4\7684\5B57\7B26, \4F8B\5982, \7528\6765\8868\793A\5343\4F4D\548C\767E\4E07\4F4D\7684\5B57\7B26\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\4EFB\4F55\5B57\7B26\4F5C\4E3A\7EC4\5206\9694\7B26\3002\6240\6307\5B9A\7684\5B57\7B26\5FC5\987B\4E3A\5355\5B57\8282\5B57\7B26, \5E76\4E14\7EC4\5206\9694\7B26\4E0D\80FD\4E0E\5C0F\6570\70B9\5B57\7B26\76F8\540C\3002\6B64\5B57\7B26\53EF\4EE5\4E3A\7A7A\683C, \4F46\4E0D\80FD\4E3A\6570\5B57\5B57\7B26\6216\4EE5\4E0B\5B57\7B26\4E4B\4E00:</p>'),
'<ul class="noIndent">',
unistr('<li>\52A0\53F7 (+)</li>'),
unistr('<li>\8FDE\5B57\53F7 (-)</li> '),
unistr('<li>\5C0F\4E8E\53F7 (<)</li>'),
unistr('<li>\5927\4E8E\53F7 (>)</li> '),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725330730312900)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5206\9694\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491647975312718)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D2\5165\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722298254312898)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\67E5\8BE2\8FD4\56DE\7684\884C\6570\8D85\8FC7\4E86 #MAX_ROW_COUNT#, \8BF7\8FC7\6EE4\6570\636E\4EE5\786E\4FDD\83B7\5F97\5B8C\6574\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092686321312397)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\7528\6237\66F4\6539\7684\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715809216312104)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\5206\5927\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715773991312104)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314772253312577)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\80FD\52A0\8F7D\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314850169312577)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5DF2\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338885843312596)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148078734312441)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 2 - \9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773134903312937)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6587\4EF6\9884\89C8\53EF\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723957924312899)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C01\95ED\7B26 (\53EF\9009)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686193647312870)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5411\5BFC\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148200076312441)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 4 - \9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093837133312398)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092126816312397)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6210\4E3A\7ECF\8FC7\590D\67E5\7684\884C, \8BF7\6267\884C\4EE5\4E0B\64CD\4F5C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206341730312488)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
unistr('\5176\4E2D SAL \548C COMM \662F\4E0A\8F7D\7684\6570\636E\7684\5217\540D, '),
unistr('my_func \662F\8FD4\56DE\76F8\5E94\503C\7684\51FD\6570, '),
unistr('\8BE5\503C\5C06\662F\5B9A\4E49\4E86\6B64\8F6C\6362\89C4\5219\7684\5217\7684\65B0\503C\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206590499312488)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'    l_result := :SAL * :COMM;',
'    return l_result;',
'end;',
'',
unistr('\8FD4\56DE\7ED3\679C\5C06\662F\5B9A\4E49\4E86\6B64\8F6C\6362\89C4\5219\7684\5217\7684\65B0\503C\3002'),
'',
unistr(':SAL \548C :COMM \662F\6307\6240\4E0A\8F7D\6570\636E\7684 SAL \548C COMM \5217\540D\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206405551312488)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'where dname = :DEPTNAME',
'  and loc   = :LOC',
'',
unistr('\5176\4E2D :DEPNAME \548C :LOC \662F\6307\4E0A\8F7D\7684\6570\636E\7684 DEPNAME \548C LOC \5217\540D\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732574194312117)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \8868\5217\4E2D\FF0C\540C\4E00\4E2A\5B57\7B26\4E0D\80FD\540C\65F6\5B9A\4E49\4E3A\7EC4\5206\9694\7B26\548C\5C0F\6570\70B9\7B26\53F7\3002\8BF7\8F93\5165\4E0D\540C\7684\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723768492312899)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\5217\5206\9694\7B26\3002\4F7F\7528 <code>\005Ct</code> \4EE3\8868\5236\8868\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723803870312899)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094010866312398)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682457394312867)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9AD8\7EA7\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682512106312867)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6570\636E\52A0\8F7D\7684\9AD8\7EA7\8BBE\7F6E: \8D27\5E01\7B26\53F7, \5C0F\6570\70B9\5B57\7B26, \6587\4EF6\7F16\7801\6216\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358718769312611)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147971325312441)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 1 - \9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761013974312928)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\005Ct \8868\793A\5236\8868\7B26)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722592892312898)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491765976312719)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\884C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802337063312967)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\4E86\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354094398312608)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\6587\4EF6, \4EE5\9017\53F7\5206\9694\7684 *.csv \683C\5F0F\6216\5236\8868\7B26\5206\9694\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358981966312612)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358817352312611)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108148106928312441)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 3 - \9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152204448312444)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\6570\636E\52A0\8F7D\5411\5BFC\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314978615312577)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\80FD\6620\5C04\6570\636E/\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315007090312577)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5DF2\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021064171312341)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\4E0A\8F7D\5217\6620\5C04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107745846273312127)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7C7B\578B\FF1A\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607691685312022)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\6570\70B9\7B26\53F7\FF1A\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607889505312022)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801\FF1A\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607726814312022)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5206\9694\7B26\FF1A\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608019414312022)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6620\5C04\5230\FF1A\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794927044312165)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\957F\5EA6\FF1A\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607933638312022)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \672A\6620\5C04\7684\5217 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141135116312436)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\7A81\51FA\663E\793A\65E5\671F\5C5E\6027\503C%0\4E0D\7B26\5408%2\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146380985312440)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\7A81\51FA\663E\793A\65E5\671F\5C5E\6027\503C%0\4E0D\662F\76F8\5BF9\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141368923312436)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\6700\5927\65E5\671F\5C5E\6027\503C%0\4E0D\7B26\5408%2\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146591234312440)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\6700\5927\65E5\671F\5C5E\6027\503C%0\4E0D\662F\76F8\5BF9\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558606780311983)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879 %1 \8F93\5165\7684\9759\6001\6700\5927\65E5\671F\5C5E\6027\503C %0 \4E0D\7B26\5408 %2 \683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141261775312436)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\6700\5C0F\65E5\671F\5C5E\6027\503C%0\4E0D\7B26\5408%2\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146490749312440)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\6700\5C0F\65E5\671F\5C5E\6027\503C%0\4E0D\662F\76F8\5BF9\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558590910311983)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879 %1 \8F93\5165\7684\9759\6001\6700\5C0F\65E5\671F\5C5E\6027\503C %0 \4E0D\7B26\5408 %2 \683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248420442312521)
,p_name=>'DATE_ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693122718312876)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542B\4E0A\6B21\8FD0\884C\65F6\95F4\7684 Oracle APEX \6570\636E\5E93\4F5C\4E1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070921689312380)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5230\6700\540E\4E00\4E2A\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071073022312380)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5230\53D1\884C\7248 %0 \7684\6700\540E\4E00\4E2A\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145716339312439)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698542350312880)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\8B66')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697327142312879)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698788662312880)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698694036312880)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538094742311967)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\53D6\6D88\201D\5BF9\8BDD\6846')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538153297311967)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690092473312085)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689921540312085)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690279615312873)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689896504312085)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066263335312376)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C JavaScript \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320480029312581)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145830189312439)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145949341312439)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303359135312567)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\7126\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066199831312376)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689737169312085)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303411908312567)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284955836312553)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284840820312552)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00\6811')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587302907312006)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5E10\6237')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062812617312373)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\8868\540D\548C\5217\540D\533A\5206\5927\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162553954312452)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5BF9\8C61\521B\5EFA\5F02\5E38\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600984324312017)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751228559312920)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747999477312918)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709 Mime')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750979515312920)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5904\7406\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748240047312918)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748021564312918)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748115545312918)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755194337312923)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('RESTful \670D\52A1\6A21\5757')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750839288312920)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755694967312924)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7A0B\5E8F\7ED1\5B9A\53D8\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728011138312903)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7A0B\5E8F\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755905800312924)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7A0B\5E8F\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728103656312903)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7A0B\5E8F\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747790715312918)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755269278312923)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5757\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755790615312924)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5757 URI \524D\7F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748384863312918)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747660324312918)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755452784312924)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('RESTful \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747867750312918)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755859746312924)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727923373312902)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EDF\4E00\8D44\6E90\6807\8BC6\7B26 (URI)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754965915312923)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \524D\7F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755053875312923)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728285451312903)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\4E00\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972178499312301)
,p_name=>'DEBUG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\8BD5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078522586312386)
,p_name=>'DECLINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\62D2\7EDD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800876394312966)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5BF9\8BDD\6846\6309\94AE\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800790353312966)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5BF9\8BDD\6846\5185\5BB9\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315643958312577)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957935220312290)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8868\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959561808312292)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8868\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208085321312489)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583312855312003)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\52A8\6001\64CD\4F5C\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374382746312624)
,p_name=>'DEFINED_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\6709 %0 \4E2A\9009\9879\5361, \8FD9\4E9B\9009\9879\5361\5DF2\7EC4\7EC7\4E3A %1 \4E2A\9009\9879\5361\96C6, \5E76\4E14\5DF2\5B9A\4E49\4E86 %2 \4E2A\7236\9009\9879\5361\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826853672312190)
,p_name=>'DEFINE_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008065805312331)
,p_name=>'DEFINITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160233349312451)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\811A\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678513626312076)
,p_name=>'DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695249586312877)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200532865312483)
,p_name=>'DELETE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108192751058312477)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610511961312024)
,p_name=>'DELETE_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\8981\6267\884C\6B64\5220\9664\64CD\4F5C?')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634845517312043)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\201C\6536\85CF\54C1\5C55\793A\201D\FF0C\53EF\4EE5\5B58\50A8\5728 Oracle APEX \4F1A\8BDD\4E2D\4F7F\7528\7684\6570\636E\884C\3002\6B64\6570\636E\5E93\5E94\7528\7A0B\5E8F\8BF4\660E\5982\4F55\4F7F\7528 PL/SQL \521B\5EFA\548C\7BA1\7406\57FA\4E8E\96C6\5408\7684\4F1A\8BDD\72B6\6001\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634676186312043)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634740274312043)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA7\54C1\95E8\6237\662F\4E00\4E2A\793A\4F8B\5E94\7528\7A0B\5E8F, \91CD\70B9\5F3A\8C03\5E38\89C1\7684\8BBE\8BA1\6982\5FF5\3002\5176\4E2D\5305\62EC\9762\5411\5BA2\6237, \4EA7\54C1\548C\8BA2\5355\7684\4E13\7528\9875, \5E76\4E14\6F14\793A\4E86\62A5\8868, \56FE\8868, \65E5\5386, \5730\56FE\548C\6811\7684\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028954136312346)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\6F14\793A\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755626130312135)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5065\5EB7\62A5\8868\548C\9875\7801\6982\5FF5\7684\793A\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755322744312135)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 %0 \6784\5EFA\5728\7EBF\5546\5E97\7684\793A\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756032616312135)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\5982\4F55\5C06 Oracle Text \4E0E %0 \4E00\8D77\4F7F\7528\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756438490312135)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528 %0 \6784\5EFA\7684\9879\76EE\72B6\6001\8DDF\8E2A\5E94\7528\7A0B\5E8F\7684\793A\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755837900312135)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\5982\4F55\5C06 web \670D\52A1\4E0E %0 \4E00\8D77\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754248848312134)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752175112312132)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751848688312132)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'zh-cn'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755591487312135)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5546\4E1A\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754329958312134)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\85CF\54C1\5C55\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751965561312132)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E0B\6587\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751357543312132)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\521B\5EFA\201C\57FA\672C\793A\4F8B\6F14\793A\5E94\7528\7A0B\5E8F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749952612312131)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\521B\5EFA (\91CD\65B0\521B\5EFA)\201C\5546\4E1A\6837\5F0F\201D\6F14\793A\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751414881312132)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\521B\5EFA\201C\6536\85CF\54C1\5C55\793A\201D\6F14\793A\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751517750312132)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\65B9\6848 %0 \4E2D\521B\5EFA\6216\91CD\65B0\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749895354312131)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\793A\4F8B\5E94\7528\7A0B\5E8F\6765\6F14\793A Web \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750090131312131)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\521B\5EFA\201C\4E16\754C\676F\72C2\70ED\4E4B\65C5\201D\6F14\793A\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591083854312009)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754073518312134)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6F14\793A\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752491256312132)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5927\7EA6\6709 %0 MB \53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754840851312134)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754506015312134)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886539548312236)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C06\8981\5B89\88C5\793A\4F8B\5E94\7528\7A0B\5E8F, \8BE5\7A0B\5E8F\6F14\793A %0 \7684\4E3B\8981\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755407795312135)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ACB\5373\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754458118312134)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3 %0 \8D2D\7269\8F66\6982\5FF5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195591922312479)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752271261312132)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\603B\7EDF\5C31\804C\6F14\8BF4\201D\6F14\793A\9700\8981\5927\7EA6 7MB \7684\53EF\7528\78C1\76D8\7A7A\95F4, \5E76\4E14\5728\60A8\7684\65B9\6848\4E2D\5B89\88C5\9700\8981\4E24\5206\949F\7684\65F6\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886295361312235)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8DB3\591F\7A7A\95F4, \65E0\6CD5\521B\5EFA\6B64\6F14\793A\3002\901A\8FC7\8F6C\81F3\7BA1\7406\9875, \7136\540E\8F6C\5230\9884\914D\670D\52A1, \5355\51FB\8BF7\6C42\989D\5916\5B58\50A8\7A7A\95F4\7684\94FE\63A5, \5373\53EF\8BF7\6C42\989D\5916\7684\5B58\50A8\7A7A\95F4\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754780281312134)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750788413312131)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749669321312130)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750688188312131)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751787841312132)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107749748224312130)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750382519312131)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5B58\5728\4EE5\4E0B\6570\636E\5E93\5BF9\8C61\5219\91CD\65B0\521B\5EFA\5B83\4EEC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750502300312131)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751219533312132)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755297485312135)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA0\7269\5546\5E97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755939585312135)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\7EDF\5C31\804C\6F14\8BF4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756213202312135)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\76EE\8DDF\8E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963425273312294)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754612419312134)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750485811312131)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751091712312131)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754163743312134)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750800935312131)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753986427312134)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6F14\793A\5E94\7528\7A0B\5E8F\5B89\88C5\72B6\6001\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751170058312132)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195636328312479)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616386527312029)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\8FDB\884C\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773904393312938)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\66F4\6B63\4EE5\4E0B\65E0\6548\5BF9\8C61\624D\80FD\6B63\5E38\8FD0\884C Websheets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755781987312135)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752595555312133)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\4E0D\91CD\65B0\521B\5EFA\6B64\6F14\793A, \53EF\80FD\4F1A\9047\5230\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697520315312091)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8DB3\591F\7A7A\95F4, \65E0\6CD5\521B\5EFA\6B64\6F14\793A\3002\901A\8FC7\8F6C\81F3\7BA1\7406\9875\5E76\5355\51FB "\8BF7\6C42\66F4\6539\5F53\524D\670D\52A1" \94FE\63A5\53EF\4EE5\8BF7\6C42\989D\5916\7684\5B58\50A8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697412071312090)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA %0 \6F14\793A\5E94\7528\7A0B\5E8F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352868788312607)
,p_name=>'DEPRECATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648575249312053)
,p_name=>'DERIVED$'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3E\751F\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028872794312346)
,p_name=>'DESIRABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101690178312404)
,p_name=>'DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158304451312449)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101735023312404)
,p_name=>'DETAIL_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599 2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599937130312016)
,p_name=>'DEVELOPER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163747978312453)
,p_name=>'DEVELOPERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048410914312361)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6D3B\52A8\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072221755312381)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556724195311982)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065545280312375)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221626448312499)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221510759312499)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569956837312781)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247840320312521)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\8BD5 (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247394918312521)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8C03\8BD5\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247568902312521)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F\FF08\9ED8\8BA4\503C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247644947312521)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8DDF\8E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247715262312521)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6574\8DDF\8E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556837843311982)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210784388312491)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\9875\52A0\8F7D\4EE5\6765\51FA\73B0\4E86\4E00\4E2A\6216\591A\4E2A\9519\8BEF\3002\6253\5F00\6D4F\89C8\5668\7684 JavaScript \63A7\5236\53F0\4EE5\67E5\770B\9519\8BEF\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210929135312491)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \9519\8BEF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570046553312781)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5FBD\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284517363312552)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\529F\80FD\9700\8981\6253\5F00 Application Express \5E94\7528\7A0B\5E8F\6784\5EFA\5668\7A97\53E3\3002\662F\5426\5728\6B64\7A97\53E3\4E2D\6253\5F00\6784\5EFA\5668?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280673296312549)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\5DE5\5177\680F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282395240312550)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282509731312551)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282444779312551)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\663E\793A\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282789336312551)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282614946312551)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282828863312551)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284123560312552)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216663182312496)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216834424312496)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6027\80FD\8BA1\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280730834312549)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\901F\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216716488312496)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\9875\8BA1\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781610138312951)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6EDA\52A8\6761')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282254482312550)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\5DE5\5177\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023197543312342)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\4EFB\52A1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191492783312476)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\8B66')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191395787312476)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191202729312475)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4E\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540587496311969)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622961966312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625354412312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625408551312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624526875312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624485360312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811076135312973)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624128919312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624392699312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624699623312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624744352312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624804816312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574108271311995)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624921253312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625065074312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623020347312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624067262312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623447391312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997800867312324)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998056637312324)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997961395312324)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623766867312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664633831312065)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664716413312066)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C - \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623577082312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IR \533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623615301312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623295551312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623927546312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623136611312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564182914312776)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623313236312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746177382312916)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107623846674312034)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625119519312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107624271152312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771875936312936)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772179815312937)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\544A\67E5\8BE2 SQL \8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771765589312936)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720826144312897)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625576883312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621079226312032)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107627065618312037)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810724391312973)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810853163312973)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\5BF9\8C61\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626838400312037)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\5BF9\8C61\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626980571312037)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\5BF9\8C61\811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625267634312035)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625924544312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626094907312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626109585312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689428225312084)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626207158312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626347788312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626440690312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626589651312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F LOV \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626629854312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107626771516312037)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625838372312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614453255312027)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562228330311986)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053600219312365)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608299286312023)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608362515312023)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7FFB\8BD1\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625742117312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107625674051312036)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737789846312910)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737802513312910)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092899729312398)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236\7528\6237\89D2\8272\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551308885311977)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551597799311977)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316 - \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773629504312938)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDE\63A5\7684\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578800964312000)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005333100312329)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\8BED\6CD5\5206\6790\6982\8981\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005485161312329)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\8BED\6CD5\5206\6790\6982\8981\6587\4EF6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789018191312956)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752786940312922)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310898091312574)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305182253312569)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305238187312569)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\8868\67E5\627E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305367978312569)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\8868\8F6C\6362\89C4\5219')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568709981311991)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567758645311990)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567875952311990)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281736376312550)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281862952312550)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281971921312550)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542783250311971)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542820234311971)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE\5C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640622628312047)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640705868312047)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052196175312364)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695642759312089)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642891065312049)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101965892312405)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\8FD0\7B97\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810950789312973)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751638541312921)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6\6807\51C6\5C5E\6027\5143\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005277524312329)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL \670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564091117312776)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810614327312973)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726929055312902)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780126612312950)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780258117312950)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694033943312088)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\663E\793A\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620917856312032)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005999618312330)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6 REST \6E90\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005638570312330)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005748437312330)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005857815312330)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005551706312330)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\8FDC\7A0B\670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551849950311978)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \540C\6B65\6B65\9AA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551730223311978)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551931984311978)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\6D88\606F\65E5\5FD7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754322536312923)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528\201C\4E0B\4E00\6B65\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754264366312923)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528\201C\4E0A\4E00\6B65\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154900424312447)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528\89E6\53D1\5668 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760303113312138)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760523971312139)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6761\4EF6\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200678330312483)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\987A\5E8F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646861454312052)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810344020312973)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\503C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749647224312919)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749748735312919)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\7528\6237')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573818555311995)
,p_name=>'DML_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DML \8868\5355')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868013601312221)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044246202312358)
,p_name=>'DOC_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045457974312359)
,p_name=>'DOC_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045685175312359)
,p_name=>'DOC_WRITER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863\4F5C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933282350312272)
,p_name=>'DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053467264312365)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D\94FE\63A5\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867755499312221)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\66F4\65B0\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867878036312221)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\66F4\65B0\6570\636E\6761\76EE\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867980343312221)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\66F4\65B0\4EC5\663E\793A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867687397312221)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\66F4\65B0\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868484458312222)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\66F4\65B0\9875\9879')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730473309312115)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638229082312045)
,p_name=>'DRILLDOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC6\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638193075312045)
,p_name=>'DRILLUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C47\96C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775797454312150)
,p_name=>'DRIVEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A71\52A8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154715726312446)
,p_name=>'DROP TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\89E6\53D1\5668 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153810163312446)
,p_name=>'DROP_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5217 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301270859312565)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301066830312565)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED1\5B9A\53D8\91CF\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301450481312566)
,p_name=>'DS_HANDLER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301866561312566)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\7684\9879\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301662694312566)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8 MIME \7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301795059312566)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\539F\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301301823312566)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301965389312566)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\7EA6\675F\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301142343312565)
,p_name=>'DS_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108301595832312566)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302089966312566)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \524D\7F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300734041312565)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772289383312937)
,p_name=>'DUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\622A\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045289048312359)
,p_name=>'DUE_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\622A\6B62\65E5\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025772630312344)
,p_name=>'DUPLICATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750312235312920)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\4E2D\7528\6237\91CD\590D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562605432311986)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562527459311986)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572794026311994)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678656528312076)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729376499312115)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555757449311981)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\5F15\7528')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107825127550312189)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\7684\6761\4EF6\5DF2\9020\6210\67E5\8BE2\65E0\6548\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567240021311990)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085822189312392)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9009\62E9\201C\786E\5B9A\201D, \672A\4FDD\5B58\7684\66F4\6539\5C06\4E22\5931\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599299733312016)
,p_name=>'EDIT_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826399575312190)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6240\6709\9875\5B9A\4E49\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080701987312387)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6B64\533A\57DF\4E2D\7684\6240\6709\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011425767312334)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100446213312403)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695467998312877)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090271347312396)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100515934312403)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\7EC4\4EF6\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191969978312476)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100356958312403)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5217\8868\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764258313312930)
,p_name=>'EDIT_LOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971936774312301)
,p_name=>'EDIT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828462598312191)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9875\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359355340312612)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6982\8981\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376780273312626)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 0% \65E0\6743\66F4\65B0\5176\4ED6\7528\6237\7684\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090039009312395)
,p_name=>'EDIT_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164521445312454)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\62A5\544A\65F6\95F4\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090181906312395)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353575349312607)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\62A5\8868 - \5BF9\8BDD\6846\5DF2\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080018140312387)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\7CFB\7EDF\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315456075312577)
,p_name=>'EDIT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101893534312405)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6B64\5C5E\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954251494312288)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\65F6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032834328312349)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">\8BBF\95EE\201C\6211\7684\5E94\7528\7A0B\5E8F\201D\5E76\7BA1\7406\7535\5B50\90AE\4EF6\9996\9009\9879</a>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039731826312355)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<b style="font-size: 24px;">\6211\7684\5E94\7528\7A0B\5E8F</b>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154224730312446)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>#INVITEE# \60A8\597D\FF1A</strong><br>'),
'<br>',
unistr('\6211\4EEC\5728\6B64\63D0\9192\60A8\FF0C\60A8\53D7\9080\53C2\52A0\7684\6D3B\52A8\5373\5C06\4E3E\884C\3002\8BF7\67E5\770B\4EE5\4E0B\6D3B\52A8\8BE6\7EC6\4FE1\606F\FF1A<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\7EC4\7EC7\8005</th>'),
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\6D3B\52A8\65E5\671F</th>'),
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\5F00\59CB\65F6\95F4</th>'),
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\6301\7EED\65F6\95F4</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\5730\70B9</th>'),
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\6CE8\91CA</th>'),
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032770876312349)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>#CUSTOMER_NAME# \60A8\597D</strong>\FF1A<br>'),
'<br>',
unistr('\611F\8C22\60A8\4E0B\8BA2\5355\FF01<br>'),
'<br>',
unistr('<strong>\8BA2\5355\8BE6\7EC6\4FE1\606F</strong><br>'),
'<br>',
'<table width="100%">',
'  <tr>',
unistr('    <th align="left">\8BA2\5355\65E5\671F</th>'),
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\8BA2\5355\53F7</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\6536\8D27\4EBA</th>'),
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\6536\8D27\5730\5740</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">\8BA2\8D2D\7684\4EA7\54C1</th>'),
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">\8BA2\5355\603B\8BA1</th>'),
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('\9700\8981\66F4\6539\8BA2\5355\FF1F<a href="#ORDER_URL#">\5728\6B64\5904\7BA1\7406\60A8\7684\8BA2\5355 #ORDER_NUMBER#\3002</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353899669312608)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#SERVICE_USER# \60A8\597D\FF1A<br>'),
'<br>',
unistr('\8BF7\6CE8\610F\FF0C\60A8\7684\670D\52A1 #SERVICE_NAME# \5373\5C06\8FDB\884C\5DF2\8C03\5EA6\7684\505C\673A\3002<br>'),
unistr('\6B64\6B21\505C\673A\5B89\6392\5728 #OUTAGE_START# \5F00\59CB\FF0C\5E76\4E14\670D\52A1\8BA1\5212\5728 #OUTAGE_DURATION# #OUTAGE_TIMEFRAME# \671F\95F4\4E0D\53EF\7528\3002<br>'),
'<br>',
unistr('\6B64\6B21\8C03\5EA6\505C\673A\671F\95F4\5C06\6267\884C\4EE5\4E0B\64CD\4F5C\FF1A<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('\6709\5173\4E0E\6B64\6B21\505C\673A\76F8\5173\7684\4EFB\610F\95EE\9898\FF0C\8BF7\4E0E #OUTAGE_CONTACT# \8054\7CFB\3002<br>'),
'<br>',
unistr('\8C22\8C22\60A8\7684\7406\89E3\FF0C<br>'),
'#SERVICE_TEAM#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353201639312607)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\63D0\9192\FF1A#EVENT_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353372836312607)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\8BA4\8BA2\5355 (#ORDER_NUMBER#)\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154427298312446)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#INVITEE# \60A8\597D\FF1A'),
'',
unistr('\6B64\7535\5B50\90AE\4EF6\65E8\5728\63D0\9192\60A8\FF0C\4E0E\60A8\6709\5173\7684\6D3B\52A8\5373\5C06\4E3E\884C\3002'),
'',
unistr('\6D3B\52A8\65E5\671F\FF1A#EVENT_DATE#'),
unistr('\5F00\59CB\65F6\95F4\FF1A#START_TIME#'),
unistr('\6301\7EED\65F6\95F4\FF1A#DURATION#'),
unistr('\7EC4\7EC7\8005\FF1A  #ORGANIZER#'),
unistr('\5730\70B9\FF1A    #LOCATION#'),
unistr('URL\FF1A     #URL_NAME# (#URL_LINK#)'),
unistr('\6CE8\91CA\FF1A    #NOTES#'),
'',
unistr('\5728\4EE5\4E0B\4F4D\7F6E\67E5\770B\6D3B\52A8\8BE6\7EC6\4FE1\606F\FF1A#EVENT_LINK#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154340471312446)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#CUSTOMER_NAME# \60A8\597D\FF1A'),
'',
unistr('\611F\8C22\60A8\4E0B\8BA2\5355\FF01'),
'',
unistr('\8BA2\5355\8BE6\7EC6\4FE1\606F'),
'--------------------------------------------------------------------------------',
unistr('  \8BA2\5355\65E5\671F\FF1A       #ORDER_DATE#'),
unistr('  \8BA2\5355\53F7\FF1A         #ORDER_NUMBER#'),
unistr('  \6536\8D27\4EBA\FF1A         #SHIP_TO#'),
unistr('  \6536\8D27\5730\5740\FF1A       #SHIPPING_ADDRESS_LINE_1#'),
'                   #SHIPPING_ADDRESS_LINE_2#',
unistr('  \8BA2\8D2D\7684\4EA7\54C1\FF1A     #ITEMS_ORDERED#'),
unistr('  \8BA2\5355\603B\8BA1\FF1A       #ORDER_TOTAL#'),
'--------------------------------------------------------------------------------',
'',
unistr('\9700\8981\66F4\6539\8BA2\5355\FF1F\5728\6B64\5904\7BA1\7406\60A8\7684\8BA2\5355 #ORDER_NUMBER#\FF1A#ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353721293312607)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#SERVICE_USER# \60A8\597D\FF1A'),
'',
unistr('\8BF7\6CE8\610F\FF0C\60A8\7684\670D\52A1 #SERVICE_NAME# \5373\5C06\8FDB\884C\5DF2\8C03\5EA6\7684\505C\673A\3002'),
unistr('\6B64\6B21\505C\673A\5B89\6392\5728 #OUTAGE_START# \5F00\59CB\FF0C\5E76\4E14\670D\52A1\8BA1\5212\5728 #OUTAGE_DURATION# #OUTAGE_TIMEFRAME# \671F\95F4\4E0D\53EF\7528\3002'),
'',
unistr('\6B64\6B21\8C03\5EA6\505C\673A\671F\95F4\5C06\6267\884C\4EE5\4E0B\64CD\4F5C\FF1A'),
'#OUTAGE_REASON#',
'',
unistr('\6709\5173\4E0E\6B64\6B21\505C\673A\76F8\5173\7684\4EFB\610F\95EE\9898\FF0C\8BF7\4E0E #OUTAGE_CONTACT# \8054\7CFB\3002'),
'',
unistr('\8C22\8C22\60A8\7684\7406\89E3\FF0C'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084049212312390)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\542F\7528\8C03\8BD5 \662F\6216\5426 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154832381312446)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\89E6\53D1\5668 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601499962312017)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\52A0\5BC6\7684\503C\957F\5EA6\4E0D\80FD\8D85\8FC7 4000 \5B57\8282\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600046529312016)
,p_name=>'END_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022896650312342)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6539\8FDB\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377415280312626)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6539\8FDB\8BF7\6C42: %1 \4E2A\5DF2\5173\95ED, \5171 %0 \4E2A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025248873312344)
,p_name=>'ENTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8F93\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566462276311989)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Websheets \8EAB\4EFD\8BC1\660E\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013076248312335)
,p_name=>'ENTRY LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012999204312335)
,p_name=>'ENTRY TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE\6587\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068389787312378)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931474361312270)
,p_name=>'ERRORPAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\9519\65F6\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081024377312388)
,p_name=>'ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014287185312336)
,p_name=>'ERROR_ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771238567312936)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\6D88\606F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006430876312330)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<br><strong>\8F6C\4E49\6570\636E\8D85\51FA\4E86\5141\8BB8\7684\9650\5236, \7ED3\679C\622A\53D6\4E3A 32K</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774983548312150)
,p_name=>'ESCAPE_SC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\4E49\7279\6B8A\5B57\7B26')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046607923312360)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F30\8BA1\5DE5\4F5C\91CF (\5C0F\65F6)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300971332312565)
,p_name=>'ETAG_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ETAG \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300851633312565)
,p_name=>'ETAG_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ETAG \7C7B\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023316423312342)
,p_name=>'EVENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357976952312611)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358229264312611)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357840492312611)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360482576312613)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5668\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821551099312186)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CC\51FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821764968312186)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821688360312186)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821815248312186)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5212\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821459950312186)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\51FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357330700312610)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356698618312610)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356731603312610)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CC\51FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356197678312609)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\5F97\7126\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356035794312609)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\53BB\7126\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357589112312610)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\4E0B\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357682450312611)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357717683312611)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CA\653E\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356241230312609)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\8D44\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356862703312610)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\4E0B\9F20\6807\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357169532312610)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9F20\6807\8FDB\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357210144312610)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9F20\6807\79BB\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357098921312610)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8\9F20\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356977642312610)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CA\653E\9F20\6807\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565446447311988)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363774191312615)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356391941312610)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\6574\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356445302312610)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565526198311988)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6EDA\52A8\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565658183311988)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6EDA\52A8\505C\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108357423959312610)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564652170311988)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5212\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564783484311988)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5DE6\5212')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564866463311988)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\53F3\5212')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564443813311987)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\51FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564526721311988)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\51FB\5E76\6309\4F4F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108356571862312610)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565265466311988)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\865A\62DF\5355\51FB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565337084311988)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\78B0\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564968648311988)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\78B0\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565052597311988)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\78B0\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565102908311988)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\78B0\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360638918312613)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561471252311985)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561562519311985)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360590309312613)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6846\67B6\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937822947312275)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\5DF2\5173\95ED\6216\5DF2\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089954853312395)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\5DF2\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779121279312942)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779271532312942)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779071360312942)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008194270312331)
,p_name=>'EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045337433312359)
,p_name=>'EVENT_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CC\7A0B\7891\7F16\53F7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086275315312392)
,p_name=>'EXACT_SUBS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CBE\786E\66FF\6362')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200067162312482)
,p_name=>'EXAMPLE_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200124351312482)
,p_name=>'EXAMPLE_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700226894312881)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\5305\542B\5728 XML \6570\636E\5E93\5217\4E2D\7684\6570\636E\7684\793A\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750295944312920)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B URI')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155976834312447)
,p_name=>'EXCLUDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135578484312431)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\7684\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077547037312385)
,p_name=>'EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632837812312041)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728 SQL \67E5\8BE2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348183678312603)
,p_name=>'EXPANDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6269\5C55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746092736312916)
,p_name=>'EXPAND_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\5C55\5F00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698043449312091)
,p_name=>'EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\6548')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011638432312334)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E3\91CA\8BA1\5212')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008440716312332)
,p_name=>'EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316707335312578)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA\8D44\6599\6863\6848\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090569298312396)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A\6216\5E94\7528\7A0B\5E8F\4E2D\5BFC\51FA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090665731312396)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5F53\524D\5DE5\4F5C\533A\4E2D\5BFC\51FA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159977027312450)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164115241312454)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\8FD9\4E9B\94FE\63A5\53EF\4EE5\4E0B\8F7D\6B64\5E94\7528\7A0B\5E8F\53CA\5176\5BF9\5E94\7684\6570\636E\5E93\652F\6301\5BF9\8C61\FF0C\4EE5\4FBF\5728\5176\4ED6 Oracle APEX \5B89\88C5\4E2D\8FDB\884C\90E8\7F72\3002\4E0B\8F7D\7684\6587\4EF6\4E3A\53EF\4EE5\4ECE SQL*Plus \6216 SQL Developer \8FD0\884C\7684 SQL \811A\672C\6216 Oracle APEX \4E2D\7684 SQL \811A\672C\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160055235312450)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA\652F\6301\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008714291312332)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008925695312332)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\6837\5F0F\8868\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009162829312332)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\6587\4EF6\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009009700312332)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008807394312332)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009251007312332)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\6587\4EF6\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108005110446312329)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\9ED8\8BA4\8BBE\7F6E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936222598312274)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934255328312273)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936055901312274)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107750934029312131)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID \4ECE 3000 \81F3 8999 \4E3A\7CFB\7EDF\4FDD\7559\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634041540312042)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\662F\4ECE\5F53\524D\5DE5\4F5C\533A\4E2D\5BFC\51FA\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634185171312042)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\662F\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A\4E2D\5BFC\51FA\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567893999312779)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \8FDC\7A0B\6253\5370\670D\52A1\5668\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567600095312779)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \8FDC\7A0B\6253\5370\670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935914791312274)
,p_name=>'F4000.BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949851472312284)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F, \4ECE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950018151312284)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935553383312274)
,p_name=>'F4000.BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076572514312384)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689333836312084)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811828883312178)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950446529312285)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714452174312892)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\7684\5217\540D\662F Oracle \4FDD\7559\7684\5173\952E\5B57\3002\8BF7\9009\62E9\5176\4ED6\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077931099312385)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5217\8868\6761\76EE\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963729612312295)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648282842312053)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633948448312042)
,p_name=>'F4000.EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965918357312296)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FEE\590D\6211')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963359526312294)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963202963312294)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\7528\6237\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950157024312284)
,p_name=>'F4000.FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752070306312132)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\5FC5\987B\5305\542B <strong>&lt;head&gt;</strong> \548C <strong>&lt;/head&gt;</strong> \6807\8BB0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752359356312132)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>#HEAD#</strong> \66FF\6362\5B57\7B26\4E32\5FC5\987B\51FA\73B0\5728 <strong> &lt;head&gt;</strong> \548C <strong>&lt;/head&gt;</strong> \6807\8BB0\4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020973768312341)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6 "%0" \7684\7C7B\578B\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935216669312273)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935341526312273)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580661381312001)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103981735312406)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968421306312298)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936647544312274)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580539852312001)
,p_name=>'F4000.LOCAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5730')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936962232312275)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950226913312285)
,p_name=>'F4000.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936810694312275)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980222745312307)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3\5C11\5FC5\987B\9009\62E9\4E00\4E2A\8981\590D\5236\6216\8BA2\9605\7684\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936385742312274)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867034490312221)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934177385312272)
,p_name=>'F4000.NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963894902312295)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948324631312283)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773740726312938)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \5728\5F53\524D\5DE5\4F5C\533A\4E2D\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374674236312624)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\68C0\67E5\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973025153312302)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636786746312044)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\6309\94AE\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636368235312044)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\53D6\6D88\201D\6309\94AE\663E\793A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636840962312044)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210\6309\94AE\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636451485312044)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5B8C\6210\201D\6309\94AE\663E\793A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636622715312044)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4E0B\4E00\6B65\201D\6309\94AE\663E\793A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636513729312044)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4E0A\4E00\6B65\201D\6309\94AE\663E\793A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973191593312302)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973281947312302)
,p_name=>'F4000.P119.GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973339495312302)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\4E0E\73B0\6709\5E94\7528\7A0B\5E8F\76F8\540C\7684\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776265683312940)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777971388312941)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\6388\6743\65B9\6848:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778256844312941)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\9762\5305\5C51\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778340375312941)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\6309\94AE\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778471627312941)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\65E5\5386\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560030538311984)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\6570\636E\52A0\8F7D\5B9A\4E49\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777826569312941)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\6807\7B7E\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777621003312941)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\5217\8868\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777301990312941)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\503C\5217\8868:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778131538312941)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\5BFC\822A\680F\6761\76EE:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777429622312941)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\9875\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778519247312942)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\63D2\4EF6:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778631109312942)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\5F39\51FA\5F0F\503C\5217\8868\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777586843312941)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\533A\57DF\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777779558312941)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\62A5\8868\6A21\677F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778004213312941)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B\5FEB\6377\65B9\5F0F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136607244312432)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\53D1\5E03 <strong>%0</strong>\3002\8FD9\5C06\5237\65B0\4EE5\4E0B REST \6570\636E\6E90\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981057479312308)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \7684\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776164425312940)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773878123312938)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107751628105312132)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\81F3\5C11\6307\5B9A\4E00\9879\624D\80FD\521B\5EFA\201C\975E\7A7A\503C\201D\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686054587312870)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \6253\5370\670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397873854312642)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\9ED8\8BA4\5BFC\51FA\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509582955312733)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017208394312338)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015345010312337)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\8FD0\884C\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782668506312951)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDE\63A5\7684\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015929560312337)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\503C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782531026312951)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015638324312337)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016179503312337)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015860526312337)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015722287312337)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015272719312337)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\663E\793A\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017191745312338)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016208188312337)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015567126312337)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\6267\884C\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108015453917312337)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016088827312337)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\503C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778872701312942)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5EFA\5217\8868\6761\76EE\7684\7236\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811494452312178)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\81F3\5C11\6307\5B9A\4E00\4E2A\8981\521B\5EFA\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933828236312272)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\5DF2\5B58\5728, \56E0\6B64\672A\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933998764312272)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779692606312942)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\9501')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811546316312178)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\81F3\5C11\6307\5B9A\4E00\4E2A\8981\521B\5EFA\7684\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779735754312942)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5F53\524D\5DF2\53D6\6D88\9501\5B9A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343140591312599)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973714963312302)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973807915312302)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973995509312302)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974029242312303)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571962971311993)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140871221312435)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140941635312435)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141050680312435)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974134352312303)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DML \548C\9875\7801\6309\94AE\9700\8981\7279\5B9A\7684\6309\94AE\540D\79F0, \5F15\7528\5E2E\52A9\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776355397312940)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 (\7C7B\5339\914D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974280915312303)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782987046312952)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\539F\59CB\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974391721312303)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362\5B57\7B26\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974426264312303)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947782355312283)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">\5728\4F7F\7528\4EE5\4E0B\8BED\6CD5\8C03\7528\65F6, \6B64\533A\57DF\5C06\663E\793A\5F53\524D\9875\7684\9875\548C\9879\5E2E\52A9:<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974598301312303)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E %0 \7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974699558312303)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698723285312091)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966801410312297)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589465857312008)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\7CFB\5217=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967014601312297)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966415264312297)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\6B21\7EA7\6587\672C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966302918312297)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF =')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966973279312297)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966506263312297)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698839114312092)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966756040312297)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 =')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967120260312297)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589369077312008)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963952435312295)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7684\6BCF\9875\5FC5\9700\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966094453312296)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966110741312296)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966270267312297)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967311255312297)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\540D=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967466716312297)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\96C6=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107966657914312297)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967265984312297)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976386329312304)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976924750312305)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'zh-cn'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975995268312304)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5916\89C2 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976056133312304)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5916\89C2 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976126544312304)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5916\89C2 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976245215312304)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5916\89C2 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975075797312303)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5916\90E8\521B\5EFA\7684\9875\7801\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975803512312304)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6807\51C6\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976569076312304)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976603325312305)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976762565312305)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976897119312305)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975502441312304)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4ECE X \5230 Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975244879312303)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868\4E2D\7684\884C\8303\56F4 1-15 16-30')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975754901312304)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5F15\64CE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975355764312303)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5F15\64CE 1,2,3,4 (\57FA\4E8E\96C6\7684\9875\7801)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975606071312304)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974849032312303)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974960373312303)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975424243312304)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9875\7801\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977023572312305)
,p_name=>'F4000.P420.XML'
,p_message_language=>'zh-cn'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107976400407312304)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('XML \5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977159458312305)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107975183426312303)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y (\5177\6709\201C\4E0B\4E00\9875\201D\548C\201C\4E0A\4E00\9875\201D\94FE\63A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802280743312967)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101129649312404)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101308377312404)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101469852312404)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101234723312404)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101066576312404)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977295573312305)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DML \6309\94AE\9700\8981\7279\5B9A\7684\6309\94AE\540D\548C\5F15\7528\5E2E\52A9\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643891108312049)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5728\5E94\7528\7A0B\5E8F%0\4E2D\521B\5EFA\65B0\63D2\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643740658312049)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\66FF\6362\5E94\7528\7A0B\5E8F%0\4E2D\7684\73B0\6709\63D2\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977399465312305)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\5FEB\6377\65B9\5F0F\7684 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977530760312305)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968291249312298)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\6309\94AE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689212424312084)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798545751312964)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\56FE\8868\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689018920312084)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5BF9\8BDD\6846\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798673087312964)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8868\5355\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799052071312964)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\4EA4\4E92\5F0F\62A5\8868\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968129049312298)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\6807\7B7E\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798739284312964)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5217\8868\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968071736312298)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799202143312964)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\9762\5305\5C51\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968332869312298)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798333888312964)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5BFC\822A\680F\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798080883312963)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5BFC\822A\83DC\5355\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797810859312963)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\7684\53EF\9009\6807\7B7E\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967702904312298)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967802410312298)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798854654312964)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\62A5\8868\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967940936312298)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797964572312963)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\7684\5FC5\9700\6807\7B7E\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798245190312964)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5B50\5BFC\822A\83DC\5355\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798997453312964)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8868\683C\5F0F\8868\5355\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798103421312964)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\9876\90E8\5BFC\822A\83DC\5355\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799151717312964)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5411\5BFC\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967638764312298)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\9519\8BEF\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108798405641312964)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\767B\5F55\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107967553388312297)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\6253\5370\6A21\5F0F\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107974762304312303)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E %0 \7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971345871312300)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\8B66\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971516494312301)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971280017312300)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\521B\5EFA\9875\9879\4E4B\524D, \60A8\81F3\5C11\5FC5\987B\521B\5EFA\4E00\4E2A\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971478646312301)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5411\5BFC\6765\521B\5EFA\65B0\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972762935312301)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5B57\6BCD\987A\5E8F\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972927221312302)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 4: \5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972887586312302)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\521B\5EFA\987A\5E8F\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972437009312301)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 2: \5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065274502312375)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 5: \67E5\8BE2\5305\542B\5185\5D4C\67E5\8BE2, \5FC5\987B\786E\4FDD SQL \8BED\53E5\4E2D\7684\7B2C\4E00\4E2A FROM \5B50\53E5\4E0D\662F\8BE5\5185\5D4C\67E5\8BE2\7684\4E00\90E8\5206')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972398354312301)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 1: \57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972635289312301)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B 3: \9759\6001\5217\8868\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972569295312301)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642756585312049)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A Yes/No, \8FD4\56DE Y \548C N')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978158587312306)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977863012312305)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978013523312306)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977943975312305)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649155228312054)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978260695312306)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646090251312051)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978478022312306)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978312590312306)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978617923312306)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\6B64\8FC7\7A0B\540E, \5C06\91CD\7F6E\6B64\5E94\7528\7A0B\5E8F\4E2D\6240\6709\9875\7684\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990764052312315)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \60A8\5DF2\9009\62E9\201C\6B63\5219\8868\8FBE\5F0F\201D\7C7B\578B\7684\9A8C\8BC1, \4F46\662F\60A8\7684\6570\636E\5E93\7248\672C\4E0D\652F\6301\3002\6B64\9A8C\8BC1\5C06\59CB\7EC8\8FD4\56DE\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727639317312902)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\672A\5BF9\6B64\5E94\7528\7A0B\5E8F\542F\7528\7FFB\8BD1\3002\8BF7\67E5\770B<a href="%0">\5168\7403\5316\5C5E\6027</a>\4E2D\7684<em>\5E94\7528\7A0B\5E8F\8BED\8A00\6E90\4E8E</em>\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789879455312957)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\672A\8BBE\7F6E\201C\6700\957F\4F1A\8BDD\7A7A\95F2\65F6\95F4\201D, \5C06\4F7F\7528\5DE5\4F5C\533A\7EA7\522B\6216\5B9E\4F8B\7EA7\522B\503C (\5F53\524D\4E3A %0 \79D2)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789956019312957)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\672A\8BBE\7F6E\201C\6700\5927\4F1A\8BDD\957F\5EA6\201D, \5C06\4F7F\7528\5DE5\4F5C\533A\7EA7\522B\6216\5B9E\4F8B\7EA7\522B\503C (\5F53\524D\4E3A %0 \79D2)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780379441312950)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091406297312396)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\4E9B\7EC4\4EF6\662F\4ECE\53E6\4E00\4E2A\5E94\7528\7A0B\5E8F\5BFC\51FA\7684, \6216\662F\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A\4E2D\7684\5E94\7528\7A0B\5E8F\5BFC\51FA\7684\3002\65E0\6CD5\5728\6B64\5E94\7528\7A0B\5E8F\4E2D\5B89\88C5\8FD9\4E9B\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095449424312399)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\4E9B\6587\4EF6\662F\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A\5BFC\51FA\7684\3002\65E0\6CD5\5728\6B64\5DE5\4F5C\533A\4E2D\5B89\88C5\8FD9\4E9B\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780484550312950)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781209552312950)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\9009\9879: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781383137312951)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\503C\5217\8868: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032346247312349)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5DF2\4ECE\53E6\4E00\4E2A\5E94\7528\7A0B\5E8F\5BFC\51FA, \6216\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A\4E2D\7684\5E94\7528\7A0B\5E8F\5BFC\51FA\3002\65E0\6CD5\5728\6B64\5E94\7528\7A0B\5E8F\4E2D\5B89\88C5\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933712086312272)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5DF2\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A\4E2D\7684\5E94\7528\7A0B\5E8F\5BFC\51FA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933698085312272)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5DF2\4ECE\5F53\524D\5DE5\4F5C\533A\4E2D\7684\5E94\7528\7A0B\5E8F\5BFC\51FA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352628631312607)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5F53\524D\5904\4E8E\9501\5B9A\72B6\6001\3002\4E0D\80FD\5BFC\5165\9501\5B9A\9875\3002\8BF7\5148\53D6\6D88\9501\5B9A\8BE5\9875, \7136\540E\518D\5B89\88C5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108778994128312942)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\7236\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780718722312950)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\53C2\6570 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752602130312133)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\81F3\5C11\9009\62E9\4E00\4E2A\8981\590D\5236\7684\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780955141312950)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP \6807\5934 %0 \7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780876441312950)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\53C2\6570 %0 \7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781103680312950)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\6807\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781009259312950)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\53C2\6570: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980453473312307)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9700\7684\6837\5F0F\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949597869312284)
,p_name=>'F4000.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964138779312295)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935678412312274)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690498768312085)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551409209311977)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\52A8\6001\64CD\4F5C - \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934310346312273)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553629809311979)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968553619312298)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949699055312284)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935784326312274)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964076106312295)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964200193312295)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936506470312274)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950547594312285)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567726325312779)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B\6253\5370\670D\52A1\5668\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951117173312285)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935168933312273)
,p_name=>'F4000.REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564283251312776)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949753262312284)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F8\5173\7684\9875\548C\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567989439312779)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065059107312375)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580701721312001)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951082203312285)
,p_name=>'F4000.SEED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\690D\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107936487409312274)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963682115312295)
,p_name=>'F4000.STATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950372673312285)
,p_name=>'F4000.TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950626413312285)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794442621312164)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\540D %0 \5DF2\5B58\5728\3002\8BF7\8F93\5165\65B0\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752743657312133)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\6A21\677F\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950815113312285)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5728\5E94\7528\7A0B\5E8F %0 \4E2D\521B\5EFA\65B0\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950901800312285)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\66FF\6362\5E94\7528\7A0B\5E8F %0 \4E2D\7684\73B0\6709\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949985497312284)
,p_name=>'F4000.TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937050241312275)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\7684\5E94\7528\7A0B\5E8F\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951262515312285)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\66F4\65B0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076480212312384)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\7528\7A0B\5E8F\5305\542B\6240\9009\5E94\7528\7A0B\5E8F\4E2D\6240\6709\9875\7684\7F51\683C\7F16\8F91\9875\548C\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935885762312274)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580865169312001)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568012824312779)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934093978312272)
,p_name=>'F4000.YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010192495312333)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F MMDDYYYY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163817227312454)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715992835312105)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\6570\636E\5E93\8868\4E0A\7684\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968991946312299)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\6570\636E\5E93\8868\4E0A\7684\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980581937312307)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6309\94AE\4F4D\7F6E\4E0D\5728\533A\57DF\6A21\677F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716598739312893)
,p_name=>'F4000_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980881021312308)
,p_name=>'F4000_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997419959312323)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5E76\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981185658312308)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\683C\5F0F\65E0\6CD5\8BC6\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648869104312053)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080217730312387)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162902116312453)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\540D %0 \5DF2\5B58\5728\3002\8BF7\8F93\5165\65B0\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004007414312328)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\5B9A\4EFB\4F55\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960347401312292)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\76F8\5173\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592156992312010)
,p_name=>'F4000_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592019528312010)
,p_name=>'F4000_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652471393312056)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\6B64\5BF9\8C61\7684\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033205604312350)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6B64\7C7B\578B\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761732997312140)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\6B64\9879\7684\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753725842312133)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753636412312133)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6B64\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769286353312145)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374711229312624)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\4E2D\5DF2\5B58\5728\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649209565312054)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5FC5\987B\662F\6570\5B57\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649383830312054)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5FC5\987B\4E3A\6B63\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649476030312054)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5FC5\987B\4E3A\6574\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081584491312388)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031047987312348)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081642265312388)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031169115312348)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979062161312306)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\683C\5F0F\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009887332312333)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9A8C\8BC1!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009992030312333)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001712439312327)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982309717312309)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\5728\6B64\65F6\95F4\4E0D\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731276040312116)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731380321312116)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F, \53EF\7075\6D3B\4F7F\7528: \5E26\6709\4EFB\4F55\5206\9694\7B26\7684 %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732019641312117)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BC6\522B\7684\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731928362312117)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\7684\683C\5F0F\5FC5\987B\4E3A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730720071312116)
,p_name=>'F4000_P430_IP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IP \5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731556686312116)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('IP \5730\5740\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730836092312116)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\8BDD\53F7\7801, \7F8E\56FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730932582312116)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\8BDD\53F7\7801, \7F8E\56FD, \53EF\7075\6D3B\4F7F\7528: 999.999.9999, (999)-999-9999, 999 999 9999, \7B49\7B49...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731770232312116)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BC6\522B\7684\7535\8BDD\53F7\7801\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731615168312116)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\8BDD\53F7\7801\683C\5F0F\5FC5\987B\4E3A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730618189312116)
,p_name=>'F4000_P430_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL: http(s)://domain/path/doc.(pdf)(html)(\7B49\7B49...)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731412394312116)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731094345312116)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90AE\7F16: 99999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731109204312116)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'zh-cn'
,p_message_text=>'ZIP + 4: 99999-9999'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107731828156312117)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90AE\7F16\7684\683C\5F0F\5FC5\987B\4E3A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662183729312064)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662265908312064)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\9A8C\8BC1\65B9\6848\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662416345312064)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8BA2\9605\6B64\9A8C\8BC1\65B9\6848\7684\8BA2\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662363146312064)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\9A8C\8BC1\65B9\6848\7684\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717115291312105)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \65E0\65B9\6848 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977662755312305)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982493705312309)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5B58\50A8\8FC7\7A0B\7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977710236312305)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981771487312308)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981617325312308)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981320650312308)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9879\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981223437312308)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9875\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004360725312329)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981508308312308)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 PL/SQL \51FD\6570\4F53\8BBE\7F6E\9879 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981440105312308)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\9879\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978534318312306)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\672A\5728\5F53\524D\5E94\7528\7A0B\5E8F\4E2D\9AD8\901F\7F13\5B58\7684\6240\6709\9875\9879\521D\59CB\5316\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982114605312309)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981858259312308)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107981912831312308)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982024339312309)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010318208312333)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F DDMMYYYY')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010234367312333)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\8BDD\53F7\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748622461312918)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978758536312306)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\6D4F\89C8\5668\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978848978312306)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717354483312106)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\5305\542B\65E5\671F\6216\65F6\95F4\6233\5217)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197163925312480)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5: select id, name, date from ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197444092312480)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 ROWID \4F2A\5217\7684\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197525647312480)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6E90\8868\4E3B\952E\7684\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197218287312480)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1. \5FC5\987B\81F3\5C11\5305\542B\4E24\5217, \5176\4E2D\4E00\5217\5FC5\987B\662F DATE \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197315264312480)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2. \7B2C\4E00\5217\5E94\6807\8BC6\7528\4E8E\7BA1\7406\6570\636E\64CD\7EB5\8BED\8A00 (DML) \64CD\4F5C\7684\4E3B\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107978955386312306)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092034381312397)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\5BFC\51FA\6E05\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033191979312350)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\9875\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979118045312306)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6982\8981\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997769319312324)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4EE5\8BBE\7F6E\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251808370312524)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F\652F\6301\4E24\5C42\9009\9879\5361, \4F46\6807\51C6\9009\9879\5361\65E0\6CD5\8BC6\522B\7236\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251752322312524)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9009\9879\5361, \6B64\9875\5C06\4E0D\4F1A\663E\793A\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251535101312524)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5C06\663E\793A\4E00\5C42\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251918070312524)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\9009\9879\5361\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252015426312525)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\5171 %0 \9875\672A\5B9A\4E49\9009\9879\5361\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251464352312524)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251699582312524)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5C06\663E\793A\4E24\5C42\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699337810312880)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0 \73B0\5728\53EF\7528\3002</strong> \60A8\7684\5B9E\4F8B\5C06\5728 <strong>%1</strong> \81EA\52A8\5347\7EA7\3002\60A8\7684\5B9E\4F8B\7BA1\7406\5458\53EF\4EE5\5728\6B64\65E5\671F\4E4B\524D\7684\4EFB\4F55\65F6\95F4\5728\7BA1\7406\670D\52A1\4E2D\542F\52A8\5347\7EA7\3002</p>'),
unistr('<p>\6709\5173 Oracle APEX %0 \4E2D\65B0\589E\529F\80FD\548C\589E\5F3A\529F\80FD\7684\66F4\591A\4FE1\606F\FF0C\8BF7\53C2\89C1<a href="%2" target="_blank" rel="noreferrer">\516C\544A</a>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699294590312880)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>\60A8\7684 %0 \5B9E\4F8B\5C06\5347\7EA7\5230\8F83\65B0\7684\53D1\884C\7248\3002</strong> \5728\5347\7EA7\8FC7\7A0B\4E2D\FF0C\66F4\6539\5E94\7528\7A0B\5E8F\7684\64CD\4F5C\5C06\7981\7528\4E00\6BB5\65F6\95F4\3002\5BF9\5E94\7528\7A0B\5E8F\548C %0 \5F00\53D1\73AF\5883\7684\8BBF\95EE\5C06\6700\591A\4E2D\65AD %1 \5206\949F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661080861312063)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661972177312063)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\6B64\65B9\6848\6210\4E3A\5F53\524D\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662078550312064)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\4E3A\5F53\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716983884312105)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661777600312063)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\72B6\6001\66F4\6539\4E3A\4E0D\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660578403312062)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660607822312062)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\4F1A\8BDD\7BA1\7406\903B\8F91, \5185\7F6E\767B\5F55\9875\548C\9488\5BF9\5185\90E8 "cookie \7528\6237" \5E10\6237\8D44\6599\6863\6848\5E93\7684\7528\6237\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660711597312063)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\65B9\6CD5\5DF2\88AB SCHEME \9A8C\8BC1\53D6\4EE3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714938715312104)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\8FC7\65F6\7684\9A8C\8BC1\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715075483312104)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\65F6\7684\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715137213312104)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6216\51C6\5907\5C06\9A8C\8BC1\65B9\6CD5\66F4\6539\4E3A %0 \4E4B\524D\5C06\5B83\4EEC\4FDD\6301\4E0D\53D8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715450854312104)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\4E86\4E00\4E2A\6216\591A\4E2A\8FC7\65F6\7684\9A8C\8BC1\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715670948312104)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6216\5C06\5B83\4EEC\8FC1\79FB\5230\9A8C\8BC1\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714637625312104)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661645642312063)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\4E0A\8FF0\62A5\8868\7BA1\7406\9A8C\8BC1\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660404749312062)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716802197312105)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\4E0D\53EF\7F16\8F91)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661885734312063)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\5F53\524D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714734880312104)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\5DF2\8FC7\65F6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661536617312063)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\65E0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660944707312063)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661142973312063)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\6216\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661205375312063)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6216\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661317165312063)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\7BA1\7406\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107661479931312063)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\5E94\7528\7A0B\5E8F\5C5E\6027\9875\4E0A\7684\8FD9\4E00\5E94\7528\7A0B\5E8F, \6216\4F7F\7528\4E0A\8FF0\62A5\8868\6765\521B\5EFA\548C\7BA1\7406\90A3\4E9B\5728\66F4\6539\9A8C\8BC1\65B9\6CD5\4E3A %0 \65F6\8981\7528\5230\7684\9A8C\8BC1\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715266738312104)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\6216\7F16\8F91\4F1A\8BDD\7BA1\7406\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715557774312104)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\67E5\6216\7F16\8F91\8FD9\4E9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714812216312104)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \9A8C\8BC1\662F\8FC7\65F6\7684\65B9\6CD5\3002\6211\4EEC\5EFA\8BAE\60A8\5728\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\4E00\4E2A\9A8C\8BC1\65B9\6848\4E0A\5355\51FB "\8BBE\4E3A\5F53\524D" \94FE\63A5 (\5982\4E0A\6240\793A), \6216\521B\5EFA\65B0\7684\9A8C\8BC1\65B9\6848\5E76\5C06\5176\8BBE\4E3A\5F53\524D\7684\9A8C\8BC1\65B9\6848\3002INTERNAL-SETUP \9A8C\8BC1\65B9\6848\5728\529F\80FD\4E0A\7B49\540C\4E8E %0 \65B9\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107715322522312104)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9A8C\8BC1\65B9\6848\6765\63A7\5236\5E94\7528\7A0B\5E8F\7684\7528\6237\9A8C\8BC1\548C\4F1A\8BDD\7BA1\7406\7684\5176\4ED6\6240\6709\65B9\9762\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979452112312307)
,p_name=>'F4000_P805_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5728\4E0A\4E00\6B65\4E2D\6307\5B9A\4E86\9875\536B\58EB\51FD\6570\3002\7531\4E8E\8BE5\51FD\6570\7528\4E8E\6BCF\9875\4E0A\7684\4F1A\8BDD\9A8C\8BC1, \6240\4EE5\4E0D\80FD\5728\6B64\5904\8F93\5165\4F1A\8BDD\9A8C\8BC1\51FD\6570\3002\5982\679C\60A8\4E0D\5E0C\671B\51FA\73B0\8FD9\79CD\60C5\51B5, \53EF\901A\8FC7\6B64\5411\5BFC\8FD4\56DE\524D\9762\7684\6B65\9AA4\5E76\8FDB\884C\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717963523312106)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718390988312106)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718094933312106)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718239587312106)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718132011312106)
,p_name=>'F4000_P806_URL'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718443170312106)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 %0 \5E10\6237\7528\6237\540D\548C\5BC6\7801\8FDB\884C\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604234269312020)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6570\636E\5E93\5E10\6237\7528\6237\540D\548C\5BC6\7801\8FDB\884C\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718549954312107)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\9A8C\8BC1\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718788279312107)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6211\7684\5B9A\5236\51FD\6570\6765\8FDB\884C\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718664932312107)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 LDAP \670D\52A1\5668\8FDB\884C\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982508119312309)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \65E0\9875\540D -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663182159312064)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663948002312065)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Cookie \57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663743258312065)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Cookie \540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663810230312065)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Cookie \8DEF\5F84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601333513312017)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662904914312064)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\4F1A\8BDD\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663488841312065)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \641C\7D22\57FA\7840')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663592139312065)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \7528\6237\540D\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663229672312064)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \4E3B\673A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663344813312065)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \7AEF\53E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664094559312065)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662693202312064)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662541389312064)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\5185\7F6E)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664149222312065)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\6570\636E\5E93\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662724234312064)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\536B\58EB\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663611411312065)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\540E\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107663089828312064)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\524D\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107662802360312064)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718913108312107)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\73B0\6709\9A8C\8BC1\65B9\6848\7684\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719065217312107)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5E93\4E2D\9884\914D\7F6E\7684\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107718841034312107)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5E93\4E2D\9884\914D\7F6E\7684\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676762743312075)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\9A8C\8BC1\65B9\6848\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664395752312065)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732138813312117)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \60A8\5C06\8981\5220\9664\6B64\5E94\7528\7A0B\5E8F\7684\5F53\524D\9A8C\8BC1\65B9\6848!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664596795312065)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664287605312065)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664467135312065)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719577082312107)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (\6211\7684\5E94\7528\7A0B\5E8F\4F5C\4E3A\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719174201312107)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\767B\5F55\9875\548C\4F7F\7528 %0 \5E10\6237\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719229324312107)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5185\7F6E\767B\5F55\9875\548C\4F7F\7528\5F00\95E8\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719388459312107)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\767B\5F55\9875\548C\4F7F\7528 LDAP \76EE\5F55\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719404753312107)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (%0 \5F15\64CE\4F5C\4E3A\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664813384312066)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9A8C\8BC1\65B9\6CD5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676863905312075)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\6B21\767B\5165 (\4EC5 Oracle \4F7F\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676950596312075)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (%0 \4F5C\4E3A\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677069664312075)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (\6211\7684\5E94\7528\7A0B\5E8F\4F5C\4E3A\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677145348312075)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\767B\5F55\9875: \4F7F\7528 %0 \5E10\6237\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699696893312092)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\7684\767B\5F55\9875: \4F7F\7528 %0 \5E10\6237\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699775765312092)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\767B\5F55\9875: \4F7F\7528 %0 \5E10\6237\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677209363312075)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\767B\5F55\9875: \5F00\95E8\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677337978312075)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\767B\5F55\9875: \4F7F\7528 LDAP \76EE\5F55\8EAB\4EFD\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699424501312092)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\7684\767B\5F55\9875: \4F7F\7528 LDAP \76EE\5F55\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699553726312092)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\767B\5F55\9875: \4F7F\7528 LDAP \76EE\5F55\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677434067312075)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5E93\4E2D\7684\9A8C\8BC1\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107719634669312107)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756337491312135)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \7684\8FD8\539F\529F\80FD\4F7F\7528\79F0\4E3A "\95EA\56DE\67E5\8BE2" \7684\5185\7F6E\6570\636E\5E93\529F\80FD, \53EF\7528\4E8E\67E5\8BE2\67D0\4E2A\65F6\95F4\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756114468312135)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\8FD4\56DE\5230\7684\65F6\95F4, \7136\540E\5355\51FB "\5E94\7528" \4EE5\5C06\6E90\5199\56DE\5230\533A\57DF\7F16\8F91\9875\5E76\5173\95ED\6B64\5BF9\8BDD\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756505070312136)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\6570\636E\5E93\53C2\6570 "UNDO_RETENTION", \60A8\53EA\80FD\8FD8\539F\5728\524D %0 \5C0F\65F6\5185\6240\4F5C\7684\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757065979312136)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\8BA4\5728\5E94\7528\7A0B\5E8F\4E2D\521B\5EFA\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757485653312136)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\65B0\9009\9879\5361\96C6 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757368006312136)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0 \5C06\4F7F\7528\73B0\6709\9009\9879\5361\96C6 "%1"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757131857312136)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A, \9009\9879\5361\96C6\4FE1\606F\4E0D\5B8C\6574\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198890466312481)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980905384312308)
,p_name=>'F4000_PREV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\6B65')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969214594312299)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB<strong>\5B8C\6210</strong>\53EF\521B\5EFA\6216\6269\5C55\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969027905312299)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B\9762\5305\5C51\5BFC\822A\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969142465312299)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\62A5\8868\9875\4E2D\7684\4E3B\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114778822312415)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875329787312227)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SVG \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980689805312308)
,p_name=>'F4000_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080311838312387)
,p_name=>'F4000_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195790423312479)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632694415312041)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6574\4E2A\54CD\5E94\6587\6863')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642657029312048)
,p_name=>'F400_P107_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613344829312026)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'zh-cn'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108197040159312480)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63A5\53D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067004909312377)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\5C06\5206\914D\7ED9\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067176024312377)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \5C06\4E0D\4F1A\628A\65B9\6848\5206\914D\7ED9\5DE5\4F5C\533A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066627663312376)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\52A0\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961818149312293)
,p_name=>'F4050.ADJUST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\6574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961122430312293)
,p_name=>'F4050.ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196572078312480)
,p_name=>'F4050.APPROVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6279\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617143128312029)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5DE5\4F5C\533A\8BF7\6C42\5DF2\6279\51C6, \8EAB\4EFD\8BC1\660E\5DF2\53D1\9001\5230\60A8\5728\6CE8\518C\671F\95F4\63D0\4F9B\7684\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035220619312351)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5E10\6237\8BF7\6C42\5DF2\83B7\6279\51C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035168771312351)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6279\51C6: %0 \7684\5E10\6237\8BF7\6C42 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035669435312351)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5DE5\4F5C\533A %1 \4E2D\83B7\5F97 %0 MB \7684\989D\5916\5B58\50A8\7A7A\95F4\7684\8BF7\6C42\5DF2\83B7\6279\51C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196264222312479)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707518150312886)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196104172312479)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787708519312955)
,p_name=>'F4050.BROKEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\65AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788123158312956)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\5DF2\505C\6EDE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036086915312352)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8BF7\6C42\5DF2\83B7\6279\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036177733312352)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8BF7\6C42\5DF2\88AB\62D2\7EDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787687740312955)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066730889312376)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196601546312480)
,p_name=>'F4050.DECLINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\62D2\7EDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035518989312351)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D2\7EDD: %0 \7684\5E10\6237\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035947735312352)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5DE5\4F5C\533A %1 \4E2D\83B7\5F97 %0 MB \7684\989D\5916\5B58\50A8\7A7A\95F4\7684\8BF7\6C42\5DF2\88AB\62D2\7EDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035784370312351)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\5F97\5DE5\4F5C\533A %1 \4E2D\6570\636E\5E93\65B9\6848 %0 \7684\8BF7\6C42\5DF2\88AB\62D2\7EDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035825744312352)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6C42\7EC8\6B62\5DE5\4F5C\533A %0 \7684\670D\52A1\7684\8BF7\6C42\5DF2\88AB\62D2\7EDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787363783312955)
,p_name=>'F4050.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613222494312026)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5355\51FB\4E0B\9762\7684\94FE\63A5\53EF\5B8C\6210\5BA1\6279\5904\7406\3002\5728\5B8C\6210\540E, \60A8\5C06\901A\8FC7\8DDF\8FDB\7535\5B50\90AE\4EF6\6536\5230\5DE5\4F5C\533A\8EAB\4EFD\8BC1\660E\3002'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035406416312351)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5355\51FB\4E0B\9762\7684\94FE\63A5\4EE5\5F00\59CB\3002'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787839823312956)
,p_name=>'F4050.FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640951057312047)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5355\51FB<a href=''%0''>\6B64\5904</a>\4EE5\5B8C\6210\5BA1\6279\5904\7406\5E76\63A5\6536\60A8\7684\8EAB\4EFD\8BC1\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951475504312285)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962690054312294)
,p_name=>'F4050.INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196706936312480)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FDB\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961439660312293)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979597433312307)
,p_name=>'F4050.P23.USE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790850445312958)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5BF9\6574\4E2A\5B9E\4F8B\7981\7528\66F4\65B0\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979665696312307)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066551374312376)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961719987312293)
,p_name=>'F4050.PROVISION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034929734312351)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8BF7\6C42\5DF2\83B7\6279\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034870234312351)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5BF9\5DE5\4F5C\533A %1 \4E2D\6570\636E\5E93\65B9\6848 %0 \7684\8BF7\6C42\5DF2\83B7\6279\51C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787965611312956)
,p_name=>'F4050.REMOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196818538312480)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960968761312293)
,p_name=>'F4050.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035094273312351)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A\FF1A\7531\4E8E\6240\8BF7\6C42\7684\65B9\6848\662F Oracle \9ED8\8BA4\65B9\6848\FF0C\6216\7531\4E8E\7279\5B9A\4E8E\7AD9\70B9\7684\7B56\7565\FF0C\8BE5\65B9\6848\53D7\9650\3002\65E0\6CD5\5C06\53D7\9650\65B9\6848\5206\914D\7ED9\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787466208312955)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8C03\5EA6\91CD\8BD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066929840312377)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\91CD\7528\73B0\6709\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787500011312955)
,p_name=>'F4050.RUNNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787293549312955)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8C03\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034651130312351)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \6240\8BF7\6C42\7684\65B9\6848\5DF2\5206\914D\7ED9\4E00\4E2A\6216\591A\4E2A\5DE5\4F5C\533A\3002\5728\6279\51C6\8BE5\8BF7\6C42\4E4B\524D, \8BF7\786E\4FDD\7AD9\70B9\7684\5B89\5168\7B56\7565\5141\8BB8\5C06\591A\4E2A\5DE5\4F5C\533A\8BBF\95EE\6743\9650\6388\4E88\540C\4E00\4E2A\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034524940312351)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \6240\8BF7\6C42\7684\65B9\6848\5DF2\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067275973312377)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067475084312377)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\7559\65B9\6848, \4E0D\80FD\5206\914D\7ED9\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034776649312351)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A\FF1A\7531\4E8E\6240\8BF7\6C42\7684\65B9\6848\662F Oracle \9ED8\8BA4\65B9\6848\FF0C\6216\7531\4E8E\7279\5B9A\4E8E\7AD9\70B9\7684\7B56\7565\FF0C\8BE5\65B9\6848\53D7\9650\3002\5982\679C\5C06\6B64\65B9\6848\5206\914D\7ED9\5DE5\4F5C\533A\FF0C\60A8\5C06\4E3A\8BE5\5DE5\4F5C\533A\4E2D\7684\5F00\53D1\4EBA\5458\63D0\4F9B\5BF9\8BE5\65B9\6848\7684\5B8C\5168\8BBF\95EE\6743\9650\3002\5728\6279\51C6\6B64\8BF7\6C42\4E4B\524D\FF0C\8BF7\786E\4FDD\6B64\64CD\4F5C\7B26\5408\7AD9\70B9\7684\5B89\5168\7B56\7565\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067322318312377)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\53D7\5230\5B89\5168\7B56\7565\7684\9650\5236\3002\65E0\6CD5\5C06\53D7\9650\65B9\6848\5206\914D\7ED9\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036281902312352)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\5DF2\7EC8\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036383764312352)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\670D\52A1 "%0" \5DF2\7EC8\6B62\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788049568312956)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196314241312480)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6302\8D77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196447267312480)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC8\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196962581312480)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7EC8\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787180263312955)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\7EC8\6B62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962000077312293)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962474378312294)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728479781312114)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728516879312114)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032273813312349)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\5B58\5728\5177\6709\76F8\540C ID \7684\5DE5\4F5C\533A\800C\65E0\6CD5\521B\5EFA\8BE5\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032104598312349)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\5B58\5728\540C\540D\7684\5DE5\4F5C\533A\800C\65E0\6CD5\521B\5EFA\8BE5\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805035292312173)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5728 %1 \521B\5EFA\4E86\5DE5\4F5C\533A %0, \5E76\5C06\786E\8BA4\53D1\9001\5230\60A8\5728\6CE8\518C\671F\95F4\63D0\4F9B\7684\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634244993312042)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\5DF2\5B58\5728, \56E0\6B64\672A\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634329197312042)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869478890312223)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869351799312222)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\6539\7528\6237 %0 \7684\5E10\6237\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869210992312222)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752357907312921)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\63A7\5236\5728\4E0B\4E00\4E2A\53D1\884C\7248\53EF\7528\65F6\7ACB\5373\5347\7EA7 %0\FF0C\8FD8\662F\5EF6\8FDF\5347\7EA7\FF08\81F3\591A\5EF6\8FDF %1 \5929\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752485911312921)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\7ACB\5373\5347\7EA7\201D\4EE5\7ACB\5373\5F00\59CB\5347\7EA7\FF0C\800C\4E0D\662F\5728 %0 \5347\7EA7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752044721312921)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF\662F\6700\65B0\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752109961312921)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 %1 <a href="%2" target="_blank" rel="noreferrer">\53EF\7528</a>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751150289312920)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\65E6\65B0\7684 %0 \53D1\884C\7248\53D8\4E3A\53EF\7528\FF0C\60A8\7684\5B9E\4F8B\5C06<strong>\7ACB\5373</strong>\5347\7EA7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751898302312921)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5B9E\4F8B\5C06\5728 <strong>%0</strong> \81EA\52A8\5347\7EA7\3002\5355\51FB\9F7F\8F6E\56FE\6807\53EF\4EE5\7ACB\5373\5347\7EA7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751086526312920)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5B9E\4F8B\6709 %0 \4E2A\5347\7EA7<strong>\5DF2\5EF6\8FDF</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293071213312559)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5F53\524D\6B63\5728\5347\7EA7\5230 %1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621149516312032)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\7528\6237 %0 \5DF2\521B\5EFA, \8BE5\7528\6237\5177\6709\4F7F\7528\6570\636E\6587\4EF6 %2 \7684\9ED8\8BA4\8868\7A7A\95F4 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637923069312045)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\7BA1\7406\5458 %1 \9884\914D\7684\5DE5\4F5C\533A %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769798251312146)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6240\6709\5DE5\4F5C\533A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761080319312139)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\957F\5EA6\4E0D\80FD\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760969859312139)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\957F\5EA6\4E0D\80FD\4E3A\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761250153312139)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D\4E0D\80FD\8D85\8FC7 %0 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761315465312139)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D\4E0D\80FD\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761816412312140)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>%0</strong> \5DF2\7531\73B0\6709\5BF9\8C61\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762067126312140)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\5E8F\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760699618312139)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D\5DF2\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761677131312139)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\4E3B\952E\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979738727312307)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107950749774312285)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\8868\683C\5BFC\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761579494312139)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D\4E0D\5F97\8D85\8FC7 %0 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772268409312148)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\884C\5305\542B\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098046041312402)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5BFC\5165')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798000485312167)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960793940312292)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\53EF\7528)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960556819312292)
,p_name=>'F4350.CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135642395312431)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\6B63\5728\8BF7\6C42\5C06\73B0\6709\65B9\6848 %0 \5206\914D\7ED9\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135745394312431)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\6B63\5728\8BF7\6C42\521B\5EFA\65B9\6848 %0 \5E76\5C06\5176\5206\914D\7ED9\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960264947312292)
,p_name=>'F4350.CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804193677312172)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960631501312292)
,p_name=>'F4350.CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\5F53\524D)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798593917312168)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\65F6\95F4 (\5728\670D\52A1\5668\4E0A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798300671312168)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960479052312292)
,p_name=>'F4350.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805228089312173)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4E34\65F6\7981\7528\5DE5\4F5C\533A\521B\5EFA\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797951708312167)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\673A\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959964862312292)
,p_name=>'F4350.INSERTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D2\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798463359312168)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797862271312167)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21 DDL \65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281614812312550)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\6253\8865\4E01\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604757961312020)
,p_name=>'F4350.MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\6709 %0 \4E2A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281596256312550)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8865\4E01\7A0B\5E8F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797671325312167)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA7\54C1\5DE5\4F5C\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329426633312588)
,p_name=>'F4350.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797750941312167)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\517C\5BB9\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604665068312020)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\8FD8\6709 %0 \4E2A\7FFB\8BD1\7684\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960130815312292)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960078436312292)
,p_name=>'F4350.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798100361312167)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798221098312168)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506357910312731)
,p_name=>'F4350_AJAX'
,p_message_language=>'zh-cn'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506237643312730)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\56DE\8C03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961606982312293)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\8FDB\65E5\5FD7\6761\76EE:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961564854312293)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6D3B\52A8\65E5\5FD7\6761\76EE:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962128130312293)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\4F1A\8BDD\4E0A\7684\552F\4E00\7528\6237\6570 = %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962547370312294)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962877719312294)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5DE5\4F5C\533A "%2" \4E2D\5B58\5728 %1 \4E2A\7528\6237\7684 %0 \4E2A\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579006574312000)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728 %1 \4E2A\7528\6237\7684 %0 \4E2A\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961381910312293)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\60A8\8981\5728\672A\9884\7F6E\4EFB\4F55\503C\7684\60C5\51B5\4E0B\8FD0\884C\5E94\7528\7A0B\5E8F, \5219\91CD\7F6E\60A8\7684\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636000970312044)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\60A8\8981\5728\672A\9884\7F6E\4EFB\4F55\503C\7684\60C5\51B5\4E0B\8FD0\884C\5E94\7528\7A0B\5E8F, \5219\91CD\7F6E\4F1A\8BDD\72B6\6001\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962962898312294)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962220045312294)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5929\4E4B\524D\7684\4F1A\8BDD\6570 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962381469312294)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F\4E4B\524D\7684\4F1A\8BDD\6570 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107960816605312293)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\4F1A\8BDD\5DF2\7531 %0 \6807\8BC6, \5E76\5305\542B %1 \4E2A\6761\76EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963524344312295)
,p_name=>'F4350_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107962726531312294)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961992098312293)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A "%0" \7684\603B\4F1A\8BDD\6570\662F %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578952480312000)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\603B\6570: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963031969312294)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \62E5\6709 %1 \4E2A\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107961270913312293)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\7528\6237 %0 \62E5\6709 %1 \4E2A\9996\9009\9879\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107963181951312294)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\65B9\6848')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965681970312296)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5728\8868\5355\4E2D\663E\793A\5E8F\5217\201D\5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965709749312296)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\663E\793A\62A5\8868\4E2D\7684\5E8F\5217\201D\5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769176999312145)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\540D <strong>%0</strong> \5728\6B64\51FD\6570\4E2D\5DF2\4F7F\7528\591A\6B21\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968705944312298)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\201C\6267\884C\6B21\5E8F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107968642543312298)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\6267\884C\6B21\5E8F\201D\5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951529959312285)
,p_name=>'F4500.FIND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979992852312307)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951965558312286)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\653E\5927')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951812286312286)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B\79FB\52A8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951757967312286)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0A\79FB\52A8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762813617312140)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\552F\4E00\7684\6267\884C\6B21\5E8F\53F7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564063645311987)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6DFB\52A0\7684\65B0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762473186312140)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\5BF9\8C61\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762203602312140)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\8868\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107951650061312286)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952003217312286)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4E3A\7A7A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065331748312375)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\524D\7684\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768692014312145)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D <strong>%0</strong> \5DF2\5728\6B64\8868\4E2D\4F7F\7528\591A\6B21\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769042069312145)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\81F3\5C11\8F93\5165\4E00\5217\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768946119312145)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D <strong>%0</strong> \65E0\6548\3002<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768785606312145)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217<strong>%0</strong>\7684\7CBE\5EA6\65E0\6548\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768833730312145)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217<strong>%0</strong>\7684\6BD4\4F8B\65E0\6548\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619146422312031)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217<strong>%0</strong>\7684\6BD4\4F8B\662F\5FC5\9700\7684\3002<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107980079931312307)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\540C\4E49\8BCD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979854537312307)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762536711312140)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\65B9\6848 <strong>%1</strong> \4E2D\672A\627E\5230\8868 <strong>%0</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568185872311990)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A\8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964741667312295)
,p_name=>'F4500_BROKEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\65AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965231796312296)
,p_name=>'F4500_BYTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\8282')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965120461312296)
,p_name=>'F4500_CARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964518193312295)
,p_name=>'F4500_CHECK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957020127312290)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4EE5\586B\5145\67E5\8BE2\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965026237312296)
,p_name=>'F4500_COST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956312473312289)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\64CD\4F5C\5DF2\6210\529F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734442780312907)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\9ED8\8BA4\503C\7684\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734370435312907)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5177\6709\9ED8\8BA4\503C\7684\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955699492312289)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6267\884C\5220\9664\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608172204312022)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869648142312223)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769407283312145)
,p_name=>'F4500_NATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\673A\6587\4EF6\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955317298312288)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\8FDB\884C\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964840103312295)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528\4E8E\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964615494312295)
,p_name=>'F4500_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964930147312296)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F18\5316\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957320475312290)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\6210\529F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945043622312281)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5DE5\4F5C\533A\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097957954312401)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('VARCHAR \5217\7C7B\578B\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642357718312048)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5BF9\811A\672C\8FDB\884C\8BED\6CD5\5206\6790 - \8BF7\7A0D\5019\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589040890312008)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\53E5\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830872519312193)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \7531 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952710319312286)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5728\811A\672C\4E2D\6709\53C2\6570, \8BF7\5728\8FD0\884C\4E4B\524D\5B9A\4E49\5B83\4EEC\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588907181312008)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830735373312193)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\5927\5C0F (\5B57\8282)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827067183312190)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952989988312287)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111680307312412)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\5BFC\5165\4EE5\4E0B\811A\672C\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111735974312412)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\8BF7\6C42\5BFC\5165\7684\811A\672C\8D85\8FC7\4E86\5141\8BB8\7684\6700\5927\5B58\50A8\7A7A\95F4\3002\8BF7\4E0E %0 \7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112771133312413)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\5BFC\5165\7684\811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953443830312287)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953204056312287)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933143272312272)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014004817312336)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014109098312336)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \521B\5EFA\5E8F\5217\64CD\4F5C\5931\8D25:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013975869312336)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "%1" \65B9\6848\4E2D\5DF2\521B\5EFA\5E8F\5217 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953649545312287)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014462880312336)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\6570\636E\5E93\540C\4E49\8BCD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014625339312336)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \521B\5EFA\540C\4E49\8BCD\64CD\4F5C\5931\8D25:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014382121312336)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "%1" \65B9\6848\4E2D\5DF2\521B\5EFA\540C\4E49\8BCD "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014777587312336)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \521B\5EFA\5305\64CD\4F5C\5931\8D25:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014854141312336)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "%1" \65B9\6848\4E2D\5DF2\521B\5EFA\5305 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796411391312166)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\5230\5DE5\4F5C\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953951053312287)
,p_name=>'F4500_P25_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953818302312287)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953797621312287)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609805454312024)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609989835312024)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\6548\5E76\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609734839312024)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609643680312024)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013817457312336)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \6B64\64CD\4F5C\5931\8D25:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990906070312315)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528\4E8E\63D2\5165\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013779558312335)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\6570\636E\5E93\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013409900312335)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \521B\5EFA\89C6\56FE\64CD\4F5C\5931\8D25:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013563092312335)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013611291312335)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "%1" \65B9\6848\4E2D\5DF2\521B\5EFA\89C6\56FE "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982287232312309)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\5217\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139838031312435)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640898520312047)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A %0 \7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955474322312288)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\64CD\4F5C\5DF2\6210\529F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952525035312286)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\4EF6\62E5\6709 %0 \4E2A\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952626084312286)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\5B9A\4E49\4EE5\4E0B %0 \4E2A\53C2\6570:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769696387312146)
,p_name=>'F4500_PARSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6B64\811A\672C\8FDB\884C\8BED\6CD5\5206\6790\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964387826312295)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573245011311994)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\8003\8D44\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769520495312145)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6587\672C\5F62\5F0F\7684\6587\6863\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107964429310312295)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813824771312976)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73AF\5883\4E2D\7684\9759\6001\6587\4EF6\914D\7F6E\51FA\73B0\95EE\9898\3002\8BF7\53C2\9605 Application Express Installation Guide \4E2D\7684 "Configuring Static File Support" \90E8\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157283575312448)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B22\8FCE\4F7F\7528 Oracle APEX\FF01\8BF7\4F7F\7528\81EA\6CBB\6570\636E\5E93\7684\7BA1\7406\5458 (ADMIN) \5BC6\7801\767B\5F55\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809963791312973)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\6536\5230\8FD9\5C01\7535\5B50\90AE\4EF6\662F\56E0\4E3A\60A8\8BF7\6C42\4E86 Oracle APEX \5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809880764312972)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6267\884C\64CD\4F5C: %0 \7684\5E10\6237\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033557778312350)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\7528\4E8E\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001\60A8\7684\8EAB\4EFD\8BC1\660E)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033724730312350)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\5F53\524D\5B58\5728\4E8E Oracle \6570\636E\5E93\4E2D\7684\6570\636E\5E93\65B9\6848\3002\7531\4E8E\5B89\5168\539F\56E0, \672A\63D0\4F9B\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033676593312350)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\8981\4E3A\60A8\7684\5DE5\4F5C\533A\521B\5EFA\7684 Oracle \6570\636E\5E93\65B9\6848\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032958963312349)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E0B\9762\7684\8BF4\660E\4E2D, \8BF7\89E3\91CA\60A8\8BF7\6C42\53D7\9650\65B9\6848\7684\539F\56E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033046009312349)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E0B\9762\7684\8BF4\660E\4E2D, \8BF7\89E3\91CA\60A8\8BF7\6C42\5DF2\7531\4E00\4E2A\6216\591A\4E2A\5176\4ED6\5DE5\4F5C\533A\4F7F\7528\7684\65B9\6848\7684\539F\56E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033468619312350)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \7531\4E8E\5B89\5168\539F\56E0, \60A8\8BF7\6C42\7684\65B9\6848\53D7\9650\3002%0 \7BA1\7406\5458\53EF\80FD\4F1A\62D2\7EDD\5C06\6B64\65B9\6848\5206\914D\7ED9\60A8\7684\5DE5\4F5C\533A\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033316280312350)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \60A8\8BF7\6C42\7684\65B9\6848\5DF2\7531\5176\4ED6\7684\5DE5\4F5C\533A\4F7F\7528\3002%0 \7BA1\7406\5458\53EF\80FD\4F1A\62D2\7EDD\5C06\6B64\65B9\6848\5206\914D\7ED9\60A8\7684\5DE5\4F5C\533A\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030390887312347)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\4E3A\5DE5\4F5C\533A\8BF7\6C42\7684\65B0\65B9\6848\662F Oracle \9ED8\8BA4\65B9\6848, \6216\8005\51FA\4E8E\5B89\5168\539F\56E0\5728\60A8\7684\7AD9\70B9\4E0A\53D7\5230\7279\522B\9650\5236\800C\4E0D\80FD\5206\914D\7ED9\5DE5\4F5C\533A\3002\5982\679C\8FD9\8FDD\53CD\7AD9\70B9\7684\5B89\5168\7B56\7565, \7AD9\70B9\7BA1\7406\5458\53EF\80FD\4F1A\62D2\7EDD\60A8\7684\9884\914D\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030245839312347)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\4E3A\5DE5\4F5C\533A\8BF7\6C42\7684\65B9\6848\5DF2\7ECF\5206\914D\7ED9 %0 \4E2A\5DE5\4F5C\533A\3002\5982\679C\8FD9\8FDD\53CD\7AD9\70B9\7684\5B89\5168\7B56\7565, \7AD9\70B9\7BA1\7406\5458\53EF\80FD\4F1A\62D2\7EDD\60A8\7684\9884\914D\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605556445312021)
,p_name=>'F4700P1_A'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle APEX \5141\8BB8\60A8\8BBF\95EE Oracle \6570\636E\5E93\548C\57FA\4E8E\6D4F\89C8\5668\7684\5F00\53D1\5DE5\5177\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605696427312021)
,p_name=>'F4700P1_B'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\58F0\660E\65B9\5F0F\6784\5EFA Web \5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605715520312021)
,p_name=>'F4700P1_C'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\548C\7BA1\7406\6570\636E\5E93\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605896390312021)
,p_name=>'F4700P1_D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DDF\8E2A\91CC\7A0B\7891, Bug, \529F\80FD\548C\5F85\529E\4E8B\9879<')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744371284312915)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\5B89\88C5\5E94\7528\7A0B\5E8F\3002\4F46\662F, \8981\901A\8FC7 Application Express \5E10\6237\9A8C\8BC1\6765\8FD0\884C\5E94\7528\7A0B\5E8F, \5FC5\987B\8BBE\7F6E Application Express \7528\6237\5E10\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744494996312915)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\5B89\88C5 Websheet\3002\4F46\662F, \8981\901A\8FC7 Application Express \5E10\6237\9A8C\8BC1\6765\8FD0\884C Websheet, \5FC5\987B\8BBE\7F6E\5177\6709 Application Express \5E10\6237\7684\7BA1\7406\5458\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098139271312402)
,p_name=>'F4750.VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7248\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768482542312934)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\91CD\7F6E\793A\4F8B RESTful \670D\52A1\6570\636E: \65B9\6848 <code>%0</code> \4E0D\5B58\5728\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343298293312599)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\4F7F\7528%0\9A8C\8BC1\65B9\6848\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377622166312626)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9762\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351048519312605)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5\5411\5BFC\65E0\6CD5\4F7F\7528\62A5\8868\6E90\521B\5EFA\5206\9762\641C\7D22\3002\6CA1\6709\53EF\641C\7D22\7684\5217\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162833532312453)
,p_name=>'FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954175692312287)
,p_name=>'FAILURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028531940312346)
,p_name=>'FDASH1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \529F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070090785312379)
,p_name=>'FEATURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788871723312956)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742574644312125)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5173\4E8E\201D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743288268312125)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E\6B64\5E94\7528\7A0B\5E8F\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742671662312125)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743368821312125)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F\4E2D\52A0\5165\57FA\4E8E\89D2\8272\7684\7528\6237\9A8C\8BC1\FF0C\4EE5\53CA\7BA1\7406\7528\6237\540D\5230\5E94\7528\7A0B\5E8F\89D2\8272\7684\6620\5C04\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742704335312125)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743401920312125)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\6709\5173\6700\7EC8\7528\6237\6D3B\52A8\7684\5927\91CF\62A5\8868\548C\56FE\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742850434312125)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744233915312126)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\5E94\7528\7A0B\5E8F\7BA1\7406\5458\5728\5E94\7528\7A0B\5E8F\4E2D\542F\7528\6216\7981\7528\4E0E Application Express \6784\5EFA\9009\9879\5173\8054\7684\7279\5B9A\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042379192312357)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\4EE5\4E0B\6784\5EFA\9009\9879\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103014175312405)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103117867312406)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 APEX_SEND() \7535\5B50\90AE\4EF6\961F\5217\4E0A\5305\62EC\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159774662312450)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\4E00\4E2A\62A5\8868\FF0C\5176\4E2D\663E\793A\8981\53D1\9001\7684\90AE\4EF6\4EE5\53CA\5DF2\53D1\9001\7535\5B50\90AE\4EF6\7684\65E5\5FD7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107742926610312125)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743567885312126)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6700\7EC8\7528\6237\63D0\4F9B\5C06\4E00\822C\8BC4\8BBA\53D1\9001\56DE\5E94\7528\7A0B\5E8F\7BA1\7406\5458\548C\5F00\53D1\8005\7684\673A\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103291816312406)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103330471312406)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6570\636E\5E93\4F5C\4E1A\4E0A\5305\62EC\62A5\8868\FF0C\5E76\63D0\4F9B\7EC6\5316\5230\7279\5B9A\4F5C\4E1A\4EE5\67E5\770B\8BE6\7EC6\4FE1\606F\7684\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107743064135312125)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107744162856312126)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\7BA1\7406\5458\4E3A\5E94\7528\7A0B\5E8F\9009\62E9\9ED8\8BA4\989C\8272\65B9\6848\FF08\4E3B\9898\6837\5F0F\FF09\3002\7BA1\7406\5458\8FD8\53EF\4EE5\8FDB\884C\9009\62E9\6765\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\81EA\5DF1\7684\4E3B\9898\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050211067312363)
,p_name=>'FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358309846312611)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD 100%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107421583312409)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD 100% (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072652213312381)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD 80%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600657497312017)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'zh-cn'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599444653312016)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\5B8C\6210 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600582740312017)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360857093312613)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248 %0 \7684\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107665120312409)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\671F (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376916089312626)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B8C\6210\5F00\53D1\7684\529F\80FD\7684\767E\5206\6BD4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107563293312409)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\65E5\671F\5185 (%0/%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139768575312434)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045799750312359)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D21\732E\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107379413312409)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354393792312608)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \4E2A\53D1\884C\7248\4E2D\6709 %0 \4E2A\529F\80FD, %1 \4E2A\5DF2\5B8C\5168\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354400763312608)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\9876\7EA7\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354579804312608)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6CA1\6709\622A\6B62\65E5\671F, %1 \4E2A\5DF2\8FC7\671F\4E14\5B8C\6210\8FDB\5EA6\4F4E\4E8E 80%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354604847312608)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\529F\80FD\5DF2\5B8C\6210\5F00\53D1, %1 \4E2A\672A\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358040701312611)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0% \7684\529F\80FD\5DF2\5B8C\5168\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044086726312358)
,p_name=>'FEATURE_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045007742312359)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775978336312940)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043643116312358)
,p_name=>'FEATURE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043788345312358)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044792470312358)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044846896312359)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044601729312358)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788991612312956)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5206\914D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791329207312958)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8BB0\5F55 %0, \5E76\4E14\5DF2\5206\914D\7ED9 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069926366312379)
,p_name=>'FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085592001312392)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\63D0\4F9B\6B64\4FE1\606F\4EE5\4F5C\4E3A\53CD\9988\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156088463312447)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049875365312363)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599791113312016)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%2 \4E2A\53CD\9988\6761\76EE\672A\5904\7406 (\5DF2\5173\95ED %0 \4E2A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085342148312391)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\60A8\7684\53CD\9988\5E76\6309\201C\63D0\4EA4\53CD\9988\201D\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377268120312626)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5173\95ED\53CD\9988\767E\5206\6BD4 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080566067312387)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\9988\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085428968312392)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6807\8BC6\6240\63D0\4F9B\7684\53CD\9988\7684\7C7B\578B\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248203280312521)
,p_name=>'FILENAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052982050312365)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295621517312561)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051499885312364)
,p_name=>'FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730943818312905)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050920999312363)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6587\4EF6, \5360\7528 %1K')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775791519312939)
,p_name=>'FILE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107578658547311999)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\672C\6587\4EF6\592A\5927, \65E0\6CD5\7F16\8F91\3002\8981\66F4\6539\5185\5BB9, \5FC5\987B\5728\60A8\7684\672C\5730\8BA1\7B97\673A\4E0A\7F16\8F91\8BE5\6587\4EF6, \7136\540E\91CD\65B0\4E0A\8F7D\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613056949312026)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\6709\6548\7684\4F1A\8BDD, \5DF2\4E0A\8F7D\4E00\4E2A\6216\591A\4E2A\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612947646312026)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8BF7\6C42\4E2D\4E0A\8F7D\7684\6587\4EF6\6570\91CF\5927\4E8E\8BE5\9875\4E2D\5B9A\4E49\7684\6587\4EF6\9879\7C7B\578B\7684\6570\91CF\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108103496860312406)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\6211\7684\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584060689312004)
,p_name=>'FIND_TABLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811101780312973)
,p_name=>'FINISH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956090138312289)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A\6761\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109137637312410)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FEE\590D\5B8C\6210\65E5\671F\8FC7\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025593496312344)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\5F00\53D1\5458\4FEE\590D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043833772312358)
,p_name=>'FOCUS_AREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FA7\91CD\9886\57DF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826584141312190)
,p_name=>'FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\6587\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565721111311988)
,p_name=>'FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774426543312938)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107759135312409)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\548C\5217\8868\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107807096312409)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\8868\5355\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943787327312280)
,p_name=>'FORM_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2D\7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685266521312081)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\8868\7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087085906312393)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\57FA\4E8E\67E5\8BE2\7684\8868\5355\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087334806312393)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\57FA\4E8E Web \670D\52A1\5F15\7528\7684\8868\5355\548C\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084622947312391)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\8868\5355\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087158457312393)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\6982\8981\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086779913312393)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\57FA\4E8E\8868\7684\8868\5355\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087259192312393)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\57FA\4E8E Web \670D\52A1\5F15\7528\7684\8868\5355\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634469339312042)
,p_name=>'FORWARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\524D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144247294312438)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6765\81EA\5C5E\6027\5B57\5178')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772732239312148)
,p_name=>'FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034012018312350)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023890814312343)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD\5B9E\65BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828183646312191)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774141600312149)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084325455312391)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5F15\7528\6E38\6807\7684 PL/SQL \51FD\6570\4F53')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077458234312385)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633222530312041)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071124619312380)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765\91CC\7A0B\7891')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723695015312899)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723593196312899)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF\7ED3\675F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723469260312899)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF\5F00\59CB\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077091438312384)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076990291312384)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311035077312574)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723155854312899)
,p_name=>'GANTT_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723015564312899)
,p_name=>'GANTT_END'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723234266312899)
,p_name=>'GANTT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108723383980312899)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722854708312899)
,p_name=>'GANTT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722991677312899)
,p_name=>'GANTT_START'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508457111312732)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\96C6\8868\7EDF\8BA1\4FE1\606F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026659331312345)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C\8BC4\8BBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377321404312626)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C\8BC4\8BBA: %1 \4E2A\5DF2\5173\95ED, \5171 %0 \4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638350225312045)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8868\662F\4F7F\7528\8868\5411\5BFC\521B\5EFA\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722719387312110)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\5DF2\4FDD\5B58\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032667701312349)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6216\7F16\8F91\9759\6001\503C\5217\8868')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045996374312359)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\7403\5316\5206\914D\4EBA\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044101134312358)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\7403\5316\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046986239312360)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\7403\5316\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566999588311989)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\9875')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091587842312397)
,p_name=>'GRAY_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7070\8272\6587\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066498971312376)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\5E03\5C40\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066373714312376)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5E03\5C40\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665063670312066)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008588316312332)
,p_name=>'GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201091654312483)
,p_name=>'GROUP_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826459474312190)
,p_name=>'HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\6587\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200828186312483)
,p_name=>'HEADING_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771476728312936)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774547942312149)
,p_name=>'HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869573961312223)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\548C\53D7\4FDD\62A4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027704877312345)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\5E38\9700\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730447581312904)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5BF9\6BD4\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492095096312719)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5BF9\6BD4\5EA6\5207\6362')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008320978312332)
,p_name=>'HISTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5386\53F2\8BB0\5F55')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084141410312390)
,p_name=>'HOME_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562861462311986)
,p_name=>'HOME_NAV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle APEX \4E3B\76EE\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615636058312028)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801506551312170)
,p_name=>'HORIZONTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548158329311975)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \6C34\5E73\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548285304311975)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \6C34\5E73\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548343079311975)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \6C34\5E73\8303\56F4\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548492543311975)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \6C34\5E73\8303\56F4\67F1\72B6\56FE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770855695312936)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70ED\95E8\6A21\677F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107606035897312021)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HR \5E10\6237\5DF2\53D6\6D88\9501\5B9A\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775687195312150)
,p_name=>'HTML'
,p_message_language=>'zh-cn'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794622229312165)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\5FEB\6377\65B9\5F0F\7684 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794362065312164)
,p_name=>'HTML_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636967259312044)
,p_name=>'HTML_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646341423312051)
,p_name=>'HTML_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826715325312190)
,p_name=>'HTML_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6807\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646480529312051)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML/\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774213760312149)
,p_name=>'HTML_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646519550312051)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6587\672C (\5E26\6709\5FEB\6377\65B9\5F0F)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771072379312936)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706757216312886)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\793A\4E3B\9898\4E0E IE 6 \517C\5BB9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113859974312414)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113983182312414)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\8BFB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775851530312150)
,p_name=>'IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316668333312578)
,p_name=>'IMAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760297569312138)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083500168312390)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\524D\7F00')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021452803312341)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5E94\7528\7A0B\5E8F\5BFC\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782798968312952)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362\5B57\7B26\4E32 %0 \7684\65B0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251342408312524)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5BFC\5165\7684\6587\4EF6\4F4D\4E8E<a href="%0">\5BFC\51FA\8D44\6599\6863\6848\5E93</a>\4E2D\3002\9664\975E\60A8\8BA1\5212\91CD\65B0\5B89\88C5, \5426\5219\5E94\5220\9664\8BE5\6587\4EF6\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956916932312290)
,p_name=>'IN/OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165/\8F93\51FA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573460589311994)
,p_name=>'INACTIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\6D3B\52A8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155893734312447)
,p_name=>'INCLUDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775332739312939)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772844043312148)
,p_name=>'INDEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153235789312445)
,p_name=>'INDEX_NOUN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D22\5F15')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107717259089312106)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931233304312270)
,p_name=>'INLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720740196312896)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\5E2E\52A9\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931180578312270)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\5E76\5305\542B\5728\901A\77E5\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077103798312385)
,p_name=>'INPUT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7C7B\578B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773551841312148)
,p_name=>'INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162663834312453)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165 wwv_flow_companies \65F6\51FA\73B0\5F02\5E38\9519\8BEF:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093218432312398)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS (\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093074722312398)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF (\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093436016312398)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\6587\4EF6 (\5E94\7528\7A0B\5E8F)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602376988312018)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659850670312062)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\9009\62E9\5305\62EC\4EE5\4E0B\6784\5EFA\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602279583312018)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\66FF\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659784089312062)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\914D\7F6E\5E94\7528\7A0B\5E8F\7684\4EE5\4E0B\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602524511312018)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660064585312062)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\786E\8BA4\60A8\8981\5B89\88C5\6B64\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602987626312019)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577524907311999)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603035117312019)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660386136312062)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5378\8F7D\5B8C\6210\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947288726312282)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6267\884C\5B89\88C5\68C0\67E5 "%0" \65F6\51FA\9519:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947330959312282)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8FD0\884C\5B89\88C5\811A\672C "%0" \65F6\51FA\9519:'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602196509312018)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\6027\68C0\67E5\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602783551312018)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\5931\8D25\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660270158312062)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\6570\636E\5E93\5BF9\8C61\548C\79CD\5B50\6570\636E\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009635445312332)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5B89\88C5\7A0B\5E8F\68C0\6D4B\5230\4EE5\524D\5B89\88C5\4E86\6B64\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\3002\5FC5\987B\5148\901A\8FC7 SQL Workshop \5220\9664\8FD9\4E9B\5BF9\8C61, \7136\540E\624D\80FD\5B89\88C5\6B64\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602859393312018)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BB8\53EF\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598009807312015)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597955728312015)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602668634312018)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\6210\529F\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107660192240312062)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\5DF2\5B89\88C5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699134002312092)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\786E\8BA4\60A8\8981\5347\7EA7\6B64\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699075371312092)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\7EA7\6B64\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698603855312091)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5B89\88C5\7A0B\5E8F\68C0\6D4B\5230\4EE5\524D\5B89\88C5\4E86\6B64\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\3002\6B64\5411\5BFC\5C06\5F15\5BFC\60A8\5B8C\6210\5347\7EA7\8FD9\4E9B\652F\6301\5BF9\8C61\7684\8FC7\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107698919740312092)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5E94\7528\7A0B\5E8F\7684\652F\6301\5BF9\8C61\5DF2\5347\7EA7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602459395312018)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659926060312062)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6267\884C\4EE5\4E0B\9A8C\8BC1\4EE5\786E\4FDD\60A8\7684\7CFB\7EDF\4E0E\6B64\5E94\7528\7A0B\5E8F\517C\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107602088778312018)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B22\8FCE\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659689085312062)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\5B89\88C5\7A0B\5E8F\5C06\5F15\5BFC\60A8\5B8C\6210\521B\5EFA\6570\636E\5E93\5BF9\8C61\548C\79CD\5B50\6570\636E\7684\8FC7\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093128128312398)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS (\5DE5\4F5C\533A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092996302312398)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF (\5DE5\4F5C\533A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093322669312398)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\6587\4EF6 (\5DE5\4F5C\533A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590326445312009)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093518434312398)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491400697312718)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle APEX \7BA1\7406\670D\52A1\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140798714312435)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F8B\8BBE\7F6E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042793553312357)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5B9E\4F8B\6B63\5728\624B\52A8\9884\914D\6A21\5F0F\4E0B\8FD0\884C, \56E0\6B64\5B83\4E0D\4F1A\63A5\53D7\670D\52A1\8BF7\6C42')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135832416312431)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\95F4\4E0D\8DB3, \65E0\6CD5\5B89\88C5\6B64\5E94\7528\7A0B\5E8F\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023905380312343)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\6210\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029167328312346)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\6210\7B7E\6536')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019642779312340)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795347830312165)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049145180312362)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614327008312027)
,p_name=>'INTERNAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566684569311989)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616061496312028)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943379000312279)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8F93\5165\6709\6548\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573326078311994)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5\6587\4EF6\4E0D\662F\6709\6548\7684\5E94\7528\7A0B\5E8F\6863\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943862808312280)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8F93\5165\6709\6548\7EC4\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635182082312043)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61 %0 \65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297094515312562)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8F93\5165\6709\6548\7684\9875\7EC4\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811654161312974)
,p_name=>'INVALID_POSITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E\65E0\6548 [\672A\5448\73B0]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162390806312452)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076163526312384)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE\503C\65E0\6548, \5B83\5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760495036312928)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6CE8\610F, %0 \4E2A\5B57\7B26\4E32\662F\65E0\6548\7684\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162260915312452)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\540D\79F0\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102870823312405)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5BF9\8C61\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100797401312404)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\6B63\65E0\6548 Websheet \5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102942003312405)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA Websheet \5E94\7528\7A0B\5E8F\6240\9700\7684\6570\636E\5E93\5BF9\8C61\65E0\6548\6216\4E0D\5B58\5728\3002\8BF7\4E0E\5DE5\4F5C\533A\7BA1\7406\5458\8054\7CFB\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548578691311975)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CD\8F6C 2D \6298\7EBF\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025451730312344)
,p_name=>'IN_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\89E3\51B3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721280391312109)
,p_name=>'IR_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969697976312299)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969512519312299)
,p_name=>'IR_END_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969942247312299)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946086183312281)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\53EF\4EE5\663E\793A\4E00\4E2A\4EA4\4E92\5F0F\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969708164312299)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5BF9\8BDD\6846\4EC5\5BF9\5F00\53D1\8005\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969472620312299)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\62A5\8868 *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969847736312299)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58 *')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774918597312939)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F: %0, \9875: %1, \8BA2\9605\8005: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088730559312394)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\4EA4\4E92\5F0F\62A5\8868\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970043190312299)
,p_name=>'IR_UNITS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\4F4D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510152232312734)
,p_name=>'ISSUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EE\9898')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957622358312290)
,p_name=>'IS_WRAPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5305\88C5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068886210312378)
,p_name=>'ITEM CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646715083312052)
,p_name=>'ITEM NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614040648312027)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795602502312962)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9879\5217\8DE8\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633551406312042)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9879\503C\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633691800312042)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9879\503C\4E0D\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633157364312041)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633030329312041)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \7684\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774128215312938)
,p_name=>'ITEM_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691238919312086)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\9009\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691399869312086)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034188075312350)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\81EA\52A8\5B8C\6210\529F\80FD\7684\6587\672C\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319876369312581)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689529844312873)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149492623312442)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\9009\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312066016312574)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\9009\53D6\5668 (\7ECF\5178)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558768054311983)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\9009\53D6\5668 (HTML5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354240715312608)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313517160312576)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108353005066312607)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\6D4F\89C8...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689304792312873)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359943811312612)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\7BA1\7406\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376186643312625)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Markdown \7F16\8F91\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303919655312568)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305476028312569)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312738442312575)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319743742312581)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\9009\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065662675312376)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4FE1\606F\6587\672C\7F16\8F91\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312160025312575)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314130843312576)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F80\8FD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579853956312001)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6ED1\5757')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691417708312086)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\505C\6B62\548C\542F\52A8\7F51\683C\5E03\5C40 (\5DF2\8FC7\65F6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067697268312377)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689450798312873)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579592141312000)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F/\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641070804312047)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691583213312086)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328830889312588)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\7EA7\8BC4\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691647752312086)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729007767312903)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\540E\7F6E\6587\672C\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728936232312903)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\524D\7F6E\6587\672C\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094170212312399)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094265298312399)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094367809312399)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094454093312399)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303887386312568)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\6700\5927\503C%0\4E0D\662F\6570\5B57\3002\5982\679C\8BE5\503C\5305\542B\5C0F\6570\4F4D\6570, \8BF7\6307\5B9A\53E5\70B9\4F5C\4E3A\5341\8FDB\5236\5206\9694\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303734764312568)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879%1\8F93\5165\7684\6700\5C0F\503C%0\4E0D\662F\6570\5B57\3002\5982\679C\8BE5\503C\5305\542B\5C0F\6570\4F4D\6570, \8BF7\6307\5B9A\53E5\70B9\4F5C\4E3A\5341\8FDB\5236\5206\9694\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579723596312000)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\9879 %1 \8F93\5165\7684\6B65\957F\503C %0 \4E0D\662F\6570\5B57\3002\5982\679C\8BE5\503C\5305\542B\5C0F\6570\4F4D\6570, \8BF7\6307\5B9A\53E5\70B9\4F5C\4E3A\5C0F\6570\5206\9694\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641495578312048)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641562218312048)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\6D4F\89C8...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641630180312048)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641701528312048)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\548C\53D7\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641893726312048)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\989C\8272\9009\62E9\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641925026312048)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642022914312048)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5B57\6BB5 (\7981\7528, \4E0D\4FDD\5B58\72B6\6001)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642133663312048)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5B57\6BB5 (\7981\7528, \4FDD\5B58\72B6\6001)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642203395312048)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5B57\6BB5 (\6309 Enter \65F6\59CB\7EC8\63D0\4EA4\9875)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019444873312340)
,p_name=>'JET_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JET \56FE\8868')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954821933312288)
,p_name=>'JOB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E1A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020653604312340)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5207\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020541403312340)
,p_name=>'JQM REFLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\6392\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096188452312400)
,p_name=>'JQM_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096069049312400)
,p_name=>'JQM_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022571955312342)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\89C6\56FE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019710080312340)
,p_name=>'JSTREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Javascript \6811')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045835604312359)
,p_name=>'JUSTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA1\6279\7406\7531')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510242366312734)
,p_name=>'LABELS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795589180312961)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\6807\7B7E\5217\8DE8\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789183357312957)
,p_name=>'LABEL_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9879\6807\7B7E ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082697953312389)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747619565312129)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747700869312129)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\6A21\677F\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747993545312129)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6A21\677F\8BA2\9605\6B64\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107747896408312129)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\6A21\677F\7684\6807\7B7E\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590833844312009)
,p_name=>'LANGUAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048668145312362)
,p_name=>'LAST_CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956145648312289)
,p_name=>'LAST_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E\4E00\4E2A\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051512787312364)
,p_name=>'LAST_LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\767B\5F55')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568266119311990)
,p_name=>'LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 - \5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605265101312020)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944567606312280)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\9875\9875\7709\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944242621312280)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010594409312333)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359192961312612)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293782704312560)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294118398312560)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\548C\9879\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695511094312089)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107935025770312273)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944072175312280)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944344167312280)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605165480312020)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934791616312273)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944682635312280)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\9875\9875\811A\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944163198312280)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934692434312273)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359023982312612)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293659407312559)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294089056312560)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\548C\9879\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934902512312273)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943993276312280)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934828866312273)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004225401312329)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686242474312082)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6846\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686321653312082)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6846\4EE5\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686445146312082)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686517783312082)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686611789312082)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686701563312082)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686836783312082)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686943551312082)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687016906312082)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687110242312083)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687265710312083)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687317582312083)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687446731312083)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927424957312267)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\66F4\6539\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998134164312324)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146938234312440)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926623061312267)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5173\95ED\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927143926312267)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\590D\5236\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926821775312267)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Create2 \6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558924301311983)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146689703312440)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5047')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146727754312440)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\771F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927033310312267)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5220\9664\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363570116312615)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\6807\7B7E - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771117797312936)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926764707312267)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5C55\5F00\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868739795312222)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147000967312440)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\9875: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926982884312267)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5E2E\52A9\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359292745312612)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\9879\5E2E\52A9\201D\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363617892312615)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868638677312222)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6587\672C\8F6C\4E49\7279\6B8A\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720644411312896)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729247320312904)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\540E\7F6E\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729123810312903)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\524D\7F6E\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927293330312267)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4E0B\4E00\6B65\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004182421312328)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\533A\57DF\5728\663E\793A\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147127685312440)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\533A\57DF\7684\9875\9879\548C\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036807341312352)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Ajax \56DE\8C03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293921952312560)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\4E4B\540E\51FA\9519\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293845797312560)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\4E4B\524D\51FA\9519\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937154003312275)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\5B9E\4F8B\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937290017312275)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\65F6\548C\8BA1\7B97\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927391790312267)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4E0A\4E00\6B65\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147356343312441)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536396723311965)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147491756312441)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587 (#0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147591938312441)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108146826879312440)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149736204312443)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868851221312222)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\5355\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869178759312222)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\6784\5316\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149631035312442)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\4E3A "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021185097312341)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869031417312222)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SVG \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653867512312057)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\7531 &PRODUCT_NAME. \4F7F\7528\7684\6837\5F0F\8868\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654252146312057)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&PRODUCT_NAME. \4F7F\7528\7684 JavaScript \6587\4EF6\548C\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773293529312937)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7528\6237\754C\9762\7EA7\522B\4E0A\5B9A\4E49\7684\7EA7\8054\6837\5F0F\8868\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654447524312058)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7528\6237\754C\9762\7EA7\522B\5B9A\4E49\7684 JavaScript \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099912963312403)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\5C5E\6027, \7528\4E8E\5B9A\4E49\4E0D\4EE5\58F0\660E\7684\5F62\5F0F\652F\6301\7684\5BF9\8BDD\6846\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722357371312898)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099506297312403)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099797182312403)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\6700\5927\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099692518312403)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794012297312960)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00/\6298\53E0\5BFC\822A\7684\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794198034312960)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00/\6298\53E0\4FA7\5217\7684\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763516534312930)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\85CF\5939\56FE\6807 HTML \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654139647312057)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\7531\7EC4\4EF6\5B9E\65F6\521B\5EFA\7684\6837\5F0F\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654587340312058)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\7EC4\4EF6\5B9E\65F6\521B\5EFA\7684 JavaScript \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099889339312403)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\9875\6A21\5F0F (\4F8B\5982, \6A21\5F0F\65F6\4E3A ''\771F'', \65E0\6A21\5F0F\65F6\4E3A ''\5047'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654022554312057)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\5728\9875\7EA7\522B\4E0A\5B9A\4E49\7684\6837\5F0F\8868\6587\4EF6\548C\5185\5D4C\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647776993312052)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303107745312567)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\9875\7EA7\522B\5B9A\4E49\7684 JavaScript \6587\4EF6\548C\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565944830311989)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9759\6001 ID (\4F8B\5982 ''P100'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562365632311986)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\5BFC\822A\5230\65B0\9875\7684\8F6C\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099437287312403)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562444890311986)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\6253\5F00\5F39\51FA\6846\7684\8F6C\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102686761312405)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5668\8BF7\6C42\7684\9875 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773470727312938)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355 (\4FA7\8FB9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653990300312057)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\5728\6A21\677F\4E2D\5B9A\4E49\7684\6837\5F0F\8868\6587\4EF6\548C\5185\5D4C\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654389406312058)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6A21\677F\4E2D\5B9A\4E49\7684 JavaScript \6587\4EF6\548C\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654672727312058)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\7EA7\522B\4E0A\5B9A\4E49\7684\7EA7\8054\6837\5F0F\8868\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782235050312951)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\7EA7\522B\5B9A\4E49\7684 JavaScript \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782348834312951)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\6837\5F0F\7EA7\522B\4E0A\5B9A\4E49\7684\7EA7\8054\6837\5F0F\8868\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773322987312938)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355 (\9876\90E8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100043654312403)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5143\7D20 (\4F8B\5982, \5F53\524D DOM \5143\7D20)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713046070312102)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303275342312567)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D7\5F71\54CD\7684\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710036168312100)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706074109312097)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709682019312100)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705417106312097)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706170977312097)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708716198312099)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707874621312098)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710170109312100)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705282771312096)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708407265312099)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707680592312098)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707712999312098)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708327336312099)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707483087312098)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707566542312098)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708178996312099)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708003631312099)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709218799312099)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708296052312099)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706225175312097)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709000824312099)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708500753312099)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709146668312099)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709961719312100)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708659712312099)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705184194312096)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705050363312096)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707962482312098)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709734134312100)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707368154312098)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709897684312100)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709450917312100)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709320623312100)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107709508163312100)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705362805312097)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704930016312096)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150382104312443)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770683635312936)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6807\7B7E (\8F6C\4E49 HTML \5B57\7B26)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360925500312613)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('When \4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710572050312100)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597871746312015)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703396809312095)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151718103312444)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687809786312083)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\8FD4\56DE\9875\7684\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687993294312083)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\8FD4\56DE URL \7684\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687592060312083)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\9875\63A5\53D7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687604123312083)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\7531\9879\6807\8BC6\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713532858312103)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688033142312083)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230 PL/SQL \8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107687717525312083)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F\5230\7531\9879\6807\8BC6\7684 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150431707312443)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702019728312094)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713448699312103)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151133038312444)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329377398312588)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706972662312098)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\533A\57DF\7684\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151562453312444)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151444268312444)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770476806312935)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702266802312094)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714139904312103)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702358642312094)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C 0 \9875\4E0D\652F\6301\8BA1\7B97\3002\5E94\7531\5E94\7528\7A0B\5E8F\7EA7\8BA1\7B97\5904\7406\6BCF\9875\4E0A\53D1\751F\7684\8BA1\7B97\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150899040312443)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713147256312102)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150162218312443)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150218408312443)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150095682312443)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700325578312093)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700147526312093)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768528419312934)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE <em>APEX.CURRENT_PROGRESS</em> \5185\90E8\6587\672C\6D88\606F\6D3E\751F\7684\6587\672C (\9ED8\8BA4\4E3A<em>\5F53\524D\8FDB\5EA6</em>)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711065234312101)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713399624312103)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151282111312444)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701893202312094)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\70B9:&nbsp;')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699474168312880)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700221834312093)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597757565312015)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6784\5EFA\5668\4E2D\7F16\8F91\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685436828312081)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\533A\57DF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686087423312082)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713230678312103)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>'exp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704832216312096)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704543946312096)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704365299312096)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704669020312096)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704467655312096)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704718421312096)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710637552312100)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711964206312102)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED HTML \8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711470087312101)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00 HTML \8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710953193312101)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702869138312095)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\9875\4E0D\652F\6301\5206\652F, \8BA1\7B97, \5904\7406\6216\9A8C\8BC1\3002\5E94\5728\5E94\7528\7A0B\5E8F\7EA7\522B\4E0A\6267\884C\6BCF\9875\4E0A\53D1\751F\7684\8BA1\7B97\548C\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363365682312615)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082295680312389)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\5217\8DE8\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710480782312100)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685847073312082)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685760076312081)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C+\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701025898312093)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702135471312094)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034233870312350)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707215302312098)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\8BA1\6570\8D85\8FC7\6700\5927\503C 200\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151300940312444)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571586241311993)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754868524312923)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217\8868 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107686116632312082)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730128745312115)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571496496311993)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363458747312615)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713741298312103)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704093376312096)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029214584312347)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688439336312083)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081992500312388)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65B0\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082133800312389)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\52A8\65B0\7F51\683C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082014263312389)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\52A8\65B0\7F51\683C\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710394271312100)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688183722312083)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685975441312082)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711520986312101)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703451756312095)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707039710312098)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107707187471312098)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571752871311993)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\4F7F\7528\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730248475312115)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\4F7F\7528\5171\4EAB\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571818615311993)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\4F7F\7528\9762\5305\5C51\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704140586312096)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F "%0" \6CA1\6709\5BFC\822A\680F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702515498312094)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\201C\52A0\8F7D\65F6\201D\8BA1\7B97\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702747961312095)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\201C\52A0\8F7D\65F6\201D\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702930043312095)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\201C\63D0\4EA4\65F6\201D\8BA1\7B97\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703233912312095)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\201C\63D0\4EA4\65F6\201D\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699916382312092)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703632886312095)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\7236\7EA7\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701977842312094)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703941299312096)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0 \6CA1\6709\9009\9879\5361\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730317647312115)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\4F7F\7528\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703169691312095)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 "%0" \6CA1\6709\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685533420312081)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700069837312092)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700824191312093)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701435330312094)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701220104312093)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711755546312101)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711872478312101)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6B63\6587\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701340704312094)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711303101312101)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9996')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700613289312093)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700515984312093)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\672A\627E\5230\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711187901312101)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\9875\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701585221312094)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701624257312094)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701177295312093)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700958082312093)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700772547312093)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711273927312101)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703546707312095)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702633160312095)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714007835312103)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107702440288312094)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C 0 \9875\4E0D\652F\6301\5904\7406\3002\5E94\5728\5E94\7528\7A0B\5E8F\7EA7\522B\4E0A\6267\884C\6BCF\9875\4E0A\53D1\751F\7684\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151634632312444)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713645950312103)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710874920312101)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770538414312935)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107701762666312094)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714499153312103)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022703411312342)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561995380311985)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021523574312341)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\533A\57DF ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080826725312387)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712098065312102)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016480704312337)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016561416312337)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016632241312338)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016760360312338)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016863609312338)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016935295312338)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017017340312338)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712140812312102)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712268619312102)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712332714312102)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712429958312102)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712501026312102)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712605340312102)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712713735312102)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108016383276312337)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021627894312341)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\9759\6001 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363214937312615)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688316054312083)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703752302312095)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710775475312101)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022382348312342)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF - \9875\7709\6761\76EE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022478595312342)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF - \9875\7709\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022258845312341)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF - \6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022035957312341)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022132124312341)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF\9875\7709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021968209312341)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF\9875\7709\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021726256312341)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF\7684\9759\6001 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021850412312341)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\533A\57DF\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107711655045312101)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571296134311993)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\683C\5F0F\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703838972312095)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708836728312099)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729431268312115)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705952374312097)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706403466312097)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705630379312097)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706649708312098)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705721283312097)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705502689312097)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107705882987312097)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706546810312097)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706797045312098)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6309\94AE\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706852207312098)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107706340331312097)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108151040541312444)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('When \6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150972883312443)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('When \5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688237032312083)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107703076926312095)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713924695312103)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329223821312588)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150649556312443)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\8868\8FBE\5F0F 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150753713312443)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108150535253312443)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\7C7B\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107700463382312093)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149991425312443)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6309\4E0B\6309\94AE\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107710246377312100)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868906004312222)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\66F4\65B0\7684 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830996129312193)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108147279339312441)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827924663312191)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870626131312223)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075126754312383)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \7528\6237\540D\7F16\8F91\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107587555492312007)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605942638312021)
,p_name=>'LEARN MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723885980312111)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\6709\5173 Oracle APEX \7684\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723682010312110)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\6709\5173\5E94\7528\7A0B\5E8F\6784\5EFA\5668\7684\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107732432724312117)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\6709\5173\9875\8BBE\8BA1\5668\7684\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723707081312110)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\6709\5173\751F\4EA7\529B\5E94\7528\7A0B\5E8F\7684\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723517230312110)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E86\89E3\6709\5173 SQL \5DE5\4F5C\5BA4\7684\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328622727312588)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\6B64\5904\53EF\4E86\89E3 Websheets')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137737112312433)
,p_name=>'LEFT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\5BF9\9F50')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782184204312951)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\65E5\5386')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612649329312026)
,p_name=>'LINES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377957268312626)
,p_name=>'LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648481294312053)
,p_name=>'LINK$'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049684745312362)
,p_name=>'LINKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775629038312939)
,p_name=>'LINK_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155260386312447)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5230\6B64 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107969373747312299)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5230\6B64\9875\9879 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775408124312150)
,p_name=>'LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074106696312382)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\9879\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070680422312380)
,p_name=>'LIST OF VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107643952171312049)
,p_name=>'LISTVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107949991312409)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\8868\5355\548C\5217\8868\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114372774312414)
,p_name=>'LIST_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108814087653312976)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6761\76EE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102444628312405)
,p_name=>'LIST_INITCAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218871509312497)
,p_name=>'LIST_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019300452312339)
,p_name=>'LIST_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082767738312389)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795183242312165)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830680461312193)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\4F7F\7528\60C5\51B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108237032312410)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\89C6\56FE\9875\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108525396312410)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\89C6\56FE\9875\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108155438312409)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\89C6\56FE\9875')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761136835312928)
,p_name=>'LOAD_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\6570\636E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157607373312449)
,p_name=>'LOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245650858312519)
,p_name=>'LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943491632312279)
,p_name=>'LOCKED BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9501\5B9A\8005: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763982264312930)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \5DF2\9501\5B9A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764118709312930)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9501\5B9A\811A\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955866377312289)
,p_name=>'LOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083697024312390)
,p_name=>'LOGGING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152035233312444)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BB0\4F4F\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152197361312444)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\9009\4E2D\6B64\590D\9009\6846\FF0C\5219\5E94\7528\7A0B\5E8F\4F1A\5C06\60A8\7684\7528\6237\540D\4FDD\5B58\5728\540D\4E3A "LOGIN_USERNAME_COOKIE" \7684\6301\4E45\6D4F\89C8\5668 cookie \4E2D\3002'),
unistr('\5728\60A8\4E0B\6B21\8F6C\5230\767B\5F55\9875\65F6\FF0C'),
unistr('\7528\6237\540D\5B57\6BB5\5C06\81EA\52A8\4F7F\7528\6B64\503C\586B\5145\3002'),
'</p>',
'<p>',
unistr('\5982\679C\53D6\6D88\9009\4E2D\6B64\590D\9009\6846\FF0C\5E76\4E14\60A8\7684\7528\6237\540D\5DF2\4FDD\5B58\5728 Cookie \4E2D\FF0C'),
unistr('\5219\5E94\7528\7A0B\5E8F\5C06\4F7F\7528\7A7A\7684\503C\6765\8986\76D6\5B83\3002'),
unistr('\60A8\8FD8\53EF\4EE5\4F7F\7528\6D4F\89C8\5668\7684\5F00\53D1\8005\5DE5\5177\6765\5F7B\5E95\5220\9664 Cookie\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083488943312390)
,p_name=>'LOGIN_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083389211312390)
,p_name=>'LOGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FBD\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569718515312780)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8BBE\7F6E\56FE\50CF\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569802480312780)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5FBD\6807\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568241871312779)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5FBD\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568721588312780)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\4EF6\8D85\8FC7\5141\8BB8\7684\9650\5236 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569256518312780)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\4E2D\8BBE\7F6E\5B9A\5236\5FBD\6807\6807\8BB0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569105502312780)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E\6587\4EF6\6216\5355\51FB\4EE5\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569061879312780)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569310074312780)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4F1A\4E3A\6B64\5E94\7528\7A0B\5E8F\663E\793A\5FBD\6807\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568920184312780)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568851916312780)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569525952312780)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5FBD\6807\7C7B\578B\9700\8981\5FBD\6807\56FE\50CF\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569627502312780)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\4FDD\5B58\5FBD\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108569489169312780)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5FBD\6807\7C7B\578B\9700\8981\5FBD\6807\6587\672C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568610063312780)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\5141\8BB8\56FE\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750072246312919)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C22\8C22\60A8\7684\53CD\9988, \5DF2\7ECF\4E3A\6B64\95EE\9898\521B\5EFA\4E86 Bug\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751567445312921)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C22\8C22\60A8\7684\53CD\9988, \5728\672A\6765\7684\53D1\884C\7248\4E2D\5C06\8003\8651\6B64\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374830384312624)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C22\8C22\60A8\7684\53CD\9988\FF0C\5DF2\5728\6211\4EEC\7684\7CFB\7EDF\4E2D\8BB0\5F55\4E86\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751792175312921)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C22\8C22\60A8\7684\53CD\9988, \5DF2\7ECF\521B\5EFA\4E86\4E00\4E2A\4EFB\52A1\6765\89E3\51B3\6B64\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779567942312942)
,p_name=>'LOG_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107956773282312289)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7\95F4\9694')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070579977312379)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\9879\6761\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028443809312346)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4E\4F18\5148\7EA7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571603229311993)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220358550312498)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220125194312498)
,p_name=>'MANAGE USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219518089312498)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164048312312454)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785636951312158)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\672A\5206\914D\9879')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603180580312019)
,p_name=>'MANUAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\624B\52A8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107541500378311970)
,p_name=>'MAP_LAYER='
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C42=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542903719311971)
,p_name=>'MAP_LAYERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE\5C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688801413312084)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\6B64\5730\56FE\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027663675312345)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8\529F\80FD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108101532294312404)
,p_name=>'MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086867732312393)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\4E3B\4ECE\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540279420311969)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\4ECE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540434900311969)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \8BE6\7EC6\8D44\6599')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540379515311969)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153363211312445)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F53\5316\89C6\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049090103312362)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\957F\5448\73B0\65F6\95F4 (\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140245961312435)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\957F\4F1A\8BDD\7A7A\95F2\65F6\95F4 (\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140316133312435)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\4F1A\8BDD\957F\5EA6 (\79D2)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723345219312110)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\5220\9664\5177\6709\5173\8054\529F\80FD\7684\91CC\7A0B\7891\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615532534312028)
,p_name=>'MEMORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5B58:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773805579312149)
,p_name=>'MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074295928312382)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\9879\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083029021312389)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316190055312578)
,p_name=>'MIGRATION FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC1\79FB\6587\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070166158312379)
,p_name=>'MILESTONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050168182312363)
,p_name=>'MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CC\7A0B\7891')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506451970312731)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BEB\79D2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052857565312365)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('MIME \7C7B\578B\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026114365312344)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\5F71\54CD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590602065312009)
,p_name=>'MIN_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\4F4E\7248\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750630688312920)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F3A\5C11 @ \7B26\53F7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973692319312302)
,p_name=>'MODEL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027889314312346)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026018953312344)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5EA6\5F71\54CD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712854876312102)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\793A\5DF2\4FEE\6539\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153612253312446)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FEE\6539\5217 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953380982312287)
,p_name=>'MONITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76D1\89C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220291475312498)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76D1\89C6\6D3B\52A8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079472662312386)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A...')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048571015312361)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\6D3B\8DC3\7684 %0 \4E2A\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043517944312357)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\8FD1\7684\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344147516312600)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\8FD1\7684\6587\4EF6\4E3A\7531%1 %2\4E0A\8F7D\7684%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811951478312178)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('MRU \4E2D\51FA\73B0\9519\8BEF: \884C= %0, %1, %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810873903312177)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\7684\4E3B\952E\5217\4E0D\5728\67E5\8BE2\7684\9009\62E9\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812021684312178)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7528\6237\5F00\59CB\66F4\65B0\8FC7\7A0B\4EE5\540E, \6570\636E\5E93\4E2D\6570\636E\7684\5F53\524D\7248\672C\5DF2\7ECF\66F4\6539\3002\5F53\524D\6821\9A8C\548C = "%0", \9879\6821\9A8C\548C = "%1"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810373860312177)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8981\5904\7406\7684\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728221663312114)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\786E\4FDD\62A5\8868\5E03\5C40\6587\4EF6\7684\6587\4EF6\7C7B\578B\4E3A XSL-FO, \4F7F\7528 ''.xsl'' \4F5C\4E3A\6587\4EF6\6269\5C55\540D\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637139337312044)
,p_name=>'MY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6211\7684\9875')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749540687312919)
,p_name=>'NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157597427312449)
,p_name=>'NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070347405312379)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F\9879\6761\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753184198312922)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\9876\5C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068267532312378)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083234516312390)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571358113311993)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\9875')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562745809311986)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\5230\5E94\7528\7A0B\5E8F\6784\5EFA\5668\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789333855312957)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\65BD: \5217\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789231365312957)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\65BD: \7ECF\5178')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038543323312354)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\590D\67E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031609725312348)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\4FE1\606F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049765750312362)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\95FB\6761\76EE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783042496312952)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED1\5B9A\53D8\91CF %0 \7684\65B0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792678548312163)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \5E10\6237\7684\65B0\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027159051312345)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\529F\80FD\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959338693312291)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\7684\6216\73B0\6709\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135432063312431)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042826709312357)
,p_name=>'NEW_SERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773781381312149)
,p_name=>'NEW_TABSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768314593312934)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \672A\9009\62E9\7236\7EA7 - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079725052312387)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5DE5\4F5C\533A\8BF7\6C42')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087960340312394)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\76F8\5E94\7684\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021256199312341)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\4E2D\6CA1\6709\5DF2\5B9A\4E49\7684\4E3B\952E\3002\4E3B\952E\5728\521B\5EFA\5E26\6709\8868\5355\7684\62A5\8868\65F6\662F\5FC5\9700\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617325316312029)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5FD7\5F52\6863: \5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012488636312335)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\5F53\524D\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068053805312378)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\5F53\524D\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072578020312381)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760192471312138)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\5F53\524D\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137124689312432)
,p_name=>'NON_PACKAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-\975E\751F\4EA7\529B\6216\793A\4F8B\5E94\7528\7A0B\5E8F-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028327476312346)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\666E\901A\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750114709312919)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775582277312939)
,p_name=>'NOTE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931394650312270)
,p_name=>'NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025097027312343)
,p_name=>'NOT_A_BUG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\662F Bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782076025312951)
,p_name=>'NOT_CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\5F53\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028081181312346)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077655801312385)
,p_name=>'NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632970077312041)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025194902312343)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4FEE\590D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157321581312448)
,p_name=>'NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788716123312956)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B8C\6210 80% \6216\66F4\5C11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090408653312396)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773657548312149)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\6570\636E\5B57\5178\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028787689312346)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\786E\5B9A\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108026558896312345)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\786E\5B9A\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072773586312381)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1A\672A\63D0\4F9B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348499005312603)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\9700\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031410113312348)
,p_name=>'NOT_STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109987791312411)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<strong>%0</strong> \4E0D\662F\6709\6548\7684\89C6\56FE\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590167266312009)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108093666856312398)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868203164312222)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\4F7F\7528\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024115235312343)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5206\914D\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635947736312043)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072963183312381)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\53EF\7528\7684\6570\636E\5E93\4F5C\4E1A\961F\5217\5904\7406\3002\8BF7\4E0E<br>\7BA1\7406\5458\8054\7CFB, \4EE5\63D0\9AD8 JOB_QUEUE_PROCESSES \521D\59CB\5316\53C2\6570<br>, \6216\7B49\5F85\5176\4ED6\4F5C\4E1A\5B8C\6210\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946854493312282)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\9762\5305\5C51\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\9762\5305\5C51\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946917912312282)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\6309\94AE\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\6309\94AE\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946447211312282)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\65E5\5386\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\65E5\5386\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722456945312109)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972273944312301)
,p_name=>'NO_DEBUG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8C03\8BD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584363109312004)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5F00\53D1\8005\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645750819312051)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \65E0\663E\793A -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600831511312017)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\76EE\6807\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944479593312280)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6B64\9875\9879\7684\5E2E\52A9\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809446319312972)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694698739312088)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931616753312271)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776086472312150)
,p_name=>'NO_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137620192312433)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\542F\7528\6570\636E\5E93\4F5C\4E1A\961F\5217\5904\7406\3002\8BF7\4E0E<br>\7BA1\7406\5458\8054\7CFB\4EE5\8BBE\7F6E JOB_QUEUE_PROCESSES \521D\59CB\5316\53C2\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946544966312282)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\6807\7B7E\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\6807\7B7E\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678225804312076)
,p_name=>'NO_LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946777093312282)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\5217\8868\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\5217\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027364261312345)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\518D\662F\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635723125312043)
,p_name=>'NO_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071279637312380)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297940679312563)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5BFC\822A\83DC\5355\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678117312312076)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\6CA1\6709\5728\6B64\9875\4E0A\521B\5EFA\7EC4\4EF6\7684\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947159309312282)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\590D\5236\4E3B\9898, \4F46\5728\5E94\7528\7A0B\5E8F %0 \4E2D\672A\627E\5230\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946274874312282)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\9875\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\9875\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107869806332312223)
,p_name=>'NO_PARENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\7236\9762\5305\5C51\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318307013312580)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1A\672A\5B9A\4E49\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079303689312386)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6682\6302\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947082565312282)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028614644312346)
,p_name=>'NO_PRIORITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\4F18\5148\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115665357312415)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\533A\57DF\4F4D\7F6E\4E0D\5728\9875\6A21\677F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946371938312282)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\533A\57DF\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\533A\57DF\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107946631420312282)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\9898\4E2D\672A\627E\5230\62A5\8868\6A21\677F\3002\81F3\5C11\9700\8981\4E00\4E2A\62A5\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635812357312043)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031389561312348)
,p_name=>'NO_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079993635312387)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\7CFB\7EDF\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374279209312624)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5E94\7528\7A0B\5E8F\5B9A\4E49\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318517583312580)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315788465312577)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1A\672A\5B9A\4E49\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108318457729312580)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749987023312919)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775900193312150)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868320296312222)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0 URL \8BBF\95EE\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360249530312613)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4F7F\7528 SQL \6807\8BB0\4E4B\524D, \5FC5\987B\5B9A\4E49\5141\8BB8\7684\8868\5217\8868\3002\8FD9\6837\505A\662F\4E3A\4E86\5B89\5168\8D77\89C1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025896575312344)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\53D8\901A\89E3\51B3\65B9\6CD5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772164340312147)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\7A7A)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156714619312448)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109747894312411)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600775826312017)
,p_name=>'NUM_TOTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \603B\8BA1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008282378312331)
,p_name=>'OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303610206312567)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\9ED8\8BA4\503C\7684\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108303593824312567)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5177\6709\9ED8\8BA4\503C\7684\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775184231312939)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096532425312400)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037881501312353)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\68C0\67E5\7EA6\675F\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107591931430312010)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097682754312401)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA6\675F\6761\4EF6\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097749282312401)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217/\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037626968312353)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\7EA6\675F\6761\4EF6\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038021302312353)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA6\675F\6761\4EF6\540D\79F0\5DF2\88AB\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096252919312400)
,p_name=>'OB_FK_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037284907312353)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\5916\952E\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037940900312353)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\952E\540D\88AB\5360\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096324048312400)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096407033312400)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037573010312353)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\5916\952E\5F15\7528\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037436381312353)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\5916\952E\5F15\7528\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037303081312353)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\5916\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158097653312449)
,p_name=>'OB_POSITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097899940312401)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\6570\636E\7C7B\578B -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096645084312400)
,p_name=>'OB_SET_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\7A7A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108037720155312353)
,p_name=>'OB_UK_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A\552F\4E00\952E\6307\5B9A\5217\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506630747312731)
,p_name=>'ODG.API.START'
,p_message_language=>'zh-cn'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506597161312731)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \672A\5904\7406\7684\5F02\5E38\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506721944312731)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5904\7406\7684\5185\7F6E data_source\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507563797312732)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6216\672A\521B\5EFA\84DD\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559151789311983)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\540D\79F0\4E0D\5F97\8D85\8FC7 26 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559056966311983)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\5165\65F6\51FA\9519\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507470457312731)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA INSERT-SELECT SQL \8BED\53E5\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506917581312731)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \6B63\5728\83B7\53D6 JSON \6570\636E\3002URL\FF1A%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507684644312732)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('INSERT INTO \811A\672C\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559399000311984)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\6570\636E\6E90\65E0\6548\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507333444312731)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\FF1AJSON \6570\636E\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507040077312731)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\662F\6709\6548\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507143305312731)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8BF7\6C42\884C\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506837880312731)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\7684\884C\592A\591A\FF0C\5141\8BB8\7684\6700\5927\884C\6570\662F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108507233031312731)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D %0 \65F6\51FA\73B0\610F\5916\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559297611311983)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5FC5\987B\4E3A Y \6216 N')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637041543312044)
,p_name=>'ONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589600331312008)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\9650\5DF2\5B89\88C5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107826667848312190)
,p_name=>'ON_LOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\65F6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027439667312345)
,p_name=>'OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\89E3\51B3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073021298312381)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8FC7\53BB 7 \5929\5185\65B0\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072102631312381)
,p_name=>'OPEN_BUGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\89E3\51B3 Bug')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071865998312380)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B8C\6210\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305663532312569)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00, \5904\7406\53CD\9988')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072014898312381)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B8C\6210\5F85\529E\4E8B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679233758312077)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00 Websheet %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013246328312335)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\9009\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793499388312960)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\9009\7684\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013110955312335)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\9009\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108013331485312335)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\9009\56FE\50CF\5C5E\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316270374312578)
,p_name=>'ORACLE FORMS'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721060635312897)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E Oracle REST Data Services \7684\6253\5370\5728 Oracle APEX 19.1 \4E2D\5DF2\8FC7\65F6\FF0C\4E0D\518D\53D7\652F\6301\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107571157654311993)
,p_name=>'OTHER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316878498312578)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\5DE5\4F5C\533A\6587\4EF6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065798836312376)
,p_name=>'OTN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle \6280\672F\7F51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065831723312376)
,p_name=>'OTN_FORUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle \6280\672F\7F51\8BBA\575B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108195803929312479)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8986\76D6 ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108771911040312937)
,p_name=>'OVERVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6982\89C8')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753466445312133)
,p_name=>'OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600476230312017)
,p_name=>'OWNERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\8005')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107977426782312305)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\51FD\6570\4F53')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115045055312415)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727838974312114)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\6B64 LOV\3002\5B83\5728\9875 %0 \4E0A\4F7F\7528\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108077757176312385)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED1\5B9A\9879 (\8F93\5165\9879\540D)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726530803312901)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\80FD\9700\8981\5237\65B0\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729336607312904)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\90E8\7F72\670D\52A1\5668')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003939818312328)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\6570\636E\5E93\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999994296312325)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0, \521B\5EFA\6570\636E\5E93\94FE\63A5\64CD\4F5C\5931\8D25:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000090688312325)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "%1" \65B9\6848\4E2D\5DF2\521B\5EFA\6570\636E\5E93\94FE\63A5 "%0"\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772978018312148)
,p_name=>'PACKAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947534410312282)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\4EA7\529B\6216\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610276886312024)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\4EA7\529B\548C\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159369463312450)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\5E94\7528\7A0B\5E8F\671F\95F4\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990626332312315)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137032396312432)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-\5168\5C40-')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107754921445312134)
,p_name=>'PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075354362312383)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BA1\7B97\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155623197312447)
,p_name=>'PAGE HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067873108312377)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709, \6B63\6587\548C\9875\811A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075663515312383)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075815177312384)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\663E\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076070560312384)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075772915312383)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\540E\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075935767312384)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\53EA\8BFB\663E\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075515688312383)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991068341312315)
,p_name=>'PAGE ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068600471312378)
,p_name=>'PAGE PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068755802312378)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5904\7406\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075487323312383)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9A8C\8BC1\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004955174312329)
,p_name=>'PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219032541312497)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049557523312362)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085753836312392)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E8B\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801987856312966)
,p_name=>'PAGE_FINDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\67E5\627E\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107564360065311987)
,p_name=>'PAGE_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085211925312391)
,p_name=>'PAGE_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\5E94\7528\7A0B\5E8F\4E2D\7684\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250449070312523)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0 \5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250574714312523)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0 \5DF2\53D6\6D88\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095710485312400)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9875\5DF2\6210\529F\5B89\88C5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991556332312316)
,p_name=>'PAGE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201647142312484)
,p_name=>'PAGE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9762: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036466132312352)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9501\5B9A\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107944960560312281)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7531 %0 \9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065475053312375)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\7684\9875\90FD\9700\8981\6709\9875\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049342180312362)
,p_name=>'PAGE_POSTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6295\9012')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219179564312497)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601146356312017)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086503839312393)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766488490312143)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766617921312143)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766561463312143)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766291157312143)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766353984312143)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766148975312143)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107766068826312143)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765837235312143)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765627437312143)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765935903312143)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765776590312143)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688673817312084)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\9875 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067739364312377)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108036599305312352)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9501\5B9A\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049401633312362)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\91CF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045126325312359)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\529F\80FD\7F16\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155388868312447)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108317051335312579)
,p_name=>'PARENT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315393682312577)
,p_name=>'PARENT_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759628167312138)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759710367312138)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\7236\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759856853312138)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\6587\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316004427312578)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\96C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604330245312020)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\65B9\6848\8FDB\884C\8BED\6CD5\5206\6790')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601289180312017)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\5206\9875')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584520347312004)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5931\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572258634311994)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E10\6237\7684\5BC6\7801\5FC5\987B\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584449827312004)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\6709\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592278106312010)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801 (\6309 Enter \65F6\63D0\4EA4)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109079460312410)
,p_name=>'PAST_DUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198927664312482)
,p_name=>'PATH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DEF\5F84')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358490263312611)
,p_name=>'PCT_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5173\95ED\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354708989312608)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4\7684\56FE\5F62\683C\5F0F\8BBE\7F6E, \4F7F\7528\4ECB\4E8E 0 \4E0E 100 \4E4B\95F4\7684\6574\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267580145312538)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267610978312538)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604119243312807)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604201513312807)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269505717312539)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269692794312539)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604379761312807)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604474699312807)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269977985312540)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270062052312540)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270117606312540)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270272089312540)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504780221312729)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504819399312729)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741469908312913)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741598209312913)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5316\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273756672312543)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273867067312543)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270376356312540)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270427049312540)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604527845312807)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604680909312807)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268987795312539)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269023429312539)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269711794312540)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269898850312540)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272583361312542)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272622233312542)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268523796312539)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268698076312539)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269128622312539)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269284694312539)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\65E5\5386\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584903710312792)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585046481312792)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585193790312792)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585220917312792)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287150174312554)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287274784312554)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275301724312544)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275465709312544)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275544424312544)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275642848312544)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364785496312616)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364888484312616)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571703942312782)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571874840312782)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271341422312541)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\6570\636E\52A0\8F7D\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271493293312541)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\6570\636E\52A0\8F7D\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272949511312542)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273093264312542)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272787383312542)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272837567312542)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829304856312192)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829452716312192)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505053324312729)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505164279312730)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576341942312785)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576492639312785)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576564008312785)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576612971312786)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268379226312538)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\6BB5\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268422256312538)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\6BB5\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115838491312415)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115948649312416)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116268419312416)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116347877312416)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116091522312416)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116140507312416)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116402144312416)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116566025312416)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583167464312790)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583835842312791)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273903005312543)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274061964312543)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274597267312544)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274602300312544)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274333841312543)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274430765312543)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364546700312616)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364674845312616)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274163019312543)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274210572312543)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163296920312453)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163371820312453)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163069205312453)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163185416312453)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5750\6807\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163494493312453)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163523501312453)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733874311312907)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733984017312907)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270543517312540)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270682287312540)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604769382312807)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604805824312807)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268788581312539)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268873498312539)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270793794312540)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270828680312540)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108604988751312808)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605083782312808)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510800430312734)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510998651312734)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511087962312734)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511157812312734)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510687885312734)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510789273312734)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272164381312542)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272281965312542)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273383039312542)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273461285312543)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271903761312541)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272038814312541)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970556002312300)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970698727312300)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273508589312543)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273661362312543)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275112354312544)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\672C\9A8C\8BC1\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275297263312544)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\672C\9A8C\8BC1\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274767224312544)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274819695312544)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108274966424312544)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275044885312544)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267916309312538)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268000560312538)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605512283312808)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605633449312808)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272304448312542)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108272451253312542)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563542308312776)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563676657312776)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500299508312726)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500357373312726)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268145016312538)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108268249366312538)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211306151312492)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211417467312492)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991976082312316)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992079778312316)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371788318312622)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371862108312622)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269397586312539)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108269493347312539)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937993503312275)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938021166312275)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938163787312276)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B5B\9009\5668\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938212640312276)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B5B\9009\5668\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938344299312276)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938481097312276)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605189110312808)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605257805312808)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271520614312541)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271640437312541)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277519956312546)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277605386312546)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277761036312546)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277862557312546)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364998417312616)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365053089312616)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267796393312538)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267899570312538)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605300340312808)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605418955312808)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271733119312541)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271855367312541)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273111922312542)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108273287500312542)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108270991534312541)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271044683312541)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271115659312541)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108271277638312541)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740509053312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\672C\9A8C\8BC1\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740657224312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\672C\9A8C\8BC1\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740729602312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP \6807\5934\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740820261312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTTP \6807\5934\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740175283312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740270194312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740379202312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740456398312912)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105310050312407)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105409023312407)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216085867312495)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216122325312495)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211111393312491)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211208405312491)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216286107312495)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\64CD\4F5C\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216346660312495)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\64CD\4F5C\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216431929312495)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216580868312495)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105557728312407)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105644138312407)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226988465312504)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741609910312913)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\4EE3\7801\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888309653312237)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888692944312237)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D7\5F71\54CD\7684\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165690380312455)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\753B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889630655312238)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886831020312236)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536524085311966)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA1\8BA1\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888472561312237)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605840223312808)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284456021312552)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\5237\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889579855312238)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259584669312531)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585554109312792)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261893562312533)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\65AD\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294574344312560)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386\72B6\6001\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585357007312792)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251094212312524)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA7\8054\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286035745312554)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756444197312924)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\7AEF\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741756709312913)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287797730312555)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365472931312617)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363826305312615)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221789856312499)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\683C\5F0F\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365378509312616)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164963774312454)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6620\5C04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886929687312236)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888230527312237)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887139927312236)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\914D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798607039312168)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297158979312562)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887216427312236)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'zh-cn'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983898213312310)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287523692312555)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386\548C\5468\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605979220312808)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286171331312554)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164821457312454)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E38\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888794684312237)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250967948312524)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\51B3\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227007641312504)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227164623312504)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295726682312561)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227211750312504)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287808974312555)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165571697312455)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CC Y \8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116746021312416)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249057233312522)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888836700312237)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116654797312416)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6237\53EF\4EE5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294631445312560)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887072067312236)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887359521312236)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888115600312237)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255474676312527)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA/\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261942538312533)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509884484312733)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285944127312553)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707670597312887)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\7A97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285576046312553)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\91CF\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887442484312236)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\548C\9875\811A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262100256312533)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887518255312236)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888991096312237)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887625318312236)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6807\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585770328312792)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\548C\5FBD\7AE0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227386216312504)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886652547312236)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887715053312237)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889017236312238)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889738687312238)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285031189312553)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165048783312454)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242183480312516)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349043871312604)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889136365312238)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287602425312555)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\7A0B\67E5\770B\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717414607312894)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5730\540E\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983261206312309)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165229448312455)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\523B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511391212312735)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511278469312734)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511834115312735)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F\7A97\53E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511444581312735)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\4F4D\7F6E\548C\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511624383312735)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\96C6\7C07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511578592312735)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511753159312735)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285192567312553)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FB9\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165119968312455)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310626832312573)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\4ECE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585892141312793)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECB\8D28')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262050429312533)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165368348312455)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B21\523B\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287310419312555)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689603182312084)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4E2A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018999302312339)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\7CFB\5217\56FE\8868\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606057627312808)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029553919312347)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793525448312960)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373434200312623)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108164724256312454)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6982\89C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365299415312616)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365674635312617)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365540719312617)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227474467312504)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247444973312521)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116948719312416)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6027\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983346223312310)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500\540E URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279970378312548)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365181346312616)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108605795364312808)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889280863312238)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\901F\9009\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887897800312237)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983416739312310)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728631957312114)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\7167\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248527924312522)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992160359312316)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207759303312489)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585625058312792)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B21\7EA7\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107887947761312237)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285229821312553)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888057080312237)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\5668\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756369406312924)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\5668\7AEF\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606177706312808)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983519833312310)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD Cookie \5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983617645312310)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886705306312236)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227696825312504)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\884C\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227563086312504)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889390533312238)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983776099312310)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585401028312792)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243086946312517)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938525774312276)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EFA\8BAE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793636284312960)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621390618312032)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9608\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165489479312455)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\523B\5EA6\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499786966312725)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\6807\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285816787312553)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108116895070312416)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\5177\680F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285740061312553)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278754005312547)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('UI \9ED8\8BA4\503C\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889440198312238)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285644154312553)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287470416312555)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107888576926312237)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285327539312553)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('X \8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108285408439312553)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Y \8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211531685312492)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E\6BD4\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118652924312418)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\6388\6743\65B9\6848\4EE5\9650\5236\53EF\4EE5\6DFB\52A0\884C\7684\7528\6237\3002'),
unistr('\8981\4F7F\67D0\4E2A\6700\7EC8\7528\6237\53EF\4EE5\6DFB\52A0\884C\FF0C\8BE5\7528\6237\7684\6B64\6388\6743\65B9\6848\7684\6C42\503C\7ED3\679C\5FC5\987B\4E3A TRUE\3002'),
unistr('\5982\679C\672A\63D0\4F9B\6388\6743\65B9\6848\FF0C\5219\4EFB\4F55\7528\6237\90FD\53EF\4EE5\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E2D\6DFB\52A0\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118571391312418)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121623864312420)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\201C\6DFB\52A0\201D\6309\94AE\7684\66FF\4EE3\6807\7B7E\3002\9ED8\8BA4\6807\7B7E\4E3A<em>\6DFB\52A0\884C</em>\3002</p>'),
unistr('        <p>\4F8B\5982, \5BF9\4E8E\7EF4\62A4\96C7\5458\7684\4EA4\4E92\5F0F\7F51\683C, \8F93\5165<em>\6DFB\52A0\96C7\5458</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121522431312420)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119888583312419)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\4EA4\4E92\5F0F\7F51\683C\5F53\524D\672A\8FD4\56DE\4EFB\4F55\8BB0\5F55\65F6\662F\5426\6DFB\52A0\65B0\884C\3002'),
unistr('        <em>\672A\627E\5230\6570\636E</em>\6D88\606F\5C06\4ECE\4E0D\663E\793A, \56E0\4E3A\59CB\7EC8\5C06\81F3\5C11\663E\793A\4E00\6761\8BB0\5F55\3002</p>'),
unistr('        <p>\6CE8 - \5982\679C\672A\5BF9\6DFB\52A0\7684\8BB0\5F55\8FDB\884C\4EFB\4F55\66F4\65B0, \5219\5728\4FDD\5B58\533A\57DF\65F6\5C06\4E0D\4F1A\63D2\5165\6B64\8BB0\5F55\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119719714312419)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7A7A\65F6\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603350777312806)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\9762\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578367414312787)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\9762\7EC4\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135072528312431)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\6CE8\FF1A\5728\4EA4\4E92\5F0F\7F51\683C\53EF\7F16\8F91\65F6\FF0C\53EF\4EE5\4F7F\7528\6B64\5C5E\6027\5BF9\76F8\5E94\9879\8FDB\884C\6837\5F0F\4FEE\6539\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580002692312788)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\6CE8\FF1A\8FD9\4E9B CSS \7C7B\5C06\5E94\7528\4E8E HTML \8868\5355\5143\7D20\6807\8BB0\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941944310312278)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7B5B\9009\5668\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942695058312279)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7B5B\9009\5668\7EC4\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579461311312788)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06 CSS \7C7B <code>articlenumber</code> \548C <code>highlight</code> \6DFB\52A0\5230\7EC4\4EF6\7684 HTML \6807\8BB0</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579390042312788)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5305\62EC\5728\7EC4\4EF6\4E2D\7684\4EE5\7A7A\683C\5206\9694\7684\9644\52A0 CSS \7C7B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579229586312787)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921775457312263)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\64CD\4F5C\5C06\5F71\54CD\7684\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921606964312263)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757333994312925)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E00\4E2A\6216\591A\4E2A\5C06\53D7\6B64\64CD\4F5C\5F71\54CD\7684\5217\3002'),
unistr('\5BF9\4E8E\591A\4E2A\5217, \7528\9017\53F7\5206\9694\5404\5217\540D\3002'),
unistr('<p>\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\5217\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\5217\540D\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757265273312925)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922183441312263)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 DOM \5BF9\8C61 (<code>document</code>, <code>window</code>) \6216 DOM \5BF9\8C61\7684 <em>id</em> (<code>myElementID</code>) \4F5C\4E3A\53D7\6B64\64CD\4F5C\5F71\54CD\7684\5143\7D20\3002</p>'),
unistr('<p>\6CE8: <em>DOM \5BF9\8C61</em>\5DF2\8FC7\65F6, \5E94\66FF\6362\4E3A <em>JavaScript \8868\8FBE\5F0F</em>\6216 <em>jQuery \9009\62E9\5668</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922044260312263)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DOM \5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921951699312263)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E00\4E2A\6216\591A\4E2A\5C06\53D7\6B64\64CD\4F5C\5F71\54CD\7684\9875\9879\3002'),
unistr('\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002'),
unistr('<p>\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921891357312263)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753750870312922)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8FD4\56DE\5BF9\6D4F\89C8\5668\7684 <code>window</code> DOM \5BF9\8C61\7684\5F15\7528\3002</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\8FD4\56DE\5BF9\6D4F\89C8\5668\7684 <code>document</code> DOM \5BF9\8C61\7684\5F15\7528\3002</dt>'),
'<dd>document</dd>',
unistr('<dt>jQuery \9009\62E9\5668\9009\62E9\7C7B\4E3A ''alert'' \7684\6240\6709 DIV \5143\7D20, \7136\540E\8FD4\56DE\5305\542B\5176\6240\6709\7236\7EA7\7684 jQuery \5BF9\8C61\3002</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753642084312922)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5C06\6C42\503C\7684 JavaScript \8868\8FBE\5F0F\4EE5\8FD4\56DE\5355\4E2A DOM \5BF9\8C61, DOM \5BF9\8C61\6570\7EC4\6216\5355\4E2A jQuery \5BF9\8C61\4F5C\4E3A\53D7\6B64\64CD\4F5C\5F71\54CD\7684\5143\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753553432312922)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412128399312654)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\9009\62E9 DOM ID \4E3A <code>my_id</code> \7684\9875\5143\7D20</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\9009\62E9\7C7B\4E3A <code>my_class</code> \7684\6240\6709\9875\5143\7D20</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\9009\62E9\6240\6709\4F5C\4E3A\8F93\5165\7684\9875\5143\7D20</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922396099312263)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 jQuery \9009\62E9\5668\8BED\6CD5\4EE5\8FD4\56DE\4E00\4E2A\6216\591A\4E2A\5C06\53D7\6B64\64CD\4F5C\5F71\54CD\7684\9875\5143\7D20\3002jQuery \5E93\63D0\4F9B\4E86\529F\80FD\975E\5E38\5F3A\5927\7684\9009\62E9\5668\8BED\6CD5, \4ECE\800C\63D0\4F9B\4E00\79CD\4ECE\9875\4E2D\8F7B\677E\8BBF\95EE\4E00\4E2A\6216\591A\4E2A\5143\7D20\7684\65B9\6CD5\3002</p>'),
unistr('<p>\6709\5173\9009\62E9\5668\8BED\6CD5\7684\8FDB\4E00\6B65\4FE1\606F, \8BF7\53C2\9605 <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery \4E3B\9875</a>\4E0A\63D0\4F9B\7684\5B98\65B9\6587\6863\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922250386312263)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('jQuery \9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921578973312263)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\64CD\4F5C\5C06\5F71\54CD\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921411039312263)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921385164312263)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\5B9A\4E49\6267\884C\6B64\64CD\4F5C\65F6\5C06\5F71\54CD\7684\9875\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410924905312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411042554312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\9009\62E9\7684\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756640516312925)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756769912312925)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\8F93\5165\7684\4E00\5217\6216\591A\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411354475312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DOM \5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411466800312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\901A\8FC7\8F93\5165\7684 DOM \5BF9\8C61\6216 DOM ID \6807\8BC6\7684\9875\5143\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411983511312654)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412088158312654)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\64CD\4F5C\5C06\5F71\54CD\5F15\8D77\4E8B\4EF6\7684\9875\5143\7D20, \5728\67D0\4E9B\60C5\51B5\4E0B\53EF\80FD\4E0E "\89E6\53D1\5143\7D20" \4E0D\540C\3002</p>'),
unistr('<p>\5728\6B64\9AD8\7EA7\914D\7F6E\4E2D, \6307\5B9A\7684\89E6\53D1\5143\7D20\901A\5E38\4E3A\5BB9\5668\5143\7D20 (\4F8B\5982\533A\57DF), \5904\7406\7531\5176\6240\6709\5B50\5143\7D20 (\4F8B\5982\533A\57DF\4E2D\7684\9875\9879) \5F15\53D1\7684\4E8B\4EF6\3002'),
unistr('\7136\540E\53EF\4EE5\4F7F\7528\6B64\9009\62E9\7C7B\578B\5904\7406\89E6\53D1\8BE5\4E8B\4EF6\7684\5B50\5143\7D20 (\800C\4E0D\662F\5BB9\5668\5143\7D20)\3002'),
unistr('\4F8B\5982, \5982\679C\5177\6709\5DF2\5BF9\9875\4E0A\7684\533A\57DF\5B9A\4E49\4E86 <strong>''\66F4\6539''</strong> \4E8B\4EF6\7684\52A8\6001\64CD\4F5C, \5219\64CD\4F5C\5C06\5F71\54CD\5DF2\66F4\6539\533A\57DF\4E2D\7684\5B9E\9645\9879\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528 <em>''\4E8B\4EF6\6E90''</em> \6765\66F4\6709\6548\5730\5B9A\4E49\5F71\54CD\591A\4E2A\9875\5143\7D20\7684\516C\5171\884C\4E3A\3002'),
unistr('\5BB9\5668\5143\7D20\6355\83B7\5B50\5143\7D20\6240\5F15\53D1\7684\4E8B\4EF6\7684\80FD\529B\7531\4E8B\4EF6\7C7B\578B\786E\5B9A\3002'),
unistr('\4E0B\5217\4E8B\4EF6\7C7B\578B\652F\6301\6B64\80FD\529B:</p>'),
'<ul>',
unistr('  <li><strong>\5237\65B0\540E</strong> (apexafterrefresh)</li>'),
unistr('  <li><strong>\5237\65B0\524D</strong> (apexbeforerefresh)</li>'),
unistr('  <li><strong>\66F4\6539</strong> (change)</li>'),
unistr('  <li><strong>\5355\51FB</strong> (click)</li>'),
unistr('  <li><strong>\53CC\51FB</strong> (dblclick)</li>'),
unistr('  <li><strong>\83B7\5F97\7126\70B9</strong> (focus)</li>'),
unistr('  <li><strong>\6309\4E0B\952E</strong> (keydown)</li>'),
unistr('  <li><strong>\6309\952E</strong> (keypress)</li>'),
unistr('  <li><strong>\91CA\653E\952E</strong> (keyup)</li>'),
unistr('  <li><strong>\5931\53BB\7126\70B9</strong> (blur)</li>'),
unistr('  <li><strong>\6309\4E0B\9F20\6807\6309\94AE</strong> (mousedown)</li>'),
unistr('  <li><strong>\91CA\653E\9F20\6807\6309\94AE</strong> (mouseup)</li>'),
unistr('  <li><strong>\79FB\52A8\9F20\6807</strong> (mousemove)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410755899312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410856352312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\8F93\5165\7684\4E00\4E2A\6216\591A\4E2A\9875\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753357604312922)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753479663312922)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\4F7F\7528\8F93\5165\7684 JavaScript \8868\8FBE\5F0F\8FD4\56DE\7684\9875\5143\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411565346312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('jQuery \9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411624658312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\4F7F\7528\8F93\5165\7684 jQuery \9009\62E9\5668\8BED\6CD5\8FD4\56DE\7684\9875\5143\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411189089312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411242613312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\9009\62E9\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411768692312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5143\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108411895030312653)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5C06\5F71\54CD\89E6\53D1\52A8\6001\64CD\4F5C\7684\9875\5143\7D20\6216\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921269448312262)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033808207312350)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108033921098312350)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\503C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684131950312868)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\805A\96C6\5173\8054\7684\56FE\8868\503C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685606797312870)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8FD1\4F3C\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685752207312870)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\4E0D\540C\503C\7684\8FD1\4F3C\8BA1\6570\3002\5728\5904\7406\5927\91CF\6570\636E\65F6, \6B64\805A\96C6\8981\660E\663E\5FEB\4E8E<em>\4E0D\540C\503C\8BA1\6570</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684643122312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684735658312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\503C\5217\7684\5E73\5747\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684241670312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684304613312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685435060312870)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685575958312870)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\4E0D\540C\503C\7684\786E\5207\6570\91CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685223830312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685384575312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\6700\5927\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684815704312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684918930312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\4E2D\95F4\6570, \5FFD\7565\7A7A\503C\3002\6B64\805A\96C6\6700\9002\5408\8FDE\7EED\5206\5E03\6A21\578B, \56E0\4E3A\5B83\8FD4\56DE\4E86\4E2D\95F4\7684\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685083884312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685125151312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\6700\5C0F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684476598312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684519400312869)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\503C\5217\7684\603B\8BA1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108684069818312868)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900696431312247)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\591A\6B21\63D0\4EA4\76F8\540C\7684\9875\3002'),
unistr('\4F7F\7528\6B64\529F\80FD\53EF\4EE5\907F\514D\5728\540C\4E00\8868\4E2D\91CD\590D\5730\63D2\5165\3002'),
unistr('\5728\6700\7EC8\7528\6237\5355\51FB\6D4F\89C8\5668\7684\201C\8FD4\56DE\201D\6309\94AE\540E\518D\6B21\63D0\4EA4\6B64\9875, \6216\8005\5728\6700\7EC8\7528\6237\5355\51FB\6D4F\89C8\5668\7684\201C\91CD\65B0\52A0\8F7D\201D\6309\94AE\65F6, \53EF\80FD\4F1A\53D1\751F\91CD\590D\63D2\5165\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402244640312646)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426 - \963B\6B62\91CD\65B0\6295\9012\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402352326312646)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F - \5141\8BB8\91CD\65B0\6295\9012\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900519794312247)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\91CD\590D\9875\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230403037312506)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5355\8BB0\5F55\89C6\56FE\4E0A\9690\85CF\7A7A\503C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230390882312506)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230697873312507)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5355\8BB0\5F55\89C6\56FE\4E2D\4EC5\663E\793A\5F53\524D\663E\793A\7684\90A3\4E9B\5217\3002\5982\679C\6307\5B9A<strong>\7981\7528</strong>\FF0C\5219\4E0D\663E\793A\7684\62A5\8868\5217\4E5F\53EF\80FD\663E\793A\5728\5355\8BB0\5F55\89C6\56FE\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230575718312506)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\663E\793A\7684\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224572213312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\805A\96C6\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224445500312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224916606312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\56FE\8868\4E2D\4F7F\7528\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224819771312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224748182312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\5176\5B9A\4E49\7684\8BA1\7B97\5217\4E2D\4F7F\7528\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224662598312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224301450312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\63A7\5236\5206\6BB5\4E2D\4F7F\7528\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224232714312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223980609312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\8FC7\6EE4\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223802575312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225121678312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\6309\6B64\5217\5206\7EC4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225094231312502)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223569270312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\9690\85CF\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223496283312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224129222312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\7A81\51FA\663E\793A\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108224061966312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537368865311966)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\6B64\62A5\8868\5185\5B9A\4E49\900F\89C6\7EC6\5206\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537200993311966)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238429855312513)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5C06\5176\5F53\524D\62A5\8868\5B9A\4E49\53E6\5B58\4E3A<em>\516C\5171</em>\62A5\8868\3002</p>'),
unistr('<p>\516C\5171\62A5\8868\663E\793A\5728\641C\7D22\680F\7684\53EF\7528\62A5\8868\9009\62E9\5217\8868\4E2D, \5E76\663E\793A\7ED9\6BCF\4E2A\4EBA\3002'),
unistr('\201C\64CD\4F5C\201D\83DC\5355\4E0A\7684\9009\9879\4EC5\9002\7528\4E8E\5DF2\9A8C\8BC1\7684\7528\6237, \5982\679C\60A8\8FD8\586B\5145<strong>\4FDD\5B58\516C\5171\62A5\8868\6388\6743</strong>, \5219\4F1A\52A0\4EE5\8FDB\4E00\6B65\9650\5236\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238398142312513)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\516C\5171\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238237237312513)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5C06\5176\5F53\524D\62A5\8868\5B9A\4E49\53E6\5B58\4E3A<em>\4E13\7528</em>\62A5\8868\3002</p>'),
unistr('<p>\4E13\7528\62A5\8868\663E\793A\5728\641C\7D22\680F\4E0A\7684\53EF\7528\62A5\8868\9009\62E9\5217\8868\4E2D, \5E76\4E14\53EA\663E\793A\7ED9\4FDD\5B58\4E86\62A5\8868\7684\7528\6237, \5047\8BBE\8FD9\4E9B\7528\6237\7ECF\8FC7\9A8C\8BC1\3002'),
unistr('\201C\64CD\4F5C\201D\83DC\5355\4E0A\7684\9009\9879\4EC5\9002\7528\4E8E\5DF2\9A8C\8BC1\7684\7528\6237\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238186514312513)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238691198312513)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4FDD\5B58\62A5\8868\7C7B\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238597899312513)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\62A5\8868\7C7B\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223782546312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\6392\5E8F\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223681788312501)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125315832312423)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\5728\5BF9\8BDD\6846\548C\5355\884C\89C6\56FE\4E2D\4F7F\7528\7684\66FF\4EE3\6807\7B7E\3002'),
unistr('        \5F53\6807\9898\5305\542B\65E0\6CD5\6B63\786E\663E\793A\7684\989D\5916\683C\5F0F (\4F8B\5982 HTML \6807\8BB0) \65F6, \4F7F\7528\66FF\4EE3\6807\7B7E\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125205045312423)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002125803312327)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\59CB\7EC8\6267\884C\6B64\9A8C\8BC1\3002'),
unistr('\5982\679C\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF0C\5219\5C06\59CB\7EC8\5BF9\6B64\9A8C\8BC1\8FDB\884C\6C42\503C\FF0C\800C\4E0D\8003\8651\9488\5BF9\63D0\4EA4\9875\7684\6309\94AE\5B9A\4E49\7684<em>\6267\884C\9A8C\8BC1</em>\8BBE\7F6E\3002'),
unistr('\5982\679C\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\FF0C\5219\4EC5\5F53\89E6\53D1\6309\94AE\7684<em>\6267\884C\9A8C\8BC1</em>\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\624D\5BF9\6B64\9A8C\8BC1\8FDB\884C\6C42\503C\3002</p>'),
unistr('<p>\6CE8\FF1A\5728\6C42\503C\4E4B\524D\FF0C\6B64\9A8C\8BC1\8FD8\5FC5\987B\7B26\5408\6307\5B9A\7684\6761\4EF6\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002091868312327)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168231289312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\662F\5426\5728\56FE\8868\4E0A\7684\6570\636E\66F4\6539\65F6\663E\793A\52A8\753B\3002\5982\679C\56FE\8868\81EA\52A8\5237\65B0, \5355\51FB\56FE\4F8B\9879\65F6\6267\884C\9690\85CF\548C\663E\793A\884C\4E3A, \6216\901A\8FC7\4E00\4E9B\5B9A\5236 JavaScript \4EE3\7801\6216\52A8\6001\64CD\4F5C\4EE5\7F16\7A0B\65B9\5F0F\66F4\65B0\56FE\8868\6570\636E, \5219\4F1A\53D1\751F\6570\636E\66F4\6539\3002</p>'),
unistr('        <p>\9009\9879<strong>\5411\5DE6\6ED1\52A8</strong>\548C<strong>\5411\53F3\6ED1\52A8</strong>\4E0D\5E94\7528\4E8E\4EEA\8868\76D8\56FE\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168381343312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298807203312564)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\56FE\8868\5E94\7528 Oracle JET \5B9A\4E49\7684\9ED8\8BA4\52A8\753B\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168689480312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308338553312572)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\66F4\6539\65F6\4E0D\5411\56FE\8868\5E94\7528\52A8\753B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168487122312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5DE6\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308181826312571)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\66F4\6539\65F6\6570\636E\5143\7D20\6ED1\5411\5DE6\4FA7\3002\6B64\8BBE\7F6E\4E0D\9002\7528\4E8E\7518\7279\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168528219312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\53F3\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308226465312571)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\66F4\6539\65F6\6570\636E\5143\7D20\6ED1\5411\53F3\4FA7\3002\6B64\8BBE\7F6E\4E0D\9002\7528\4E8E\7518\7279\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168102961312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\66F4\6539\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167679909312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6700\521D\663E\793A\56FE\8868\65F6\4F7F\7528\7684\52A8\753B\7C7B\578B\3002</p>'),
unistr('        <p>\9009\9879<strong>\6DE1\51FA</strong>\548C<strong>\7F29\653E</strong>\4E0D\5E94\7528\4E8E\4EEA\8868\76D8\56FE\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167807476312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DE1\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298518700312563)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\521D\663E\793A\65F6\6DE1\5165\56FE\8868\3002\6B64\8BBE\7F6E\4E0D\9002\7528\4E8E\7518\7279\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167768001312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298422566312563)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\56FE\8868\5E94\7528 Oracle JET \5B9A\4E49\7684\9ED8\8BA4\52A8\753B\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168081715312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298754027312563)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\521D\663E\793A\65F6\4E0D\5411\56FE\8868\5E94\7528\52A8\753B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167904105312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298667167312563)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\521D\663E\793A\65F6\653E\5927\56FE\8868\3002\6B64\8BBE\7F6E\4E0D\9002\7528\4E8E\7518\7279\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167597924312457)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580121188312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603281503312806)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580986328312789)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\62A5\8868\4E2D\7684\9644\52A0 CSS \7C7B, \4EE5\7A7A\683C\5206\9694\3002\62A5\8868\6A21\677F\5FC5\987B\5305\542B <code>#COMPONENT_CSS_CLASSES#</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134876277312431)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
'',
unistr('        <p>\6CE8\FF1A\8FD9\4E9B CSS \7C7B\5C06\5E94\7528\4E8E\4EA4\4E92\5F0F\7F51\683C\4E2D\7684\5355\5143\3002\8981\5C06 CSS \7C7B\5E94\7528\4E8E\76F8\5E94\9879\FF0C\8BF7\53C2\89C1\9AD8\7EA7\7EC4\4E0B\65B9\7684\201CCSS \7C7B\201D\5C5E\6027\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579863474312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579956445312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\6B64\9879\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B, \5E76\4F7F\7528\7A7A\683C\5206\9694\3002<p/>'),
unistr('        <p>\6B64\5C5E\6027\53EF\7528\4E8E\5728\6A21\677F\9009\9879\4E4B\5916\5BF9\9879\8FDB\884C\6837\5F0F\4FEE\6539, \6216\8005\63D0\4F9B\66F4\7B80\5355\7684\65B9\6CD5\4EE5\901A\8FC7 JavaScript \9009\62E9\6B64\9879\3002</p>'),
unistr('        <p>\6CE8: \8981\5C06 CSS \7C7B\5E94\7528\5230 HTML \8868\5355\5143\7D20\6807\8BB0, \8BF7\53C2\9605\201C\9AD8\7EA7\201D\7EC4\4E0B\7684\201CCSS \7C7B\201D\5C5E\6027\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580266611312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581176495312789)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581026766312789)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\62A5\8868\4E2D\7684\9644\52A0 CSS \7C7B, \4EE5\7A7A\683C\5206\9694\3002\62A5\8868\6A21\677F\5FC5\987B\5305\542B <code>#COMPONENT_CSS_CLASSES#</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579796498312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06 CSS \7C7B <code>articlenumber</code> \548C <code>highlight</code> \6DFB\52A0\5230\7EC4\4EF6</dt>'),
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579666160312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579551900312788)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538887746311968)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\5E94\7528\7A0B\5E8F\9879\7684\8303\56F4\3002\5982\679C\6709\591A\4E2A\5E94\7528\7A0B\5E8F\5171\4EAB &PRODUCT_NAME. \4F1A\8BDD, \5E76\4E14\9879\503C\5BF9\4E8E\6240\6709\5E94\7528\7A0B\5E8F\5E94\76F8\540C, \8BF7\9009\62E9<strong>\5168\5C40</strong>\3002'),
unistr('\5426\5219\9009\62E9<strong>\5E94\7528\7A0B\5E8F</strong> (\8FD9\662F\9ED8\8BA4\8303\56F4)\3002</p>'),
unistr('<p>\5982\679C\5E94\7528\7A0B\5E8F\9A8C\8BC1\6709\76F8\540C\7684<em>\4F1A\8BDD Cookie \5C5E\6027</em>, \90A3\4E48\5E94\7528\7A0B\5E8F\53EF\4EE5\5171\4EAB\76F8\540C\7684\4F1A\8BDD\3002'),
unistr('\5E94\7528\7A0B\5E8F\9879\7684\8303\56F4\5C5E\6027\5728\8FD9\4E9B\5E94\7528\7A0B\5E8F\4E2D\4E5F\5FC5\987B\76F8\540C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434012393312674)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434195828312674)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538722053311967)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184823405312470)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5C06\5F53\524D\7CFB\5217\5206\914D\7ED9\56FE\8868\4E0A\5448\73B0\7684 Y2 \8F74\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184772107312470)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\914D\7ED9 Y2 \8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002708956312327)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\6B64\9875\5904\7406\7EC4\4EF6\5173\8054\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002669649312327)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\8054\7684\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002587376312327)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5728\5176\4E2D\663E\793A\6B64\9A8C\8BC1\9519\8BEF\6D88\606F\7684\9879\3002'),
unistr('\5982\679C\9009\62E9\9879\5E76\4E14<em>\9519\8BEF\6D88\606F\7684\663E\793A\4F4D\7F6E</em>\5305\62EC "\4E0E\5B57\6BB5\4E00\8D77\5185\5D4C", \5219\9519\8BEF\6D88\606F\5C06\663E\793A\5728\6307\5B9A\9879\7684\6807\7B7E\4E0B\65B9\3002'),
unistr('\5982\679C<em>\9519\8BEF\6D88\606F\7684\663E\793A\4F4D\7F6E</em>\4E0D\5305\62EC "\4E0E\5B57\6BB5\4E00\8D77\5185\5D4C", \5219\6B64\5C5E\6027\5BF9\9519\8BEF\6D88\606F\7684\663E\793A\6CA1\6709\5F71\54CD\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002402323312327)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F8\5173\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606234079312809)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984574751312310)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930154349312269)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5E94\7528\4E8E\8BE5\9875\7684\6388\6743\65B9\6848\3002\6388\6743\65B9\6848\662F\5728\5E94\7528\7A0B\5E8F\7EA7\5B9A\4E49\7684, \53EF\4EE5\5E94\7528\4E8E\5E94\7528\7A0B\5E8F\4E2D\7684\591A\4E2A\5143\7D20\3002</p>'),
unistr('<p>\53EF\4EE5\9488\5BF9\6BCF\4E2A\5E94\7528\7A0B\5E8F\4F1A\8BDD (\5728\521B\5EFA\4F1A\8BDD\65F6) \5BF9\6388\6743\65B9\6848\6C42\503C\4E00\6B21, \4E5F\53EF\4EE5\9488\5BF9\6BCF\6B21\9875\8BBF\95EE\5BF9\6388\6743\65B9\6848\6C42\503C\4E00\6B21\3002\5982\679C\6240\9009\6388\6743\65B9\6848\7684\8BA1\7B97\7ED3\679C\4E3A<strong>\771F</strong>, \5219\5C06\663E\793A\8BE5\9875\5E76\4E14\8BE5\9875\7B26\5408\5176\4ED6\5DF2\5B9A\4E49\7684\6761\4EF6\3002\5982\679C\8BA1\7B97\7ED3\679C\4E3A<strong>\5047</strong>, \5219\4E0D\663E\793A\8BE5\9875\800C\663E\793A\9519\8BEF\6D88\606F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899872222312246)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\63A7\5236\6B64\7EC4\4EF6\7684\6388\6743\65B9\6848\3002\4E3A\4E86\5448\73B0\6216\6267\884C\6B64\7EC4\4EF6, \6B64\6388\6743\7684\6C42\503C\5FC5\987B\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899723225312246)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890789837312239)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5E94\7528\7684\6388\6743\65B9\6848\3002\652F\6301\4EE5\4E0B\6388\6743\7C7B\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\636E\5E94\7528\7A0B\5E8F\914D\7F6E, \6B64\5904\53EF\80FD\6709\5176\4ED6\6388\6743\7C7B\578B\7684\63D2\4EF6\53EF\7528\3002'),
unistr('\8FD9\4E9B\63D2\4EF6\663E\793A\4E3A <em>&lt;\6211\7684\63D2\4EF6&gt; [\63D2\4EF6]</em>\3002'),
unistr('\5728\6B64\5E94\7528\7A0B\5E8F\7684\5171\4EAB\7EC4\4EF6\5185\5B89\88C5\4EE5\4E0B\63D2\4EF6:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890626504312239)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742690642312914)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742979854312914)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742882995312914)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742762654312914)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743087900312914)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742524212312914)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743856134312915)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\6267\884C\81EA\52A8\5316\8FC7\7A0B\4E2D\8FDB\884C\6C42\503C\7684\6570\636E\6E90\3002\81EA\52A8\5316\53EF\57FA\4E8E\8868\3001SQL \67E5\8BE2\6216\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743768354312915)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743662328312915)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743542776312914)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\6267\884C\81EA\52A8\5316\8FC7\7A0B\4E2D\8FDB\884C\6C42\503C\7684\6570\636E\6E90\3002\81EA\52A8\5316\53EF\57FA\4E8E\8868\3001SQL \67E5\8BE2\6216\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743446080312914)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743373003312914)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743215336312914)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\6267\884C\81EA\52A8\5316\8FC7\7A0B\4E2D\8FDB\884C\6C42\503C\7684\6570\636E\6E90\3002\81EA\52A8\5316\53EF\57FA\4E8E\8868\3001SQL \67E5\8BE2\6216\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743138455312914)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744089490312915)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\6267\884C\81EA\52A8\5316\8FC7\7A0B\4E2D\8FDB\884C\6C42\503C\7684\6570\636E\6E90\3002\81EA\52A8\5316\53EF\57FA\4E8E\8868\3001SQL \67E5\8BE2\6216\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108743961284312915)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742144451312913)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742073247312913)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741948436312913)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\6267\884C\81EA\52A8\5316\8FC7\7A0B\4E2D\8FDB\884C\6C42\503C\7684\6570\636E\6E90\3002\81EA\52A8\5316\53EF\57FA\4E8E\8868\3001SQL \67E5\8BE2\6216\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741879997312913)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742479898312914)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742383991312914)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\64CD\4F5C\7684\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108742259376312913)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041166784312356)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\81EA\52A8\68C0\6D4B\9002\5408\7684\7528\6237\754C\9762\3002'),
unistr('\5982\679C\81EA\52A8\68C0\6D4B\4E3A<strong>\542F\7528</strong>\FF0C\5219\4F1A\6839\636E\6B63\5728\4F7F\7528\7684\8BBE\5907\5927\5C0F\81EA\52A8\5C06\7528\6237\91CD\5B9A\5411\5230\6700\9002\5408\7684\767B\5F55\9875\6216\4E3B\9875\3002'),
unistr('\4F7F\7528\4ECB\8D28\67E5\8BE2\6765\786E\5B9A\8981\663E\793A\7684\76F8\5E94\7528\6237\754C\9762\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041008919312356)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\68C0\6D4B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186830299312472)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8F74\7684\6700\5927\503C\3002\82E5\57FA\4E8E\6570\636E\81EA\52A8\8BA1\7B97, \5219\9ED8\8BA4\4E3A\7A7A\503C\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186771867312472)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186638500312472)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8F74\7684\6700\5C0F\503C\3002\82E5\57FA\4E8E\6570\636E\81EA\52A8\8BA1\7B97, \5219\9ED8\8BA4\4E3A\7A7A\503C\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186544284312472)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187631642312473)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\56FE\8868\4E0A\5448\73B0\7684\6807\7B7E\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187728148312473)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188124508312473)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187985955312473)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187888883312473)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188079227312473)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187563334312472)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210081773312491)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8F74\6807\5EA6\3002\4EC5\9002\7528\4E8E\6570\5B57\8F74\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210156425312491)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\6027')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210215800312491)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209990570312490)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187479860312472)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3B\523B\5EA6\7EBF\4E4B\95F4\7684\589E\91CF\3002\82E5\57FA\4E8E\6570\636E\81EA\52A8\8BA1\7B97, \5219\9ED8\8BA4\4E3A\7A7A\503C\3002\4EC5\9002\7528\4E8E\65F6\95F4\548C\6570\5B57\8F74\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187340044312472)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\8FDB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594353209312799)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\5FBD\7AE0\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594210467312799)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FBD\7AE0\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594521083312799)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594479523312799)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FBD\7AE0 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594844874312800)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\663E\793A\7535\5F71\8BC4\7EA7</dt>'),
unistr('    <dd>\5FBD\7AE0\5217\53EF\4EE5\662F\8BC4\7EA7\5217\FF0C\5FBD\7AE0\6807\7B7E\53EF\4EE5\662F\201C\661F\7EA7\201D</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594722860312799)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\63CF\8FF0\5FBD\7AE0\503C\7684\5FBD\7AE0\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594683616312799)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FBD\7AE0\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289895572312557)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\65E5\5386\5F00\59CB\65F6\95F4\3002\9009\62E9\6B64\9009\9879\5C06\521B\5EFA\4E00\4E2A\8DE8\8D8A\6574\4E2A\65F6\95F4\95F4\9694\FF08\4F8B\5982\4E00\4E2A\6708\FF09\7684\65E5\5386\3002</p>'),
'<ul>',
unistr('  <li>\5982\679C\201C\4ECE\65F6\95F4\95F4\9694\5F00\59CB\65F6\7B97\8D77\201D\4E3A<strong>\542F\7528</strong>\FF0C\65E5\671F\4E3A 6 \6708 15 \65E5\FF0C\663E\793A\4E00\4E2A\6708\7684\65E5\671F\FF0C\5219\6240\5F97\65E5\5386\5C06\4ECE 6 \6708 1 \65E5\81F3 6 \6708 30 \65E5\3002</li>'),
unistr('  <li>\5982\679C\201C\4ECE\65F6\95F4\95F4\9694\5F00\59CB\65F6\7B97\8D77\201D\4E3A<strong>\7981\7528</strong>\FF0C\65E5\671F\4E3A 6 \6708 15 \65E5\FF0C\663E\793A\4E00\4E2A\6708\7684\65E5\671F\FF0C\5219\6240\5F97\65E5\5386\4ECE 6 \6708 15 \65E5\81F3 6 \6708 30 \65E5\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289759479312556)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\65F6\95F4\95F4\9694\5F00\59CB\65F6\7B97\8D77')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261129169312532)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\4E2D\9009\62E9\5B57\7B26\96C6\5217\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261067743312532)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\7B26\96C6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260162630312531)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\4E2D\9009\62E9 BLOB \5217\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260089399312531)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260904256312532)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\4E2D\8F93\5165\6587\4EF6\540D\5217\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260843436312532)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261302288312532)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\4E2D\9009\62E9\4E0A\6B21\66F4\65B0\7684\5217\3002\5982\679C\60A8\5DF2\5177\6709\5173\8054\89E6\53D1\5668\7684 <code>UPDATED</code> \5217\6765\7EF4\62A4\65E5\671F, \5219\53EF\4EE5\4F7F\7528\6B64\5217, \800C\4E0D\7528\4E13\95E8\4E3A\56FE\50CF\7684\4E0A\6B21\66F4\65B0\65F6\95F4\5B9A\4E49\4E00\65B0\5217\3002\4F46\662F, \5982\679C\5B9A\671F\66F4\65B0 BLOB \5185\5BB9\4E4B\5916\7684\5217, \5219\56FE\50CF\9AD8\901F\7F13\5B58\4F1A\53D7\5230\8D1F\9762\5F71\54CD\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261240376312532)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\66F4\65B0\7684\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260752278312532)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\4E2D\9009\62E9 Mime \7C7B\578B\5217\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260698635312532)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Mime \7C7B\578B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260378953312532)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\4E2D\9009\62E9\7B2C\4E00\4E3B\952E\5217\3002\5982\679C\6B64\8868\7684\4E3B\952E\5177\6709\4E24\4E2A\4EE5\4E0A\7684\5217, \5219\5FC5\987B\9009\62E9 <code>ROWID</code> \5217\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260284045312532)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260578464312532)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5F53\8868\7684\4E3B\952E\5177\6709\4E24\5217\65F6\624D\9009\62E9\7B2C\4E8C\4E3B\952E\5217\3002\5982\679C\4E3A\7B2C\4E00\4E3B\952E\5217\9009\62E9 <code>ROWID</code>, \5219\4E0D\5E94\586B\5145\6B64\5217\3002\5982\679C\9009\62E9\5177\6709\9519\8BEF\6570\636E\7C7B\578B\7684\5217, \5219\56FE\50CF\5F88\53EF\80FD\4E0D\4F1A\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108260415552312532)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259935580312531)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9\7684\8868\540D\3002'),
unistr('\53EF\4EE5\952E\5165\8868\540D\6216\4ECE\53EF\7528\8868\5217\8868\4E2D\9009\53D6\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259874311312531)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259748336312531)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62E5\6709\8868 (\5B58\50A8\8981\663E\793A\7684 BLOB \5185\5BB9) \7684\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259669018312531)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589919436312796)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\7EC4\4EF6\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589851455312796)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590190547312796)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\6B63\6587\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590035737312796)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590639793312796)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590576382312796)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899438666312246)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\663E\793A\5728\8FD0\884C\4E2D\7684\9875\4E0A\5404\533A\57DF\4E4B\524D\7684\6587\672C\6216 HTML\3002'),
unistr('\5728\6B64\5904\8F93\5165\7684\6587\672C\663E\793A\5728\9875\6A21\677F <code>#BODY#</code> \66FF\6362\5B57\7B26\4E32\4E4B\524D\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899320132312246)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\9875\7709')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590442926312796)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590320097312796)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590218113312796)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281024932312549)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5305\62EC\5728\5206\652F\94FE\63A5\5185\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280962982312549)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679382739312865)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679690497312865)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679542496312865)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679412274312865)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679773024312865)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679294832312865)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254791089312527)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5305\542B\8981\91CD\5B9A\5411\5230\7684\9875\7801\6216 URL \7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\6B64\9879\53EF\901A\8FC7\8C03\7528\9875\6216\7B2C\4E00\6B21\52A0\8F7D\9875\65F6\7684\5904\7406\8FDB\884C\8BBE\7F6E\3002'),
unistr('\901A\8FC7\6307\5B9A\9879\63D0\4F9B\4E00\79CD\52A8\6001\5730\4E3A\4ECE\8BB8\591A\5176\4ED6\9875\8C03\7528\7684\9875\8BBE\7F6E\5206\652F\7684\7B80\4FBF\65B9\6CD5\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254601633312527)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680596614312866)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\8981\91CD\5B9A\5411\5230\7684\9875\7801\6216 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680434915312866)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680324093312865)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680236003312865)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\8981\91CD\5B9A\5411\5230\7684\9875\7801\6216 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680190863312865)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001008777312326)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\5206\652F\5C06\91CD\5B9A\5411\5230\7684\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000980387312326)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001282771312326)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7531\5206\652F\6267\884C\7684 PL/SQL \4EE3\7801\3002\6B64 PL/SQL \8FC7\7A0B\8D1F\8D23\8C03\7528\6240\9700\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001144817312326)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680059023312865)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679939798312865)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\8981\91CD\5B9A\5411\5230\7684\9875\7801\6216 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679861240312865)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000630823312326)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\9875\5448\73B0\6216\5904\7406\4E2D\7684\54EA\4E2A\70B9\6267\884C\6B64\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422506072312665)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712176798312890)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\6267\884C\5904\7406\4E4B\540E\8FDB\884C\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422257306312664)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711834149312890)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\63D0\4EA4\9875\4E4B\540E\5E76\5728\6267\884C\8BA1\7B97\3001\9A8C\8BC1\548C\5904\7406\4E4B\524D\8FDB\884C\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422670037312665)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712281267312890)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\5448\73B0\4E4B\524D\8FDB\884C\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422407908312665)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712010068312890)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\6267\884C\5904\7406\4E4B\524D\8FDB\884C\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422342632312665)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711915853312890)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\6267\884C\9A8C\8BC1\4E4B\524D\8FDB\884C\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000581007312326)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680706060312866)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\8981\91CD\5B9A\5411\5230\7684\9875\7801\6216 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680647368312866)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000402200312326)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\8981\6267\884C\7684\9875\5206\652F\7C7B\578B\3002</p>'),
'<dl>',
unistr('<dt>\91CD\5B9A\5411\5206\652F</dt>'),
unistr('<dd>&PRODUCT_NAME. \5C06\65B0\9875\6216 URL \8FD4\56DE\5230\6D4F\89C8\5668, \8FD9\5C06\5728\663E\793A\751F\6210\7684\9875\4E4B\524D\6267\884C\65B0\8BF7\6C42\3002'),
unistr('\4E3B\8981\4F18\70B9\662F, \6700\7EC8\7528\6237\53EF\4EE5\5237\65B0\9875\800C\4E0D\4F1A\4E22\5931\4E0A\4E0B\6587, \56E0\4E3A\6D4F\89C8\5668\5730\5740\5305\542B\5B8C\6574\9875 URL\3002'),
unistr('\7F3A\70B9\662F, \6D4F\89C8\5668\6267\884C\9644\52A0\8BF7\6C42\6765\663E\793A\9875\3002</dd>'),
unistr('<dt>\4EC5\663E\793A\5206\652F</dt>'),
unistr('<dd>&PRODUCT_NAME. \7ACB\5373\4F5C\4E3A\5F53\524D\9875\5904\7406\7684\4E00\90E8\5206\5448\73B0\65B0\9875, \800C\4E0D\6267\884C\53E6\4E00\8BF7\6C42\3002'),
unistr('\8FD9\5177\6709\6D4F\89C8\5668\4E0D\5FC5\6267\884C\9644\52A0\8BF7\6C42\7684\4F18\70B9\3002'),
unistr('\4E3B\8981\7F3A\70B9\662F, \6D4F\89C8\5668\5730\5740\5C06\662F <code>wwv_flow.accept</code>\3002'),
unistr('\5982\679C\6700\7EC8\7528\6237\5237\65B0\9875, \6D4F\89C8\5668\5C06\8981\6C42\91CD\65B0\53D1\9001\6570\636E, \56E0\4E3A\6D4F\89C8\5668\5730\5740\4E0D\662F\5B8C\6574\9875 URL\3002</dd>'),
'</dl>',
unistr('<p>Oracle \5EFA\8BAE\60A8\9009\62E9\4E00\79CD\91CD\5B9A\5411\5206\652F\7C7B\578B\4EE5\63D0\4F9B\66F4\597D\7684\6700\7EC8\7528\6237\4F53\9A8C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421675057312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9875\7684\51FD\6570 (\4EC5\663E\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421755966312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE URL \7684\51FD\6570 (\91CD\5B9A\5411)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422138184312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5904\7406 {\4E0D\5E38\7528}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421955806312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\9879\6807\8BC6\7684\9875 (\4EC5\663E\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421591872312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 (\4EC5\663E\793A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422057780312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\9879\6807\8BC6\7684 URL (\91CD\5B9A\5411)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421819011312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8FC7\7A0B [\65E7]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421464674312664)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6216 URL (\91CD\5B9A\5411)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000301652312326)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538635895311967)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6B64\9762\5305\5C51\7684\9762\5305\5C51\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538592954311967)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266779311312537)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\663E\793A\4E2D\65AD\884C\65F6, \5C06\5728\4E2D\65AD\5217\4E4B\540E\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266653746312537)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266381988312537)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\663E\793A\4E2D\65AD\884C\65F6, \5C06\5728\4E2D\65AD\5217\4E4B\524D\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266257345312537)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277084477312546)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\4E2D\65AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278284049312547)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\4E2D\65AD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265545833312536)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5C06\591A\5C11\62A5\8868\5217\5E76\5165\4E2D\65AD\683C\5F0F\4E2D\3002\8FD9\4E9B\5217\5FC5\987B\662F\8FDE\7EED\5217, \4ECE\7B2C\4E00\5217\5F00\59CB\5728\62A5\8868\4E2D\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444574378312682)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444682992312682)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\5217\548C\7B2C\4E8C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444739429312682)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\5217, \7B2C\4E8C\5217\548C\7B2C\4E09\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265400409312536)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265782036312536)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E2D\65AD\5982\4F55\5F71\54CD\62A5\8868\7684\663E\793A\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445001443312683)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\4E2D\65AD\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445157255312683)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\65AD\663E\793A\5728\5355\4E2A\62A5\8868\4E2D, \5E76\4E14\4E0D\91CD\590D\6BCF\4E2A\4E2D\65AD\5904\7684\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444830728312682)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\4E2D\65AD\5904\7684\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444994468312683)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\663E\793A\4E3A\82E5\5E72\4E2A\5B50\62A5\8868, \5E76\4E14\91CD\590D\6BCF\4E2A\4E2D\65AD\5904\7684\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265651206312536)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266111638312537)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\62A5\8868\4E2D\65AD\5904\663E\793A\7684\6587\672C\3002\4F7F\7528 <code>#SUM_COLUMN_HEADER#</code> \66FF\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266036877312536)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\4E2D\65AD\683C\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266520832312537)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\663E\793A\62A5\8868\4E2D\65AD\65F6\4E2D\65AD\5217\7684\6587\672C\3002\53EF\4EE5\4F7F\7528 <code>#COLUMN_VALUE#</code> \66FF\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266414354312537)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E2D\65AD\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265970685312536)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\62A5\8868\4E2D\65AD\5904\663E\793A\7684\91CD\590D\6807\9898\7684\6587\672C\3002\53EF\4EE5\4F7F\7528 <code>#COLUMN_VALUE#</code> \66FF\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265880411312536)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\6807\9898\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276246637312545)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717395927312894)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5728\5E94\7528\7A0B\5E8F\5B89\5168\5C5E\6027\4E2D\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901490076312247)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\542F\7528\4E86\9AD8\901F\7F13\5B58, \5219\6D4F\89C8\5668\53EF\4EE5\5728\5185\5B58\548C\786C\76D8\7684\9AD8\901F\7F13\5B58\4E2D\4FDD\5B58\5E94\7528\7A0B\5E8F\9875\7684\5185\5BB9\3002'),
unistr('\5982\679C\7528\6237\5355\51FB\4E86\6D4F\89C8\5668\7684\201C\8FD4\56DE\201D\6309\94AE, \5219\901A\5E38\4F1A\4ECE\9AD8\901F\7F13\5B58\4E2D\52A0\8F7D\6B64\9875, \800C\4E0D\662F\4ECE\670D\52A1\5668\52A0\8F7D\3002'),
unistr('\5982\679C\7981\7528\9AD8\901F\7F13\5B58, \5219\5C06\6307\793A\6D4F\89C8\5668\4E0D\4FDD\5B58\9875\5185\5BB9, \5E76\5C06\4ECE\670D\52A1\5668\8BF7\6C42\65B0\9875\3002</p>'),
unistr('<p>\4ECE\5B89\5168\89D2\5EA6\800C\8A00, Oracle \5EFA\8BAE\7981\7528\9AD8\901F\7F13\5B58, \8FD9\6837\6D4F\89C8\5668\4FBF\4E0D\4F1A\5B58\50A8\654F\611F\6570\636E, \5E76\4E14\5728 URL \66F4\6539\65F6\5C06\59CB\7EC8\8BF7\6C42\9875\3002'),
unistr('\5426\5219, \751A\81F3\53EF\4EE5\5728\6CE8\9500\540E\8FD4\56DE\5230\6D4F\89C8\5668\5386\53F2\8BB0\5F55\4E2D\5E76\67E5\770B\5148\524D\4F1A\8BDD\7684\9AD8\901F\7F13\5B58\5185\5BB9\3002'),
unistr('\7981\7528\6D4F\89C8\5668\9AD8\901F\7F13\5B58\5C06\9632\6B62\4F7F\7528\90E8\5206\9875\5237\65B0\7684\9875 (\4F8B\5982\4EA4\4E92\5F0F\62A5\8868) \51FA\73B0\96BE\4EE5\9884\6599\7684\201C\8FD4\56DE\201D\6309\94AE\95EE\9898\3002</p>'),
unistr('<p>\5982\679C\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\7981\7528</strong>, \5219 &PRODUCT_NAME. \5C06\53D1\9001 HTTP \6807\5934 <em>cache-control: no-store</em>, \8FD9\4F1A\6307\793A\6D4F\89C8\5668\4E0D\5728\78C1\76D8\6216\5185\5B58\4E2D\9AD8\901F\7F13\5B58\9875\5185\5BB9\3002'),
unistr('\5982\679C\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\5E94\7528\7A0B\5E8F\9ED8\8BA4\503C</strong>, \5219\5C06\4ECE\5E94\7528\7A0B\5E8F\7684<em>\6D4F\89C8\5668\9AD8\901F\7F13\5B58</em>\5C5E\6027\4E2D\63D0\53D6\8FD0\884C\65F6\503C\3002</p>'),
unistr('<p>\6CE8: \6B64\529F\80FD\9700\8981\652F\6301 HTTP \6807\5934\54CD\5E94\53D8\91CF <code>cache-control</code> \7684\65B0\578B\6D4F\89C8\5668\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404631886312648)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404530734312648)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901363169312247)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8\5668\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786219947312954)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. \60A8\5728\5F00\53D1\6709\591A\79CD\5B89\88C5\7684\5E94\7528\7A0B\5E8F\3002'),
unistr('                                        \6B64\5916, \6BCF\79CD\5B89\88C5\53EF\4EE5\9009\62E9\542F\7528\6216\7981\7528\7279\5B9A\5E94\7528\7A0B\5E8F\529F\80FD\3002'),
unistr('                                        \4F7F\7528\6784\5EFA\9009\9879, \60A8\53EF\4EE5\5F00\53D1\4E00\4E2A\5E94\7528\7A0B\5E8F, \5728\5B89\88C5\65F6\53EF\914D\7F6E\6784\5EFA\9009\9879\6765\5305\62EC\6216\6392\9664\5173\8054\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002'),
unistr('                                        \4E5F\53EF\4EE5\4F7F\7528 API \6765\516C\5F00\5E94\7528\7A0B\5E8F\4E2D\7684\6B64\529F\80FD\3002'),
unistr('                                        \8FD9\4F7F\5F97\6388\6743\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\6027\5730\542F\7528\6216\7981\7528\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
unistr('                                      <p>2. \60A8\5728\5F00\53D1\5C1A\672A\5B8C\5584\7684\529F\80FD, \56E0\6B64\4E0D\5E0C\671B\5411\6700\7EC8\7528\6237\516C\5F00\3002'),
unistr('									    \4F7F\7528\6784\5EFA\9009\9879, \60A8\53EF\5728\5C06\5E94\7528\7A0B\5E8F\6784\5EFA\5230\6D4B\8BD5\548C\751F\4EA7\73AF\5883\4E2D\65F6, \5728\5E94\7528\7A0B\5E8F\4E2D\7981\7528\6B64\529F\80FD\3002'),
unistr('									    \6B64\65B9\6CD5\7684\4F18\70B9\5728\4E8E\4ECD\53EF\4EE5\90E8\7F72\5E94\7528\7A0B\5E8F\800C\4E0D\5305\542B\4E0D\5B8C\5584\7684\529F\80FD\3002</p>'),
unistr('                                      <p>3. \60A8\5728\5220\9664\81EA\5DF1\8BA4\4E3A\5E94\7528\7A0B\5E8F\4E0D\9700\8981\7684\529F\80FD, \4F46\4E0D\786E\5B9A\6B64\64CD\4F5C\662F\5426\5B89\5168\3002'),
unistr('									    \5728\8FD9\79CD\60C5\51B5\4E0B, \53EF\4EE5\4F7F\7528\6784\5EFA\9009\9879\6765\5B9E\9645 "\5C4F\853D\6389" \7279\5B9A\529F\80FD\3002'),
unistr('									    \5982\679C\5728\90E8\7F72\65F6\8BA4\4E3A\6240\79FB\9664\7684\529F\80FD\662F\5FC5\9700\7684, \5219\53EF\4EE5\6062\590D\8BE5\529F\80FD\3002'),
unistr('									    \5982\679C\8BA4\4E3A\4E0D\9700\8981\8BE5\529F\80FD, \5219\53EF\4EE5\5C06\5176\4ECE\5E94\7528\7A0B\5E8F\4E2D\5B89\5168\5220\9664\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901656835312247)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\6B64\7EC4\4EF6\9009\62E9\6784\5EFA\9009\9879\3002</p>'),
unistr('                                     <p>\4F7F\7528\6784\5EFA\9009\9879\53EF\5728\5B89\88C5\5E94\7528\7A0B\5E8F\65F6, \6216\5728\8FD0\884C\65F6\901A\8FC7 API (APEX_UTIL.SET_BUILD_OPTION_STATUS) \6709\6761\4EF6\5730\542F\7528\6216\7981\7528\5E94\7528\7A0B\5E8F\7EC4\4EF6\548C\529F\80FD\3002<br>'),
unistr('                                       \6784\5EFA\9009\9879\53EF\4EE5\5C06\6B64\7EC4\4EF6\8BBE\7F6E\4E3A\5728\8FD0\884C\65F6\5E94\7528\7A0B\5E8F\4E2D\5305\62EC\6216\6392\9664:</p>'),
unistr('                                     <p><strong>\5305\62EC</strong> - \542F\7528, \5E76\4E14\7528\4F5C\5E94\7528\7A0B\5E8F\7684\4E00\90E8\5206\3002</p>'),
unistr('									 <p><strong>\6392\9664</strong> - \7981\7528, \5E76\4E14\4E0D\7528\4F5C\5E94\7528\7A0B\5E8F\7684\4E00\90E8\5206\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901531024312247)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890109198312238)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\7EC4\4EF6\9009\62E9\6784\5EFA\9009\9879\72B6\6001\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398539913312643)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398621222312643)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&PRODUCT_NAME. \5F15\64CE\8BA4\4E3A\6B64\7EC4\4EF6\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398358269312643)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398409788312643)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&PRODUCT_NAME. \5F15\64CE\5728\8FD0\884C\65F6\5C06\6B64\7EC4\4EF6\89C6\4E3A\5E94\7528\7A0B\5E8F\5B9A\4E49\7684\4E00\90E8\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890054041312238)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003724999312328)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5355\51FB\6B64\6309\94AE\65F6\5C06\6267\884C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424366933312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\52A8\6001\64CD\4F5C\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424488566312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\63D0\4EA4\9875\6216\91CD\5B9A\5411\5230\5176\4ED6\9875\3002\800C\662F\7531\52A8\6001\64CD\4F5C\5B9A\4E49\6309\94AE\7684\884C\4E3A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424754187312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424851694312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\4E0B\4E00\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424982851312667)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425070156312667)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\4E0A\4E00\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423971878312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424091293312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875\FF0C\4F7F\7528\53EF\9009\7684\9644\52A0\5C5E\6027\5728\76EE\6807\9875\4E0A\91CD\7F6E\9875\7801\FF0C\8BBE\7F6E\8BF7\6C42\503C\FF0C\6E05\9664\9AD8\901F\7F13\5B58\548C\8BBE\7F6E\9879\503C\3002</p>'),
unistr('<p>\6CE8\FF1A\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875\4F9D\8D56\4E8E\76EE\6807\5E94\7528\7A0B\5E8F\4E2D\542F\7528\7684\6DF1\94FE\63A5\3002\8981\542F\7528\6DF1\94FE\63A5\FF0C\8BF7\8F6C\81F3\5E94\7528\7A0B\5E8F\7684<em>\5B89\5168\6027</em>\5C5E\6027\5E76\542F\7528<em>\6DF1\94FE\63A5</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423773014312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423825621312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\5F53\524D\5E94\7528\7A0B\5E8F\4E2D\7684\9875, \4F7F\7528\53EF\9009\7684\9644\52A0\5C5E\6027\5728\76EE\6807\9875\4E0A\91CD\7F6E\9875\7801, \8BBE\7F6E\8BF7\6C42\503C, \6E05\9664\9AD8\901F\7F13\5B58\548C\8BBE\7F6E\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424137305312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424256066312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\60A8\6307\5B9A\7684\76EE\6807 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424531899312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108424630555312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7\6267\884C\5B8C\6574\9875\5237\65B0\800C\975E\90E8\5206\9875\5237\65B0 (PPR) \6765\91CD\7F6E\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423562670312665)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423608337312666)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\7B49\4E8E\6309\94AE\540D\7684 REQUEST \503C\63D0\4EA4\5F53\524D\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003661779312328)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907031189312252)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5355\51FB\6B64\6309\94AE\540E\6267\884C\7684 SQL \64CD\4F5C\7C7B\578B\3002'),
unistr('\6B64\9009\62E9\7528\4E8E\89E6\53D1\5185\7F6E\81EA\52A8\884C\5904\7406 (DML) \4E2D\7684\6307\5B9A\6570\636E\5E93\64CD\4F5C\3002'),
unistr('\5982\679C\672A\9009\62E9\7C7B\578B, \5219\57FA\4E8E REQUEST \503C\6267\884C\6570\636E\5E93\5904\7406, \57FA\4E8E\4E3A\6B64\6309\94AE\5B9A\4E49\7684<strong>\6309\94AE\540D</strong>\8BBE\7F6E\6B64\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418506159312659)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL DELETE \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418334710312658)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL INSERT \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418490434312659)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL UPDATE \64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906934828312251)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601708317312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6309\94AE\663E\793A\7C7B\578B\53EF\5B9A\4E49\6B64\6309\94AE\7684\5916\89C2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602056595312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602132498312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\663E\793A\56FE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601835345312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601949342312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\663E\793A\6309\94AE\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602217900312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\56FE\6807\7684\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602309070312806)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6309\94AE\6807\7B7E\65C1\8FB9\663E\793A\56FE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601692542312805)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703582562312884)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\663E\793A\5355\9009\7EC4\6216\590D\9009\6846\96C6\4E2D\5404\4E2A\5355\72EC\9009\9879\7684 HTML \8868\5355\5143\4E4B\540E\663E\793A\7684\9644\52A0\5C5E\6027\3002'),
unistr('\53EF\4EE5\5305\542B HTML, Javascript \548C\5FEB\6377\65B9\5F0F\3002</p>'),
unistr('<p>\53EF\4EE5\5F15\7528\4E0B\5217\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\83B7\5F97\6B64\9875\9879\5173\8054\7684 HTML \8868\5355\5143\7D20\7684\540D\79F0\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\83B7\5F97\5F53\524D\9875\9879\7684\540D\79F0\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703446238312883)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540E\7F6E\6587\672C ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703350314312883)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\663E\793A\5355\9009\7EC4\6216\590D\9009\6846\96C6\4E2D\5404\4E2A\5355\72EC\9009\9879\7684 HTML \8868\5355\5143\4E4B\524D\663E\793A\7684\9644\52A0\5C5E\6027\3002'),
unistr('\53EF\4EE5\5305\542B HTML, Javascript \548C\5FEB\6377\65B9\5F0F\3002</p>'),
unistr('<p>\53EF\4EE5\5F15\7528\4E0B\5217\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\83B7\5F97\6B64\9875\9879\5173\8054\7684 HTML \8868\5355\5143\7D20\7684\540D\79F0\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\83B7\5F97\5F53\524D\9875\9879\7684\540D\79F0\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703289150312883)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\524D\7F6E\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906805241312251)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\63D0\4EA4\4E86\9875\5E76\4E14\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF0C\5219\5C06\5728\670D\52A1\5668\7AEF\6267\884C\4E3A\6B64\9875\5B9A\4E49\7684\6240\6709\9A8C\8BC1\4EE5\53CA\5185\7F6E\9A8C\8BC1\FF08\4F8B\5982\FF0C\5FC5\9700\3001\6709\6548\6570\5B57\6216\6709\6548\65E5\671F\FF09\3002'),
unistr('\6B64\5916\FF0C\5982\679C\5E94\7528\7A0B\5E8F\7684<em>\517C\5BB9\6A21\5F0F</em>\8BBE\7F6E\4E3A <strong>5.1</strong> \6216\66F4\9AD8\7248\672C, \5219 &PRODUCT_NAME. \8FD8\5C06\6267\884C\5BA2\6237\7AEF\9A8C\8BC1\FF0C\4F8B\5982\5FC5\9700\9879\3002\6709\5173\8FDB\4E00\6B65\8BE6\7EC6\4FE1\606F\FF0C\8BF7\53C2\89C1\53D1\884C\8BF4\660E\4E2D\7684\201C\517C\5BB9\6A21\5F0F\201D\3002'),
unistr('\5728\6240\6709\95EE\9898\5F97\5230\4FEE\590D\4E4B\524D\FF0C\4E0D\4F1A\63D0\4EA4\8BE5\9875\3002</p>'),
unistr('<p>\5982\679C\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\FF0C\5219\4E0D\6267\884C\4EFB\4F55\5B9A\4E49\7684\9A8C\8BC1\548C\5185\7F6E\9A8C\8BC1\3002'),
unistr('\5982\679C\5E0C\671B\6267\884C\7279\5B9A\9A8C\8BC1\800C\4E0D\8003\8651\6B64\8BBE\7F6E\FF0C\5219\4FEE\6539\9A8C\8BC1\5E76\5C06\9A8C\8BC1\5C5E\6027<strong>\59CB\7EC8\6267\884C</strong>\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\3002</p>'),
unistr('<p>\6B64\5C5E\6027\5BF9\4E8E\5927\591A\6570\9A8C\8BC1\5747\4E0D\5E94\6267\884C\7684\201C\5220\9664\201D\6216\201C\53D6\6D88\201D\7B49\6309\94AE\5C24\4E3A\6709\7528\3002'),
unistr('\5982\679C\9879\4E3A\7A7A\503C\6216\9879\7C7B\578B\9519\8BEF\FF0C\5219\901A\5E38\4E0D\5E94\963B\6B62\7528\6237\6267\884C\6B64\7C7B\64CD\4F5C\3002'),
unistr('\4F46\662F\FF0C\5982\679C\201C\5220\9664\201D\7B49\64CD\4F5C\53EA\5E94\7531\6388\6743\7684\7528\6237\6267\884C\FF0C\8BF7\52A1\5FC5\5C06\5BF9\5E94\7684\9A8C\8BC1\5C5E\6027<strong>\59CB\7EC8\6267\884C</strong>\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF0C\6216\786E\4FDD\6309\94AE\672C\8EAB\5B9A\4E49\4E86\9002\5F53\7684\6761\4EF6\FF0C\4EE5\4FBF\4EC5\5411\6388\6743\7684\7528\6237\663E\793A\6309\94AE\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906701121312251)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603178313312806)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\5448\73B0\6B64\6309\94AE\65F6\662F\4F7F\7528<strong>\6B63\5E38</strong>\8FD8\662F<strong>\70ED\95E8</strong>\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906484345312251)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\5448\73B0\6B64\6309\94AE\65F6\662F\4F7F\7528<strong>\6B63\5E38</strong>\8FD8\662F<strong>\70ED\95E8</strong>\6309\94AE\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906381295312251)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70ED\95E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602956962312806)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\663E\793A\5728\6309\94AE\4E0A\7684\6587\672C\3002\5982\679C\6309\94AE\663E\793A\7C7B\578B\4E3A\56FE\6807\FF0C\5219\6B64\6587\672C\5C06\53D8\4E3A\56FE\6807\56FE\50CF\7684\66FF\4EE3\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919742399312261)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6309\94AE\4E3A\6587\672C, \5219\8F93\5165\5C06\663E\793A\5728\6309\94AE\4E0A\7684\6587\672C\3002\5982\679C\6309\94AE\4E3A\56FE\50CF, \5219\6B64\6587\672C\5C06\53D8\4E3A\56FE\50CF\7684 ALT \6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919663641312261)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930628200312270)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\5F15\7528\5355\51FB\7684\6309\94AE\7684\540D\79F0\3002\63D0\4EA4\6B64\9875\65F6, REQUEST \7684\503C\5C06\8BBE\7F6E\4E3A\6B64\6309\94AE\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919537947312261)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\5728\540E\7EED\9875\5904\7406\5185\6807\8BC6\6B64\6309\94AE\7684\540D\79F0\3002'),
unistr('\901A\8FC7\6309\6B64\6309\94AE\63D0\4EA4\9875\65F6, REQUEST \503C\4F1A\8BBE\7F6E\4E3A\8F93\5165\7684\540D\79F0\3002</p>'),
unistr('<p>\5BF9\4E8E\540C\4E00\9875\4E0A\6216\540C\4E00\533A\57DF\4E2D\7684\6309\94AE, \6309\94AE\540D\4E0D\5FC5\552F\4E00\3002'),
unistr('\53EF\4EE5\4F7F\7528\540C\4E00\6309\94AE\540D\5B9A\4E49\591A\4E2A\6309\94AE, \8FD9\4F1A\5728\6309\4E0B\6309\94AE\65F6\8BBE\7F6E\76F8\540C\7684 REQUEST \503C\3002'),
unistr('\8FD9\5BF9\4E8E\4F7F\7528\4E0D\540C<strong>\6309\94AE\6807\7B7E</strong>\6216\6761\4EF6\5B9A\4E49\9700\8981\6267\884C\76F8\540C\9875\5904\7406\7684\6309\94AE\7684\60C5\51B5\975E\5E38\6709\7528, \8FD9\79CD\60C5\51B5\4E0B, \53EA\9700\5BF9\5E38\7528 REQUEST \503C\6C42\503C\5373\53EF\3002</p>'),
unistr('<p>\5982\679C\5C06\6309\94AE\547D\540D\4E3A <code>FLOW_RESET_BUTTON</code>, \5219\6B64\6309\94AE\5C06\91CD\7F6E\5F53\524D\9875\800C\4E0D\6267\884C\9875\63D0\4EA4\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919412693312261)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702943870312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\4E0B\6B64\6309\94AE\4E4B\540E\5C06\63D0\4EA4\6B64\9875, \5E76\5C06\9875\8BF7\6C42\8BBE\7F6E\4E3A\6B64\503C\3002\5982\679C\6B64\503C\4E3A\7A7A\503C\5E76\4E14<em>\8BF7\6C42\6E90\7C7B\578B</em>\4E3A<em>\9759\6001\503C</em>, \5219\5C06\6309\94AE\540D\7528\4F5C\8BF7\6C42\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702879482312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700837049312881)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\6807\8BC6\5305\542B\5728\8BF7\6C42\6E90\5C5E\6027\4E2D\7684\8868\8FBE\5F0F\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702602000312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702754689312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701108043312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701231618312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\6570\636E\5E93\5217</em>\4E2D\8F93\5165\7684\5217\503C, \6B64\503C\4ECE\5185\7F6E\63D0\53D6\884C\5904\7406\68C0\7D22\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702042921312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702145690312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6267\884C\8F93\5165\7684 <em>PL/SQL \8868\8FBE\5F0F</em>\6240\751F\6210\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702270541312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702397215312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>PL/SQL \51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701302094312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701517668312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702461920312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108702566320312883)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701626878312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5355\4E2A\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701788028312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\7B2C\4E00\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701883374312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5192\53F7\5206\9694\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701942189312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\5355\4E2A\5192\53F7\5206\9694\503C (\8FDE\63A5\6BCF\884C\503C)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700963860312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108701059726312882)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\5230<em>\9759\6001\503C</em>\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108700748262312881)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906664826312251)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\76EE\6807\201D\53EF\8C03\7528\6A21\5F0F\5BF9\8BDD\6846\3002\53EF\4EE5\8F93\5165\5728\5355\51FB\6B64\6309\94AE\65F6\8981\8C03\7528\7684\76EE\6807\3002\4EC5\4E3A\5355\51FB\65F6\4E0D\5E94\8C03\7528\9875\5904\7406\7684\6309\94AE\8F93\5165\76EE\6807 (\4F8B\5982\201C\53D6\6D88\201D\6309\94AE)\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906558105312251)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906265324312251)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6309\94AE\6A21\677F\53EF\5B9A\4E49\6B64\6309\94AE\7684\5916\89C2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906134816312251)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582492314312790)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9ED8\8BA4\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603567099312806)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5728\9875\7EA7\522B\542F\7528\4E86\6B64\68C0\67E5, \5219\5728\5355\51FB\6309\94AE\65F6\68C0\67E5\662F\5426\6709\672A\4FDD\5B58\7684\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582128236312790)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5F53\7528\6237\5C1D\8BD5\901A\8FC7\5355\51FB\6309\94AE\9000\51FA\5305\542B\672A\4FDD\5B58\66F4\6539\7684\9875\65F6, \662F\5426\5411\7528\6237\53D1\51FA\8B66\544A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582246279312790)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584842472312792)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\6309\94AE\65F6, \5C06\4E0D\6267\884C\672A\4FDD\5B58\66F4\6539\68C0\67E5\3002\6B64\8BBE\7F6E\5E94\8BE5\7528\4E8E\201C\53D6\6D88\201D,\201C\5220\9664\201D\548C\201C\5E94\7528\66F4\6539\201D\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582053602312790)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\672A\4FDD\5B58\66F4\6539\65F6\53D1\51FA\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632710859312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633121085312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633078315312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632904672312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633211122312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632845708312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632654949312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634738931312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635062417312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634911437312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634818615312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635188140312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634686753312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908289051312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908146878312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909623885312254)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909562567312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634336283312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Java \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634200914312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635917697312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Java \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635853879312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634174779312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634048292312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 JavaScript \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633904367312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635779749312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635643236312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 JavaScript \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635596485312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908428849312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\5192\53F7 (:) \5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908332453312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908849388312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908721875312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909035930312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\9875\7801\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908961489312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633882899312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633750149312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 PL/SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633686685312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635471832312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635394787312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108635252207312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908677144312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4E0E\6307\5B9A\503C\8FDB\884C\6BD4\8F83\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908574274312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634597159312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Python \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108634404017312830)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636106196312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Python \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636047695312831)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633546664312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633427533312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108633370990312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786774101312955)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 30 \65F6, \8981\5728\6709\4E00\884C\6216\591A\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 40 \65F6, \8981\5728\6CA1\6709\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907875762312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907778508312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909241298312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909124851312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909899380312254)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909781677312254)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990257255312315)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\9AD8\901F\7F13\5B58\533A\57DF\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907664949312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6761\4EF6\3002\5982\679C\6761\4EF6\8FD4\56DE<strong>\771F</strong>, \5219\4ECE\9AD8\901F\7F13\5B58\4E2D\663E\793A\9875\3002\5982\679C\6761\4EF6\8FD4\56DE<strong>\5047</strong>, \5219\52A8\6001\5448\73B0\9875, \4E0D\4ECE\9AD8\901F\7F13\5B58\68C0\7D22\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472914533312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614489672312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\59CB\7EC8\5448\73B0\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471567572312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Microsoft Internet Explorer 7.0 \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471667560312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\652F\6301 XHTML/CSS \7684\6D4F\89C8\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471431108312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Mozilla, Netscape 6.x/7x \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471774368312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\5176\4ED6\6D4F\89C8\5668 (\6216\8F83\4F4E\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470127631312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\9879\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472149177312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618049722312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471846653312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618275214312818)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472088646312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618126391312818)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471954448312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618391960312818)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469311107312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616808115312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469539356312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617072339312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469404459312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616936988312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469618815312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617170127312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472287378312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472310478312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471004862312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617829262312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875\540E, \5728\9875\4E0A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470440226312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470253432312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470314734312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470555655312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467049032312700)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614579141312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632441931312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632593881312829)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467214771312700)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614725882312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\8FD4\56DE\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472655268312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472729270312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470701040312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E0D\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617581748312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38\663E\793A\9875\548C\7236\533A\57DF (\5982\679C\9002\7528)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470632213312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617434939312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6216\7236\533A\57DF (\5982\679C\9002\7528) \7684 ''\53EA\8BFB'' \6761\4EF6\7684\503C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468551461312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616068507312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5305\542B\7A7A\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468825013312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616381147312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\662F\4EC5\5305\542B\5B57\6BCD\6216\6570\5B57\4E14\4E0D\5305\542B\7279\6B8A\5B57\7B26\7684\5B57\6BCD\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468043390312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615597926312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468718427312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616244314312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468281866312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\96F6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615716701312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467955862312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615461562312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468397359312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615820317312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\6216\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468608840312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616196119312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468158386312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615671634312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468446752312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C\4E14\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615940981312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\4E14\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471219627312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\8BA4\201D\4EE5\663E\793A\201C\5411\524D\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471364739312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\5B9A\201D\4EE5\663E\793A\201C\5411\540E\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472834114312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108471192932312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617984902312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0A\672A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467101343312700)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614643165312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469954393312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617279444312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470057688312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617395629312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5C1A\672A\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467312729312700)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614850329312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467578437312700)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615096140312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467449382312700)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614907291312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467689742312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615146909312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472444635312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108472561213312704)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470868880312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\9A8C\8BC1 (\4E0D\662F\516C\5171\7528\6237)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617677086312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108470917169312703)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\662F\516C\5171\7528\6237 (\7528\6237\672A\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108617753736312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\672A\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469166497312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616679416312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469238008312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616773031312817)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108468986359312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616405303312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469007887312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108616579730312816)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467743734312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615292528312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108467830016312701)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108615356499312815)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469869858312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108469703038312702)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907582424312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107908043978312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E0E\6761\4EF6\8FDB\884C\6BD4\8F83\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907905436312252)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909490012312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909381005312253)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727359348312902)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9AD8\901F\7F13\5B58\5185\5BB9\6240\4F9D\8D56\9879\7684\9017\53F7\5206\9694\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727276335312902)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F9D\8D56\4E8E\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721371945312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9 &PRODUCT_NAME. \5F15\64CE\5982\4F55\5728\670D\52A1\5668\7AEF\9AD8\901F\7F13\5B58 HTML \6587\672C\3002\5982\679C\53EF\4EE5\4F7F\7528\9AD8\901F\7F13\5B58, \5219\4F1A\53D1\51FA\9AD8\901F\7F13\5B58\7684\7ED3\679C\800C\4E0D\662F\91CD\65B0\8BA1\7B97\3002\8FD9\5C06\524A\51CF\670D\52A1\5668\4E0A\5F00\9500\5F88\5927\7684\8BA1\7B97\65F6\95F4\3002\6B64\529F\80FD\4E0E\6D4F\89C8\5668\7684\9AD8\901F\7F13\5B58\529F\80FD\65E0\5173\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721664463312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721792602312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\7531\6240\6709\7528\6237\9AD8\901F\7F13\5B58\548C\5229\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721429125312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721562552312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6BCF\4E2A\8BF7\6C42\9AD8\901F\7F13\5B58\548C\8BA1\7B97\5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722045710312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\4F1A\8BDD\7EDF\8BA1\7684\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722153714312898)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6BCF\4E2A\4F1A\8BDD\5206\522B\9AD8\901F\7F13\5B58\5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721804976312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\7528\6237\7EDF\8BA1\7684\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721948709312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6BCF\4E2A\7528\6237\5206\522B\9AD8\901F\7F13\5B58\5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108721210338312897)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901203622312247)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9AD8\901F\7F13\5B58\9875\7684\6709\6548\65F6\95F4\3002\5982\679C\8D85\65F6\5DF2\8FC7, \5219\540E\7EED\9875\8BF7\6C42\5C06\4E0D\5229\7528\9AD8\901F\7F13\5B58\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402687855312646)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('10 \79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403266049312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404133485312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403313441312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('4 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403735470312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402921588312646)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('30 \5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403447730312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('6 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404288352312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('4 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403828709312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404461726312648)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403939965312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('4 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403076052312646)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403536994312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('12 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402721745312646)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402897090312646)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('10 \5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404046823312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404318845312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('10 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403100667312646)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108403668184312647)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901112611312247)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\901F\7F13\5B58\8D85\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448228480312685)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\5217\503C</dt>'),
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
unistr('<dt>\5728\65E5\5386\4E8B\4EF6\4E2D\663E\793A\56FE\50CF\3002</dt>'),
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294406776312560)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\663E\793A\5728\65E5\5386\5355\5143\4E2D\7684\5B9A\5236\6587\672C\3002\53EF\4EE5\8F93\5165 HTML \8868\8FBE\5F0F\5E76\4F7F\7528 <code>#COLUMN_NAME#</code> \8BED\6CD5\663E\793A\5217\503C\3002\6B64\663E\793A\7C7B\578B\4F7F\60A8\53EF\4EE5\5728\663E\793A\4E2D\8F93\5165\591A\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294379994312560)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\663E\793A\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288649018312556)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5B58\653E\5F53\524D\663E\793A\7ED9\6700\7EC8\7528\6237\7684\65E5\5386\5F00\59CB\65E5\671F\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\5F53\6700\7EC8\7528\6237\9009\62E9\5BFC\822A\5230\4E0A\4E00\65F6\6BB5\6216\4E0B\4E00\65F6\6BB5\65F6, &PRODUCT_NAME. \5F15\64CE\5C06\4F7F\7528\6B64\9879\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288538747312556)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289284791312556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\65E5\5386\4E0A\663E\793A\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447629051312685)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447723713312685)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528<strong>\663E\793A\5217</strong>\5C5E\6027\53EF\4EE5\9009\62E9\8981\5728\65E5\5386\5355\5143\4E2D\663E\793A\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447844367312685)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447982090312685)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\60A8\53EF\4EE5\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\8F93\5165\5B9A\5236\5217\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448031794312685)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\663E\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448194227312685)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\65E5\5386\5355\5143\4E2D\4E0D\663E\793A\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289152074312556)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288800309312556)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5B58\653E\5F53\524D\663E\793A\7ED9\6700\7EC8\7528\6237\7684\65E5\5386\7ED3\675F\65E5\671F\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\5F53\6700\7EC8\7528\6237\9009\62E9\5BFC\822A\5230\4E0A\4E00\65F6\6BB5\6216\4E0B\4E00\65F6\6BB5\65F6, &PRODUCT_NAME. \5F15\64CE\5C06\4F7F\7528\6B64\9879\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288765078312556)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288024810312555)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5448\73B0\65E5\5386\65F6\8981\4F7F\7528\7684\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287919193312555)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289000720312556)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B58\653E\5F53\524D\663E\793A\7ED9\6700\7EC8\7528\6237\7684\65E5\5386\7C7B\578B\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288996418312556)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601402649312805)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6BCF\9875\8981\663E\793A\7684\5361\7247\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601345251312805)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\7684\5361\7247\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600275849312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\6309\94AE\5728\5361\7247\4E0A\7684\653E\7F6E\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600324179312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600441646312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B21\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600176299312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599053751312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\8981\6DFB\52A0\5230\5361\7247\7EC4\4EF6\7684\64CD\4F5C\7C7B\578B\3002</p>'),
unistr('<p>\60A8\53EF\4EE5\5B9A\4E49\591A\4E2A\76F8\540C\7C7B\578B\7684\64CD\4F5C\3002\4F46\662F\FF0C\53EA\6709\6309\94AE\64CD\4F5C\5448\73B0\591A\6B21\3002'),
unistr('\5BF9\4E8E\6240\6709\5176\4ED6\64CD\4F5C\7C7B\578B\FF0C\5C06\5448\73B0\7B2C\4E00\4E2A\201C\771F\201D\663E\793A\6761\4EF6\FF0C\5C06\5FFD\7565\5176\4F59\6761\4EF6\3002</p>'),
unistr('<p>\5982\679C\6267\884C\6761\4EF6\8BBE\7F6E\4E3A\68C0\67E5\6BCF\884C\FF0C\5219\53EF\4EE5\57FA\4E8E\5217\503C\5B9A\4E49\663E\793A\6761\4EF6\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599123369312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599258848312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5361\7247\6DFB\52A0\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599398691312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6574\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599495540312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6DFB\52A0\6307\5411\5B8C\6574\5361\7247\7684\94FE\63A5\3002\901A\5E38\FF0C\5E94\5B9A\4E49\6B64\64CD\4F5C\7C7B\578B\4E4B\4E00\3002'),
unistr('\5982\679C\5B9A\4E49\591A\4E2A\FF0C\5219\6839\636E\5217\503C\6DFB\52A0\663E\793A\6761\4EF6\FF0C\5E76\8BBE\7F6E\4E3A\68C0\67E5\6BCF\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599910735312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECB\8D28')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600048339312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6DFB\52A0\6307\5411\5361\7247\4ECB\8D28\7684\94FE\63A5\3002\901A\5E38\FF0C\5E94\5B9A\4E49\6B64\64CD\4F5C\7C7B\578B\4E4B\4E00\3002'),
unistr('\5982\679C\5B9A\4E49\591A\4E2A\FF0C\5219\6839\636E\5217\503C\6DFB\52A0\663E\793A\6761\4EF6\FF0C\5E76\8BBE\7F6E\4E3A\68C0\67E5\6BCF\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599747984312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599874468312804)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6DFB\52A0\6307\5411\5361\7247\5B50\6807\9898\7684\94FE\63A5\3002\901A\5E38\FF0C\5E94\5B9A\4E49\6B64\64CD\4F5C\7C7B\578B\4E4B\4E00\3002'),
unistr('\5982\679C\5B9A\4E49\591A\4E2A\FF0C\5219\6839\636E\5217\503C\6DFB\52A0\663E\793A\6761\4EF6\FF0C\5E76\8BBE\7F6E\4E3A\68C0\67E5\6BCF\884C\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599527658312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108599678113312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6DFB\52A0\6307\5411\5361\7247\6807\9898\7684\94FE\63A5\3002\901A\5E38\FF0C\5E94\5B9A\4E49\6B64\64CD\4F5C\7C7B\578B\4E4B\4E00\3002'),
unistr('\5982\679C\5B9A\4E49\591A\4E2A\FF0C\5219\6839\636E\5217\503C\6DFB\52A0\663E\793A\6761\4EF6\FF0C\5E76\8BBE\7F6E\4E3A\68C0\67E5\6BCF\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598981797312803)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587910471312794)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5E94\7528\4E8E\6BCF\4E2A\5355\72EC\5361\7247\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587861966312794)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593114397312798)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\53F3\7BAD\5934</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593096487312798)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\7EC4\4EF6\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592909738312798)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694088335312876)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\53F3\7BAD\5934</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693917752312876)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\7EC4\4EF6\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693857514312876)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586331685312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5C5E\6027\786E\5B9A\5361\7247\5728\9875\9762\4E0A\7684\6392\5217\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586681942312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D6E\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586719828312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\5361\7247\5728\5C4F\5E55\6C34\5E73\65B9\5411\4E0A\5BB9\7EB3\4E0D\4E0B\65F6\FF0C\5361\7247\5C06\6362\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586499556312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586543244312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\5217\7F51\683C\4E2D\7684\5361\7247\8FDB\884C\6392\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586813835312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73\FF08\884C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586904732312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247\5C06\53E0\653E\5728\4E00\8D77\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586255336312793)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600649402312804)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5355\51FB\6307\5B9A\7684\64CD\4F5C\7C7B\578B\65F6\5C06\6267\884C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600938072312804)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601099912312805)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875\FF0C\4F7F\7528\53EF\9009\7684\9644\52A0\5C5E\6027\5728\76EE\6807\9875\4E0A\91CD\7F6E\9875\7801\FF0C\8BBE\7F6E\8BF7\6C42\503C\FF0C\6E05\9664\9AD8\901F\7F13\5B58\548C\8BBE\7F6E\9879\503C\3002</p>'),
unistr('<p>\6CE8\FF1A\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875\4F9D\8D56\4E8E\76EE\6807\5E94\7528\7A0B\5E8F\4E2D\542F\7528\7684\6DF1\94FE\63A5\3002\8981\542F\7528\6DF1\94FE\63A5\FF0C\8BF7\8F6C\81F3\5E94\7528\7A0B\5E8F\7684<em>\5B89\5168\6027</em>\5C5E\6027\5E76\542F\7528<em>\6DF1\94FE\63A5</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600771722312804)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600826862312804)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\5F53\524D\5E94\7528\7A0B\5E8F\4E2D\7684\9875, \4F7F\7528\53EF\9009\7684\9644\52A0\5C5E\6027\5728\76EE\6807\9875\4E0A\91CD\7F6E\9875\7801, \8BBE\7F6E\8BF7\6C42\503C, \6E05\9664\9AD8\901F\7F13\5B58\548C\8BBE\7F6E\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601180138312805)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601237935312805)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\60A8\6307\5B9A\7684\76EE\6807 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108600578584312804)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713717029312891)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\533A\57DF\6E90\4E2D\9009\62E9\7B2C\4E00\4E3B\952E\5217\3002\5982\679C\6B64\8868\7684\4E3B\952E\5177\6709\4E24\4E2A\4EE5\4E0A\7684\5217\FF0C\60A8\5FC5\987B\9009\62E9 <code>ROWID</code> \5217\3002\5982\679C\533A\57DF\8BBE\7F6E\4E3A\663E\793A\6EDA\52A8\5206\9875\FF0C\5219\4E3B\952E\7528\4E8E\907F\514D\663E\793A\91CD\590D\884C\3002\5982\679C\533A\57DF\663E\793A BLOB \5217\4E2D\7684\56FE\50CF\FF0C\5219\4E3B\952E\7528\4E8E\83B7\53D6\8BE5\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713647439312891)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714181678312891)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\533A\57DF\6E90\4E2D\9009\62E9\7B2C\4E00\4E3B\952E\5217\3002\5982\679C\6B64\8868\7684\4E3B\952E\5177\6709\4E24\4E2A\4EE5\4E0A\7684\5217\FF0C\60A8\5FC5\987B\9009\62E9 <code>ROWID</code> \5217\3002\5982\679C\533A\57DF\8BBE\7F6E\4E3A\663E\793A\6EDA\52A8\5206\9875\FF0C\5219\4E3B\952E\7528\4E8E\907F\514D\663E\793A\91CD\590D\884C\3002\5982\679C\533A\57DF\663E\793A BLOB \5217\4E2D\7684\56FE\50CF\FF0C\5219\4E3B\952E\7528\4E8E\83B7\53D6\8BE5\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714043107312891)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713992744312891)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\533A\57DF\6E90\7684\4E3B\952E\5177\6709\4E24\5217\FF0C\5219\4EC5\9009\62E9\7B2C\4E8C\4E3B\952E\5217\3002\5982\679C\60A8\4E3A\7B2C\4E00\4E3B\952E\5217\9009\62E9 <code>ROWID</code>\FF0C\5219\4E0D\5E94\586B\5145\6B64\5217\3002\5982\679C\533A\57DF\8BBE\7F6E\4E3A\663E\793A\6EDA\52A8\5206\9875\FF0C\5219\7B2C\4E8C\4E3B\952E\7528\4E8E\907F\514D\663E\793A\91CD\590D\884C\3002\5982\679C\533A\57DF\663E\793A BLOB \5217\4E2D\7684\56FE\50CF\FF0C\5219\7B2C\4E8C\4E3B\952E\7528\4E8E\83B7\53D6\8BE5\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713837581312891)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714326660312892)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\533A\57DF\6E90\7684\4E3B\952E\5177\6709\4E24\5217\FF0C\5219\4EC5\9009\62E9\7B2C\4E8C\4E3B\952E\5217\3002\5982\679C\60A8\4E3A\7B2C\4E00\4E3B\952E\5217\9009\62E9 <code>ROWID</code>\FF0C\5219\4E0D\5E94\586B\5145\6B64\5217\3002\5982\679C\533A\57DF\8BBE\7F6E\4E3A\663E\793A\6EDA\52A8\5206\9875\FF0C\5219\7B2C\4E8C\4E3B\952E\7528\4E8E\907F\514D\663E\793A\91CD\590D\884C\3002\5982\679C\533A\57DF\663E\793A BLOB \5217\4E2D\7684\56FE\50CF\FF0C\5219\7B2C\4E8C\4E3B\952E\7528\4E8E\83B7\53D6\8BE5\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714296773312892)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108601531150312805)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247\4F7F\7528 BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254223132312526)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\503C\5217\8868\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\FF0C\5728\4F7F\7528\7236\9762\6216\7B5B\9009\5668\503C\67E5\8BE2\65F6\4F7F\7528\8BE5\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254139430312526)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LOV \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791161627312958)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\89E6\53D1\5237\65B0\6B64\503C\5217\8868\7684\5217\3002'),
unistr('\5BF9\4E8E\591A\4E2A\5217, \7528\9017\53F7\5206\9694\5404\5217\540D\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\5217\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\5217\540D\3002</p>'),
unistr('<p>\53EA\8981\6B64\9875\4E0A\6709\4EFB\4F55\6307\5B9A\5217\503C\53D1\751F\66F4\6539\5C31\4F1A\5237\65B0\6B64\503C\5217\8868\3002</p>'),
unistr('<p>\5E94\4F7F\7528\5728\6B64\5C5E\6027 (\4F4D\4E8E\6B64\503C\5217\8868 SQL \67E5\8BE2\7684 <em>Where \5B50\53E5</em>\5185) \4E2D\6307\5B9A\7684\9875\9879\9650\5236\8FD4\56DE\503C\3002</p>'),
unistr('<p>\4F8B\5982, \5982\679C\5177\6709\201C\6C7D\8F66\54C1\724C\201D\548C\201C\578B\53F7\201D\5217, \5219\53EF\4EE5\5728\201C\578B\53F7\201D\7684\503C\5217\8868\5B9A\4E49\5185\5C06\201C\6C7D\8F66\54C1\724C\201D\6307\5B9A\4E3A\7EA7\8054 LOV \7236\5217, \5E76\5728\6B64\503C\5217\8868\7684 Where \5B50\53E5\4E2D\4F7F\7528\201C\6C7D\8F66\54C1\724C\201D\3002'),
unistr('\7136\540E, \6BCF\5F53\66F4\6539\201C\6C7D\8F66\54C1\724C\201D\65F6, \5C31\4F1A\5237\65B0\201C\578B\53F7\201D\7684 LOV, \5E76\4E14\6B64\5217\8868\4EC5\663E\793A\5F53\524D\6240\9009\201C\6C7D\8F66\54C1\724C\201D\7684\503C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791019415312958)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254473218312527)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\89E6\53D1\6B64\503C\5217\8868\5237\65B0\7684\9762\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254376995312526)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940895368312278)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\89E6\53D1\6B64\503C\5217\8868\5237\65B0\7684\7B5B\9009\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940790551312277)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\7B5B\9009\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905919732312251)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\89E6\53D1\5237\65B0\6B64\503C\5217\8868\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002</p>'),
unistr('<p>\53EA\8981\6B64\9875\4E0A\6709\4EFB\4F55\6307\5B9A\9879\503C\53D1\751F\66F4\6539\5C31\4F1A\5237\65B0\6B64\503C\5217\8868\3002</p>'),
unistr('<p>\5E94\4F7F\7528\5728\6B64\5C5E\6027 (\4F4D\4E8E\6B64\503C\5217\8868 SQL \67E5\8BE2\7684 <em>Where \5B50\53E5</em>\5185) \4E2D\6307\5B9A\7684\9875\9879\9650\5236\8FD4\56DE\503C\3002</p>'),
unistr('<p>\4F8B\5982, \5982\679C\5177\6709\201C\6C7D\8F66\54C1\724C\201D\548C\201C\578B\53F7\201D\9875\9879, \5219\53EF\4EE5\5728\201C\578B\53F7\201D\7684\503C\5217\8868\5B9A\4E49\5185\5C06\201C\6C7D\8F66\54C1\724C\201D\6307\5B9A\4E3A\7EA7\8054 LOV \7236\9879, \5E76\5728\6B64\503C\5217\8868\7684 Where \5B50\53E5\4E2D\4F7F\7528\201C\6C7D\8F66\54C1\724C\201D\3002'),
unistr('\7136\540E, \6BCF\5F53\66F4\6539\201C\6C7D\8F66\54C1\724C\201D\65F6, \5C31\4F1A\5237\65B0\201C\578B\53F7\201D\7684 LOV, \5E76\4E14\6B64\5217\8868\4EC5\663E\793A\5F53\524D\6240\9009\201C\6C7D\8F66\54C1\724C\201D\7684\503C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905895517312251)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251225509312524)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5237\65B0\6B64\503C\5217\8868\7684\6761\4EF6\3002</p>'),
unistr('<p>\5982\679C\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF0C\5219\4EC5\5F53\6240\6709<em>\7EA7\8054 LOV \7236\9879</em>\5747\4E3A\975E\7A7A\503C\65F6\FF0C\624D\4F1A\6267\884C\7528\4E8E\83B7\53D6\65B0\503C\7684\5237\65B0\8C03\7528\3002'),
unistr('\5982\679C\5176\4E2D\4E00\9879\4E3A\7A7A\503C\FF0C\5219\5047\5B9A LOV \67E5\8BE2\4E0D\4F1A\8FD4\56DE\4EFB\4F55\884C\3002'),
unistr('\5728\8FD9\79CD\60C5\51B5\4E0B\FF0C\4EC5\5728\6D4F\89C8\5668\4E2D\76F4\63A5\6E05\9664\9009\62E9\5217\8868\6761\76EE\800C\4E0D\6267\884C\5237\65B0\3002</p>'),
unistr('<p>\5982\679C\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\FF0C\5219\5C06\59CB\7EC8\6267\884C\5237\65B0\3002'),
unistr('\4EC5\5F53\60A8\5728\6B64\503C\5217\8868 SQL \67E5\8BE2\7684 <em>Where \5B50\53E5</em>\4E2D\5BF9\53EF\4E3A\7A7A\503C\7684<em>\7EA7\8054 LOV \7236\9879</em>\8FDB\884C\4E13\95E8\5904\7406\65F6\FF0C\624D\4F7F\7528\6B64\9009\9879\3002'),
unistr('\5982\679C\5BF9\53EF\4E3A\7A7A\503C\7684\9875\9879\672A\8FDB\884C\6B63\786E\5904\7406\FF0C\5219\4F1A\6267\884C\4ECE\4E0D\8FD4\56DE\4EFB\4F55\884C\7684\4E0D\5FC5\8981\7684\5237\65B0\8C03\7528\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108251109064312524)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\7236\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536797263311966)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E0A\6B21\66F4\65B0\6B64\5C5E\6027\7684\5F00\53D1\8005\7684\7528\6237\8EAB\4EFD\8BC1\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536618273311966)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536942404311966)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E0A\6B21\66F4\65B0\6B64\5C5E\6027\7684\65F6\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536830349311966)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286715028312554)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\56FE\8868\7684\9AD8\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002\9AD8\5EA6\5B9A\4E49\56FE\8868\533A\57DF\7684\56FA\5B9A\9AD8\5EA6\3002\6216\8005, \8981\5141\8BB8\81EA\52A8\8C03\6574\56FE\8868\9AD8\5EA6\7684\5927\5C0F, \5C06\6B64\9879\7559\7A7A\3002'),
unistr('\9AD8\5EA6\968F\540E\57FA\4E8E\6D4F\89C8\5668\7684\9AD8\5EA6\3002</p>'),
unistr('<p>\9ED8\8BA4\60C5\51B5\4E0B, \4F7F\7528 jQuery Mobile \667A\80FD\624B\673A\7528\6237\754C\9762\5728\9875\4E0A\521B\5EFA\7684\56FE\8868\6CA1\6709\8BBE\7F6E\9AD8\5EA6\503C, \4F1A\6B63\786E\8C03\6574\5927\5C0F\4EE5\9002\5408\5176\5448\73B0\4E8E\7684\8BBE\5907\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286619489312554)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286880774312554)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310552664312573)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\56FE\8868\7684\6700\5927\5BBD\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002\6700\5927\5BBD\5EA6\5B9A\4E49\56FE\8868\533A\57DF\7684\56FA\5B9A\5BBD\5EA6\3002'),
unistr('\6216\8005, \8981\5141\8BB8\81EA\52A8\8C03\6574\56FE\8868\5BBD\5EA6\7684\5927\5C0F, \5C06\6B64\9879\7559\7A7A\3002\5BBD\5EA6\968F\540E\81EA\52A8\8BBE\7F6E\4E3A\533A\57DF\7684 100%\3002</p>'),
unistr('<p>\9ED8\8BA4\60C5\51B5\4E0B, \4F7F\7528 jQuery Mobile \667A\80FD\624B\673A\7528\6237\754C\9762\5728\9875\4E0A\521B\5EFA\7684\56FE\8868\6CA1\6709\8BBE\7F6E\5BBD\5EA6\503C, \4F1A\6B63\786E\8C03\6574\5927\5C0F\4EE5\9002\5408\5176\5448\73B0\4E8E\7684\8BBE\5907\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304960582312568)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305085190312569)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283668542312551)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\56FE\8868\9876\90E8\663E\793A\7684\6807\9898\3002\5BF9\4E8E\7518\7279\56FE, \6B64\503C\4EC5\7528\4E8E\5B9A\4E49\53EF\8BBF\95EE\7684\56FE\8868\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283503887312551)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512075455312735)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6570\636E\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512108682312735)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5730\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512242847312735)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\672C\5730\6570\636E\5E93\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512765382312736)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512859113312736)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\5728\533A\57DF\6E90\5B9A\4E49\4E2D\6307\5B9A\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512303833312735)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512488395312735)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\8FDC\7A0B\6570\636E\5E93\FF0C\6570\636E\5E93\8FDE\63A5\4F7F\7528\542F\7528 REST \7684 SQL \6765\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512522839312736)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512667236312736)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\4F7F\7528 REST \6570\636E\6E90\5B9A\4E49\7684 RESTful Web \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108511971463312735)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277338690312546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\62A5\8868\5217\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435103453312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \65E5\671F\9009\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435090944312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \65E5\671F\9009\53D6\5668 (\7ECF\5178)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434936802312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \663E\793A\4E3A\6587\672C (\4FDD\5B58\72B6\6001)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434668952312674)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612064704312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\4EE5\4E0B\8F7D\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434880879312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612236831312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5217, \4F46\53EF\5F15\7528\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435694185312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \9690\85CF\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434559342312674)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611971748312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434474646312674)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611846077312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434781286312674)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4\56FE\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612157848312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\767E\5206\6BD4\56FE\5F62\3002\68C0\7D22\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 100 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434283966312674)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611690684312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108434393626312674)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C (\57FA\4E8E\503C\5217\8868)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611774210312813)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4ECE\6307\5B9A\7684\503C\5217\8868\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435764600312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \5F39\51FA\5F0F LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435839267312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \5F39\51FA\5F0F\5173\952E\5B57 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435539366312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \5355\9009\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683153980312868)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4FE1\606F\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683242806312868)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 HTML \6216 Markdown \5448\73B0\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436075784312676)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \884C\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435478846312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \9009\62E9\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435981111312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \7B80\5355\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435248884312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \6587\672C\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108435379058312675)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('* \6587\672C\533A\57DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277293675312546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276985985312546)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9875\7801 (\663E\793A\6240\6709\884C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278182893312547)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9875\7801 (\663E\793A\6240\6709\884C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263396823312534)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\8981\5728\6B64\62A5\8868\4E2D\4F7F\7528\7684\9875\7801\7C7B\578B\3002'),
unistr('\901A\5E38, \5F53\524D\53EA\5728\62A5\8868\4E2D\663E\793A\4E00\90E8\5206\7ED3\679C\3002'),
unistr('\9875\7801\4E3A\7528\6237\63D0\4F9B\6709\5173\7ED3\679C\96C6\4E2D\7684\884C\6570\548C\5F53\524D\4F4D\7F6E\7684\4FE1\606F\3002\9875\7801\8FD8\5B9A\4E49\94FE\63A5\6216\6309\94AE\7684\6837\5F0F, \800C\8FD9\4E9B\94FE\63A5\6216\6309\94AE\7528\4E8E\5BFC\822A\5230\4E0B\4E00\9875\6216\4E0A\4E00\9875\3002</p>'),
unistr('<p>\9875\7801\53EF\4EE5\663E\793A\5728\62A5\8868\7684\4E0A\65B9\6216\4E0B\65B9 (\6216\540C\65F6\663E\793A\5728\4E0A\65B9\548C\4E0B\65B9), \5E76\4E14\53EF\4EE5\4F4D\4E8E\5DE6\4FA7\6216\53F3\4FA7\3002</p>'),
unistr('<p>\60A8\4E5F\53EF\4EE5\4F7F\7528\7B80\5316\9875\7801\6837\5F0F\6765\6539\5584\6027\80FD, \4F8B\5982 <strong>\884C\7684\8303\56F4\4ECE X \5230 Y (\5177\6709\201C\4E0B\4E00\9875\201D\548C\201C\4E0A\4E00\9875\201D\94FE\63A5)</strong>\3002'),
unistr('\4F7F\7528 "\4ECE X \5230 Y, \5171 Z \884C" \5F62\5F0F\7684\9875\7801\7C7B\578B\65F6, \8981\6C42 &PRODUCT_NAME. \5F15\64CE\6267\884C\4E24\4E2A\67E5\8BE2\6765\8FD4\56DE\7ED3\679C\3002'),
unistr('\4E00\4E2A\67E5\8BE2\68C0\7D22\8981\663E\793A\7684\5F53\524D\8BB0\5F55, \53E6\4E00\4E2A\67E5\8BE2\83B7\53D6\603B\8BB0\5F55\8BA1\6570\4EE5\663E\793A\5728\9875\7801\63A7\4EF6\4E2D\3002'),
unistr('\5BF9\4E8E\57FA\4E8E\975E\5E38\5927\7684\6570\636E\96C6\6216\5177\6709\5360\7528\5927\91CF CPU \7684\67E5\8BE2\7684\62A5\8868 (\4F8B\5982, \8BB8\591A\975E\4F18\5316\8868\8054\63A5\6216\5F00\9500\5F88\5927\7684\6761\4EF6), \6B64\9644\52A0\67E5\8BE2\4F1A\589E\52A0\4E00\4E9B\5904\7406\65F6\95F4, \8FD9\53EF\80FD\5BFC\81F4\62A5\8868\7684\5448\73B0\65F6\95F4\5EF6\957F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443799789312682)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5916\90E8\521B\5EFA\7684\9875\7801\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443848154312682)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y (\5177\6709\201C\4E0B\4E00\9875\201D\548C\201C\4E0A\4E00\9875\201D\94FE\63A5)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443146890312681)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y (\65E0\9875\7801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443262436312681)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y, \5171 Z \884C (\65E0\9875\7801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443478923312681)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4 1-15 16-30  (\5177\6709\96C6\9875\7801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443568647312681)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868\4E2D\7684\884C\8303\56F4 1-15 16-30 (\5177\6709\9875\7801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443373426312681)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y, \5171 Z \884C (\5177\6709\9875\7801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443661367312682)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5F15\64CE 1,2,3,4 (\57FA\4E8E\96C6\7684\9875\7801)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263216034312534)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232875799312508)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\6807\89C6\56FE\4E2D\6BCF\884C\663E\793A\7684\56FE\6807\6570\3002\503C\4E3A 5 \5C06\5728\62A5\8868\7684\6BCF\884C\4E0A\663E\793A 5 \4E2A\56FE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431275322312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431366488312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431416056312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'zh-cn'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431527476312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'zh-cn'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431686870312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'zh-cn'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431740609312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'zh-cn'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431811165312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'zh-cn'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431936467312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432017625312672)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'zh-cn'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232715148312508)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\884C\5217\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223362755312501)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\663E\793A\5BF9\9F50\65B9\5F0F\3002\8BF7\6CE8\610F, \60A8\5FC5\987B\9009\62E9\6240\9009\62A5\8868\6A21\677F\652F\6301\7684\5BF9\9F50\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427384659312669)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427253380312668)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427450618312669)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223254524312501)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279672701312548)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9ED8\8BA4\5217\503C\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447258909312684)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447104534312684)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279545315312548)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134560568312430)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7EC4\6807\9898\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222565518312500)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\62A5\8868\5217\6807\9898\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222433417312500)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652249545312056)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561441996312774)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5305\542B\552F\4E00\952E\7684\5217\6765\6807\8BC6\884C\3002\4F7F\7528\6B64\9879\53EF\4E3A\5B9A\5236 JavaScript \4EE3\7801\6216\5730\56FE\4E8B\4EF6\5904\7406\7A0B\5E8F\63D0\4F9B\4E3B\952E\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561359994312774)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221972668312500)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\62A5\8868\5217\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221834770312500)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277196088312546)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278576058312547)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257683243312529)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\6309\964D\5E8F\987A\5E8F\6392\5E8F\6B64\5217\3002\5982\679C\672A\6307\5B9A, \5219\6309\5347\5E8F\987A\5E8F\6392\5E8F\6B64\5217 (\9ED8\8BA4)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440491590312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257500451312529)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257489260312529)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\5217\7684\6392\5E8F\5E8F\5217\3002'),
unistr('\6BCF\4E00\5217\5E94\5177\6709\552F\4E00\7684\5E8F\5217\4EE5\4FBF\6B63\786E\5730\6392\5E8F\62A5\8868\8F93\51FA\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439692840312678)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439725135312678)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439871317312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'zh-cn'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439903354312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'zh-cn'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440042047312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'zh-cn'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440151670312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'zh-cn'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440282761312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'zh-cn'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440380567312679)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257362145312529)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222162346312500)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\62A5\8868\5217\7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222017429312500)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255893602312528)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5217\5BBD (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002'),
unistr('\5728\6D4F\89C8\5668\4E2D\663E\793A\62A5\8868\65F6\4F7F\7528\6B64\5C5E\6027\3002'),
unistr('\8BF7\6CE8\610F, \6240\9009\62A5\8868\6A21\677F\5FC5\987B\652F\6301\8BBE\7F6E\5217\5BBD\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255769854312528)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\5143\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286236843312554)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890532203312239)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\8F93\5165\4EFB\4F55\5F00\53D1\8005\6CE8\91CA\3002\8FD9\4E9B\6CE8\91CA\4EC5\663E\793A\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\5185, \5728\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\4ECE\4E0D\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890448143312239)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587799185312794)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5E94\7528\4E8E\6B64\7EC4\4EF6\7684 CSS \7C7B\3002\6B64\7C7B\5C06\5E94\7528\4E8E\5361\7247\5BB9\5668\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587646157312794)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647720732312840)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648126114312841)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648012161312841)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647959049312841)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648259254312841)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647810054312841)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647667284312840)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649769977312842)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650054622312842)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649977678312842)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649876643312842)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650142242312842)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649691727312842)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894564724312242)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\901A\8FC7\6B64\8BA1\7B97\586B\5145\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894452513312242)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895378659312242)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5176\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\7684\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895218053312242)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649322047312842)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649281685312842)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650977631312843)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650836355312843)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649155447312842)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649000669312841)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648956837312841)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650719980312843)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650622490312843)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650594115312843)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648846315312841)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648752206312841)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648618836312841)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650490344312843)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650303049312842)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108650251004312842)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895901226312243)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5728\9875\5448\73B0\6216\5904\7406\4E2D\7684\54EA\4E2A\70B9\6267\884C\6B64\8BA1\7B97\3002'),
unistr('\6700\5178\578B\7684\8BA1\7B97\70B9\662F<strong>\63D0\4EA4\540E</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407929876312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709325987312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\533A\57DF\5448\73B0\4E4B\540E\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408169459312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709576598312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\811A\5448\73B0\4E4B\540E\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407742849312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709198440312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\6807\5934\5448\73B0\4E4B\540E\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408240688312651)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709627087312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\9875\63D0\4EA4\4E4B\540E\3001\4F46\5728\9875\5904\7406\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407823215312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709260278312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\533A\57DF\5448\73B0\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408051339312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709470407312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\811A\5448\73B0\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407628038312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709015501312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\5448\73B0\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407531447312650)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708917914312888)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\751F\6210\65B0\4F1A\8BDD\65F6\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895843483312243)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895518382312243)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895481421312243)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649591947312842)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108649433836312842)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651129007312843)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651079160312843)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614304282312815)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\63D0\4F9B\7528\4E8E\586B\5145\8BA1\7B97\9879\7684\503C\7684 SQL \67E5\8BE2\3002\5982\679C\7ED3\679C\5305\542B\591A\884C, \5219\5404\884C\7684\503C\5C06\5F62\6210\5355\4E2A\5192\53F7\5206\9694\7684\503C\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614253561312815)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648562824312841)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648473020312841)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4E8E\586B\5145\8BA1\7B97\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108648344748312841)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895147240312242)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\63D0\4F9B\7528\4E8E\586B\5145\8BA1\7B97\9879\7684\503C\7684 SQL \67E5\8BE2\3002\5982\679C\7ED3\679C\5305\542B\591A\884C, \5219\53EA\8FD4\56DE\7B2C\4E00\884C\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895090496312242)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894957666312242)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\586B\5145\8BA1\7B97\9879\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894841833312242)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894707902312242)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4EE5\4E0B\5217\8868\4E2D\9009\62E9\8BA1\7B97\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630836253312827)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630951095312827)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6267\884C\8F93\5165\7684<em>\8868\8FBE\5F0F</em>\6240\751F\6210\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407085767312650)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609462389312811)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407386920312650)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609185769312811)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407124907312650)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5355\4E2A\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609277363312811)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\7B2C\4E00\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407239160312650)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5192\53F7\5206\9694\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609377663312811)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\5355\4E2A\5192\53F7\5206\9694\503C (\8FDE\63A5\6BCF\884C\503C)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108407419610312650)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609531145312811)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406919786312650)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609075289312811)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\5230<em>\9759\6001\503C</em>\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894664516312242)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255611270312528)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BF9\4E8E\6B64\5217, \6307\5B9A\662F\5426\8BA1\7B97\603B\548C\5E76\663E\793A\5728\62A5\8868\7ED3\5C3E\5904\3002'),
unistr('\5728\7528\4E8E\5206\6BB5\5217\65F6, \4F1A\663E\793A\603B\548C\603B\8BA1\53CA\6BCF\4E2A\5206\6BB5\7684\603B\548C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255568523312528)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\603B\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640395276312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640758280312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640699685312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640598418312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640845625312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640479530312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640287595312835)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642304576312836)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642675772312836)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642598204312836)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642448390312836)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642707420312837)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642266951312836)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928053504312268)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927927005312268)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929489392312269)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929373378312269)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641981308312836)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Java \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641845275312836)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643512066312837)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Java \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643427754312837)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641792975312836)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641668493312836)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 JavaScript \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641536013312836)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643336411312837)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643259309312837)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 JavaScript \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643163169312837)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928204735312268)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\5192\53F7 (:) \5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928150316312268)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928694725312268)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928510083312268)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928870059312268)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\9875\7801\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928725251312268)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641425663312836)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641360489312835)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 PL/SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641257064312835)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643023734312837)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642904781312837)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642807823312837)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928430599312268)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4E0E\6307\5B9A\503C\8FDB\884C\6BD4\8F83\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928325586312268)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642125920312836)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Python \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108642074019312836)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643719813312837)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Python \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643602205312837)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641103219312835)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108641011371312835)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640968692312835)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786919968312955)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 30 \65F6, \8981\5728\6709\4E00\884C\6216\591A\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 40 \65F6, \8981\5728\6CA1\6709\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927621556312267)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927572466312267)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929027934312269)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107928927635312268)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929660646312269)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929547158312269)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302936909312567)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\6FC0\6D3B\6B64\64CD\4F5C\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930529534312270)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\6FC0\6D3B\6B64\52A8\6001\64CD\4F5C\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926574572312267)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\4E86\5448\73B0\6216\5904\7406\6B64\7EC4\4EF6\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484966411312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622534319312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\59CB\7EC8\5448\73B0\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483535254312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Microsoft Internet Explorer 7.0 \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483642922312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\652F\6301 XHTML/CSS \7684\6D4F\89C8\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483474423312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Mozilla, Netscape 6.x/7x \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483737114312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\5176\4ED6\6D4F\89C8\5668 (\6216\8F83\4F4E\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482171326312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\9879\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484161210312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626167385312824)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483864029312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626390800312824)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484074141312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626252621312824)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483990551312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626411229312824)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481337949312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624906554312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481572150312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625157146312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481439243312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625000746312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481655916312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625268402312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484220632312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484352276312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483015769312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625946926312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875\540E, \5728\9875\4E0A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482487533312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482225532312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482352942312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482500573312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479072896312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622678612312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640098386312834)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108640134776312835)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\771F\201D\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479297599312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622849108312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\8FD4\56DE\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484653630312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484753409312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482775567312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E0D\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625665513312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38\663E\793A\9875\548C\7236\533A\57DF (\5982\679C\9002\7528)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482652289312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625504003312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6216\7236\533A\57DF (\5982\679C\9002\7528) \7684 ''\53EA\8BFB'' \6761\4EF6\7684\503C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480558115312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624171361312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5305\542B\7A7A\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480806492312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624410816312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\662F\4EC5\5305\542B\5B57\6BCD\6216\6570\5B57\4E14\4E0D\5305\542B\7279\6B8A\5B57\7B26\7684\5B57\6BCD\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480041886312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623652415312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480729476312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624306325312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480224868312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623899542312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479989553312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623566656312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480351565312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623908172312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\6216\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480690328312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624263233312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480113965312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623728575312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480468561312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C\4E14\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624009631312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\4E14\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483273519312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\8BA4\201D\4EE5\663E\793A\201C\5411\524D\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483306485312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\5B9A\201D\4EE5\663E\793A\201C\5411\540E\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484879179312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626544056312824)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4ECE\4E0D\5448\73B0\7EC4\4EF6\3002</p>'),
unistr('<p>\6CE8: \5C06\6761\4EF6\66F4\6539\4E3A<strong>\4ECE\4E0D</strong>\5C06\5220\9664\6240\6709\73B0\6709\6761\4EF6\3002\8981\4E34\65F6\7981\7528\7EC4\4EF6, Oracle \5EFA\8BAE\6539\7528<em>\6784\5EFA\9009\9879</em>\5C5E\6027\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108483135010312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626043233312824)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0A\672A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479157162312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622792533312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481916199312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625385395312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482093475312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625471604312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5C1A\672A\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479378887312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622984140312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479550040312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623106682312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479418879312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623080018312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479604020312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623215297312821)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484453538312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108484580235312713)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482898860312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\9A8C\8BC1 (\4E0D\662F\516C\5171\7528\6237)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625765015312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108482930536312712)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\662F\516C\5171\7528\6237 (\7528\6237\672A\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108625884680312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\672A\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481193811312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624751867312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481269141312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624834394312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108480980061312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624562787312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481078787312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108624656019312823)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479733541312709)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623312011312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108479876711312710)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108623449686312822)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481871148312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108481768521312711)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926475287312266)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927809040312268)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E0E\6761\4EF6\8FDB\884C\6BD4\8F83\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107927729863312267)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929270306312269)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929173160312269)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798881560312168)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\786E\8BA4\63D0\793A\6765\4FDD\62A4\6309\94AE\7684\884C\4E3A\3002\5728\5355\51FB\6309\94AE\540E\FF0C\663E\793A\786E\8BA4\5BF9\8BDD\6846\FF0C\7528\6237\5FC5\987B\5148\8FDB\884C\786E\8BA4\FF0C\6309\94AE\624D\6267\884C\76F8\5E94\7684\64CD\4F5C\3002</p>'),
unistr('<p>\6B64\529F\80FD\53EF\7528\4E8E\786E\4FDD\7528\6237\4E0D\4F1A\610F\5916\6267\884C\91CD\8981\64CD\4F5C\FF0C\4F8B\5982\5220\9664\8BB0\5F55\3002</p>'),
unistr('<p>\6CE8\FF1A\5BF9\8BDD\6846\4E2D\7684\786E\8BA4\6309\94AE\4ECE\4E3B\6309\94AE\6807\7B7E\6D3E\751F\5176\6807\7B7E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798779953312168)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6C42\786E\8BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799117542312168)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<pre>&lt;strong&gt;\662F\5426\786E\5B9E&lt;&#x2F;strong&gt\8981\5220\9664\5458\5DE5 &amp;P1_ENAME.\FF1F</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799061501312168)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\786E\8BA4\5BF9\8BDD\6846\4E2D\663E\793A\7684\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107798911482312168)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799824608312169)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799375944312168)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5BF9\8BDD\6846\7684\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799613112312169)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5371\9669')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799469630312168)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799717911312169)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799510548312169)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799234189312168)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261791191312533)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\53EF\7528\5217\8868\4E2D\9009\62E9\5185\5BB9\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440688437312679)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440794000312679)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261691505312533)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986939939312312)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4F1A\8BDD Cookie \7684 URL \57DF\5C5E\6027\3002'),
unistr('\5982\679C\8BF7\6C42 URL \7684\7ED3\5C3E\6BD4\8F83\4E0E\6307\5B9A\7684\57DF\4E0D\5339\914D, \5219\4E0D\4F1A\5C06 Cookie \53D1\9001\5230\6D4F\89C8\5668\3002'),
unistr('\9ED8\8BA4\503C\662F\8BF7\6C42 URL \7684\4E3B\673A\540D\3002</p>'),
unistr('<p>\5F53\60A8\5E0C\671B\5728\5177\6709\516C\7528\57DF\7684\5E94\7528\7A0B\5E8F\4E4B\95F4\5171\4EAB\4F1A\8BDD Cookie \65F6, \4F7F\7528\6B64\5C5E\6027\53EF\4EE5\6307\5B9A\9650\5236\8F83\5C11\7684\57DF\3002'),
unistr('\4F8B\5982, \5982\679C\8F93\5165\4E86 <code>yahoo.com</code> \57DF, \5219 <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> \548C <code>finance.yahoo.com</code> \5168\90E8\53EF\4EE5\8BBF\95EE\540C\4E00\4E2A Cookie\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986875640312312)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Cookie \57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986527977312312)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4F1A\8BDD Cookie \7684\540D\79F0, \6B64\540D\79F0\4E0E URL \4E2D\7684\4F1A\8BDD ID \4E00\8D77\7528\6765\6807\8BC6 &PRODUCT_NAME. \4F1A\8BDD\3002'),
unistr('\5982\679C\672A\6307\5B9A\4F1A\8BDD Cookie \540D\79F0, &PRODUCT_NAME. \5C06\4F7F\7528\9ED8\8BA4\503C\3002</p>'),
unistr('<p>\901A\8FC7\5728\591A\4E2A\5E94\7528\7A0B\5E8F\4E2D\8F93\5165\76F8\540C\7684 Cookie \540D\79F0, \5404\5E94\7528\7A0B\5E8F\53EF\4EE5\4F7F\7528\76F8\540C\7684\4F1A\8BDD Cookie\3002'),
unistr('\56E0\6B64, \4F7F\7528\76F8\540C Cookie \540D\79F0\7684\4ECE\4E00\4E2A &PRODUCT_NAME. \5E94\7528\7A0B\5E8F\5230\53E6\4E00\4E2A &PRODUCT_NAME. \5E94\7528\7A0B\5E8F\7684 URL \8C03\7528\4E0D\8981\6C42\7528\6237\91CD\65B0\9A8C\8BC1, \56E0\4E3A\65B0\5E94\7528\7A0B\5E8F\53EF\4EE5\4F7F\7528\73B0\6709\7684\4F1A\8BDD Cookie\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986427717312312)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Cookie \540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986769350312312)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4F1A\8BDD Cookie \7684 URL \8DEF\5F84\5C5E\6027\3002'),
unistr('\5982\679C\8BF7\6C42 URL \7684\5F00\5934\4E0E\6307\5B9A\7684\8DEF\5F84\4E0D\5339\914D, \5219\4E0D\4F1A\5C06 Cookie \53D1\9001\5230\6D4F\89C8\5668\3002'),
unistr('\9ED8\8BA4\503C\662F\8BF7\6C42 URL \7684\8DEF\5F84\3002</p>'),
unistr('<p>\5F53\60A8\5E0C\671B\5728\6700\521D\7B26\5408 URL \8DEF\5F84\7684\5E94\7528\7A0B\5E8F\4E4B\95F4\5171\4EAB\4F1A\8BDD Cookie \65F6, \4F7F\7528\6B64\5C5E\6027\53EF\4EE5\6307\5B9A\9650\5236\8F83\5C11\7684\8DEF\5F84\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986640682312312)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Cookie \8DEF\5F84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406732824312649)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6807\51C6\6587\4EF6\5F15\7528</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>\6807\51C6\6587\4EF6\5F15\7528 (\4ECE /mycss/minified/ \52A0\8F7D\7F29\51CF\7248\6587\4EF6 main.min.css \4EE5\6EE1\8DB3\5E38\89C4\9875\8BBF\95EE\9700\6C42, \5E76\5728\8C03\8BD5\6A21\5F0F\4E0B\6216\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\4ECE /mycss/ \52A0\8F7D main.css)\3002</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
unistr('<dt>\6761\4EF6\4ECB\8D28\67E5\8BE2</dt>'),
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>\6587\4EF6\5F15\7528 (\5728\5F15\7528\5E94\7528\7A0B\5E8F\7248\672C\7684 URL \4E2D\4F7F\7528\67E5\8BE2\5B57\7B26\4E32, \8FD9\6837\5728\5347\7EA7\5E94\7528\7A0B\5E8F (\5E76\9012\589E\7248\672C) \65F6, \7CFB\7EDF\5C06\6307\793A\6D4F\89C8\5668\59CB\7EC8\52A0\8F7D\65B0\6587\4EF6, \5E76\5FFD\7565\4EE5\524D\9AD8\901F\7F13\5B58\7684\6240\6709\6587\4EF6)\3002</dt>'),
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893336891312241)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\6B64\9875\4E0A\52A0\8F7D\7684\7EA7\8054\6837\5F0F\8868 (CSS) \6587\4EF6 URL\3002\5404 URL \5FC5\987B\5199\5165\5230\65B0\884C\4E0A\3002'),
unistr('\5982\679C\63D0\4F9B\6587\4EF6\7684\7F29\51CF\7248, \5219\53EF\4EE5\4F7F\7528\66FF\6362\5B57\7B26\4E32 <code>#MIN#</code> \5C06 <code>.min</code> \5305\542B (\6216\4F7F\7528 <code>#MIN_DIRECTORY#</code> \5305\542B <code>minified/</code>) \5728\6587\4EF6 URL \4E2D\4EE5\6EE1\8DB3\5E38\89C4\9875\8BBF\95EE\9700\6C42; \5982\679C\5728\8C03\8BD5\6A21\5F0F\4E0B\6216\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\67E5\770B\6B64\9875, \5219\53EF\4EE5\4F7F\7528\7A7A\5B57\7B26\4E32\3002'),
unistr('\5982\679C\8981\5728\6587\4EF6 URL \4E2D\5305\542B\5E94\7528\7A0B\5E8F\7684\7248\672C, \60A8\8FD8\53EF\4EE5\8BBF\95EE\66FF\6362\5B57\7B26\4E32 <code>#APP_VERSION#</code>\3002</p>'),
unistr('<p>\6B64\5904\8F93\5165\7684\6587\4EF6 URL \5C06\66FF\6362\9875\6A21\677F\4E2D\7684 <code>#PAGE_CSS#</code> \66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('<p>\6CE8: \65E0\9700\5305\542B\5F00\59CB\6216\7ED3\675F <code>link</code> \6807\8BB0\3002\53EA\9700\5305\542B\6587\4EF6 URL \5373\53EF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893228323312241)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439562190312678)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A <code>color:#FF0000;</code> \4F1A\5C06\5217\7684\6587\672C\989C\8272\66F4\6539\4E3A\7EA2\8272\5E76\751F\6210\4EE5\4E0B HTML</dt>'),
'<dd><pre>',
unistr('&lt;span style="color:#FF0000"&gt;\793A\4F8B\6570\636E&lt;/span&gt;'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257020181312529)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5E94\7528\4E8E\6B64\5217\503C\7684 CSS \6837\5F0F\3002\53EF\4EE5\952E\5165 CSS \6837\5F0F\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256904202312529)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230067679312506)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5206\9694\7B26\4EE5\6807\8BB0\6570\636E\503C\7684\8D77\59CB\548C\7EC8\6B62\8FB9\754C\3002\9ED8\8BA4\5206\9694\7B26\4E3A\53CC\5F15\53F7\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229975572312506)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSV \5C01\95ED\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264958876312536)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5C06\62A5\8868\5185\5BB9\4E0B\8F7D\5230 CSV \6587\4EF6\3002\8981\542F\7528 <em>CSV \4E0B\8F7D</em>\FF0C\5FC5\987B\4F7F\7528\5E26\6709 <code>#CSV_LINK#</code> \66FF\6362\5B57\7B26\4E32\7684\62A5\8868\6A21\677F\FF0C\5E76\5C06\6B64\9009\9879\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264845639312535)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSV \5BFC\51FA\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229860848312506)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5217\5206\9694\7B26\3002\5982\679C\672A\8F93\5165\4EFB\4F55\503C, \5C06\4F7F\7528\9017\53F7\6216\5206\53F7, \5177\4F53\53D6\51B3\4E8E\5F53\524D\7684 NLS \8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229708746312506)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSV \5206\9694\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897846728312244)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7B2C\4E00\6B21\8FDB\5165\9875\65F6\662F\5426\805A\7126\6E38\6807\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400335748312644)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7684\7B2C\4E00\4E2A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400442696312644)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\7531 &PRODUCT_NAME. \5F15\64CE\751F\6210\7684 JavaScript \5C06\6E38\6807\805A\7126\653E\5728\9875\7684\7B2C\4E00\4E2A\5B57\6BB5\4E0A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400571254312644)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\805A\7126\6E38\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400623209312644)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0D\805A\7126\6E38\6807\4E14\4E0D\751F\6210 JavaScript\3002<br>'),
unistr('\5982\679C\751F\6210\7684 JavaScript \4E0E\5B9A\5236 JavaScript \51B2\7A81, \5219\9009\62E9\6B64\9009\9879\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892471543312240)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E38\6807\805A\7126')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990578096312315)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\533A\57DF\4E2D\7684\663E\793A\5C5E\6027\80FD\5426\7531\7528\6237\5B9A\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421394285312664)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7531\6700\7EC8\7528\6237\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421202007312664)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\60C5\51B5\4E0B\53EF\5B9A\5236\4E14\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421194159312664)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\60C5\51B5\4E0B\53EF\5B9A\5236\4F46\4E0D\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990499874312315)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989542450312314)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5728\6B64\533A\57DF\4E0B\65B9\663E\793A\7684\94FE\63A5\7684\6807\7B7E, \6B64\6807\7B7E\63D0\4F9B\5BF9\533A\57DF\5B9A\5236\9875\7684\8BBF\95EE\6743\9650\3002'),
unistr('\4EC5\4E3A\53EF\5B9A\5236\7684\533A\57DF\663E\793A\6B64\6807\7B7E\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989480961312314)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295072386312561)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\4E3A\6B64\6309\94AE\5305\62EC\7684 HTML \6587\672C:'),
'<ul>',
unistr('  <li>\5BF9\4E8E <strong>HTML \6309\94AE</strong>\7C7B\578B\7684\6309\94AE, \6B64\6587\672C\5C06\6DFB\52A0\5230 HTML \5143\7D20\5B9A\4E49\3002</li>'),
unistr('  <li>\5BF9\4E8E\57FA\4E8E\6A21\677F\7684\6309\94AE, \60A8\7684\6A21\677F\5FC5\987B\5305\62EC <code>#BUTTON_ATTRIBUTES#</code> \66FF\6362\5B57\7B26\4E32\3002</li>'),
'</ul>',
unistr('<p>\53EF\4EE5\4F7F\7528\6B64\5C5E\6027\6765\63A7\5236\5236\8868\4F4D</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295284616312561)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6B64\503C\66FF\6362\62A5\8868\6A21\677F\66FF\6362\5B57\7B26\4E32 <code>#REPORT_ATTRIBUTES#</code>\3002<code>#REPORT_ATTRIBUTES#</code> \66FF\6362\5B57\7B26\4E32\4EC5\5728\62A5\8868\6A21\677F\7684\201C\884C\4E4B\524D\201D\5C5E\6027\4E2D\66FF\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135198406312431)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\5305\542B\5728\8868\5355\5143\7D20 HTML \6807\8BB0\4E2D\7684\9644\52A0\5C5E\6027\3002\4F1A\751F\6210 <code>size</code> \548C <code>id</code> HTML \5C5E\6027, \56E0\6B64\4E0D\5E94\63D0\4F9B\8FD9\4E24\4E2A\5C5E\6027\3002\5BF9\4E8E <code>class</code> HTML \5C5E\6027, \6700\597D\6539\7528\4E13\7528\7684 <em>CSS \7C7B</em>\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294954319312560)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\5305\542B\5728\8868\5355\5143\7D20 HTML \6807\8BB0\4E2D\7684\9644\52A0\5C5E\6027\3002\4F1A\751F\6210 <code>size</code> \548C <code>id</code> HTML \5C5E\6027, \56E0\6B64\4E0D\5E94\63D0\4F9B\8FD9\4E24\4E2A\5C5E\6027\3002\5BF9\4E8E <code>class</code> HTML \5C5E\6027, \6700\597D\6539\7528\4E13\7528\7684 <em>CSS \7C7B</em>\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295171600312561)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\66FF\6362\533A\57DF\5C5E\6027\7684\503C\3002\4F7F\7528\6B64\503C\66FF\6362\5305\542B\66FF\6362\5B57\7B26\4E32 <code>#REGION_ATTRIBUTES#</code> \7684\533A\57DF\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295340505312561)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6B64\503C\66FF\6362\62A5\8868\6A21\677F\66FF\6362\5B57\7B26\4E32 <code>#REPORT_ATTRIBUTES#</code>\3002<code>#REPORT_ATTRIBUTES#</code> \66FF\6362\5B57\7B26\4E32\4EC5\5728\62A5\8868\6A21\677F\7684\201C\884C\4E4B\524D\201D\5C5E\6027\4E2D\66FF\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294825021312560)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\5305\62EC\5728\9879\6807\8BB0\4E2D\7684\4EE5\7A7A\683C\5206\9694\7684\9644\52A0\5C5E\6027\3002'),
unistr('\5BF9\4E8E HTML CLASS \5C5E\6027, Oracle \5EFA\8BAE\4F7F\7528\4E13\7528\7684 CSS \7C7B\5C5E\6027\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294787722312560)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206141952312487)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\5B9A\4E49\5B9A\5236\5DE5\5177\63D0\793A\7684\5B9A\5236\5217\540D\FF0C\6216\7528\4E8E\56FE\8868\5143\7D20\7684\57FA\4E8E\6570\636E\5E93\7684\989C\8272\3002\5BF9\4E8E\7BB1\7EBF\56FE\FF0C\5217\4E0D\5F97\4E0E\6240\9009\503C\5217\6620\5C04\76F8\5339\914D\3002\9009\62E9\4E0E\503C\5217\6620\5C04\76F8\5339\914D\7684\5217\5C06\5BFC\81F4\6CA1\6709\7528\4E8E\56FE\8868\7684\5B9A\5236\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206036392312487)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\5217 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896305996312243)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\63D0\4F9B\7684\58F0\660E\4E8B\4EF6\4E0D\8DB3, \8BF7\6307\5B9A\5B9A\5236 JavaScript \4E8B\4EF6\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896296048312243)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212897260312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6570\636E\5E93\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213383551312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212927668312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213078942312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\5355\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213111935312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213243416312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212787707312493)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450653226312687)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291293940312558)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\65E5\5386\4E2D\6240\793A\6570\636E\7684\80CC\666F\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291180399312558)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\80CC\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726095804312112)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4F5C\6B64\9879\503C\6E90\7684\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\3002</p>'),
unistr('<p>\6B64\5217\5FC5\987B\5B58\5728\4E8E\5728\8868\5355\533A\57DF\4E2D\6307\5B9A\7684\6570\636E\6E90\4E2D\3002'),
unistr('\5982\679C\5217\540D\4E0D\5B58\5728\4E8E\5F15\7528\7684\8868\4E2D\FF0C\5219\5C06\5728\8FD0\884C\65F6\5F15\53D1\9519\8BEF\FF0C\5E76\4E14\4E0D\52A0\8F7D\8BE5\9875\3002'),
unistr('\540C\6837\FF0C\5982\679C\672A\5B9A\4E49\5185\7F6E\63D0\53D6\884C\5904\7406\4F46\5B58\5728\6E90\7C7B\578B\4E3A<strong>\6570\636E\5E93\5217</strong>\7684\9879\FF0C\5219\5C06\5F15\53D1\9519\8BEF\FF0C\5E76\4E14\5728\5C1D\8BD5\5448\73B0\8BE5\9875\65F6\5C06\4E0D\4F1A\52A0\8F7D\8BE5\9875\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725947627312112)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725839142312112)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\9875\9879\7684\5173\8054\8868\5355\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725700943312112)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491105159312718)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291451428312558)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\65E5\5386\4E2D\7684\6570\636E\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291310745312558)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131065047312427)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\57FA\7840\6570\636E\5E93\5217\7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797416229312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'zh-cn'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797248188312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'zh-cn'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797142711312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'zh-cn'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796576357312962)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DATE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797085680312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'zh-cn'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796937861312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'zh-cn'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796423854312962)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797334495312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'zh-cn'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796730877312166)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796665751312962)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'zh-cn'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796890362312963)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'zh-cn'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796786235312962)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'zh-cn'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796362522312962)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'zh-cn'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130946914312427)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288248250312555)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5305\542B\65E5\5386\4E0A\5C06\663E\793A\7684\65E5\671F\7684\8868\6216\67E5\8BE2\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288136652312555)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288454803312555)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5E0C\671B\5728\65E5\5386\4E0A\663E\793A\65F6\95F4\8FD8\662F\4EC5\663E\793A\65E5\671F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108288339042312555)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256224440312528)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5E94\7528\4E8E\6B64\5217\7684\65E5\671F\9009\53D6\5668\7684\683C\5F0F\63A9\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436632861312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436449092312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436549033312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437283465312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437026419312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437133721312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436973439312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436763442312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436864488312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437300451312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437573231312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437429758312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437669827312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437805460312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437744963312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108437949349312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'zh-cn'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438103611312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438001501312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438286475312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'zh-cn'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438486752312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438304344312677)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436146534312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5E94\7528\7A0B\5E8F\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436200951312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5E94\7528\7A0B\5E8F\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108436316684312676)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9879\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438593615312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438786315312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438613634312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438839614312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439281474312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439355003312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439065326312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439132914312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108438955767312678)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256156348312528)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292529883312559)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\76EE\6807\201D\53EF\8C03\7528\6A21\5F0F\5BF9\8BDD\6846\3002\53EF\4EE5\8F93\5165\901A\8FC7\5355\51FB\73B0\6709\4E8B\4EF6\5916\90E8\7684\65E5\5386\5355\5143\521B\5EFA\4E8B\4EF6\65F6\65E5\5386\8C03\7528\7684\76EE\6807\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292405778312559)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920722123312262)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\6267\884C\7684\64CD\4F5C\3002\652F\6301\4EE5\4E0B\64CD\4F5C:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\636E\5E94\7528\7A0B\5E8F\914D\7F6E, \6B64\5904\53EF\80FD\8FD8\6709\5176\4ED6\52A8\6001\64CD\4F5C\63D2\4EF6\53EF\7528\3002'),
unistr('\8FD9\4E9B\63D2\4EF6\663E\793A\4E3A <em>&lt;\6211\7684\63D2\4EF6&gt; [\63D2\4EF6]</em>\3002'),
unistr('\5728\6B64\5E94\7528\7A0B\5E8F\7684\5171\4EAB\7EC4\4EF6\5185\5B89\88C5\4EE5\4E0B\63D2\4EF6:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920689558312262)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244192925312518)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\53EF\7528\5217\8868\4E2D\9009\62E9\9002\5F53\7684\52A8\6001\64CD\4F5C\4E8B\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244034481312518)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607251588312809)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664 PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607172818312809)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316 PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276171423312545)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9ED8\8BA4\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717235224312894)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5728\5E94\7528\7A0B\5E8F\5B89\5168\5C5E\6027\4E2D\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900277944312246)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5982\4F55\5904\7406\6B64\9875\7684\5916\90E8 URL \8BF7\6C42\3002'),
unistr('\6B64\5E94\7528\7A0B\5E8F\5BF9\6B64\9875\7684\9875\8BF7\6C42\4E0D\4F1A\88AB\89C6\4E3A\6DF1\94FE\63A5, \4E0D\7531\6B64\5C5E\6027\7684\8BBE\7F6E\63A7\5236\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401256899312645)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401332460312645)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C URL \4E2D\4E0D\5305\542B\6709\6548\7684\4F1A\8BDD ID, \5219 &PRODUCT_NAME. \5C06\542F\52A8\4E00\4E2A\65B0\4F1A\8BDD, \5E76\5C06\7528\6237\91CD\5B9A\5411\5230\5E94\7528\7A0B\5E8F\7684\4E3B\9875\800C\4E0D\662F\6B64\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401096100312645)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401141537312645)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5728 URL \4E2D\5C06\6B64\9875\6307\5B9A\4E3A\76EE\6807\9875, URL \6700\7EC8\5C06\91CD\5B9A\5411\5230\6B64\9875\3002<br>'),
unistr('\5982\679C\7528\6237\5C1A\672A\9A8C\8BC1\4E14\9875\4E0D\662F\516C\5171\9875, \5219\7CFB\7EDF\5C06\63D0\793A\7528\6237\767B\5F55\3002'),
unistr('\6210\529F\767B\5F55\5230\5E94\7528\7A0B\5E8F\540E, \7528\6237\4F1A\91CD\5B9A\5411\5230\6B64\9875\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900197148312246)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041335698312356)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\6237\754C\9762\662F\5426\4E3A\9ED8\8BA4\5E94\7528\7A0B\5E8F\754C\9762\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041265178312356)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890300943312239)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5BFC\51FA\65F6\5E94\7528\4E8E\6B64\7EC4\4EF6\7684\9ED8\8BA4\6784\5EFA\9009\9879\3002\6B64\9009\9879\53EF\7531\5BFC\51FA\9009\9879\8986\76D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398741701312643)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708715426312887)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528, \4E0D\662F\5E94\7528\7A0B\5E8F\7684\4E00\90E8\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398844184312643)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708800595312887)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528, \662F\5E94\7528\7A0B\5E8F\7684\4E00\90E8\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890235652312238)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA\65F6\7684\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131882285312428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\786E\5B9A\6B64\5217\7684\9ED8\8BA4\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631852583312828)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631940284312828)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\8868\8FBE\5F0F</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632079654312828)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632128079312828)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132153190312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132280564312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132791190312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132811936312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\5E8F\5217</em>\8FD4\56DE\7684\503C\3002\8FD9\662F\201C\7279\6B8A\201D\7684\9ED8\8BA4\7C7B\578B\FF1A\5B83\5728\4EA4\4E92\5F0F\7F51\683C DML \5904\7406\8FC7\7A0B\4E2D\6267\884C\FF0C\800C<em>\4E0D\662F</em>\5728\52A0\8F7D\9875\7684\8FC7\7A0B\4E2D\6267\884C\3002\65E0\6CD5\4F7F\7528<strong>\63D2\5165\540E\8FD4\56DE\4E3B\952E</strong>\65F6\FF08\4F8B\5982\4F7F\7528\89C6\56FE\548C INSTEAD OF \89E6\53D1\5668\6216\4F7F\7528\6570\636E\5E93\94FE\63A5\65F6\FF09\FF0C\5BF9\81EA\52A8\751F\6210\7684\4E3B\952E\503C\4F7F\7528\6B64\7C7B\578B\3002\5E8F\5217\540D\533A\5206\5927\5C0F\5199\FF1B\4F7F\7528\53CC\5F15\53F7\6765\6307\793A\5927\5C0F\5199\6DF7\5408\7684\5E8F\5217\540D ("mySequence")\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132391956312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132462472312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132562159312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5192\53F7\5206\9694\5217\8868\7684 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132675810312429)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\5192\53F7\5206\9694\503C\5217\8868\3002</p>'),
unistr('        <p>\6CE8 - \5F53\5217\663E\793A\4E3A\590D\9009\6846, \5355\9009\7EC4\6216\5F80\8FD4\6309\94AE\65F6, \9700\8981\5192\53F7\5206\9694\5217\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131920964312428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132032647312428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\9759\6001</em>\503C\4E2D\8F93\5165\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131780974312428)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654929524312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655389908312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655218691312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655107912312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655453613312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655063626312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654844796312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656973771312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657225113312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657121081312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657096843312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657307804312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656851308312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279843855312548)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5B58\653E\9ED8\8BA4\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279724772312548)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656567451312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\751F\6210\503C\7684 Java \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656486186312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658144713312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\8FD4\56DE\503C\7684 Java \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658045866312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656379291312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656248329312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\751F\6210\503C\7684 JavaScript \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656172175312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657932427312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657893349312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\8FD4\56DE\503C\7684 JavaScript \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657764696312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656028420312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655943732312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\751F\6210\503C\7684 PL/SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655891127312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657616121312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657516713312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\8FD4\56DE\503C\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108657459174312848)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656749085312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\751F\6210\503C\7684 Python \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108656694849312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658378216312849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\8FD4\56DE\503C\7684 Python \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658226866312849)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133476153312430)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\5217\8FD4\56DE\9ED8\8BA4\503C\7684\6570\636E\5E93\5E8F\5217\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133387993312429)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655766734312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655644621312847)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\9879\751F\6210\503C\7684 SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108655552214312846)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133087208312429)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\5217\8FD4\56DE\9ED8\8BA4\503C\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108132900399312429)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133245938312429)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\6B64\5217\8FD4\56DE\9ED8\8BA4\7684\5192\53F7\5206\9694\503C\5217\8868\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133192996312429)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\5192\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913936268312257)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\9879\7684\9ED8\8BA4\503C\3002\5F53\9879\503C\4E0D\4ECE\4F1A\8BDD\72B6\6001\6D3E\751F\4E14\6E90\503C\4E3A\7A7A\503C\65F6, \4F7F\7528\6B64\9ED8\8BA4\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913874664312257)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913796667312257)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\9879\7684\9ED8\8BA4\503C\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631217345312828)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631323081312828)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\8868\8FBE\5F0F</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631473842312828)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631566742312828)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724632298312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724767565312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725283120312112)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725320177312112)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\5E8F\5217</em>\8FD4\56DE\7684\503C\3002\8FD9\662F\201C\7279\6B8A\201D\7684\9ED8\8BA4\7C7B\578B\FF1A\5B83\5728\8868\5355\533A\57DF DML \5904\7406\8FC7\7A0B\4E2D\6267\884C\FF0C\800C<em>\4E0D\662F</em>\5728\52A0\8F7D\9875\7684\8FC7\7A0B\4E2D\6267\884C\3002\65E0\6CD5\4F7F\7528<strong>\63D2\5165\540E\8FD4\56DE\4E3B\952E</strong>\65F6\FF08\4F8B\5982\4F7F\7528\89C6\56FE\548C INSTEAD OF \89E6\53D1\5668\6216\4F7F\7528\6570\636E\5E93\94FE\63A5\65F6\FF09\FF0C\5BF9\81EA\52A8\751F\6210\7684\4E3B\952E\503C\4F7F\7528\6B64\7C7B\578B\3002\5E8F\5217\540D\533A\5206\5927\5C0F\5199\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724853519312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724922459312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725094995312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5192\53F7\5206\9694\5217\8868\7684 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725164525312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\5192\53F7\5206\9694\503C\5217\8868\3002</p>'),
unistr('        <p>\6CE8 - \5F53\5217\663E\793A\4E3A\590D\9009\6846, \5355\9009\7EC4\6216\5F80\8FD4\6309\94AE\65F6, \9700\8981\5192\53F7\5206\9694\5217\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416032706312657)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724571297312111)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\9759\6001</em>\503C\4E2D\8F93\5165\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913629948312257)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143490713312437)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\4EA4\4E92\5F0F\7F51\683C\5B9A\4E49\56FE\8868\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143318621312437)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49\56FE\8868\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119068938312418)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6388\6743\65B9\6848\4EE5\9650\5236\53EF\4EE5\5220\9664\884C\7684\7528\6237\3002'),
unistr('		\8981\4F7F\67D0\4E2A\6700\7EC8\7528\6237\53EF\4EE5\5220\9664\884C, \8BE5\7528\6237\7684\6B64\6388\6743\65B9\6848\5FC5\987B\6C42\503C\4E3A TRUE\3002'),
unistr('		\5982\679C\672A\63D0\4F9B\6388\6743\65B9\6848, \5219\53EF\4EE5\7531\4EFB\4F55\7528\6237\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E2D\5220\9664\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118971897312418)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252495443312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\68C0\67E5\5176\4ED6\9762\6216\7B5B\9009\5668\7684\503C\7684\6761\4EF6\FF0C\4EE5\63A7\5236\662F\5426\5E94\663E\793A\5F53\524D\9762\6216\7B5B\9009\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252593310312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B49\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252675583312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\4F9D\8D56<em>\9762\6216\7B5B\9009\5668</em>\7684\503C\662F\5426\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252929650312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253051489312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\4F9D\8D56<em>\9762\6216\7B5B\9009\5668</em>\7684\503C\662F\5426\5728\6307\5B9A\7684<em>\5217\8868</em>\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252779452312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\7B49\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252881630312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\4F9D\8D56<em>\9762\6216\7B5B\9009\5668</em>\7684\503C\662F\5426\4E0D\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253167132312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253210542312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\4F9D\8D56<em>\9762\6216\7B5B\9009\5668</em>\7684\503C\662F\5426\4E0D\5728\6307\5B9A\7684<em>\5217\8868</em>\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253551363312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253653490312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\4F9D\8D56<em>\9762\6216\7B5B\9009\5668</em>\7684\503C\662F\5426\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253360443312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253476654312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\4F9D\8D56<em>\9762\6216\7B5B\9009\5668</em>\7684\503C\662F\5426\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252315807312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254086560312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253968407312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253810429312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108253742975312526)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252246874312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5E94\68C0\67E5\7684\5173\8054\9762\FF0C\4EE5\786E\5B9A\662F\5426\5E94\663E\793A\5F53\524D\9762\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108252125924312525)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577775389312786)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5E94\68C0\67E5\7684\5173\8054\590D\9009\6846\FF0C\4EE5\786E\5B9A\662F\5426\5E94\663E\793A\5F53\524D\590D\9009\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577659244312786)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940219267312277)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5E94\68C0\67E5\7684\5173\8054\7B5B\9009\5668\FF0C\4EE5\786E\5B9A\662F\5426\5E94\663E\793A\5F53\524D\7B5B\9009\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940105732312277)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940470725312277)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5E94\68C0\67E5\7684\5173\8054\590D\9009\6846\FF0C\4EE5\786E\5B9A\662F\5426\5E94\663E\793A\5F53\524D\590D\9009\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940388805312277)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492367443312719)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('$$$ DJP \5F53\524D\5DF2\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283247427312551)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3E\751F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797752918312963)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\4EA4\4E92\5F0F\62A5\8868\7684\8BF4\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226800085312503)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5217\7EC4\7684\8BF4\660E\3002\6B64\8BF4\660E\4ECE\4E0D\663E\793A\7ED9\6700\7EC8\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894384874312242)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8BF4\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894274593312242)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432701563312673)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235029150312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\663E\793A\5728\62A5\8868\884C\4E4B\540E\7684 HTML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234993479312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432563714312673)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234616759312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\663E\793A\5728\62A5\8868\884C\4E4B\524D\7684 HTML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234573490312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134302375312430)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\542F\7528\8BE6\7EC6\4FE1\606F\89C6\56FE\3002\9009\62E9<strong>\542F\7528</strong>\53EF\5C06\201C\67E5\770B\8BE6\7EC6\4FE1\606F\201D\56FE\6807\6DFB\52A0\5230\4EA4\4E92\5F0F\62A5\8868\7684\641C\7D22\680F\4E2D\FF0C\6216\6DFB\52A0\5230\4EA4\4E92\5F0F\7F51\683C\7684\201C\89C6\56FE\201D\6309\94AE\4E2D\FF0C\4EE5\4FBF\7528\6237\8BBF\95EE\6B64\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234435768312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\542F\7528\8BE6\7EC6\4FE1\606F\89C6\56FE\3002\9009\62E9<strong>\542F\7528</strong>\53EF\5C06\201C\67E5\770B\8BE6\7EC6\4FE1\606F\201D\56FE\6807\6DFB\52A0\5230\4EA4\4E92\5F0F\62A5\8868\7684\641C\7D22\680F\4E2D\FF0C\6216\6DFB\52A0\5230\4EA4\4E92\5F0F\7F51\683C\7684\201C\89C6\56FE\201D\6309\94AE\4E2D\FF0C\4EE5\4FBF\7528\6237\8BBF\95EE\6B64\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234371593312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795211350312961)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795330041312961)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\201C\8BE6\7EC6\8D44\6599\89C6\56FE\201D\4E2D\62A5\8868\884C\7684\6B63\6587\3002</p>'),
unistr('<p>\6709\4EE5\4E0B\66FF\6362\5B57\7B26\4E32\53EF\7528\FF1A'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \5217\540D\7684\66FF\6362\5B57\7B26\4E32\3002</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \5217\6807\7B7E\7684\66FF\6362\5B57\7B26\4E32\3002</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \884C\7684\8BB0\5F55\6807\8BC6\7B26\3002</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \8BB0\5F55\663E\793A\5E8F\5217\53F7\3002</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \8BB0\5F55\72B6\6001\FF0C\5982 <code>is-inserted</code> \6216 <code>is-deleted</code>\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432666679312673)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234858728312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8BE6\7EC6\4FE1\606F\89C6\56FE\4E2D\62A5\8868\884C\7684\6B63\6587\3002\4F7F\7528\5217\540D\7684 <code>#COLUMN_NAME#</code> \66FF\6362\5B57\7B26\4E32\548C\5217\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234741363312510)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E00\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894196203312242)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME. \4E2D\7684\5BF9\8BDD\6846\652F\6301\56E0\9875\7684\7528\6237\754C\9762\4E0D\540C\800C\5F02\3002'),
unistr('\4EE5\58F0\660E\65B9\5F0F\652F\6301\4E00\90E8\5206\5BF9\8BDD\6846\5C5E\6027: <em>\9AD8\5EA6, \5BBD\5EA6\548C\6700\5927\5BBD\5EA6</em>\3002'),
unistr('\8981\4E3A\5BF9\8BDD\6846\5B9A\4E49\4EFB\4F55\5176\4ED6\5C5E\6027, \8BF7\4EE5\9017\53F7\5206\9694\7684\5217\8868\5F62\5F0F\8F93\5165\540D\79F0/\503C\5BF9\3002</p>'),
unistr('<p>\5728\9875\6A21\677F\7EA7\5B9A\4E49\7684\5BF9\8BDD\6846\521D\59CB\5316\4EE3\7801\4E2D\7684\66FF\6362\5B57\7B26\4E32 <code>#DIALOG_ATTRIBUTES#</code> \5C06\66FF\6362\4E3A\5728\6B64\9879\4E2D\8F93\5165\7684\4EFB\4F55\503C\3002</p>'),
unistr('<p>\5BF9\4E8E\4F7F\7528\201C\684C\9762\201D\7528\6237\754C\9762\7684\9875, \5C06\5229\7528 jQuery UI \5BF9\8BDD\6846\5C0F\90E8\4EF6\3002'),
unistr('\5BF9\4E8E\4F7F\7528 jQuery Mobile \667A\80FD\624B\673A\7528\6237\754C\9762\7684\9875, \5C06\5229\7528 jQuery Mobile \5BF9\8BDD\6846\5C0F\90E8\4EF6\3002</p>'),
unistr('<p>\4F8B\5982, \4F7F\7528\201C\684C\9762\201D\7528\6237\754C\9762\7684\5BF9\8BDD\6846\9875\53EF\80FD\5B9A\4E49\6709\4EE5\4E0B\5C5E\6027: <code>resizable:true, draggable:true</code></p>'),
unistr('<p>\6709\5173\53EF\7528\5C5E\6027\7684\8FDB\4E00\6B65\4FE1\606F, \8BF7\53C2\9605 <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery UI \5BF9\8BDD\6846\5C0F\90E8\4EF6\6587\6863</a>\548C <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">jQuery Mobile \5BF9\8BDD\6846\5C0F\90E8\4EF6\6587\6863</a>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107894034514312241)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584601207312792)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\6B64\5BF9\8BDD\6846\7531\53E6\4E00\5BF9\8BDD\6846\6253\5F00\5E76\4E14\5E94\91CD\7528\540C\4E00\5BF9\8BDD\6846\7A97\53E3\FF0C\5219\9009\62E9<strong>\542F\7528</strong>\3002'),
unistr('\4F8B\5982\FF0C\6B64\5BF9\8BDD\6846\662F\591A\9875\5BF9\8BDD\6846\5411\5BFC\7684\4E00\90E8\5206\FF0C\5E76\4E14\60A8\5E0C\671B\5BF9\5411\5BFC\7684\6BCF\4E00\6B65\91CD\7528\5BF9\8BDD\6846\7A97\53E3\3002<p><p>'),
unistr('\5982\679C\6B64\5BF9\8BDD\6846\7531\53E6\4E00\5BF9\8BDD\6846\6253\5F00\5E76\4E14\5E94\5728\65B0\5BF9\8BDD\6846\7A97\53E3\4E2D\6253\5F00\FF0C\5219\9009\62E9<strong>\5173\95ED</strong>\3002\4F8B\5982\FF0C\6B64\5BF9\8BDD\6846\4E3A\6A21\5F0F\FF0C'),
unistr('\5E76\4E14\60A8\5E0C\671B\5728\7236\6A21\5F0F\5BF9\8BDD\6846\7A97\53E3\4E2D\6253\5F00\5B83\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584559731312792)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295984400312561)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295854445312561)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984479422312310)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4EE5\50CF\7D20\4E3A\5355\4F4D\7684\5BF9\8BDD\6846\9AD8\5EA6, \4F8B\5982 <strong><em>500</em></strong>\3002'),
unistr('\9875\6A21\677F\7684\5BF9\8BDD\6846\521D\59CB\5316\4EE3\7801\4E2D\7684\66FF\6362\5B57\7B26\4E32 <code>#DIALOG_HEIGHT#</code> \4F1A\66FF\6362\4E3A\8F93\5165\7684\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984349597312310)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893901701312241)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\50CF\7D20\4E3A\5355\4F4D\8F93\5165\5BF9\8BDD\6846\7684\6700\5927\5BBD\5EA6\3002'),
unistr('\9875\6A21\677F\7684\5BF9\8BDD\6846\521D\59CB\5316\4EE3\7801\4E2D\7684\66FF\6362\5B57\7B26\4E32 <code>#DIALOG_MAX_WIDTH#</code> \5C06\66FF\6362\4E3A\5728\6B64\9879\4E2D\8F93\5165\7684\503C\3002</p>'),
unistr('<p>\5BF9\4E8E\4F7F\7528 jQuery Mobile \667A\80FD\624B\673A\7528\6237\754C\9762\7684\9875, \6700\5927\5BBD\5EA6\4E3A <strong><em>500</em></strong>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893886862312241)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275840406312545)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029422229312347)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5BF9\8BDD\6846\6A21\677F\4EE5\5B9A\4E49\6B64\9875\7684\5916\89C2\548C\5E03\5C40\3002</p>'),
unistr('        <p>\5BF9\8BDD\6846\6A21\677F\5728\5E94\7528\7A0B\5E8F\4E3B\9898\4E2D\5B9A\4E49\3002'),
unistr('        \521B\5EFA\5BF9\8BDD\6846\9875\65F6, \6A21\677F\81EA\52A8\8BBE\7F6E\4E3A<em>\4E3B\9898\9ED8\8BA4\503C</em>, \8FD9\4F1A\4F7F\7528\5728\5F53\524D\4E3B\9898\4E2D\5B9A\4E49\7684\9ED8\8BA4\9875\6A21\677F\5448\73B0\9875\3002'),
unistr('        \5728\6B64\5904\8FDB\884C\7684\9009\62E9\5C06\8986\76D6\9ED8\8BA4\5BF9\8BDD\6846\6A21\677F\3002</p>'),
unistr('        <p>\901A\7528\4E3B\9898\63D0\4F9B\4EE5\4E0B\5BF9\8BDD\6846\6A21\677F:'),
'          <dl>',
unistr('            <dt>\6A21\5F0F\5BF9\8BDD\6846</dt>'),
unistr('              <dd>\53EF\7528\4E8E\5927\90E8\5206\5BF9\8BDD\6846\7528\4F8B\3002</dd>'),
unistr('            <dt>\5411\5BFC\6A21\5F0F\5BF9\8BDD\6846</dt>'),
unistr('              <dd>\63D0\4F9B\7B80\5316\7684\7528\6237\754C\9762, \975E\5E38\9002\7528\4E8E\6A21\5F0F\5BF9\8BDD\6846\5411\5BFC, \9884\8B66, \901A\77E5\6216\5C0F\578B\8868\5355\3002</dd>'),
'          </dl>',
unistr('          \53E6\8BF7\53C2\9605: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029390531312347)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893728508312241)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\50CF\7D20\6216\767E\5206\6BD4\5F62\5F0F\8F93\5165\5BF9\8BDD\6846\7684\5BBD\5EA6\3002'),
unistr('\9875\6A21\677F\7684\5BF9\8BDD\6846\521D\59CB\5316\4EE3\7801\4E2D\7684\66FF\6362\5B57\7B26\4E32 <code>#DIALOG_WIDTH#</code> \5C06\66FF\6362\4E3A\5728\6B64\9879\4E2D\8F93\5165\7684\503C\3002</p>'),
unistr('<p>\5BF9\4E8E\4F7F\7528\684C\9762\7528\6237\754C\9762\7684\9875, \4EE5\50CF\7D20\4E3A\5355\4F4D\8BBE\7F6E\6B64\503C, \4F8B\5982 <strong><em>500</em></strong>\3002'),
unistr('\4F46\662F, \5BF9\4E8E\4F7F\7528 jQuery Mobile \667A\80FD\624B\673A\7528\6237\754C\9762\7684\9875, \4EE5\767E\5206\6BD4\5F62\5F0F\8BBE\7F6E\6B64\503C, \4F8B\5982 <strong><em>80%</em></strong>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893687807312241)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211731216312492)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\53C2\6570\7684\65B9\5411\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211891773312492)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212077256312492)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165/\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211929090312492)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211657070312492)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257862672312530)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4F7F\7528\6B64\5217\5BF9\62A5\8868\6392\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257712766312530)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289420239312556)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\65E5\5386\5355\5143\4E2D\663E\793A\7684\5355\4E00\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289387281312556)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905149090312250)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9879\53EF\80FD\6709\4F1A\8BDD\72B6\6001\503C, \4F46\4E0D\51FA\73B0\5728\7ED9\5B9A\7684\503C\5217\8868\5B9A\4E49\4E2D\3002'),
unistr('\9009\62E9\6B64\503C\5217\8868\662F\5426\663E\793A\6B64\989D\5916\4F1A\8BDD\72B6\6001\503C\3002'),
unistr('\5982\679C\9009\62E9\4E0D\663E\793A\6B64\989D\5916\4F1A\8BDD\72B6\6001\503C\4E14\5728\503C\5217\8868\5B9A\4E49\4E2D\6CA1\6709\5339\914D\7684\503C, \5219\503C\5217\8868\4E2D\7684\7B2C\4E00\4E2A\503C\662F\9009\62E9\548C\663E\793A\7684\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905033101312250)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\9644\52A0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905398661312250)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\6B64\9879\7684\503C\5217\8868\662F\5426\5728\5217\8868\9876\90E8\663E\793A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905219618312250)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947955965312283)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\663E\793A\6B64\7EC4\4EF6\7684\4F4D\7F6E\3002\4F4D\7F6E\6D3E\751F\81EA\76F8\5E94\7684\9875\6216\533A\57DF\6A21\677F\663E\793A\70B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947802397312283)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603011755312806)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\6B64\64CD\4F5C\7684\663E\793A\5E8F\5217\3002'),
unistr('\8FD9\7528\4E8E\8BC4\4F30\663E\793A\6761\4EF6\5E76\6309\7167\6240\5B9A\4E49\7684\987A\5E8F\5448\73B0\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134726378312431)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\5217\7684\663E\793A\5E8F\5217\3002\5E8F\5217\8BBE\7F6E\786E\5B9A\5728\533A\57DF\5185\6B64\5217\76F8\5BF9\4E8E\5176\4ED6\5217\7684\663E\793A\4F4D\7F6E\3002</p>'),
unistr('<p>\6CE8: \5982\679C\540C\4E00\533A\57DF\5185\7684\4E24\5217\5177\6709\76F8\540C\7684\5E8F\5217\503C, \5219\5728\5BFC\51FA\5E94\7528\7A0B\5E8F\5E76\5BFC\5165\5230\5176\4ED6\73AF\5883 (\4F8B\5982, \6D4B\8BD5\6216\751F\4EA7\73AF\5883) \65F6, \53EF\80FD\4F1A\4EE5\4E0D\540C\7684\987A\5E8F\663E\793A\8FD9\4E24\5217\3002'),
unistr('\4E3A\786E\4FDD\4E00\81F4\6027, Oracle \5EFA\8BAE\4E3A\6BCF\4E00\9879\6307\5B9A\552F\4E00\7684\5E8F\5217\53F7, \6216\81F3\5C11\4E3A\540C\4E00\533A\57DF\5185\7684\90A3\4E9B\9879\6307\5B9A\552F\4E00\7684\5E8F\5217\53F7\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226780808312503)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\5217\7EC4\7684\663E\793A\987A\5E8F\3002\6B64\987A\5E8F\786E\5B9A\5217\7EC4\5728\8BE6\7EC6\4FE1\606F\89C6\56FE\4E2D\7684\663E\793A\987A\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560581870312774)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\5C42\7684\663E\793A\5E8F\5217\3002\5E8F\5217\8BBE\7F6E\786E\5B9A\5730\56FE\5C42\53E0\653E\5728\4E00\8D77\7684\663E\793A\987A\5E8F\3002\6570\5B57\8F83\9AD8\7684\5C42\663E\793A\5728\6570\5B57\8F83\4F4E\7684\5C42\7684\4E0A\9762\3002</p>'),
unistr('<p>\6CE8\FF1A\5982\679C\4E24\4E2A\5730\56FE\5C42\5177\6709\76F8\540C\7684\5E8F\5217\503C\FF0C\5219\5728\5BFC\51FA\5E94\7528\7A0B\5E8F\5E76\5BFC\5165\5230\5176\4ED6\73AF\5883\FF08\4F8B\5982\FF0C\6D4B\8BD5\6216\751F\4EA7\73AF\5883\FF09\65F6\FF0C\53EF\80FD\4F1A\4EE5\4E0D\540C\7684\987A\5E8F\663E\793A\8FD9\4E24\4E2A\5C42\3002'),
unistr('\4E3A\786E\4FDD\4E00\81F4\6027\FF0COracle \5EFA\8BAE\4E3A\6BCF\4E2A\5C42\6307\5B9A\552F\4E00\7684\5E8F\5217\53F7\FF0C\6216\81F3\5C11\4E3A\540C\4E00\5730\56FE\533A\57DF\5185\7684\90A3\4E9B\5C42\6307\5B9A\552F\4E00\7684\5E8F\5217\53F7\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923582678312264)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\9879\7684\663E\793A\5E8F\5217\3002\5E8F\5217\548C\5176\4ED6\5E03\5C40\8BBE\7F6E\786E\5B9A\4E86\6B64\9879\5728\533A\57DF\5185\76F8\5BF9\4E8E\5176\4ED6\9879\7684\663E\793A\4F4D\7F6E\3002</p>'),
unistr('<p>\6CE8: \5982\679C\540C\4E00\533A\57DF\5185\7684\4E24\9879\5177\6709\76F8\540C\7684\5E8F\5217\503C, \5219\5728\5BFC\51FA\5E94\7528\7A0B\5E8F\5E76\5BFC\5165\5230\5176\4ED6\73AF\5883 (\4F8B\5982, \6D4B\8BD5\6216\751F\4EA7\73AF\5883) \65F6, \53EF\80FD\4F1A\4EE5\4E0D\540C\7684\987A\5E8F\663E\793A\8FD9\4E24\9879\3002\4E3A\786E\4FDD\4E00\81F4\6027, Oracle \5EFA\8BAE\4E3A\6BCF\4E00\9879\6307\5B9A\552F\4E00\7684\5E8F\5217\53F7, \6216\81F3\5C11\4E3A\540C\4E00\533A\57DF\5185\7684\90A3\4E9B\9879\6307\5B9A\552F\4E00\7684\5E8F\5217\53F7\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923424427312264)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744653873312915)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6388\6743\65B9\6848\4EE5\9650\5236\53EF\4EE5\4E0B\8F7D\7684\7528\6237\3002'),
unistr('		\8981\4F7F\67D0\4E2A\6700\7EC8\7528\6237\53EF\4EE5\4E0B\8F7D\FF0C\8BE5\7528\6237\7684\6B64\6388\6743\65B9\6848\5FC5\987B\6C42\503C\4E3A TRUE\3002</p>'),
unistr('		<p>\6CE8 - \5982\679C\672A\63D0\4F9B\6388\6743\65B9\6848\FF0C\5219\53EF\4EE5\4F9B\4EFB\4F55\7528\6237\4E0B\8F7D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744544241312915)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267239264312537)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A CSV \4E0B\8F7D\6587\4EF6\7684\540D\79F0\3002\5982\679C\672A\6307\5B9A\540D\79F0, \5C06\4F7F\7528\6269\5C55\540D\4E3A .csv \7684\533A\57DF\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278302591312547)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A CSV \4E0B\8F7D\6587\4EF6\7684\540D\79F0\3002\5982\679C\672A\6307\5B9A\540D\79F0, \5C06\4F7F\7528\6269\5C55\540D\4E3A .csv \7684\533A\57DF\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262391006312533)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0B\8F7D\65F6\6587\6863\7684\6587\4EF6\540D\3002\8BF7\52FF\6307\5B9A\6587\4EF6\6269\5C55\540D\3002\4F1A\81EA\52A8\6DFB\52A0\6269\5C55\540D\3002\5982\679C\5C06\6B64\5C5E\6027\7559\7A7A, \5219\4F1A\5C06\533A\57DF\540D\79F0\7528\4F5C\6587\4EF6\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262292494312533)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229624990312506)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\68C0\67E5\7528\6237\5728\4E0B\8F7D\5F53\524D\6240\793A\5217\65F6\53EF\4F7F\7528\7684\4E0B\8F7D\683C\5F0F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430087252312671)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'zh-cn'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430122988312671)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'zh-cn'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430205404312671)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504954256312729)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229573473312506)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265134427312536)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\8C03\7528 CSV \4E0B\8F7D\7684\94FE\63A5\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265072046312536)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261591619312533)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\7528\4E8E\9875\4E0A\7684\4E0B\8F7D\94FE\63A5\7684\6587\672C\3002\6700\7EC8\7528\6237\4F7F\7528\6B64\94FE\63A5\6765\4E0B\8F7D BLOB \5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108261400867312533)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292912154312559)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6388\6743\65B9\6848\4EE5\9650\5236\8C01\6709\6743\4F7F\7528\62D6\653E\64CD\4F5C\66F4\65B0\73B0\6709\65E5\5386\4E8B\4EF6\3002'),
unistr('\5982\679C\6307\5B9A\FF0C\6B64\6388\6743\65B9\6848\7684\8BA1\7B97\7ED3\679C\5FC5\987B\4E3A\201C\771F\201D\624D\80FD\5904\7406\62D6\653E\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292842332312559)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451540149312688)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5B9A\5236\5904\7406</dt>'),
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292746441312559)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49\62D6\653E\65E5\5386\6761\76EE\65F6\5C06\6267\884C\7684\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292693904312559)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133662568312430)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\590D\5236\8BB0\5F55\65F6\6B64\5217\662F\5426\5E94\9ED8\8BA4\4E3A\73B0\6709\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133517360312430)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\590D\5236\73B0\6709\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931554539312270)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\68C0\67E5\652F\6301\54EA\4E9B\6570\636E\64CD\7EB5\8BED\8A00 (DML) \64CD\4F5C\3002\6B64\8FC7\7A0B\5C06\57FA\4E8E\6309\94AE\7684<strong>\6570\636E\5E93\64CD\4F5C</strong>\5C5E\6027\6267\884C DML \64CD\4F5C\4EE5\63D0\4EA4\9875\3002\5982\679C\672A\8BBE\7F6E\8BE5\5C5E\6027\FF0C\64CD\4F5C\5C06\7531\6309\94AE\7684\8BF7\6C42\503C\786E\5B9A\3002\8BE5\503C\57FA\4E8E\6309\94AE\540D\79F0\8BBE\7F6E\FF0C\5982\4E0B\6240\793A\FF1A</p>'),
'<ul>',
unistr('<li>\4EE5\4E0B\8BF7\6C42\503C\89E6\53D1<strong>\6DFB\52A0\884C</strong>\FF1AINSERT\3001CREATE\3001CREATE_AGAIN\3001CREATEAGAIN</li>'),
unistr('<li>\4EE5\4E0B\8BF7\6C42\503C\89E6\53D1<strong>\66F4\65B0\884C</strong>\FF1ASAVE\3001APPLY CHANGES\3001UPDATE\3001UPDATE ROW\3001CHANGE\3001APPLY\3001APPLY%CHANGES%\3001GET_NEXT%\3001GET_PREV%</li>'),
unistr('<li>\4EE5\4E0B\8BF7\6C42\503C\89E6\53D1<strong>\5220\9664\884C</strong>\FF1ADELETE\3001REMOVE\3001DELETE ROW\3001DROP</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117901753312417)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\5141\8BB8\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E0A\6267\884C\54EA\4E9B\6570\636E\64CD\7EB5\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118280576312417)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118067600312417)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118166824312417)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117851305312417)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\7684\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118432861312418)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5176\5217\503C\6307\793A\662F\5426\53EF\66F4\65B0\548C/\6216\5220\9664\884C\7684\5217\3002\5141\8BB8\7684\503C\5305\62EC:'),
'        <dl>',
'          <dt>U</dt>',
unistr('            <dd>\53EF\66F4\65B0\884C</dd>'),
'          <dt>D</dt>',
unistr('            <dd>\53EF\5220\9664\884C</dd>'),
'          <dt>UD</dt>',
unistr('            <dd>\53EF\66F4\65B0\6216\5220\9664\884C</dd>'),
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118376539312418)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\7684\884C\64CD\4F5C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910143682312254)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9 HTML \8868\5355\5143\4E2D\9879\5468\56F4\7684\5BF9\9F50\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413768961312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413853182312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413938384312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413602916312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414113066312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414218573312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\9760\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414318848312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414050368312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414503043312656)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414669367312656)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\9760\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414724602312656)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414412873312655)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107906039700312251)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910769379312254)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6587\672C\533A\57DF, \5F80\8FD4, \591A\9009\5217\8868\4EE5\53CA\4EFB\4F55\652F\6301\201C\5177\6709\9AD8\5EA6\5C5E\6027\201D\5C5E\6027\7684\63D2\4EF6\9879\7C7B\578B\7684\9AD8\5EA6 (\5927\7EA6\884C\6570)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910602055312254)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296276348312561)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910548255312254)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\6237\53EF\4EE5\952E\5165\5230\6B64\9879\4E2D\7684\6700\5927\5B57\7B26\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910489256312254)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\957F\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296380092312562)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911194946312255)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\663E\793A\5355\9009\7EC4\6216\590D\9009\6846\96C6\4E2D\5404\4E2A\5355\72EC\9009\9879\7684 HTML \8868\5355\5143\7684\9644\52A0\7A7A\683C\5206\9694\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911033017312255)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879 HTML \5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911548427312255)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\663E\793A\5355\9009\7EC4\6216\590D\9009\6846\96C6\4E2D\5404\4E2A\5355\72EC\9009\9879\7684 HTML \8868\5355\5143\4E4B\540E\663E\793A\7684\9644\52A0\5C5E\6027\3002'),
unistr('\53EF\4EE5\5305\542B HTML, Javascript \548C\5FEB\6377\65B9\5F0F\3002</p>'),
unistr('<p>\53EF\4EE5\5F15\7528\4E0B\5217\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\83B7\5F97\6B64\9875\9879\5173\8054\7684 HTML \8868\5355\5143\7D20\7684\540D\79F0\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\83B7\5F97\5F53\524D\9875\9879\7684\540D\79F0\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911467710312255)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540E\7F6E\6587\672C ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911359205312255)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\663E\793A\5355\9009\7EC4\6216\590D\9009\6846\96C6\4E2D\5404\4E2A\5355\72EC\9009\9879\7684 HTML \8868\5355\5143\4E4B\524D\663E\793A\7684\9644\52A0\5C5E\6027\3002'),
unistr('\53EF\4EE5\5305\542B HTML, Javascript \548C\5FEB\6377\65B9\5F0F\3002</p>'),
unistr('<p>\53EF\4EE5\5F15\7528\4E0B\5217\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>\83B7\5F97\6B64\9875\9879\5173\8054\7684 HTML \8868\5355\5143\7D20\7684\540D\79F0\3002</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>\83B7\5F97\5F53\524D\9875\9879\7684\540D\79F0\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911256030312255)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\524D\7F6E\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910914381312255)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6CA1\6709\4E3A\6B64\9879\8F93\5165\503C\65F6\663E\793A\5728\6B64\9879\4E2D\7684\63D0\793A\6587\672C\3002\4E00\65E6\5728\6B64\9879\4E2D\8F93\5165\4E86\4EFB\4F55\6587\672C, \5C31\5C06\5220\9664\63D0\793A\3002</p>'),
unistr('<p>\6B64\5360\4F4D\7B26\5C5E\6027\6307\5B9A\53EF\7528\4E8E\63CF\8FF0\9875\9879\7684\9884\671F\503C\7684\7B80\8981\63D0\793A\3002'),
unistr('\8FD9\79CD\63D0\793A\5BF9\4E8E\63D0\4F9B\793A\4F8B\503C, \9884\671F\683C\5F0F\793A\4F8B\6216\8BF4\660E\975E\5E38\6709\7528, \4F8B\5982: \6807\9898\641C\7D22, \8BF4\660E\548C\6807\8BB0\3002'),
unistr('\51FA\4E8E\53EF\8BBF\95EE\6027\539F\56E0, \6B64\5C5E\6027\4E0D\80FD\7528\4F5C\6B63\786E\5B9A\4E49\7684\6709\610F\4E49\6807\7B7E\7684\66FF\4EE3\9879\3002</p>'),
unistr('<p><strong>\6CE8\610F:</strong> \8FD9\662F HTML5 \529F\80FD, \4EC5\9002\7528\4E8E\65B0\578B\6D4F\89C8\5668! \65E9\671F\6D4F\89C8\5668\4E0D\4F1A\663E\793A\8F93\5165\5230\6B64\5C5E\6027\4E2D\7684\6587\672C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910870996312254)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5360\4F4D\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910339304312254)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\7528\4E8E\663E\793A\6B64\9879\7684\8868\5355\5143\7D20\7684\5BBD\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910231819312254)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296154391312561)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431145219312672)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232424866312508)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6709\6548\7684\7535\5B50\90AE\4EF6\5730\5740\4EE5\4FBF\5728\53D1\9001\6765\81EA\6B64\62A5\8868\7684\7535\5B50\90AE\4EF6\65F6\7528\4F5C<em>\53D1\4EF6\4EBA</em>\5730\5740\3002\9488\5BF9\7535\5B50\90AE\4EF6\7C7B\578B\7684\4E0B\8F7D\548C\8BA2\9605\4ECE\6B64\62A5\8868\53D1\9001\7535\5B50\90AE\4EF6\3002</p>'),
unistr('<p>\6B64\503C\53EF\4EE5\662F\5305\542B\6709\6548\7535\5B50\90AE\4EF6\5730\5740\7684\6587\5B57\5B57\7B26\4E32, \6216\8005\662F\5E94\7528\7A0B\5E8F\4E2D\5B9A\4E49\7684\4F7F\7528\66FF\6362\8BED\6CD5\7684\9759\6001\66FF\6362\5F15\7528\3002'),
unistr('\4E0D\5EFA\8BAE\4F7F\7528\9875\6216\5E94\7528\7A0B\5E8F\9879\66FF\6362, \56E0\4E3A\5B83\4EC5\9002\7528\4E8E\7535\5B50\90AE\4EF6\4E0B\8F7D, \5E76\4F1A\5BFC\81F4\6240\6709\8BA2\9605\7535\5B50\90AE\4EF6\5931\8D25, \56E0\4E3A\65E0\6CD5\5728\6709\6548\4F1A\8BDD\5916\90E8\8BBF\95EE\8FD9\4E9B\9879\3002'),
unistr('\76F4\63A5\4ECE &PRODUCT_NAME. \5F15\64CE (\800C\975E\4ECE\7528\6237\4F1A\8BDD) \53D1\9001\8BA2\9605\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232356403312508)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\7684\53D1\4EF6\4EBA\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144009653312438)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\63A7\5236\7EC6\5206\548C\805A\96C6\4E2D\4F7F\7528\6B64\5217\3002</p>'),
unistr('        <p>\6CE8 - \5141\8BB8\8FD9\4E9B\64CD\4F5C\53EF\80FD\4F1A\5F15\8D77\6027\80FD\95EE\9898\FF0C\5C24\5176\662F\5728\6570\636E\96C6\975E\5E38\5927\6216\6CA1\6709\5408\9002\7684\5217\7D22\5F15\53EF\7528\65F6\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143988279312438)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\7EC6\5206/\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122408560312421)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5C06\62A5\8868\4E0B\8F7D\4E3A\6307\5B9A\7684\67D0\79CD\4E0B\8F7D\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122388499312421)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126522646312424)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\8FC7\6EE4\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126475475312424)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143286125312437)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\4EA4\4E92\5F0F\7F51\683C\4F7F\7528\95EA\56DE\67E5\8BE2\3002</p>'),
unistr('<p>\95EA\56DE\67E5\8BE2\4F7F\7528 Oracle \95EA\56DE\6280\672F\548C\6570\636E\5E93\65F6\95F4\70B9\6062\590D\6765\67E5\770B\4E4B\524D\7684\67D0\4E2A\65F6\95F4\70B9\5B58\5728\7684\6570\636E\3002\7528\6237\53EA\80FD\67E5\8BE2\6B64\6570\636E\FF0C\4F46\4E0D\80FD\540E\9000\4EFB\4F55\6570\636E\66F4\6539\3002\7528\6237\53EF\4EE5\6210\529F\6267\884C\95EA\56DE\67E5\8BE2\7684\8FFD\6EAF\65F6\95F4\957F\5EA6\53D6\51B3\4E8E\4E0A\6B21\5728 Oracle \6570\636E\5E93\5185\5207\6362\91CD\505A\65E5\5FD7\6587\4EF6\7684\65F6\95F4\FF0C\56E0\4E3A\6B64\6280\672F\4F7F\7528 RMAN \5907\4EFD\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143151270312437)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143858560312438)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\9690\85CF\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143754723312438)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123085521312421)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\53D1\9001\7535\5B50\90AE\4EF6\5E76\4EE5\9644\4EF6\5F62\5F0F\63D0\4F9B\62A5\8868\4E0B\8F7D\3002</p>'),
unistr('<p>\7535\5B50\90AE\4EF6\4EC5\9002\7528\4E8E\5DF2\9A8C\8BC1\7684\7528\6237\FF0C\5E76\9700\8981\5B9E\4F8B\7BA1\7406\5458\5728 &PRODUCT_NAME. \7BA1\7406\670D\52A1\5E94\7528\7A0B\5E8F\5185\914D\7F6E SMTP\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122910145312421)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\7535\5B50\90AE\4EF6\53D1\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372007046312622)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\542F\7528\62A5\8868\6253\5370\3002\5982\679C\9009\62E9<strong>\542F\7528</strong>\FF0C\7528\6237\53EF\4EE5\4E0B\8F7D\591A\79CD\683C\5F0F\7684\62A5\8868\FF0C\5176\4E2D\5305\62EC PDF\3001Microsoft Word\3001Microsoft Excel \548C HTML \683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371928236312622)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121824318312420)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5C06\5176\5F53\524D\62A5\8868\5B9A\4E49\53E6\5B58\4E3A<em>\516C\5171</em>\62A5\8868\3002</p>'),
unistr('		<p>\516C\5171\62A5\8868\663E\793A\5728\5DE5\5177\680F\7684\53EF\7528\62A5\8868\9009\62E9\5217\8868\4E2D, \5E76\663E\793A\7ED9\6BCF\4E2A\4EBA\3002<p>'),
unistr('		<p>\6CE8 - \6B64\9009\9879\4EC5\9002\7528\4E8E\5DF2\9A8C\8BC1\7684\7528\6237, \5982\679C\60A8\8FD8\586B\5145<strong>\4FDD\5B58\516C\5171\62A5\8868\6388\6743</strong>, \5219\4F1A\52A0\4EE5\8FDB\4E00\6B65\9650\5236\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121767498312420)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\516C\5171\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131682895312428)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\6392\5E8F\4E2D\4F7F\7528\6B64\5217\3002</p>'),
unistr('        <p>\6CE8 - \5141\8BB8\6392\5E8F\64CD\4F5C\53EF\80FD\4F1A\5F15\8D77\6027\80FD\95EE\9898\FF0C\5C24\5176\662F\5728\6570\636E\96C6\975E\5E38\5927\6216\6CA1\6709\5408\9002\7684\5217\7D22\5F15\53EF\7528\65F6\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131530081312428)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122260875312421)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\8BA2\9605\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122189510312421)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918991199312261)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5B58\50A8\5728\4F1A\8BDD\72B6\6001\4E2D\65F6\662F\5426\52A0\5BC6\6B64\9879\3002'),
unistr('\5982\679C\9879\5185\5BB9\5305\542B\654F\611F\6570\636E\FF0C\5219\5E94\5BF9\5B58\50A8\5728 &PRODUCT_NAME. \4F1A\8BDD\72B6\6001\7BA1\7406\8868\4E2D\7684\503C\8FDB\884C\52A0\5BC6\3002'),
unistr('\5426\5219\FF0C\4EFB\4F55\6709\6743\8BFB\53D6 &PRODUCT_NAME. \5143\6570\636E\8868\7684\7528\6237\90FD\53EF\80FD\4F1A\7F16\5199\67E5\8BE2\6765\63D0\53D6\6B64\654F\611F\6570\636E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918834103312261)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\50A8\4F1A\8BDD\72B6\6001\4E2D\7684\52A0\5BC6\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290434834312557)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5728\5468\5386\4E0A\663E\793A\7684\4E00\5468\4E2D\7684\7B2C\4E00\5929\3002'),
unistr('\53EF\4EE5\5C06\6B64\5C5E\6027\4E0E<strong>\7ED3\675F\65E5\671F</strong>\7ED3\5408\4F7F\7528\6765\9650\5236\663E\793A\7684\4E00\5468\4E2D\7684\5929\6570, \6216\7B80\5355\6307\5B9A\663E\793A\7684\4E00\5468\4E2D\7684\7B2C\4E00\5929\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449768821312686)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449871040312686)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449929711312687)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450019850312687)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450188497312687)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\56DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450215468312687)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450330296312687)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\516D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290342832312557)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291012518312557)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\96C6\4E2D\663E\793A\5468\5386\548C\65E5\5386\7684\7ED3\675F\65F6\95F4 (\5C0F\65F6)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290964100312557)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65F6\95F4 (\5C0F\65F6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292318605312558)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\76EE\6807\201D\53EF\8C03\7528\6A21\5F0F\5BF9\8BDD\6846\3002\53EF\4EE5\8F93\5165\65E5\5386\8C03\7528\7684\76EE\6807\94FE\63A5\4EE5\67E5\770B\73B0\6709\4E8B\4EF6\7684\8BE6\7EC6\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292211168312558)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892583001312240)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5E94\7528\7A0B\5E8F\5185\53D1\751F\9519\8BEF\65F6\8C03\7528\7684 PL/SQL \51FD\6570\7684\540D\79F0\3002'),
unistr('\53EF\4EE5\4F7F\7528\6B64\51FD\6570\5904\7406\5404\79CD\9519\8BEF\4EE3\7801 (\5305\62EC\90A3\4E9B\4ECE Oracle \6570\636E\5E93\53D1\51FA\7684\9519\8BEF\4EE3\7801), \5E76\6839\636E\9700\8981\5728\60A8\5B9A\4E49\7684\5B9A\5236\8868\4E2D\8BB0\5F55\6B64\7C7B\9519\8BEF\3002'),
unistr('\6B64\51FD\6570\53EF\4EE5\5305\62EC\7528\4E8E\4FEE\6539\9519\8BEF\6D88\606F\548C\663E\793A\4F4D\7F6E\7684\903B\8F91, \4ECE\800C\5C06 Oracle \6570\636E\5E93\9519\8BEF\8F6C\6362\4E3A\7528\6237\53CB\597D\7684\6D88\606F\3002'),
unistr('\4F8B\5982, \53EF\4EE5\6355\83B7 <code>DEMO_CUSTOMERS</code> \4E0A\7684\552F\4E00\5173\952E\5B57\8FDD\89C4\5E76\5C06 <code>ORA-00001</code> \6D88\606F\66FF\6362\4E3A\4EE5\4E0B\6587\672C: \5BA2\6237\540D\5FC5\987B\552F\4E00\3002'),
unistr('\4ECE\6253\5305\7684\5E94\7528\7A0B\5E8F\5B89\88C5\793A\4F8B\6570\636E\5E93\5E94\7528\7A0B\5E8F\65F6\5C06\521B\5EFA\5305\62EC <code>demo_error_handling</code> \51FD\6570\7684 <code>SAMPLE_PKG</code> \7A0B\5E8F\5305\3002'),
unistr('\6B64\793A\4F8B\9519\8BEF\5904\7406\51FD\6570\5305\62EC\5927\91CF\6CE8\91CA, \4EE5\4FBF\4E8E\60A8\5C06\6B64\51FD\6570\4F5C\4E3A\57FA\7840\6765\5B9A\4E49\81EA\5DF1\7684\51FD\6570\3002</p>'),
unistr('<p>\8F93\5165\7684\51FD\6570\540D\53EF\4EE5\5F15\7528\6570\636E\5E93\4E2D\7684\7A0B\5E8F\5305\51FD\6570\6216\72EC\7ACB\51FD\6570\3002\4F8B\5982:'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>\5F15\7528\6570\636E\5E93 PL/SQL \7A0B\5E8F\5305\6216\72EC\7ACB\51FD\6570\65F6, \53EF\4EE5\4F7F\7528 <code>#OWNER#</code> \66FF\6362\5B57\7B26\4E32\6765\5F15\7528\5F53\524D\5E94\7528\7A0B\5E8F\7684\8BED\6CD5\5206\6790\65B9\6848\3002\4F8B\5982:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>\5982\679C\5728\9875\4E0A\6307\5B9A\4E86\9519\8BEF\5904\7406\51FD\6570, \5219\5229\7528\6B64\51FD\6570, \800C\4E0D\5BF9\6B64\9875\4F7F\7528\6B64\5E94\7528\7A0B\5E8F\7EA7\8BBE\7F6E\3002</p>'),
unistr('<p>\9519\8BEF\5904\7406\51FD\6570\5FC5\987B\5B9E\65BD\4EE5\4E0B\63A5\53E3:'),
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p>\6709\5173\7A0B\5E8F\5305 <code>apex_error</code> \7684\8BF4\660E, \8BF7\53C2\9605 API \53C2\8003\624B\518C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902178217312248)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\51FD\6570\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608791555312810)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\8BA1\7B97\5931\8D25\65F6\663E\793A\7684\9519\8BEF\6D88\606F\3002'),
unistr('    \4F7F\7528 <code>#SQLERRM#</code> \4F5C\4E3A\5931\8D25\8BA1\7B97\751F\6210\7684 SQL \9519\8BEF\6D88\606F\7684\66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('    <p>\8BA1\7B97\8BBE\8BA1\4E3A\59CB\7EC8\6210\529F, \4EC5\5728\51FA\73B0\610F\5916\9519\8BEF\65F6\5931\8D25\3002'),
unistr('    \4E0D\5EFA\8BAE\5B9E\65BD\7ECF\5E38\5931\8D25\4E14\7528\4F5C\5229\7528\6B64\9519\8BEF\6D88\606F\7684\4F2A\9A8C\8BC1\7684\8BA1\7B97\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930330543312270)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\8BA1\7B97\5931\8D25\65F6\663E\793A\7684\9519\8BEF\6D88\606F\3002'),
unistr('    \4F7F\7528 <code>#SQLERRM#</code> \4F5C\4E3A\5931\8D25\8BA1\7B97\751F\6210\7684 SQL \9519\8BEF\6D88\606F\7684\66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('    <p>\8BA1\7B97\8BBE\8BA1\4E3A\59CB\7EC8\6210\529F, \4EC5\5728\51FA\73B0\610F\5916\9519\8BEF\65F6\5931\8D25\3002'),
unistr('    \4E0D\5EFA\8BAE\5B9E\65BD\7ECF\5E38\5931\8D25\4E14\7528\4F5C\5229\7528\6B64\9519\8BEF\6D88\606F\7684\4F2A\9A8C\8BC1\7684\8BA1\7B97\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243988954312518)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\5904\7406\7684\9519\8BEF\6D88\606F\3002'),
unistr('\5982\679C\51FA\73B0\65E0\6CD5\5904\7406\7684\5F02\5E38\9519\8BEF, \5219\663E\793A\6B64\6D88\606F\3002\5728\6240\6709\9519\8BEF\5904\7406\505C\6B62\4E4B\540E, \4FBF\6267\884C\56DE\9000\5E76\663E\793A\9519\8BEF\6D88\606F\3002</p>'),
unistr('<p>\6CE8: \5982\679C<strong>\51FA\9519\65F6\9875</strong>\5B9A\4E49\4E3A\9519\8BEF\663E\793A\4F4D\7F6E, \5219\9ED8\8BA4\60C5\51B5\4E0B\663E\793A SQL \9519\8BEF\6D88\606F (sqlerrm), \56E0\6B64\65E0\9700\5C06 <code>#SQLERRM#</code> \6DFB\52A0\5230\9519\8BEF\6587\672C\3002</p>'),
unistr('<p>\9519\8BEF\6D88\606F\53EF\4EE5\5305\542B\4E0B\5217\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>\9519\8BEF\6D88\606F\7684\6587\672C, \4E0D\542B\9519\8BEF\53F7\3002</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
unistr('  <dd>\5B8C\6574\7684\9519\8BEF\6D88\606F\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803166073312967)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890922172312239)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\9A8C\8BC1\672A\901A\8FC7\65F6\663E\793A\7684\6587\672C\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528 <code>#LABEL#</code> \4F5C\4E3A\5173\8054\9875\9879\7684\6807\7B7E\7684\5360\4F4D\7B26, \6216\4F7F\7528 <code>#COLUMN_HEADER#</code> \4F5C\4E3A\5173\8054\7684\53EF\7F16\8F91\533A\57DF\5217\7684\6807\9898\3002\5982\679C\9519\8BEF\663E\793A\4F4D\7F6E\8BBE\7F6E\4E3A\201C\51FA\9519\65F6\9875\201D, \5219\4E0D\652F\6301\5360\4F4D\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107890891717312239)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002325150312327)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\9A8C\8BC1\7684\9519\8BEF\6D88\606F\7684\663E\793A\4F4D\7F6E\3002'),
unistr('\9A8C\8BC1\9519\8BEF\6D88\606F\663E\793A\5728\5355\72EC\7684\9519\8BEF\9875\4E0A, \6216\4E0E\73B0\6709\9875\4E00\8D77\5185\5D4C\3002'),
unistr('\5185\5D4C\9519\8BEF\6D88\606F\663E\793A\5728<em>\76F8\5173\9879</em>\6807\7B7E\4E0B\65B9\548C/\6216\201C\901A\77E5\201D\533A\57DF (\5DF2\5B9A\4E49\4E3A\9875\6A21\677F\7684\4E00\90E8\5206) \4E2D\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422954213312665)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\5230\901A\77E5\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422895706312665)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0E\5B57\6BB5\4E00\8D77\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108422700801312665)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0E\5B57\6BB5\4E00\8D77\5185\5D4C\5E76\4E14\5185\5D4C\5230\901A\77E5\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423062429312665)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\9519\65F6\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002205664312327)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919102404312261)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3A\9632\6B62\8DE8\7AD9\70B9\811A\672C\7F16\5199 (Cross-Site Scripting, XSS) \653B\51FB\FF0C\59CB\7EC8\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\3002'),
unistr('\5982\679C\9700\8981\5448\73B0\5B58\50A8\5728\9875\9879\6216\503C\5217\8868\6761\76EE\4E2D\7684 HTML \6807\8BB0\FF0C\53EF\4EE5\5C06\6B64\6807\8BB0\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\3002'),
unistr('\5728\8FD9\79CD\60C5\51B5\4E0B\FF0C\5E94\5F53\91C7\53D6\989D\5916\7684\9884\9632\63AA\65BD\4EE5\786E\4FDD\5728\8F93\5165\65F6\548C\4FDD\5B58\4E4B\524D\6B63\786E\8F6C\4E49\6B64\7C7B\5B57\6BB5\4E2D\7684\7528\6237\8F93\5165\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919045882312261)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\4E49\7279\6B8A\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891159461312239)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7B2C\4E00\6B21\5728\4F1A\8BDD\4E2D\4F7F\7528\6388\6743\65B9\6848\65F6\4F1A\5BF9\5176\8FDB\884C\6C42\503C\3002'),
unistr('\9009\62E9\9002\5F53\7684\6C42\503C\70B9\4EE5\786E\5B9A\7ED9\5B9A\6388\6743\7684\540E\7EED\4F7F\7528\662F\4ECE\5185\5B58\83B7\53D6\7ED3\679C\8FD8\662F\5BF9\6388\6743\65B9\6848\91CD\65B0\6C42\503C\3002</p>'),
'#LOV_VALUES#',
unistr('<p>\9ED8\8BA4\503C<em>\6BCF\4E2A\4F1A\8BDD\4E00\6B21</em>\7684\6548\7387\6700\9AD8\3002'),
unistr('\5982\679C\6388\6743\68C0\67E5\53D7\5230\4E0D\786E\5B9A\7684\4F1A\8BDD\72B6\6001\6216\6574\4E2A\4F1A\8BDD\671F\95F4\4E0D\4E00\81F4\7684\5176\4ED6\56E0\7D20\7684\5F71\54CD\FF0C\5219\5E94\9009\62E9\5176\4ED6\503C\3002'),
unistr('\9009\9879<em>\6BCF\4E2A\7EC4\4EF6\4E00\6B21</em>\548C<em>\59CB\7EC8\FF08\4E0D\9AD8\901F\7F13\5B58\FF09</em>\63D0\4F9B\5176\4ED6\53EF\8FDB\884C\5B9A\4E49\4EE5\4F9B\6388\6743\65B9\6848\4F7F\7528\7684\53C2\6570\3002'),
unistr('\5728\6388\6743\63D2\4EF6\4E2D\FF0C\53EF\4EE5\4F7F\7528 <em>t_authorization</em> \53C2\6570\7684 <em>component.type</em>\3001<em>component.id</em> \548C <em>component.name</em> \5C5E\6027\3002'),
unistr('\5BF9\4E8E\5185\7F6E\7684<em>\5B58\5728 SQL \67E5\8BE2</em>\548C<em>\51FD\6570\4F53</em>\65B9\6848\7C7B\578B\FF0C\53EF\4F7F\7528\7B49\6548\7684\7ED1\5B9A\53D8\91CF <em>:APP_COMPONENT_TYPE</em>\3001<em>:APP_COMPONENT_ID</em> \548C <em>:APP_COMPONENT_NAME</em>\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399392537312643)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\7EC4\4EF6\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399452848312643)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\5F15\7528\6388\6743\65B9\6848\7684\6BCF\4E2A\7EC4\4EF6\6C42\503C\4E00\6B21, \4F46\5C06\7ED3\679C\4FDD\5B58\5230\4F1A\8BDD\4E2D\3002\7528\4E8E\5448\73B0\6216\5904\7406\65B9\6848\7684\8FDB\4E00\6B65\8BF7\6C42\5C06\4F7F\7528\5185\5B58\4E2D\7684\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399189002312643)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\6B21\9875\8BBF\95EE\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399257612312643)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\5904\7406\7684\6BCF\4E2A\8BF7\6C42\6C42\503C\4E00\6B21\3002\5982\679C\5728\9875\4E0A\7684\591A\4E2A\7EC4\4EF6\4E2D\5F15\7528\4E86\6388\6743\65B9\6848, \5219\4F7F\7528\5185\5B58\4E2D\7684\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398914627312643)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\4F1A\8BDD\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399062929312643)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\6C42\503C\4E00\6B21, \7136\540E\4F7F\7528\5185\5B58\4E2D\7684\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399546796312644)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8 (\4E0D\9AD8\901F\7F13\5B58)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399626421312644)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8\5BF9\6388\6743\65B9\6848\6C42\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891079629312239)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C42\503C\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896121638312243)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5C06\5BFC\81F4\89E6\53D1\52A8\6001\64CD\4F5C\7684\4E8B\4EF6\3002'),
unistr('\6709\5173\7279\5B9A\4E8B\4EF6\7684\4FE1\606F, \8BF7\53C2\9605 <em>App Builder User''s Guide</em> \4E2D\7684\76F8\5173\90E8\5206\3002</p>'),
unistr('\4E8B\4EF6\5206\7C7B\4E3A\4EE5\4E0B\7C7B\578B:'),
'<dl>',
unistr('  <dt>\6D4F\89C8\5668\4E8B\4EF6</dt>'),
unistr('    <dd>\6807\51C6\6D4F\89C8\5668\4E8B\4EF6\3002</dd>'),
unistr('  <dt>\6846\67B6\4E8B\4EF6</dt>'),
unistr('    <dd>\6846\67B6\4E8B\4EF6\4ECE Application Express \6846\67B6\5185\89E6\53D1\3002</dd>'),
unistr('  <dt>\7EC4\4EF6\4E8B\4EF6</dt>'),
unistr('    <dd>\4EC5\5F53\5B58\5728\53EF\7528\4E8E\5E94\7528\7A0B\5E8F\7684\7EC4\4EF6\4E14\6B64\7EC4\4EF6\89E6\53D1\5B9A\5236\4E8B\4EF6\65F6\624D\53EF\7528\3002\8FD9\4E9B\4E8B\4EF6\4ECE\672C\673A\7EC4\4EF6\6216\4ECE\60A8\5728\5E94\7528\7A0B\5E8F\4E2D\5B89\88C5\7684\63D2\4EF6\7EC4\4EF6\89E6\53D1\3002</dd>'),
unistr('  <dt>\5B9A\5236\4E8B\4EF6</dt>'),
unistr('    <dd>\4ECE\5E94\7528\7A0B\5E8F\89E6\53D1\7684\4EFB\4F55\5B9A\5236\4E8B\4EF6\3002</dd>'),
'</dl>',
unistr('<p>\6CE8: \6839\636E\9875\5F53\524D\7684\7528\6237\754C\9762\7C7B\578B, \663E\793A\7684\4E8B\4EF6\5C06\6709\6240\4E0D\540C\3002'),
unistr('\5982\679C\8981\9009\62E9\5BF9\5E94\4E8E\5176\4ED6\7C7B\578B\7684\4E8B\4EF6, \5219\53EF\4EE5\9009\62E9<strong>\663E\793A\4E0D\652F\6301\7684\9879</strong>,'),
unistr('\6B64\9009\9879\5C06\663E\793A\6240\6709\4E8B\4EF6 (\5305\62EC\90A3\4E9B\4E0D\5BF9\5E94\4E8E\5F53\524D\7C7B\578B\7684\4E8B\4EF6)\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896033864312243)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920377558312262)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E8B\4EF6\7684\8303\56F4, \6B64\8303\56F4\786E\5B9A\4F55\65F6\5BF9\4E8B\4EF6\7B2C\4E8C\6B21\6C42\503C\6216\8FDE\7EED\6C42\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409951684312652)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410008408312652)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4E8B\4EF6\5904\7406\7A0B\5E8F\7ED1\5B9A\5230\89E6\53D1\5143\7D20, \6301\7EED\65F6\95F4\4E3A\5F53\524D\9875\7684\6709\6548\671F, \4F46\5728\901A\8FC7\90E8\5206\9875\5237\65B0 (PPR) \66F4\65B0\89E6\53D1\5143\7D20\4E4B\540E, \5C06\4E0D\518D\7ED1\5B9A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410151394312652)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410288174312652)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4E8B\4EF6\5904\7406\7A0B\5E8F\7ED1\5B9A\5230\89E6\53D1\5143\7D20, \6301\7EED\65F6\95F4\4E3A\5F53\524D\9875\7684\6709\6548\671F, \800C\4E0D\8003\8651\4EFB\4F55\901A\8FC7\90E8\5206\9875\5237\65B0 (PPR) \91CD\65B0\521B\5EFA\7684\89E6\53D1\5143\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410363872312652)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410457738312652)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5C06\4E8B\4EF6\5904\7406\7A0B\5E8F\7ED1\5B9A\5230\89E6\53D1\5143\7D20\4E00\6B21\3002\5B8C\5168\5237\65B0\9875\540E\4E0D\4F1A\518D\6B21\89E6\53D1\52A8\6001\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920289332312262)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727855880312902)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\6392\9664\8F6C\6362\6B64\6807\9898\3002\6B64\5C5E\6027\6CA1\6709\4EFB\4F55\6548\679C, \5C06\5E94\7528\7A0B\5E8F\7FFB\8BD1\4E3A\5176\4ED6\8BED\8A00\65F6\9664\5916\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727750671312902)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\6362\65F6\4E0D\5305\62EC\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561007112312774)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\5C42\6761\4EF6\7684\6267\884C\6B21\6570\3002'),
unistr('\5982\679C\5728\6761\4EF6\4E2D\5F15\7528<em>\5217</em>\FF0C\5219\5FC5\987B\6307\5B9A<strong>\6BCF\4E00\884C</strong>\4EE5\4FBF\4E3A\5C42\67E5\8BE2\7684\6BCF\4E00\884C\5BF9\6761\4EF6\6C42\503C\3002'),
unistr('\5426\5219\FF0C\8BBE\7F6E\4E3A<strong>\4E00\6B21</strong>\4E3A\533A\57DF\5BF9\9A8C\8BC1\6C42\503C\4E00\6B21\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003148191312328)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\53EF\7F16\8F91\533A\57DF\9A8C\8BC1\7684\6267\884C\6B21\6570\3002'),
unistr('\5982\679C\5728\6761\4EF6\4E2D\5F15\7528<em>\5217</em>, \5219\5FC5\987B\6307\5B9A<strong>\6BCF\4E00\884C</strong>\4EE5\4FBF\4E3A\53EF\7F16\8F91\533A\57DF\7684\6BCF\4E00\884C\5BF9\6761\4EF6\6C42\503C\3002'),
unistr('\5426\5219, \8BBE\7F6E\4E3A<strong>\4E00\6B21</strong>\4E3A\533A\57DF\5BF9\9A8C\8BC1\6C42\503C\4E00\6B21\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423401916312665)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423370885312665)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E00\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003019678312328)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133829601312430)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4F55\65F6\6267\884C\6B64\53EA\8BFB\6761\4EF6\3002</p>'),
unistr('        <p>\5982\679C\5728\53EA\8BFB\6761\4EF6\4E2D\5F15\7528<em>\5217</em>, \5219\5FC5\987B\6307\5B9A<strong>\6BCF\4E00\884C</strong>\4EE5\4FBF\4E3A\4EA4\4E92\5F0F\7F51\683C\7684\6BCF\4E00\884C\5BF9\6761\4EF6\6C42\503C\3002'),
unistr('		\5426\5219, \8BBE\7F6E\4E3A<strong>\4E00\6B21</strong>\53EA\4E3A\533A\57DF\5BF9\6761\4EF6\6C42\503C\4E00\6B21\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134000980312430)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\6B21')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249838661312523)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\6C42\503C\4E00\6B21\6574\4E2A\533A\57DF\7684\53EA\8BFB\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133918944312430)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E00\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249724177312523)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\72EC\6C42\503C\6BCF\4E00\884C\7684\53EA\8BFB\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108133775654312430)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002994156312328)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\53EF\7F16\8F91\533A\57DF\9A8C\8BC1\7684\6267\884C\8303\56F4\3002'),
unistr('\5982\679C\5E0C\671B\9488\5BF9\53EF\7F16\8F91\533A\57DF\4E2D\7684\65B0\884C\548C\5DF2\66F4\65B0\884C\5BF9\6B64\9A8C\8BC1\8FDB\884C\6C42\503C, \5219\9009\62E9<strong>\9488\5BF9\5DF2\521B\5EFA\548C\5DF2\4FEE\6539\884C</strong>\3002'),
unistr('\5982\679C\5E0C\671B\9488\5BF9\63D0\4EA4\7684\6BCF\4E00\884C\5BF9\60A8\7684\9A8C\8BC1\8FDB\884C\6C42\503C, \5219\9009\62E9<strong>\6240\6709\5DF2\63D0\4EA4\884C</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423276631312665)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\5DF2\63D0\4EA4\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108423183985312665)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9488\5BF9\5DF2\521B\5EFA\548C\5DF2\4FEE\6539\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108002810810312328)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895735006312243)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\7EC4\4EF6\7684\5E8F\5217\3002\5E8F\5217\51B3\5B9A\6267\884C\7684\987A\5E8F\3002</p>'),
unistr('<p>\6CE8: \5982\679C\4E24\4E2A\7EC4\4EF6\5177\6709\76F8\540C\7684\5E8F\5217\503C, \5219\5728\5BFC\51FA\5E94\7528\7A0B\5E8F\5E76\5BFC\5165\5230\5176\4ED6\73AF\5883\65F6, \53EF\80FD\4F1A\4EE5\4E0D\540C\7684\987A\5E8F\6267\884C\8FD9\4E24\4E2A\7EC4\4EF6\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107895648064312243)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719394039312895)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5BF9\4E8E ORDS REST \670D\52A1\FF0C\8FC7\6EE4\6389\6240\6709 "sal" \5C5E\6027\5C0F\4E8E 3000 \7684\8BB0\5F55\3002</dt>'),
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719224207312895)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\8981\4F20\9012\5230\5916\90E8 REST \670D\52A1\7684\8FC7\6EE4\5668\8868\8FBE\5F0F\3002\8BE5\8868\8FBE\5F0F\5C06\539F\6837\4F20\9012\5230\8FDC\7A0B\670D\52A1\5668\3002\8BED\6CD5\53D6\51B3\4E8E REST \6570\636E\6E90\7684\7C7B\578B\3002\4F8B\5982\FF0COracle REST Data Services (ORDS) \9700\8981 JSON \8BED\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719104681312895)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719616997312896)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5BF9\4E8E ORDS REST \670D\52A1\FF0C\6309\7167 "job" \5C5E\6027\5347\5E8F\6392\5E8F\FF0C\7136\540E\6309 "ename" \964D\5E8F\6392\5E8F\3002</dt>'),
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719534626312896)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\8981\4F20\9012\5230\5916\90E8 REST \670D\52A1\7684\6392\5E8F\65B9\5F0F\8868\8FBE\5F0F\3002\8BE5\8868\8FBE\5F0F\5C06\539F\6837\4F20\9012\5230\8FDC\7A0B\670D\52A1\5668\3002\8BED\6CD5\53D6\51B3\4E8E REST \6570\636E\6E90\7684\7C7B\578B\3002\4F8B\5982\FF0COracle REST Data Services (ORDS) \9700\8981 JSON \8BED\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719484811312895)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8\6392\5E8F\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267488684312538)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\4E3A\6B64\62A5\8868\542F\7528\5916\90E8\540E\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267345199312538)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267104520312537)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6700\7EC8\7528\6237\5355\51FB\6765\8C03\7528\5916\90E8\5904\7406\5F15\64CE\7684\94FE\63A5\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108267078766312537)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266977406312537)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\670D\52A1\5668\7684 URL \7528\4E8E\6B64\62A5\8868\7684\540E\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108266806511312537)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576909201312786)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\6B64\590D\9009\6846\76F8\5173\8054\7684\9762\7EC4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576885142312786)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505336833312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\503C\5217\8868\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506070366312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108506116374312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\57FA\4E8E\81EA\52A8\751F\6210\7684\67E5\8BE2\FF0C\6B64\67E5\8BE2\4F1A\9009\62E9\4E0D\540C\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632296240312828)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108632342757312828)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\503C\5217\8868\57FA\4E8E\60A8\8F93\5165\7684\51FD\6570\4F53\6240\8FD4\56DE\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505449986312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505559718312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\57FA\4E8E\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\7684\9884\5B9A\4E49\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505623295312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505721922312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\503C\5217\8868\57FA\4E8E\60A8\8F93\5165\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505889351312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505927243312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C\5217\8868\57FA\4E8E\60A8\8F93\5165\7684\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108505220106312730)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350282918312605)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\9762\662F\5426\53EF\6298\53E0\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\9762\5DE6\4FA7\5C06\663E\793A\4E00\4E2A\5207\6362\9009\9879\FF0C\7528\4E8E\9690\85CF/\663E\793A\5176\5217\8868\6761\76EE\3002\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\65F6\FF0C\9762\53CA\5176\5217\8868\6761\76EE\59CB\7EC8\53EF\89C1\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350196628312605)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\6298\53E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768906702312934)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\8BA1\7B97\9762\6216\7B5B\9009\5668\7684\5217\8868\6761\76EE\8BA1\6570\3002\4F7F\7528\6B64\9009\9879\65F6\4F1A\5F71\54CD\6027\80FD\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768854375312934)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577154181312786)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5982\4F55\7EC4\5408\6B64\7EC4\5185\7684\7B5B\9009\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577474837312786)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('AND\FF08\4EA4\96C6\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577539550312786)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F7F\7528 "AND" \7EC4\5408\7B5B\9009\5668\FF0C\56E0\6B64\7ED3\679C\5C06\4E3A\5404\4E2A\7B5B\9009\5668\7684\4EA4\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577232688312786)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OR\FF08\5E76\96C6\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577381009312786)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F7F\7528 "OR" \7EC4\5408\7B5B\9009\5668\FF0C\56E0\6B64\7ED3\679C\5C06\4E3A\5404\4E2A\7B5B\9009\5668\7684\5E76\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577035838312786)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5408\7B5B\9009\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349667457312604)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\5141\8BB8\5BA2\6237\7AEF\7B5B\9009\9762\6216\7B5B\9009\5668\7684\5217\8868\6761\76EE\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\5C06\5728\5217\8868\6761\76EE\4E0A\65B9\5448\73B0\4E00\4E2A\641C\7D22\5B57\6BB5\FF0C\4EE5\5141\8BB8\6700\7EC8\7528\6237\7B5B\9009\5217\8868\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349570298312604)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\7AEF\8FC7\6EE4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578194871312787)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\6700\521D\662F\5426\663E\793A\56FE\8868\3002\4EC5\5F53\5206\9762\641C\7D22\533A\57DF\5C5E\6027\201C\663E\793A\56FE\8868\201D\662F\201C\9009\62E9\5668\201D\65F6\FF0C\624D\4F1A\5E94\7528\6B64\5C5E\6027\3002\7531\4E8E\7528\6237\5DF2\7ECF\663E\793A\7684\56FE\8868\96C6\6301\4E45\4FDD\5B58\5728\6D4F\89C8\5668\4F1A\8BDD\4E2D\FF0C\60A8\53EF\80FD\4E0D\4F1A\7ACB\5373\770B\5230\5BF9\6B64\5C5E\6027\7684\66F4\6539\3002\8981\67E5\770B\66F4\6539\6B64\5C5E\6027\7684\6548\679C\FF0C\8BF7\4F7F\7528\94FE\63A5\5BF9\8BDD\6846\4E2D\7684\201C\91CD\7F6E\533A\57DF\201D\6216\9AD8\901F\7F13\5B58\63A7\5236\9009\9879\FF08\4F8B\5982\4F7F\7528\5411\5BFC\751F\6210\7684\201C\91CD\7F6E\201D\6309\94AE\FF09\91CD\7F6E\62A5\8868\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578050587312787)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\521D\663E\793A\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350430847312605)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\6700\521D\662F\5426\5E94\4EE5\6298\53E0\72B6\6001\5448\73B0\9762\3002\7531\4E8E\5C55\5F00\72B6\6001\6301\4E45\4FDD\5B58\5728\6D4F\89C8\5668\4F1A\8BDD\4E2D\FF0C\60A8\53EF\80FD\4E0D\4F1A\7ACB\5373\770B\5230\5BF9\6B64\5C5E\6027\7684\66F4\6539\3002\8981\67E5\770B\66F4\6539\6B64\5C5E\6027\7684\6548\679C\FF0C\8BF7\4F7F\7528\94FE\63A5\5BF9\8BDD\6846\4E2D\7684\201C\91CD\7F6E\533A\57DF\201D\6216\9AD8\901F\7F13\5B58\63A7\5236\9009\9879\FF08\4F8B\5982\4F7F\7528\5411\5BFC\751F\6210\7684\201C\91CD\7F6E\201D\6309\94AE\FF09\91CD\7F6E\62A5\8868\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350364167312605)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\6298\53E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583034975312790)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\786E\5B9A\9ED8\8BA4\60C5\51B5\4E0B\662F\5426\663E\793A\9762\3002\7531\4E8E\663E\793A\72B6\6001\6301\4E45\4FDD\5B58\5728\6D4F\89C8\5668\4F1A\8BDD\4E2D\FF0C\60A8\53EF\80FD\4E0D\4F1A\7ACB\5373\770B\5230\5BF9\6B64\5C5E\6027\7684\66F4\6539\3002\8981\67E5\770B\66F4\6539\6B64\5C5E\6027\7684\6548\679C\FF0C\8BF7\4F7F\7528\94FE\63A5\5BF9\8BDD\6846\4E2D\7684\201C\91CD\7F6E\533A\57DF\201D\6216\9AD8\901F\7F13\5B58\63A7\5236\9009\9879\FF08\4F8B\5982\4F7F\7528\5411\5BFC\751F\6210\7684\201C\91CD\7F6E\201D\6309\94AE\FF09\91CD\7F6E\62A5\8868\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582961835312790)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\521D\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350657251312605)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9762\7684\6700\5927\9AD8\5EA6\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350525318312605)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350751650312605)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692960563312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7B5B\9009\65F6\5982\4F55\7EC4\5408\5404\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693247020312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('AND\FF08\4EA4\96C6\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693339816312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F7F\7528 "AND" \7EC4\5408\591A\4E2A\503C\FF0C\56E0\6B64\7ED3\679C\5C06\4E3A\5404\4E2A\503C\7684\4EA4\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693016094312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OR\FF08\5E76\96C6\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693117641312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F7F\7528 "OR" \7EC4\5408\591A\4E2A\503C\FF0C\56E0\6B64\7ED3\679C\5C06\4E3A\5404\4E2A\503C\7684\5E76\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692866032312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\7EC4\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692518669312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\666E\901A\5B57\7B26\FF1A</dt>'),
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
unistr('<dt>\63A7\5236\5B57\7B26\FF1A</dt>'),
unistr('<dd>\5236\8868\7B26 (<em>ASCII: 9</em>) <pre>\005Ct</pre></dd>'),
unistr('<dd>\6362\884C\7B26 (<em>ASCII: 10</em>) <pre>\005Cn</pre></dd>'),
unistr('<dt>\5176\4ED6\5B57\7B26\FF1A</dt>'),
unistr('<dd>\4F7F\7528 ''\005Cxxxx'' \683C\5F0F\7684 Unicode \7F16\7801\503C\FF0C\5176\4E2D ''\005Cxxxx'' \662F UCS-2 \7F16\7801\683C\5F0F\7684\5B57\7B26\7684\5341\516D\8FDB\5236\503C\3002</dd>'),
unistr('<dd>\6807\9898\5F00\5934 (<em>ASCII: 1</em>) <pre>\005C0001</pre></dd>'),
'<dd>"@"-Symbol (<em>ASCII: 64</em>) <pre>\0040</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692485231312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\8BC6\5C06\503C\5F7C\6B64\5206\9694\7684\5B57\7B26\3002\8BF7\6CE8\610F\FF0C\4E0D\652F\6301\5C06 <strong>"</strong>\FF08\53CC\5F15\53F7\FF09\548C <strong>\005C</strong>\FF08\53CD\659C\6760\FF09\5B57\7B26\4F5C\4E3A\503C\5206\9694\7B26\FF0C\4E5F\4E0D\652F\6301\91C7\7528 <strong>\005Cxxxx</strong> \683C\5F0F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692310790312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692745927312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\62C6\5206\540E\662F\5426\4ECE\5404\4E2A\503C\4E2D\622A\53D6\524D\5BFC\548C\5C3E\968F\7A7A\683C\3002</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>\5982\679C\201C\622A\53D6\7A7A\683C\201D\5904\4E8E<em>\5DF2\7981\7528</em>\72B6\6001\FF0C\5C06\5BFC\81F4\5BF9\4EE5\4E0B\5404\4E2A\503C\8FDB\884C\8BA1\6570\FF1A</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>\5982\679C\201C\622A\53D6\7A7A\683C\201D\5904\4E8E<em>\5DF2\542F\7528</em>\72B6\6001\FF0C\5C06\5BFC\81F4\5BF9\4EE5\4E0B\5404\4E2A\503C\8FDB\884C\8BA1\6570\FF1A</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>\8BF7\6CE8\610F\FF0C\622A\53D6\7A7A\683C\53EF\80FD\4F1A\663E\8457\5F71\54CD\67E5\8BE2\6027\80FD\3002\5BF9\4E8E\8F83\5927\7684\6570\636E\96C6\FF0C\8BF7\8003\8651\8FDB\884C\6570\636E\6E05\7406\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692613451312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\622A\53D6\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693695341312088)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693727500312088)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\5305\542B\591A\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942166312312278)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942205363312279)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\5305\542B\591A\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691801583312086)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\786E\5B9A\6E90\5217\662F\5426\5305\542B\591A\4E2A\503C\4EE5\53CA\8FD9\4E9B\503C\7684\7F16\7801\65B9\5F0F\3002</p><p><em>\53EA\6709 Oracle 12.2 \6216\66F4\9AD8\7248\672C\7684\6570\636E\5E93\624D\652F\6301\591A\503C\9762\6216\7B5B\9009\5668\3002\5728 12.1 \6570\636E\5E93\4E2D\FF0C\5982\679C\5B9A\4E49\4E86\591A\503C\9762\6216\7B5B\9009\5668\FF0C&PRODUCT_NAME. \5C06\5F15\53D1\8FD0\884C\65F6\9519\8BEF\3002</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692126084312086)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JSON \6570\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692285213312087)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\201C\6E90\201D\5217\5305\542B\6807\91CF\503C\7684 JSON \6570\7EC4\3002\5982\679C\8BE5\5217\4E2D\5305\542B\65E0\6548\7684 JSON \8BED\6CD5\FF0C&PRODUCT_NAME. \5C06\5F15\53D1\9519\8BEF\6D88\606F\3002</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691983552312086)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107692036988312086)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5217\4EE5\5206\9694\5217\8868\7684\5F62\5F0F\5305\542B\503C\3002</p><pre>APEX,SQL,PL/SQL</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691765939312086)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577972852312786)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\6309\94AE\662F\5426\663E\793A\5728\9762\7684\65C1\8FB9\FF0C\4EE5\5141\8BB8\7528\6237\663E\793A\9762\5217\8868\6761\76EE\8BA1\6570\7684\56FE\8868\3002\4EC5\5F53\5206\9762\641C\7D22\533A\57DF\5C5E\6027\201C\663E\793A\56FE\8868\201D\4E0D\662F\201C\5426\201D\65F6\FF0C\624D\4F1A\5E94\7528\6B64\5C5E\6027\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108577808102312786)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349432985312604)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\663E\793A\9762\6216\7B5B\9009\5668\7684\5217\8868\6761\76EE\7684\51FA\73B0\6B21\6570\8BA1\6570\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\5C06\5728\5217\8868\6761\76EE\65C1\8FB9\663E\793A\7528\62EC\53F7\62EC\4F4F\7684\8BA1\6570\3002\4F8B\5982 KING (3)\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349341593312604)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350071502312605)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\8981\4E3A\9762\663E\793A\7684\6700\5927\5217\8868\6761\76EE\6570\3002\6307\5B9A\4E86\503C\4E14\5217\8868\5305\542B\7684\6761\76EE\6570\8D85\8FC7\6B64\6761\76EE\6570\65F6\FF0C\5217\8868\5E95\90E8\5C06\5448\73B0<strong>\663E\793A\66F4\591A</strong>\94FE\63A5\3002\672A\6307\5B9A\4EFB\4F55\503C\65F6\FF0C\5C06\663E\793A\6240\6709\5217\8868\6761\76EE\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349954736312604)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\663E\793A\6761\76EE\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349851271312604)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\6240\9009\7684\5217\8868\6761\76EE\662F\5426\663E\793A\5728\9762\6216\7B5B\9009\5668\5217\8868\4E2D\6700\524D\9762\7684\4F4D\7F6E\3002\5728\4E0E\9762\5173\8054\7684\503C\5217\8868\5B9A\4E49\7EC4\7684\60C5\51B5\4E0B\FF0C\6B64\5C5E\6027\4E0D\9002\7528\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349780277312604)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\9879\663E\793A\5728\6700\524D\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979376727312307)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5BF9\9762\6216\7B5B\9009\5668\7684\5217\8868\6761\76EE\6392\5E8F\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\5217\8868\6761\76EE\5C06\6309\6570\91CF\964D\5E8F\6392\5E8F\3002\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\65F6\FF0C\5217\8868\6761\76EE\5C06\6309\503C\5217\8868\5B9A\4E49\7684\987A\5E8F\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107979239179312306)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\6570\91CF\4ECE\591A\5230\5C11\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582867410312790)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\663E\793A\6216\9690\85CF\9762\3002\5F53\81F3\5C11\6709\4E00\4E2A\9762\542F\7528\6B64\9009\9879\65F6\FF0C\4F1A\6DFB\52A0\201C\66F4\591A\9762\201D\6309\94AE\3002\53EF\4F7F\7528\6B64\6309\94AE\9009\62E9\663E\793A\6216\9690\85CF\54EA\4E9B\9762\3002\8BA1\7B97\672A\663E\793A\7684\9762\6570\6CA1\6709\6027\80FD\6210\672C\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582708458312790)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5207\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769161804312934)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\5982\4F55\663E\793A\9762\6216\7B5B\9009\5668\7684\8BA1\6570\4E3A\96F6\7684\5217\8868\6761\76EE\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769447329312935)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769573740312935)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\663E\793A\6240\6709\6761\76EE\FF0C\4F46\7981\7528\4E0D\53EF\8FC7\6EE4\7684\6761\76EE\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769204009312934)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769392687312934)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\4EC5\663E\793A\53EF\8FC7\6EE4\7684\5217\8868\6761\76EE\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769678410312935)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6700\540E\4F4D\7F6E\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769743381312935)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5728\9762\6216\7B5B\9009\5668\7684\5217\8868\4E2D\663E\793A\6240\6709\6761\76EE\FF0C\4F46\7981\7528\4E0D\53EF\7B5B\9009\7684\6761\76EE\FF0C\5E76\5728\6700\540E\4F4D\7F6E\663E\793A\5B83\4EEC\3002\5982\679C\5173\8054\7684\5171\4EAB\503C\5217\8868\4F7F\7528\7EC4\529F\80FD\FF0C\5219\5FFD\7565\6B64\9009\9879\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769067231312934)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570\4E3A\96F6\7684\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902521699312248)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\5305\542B\6B64\6807\7B7E\7684 HTML \8868\5355\5143\4E2D\4F7F\7528\7684\4EFB\4F55\9644\52A0\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902409003312248)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\5143\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258471734312530)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\5448\73B0\8868\683C\5F0F\8868\5355\5B57\6BB5\65F6\4F7F\7528\7684\5B57\6BB5\6A21\677F\3002\672A\9009\4E2D\4EFB\4F55\6A21\677F\65F6, \5C06\4F7F\7528\9ED8\8BA4\7684\53EF\8BBF\95EE\6027\76F8\5BB9\6807\7B7E\5448\73B0\5B57\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278604070312547)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\5448\73B0\8868\683C\5F0F\8868\5355\5B57\6BB5\65F6\4F7F\7528\7684\5B57\6BB5\6A21\677F\3002\672A\9009\4E2D\4EFB\4F55\6A21\677F\65F6, \5C06\4F7F\7528\9ED8\8BA4\7684\53EF\8BBF\95EE\6027\76F8\5BB9\6807\7B7E\5448\73B0\5B57\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902392501312248)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6807\7B7E\6A21\677F\4EE5\5B9A\4E49\6B64\9879\6807\7B7E\7684\5916\89C2\548C\5E03\5C40\3002</p>'),
unistr('        <p>\6807\7B7E\6A21\677F\5728\5E94\7528\7A0B\5E8F\4E3B\9898\4E2D\5B9A\4E49\3002'),
unistr('        \521B\5EFA\9879\65F6\FF0C\6A21\677F\81EA\52A8\8BBE\7F6E\4E3A\5728\5F53\524D\4E3B\9898\4E2D\5B9A\4E49\7684\9ED8\8BA4\9879\6A21\677F\3002</p>'),
unistr('        <p>\8BB8\591A\4E3B\9898\5305\542B\7528\4E8E\663E\793A\5FC5\9700\3001\53EF\9009\548C\9690\85CF\6807\7B7E\7684\6807\7B7E\6A21\677F\3002<br>'),
unistr('        \901A\7528\4E3B\9898\63D0\4F9B\4EE5\4E0B\6807\7B7E\6A21\677F\FF1A'),
'          <dl>',
unistr('            <dt>\9690\85CF</dt>'),
unistr('              <dd>\5F53\6807\7B7E\4E0D\5E94\663E\793A\5728\5C4F\5E55\4E0A\65F6\4F7F\7528\6B64\9879\3002\8BF7\6CE8\610F\FF0C\8F85\52A9\6280\672F\4ECD\80FD\591F\8BFB\53D6\6807\7B7E\3002'),
unistr('              \5BF9\4E8E\590D\9009\6846\9879\4F1A\5FFD\7565\201C\9690\85CF\201D\FF0C\56E0\4E3A\5728\590D\9009\6846\540E\9762\5FC5\987B\663E\793A\6807\7B7E\3002</dd>'),
unistr('            <dt>\53EF\9009</dt>'),
unistr('              <dd>\6B64\9879\7528\4E8E\53EF\9009\7684\8868\5355\9879\3002\6807\7B7E\5C06\663E\793A\5728\9879\7684\65C1\8FB9\3002</dd>'),
unistr('            <dt>\53EF\9009 - \4E0A\65B9</dt>'),
unistr('              <dd>\6B64\9879\7528\4E8E\53EF\9009\7684\8868\5355\9879\3002\6807\7B7E\5C06\663E\793A\5728\9879\7684\4E0A\65B9\3002</dd>'),
unistr('            <dt>\53EF\9009 - \6D6E\52A8</dt>'),
unistr('              <dd>\6B64\9879\7528\4E8E\53EF\9009\7684\8868\5355\9879\3002\6807\7B7E\5C06\663E\793A\5728\8F93\5165\9879\7684\5185\90E8\FF0C\5E76\5728\8F93\5165\5B57\6BB5\4E2D\5177\6709\503C\65F6\81EA\52A8\6536\7F29\3002</dd>'),
unistr('            <dt>\5FC5\9700</dt>'),
unistr('              <dd>\6B64\6807\7B7E\6A21\677F\5728\6807\7B7E\7684\65C1\8FB9\663E\793A\7EA2\8272\661F\53F7\FF0C\5E76\7528\4E8E\9700\8981\7528\6237\8F93\5165\7684\8868\5355\9879\3002\6807\7B7E\5C06\663E\793A\5728\9879\7684\65C1\8FB9\3002</dd>'),
unistr('            <dt>\5FC5\9700 - \4E0A\65B9</dt>'),
unistr('              <dd>\6B64\6807\7B7E\6A21\677F\5728\6807\7B7E\7684\65C1\8FB9\663E\793A\7EA2\8272\661F\53F7\FF0C\5E76\7528\4E8E\9700\8981\7528\6237\8F93\5165\7684\8868\5355\9879\3002\6807\7B7E\5C06\663E\793A\5728\9879\7684\4E0A\65B9\3002\4F7F\7528\9879\6A21\677F\53EF\4EE5\5C06\7528\6237\754C\9762\5C5E\6027\5B9A\4E49\4E3A\4E3B\9898\7684\4E00\90E8\5206\FF0C\5E76\5728\591A\4E2A\9875\9879\4E4B\95F4\5171\4EAB\5B9A\4E49\3002</dd>'),
unistr('            <dt>\5FC5\9700 - \6D6E\52A8</dt>'),
unistr('              <dd>\6B64\6807\7B7E\6A21\677F\5728\6807\7B7E\7684\65C1\8FB9\663E\793A\7EA2\8272\661F\53F7\FF0C\5E76\7528\4E8E\9700\8981\7528\6237\8F93\5165\7684\8868\5355\9879\3002\6807\7B7E\5C06\663E\793A\5728\8F93\5165\9879\7684\5185\90E8\FF0C\5E76\5728\8F93\5165\5B57\6BB5\4E2D\5177\6709\503C\65F6\81EA\52A8\6536\7F29\3002\4F7F\7528\9879\6A21\677F\53EF\4EE5\5C06\7528\6237\754C\9762\5C5E\6027\5B9A\4E49\4E3A\4E3B\9898\7684\4E00\90E8\5206\FF0C\5E76\5728\591A\4E2A\9875\9879\4E4B\95F4\5171\4EAB\5B9A\4E49\3002</dd>'),
'          </dl>',
unistr('          \53E6\8BF7\53C2\89C1\FF1A<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902277084312248)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715540466312893)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129523716312426)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5F53\6700\7EC8\7528\6237\5728\5217\8FC7\6EE4\5668\4E2D\8F93\5165\6587\672C\65F6\662F\5426\6267\884C\5B8C\5168\5339\914D\641C\7D22\3002'),
unistr('      \5982\679C\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\FF0C\5219\8FC7\6EE4\5668\5C06\6267\884C\5305\542B\641C\7D22\800C\975E\7B49\4E8E\641C\7D22\3002</p>'),
unistr('      <p>\4F8B\5982\FF0C\5BF9\4E8E\540D\4E3A TAGS \7684\5217\FF0C\8FD9\7B49\540C\4E8E TAGS = ''<<value>>''\FF0C\5982\679C\201C\5B8C\5168\5339\914D\201D\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\FF0C\8FD9\7B49\540C\4E8E TAGS LIKE ''%<<value>>%''\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129433547312426)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\5168\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127998700312425)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\59CB\7EC8\9700\8981\5BF9\6B64\5217\4F7F\7528\8FC7\6EE4\5668\3002</p>'),
unistr('        <p>\6CE8 - \5728\8FD4\56DE\4EFB\4F55\6570\636E\4E4B\524D, \5C06\59CB\7EC8\9700\8981\5BF9\6B64\7279\5B9A\5217\4F7F\7528\8FC7\6EE4\5668, \800C\4E0D\8003\8651\4EA4\4E92\5F0F\7F51\683C\5C5E\6027\4E2D\7684<strong>\9700\8981\8FC7\6EE4\5668</strong>\9009\9879\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127862810312425)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128161381312425)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5F53\7528\6237\5355\51FB\5217\6807\9898\6216\8FC7\6EE4\5668\5BF9\8BDD\6846\65F6\5982\4F55\4E3A\8FC7\6EE4\5668\6D3E\751F\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128457165312425)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128563243312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A VARCHAR2 \548C NUMBER \5217\663E\793A\4E0D\540C\5217\503C\3002DATE \548C TIMESTAMP \5217\4F7F\7528\5185\7F6E\7684\9884\5B9A\4E49\65E5\671F\8303\56F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714516096312892)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714670711312892)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\503C\5217\8868\6D3E\751F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128292476312425)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128368506312425)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7981\6B62\5728\8FC7\6EE4\5668\4E2D\663E\793A\4EFB\4F55\503C\3002'),
unistr('        \5217\975E\5E38\5927 (\901A\5E38, \591A\6570\503C\8D85\8FC7 50 \4E2A\5B57\7B26) \65F6\6216\8005\5217\8868\4E0D\592A\9002\7528\4E8E\9009\62E9\7279\5B9A\8BB0\5F55\65F6, \9002\5408\4F7F\7528\6B64\9009\9879\3002'),
unistr('        \800C\6700\7EC8\7528\6237\53EF\4EE5\53EA\952E\5165\90E8\5206\503C, \7136\540E\4FBF\53EF\67E5\770B\7ED3\679C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129267678312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129352858312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53\6D3E\751F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128878479312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128909483312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\6709\503C\5217\8868\6D3E\751F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128614521312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128714907312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE SQL \67E5\8BE2\5B9A\4E49\6D3E\751F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129036858312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129153075312426)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9759\6001\503C\5217\8868\6D3E\751F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108128051843312425)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LOV \7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126715245312424)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6700\7EC8\7528\6237\53EF\5BF9\6B64\5217\4F7F\7528\7684\8FC7\6EE4\5668\8FD0\7B97\7B26\3002</p>'),
unistr('        <p>\6839\636E\6570\636E\96C6\5927\5C0F\548C\5217\7D22\5F15\6570, \60A8\53EF\4EE5\9009\62E9\5BF9\6700\7EC8\7528\6237\7981\7528\67D0\4E9B\8FC7\6EE4\5668\8FD0\7B97\7B26\4EE5\907F\514D\51FA\73B0\6027\80FD\95EE\9898\3002'),
unistr('        \67D0\4E9B\8FD0\7B97\7B26\53EF\80FD\4F1A\5BFC\81F4\5168\8868\626B\63CF\800C\4E0D\662F\4F7F\7528\5217\7D22\5F15\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298033470312563)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298114200312563)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FC7\6EE4\5668\8FD4\56DE\5305\542B\8FC7\6EE4\5668\503C\7684\5217\503C\7ED3\679C\3002'),
unistr('        &PRODUCT_NAME. \5C06\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code>\3002</p>'),
unistr('        <p>\6CE8 - \6B64\8FD0\7B97\7B26\5C06\963B\6B62\4F7F\7528\4EFB\4F55\5217\7D22\5F15, \8FD9\53EF\80FD\4F1A\5BFC\81F4\5168\8868\626B\63CF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126982596312424)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\533A\5206\5927\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249527490312522)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FC7\6EE4\5668\8FD4\56DE\5217\503C\7ED3\679C, \800C\4E0D\8003\8651\5217\503C\548C\8FC7\6EE4\5668\503C\7684\5DEE\5F02\3002'),
unistr('        &PRODUCT_NAME. \5C06\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>UPPER(column) <em>\8FD0\7B97\7B26</em> UPPER(filtervalue)</code>\3002</p>'),
unistr('        <p>\6CE8 - \901A\5E38, \540C\65F6\5BF9\5217\503C\548C\8FC7\6EE4\5668\503C\6267\884C UPPER \5C06\963B\6B62\4F7F\7528\4EFB\4F55\5217\7D22\5F15, \5E26\6709 UPPER(<em>column</em>) \7684\57FA\4E8E\51FD\6570\7684\5217\7D22\5F15\9664\5916\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126897029312424)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5219\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249651151312522)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FC7\6EE4\5668\57FA\4E8E\8F93\5165\7684\6B63\5219\8868\8FBE\5F0F\8FD4\56DE\7ED3\679C\3002</p>'),
unistr('        <p>\6CE8 - \4F7F\7528 REGEXP \8FD0\7B97\7B26\975E\5E38\590D\6742, \901A\5E38\53EA\7531\9AD8\7EA7\7528\6237\4F7F\7528\3002\6B64\7C7B\8FD0\7B97\7B26\4F1A\5BFC\81F4\6027\80FD\975E\5E38\5DEE\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298283103312563)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298359733312563)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FC7\6EE4\5668\8FD4\56DE\4EE5\8FC7\6EE4\5668\503C\5F00\5934\7684\5217\503C\7ED3\679C\3002'),
unistr('        &PRODUCT_NAME. \5C06\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column LIKE filtervalue<strong>%</strong></code>\3002</p>'),
unistr('        <p>\6CE8 - \6B64\8FD0\7B97\7B26\53EF\4EE5\4F7F\7528\53EF\7528\7684\5217\7D22\5F15\3002{\8BF7\67E5\770B<strong>\4E0D\533A\5206\5927\5C0F\5199</strong>\4EE5\4E86\89E3\4F8B\5916\60C5\51B5}\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126661852312424)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6027\80FD\5F71\54CD\8FD0\7B97\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127182339312424)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5217\503C\4E2D\6587\672C\7684\5927\5C0F\5199\5B58\50A8\5F62\5F0F\3002</p>'),
unistr('        <p>\5982\679C\5217\53EF\6307\5B9A\4E3A\59CB\7EC8\5927\5199 (\4F8B\5982<em>\7528\6237\540D</em>) \6216\59CB\7EC8\5C0F\5199, \5219\68C0\7D22\8FC7\6EE4\7ED3\679C\7684\6027\80FD\4F1A\5F97\5230\63D0\9AD8\3002'),
unistr('          \5982\679C\9009\62E9\4E86<strong>\5927\5199</strong>\6216<strong>\5C0F\5199</strong>, \5219\641C\7D22\5C06\59CB\7EC8\6267\884C\533A\5206\5927\5C0F\5199\7684\641C\7D22\3002</p>'),
unistr('        <p>\6CE8 - \5982\679C\9009\62E9\4E86\201C\6DF7\5408\201D, \5219\6700\7EC8\7528\6237\53EF\4EE5\5728\201C\641C\7D22\201D\548C\201C\8FC7\6EE4\201D\5BF9\8BDD\6846\4E2D\6307\5B9A<strong>\533A\5206\5927\5C0F\5199</strong>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127491573312425)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127533076312425)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F55\65F6\59CB\7EC8\4EE5\5C0F\5199\5B58\50A8\5217\503C\3002'),
unistr('        &PRODUCT_NAME. \5C06\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column <em>\8FD0\7B97\7B26</em> LOWER(filtervalue)</code>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127682448312425)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF7\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127738975312425)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F55\65F6\4EE5\6DF7\5408\5927\5C0F\5199\5F62\5F0F\5B58\50A8\5217\503C\3002<strong>\4E0D\533A\5206\5927\5C0F\5199</strong>\8FD0\7B97\7B26\7684\8BBE\7F6E\5C06\786E\5B9A\4F7F\7528\7684 where \5B50\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127205056312425)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127384595312425)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F55\65F6\59CB\7EC8\4EE5\5927\5199\5B58\50A8\5217\503C\3002'),
unistr('        &PRODUCT_NAME. \5C06\5728 where \5B50\53E5\4E2D\4F7F\7528 <code>column <em>\8FD0\7B97\7B26</em> UPPER(filtervalue)</code>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108127033680312424)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5927\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921128202312262)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\521D\59CB\5316\65F6\89E6\53D1\64CD\4F5C\3002</p>'),
unistr('        							<p>\6839\636E\52A8\6001\64CD\4F5C\7684\5B9A\4E49\65B9\5F0F, \521D\59CB\5316\7565\6709\4E0D\540C\3002\5BF9\4E8E\5B9A\4E49\4E3A'),
unistr('        							\5728\4EA4\4E92\5F0F\7F51\683C\5217\4E0A\89E6\53D1\7684\52A8\6001\64CD\4F5C, \8FD9\6307\5B9A\662F\5426\5728\6FC0\6D3B'),
unistr('        							\4EA4\4E92\5F0F\7F51\683C\884C\8FDB\884C\7F16\8F91\65F6\89E6\53D1\64CD\4F5C\3002\5BF9\4E8E\6240\6709\5176\4ED6\52A8\6001\64CD\4F5C,'),
unistr('        							\8FD9\6307\5B9A\662F\5426\5728\9875\52A0\8F7D\65F6\89E6\53D1\64CD\4F5C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107921098991312262)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\65F6\89E6\53D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920926500312262)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\901A\8FC7\9009\62E9<strong>\771F</strong> (\201C\771F\201D\64CD\4F5C) \6EE1\8DB3\89E6\53D1\5143\7D20\6761\4EF6\65F6\6216\901A\8FC7\9009\62E9<strong>\5047</strong> (\201C\5047\201D\64CD\4F5C) \4E0D\6EE1\8DB3\89E6\53D1\5143\7D20\6761\4EF6\65F6, \662F\5426\89E6\53D1\6B64\64CD\4F5C\3002</p>'),
unistr('<p>\6CE8: \5982\679C\672A\6307\5B9A\6761\4EF6, \5219\4EC5\5C06\89E6\53D1<strong>\771F</strong>\64CD\4F5C\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410687892312652)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5047')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108410530627312652)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\771F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920810578312262)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\4E8B\4EF6\7ED3\679C\4E3A\4EE5\4E0B\5185\5BB9\65F6\89E6\53D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794770597312961)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E0C\671B\5C06\62A5\8868\7684\5217\6807\9898\56FA\5B9A\5230<strong>\9875</strong>\7684\9876\90E8\6216<strong>\533A\57DF</strong>\7684\9876\90E8, \4ECE\800C\4F7F\5217\6807\9898\5728\7528\6237\5782\76F4\6EDA\52A8\62A5\8868\65F6\4FDD\6301\53EF\89C1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795741568312962)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795808648312962)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\56FA\5B9A\62A5\8868\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794909502312961)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795179871312961)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\62A5\8868\6807\9898\56FA\5B9A\5230\9875\9876\90E8\3002\5F53\7528\6237\5782\76F4\6EDA\52A8\9875\65F6\FF0C\62A5\8868\6807\9898\5C06\4FDD\6301\56FA\5B9A\5728\9875\9876\90E8\3002<strong>\9875</strong>\7EA7\522B\56FA\5B9A\6807\9898\5728\62A5\8868\662F\9875\4E0A\7684\4E3B\8981\5185\5BB9\65F6\4F1A\975E\5E38\6709\7528\3002\533A\57DF\5728\5BF9\8BDD\6846\4E2D\65F6\4E0D\652F\6301\6B64\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794818386312961)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795061624312961)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\62A5\8868\6807\9898\56FA\5B9A\5230\5F53\524D\533A\57DF\7684\9876\90E8\3002\5F53\7528\6237\5728\533A\57DF\4E2D\5782\76F4\6EDA\52A8\65F6, \62A5\8868\6807\9898\5C06\4FDD\6301\56FA\5B9A\5728\533A\57DF\9876\90E8\3002<strong>\533A\57DF</strong>\7EA7\522B\56FA\5B9A\6807\9898\5BF9\4E8E\5305\542B\591A\4E2A\533A\57DF\7684\9875\4F1A\975E\5E38\6709\7528, \4F8B\5982\9762\677F\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794625572312961)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FA\5B9A\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796129794312962)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\62A5\8868\7684\6700\5927\9AD8\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796099982312962)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\62A5\8868\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108796229065312962)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304131341312568)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\62A5\8868\7684\56FA\5B9A\9AD8\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304068341312568)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FA\5B9A\62A5\8868\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304240037312568)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120643821312419)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\663E\793A\884C\9AD8\5EA6\56FA\5B9A\7684\4EA4\4E92\5F0F\7F51\683C\3002</p>'),
unistr('        <p>\5982\679C\8BBE\7F6E\4E3A<em>\662F</em>\FF0C\5219\5BF9\4E8E\592A\7A84\800C\65E0\6CD5\663E\793A\6240\6709\6570\636E\7684\5217\FF0C\5C06\5728\6570\636E\7ED3\5C3E\663E\793A\7701\7565\53F7 (...)\3002'),
unistr('        \5982\679C\8BBE\7F6E\4E3A<em>\5426</em>\FF0C\5219\6570\636E\5C06\6839\636E\9700\8981\5206\5E03\5728\591A\884C\4E0A\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120578184312419)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FA\5B9A\884C\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990082532312315)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7D27\63A5\7740\6B63\6587\5185\5BB9\663E\793A\7684\533A\57DF\9875\811A (\5373\533A\57DF\6A21\677F\4E2D\51FA\73B0\5728 <code>#BODY#</code> \4E4B\540E\7684\5185\5BB9)\3002'),
unistr('\53EF\4EE5\4F7F\7528\5FEB\6377\65B9\5F0F\548C\66FF\6362\5B57\7B26\4E32 <code>#TIMING#</code> \6765\663E\793A\5448\73B0\6B64\533A\57DF\6240\82B1\7684\65F6\95F4\3002</p>'),
unistr('<p>\5BF9\4E8E\62A5\8868\533A\57DF, \53EF\4EE5\4F7F\7528\4EE5\4E0B\9875\7801\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\663E\793A\62A5\8868\5F15\64CE\63D0\53D6\7684\884C\6570 (\9875\5927\5C0F)\3002\4F7F\7528\8FD9\4E9B\66FF\6362\5B57\7B26\4E32\5411\7528\6237\663E\793A\5B9A\5236\7684\6D88\606F\3002</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>\663E\793A\6EE1\8DB3\7528\4E8E\62A5\8868\7684 SQL \67E5\8BE2\7684\603B\884C\6570\3002\4F8B\5982, \884C X - Y (\5171 Z \884C) \4E2D\7684 Z</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\884C X - Y (\5171 Z \884C) \4E2D\7684 X</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>\884C X - Y (\5171 Z \884C) \4E2D\7684 Y</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899688866312246)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\9875\6A21\677F\9875\811A\4E4B\524D\663E\793A\7684\6587\672C\6216 HTML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899547640312246)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108439479646312678)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A <code>fielddatabold</code> \5C06\5BFC\81F4\751F\6210\4EE5\4E0B HTML</dt>'),
'<dd><pre>',
unistr('&lt;span class="fielddatabold"&gt;\793A\4F8B\6570\636E&lt;/span&gt;'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256890695312529)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5E94\7528\4E8E\6B64\5217\503C\7684 CSS \7C7B\3002\53EF\4EE5\952E\5165 CSS \7C7B\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('<p>\9ED8\8BA4\60C5\51B5\4E0B\6B64\7C7B\5305\62EC\5728\6240\6709 &PRODUCT_NAME. \9875\4E0A, \5E76\4E14\5176\5B9A\4E49\4E3A <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256784020312529)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258320489312530)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5E94\7528\4E8E\6B64\5217\7684\683C\5F0F\63A9\7801\3002'),
unistr('    \6839\636E\683C\5F0F\63A9\7801\663E\793A\65B9\5F0F\7684\793A\4F8B\8868\793A\5F62\5F0F, \53EF\4EE5\952E\5165\683C\5F0F\63A9\7801\6216\4ECE\9884\5B9A\4E49\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('    <p>\91CD\8981\7684\662F, \6570\5B57\683C\5F0F\63A9\7801\4EC5\5E94\7528\4E8E\5305\542B\6570\5B57\7684\5217, \65E5\671F\683C\5F0F\63A9\7801\4EC5\5E94\7528\4E8E\5305\542B\65E5\671F\7684\5217\3002'),
unistr('    \5426\5219, \5F53\6709\4EFB\4F55\8BB0\5F55\5305\542B\65E0\6CD5\4F7F\7528\6307\5B9A\683C\5F0F\63A9\7801\8F6C\6362\7684\503C\65F6, \5C06\51FA\73B0\8FD0\884C\65F6\9519\8BEF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278415951312547)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5E94\7528\4E8E\6B64\5217\7684\683C\5F0F\63A9\7801\3002'),
unistr('    \6839\636E\683C\5F0F\63A9\7801\663E\793A\65B9\5F0F\7684\793A\4F8B\8868\793A\5F62\5F0F, \53EF\4EE5\952E\5165\683C\5F0F\63A9\7801\6216\4ECE\9884\5B9A\4E49\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('    <p>\91CD\8981\7684\662F, \6570\5B57\683C\5F0F\63A9\7801\4EC5\5E94\7528\4E8E\5305\542B\6570\5B57\7684\5217, \65E5\671F\683C\5F0F\63A9\7801\4EC5\5E94\7528\4E8E\5305\542B\65E5\671F\7684\5217\3002'),
unistr('    \5426\5219, \5F53\6709\4EFB\4F55\8BB0\5F55\5305\542B\65E0\6CD5\4F7F\7528\6307\5B9A\683C\5F0F\63A9\7801\8F6C\6362\7684\503C\65F6, \5C06\51FA\73B0\8FD0\884C\65F6\9519\8BEF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904311537312249)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5E94\7528\4E8E\6B64\7EC4\4EF6\7684\683C\5F0F\63A9\7801\3002'),
unistr('   \6839\636E\683C\5F0F\63A9\7801\663E\793A\65B9\5F0F\7684\793A\4F8B\8868\793A\5F62\5F0F, \53EF\4EE5\952E\5165\683C\5F0F\63A9\7801\6216\4ECE\9884\5B9A\4E49\683C\5F0F\63A9\7801\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('   <p>\91CD\8981\7684\662F, \6570\5B57\683C\5F0F\63A9\7801\4EC5\5E94\7528\4E8E\5305\542B\6570\5B57\7684\7EC4\4EF6, \65E5\671F\683C\5F0F\63A9\7801\4EC5\5E94\7528\4E8E\5305\542B\65E5\671F\7684\7EC4\4EF6\3002'),
unistr('    \5426\5219, \5F53\6709\4EFB\4F55\7EC4\4EF6\5305\542B\65E0\6CD5\4F7F\7528\6307\5B9A\683C\5F0F\63A9\7801\8F6C\6362\7684\503C\65F6, \5C06\51FA\73B0\8FD0\884C\65F6\9519\8BEF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904239434312249)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904564755312250)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\5E94\7528\4E8E\6B64\7EC4\4EF6\7684\65E5\671F\683C\5F0F\63A9\7801\3002'),
unistr('\6839\636E\6B64\683C\5F0F\63A9\7801\663E\793A\65B9\5F0F\7684\793A\4F8B\8868\793A\5F62\5F0F, \53EF\4EE5\952E\5165\683C\5F0F\63A9\7801\6216\4ECE\9884\5B9A\4E49\683C\5F0F\63A9\7801\5217\8868\4E2D\9009\53D6\3002'),
unistr('\4E5F\53EF\4EE5\4F7F\7528\66FF\6362\8BED\6CD5\4ECE\5E94\7528\7A0B\5E8F\6216\9875\9879\4E2D\5F15\7528\52A8\6001\683C\5F0F\63A9\7801\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904437065312250)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904772749312250)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\5E94\7528\4E8E\6B64\7EC4\4EF6\7684\6570\5B57\683C\5F0F\63A9\7801\3002'),
unistr('\6839\636E\6B64\683C\5F0F\63A9\7801\663E\793A\65B9\5F0F\7684\793A\4F8B\8868\793A\5F62\5F0F, \53EF\4EE5\952E\5165\683C\5F0F\63A9\7801\6216\4ECE\9884\5B9A\4E49\683C\5F0F\63A9\7801\5217\8868\4E2D\9009\53D6\3002'),
unistr('\4E5F\53EF\4EE5\4F7F\7528\66FF\6362\8BED\6CD5\4ECE\5E94\7528\7A0B\5E8F\6216\9875\9879\4E2D\5F15\7528\683C\5F0F\63A9\7801\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904641412312250)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901027375312247)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\4E3A\6B64\9875\7981\7528\81EA\52A8\5B8C\6210\3002\503C\4E3A<strong>\542F\7528</strong>\5BF9\6B64\9875\6CA1\6709\4EFB\4F55\5F71\54CD\3002\503C\4E3A<strong>\7981\7528</strong>\5C06\5728 FORM \6807\8BB0\4E2D\751F\6210\4EE5\4E0B HTML:'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>\6CE8\FF1A\5BF9\4E8E\9075\5FAA\8FD8\662F\5FFD\7565 <code>autocomplete="off"</code> \7684\6761\4EF6\FF0C\4E0D\540C\6D4F\89C8\5668\53EF\80FD\4F1A\6709\4E0D\540C\7684\89C4\5219\3002\56E0\6B64\8BF7\7262\8BB0\8FD9\4E00\70B9\FF0C\7279\522B\662F\5728\8BBE\7F6E\4E3A <strong>Off</strong> \65F6\FF0C\5E76\4E14\5728\76EE\6807\6D4F\89C8\5668\4E2D\8FDB\884C\6D4B\8BD5\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402591738312646)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402441635312646)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900943571312247)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\81EA\52A8\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612421549312026)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\56FE\8868\7684\6807\7B7E\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612329067312026)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255304910312527)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4E00\822C\62A5\8868\5217\7684\6700\5927\6570\91CF\3002'),
unistr('\53EA\6709\5728\8FD0\884C\65F6, \624D\4F1A\5BF9\4F7F\7528\4E00\822C\5217\540D\7684\62A5\8868\8FDB\884C\8BED\6CD5\5206\6790, \6240\4EE5\5728\7F16\8F91\62A5\8868\65F6, \5217\6570\662F\672A\77E5\7684\3002</p>'),
unistr('<p>\62A5\8868\5217\7684\6700\5927\6570\91CF\5E94\8BE5\4E0E\9884\671F\7684\62A5\8868\5217\6570\5339\914D\3002'),
unistr('\5982\679C\5B9E\9645\6570\91CF\8F83\5C11, \62A5\8868\4F1A\5448\73B0\5B9E\9645\7684\5217\6570\3002'),
unistr('\4F46\662F, \5982\679C\5B9E\9645\6570\91CF\5927\4E8E\6700\5927\6570\91CF, \5219\4F1A\5728\8FD0\884C\65F6\663E\793A\4E00\6761\9519\8BEF\6D88\606F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255272463312527)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C\5217\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042151426312356)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5F53\524D\7528\6237\754C\9762\7684\5168\5C40\9875 (\5982\679C\672A\5B9A\4E49)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042024290312356)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703026114312883)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276391882312545)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276669664312545)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903315160312249)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7279\5B9A\7684\5E03\5C40\5217\3002\4F7F\7528<strong>\81EA\52A8</strong>\53EF\4EE5\81EA\52A8\786E\5B9A\663E\793A\6B64\7EC4\4EF6\7684\4E0B\4E00\53EF\7528\5E03\5C40\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903267929312249)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904143994312249)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3A\5E03\5C40\5217\8BBE\7F6E\7684\9644\52A0\5C5E\6027\3002\8BE5\503C\66FF\6362\5E03\5C40\5217\6A21\677F\4E2D\7684 <code>#ATTRIBUTES#</code> \66FF\6362\5360\4F4D\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904092431312249)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602545919312806)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587127465312793)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\7EC4\4EF6\5360\636E\591A\5C11\5E03\5C40\5217\3002\4F7F\7528\201C\81EA\52A8\201D\53EF\4EE5\5728\540C\4E00\884C\4E2D\7684\6240\6709\7EC4\4EF6\5185\5E73\8861\53EF\7528\5E03\5C40\5217\3002</p>'),
'<dl>',
unistr('  <dt>\81EA\52A8</dt>'),
unistr('    <dd>\5361\7247\5177\6709\521D\59CB\5BBD\5EA6\FF0C\5F53\4E00\884C\4E2D\65E0\6CD5\5408\9002\5730\5BB9\7EB3\5361\7247\65F6\FF0C\5B83\4EEC\5C06\81EA\52A8\6362\5230\65B0\884C\3002</dd>'),
unistr('  <dt>2\30013\30014\30015 \5217</dt>'),
unistr('    <dd>\5BF9\5361\7247\8FDB\884C\6392\5217\FF0C\4F7F\6BCF\884C\5BB9\7EB3\9009\5B9A\5217\6570\3002\8BE5\5E03\5C40\53EF\4EE5\6839\636E\89C6\7A97\5BBD\5EA6\51CF\5C11\5217\6570\3002</dd>'),
unistr('  <dt>\53EF\4EE5\901A\8FC7\8BBE\7F6E CSS \53D8\91CF\6765\914D\7F6E\5361\7247\5BBD\5EA6\3002</dt>'),
unistr('    <dd>\4F8B\5982\FF0C\6DFB\52A0\4EE5\4E0B\7247\6BB5\4EE5\5C06\5361\7247\5BBD\5EA6\8BBE\7F6E\4E3A 320px\FF1A<pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587285682312794)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2 \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587317318312794)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3 \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587469728312794)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('4 \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587528782312794)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('5 \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108587031518312793)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797630741312963)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5E94\7528\5230\5305\542B\6B64\533A\57DF\7684\5E03\5C40\5217\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\6B64\5C5E\6027\53EF\5728\89C6\7A97\5927\5C0F\6539\53D8\65F6\FF0C\7528\4E8E\5BF9\533A\57DF\5E03\5C40\5217\7684\54CD\5E94\901F\5EA6\548C\5E03\5C40\63D0\4F9B\7EC6\7C92\5EA6\63A7\5236\3002'),
unistr('        \5BF9\4E8E\901A\7528\4E3B\9898\5E94\7528\7A0B\5E8F\FF0C\6709\591A\4E2A CSS \4FEE\9970\7B26\53EF\7528\4E8E\6269\5C55\9875\7EC4\4EF6\3002\8981\4E86\89E3\66F4\591A\4FE1\606F\FF0C\8BF7\67E5\770B\201C\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\201D\7684\201C\53C2\8003\201D\90E8\5206\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108797539311312963)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703143858312883)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276468041312545)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276799714312545)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903726984312249)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\5360\636E\591A\5C11\5E03\5C40\5217\3002\4F7F\7528<strong>\81EA\52A8</strong>\53EF\4EE5\5728\540C\4E00\884C\4E2D\7684\6240\6709\7EC4\4EF6\5185\5E73\8861\53EF\7528\5E03\5C40\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903654073312249)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8DE8\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794527487312961)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794446100312961)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6807\7B7E\5360\636E\591A\5C11\4E2A\5E03\5C40\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794318001312961)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5217\8DE8\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903527019312249)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5728\4E0B\4E00\5217\8FD8\662F\5728\4E0E\4E0A\4E00\7EC4\4EF6\76F8\540C\7684\5217\4E2D\663E\793A\6B64\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903485630312249)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902993424312248)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5728\65B0\5E03\5C40\8FD8\662F\5728\4E0E\4E0A\4E00\7EC4\4EF6\76F8\540C\7684\5E03\5C40\4E2D\663E\793A\6B64\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902863996312248)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65B0\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903173838312249)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5728\4E0A\4E00\7EC4\4EF6\4E4B\540E\7684\65B0\884C\4E0A\8FD8\662F\5728\540C\4E00\884C\4E0A\663E\793A\6B64\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903080853312248)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65B0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561217064312774)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5E94\7528\5230\5305\542B\6B64\533A\57DF\7684\5E03\5C40\884C\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\6B64\5C5E\6027\53EF\5728\89C6\7A97\5927\5C0F\6539\53D8\65F6\FF0C\7528\4E8E\5BF9\533A\57DF\5E03\5C40\884C\7684\54CD\5E94\901F\5EA6\548C\5E03\5C40\63D0\4F9B\7EC6\7C92\5EA6\63A7\5236\3002'),
unistr('        \5BF9\4E8E\901A\7528\4E3B\9898\5E94\7528\7A0B\5E8F\FF0C\6709\591A\4E2A CSS \4FEE\9970\7B26\53EF\7528\4E8E\6269\5C55\9875\7EC4\4EF6\3002\8981\4E86\89E3\66F4\591A\4FE1\606F\FF0C\8BF7\67E5\770B\201C\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\201D\7684\201C\53C2\8003\201D\90E8\5206\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561138360312774)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903913192312249)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\5360\636E HTML \8868\4E2D\7684\591A\5C11\884C\3002\5728 HTML \8868\4E2D\5E03\7F6E\7EC4\4EF6\3002\6B64\5C5E\6027\51B3\5B9A\4E86\7528\4E8E\6B64\7EC4\4EF6\7684\8868\5355\5143\4E2D <em>ROWSPAN</em> \5C5E\6027\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107903822837312249)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\8DE8\8DDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180434160312467)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\56FE\8868\56FE\4F8B\4E0A\7684\7CFB\5217\540D\79F0\FF0C\9009\62E9\8981\7528\4E8E\4E3A\5176\5B9A\4E49\7B80\77ED\7684\8BF4\660E\6027\5B9A\5236\5DE5\5177\63D0\793A\7684\5217\540D\3002\5BF9\4E8E\7BB1\7EBF\56FE\FF0C\5217\4E0D\5F97\4E0E\6240\9009\503C\5217\6620\5C04\76F8\5339\914D\3002\9009\62E9\4E0E\503C\5217\6620\5C04\76F8\5339\914D\7684\5217\5C06\5BFC\81F4\56FE\8868\4E0A\4E0D\4F1A\5448\73B0\4EFB\4F55\56FE\4F8B\5DE5\5177\63D0\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180366132312467)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\4F8B\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180658464312467)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\56FE\8868\7684 x \8F74\6807\7B7E\FF0C\9009\62E9\8981\7528\4E8E\4E3A\5176\5B9A\4E49\7B80\77ED\7684\8BF4\660E\6027\5B9A\5236\5DE5\5177\63D0\793A\7684\5217\540D\3002\5BF9\4E8E\7BB1\7EBF\56FE\FF0C\5217\4E0D\5F97\4E0E\6240\9009\503C\5217\6620\5C04\76F8\5339\914D\3002\9009\62E9\4E0E\503C\5217\6620\5C04\76F8\5339\914D\7684\5217\5C06\5BFC\81F4\56FE\8868\4E0A\4E0D\4F1A\5448\73B0\4EFB\4F55\6807\7B7E\5DE5\5177\63D0\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180501868312467)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255197939312527)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\4ECE SQL \67E5\8BE2\6D3E\751F\5217\5B9A\4E49\3002'),
unistr('\5982\679C\662F\5219\8981\6C42 &PRODUCT_NAME. \5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790\3002'),
unistr('\5982\679C\4E0D\5E0C\671B\6B64\65F6\5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790\FF0C\8BF7\4F7F\7528\4E00\822C\5217\540D\FF0C\8FD9\5C06\751F\6210\5360\4F4D\7B26\5217\5B9A\4E49\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255033527312527)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\4E00\822C\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989911916312315)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\533A\57DF\9876\90E8\7684 <code>#BODY#</code> \4E4B\524D\663E\793A\7684 HTML \6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899227011312246)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\7D27\63A5\7740\9875\7709\5E76\5728\6B63\6587\5185\5BB9\4E4B\524D\663E\793A\7684\6587\672C\6216 HTML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899174479312245)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262562682312533)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\5B9A\4E49\62A5\8868\7684\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441286075312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441376595312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\60A8\53EF\4EE5\8F93\5165\81EA\5DF1\7684\6807\9898\3002\6700\521D\57FA\4E8E\5217\540D\67E5\8BE2\751F\6210\9ED8\8BA4\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441422857312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441531867312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E PL/SQL \51FD\6570\521B\5EFA\6807\9898, \6B64\51FD\6570\8FD4\56DE\5192\53F7\5206\9694\7684\540D\79F0\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441610924312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441700351312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E0D\5E26\62A5\8868\6807\9898\7684\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440803692312679)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440965719312679)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5217\540D\67E5\8BE2\751F\6210\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441050593312679)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('\5217\540D (\9996\5B57\6BCD\5927\5199)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441139139312680)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5217\540D\67E5\8BE2\751F\6210\6807\9898, \6807\9898\4F1A\8F6C\6362\4E3A\9996\5B57\6BCD\5927\5199\7684\5F62\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262495413312533)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223137856312501)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6807\9898\5BF9\9F50\65B9\5F0F\3002\8BF7\6CE8\610F, \60A8\5FC5\987B\9009\62E9\6240\9009\62A5\8868\6A21\677F\652F\6301\7684\5BF9\9F50\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427033120312668)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426973708312668)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427169364312668)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108223084422312500)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441852900312680)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E DEPT \8868\63D0\4F9B\62A5\8868\7684\6807\9898</dt>'),
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262792667312534)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8FD4\56DE\5192\53F7\5206\9694\7684\5217\6807\9898\5B57\7B26\4E32\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262619438312534)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134444071312430)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\8F93\5165\4EA4\4E92\5F0F\7F51\683C\7684\5E2E\52A9\6587\672C\3002\8F93\5165\7684\5E2E\52A9\6587\672C\5C06\4E0E\9ED8\8BA4\5E2E\52A9\5185\5BB9\4E00\8D77\663E\793A\5728\201C\64CD\4F5C\83DC\5355\201D\5E2E\52A9\4E0B\65B9\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135360710312431)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\5217\7684\5E2E\52A9\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277408421312546)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9879\7684\5E2E\52A9\6587\672C\3002\6B64\5E2E\52A9\6587\672C\53EF\5728\5B57\6BB5\7EA7\522B\4E0A\63D0\4F9B\4E0A\4E0B\6587\76F8\5173\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902097949312248)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\8F93\5165\5F53\524D\9875\7684\5E2E\52A9\6587\672C\3002\9875\7EA7\5E2E\52A9\652F\6301\4F7F\7528\4EE5\4E0B\8BED\6CD5\7684\5FEB\6377\65B9\5F0F:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\9ED8\8BA4\60C5\51B5\4E0B\4E0D\663E\793A\9875\5E2E\52A9\6587\672C\3002\4E0D\8FC7, \60A8\53EF\4EE5\8F7B\677E\5730\5F00\53D1\516C\5F00\6B64\6587\672C\7684\5E2E\52A9\7CFB\7EDF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901913265312248)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156400435312448)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\8F93\5165\5F53\524D\9875\7684\5E2E\52A9\6587\672C\3002\9875\7EA7\5E2E\52A9\652F\6301\4F7F\7528\4EE5\4E0B\8BED\6CD5\7684\5FEB\6377\65B9\5F0F:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>\9ED8\8BA4\60C5\51B5\4E0B\4E0D\663E\793A\9875\5E2E\52A9\6587\672C\3002\4E0D\8FC7, \60A8\53EF\4EE5\8F7B\677E\5730\5F00\53D1\516C\5F00\6B64\6587\672C\7684\5E2E\52A9\7CFB\7EDF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156322173312448)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938620007312276)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563708955312776)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176311808312463)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5728\5355\51FB\56FE\4F8B\9879\65F6\6267\884C\7684\9690\85CF\548C\663E\793A\884C\4E3A\3002'),
unistr('        \4F8B\5982, \53D6\6D88\9009\62E9\56FE\4F8B\9879\5C06\5728\56FE\8868\4E0A\9690\85CF\5176\5173\8054\7684\6570\636E\7CFB\5217\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176457796312464)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300021157312565)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' \56FE\8868\5C06\4E0D\542F\7528\9690\85CF\548C\663E\793A\884C\4E3A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176676852312464)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\91CD\65B0\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300209406312565)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' \56FE\8868\8F74\5C06\4E0D\91CD\65B0\7F29\653E\3002\8FD9\53EF\7528\4E8E\4F7F\7528\6237\4FDD\7559\5728\4E0A\4E0B\6587\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176598809312464)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300169719312565)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' \56FE\8868\8F74\5C06\91CD\65B0\7F29\653E\4E3A\53EF\89C6\6570\636E\589E\5927\6216\51CF\5C0F\5230\7684\6700\5C0F\503C\548C\6700\5927\503C\3002\8FD9\53EF\7528\4E8E\53D8\5316\5F88\5927\7684\503C\7CFB\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176253274312463)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\548C\663E\793A\884C\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257294307312529)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5C06\5728\62A5\8868\5217\4E2D\7A81\51FA\663E\793A\7684\6587\672C\5B57\7B26\4E32\3002'),
unistr('\5BF9\4E8E\591A\4E2A\7A81\51FA\663E\793A\7684\5355\8BCD, \8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002'),
unistr('\4E5F\53EF\4EE5\4F7F\7528 <code>&amp;ITEM.</code> \8BED\6CD5\6765\5F15\7528\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\4F8B\5982, \53EF\4EE5\7A81\51FA\663E\793A\5728\641C\7D22\5B57\6BB5\4E2D\8F93\5165\7684\5B57\7B26\4E32\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257160019312529)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\5355\8BCD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041594943312356)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\6237\754C\9762\7684\5E94\7528\7A0B\5E8F\4E3B\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041458490312356)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919980457312261)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\9009\62E9\6B64\6309\94AE\5728\6307\5B9A\6A21\677F\4F4D\7F6E\5185\7684\6C34\5E73\5BF9\9F50\65B9\5F0F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418176705312658)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418272188312658)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919899927312261)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429032181312670)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>#COLUMN_CLASS#</code> \548C <code>#EMPLOYEE_STATUS#</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225705304312503)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>#COLUMN#</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225611120312503)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898861739312245)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\66FF\6362\9875\6A21\677F\9875\7709\4E2D\7684 <code>#HEAD#</code> \66FF\6362\5B57\7B26\4E32\7684\6587\672C\3002'),
unistr('\6B64\5904\8F93\5165\7684\503C\5C06\63D2\5165\5230 HTML <code>&lt;head&gt;</code> \6807\8BB0\7684\540E\9762\3002\6B64\9875\5C5E\6027\7528\4E8E\6DFB\52A0\9875\7279\5B9A\7684\5143\6807\8BB0\3002'),
'</p>',
unistr('<p>\6CE8: JavaScript \4EE3\7801\6216\7EA7\8054\6837\5F0F\8868\5E94\6DFB\52A0\5230\4E13\7528 JavaScript \548C CSS \5C5E\6027\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898779963312245)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \6807\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592666030312798)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\56FE\6807\56FE\50CF\6E90\8FD4\56DE BLOB \7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592506602312798)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592488780312798)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\56FE\6807\56FE\50CF\6E90\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592398693312798)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941162910312278)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7528\4E8E\6807\8BC6\6B64\9762\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('            <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941290510312278)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7528\4E8E\6807\8BC6\6B64\9762\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('            <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941389603312278)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7528\4E8E\6807\8BC6\6B64\9762\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('            <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720093629312896)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\7EC4\4EF6\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>'),
unistr('        <p>\6CE8\FF1A\6B64\56FE\6807\5C06\663E\793A\5728\9879\5185\90E8\FF0C\800C\4E0D\662F\6807\7B7E\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719966771312896)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\7EC4\4EF6\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>'),
unistr('        <p>\6CE8\FF1A\6B64\56FE\6807\5C06\663E\793A\5728\9879\5185\90E8\FF0C\800C\4E0D\662F\6807\7B7E\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941570775312278)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7528\4E8E\6807\8BC6\6B64\7B5B\9009\5668\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('            <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942434497312279)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7528\4E8E\6807\8BC6\6B64\7B5B\9009\5668\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('            <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942892195312279)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7528\4E8E\6807\8BC6\6B64\7B5B\9009\5668\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('            <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579103519312787)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\53F3\7BAD\5934</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108579016807312787)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\7EC4\4EF6\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578956768312787)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594145807312799)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\672C\63CF\8FF0\56FE\6807\FF0C\53EF\7528\4E8E\5DE5\5177\63D0\793A\548C\66FF\4EE3\56FE\50CF\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594023678312799)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592854997312798)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\6807\56FE\50CF\6E90\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592782263312798)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593331555312798)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\56FE\6807\5728\5361\7247\6807\9898\4E2D\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593822864312799)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593911794312799)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\56FE\6807\4E0E\6807\9898\7684\7ED3\675F\4F4D\7F6E\FF08\901A\5E38\662F\53F3\8FB9\FF09\5BF9\9F50\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593659439312799)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593726460312799)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\56FE\6807\4E0E\6807\9898\7684\8D77\59CB\4F4D\7F6E\FF08\901A\5E38\662F\5DE6\8FB9\FF09\5BF9\9F50\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593489166312798)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593540533312799)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6807\9898\7684\9876\90E8\663E\793A\56FE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108593289063312798)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602607691312806)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591729773312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\5361\7247\7EC4\4EF6\6807\9898\4E2D\663E\793A\7684\56FE\6807\9009\62E9\56FE\6807\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592266307312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592031221312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\7C7B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591845123312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\5B57\6BCD\7F29\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591960789312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108592160675312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591603983312797)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123312584312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123256449312421)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('</p>\8F93\5165\56FE\6807\89C6\56FE\7684\5B9A\5236\5217 HTML\3002</p>'),
unistr('<p>\6709\4EE5\4E0B\66FF\6362\5B57\7B26\4E32\53EF\7528\FF1A'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - \5217\540D\7684\66FF\6362\5B57\7B26\4E32\3002</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - \5217\6807\7B7E\7684\66FF\6362\5B57\7B26\4E32\3002</li>'),
unistr('<li><code>&APEX$ROW_ID.</code> - \884C\7684\8BB0\5F55\6807\8BC6\7B26\3002</li>'),
unistr('<li><code>&APEX$ROW_INDEX.</code> - \8BB0\5F55\663E\793A\5E8F\5217\53F7\3002</li>'),
unistr('<li><code>&APEX$ROW_URL.</code> - \5F15\7528\6307\5B9A\7684\94FE\63A5\76EE\6807\3002</li>'),
unistr('<li><code>&APEX$ROW_STATE_CLASSES.</code> - \8BB0\5F55\72B6\6001\FF0C\5982 <code>is-inserted</code> \6216 <code>is-deleted</code>\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123192788312421)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432409131312673)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234278965312510)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\6807\89C6\56FE\7684\5217\94FE\63A5\3002\6839\636E\9700\8981\4F7F\7528\5217\540D\7684 <code>#COLUMN_NAME#</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234107514312510)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134236185312430)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\542F\7528\56FE\6807\89C6\56FE\3002\9009\62E9<strong>\542F\7528</strong>\53EF\5C06\201C\67E5\770B\56FE\6807\201D\56FE\6807\6DFB\52A0\5230\4EA4\4E92\5F0F\62A5\8868\7684\641C\7D22\680F\4E2D\FF0C\6216\6DFB\52A0\5230\4EA4\4E92\5F0F\7F51\683C\7684\201C\89C6\56FE\201D\6309\94AE\4E2D\FF0C\4EE5\4FBF\7528\6237\8BBF\95EE\6B64\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232609978312508)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\542F\7528\56FE\6807\89C6\56FE\3002\9009\62E9<strong>\542F\7528</strong>\53EF\5C06\201C\67E5\770B\56FE\6807\201D\56FE\6807\6DFB\52A0\5230\4EA4\4E92\5F0F\62A5\8868\7684\641C\7D22\680F\4E2D\FF0C\6216\6DFB\52A0\5230\4EA4\4E92\5F0F\7F51\683C\7684\201C\89C6\56FE\201D\6309\94AE\4E2D\FF0C\4EE5\4FBF\7528\6237\8BBF\95EE\6B64\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232501590312508)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233864014312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\50CF\7684 HTML ALT \6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233775572312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML ALT \6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108234002548312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\50CF\7684 HTML TITLE \6807\8BB0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233955029312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML TITLE \6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124549216312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 HTML IMG \6807\8BB0\4F7F\7528\7684\56FE\6807\56FE\50CF\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124402521312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123950464312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\56FE\6807\56FE\50CF\6E90\8FD4\56DE BLOB \7684\4EA4\4E92\5F0F\7F51\683C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123862798312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\5217')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124317156312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\56FE\6807\56FE\50CF\6E90\8FD4\56DE CSS \7C7B\7684\4EA4\4E92\5F0F\7F51\683C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124284946312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123581569312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4FDD\5B58\56FE\6807\56FE\50CF\6E90\7684\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123750659312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123612111312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \4E2D\7684\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108123460077312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124153748312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\56FE\6807\56FE\50CF\6E90\8FD4\56DE URL \7684\4EA4\4E92\5F0F\7F51\683C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124098189312422)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233613016312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 HTML IMG \6807\8BB0\4F7F\7528\7684\56FE\50CF\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233545014312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432225449312672)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\68C0\67E5 <code>IMAGE</code> \5217</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233282256312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\56FE\50CF\6E90\7684\62A5\8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233174489312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\6E90\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432359761312673)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\68C0\67E5 <code>ENAME</code> \5217</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233480718312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\56FE\50CF\6807\7B7E\7684\62A5\8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233325778312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106655347312408)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\68C0\67E5 <code>ENAME</code> \5217</dt>'),
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106546263312408)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\56FE\50CF\6807\7B7E\7684\62A5\8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106463008312408)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124977062312423)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\6BCF\4E2A<strong>\94FE\63A5\76EE\6807</strong>\663E\793A\5173\8054\7684 HTML \5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124869816312423)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432126908312672)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\68C0\67E5 <code>LINK</code> \5217</dt>'),
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108233010381312509)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\56FE\6807\7684\94FE\63A5\76EE\6807\7684\62A5\8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232927481312508)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660143488312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660477704312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660362168312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660249015312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660571396312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660011091312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661334623312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002</p>'),
unistr('<p>SQL \67E5\8BE2\53EA\9700\8981\8FD4\56DE\4E00\5217\3002\5982\679C\6B64\67E5\8BE2\8FD4\56DE\591A\5217\FF0C\5219\4EC5\5728\8FC7\6EE4\5668\641C\7D22\4E2D\4F7F\7528\7B2C\4E00\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661285742312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661123534312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\90E8\95E8\540D\79F0\FF0C\8BBE\7F6E\90E8\95E8\7F16\53F7</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661030079312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002</p>'),
unistr('<p>SQL \67E5\8BE2\53EA\9700\8981\8FD4\56DE\4E00\5217\3002\5982\679C\6B64\67E5\8BE2\8FD4\56DE\591A\5217\FF0C\5219\4EC5\5728\8FC7\6EE4\5668\641C\7D22\4E2D\4F7F\7528\7B2C\4E00\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660929623312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660854470312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8FD4\56DE\90E8\95E8\540D\79F0:</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660726253312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53\4EE5\586B\5145\6B64\503C\5217\8868\3002</p>'),
unistr('<p>SQL \67E5\8BE2\53EA\9700\8981\8FD4\56DE\4E00\5217\3002\5982\679C\6B64\67E5\8BE2\8FD4\56DE\591A\5217, \5219\4EC5\5728\8FC7\6EE4\5668\641C\7D22\4E2D\4F7F\7528\7B2C\4E00\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108660606586312850)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661502850312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002</p>'),
unistr('<p>SQL \67E5\8BE2\53EA\9700\8981\8FD4\56DE\4E00\5217\3002\5982\679C\6B64\67E5\8BE2\8FD4\56DE\591A\5217\FF0C\5219\4EC5\5728\8FC7\6EE4\5668\641C\7D22\4E2D\4F7F\7528\7B2C\4E00\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661425614312851)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129886532312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>'<pre>Cow,Dog,Cat,Lion</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129749905312426)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\6B64\9759\6001\5217\8868\8F93\5165\9017\53F7\5206\9694\7684\503C\5217\8868\3002</p>'),
unistr('        <p>\6CE8 - \9759\6001\503C\5C06\59CB\7EC8\6309\5176\6307\5B9A\987A\5E8F\800C\975E\5B57\6BCD\987A\5E8F\663E\793A\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129640266312426)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125551440312423)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3A\6B64\5217\9009\62E9\7EC4\3002\7EC4\7528\4E8E\5C06\7F51\683C\548C\5355\884C\89C6\56FE\4E2D\7684\5217\5173\8054\5728\4E00\8D77\3002</p>'),
unistr('        <p>\6CE8 - \901A\8FC7\5C55\5F00\201C\5448\73B0\201D\6811\5185\7684\201C\5C5E\6027\201D\6587\4EF6\5939\5E76\53F3\952E\5355\51FB\201C\5217\7EC4\201D\521B\5EFA\65B0\7EC4, \53EF\6DFB\52A0\7EC4\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125495462312423)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130038017312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\5217\503C\57FA\4E8E\7684\6E90\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130108315312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130287917312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\6570\636E\5E93\5217</em>\4E2D\8F93\5165\7684\5217\503C, \6B64\503C\4ECE\533A\57DF\6E90 SQL \67E5\8BE2\68C0\7D22\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130556179312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130659307312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\503C\4E0D\4ECE\4EFB\4F55\6E90\68C0\7D22\3002\4F8B\5982, APEX$ROW_SELECTOR \548C APEX$ROW_ACTION \5217\6CA1\6709\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130346533312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130493631312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \8868\8FBE\5F0F</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108129996572312427)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122647221312421)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\68C0\67E5\7528\6237\5728\4E0B\8F7D\5F53\524D\6240\793A\5217\65F6\53EF\4F7F\7528\7684\4E0B\8F7D\683C\5F0F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122738846312421)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'zh-cn'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122859564312421)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'zh-cn'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280875588312549)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566138274311989)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122524616312421)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124711170312423)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\94FE\63A5\76EE\6807\201D\53EF\8C03\7528\6A21\5F0F\5BF9\8BDD\6846\3002\53EF\4EE5\8F93\5165\5728\5355\51FB\6B64\56FE\6807\65F6\5C06\8C03\7528\7684\5B9A\5236\76EE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108124635477312423)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120826777312419)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\62A5\8868\7684\9875\7801\7C7B\578B\3002\901A\5E38, \5E76\975E\6240\6709\62A5\8868\884C\90FD\4F1A\663E\793A\5728\62A5\8868\4E2D\3002'),
unistr('		\8981\663E\793A\989D\5916\7684\884C, \6700\7EC8\7528\6237\53EF\4EE5\4F7F\7528\63D0\4F9B\7684\9875\7801\3002</p>'),
unistr('		<p>\9875\7801\4E3A\6700\7EC8\7528\6237\63D0\4F9B\6709\5173\663E\793A\7684\884C\6570\548C\7ED3\679C\96C6\5185\7684\5F53\524D\4F4D\7F6E\7684\4FE1\606F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121097412312420)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249462741312522)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6700\521D\663E\793A\8DB3\591F\7684\884C\6765\586B\5145\4EA4\4E92\5F0F\62A5\8868\7684\9AD8\5EA6\3002'),
unistr('        \968F\7740\6700\7EC8\7528\6237\6267\884C\6EDA\52A8\64CD\4F5C, \5C06\4F1A\663E\793A\989D\5916\7684\884C, \5E76\6839\636E\9700\8981\4ECE\670D\52A1\5668\83B7\53D6\66F4\591A\6570\636E\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120900539312420)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249328421312522)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5C06\57FA\4E8E<em>\6BCF\9875\884C\6570</em>\4E2D\6307\5B9A\7684\6570\5B57\663E\793A\524D\51E0\884C\3002'),
unistr('        \5982\679C\5B58\5728\5176\4ED6\884C, \5219\5C06\5728\62A5\8868\9875\811A\5904\6DFB\52A0\63A7\4EF6, \6700\7EC8\7528\6237\53EF\4EE5\4F7F\7528\63A7\4EF6\5728\884C\96C6\4E4B\95F4\524D\540E\5BFC\822A\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120703586312419)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790953855312958)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584302668312791)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\5DF2\4FDD\5B58\62A5\8868\7684\522B\540D\3002\4F7F\7528\6B64\522B\540D\53EF\4EE5\5B9A\4E49\6307\5411\6B64\7279\5B9A\5DF2\4FDD\5B58\62A5\8868\7684\66F4\6709\610F\4E49\7684 URL \94FE\63A5\3002\6B64\94FE\63A5\53EF\7528\4E8E\76F4\63A5\4ECE\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\4F4D\7F6E\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583390060312791)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584445376312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\5DF2\4FDD\5B58\62A5\8868\7684\7C7B\522B, \6B64\7C7B\522B\89C4\5B9A\6B64\62A5\8868\5728\201C\62A5\8868\201D\9009\62E9\5217\8868\5185\7684\663E\793A\4F4D\7F6E\3002\53EA\80FD\67E5\770B\6B64\5C5E\6027, \4E0D\80FD\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583555711312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584050057312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\4FDD\5B58\7684\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\7684\540E\7EED\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583408072312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583976398312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\4FDD\5B58\7684\9ED8\8BA4\663E\793A\7684\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583713698312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E13\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584229490312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\4FDD\5B58\7684\53EA\6709\4FDD\5B58\5B83\7684\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\7684\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583683619312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584124031312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\4FDD\5B58\7684\6240\6709\5176\4ED6\6700\7EC8\7528\6237\90FD\53EF\4EE5\9009\62E9\7684\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108583221846312791)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\89C1\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125778983312423)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4F7F\7528\7EC4\663E\793A\6B64\5217\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125880479312423)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8C\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125986754312424)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5C06\540C\65F6\663E\793A\5728\62A5\8868\6807\9898\548C\5355\884C\89C6\56FE\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126288879312424)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126330648312424)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5C06\4EC5\663E\793A\5728\62A5\8868\6807\9898\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126013194312424)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\884C\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108126184508312424)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5C06\4EC5\663E\793A\5728\5355\884C\89C6\56FE\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125643294312423)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\7EC4\7528\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989385822312314)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\56FE\50CF HTML \4E2D\5305\542B\7684\56FE\50CF\6807\8BB0\5C5E\6027\3002\8FD9\4E9B\5C5E\6027\53EF\7528\4E8E\9AD8\5EA6, \5BBD\5EA6\6216\56FE\50CF ALT \6587\672C (\5982\679C\56FE\50CF\662F\975E\4FEE\9970\7684) \7B49\5C5E\6027\3002</p>'),
unistr('<p>\6CE8: \5982\679C\56FE\50CF\6807\8BB0\5C5E\6027\4E2D\672A\5B9A\4E49 ALT, \5219 &PRODUCT_NAME. \9ED8\8BA4\4E3A\5C06\56FE\50CF\5448\73B0\4E3A\4FEE\9970\56FE\50CF, \4F8B\5982, \4F7F\7528\7A7A ALT \6807\8BB0\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989286441312314)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\6807\8BB0\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258003052312530)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5C06\62A5\8868\5BFC\51FA\5230 CSV \6216\6253\5370\62A5\8868\65F6\662F\5426\5305\542B\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108257959476312530)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA/\6253\5370\4E2D\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769979334312935)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\503C\5217\8868\662F\5426\5728\5217\8868\9876\90E8\663E\793A\7A7A\503C\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108769880815312935)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\7A7A\503C\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110435129312411)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\9009\62E9\4F2A\5217 ROWID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110337907312411)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC ROWID \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227811724312504)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\641C\7D22\680F\663E\793A\5728\62A5\8868\4E0A\65B9\3002\5982\679C\5305\62EC\641C\7D22\680F, \5219\8FD8\53EF\4EE5\5B8C\5168\5B9A\5236\8981\663E\793A\7684\51FD\6570\3002</p>'),
unistr('\641C\7D22\680F\53EF\4EE5\5305\62EC\4EE5\4E0B\7EC4\4EF6:'),
'<dl>',
unistr('  <dt>\641C\7D22\5B57\6BB5</dt>'),
unistr('    <dd>\5728\641C\7D22\680F\4E2D\663E\793A\7528\4E8E\8F93\5165\641C\7D22\6807\51C6\7684\6587\672C\5B57\6BB5\3002</dd>'),
unistr('  <dt>\67E5\627E\5668\4E0B\62C9\5217\8868</dt>'),
unistr('    <dd>\5D4C\5165\5728<em>\641C\7D22\5B57\6BB5</em>\5185, \663E\793A\6240\663E\793A\5217\7684\4E0B\62C9\5217\8868\3002\5982\679C\9009\62E9\4E86\67D0\4E00\5217, \5219\4EC5\5BF9\6240\9009\5217\4E2D\7684\503C\6267\884C\641C\7D22\3002</dd>'),
unistr('  <dt>\62A5\8868\9009\62E9\5217\8868</dt>'),
unistr('    <dd>\4E3A\7528\6237\663E\793A\6240\6709\53EF\7528\62A5\8868\7684\5217\8868, \5305\62EC\4E3B\62A5\8868, \66FF\4EE3\62A5\8868, \516C\5171\62A5\8868\548C\4E13\7528\62A5\8868\3002\4EC5\5F53\7528\6237\53EF\4EE5\8BBF\95EE\4E3B\62A5\8868\4E4B\5916\7684\62A5\8868\65F6\624D\663E\793A\6B64\5217\8868\3002</dd>'),
unistr('  <dt>\201C\6BCF\9875\884C\6570\201D\9009\62E9\5668</dt>'),
unistr('    <dd>\663E\793A\7528\4E8E\9009\62E9\6BCF\9875\663E\793A\7684\884C\6570\7684\9009\62E9\5217\8868\3002</dd>'),
unistr('  <dt>\64CD\4F5C\83DC\5355</dt>'),
unistr('    <dd>\663E\793A\201C\64CD\4F5C\201D\83DC\5355\6309\94AE, \5176\4E2D\901A\5E38\5305\542B\4E00\7EC4\5168\9762\7684\9009\9879\3002\8FD9\4E9B\9009\9879\4F7F\6700\7EC8\7528\6237\53EF\4EE5\6839\636E\60A8\63D0\4F9B\7684\51FD\6570\5B9A\5236\62A5\8868\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227793119312504)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\641C\7D22\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898667483312245)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME. \901A\5E38\9700\8981\7279\5B9A\7684 JavaScript \548C CSS \6587\4EF6\3002'),
unistr('\5BF9\4E8E\67D0\4E9B\5E94\7528\7A0B\5E8F\FF08\4F8B\5982\79FB\52A8\5E94\7528\7A0B\5E8F\FF09\FF0C\53EF\80FD\9700\8981\7981\6B62\5728\9875\4E0A\5305\62EC\8FD9\4E9B\6587\4EF6\3002</p>'),
unistr('<p>\8981\5305\62EC\6807\51C6 &PRODUCT_NAME. \548C JavaScript \6587\4EF6\FF0C\8BF7\9009\62E9<strong>\542F\7528</strong>\3002\9009\62E9<strong>\7981\7528</strong>\5C06\7981\6B62\5728 HTML \6807\5934\4E2D\5305\62EC\8FD9\4E9B\6587\4EF6\3002</p>'),
unistr('<p>\7981\6B62\5305\62EC\8FD9\4E9B\6587\4EF6\4F1A\5BF9\5E94\7528\7A0B\5E8F\4EA7\751F\8D1F\9762\5F71\54CD\5E76\53EF\80FD\5BFC\81F4\5176\4E2D\65AD\3002'),
unistr('\56E0\6B64\FF0C\53EA\5EFA\8BAE\9AD8\7EA7\5F00\53D1\4EBA\5458\7981\7528\6B64\5C5E\6027\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898531257312245)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\6807\51C6 JavaScript \548C CSS')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520314162312742)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6\5217\FF0C\5305\542B\521D\59CB\5730\56FE\4F4D\7F6E\4F5C\4E3A GeoJSON \70B9\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520296294312742)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GeoJSON \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520118720312742)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6 SDO_GEOMETRY \5217\FF0C\5305\542B\521D\59CB\5730\56FE\4F4D\7F6E\4F5C\4E3A\70B9\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520079035312742)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51E0\4F55\7ED3\6784\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519380252312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\7528\4E8E\521D\59CB\5730\56FE\4F4D\7F6E\7684\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519619934312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'GeoJSON'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519732521312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GeoJSON\FF0C\4F5C\4E3A VARCHAR2 \6216 CLOB \5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519861550312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6/\7EAC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519950292312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6\548C\7EAC\5EA6\FF0C\4F5C\4E3A\4E24\4E2A NUMBER \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519491108312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519508846312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle SDO_GEOMETRY \7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519249990312741)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51E0\4F55\7ED3\6784\5217\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518241126312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\662F\5426\4F7F\5730\56FE\4EE5\6D4F\89C8\5668\4E2D\7684\5F53\524D\4F4D\7F6E\4E3A\4E2D\5FC3\3002\5982\679C\542F\7528\FF0C\5E76\4E14\6D4F\89C8\5668\53EF\4EE5\8BBF\95EE\5F53\524D\4F4D\7F6E\FF0C\5219\8BE5\4F4D\7F6E\4F18\5148\4E8E\7531\9759\6001\503C\3001SQL \67E5\8BE2\6216\57FA\4E8E\7A7A\95F4\7ED3\679C\786E\5B9A\7684\521D\59CB\4F4D\7F6E\FF08\5982\4E0A\6240\914D\7F6E\FF09\3002</p><p>\8FD9\53EA\9002\7528\4E8E APEX \4F1A\8BDD\4E2D\7684\7B2C\4E00\4E2A\9875\52A0\8F7D\3002\5728 APEX \4F1A\8BDD\4E2D\91CD\65B0\8BBF\95EE\5730\56FE\9875\65F6\FF0C\5730\56FE\5C06\4EE5\5176\6700\540E\7684\4F4D\7F6E\4E3A\4E2D\5FC3\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518118194312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\6D4F\89C8\5668\83B7\53D6\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520735949312742)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6\5305\542B\521D\59CB\5730\56FE\4F4D\7F6E\7684\7EAC\5EA6\7684\5217\3002\8FD4\56DE\7684\503C\5E94\8BE5\4ECB\4E8E -90 \548C 90 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520653679312742)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\7EAC\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518932333312741)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\521D\59CB\5730\56FE\4F4D\7F6E\7684\7EAC\5EA6\3002\4F7F\7528\4ECB\4E8E -90\FF08\5357\7EAC\FF09\548C 90\FF08\5317\7EAC\FF09\4E4B\95F4\7684\503C\4EE5\53CA\5C0F\6570\70B9\7B26\53F7 "."\3002\793A\4F8B\FF1A<strong>45.5</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518891727312741)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520524845312742)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6\5305\542B\521D\59CB\5730\56FE\4F4D\7F6E\7684\7ECF\5EA6\7684\5217\3002\8FD4\56DE\7684\503C\5E94\8BE5\4ECB\4E8E -180 \548C 180 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520466556312742)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\7ECF\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518710195312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\521D\59CB\5730\56FE\4F4D\7F6E\7684\7ECF\5EA6\3002\4F7F\7528\4ECB\4E8E -180\FF08\897F\7ECF\FF09\548C 180\FF08\4E1C\7ECF\FF09\4E4B\95F4\7684\503C\4EE5\53CA\5C0F\6570\70B9\7B26\53F7 "."\3002\793A\4F8B\FF1A<strong>100.5</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518677843312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518531727312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\67E5\8BE2\8FD4\56DE NUMBER \5217\4EE5\786E\5B9A\521D\59CB\5730\56FE\4F4D\7F6E\548C\7F29\653E\7EA7\522B\FF1A</p>'),
'<pre>',
'select -133.5 longituide,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>\67E5\8BE2\8FD4\56DE SDO_GEOMETRY \5217\4EE5\786E\5B9A\521D\59CB\5730\56FE\4F4D\7F6E\FF0C\8FD4\56DE NUMBER \5217\4EE5\786E\5B9A\7F29\653E\7EA7\522B\3002</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518423308312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \67E5\8BE2\4EE5\786E\5B9A\521D\59CB\5730\56FE\4F4D\7F6E\548C\7F29\653E\7EA7\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518346064312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517424514312739)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5982\4F55\4E3A\65B0 APEX \4F1A\8BDD\6216\8005\5728\5730\56FE\533A\57DF<strong>\6E05\9664</strong>\6216<strong>\91CD\7F6E</strong>\64CD\4F5C\540E\786E\5B9A\521D\59CB\5730\56FE\4F4D\7F6E\548C\7F29\653E\7EA7\522B\3002\5728 APEX \4F1A\8BDD\4E2D\FF0C\5730\56FE\533A\57DF\4F1A\5BF9\4E0D\540C\7684\9875\8BF7\6C42\8BB0\4F4F\5F53\524D\4F4D\7F6E\548C\7F29\653E\7EA7\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517966703312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\7A7A\95F4\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108518020510312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\653E\7F6E\5730\56FE\FF0C\4EE5\4FBF\5C42\67E5\8BE2\7ED3\679C\53EF\89C1\3002<em>\8BF7\6CE8\610F\FF0C\5982\679C\9009\62E9 GeoJSON \4F5C\4E3A\5C42\51E0\4F55\7ED3\6784\5217\7C7B\578B\FF0C\5219\4E0D\652F\6301\6B64\64CD\4F5C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517722238312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517818786312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B SQL \67E5\8BE2\FF0C\8FD4\56DE\521D\59CB\5730\56FE\4F4D\7F6E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517592104312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517690634312740)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\521D\59CB\5730\56FE\4F4D\7F6E\7684\9759\6001\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517371260312739)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520964698312742)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6\5305\542B\521D\59CB\7F29\653E\7EA7\522B\7684\5217\3002\8FD4\56DE\7684\503C\5E94\8BE5\4ECB\4E8E 1 \548C 18 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108520876970312742)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\7F29\653E\7EA7\522B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519128021312741)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\521D\59CB\7F29\653E\7EA7\522B\3002\4F7F\7528\4ECB\4E8E 1 \548C 18 \4E4B\95F4\7684\6574\6570\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108519019668312741)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406819670312649)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06 CSS \7C7B <code>display_only</code> \8BBE\7F6E\4E3A\7C97\4F53</dt>'),
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893558993312241)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\6B64\9875\4E0A\4F7F\7528\7684\7EA7\8054\6837\5F0F\8868 (CSS) \4EE3\7801\3002'),
unistr('\5982\679C\5728\591A\4E2A\9875\4E0A\9700\8981\76F8\540C\7684 CSS, \5219\8003\8651\5C06\6B64\4EE3\7801\653E\5165\5916\90E8\6587\4EF6\4EE5\907F\514D\91CD\590D\548C\5229\7528\9759\6001\6587\4EF6\7684\6D4F\89C8\5668\9AD8\901F\7F13\5B58\3002</p>'),
unistr('<p>\6B64\5904\8F93\5165\7684\4EE3\7801\5C06\66FF\6362\9875\6A21\677F\4E2D\7684 <code>#PAGE_CSS#</code> \66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('<p>\6CE8: \4E0D\5FC5\5305\542B\5F00\59CB\6216\7ED3\675F <code>style</code> \6807\8BB0\3002\53EA\9700\5305\542B\7EA7\8054\6837\5F0F\8868\4EE3\7801\5373\53EF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893401935312241)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901845354312247)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\6B64\9875\51FA\9519\65F6\663E\793A\7684\9519\8BEF\6D88\606F\3002\8BE5\9519\8BEF\6D88\606F\5C06\66FF\6362\9875\6A21\677F\4E2D\7684 <code>#NOTIFICATION_MESSAGE#</code>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107901709529312247)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\9519\8BEF\901A\77E5\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719849547312896)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9879\7684\5185\5D4C\5E2E\52A9\6587\672C\3002\6B64\5E2E\52A9\6587\672C\76F4\63A5\968F\6B64\9879\4E00\8D77\663E\793A, \5E76\4E14\53EF\5728\5B57\6BB5\7EA7\522B\63D0\4F9B\4E0A\4E0B\6587\76F8\5173\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719747680312896)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985395914312311)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4F1A\8BDD\65E0\6548\65F6 &PRODUCT_NAME. \91CD\5B9A\5411\5230\7684\4F4D\7F6E\3002'),
unistr('\5982\679C<strong>\536B\58EB\51FD\6570</strong>\6216<strong>\9A8C\8BC1\51FD\6570</strong>\5728\666E\901A\9875\8BF7\6C42 (\800C\975E Ajax \8BF7\6C42) \4E0A\8FD4\56DE\4E86\201C\5047\201D, \5219\5C06\51FA\73B0\8FD9\79CD\60C5\51B5\3002</p>'),
unistr('<p>\6CE8: \5982\679C\4F7F\7528 <strong>''\5B9A\5236''</strong> \9A8C\8BC1\65B9\6848\7C7B\578B, \5219\4E5F\53EF\4EE5\4F7F\7528\9A8C\8BC1\65B9\6848\4E2D\7684 <strong>''\536B\58EB\51FD\6570''</strong> \5C5E\6027\3002'),
unistr('\5BF9\4E8E\63D2\4EF6\9A8C\8BC1\65B9\6848\7C7B\578B, \6B64\9879\7531\63D2\4EF6\5F00\53D1\8005\5728 <strong>''\4F1A\8BDD\536B\58EB\51FD\6570\540D\79F0''</strong> \56DE\8C03\4E2D\5B9A\4E49\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419829777312660)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419976357312660)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 &PRODUCT_NAME. \63D0\4F9B\7684 <code>wwv_flow_custom_auth_std.login_page</code> \4E2D\5B9A\4E49\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419655533312659)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419793928312660)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\5E94\7528\7A0B\5E8F\5C5E\6027\4E2D\5B9A\4E49\7684\767B\5F55 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420062992312660)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420189368312660)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\60A8\8F93\5165\7684 URL, \4F8B\5982 <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985221428312311)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\4F1A\8BDD\91CD\5B9A\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985572250312311)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\4F1A\8BDD\536B\58EB\51FD\6570\8FD4\56DE\201C\5047\201D\65F6 &PRODUCT_NAME. \91CD\5B9A\5411\5230\7684 URL\3002\901A\5E38\8FD9\5E94\5F53\662F\767B\5F55\9875\6216\4E00\6B21\767B\5165\95E8\6237\7684 URL\3002\4F8B\5982, f?p=&amp;APP_ID.:101:&amp;SESSION')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985461777312311)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\4F1A\8BDD URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226576066312503)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\76F8\5173\5217\663E\793A\7C7B\578B\4EE5\5B9A\4E49\5982\4F55\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426560818312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610853500312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\4EE5\4E0B\8F7D\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426800808312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611175310312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5217, \4F46\53EF\5F15\7528\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426423802312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610744413312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426343167312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610684555312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426663300312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4\56FE\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610960233312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\767E\5206\6BD4\56FE\5F62\3002\68C0\7D22\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 100 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426114554312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610452982312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426254088312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C (\57FA\4E8E\503C\5217\8868)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610539818312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4ECE\6307\5B9A\7684\503C\5217\8868\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682975675312868)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4FE1\606F\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683058638312868)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 HTML \6216 Markdown \5448\73B0\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426745453312668)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611034127312812)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5220\9664 HTML \6807\8BB0\5E76\5BF9\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\4E4B\540E\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226466667312503)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310722967312573)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8FD4\56DE\90E8\95E8\540D\79F0:</dt>'),
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244878505312518)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\9700\8981\8FD4\56DE\4E00\5217\7684 SQL \67E5\8BE2\3002\5982\679C\67E5\8BE2\8FD4\56DE\591A\5217, \5219\4EC5\5728\503C\5217\8868\4E2D\4F7F\7528\7B2C\4E00\5217\3002</p>'),
unistr('<p>\8F93\5165 SQL \67E5\8BE2\53EF\4EE5\63D0\9AD8\4E00\4E9B\62A5\8868\7684\6027\80FD, \6216\8005\53EF\7528\4E8E\9650\5236\663E\793A\7684\503C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244739855312518)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364232627312616)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B9A\4E49\7684\547D\540D\503C\5217\8868\3002\5217\8FC7\6EE4\5668\53EA\4F7F\7528\52A8\6001\503C\5217\8868\67E5\8BE2\7684\7B2C\4E00\5217\6216\9759\6001\503C\5217\8868\7684\663E\793A\503C\6765\8FC7\6EE4\62A5\8868\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364175264312616)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\547D\540D\7684 LOV')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225356251312502)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\6D3E\751F\5728\62A5\8868\5217\4E0B\62C9\5217\8868\4E2D\63D0\4F9B\7684\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428398607312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\547D\540D\7684\503C\5217\8868\8FC7\6EE4\5B8C\5168\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428438390312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\547D\540D\7684\503C\5217\8868\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\7B49\4E8E\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428584874312670)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\547D\540D\7684\503C\5217\8868\8FC7\6EE4\8BCD\8BED\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428673283312670)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\547D\540D\7684\503C\5217\8868\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\5305\542B\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428160802312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5B9A\4E49\7684\503C\5217\8868\8FC7\6EE4\8BCD\8BED\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428279907312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B9A\4E49\7684\503C\5217\8868 SQL \67E5\8BE2\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\5305\542B\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427772973312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\57FA\4E8E\5217\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427846351312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('STRING \548C NUMBER \5217\5C06\4ECE\4E0D\540C\5217\503C\4E2D\6D3E\751F\503C\5217\8868\3002DATE \5217\5C06\4ECE\9884\5B9A\4E49\65E5\671F\8303\56F4\6D3E\751F\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427504462312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427648864312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\62A5\8868\63D0\4F9B\5217\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108427943876312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5B9A\4E49\7684\503C\5217\8868\8FC7\6EE4\5B8C\5168\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428052283312669)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B9A\4E49\7684\503C\5217\8868 SQL \67E5\8BE2\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\7B49\4E8E\201D\5339\914D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225252401312502)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226356278312503)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\5217\9009\62E9\7EC4\3002\7EC4\7528\4E8E\5728\5355\884C\89C6\56FE\7684\903B\8F91\7EC4\4E2D\663E\793A\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226285624312503)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230225867312506)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3A\6B64\62A5\8868\9009\62E9\94FE\63A5\5217\7C7B\578B\3002'),
unistr('\5982\679C\9009\62E9\94FE\63A5\5217, \5219\6B64\5217\5728\62A5\8868\4E2D\59CB\7EC8\663E\793A\4E3A\7B2C\4E00\5217, \7528\6237\65E0\6CD5\9690\85CF\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430502701312671)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5230\5B9A\5236\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430611316312671)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\60A8\8F93\5165\7684\76EE\6807 URL \5C06\6700\7EC8\7528\6237\5B9A\5411\5230\5176\4ED6\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430777790312671)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664\94FE\63A5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430834831312671)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\663E\793A\94FE\63A5\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430397604312671)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5230\5355\884C\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430414443312671)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6700\7EC8\7528\6237\5B9A\5411\5230\4E3A\6307\5B9A\884C\663E\793A\5217\503C\7684\9875\3002\5217\7684\663E\793A\5185\5BB9\548C\65B9\5F0F\7531\5404\79CD\62A5\8868\548C\5217\5C5E\6027\63A7\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230130162312506)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276845084312545)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228053033312504)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\62A5\8868\7684\9875\7801\7C7B\578B\3002\901A\5E38, \53EA\5728\9875\4E0A\663E\793A\4E00\5B9A\6570\91CF\7684\62A5\8868\884C\3002'),
unistr('\8981\5305\542B\989D\5916\7684\884C, \5E94\7528\7A0B\5E8F\6700\7EC8\7528\6237\5FC5\987B\5BFC\822A\5230\62A5\8868\7684\4E0B\4E00\9875\3002</p>'),
unistr('<p>\9875\7801\4E3A\6700\7EC8\7528\6237\63D0\4F9B\6709\5173\7ED3\679C\96C6\4E2D\7684\884C\6570\548C\5F53\524D\4F4D\7F6E\7684\4FE1\606F\3002</p>'),
unistr('<p>\9875\7801\53EF\4EE5\663E\793A\5728\62A5\8868\7684\4E0A\65B9\6216\4E0B\65B9 (\6216\540C\65F6\663E\793A\5728\4E0A\65B9\548C\4E0B\65B9), \5E76\4E14\53EF\4EE5\4F4D\4E8E\5DE6\4FA7\6216\53F3\4FA7\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429397138312670)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429214831312670)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7684\8303\56F4\4ECE X \5230 Y, \5171 Z \884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108227971899312504)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242572007312517)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\5DF2\4FDD\5B58\62A5\8868\7684\522B\540D\3002\4F7F\7528\6B64\522B\540D\53EF\4EE5\5B9A\4E49\6307\5411\6B64\7279\5B9A\5DF2\4FDD\5B58\62A5\8868\7684\66F4\6709\610F\4E49\7684 URL \94FE\63A5\3002\6B64\94FE\63A5\53EF\7528\4E8E\76F4\63A5\4ECE\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\4F4D\7F6E\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242460822312517)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242922164312517)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\5DF2\4FDD\5B58\62A5\8868\7684\7C7B\522B, \6B64\7C7B\522B\89C4\5B9A\6B64\62A5\8868\5728\201C\62A5\8868\201D\9009\62E9\5217\8868\5185\7684\663E\793A\4F4D\7F6E\3002\53EA\80FD\67E5\770B\6B64\5C5E\6027, \4E0D\80FD\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432951204312673)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611340147312812)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\4FDD\5B58\7684\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\7684\540E\7EED\62A5\8868\5E03\5C40\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108432880747312673)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611286774312812)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\53D1\8005\4FDD\5B58\7684\9ED8\8BA4\663E\793A\7684\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433178103312673)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E13\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611592852312813)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\4FDD\5B58\7684\53EA\6709\4FDD\5B58\5B83\7684\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\7684\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433052979312673)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108611473102312813)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\4FDD\5B58\7684\6240\6709\5176\4ED6\6700\7EC8\7528\6237\90FD\53EF\4EE5\9009\62E9\7684\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242860870312517)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\89C1\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076819119312384)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\7F16\8F91\6B64\8868\5355\533A\57DF\3002</p>'),
unistr('        <p>\6CE8 - \4F7F\8868\5355\533A\57DF\53EF\7F16\8F91\65F6\FF0C\4F1A\81EA\52A8\521B\5EFA\4E00\4E2A\5904\7406\6765\5904\7406\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117708042312417)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\7F16\8F91\6B64\4EA4\4E92\5F0F\7F51\683C\3002</p>'),
unistr('        <p>\6CE8 - \4F7F\4EA4\4E92\5F0F\7F51\683C\53EF\7F16\8F91\65F6\FF0C\4F1A\81EA\52A8\521B\5EFA\4E00\4E2A\5904\7406\6765\5904\7406\8FD9\4E9B\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117671592312417)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715656260312893)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5168\5C40\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131472032312428)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\5217\662F\5426\4E3A\57FA\7840\8868\7684\4E3B\952E\503C\4E4B\4E00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131314005312428)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131264468312428)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4ECE DML \64CD\4F5C\4E2D\6392\9664\5217\3002</p>'),
unistr('        <p>\5982\679C\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF0C\5219 &PRODUCT_NAME. \5728\6267\884C\201C\4EA4\4E92\5F0F\7F51\683C - \81EA\52A8\884C\5904\7406 (DML)\201D\65F6\5C06\4E0D\4F7F\7528\5217\3002'),
unistr('        \4F8B\5982\FF0C\5E94\8BE5\6392\9664\5176\5B9A\4E49\5305\542B\8FDE\63A5\3001\5185\90E8\9009\62E9\3001\51FD\6570\8C03\7528\7684\5217\FF0C\6216\8005\57FA\4E8E\8868\8FBE\5F0F\7684\53EF\66F4\65B0\89C6\56FE\4E2D\7684\5217\3002</p>'),
unistr('        <p>\5BF9\4E8E\9700\8981\5305\62EC\5728\4EFB\4F55 INSERT \6216 UPDATE \8BED\53E5\4E2D\7684\6240\6709\5217\FF0C\6B64\9009\9879\5FC5\987B\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\3002</p>'),
unistr('        <p>\6CE8\FF1A\7C7B\578B\4E3A<em>\4EC5\663E\793A</em>\7684\5217<u>\4E5F</u>\4F1A\5305\62EC\5728\81EA\52A8\884C\5904\7406\4E2D\FF0C\9664\975E<strong>\542F\7528</strong>\6B64\9009\9879\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108131176473312428)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212262191312492)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\53C2\6570\53EA\80FD\4F7F\7528\9759\6001\503C\8BBE\7F6E\4E00\6B21, \8FD8\662F\5728\7EC4\4EF6\7EA7\522B\8986\76D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212116343312492)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563966575312776)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\663E\793A\8FD8\662F\9690\85CF\6B64\5217\3002\5373\4F7F\9690\85CF, \4E5F\53EF\4EE5\59CB\7EC8\4F7F\7528\66FF\6362\8BED\6CD5 <code>&amp;COLUMN_NAME.</code> \5F15\7528\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563806682312776)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104379002312406)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\7684\4E0A\9650\503C\7684\5217\540D\3002\5728\672A\9009\62E9\5217\65F6, \7BB1\7EBF\56FE\7684\6700\9AD8\503C\5C06\57FA\4E8E\6570\636E\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104105057312406)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\9AD8\4EF7 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104294981312406)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\7684\4E0B\9650\503C\7684\5217\540D\3002\5728\672A\9009\62E9\5217\65F6, \7BB1\7EBF\56FE\7684\6700\4F4E\503C\5C06\57FA\4E8E\6570\636E\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104055537312406)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\4F4E\4EF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179210482312466)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\6536\76D8\4EF7\503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179151612312466)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\76D8\4EF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178841082312465)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\6700\9AD8\4EF7\503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178750839312465)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\9AD8\4EF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180834136312467)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\56FE\8868 x \8F74\6807\7B7E\7684\5217\540D\3002\5BF9\4E8E\80A1\4EF7\56FE, \6B64\5217\7684\6570\636E\7C7B\578B\5E94\4E3A\65E5\671F/\65F6\95F4\6233, \4EE5\4FBF\5728\65F6\95F4\8F74\4E0A\8868\793A\80A1\7968\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180780229312467)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010069900312333)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186249180312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165 CSS \6837\5F0F\5B57\7B26\4E32, \8BE5\5B57\7B26\4E32\5B9A\4E49\6B64\56FE\8868\4E0A\6807\7B7E\7684\6837\5F0F\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186143100312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210436926312491)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5BF9\4E8E\8303\56F4\7CFB\5217\FF0C\5982\679C\63D0\4F9B\4E86\4E00\4E2A\7531\4E24\4E2A\503C\7EC4\6210\7684\6570\7EC4\FF0C\5219\7B2C\4E00\4E2A\503C\548C\7B2C\4E8C\4E2A\503C\5C06\5206\522B\5E94\7528\4E8E\4F4E\70B9\548C\9AD8\70B9\3002<strong>\5207\7247\5916\90E8</strong>\503C\4EC5\9002\7528\4E8E\997C\56FE\3002'),
unistr('        <strong>\6807\8BB0\4E0A\9762</strong>\3001<strong>\6807\8BB0\4E0B\9762</strong>\3001<strong>\6807\8BB0\524D\9762</strong>\548C<strong>\6807\8BB0\540E\9762</strong>\503C\4EC5\9002\7528\4E8E\6298\7EBF\56FE\3001\9762\79EF\56FE\3001\6563\70B9\56FE\548C\6C14\6CE1\56FE\7CFB\5217\3002<strong>\5728\6761\5F62\56FE\8FB9\7F18\5185</strong>\548C<strong>\5728\6761\5F62\56FE\8FB9\7F18\5916</strong>\503C'),
unistr('        \4EC5\9002\7528\4E8E\975E\6781\5750\6807\6761\5F62\56FE\7CFB\5217\3002\5806\53E0\6761\5F62\56FE\4E0D\652F\6301<strong>\5728\6761\5F62\56FE\8FB9\7F18\5916</strong>\3002<strong>\5F00\59CB</strong>\503C\4EC5\9002\7528\4E8E\6C34\5E73\548C\5782\76F4\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\3002\56FE\8868\5F53\524D\4E0D\4F1A\8C03\6574\5E03\5C40\4EE5\9002\5408\7ED8\56FE\533A\5185\7684\6807\7B7E\6216\5904\7406\6807\7B7E\95F4\7684\4EFB\4F55\91CD\53E0\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185234833312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\56FE\8868\4E0A\5448\73B0\7684\6807\7B7E\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185482965312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0\4E0A\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185751993312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0\540E\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186037411312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185627668312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0\524D\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185571922312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0\4E0B\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185324353312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185857378312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6761\5F62\56FE\8FB9\7F18\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209816625312490)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185937273312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6761\5F62\56FE\8FB9\7F18\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209727914312490)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\7247\5916\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645644686312051)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185129396312471)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108185067860312470)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\6807\7B7E\3002\6B64\8BBE\7F6E\9002\7528\4E8E\4EEA\8868\76D8\56FE\8868\4E0A\7684\5EA6\91CF\503C\7684\53EF\89C1\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184960986312470)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178646729312465)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\6700\4F4E\4EF7\503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178599387312465)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\4F4E\4EF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180276300312467)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\6700\5927\503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180131284312466)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282196276312550)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\6700\5C0F\503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282065452312550)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179059436312466)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\5F00\76D8\4EF7\503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178989609312466)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\76D8\4EF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181081285312467)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\56FE\8868\6570\636E\70B9\FF0C\9009\62E9\8981\7528\4E8E\4E3A\5176\5B9A\4E49\7B80\77ED\7684\8BF4\660E\6027\5B9A\5236\5DE5\5177\63D0\793A\7684\5217\540D\3002\8981\5728\56FE\8868\6570\636E\70B9\4E0A\5448\73B0\5DE5\5177\63D0\793A\FF0C\8BF7\786E\4FDD\56FE\8868\5DE5\5177\63D0\793A\5C5E\6027<strong>\663E\793A</strong>\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\3002\5BF9\4E8E\7BB1\7EBF\56FE\FF0C\5217\4E0D\5E94\4E0E\6240\9009\503C\5217\6620\5C04\76F8\5339\914D\3002\9009\62E9\4E0E\503C\5217\6620\5C04\76F8\5339\914D\7684\5217\5C06\5BFC\81F4\56FE\8868\4E0A\4E0D\4F1A\5448\73B0\4EFB\4F55\5B9A\5236\5DE5\5177\63D0\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180953647312467)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108180043092312466)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\76EE\6807\503C\7684\5217\540D\3002\8BBE\7F6E\65F6, \503C\5C5E\6027\5B9A\4E49\5207\7247\5185\7684\586B\5145\533A\5E76\8868\793A\6574\4E2A\5207\7247\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179952922312466)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178480668312465)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\503C\7684\5217\540D\3002\5BF9\4E8E\7BB1\7EBF\56FE, \6B64\5217\5C06\7528\4E8E\5B9A\4E49\6570\503C\6570\636E\96C6\7684\6700\5C0F\503C, \56DB\5206\4F4D\6570, \4E2D\503C\548C\6700\5927\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178332537312465)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179406443312466)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684\6210\4EA4\91CF\503C\7684\5217\540D\3002\63D0\4F9B\503C\65F6, \6210\4EA4\91CF\663E\793A\5728 y2 \8F74\4E0A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179353716312466)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\4EA4\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179674340312466)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684 x \503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179542674312466)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179813400312466)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\6B64\56FE\8868\4E0A\7684 y \503C\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108179707872312466)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177230768312464)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5728\6B64\56FE\8868\4E0A\5B9A\4E49 z \503C\7684\5217\540D\3002z \503C\5B9A\4E49\6C14\6CE1\56FE\7684\6C14\6CE1\534A\5F84, \7BB1\7EBF\56FE\9879\7684\5BBD\5EA6\4EE5\53CA\6761\5F62\56FE\6216\7EC4\5408\56FE\7684\6761\5BBD\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177148074312464)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988719360312314)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\533A\57DF\7EC4\4EF6\FF08\5B50\533A\57DF\3001\9879\3001\6309\94AE\FF09\662F\663E\793A\5728\4E3B\533A\57DF\5185\5BB9\4E4B\4E0A\8FD8\662F\4E4B\4E0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420984925312660)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\4E0A\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108421026830312661)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\4E0B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988652268312314)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923326704312264)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9879\7684\540D\79F0\3002\9879\540D\5FC5\987B\662F\6709\6548\7684 Oracle \6807\8BC6\7B26\3002\5EFA\8BAE\9879\540D\4E0D\8D85\8FC7 30 \5B57\8282, \4EE5\4FBF\7528\4F5C SQL \67E5\8BE2\4E2D\7684\7ED1\5B9A\53D8\91CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923268013312264)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134654256312431)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\5448\73B0\6B64\5217\3002\652F\6301\4EE5\4E0B\5217\7C7B\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\636E\5E94\7528\7A0B\5E8F\914D\7F6E, \6B64\5904\53EF\80FD\8FD8\6709\5176\4ED6\5217\7C7B\578B\7684\63D2\4EF6\53EF\7528\3002'),
unistr('\8FD9\4E9B\63D2\4EF6\663E\793A\4E3A <em>&lt;\6211\7684\63D2\4EF6&gt; [\63D2\4EF6]</em>\3002'),
unistr('\5728\6B64\5E94\7528\7A0B\5E8F\7684\5171\4EAB\7EC4\4EF6\4E2D\5B89\88C5\4EE5\4E0B\63D2\4EF6:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922981560312264)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\9879\7684\5448\73B0\65B9\5F0F\3002\652F\6301\4EE5\4E0B\9879\7C7B\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\636E\5E94\7528\7A0B\5E8F\914D\7F6E, \6B64\5904\53EF\80FD\8FD8\6709\5176\4ED6\9879\7C7B\578B\63D2\4EF6\53EF\7528\3002'),
unistr('\8FD9\4E9B\63D2\4EF6\663E\793A\4E3A <em>&lt;\6211\7684\63D2\4EF6&gt; [\63D2\4EF6]</em>\3002'),
unistr('\5728\6B64\5E94\7528\7A0B\5E8F\7684\5171\4EAB\7EC4\4EF6\4E2D\5B89\88C5\4EE5\4E0B\63D2\4EF6:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922829260312264)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582392832312790)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9ED8\8BA4\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108603404030312806)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5728\9875\7EA7\522B\542F\7528\4E86\672A\4FDD\5B58\66F4\6539\68C0\67E5, \5219\5728\6B64\68C0\67E5\4E2D\5305\542B\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581849640312789)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\9875\9879\662F\5426\5305\62EC\5728\672A\4FDD\5B58\66F4\6539\68C0\67E5\4E2D, \4EE5\4FBF\5728\7528\6237\5C1D\8BD5\9000\51FA\5305\542B\672A\4FDD\5B58\66F4\6539\7684\9875\65F6\5411\7528\6237\53D1\51FA\8B66\544A\3002\67D0\4E9B\9879\53EF\80FD\4E0D\9700\8981\68C0\67E5 (\4F8B\5982, \5B83\4EEC\4E0D\57FA\4E8E\6570\636E\5E93\5217, \5982\641C\7D22\9879), \56E0\6B64\53EF\4EE5\8BBE\7F6E\4E3A\5FFD\7565\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581964053312790)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FFD\7565')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108584743306312792)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\4FDD\5B58\66F4\6539\68C0\67E5\5FFD\7565\5BF9\9879\7684\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581767347312789)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\672A\4FDD\5B58\66F4\6539\65F6\53D1\51FA\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726669844312901)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145173104312439)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\83B7\53D6\4EA4\4E92\5F0F\7F51\683C\7684\914D\7F6E\5BF9\8C61, \4FEE\6539\5E76\8FD4\56DE\8BE5\5BF9\8C61\7684 JavaScript \51FD\6570\3002\8FD9\53EF\4EE5\5BF9\4EA4\4E92\5F0F\7F51\683C\7684\5916\89C2, \529F\80FD\548C\884C\4E3A (\5305\62EC\5DE5\5177\680F, \83DC\5355\548C\64CD\4F5C) \8FDB\884C\9AD8\7EA7\5B9A\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726718814312902)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281410038312550)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\83B7\53D6\5217\7684\914D\7F6E\5BF9\8C61, \4FEE\6539\5E76\8FD4\56DE\8BE5\5BF9\8C61\7684 JavaScript \51FD\6570\3002\8FD9\53EF\4EE5\5BF9\5217\7684\5916\89C2, \529F\80FD\548C\884C\4E3A\8FDB\884C\9AD8\7EA7\5B9A\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726831341312902)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
unistr('    // \8BBE\7F6E\4E00\4E2A\5728\68C0\7D22\6570\636E\65F6\8C03\7528\7684\56DE\8C03\51FD\6570, \6B64\51FD\6570\53EF\7528\4E8E\64CD\7EB5\7CFB\5217'),
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
unistr('    // \8BBE\7F6E\56FE\8868\521D\59CB\5316\9009\9879'),
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190806509312475)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165 JavaScript \4EE3\7801\4EE5\5B9A\5236\56FE\8868\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727498934312902)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125196443312423)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\83B7\53D6\7EC4\4EF6\7684\914D\7F6E\5BF9\8C61, \4FEE\6539\5E76\8FD4\56DE\8BE5\5BF9\8C61\7684 JavaScript \51FD\6570\3002\8FD9\53EF\4EE5\5BF9\7EC4\4EF6\7684\5916\89C2, \529F\80FD\548C\884C\4E3A\8FDB\884C\9AD8\7EA7\5B9A\5236\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108125009308312423)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \521D\59CB\5316\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496111852312722)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\56FE\8868\4E0A\4E3B\8F74\548C\6B21\8F74\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496816515312723)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496781713312723)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496075679312722)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F74\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499648705312725)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\56FE\8868\4E0A\8F74\7684\65F6\95F4\6807\5EA6\3002\9700\8981\6B64\9879\624D\80FD\6B63\786E\5448\73B0\7518\7279\56FE\3002\6240\9009\65F6\95F4\6807\5EA6\5C06\5728\672A\9009\62E9\201C\7F29\653E\6BD4\4F8B\201D\9009\9879\65F6\7528\4E8E\7F29\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497744153312724)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497687686312724)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497345342312723)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498185302312724)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498399275312724)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B63\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497288199312723)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497954604312724)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498563925312724)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499513973312725)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165880329312455)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7C7B\578B\3002\56FE\8868\7C7B\578B\786E\5B9A\7528\4E8E\5448\73B0\56FE\8868\7684\663E\793A\5F62\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165993669312455)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306600310312570)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE\7528\4E8E\6BD4\8F83\4E00\6BB5\65F6\95F4\5185\7684\7D2F\8BA1\503C\8D8B\52BF, \4F8B\5982\9500\552E\8D8B\52BF\60C5\51B5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166053884312455)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306775216312570)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE\7528\4E8E\6BD4\8F83\4E0D\540C\7C7B\522B\6216\4E00\6BB5\65F6\95F4\5185\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087566822312393)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BB1\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087657450312394)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5206\6790\4E00\7EC4\6570\503C\6570\636E\7684\6570\636E\5206\5E03, \663E\793A\6700\5C0F\503C, \56DB\5206\4F4D\6570, \4E2D\503C\548C\6700\5927\503C\65F6, \7BB1\7EBF\56FE\975E\5E38\6709\7528\3002\7BB1\7EBF\56FE\4E5F\79F0\4E3A\7BB1\987B\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166134300312455)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C14\6CE1\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306830116312570)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C14\6CE1\56FE\4F7F\7528 x, y \548C z \503C\5B9A\4E49\6570\636E\9879, \53EF\7528\4E8E\67E5\770B\4E09\4E2A\7EF4\5EA6\4E4B\95F4\7684\5173\7CFB\3002\7B2C\4E09\7EF4\7531\6C14\6CE1\5927\5C0F\8868\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166212163312455)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5408\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306907729312570)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5408\56FE\8868\5141\8BB8\5728\540C\4E00\4E2A\56FE\8868\4E0A\663E\793A\6761\5F62\56FE, \6298\7EBF\56FE\548C\9762\79EF\56FE\7CFB\5217\3002\6700\5E38\89C1\7684\7528\4F8B\662F\6761\7EBF\56FE\6216\5806\53E0\6761\7EBF\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166398846312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307066516312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\7528\4E8E\663E\793A\5EA6\91CF\503C\FF08\76F8\5BF9\4E8E\8BE5\5EA6\91CF\53EF\80FD\7684\6700\5C0F\503C\548C\6700\5927\503C\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201487135312484)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\73AF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307179381312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\73AF\56FE\662F\4E2D\95F4\4E3A\7A7A\5FC3\7684\997C\56FE\3002\5B83\4EEC\53EF\7528\4E8E\76F4\89C2\663E\793A\6574\4F53\7684\5404\4E2A\90E8\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166435239312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6F0F\6597\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307212622312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6F0F\6597\56FE\7528\4E8E\67E5\770B\5404\5904\7406\9636\6BB5\7684\6570\636E, \4F8B\5982\9500\552E\5904\7406\9636\6BB5\3002\6F0F\6597\56FE\5207\7247\7684\9762\79EF\4E0E\5BF9\5E94\9636\6BB5\7684\503C\6210\6B63\6BD4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496569284312723)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7518\7279\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496631656312723)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7518\7279\56FE\5BF9\4E8E\663E\793A\9879\76EE\8C03\5EA6, \663E\793A\6307\660E\4EFB\52A1\5F00\59CB\548C\7ED3\675F\65E5\671F\7684\6761\5F62\56FE\975E\5E38\6709\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166522826312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307353991312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\56FE\53EF\7528\4E8E\76F4\89C2\663E\793A\4E00\6BB5\65F6\95F4\5185\4E00\7EC4\503C\7684\8D8B\52BF\5E76\8DE8\7CFB\5217\6BD4\8F83\8FD9\4E9B\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166633769312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307436469312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE\4E0E\7EBF\5F62\56FE\76F8\540C\FF0C\4F7F\7528\6BCF\6761\7EBF\4E0B\9762\7684\9762\79EF\8FDB\884C\586B\5145\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166770143312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307507098312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE\53EF\7528\4E8E\76F4\89C2\663E\793A\6574\4F53\7684\5404\4E2A\90E8\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201124201312483)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6781\5750\6807\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307694163312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6781\5750\6807\56FE\5177\6709\4E00\4E2A\5F84\5411 y \8F74\548C\4E00\4E2A\5207\5411 x \8F74\3002\6781\5750\6807\56FE\53EF\4EE5\5448\73B0\4E3A\6761\5F62\56FE, \6298\7EBF\56FE, \9762\79EF\56FE, \7EC4\5408\56FE, \6563\70B9\56FE\6216\6C14\6CE1\56FE\7CFB\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000141091312325)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9525\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000271057312325)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5BF9\5206\5C42\5173\7CFB, \6BD4\4F8B\5173\7CFB\548C\57FA\4E8E\57FA\7840\7684\5173\7CFB, \5904\7406\6B65\9AA4, \7EC4\7EC7\5C42\6216\4E3B\9898\4E92\8FDE\8FDB\884C\53EF\89C6\5316\65F6, \9525\4F53\56FE\975E\5E38\6709\7528\3002\9525\4F53\5207\7247\7684\9762\79EF\4E0E\5BF9\5E94\9636\6BB5\7684\503C\6210\6B63\6BD4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201226095312483)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96F7\8FBE\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307707032312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96F7\8FBE\56FE\662F\591A\8FB9\5F62\7F51\683C\5F62\72B6 (\800C\975E\5706\5708) \7684\6781\5750\6807\56FE\3002\6298\7EBF\56FE\548C\9762\79EF\56FE\7CFB\5217\7C7B\578B\652F\6301\96F7\8FBE\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201387078312483)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307823268312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\56FE\4F7F\7528\6761\5F62\6216\9762\79EF\663E\793A\6BCF\4E2A\6761\76EE\7684\6700\5927\503C\548C\6700\5C0F\503C (\4E0A\9650\503C/\4E0B\9650\503C)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166882091312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6563\70B9\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108307942963312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6563\70B9\56FE\4F7F\7528 x \548C y \503C\5B9A\4E49\6570\636E\9879, \53EF\7528\4E8E\67E5\770B\4E24\4E2A\7EF4\5EA6\4E4B\95F4\7684\5173\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108166906949312456)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80A1\4EF7\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308033098312571)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80A1\4EF7\56FE\7528\4E8E\5728\65F6\95F4\8F74\4E0A\663E\793A\80A1\7968\7684\76F8\5173\4FE1\606F\3002\80A1\4EF7\56FE\7279\6709<strong>\80A1\7968\5448\73B0\4E3A</strong> K \7EBF\5C5E\6027, \53EF\663E\793A\80A1\7968\7684\5F00\76D8\4EF7, \6536\76D8\4EF7, \9AD8\4EF7, \4F4E\4EF7\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108165732905312455)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104548517312407)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\591A\7CFB\5217\56FE\8868\6570\636E\4E2D\7684\95F4\9699\5E94\8BBE\7F6E\4E3A\96F6\503C\8FD8\662F\7A7A\503C\3002</p>'),
unistr('        <p>\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\6570\636E\4E2D\7684\95F4\9699\5904\7406\4E3A\96F6\3002\5BF9\4E8E\7EBF\5F62\56FE\FF0C\8FD9\5C06\786E\4FDD\7EBF\6761\4EE5\5B9E\7EBF\65B9\5F0F\5448\73B0\3002\5BF9\4E8E\201C\5806\53E0\6761\6807\7B7E\201D\8BBE\7F6E\4E3A\201C\542F\7528\201D\7684\5806\53E0\6761\5F62\56FE\FF0C\8FD9\5C06\786E\4FDD\6BCF\4E2A\5806\53E0\6761\90FD\4F1A\5448\73B0\5806\53E0\6761\6807\7B7E\3002</p>'),
unistr('        <p>\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\65F6\FF0C\6570\636E\4E2D\7684\95F4\9699\5904\7406\4E3A\7A7A\503C\3002\5BF9\4E8E\7EBF\5F62\56FE\FF0C\7EBF\6761\5C06\4EE5\865A\7EBF\65B9\5F0F\5448\73B0\FF0C\95F4\9699\8868\793A\7A7A\503C\6570\636E\70B9\3002<p>'),
unistr('        <p>\6B64\8BBE\7F6E\5C06\5E94\7528\4E8E\652F\6301\4EE5\6761\5F62\548C\7EBF\6761\65B9\5F0F\5448\73B0\7684\591A\7CFB\5217\56FE\8868\7C7B\578B\FF0C\4F8B\5982\FF0C\6761\5F62\56FE\3001\7EBF\5F62\56FE\3001\7EBF\5F62\9762\79EF\56FE\3001\7EC4\5408\56FE\3001\9762\79EF\56FE\3001\6781\5750\6807\56FE\3001\96F7\8FBE\56FE\548C\6563\70B9\56FE\3002\9ED8\8BA4\503C\4E3A<strong>\542F\7528</strong>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104434086312406)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\95F4\9699\5448\73B0\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168885409312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\662F\5426\5728\56FE\8868\4E0A\542F\7528\6570\636E\6E38\6807\3002'),
unistr('        \5F53\96BE\4EE5\5BFC\822A\5230\6570\636E\9879 (\5C24\5176\5728\89E6\63A7\5F0F\8BBE\5907\4E0A) \65F6, \6570\636E\6E38\6807\53EF\7528\4E8E\66FF\4EE3\5DE5\5177\63D0\793A\3002<p/>'),
unistr('        <p>\5982\679C\8BBE\7F6E\4E3A<strong>\81EA\52A8</strong>, \5219\4EC5\4E3A\89E6\63A7\5F0F\8BBE\5907\4E0A\7684\6298\7EBF\56FE\6216\9762\79EF\56FE\663E\793A\6570\636E\6E38\6807\3002<p/>'),
unistr('        <p>\6CE8 - \6570\636E\6E38\6807\5728\5DE5\5177\63D0\793A\4E3A\7A7A\503C\65F6\4E0D\663E\793A, \5E76\4E14\5728\6781\5750\6807\56FE\8868\4E0A\4E0D\53D7\652F\6301\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168910467312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308439090312572)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\56FE\8868\5E94\7528 Oracle JET \5B9A\4E49\7684\9ED8\8BA4\6570\636E\6E38\6807\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169144396312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308694102312572)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\6570\636E\6E38\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169038828312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308509583312572)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8\663E\793A\6570\636E\6E38\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108168771058312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E38\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169322659312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\4E0A\7684\6570\636E\6E38\6807\884C\4E3A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169497628312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108298936397312564)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\56FE\8868\5E94\7528 Oracle JET \5B9A\4E49\7684\9ED8\8BA4\6570\636E\6E38\6807\884C\4E3A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169596106312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\6ED1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308724683312572)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6570\636E\6E38\6807\968F\9F20\6807/\89E6\63A7\70B9\79FB\52A8\800C\5E73\6ED1\79FB\52A8, \4E14\53EA\8981\6570\636E\6E38\6807\60AC\505C\5728\6570\636E\5143\7D20\4EFB\610F\90E8\5206 (\800C\4E0D\4EC5\4EC5\662F\7279\5B9A\6570\636E\70B9) \7684\4E0A\65B9\5C31\4F1A\663E\793A\5DE5\5177\63D0\793A\3002\5C06\7528\4E00\4E2A\6307\793A\7B26\6807\8BC6\5F53\524D\9009\62E9\7684\6570\636E\5143\7D20\3002</p>'),
unistr('        <p>\6CE8 - \5C06<strong>\6E38\6807</strong>\8BBE\7F6E\4E3A<strong>\662F</strong>\53EF\5B8C\5168\5B9E\73B0\8FD9\79CD\53EF\89C6\5316\6548\679C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169655347312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308887660312572)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\56FE\8868\4E0A\79FB\52A8\9F20\6807/\89E6\63A7\70B9\65F6, \6570\636E\6E38\6807\5C06\5BF9\9F50\5230 (\8DF3\5230) \6570\636E\5143\7D20, \4E14\53EA\8981\6570\636E\6E38\6807\60AC\505C\5728\6570\636E\5143\7D20\4E0A\65B9, \5C31\4F1A\663E\793A\5DE5\5177\63D0\793A\3002\4F1A\7528\4E00\4E2A\6307\793A\7B26\6765\6807\8BC6\5F53\524D\9009\62E9\7684\6570\636E\5143\7D20\3002</p>'),
unistr('        <p>\6CE8 - \5C06<strong>\6E38\6807</strong>\8BBE\7F6E\4E3A<strong>\662F</strong>\53EF\5B8C\5168\5B9E\73B0\8FD9\79CD\53EF\89C6\5316\6548\679C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169203460312458)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019194497312339)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\81EA\52A8\586B\5145\591A\7CFB\5217\56FE\8868\6570\636E\4E2D\7684\95F4\9699\3002\6B64\8BBE\7F6E\4E0D\9002\7528\4E8E\5355\7CFB\5217\56FE\8868\6216\4EE5\4E0B\7C7B\578B\7684\56FE\8868\FF1A\6C14\6CE1\56FE\3001\5706\73AF\56FE\3001\6F0F\6597\56FE\3001\7518\7279\56FE\3001\997C\56FE\3001\9525\4F53\56FE\3001\6563\70B9\56FE\548C\80A1\4EF7\56FE\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\5728 Oracle Application Express 5.1.3 \4E2D\5F15\5165\7684\6570\636E\81F4\5BC6\5316\903B\8F91\5C06\5E94\7528\5230\56FE\8868\6570\636E\3002\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\65F6\FF0C\5C06\4E0D\586B\5145\6570\636E\4E2D\7684\95F4\9699\5E76\53EF\80FD\5BFC\81F4\56FE\8868\5448\73B0\4E0D\51C6\786E\3002\9ED8\8BA4\503C\4E3A<strong>\542F\7528</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019029328312339)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\56FE\8868\6570\636E\4E2D\7684\95F4\9699')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733064336312906)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\8981\5E94\7528\5230\7518\7279\56FE\4E0A\57FA\7EBF\680F\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\4F7F\7528\7A7A\683C\5206\9694\7684\591A\4E2A\7C7B\3002\53EF\4EE5\5229\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732999922312906)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503271365312728)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\57FA\7EBF\7ED3\675F\65E5\671F\7684\5217\540D\3002\57FA\7EBF\7ED3\675F\65E5\671F\662F\4EFB\52A1\7684\539F\59CB\8BA1\5212\7ED3\675F\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503126753312728)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503093936312728)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\57FA\7EBF\5F00\59CB\65E5\671F\7684\5217\540D\3002\57FA\7EBF\5F00\59CB\65E5\671F\662F\4EFB\52A1\7684\539F\59CB\8BA1\5212\5F00\59CB\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502985236312728)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501463750312727)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\7ED3\675F\65E5\671F\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501331977312727)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501605642312727)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\7ED3\675F\65E5\671F\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501553737312727)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500626981312726)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\7518\7279\56FE\7ED3\675F\65E5\671F\7684\6E90\3002\9700\8981\7ED3\675F\65E5\671F\624D\80FD\5448\73B0\56FE\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500812638312726)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500983851312726)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\7ED3\675F\65E5\671F\5217</em>\4E2D\8F93\5165\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501164137312726)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501288801312726)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\7ED3\675F\65E5\671F\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500737352312726)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503410928312728)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5728\7518\7279\56FE\4E0A\5B9A\4E49\4EFB\52A1\8FDB\5EA6\7684\5217\540D\3002\8FDB\5EA6\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 1 \4E4B\95F4\3002\5982\679C\503C\65E0\6548, \5C06\4E0D\663E\793A\8FDB\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503344879312728)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732837891312906)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\8981\5E94\7528\5230\7518\7279\56FE\4E0A\8FDB\5EA6\680F\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\4F7F\7528\7A7A\683C\5206\9694\7684\591A\4E2A\7C7B\3002\53EF\4EE5\5229\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732785655312906)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDB\5EA6 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501803689312727)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\884C ID \7684\5217\540D\3002\5982\679C\60A8\5E0C\671B\6BCF\884C\5448\73B0\591A\4E2A\4EFB\52A1\FF0C\5219\9700\8981\884C ID\3002\672A\5B9A\4E49\884C ID \5217\6620\5C04\65F6\FF0C\6BCF\884C\5C06\53EA\5448\73B0\5355\4E2A\4EFB\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501738992312727)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502001206312727)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\884C\540D\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501973947312727)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500570443312726)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\5F00\59CB\65E5\671F\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500409930312726)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510066684312734)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\5F00\59CB\65E5\671F\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108501030828312726)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497011535312723)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\7518\7279\56FE\5F00\59CB\65E5\671F\7684\6E90\3002\9700\8981\5F00\59CB\65E5\671F\624D\80FD\5448\73B0\56FE\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499878959312725)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499959789312725)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\5F00\59CB\65E5\671F\5217</em>\4E2D\8F93\5165\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500006089312725)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108500133834312726)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\5F00\59CB\65E5\671F\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496964105312723)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732617126312906)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\8981\5E94\7528\5230\7518\7279\56FE\4E0A\4EFB\52A1\680F\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\4F7F\7528\7A7A\683C\5206\9694\7684\591A\4E2A\7C7B\3002\53EF\4EE5\5229\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732514153312906)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502892445312728)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\4EFB\52A1\7ED3\675F\65E5\671F\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502769778312728)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502234365312727)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\4EFB\52A1 ID \7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502115161312727)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502448696312727)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\4EFB\52A1\540D\79F0\7684\5217\540D\3002\672A\5B9A\4E49\884C\540D\5217\6620\5C04\65F6\FF0C\4EFB\52A1\540D\79F0\5C06\7528\4F5C\56FE\8868\884C\8F74\4E0A\7684\884C\6807\7B7E\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502373065312727)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502624775312728)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\4EFB\52A1\5F00\59CB\65E5\671F\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108502559537312728)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713276196312891)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\89C6\7A97\7ED3\675F\65E5\671F\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708208769312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713392477312891)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\89C6\7A97\7ED3\675F\65E5\671F\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708061519312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712915237312891)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\7518\7279\56FE\7684\89C6\7A97\7ED3\675F\65E5\671F\7684\6E90\3002\89C6\7A97\662F\4E00\4E2A\65E5\671F\8303\56F4, \5728\5B9A\4E49\540E, \53EF\4EE5\63A7\5236\5448\73B0\56FE\8868\65F6\7684\521D\59CB\7F29\653E\3002\56FE\8868\5C06\7F29\653E\5230\6307\5B9A\7684\65E5\671F\8303\56F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708458122312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713049534312891)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\7ED3\675F\65E5\671F\5217</em>\4E2D\8F93\5165\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708691656312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108713159427312891)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\7ED3\675F\65E5\671F\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707926913312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712722408312890)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\89C6\7A97\5F00\59CB\65E5\671F\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708144020312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712816031312890)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\7518\7279\56FE\4E0A\89C6\7A97\5F00\59CB\65E5\671F\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707870205312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712465068312890)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\7518\7279\56FE\7684\89C6\7A97\5F00\59CB\65E5\671F\7684\6E90\3002\89C6\7A97\662F\4E00\4E2A\65E5\671F\8303\56F4, \5728\5B9A\4E49\540E, \53EF\4EE5\63A7\5236\5448\73B0\56FE\8868\65F6\7684\521D\59CB\7F29\653E\3002\56FE\8868\5C06\7F29\653E\5230\6307\5B9A\7684\65E5\671F\8303\56F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708338660312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712517662312890)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\5F00\59CB\65E5\671F\5217</em>\4E2D\8F93\5165\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108708553056312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712605869312890)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\5F00\59CB\65E5\671F\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707721913312887)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F\6E90\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612065992312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\91C7\7528\5706\5F62\56FE\65B9\5411\7684\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\7684\89D2\5EA6\533A\FF08\4EE5\5EA6\4E3A\5355\4F4D\FF09\3002\89D2\5EA6\533A\662F\5706\5F62\56FE\65B9\5411\7684\5B9E\9645\89D2\5EA6\3002\6B63\503C\8868\793A\987A\65F6\9488\8D77\59CB\89D2\5EA6\3002\8D1F\503C\8868\793A\9006\65F6\9488\8D77\59CB\89D2\5EA6\3002\53EF\4EE5\6309\6240\9700\7684\4EFB\610F\89D2\5EA6\7ED8\5236\5706\5F62\8BA1\91CF\8868\FF0C\5E76\6839\636E\9009\62E9\7684\89D2\5EA6\66F4\6539\5176\5F62\72B6\3002\8BA1\91CF\8868\7684\5F62\72B6\53D6\51B3\4E8E 2 \4E2A\8BBE\7F6E\FF1A<strong>\8D77\59CB\89D2\5EA6</strong>\548C<strong>\89D2\5EA6\533A</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611843025312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\5EA6\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611453574312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7ED8\56FE\533A\7684\6307\793A\5668\7684\76F8\5BF9\539A\5EA6\7684\6BD4\7387\3002\9ED8\8BA4\503C\4E3A 1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611319043312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\793A\5668\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611508280312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\91C7\7528\5706\5F62\56FE\65B9\5411\7684\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\7684\5185\534A\5F84\FF0C\5B9A\4E49\4E3A\4ECE\8BA1\91CF\8868\7684\4E2D\5FC3\5230\6307\793A\5668\548C\7ED8\56FE\533A\7684\6700\5185\8FB9\7F18\7684\8DDD\79BB\3002\6709\6548\503C\4E3A\4ECE 0 \5230 1 \7684\767E\5206\6BD4\6216\6BD4\7387\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611609255312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\534A\5F84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611072309312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5448\73B0\7684\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\7684\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610726042312024)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610836810312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610902534312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610689955312024)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611273795312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\5448\73B0\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\7684\7ED8\56FE\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611120115312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7ED8\56FE\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725409450312112)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621655493312033)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\4E3A\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\7684\7ED8\56FE\533A\663E\793A\7684\989C\8272\3002\60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002\53EA\6709\6CA1\6709\4E3A\56FE\8868\5B9A\4E49\9608\503C\989C\8272\65F6\624D\4F1A\5E94\7528\6B64\989C\8272\3002</p>'),
unistr('<p>\989C\8272\662F\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\7684\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621562834312033)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED8\56FE\533A\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611998926312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\91C7\7528\5706\5F62\56FE\65B9\5411\7684\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\7684\8D77\59CB\89D2\5EA6\FF08\4EE5\5EA6\4E3A\5355\4F4D\FF09\3002\6B63\503C\8868\793A\987A\65F6\9488\8D77\59CB\89D2\5EA6\3002\8D1F\503C\8868\793A\9006\65F6\9488\8D77\59CB\89D2\5EA6\3002\53EF\4EE5\6309\6240\9700\7684\4EFB\610F\89D2\5EA6\7ED8\5236\5706\5F62\8BA1\91CF\8868\FF0C\5E76\6839\636E\9009\62E9\7684\89D2\5EA6\66F4\6539\5176\5F62\72B6\3002\8BA1\91CF\8868\7684\5F62\72B6\53D6\51B3\4E8E 2 \4E2A\8BBE\7F6E\FF1A<strong>\8D77\59CB\89D2\5EA6</strong>\548C<strong>\89D2\5EA6\533A</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107611772499312025)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D77\59CB\89D2\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496423043312722)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\663E\793A\6C34\5E73\7F51\683C\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495734807312722)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6C34\5E73\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169880432312458)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\5F53\9F20\6807\60AC\505C\5728\56FE\8868\4E0A\7684\6570\636E\9879\4E0A\65B9\65F6\8981\5E94\7528\7684\884C\4E3A\3002<p/>'),
unistr('        \5982\679C\9009\62E9<strong>\542F\7528</strong>\FF0C\9F20\6807\5F53\524D\672A\60AC\505C\5728\5176\4E0A\7684\6240\6709\6570\636E\9879\5C06\53D8\6DE1\FF0C\4EC5\9F20\6807\5F53\524D\60AC\505C\5728\5176\4E0A\7684\6570\636E\9879\5C06\7A81\51FA\663E\793A\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169739922312458)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60AC\505C\65F6\53D8\6DE1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757518736312925)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7684\521D\59CB\7F29\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757659702312925)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757718557312925)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\7F29\653E\5230\9002\5408\56FE\8868\7ED8\56FE\533A\57DF\7684\7B2C\4E00\4E2A\6570\636E\70B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757899977312926)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757925311312926)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\7F29\653E\5230\9002\5408\56FE\8868\7ED8\56FE\533A\57DF\7684\6700\540E\4E00\4E2A\6570\636E\70B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758095424312926)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758151648312926)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528\521D\59CB\7F29\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757471269312925)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143099094312437)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885736671312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\663E\793A\6307\5B9A\5C5E\6027\7684\5B57\4F53\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882773910312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884383392312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\7CFB\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882997273312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882869699312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883051309312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883180288312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883377907312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883251426312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883494900312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883543928312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883683961312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883771297312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883855976312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884027606312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107883935499312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884123751312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884262688312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882444123312232)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884834715312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885030802312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-cn'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885184936312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-cn'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885214855312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-cn'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885330790312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-cn'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885443571312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-cn'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885594609312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-cn'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885638841312235)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-cn'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884972783312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882637559312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884483947312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884677592312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884510892312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107884719415312234)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503E\659C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882514359312233)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693452546312087)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5E94\5982\4F55\5728\997C\56FE\5207\7247\4E0A\663E\793A\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737004024312909)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E - \767E\5206\6BD4\FF08\503C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737516732312910)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\7B7E\5C06\6309\7167\4EE5\4E0B\683C\5F0F\663E\793A\6807\7B7E\3001\503C\548C\767E\5206\6BD4\4FE1\606F\FF1A\6807\7B7E - \767E\5206\6BD4\FF08\503C\FF09\3002\4F8B\5982\FF0C<strong>Bug - 15% ( 18 )</strong>\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737117755312910)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4\FF08\503C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737695010312910)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\7B7E\5C06\6839\636E\9009\5B9A\201C\503C\201D\5217\6620\5C04\663E\793A\4E3A\6570\503C\3002\4F8B\5982\FF0C<strong>15% ( 18 )</strong>\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736791784312909)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737203561312910)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\7B7E\6839\636E\9009\5B9A\201C\6807\7B7E\201D\5217\6620\5C04\663E\793A\5728\56FE\8868\7684\5207\7247\4E0A\3002\4F8B\5982\FF0C<strong>Bug</strong>\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081302115312388)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E - \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081480308312388)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\7B7E\5C06\6309\4EE5\4E0B\683C\5F0F\663E\793A\6807\7B7E\548C\503C\4FE1\606F\FF1A\6807\7B7E - \503C\3002\4F8B\5982\FF0C<strong>Bugs - 18</strong>\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736882041312909)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737355274312910)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\7B7E\6839\636E\9009\5B9A\201C\503C\201D\5217\6620\5C04\663E\793A\4E3A\4ECB\4E8E 0% \4E0E 100% \4E4B\95F4\7684\503C\3002\8BE5\503C\662F\56FE\8868\4E0A\663E\793A\7684\603B\8BA1\503C\7684\767E\5206\6BD4\3002\4F8B\5982\FF0C<strong>15%</strong>\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736920754312909)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108737426075312910)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6807\7B7E\5C06\6839\636E\9009\5B9A\201C\503C\201D\5217\6620\5C04\663E\793A\4E3A\6570\503C\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736673687312909)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142952718312437)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879788977312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\663E\793A\6307\5B9A\5C5E\6027\7684\5B57\4F53\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879387162312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879492848312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\7CFB\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879978982312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879839605312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880098516312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880170732312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880338587312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880204746312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880451581312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880544990312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880676919312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880731924312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880895487312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881007852312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107880937909312231)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881185696312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881206011312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879092902312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879623765312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881736807312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-cn'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881896259312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-cn'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881991599312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-cn'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882087267312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-cn'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882101326312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-cn'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882296158312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-cn'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107882387588312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-cn'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881620293312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879232105312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879592641312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881440908312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881304506312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107881501332312232)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503E\659C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107879107597312230)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729299246312115)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\989C\8272\7684\9017\53F7\5206\9694\5217\8868\FF1A</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \8BED\6CD5\8FD4\56DE\989C\8272\3002\4F8B\5982\FF0C<strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\5217\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \8BED\6CD5\8FD4\56DE\989C\8272\3002\4F8B\5982\FF0C<strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729138190312115)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\7528\6765\6807\8BC6\8981\5728\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\4E0A\5448\73B0\7684\53C2\7167\7EBF\7684\989C\8272\3002'),
unistr('\5982\679C\6709\591A\6761\53C2\7167\7EBF\FF0C\8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728866400312114)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729004750312114)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9759\6001\6570\5B57\503C\7684\9017\53F7\5206\9694\5217\8868\FF1A</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \8BED\6CD5\8FD4\56DE\6570\5B57\503C\3002\4F8B\5982\FF0C<strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\5217\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \8BED\6CD5\8FD4\56DE\6570\5B57\503C\3002\4F8B\5982\FF0C<strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728943918312114)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\7528\6765\6807\8BC6\8981\5728\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\4E0A\5448\73B0\7684\53C2\7167\7EBF\7684\6570\5B57\3002'),
unistr('\5982\679C\6709\591A\6761\53C2\7167\7EBF\FF0C\8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728799774312114)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496208494312722)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\5448\73B0\884C\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495907133312722)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\884C\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181392912312468)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181281844312467)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\4E3A\4E0E\6B64\56FE\8868\7CFB\5217\5173\8054\7684\6570\636E\9879\663E\793A\7684\989C\8272\3002\60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002\5BF9\4E8E\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\FF0C\6B64\989C\8272\5C06\5E94\7528\4E8E\6307\793A\5668\FF0C\4F46\5B9A\4E49\4E86\9608\503C\5E76\4E14<strong>\9608\503C\663E\793A</strong>\5C5E\6027\8BBE\7F6E\4E3A<strong>\5728\6307\793A\5668\4E0A</strong>\65F6\4F8B\5916\3002</p>'),
unistr('<p>\989C\8272\662F\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\7684\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181186133312467)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107154802312409)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106916367312409)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\4E3A\7BB1\7EBF\56FE\7CFB\5217\7684 q2 \6BB5\663E\793A\7684\989C\8272\3002\60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106752078312408)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Q2 \989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107275273312409)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108107091581312409)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\4E3A\7BB1\7EBF\56FE\7CFB\5217\7684 q3 \6BB5\663E\793A\7684\989C\8272\3002\60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106824466312408)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Q3 \989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102067949312405)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7CFB\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088982234312395)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089078142312395)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088895136312394)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BB1\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089160195312395)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089207095312395)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089357099312395)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203337095312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217\7C7B\578B\5217\6620\5C04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203567132312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7CFB\5217\7C7B\578B\3002\4E5F\53EF\4EE5\521B\5EFA\5728\540C\4E00\4E2A\6570\636E\56FE\4E0A\7EC4\5408\4E0D\540C\7C7B\578B\7684\7CFB\5217\7684\56FE\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203630780312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204194615312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203791141312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204098515312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203831335312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203981973312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203497386312485)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204759193312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7CFB\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204892123312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205437946312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204909769312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205369208312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205259382312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C14\6CE1\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205042115312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492568012312719)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205119709312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6563\70B9\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204655512312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205656395312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7CFB\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205733459312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205884790312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205952217312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108205580040312487)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204355471312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7CFB\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204554732312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204400967312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108204251133312486)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186467650312472)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\5448\73B0\8F74\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186304407312471)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727753598312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\57FA\7EBF\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727110600312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\57FA\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727544788312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\7ED3\675F\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726948835312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727653667312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\8FDB\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727053914312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727272835312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\884C\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726677551312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727499120312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\5F00\59CB\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726807370312113)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612256511312026)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612111171312025)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727345382312113)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726727526312113)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174624314312462)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\5DE5\5177\63D0\793A\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174532382312462)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175271713312463)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\503C\3002\503C\6D3E\751F\81EA\56FE\8868\67E5\8BE2\5E76\663E\793A\5728\56FE\8868\6570\636E\65C1\8FB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175187891312463)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108509975367312733)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6839\636E\56FE\8868\7684\503C\6216\6807\7B7E\FF0C\9009\62E9\591A\7CFB\5217\56FE\8868\4E0A\6570\636E\7684\56FE\8868\6392\5E8F\987A\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494595974312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E - \5347\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494990173312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6309\7167 x \8F74\6807\7B7E\7684\5347\5E8F\5BF9\56FE\8868\8FDB\884C\6392\5E8F\3002\8FD9\662F\9ED8\8BA4\6392\5E8F\987A\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494685907312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E - \964D\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495076485312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6309\7167 x \8F74\6807\7B7E\7684\964D\5E8F\5BF9\56FE\8868\8FDB\884C\6392\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494381583312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C - \5347\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494786247312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6309\7167\503C\7684\5347\5E8F (1, 2, 3, ...) \5BF9\56FE\8868\8FDB\884C\6392\5E8F\3002\6B64\8BBE\7F6E\4EC5\7528\4E8E\997C\56FE, \5177\6709\4E00\4E2A\7CFB\5217\7684\6761\5F62\56FE/\7EBF\5F62\56FE/\9762\79EF\56FE, \6216\8005\5806\53E0\7684\6761\5F62\56FE/\9762\79EF\56FE\3002\4F7F\7528\5206\5C42\7EC4\5750\6807\8F74\65F6\4E0D\5E94\7528\6392\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494454213312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C - \964D\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494839921312721)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6309\7167\503C\7684\964D\5E8F (10, 9, 8, ...) \5BF9\56FE\8868\8FDB\884C\6392\5E8F\3002\6B64\8BBE\7F6E\4EC5\7528\4E8E\997C\56FE, \5177\6709\4E00\4E2A\7CFB\5217\7684\6761\5F62\56FE/\7EBF\5F62\56FE/\9762\79EF\56FE, \6216\8005\5806\53E0\7684\6761\5F62\56FE/\9762\79EF\56FE\3002\4F7F\7528\5206\5C42\7EC4\5750\6807\8F74\65F6\4E0D\5E94\7528\6392\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494273643312720)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\987A\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339782020312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339655379312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\663E\793A\6307\5B9A\5C5E\6027\7684\5B57\4F53\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339278949312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339398371312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\7CFB\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341046527312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340931050312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341160826312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341298637312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341449214312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341382151312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341514339312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341669801312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341775361312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341893695312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108341971214312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342156686312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342090233312598)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342279811312599)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342369069312599)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338916796312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339518341312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339986228312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-cn'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340039983312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-cn'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340177553312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-cn'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340262528312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-cn'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340357584312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-cn'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340490398312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-cn'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340519925312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-cn'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339819093312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339199690312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339445044312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340762690312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340684775312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108340889571312597)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503E\659C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108339077000312596)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503643683312728)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7518\7279\56FE\4E0A\4EFB\52A1\6807\7B7E\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503931181312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504348739312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\6807\7B7E\5448\73B0\5728\7518\7279\56FE\4E0A\4EFB\52A1\680F\7684\7ED3\675F\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504078078312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8\4E2D\5FC3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504447037312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\6807\7B7E\5448\73B0\5728\7518\7279\56FE\4E0A\4EFB\52A1\680F\7684\5185\90E8\4E2D\5FC3\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504206190312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504685973312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\6807\7B7E\5448\73B0\5728\7518\7279\56FE\4E0A\4EFB\52A1\680F\7684\5185\90E8\7ED3\675F\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504117826312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108504569329312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\6807\7B7E\5448\73B0\5728\7518\7279\56FE\4E0A\4EFB\52A1\680F\7684\5185\90E8\5F00\59CB\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503770819312728)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503899672312729)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\6807\7B7E\5448\73B0\5728\7518\7279\56FE\4E0A\4EFB\52A1\680F\7684\5F00\59CB\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108503558725312728)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\6807\7B7E\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640525219312047)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\989C\8272\7684\9017\53F7\5206\9694\5217\8868\FF1A</dt>'),
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \8BED\6CD5\8FD4\56DE\989C\8272\3002\4F8B\5982\FF0C<strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\5217\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \8BED\6CD5\8FD4\56DE\989C\8272\3002\4F8B\5982\FF0C<strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640444904312047)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\7528\6765\6807\8BC6\8981\5728\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\4E0A\5448\73B0\7684\9608\503C\4E0A\9650\7684\989C\8272\3002'),
unistr('\5982\679C\6709\591A\4E2A\9608\503C\FF0C\8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621812867312033)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725561171312112)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\9608\503C\5982\4F55\663E\793A\5728\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\4E0A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639965801312046)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640066538312047)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528<strong>\9608\503C</strong>\5C5E\6027\5B9A\4E49\7684\6240\6709\9608\503C\90FD\663E\793A\5728\56FE\8868\7684\7ED8\56FE\533A\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640204087312047)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5F53\524D\9608\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640392728312047)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528<strong>\9608\503C</strong>\5C5E\6027\5B9A\4E49\7684\5F53\524D\9608\503C\663E\793A\5728\56FE\8868\7684\7ED8\56FE\533A\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107640148114312047)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6307\793A\5668\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107725612802312112)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528<strong>\9608\503C</strong>\5C5E\6027\5B9A\4E49\7684\5F53\524D\9608\503C\663E\793A\5728\56FE\8868\7684\6307\793A\5668\4E0A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639868214312046)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639755784312046)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>\9759\6001\6570\5B57\503C\7684\9017\53F7\5206\9694\5217\8868\FF1A</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;ITEM.</code> \8BED\6CD5\8FD4\56DE\6570\5B57\503C\3002\4F8B\5982\FF0C<strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>'),
'</pre></dd>',
unistr('<dt>\5217\7684\9017\53F7\5206\9694\5217\8868\FF0C\4F7F\7528 </dt>'),
'<dd><pre>',
unistr('<code>&amp;COLUMN_NAME.</code> \8BED\6CD5\8FD4\56DE\6570\5B57\503C\3002\4F8B\5982\FF0C<strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621792172312033)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8981\7528\6765\6807\8BC6\8981\5728\72B6\6001\6D4B\91CF\4EEA\6570\636E\8BA1\91CF\8868\56FE\8868\4E0A\5448\73B0\7684\9608\503C\4E0A\9650\7684\6570\5B57\3002'),
unistr('\5982\679C\6709\591A\4E2A\9608\503C\FF0C\8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621497643312033)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142863593312437)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878929696312230)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\663E\793A\6307\5B9A\5C5E\6027\7684\5B57\4F53\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875918250312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877560919312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\7CFB\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876143040312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876027700312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876217069312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876325560312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876574976312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876474328312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876696069312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876702702312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876876038312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107876998293312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877062668312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877225903312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877158400312228)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877358334312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877408412312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875693478312227)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878040369312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878210847312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-cn'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878331272312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-cn'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878459092312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-cn'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878546513312230)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-cn'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878619012312230)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-cn'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878735196312230)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-cn'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878880286312230)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-cn'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107878175141312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875870504312227)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877653781312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877885893312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877751372312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107877994168312229)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503E\659C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875710668312227)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170054808312459)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\56FE\8868\4E0A\663E\793A\7684\65F6\95F4\8F74\7C7B\578B\3002\6B64\8BBE\7F6E\5C06\81EA\52A8\6309\65F6\95F4\987A\5E8F\5448\73B0\56FE\8868\6570\636E, \5982\679C\60A8\9700\8981\6309\65F6\95F4\987A\5E8F\7684\9006\5E8F\5448\73B0\6570\636E, \5219\4E0D\5E94\4F7F\7528\6B64\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170165871312459)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299000623312564)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\8981\5448\73B0\7684\6570\636E, \5411\56FE\8868\5E94\7528 Oracle JET \5B9A\4E49\7684\9ED8\8BA4\65F6\95F4\8F74\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170232860312459)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299163309312564)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5411\56FE\8868\5E94\7528\65F6\95F4\8F74\7C7B\578B\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170335064312459)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299292064312564)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\56FE\8868\5E94\7528\65F6\95F4\8F74\7C7B\578B\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170412350312459)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF7\5408\9891\7387')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209340276312490)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\6DF7\5408\9891\7387\663E\793A\5728\56FE\8868\5750\6807\8F74\4E0A\7684\65F6\95F4\503C\3002\7531\4E8E\6570\636E\7684\65F6\95F4\503C\53EF\80FD\4E0D\540C\FF0C\56E0\6B64\4E0D\652F\6301\5806\53E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209491472312490)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DF3\8FC7\95F4\9699')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209561932312490)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5728\56FE\8868\8F74\4E0A\7684\65F6\95F4\503C\5C06\6309\5B9A\671F\95F4\9694\5448\73B0, \800C\4E0D\8003\8651\6570\636E\4E2D\53EF\80FD\5B58\5728\7684\4EFB\4F55\65F6\95F4\95F4\9699\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108169984370312459)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\8F74\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142702709312437)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875140501312227)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\663E\793A\6307\5B9A\5C5E\6027\7684\5B57\4F53\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875087943312227)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874746548312227)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\7CFB\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873379248312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873221755312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873426350312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873580635312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873789851312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873661968312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873840065312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873945688312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874011598312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874174255312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874248506312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874445404312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874312921312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874555738312226)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874602999312227)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871818803312224)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7CFB\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874986599312227)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872567742312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'zh-cn'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872611850312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'zh-cn'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872791226312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'zh-cn'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872814874312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'zh-cn'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872904806312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'zh-cn'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873096754312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'zh-cn'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107873118295312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'zh-cn'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872462060312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'zh-cn'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872021718312224)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107874860158312227)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B57\4F53\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872288860312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872198170312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107872369598312225)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503E\659C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871966905312224)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108496392015312722)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\56FE\8868\4E0A\663E\793A\5782\76F4\7F51\683C\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495874311312722)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5782\76F4\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210317370312491)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\56FE\8868\7684\7F29\653E\548C\6EDA\52A8\884C\4E3A\3002<strong>\5B9E\65F6</strong>\884C\4E3A\8868\793A\5C06\968F\7740\64CD\7EB5\56FE\8868\6301\7EED\66F4\65B0\56FE\8868,'),
unistr('        \800C<strong>\5EF6\8FDF</strong>\5219\8868\793A\5C06\7B49\5230\7F29\653E/\6EDA\52A8\64CD\4F5C\5B8C\6210\540E\6267\884C\66F4\65B0\3002\867D\7136<strong>\5B9E\65F6</strong>\7F29\653E\548C\6EDA\52A8\63D0\4F9B\6700\597D\7684\6700\7EC8\7528\6237\4F53\9A8C, \4F46\662F\4E0D\4FDD\8BC1'),
unistr('        \5927\578B\6570\636E\96C6\6216\7F13\6162\5BA2\6237\673A\73AF\5883\7684\5448\73B0\6027\80FD\6216\53EF\7528\6027\3002\5982\679C\51FA\73B0\6027\80FD\95EE\9898, \5219\5E94\6539\7528<strong>\5EF6\8FDF</strong>\7F29\653E\548C\6EDA\52A8\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170625401312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\56FE\8868\7684\7F29\653E\548C\6EDA\52A8\884C\4E3A\3002'),
unistr('        \7F29\653E\548C\6EDA\52A8\4F7F\6700\7EC8\7528\6237\53EF\4EE5\4F7F\7528\9F20\6807\6EDA\8F6E\6216\4E24\6839\624B\6307\7F29\653E\6765\6267\884C\64CD\4F5C (\4F8B\5982, \5728\7ED8\56FE\533A\4E0A\62D6\52A8), \4EE5\4FBF\8C03\6574\6240\793A\503C\7684\5927\5C0F\4EE5\53CA\5728\56FE\8868\5185\5BFC\822A\4EE5\663E\793A\5176\4ED6\56FE\8868\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170883080312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EF6\8FDF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250081995312523)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6570\636E\663E\793A\7684\66F4\6539\5C06\7B49\5230\7F29\653E/\6EDA\52A8\64CD\4F5C\5B8C\6210\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170915543312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5EF6\8FDF\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250107627312523)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6570\636E\663E\793A\7684\66F4\6539\5C06\7B49\5230\6EDA\52A8\64CD\4F5C\5B8C\6210\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171087603312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250231890312523)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5B9E\65F6\884C\4E3A\8868\793A\5C06\968F\7740\64CD\7EB5\56FE\8868\6301\7EED\66F4\65B0\56FE\8868\3002'),
unistr('        \5BF9\4E8E\5927\578B\6570\636E\96C6\6216\7F13\6162\7684\5BA2\6237\673A\73AF\5883, \5EFA\8BAE\9009\62E9<strong>\5EF6\8FDF</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171177405312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5B9E\65F6\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250383317312523)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4EC5\5B9E\65F6\6EDA\52A8\884C\4E3A\8868\793A\5C06\968F\7740\6EDA\52A8\56FE\8868\6301\7EED\66F4\65B0\56FE\8868\3002'),
unistr('        \5BF9\4E8E\5927\578B\6570\636E\96C6\6216\7F13\6162\7684\5BA2\6237\673A\73AF\5883, \8003\8651\9009\62E9<strong>\4EC5\5EF6\8FDF\6EDA\52A8</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170712233312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249952465312523)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528\56FE\8868\7684\7F29\653E\548C\6EDA\52A8\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108170579451312459)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E\548C\6EDA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714894049312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\7684\7F29\653E\65B9\5411\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714995482312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E24\4E2A\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715043184312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\65F6\5728 x \8F74\548C y \8F74\65B9\5411\7F29\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715157303312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('X \8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715295132312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\5728 x \8F74\65B9\5411\7F29\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715334779312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Y \8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715473782312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\5728 y \8F74\65B9\5411\7F29\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108714795298312892)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499013012312725)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\5929\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497814390312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498917476312725)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\5C0F\65F6\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497555259312723)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498860838312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\5206\949F\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497422244312723)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499225555312725)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\6708\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498267262312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499344816312725)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\5B63\5EA6\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498457999312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B63\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498794874312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\79D2\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108497104971312723)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499124997312725)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\5468\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498007757312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108499454534312725)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\5728\56FE\8868\4E0A\7F29\653E\5230\5E74\6807\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108498612995312724)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302688332312567)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\63A7\5236\64CD\4F5C\662F\5426\89E6\53D1\7684\5BA2\6237\7AEF\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897718176312244)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\63A7\5236\89E6\53D1 True \8FD8\662F False \64CD\4F5C\7684\5BA2\6237\7AEF\6761\4EF6\3002\5982\679C\6761\4EF6'),
unistr('                                  \6C42\503C\7ED3\679C\4E3A True, \5219\89E6\53D1 True \64CD\4F5C, \5982\679C\6761\4EF6\6C42\503C\7ED3\679C\4E3A False, \5219\89E6\53D1 False \64CD\4F5C\3002'),
unistr('                                  \5982\679C\672A\6307\5B9A\6761\4EF6, \5219\4EC5\89E6\53D1 True \64CD\4F5C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408824984312651)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765520876312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409087973312651)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 > \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765772408312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\5927\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409157359312651)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 >= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765815665312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\5927\4E8E\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409612887312652)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5728\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766382543312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\5728\6307\5B9A\7684<em>\5217\8868</em>\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409809769312652)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766538832312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6307\5B9A JavaScript \8868\8FBE\5F0F\6C42\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409224437312651)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 < \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765965858312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\5C0F\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409335281312651)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 <= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766036513312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\5C0F\4E8E\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408976673312651)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108765689289312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\4E0D\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409724666312652)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5728\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766413247312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\7684\503C\662F\5426\4E0D\5728\6307\5B9A\7684<em>\5217\8868</em>\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409595666312652)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766259303312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\662F\5426\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108409458358312652)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766176236312932)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\662F\5426\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897636084312244)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766915096312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\5217\3002</p>'),
unistr('<p>\6CE8: \5728\5927\90E8\5206\60C5\51B5\4E0B, \8FD9\5E94\4E3A\5728\4E0A\9762 (\5373<em>\201C\65F6\95F4\201D\5206\7EC4\4E0B\7684\201C\5217\201D\5C5E\6027</em>\4E2D) \6307\5B9A\7684\5217,'),
unistr('\56E0\6B64\9ED8\8BA4\4E3A\6B64\503C\3002\4E0D\8FC7, \60A8\53EF\80FD\4F1A\5E0C\671B\4F7F\6761\4EF6\57FA\4E8E\5176\4ED6\5217,'),
unistr('\4F8B\5982, \5BF9\4E8E\57FA\4E8E EMP \8868\7684\4EA4\4E92\5F0F\7F51\683C, \5982\679C\5E0C\671B\5728 <code>SAL</code> \53D1\751F\66F4\6539\4F46\4EC5\5F53 '),
unistr('<code>JOB</code> \7B49\4E8E <em>SALESMAN</em> \65F6\89E6\53D1\52A8\6001\64CD\4F5C, \5219\5E94\5C06\6B64\5C5E\6027\66F4\6539\4E3A <code>JOB</code>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761553036312928)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768213629312934)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\662F\5426\5728\6B64\6761\4EF6\4E2D\4F7F\7528\4E86<em>\9879</em>\6216<em>\5217</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757050764312925)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756959767312925)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756839412312925)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302746375312567)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\8005\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302528787312567)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\8005\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767023971312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\8005\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('<p>\6CE8: \5728\5927\90E8\5206\60C5\51B5\4E0B, \8FD9\5E94\4E3A\5728\4E0A\9762 (\5373<em>\201C\65F6\95F4\201D\5206\7EC4\4E0B\7684\201C\9879\201D\5C5E\6027</em>\4E2D) \6307\5B9A\7684\9879,'),
unistr('\56E0\6B64\9ED8\8BA4\4E3A\6B64\503C\3002\4E0D\8FC7, \60A8\53EF\80FD\4F1A\5E0C\671B\4F7F\6761\4EF6\57FA\4E8E\5176\4ED6\9875\9879,'),
unistr('\4F8B\5982, \5BF9\4E8E\57FA\4E8E EMP \8868\7684\8868\5355, \5982\679C\5E0C\671B\5728 <code>P2_SAL</code> \53D1\751F\66F4\6539\4F46\4EC5\5F53'),
unistr('<code>P2_JOB</code> \7B49\4E8E <em>SALESMAN</em> \65F6\89E6\53D1\52A8\6001\64CD\4F5C, \5219\5E94\5C06\6B64\5C5E\6027\66F4\6539\4E3A <code>P2_JOB</code>\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108757194725312925)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108766816470312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\8005\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761496755312928)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302879204312567)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\63A7\5236\64CD\4F5C\662F\5426\89E6\53D1\7684\5BA2\6237\7AEF\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761748422312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\63A7\5236\89E6\53D1 True \8FD8\662F False \64CD\4F5C\7684\5BA2\6237\7AEF\6761\4EF6\3002\5982\679C\6761\4EF6'),
unistr('                                  \6C42\503C\7ED3\679C\4E3A True, \5219\89E6\53D1 True \64CD\4F5C, \5982\679C\6761\4EF6\6C42\503C\7ED3\679C\4E3A False, \5219\89E6\53D1 False \64CD\4F5C\3002'),
unistr('                                  \5982\679C\672A\6307\5B9A\6761\4EF6, \5219\4EC5\89E6\53D1 True \64CD\4F5C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761899113312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767174537312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762020611312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217 > \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767345378312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\5927\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762130014312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217 >= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767499731312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\5927\4E8E\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762637866312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217\5728\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767966430312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\5728\6307\5B9A\7684<em>\5217\8868</em>\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762861989312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768156211312934)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6307\5B9A JavaScript \8868\8FBE\5F0F\6C42\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762242078312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217 < \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767581025312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\5C0F\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762309214312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217 <= \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767606168312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\5C0F\4E8E\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761951217312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767244535312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\4E0D\7B49\4E8E\6307\5B9A\7684<em>\503C</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762704329312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217\4E0D\5728\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768039917312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\7684\503C\662F\5426\4E0D\5728\6307\5B9A\7684<em>\5217\8868</em>\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762541517312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767846390312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\662F\5426\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762416972312929)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879/\5217\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108767754482312933)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\6240\9009<em>\9879</em>\6216<em>\5217</em>\662F\5426\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761609059312928)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302429611312566)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\4E3A\6B64\6761\4EF6\6C42\503C\7684 JavaScript \8868\8FBE\5F0F\3002'),
unistr('\4EE3\7801\5177\6709\4EE5\4E0B\52A8\6001\64CD\4F5C\76F8\5173\5C5E\6027\7684\8BBF\95EE\6743\9650:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\5BF9 DOM \5BF9\8C61\7684\5F15\7528, \8BE5\5BF9\8C61\5C5E\4E8E\89E6\53D1\4E86\52A8\6001\64CD\4F5C\7684\5143\7D20\3002</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\89E6\53D1\4E86\4E8B\4EF6\7684\4E8B\4EF6\5BF9\8C61\3002\6CE8: \6B64\5C5E\6027\5728\52A0\8F7D\65F6\7B49\4E8E ''load''\3002</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\53EF\4ECE\4E8B\4EF6\5904\7406\7A0B\5E8F\4F20\9012\7684\5176\4ED6\53EF\9009\6570\636E\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302368567312566)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763452630312930)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\4E3A\6B64\6761\4EF6\6C42\503C\7684 JavaScript \8868\8FBE\5F0F\3002'),
unistr('\4EE3\7801\5177\6709\4EE5\4E0B\52A8\6001\64CD\4F5C\76F8\5173\5C5E\6027\7684\8BBF\95EE\6743\9650:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>\5BF9 DOM \5BF9\8C61\7684\5F15\7528, \8BE5\5BF9\8C61\5C5E\4E8E\89E6\53D1\4E86\52A8\6001\64CD\4F5C\7684\5143\7D20\3002</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>\89E6\53D1\4E86\4E8B\4EF6\7684\4E8B\4EF6\5BF9\8C61\3002\6CE8: \6B64\5C5E\6027\5728\52A0\8F7D\65F6\7B49\4E8E ''load''\3002</dd>'),
'  <dt>this.data</dt>',
unistr('    <dd>\53EF\4ECE\4E8B\4EF6\5904\7406\7A0B\5E8F\4F20\9012\7684\5176\4ED6\53EF\9009\6570\636E\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763317464312930)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761364319312928)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108761208359312928)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763243215312930)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\8981\6D4B\8BD5\7684\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763114228312930)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801824712312966)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801755267312966)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763085532312930)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\8981\6D4B\8BD5\7684\6761\4EF6\8F93\5165\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108762911857312929)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898426391312245)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\9875\52A0\8F7D\65F6\6267\884C\7684 JavaScript \4EE3\7801\3002'),
unistr('\8BE5\4EE3\7801\5C06\5728 &PRODUCT_NAME. \751F\6210\7684 JavaScript \4EE3\7801\4E4B\540E\6267\884C\3002</p>'),
unistr('<p>\6B64\5904\8F93\5165\7684\4EE3\7801\5C06\66FF\6362\9875\6A21\677F\4E2D\7684 <code>#GENERATED_JAVASCRIPT#</code> \66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('<p>\6CE8\FF1A\65E0\9700\6DFB\52A0\4EFB\4F55\5F00\59CB\6216\7ED3\675F <code>script</code> \6807\8BB0\FF0C\53EA\9700\63D0\4F9B JavaScript \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898355531312245)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\9875\65F6\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400748161312645)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6807\51C6\6587\4EF6\5F15\7528</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>\6807\51C6\6587\4EF6\5F15\7528 (\4ECE <code>/myjs/minified/</code> \52A0\8F7D\7F29\51CF\7248\6587\4EF6 <code>main.min.js</code> \4EE5\6EE1\8DB3\5E38\89C4\9875\8BBF\95EE\9700\6C42, \5E76\5728\8C03\8BD5\6A21\5F0F\4E0B\6216\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\4ECE <code>/myjs/</code> \52A0\8F7D <code>main.js</code>)\3002</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>\5982\679C\8FD8\4F1A\901A\8FC7 RequireJS require \8C03\7528\6765\4F7F\7528\5E93, \5219\4F7F\7528\6B64\8BED\6CD5\3002define \540D\79F0\5FC5\987B\4E0E requirejs.config \8DEF\5F84\4E2D\4F7F\7528\7684\540D\79F0\5339\914D, \5E76\4E14\503C\5FC5\987B\4E3A\7531\5E93\516C\5F00\7684\5168\5C40\7B26\53F7\3002\4EC5\5728\4F7F\7528 RequireJS \65F6\9002\7528\3002\8FD9\53EF\4EE5\907F\514D RequireJS \518D\6B21\52A0\8F7D\8BE5\5E93\3002</dt>'),
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>\4EC5\5728\6587\4EF6\4F9D\8D56\4E8E RequireJS \65F6\4F7F\7528\6B64\8BED\6CD5\3002\8FD9\4F1A\5728\6B64\6587\4EF6\4E4B\524D\81EA\52A8\52A0\8F7D RequireJS\3002</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>\4EC5\5728\6587\4EF6\4F9D\8D56\4E8E Oracle JET \65F6\4F7F\7528\6B64\8BED\6CD5\3002\8FD9\4F1A\5728\6B64\6587\4EF6\4E4B\524D\81EA\52A8\52A0\8F7D RequireJS \548C Oracle JET RequireJS \914D\7F6E\3002</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>\6587\4EF6\5F15\7528 (\5728\5F15\7528\5E94\7528\7A0B\5E8F\7248\672C\7684 URL \4E2D\4F7F\7528\67E5\8BE2\5B57\7B26\4E32, \8FD9\6837\5728\5347\7EA7\5E94\7528\7A0B\5E8F (\5E76\9012\589E\7248\672C) \65F6, \7CFB\7EDF\5C06\6307\793A\6D4F\89C8\5668\59CB\7EC8\52A0\8F7D\65B0\6587\4EF6, \5E76\5FFD\7565\4EE5\524D\9AD8\901F\7F13\5B58\7684\6240\6709\6587\4EF6)\3002</dt>'),
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898030882312245)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\6B64\9875\4E0A\52A0\8F7D\7684\4EE3\7801\7684 JavaScript \6587\4EF6 URL\3002\5404 URL \5FC5\987B\5199\5165\5230\65B0\884C\4E0A\3002'),
unistr('\5982\679C\63D0\4F9B\6587\4EF6\7684\7F29\51CF\7248, \5219\53EF\4EE5\4F7F\7528\66FF\6362\5B57\7B26\4E32 <code>#MIN#</code> \5C06 <code>.min</code> \5305\542B (\6216\4F7F\7528 <code>#MIN_DIRECTORY#</code> \5305\542B <code>minified/</code>) \5728\6587\4EF6 URL \4E2D\4EE5\6EE1\8DB3\5E38\89C4\9875\8BBF\95EE\9700\6C42; \5982\679C\5728\8C03\8BD5\6A21\5F0F\4E0B\6216\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\67E5\770B\6B64\9875, \5219\53EF\4EE5\4F7F\7528\7A7A\5B57\7B26\4E32\3002'),
unistr('\5982\679C\8981\5728\6587\4EF6 URL \4E2D\5305\542B\5E94\7528\7A0B\5E8F\7684\7248\672C, \60A8\8FD8\53EF\4EE5\8BBF\95EE\66FF\6362\5B57\7B26\4E32 <code>#APP_VERSION#</code>\3002</p>'),
unistr('<p>\6B64\5904\8F93\5165\7684 JavaScript \6587\4EF6 URL \5C06\66FF\6362\9875\6A21\677F\4E2D\7684 <code>#PAGE_JAVASCRIPT#</code> \66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('<p>\6CE8: \65E0\9700\5305\542B\5F00\59CB\6216\7ED3\675F <code>script</code> \6807\8BB0\3002\53EA\9700\6307\5B9A URL \5373\53EF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897914958312244)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898245585312245)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\6B64\9875\4E0A\5F15\7528\7684 JavaScript \4EE3\7801 (\4F8B\5982\51FD\6570\6216\5168\5C40\53D8\91CF\58F0\660E)\3002'),
unistr('\8981\5F15\7528\5FEB\6377\65B9\5F0F, \8BF7\4F7F\7528 <code>"SHORTCUTNAME"</code>\3002'),
unistr('\5982\679C\591A\4E2A\9875\4E0A\9700\8981\76F8\540C\7684 JavaScript, \8BF7\8003\8651\5C06\6B64\4EE3\7801\653E\5165\5916\90E8 JavaScript \6587\4EF6\4EE5\907F\514D\91CD\590D\548C\5229\7528\9759\6001\6587\4EF6\7684\6D4F\89C8\5668\9AD8\901F\7F13\5B58\3002</p>'),
unistr('<p>\6B64\5904\8F93\5165\7684\4EE3\7801\5C06\66FF\6362\9875\6A21\677F\4E2D\7684 <code>#PAGE_JAVASCRIPT#</code> \66FF\6362\5B57\7B26\4E32\3002</p>'),
unistr('<p>\6CE8: \4E0D\5FC5\5305\542B\5F00\59CB\6216\7ED3\675F <code>script</code> \6807\8BB0\3002\53EA\9700\5305\542B JavaScript \4EE3\7801\5373\53EF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898148724312245)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\548C\5168\5C40\53D8\91CF\58F0\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738807334312911)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\9762\7684\6807\7B7E\3002'),
unistr('    \4EC5\5F53\9762\663E\793A\65F6\FF0C\8BE5\6807\7B7E\624D\4F1A\663E\793A\5728\9875\9762\4E0A\3002\7C7B\578B\4E3A<strong>\641C\7D22</strong>\7684\6807\7B7E\5728\89C6\89C9\4E0A\5904\4E8E\9690\85CF\72B6\6001\FF0C\4F46\53EF\7528\4E8E\8F85\52A9\6280\672F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578231484312787)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('~\8F93\5165\9762\7EC4\7684\6807\7B7E\3002~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578452476312787)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\9762\7684\6807\7B7E\3002'),
unistr('    \4EC5\5F53\9762\663E\793A\65F6\FF0C\8BE5\6807\7B7E\624D\4F1A\663E\793A\5728\9875\9762\4E0A\3002\7C7B\578B\4E3A<strong>\641C\7D22</strong>\7684\6807\7B7E\5728\89C6\89C9\4E0A\5904\4E8E\9690\85CF\72B6\6001\FF0C\4F46\53EF\7528\4E8E\8F85\52A9\6280\672F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941409533312278)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7B5B\9009\5668\7684\6807\7B7E\3002'),
unistr('    \4EC5\5F53\7B5B\9009\5668\663E\793A\65F6\FF0C\8BE5\6807\7B7E\624D\4F1A\663E\793A\5728\9875\9762\4E0A\3002\7C7B\578B\4E3A<strong>\641C\7D22</strong>\7684\6807\7B7E\5728\89C6\89C9\4E0A\5904\4E8E\9690\85CF\72B6\6001\FF0C\4F46\53EF\7528\4E8E\8F85\52A9\6280\672F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942381413312279)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('~\8F93\5165\7B5B\9009\5668\7EC4\7684\6807\7B7E\3002~')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942760069312279)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7B5B\9009\5668\7684\6807\7B7E\3002'),
unistr('    \4EC5\5F53\7B5B\9009\5668\663E\793A\65F6\FF0C\8BE5\6807\7B7E\624D\4F1A\663E\793A\5728\9875\9762\4E0A\3002\7C7B\578B\4E3A<strong>\641C\7D22</strong>\7684\6807\7B7E\5728\89C6\89C9\4E0A\5904\4E8E\9690\85CF\72B6\6001\FF0C\4F46\53EF\7528\4E8E\8F85\52A9\6280\672F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923985596312265)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\9875\9879\7684\5B57\6BB5\6807\7B7E\3002'),
unistr('\53EA\6709\5F53\663E\793A\9879\65F6, \6807\7B7E\624D\4F1A\663E\793A\5728\9875\4E0A\3002'),
unistr('\6839\636E\6807\7B7E\7684\5BF9\9F50\65B9\5F0F\548C\663E\793A, \6807\7B7E\5C06\663E\793A\5728\81EA\5DF1\7684 HTML \8868\5355\5143\4E2D\6216\540C\4E00\4E2A\5355\5143\4E2D\3002</p>'),
unistr('<p>\9879\6807\7B7E\53EF\4EE5\5305\542B\4F7F\7528 <code>"SHORTCUT_NAME"</code> \8BED\6CD5\7684\5FEB\6377\65B9\5F0F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923867324312265)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924167227312265)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6807\7B7E\5BF9\9F50\65B9\5F0F\3002\6807\7B7E\53EF\4EE5\663E\793A\5728\9879\7684\4E0A\9762, \4E0B\9762\6216\5DE6\4FA7\3002'),
unistr('\5F53\6807\7B7E\663E\793A\5728\8868\5355\5143\7D20\65C1\8FB9\65F6, \5B83\5C06\5360\636E\81EA\5DF1\7684 HTML \8868\5355\5143\3002'),
unistr('\901A\8FC7\66F4\6539\6B64\6807\7B7E\5BF9\9F50\65B9\5F0F, \53EF\4EE5\63A7\5236\6B64\8868\5355\5143\5185\6807\7B7E\7684\4F4D\7F6E\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412290797312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412376514312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412525340312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412615229312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412754145312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412409533312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412940794312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413014020312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\9760\5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413172078312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108412878840312654)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413318842312655)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413455047312655)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\9760\53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413540329312655)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108413266249312655)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924001907312265)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741346655312913)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\72EC\7ACB\4E8E\533A\57DF\7684\6570\636E\52A0\8F7D\6B64\533A\57DF\3002</p>'),
unistr('        <p>\6307\5B9A\4E86\5EF6\8FDF\52A0\8F7D\65F6\FF0C\9875\4F1A\7ACB\5373\5448\73B0\5E76\663E\793A\7A7A\533A\57DF\FF0C\76F4\81F3\52A0\8F7D\6570\636E\3002'),
unistr('        \901A\5E38\FF0C\5728\6240\6709\9875\5747\5DF2\52A0\8F7D\5E76\51C6\5907\597D\5448\73B0\4E4B\524D\FF0C\4E0D\4F1A\663E\793A\9875\3002'),
unistr('        \56E0\6B64\FF0C\5982\679C\52A0\8F7D\533A\57DF\7684\6240\6709\6570\636E\9700\8981 5 \79D2\949F\FF0C\82E5\6CA1\6709\5EF6\8FDF\52A0\8F7D\FF0C\5219\6700\7EC8\7528\6237\5FC5\987B\7B49\5F85 5 \79D2\FF0C\4E4B\540E\9875\624D\5F00\59CB\5448\73B0\3002</p>'),
unistr('        <p>\6CE8 - \5EF6\8FDF\52A0\8F7D\5E94\53EA\7528\4E8E\9700\8981\5927\91CF\65F6\95F4\52A0\8F7D\7684\6570\636E\96C6\FF0C\56E0\4E3A\8FD9\5BF9\4E8E\5FEB\901F\52A0\8F7D\7684\533A\57DF\FF0C\4F1A\589E\52A0\4E0D\5FC5\8981\7684\6570\636E\5E93\5904\7406\5F00\9500\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120299942312419)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\72EC\7ACB\4E8E\533A\57DF\7684\6570\636E\52A0\8F7D\6B64\533A\57DF\3002</p>'),
unistr('        <p>\6307\5B9A\4E86\5EF6\8FDF\52A0\8F7D\65F6\FF0C\9875\4F1A\7ACB\5373\5448\73B0\5E76\663E\793A\7A7A\533A\57DF\FF0C\76F4\81F3\52A0\8F7D\6570\636E\3002'),
unistr('        \901A\5E38\FF0C\5728\6240\6709\9875\5747\5DF2\52A0\8F7D\5E76\51C6\5907\597D\5448\73B0\4E4B\524D\FF0C\4E0D\4F1A\663E\793A\9875\3002'),
unistr('        \56E0\6B64\FF0C\5982\679C\52A0\8F7D\533A\57DF\7684\6240\6709\6570\636E\9700\8981 5 \79D2\949F\FF0C\82E5\6CA1\6709\5EF6\8FDF\52A0\8F7D\FF0C\5219\6700\7EC8\7528\6237\5FC5\987B\7B49\5F85 5 \79D2\FF0C\4E4B\540E\9875\624D\5F00\59CB\5448\73B0\3002</p>'),
unistr('        <p>\6CE8 - \5EF6\8FDF\52A0\8F7D\5E94\53EA\7528\4E8E\9700\8981\5927\91CF\65F6\95F4\52A0\8F7D\7684\6570\636E\96C6\FF0C\56E0\4E3A\8FD9\5BF9\4E8E\5FEB\901F\52A0\8F7D\7684\533A\57DF\FF0C\4F1A\589E\52A0\4E0D\5FC5\8981\7684\6570\636E\5E93\5904\7406\5F00\9500\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120177714312419)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EF6\8FDF\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559900387312773)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\53EF\4EE5\901A\8FC7\5355\51FB\56FE\4F8B\4E2D\7684\5C42\540D\6765\5207\6362\5C42\7684\53EF\89C1\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559876541312773)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\4EE5\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560130599312773)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5728\56FE\4F8B\4E2D\4E3A\6B64\5C42\663E\793A\7684\56FE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560095637312773)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175646230312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\4E0A\7684\56FE\4F8B\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175717503312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176000233312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175945157312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175898115312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176159311312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175529092312463)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175441580312463)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\56FE\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175373602312463)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560386405312773)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\56FE\4F8B\7684\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286584959312554)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\56FE\8868\56FE\4F8B\9876\90E8\663E\793A\7684\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286400971312554)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181577670312468)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5728\56FE\8868\4E0A\5448\73B0\7684\7EBF\6761\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181783414312468)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\865A\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181649697312468)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181817107312468)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181484733312468)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182362841312468)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5728\56FE\8868\4E0A\5448\73B0\7684\7EBF\6761\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182483951312468)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182759235312469)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182570111312468)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D\9636\68AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182660268312469)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F2\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183073804312469)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182940718312469)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182894597312469)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9636\68AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183143418312469)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F4\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182298263312468)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182048368312468)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5728\56FE\8868\4E0A\5448\73B0\7684\7EBF\6761\5BBD\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108181921418312468)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108182190643312468)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429148255312670)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5728\65B0\7A97\53E3\4E2D\6253\5F00\94FE\63A5</dt>'),
'<dd><pre>target="_blank"</pre></dd>',
unistr('<dt>\60AC\505C\65F6\663E\793A\5DE5\5177\63D0\793A</dt>'),
unistr('<dd><pre>title="\5355\51FB\53EF\8FDB\884C\7F16\8F91"</pre></dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226161372312503)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5305\542B\5728 <code>&lt;a href=...&gt;</code> \6807\8BB0\4E2D\7684\9644\52A0\5217\94FE\63A5\5C5E\6027, \5305\62EC\94FE\63A5\76EE\6807, \7C7B\6216\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226084249312503)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231816488312508)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\94FE\63A5\5217\5173\8054\7684\6388\6743\65B9\6848\3002\8981\5728\62A5\8868\4E2D\5448\73B0\94FE\63A5\5217, \6B64\6388\6743\65B9\6848\5FC5\987B\6C42\503C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231777646312507)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644153006312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644575501312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644436723312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644338807312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644624980312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644275894312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644024175312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646169726312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646460511312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646390187312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646217060312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646554877312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646081780312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240471649312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240387477312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241811665312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241790230312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645750891312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Java \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645684939312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647368827312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Java \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647214367312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645571805312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645430649312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 JavaScript \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645324726312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647179594312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647051436312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 JavaScript \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646941554312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240614422312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\5192\53F7 (:) \5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240545256312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241037981312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240901991312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241248205312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\9875\7801\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241104608312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645280905312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645152352312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 PL/SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645031167312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646897650312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646711531312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108646615963312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240826644312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4E0E\6307\5B9A\503C\8FDB\884C\6BD4\8F83\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240700825312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645926544312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Python \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108645858060312839)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647505286312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Python \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108647494536312840)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644977660312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644899522312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108644791319312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108787095628312955)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 30 \65F6, \8981\5728\6709\4E00\884C\6216\591A\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 40 \65F6, \8981\5728\6CA1\6709\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240081349312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239961067312514)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241456370312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241325420312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242039307312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241946172312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239833917312514)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\4E86\5448\73B0\6B64\94FE\63A5\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490992587312718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626689243312824)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\59CB\7EC8\5448\73B0\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489501673312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Microsoft Internet Explorer 7.0 \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489630987312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\652F\6301 XHTML/CSS \7684\6D4F\89C8\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489423183312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Mozilla, Netscape 6.x/7x \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489712265312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\5176\4ED6\6D4F\89C8\5668 (\6216\8F83\4F4E\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488149675312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\9879\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490120921312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630268505312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489824739312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630454238312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490089732312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630329951312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489990035312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630569616312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487378496312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629079345312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487552863312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629292015312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487471464312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629143971312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487643625312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629395749312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490254855312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490351871312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489082493312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630080184312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875\540E, \5728\9875\4E0A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488432796312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488294222312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488382327312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488534689312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485094484312713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626721486312824)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643832452312837)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108643983358312838)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485295786312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626900111312824)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\8FD4\56DE\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490612876312718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490708614312718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488720352312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E0D\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629783779312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38\663E\793A\9875\548C\7236\533A\57DF (\5982\679C\9002\7528)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488692112312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629698486312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6216\7236\533A\57DF (\5982\679C\9002\7528) \7684 ''\53EA\8BFB'' \6761\4EF6\7684\503C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486544757312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628234409312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5305\542B\7A7A\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486871211312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628577578312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\662F\4EC5\5305\542B\5B57\6BCD\6216\6570\5B57\4E14\4E0D\5305\542B\7279\6B8A\5B57\7B26\7684\5B57\6BCD\6570\5B57\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486057402312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627748473312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486715797312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628480530312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486228072312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627958715312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485900166312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627679781312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486387760312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628044932312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\6216\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486671754312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628315462312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486105048312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627848104312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486456466312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C\4E14\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628176894312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\4E14\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489223946312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\8BA4\201D\4EE5\663E\793A\201C\5411\524D\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489312668312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\5B9A\201D\4EE5\663E\793A\201C\5411\540E\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490828482312718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630698598312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4ECE\4E0D\5448\73B0\7EC4\4EF6\3002</p>'),
unistr('<p>\6CE8: \5C06\6761\4EF6\66F4\6539\4E3A<strong>\4ECE\4E0D</strong>\5C06\5220\9664\6240\6709\73B0\6709\6761\4EF6\3002\8981\4E34\65F6\7981\7528\7EC4\4EF6, Oracle \5EFA\8BAE\6539\7528<em>\6784\5EFA\9009\9879</em>\5C5E\6027\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108489121329312717)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108630183860312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0A\672A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485103871312713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108626800810312824)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487912792312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629494710312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488084215312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629565106312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5C1A\672A\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485360810312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627097486312824)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485501040312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627258525312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485445259312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627104792312824)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485649349312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627307801312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490497080312718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108490556530312718)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488856844312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\9A8C\8BC1 (\4E0D\662F\516C\5171\7528\6237)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629803326312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108488999466312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\662F\516C\5171\7528\6237 (\7528\6237\672A\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108629988812312827)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\672A\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487129275312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628831892312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487241843312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628996747312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108486964186312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628625583312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487033202312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108628741273312826)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485764780312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627465083312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108485822870312714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108627569220312825)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487811310312716)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108487793021312715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239716384312514)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240299681312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E0E\6761\4EF6\8FDB\884C\6BD4\8F83\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108240179530312515)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241688553312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108241561106312516)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373331448312623)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\62A5\8868\533A\57DF\53EF\4EE5\4F7F\7528\6807\51C6\6253\5370\94FE\63A5 (\663E\793A\5728\62A5\8868\533A\57DF\4E0B) \6216\8005\4F7F\7528\6309\94AE\6765\6253\5370\3002\5982\679C\8981\4F7F\7528\6309\94AE, \8BF7\5220\9664\94FE\63A5\6807\7B7E\5E76\5728\9875\4E0A\521B\5EFA\6309\94AE, \4F7F\7528\201C\6253\5370 URL\201D\4E2D\663E\793A\7684 URL \4F5C\4E3A\6309\94AE\76EE\6807\3002</p>'),
unistr('<p>\4F7F\7528\6309\94AE\6253\5370\62A5\8868\533A\57DF\65F6\53EF\4EE5\8BBE\7F6E\4F1A\8BDD\72B6\6001\3002\5982\679C\8BA1\5212\652F\6301\6253\5370\5230\591A\79CD\4E0D\540C\8F93\51FA\683C\5F0F (Word, Excel, PDF \7B49\7B49) \5E76\4E3A\6BCF\4E2A\9009\9879\663E\793A\6309\94AE, \94FE\63A5\6216\56FE\50CF, \5219\6B64\9879\975E\5E38\6709\7528\3002\5BF9\4E8E\6B64\5B9E\65BD, \8BF7\4F7F\7528\4ECE\9879\9009\9879\6D3E\751F\7684\8F93\51FA\683C\5F0F\5E76\5728\6253\5370 URL \4E2D\5305\62EC\9879\540D\548C\503C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602456797312806)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\67E5\770B\6B64\5DF2\4FDD\5B58\62A5\8868\7684 URL \94FE\63A5\3002\53EA\80FD\67E5\770B\6B64\5C5E\6027, \4E0D\80FD\66F4\65B0\3002</p>'),
unistr('    <p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\5FEB\901F\5730\590D\5236\663E\793A\7684 URL\3002\6B64 URL \53EF\7528\4E8E\4ECE\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\4F4D\7F6E\76F4\63A5\94FE\63A5\5230\6B64\7279\5B9A\7684\5DF2\4FDD\5B58\62A5\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373998602312623)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\62A5\8868\533A\57DF\53EF\4EE5\4F7F\7528\6807\51C6\6253\5370\94FE\63A5 (\663E\793A\5728\62A5\8868\533A\57DF\4E0B) \6216\8005\4F7F\7528\6309\94AE\6765\6253\5370\3002\5982\679C\8981\4F7F\7528\6309\94AE, \8BF7\5220\9664\94FE\63A5\6807\7B7E\5E76\5728\9875\4E0A\521B\5EFA\6309\94AE, \4F7F\7528\201C\6253\5370 URL\201D\4E2D\663E\793A\7684 URL \4F5C\4E3A\6309\94AE\76EE\6807\3002</p>'),
unistr('<p>\4F7F\7528\6309\94AE\6253\5370\62A5\8868\533A\57DF\65F6\53EF\4EE5\8BBE\7F6E\4F1A\8BDD\72B6\6001\3002\5982\679C\8BA1\5212\652F\6301\6253\5370\5230\591A\79CD\4E0D\540C\8F93\51FA\683C\5F0F (Word, Excel, PDF \7B49\7B49) \5E76\4E3A\6BCF\4E2A\9009\9879\663E\793A\6309\94AE, \94FE\63A5\6216\56FE\50CF, \5219\6B64\9879\975E\5E38\6709\7528\3002\5BF9\4E8E\6B64\5B9E\65BD, \8BF7\4F7F\7528\4ECE\9879\9009\9879\6D3E\751F\7684\8F93\51FA\683C\5F0F\5E76\5728\6253\5370 URL \4E2D\5305\62EC\9879\540D\548C\503C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242737775312517)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\67E5\770B\6B64\5DF2\4FDD\5B58\62A5\8868\7684 URL \94FE\63A5\3002\53EA\80FD\67E5\770B\6B64\5C5E\6027, \4E0D\80FD\66F4\65B0\3002</p>'),
unistr('<p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\5FEB\901F\5730\590D\5236\663E\793A\7684 URL\3002\6B64 URL \53EF\7528\4E8E\4ECE\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\4F4D\7F6E\76F4\63A5\94FE\63A5\5230\6B64\7279\5B9A\7684\5DF2\4FDD\5B58\62A5\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242691084312517)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231649066312507)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4F9B\94FE\63A5\4F7F\7528\7684 HTML\3002\4F7F\7528\56FE\50CF\6807\8BB0\53EF\4EE5\663E\793A\56FE\50CF, \6216\4ECE\9ED8\8BA4\56FE\50CF\5217\8868\4E2D\9009\53D6\3002\5982\679C\672A\5B9A\4E49, \5219\5C06\4F7F\7528 <code>#IMAGE_PREFIX#ws/small_page.gif</code>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231527801312507)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242336828312516)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5355\51FB\201C\76EE\6807\201D\53EF\8C03\7528\6A21\5F0F\5BF9\8BDD\6846\3002\53EF\4EE5\8F93\5165\5728\5355\51FB\201C\94FE\63A5\5217\201D\65F6\8981\8C03\7528\7684\5B9A\5236\76EE\6807\3002</p>'),
unistr('        <p>\6839\636E\9700\6C42\5728\201C\94FE\63A5\6784\5EFA\5668 - \76EE\6807\201D\4E2D\9009\62E9\5408\9002\7684\7C7B\578B:'),
'        <dl>',
unistr('        <dt>\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875</dt>'),
unistr('        <dd>\8F93\5165\4EE5\4E0B\5185\5BB9:'),
'        <ul>',
unistr('        <li>\9875 - \8F93\5165\8981\5BFC\822A\5230\7684\9875\7801\6216\9875\522B\540D\3002\8FD8\53EF\4EE5\4ECE\9009\62E9\5217\8868\4E2D\9009\62E9\9875\7801\3002</li>'),
unistr('        <li>\8BBE\7F6E\9879: \540D\79F0 - \8F93\5165\6216\9009\62E9\8981\8BBE\7F6E\5230\4F1A\8BDD\72B6\6001\4E2D\7684\9875\9879 (<code>P3_ID</code>), \5E94\7528\7A0B\5E8F\9879 (<code>LAST_PAGE</code>) \6216\4EA4\4E92\5F0F\62A5\8868\8FC7\6EE4\5668 (<code>IR_EMPNO</code>)\3002</li>'),
unistr('        <li>\8BBE\7F6E\9879: \503C - \8F93\5165\6216\9009\62E9\62A5\8868\5217 (<code>#ID#</code>), \8F93\5165\5E94\7528\7A0B\5E8F\6216\9875\9879 (<code>&P2_EMPNO.</code>), \6216\8005\8F93\5165\9759\6001\503C (<code>2</code>)\3002</li>'),
unistr('        <li>\6E05\9664\9AD8\901F\7F13\5B58 - \8F93\5165\8981\6E05\9664\7684\9017\53F7\5206\9694\7684\9875\7801\5217\8868 (<code>2,3</code>), \9879 (<code>P3_EMPNO,LAST_PAGE</code>) \548C\62A5\8868\8BBE\7F6E\3002\8981\91CD\7F6E\62A5\8868\7684\5206\9875, \8BF7\8F93\5165 <code>RP</code>\3002\8981\6E05\9664\6216\91CD\7F6E\4EA4\4E92\5F0F\62A5\8868\8BBE\7F6E, \8BF7\8F93\5165 <code>CIR</code> \6216 <code>RIR</code>\3002</li>'),
unistr('        <li>\91CD\7F6E\5206\9875 - \5BF9\4E8E\76EE\6807\9875\4E0A\7684\62A5\8868, \9009\62E9\201C\662F\201D\53EF\5C06\5206\9875\91CD\7F6E\56DE\7B2C\4E00\7EC4\8BB0\5F55\3002\8FD9\4E0E\5728\201C\6E05\9664\9AD8\901F\7F13\5B58\201D\4E2D\4F20\9012 <code>RP</code> \5177\6709\76F8\540C\6548\679C\3002</li>'),
unistr('        <li>\9AD8\7EA7: \8BF7\6C42 - \8F93\5165\8981\4F7F\7528\7684\8BF7\6C42\3002</li>'),
'        </ul>',
'        </dd>',
unistr('        <dt>\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875</dt>'),
unistr('        <dd>\8F93\5165\4E3A\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875\5217\51FA\7684\76F8\540C\5C5E\6027, \6B64\5916\8FD8\9700\8981\4E3A\5E94\7528\7A0B\5E8F\8F93\5165\5E94\7528\7A0B\5E8F ID \6216\5E94\7528\7A0B\5E8F\522B\540D\3002</dd>'),
'        <dt>URL</dt>',
unistr('        <dd>\8F93\5165 URL</dd>'),
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108242256557312516)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560767071312774)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5355\51FB\5730\56FE\4E0A\7684\5BF9\8C61\65F6\5C06\6267\884C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177426385312464)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5355\51FB\56FE\8868\65F6\5C06\6267\884C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136709277312432)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\7B2C\4E00\5217\8FD4\56DE\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136806995312432)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 SQL \67E5\8BE2\7684\7B2C\4E00\5217\8FD4\56DE\7684\76EE\6807 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177702585312465)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177894956312465)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875\FF0C\4F7F\7528\53EF\9009\7684\9644\52A0\5C5E\6027\5728\76EE\6807\9875\4E0A\91CD\7F6E\9875\7801\FF0C\8BBE\7F6E\8BF7\6C42\503C\FF0C\6E05\9664\9AD8\901F\7F13\5B58\548C\8BBE\7F6E\9879\503C\3002</p>'),
unistr('<p>\6CE8\FF1A\91CD\5B9A\5411\5230\4E0D\540C\5E94\7528\7A0B\5E8F\4E2D\7684\9875\4F9D\8D56\4E8E\76EE\6807\5E94\7528\7A0B\5E8F\4E2D\542F\7528\7684\6DF1\94FE\63A5\3002\8981\542F\7528\6DF1\94FE\63A5\FF0C\8BF7\8F6C\81F3\5E94\7528\7A0B\5E8F\7684<em>\5B89\5168\6027</em>\5C5E\6027\5E76\542F\7528<em>\6DF1\94FE\63A5</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177565061312464)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177660845312465)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\5F53\524D\5E94\7528\7A0B\5E8F\4E2D\7684\9875, \4F7F\7528\53EF\9009\7684\9644\52A0\5C5E\6027\5728\76EE\6807\9875\4E0A\91CD\7F6E\9875\7801, \8BBE\7F6E\8BF7\6C42\503C, \6E05\9664\9AD8\901F\7F13\5B58\548C\8BBE\7F6E\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177929136312465)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178072133312465)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\60A8\6307\5B9A\7684\76EE\6807 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177303259312464)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225931105312503)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\663E\793A\4E3A\94FE\63A5\7684 HTML \6587\672C\3002\4F7F\7528\56FE\50CF\6807\8BB0\53EF\4EE5\663E\793A\56FE\50CF, \6216\8005\4ECE\9ED8\8BA4\56FE\50CF\5217\8868\4E2D\9009\53D6\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225852625312503)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538488738311967)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6A21\677F\53EF\5B9A\4E49\6B64\5217\8868\7684\5916\89C2\548C\5E03\5C40\3002</p>'),
unistr('        <p>\5217\8868\6A21\677F\5728\5E94\7528\7A0B\5E8F\4E3B\9898\4E2D\5B9A\4E49\3002'),
unistr('        \521B\5EFA\5217\8868\533A\57DF\65F6, \6A21\677F\5C06\81EA\52A8\8BBE\7F6E\4E3A\5728\5F53\524D\4E3B\9898\4E2D\5B9A\4E49\7684\9ED8\8BA4\5217\8868\6A21\677F\3002</p>'),
unistr('        <p>\901A\7528\4E3B\9898\63D0\4F9B\4EE5\4E0B\5217\8868\6A21\677F:'),
'          <dl>',
unistr('            <dt>\5FBD\7AE0\5217\8868</dt>'),
unistr('            <dt>\5361</dt>'),
unistr('            <dt>\94FE\63A5\5217\8868</dt>'),
unistr('            <dt>\4ECB\8D28\5217\8868</dt>'),
unistr('            <dt>\83DC\5355\680F</dt>'),
unistr('            <dt>\5F39\51FA\83DC\5355</dt>'),
unistr('            <dt>\5BFC\822A\680F</dt>'),
unistr('            <dt>\5B50\5BFC\822A\83DC\5355</dt>'),
unistr('            <dt>\9009\9879\5361</dt>'),
unistr('            <dt>\9876\90E8\5BFC\822A\83DC\5355</dt>'),
unistr('            <dt>\5411\5BFC\8FDB\5EA6</dt>'),
'          </dl>',
unistr('          \53E6\8BF7\53C2\9605: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538309064311967)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606471113312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606951797312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607078655312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\5217\8868\57FA\4E8E\60A8\8F93\5165\7684 PL/SQL \51FD\6570\4F53\6240\8FD4\56DE\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606727872312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606809828312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\5217\8868\57FA\4E8E\60A8\8F93\5165\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606570483312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606690221312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5217\8868\57FA\4E8E\60A8\8F93\5165\7684\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108606374601312809)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291869867312558)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\65E5\7A0B\67E5\770B\4E2D\663E\793A\7684\603B\5929\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291791491312558)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291942330312558)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291682996312558)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\4E3A\5217\8868\89C6\56FE\663E\793A\7684\5929\6570\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451193917312688)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451268907312688)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\60A8\8F93\5165\7684\5929\6570\663E\793A\65E5\5386\6761\76EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450782868312687)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450835842312687)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\672C\6708\7684\65E5\5386\6761\76EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450915794312687)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451003783312687)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\672C\5E74\7684\65E5\5386\6761\76EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108291589088312558)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041704701312356)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\6237\754C\9762\7684\5E94\7528\7A0B\5E8F\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041612681312356)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986176277312312)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 &PRODUCT_NAME. \5728\6CE8\9500\4E4B\540E\91CD\5B9A\5411\5230\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420246672312660)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420335864312660)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\5E94\7528\7A0B\5E8F\5C5E\6027\4E2D\6307\5B9A\7684\4E3B\9875\94FE\63A5\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420420594312660)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420510926312660)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\60A8\8F93\5165\7684 URL, \4F8B\5982 <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986080305312312)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119266609312418)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\4FDD\62A4\6570\636E\4EE5\9632\4E22\5931\66F4\65B0\3002'),
unistr('		\5F53\4E24\4E2A\6216\66F4\591A\4EBA\5458\5C1D\8BD5\66F4\65B0\540C\4E00\6570\636E\5E76\4E14\6700\540E\7684\66F4\65B0\8986\76D6\7B2C\4E00\4E2A\7528\6237\6240\505A\7684\66F4\65B0\6765\4FDD\5B58\66F4\6539\65F6, \66F4\65B0\4F1A\4E22\5931\3002'),
unistr('		\4E3A\9632\6B62\53D1\751F\8FD9\79CD\60C5\51B5, \66F4\65B0\53EF\68C0\67E5\6570\636E\5E93\4E2D\7684\73B0\6709\5217\503C\548C\6700\521D\67E5\8BE2\8BB0\5F55\65F6\68C0\7D22\5230\7684\76F8\5E94\503C\3002</p>'),
unistr('		<p>\4F8B\5982:'),
'          <ol>',
unistr('            <li>\7528\6237 A \67E5\8BE2\96C7\5458 (EMP) \8BB0\5F55\3002</li>'),
unistr('		    <li>\7528\6237 B \67E5\8BE2\76F8\540C\7684\96C7\5458\8BB0\5F55\3002</li>'),
unistr('		    <li>\7528\6237 B \66F4\65B0 EMPNO = 7839 \7684\96C7\5458\8BE6\7EC6\4FE1\606F\5E76\5411\6570\636E\5E93\5E94\7528 (\63D0\4EA4) \66F4\6539\3002</li>'),
unistr('		    <li>\7528\6237 A \66F4\65B0 EMPNO = 7839 \7684\96C7\5458\8BE6\7EC6\4FE1\606F\5E76\5C1D\8BD5\5411\6570\636E\5E93\5E94\7528\66F4\6539\3002</li>'),
'          </ol>',
unistr('          \5982\679C\7528\6237 A \6210\529F\66F4\65B0\76F8\540C\7684\8BB0\5F55, \5219\7528\6237 B \6240\505A\7684\66F4\6539\5C06\4E22\5931\3002</p>'),
unistr('         <p>\5F53\7528\6237 A \5C1D\8BD5\4FDD\5B58\96C7\5458\8BB0\5F55\65F6, \6570\636E\5E93\4E2D\7684\6570\636E\4E0D\540C\4E8E\7528\6237 A \6700\521D\67E5\8BE2\5230\7684\6570\636E\3002'),
unistr('		  \5728\4E0A\9762\7684\6B65\9AA4 1 \4E2D, \53EF\4EE5\6355\83B7\7528\6237 A \6700\521D\67E5\8BE2\7684\5217\503C\3002'),
unistr('		  \7136\540E\5728\4E0A\9762\7684\6B65\9AA4 4 \4E2D, \8FD9\4E9B\503C\53EF\4E0E\6570\636E\5E93\4E2D\7684\5F53\524D\503C\8FDB\884C\6BD4\8F83\3002'),
unistr('		  \6B64\6BD4\8F83\5C06\5BF9\7528\6237 A \5F15\53D1\9519\8BEF, \56E0\4E3A\6570\636E\5E93\503C\7531\7528\6237 B \5728\6B65\9AA4 3 \4E2D\8FDB\884C\4E86\66F4\65B0\3002'),
unistr('		  \8FD9\53EF\9632\6B62\7528\6237\8986\76D6\5176\4ED6\7528\6237\5BF9\76F8\540C\884C\6240\505A\7684\66F4\6539\3002</p>'),
unistr('		  <p>\6CE8 -\201C\4E22\5931\66F4\65B0\7C7B\578B\201D\53EA\6709\5728\5BF9\5E94\7684\5904\7406\201C\4EA4\4E92\5F0F\7F51\683C - \81EA\52A8\884C\5904\7406 (DML)\201D\542F\7528\4E86<strong>\9632\6B62\4E22\5931\66F4\65B0</strong>\65F6\624D\4F1A\4F7F\7528\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119469761312418)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7248\672C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249257397312522)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\6570\636E\5E93\8868\5305\62EC\4E00\4E2A\6BCF\6B21\66F4\65B0\8BB0\5F55\65F6\9012\589E\7684\5217 (\6700\597D\901A\8FC7\6570\636E\5E93\89E6\53D1\5668), \5219\53EF\4EE5\4F7F\7528\6B64\5217\6765\4EE3\66FF\8BA1\7B97\6821\9A8C\548C\3002'),
unistr('        \5982\679C\4EA4\4E92\5F0F\7F51\683C\66F4\65B0\591A\4E2A\8868\4E2D\7684\6570\636E, \5219\4E0D\5E94\4F7F\7528\6B64\9009\9879\3002</p>'),
unistr('        <p>\6CE8 - \884C\7248\672C\5217\5FC5\987B\5305\62EC\5728\533A\57DF\7684 SQL \6E90\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119364252312418)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108249159034312522)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6700\521D\67E5\8BE2\6570\636E\65F6, \5C06\5BF9\6BCF\4E00\884C\8BA1\7B97\6821\9A8C\548C\503C\3002'),
unistr('        \901A\8FC7\5C06\6240\6709\53EF\66F4\65B0\5217\8FDE\63A5\5230\4E00\4E2A\5B57\7B26\4E32\7136\540E\751F\6210\552F\4E00\503C, \8BA1\7B97\6821\9A8C\548C\3002'),
unistr('        \63D0\4EA4\5DF2\66F4\65B0\7684\8BB0\5F55\65F6, \4F1A\5C06\6B64\6821\9A8C\548C\503C\4E0E\5F53\524D\6570\636E\5E93\8BB0\5F55\7684\6821\9A8C\548C\503C\8FDB\884C\6BD4\8F83\3002'),
unistr('        \5982\679C\5B83\4EEC\4E0D\76F8\540C, \5219\5C06\5F15\53D1\9519\8BEF\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119137709312418)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E22\5931\66F4\65B0\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658574404312849)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658823486312849)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658719295312849)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658662436312849)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658914096312849)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108658488367312849)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659705961312850)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\62EC SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659641595312850)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659547381312849)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\90E8\95E8\540D\79F0\FF0C\8BBE\7F6E\90E8\95E8\7F16\53F7</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659437389312849)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\62EC SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659322802312849)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254900939312527)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\503C\5217\8868\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254869219312527)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984033403312310)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5F53\6B64\9875\4E0A\7684\4EFB\4F55\6307\5B9A\7EA7\8054 LOV \7236\9879\503C\53D1\751F\66F4\6539\65F6\5C06\8BBE\7F6E\5230\4F1A\8BDD\72B6\6001\7684\5217, \9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\8005\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002</p>'),
unistr('<p>\5E94\4F7F\7528\5728\6B64\5C5E\6027 (\4F4D\4E8E\6B64\503C\5217\8868 SQL \67E5\8BE2\7684 <em>Where \5B50\53E5</em>\5185) \4E2D\6307\5B9A\7684\9875\9879\9650\5236\8FD4\56DE\503C\3002</p>'),
unistr('<p>\6CE8: \5728<em>\7EA7\8054 LOV \7236\9879</em>\4E2D\5B9A\4E49\7684\9875\9879\4F1A\81EA\52A8\4F20\8F93, \65E0\9700\8F93\5165\5230\6B64\5C5E\6027\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983956574312310)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\63D0\4EA4\7684\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659221782312849)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\90E8\95E8\540D\79F0, \8BBE\7F6E\90E8\95E8\7F16\53F7</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659103922312849)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38, \503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\62EC SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659040055312849)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659991869312850)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\62EC SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108659827352312850)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722735577312899)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\542B SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>'),
unistr('<p>\6CE8\FF1A\5B9A\4E49\5F39\51FA\5F0F LOV \9879\7C7B\578B\65F6\FF0C\5982\679C\8981\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\591A\4E2A\5217\FF0C\5219\5FC5\987B\6539\4E3A\5728\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\503C\5217\8868\FF0C'),
unistr('\5E76\63D0\4F9B\6240\9700\7684\5176\4ED6\5143\6570\636E\3002\5185\5D4C\503C\5217\8868\53EA\80FD\7528\4E8E\5728\5F39\51FA\5F0F LOV \4E2D\663E\793A\5355\4E2A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578543870312787)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\542B SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>'),
unistr('<p>\6CE8\FF1A\5B9A\4E49\5F39\51FA\5F0F LOV \9879\7C7B\578B\65F6\FF0C\5982\679C\8981\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\591A\4E2A\5217\FF0C\5219\5FC5\987B\6539\4E3A\5728\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\503C\5217\8868\FF0C'),
unistr('\5E76\63D0\4F9B\6240\9700\7684\5176\4ED6\5143\6570\636E\3002\5185\5D4C\503C\5217\8868\53EA\80FD\7528\4E8E\5728\5F39\51FA\5F0F LOV \4E2D\663E\793A\5355\4E2A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738796399312911)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\542B SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>'),
unistr('<p>\6CE8\FF1A\5B9A\4E49\5F39\51FA\5F0F LOV \9879\7C7B\578B\65F6\FF0C\5982\679C\8981\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\591A\4E2A\5217\FF0C\5219\5FC5\987B\6539\4E3A\5728\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\503C\5217\8868\FF0C'),
unistr('\5E76\63D0\4F9B\6240\9700\7684\5176\4ED6\5143\6570\636E\3002\5185\5D4C\503C\5217\8868\53EA\80FD\7528\4E8E\5728\5F39\51FA\5F0F LOV \4E2D\663E\793A\5355\4E2A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108722665561312898)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\542B SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>'),
unistr('<p>\6CE8\FF1A\5B9A\4E49\5F39\51FA\5F0F LOV \9879\7C7B\578B\65F6\FF0C\5982\679C\8981\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\591A\4E2A\5217\FF0C\5219\5FC5\987B\6539\4E3A\5728\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\503C\5217\8868\FF0C'),
unistr('\5E76\63D0\4F9B\6240\9700\7684\5176\4ED6\5143\6570\636E\3002\5185\5D4C\503C\5217\8868\53EA\80FD\7528\4E8E\5728\5F39\51FA\5F0F LOV \4E2D\663E\793A\5355\4E2A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941681944312278)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\542B SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>'),
unistr('<p>\6CE8\FF1A\5B9A\4E49\5F39\51FA\5F0F LOV \9879\7C7B\578B\65F6\FF0C\5982\679C\8981\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\591A\4E2A\5217\FF0C\5219\5FC5\987B\6539\4E3A\5728\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\503C\5217\8868\FF0C'),
unistr('\5E76\63D0\4F9B\6240\9700\7684\5176\4ED6\5143\6570\636E\3002\5185\5D4C\503C\5217\8868\53EA\80FD\7528\4E8E\5728\5F39\51FA\5F0F LOV \4E2D\663E\793A\5355\4E2A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942984623312279)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38\FF0C\503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B\FF1A</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\542B SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>'),
unistr('<p>\6CE8\FF1A\5B9A\4E49\5F39\51FA\5F0F LOV \9879\7C7B\578B\65F6\FF0C\5982\679C\8981\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\591A\4E2A\5217\FF0C\5219\5FC5\987B\6539\4E3A\5728\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\503C\5217\8868\FF0C'),
unistr('\5E76\63D0\4F9B\6240\9700\7684\5176\4ED6\5143\6570\636E\3002\5185\5D4C\503C\5217\8868\53EA\80FD\7528\4E8E\5728\5F39\51FA\5F0F LOV \4E2D\663E\793A\5355\4E2A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108494094489312720)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\90E8\95E8\540D\79F0, \8BBE\7F6E\90E8\95E8\7F16\53F7</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245037504312519)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 SQL \67E5\8BE2\5B9A\4E49\6765\586B\5145\6B64\503C\5217\8868\3002\901A\5E38, \503C\5217\8868\67E5\8BE2\7684\5F62\5F0F\5982\4E0B:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>\9009\5B9A\7684\6BCF\4E00\5217\5FC5\987B\5177\6709\552F\4E00\7684\540D\79F0\6216\522B\540D\3002Oracle \5EFA\8BAE\5728\5305\62EC SQL \8868\8FBE\5F0F\7684\4EFB\4F55\5217\4E0A\4F7F\7528\522B\540D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108244943200312519)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245468078312519)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9759\6001\503C\5217\8868\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245310256312519)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245250000312519)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\503C\5217\8868\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631699360312828)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631750757312828)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\503C\5217\8868\57FA\4E8E\60A8\8F93\5165\7684\51FD\6570\4F53\6240\8FD4\56DE\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117034405312417)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117170678312417)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\57FA\4E8E\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\5B9A\4E49\7684\9884\5B9A\4E49\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117211241312417)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117393905312417)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\503C\5217\8868\57FA\4E8E\60A8\8F93\5165\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433860052312674)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433930201312674)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C\5217\8868\57FA\4E8E\60A8\8F93\5165\7684\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245179072312519)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913550640312257)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\7EF4\62A4\4F1A\8BDD\72B6\6001\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871096201312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\8BF7\6C42\FF08\4EC5\5185\5B58\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871106875312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\6570\636E\5E93\4E2D\4FDD\5B58\72B6\6001\3002\72B6\6001\4EC5\5728\5904\7406\5F53\524D\8BF7\6C42\65F6\53EF\7528\3002\5F53 AJAX \8BF7\6C42\9700\8981\4F7F\7528\67D0\9879\65F6\FF0C\8BF7\786E\4FDD\901A\8FC7\201C\8981\63D0\4EA4\7684\9875\9879\201D\6765\4F20\9012\8BE5\9879\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415938148312657)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\7528\6237\FF08\78C1\76D8\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710440392312889)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\6BCF\4E2A\7528\6237\7684\503C\FF0C\5C06\503C\5B58\50A8\5728\6570\636E\5E93\4E2D\FF0C\4EE5\4FBF\4E0D\540C\4F1A\8BDD\8BBF\95EE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415879959312657)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\4F1A\8BDD\FF08\78C1\76D8\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710316633312889)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\6BCF\4E2A\4F1A\8BDD\7684\503C\FF0C\5C06\503C\5B58\50A8\5728\6570\636E\5E93\4E2D\FF0C\4EE5\4FBF\4E0D\540C\8BF7\6C42\8BBF\95EE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913414012312256)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\4F1A\8BDD\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871301282312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\7EF4\62A4\4F1A\8BDD\72B6\6001\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871402075312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\8BF7\6C42\FF08\4EC5\5185\5B58\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871586762312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\6570\636E\5E93\4E2D\4FDD\5B58\72B6\6001\3002\72B6\6001\4EC5\5728\5904\7406\5F53\524D\8BF7\6C42\65F6\53EF\7528\3002\5F53 AJAX \8BF7\6C42\9700\8981\4F7F\7528\67D0\9879\65F6\FF0C\8BF7\786E\4FDD\901A\8FC7\201C\8981\63D0\4EA4\7684\9875\9879\201D\6765\4F20\9012\8BE5\9879\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871615668312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\4F1A\8BDD\FF08\78C1\76D8\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871731390312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\6BCF\4E2A\4F1A\8BDD\7684\503C\FF0C\5C06\503C\5B58\50A8\5728\6570\636E\5E93\4E2D\FF0C\4EE5\4FBF\4E0D\540C\8BF7\6C42\8BBF\95EE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107871258104312224)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EF4\62A4\4F1A\8BDD\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188303960312473)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\662F\5426\5448\73B0\4E3B\523B\5EA6\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188491450312473)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188696824312473)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188548415312473)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188263653312473)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533480463312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533318393312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7528\4E8E\663E\793A\70B9\7C07\7684\586B\5145\989C\8272\3002'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533285858312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532605769312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\663E\793A\70B9\7C07\7684\56FE\6807 CSS \7C7B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532544625312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532445415312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\663E\793A\70B9\7C07\7684\56FE\50CF\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532387099312751)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532878469312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\663E\793A\70B9\7C07\7684 SVG \5F62\72B6\3002\4ECE\9884\5B9A\4E49\7684\5F62\72B6\4E2D\9009\62E9\FF0C\6216\8005\8F93\5165\5728<strong>\5B9A\5236 SVG \6837\5F0F</strong>\5730\56FE\533A\57DF\5C5E\6027\4E2D\6307\5B9A\7684<em>\5B9A\5236 SVG \5F62\72B6</em>\7684\540D\79F0\3002\5982\679C\6307\5B9A\7684\540D\79F0\4E0D\5728\9ED8\8BA4\6216\5B9A\5236 SVG \6837\5F0F\7684\5217\8868\4E2D\FF0C\5219\5C06\4F7F\7528<strong>\9ED8\8BA4\6807\8BB0</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566330221312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F8\673A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574180845312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570930707312781)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575441262312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566420435312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574381359312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533001487312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574275602312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566229418312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574012089312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566558831312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76B1\7709\8138')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574409396312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566621368312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\8DA3\8138')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574577428312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566788929312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B11\8138')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574645076312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571400465312782)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E09\89D2\65D7\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575969823312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571529158312782)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\71D5\5C3E\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576012834312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567117307312779)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC3\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575173312312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571070310312781)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575598346312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567263793312779)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E94\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575216810312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566982086312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574965512312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567043408312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575056475312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571279922312781)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\5149')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575758821312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571174890312781)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\6760')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575602894312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566894431312778)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574884859312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532906661312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108574763494312784)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571313373312782)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8857\666F\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575840366312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533169542312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108575352436312785)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532701095312752)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F62\72B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567442616312779)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\663E\793A\70B9\7C07\7684 SVG \5F62\72B6\7684\7F29\653E\56E0\5B50\3002\6700\5927\6BD4\4F8B\4E3A <strong>10</strong>\FF0C\5E76\4E14\5730\56FE\7EC4\4EF6\4F1A\5C06\503C\820D\5165\5230\7B2C\4E00\4E2A\5C0F\6570\4F4D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108567339391312779)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F62\72B6\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536666229312755)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7C07\534A\5F84\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002\5982\679C\6307\5B9A\503C <strong>80</strong>\FF0C\5219\76F8\4E92\95F4\8DDD\79BB\5728 80 \4E2A\50CF\7D20\5185\7684\70B9\5C06'),
unistr('\805A\96C6\4E3A\70B9\7C07\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536587454312755)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\7C07\534A\5F84')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536778691312755)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557483033312771)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\5149\6807\60AC\505C\5728\5730\56FE\4E0A\7684\7C07\6807\8BB0\4E0A\65B9\65F6\5C06\663E\793A\4E3A\5DE5\5177\63D0\793A\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <strong>&LAYER.</strong> \548C <strong>&COUNT.</strong> \5360\4F4D\7B26\53EF\4EE5\5F15\7528\5C42\540D\548C\7C07\4E2D\5730\56FE\5BF9\8C61\7684\6570\91CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557396995312771)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\5177\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522935150312744)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\5C06\653E\7F6E\4E8E\5730\56FE\9875\811A\7684\7248\6743\58F0\660E\3002\5982\679C\4E3A\7A7A\FF0C\5C06\751F\6210\5DF2\4F7F\7528\80CC\666F\5730\56FE\7684\7248\6743\58F0\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522803875312744)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7248\6743\58F0\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524662130312745)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524537532312745)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\53EF\7528\4F5C\5730\56FE\6807\8BB0\7684\5B9A\5236 SVG \5F62\72B6\63D0\4F9B\5B9A\4E49\3002\6B64\5904\5B9A\4E49\7684\6837\5F0F\53EF\4EE5\7528\4F5C\70B9\5C42\4E2D\7684 <strong>SVG \5F62\72B6</strong>\5C5E\6027\3002</p>'),
unistr('<p>SVG \5F62\72B6\7684\5BBD\5EA6\548C\9AD8\5EA6\5FC5\987B\4E3A <strong>20</strong>\3002\6807\8BB0\5C06\653E\7F6E\5728\5730\56FE\4E0A\FF0C\4EE5\4FBF\5F62\72B6\5E95\90E8\7684\4E2D\5FC3\FF08SVG \5750\6807 <strong>10</strong>\3001<strong>20</strong>\FF09\6307\5411\5730\56FE\5BF9\8C61\3002</p>'),
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">SVG \6807\8BB0\7684\5BBD\5EA6\548C\9AD8\5EA6\4E3A 20\FF0C\5E76\4E14\6307\5411\4F4D\4E8E\4F4D\7F6E x=10 \548C y=20 \7684\5730\56FE\4F4D\7F6E\3002</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524499902312745)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236 SVG \6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555180884312770)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\503C\7684\5217\FF0C\4EE5\786E\5B9A\6324\538B\591A\8FB9\5F62\7684\9AD8\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555062133312769)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\90E8\5206\503C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556801300312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5355\4F4D\FF0C\4EE5\786E\5B9A\6324\538B\591A\8FB9\5F62\7684\9AD8\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557168430312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\82F1\5C3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557051800312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\91CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556962796312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557247933312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\82F1\91CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556751357312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529352424312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529271605312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\586B\5145\989C\8272\3002'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529135801312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538188875312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\4E3A\6B64\5C42\4F7F\7528<em>\989C\8272\65B9\6848</em>\3002\989C\8272\65B9\6848\662F\989C\8272\5217\8868\3002\5730\56FE\5C0F\90E8\4EF6\57FA\4E8E\503C\4EE5\53CA\6700\5C0F\503C\548C\6700\5927\503C\FF0C\4ECE\5217\8868\4E2D\4E3A\6B64\5BF9\8C61\9009\53D6\5B9E\9645\663E\793A\989C\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538005851312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\989C\8272\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690977444312874)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\4ECE\7EA2\8272\5230\767D\8272\7684\989C\8272\5217\8868</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\4ECE\84DD\8272\5230\9ED1\8272\7684\989C\8272\5217\8868</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538326857312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\5C42\7684\5B9A\5236<em>\989C\8272\65B9\6848</em>\3002\989C\8272\65B9\6848\662F\989C\8272\5217\8868\3002\5730\56FE\5C0F\90E8\4EF6\57FA\4E8E\503C\4EE5\53CA\6700\5C0F\503C\548C\6700\5927\503C\FF0C\4ECE\5217\8868\4E2D\4E3A\6B64\5BF9\8C61\9009\53D6\5B9E\9645\663E\793A\989C\8272\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538234070312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\989C\8272\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538563821312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\503C\7684\5217\FF0C\4EE5\4FBF\6839\636E\65B9\6848\786E\5B9A\663E\793A\989C\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538496102312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272\503C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529527806312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\586B\5145\4E0D\900F\660E\5EA6\3002\8303\56F4\4E3A\96F6\FF08\5B8C\5168\900F\660E\FF09\5230 1.0\FF08\4E0D\900F\660E\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529418763312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\4E0D\900F\660E\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538727759312757)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FD4\56DE\503C\7684\5217\FF0C\4EE5\4FBF\6839\636E\65B9\6848\786E\5B9A\663E\793A\989C\8272\3002\5982\679C\672A\9009\62E9\5217\FF0C\5C06\4EC5\6839\636E\70B9\5BC6\5EA6\786E\5B9A\663E\793A\989C\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538699076312756)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534525157312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\4FE1\606F\7A97\53E3\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002\5F53\5355\51FB\5730\56FE\4E0A\7684\5BF9\8C61\65F6\FF0C\4FE1\606F\7A97\53E3\5C06\663E\793A\4E3A\5F39\51FA\7A97\53E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534470908312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534994679312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\4FE1\606F\7A97\53E3\6B63\6587\7684\5217\3002\5F53\5355\51FB\5730\56FE\4E0A\7684\5BF9\8C61\65F6\FF0C\4FE1\606F\7A97\53E3\5C06\663E\793A\4E3A\5F39\51FA\5F0F\7A97\53E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534803337312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535490227312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\5448\73B0\4FE1\606F\5F39\51FA\5F0F\7A97\53E3\65F6\4F7F\7528\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535343821312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535202217312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535182285312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\5355\51FB\7A7A\95F4\5BF9\8C61\65F6\5C06\663E\793A\4E3A\4FE1\606F\5F39\51FA\5F0F\7A97\53E3\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535029064312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534743208312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\4FE1\606F\7A97\53E3\6807\9898\7684\5217\3002\5F53\5355\51FB\5730\56FE\4E0A\7684\5BF9\8C61\65F6\FF0C\4FE1\606F\7A97\53E3\5C06\663E\793A\4E3A\5F39\51FA\5F0F\7A97\53E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534674219312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558383411312772)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\5728\56FE\4F8B\6216\5DE5\5177\63D0\793A\4E2D\663E\793A\7684\6807\7B7E\3002\5982\679C\672A\6307\5B9A\FF0C\5219\5C06\4F7F\7528<strong>\540D\79F0</strong>\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558145772312772)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5728\56FE\4F8B\548C\5DE5\5177\63D0\793A\4E2D\7528\4E8E\6B64\5C42\7684\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558088075312772)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557939283312772)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557800772312772)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\6807\8BB0\586B\5145\989C\8272\3002'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557783538312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557667620312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\586B\5145\4E0D\900F\660E\5EA6\3002\8303\56F4\4E3A\96F6\FF08\5B8C\5168\900F\660E\FF09\5230 1.0\FF08\4E0D\900F\660E\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108557511801312771)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\4E0D\900F\660E\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555479802312770)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555355433312770)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7B14\5212\989C\8272\3002'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555213032312770)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B14\5212\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555690775312770)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7B14\5212\5BBD\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555555886312770)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B14\5212\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535645863312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5C06\533A\57DF\6E90\4E2D\7684\884C\5206\914D\7ED9\6B64\5C42\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535544356312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535800082312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B<strong>\884C\5206\914D\5217</strong><em>\503C</em>\FF0C\7528\4E8E\5C06\533A\57DF\6E90\4E2D\7684\884C\5206\914D\7ED9\6B64\5C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535755734312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5C42\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528822125312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528701819312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\7B14\5212\989C\8272\3002'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22\201CHTML \989C\8272\4EE3\7801\201D\4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528615437312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B14\5212\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536078172312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7B14\5212\6837\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536343190312755)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\865A\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536256146312755)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536450976312755)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\5212\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536180444312755)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108535967482312754)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B14\5212\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529050277312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7B14\5212\5BBD\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528943532312749)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B14\5212\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533638269312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5DE5\5177\63D0\793A\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002\5C06\9F20\6807\60AC\505C\5728\5730\56FE\4E0A\5BF9\8C61\7684\4E0A\65B9\65F6\FF0C\5C06\663E\793A\5DE5\5177\63D0\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533519952312752)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533819138312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\5DE5\5177\63D0\793A\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533721489312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534399721312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\5448\73B0\5DE5\5177\63D0\793A\65F6\4F7F\7528\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534265758312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534188600312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108534083043312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\5149\6807\60AC\505C\5728\5730\56FE\4E0A\7684\5BF9\8C61\4E0A\65B9\65F6\5C06\663E\793A\4E3A\5DE5\5177\63D0\793A\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108533986959312753)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527908388312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\8981\5728\5730\56FE\4E0A\663E\793A\7684 GeoJSON \5BF9\8C61\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527840888312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GeoJSON \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528145812312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SDO_GEOMETRY \5217\FF0C\8FD4\56DE\8981\5728\5730\56FE\4E0A\663E\793A\7684\51E0\4F55\7ED3\6784\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528083900312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51E0\4F55\7ED3\6784\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526508379312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\51E0\4F55\7ED3\6784\5217\7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526823752312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526930333312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GeoJSON\FF0C\4F5C\4E3A VARCHAR2 \6216 CLOB \7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527064744312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6/\7EAC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527167129312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6\548C\7EAC\5EA6\FF0C\4F5C\4E3A\4E24\4E2A NUMBER \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526611429312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526717600312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle SDO_GEOMETRY \7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526407066312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51E0\4F55\7ED3\6784\5217\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527360511312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\51E0\4F55\7ED3\6784\5217\7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527430583312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527559715312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GeoJSON\FF0C\4F5C\4E3A VARCHAR2 \6216 CLOB \7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527699076312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6/\7EAC\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527759821312748)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6\548C\7EAC\5EA6\FF0C\4F5C\4E3A\4E24\4E2A NUMBER \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108527252247312747)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51E0\4F55\7ED3\6784\5217\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526325228312747)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\4ECE\6570\636E\5E93\63D0\53D6\884C\65F6\FF0C\57FA\7840\8868\5177\6709\7A7A\95F4\7D22\5F15\FF0C\5E76\4E14\5730\56FE\5C0F\90E8\4EF6\5E94\8BE5\4F7F\7528\5B83\FF0C\5219\542F\7528\6B64\5F00\5173\3002\5728\8FD9\79CD\60C5\51B5\4E0B\FF0C\8BE5\5C0F\90E8\4EF6\5C06<em>\4EC5</em>\4ECE\6570\636E\5E93\4E2D\63D0\53D6\5F53\524D\5730\56FE\7A97\53E3\7684\884C\3002\5F53\6570\636E\6E90\5305\542B\5927\91CF\884C\65F6\FF0C\8FD9\4F1A\5E26\6765\6027\80FD\4F18\52BF\3002</p><p>\53EF\4EE5\5728 SQL \5DE5\4F5C\5BA4\7684 SDO_GEOMETRY \5217\4E0A\521B\5EFA\7A7A\95F4\7D22\5F15\3002</p>'),
unistr('<p>\8BF7\6CE8\610F\FF0C\5728\4EE5\4E0B\60C5\51B5\4E0B<em>\4E0D</em>\4F1A\4F7F\7528\7A7A\95F4\7D22\5F15\FF1A</p>'),
'<ul>',
unistr('<li>\591A\4E2A\5C42\5F15\7528<strong>\533A\57DF\6E90</strong>\4F5C\4E3A\5176\6570\636E\6E90\3002</li>'),
unistr('<li>\5730\56FE\7A97\53E3\592A\5927\FF1B\5982\8DE8\8D8A\5927\534A\4E2A\4E16\754C\65F6\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526298474312747)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\7A7A\95F4\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528578554312748)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('NUMBER \5217\FF0C\5305\542B\8981\5728\5730\56FE\4E0A\663E\793A\7684\7A7A\95F4\5BF9\8C61\7684\7EAC\5EA6\3002\8FD4\56DE\7684\503C\5E94\8BE5\4ECB\4E8E -90 \548C 90 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528422915312748)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAC\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544179482312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\4E2D\4E00\79CD\9884\5B9A\4E49\7684\79BB\6563\989C\8272\65B9\6848\3002\5B83\4EEC\9002\5408\4E8E\53EF\89C6\5316\4ECE\4E00\4E2A\6781\503C\5230\53E6\4E00\4E2A\6781\503C\7684\79BB\6563\503C\3002\989C\8272\65B9\6848\6765\81EA cartcolor\FF08<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544288514312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\519B\8272\201D\5230\73AB\7470\7EA2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544344852312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545482927312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5730\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545591533312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544476577312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79CB\5929\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544520528312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544655437312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\55B7\6CC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544749895312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545061676312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272\5230\73AB\7470\7EA2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545101309312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544858505312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E29\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544958158312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545211266312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70ED\5E26\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545315755312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108544072198312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545796257312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\4E2D\4E00\79CD\9884\5B9A\4E49\7684\5B9A\6027\989C\8272\65B9\6848\3002\5B83\4EEC\9002\5408\4E8E\53EF\89C6\5316\4E0D\540C\503C\3002\989C\8272\65B9\6848\6765\81EA cartcolor\FF08<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545819777312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53E4\65E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545915935312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546045959312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546104506312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546267380312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D45\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546312602312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546446654312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68F1\955C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546501395312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546661386312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546799355312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546839514312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9C9C\8273')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108546963602312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108545686445312762)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540153785312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\4E2D\4E00\79CD\9884\5B9A\4E49\7684\8FDE\7EED\989C\8272\65B9\6848\3002\5B83\4EEC\9002\5408\4E8E\53EF\89C6\5316\4ECE\4F4E\503C\5230\9AD8\503C\7684\8FDE\7EED\503C\3002\989C\8272\65B9\6848\6765\81EA cartcolor\FF08<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541645659312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272\5230\7EFF\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541749663312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542242744312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542345314312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543872203312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68D5\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543901263312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540292966312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9152\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540381008312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540419383312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9152\7EA2\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540515707312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541852613312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6697\8584\8377\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541928471312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542006417312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7956\6BCD\7EFF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542118596312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543460151312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D0B\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543545673312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541444247312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8584\8377\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541514752312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540880152312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A59\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540990865312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541024564312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6843\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541186486312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541201280312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C89\7EA2\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108541383920312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542838282312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D2B\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542953393312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543018592312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D2B\8272\5230\6A59\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543115610312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540609484312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA2\8272\5230\6A59\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540719879312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543205203312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\843D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543366574312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543663323312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6697\65E5\843D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108543750833312761)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542470355312759)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542555522312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542682595312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272\5230\7EFF\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108542761733312760)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108540002724312758)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558799143312772)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558883057312772)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A HTML \989C\8272\5217\8868 (#rrggbb)\FF0C\4EE5\9017\53F7\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539387759312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\989C\8272\65B9\6848\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539615798312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79BB\6563')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539716651312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\989C\8272\65B9\6848\9002\5408\4E8E\53EF\89C6\5316\4ECE\4E00\4E2A\6781\503C\5230\53E6\4E00\4E2A\6781\503C\7684\79BB\6563\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539890196312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539937888312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\989C\8272\65B9\6848\9002\5408\4E8E\53EF\89C6\5316\4E0D\540C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539448636312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDE\7EED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539507283312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\989C\8272\65B9\6848\9002\5408\4E8E\53EF\89C6\5316\4ECE\4F4E\503C\5230\9AD8\503C\7684\8FDE\7EED\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539288085312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691333972312874)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\4ECE\7EA2\8272\5230\767D\8272\7684\989C\8272\5217\8868</dt>'),
unistr('    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>\4ECE\84DD\8272\5230\9ED1\8272\7684\989C\8272\5217\8868</dt>'),
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554949848312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\70ED\56FE\5C42\7684\5B9A\5236<em>\989C\8272\65B9\6848</em>\3002\989C\8272\65B9\6848\662F\989C\8272\5217\8868\3002\5730\56FE\5C0F\90E8\4EF6\57FA\4E8E\503C\4EE5\53CA\6700\5C0F\503C\548C\6700\5927\503C\FF0C\4ECE\5217\8868\4E2D\4E3A\6B64\5BF9\8C61\9009\53D6\5B9E\9645\663E\793A\989C\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554841875312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\989C\8272\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551994646312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\4E2D\4E00\79CD\9884\5B9A\4E49\7684\79BB\6563\989C\8272\65B9\6848\3002\5B83\4EEC\9002\5408\4E8E\53EF\89C6\5316\4ECE\4E00\4E2A\6781\503C\5230\53E6\4E00\4E2A\6781\503C\7684\79BB\6563\503C\3002\989C\8272\65B9\6848\6765\81EA cartcolor\FF08<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552033039312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\519B\8272\201D\5230\73AB\7470\7EA2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552187550312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553296552312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5730\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553349877312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552216712312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79CB\5929\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552343392312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552461258312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\55B7\6CC9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552577886312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552820356312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272\5230\73AB\7470\7EA2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552953249312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552695018312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E29\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108552770491312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553078739312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70ED\5E26\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553100439312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551866853312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553573721312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\4E2D\4E00\79CD\9884\5B9A\4E49\7684\5B9A\6027\989C\8272\65B9\6848\3002\5B83\4EEC\9002\5408\4E8E\53EF\89C6\5316\4E0D\540C\503C\3002\989C\8272\65B9\6848\6765\81EA cartcolor\FF08<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553605192312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53E4\65E7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553799762312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553846128312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553933009312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554066176312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D45\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554178693312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554249967312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68F1\955C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554357784312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554414576312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554511678312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554690383312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9C9C\8273')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108554727918312769)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108553448087312768)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547997897312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\4E2D\4E00\79CD\9884\5B9A\4E49\7684\8FDE\7EED\989C\8272\65B9\6848\3002\5B83\4EEC\9002\5408\4E8E\53EF\89C6\5316\4ECE\4F4E\503C\5230\9AD8\503C\7684\8FDE\7EED\503C\3002\989C\8272\65B9\6848\6765\81EA cartcolor\FF08<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">GitHub \4E0A\7684 CARTOcolor</a>\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549478669312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272\5230\7EFF\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549589655312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550082657312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550196396312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551692548312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68D5\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551730158312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548069276312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9152\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548142278312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548244639312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9152\7EA2\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548342097312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549666757312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6697\8584\8377\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549791351312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549849751312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7956\6BCD\7EFF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549938539312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551258399312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D0B\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551384677312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549212606312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8584\8377\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549333306312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548688393312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A59\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548705320312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548826470312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6843\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548985835312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549064505312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C89\7EA2\8272\5230\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108549118099312765)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550645821312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D2B\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550790061312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550891799312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D2B\8272\5230\6A59\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550912383312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548498908312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA2\8272\5230\6A59\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108548541269312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551019567312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\843D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551186563312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551417652312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6697\65E5\843D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108551514760312767)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550271473312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550371311312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550456816312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272\5230\7EFF\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108550531623312766)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547886802312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558925816312772)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559009455312772)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A HTML \989C\8272\5217\8868 (#rrggbb)\FF0C\4EE5\9017\53F7\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547104382312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\989C\8272\65B9\6848\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547423082312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79BB\6563')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547549650312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\989C\8272\65B9\6848\9002\5408\4E8E\53EF\89C6\5316\4ECE\4E00\4E2A\6781\503C\5230\53E6\4E00\4E2A\6781\503C\7684\79BB\6563\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547672247312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547778899312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\989C\8272\65B9\6848\9002\5408\4E8E\53EF\89C6\5316\4E0D\540C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547292430312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDE\7EED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547398442312764)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\989C\8272\65B9\6848\9002\5408\4E8E\53EF\89C6\5316\4ECE\4F4E\503C\5230\9AD8\503C\7684\8FDE\7EED\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108547084594312763)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536992180312755)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\6B64\5C42\7684\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537624696312756)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70ED\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537732300312756)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\5BF9\8C61\FF0C\663E\793A\4E3A\70ED\56FE\3002\70ED\56FE\53EF\7528\4E8E\53EF\89C6\5316\70B9\5BF9\8C61\7684\5BC6\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537248030312755)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537331181312755)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537058596312755)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537194032312755)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537473246312756)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\8FB9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537525868312756)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\8FB9\5F62\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537871604312756)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6324\538B\591A\8FB9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108537927109312756)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\6324\538B\201D\591A\8FB9\5F62\FF0C\663E\793A\4E3A 3D \5BF9\8C61\3002\9AD8\5EA6\57FA\4E8E\7ED3\679C\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108536877016312755)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C42\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539149696312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\5C42\4FDD\6301\53EF\89C1\7684\6700\5927\7F29\653E\7EA7\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108539051560312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538937740312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\5C42\53D8\4E3A\53EF\89C1\7684\6700\5C0F\7F29\653E\7EA7\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108538819374312757)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528368768312748)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('NUMBER \5217\FF0C\5305\542B\8981\5728\5730\56FE\4E0A\663E\793A\7684\7A7A\95F4\5BF9\8C61\7684\7ECF\5EA6\3002\8FD4\56DE\7684\503C\5E94\8BE5\4ECB\4E8E -180 \548C 180 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108528281474312748)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532288741312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\5BF9\5730\56FE\4E0A\540C\4E00\4F4D\7F6E\7684\70B9\8FDB\884C\805A\7C07\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532134475312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529787795312749)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6\5982\4F55\663E\793A\70B9\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530086844312750)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530165985312750)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E3A\56FE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529825869312749)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529966360312750)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E3A SVG \5F62\72B6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108529608984312749)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531732645312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7528\4E8E\663E\793A\70B9\5BF9\8C61\7684 SVG \5F62\72B6\3002\4ECE\9884\5B9A\4E49\7684\5F62\72B6\4E2D\9009\62E9\FF0C\6216\8005\8F93\5165\5728<strong>\5B9A\5236 SVG \6837\5F0F</strong>\5730\56FE\533A\57DF\5C5E\6027\4E2D\6307\5B9A\7684<em>\5B9A\5236 SVG \5F62\72B6</em>\7684\540D\79F0\3002\5982\679C\672A\6307\5B9A\540D\79F0\FF0C\6216\8005\6307\5B9A\7684\540D\79F0\4E0D\5728\9ED8\8BA4\6216\5B9A\5236 SVG \5F62\72B6\7684\5217\8868\4E2D\FF0C\5219\5C06\4F7F\7528<strong>\9ED8\8BA4</strong>\5F62\72B6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565008935312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F8\673A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572022900312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570219086312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573302976312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565177575312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572227925312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531937000312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572145623312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108564934516312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108571920823312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565292233312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76B1\7709\8138')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572363236312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565349399312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\8DA3\8138')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572482301312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565432334312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B11\8138')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572560048312782)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570714886312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E09\89D2\65D7\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573815983312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570869599312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\71D5\5C3E\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573926341312784)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565816830312778)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC3\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573091060312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570383443312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573465454312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565983091312778)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E94\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573171042312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565650851312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572872869312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565713935312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572970387312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570599044312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\5149')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573611470312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570444441312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\6760')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573593122312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108565535172312777)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572710496312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531852236312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108572675715312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570618607312781)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8857\666F\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573726841312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108532059561312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E09\89D2\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108573222229312783)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531629891312751)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F62\72B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566127587312778)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A SVG \5F62\72B6\7684\7F29\653E\56E0\5B50\3002\6700\5927\6BD4\4F8B\4E3A <strong>10</strong>\3002\5982\679C\4F7F\7528\5217\66FF\6362\FF0C\5E76\4E14\503C\5927\4E8E <strong>10</strong>\FF0C\5219\4F1A\5C06\6D88\606F\5199\5165 JavaScript \63A7\5236\53F0\FF0C\5E76\4E14\6807\8BB0\663E\793A\7F29\653E\56E0\5B50\4E3A <strong>10</strong>\3002\5730\56FE\7EC4\4EF6\4F1A\5C06\503C\820D\5165\5230\7B2C\4E00\4E2A\5C0F\6570\4F4D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108566048091312778)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F62\72B6\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531136685312751)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5305\542B\56FE\6807 CSS \7C7B\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531089213312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531504829312751)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\7528\4F5C\56FE\6807\6E90\7684 CSS \7C7B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531403667312751)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531342254312751)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\50CF\6E90\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108531242464312751)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530351824312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\6807\7684\6E90\4EE5\5728\5730\56FE\4E0A\663E\793A\70B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530640917312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\7C7B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530741571312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6BCF\4E00\884C\4F7F\7528\5355\72EC\7684 CSS \7C7B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530480977312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530561577312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6240\6709\884C\4F7F\7528\9759\6001 CSS \7C7B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530832177312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530922053312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5411\7528\4E8E\70B9\663E\793A\7684\56FE\50CF\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108530243018312750)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521177355312742)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\6216\7981\7528\5176\4ED6\5730\56FE\5C0F\90E8\4EF6\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522268799312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\6D4F\89C8\5668\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522334010312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\6D4F\89C8\5668\83B7\53D6\7528\6237\7684\5F53\524D\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522413341312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\5DE5\5177')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522599652312744)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62\5DE5\5177\5141\8BB8\6700\7EC8\7528\6237\5728\5730\56FE\4E0A\5708\753B\5706\5F62\3002\5B8C\6210\540E\FF0C\5C06\89E6\53D1\4E8B\4EF6\FF0C\4F7F\60A8\53EF\4EE5\901A\8FC7\52A8\6001\64CD\4F5C\6216 JavaScript \4EE3\7801\5904\7406\8BE5\5706\5F62\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522684933312744)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DDD\79BB\5DE5\5177')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522789984312744)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\6700\7EC8\7528\6237\6D4B\91CF\5730\56FE\4E0A\70B9\4E4B\95F4\7684\8DDD\79BB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522044974312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9650\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108522126367312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9650\5730\56FE\6EDA\52A8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521265145312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9F20\6807\6EDA\8F6E\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521370124312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9F20\6807\6EDA\8F6E\653E\5927\6216\7F29\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521874730312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\7565\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521937767312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\53F3\4E0B\65B9\663E\793A\7F29\7565\5730\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521459455312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\77E9\5F62\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521580610312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7\5728\5730\56FE\4E0A\5708\753B\77E9\5F62\FF0C\5C06\5730\56FE\653E\5927\5230\67D0\4E2A\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521651017312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BD4\4F8B\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521781148312743)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5730\56FE\4E0A\663E\793A\6BD4\4F8B\680F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108521011607312742)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526026278312746)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5730\56FE\533A\57DF\7684\9AD8\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525986005312746)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108526119832312746)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524368433312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\56FE\4F8B\7684 CSS \7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524270689312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524168058312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\663E\793A\56FE\4F8B\7684\5143\7D20\7684 jQuery \9009\62E9\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524076884312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523311089312744)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\56FE\4F8B\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523681630312744)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523723541312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7ED3\675F\4F4D\7F6E\FF08\901A\5E38\5728\5730\56FE\4E0B\65B9\FF09\663E\793A\56FE\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523855286312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523924824312745)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7528\4E8E\663E\793A\56FE\4F8B\7684\5143\7D20\6307\5B9A jQuery \9009\62E9\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523407762312744)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523526997312744)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8D77\59CB\4F4D\7F6E\FF08\901A\5E38\5728\5730\56FE\4E0A\65B9\FF09\663E\793A\56FE\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523224023312744)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558256697312772)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691197063312874)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5C42\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524890311312745)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\663E\793A\5730\56FE\5C42\6D88\606F\201C\672A\627E\5230\6570\636E\201D\548C\201C\627E\5230\66F4\591A\6570\636E\201D\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524931522312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525057934312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5730\56FE\4E0A\65B9\663E\793A\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525105896312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525291287312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5730\56FE\4E0B\65B9\663E\793A\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525378708312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525443094312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7528\4E8E\663E\793A\6D88\606F\7684\5143\7D20\6307\5B9A jQuery \9009\62E9\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108524766818312745)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525642572312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\663E\793A\6D88\606F\7684\5143\7D20\7684 jQuery \9009\62E9\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525559278312746)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523117126312744)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\663E\793A\56FE\4F8B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108523072674312744)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525895435312746)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\9009\62E9\9875\9879\FF0C\5219\5730\56FE\533A\57DF\59CB\7EC8\5C06\5F53\524D\5730\56FE\8FB9\6846\FF08\4EE5 GeoJSON \683C\5F0F\FF09\4F5C\4E3A\6B64\9879\7684\503C\3002\8FD9\5BF9\4E8E\5C06\5730\56FE\8FDE\63A5\5230\53E6\4E00\4E2A APEX \7EC4\4EF6\FF08\4F8B\5982\FF0C\7ECF\5178\6216\4EA4\4E92\5F0F\62A5\8868\FF09\5F88\6709\7528\FF1A\8FB9\6846\9879\7684\5185\5BB9\53EF\4F9B\53E6\4E00\4E2A\7EC4\4EF6\6267\884C\7A7A\95F4\67E5\8BE2\FF0C\5E76\4EC5\663E\793A\5730\56FE\4E0A\53EF\89C1\7684\6570\636E\3002</p>'),
unistr('<p>\6267\884C\5730\56FE\79FB\52A8\6216\7F29\653E\7EA7\522B\66F4\6539\540E\7684\8FB9\6846\9879\5185\5BB9\793A\4F8B\FF1A</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('\4F7F\7528<strong>\5237\65B0</strong>\52A8\6001\64CD\4F5C\FF0C\5730\56FE\53EF\4EE5\8FDE\63A5\5230\62A5\8868\533A\57DF\3002\8BE5\62A5\8868\533A\57DF\53EF\4EE5\5E94\7528\7A7A\95F4\8FC7\6EE4\5668\FF0C\4EE5\4EC5\663E\793A\5728\5730\56FE\4E0A\4E5F\53EF\89C1\7684\7ED3\679C\3002</p>'),
unistr('<p>\62A5\8868\67E5\8BE2\793A\4F8B\FF1A</p>'),
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108525766187312746)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FB9\6846\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555863418312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\6BD4\4F8B\680F\548C\8DDD\79BB\5DE5\5177\7684\5355\4F4D\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556120110312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\82F1\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556239662312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\82F1\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556339116312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9879\6D3E\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556466078312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\503C\6D3E\751F\5355\4F4D\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555970559312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EA6\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556092141312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\516C\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108555759681312770)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\4F4D\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556644041312771)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9875\6216\5E94\7528\7A0B\5E8F\9879\FF0C\5176\4E2D\5305\542B\8981\7528\4F5C\5730\56FE\5355\4F4D\5236\7684\503C\FF1A<strong>METRIC</strong> (<strong>M</strong>) \6216 <strong>IMPERIAL</strong> (<strong>I</strong>)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108556548316312771)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\4F4D\5236\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183338859312469)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\7684\6570\636E\9879\4E0A\5448\73B0\6807\8BB0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183434463312469)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183678669312469)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183528500312469)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183271614312469)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183880336312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\56FE\8868\7684\6570\636E\9879\4E0A\5448\73B0\7684\6807\8BB0\5F62\72B6\3002\8303\56F4\7CFB\5217\4EC5\652F\6301<strong>\81EA\52A8</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183927815312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184079952312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184142212312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83F1\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184249198312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EBA\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184325452312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184435330312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209672029312490)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184560243312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5012\4E09\89D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108184697354312470)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\4E09\89D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108183760320312469)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F62\72B6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299784429312564)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\533A\57DF\8BBE\7F6E\4E2D\7684<strong>\4E3B\533A\57DF</strong>\6307\5B9A\6B64\5217\4E3A\4E3B\4EA4\4E92\5F0F\7F51\683C\533A\57DF\7684\5916\952E\5217, \5219\4ECE\4E3B\8868\4E2D\9009\62E9\5BF9\5E94\7684\5916\952E\5217\3002</p>'),
unistr('        <p>\4F8B\5982, \5982\679C\4E3B\533A\57DF\4E3A DEPT, \6B64\4EA4\4E92\5F0F\7F51\683C\4E3A EMP, \5219\9009\62E9 EMP \4EA4\4E92\5F0F\7F51\683C\5185\7684 DEPTNO \5217, \7136\540E\4ECE\4E3B\5217\7684 DEPT \5217\7684\5217\8868\4E2D\9009\62E9 DEPTNO \5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299607284312564)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117555076312417)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\8BE6\7EC6\4FE1\606F\533A\57DF\6240\5C5E\7684\4E3B\533A\57DF\3002<br>'),
unistr('        \5F53\6B64\533A\57DF\662F\8BE6\7EC6\4FE1\606F\533A\57DF, \4E0E\6B64\9875\4E0A\7684\53E6\4E00\533A\57DF\662F\4E3B\4ECE\5173\7CFB\65F6, \5E94\8FDB\884C\6B64\8BBE\7F6E\3002</p>'),
unistr('        <p>\8981\4F7F\4E3B\4ECE\5173\7CFB\6B63\786E\5DE5\4F5C, \8BF7\5728\6B64\533A\57DF\4E2D\9009\62E9\4F5C\4E3A\4E3B\533A\57DF\5916\952E\7684\5217, \5E76\76F8\5E94\5730\6307\5B9A<strong>\4E3B\5217</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108117492805312417)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229429289312506)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\201C\6BCF\9875\884C\6570\201D\9009\62E9\5668\4E2D\663E\793A\7684\6700\5927\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229355973312505)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\6700\5927\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560998528312774)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\53EF\4EE5\4E3A\6B64\5C42\5904\7406\7684\6700\5927\884C\6570\3002\8FD9\53EF\4EE5\7528\4F5C\9632\6B62\5728\5730\56FE\4E2D\4E0B\8F7D\548C\663E\793A\592A\591A\7A7A\95F4\5BF9\8C61\7684\63AA\65BD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228652809312505)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\67E5\8BE2\53EF\5904\7406\7684\6700\5927\884C\6570\3002\5982\679C\8981\5904\7406\7684\6700\5927\884C\6570\8D85\8FC7\9650\5236, \5219\5C06\663E\793A\9519\8BEF\6D88\606F\800C\4E0D\662F\6570\636E\3002'),
unistr('\901A\8FC7\5728<strong>\627E\5230\66F4\591A\6570\636E</stron>\4E2D\6307\5B9A\6D88\606F\53EF\4EE5\5B9A\4E49\5B9A\5236\6D88\606F\3002</p>'),
unistr('<p>\6B64\5C5E\6027\7528\4E8E\9632\6B62\6700\7EC8\7528\6237\5728\8D85\5927\578B\8868\6216\89C6\56FE\4E0A\5BF9\6240\6709\8BB0\5F55\6267\884C\64CD\4F5C (\4F8B\5982\6392\5E8F\6216\805A\96C6), \6B64\7C7B\64CD\4F5C\53EF\80FD\4F1A\5BFC\81F4\6027\80FD\6B20\4F73\3002'),
unistr('\76F8\53CD, \6B64\65F6\9996\5148\9700\8981\6DFB\52A0\989D\5916\7684\8FC7\6EE4\5668\6765\51CF\5C11\5904\7406\7684\8BB0\5F55\6570\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228558525312505)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\5904\7406\7684\6700\5927\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595013012312800)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\7EC4\4EF6\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108594995930312800)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602838540312806)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597461786312802)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\786E\5B9A\4ECB\8D28\7684\7EB5\6A2A\6BD4\3002'),
unistr('<strong>\81EA\52A8</strong>\91C7\7528\6700\4F73\9002\914D\6765\4FDD\7559\539F\59CB\4ECB\8D28\5927\5C0F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597507978312802)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597608845312802)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\65B9\5F62\7EB5\6A2A\6BD4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597786105312802)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5C4F\5E55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597807176312802)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\5BBD\5C4F\5E55\7EB5\6A2A\6BD4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597378982312802)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596437491312801)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\4ECB\8D28\6E90\8FD4\56DE BLOB \7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596318509312801)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598601000312803)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598573402312803)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598819676312803)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\672C\63CF\8FF0\4ECB\8D28\FF0C\53EF\7528\4E8E\5DE5\5177\63D0\793A\548C\66FF\4EE3\56FE\50CF\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598720473312803)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596606233312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\4ECB\8D28\7EC4\4EF6\5728\5361\7247\4E0A\7684\653E\7F6E\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597161877312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\80CC\666F\56FE\50CF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597258201312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4ECB\8D28\663E\793A\4E3A\5361\7247\80CC\666F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596947003312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597034460312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5361\7247\6B63\6587\5185\90E8\663E\793A\4ECB\8D28\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596789159312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596849211312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5361\7247\6807\9898\524D\9762\663E\793A\4ECB\8D28\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596506088312801)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595320968312800)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595213625312800)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595166467312800)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598067299312802)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\5982\4F55\5728\4ECB\8D28\7EC4\4EF6\5185\8C03\6574\4ECB\8D28\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598316710312802)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8986\76D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598433268312802)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\6574\5927\5C0F\FF0C\4EE5\4FBF\4ECB\8D28\586B\5145\4ECB\8D28\663E\793A\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598154432312802)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9002\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108598202132312802)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\6574\5927\5C0F\FF0C\4EE5\4FBF\4ECB\8D28\5305\542B\5728\4ECB\8D28\663E\793A\533A\57DF\5185\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108597959863312802)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5C0F\8C03\6574')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108602711639312806)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\4ECB\8D28')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595587692312800)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4ECB\8D28\6E90\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595834017312800)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('BLOB \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595763631312800)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595648597312800)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595431846312800)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893151129312241)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 Internet \4ECB\8D28\7C7B\578B\3002Internet \4ECB\8D28\7C7B\578B\662F Internet \4E0A\6587\4EF6\683C\5F0F\7684\5305\542B\4E24\90E8\5206\7684\6807\8BC6\7B26\3002'),
unistr('\4ECB\8D28\7C7B\578B\81F3\5C11\7531\4E24\4E2A\90E8\5206\7EC4\6210: \7C7B\578B\548C\5B50\7C7B\578B, \4EE5\53CA\4E00\4E2A\6216\591A\4E2A\53EF\9009\53C2\6570\3002'),
unistr('\6B64\4ECB\8D28\7C7B\578B\5728\5448\73B0\9875\65F6\7528\5728\5185\5BB9\7C7B\578B HTTP \6807\5934\4E2D\3002</p>'),
unistr('<p>\9875\7EA7\4ECB\8D28\7C7B\578B\8986\76D6\5E94\7528\7A0B\5E8F\7EA7\4ECB\8D28\7C7B\578B\3002'),
unistr('\5982\679C\4ECB\8D28\7C7B\578B\7684\9875\7EA7\503C\548C\5E94\7528\7A0B\5E8F\7EA7\503C\5747\4E3A <code>NULL</code>, \5219\4F7F\7528\4ECB\8D28\7C7B\578B <code>text/html</code>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107893030678312241)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECB\8D28\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596098960312801)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4ECB\8D28\6E90\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108595973798312800)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596238141312801)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\4ECB\8D28\6E90\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108596186455312801)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189252035312474)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B21\523B\5EA6\7EBF\4E4B\95F4\7684\589E\91CF\3002\82E5\57FA\4E8E\6570\636E\81EA\52A8\8BA1\7B97, \5219\9ED8\8BA4\4E3A\7A7A\503C\3002\4EC5\9002\7528\4E8E\6570\5B57\8F74\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189196966312474)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\8FDB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189042052312474)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5448\73B0\6B21\523B\5EA6\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188958131312474)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188836113312474)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3B\523B\5EA6\7EBF\4E4B\95F4\7684\6700\5C0F\589E\91CF\3002\8FD9\901A\5E38\7528\4E8E\9632\6B62\79BB\6563\5EA6\91CF\51FA\73B0\5C0F\6570\8F74\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108188787920312473)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\6B65\8FDB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608817737312811)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5E94\7528\7A0B\5E8F\5904\7406\7684\540D\79F0\4EE5\4FBF\4E8E\5F00\53D1\8005\8FDB\884C\8BC6\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990322926312315)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5E94\7528\7A0B\5E8F\5F00\53D1\8005\7528\6765\5F15\7528\6B64\9A8C\8BC1\65B9\6848\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929852129312269)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6807\8BC6\6B64\6388\6743\65B9\6848\7684\552F\4E00\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003520077312328)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5206\652F\7684\540D\79F0, \4EE5\4FBF\4E8E\5F00\53D1\8005\8FDB\884C\8BC6\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040474839312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\9762\5305\5C51\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929709490312269)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\6784\5EFA\9009\9879\7684\540D\79F0\3002\6784\5EFA\9009\9879\662F\9884\5B9A\4E49\7684\8BBE\7F6E, \8FD9\4E9B\8BBE\7F6E\51B3\5B9A\662F\5426\542F\7528\5E94\7528\7A0B\5E8F\5185\90E8\7684\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040174488312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6309\94AE\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040581699312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\65E5\5386\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930421833312270)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\52A8\6001\64CD\4F5C\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040232235312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\9879\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108226647592312503)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5217\7EC4\7684\540D\79F0\3002\6B64\540D\79F0\5728\8BE6\7EC6\89C6\56FE\4E2D\663E\793A\4E3A\533A\57DF\9875\7709\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040343056312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\5217\8868\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560450152312774)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\8BF4\660E\6027\540D\79F0\3002\5982\679C\9700\8981 HTML \6216\66FF\6362\624D\80FD\5728\5730\56FE\533A\57DF\4E0A\663E\793A\6807\7B7E\FF0C\5219\4F7F\7528<strong>\6807\7B7E</strong>\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107929986224312269)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\524D\9875\7684\540D\79F0\3002\6B64\540D\79F0\4E0E\9875\7801\548C\9875\6807\9898\4E00\8D77\7528\4E8E\8BB8\591A &PRODUCT_NAME. \9875\548C\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930208951312269)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9875\7EC4\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107931032265312270)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9875\5904\7406\7684\540D\79F0\4EE5\4FBF\4E8E\5F00\53D1\8005\8FDB\884C\8BC6\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039902180312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\7279\5B9A\9875\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040049590312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\533A\57DF\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040633568312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\62A5\8868\6A21\677F\8F93\5165\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039891088312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\4E3B\9898\8F93\5165\7B80\77ED\7684\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040701365312355)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\7528\6237\754C\9762\8F93\5165\540D\79F0\3002\6B64\540D\79F0\663E\793A\5728\5411\5BFC\4E2D, \4F8B\5982, \521B\5EFA\4E3B\9898\5411\5BFC\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003219148312328)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9A8C\8BC1\7684\540D\79F0\3002\6B64\540D\79F0\5E94\8BE5\662F\8BF4\660E\6027\540D\79F0, \4EE5\4FBF\5F00\53D1\8005\53EF\4EE5\8F7B\677E\6807\8BC6\8981\68C0\67E5\7684\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889963645312238)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\8BF4\660E\6027\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107889824941312238)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904951146312250)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\73B0\6709\503C\5217\8868\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107904863390312250)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516867293312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5BFC\822A\680F\5728\5730\56FE\4E0A\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517128440312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517252978312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5730\56FE\7684\7ED3\675F\4F4D\7F6E\FF08\901A\5E38\662F\53F3\4FA7\FF09\663E\793A\5BFC\822A\680F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516951042312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108517073115312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5730\56FE\7684\8D77\59CB\4F4D\7F6E\FF08\901A\5E38\662F\5DE6\4FA7\FF09\663E\793A\5BFC\822A\680F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516761950312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516079588312738)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F\7528\7684\5BFC\822A\680F\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516536167312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\653E\548C\6307\5357\9488')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516660028312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\63A7\5236\5730\56FE\65B9\5411\7684\7F29\653E\63A7\4EF6\548C\6307\5357\9488\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516128965312738)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516219842312738)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5BFC\822A\680F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516302238312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108516497702312739)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\653E\5927\548C\7F29\5C0F\63A7\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515929255312738)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773021985312937)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5BFC\822A\83DC\5355\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029955407312347)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5728\6B64\9875\4E0A\5BFC\822A\7684\5BFC\822A\83DC\5355\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029811595312347)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772579868312937)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\9875\4E0A\7684\5BFC\822A\83DC\5355\5217\8868\9009\62E9\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772759469312937)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FA7\8FB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772665453312937)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772407902312937)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030195515312347)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6B64\9875\4E0A\7684\5BFC\822A\83DC\5355\5217\8868\7684\5BFC\822A\83DC\5355\5217\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030015501312347)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772933879312937)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\9009\62E9\6A21\677F\9009\9879\4EE5\5B9A\5236\6B64\5BFC\822A\5217\8868\7684\7528\6237\754C\9762\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108772827698312937)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586146363312793)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\53F3\7BAD\5934</dt>'),
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108586081930312793)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\6DFB\52A0\5230\7EC4\4EF6\7684\56FE\6807\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002</p>'),
unistr('        <p>\5982\679C\4E3B\9898\4F7F\7528\5B57\4F53 APEX\FF0C\8BF7\8BBF\95EE <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Universal Theme Sample Application\FF08\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F\FF09</a>\6765\67E5\770B\53EF\7528\7684\56FE\6807\548C\4FEE\9970\7B26\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108585970719312793)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\672A\627E\5230\6570\636E\201D\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770278835312935)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\6B64\5217\8868\9876\90E8\7684\5217\8868\7A7A\503C\9009\9879\5185\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578611217312787)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\6B64\5217\8868\9876\90E8\7684\5217\8868\7A7A\503C\9009\9879\5185\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941740793312278)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\6B64\5217\8868\9876\90E8\7684\5217\8868\7A7A\503C\9009\9879\5185\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943030989312279)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\6B64\5217\8868\9876\90E8\7684\5217\8868\7A7A\503C\9009\9879\5185\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905571504312250)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\6B64\5217\8868\9876\90E8\7684\5217\8868\7A7A\503C\9009\9879\5185\663E\793A\7684\6587\672C\3002\5982\679C\6B64\503C\4E3A\7A7A\503C, \5219\5728\5448\73B0\9879\65F6\4E5F\4F1A\663E\793A\6B64\503C\3002\5982\679C\60A8\672A\8F93\5165\4EFB\4F55\6587\672C, \5219\4F1A\5728\5217\8868\4E2D\663E\793A\4E3A\4E00\7A7A\884C, \5E76\5728\5448\73B0\65F6\663E\793A\7A7A\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905478714312250)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\663E\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905720158312251)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\503C\5217\8868\4E2D\9009\62E9\4E86\7A7A\503C\65F6\8981\8FD4\56DE\7684\503C\3002\5982\679C\60A8\672A\63D0\4F9B\503C, \5219\5728\4ECE\6B64\5217\8868\4E2D\9009\62E9\4E86\7A7A\503C\9009\9879\65F6, \9879\503C\4F1A\7559\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107905655657312250)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\8FD4\56DE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263986641312535)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E3A\6BCF\4E2A\62A5\8868\9875\663E\793A\7684\62A5\8868\884C\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263800088312535)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264174712312535)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5176\503C\6307\5B9A\8981\4E3A\6BCF\4E2A\62A5\8868\9875\663E\793A\7684\62A5\8868\884C\6570\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264033690312535)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263788776312534)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\8F93\5165\6B64\62A5\8868\7684\884C\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444078181312682)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\9879\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443993676312682)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263622131312534)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6570\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900843165312247)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6700\7EC8\7528\6237\5C1D\8BD5\6267\884C\7B2C\4E8C\6B21\9875\63D0\4EA4\65F6\8F6C\5230\7684 URL \76EE\6807\3002&PRODUCT_NAME. \5C06\663E\793A\4E00\6761\9519\8BEF\6D88\606F\548C\4E00\4E2A\6307\5411\6B64 URL \7684\94FE\63A5, \4EE5\4F7F\7528\6237\53EF\4EE5\7EE7\7EED\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900752482312247)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\63D0\4EA4\91CD\590D\9875\65F6\8F6C\5230\6B64 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292173158312558)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\9875\6216 URL \662F\66FF\6362\5F53\524D\9875\8FD8\662F\5728\5BF9\8BDD\6846\4E2D\6253\5F00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451439116312688)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451391149312688)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\4E00\7A97\53E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108292087825312558)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4EE5\4E0B\4F4D\7F6E\6253\5F00\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215961887312495)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104841864312407)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8BBF\95EE\8868\65F6, <code>employee</code> \5C1D\8BD5\4F7F\7528\7D22\5F15 <code>emp_department_ix</code></dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>\5728 SQL \67E5\8BE2\4E2D\542F\7528 <code>WITH plsql_declarations</code> \5B50\53E5</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104721061312407)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 Oracle Optimizer \63D0\793A, \8BE5\63D0\793A\5728\6267\884C SQL \67E5\8BE2\65F6\6DFB\52A0\5230\9876\7EA7\8BED\53E5\3002'),
unistr('        \63D0\793A\662F\5411 Optimizer \53D1\51FA\7684\6307\4EE4\3002\5728\7F16\5199 SQL \65F6, \60A8\53EF\80FD\77E5\9053\5BF9 Optimizer \672A\77E5\7684\6570\636E\7684\4FE1\606F\3002\4F7F\7528\63D0\793A\53EF\5E2E\52A9\60A8\505A\51FA\901A\5E38\7531 Optimizer \505A\51FA\7684\51B3\7B56,'),
unistr('        \6709\65F6\8FD9\5BFC\81F4\8BA9 Optimizer \9009\62E9\5B83\8BA4\4E3A\6210\672C\8F83\9AD8\7684\8BA1\5212\3002</p>'),
unistr('        <p>\4F8B\5982, \60A8\53EF\80FD\77E5\9053\7279\5B9A\7D22\5F15\5BF9\4E8E\7279\5B9A\67E5\8BE2\66F4\5177\9009\62E9\6027\3002\6839\636E\6B64\4FE1\606F, \60A8\4E5F\8BB8\53EF\4EE5\9009\62E9\6BD4 Optimizer \66F4\6709\6548\7684\6267\884C\8BA1\5212\3002'),
unistr('        \5728\8FD9\79CD\60C5\51B5\4E0B, \4F7F\7528\63D0\793A\6765\5F3A\5236 Optimizer \4F7F\7528\6700\4F18\7684\6267\884C\8BA1\5212\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104635563312407)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F18\5316\7A0B\5E8F\63D0\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777268659312941)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4E00\5217\FF0C\8BE5\5217\6309 Oracle Text \7D22\5F15\7F16\5236\7D22\5F15\3002</p>'),
unistr('<p>\884C\641C\7D22\57FA\4E8E\8F93\5165\7684 Oracle Text \8FD0\7B97\7B26\8FD4\56DE\7ED3\679C\FF0C\524D\63D0\662F\5DF2\4E3A\5217\521B\5EFA\5BF9\5E94\7684 Oracle Text \7D22\5F15\3002'),
unistr('\53EA\6709\5728\6240\9700\7684\7D22\5F15\5B58\5728\FF0C\5E76\4E14\6700\7EC8\7528\6237\5DF2\7ECF\8FC7\57F9\8BAD\77E5\9053\5982\4F55\4F7F\7528 Oracle Text \641C\7D22\8FD0\7B97\7B26\65F6\FF0C\624D\5E94\542F\7528\6B64\9009\9879\3002'),
unistr('\4E3A\4E86\5E2E\52A9\6700\7EC8\7528\6237\7B80\5316 Oracle Text \8BED\6CD5\FF0C\53EF\5728\201C\5171\4EAB\7EC4\4EF6\201D\7684\201C\4EA4\4E92\5F0F\7F51\683C\201D\4E2D\4E3A <em>Oracle Text PL/SQL \51FD\6570\540D</em>\7EC4\4EF6\8BBE\7F6E\6307\5B9A\51FD\6570\3002<br>'),
unistr('\8BF7\53C2\89C1\300A<a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Oracle Text Application Developers Guide</a>\300B\3002</p>'),
unistr('<p>\6CE8 - \5F53\6700\7EC8\7528\6237\6B63\786E\8F93\5165\4E86 Oracle Text \8FD0\7B97\7B26\65F6\FF0C\641C\7D22\7684\6027\80FD\5C06\5927\4E3A\63D0\5347\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777110439312940)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Text \7D22\5F15\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608587836312810)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608418143312810)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167121862312456)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\56FE\8868\7684\65B9\5411\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167258321312456)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297896707312563)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73\663E\793A\56FE\8868\7684\6570\636E\9879\3002\4F8B\5982, \6761\5F62\56FE\4E0A\7684\5404\4E2A\6761\5F62\5C06\6C34\5E73\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297601054312563)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297703577312563)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4\663E\793A\56FE\8868\7684\6570\636E\9879\3002\4F8B\5982, \6761\5F62\56FE\4E0A\7684\5404\4E2A\6761\5F62\5C06\5782\76F4\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167082131312456)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108177032572312464)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\56FE\8868\4E0A\5448\73B0\7684\6982\89C8\6EDA\52A8\6761\7684\9AD8\5EA6, \4EE5\50CF\7D20 (\4F8B\5982 50px) \6216\767E\5206\6BD4 (\4F8B\5982 15%) \4E3A\5355\4F4D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176976144312464)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176823559312464)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\6982\89C8\6EDA\52A8\6761\3002'),
unistr('        \76EE\524D\FF0C\4EC5\5782\76F4\6761\5F62\56FE\3001\6298\7EBF\56FE\3001\9762\79EF\56FE\3001\7EBF\5F62\9762\79EF\56FE\3001\80A1\4EF7\56FE\548C\7EC4\5408\56FE\652F\6301\6B64\9009\9879\3002</p>'),
unistr('        <p>\6CE8 - \5FC5\987B\542F\7528<strong>\7F29\653E\548C\6EDA\52A8</strong>\9009\9879\FF0C\624D\4F1A\663E\793A\6982\89C8\6EDA\52A8\6761\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108176737670312464)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029751493312347)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8986\76D6\9ED8\8BA4\7528\6237\754C\9762\7EA7\522B\5BFC\822A\3002\8FD9\53EF\7528\4E8E\5F53\524D\9875\6CA1\6709\5BFC\822A\7684\60C5\51B5, \4E5F\53EF\4E3A\5F53\524D\9875\9009\62E9\66FF\4EE3\5BFC\822A (\4F8B\5982, \4E3A\5E94\7528\7A0B\5E8F\7684\5B50\90E8\5206\63D0\4F9B\4E0D\540C\7684\5BFC\822A)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029657179312347)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8986\76D6\7528\6237\754C\9762\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900434298312246)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3A\6B64\9875\5B9E\65BD\4EC0\4E48\7C7B\578B\7684\4F1A\8BDD\72B6\6001\4FDD\62A4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401620076312645)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\5FC5\987B\5177\6709\6821\9A8C\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401744341312645)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C Request, Clear Cache \6216 Name/Value \5BF9\53C2\6570\663E\793A\5728 URL \4E2D, \5219\5FC5\987B\540C\65F6\63D0\4F9B\6821\9A8C\548C\3002<br>'),
unistr('\6821\9A8C\548C\7C7B\578B\5FC5\987B\4E0E\4F5C\4E3A\53C2\6570\4F20\9012\7684\6240\6709\9879\7684\6700\4E25\5BC6\7684<em>\4F1A\8BDD\72B6\6001\4FDD\62A4</em>\5C5E\6027\76F8\517C\5BB9\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402038667312646)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0 URL \8BBF\95EE\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108402125702312646)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0D\80FD\4F7F\7528 URL \8BBF\95EE\9875\3002<br>'),
unistr('\4F46\662F, \8BE5\9875\53EF\4EE5\662F<em>\5206\652F\5230\9875</em>\5206\652F\7C7B\578B\7684\76EE\6807, \56E0\4E3A\6B64\5206\652F\7C7B\578B\4E0D\6267\884C URL \91CD\5B9A\5411\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401406219312645)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401557976312645)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\4F7F\7528\5177\6709\6216\4E0D\5177\6709\4F1A\8BDD\72B6\6001\53C2\6570\7684 URL (\4E0D\5FC5\5177\6709\6821\9A8C\548C) \8BF7\6C42\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401816307312645)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\53C2\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108401993036312645)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\4F7F\7528 URL \8BF7\6C42\9875, \4F46 URL \4E2D\4E0D\80FD\5305\542B Request, Clear Cache \6216 Name/Value \5BF9\53C2\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900390185312246)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BBF\95EE\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891360508312239)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\6B64\9875\7684\5B57\6BCD\6570\5B57\522B\540D\3002\6B64\522B\540D\53EF\4EE5\4EE3\66FF\9875\7801\6765\5F15\7528\9875\3002'),
unistr('\4F8B\5982, \5982\679C\60A8\6B63\5728\4F7F\7528\5E94\7528\7A0B\5E8F 100 \7684\9875 1, \5219\53EF\4EE5\521B\5EFA\540D\4E3A <code>home</code> \7684\522B\540D\3002'),
unistr('\7136\540E, \60A8\53EF\4EE5\4F7F\7528\4E0B\9762\7684 f?p \8BED\6CD5\4ECE\5176\4ED6\9875\8BBF\95EE\6B64\9875:'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891262268312239)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107900057050312246)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\6B64\9875\662F\516C\5171\7684\8FD8\662F\8981\6C42\9A8C\8BC1\3002'),
unistr('\5982\679C\5C06\9875\6807\8BC6\4E3A\516C\5171, \5219\8BBF\95EE\6B64\9875\7684\4EFB\4F55\7528\6237\90FD\53EF\4EE5\67E5\770B\6B64\9875\3002'),
unistr('\5E94\7528\7A0B\5E8F\7684\9875\536B\58EB\51FD\6570\53EF\4EE5\8BBF\95EE\6B64\9875\5C5E\6027\6765\786E\5B9A\90A3\4E9B\65E0\9700\63D0\524D\9A8C\8BC1\5373\53EF\67E5\770B\7684\9875\3002'),
unistr('\9A8C\8BC1\65B9\6848\9875\536B\58EB\51FD\6570\7684\5B9E\65BD\5C06\51B3\5B9A\6B64\5C5E\6027\7684\6548\679C\5982\4F55\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400842001312645)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9700\8981\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400948079312645)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\662F\516C\5171\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899937804312246)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891532911312239)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\8981\4E0E\6B64\9875\5173\8054\7684\9875\7EC4\3002'),
unistr('\9875\7EC4\4E0D\5F71\54CD\529F\80FD, \4F46\662F\53EF\4EE5\5E2E\52A9\5F00\53D1\8005\7BA1\7406\5E94\7528\7A0B\5E8F\4E2D\7684\9875\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891421180312239)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107899087338312245)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\66FF\6362\9875\6A21\677F\4E2D <code>#ONLOAD#</code> \66FF\6362\5B57\7B26\4E32\7684\6587\672C\3002'),
unistr('\8981\4F7F\7528\6B64\529F\80FD, \60A8\7684\9875\6A21\677F\5FC5\987B\5305\542B <code>#ONLOAD#</code> \66FF\6362\5B57\7B26\4E32\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107898900143312245)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 HTML \6B63\6587\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891762772312240)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\6B64\9875\9009\62E9\9875\6A21\5F0F\3002</p>'),
'#LOV_VALUES#',
unistr('<p>\8BF7\6CE8\610F, \53EA\6709\5728\5F53\524D\5E94\7528\7A0B\5E8F\4E3B\9898\5305\542B\9ED8\8BA4\7684<em>\5BF9\8BDD\6846\9875\6A21\677F</em>\65F6, \9009\9879<em>\6A21\5F0F\5BF9\8BDD\6846</em>\548C<em>\65E0\6A21\5F0F\5BF9\8BDD\6846</em>\624D\53EF\4F9B\9009\62E9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399909475312644)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5F0F\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400068837312644)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9875\663E\793A\4E3A\6A21\5F0F\5BF9\8BDD\6846\3002<br>'),
unistr('\6A21\5F0F\5BF9\8BDD\6846\662F\4F4D\4E8E\89C6\7A97\4E2D\7684\91CD\53E0\7A97\53E3, \5728\6700\7EC8\7528\6237\5173\95ED\4E4B\524D\4E00\76F4\5904\4E8E\6D3B\52A8\548C\805A\7126\72B6\6001\3002'),
unistr('\57FA\7840\9875\7070\663E, \5728\5BF9\8BDD\6846\5173\95ED\4E4B\524D, \6700\7EC8\7528\6237\4E0D\80FD\4E0E\8BE5\9875\7684\5176\4F59\90E8\5206\4EA4\4E92\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400110598312644)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6A21\5F0F\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108400291625312644)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9875\663E\793A\4E3A\65E0\6A21\5F0F\5BF9\8BDD\6846\3002<br>'),
unistr('\65E0\6A21\5F0F\5BF9\8BDD\6846\662F\4F4D\4E8E\89C6\7A97\4E2D\7684\91CD\53E0\7A97\53E3, \6700\7EC8\7528\6237\53EF\4EE5\4E0E\8BE5\5BF9\8BDD\6846\4EE5\53CA\9875\4E0A\542F\52A8\8BE5\5BF9\8BDD\6846\7684\5185\5BB9\8FDB\884C\4EA4\4E92\3002'),
unistr('\4E0D\5FC5\7EE7\7EED\5904\7406\8BF7\6C42\7684\4FE1\606F\65F6\53EF\4EE5\4F7F\7528\65E0\6A21\5F0F\5BF9\8BDD\6846, \53EF\5728\7A97\53E3\4ECD\6253\5F00\65F6\5728\5176\4ED6\5730\65B9\7EE7\7EED\5DE5\4F5C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399737998312644)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108399865519312644)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\663E\793A\4E3A\6B63\5E38 &PRODUCT_NAME. \5E94\7528\7A0B\5E8F\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891609345312240)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108741251433312913)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100201862312403)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6267\884C\7684\5904\7406\7C7B\578B\3002\652F\6301\4EE5\4E0B\5904\7406\7C7B\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\636E\5E94\7528\7A0B\5E8F\914D\7F6E, \6B64\5904\53EF\80FD\8FD8\6709\5176\4ED6\5904\7406\7C7B\578B\7684\63D2\4EF6\53EF\7528\3002'),
unistr('\8FD9\4E9B\63D2\4EF6\663E\793A\4E3A <em>&lt;\6211\7684\63D2\4EF6&gt; [\63D2\4EF6]</em>\3002'),
unistr('\5728\6B64\5E94\7528\7A0B\5E8F\7684\5171\4EAB\7EC4\4EF6\5185\5B89\88C5\4EE5\4E0B\63D2\4EF6:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923152546312264)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724326738312900)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\53C2\6570\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724210157312900)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724184248312900)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4F5C\6B64\53C2\6570\7684\6E90\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724006763312900)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724515108312900)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4E00\4E2A\6216\591A\4E2A\7528\4F5C\6B64\53C2\6570\7684\76EE\6807\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002</p>'),
unistr('<p>\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108724428672312900)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725733898312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\53EF\7528\5217\8868\4E2D\9009\62E9\53C2\6570\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726276469312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726316466312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>PL/SQL \51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725855649312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725908721312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726064649312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108726185499312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\5230<em>\9759\6001\503C</em>\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108725650405312901)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248085416312521)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\53C2\6570\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247967784312521)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275715344312545)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891960283312240)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\9875\6A21\677F\6765\5B9A\4E49\6B64\9875\7684\5916\89C2\548C\5E03\5C40\3002</p>'),
unistr('        <p>\9875\6A21\677F\5728\5E94\7528\7A0B\5E8F\4E3B\9898\4E2D\5B9A\4E49\3002'),
unistr('        \521B\5EFA\9875\65F6, \6A21\677F\5C06\81EA\52A8\8BBE\7F6E\4E3A<em>\4E3B\9898\9ED8\8BA4\503C</em>, \8FD9\5C06\4F7F\7528\5728\5F53\524D\4E3B\9898\4E2D\5B9A\4E49\7684\9ED8\8BA4\9875\6A21\677F\5448\73B0\9875\3002'),
unistr('        \5728\6B64\5904\8FDB\884C\7684\9009\62E9\5C06\8986\76D6\9ED8\8BA4\9875\6A21\677F\3002</p>'),
unistr('        <p>\8BB8\591A\4E3B\9898\5305\542B\5177\6709\7279\5B9A\7528\9014\7684\9875\6A21\677F, \7528\4E8E\4F7F\7528\4FA7\5217, \767B\5F55\9875\548C\5BF9\8BDD\6846\9875\7B49\663E\793A\5185\5BB9\3002<br>'),
unistr('        \901A\7528\4E3B\9898\63D0\4F9B\4EE5\4E0B\9875\6A21\677F:'),
'          <dl>',
unistr('            <dt>\6807\51C6</dt>'),
unistr('              <dd>\9ED8\8BA4\9875\6A21\677F\3002\9002\7528\4E8E\4E3B\9875, \9762\677F, \5927\578B\62A5\8868\4EE5\53CA\5176\4ED6\9700\8981\5360\7528\5927\5E45\5C4F\5E55\7684\5E03\5C40\3002</dd>'),
unistr('            <dt>\5DE6\4FA7\5217</dt>'),
unistr('              <dd>\63D0\4F9B\5DE6\4FA7\663E\793A\4F4D\7F6E, \8FD9\5BF9\4E8E\641C\7D22\548C\8FC7\6EE4\9875\975E\5E38\6709\7528\3002</dd>'),
unistr('            <dt>\53F3\4FA7\5217</dt>'),
unistr('              <dd>\63D0\4F9B\53EF\6298\53E0\7684\53F3\4FA7\663E\793A\4F4D\7F6E, \8FD9\5BF9\4E8E\663E\793A\6309\94AE\6216\5217\8868\7B49\9762\5411\64CD\4F5C\7684\63A7\4EF6\975E\5E38\6709\7528\3002</dd>'),
unistr('            <dt>\5DE6\4FA7\548C\53F3\4FA7\5217</dt>'),
unistr('              <dd>\540C\65F6\63D0\4F9B\5DE6\4FA7\5217\548C\53EF\6298\53E0\7684\53F3\4FA7\5217, \8FD9\9002\7528\4E8E\975E\5E38\590D\6742\7684\9875\3002</dd>'),
unistr('            <dt>\767B\5F55</dt>'),
unistr('              <dd>\4E13\7528\4E8E\5E94\7528\7A0B\5E8F\767B\5F55\9875\3002</dd>'),
unistr('            <dt>\79FB\52A8</dt>'),
unistr('              <dd>\63D0\4F9B\53EF\6298\53E0\7684\53F3\4FA7\5217\4EE5\53CA\5305\542B\4E3B\8981\4FE1\606F\7684\6807\9898\680F\533A\57DF\3002'),
unistr('              \6B64\9875\6A21\677F\975E\5E38\9002\7528\4E8E\663E\793A\5177\6709\591A\4E2A\76F8\5173\62A5\8868\6216\6570\636E\7684\5355\4E2A\8BB0\5F55\3002'),
unistr('              \79FB\52A8\529F\80FD\901A\5E38\7528\4E8E\663E\793A\4E3B\4ECE\5173\7CFB, \8FD9\65F6\9700\8981\5148\4ECE\62A5\8868\4E2D\9009\62E9\5355\4E2A\4E3B\8BB0\5F55\3002</dd>'),
unistr('            <dt>\6700\5C0F (\65E0\5BFC\822A)</dt>'),
unistr('              <dd>\9002\7528\4E8E\975E\5E38\7B80\5355\7684\9875, \514D\8D23\58F0\660E, \5355\9875\5E94\7528\7A0B\5E8F\6216\8005\4E0D\9700\8981\5BFC\822A\7684\60C5\51B5\3002</dd>'),
'          </dl>',
unistr('          \53E6\8BF7\53C2\9605: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107891891628312240)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108275968583312545)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716964442312894)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5728\4E3B\9898\9ED8\8BA4\503C\5185\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892752234312240)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5BFC\822A\5230\65B0\9875\6216\63D0\4EA4\9875\65F6\4F7F\7528\7684\8FC7\6E21\3002</p>'),
unistr('<p>\4E0D\652F\6301\4E09\7EF4\8F6C\6362\7684\65E7\6D4F\89C8\5668\65E0\6CD5\5229\7528\5927\591A\6570\8FC7\6E21\3002'),
unistr('\9ED8\8BA4\60C5\51B5\4E0B, \5BF9\4E8E\6240\6709\8FC7\6E21\7C7B\578B\800C\8A00, \7F3A\4E4F\4E09\7EF4\652F\6301\7684\8BBE\5907 (\4F8B\5982 Android 2.x) \5C06\56DE\9000\5230\201C\6DE1\51FA\201D\3002'),
unistr('\6709\5173\5176\4ED6\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605 jQuery Mobile \6587\6863\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404856672312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DE1\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404936255312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7FFB\8F6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405035231312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108404790551312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405110326312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405256950312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405340532312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405457802312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6ED1\52A8\6DE1\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405516940312648)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0A\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405661818312649)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65CB\8F6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892671048312240)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8F6C\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580872807312789)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5F53\7528\6237\5C1D\8BD5\9000\51FA\5305\542B\672A\4FDD\5B58\66F4\6539\7684\9875\65F6\FF0C\662F\5426\5411\7528\6237\53D1\51FA\8B66\544A\3002'),
unistr('        \5BF9\4E8E\4F55\65F6\6267\884C\6B64\68C0\67E5\4EE5\53CA\6B64\68C0\67E5\5305\542B\4EC0\4E48\5185\5BB9\FF0C\9875\9879\548C\6309\94AE\8FD8\63D0\4F9B\4E86\66F4\7EC6\7C92\5EA6\7684\63A7\5236\3002'),
unistr('        \5BF9\4E8E\6309\94AE\FF0C\53EF\4EE5\6307\5B9A\5728\5355\51FB\6309\94AE\65F6\662F\5426\5C06\6267\884C\6B64\68C0\67E5\3002'),
unistr('        \5BF9\4E8E\9875\9879\FF0C\53EF\4EE5\6307\5B9A\6B64\68C0\67E5\662F\5305\542B\8FD8\662F\5FFD\7565\5BF9\9879\7684\66F4\6539\FF08\8BF7\53C2\89C1\8FD9\4E8C\8005\7684<em>\6709\672A\4FDD\5B58\66F4\6539\65F6\53D1\51FA\8B66\544A</em>\5C5E\6027\FF09\3002</p>'),
unistr('        <p>\6CE8\FF1A\8FD9\4E0D\9002\7528\4E8E\5173\95ED\6A21\5F0F\5BF9\8BDD\6846\9875\7684\6700\7EC8\7528\6237\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580766426312789)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\672A\4FDD\5B58\66F4\6539\65F6\53D1\51FA\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228261684312505)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62A5\8868\9875\7801\7684\663E\793A\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429481419312670)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8 - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429533860312670)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8 - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429836915312671)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8\548C\5E95\90E8 - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429955446312671)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8\548C\5E95\90E8 - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429699733312670)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8 - \5DE6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108429743139312670)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8 - \53F3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228189193312505)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108740909883312912)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212470627312492)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\9700\8981\8BE5\53C2\6570\4E14\5FC5\987B\59CB\7EC8\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212370287312492)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212639682312492)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\53C2\6570\7684\9ED8\8BA4\503C\6216\9759\6001\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108212569051312492)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948225005312283)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\7236\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907264659312252)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\663E\793A\8BE5\533A\57DF\7684\7236\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907142951312252)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263597119312534)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4F7F\7528\90E8\5206\9875\5237\65B0 (Partial Page Refresh, PPR) \6765\66F4\65B0\62A5\8868\663E\793A\3002</p>'),
unistr('\5982\679C\6700\7EC8\7528\6237\6267\884C\5206\9875\8BF7\6C42\6216\9009\62E9\65B0\6392\5E8F\5217\7B49\64CD\4F5C\FF0C\5219\5FC5\987B\5237\65B0\5F53\524D\62A5\8868\884C\3002\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\5C06\53EA\5237\65B0\62A5\8868\533A\57DF\3002\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\5C06\5237\65B0\6574\4E2A\9875\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263472375312534)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\5206\9875\5237\65B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108440523805312679)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259087810312531)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\80CC\666F\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258981671312530)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259498023312531)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\6761\5F62\56FE\7684\5BBD\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259315214312531)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286359203312554)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\50CF\7D20')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491014961312718)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259259603312531)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\524D\666F\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108259138078312531)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\524D\666F\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171352375312460)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5360\6574\4E2A\997C\56FE\7684\6BD4\4F8B, \4F4E\4E8E\6B64\6BD4\4F8B\7684\5207\7247\5C06\805A\96C6\5230 "\5176\4ED6" \5207\7247\3002\6709\6548\503C\8303\56F4\4ECE 0 (\9ED8\8BA4\503C) \5230 1</p>'),
unistr('        <p>\4F8B\5982, \503C 0.15 \5C06\5BFC\81F4\5C11\4E8E\997C\56FE 15% \7684\6240\6709\5207\7247\805A\96C6\5230 "\5176\4ED6" \5207\7247\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171219373312460)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE\7684\5176\4ED6\9608\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201944067312484)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\9009\5B9A\997C\56FE\6BB5\65F6\5E94\7528\7684\6548\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202053179312484)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202246766312484)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202107419312484)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\548C\5206\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201807038312484)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE\9009\62E9\6548\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280393392312549)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\63D0\4F9B\4E3B\952E\503C\7684 PL/SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280259234312549)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280556965312549)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E3B\952E\7684\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280458917312549)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280153576312548)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3B\952E\7684\6E90\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447461015312685)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447514051312685)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447355927312684)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\89E6\53D1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108280016683312548)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364426138312616)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \67E5\8BE2, \8BE5\67E5\8BE2\5C06\7528\4E8E\66FF\6362\81EA\52A8\751F\6210\7684, \9009\62E9\4E0D\540C\5217\503C\7684\67E5\8BE2\3002SQL \67E5\8BE2\9700\8981\8FD4\56DE\4E00\5217\3002\8F93\5165 SQL \67E5\8BE2\53EF\4EE5\63D0\9AD8\90E8\5206\62A5\8868\7684\6027\80FD\3002\7528\6237\5355\51FB\5217\6807\9898\65F6\5C06\663E\793A\6B64\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364340530312616)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108364051784312615)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\4E3A\62A5\8868\5217\4E0B\62C9\5217\8868\4E0A\7684\8FC7\6EE4\5668\6D3E\751F\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452418819312689)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\547D\540D\7684\503C\5217\8868\8FC7\6EE4\5B8C\5168\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452529739312689)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\547D\540D\7684\503C\5217\8868\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\7B49\4E8E\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452678117312689)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\547D\540D\7684\503C\5217\8868\8FC7\6EE4\8BCD\8BED\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452721637312689)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\547D\540D\7684\503C\5217\8868\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\5305\542B\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452220013312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5B9A\4E49\7684\503C\5217\8868\8FC7\6EE4\8BCD\8BED\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452335518312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B9A\4E49\7684\503C\5217\8868 SQL \67E5\8BE2\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\5305\542B\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451863899312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\57FA\4E8E\5217\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451932383312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('STRING \548C NUMBER \5217\5C06\4ECE\4E0D\540C\5217\503C\4E2D\6D3E\751F\503C\5217\8868\3002DATE \5217\5C06\4ECE\9884\5B9A\4E49\65E5\671F\8303\56F4\6D3E\751F\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451667020312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108451724565312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528\503C\5217\8868\8FC7\6EE4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452015077312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5B9A\4E49\7684\503C\5217\8868\8FC7\6EE4\5B8C\5168\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452145252312688)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5B9A\4E49\7684\503C\5217\8868 SQL \67E5\8BE2\6D3E\751F\503C\5217\8868\4EE5\521B\5EFA\201C\7B49\4E8E\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363921018312615)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608911522312811)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6267\884C\7684 PL/SQL \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218221427312497)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\9488\5BF9\8FDC\7A0B\6570\636E\5E93\6267\884C\7684 PL/SQL \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218106780312497)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \4EE3\7801\4EE5\751F\6210 HTML \8F93\51FA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984915144312311)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\9A8C\8BC1\65B9\6848\5185\4F7F\7528\7684 PL/SQL \6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984892191312311)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217679074312496)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6267\884C\5904\7406\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217789636312496)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5730\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217841481312496)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \4EE3\7801\5728\672C\5730\6570\636E\5E93\4E2D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217947066312497)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218071713312497)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \5728\8FDC\7A0B\6570\636E\5E93\4E2D\6267\884C\FF0C\6570\636E\5E93\8FDE\63A5\4F7F\7528\542F\7528 REST \7684 SQL \6765\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217501817312496)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099329115312403)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\7528\6237\754C\9762\4E2D\5C06\63D2\4EF6\663E\793A\5728\54EA\4E2A\7C7B\522B\4E0B\65B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425346118312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425432658312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6548\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425596142312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425625708312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425721916312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425827994312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425929076312667)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108426022589312668)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099291999312402)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751486194312920)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\53EF\4EE5\6267\884C\7684 JavaScript \4EE3\7801\3002\6CE8\FF1A\6B64\4EE3\7801\6240\5B9E\73B0\529F\80FD\7684\786E\5207\6027\8D28\5C06\53D6\51B3\4E8E\5F53\524D\7684\63D2\4EF6\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108751392805312920)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \521D\59CB\5316\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276038714312545)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717008734312894)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5728\4E3B\9898\9ED8\8BA4\503C\5185\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892956911312241)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6253\5F00\5F39\51FA\6846\65F6\4F7F\7528\7684\8FC7\6E21\3002</p>'),
unistr('<p>\4E0D\652F\6301\4E09\7EF4\8F6C\6362\7684\65E7\6D4F\89C8\5668\65E0\6CD5\5229\7528\5927\591A\6570\8FC7\6E21\3002'),
unistr('\9ED8\8BA4\60C5\51B5\4E0B, \5BF9\4E8E\6240\6709\8FC7\6E21\7C7B\578B\800C\8A00, \7F3A\4E4F\4E09\7EF4\652F\6301\7684\8BBE\5907 (\4F8B\5982 Android 2.x) \5C06\56DE\9000\5230\201C\6DE1\51FA\201D\3002'),
unistr('\6709\5173\5176\4ED6\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605 jQuery Mobile \6587\6863\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405818905312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DE1\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405934041312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7FFB\8F6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406038316312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D41\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108405774884312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406129228312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406238904312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406324264312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406463417312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6ED1\52A8\6DE1\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406523715312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0A\6ED1\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108406698829312649)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65CB\8F6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892855692312240)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\8F6C\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985942841312311)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5728\9A8C\8BC1\6B65\9AA4 (\767B\5F55\8EAB\4EFD\8BC1\660E\9A8C\8BC1) \4E4B\540E\8981\7531 &PRODUCT_NAME. \767B\5F55\8FC7\7A0B (\767B\5F55 API) \6267\884C\7684\8FC7\7A0B\7684\540D\79F0\3002'),
unistr('\767B\5F55\8FC7\7A0B\5C06\5728\6267\884C\6B63\5E38\767B\5F55\8FC7\7A0B\4EFB\52A1 (\5305\62EC\8BBE\7F6E cookie, \6CE8\518C\4F1A\8BDD) \4E4B\540E, \4F46\5728\91CD\5B9A\5411\5230\9884\671F\5E94\7528\7A0B\5E8F\9875\4E4B\524D\6267\884C\6B64\4EE3\7801\3002'),
unistr('\6B64\8FC7\7A0B\53EF\4EE5\5728 "PL/SQL \4EE3\7801" \5C5E\6027\6216\6570\636E\5E93\4E2D\5B9A\4E49\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985812528312311)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\540E\8FC7\7A0B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913395391312256)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7EC6\5316\6B64\9879\503C\7684 PL/SQL \8868\8FBE\5F0F\3002</p>'),
unistr('<p>\4F8B\5982, \5982\679C\6B64\9879\547D\540D\4E3A <code>P1_X</code>, \53EF\4EE5\4F7F\7528\8BA1\7B97\540E\8868\8FBE\5F0F (\4F8B\5982 <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, <code>NVL(:P1_X, :P2_Y)</code>) \6216\51FD\6570\8C03\7528 (\4F8B\5982 <code>my_func(:P1_X)</code>) \6765\8BBE\7F6E\6B64\9879\6700\7EC8\7684\503C\3002'),
unistr('\8BF7\6CE8\610F, \8FD9\4E9B\793A\4F8B\8868\660E\8868\8FBE\5F0F\53EF\4EE5\5F15\7528\5F53\524D\9879, \4E5F\53EF\4EE5\5F15\7528\4F1A\8BDD\72B6\6001\4E2D\7684\4EFB\4F55\5176\4ED6\9879\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913272309312256)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\540E\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986375602312312)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728 &PRODUCT_NAME. \6E05\9664\7528\6237\4F1A\8BDD\4E4B\540E\5E94\7528\7A0B\5E8F\91CD\5B9A\5411\5230\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107986291081312312)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500\540E URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663343092312852)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663625974312853)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663515910312853)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663403455312853)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663797175312853)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663230954312852)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664572357312853)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5728\5176\4E2D\8FD4\56DE\7684 SQL \67E5\8BE2\4F1A\8F6C\6362\4ECE Web \6E90\68C0\7D22\5230\7684\6570\636E\3002Java \51FD\6570\4F53\8FD4\56DE\7684 SQL \67E5\8BE2\5FC5\987B\4ECE #APEX$SOURCE_DATA# \4F2A\8868\9009\62E9\5E76\8BFB\53D6\6570\636E\6982\8981\6587\4EF6\4E2D\53EF\7528\7684\5217\3002\6B64\5904\4E0D\652F\6301\4F7F\7528 SQL WITH \5B50\53E5\8FDB\884C\5B50\67E5\8BE2\8981\7D20\5206\89E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664485580312853)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664348367312853)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9009\62E9 EMPNO\3001ENAME \548C SAL \5217\FF0C\5E76\8FC7\6EE4\6389 SAL \5C0F\4E8E 3000 \7684\6240\6709\884C\3002</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664266166312853)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5728\5176\4E2D\8FD4\56DE\7684 SQL \67E5\8BE2\4F1A\8F6C\6362\4ECE Web \6E90\68C0\7D22\5230\7684\6570\636E\3002JavaScript \51FD\6570\4F53\8FD4\56DE\7684 SQL \67E5\8BE2\5FC5\987B\4ECE #APEX$SOURCE_DATA# \4F2A\8868\9009\62E9\5E76\8BFB\53D6\6570\636E\6982\8981\6587\4EF6\4E2D\53EF\7528\7684\5217\3002\6B64\5904\4E0D\652F\6301\4F7F\7528 SQL WITH \5B50\53E5\8FDB\884C\5B50\67E5\8BE2\8981\7D20\5206\89E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664173811312853)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718839999312895)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5148\663E\793A\6700\65B0\7684\96C7\4F63, \6700\540E\663E\793A\5C1A\672A\96C7\4F63\7684\4EBA\3002\5982\679C\65E5\671F\76F8\540C, \5219\6309\7167\90E8\95E8\7F16\53F7\8FDB\884C\6392\5E8F\3002</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718718711312895)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4E00\4E2A\6216\591A\4E2A\4EE5\9017\53F7\5206\9694\7684\5217\540D (\5305\62EC\6307\4EE4), \7528\4E8E\5B9A\4E49\68C0\7D22\8BB0\5F55\7684\987A\5E8F\3002</p>'),
unistr('        <p>\6307\4EE4\5305\62EC:'),
'          <ul>',
unistr('            <li>ASC - \4EE5\5347\5E8F\8FD4\56DE\5217</li>'),
unistr('            <li>DESC - \4EE5\964D\5E8F\8FD4\56DE\5217</li>'),
unistr('            <li>NULLS FIRST - \5148\8FD4\56DE\6CA1\6709\503C\7684\5217, \7136\540E\8FD4\56DE\6709\503C\7684\5217</li>'),
unistr('            <li>NULLS LAST - \5148\8FD4\56DE\6709\503C\7684\5217, \7136\540E\8FD4\56DE\6CA1\6709\503C\7684\5217</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718681698312895)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664085207312853)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9009\62E9 EMPNO\3001ENAME \548C SAL \5217\FF0C\5E76\8FC7\6EE4\6389\6240\6709 SAL \5C0F\4E8E 3000 \7684\884C\3002</dt></dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663907780312853)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5728\5176\4E2D\8FD4\56DE\7684 SQL \67E5\8BE2\4F1A\8F6C\6362\4ECE Web \6E90\68C0\7D22\5230\7684\6570\636E\3002PL/SQL \51FD\6570\4F53\8FD4\56DE\7684 SQL \67E5\8BE2\5FC5\987B\4ECE #APEX$SOURCE_DATA# \4F2A\8868\9009\62E9\5E76\8BFB\53D6\6570\636E\6982\8981\6587\4EF6\4E2D\53EF\7528\7684\5217\3002\6B64\5904\4E0D\652F\6301\4F7F\7528 SQL WITH \5B50\53E5\7684\5B50\67E5\8BE2\8981\7D20\5206\89E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663872394312853)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664775300312853)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5728\5176\4E2D\8FD4\56DE\7684 SQL \67E5\8BE2\4F1A\8F6C\6362\4ECE Web \6E90\68C0\7D22\5230\7684\6570\636E\3002Python \51FD\6570\4F53\8FD4\56DE\7684 SQL \67E5\8BE2\5FC5\987B\4ECE #APEX$SOURCE_DATA# \4F2A\8868\9009\62E9\5E76\8BFB\53D6\6570\636E\6982\8981\6587\4EF6\4E2D\53EF\7528\7684\5217\3002\6B64\5904\4E0D\652F\6301\4F7F\7528 SQL WITH \5B50\53E5\8FDB\884C\5B50\67E5\8BE2\8981\7D20\5206\89E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664664587312853)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720376434312896)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9009\62E9 EMPNO\3001ENAME \548C SAL \5217\FF0C\5E76\8FC7\6EE4\6389\6240\6709 SAL \5C0F\4E8E 3000 \7684\884C\3002</dt>'),
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108719037689312895)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \67E5\8BE2\4EE5\8F6C\6362\4ECE REST \6570\636E\6E90\68C0\7D22\5230\7684\6570\636E\3002\4ECE\4F2A\8868 #APEX$SOURCE_DATA# \9009\62E9\5E76\6307\5B9A\6570\636E\6982\8981\6587\4EF6\4E2D\53EF\7528\7684\5217\3002\6B64\5904\4E0D\652F\6301\4F7F\7528 SQL WITH \5B50\53E5\8FDB\884C\5B50\67E5\8BE2\8981\7D20\5206\89E3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718967395312895)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718524456312895)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\53EA\5305\62EC\90A3\4E9B\5177\6709\7ECF\7406\6216\8005\672C\8EAB\5DE5\4F5C\662F\9500\552E\4EBA\5458\7684\5458\5DE5\3002</dt>'),
'<dd><pre>',
unistr('(MGR \662F\975E\7A7A\503C, \6216\8005 JOB = ''SALESMAN'')'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718496352312895)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\9650\5236\6240\68C0\7D22\8BB0\5F55\7684\6709\6548 SQL where \6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718387886312895)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Where \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985704843312311)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\63D0\4EA4\767B\5F55\9875\4E4B\540E\5E76\6B63\597D\5728\6267\884C\8EAB\4EFD\8BC1\660E\9A8C\8BC1\4E4B\524D\6267\884C\7684\8FC7\7A0B\7684\540D\79F0\3002'),
unistr('\6B64\8FC7\7A0B\53EF\4EE5\5728 "PL/SQL \4EE3\7801" \5C5E\6027\6216\6570\636E\5E93\4E2D\5B9A\4E49\3002</p>'),
unistr('<p>\5728 &PRODUCT_NAME. \5916\90E8\6267\884C\7528\6237\8EAB\4EFD\8BC1\660E\68C0\67E5\7684\9A8C\8BC1\65B9\6848\901A\5E38\4E0D\4F1A\6267\884C\9A8C\8BC1\524D\8FC7\7A0B\3002'),
unistr('\793A\4F8B\5305\62EC <em>HTTP \6807\5934\53D8\91CF</em>, <em>Oracle Application Server Single Sign-On</em> \548C\4F7F\7528 <code>apex_authentication.post_login</code> (\800C\975E <code>apex_authentication.login</code>) \7684\5B9A\5236\9A8C\8BC1\65B9\6848\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985604199312311)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\524D\8FC7\7A0B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289688242312556)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5B58\653E\8868\4E3B\952E\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289548089312556)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454274479312690)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367209511312618)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\663E\793A\6307\5B9A\5C5E\6027\7684\8FB9\6846\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367164594312618)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FB9\6846\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367027597312618)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8868\8FB9\6846\7684\5BBD\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366917524312618)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FB9\6846\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491318718312718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370424890312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\6B64\7EC4\4EF6\7684\80CC\666F\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370362262312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456319761312692)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370217845312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\6B64\7EC4\4EF6\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370104640312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369628773312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456058366312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455892802312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455913616312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369592715312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370012669312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369968543312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369897270312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\7C97\7EC6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456283038312692)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456155827312692)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369754154312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7C97\7EC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491272469312718)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369418410312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\6B64\7EC4\4EF6\7684\80CC\666F\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369342330312620)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455738845312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369239904312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\6B64\7EC4\4EF6\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369192671312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368620038312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455463156312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455231885312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455317270312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368588048312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108369054005312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368972344312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368836879312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\7C97\7EC6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455638753312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455560291312691)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368785562312619)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7C97\7EC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258212363312530)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6253\5370\62A5\8868\65F6\7528\4E8E\8C03\6574\6B64\5217\5927\5C0F\7684\5217\5BBD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258157168312530)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373023986312623)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B9A\4E49\5217\5BBD\5EA6\503C\7684\5355\4F4D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457853295312693)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457962003312693)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372923914312623)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6\5355\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372265824312622)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3A\4E0B\8F7D\7684\6587\6863\8F93\5165\540D\79F0\3002\5982\679C\5C06\5176\7559\7A7A, \5C06\4F7F\7528\533A\57DF\540D\79F0\4F5C\4E3A\6587\4EF6\540D\3002'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372145737312622)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366874896312618)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9875\7684\9AD8\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366751095312618)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373603634312623)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8BF7\8F93\5165\8868\793A\4E0B\8F7D\94FE\63A5\7684\6587\672C\3002\8981\5C06\6B64\94FE\63A5\66FF\6362\4E3A\5176\4ED6\5BFC\822A\7EC4\4EF6 (\5982\6309\94AE), \8BF7\5C06\6B64\5B57\6BB5\7559\7A7A\3002\60A8\53EF\4EE5\4F7F\7528\5E26\6709\4EE5\4E0B\8BED\6CD5\7684 URL \4F5C\4E3A\76EE\6807\6765\8BBE\7F6E\5176\4ED6\7EC4\4EF6, \4ECE\800C\542F\52A8\6253\5370\8FDB\7A0B:</p>'),
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('<p><strong>\6CE8</strong>: \5C06\4E0A\8FF0\5B57\7B26\4E32\4E2D\7684 <code>[REGION_ID]</code> \66FF\6362\4E3A\60A8\7684\533A\57DF ID\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373502862312623)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366244887312617)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9875\7684\65B9\5411\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453783113312690)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A2A\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453666519312690)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EB5\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366132670312617)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373192848312623)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9879\6D3E\751F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373730945312623)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\9879\6D3E\751F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372400231312622)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62A5\8868\8F93\51FA\683C\5F0F\3002\8FD8\53EF\4EE5\5177\6709\7531\9879\6307\5B9A\7684\8F93\51FA\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457689659312693)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'zh-cn'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457337964312692)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457471884312693)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457578765312693)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457783768312693)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'zh-cn'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372349730312622)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372662278312622)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4FDD\5B58\683C\5F0F\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\5305\542B<em>\9009\62E9\5217\8868</em>\9875\9879, \4EE5\4FBF\7528\6237\5728\8FD0\884C\65F6\9009\62E9\8F93\51FA\683C\5F0F\3002\6709\6548\503C\5305\62EC</p>'),
'<dl>',
'<dt>PDF</dt>',
unistr('<dd>\5728 PDF Previewer \4E2D\6253\5F00\6587\6863</dd>'),
'<dt>RTF</dt>',
unistr('<dd>\5728 Microsoft Word \4E2D\6253\5F00\6587\6863</dd>'),
'<dt>XLS</dt>',
unistr('<dd>\5728 Microsoft Excel \4E2D\6253\5F00\6587\6863</dd>'),
'<dt>HTM</dt>',
unistr('<dd>\4EE5 HTML \6587\4EF6\7684\5F62\5F0F\4E0B\8F7D\6587\6863</dd>'),
'<dt>XML</dt>',
unistr('<dd>\4EE5 XML \6587\4EF6\7684\5F62\5F0F\4E0B\8F7D\6587\6863</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372523720312622)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371405067312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9875\811A\7684\5BF9\9F50\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457105460312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457046594312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108457204636312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371391949312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456917981312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371299083312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\6B64\7EC4\4EF6\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371199628312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370694937312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456693702312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456404159312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456555121312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370568449312620)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371017041312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370971976312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370827615312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\7C97\7EC6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456875404312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108456729039312692)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108370781821312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7C97\7EC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371696895312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6587\6863\9875\811A\90E8\5206\7684\6587\672C\3002\8981\663E\793A\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\503C, \8BF7\4F7F\7528 <code>&amp;ITEM_NAME.</code> \8BED\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108371512129312621)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368293369312619)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9875\7709\7684\5BF9\9F50\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455054507312691)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454998270312691)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108455139002312691)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368147823312619)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454858810312690)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368037245312619)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\6B64\7EC4\4EF6\6240\7528\7684\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367930477312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367403093312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454567677312690)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454388730312690)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454429181312690)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367370869312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367848424312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\5B57\4F53\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367793923312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367673407312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\7EC4\4EF6\7684\5B57\4F53\7C97\7EC6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454730118312690)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454603647312690)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108367534126312618)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\4F53\7C97\7EC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368412978312619)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6587\6863\9875\7709\90E8\5206\7684\6587\672C\3002\8981\663E\793A\9875\6216\5E94\7528\7A0B\5E8F\9879\7684\503C, \8BF7\4F7F\7528 <code>&amp;ITEM_NAME.</code> \8BED\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108368370396312619)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366084203312617)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62A5\8868\9875\5927\5C0F\3002\8981\952E\5165\81EA\5DF1\7684\9875\5BBD\5EA6\548C\9AD8\5EA6, \8BF7\9009\62E9<strong>\5B9A\5236</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453436516312689)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'zh-cn'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453353450312689)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'zh-cn'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453543124312689)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453101387312689)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453007604312689)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453229448312689)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365902320312617)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366404609312617)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6307\5B9A\9875\5BBD\5EA6\548C\9AD8\5EA6\7684\5355\4F4D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454016177312690)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5398\7C73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453832614312690)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\82F1\5BF8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108453968991312690)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BEB\7C73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108454173876312690)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\78C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366312249312617)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365848152312617)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6253\5370\6587\6863\9009\62E9 content-disposition\3002Content-disposition \662F\5BF9 MIME \534F\8BAE\7684\6269\5C55, \6307\793A\6D4F\89C8\5668\5982\4F55\663E\793A\6587\6863\3002\9009\62E9<strong>\9644\4EF6</strong>\53EF\6307\793A\6D4F\89C8\5668\5C06\6587\4EF6\4FDD\5B58\5230\78C1\76D8\800C\4E0D\662F\5185\5D4C\663E\793A\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452880834312689)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108452964718312689)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108365782526312617)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6587\4EF6\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366615847312617)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9875\7684\5BBD\5EA6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108366557290312617)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726271564312112)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\9875\9879\7684\5173\8054\8868\5355\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107726139379312112)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243523529312517)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5F53\5904\7406\672A\80FD\6210\529F\5B8C\6210\65F6\6B64\5904\7406\9519\8BEF\6D88\606F\7684\663E\793A\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433439805312673)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\5230\901A\77E5\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433588451312674)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9519\8BEF\6D88\606F\663E\793A\5728 "\901A\77E5" \533A\57DF (\5B9A\4E49\4E3A\9875\6A21\677F\7684\4E00\90E8\5206)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433669962312674)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\9519\65F6\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433719553312674)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9519\8BEF\6D88\606F\663E\793A\5728\9519\8BEF\9875\4E0A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243440470312517)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907489710312252)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\9875\5448\73B0\6216\5904\7406\4E2D\7684\54EA\4E2A\70B9\6267\884C\6B64\6D41\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419059868312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710960729312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\533A\57DF\5448\73B0\4E4B\540E\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419224846312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711189830312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\5448\73B0\4E4B\540E\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418874118312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710757612312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\6807\5934\5448\73B0\4E4B\540E\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419448559312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711329572312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\8FDB\884C\9A8C\8BC1\548C\8BA1\7B97\4E4B\540E\3001\4F46\5728\9875\5904\7406\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418922807312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710811481312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\533A\57DF\5448\73B0\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419125747312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711014406312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\811A\5448\73B0\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418703914312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710654087312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\FF1A\5728\9875\5448\73B0\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419524582312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Ajax \56DE\8C03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711476884312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7531 apex.server JavaScipt API \8C03\7528\65F6\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418621479312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710529724312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\751F\6210\65B0\4F1A\8BDD\65F6\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108419370529312659)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711299539312889)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\FF1A\5728\9875\63D0\4EA4\4E4B\540E\FF0C\4F46\5728\8FDB\884C\8BA1\7B97\3001\9A8C\8BC1\548C\9875\5904\7406\4E4B\524D\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107907306072312252)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243740729312518)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\4E0E\6B64\5904\7406\5173\8054\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243621153312517)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7F16\8F91\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108122070054312420)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6388\6743\65B9\6848\4EE5\9650\5236\53EF\4EE5\4FDD\5B58\516C\5171\62A5\8868\5B9A\4E49\7684\7528\6237\3002'),
unistr('		\8981\4F7F\67D0\4E2A\6700\7EC8\7528\6237\53EF\4EE5\4FDD\5B58\516C\5171\62A5\8868, \6B64\7528\6237\7684\6B64\6388\6743\65B9\6848\5FC5\987B\6C42\503C\4E3A TRUE\3002</p>'),
unistr('		<p>\6CE8 - \5982\679C\672A\63D0\4F9B\6388\6743\65B9\6848, \5219\53EF\4EE5\7531\4EFB\4F55\7528\6237\4FDD\5B58\516C\5171\62A5\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121926116312420)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\516C\5171\62A5\8868\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492275663312719)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('$$$ DJP \5F53\524D\5DF2\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108282993366312551)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217\67E5\8BE2 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914565358312257)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\4E00\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914424676312257)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914921686312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\4E8C\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914861607312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915395372312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\4E09\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915271551312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915710570312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\56DB\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915658367312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916132716312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\4E94\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916051532312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916527369312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\516D\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916443393312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916988732312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\4E03\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916865807312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917384645312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\516B\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917216766312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917723557312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\4E5D\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917680194312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918111818312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7B2C\5341\4E2A<strong>\5FEB\901F\9009\53D6</strong>\7684\6807\7B7E\3002\6B64\6807\7B7E\662F\5E94\7528\7A0B\5E8F\7684\6700\7EC8\7528\6237\5C06\770B\5230\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918082422312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914314394312257)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\6BCF\4E2A<strong>\5FEB\901F\9009\53D6</strong>\94FE\63A5\663E\793A\5173\8054\7684 HTML \5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914245141312257)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914764468312257)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\4E00\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914659553312257)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915173148312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\4E8C\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915013997312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915555992312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\4E09\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915492830312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915951461312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\56DB\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107915829391312258)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916380339312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\4E94\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916266232312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916771135312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\516D\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107916607513312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917155192312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\4E03\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917037524312259)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917518391312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\516B\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917418498312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917938122312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\4E5D\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107917892888312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918361123312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4E0E\7B2C\5341\4E2A<strong>\5FEB\901F\9009\53D6</strong>\5173\8054\7684\503C\3002\5F53\7528\6237\5355\51FB\6B64\5FEB\901F\9009\53D6\65F6, \6B64\503C\5C06\66FF\6362\73B0\6709\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918292335312260)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256451847312528)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E3A\6B64\5355\9009\7EC4\5217\663E\793A\7684\5217\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256330822312528)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987565734312313)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4EE5\5192\53F7\5206\9694\7684 Real Application Security \52A8\6001\89D2\8272\5217\8868, \4F8B\5982:'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. \901A\8FC7 <em>sys.dbms_xs_sessions.assign_user</em> \7684 <em>enable_dynamic_roles</em> \53C2\6570\4F20\9012\8FD9\4E9B\89D2\8272, \5728\767B\5F55\65F6\542F\7528\5B83\4EEC\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987423989312313)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987331404312313)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\5728\6B64\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528 Oracle Real Application Security (RAS)\3002</p>'),
unistr('<p>\5982\679C\542F\7528 RAS \6A21\5F0F, \8BF7\786E\4FDD\7528\6237\5177\6709\8BBF\95EE\5E94\7528\7A0B\5E8F\65B9\6848\5BF9\8C61\7684\6743\9650\3002'),
unistr('\4F8B\5982, \5BF9\4E8E<strong>\5916\90E8\7528\6237</strong>, \53EF\4EE5\5C06\6570\636E\5E93\6743\9650\6388\4E88 <em>RAS \52A8\6001\5E94\7528\7A0B\5E8F\89D2\8272</em> \5E76\5728\6B64\9A8C\8BC1\65B9\6848\4E2D\5C06\5176\914D\7F6E\4E3A<em>\52A8\6001\89D2\8272</em>\3002'),
unistr('\8FD8\53EF\4EE5\901A\8FC7\5BF9 <em>apex_authorization.enable_dynamic_groups</em> \7684\8C03\7528\6765\542F\7528\89D2\8272, \4F8B\5982, \5728\9A8C\8BC1\540E\8FC7\7A0B\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420643108312660)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711520116312889)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5728\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528 Real Application Security\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420725096312660)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711610947312890)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&PRODUCT_NAME. \5047\5B9A\6240\6709\7528\6237\4E3A\5185\90E8\7528\6237, \5E76\901A\8FC7 <em>is_external</em> \53C2\6570\5C06 <em>false</em> \4F20\9012\5230 <em>sys.dbms_xs_sessions.assign_user</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108420891624312660)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108711747154312890)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&PRODUCT_NAME. \901A\8FC7 <em>is_external</em> \53C2\6570\5C06 <em>true</em> \4F20\9012\5230 <em>sys.dbms_xs_sessions.assign_user</em>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987256417312313)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('RAS \6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987776965312313)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4EE5\5192\53F7\5206\9694\7684 Real Application Security \540D\79F0\7A7A\95F4\6A21\677F\5217\8868, \4F8B\5982:'),
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. \901A\8FC7 <em>sys.dbms_xs_sessions.assign_user</em> \7684 <em>namespaces</em> \53C2\6570\4F20\9012\8FD9\4E9B\540D\79F0\7A7A\95F4, \5728\767B\5F55\65F6\542F\7528\5B83\4EEC\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987636581312313)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636571780312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636912021312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636828785312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636733381312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637053960312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636698417312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636417602312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638567775312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638883236312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638759760312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638615672312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638935821312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638495469312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924761758312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924625076312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926109457312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\6761\4EF6\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926093184312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638159873312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Java \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638091110312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639743090312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Java \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639698361312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637923910312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637817057312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 JavaScript \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637761738312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639580288312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639432869312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 JavaScript \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639304583312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924942231312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\5192\53F7 (:) \5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924858256312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925384305312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925204309312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925582022312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4EE5\9017\53F7\5206\9694\7684\9875\7801\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925450745312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637695790312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637509786312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 PL/SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637487954312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639273134312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\6210\529F\8FD4\56DE\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639180410312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639064150312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925155228312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\4E0E\6307\5B9A\503C\8FDB\884C\6BD4\8F83\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925044876312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638393589312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 Python \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108638273254312833)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639997630312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 Python \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108639826752312834)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637381798312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637286714312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108637187819312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786897548312955)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 30 \65F6, \8981\5728\6709\4E00\884C\6216\591A\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5728\68C0\67E5\5458\5DE5\662F\5426\4F4D\4E8E\90E8\95E8 40 \65F6, \8981\5728\6CA1\6709\884C\7684\60C5\51B5\4E0B\6210\529F\8FD4\56DE, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924344661312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924280780312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925787771312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\6587\672C\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925627641312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926347911312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107926245870312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108135260309312431)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4E3A\4E86\5C06\6B64\7EC4\4EF6\5448\73B0\4E3A\53EA\8BFB\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002'),
unistr('\5982\679C\4E0D\9009\62E9\6761\4EF6, \9879\5C06\6B63\5E38\5448\73B0\3002'),
unistr('\4F7F\7528\4E0E\201C\4EC5\663E\793A\201D\9879\76F8\540C\7684\8BBE\7F6E\5448\73B0\53EA\8BFB\9879\3002</p>'),
unistr('<p>\6CE8: \5C06\6761\4EF6\7C7B\578B\8BBE\7F6E\4E3A<strong>\4ECE\4E0D</strong>\53EF\59CB\7EC8\5C06\9879\5448\73B0\4E3A\53EF\8F93\5165\5B57\6BB5\3002'),
unistr('\6B64\8BBE\7F6E\5C06\8986\76D6\6240\6709\533A\57DF\7EA7\6216\9875\7EA7\53EA\8BFB\6761\4EF6\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539261519311968)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4E3A\4E86\5C06\6B64\7EC4\4EF6\5448\73B0\4E3A\53EA\8BFB\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002'),
unistr('\5982\679C\4E0D\9009\62E9\6761\4EF6, \9879\5C06\6B63\5E38\5448\73B0\3002'),
unistr('\4F7F\7528\4E0E\201C\4EC5\663E\793A\201D\9879\76F8\540C\7684\8BBE\7F6E\5448\73B0\53EA\8BFB\9879\3002</p>'),
unistr('<p>\6CE8: \5C06\6761\4EF6\7C7B\578B\8BBE\7F6E\4E3A<strong>\4ECE\4E0D</strong>\53EF\59CB\7EC8\5C06\9879\5448\73B0\4E3A\53EF\8F93\5165\5B57\6BB5\3002'),
unistr('\6B64\8BBE\7F6E\5C06\8986\76D6\6240\6709\533A\57DF\7EA7\6216\9875\7EA7\53EA\8BFB\6761\4EF6\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990122045312315)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4E3A\4F7F\6B64\533A\57DF\7684\9875\9879\5448\73B0\4E3A\53EA\8BFB\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002'),
unistr('\4E0D\9009\62E9\6761\4EF6\5C06\5BFC\81F4\9875\9879\6B63\5E38\5448\73B0\3002</p>'),
unistr('<p>\6CE8: \5982\679C\60A8\60F3\8981\5C06\6B64\533A\57DF\7684\9875\9879 (\4F8B\5982, \641C\7D22\5B57\6BB5) \59CB\7EC8\5448\73B0\4E3A\53EF\8F93\5165\7684\9875\9879, \800C\4E0D\7BA1\6B64\6761\4EF6\7684\6C42\503C\7ED3\679C\5982\4F55, \5219\5E94\5C06\6B64\9875\9879\7684\53EA\8BFB\6761\4EF6\8BBE\7F6E\4E3A "\4ECE\4E0D" \4EE5\4FBF\8986\76D6\533A\57DF\8BBE\7F6E\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107910018595312254)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\4E3A\4F7F\6B64\9875\7684\9875\9879\4F5C\4E3A\53EA\8BFB\9879\5448\73B0\800C\5FC5\987B\6EE1\8DB3\7684\6761\4EF6\7C7B\578B\3002\4E0D\9009\62E9\6761\4EF6\5C06\5BFC\81F4\9875\9879\6B63\5E38\5448\73B0\3002'),
unistr('\5728\6267\884C\5E26\6709\5904\7406\70B9<em>\9875\7709\4E4B\524D</em>\7684\5904\7406\540E, \5C06\5BF9\53EA\8BFB\6761\4EF6\6C42\503C\3002</p>'),
unistr('<p>\6CE8: \5982\679C\60A8\60F3\8981\5C06\7279\5B9A\533A\57DF\7684\67D0\4E9B\9875\9879 (\4F8B\5982, \641C\7D22\5B57\6BB5) \6216\6240\6709\9875\9879\59CB\7EC8\5448\73B0\4E3A\53EF\8F93\5165\7684\9875\9879, \800C\4E0D\7BA1\6B64\6761\4EF6\7684\6C42\503C\7ED3\679C\5982\4F55, \5219\5E94\5C06\8FD9\4E9B\533A\57DF/\9875\9879\7684\53EA\8BFB\6761\4EF6\8BBE\7F6E\4E3A<strong>\4ECE\4E0D</strong>\4EE5\4FBF\8986\76D6\7236\7EA7\8BBE\7F6E\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478950969312709)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618416610312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\5C06\59CB\7EC8\5448\73B0\4E3A\53EA\8BFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477547156312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Microsoft Internet Explorer 7.0 \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477620142312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\652F\6301 XHTML/CSS \7684\6D4F\89C8\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477435488312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F Mozilla, Netscape 6.x/7x \6216\66F4\9AD8\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477727411312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\673A\6D4F\89C8\5668\662F\5176\4ED6\6D4F\89C8\5668 (\6216\8F83\4F4E\7248\672C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476197941312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\9879\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478148202312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622065355312821)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477805071312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622259030312821)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478054119312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622173751312821)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477944584312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8BED\8A00\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622301816312821)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5F53\524D\672A\4F7F\7528\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\8BED\8A00\4E4B\4E00\8FD0\884C\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475369506312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620821632312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475507376312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621002698312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475401374312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620941425312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\9875</em>\4E2D\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475645636312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\9017\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621150574312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5728\60A8\8F93\5165\5230<em>\9875</em>\7684\9017\53F7\5206\9694\5217\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478296533312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478393155312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: DAD_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477091724312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621879029312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875\540E, \5728\9875\4E0A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476429319312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476255597312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476376165312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476570511312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473065985312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618581832312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636264415312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108636384375312832)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473255343312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618735423312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\8FD4\56DE\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478661427312709)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478770011312709)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: HTTP_HOST != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476755811312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E0D\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621513051312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38\663E\793A\9875\548C\7236\533A\57DF (\5982\679C\9002\7528)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476621642312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875/\533A\57DF\4E3A\53EA\8BFB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621402477312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6216\7236\533A\57DF (\5982\679C\9002\7528) \7684 ''\53EA\8BFB'' \6761\4EF6\7684\503C\4E3A\201C\771F\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474591062312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620085541312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5305\542B\7A7A\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474874255312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620308997312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\662F\4EC5\5305\542B\5B57\6BCD\6216\6570\5B57\4E14\4E0D\5305\542B\7279\6B8A\5B57\7B26\7684\5B57\6BCD\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474051768312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619505785312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474790826312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620222462312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474200094312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619789223312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473991526312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619474887312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474360796312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619858728312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\7A7A\6216\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474669434312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620132563312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474131140312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619645969312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474487381312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C\4E14\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619946575312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\4E3A\7A7A\4E14\4E0D\4E3A\6570\5B57\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477213280312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\8BA4\201D\4EE5\663E\793A\201C\5411\524D\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477373538312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868 (\201C\786E\5B9A\201D\4EE5\663E\793A\201C\5411\540E\201D\6309\94AE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478837429312709)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108622484164312821)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38\5448\73B0\7EC4\4EF6, \800C\4E0D\8003\8651\7236\7EC4\4EF6\7684\53EA\8BFB\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108477187983312708)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621993773312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0A\672A\663E\793A\5185\5D4C\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473102648312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618668529312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475958583312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621224279312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476038755312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875\4E0D\5904\4E8E\6253\5370\673A\53CB\597D\6A21\5F0F\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621305174312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5C1A\672A\5C06\5F53\524D\9875\5207\6362\5230 ''\6253\5370\673A\53CB\597D\6A21\5F0F''\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473381316312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618859263312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473511626312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619017737312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473426074312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108618993813312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473619381312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619130166312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF7\6C42\4E0D\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478485272312709)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108478537409312709)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CGI_ENV: SERVER_NAME != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476853583312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\9A8C\8BC1 (\4E0D\662F\516C\5171\7528\6237)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621644571312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\5DF2\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108476974360312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\662F\516C\5171\7528\6237 (\7528\6237\672A\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108621754029312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\7EC8\7528\6237\672A\767B\5F55\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475106819312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620618282312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475244384312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9996\9009\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620760461312820)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108474976863312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620472552312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475013255312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5728\5192\53F7\5206\9694\7684\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108620515625312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473779488312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619251901312818)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108473870250312705)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108619367642312819)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009<em>\9879</em>\7684\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475881651312707)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 != \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108475789233312706)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\9875 = \63D0\4EA4\7684\9875 (\5DF2\6295\9012)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107909965801312254)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924542782312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E0E\6761\4EF6\8FDB\884C\6BD4\8F83\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107924405785312265)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925940124312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\6761\4EF6\8F93\5165\503C, \5305\542B <code>&ITEM.</code> \66FF\6362\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107925827030312266)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416181106312657)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918504483312260)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\4EE5\53EA\8BFB\6A21\5F0F\663E\793A\65F6\5305\62EC\5728\9879 HTML \8868\5355\5143\6807\8BB0 <code>&lt;td&gt;</code> \4E2D\7684\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918442220312260)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\8BFB HTML \5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203166797312485)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\79D2\8868\793A\7684\4E24\6B21\56FE\8868\66F4\65B0\4E4B\95F4\7684\65F6\95F4\95F4\9694\3002\4E0D\8D5E\6210\4F7F\7528\975E\5E38\5C0F\7684\66F4\65B0\65F6\95F4\95F4\9694 (\4F8B\5982 2 \79D2), \56E0\4E3A\8FD9\4F1A\5F15\8D77\4E25\91CD\7684\6570\636E\5E93\6027\80FD\95EE\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203027814312485)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95F4\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108203291859312485)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930864719312270)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\663E\793A\8BE5\6309\94AE\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948186100312283)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\7236\7EA7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539175904311968)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\663E\793A\8BE5\9879\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948043081312283)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\7236\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923734700312264)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\5176\4E2D\5173\8054\6B64\7EC4\4EF6\7684\533A\57DF\3002\5982\679C\663E\793A\6B64\7EC4\4EF6\FF0C\5219\6B64\7EC4\4EF6\4F1A\663E\793A\5728\6307\5B9A\7684\533A\57DF\5185\5E76\5728\6B64\533A\57DF\5185\76F8\5BF9\4E8E\5176\4ED6\7EC4\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923615784312264)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988939610312314)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\60A8\5E0C\671B\5728\533A\57DF\663E\793A\9009\62E9\5668\4E2D\5305\62EC\6B64\533A\57DF\FF0C\5219\6307\5B9A<strong>\542F\7528</strong>\3002'),
unistr('\4EC5\5F53\5B9A\4E49\4E86<em>\533A\57DF\663E\793A\9009\62E9\5668</em>\533A\57DF\7C7B\578B\4E14\53EF\5728\9875\4E0A\67E5\770B\6B64\7C7B\578B\65F6\FF0C\624D\4F7F\7528\6B64\5C5E\6027\3002</p>'),
unistr('<p>\5F53\7528\6237\5355\51FB\5305\62EC\5728\533A\57DF\663E\793A\9009\62E9\5668\4E2D\7684\533A\57DF\540D\79F0\65F6\FF0C\4EC5\663E\793A\6240\9009\533A\57DF\FF0C\800C\5217\51FA\7684\6240\6709\5176\4ED6\533A\57DF\5747\9690\85CF\3002'),
unistr('\533A\57DF\663E\793A\9009\62E9\5668\4E2D\7684\7B2C\4E00\4E2A\6761\76EE\662F<em>\5168\90E8\663E\793A</em>\FF0C\4EE5\4FBF\7528\6237\53EF\4EE5\663E\793A\6240\6709\53EF\7528\7684\533A\57DF\FF0C\800C\4E0D\53EA\662F\4EE5\524D\9009\62E9\7684\533A\57DF\3002</p>'),
unistr('<p>\5982\679C\6839\636E\533A\57DF\6761\4EF6\65E0\6CD5\663E\793A\67D0\4E2A\533A\57DF\FF0C\5219\6B64\533A\57DF\4E0D\4F1A\5305\62EC\5728\533A\57DF\663E\793A\9009\62E9\5668\5185\7684\533A\57DF\5217\8868\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988848181312314)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\663E\793A\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989796138312314)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\FF0C\5B83\8FD4\56DE\7684 SQL \67E5\8BE2\7528\4F5C\6B64\533A\57DF\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989680948312314)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987953278312313)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6839\636E\9009\62E9\7684<em>\533A\57DF\7C7B\578B</em>, \8F93\5165\533A\57DF\6E90\6216\5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987825585312313)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989141463312314)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5BF9\663E\793A\5728\533A\57DF\5DE6\4E0A\89D2\7684\56FE\50CF\7684\5F15\7528\3002\5BF9\7528\4E8E\663E\793A\6B64\56FE\50CF\7684\8868\6807\8BB0\6CA1\6709\4EFB\4F55\63A7\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989092754312314)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283107707312551)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\6587\672C\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283024863312551)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984297677312310)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684 SQL \6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984161970312310)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988553464312314)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\533A\57DF\6A21\677F\53EF\5B9A\4E49\6B64\533A\57DF\7684\5916\89C2\548C\5E03\5C40\3002</p>'),
unistr('        <p>\533A\57DF\6A21\677F\5728\5E94\7528\7A0B\5E8F\4E3B\9898\4E2D\5B9A\4E49\3002'),
unistr('        \521B\5EFA\533A\57DF\65F6\FF0C\6A21\677F\81EA\52A8\8BBE\7F6E\4E3A\5F53\524D\4E3B\9898\4E2D\5B9A\4E49\7684\9ED8\8BA4\533A\57DF\6A21\677F\3002</p>'),
unistr('        <p>\8BB8\591A\4E3B\9898\5305\542B\7528\4E8E\663E\793A\62A5\8868\3001\8868\5355\3001\9884\8B66\3001\6309\94AE\3001\53EF\6298\53E0\FF08\9690\85CF/\663E\793A\FF09\5185\5BB9\548C\767B\5F55\8868\5355\7B49\7684\533A\57DF\6A21\677F\3002<br>'),
unistr('        \901A\7528\4E3B\9898\63D0\4F9B\4EE5\4E0B\533A\57DF\6A21\677F\FF1A'),
'          <dl>',
unistr('            <dt>\9884\8B66</dt>'),
unistr('            <dt>\7A7A\767D\FF0C\5E26\6709\5C5E\6027</dt>'),
unistr('            <dt>\6309\94AE\5BB9\5668</dt>'),
unistr('            <dt>\4F20\9001\5E26\5BB9\5668</dt>'),
unistr('            <dt>\53EF\6298\53E0</dt>'),
unistr('            <dt>\5185\5BB9\5757</dt>'),
unistr('            <dt>\4E3B\89C6\89C9</dt>'),
unistr('            <dt>\5185\5D4C\5BF9\8BDD\6846</dt>'),
unistr('            <dt>\5185\5D4C\5F39\51FA\7A97\53E3</dt>'),
unistr('            <dt>\4EA4\4E92\5F0F\62A5\8868</dt>'),
unistr('            <dt>\767B\5F55</dt>'),
unistr('            <dt>\6807\51C6</dt>'),
unistr('            <dt>\9009\9879\5361\5BB9\5668</dt>'),
unistr('            <dt>\6807\9898\680F</dt>'),
unistr('            <dt>\5411\5BFC\5BB9\5668</dt>'),
'          </dl>',
unistr('          \53E6\8BF7\53C2\89C1\FF1A<a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988486002312313)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100187233312403)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5982\4F55\5448\73B0\6B64\533A\57DF\3002\652F\6301\4EE5\4E0B\533A\57DF\7C7B\578B:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>\6839\636E\5E94\7528\7A0B\5E8F\914D\7F6E, \6B64\5904\53EF\80FD\8FD8\6709\5176\4ED6\533A\57DF\7C7B\578B\7684\63D2\4EF6\53EF\7528\3002'),
unistr('\8FD9\4E9B\63D2\4EF6\663E\793A\4E3A <em>&lt;\6211\7684\63D2\4EF6&gt; [\63D2\4EF6]</em>\3002'),
unistr('\5728\6B64\5E94\7528\7A0B\5E8F\7684\5171\4EAB\7EC4\4EF6\5185\5B89\88C5\4EE5\4E0B\63D2\4EF6:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107923033254312264)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362125698312614)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\8981\4E3A\6B64\9A8C\8BC1\6D4B\8BD5\7684\7B49\5F0F\7C7B\578B\3002\53D6\51B3\4E8E\60A8\7684\9009\62E9, \9700\8981\4E00\4E2A\6216\591A\4E2A\9644\52A0\5C5E\6027\624D\80FD\5B8C\5168\5B9A\4E49\6B64\9A8C\8BC1\3002</p>'),
unistr('<p>\5982\679C\9A8C\8BC1\901A\8FC7\7B49\5F0F\6D4B\8BD5, \6216\8005\6C42\503C\7ED3\679C\4E3A\201C\771F\201D, \5219\4E0D\4F1A\663E\793A\9A8C\8BC1\9519\8BEF\6D88\606F\3002'),
unistr('\5982\679C\9A8C\8BC1\672A\80FD\901A\8FC7\7B49\5F0F\6D4B\8BD5, \6C42\503C\7ED3\679C\4E3A\201C\5047\201D, \6216\8005\8FD4\56DE\975E\7A7A\6587\672C\5B57\7B26\4E32, \5219\4F1A\663E\793A\9A8C\8BC1\9519\8BEF\6D88\606F\3002</p>'),
unistr('<p>\9A8C\8BC1\5931\8D25\4E0D\4F1A\505C\6B62\5BF9\540E\7EED\9A8C\8BC1\6C42\503C, \56E0\6B64, \6BCF\4E2A\540E\7EED\9A8C\8BC1\53EF\80FD\4F1A\5F15\53D1\5176\4ED6\9A8C\8BC1\9519\8BEF\6D88\606F\3002\5982\679C\8981\505C\6B62\6267\884C\540E\7EED\9A8C\8BC1, \5219\9700\8981\5728\7B2C\4E00\4E2A\5931\8D25\7684\9A8C\8BC1\4E2D\6DFB\52A0\5176\4ED6\903B\8F91, \4F8B\5982\5C06\9875\9879\8BBE\7F6E\4E3A\7279\5B9A\503C, \7136\540E\6839\636E\9700\8981\589E\5F3A\540E\7EED\9A8C\8BC1\7684\6761\4EF6\903B\8F91\3002\5982\679C\5BF9\4E00\4E2A\6216\591A\4E2A\9A8C\8BC1\6C42\503C\5931\8D25, \5219\4E0D\6267\884C\540E\7EED\5904\7406\548C\5206\652F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462872438312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462956868312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C SQL \67E5\8BE2\672A\8FD4\56DE\884C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670226325312858)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670338444312858)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\771F\201D\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\5047\201D\FF0C\5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463433717312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\FF08\8FD4\56DE\5E03\5C14\503C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463569712312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\201C\771F\201D\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\201C\5047\201D\FF0C\5219\9A8C\8BC1\5931\8D25\3002<br>'),
unistr('\6CE8\FF1A\4ECE\8BE5\51FD\6570\8FD4\56DE\7684\7ED3\679C\5FC5\987B\662F\5E03\5C14\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463602568312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\FF08\8FD4\56DE\9519\8BEF\6587\672C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463764878312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\7A7A\5B57\7B26\4E32\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\975E\7A7A\5B57\7B26\4E32\FF0C\5219\9A8C\8BC1\5931\8D25\3002\8FD4\56DE\7684\5B57\7B26\4E32\663E\793A\4E3A\9A8C\8BC1\7684\9519\8BEF\6D88\606F\3002<br>'),
unistr('\6CE8\FF1A\4ECE\8BE5\51FD\6570\8FD4\56DE\7684\7ED3\679C\5FC5\987B\662F\6587\672C\5B57\7B26\4E32\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464493004312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464583308312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\5305\542B\7A7A\683C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\5305\542B\7A7A\683C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466487192312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\81F3\5C11\5305\542B\503C\4E2D\7684\4E00\4E2A\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466584005312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\81F3\5C11\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4E00\4E2A\5B57\7B26, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E0D\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4EFB\4F55\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466611345312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\5305\542B\503C\4E2D\7684\4EFB\4F55\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466779994312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4EFB\4F55\5B57\7B26, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\81F3\5C11\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4E00\4E2A\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466269487312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\53EA\5305\542B\5728\503C\4E2D\6307\5B9A\7684\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466314751312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\53EA\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\627E\5230\7684\5B57\7B26, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\5305\542B\4E0D\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4EFB\4F55\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465437564312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465563342312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465800487312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465910406312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465639131312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465762220312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466023806312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466159737312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464650364312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464744741312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\662F\4EC5\5305\542B\5B57\6BCD\548C\6570\5B57\4E14\4E0D\5305\542B\7279\6B8A\5B57\7B26\7684\5B57\6BCD\6570\5B57, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\5305\542B\7279\6B8A\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465014736312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\662F\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465194657312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\662F\6709\6548\65E5\671F, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E0D\662F\6709\6548\65E5\671F, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464836675312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464926996312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\662F\6570\5B57, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\5305\542B\975E\6570\5B57\5B57\7B26 (\5305\62EC\7A7A\683C, \524D\5BFC\7A7A\683C\9664\5916), \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465225949312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\662F\6709\6548\65F6\95F4\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108465330640312699)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\662F\6709\6548\65F6\95F4\6233, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E0D\662F\6709\6548\65F6\95F4\6233, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463884661312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463961921312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\4E3A\7A7A, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E3A\7A7A, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464037485312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464112841312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\4E3A\7A7A\548C\6570\5B57\96F6, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E3A\7A7A\6216\6570\5B57\96F6, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464208251312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108464369239312698)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\4E0D\4E3A\6570\5B57\96F6, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\5217\503C\4E3A\6570\5B57\96F6, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463022422312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463151366312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8BE2\672A\8FD4\56DE\884C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463275763312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108463359677312697)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C PL/SQL \4EE3\7801\6267\884C\65F6\6CA1\6709\4EA7\751F\9519\8BEF\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C PL/SQL \8868\8FBE\5F0F\6267\884C\65F6\4EA7\751F\9519\8BEF\FF0C\5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466814691312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5339\914D\6B63\5219\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108466993100312700)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5217\503C\5339\914D\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6B63\5219\8868\8FBE\5F0F, \5219\9A8C\8BC1\901A\8FC7\3002'),
unistr('\5982\679C\5217\503C\4E0D\5339\914D\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6B63\5219\8868\8FBE\5F0F, \5219\9A8C\8BC1\5931\8D25\3002<br>'),
unistr('\6CE8: \6B63\5219\8868\8FBE\5F0F\4F7F\60A8\53EF\4EE5\901A\8FC7\4F7F\7528\6807\51C6\5316\8BED\6CD5\60EF\4F8B\800C\4E0D\53EA\662F\76F4\63A5\5B57\7B26\6BD4\8F83\6765\5728\5B57\7B26\4E32\6570\636E\4E2D\641C\7D22\6A21\5F0F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362040439312614)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362754055312614)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\9A8C\8BC1\7684\533A\5206\5927\5C0F\5199\7684\5217\540D\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\5217\7684\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362634271312614)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672119786312859)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672500735312860)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672433960312859)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672380893312859)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672600181312860)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672289204312859)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672010390312859)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674186382312861)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674410391312861)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674312012312861)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674281168312861)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674541891312861)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674052530312861)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670593660312858)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670886034312858)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670784993312858)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670630817312858)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670983055312858)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670417221312858)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673791246312860)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673611528312860)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675351939312862)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675241955312862)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671714202312859)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671680585312859)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673520399312860)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673470586312860)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673360929312860)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675165189312862)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675083282312861)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674963178312861)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671515469312859)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\6307\5B9A\7684\9519\8BEF\6D88\606F\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671464906312859)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671353018312859)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786641896312955)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\6307\5B9A\7684\9519\8BEF, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362574406312614)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\FF0C\5B83\5F15\53D1\7684\9519\8BEF\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362422532312614)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\53D1\9519\8BEF\7684 PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673260980312860)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673117397312860)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673000145312860)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674876013312861)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674721969312861)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108674684320312861)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671221625312859)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\6307\5B9A\7684\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671149189312858)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671063497312858)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673935059312861)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108673823735312861)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675501823312862)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675497833312862)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671969222312859)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108671802250312859)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363178463312615)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\5339\914D\4E3A\6B64\9A8C\8BC1\6307\5B9A\7684\5217\7684\6B63\5219\8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108363004492312615)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5219\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672996122312860)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\6216\8005\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672823620312860)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108672782156312860)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786554242312955)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5BF9\4E8E<strong>\5DF2\8FD4\56DE\884C</strong>, \8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5BF9\4E8E<strong>\672A\8FD4\56DE\884C</strong>, \8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 40 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362349525312614)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \67E5\8BE2\4EE5\5B9A\4E49\6B64\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362289453312614)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362971175312615)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\9488\5BF9\4E3A\6B64\9A8C\8BC1\6307\5B9A\7684\5217\503C\8FDB\884C\6BD4\8F83\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108362800924312615)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376563618312625)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717161279312894)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EE7\627F\9488\5BF9\5E94\7528\7A0B\5E8F\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376426749312625)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5C5E\6027\63A7\5236 &PRODUCT_NAME. \662F\5426\5E94\8BE5\652F\6301\4E0D\5305\542B\4F1A\8BDD ID \7684\5E94\7528\7A0B\5E8F URL\3002'),
unistr('\5982\679C URL \4E0D\5305\542B\4F1A\8BDD ID, \5219\5728\542F\7528\4E86\91CD\65B0\8054\63A5\4F1A\8BDD\65F6, &PRODUCT_NAME. \5C06\5C1D\8BD5\4F7F\7528\4F1A\8BDD cookie \8054\63A5\73B0\6709\4F1A\8BDD\3002'),
'</p>',
unistr('<p>\9650\5236\6027\8F83\5F3A\7684\5B9E\4F8B\7EA7\8BBE\7F6E\4F1A\8986\76D6\6B64\9875\7EA7\503C\3002'),
'</p>',
unistr('<p><em><strong>\6CE8:</em></strong> \542F\7528\91CD\65B0\8054\63A5\4F1A\8BDD\53EF\80FD\4F1A\9020\6210\5E94\7528\7A0B\5E8F\51FA\73B0\5B89\5168\8FDD\89C4, '),
unistr('\56E0\4E3A\8FD9\4F1A\8BA9\653B\51FB\8005\63A5\7BA1\6700\7EC8\7528\6237\7684\73B0\6709\4F1A\8BDD\3002'),
unistr('\8981\4E86\89E3\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605 App Builder User''s Guide \7684 "Managing Application Security" \4E2D\5173\4E8E<em>\91CD\65B0\8054\63A5\4F1A\8BDD</em>\7684\90E8\5206\3002'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458074707312693)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458129737312693)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C URL \4E0D\5305\542B\4F1A\8BDD ID, \5219 &PRODUCT_NAME. \5C06\521B\5EFA\65B0\4F1A\8BDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458244052312693)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\516C\5171\4F1A\8BDD\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458384200312693)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C URL \8F6C\5230\516C\5171\9875\5E76\4E14\4E0D\5305\542B\4F1A\8BDD ID, &PRODUCT_NAME. \5C06\5C1D\8BD5\5229\7528\4E3A\6B64\5E94\7528\7A0B\5E8F\5EFA\7ACB\7684\73B0\6709\4F1A\8BDD cookie\3002'),
unistr('\5BF9\4E8E\540C\65F6\5305\542B\516C\5171\9875\548C\5DF2\9A8C\8BC1\9875\7684\5E94\7528\7A0B\5E8F, \4F1A\5728\6700\7EC8\7528\6237\9A8C\8BC1\4E4B\540E\5B9A\4E49\4F1A\8BDD ID\3002'),
unistr('\4EC5\5F53\5C1A\672A\9A8C\8BC1\4F1A\8BDD\65F6, &PRODUCT_NAME. \624D\4F1A\901A\8FC7 cookie \8054\63A5\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458418012312693)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6240\6709\4F1A\8BDD\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458522560312693)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C URL \4E0D\5305\542B\4F1A\8BDD ID, &PRODUCT_NAME. \5C06\5C1D\8BD5\5229\7528\4E3A\6B64\5E94\7528\7A0B\5E8F\5EFA\7ACB\7684\73B0\6709\4F1A\8BDD cookie, \524D\63D0\662F\6EE1\8DB3\4EE5\4E0B\6761\4EF6:</p>'),
'<p><ul>',
unistr('  <li>\4E3A\5E94\7528\7A0B\5E8F\542F\7528\4F1A\8BDD\72B6\6001\4FDD\62A4\5E76\4E14 URL \5305\542B\6709\6548\7684\6821\9A8C\548C\3002'),
unistr('    \5BF9\4E8E\516C\5171\4E66\7B7E, \9650\5236\6027\6700\5F3A\7684\9879\7EA7\4FDD\62A4\5FC5\987B\4E3A<em>\65E0\9650\5236</em>\6216<em>\9700\8981\6821\9A8C\548C - \5E94\7528\7A0B\5E8F\7EA7\522B</em>\3002</li>'),
unistr('  <li>\6216\8005 URL \4E0D\5305\542B\6709\6548\8D1F\8F7D (\8BF7\6C42\53C2\6570, \6E05\9664\9AD8\901F\7F13\5B58\6216\6570\636E\503C\5BF9)\3002</li>'),
'</ul></p>',
unistr('<p>\6B64\8BBE\7F6E\8FD8\8981\6C42\5C06\5E94\7528\7A0B\5E8F\7684<em>\5D4C\5165\5230\6846\67B6\4E2D</em>\8BBE\7F6E\4E3A<em>\5141\8BB8\76F8\540C\6765\6E90</em>\6216<em>\62D2\7EDD</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376334719312625)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\8054\63A5\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304411300312568)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\9875\63D0\4EA4\4E4B\540E\5E94\5728\4F55\65F6\91CD\65B0\52A0\8F7D\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304524898312568)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304688505312568)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8\91CD\65B0\52A0\8F7D\9875\4EE5\663E\793A\9519\8BEF\548C\6210\529F\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304778279312568)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\6210\529F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304829042312568)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\663E\793A\9519\8BEF\800C\4E0D\91CD\65B0\52A0\8F7D\9875, \4F46\5728\6210\529F\5904\7406\540E\91CD\65B0\52A0\8F7D\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108304368571312568)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\65F6\91CD\65B0\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685846045312870)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108685979184312870)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\9AD8\901F\7F13\5B58\6570\636E\FF0C\6BCF\6B21\90FD\8BF7\6C42\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558576741312772)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558674364312772)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\9AD8\901F\7F13\5B58\6570\636E\FF0C\6BCF\6B21\90FD\8BF7\6C42\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995909307312322)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996035608312322)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\679C\4E0D\7F13\5B58\3002\4E3A\6BCF\4E2A\8BF7\6C42\4ECE\8FDC\7A0B\6570\636E\5E93\63D0\53D6\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994183946312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9 &PRODUCT_NAME. \5F15\64CE\5982\4F55\5728\672C\5730\6570\636E\5E93\4E2D\9AD8\901F\7F13\5B58\6570\636E\3002'),
unistr('        \5982\679C\53EF\4EE5\4F7F\7528\9AD8\901F\7F13\5B58, \5219\57FA\4E8E\9AD8\901F\7F13\5B58\7684\7ED3\679C\6765\5448\73B0\7EC4\4EF6, \800C\4E0D\662F\4ECE\8FDC\7A0B\6570\636E\5E93\4E2D\63D0\53D6\3002'),
unistr('        \9AD8\901F\7F13\5B58\7684\7ED3\679C\53EF\4EE5\6781\5927\63D0\5347\6027\80FD, \7279\522B\662F\5F53\672C\5730\6570\636E\5E93\4E0E\8FDC\7A0B\6570\636E\5E93\4E4B\95F4\5B58\5728\5EF6\8FDF\65F6\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994242650312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9002\7528\4E8E\6240\6709\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994340666312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\679C\5C06\4F1A\7F13\5B58\5E76\7531\6240\6709\7528\6237\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994682205312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994740323312322)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9488\5BF9\6BCF\4E2A\7528\6237\4F1A\8BDD\7F13\5B58\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994476896312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994515012312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DE8\4F1A\8BDD\4E13\95E8\9488\5BF9\5404\4E2A\7528\6237\7F13\5B58\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994099922312321)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995084168312322)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\6570\636E\5728\9AD8\901F\7F13\5B58\4E86 15 \5206\949F\4E4B\540E\5931\6548</dt>'),
'  <dd><pre>15</pre></dd>',
unistr('<dt>\6570\636E\5728\6574\70B9\65F6\95F4\5931\6548</dt>'),
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
unistr('<dt>\6570\636E\5728\5348\591C\5931\6548</dt>'),
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994993957312322)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4F7F\9AD8\901F\7F13\5B58\7684\6570\636E\5931\6548\7684\65F6\95F4\3002'),
unistr('        \63D0\4F9B\5206\949F\6570\6216 DBMS_SCHEDULER \65E5\5386\5B57\7B26\4E32\3002</p>'),
unistr('        <p>\5BF9\4E8E DBMS_SCHEDULER \65E5\5386\5B57\7B26\4E32, \60A8\53EF\4EE5\5B9A\4E49\9AD8\901F\7F13\5B58\7684\6570\636E\5728\67D0\4E2A\5C0F\65F6\7684\5F00\59CB, \5728\5348\591C\6216\8005\5728\5176\4ED6\7279\5B9A\91CD\590D\65F6\95F4\70B9\5931\6548\3002'),
unistr('        \6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605 DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING \7684\76F8\5173\6587\6863\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107994875158312322)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\901F\7F13\5B58\8D85\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232082110312508)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\6B64\4EA4\4E92\5F0F\62A5\8868\533A\57DF\7684\5B57\6BCD\6570\5B57\522B\540D\3002'),
unistr('\6B64\522B\540D\5728\5E94\7528\7A0B\5E8F\4E2D\5FC5\987B\552F\4E00\3002'),
unistr('\53EF\4EE5\4F7F\7528\522B\540D\5728\5B9A\5236 API \8C03\7528\4E2D\5F15\7528\4EA4\4E92\5F0F\62A5\8868\533A\57DF\3002'),
unistr('\4F8B\5982, \53EF\4EE5\7F16\5199\51FD\6570, \901A\8FC7\67E5\8BE2 <code>APEX_APPLICATION_PAGE_IR</code> \89C6\56FE\4E2D\7684 <code>ALIAS</code> \5217\8FD4\56DE <code>INTERACTIVE_REPORT_ID</code>\3002'),
unistr('\7531\4E8E <code>INTERACTIVE_REPORT_ID</code> \503C\53EF\4EE5\5728\5BFC\51FA\5E94\7528\7A0B\5E8F\6216\5C06\5E94\7528\7A0B\5E8F\5BFC\5165\5230\5176\4ED6\5B9E\4F8B\65F6\53D1\751F\66F4\6539, \56E0\6B64\4F7F\7528\522B\540D\5F15\7528\4EA4\4E92\5F0F\62A5\8868\533A\57DF\53EF\80FD\66F4\53EF\53D6\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231948098312508)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225511537312502)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\503C\5217\8868\65E5\671F\9650\5236\3002'),
unistr('\5BF9\4E8E\65E5\671F\5217, \503C\5217\8868\53EF\4EE5\5728\62A5\8868\5217\4E0B\62C9\5217\8868\7684\8FC7\6EE4\5668\4E2D\663E\793A\8FC7\53BB\65F6\95F4, \5C06\6765\65F6\95F4\6216\540C\65F6\663E\793A\4E8C\8005\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428723036312670)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428922075312670)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6765')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108428879057312670)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108225459137312502)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\8303\56F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232244985312508)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5176\503C\5B58\50A8\5DF2\4FDD\5B58\7684\62A5\8868 ID \7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\4EA4\4E92\5F0F\62A5\8868\4F7F\7528\6B64\9879\503C\94FE\63A5\5230\5DF2\4FDD\5B58\7684\62A5\8868\3002'),
unistr('\4F8B\5982, \53EF\4EE5\5B9A\4E49\5DF2\4FDD\5B58\7684\62A5\8868\5217\8868, \5E76\4E0E\5B9A\4E49\7684\9879\540D\79F0\548C\5DF2\4FDD\5B58\7684\62A5\8868 ID \76F8\94FE\63A5\4F5C\4E3A\5176\503C, \4EE5\94FE\63A5\5230\5DF2\4FDD\5B58\7684\9ED8\8BA4\62A5\8868, \516C\5171\62A5\8868\6216\4E13\7528\62A5\8868\3002'),
unistr('\5DF2\4FDD\5B58\7684\62A5\8868 ID \53EF\4ECE <code>APEX_APPLICATION_PAGE_IR_RPT</code> \89C6\56FE\68C0\7D22\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108232190839312508)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868 ID \9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373281337312623)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108373813934312623)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372833728312622)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\6253\5370\62A5\8868\65F6\4F7F\7528\7684\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108372778125312622)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263145478312534)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\63A7\5236\6B64\62A5\8868\663E\793A\7684\9884\5B9A\4E49\62A5\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442313120312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML (\6807\51C6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442461952312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6807\51C6 HTML \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442556252312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442624941312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E0D\540C\7684\884C\663E\793A\6BCF\4E00\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442779207312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'zh-cn'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442858835312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\62A5\8868\5BFC\51FA\4E3A CSV \6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442986191312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'zh-cn'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108443052258312681)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\62A5\8868\5BFC\51FA\4E3A XML \6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108263083419312534)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265389569312536)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\62A5\8868\603B\548C\503C\65C1\8FB9\663E\793A\7684\6587\672C\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108265294393312536)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\603B\548C\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258600690312530)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\62A5\8868\6A21\677F\4EE5\5B9A\4E49\6B64\7ECF\5178\62A5\8868\7684\5916\89C2\548C\5E03\5C40\3002</p>'),
unistr('        <p>\62A5\8868\6A21\677F\5728\5E94\7528\7A0B\5E8F\4E3B\9898\4E2D\5B9A\4E49\3002'),
unistr('        \521B\5EFA\7ECF\5178\62A5\8868\65F6, \6A21\677F\81EA\52A8\8BBE\7F6E\4E3A\5728\5F53\524D\4E3B\9898\4E2D\5B9A\4E49\7684\9ED8\8BA4\62A5\8868\6A21\677F\3002</p>'),
unistr('        <p>\8BB8\591A\4E3B\9898\5305\542B\7ECF\5178\62A5\8868\6A21\677F, \7528\4E8E\663E\793A\8868\4E2D\7684\6570\636E, \952E\503C\5BF9, \641C\7D22\7ED3\679C\548C\5361\7B49\4FE1\606F\3002'),
unistr('        \8BF7\6CE8\610F, \67D0\4E9B\62A5\8868\6A21\677F (\4F8B\5982\5361\548C\641C\7D22\7ED3\679C) "\57FA\4E8E\884C" \5E76\9884\671F SQL \67E5\8BE2\8FD4\56DE\5728\6A21\677F\4E2D\66FF\6362\7684\4E00\7EC4\7279\5B9A\5217\522B\540D\3002<br>'),
unistr('        \901A\7528\4E3B\9898\63D0\4F9B\4EE5\4E0B\62A5\8868\6A21\677F:'),
'          <dl>',
unistr('            <dt>\9884\8B66</dt>'),
unistr('              <dd>\5728\9875\4E0A\663E\793A\4EFB\610F\6570\91CF\7684\6C34\5E73\9884\8B66\6216\901A\77E5\3002</dd>'),
unistr('            <dt>\5FBD\7AE0\5217\8868</dt>'),
unistr('              <dd>\5728\7C7B\4F3C\4E8E\9762\677F\7684\7528\6237\754C\9762\4E2D\663E\793A\952E\503C\5BF9\3002</dd>'),
unistr('            <dt>\5361</dt>'),
unistr('              <dd>\5728\5361\6216\5C0F\65B9\5757\4E2D\663E\793A\62A5\8868\6570\636E, \8FD9\5BF9\4E8E\5448\73B0\591A\79CD\4FE1\606F\975E\5E38\6709\7528\3002\5361\53EF\4EE5\901A\8FC7\201C\6A21\677F\9009\9879\201D\6DF1\5EA6\5B9A\5236\3002</dd>'),
unistr('            <dt>\6CE8\91CA</dt>'),
unistr('              <dd>\663E\793A\6CE8\91CA\548C\5176\4ED6\6D88\606F\3002</dd>'),
unistr('            <dt>\641C\7D22\7ED3\679C</dt>'),
unistr('              <dd>\663E\793A\641C\7D22\5F15\64CE\6837\5F0F\641C\7D22\7ED3\679C</dd>'),
unistr('            <dt>\6807\51C6</dt>'),
unistr('              <dd>\8FD9\662F\7528\4E8E\5728\8868\4E2D\663E\793A\6570\636E\7684\9ED8\8BA4\62A5\8868\6A21\677F, \53EF\901A\8FC7\201C\6A21\677F\9009\9879\201D\6DF1\5EA6\5B9A\5236\3002</dd>'),
unistr('            <dt>\65F6\95F4\8868</dt>'),
unistr('              <dd>\663E\793A\64CD\4F5C\7684\65F6\95F4\8868\3002\8FD9\975E\5E38\9002\5408\4E3B\9875, \66F4\6539\65E5\5FD7\548C\9700\8981\6700\8FD1\64CD\4F5C\7684\6D3B\52A8\6E90\7684\5176\4ED6\533A\57DF\3002</dd>'),
unistr('            <dt>\503C\5C5E\6027\5BF9 - \5217</dt>'),
unistr('              <dd>\4E3A\57FA\4E8E\5217\7684\67E5\8BE2\663E\793A\952E\503C\5BF9\3002\5B83\4F7F\7528\5217\6807\9898\4F5C\4E3A\6BCF\4E2A\9879\7684\6807\7B7E\3002</dd>'),
unistr('            <dt>\503C\5C5E\6027\5BF9 - \884C</dt>'),
unistr('              <dd>\4E3A\57FA\4E8E\884C\7684\67E5\8BE2\663E\793A\952E\503C\5BF9\3002\5B83\4E3A\6807\7B7E\4F7F\7528\7B2C\4E00\5217, \4E3A\503C\4F7F\7528\7B2C\4E8C\5217\3002</dd>'),
'          </dl>',
unistr('          \53E6\8BF7\53C2\9605: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">\901A\7528\4E3B\9898\793A\4F8B\5E94\7528\7A0B\5E8F</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258530609312530)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120429189312419)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\963B\6B62\4EA4\4E92\5F0F\7F51\683C\663E\793A\6570\636E, \9664\975E\5728\67D0\4E00\62A5\8868\5217\4E0A\5B9A\4E49\4E86\81F3\5C11\4E00\4E2A\8FC7\6EE4\5668\3002'),
unistr('		\6B64\9009\9879\8BBE\8BA1\4E3A\901A\8FC7\57FA\4E8E\8FC7\6EE4\5668\9650\5236\8FD4\56DE\7684\884C, \9650\5236\4ECE\975E\5E38\5927\7684\6570\636E\96C6\52A0\8F7D\7684\6570\636E\3002</p>'),
unistr('		<p>\53EF\5BF9\5404\5217\542F\7528<strong>\9700\8981\5217\8FC7\6EE4\5668</strong>\4EE5\786E\4FDD\6B64\5217\9700\8981\8FC7\6EE4\5668, \800C\6B64\9009\9879\5728\4EFB\610F\591A\5217\4E0A\53EA\9700\8981\4E00\4E2A\8FC7\6EE4\5668\3002</p>'),
unistr('		<p>\6CE8 - \8BBE\7F6E\4E86\6B64\9009\9879\800C\5F53\524D\672A\5B9A\4E49\4EFB\4F55\8FC7\6EE4\5668\65F6, \5C06\4F1A\663E\793A\4E00\6761\6D88\606F, \8BF7\6C42\7528\6237\8F93\5165\8FC7\6EE4\5668\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120361810312419)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108276588588312545)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\4FDD\5B58\6240\6709\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919360000312261)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\9650\5236\53EF\5728\4F1A\8BDD\72B6\6001\4E2D\4FDD\5B58\7684\5B57\7B26\3002'),
unistr('\5982\679C\7528\6237\5C1D\8BD5\4FDD\5B58\4E0D\7B26\5408\6240\9009\5B57\7B26\9650\5236\7684\6570\636E, &PRODUCT_NAME. \5C06\663E\793A\4E00\6761\9519\8BEF\6D88\606F\3002</p>'),
unistr('<p>\901A\8FC7\9650\5236\5B57\7B26\53EF\589E\5F3A\5E94\7528\7A0B\5E8F\5B89\5168\6027, \5E76\4E14\662F\9632\8303\8DE8\7AD9\70B9\811A\672C\7F16\5199 (XSS) \653B\51FB\7684\53EF\80FD\63AA\65BD\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417647267312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\963B\6B62\5217\8868\FF1A&<>"/;,*|=% \548C --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417700229312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4FDD\5B58\4EE5\4E0B\5B57\7B26: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % \548C "--" (PL/SQL \6CE8\91CA)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417832522312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\963B\6B62\5217\8868\FF1A&<>"/;,*|=% \6216 -- \548C\6362\884C\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417920212312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4FDD\5B58\4EE5\4E0B\5B57\7B26: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, %, "--" \548C\65B0\884C\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417250134312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\5217\8868\5305\542B a-Z\30010-9 \548C\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417308288312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\80FD\4FDD\5B58\5B57\7B26 a-z, A-Z, 0-9 \548C\7A7A\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417419924312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\963B\6B62\5217\8868\FF1AHTML \547D\4EE4\5B57\7B26 (<>")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417522579312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4FDD\5B58\4FDD\7559\7684 HTML \5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108418072165312658)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107919222638312261)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D7\9650\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683435120312868)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6240\5448\73B0\5185\5BB9\7684\8F93\5165\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683501789312868)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'zh-cn'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683679133312868)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\5305\542B HTML \6807\8BB0\FF0C\5E76\4E14\5728\5448\73B0\65F6\4E0D\5E94\7528\7279\6B8A\5B57\7B26\8F6C\4E49\3002\8BF7\786E\4FDD\6570\636E\662F\5B89\5168\7684\FF0C\5E76\4E14\4E0D\5305\542B\6700\7EC8\7528\6237\8F93\5165\7684\6570\636E\FF0C\4EE5\907F\514D\8DE8\7AD9\70B9\811A\672C (XSS) \6F0F\6D1E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683747556312868)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683855045312868)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\5305\542B Markdown \6807\8BB0\FF0C\8BE5\6807\8BB0\5728\5448\73B0\4E4B\524D\4F1A\8F6C\6362\6210\5B89\5168\7684 HTML \6807\8BB0\3002\8F6C\6362\4F17\6240\5468\77E5\7684 Markdown \6807\8BB0\6709\52A9\4E8E<strong>\9632\6B62</strong>\8DE8\7AD9\70B9\811A\672C (XSS) \6F0F\6D1E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683354346312868)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119655923312419)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5B58\50A8\8981\66F4\65B0\7684\8868\7684\884C\7248\672C\53F7\7684\5217\3002\6B64\5217\5C06\7528\5728\4E22\5931\66F4\65B0\68C0\67E5\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119524602312418)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\7248\672C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243220369312517)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\5904\7406\7684\6267\884C\9891\7387\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433319652312673)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\6B21\8BBF\95EE\9875\65F6\4E00\6B21 (\9ED8\8BA4\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108433263111312673)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\4F1A\8BDD\4E00\6B21\6216\5F53\91CD\7F6E\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243178762312517)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229023108312505)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6388\6743\65B9\6848\4EE5\9650\5236\53EF\4EE5\4FDD\5B58\516C\5171\62A5\8868\5B9A\4E49\7684\7528\6237\3002'),
unistr('\8981\4F7F\6700\7EC8\7528\6237\53EF\4EE5\4FDD\5B58\516C\5171\62A5\8868, \6B64\6388\6743\65B9\6848\5FC5\987B\6C42\503C\4E3A TRUE\3002'),
unistr('\5982\679C\672A\63D0\4F9B\6388\6743\65B9\6848, \5219\53EF\4EE5\7531\4EFB\4F55\7528\6237\4FDD\5B58\62A5\8868\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228916207312505)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\516C\5171\62A5\8868\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001434468312326)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\5728\6267\884C\5206\652F\4E4B\524D\662F\5426\5C06\4F1A\8BDD\72B6\6001\4E2D\7684\503C\4FDD\5B58\5230\6570\636E\5E93\3002'),
unistr('\5982\679C\5BFC\822A\5230\9700\8981\4ECE\6B64\5E94\7528\7A0B\5E8F\8BBF\95EE\4F1A\8BDD\72B6\6001\503C\7684\5176\4ED6\5E94\7528\7A0B\5E8F\FF0C\8BF7\52A1\5FC5\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001301117312326)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDB\884C\5206\652F\4E4B\524D\4FDD\5B58\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988300613312313)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\7528\4F5C\8986\76D6\8BED\6CD5\5206\6790\65B9\6848\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\8FD9\4EC5\9002\7528\4E8E\5185\90E8\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988231071312313)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\8986\76D6\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608295461312810)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608114638312810)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607452177312809)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\9009\62E9\5C06\5982\4F55\5E94\7528\6B64\6388\6743\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607526179312810)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607668904312810)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\67E5\8BE2\8FD4\56DE\503C\65F6\6388\6743\4F1A\901A\8FC7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607946224312810)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608008059312810)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607734423312810)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728 SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607857163312810)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\67E5\8BE2\4E0D\8FD4\56DE\4EFB\4F55\503C\65F6\6388\6743\4F1A\901A\8FC7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108607300566312809)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229260134312505)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\641C\7D22\6309\94AE\6807\7B7E\8F93\5165\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108229160432312505)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590814049312796)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\7EC4\4EF6\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590752017312796)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591007556312796)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\6B21\7EA7\6B63\6587\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108590914842312796)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591542407312797)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591451805312797)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591305539312797)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591213418312797)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108591177871312797)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987152097312312)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A<strong>\542F\7528</strong>\4EE5\5141\8BB8\4EC5\5728\534F\8BAE\4E3A HTTPS \65F6\624D\4ECE\6D4F\89C8\5668\53D1\9001\4F1A\8BDD\7BA1\7406 cookie\3002'),
unistr('\9009\62E9<strong>\7981\7528</strong>\4EE5\5141\8BB8\5728\534F\8BAE\4E3A HTTP \6216 HTTPS \65F6\4ECE\6D4F\89C8\5668\53D1\9001\4F1A\8BDD\7BA1\7406 cookie\3002</p>'),
unistr('<p>\5982\679C\5728 Web \670D\52A1\5668\4E0A\914D\7F6E\4E86 SSL\FF0C\5219\5E94\9009\62E9<strong>\542F\7528</strong>\4EE5\901A\8FC7\7981\6B62\672A\52A0\5BC6\7684 HTTP \901A\4FE1\6765\52A0\5F3A\5E94\7528\7A0B\5E8F\7684\5B89\5168\6027\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107987086932312312)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143601994312438)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\81EA\52A8\9009\62E9\7B2C\4E00\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108143580249312438)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7B2C\4E00\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283754796312552)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217\56FE\8868\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178285459312465)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\5B9A\4E49\591A\7CFB\5217\52A8\6001\67E5\8BE2\7684\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108178125510312465)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918771568312261)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4F1A\8BDD\72B6\6001\4FDD\62A4\7EA7\522B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416403729312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \5E94\7528\7A0B\5E8F\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416564479312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\4F20\9012 URL (\5305\542B\7279\5B9A\4E8E\5DE5\4F5C\533A\548C\5E94\7528\7A0B\5E8F\7684\6821\9A8C\548C) \4E2D\7684\9879\6765\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417023942312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9650\5236 - \4E0D\80FD\4ECE\6D4F\89C8\5668\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108417127134312658)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0D\80FD\4F7F\7528 URL \6216 POSTDATA \6765\53D8\66F4\9879\3002'),
unistr('\9009\62E9\6B64\9009\9879\53EF\4EE5\9650\5236\53EF\5C06\9879\503C\8BBE\7F6E\4E3A\5185\90E8\5904\7406, \8BA1\7B97\7B49\7684\5BF9\8C61\3002'),
unistr('\6B64\5C5E\6027\4EC5\9002\7528\4E8E\672A\7528\4F5C\6570\636E\6761\76EE\9879\7684\9879, \5373\4F7F\7981\7528\4E86\4F1A\8BDD\72B6\6001\4FDD\62A4, \4E5F\59CB\7EC8\9075\5B88\6B64\5C5E\6027\3002'),
unistr('\5BF9\5177\6709\4EE5\4E0B<strong>\663E\793A\4E3A</strong>\7C7B\578B\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\4F7F\7528\6B64\5C5E\6027:'),
'<ul>',
unistr('  <li>\4EC5\663E\793A (\4E0D\4FDD\5B58\72B6\6001)</li>'),
unistr('  <li>\6587\672C\5B57\6BB5 (\7981\7528, \4E0D\4FDD\5B58\72B6\6001)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416216045312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9650\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416348234312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\4F20\9012 URL \6216\8868\5355\4E2D\7684\9879\6765\8BBE\7F6E\9879\3002URL \4E2D\4E0D\9700\8981\6821\9A8C\548C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416648553312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \7528\6237\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416700500312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\4F20\9012 URL (\5305\542B\7279\5B9A\4E8E\5DE5\4F5C\533A, \5E94\7528\7A0B\5E8F\548C\7528\6237\7684\6821\9A8C\548C) \4E2D\7684\9879\6765\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416820304312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6821\9A8C\548C - \4F1A\8BDD\7EA7\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108416912381312657)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\4F20\9012 URL\FF08\5305\542B\7279\5B9A\4E8E\4F1A\8BDD\7684\6821\9A8C\548C\FF09\4E2D\7684\9879\6765\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107918603902312260)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\72B6\6001\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940645033312277)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\6B64\590D\9009\6846\76F8\5173\8054\7684\7B5B\9009\5668\7EC4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940580922312277)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B5B\9009\5668\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703922298312884)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608377696312810)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704050045312884)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239412268312514)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\641C\7D22\680F\5185\5305\62EC<em>\64CD\4F5C</em>\83DC\5355\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239355600312514)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\201C\64CD\4F5C\201D\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236659628312512)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\805A\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236584249312512)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222318399312500)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\9ED8\8BA4\60C5\51B5\4E0B\662F\5426\5728\62A5\8868\4E2D\663E\793A\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222276206312500)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\60C5\51B5\4E0B\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236812111312512)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\56FE\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236721587312512)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236440799312512)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\8BA1\7B97\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236385167312511)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236071849312511)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\63A7\5236\5206\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235992573312511)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941065404312278)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\5F53\524D\9762\5217\8868\4E2D\9009\5B9A\503C\7684\65C1\8FB9\663E\793A\9762\6807\7B7E\3002\5982\679C\9009\5B9A\503C\7684\542B\4E49\4E0D\8A00\81EA\660E\FF08\4F8B\5982\8BA2\5355\72B6\6001\FF09\FF0C\5219\9690\85CF\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940951826312278)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5F53\524D\9762\7684\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239001369312514)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\5728\641C\7D22\680F\5185\5305\62EC\5355\72EC\7684\4E0B\62C9\884C\9009\62E9\5668\3002'),
unistr('\4E0D\5E94\540C\65F6\9009\62E9\6B64\5C5E\6027\548C<strong>\6BCF\9875\884C\6570</strong>\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238968181312514)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\6BCF\9875\884C\6570\201D\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237856734312513)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5C06\62A5\8868\4E0B\8F7D\4E3A\6307\5B9A\7684\67D0\79CD\4E0B\8F7D\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237771144312513)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235292109312511)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\5728\6B64\62A5\8868\4E0A\5B9A\4E49\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235152149312510)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238894284312514)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\662F\5426\5728\641C\7D22\680F\5185\7684\201C\641C\7D22\201D\5B57\6BB5\5F00\5934\5305\62EC\67E5\627E\5668\4E0B\62C9\5217\8868\3002'),
unistr('\67E5\627E\5668\4E0B\62C9\5217\8868\662F\5217\7684\5217\8868, \4F7F\7528\6237\53EF\4EE5\5C06\5176\641C\7D22\9650\5236\5230\7279\5B9A\5217\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238714799312513)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\5668\4E0B\62C9\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237438409312512)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\4F7F\7528\95EA\56DE\67E5\8BE2\3002</p>'),
unistr('<p>\95EA\56DE\67E5\8BE2\4F7F\7528 Oracle \95EA\56DE\6280\672F\548C\6570\636E\5E93\65F6\95F4\70B9\6062\590D\6765\67E5\770B\4E4B\524D\7684\67D0\4E2A\65F6\95F4\70B9\4E0A\5B58\5728\7684\6570\636E\3002\7528\6237\53EA\80FD\67E5\8BE2\6B64\6570\636E, \4F46\4E0D\80FD\540E\9000\4EFB\4F55\6570\636E\66F4\6539\3002\7528\6237\53EF\4EE5\6210\529F\6267\884C\95EA\56DE\67E5\8BE2\7684\4EE5\524D\65F6\95F4\957F\5EA6\7531\4E0A\6B21\5728 Oracle \6570\636E\5E93\5185\5207\6362\91CD\505A\65E5\5FD7\6587\4EF6\7684\65F6\95F4\786E\5B9A, \56E0\4E3A\6B64\6280\672F\4F7F\7528 RMAN \5907\4EFD\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237316114312512)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237221964312512)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\5206\7EC4\65B9\5F0F\7EC6\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237167271312512)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108175048315312462)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\7EC4\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174956015312462)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7EC4\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108238048568312513)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\4EA4\4E92\5F0F\62A5\8868\8C03\7528\5185\7F6E\7684\5E2E\52A9\6A21\5F0F\5BF9\8BDD\6846\3002</p>'),
unistr('<p>\5E2E\52A9\5BF9\8BDD\6846\4EC5\5217\51FA\90A3\4E9B\53EF\4F9B\5F53\524D\7528\6237\4F7F\7528\7684\9009\9879\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237934456312513)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236260119312511)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\7A81\51FA\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236116527312511)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559797602312773)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\5C42\662F\5426\8981\663E\793A\5728\56FE\4F8B\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559667432312773)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237009638312512)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\8BA2\9605\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108236969947312512)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228451366312505)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\4E3A\7A7A\503C\5217\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228366956312505)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\7A7A\503C\663E\793A\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537185757311966)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\900F\89C6\7EC6\5206\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537069304311966)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914129698312257)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4E3A\6B64\9875\9879\663E\793A\5FEB\901F\9009\53D6\3002'),
unistr('\901A\8FC7\5FEB\901F\9009\53D6, \7528\6237\53EA\9700\5355\51FB\4E00\6B21\5373\53EF\9009\62E9\9884\5B9A\4E49\503C, \800C\4E0D\662F\952E\5165\6587\672C\6216\4ECE\53EF\7528\9009\9879\5217\8868\4E2D\9009\62E9\3002</p>'),
unistr('<p>\5F53\5B58\5728\76F8\5BF9\8F83\5C0F\7684\79BB\6563<em>\5E38\7528</em>\8F93\5165\503C\96C6\65F6, \5E94\6307\5B9A\5FEB\901F\9009\53D6\3002'),
unistr('\6700\591A\53EF\4EE5\4E3A\4E00\9879\5B9A\4E49\5341\4E2A\5FEB\901F\9009\53D6\3002'),
unistr('\4E3A\5177\6709\8F83\957F\7684\53EF\7528\503C\9009\62E9\5217\8868\7684\9879\5B9A\4E49\65F6, \8FD9\79CD\7528\6237\5E2E\52A9\5C24\4E3A\6709\7528\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107914085493312257)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5FEB\901F\9009\53D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239611369312514)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\641C\7D22\680F\4E2D\663E\793A\201C\62A5\8868\201D\9009\62E9\5217\8868\3002</p>'),
unistr('<p>\4EC5\5F53\7528\6237\53EF\4EE5\8BBF\95EE\4E3B\62A5\8868\4E4B\5916\7684\62A5\8868\65F6, \624D\663E\793A\201C\62A5\8868\201D\9009\62E9\5217\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239567027312514)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9009\62E9\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237688278312513)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4ECE\201C\64CD\4F5C\201D\83DC\5355\91CD\7F6E\5176\62A5\8868\3002</p>'),
unistr('<p>\901A\8FC7\91CD\7F6E\62A5\8868\5C06\8FD8\539F\7528\6237\6240\505A\7684\6216\8C03\7528\7684 URL \6240\6307\5B9A\7684\6240\6709\5B9A\5236\8BBE\7F6E, \5E76\663E\793A\4E3B\62A5\8868\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108237512606312512)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235686561312511)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\66F4\6539\4E3A\6B64\62A5\8868\663E\793A\7684\884C\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235501711312511)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239284861312514)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\641C\7D22\680F\5185\5305\62EC\641C\7D22\5B57\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108239101255312514)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235461022312511)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4F7F\7528\201C\64CD\4F5C\201D\83DC\5355\4E2D\7684<strong>\9009\62E9\5217</strong>\66F4\6539\6B64\62A5\8868\4E2D\663E\793A\7684\5217\3002\7528\6237\53EF\4EE5\4F7F\7528\6B64\9009\9879\9009\62E9 (\6216\663E\793A), \53D6\6D88\9009\62E9 (\6216\9690\85CF) \4EE5\53CA\91CD\6392\5E8F\591A\4E2A\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235369942312511)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174873933312462)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\56FE\8868\4E0A\5448\73B0\7684\5DE5\5177\63D0\793A\4E2D\663E\793A\7CFB\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174796653312462)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7CFB\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235838900312511)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6700\7EC8\7528\6237\662F\5426\53EF\4EE5\4E3A\6B64\62A5\8868\5B9A\4E49\6392\5E8F\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108235764769312511)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107940034532312277)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5728\5EFA\8BAE\6761\4E2D\663E\793A\7B5B\9009\5668\7684\6807\7B7E\8FD8\662F\4EC5\663E\793A\503C\3002\5982\679C\5EFA\8BAE\503C\7684\542B\4E49\4E0D\8A00\81EA\660E\FF08\4F8B\5982\8BA2\5355\72B6\6001\FF09\FF0C\5219\9690\85CF\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939979960312277)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121442465312420)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5728\62A5\8868\4E0A\65B9\663E\793A\5DE5\5177\680F\3002\5DE5\5177\680F\53EF\4EE5\5305\62EC\641C\7D22, \62A5\8868\7C7B\578B, \5DF2\4FDD\5B58\7684\62A5\8868, \64CD\4F5C, \66F4\6539\548C\91CD\7F6E\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121378240312420)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121284645312420)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\62A5\8868\9875\811A\5904\663E\793A\603B\884C\6570\3002<p/>'),
unistr('        <p>\6CE8 - \9700\6267\884C\989D\5916\7684\67E5\8BE2\6765\83B7\53D6\603B\884C\6570, \8FD9\53EF\80FD\4F1A\5F71\54CD\6027\80FD, \5C24\5176\662F\6570\636E\96C6\975E\5E38\5927\65F6\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108121162896312420)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\603B\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256663275312528)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BF9\4E8E\201C\7B80\5355\590D\9009\6846\201D\663E\793A\7C7B\578B, \8BF7\8F93\5165\4E00\4E2A\503C\6216\4E24\4E2A\4EE5\9017\53F7\5206\9694\7684\503C\3002'),
unistr('\5982\679C\9009\4E2D\590D\9009\6846, \5219\63D0\4EA4\7B2C\4E00\4E2A\503C\3002\5982\679C\5B9A\4E49\4E86\7B2C\4E8C\4E2A\503C, \5219\5728\53D6\6D88\9009\4E2D\590D\9009\6846\65F6\63D0\4EA4\6B64\503C\3002'','),
'        p_examples           => q''~<dl>',
unistr('<dt>\9009\4E2D\65F6\63D0\4EA4 Yes, \53D6\6D88\9009\4E2D\65F6\63D0\4EA4 No</dt>'),
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256548519312528)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\9009\6846\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222958839312500)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\5355\884C\89C6\56FE\4E2D\4F7F\7528\7684\5217\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222825753312500)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264577401312535)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\542F\7528\5217\6807\9898\6392\5E8F\7684\62A5\8868\5217, \9009\62E9\5E0C\671B\5982\4F55\76F8\5BF9\4E8E\5177\6709\975E\7A7A\503C\7684\8BB0\5F55\6392\5E8F\5177\6709\7A7A\503C\7684\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444102584312682)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444256987312682)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5177\6709\975E\7A7A\503C\7684\4EFB\4F55\5217\4E4B\524D\663E\793A\5177\6709\7A7A\503C\7684\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444371262312682)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108444465575312682)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5177\6709\7A7A\503C\7684\4EFB\4F55\5217\4E4B\524D\663E\793A\5177\6709\975E\7A7A\503C\7684\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264465578312535)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537800702311967)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\6B64\9875\5173\8054\7684\9762\5305\5C51\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537702529311967)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770393666312935)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\7528\4F5C\6B64\9762\7684\6E90\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108578747214312787)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\7528\4F5C\6B64\9762\7684\6E90\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942043832312278)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\7528\4F5C\6B64\7B5B\9009\5668\6E90\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943172976312279)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\8F93\5165\7528\4F5C\6B64\7B5B\9009\5668\6E90\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912954812312256)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4F5C\6B64\9879\503C\6E90\7684\533A\5206\5927\5C0F\5199\7684\6570\636E\5E93\5217\540D\3002</p>'),
unistr('<p>\6B64\5217\5FC5\987B\5B58\5728\4E8E\6B64\9875\4E0A\5B9A\4E49\7684\5185\7F6E\63D0\53D6\884C\5904\7406\5185\6307\5B9A\7684\8868\4E2D\3002'),
unistr('\5982\679C\6570\636E\5E93\5217\540D\4E0D\5B58\5728\4E8E\5F15\7528\7684\8868\4E2D, \5219\5C06\5F15\53D1\9519\8BEF, \5E76\4E14\4E0D\52A0\8F7D\6B64\9875\3002'),
unistr('\540C\6837, \5982\679C\672A\5B9A\4E49\5185\7F6E\63D0\53D6\884C\5904\7406\4F46\5B58\5728\6E90\7C7B\578B\4E3A<strong>\6570\636E\5E93\5217</strong>\7684\9879, \5219\5C06\5F15\53D1\9519\8BEF, \5E76\4E14\5728\5C1D\8BD5\5448\73B0\6B64\9875\65F6\5C06\4E0D\4F1A\52A0\8F7D\6B64\9875\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912841075312256)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651335122312843)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651752012312844)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651653993312843)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651569390312843)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651836054312844)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651498650312843)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651213426312843)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349205958312604)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\6B64\5206\9762\641C\7D22\6216\667A\80FD\7B5B\9009\5668\533A\57DF\5173\8054\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108349162185312604)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653341699312845)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653689839312845)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653597836312845)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653410131312845)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653766620312845)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653211010312845)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912775761312256)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\7528\4F5C\6B64\9879\503C\7684\6E90\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912690647312256)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682138511312867)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6267\884C\7684 Java \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682083872312867)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652917475312844)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652809104312844)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654545399312846)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654471574312846)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681928462312867)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\9488\5BF9\7B26\5408\52A0\85AA\6761\4EF6\7684\5458\5DE5\5C06\85AA\6C34\589E\52A0 3%\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
'    // placeholder for some complicated logic to calculate if employee needs a raise',
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681859197312867)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6267\884C\7684 JavaScript \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681787794312867)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652717681312844)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652602616312844)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652585438312844)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654301185312846)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654245757312845)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654118698312845)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537688982311967)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\5217\8868\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537572133311966)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995213713312322)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6570\636E\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995374022312322)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672C\5730\6570\636E\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995471013312322)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\672C\5730\6570\636E\5E93\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995549720312322)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995660179312322)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\8FDC\7A0B\6570\636E\5E93\FF0C\6570\636E\5E93\8FDE\63A5\4F7F\7528\542F\7528 REST \7684 SQL \6765\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105726101312408)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108712302143312890)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6E90\81EA\4F7F\7528 REST \6570\636E\6E90\5B9A\4E49\7684 RESTful Web \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995150485312322)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190976461312475)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\4F7F\7528\5355\72EC\8BF7\6C42\8BFB\53D6\56FE\8868\6570\636E\65F6, \5F53\524D\9875\4E0A\8981\8BBE\7F6E\5230\4F1A\8BDD\72B6\6001\4E2D\7684\9875\9879\FF08\4EE5\9017\53F7\5206\9694\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108558467981312772)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\4F7F\7528\5355\72EC\8BF7\6C42\63D0\53D6\5730\56FE\6570\636E\65F6\FF0C\5F53\524D\9875\4E0A\8981\8BBE\7F6E\5230\4F1A\8BDD\72B6\6001\4E2D\7684\9875\9879\7684\9017\53F7\5206\9694\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988121455312313)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\901A\8FC7\90E8\5206\9875\5237\65B0\6765\5237\65B0\533A\57DF\65F6\8981\8BBE\7F6E\5230\4F1A\8BDD\72B6\6001\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\5BF9\4E8E\591A\4E2A\9879\FF0C\7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C\FF0C\5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7\FF0C\540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002</p>'),
unistr('<p>\53EF\4EE5\5728\5206\9875\671F\95F4\4F7F\7528\90E8\5206\9875\5237\65B0\FF08\5982\679C<em>\542F\7528\90E8\5206\9875\5237\65B0</em>\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF09\6216\4F7F\7528\52A8\6001\64CD\4F5C\4E2D\7684\201C\5237\65B0\201D\64CD\4F5C\6765\5237\65B0\533A\57DF\3002</p>'),
unistr('\7136\540E\FF0C\53EF\4EE5\5728\533A\57DF\6E90 SQL \67E5\8BE2\7684 <em>Where \6761\4EF6</em>\4E2D\4F7F\7528\8FD9\4E9B\9875\9879\6765\9650\5236\67E5\8BE2\7ED3\679C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107988047617312313)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\63D0\4EA4\7684\9875\9879')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681675166312866)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\9488\5BF9\7B26\5408\52A0\85AA\6761\4EF6\7684\5458\5DE5\5C06\85AA\6C34\589E\52A0 3%\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681514000312866)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6267\884C\7684 PL/SQL \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681431940312866)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652439707312844)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652366185312844)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652296619312844)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654009777312845)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653971020312845)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653820251312845)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717655772312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\5BF9\5728\672C\5730\6570\636E\5E93\4E2D\68C0\7D22\5230\7684 REST \6E90\6570\636E\8FDB\884C\540E\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718130801312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718209496312895)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53, \5728\5176\4E2D\8FD4\56DE\7684 SQL \67E5\8BE2\4F1A\8F6C\6362\68C0\7D22\5230\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717988181312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108718097671312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \67E5\8BE2\4EE5\8F6C\6362\68C0\7D22\5230\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717795540312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Where/Order By \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717813823312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 where \548C/\6216 order by \5B50\53E5\4EE5\9650\5236\548C\6392\5E8F\68C0\7D22\5230\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108717536854312894)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913171519312256)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\7528\4F5C\6B64\9879\503C\7684\6E90\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107913027166312256)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682323306312867)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6267\884C\7684 Python \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108682229567312867)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653132382312845)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108653095674312845)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654725670312846)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108654671052312846)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912379069312256)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4F5C\6B64\9879\503C\7684\6E90\7684 SQL \67E5\8BE2\3002\5982\679C\8FD4\56DE\4E86\591A\884C, \5219\4F7F\7528\7B2C\4E00\884C\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912214282312256)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912505149312256)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8FD4\56DE\8981\7528\4F5C\6B64\9879\503C\6E90\7684\4E00\884C\6216\591A\884C\7684 SQL \67E5\8BE2\3002\5982\679C\7ED3\679C\5305\542B\591A\884C, \5219\5404\884C\7684\503C\5C06\5F62\6210\5355\4E2A\5192\53F7\5206\9694\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912403893312256)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661768538312851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662045010312851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661925653312851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661855874312851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662114246312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108661657432312851)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662970824312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\56FE\8868\7CFB\5217\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662873897312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662721569312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9009\62E9 EMPNO\3001ENAME \548C SAL \5217\FF0C\5E76\8FC7\6EE4\6389 SAL \5C0F\4E8E 3000 \7684\6240\6709\884C\3002</dt>'),
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662627291312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\56FE\8868\7CFB\5217\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662579234312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993701699312321)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5148\663E\793A\6700\65B0\7684\96C7\4F63, \6700\540E\663E\793A\5C1A\672A\96C7\4F63\7684\4EBA\3002\5982\679C\65E5\671F\76F8\540C, \5219\6309\7167\90E8\95E8\7F16\53F7\8FDB\884C\6392\5E8F\3002</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993699030312321)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4E00\4E2A\6216\591A\4E2A\4EE5\9017\53F7\5206\9694\7684\5217\540D (\5305\62EC\6307\4EE4), \7528\4E8E\5B9A\4E49\68C0\7D22\8BB0\5F55\7684\987A\5E8F\3002</p>'),
unistr('        <p>\6307\4EE4\5305\62EC:'),
'          <ul>',
unistr('            <li>ASC - \4EE5\5347\5E8F\8FD4\56DE\5217</li>'),
unistr('            <li>DESC - \4EE5\964D\5E8F\8FD4\56DE\5217</li>'),
unistr('            <li>NULLS FIRST - \5148\8FD4\56DE\6CA1\6709\503C\7684\5217, \7136\540E\8FD4\56DE\6709\503C\7684\5217</li>'),
unistr('            <li>NULLS LAST - \5148\8FD4\56DE\6709\503C\7684\5217, \7136\540E\8FD4\56DE\6CA1\6709\503C\7684\5217</li>'),
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993525863312321)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992971367312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62E5\6709\8868\7684\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992837458312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106366870312408)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\FF0C\5B83\8FD4\56DE\7684 SQL \67E5\8BE2\7528\4F5C\6B64\533A\57DF\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106246340312408)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662496442312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\9009\62E9 EMPNO\3001ENAME \548C SAL \5217\FF0C\5E76\8FC7\6EE4\6389 SAL \5C0F\4E8E 3000 \7684\6240\6709\884C\3002</dt>'),
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662361081312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\56FE\8868\7CFB\5217\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108662255420312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663185434312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\56FE\8868\7CFB\5217\8F93\5165\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108663034594312852)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684 Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993140815312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993020283312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992577165312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\67E5\8BE2\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105827368312408)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108105919774312408)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\6267\884C\51FD\6570\4F53\6240\8FD4\56DE\7684 SQL \67E5\8BE2\68C0\7D22\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995745252312322)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107995823173312322)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E SQL \67E5\8BE2\68C0\7D22\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992624045312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868/\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992779206312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\8868\6216\89C6\56FE\68C0\7D22\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992459210312316)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993402399312321)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\53EA\5305\62EC\90A3\4E9B\5177\6709\7ECF\7406\6216\8005\672C\8EAB\5DE5\4F5C\662F\9500\552E\4EBA\5458\7684\5458\5DE5\3002</dt>'),
'<dd><pre>',
unistr('(MGR \662F\975E\7A7A\503C, \6216\8005 JOB = ''SALESMAN'')'),
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993395745312320)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\9650\5236\6240\68C0\7D22\8BB0\5F55\7684\6709\6548 SQL where \6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993278887312317)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Where \5B50\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992353603312316)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8FDC\7A0B\6570\636E\5E93\670D\52A1\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107992216212312316)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B\670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680949245312866)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\4EE3\7801\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681203644312866)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681195976312866)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681062172312866)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108681338102312866)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108680883814312866)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306502251312570)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06\4E24\5217\8FDE\63A5\5728\4E00\8D77:</dt>'),
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>\5305\62EC\5185\90E8\9009\62E9:</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130878215312427)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108130726947312427)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652147303312844)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108652011227312844)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\9879\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108651965697312844)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560668720312774)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\67E5\8BE2\8FD4\56DE\7ECF\5EA6\548C\7EAC\5EA6\503C\4F5C\4E3A NUMBER \5217\FF1A</p>'),
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>\67E5\8BE2\8FD4\56DE\5BA2\6237\4F4D\7F6E\4F5C\4E3A SDO_GEOMETRY \5217\FF1A</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993934169312321)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684 SQL \6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107993882119312321)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912162260312255)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4F5C\6B64\9879\503C\7684\6E90\7684\9759\6001\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107912057042312255)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911990527312255)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\9879\503C\57FA\4E8E\7684\6E90\7C7B\578B\3002</p>'),
unistr('<p>\6CE8: \5982\679C<strong>\6E90: \5DF2\7528</strong>\8BBE\7F6E\4E3A<em>\4EC5\5F53\4F1A\8BDD\72B6\6001\4E2D\7684\5F53\524D\503C\4E3A\7A7A\65F6</em>, \5219\5728\4E3A\6B64\9879\8BBE\7F6E\4E86\4F1A\8BDD\72B6\6001\7684\503C\65F6\5C06\4E0D\4F7F\7528\8BE5\6E90\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415014110312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610366339312812)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\672A\6307\5B9A\503C\800C\8BBE\7F6E\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415222573312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609755005312811)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5728<em>\6570\636E\5E93\5217</em>\4E2D\8F93\5165\7684\5217\503C, \6B64\503C\4ECE\5185\7F6E\63D0\53D6\884C\5904\7406\68C0\7D22\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631054380312827)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108631176636312828)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6267\884C\8F93\5165\7684<em>\8868\8FBE\5F0F</em>\6240\751F\6210\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415545202312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4E3B\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610188542312811)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684<em>\51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415607260312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609838985312811)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415756629312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610252815312812)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415388757312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5355\4E2A\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609969402312811)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\7B2C\4E00\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415435174312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5192\53F7\5206\9694\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108610092881312811)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\5355\4E2A\5192\53F7\5206\9694\503C (\8FDE\63A5\6BCF\884C\503C)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108415177659312656)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108609632628312811)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\5230<em>\9759\6001\503C</em>\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911880164312255)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911758055312255)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\54EA\4E2A\503C\4F18\5148: \662F\4F1A\8BDD\72B6\6001\4E2D\7684\503C\4F18\5148, \8FD8\662F\9879\6E90\503C\4F18\5148\3002</p>'),
unistr('<p>\5BF9\4E8E\6E90\7C7B\578B\4E3A<strong>\6570\636E\5E93\5217</strong>\7684\9879, \5982\679C\60A8\5E0C\671B\5173\8054\884C\63D0\53D6\64CD\4F5C\5728\9875\6CBF\7740\5206\652F\56DE\5230\5176\672C\8EAB\65F6\586B\5145\6B64\9879, \8BF7\9009\62E9<strong>\59CB\7EC8\66FF\6362\4F1A\8BDD\72B6\6001\4E2D\7684\4EFB\4F55\73B0\6709\503C</strong>\3002'),
unistr('\5BF9\4E8E\5176\4ED6\6E90\7C7B\578B, \5FC5\987B\6839\636E\9875\7684\4F7F\7528\65B9\5F0F\51B3\5B9A\662F\663E\793A\4EE5\524D\7684\6E90\503C\8FD8\662F\5BF9\6BCF\6B21\9875\8BBF\95EE\91CD\65B0\5E94\7528\6E90\7C7B\578B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414858585312656)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8\66FF\6362\4F1A\8BDD\72B6\6001\4E2D\7684\4EFB\4F55\73B0\6709\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108414955323312656)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5F53\4F1A\8BDD\72B6\6001\4E2D\7684\5F53\524D\503C\4E3A\7A7A\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107911681579312255)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106190480312408)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\652F\6301\63D0\53D6\96C6\5408\7684 REST \6570\636E\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108106001226312408)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190789713312475)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5206\79BB\53CC Y \56FE\8868\4E0A, \6307\5B9A\5206\914D\7ED9 Y \8F74\5B50\56FE\8868\7684\7A7A\95F4\6BD4\4F8B\3002\6709\6548\503C\662F\4ECE 0 \5230 1 \7684\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190661092312475)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62C6\5206\5668\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190254168312475)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5C06\7ED8\56FE\533A\62C6\5206\6210\4E24\90E8\5206, \4EE5\4FBF\5206\914D\7ED9\4E0D\540C Y \8F74\7684\6570\636E\96C6\663E\793A\5728\4E0D\540C\7684\7ED8\56FE\533A\90E8\5206\3002\80A1\4EF7\56FE\4E0D\652F\6301<strong>\5426</strong>\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190312517312475)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190564547312475)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190418438312475)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190106871312475)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167470816312457)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\5806\53E0\6570\636E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108167321932312456)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5806\53E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791514954312162)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5C06\6B64\7CFB\5217\5206\914D\5230\7684\5806\53E0\6761\7C7B\522B\540D\79F0\3002\9ED8\8BA4\60C5\51B5\4E0B\FF0C\5806\53E0\56FE\7684\6240\6709\7CFB\5217\5C06\5F52\5230\540C\4E00\4E2A\5806\53E0\6761\4E2D\3002\8981\5C06\8BE5\7CFB\5217\5F52\5230\4E00\4E2A\5355\72EC\7684\5806\53E0\6761\4E2D\FF0C\8BF7\8BBE\7F6E\5806\53E0\6761\7C7B\522B\3002\60A8\53EF\4EE5\4F7F\7528 <code>&COLUMN_VALUE.</code> \66FF\6362\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791432170312162)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5806\53E0\6761\7C7B\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791333541312162)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6307\5B9A\662F\5426\5E94\663E\793A\5806\53E0\6570\636E\9879\7684\603B\8BA1\503C\3002\4EC5\9002\7528\4E8E\6761\5F62\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791218139312162)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5806\53E0\6761\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892156326312240)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6B64\9875\7684\6807\51C6\9009\9879\5361\96C6\3002\6807\51C6\9009\9879\5361\96C6\4E0E\7279\5B9A\9875\7801\76F8\5173\8054\3002\60A8\53EF\4EE5\4F7F\7528\6807\51C6\9009\9879\5361\5C06\7528\6237\94FE\63A5\5230\7279\5B9A\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892098108312240)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290203442312557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5728\5468\5386\4E0A\663E\793A\7684\4E00\5468\4E2D\7684\7B2C\4E00\5929\3002'),
unistr('\53EF\4EE5\5C06\6B64\5C5E\6027\4E0E<strong>\7ED3\675F\65E5\671F</strong>\7ED3\5408\4F7F\7528\6765\9650\5236\663E\793A\7684\4E00\5468\4E2D\7684\5929\6570, \6216\7B80\5355\6307\5B9A\663E\793A\7684\4E00\5468\4E2D\7684\7B2C\4E00\5929\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449097461312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449102445312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449242678312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449362141312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449498931312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\56DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449515621312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108449685258312686)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\516D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290171303312557)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290064398312557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\6708\5386\59CB\4E8E\661F\671F\51E0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448363347312685)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448469501312685)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448518949312685)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E8C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448622033312685)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448782705312686)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\56DB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448845500312686)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\4E94')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108448980133312686)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\661F\671F\516D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108289992916312557)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290861195312557)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\96C6\4E2D\663E\793A\5468\5386\548C\65E5\5386\7684\5F00\59CB\65F6\95F4 (\5C0F\65F6)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290726957312557)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65F6\95F4 (\5C0F\65F6)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920512358312262)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165 jQuery \9009\62E9\5668\7684\9759\6001\5BB9\5668\4EE5\4F9B\6B64\52A8\6001\64CD\4F5C\4F7F\7528\3002'),
unistr('\53EF\4EE5\63D0\9AD8\4E8B\4EF6\8303\56F4\4E3A<strong>\52A8\6001</strong>\7684\52A8\6001\64CD\4F5C\7684\6027\80FD\3002'),
unistr('\8FD9\5FC5\987B\662F\9875\4E0A\81EA\8EAB\4E0D\4F1A\91CD\65B0\521B\5EFA\7684\5143\7D20, \4F46\5B83\5305\542B\4F7F\7528\90E8\5206\9875\5237\65B0 (PPR) \91CD\65B0\521B\5EFA\7684\89E6\53D1\5143\7D20\3002'),
unistr('\6B64\5143\7D20\5F15\7528\9700\8981\5B9A\4E49\4E3A jQuery \9009\62E9\5668\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920465799312262)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5BB9\5668 (jQuery \9009\62E9\5668)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930706056312270)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\6309\94AE\7684\9759\6001 ID\3002\5982\679C\5B9A\4E49, \5219\5C06\9759\6001 ID \7528\4F5C\6309\94AE\7684 ID\3002\5728\4E3A\6309\94AE\5F00\53D1\5B9A\5236 JavaScript \884C\4E3A\65F6, \9759\6001 ID \4F1A\975E\5E38\6709\7528\3002\5982\679C\672A\5B9A\4E49\9759\6001 ID, \5219\6309\94AE\5C06\751F\6210\5185\90E8 ID\3002</p>'),
unistr('<p>\6CE8: \6A21\677F\5FC5\987B\5305\542B <code>#BUTTON_ID#</code> \66FF\6362\5B57\7B26\4E32, \8FD9\6837\6309\94AE\624D\80FD\5229\7528\8F93\5165\7684\9759\6001 ID\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134904952312431)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5217\7684\9759\6001 ID\3002\5728\4E3A\5217\9879\5F00\53D1\5B9A\5236 JavaScript \884C\4E3A\6216\5B9A\5236\6837\5F0F\65F6, \9759\6001 ID \4F1A\975E\5E38\6709\7528\3002\5982\679C\672A\5B9A\4E49\9759\6001 ID, \5219\4E3A\5217\9879 ID \4F7F\7528\5185\90E8 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812120737312974)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5217\7684\9759\6001 ID\3002\5982\679C\5B9A\4E49, \5219\5C06\9759\6001 ID \7528\4F5C\5BF9\5E94\8868\6807\9898 (TH) \5355\5143\7684 ID, \5E76\7528\4F5C\5BF9\5E94\8868\6570\636E (TD) \5355\5143\7684 HEADERS \503C\3002\5728\4E3A\5217\5F00\53D1\5B9A\5236 JavaScript \884C\4E3A\6216\5B9A\5236\6837\5F0F\65F6, \9759\6001 ID \4F1A\975E\5E38\6709\7528\3002\5982\679C\672A\5B9A\4E49\9759\6001 ID, \5219\8868\5C06\4E3A\8FD9\4E9B\5C5E\6027\503C\751F\6210\5185\90E8 ID\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191104400312475)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\8868\8F74\7684\9759\6001 ID\3002\5F53\5F00\53D1\56FE\8868\8F74\7684\5B9A\5236 JavaScript \884C\4E3A\65F6, \9759\6001 ID \4F1A\975E\5E38\6709\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191024483312475)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\56FE\8868\7CFB\5217\7684\9759\6001 ID\3002\5F53\5F00\53D1\56FE\8868\7CFB\5217\7684\5B9A\5236 JavaScript \884C\4E3A\65F6, \9759\6001 ID \4F1A\975E\5E38\6709\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107989821426312314)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\533A\57DF\7684\9759\6001 ID\3002\5982\679C\5B9A\4E49, \5219\6B64\9879\5C06\7528\4F5C\533A\57DF\7684 ID (\4F7F\7528\66FF\6362\5B57\7B26\4E32 <code>#REGION_STATIC_ID#</code>), \5728\4E3A\533A\57DF\5F00\53D1\5B9A\5236 JavaScript \884C\4E3A\65F6\975E\5E38\6709\7528\3002\5982\679C\672A\5B9A\4E49\6B64\9879, \5219\533A\57DF\5C06\751F\6210\5185\90E8 ID\3002</p>'),
unistr('<p>\6CE8: \8981\4F7F\533A\57DF\4F7F\7528\8F93\5165\7684\9759\6001 ID, \6A21\677F\5FC5\987B\5305\62EC <code>#REGION_STATIC_ID#</code> \66FF\6362\5B57\7B26\4E32\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920186125312262)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\6B64\7EC4\4EF6\7684\9759\6001 ID\3002\5982\679C\5B9A\4E49, \5219\4E3A\6B64\7EC4\4EF6\5F00\53D1\5B9A\5236 JavaScript \884C\4E3A\65F6, \6B64 ID \4F1A\975E\5E38\6709\7528\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107920066637312262)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202444654312484)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5E94\7528\4E8E\6240\5448\73B0\7684\80A1\4EF7\56FE\7684\7CFB\5217\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202534602312484)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202626312312484)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202788363312485)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('K \7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202872812312485)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202920734312485)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108202339024312484)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922540140312263)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\6267\884C\5F53\524D\64CD\4F5C\51FA\9519\65F6\662F\5426\505C\6B62\6240\6709\5176\4ED6\6682\6302\64CD\4F5C\7684\5904\7406\3002</p>'),
unistr('<p>\6CE8: \7279\5B9A\64CD\4F5C\7684\6267\884C\987A\5E8F\7531\4E3A\6BCF\4E2A\64CD\4F5C\6307\5B9A\7684\5E8F\5217\786E\5B9A\3002\8981\786E\4FDD\64CD\4F5C\4EE5\76F8\540C\7684\987A\5E8F\8FD0\884C, Oracle \5EFA\8BAE\5E8F\5217\53F7\5BF9\4E8E\6240\6709\201C\771F\201D\64CD\4F5C\548C\6240\6709\201C\5047\201D\64CD\4F5C\552F\4E00\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922471908312263)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\9519\65F6\505C\6B62\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999726185312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\62A5\8868\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999848236312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5C06\4F7F\7528\6700\7EC8\7528\6237\8BBE\7F6E\7684<strong>\62C9\4F38</strong>\62A5\8868\8BBE\7F6E\FF0C\4EE5\6B64\6765\5B9A\4E49\662F\5426\5E94\62C9\4F38\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999210713312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\5F53\5C4F\5E55\4E2D\6709\8DB3\591F\591A\7684\5B9E\9645\53EF\7528\7A7A\95F4\65F6\FF0C\662F\5426\5E94\62C9\4F38\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999543662312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59CB\7EC8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999654856312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\59CB\7EC8\62C9\4F38\FF0C\4E0D\8BBA\6700\7EC8\7528\6237\5982\4F55\8BBE\7F6E<strong>\62C9\4F38</strong>\62A5\8868\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999356981312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999491455312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5C06\4E0D\62C9\4F38\FF0C\59CB\7EC8\53EA\4F7F\7528\6307\5B9A\7684\5BBD\5EA6\3002\5BF9\4E8E\5177\6709\7C7B\4F3C\4E8E\201C\662F/\5426\201D\6216\6570\5B57\7684\7B80\77ED\5185\5BB9\7684\5217\FF0C\8FD9\975E\5E38\6709\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107999172007312325)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62C9\4F38')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264355097312535)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4ECE\539F\59CB\5217\503C\4E2D\5220\9664 HTML \6807\8BB0\3002'),
unistr('\8FD9\5BF9\4E8E\4F7F\7528 HTML \8868\8FBE\5F0F, \5728\5217\94FE\63A5\4E2D\4F7F\7528\6216\5BFC\51FA\5230 CSV \6587\4EF6\7684\5217\5C24\4E3A\91CD\8981\3002</p>'),
unistr('<p>\5982\679C\4ECE\5DF2\5305\542B HTML \6807\8BB0\7684\6570\636E\5E93\4E2D\9009\62E9\503C, \5219\8FD9\4E9B\6807\8BB0\4F1A\4E0E\4E3A HTML \8868\8FBE\5F0F\751F\6210\7684 HTML \6216\4E3A\5217\94FE\63A5\751F\6210\7684 URL \51B2\7A81\3002'),
unistr('\5F53\5BFC\51FA\6B64\7C7B\503C\65F6, \73B0\6709 HTML \6807\8BB0\5C06\4F5C\4E3A\7EAF\6587\672C\5305\62EC\5728\751F\6210\7684 CSV \6587\4EF6\4E2D\3002'),
unistr('\5F53\542F\7528\6B64\9009\9879\65F6, \5C06\4EC5\4F7F\7528\5217\503C\7684\5B9E\9645\6570\636E\90E8\5206\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264276194312535)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5265\9664 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108120044354312419)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\901A\5E38\7531\5B9A\5236\6309\94AE (\4F8B\5982<strong>\6807\8BB0\4E3A\5DF2\5B8C\6210</strong>) \542F\52A8\7684\9875\5904\7406\4E2D\5305\62EC\9009\4E2D\884C\3002'),
unistr('        \8FD9\4E9B\9009\4E2D\884C\968F\540E\53EF\7528\5728\5B9A\5236\5904\7406\4E2D\4EE5\6267\884C\6240\9700\7684\64CD\4F5C\3002</p>'),
unistr('        <p>\6CE8 - \5373\4F7F\5C1A\672A\66F4\65B0\6240\9009\884C\4E0A\7684\4EFB\4F55\5185\5BB9, \4E5F\5C06\5904\7406\8FD9\4E9B\884C\3002\901A\5E38, \4EC5\5904\7406\5DF2\63D2\5165, \5DF2\66F4\65B0\6216\5DF2\5220\9664\7684\884C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108119989469312419)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\5305\62EC\6240\9009\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984781613312311)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5E94\7528\7A0B\5E8F, \800C\60A8\5E0C\671B\6B64\65B9\6848\8BA2\9605\5176\9A8C\8BC1\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107984648816312311)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589028834312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\7EC4\4EF6\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588957606312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589216963312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\5B50\6807\9898\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589153224312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589750422312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589621567312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589591999312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589457316312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108589384642312795)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243874285312518)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\5904\7406\7684\6210\529F\6D88\606F\3002'),
unistr('\5982\679C\5904\7406\5DF2\8FD0\884C\5E76\4E14\672A\751F\6210\9519\8BEF, \5219\4F1A\5728\663E\793A\7684\751F\6210\9875\7684\901A\77E5\90E8\5206\4E2D\663E\793A\6B64\5904\7406\7684\6210\529F\6D88\606F\3002'),
unistr('\5982\679C\901A\8FC7 URL \91CD\5B9A\5411\5206\652F\5230\53E6\4E00\9875, \5219\53EF\80FD\9700\8981\68C0\67E5<em>\4FDD\5B58\6210\529F\6D88\606F</em>\5C5E\6027\3002</p>'','),
unistr('<p>\5BF9\4E8E\591A\884C\5904\7406, \53EF\4EE5\4F7F\7528\4E0B\9762\7684\66FF\6362\5B57\7B26\4E32\83B7\53D6\5904\7406\7684\8BB0\5F55\6570:</p>'),
'<ul>',
unistr('  <li>\63D2\5165: <code>#MRI_COUNT#</code></li>'),
unistr('  <li>\66F4\65B0: <code>#MRU_COUNT#</code></li>'),
unistr('  <li>\5220\9664: <code>#MRD_COUNT#</code></li>'),
'</ul>',
unistr('<p>\5BF9\4E8E\201C\53D1\9001\7535\5B50\90AE\4EF6\201D\5904\7406\7C7B\578B, \53EF\4EE5\4F7F\7528\66FF\6362\5B57\7B26\4E32 <code>#TO#</code> \83B7\53D6\7535\5B50\90AE\4EF6\7684\6536\4EF6\4EBA\3002</p>'),
unistr('<p>\63D2\4EF6\4E5F\53EF\4EE5\5177\6709\5176\4ED6\66FF\6362\5B57\7B26\4E32\3002\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605\63D2\4EF6\7684\6587\6863\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108398296759312642)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\6B64\5904\7406\6210\529F\5B8C\6210\540E\8981\5728 "\901A\77E5" \533A\57DF (\5B9A\4E49\4E3A\9875\6A21\677F\7684\4E00\90E8\5206) \4E2D\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108243352006312517)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939874112312277)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4F5C\5EFA\8BAE\6E90\7684 SQL \67E5\8BE2\3002</p>'),
unistr('<p>\6CE8\FF1A\503C\7684\8FD4\56DE\987A\5E8F\7528\4E8E\786E\5B9A\5B83\4EEC\7684\663E\793A\987A\5E8F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939710216312277)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939675983312277)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4F5C\5EFA\8BAE\6E90\7684\9017\53F7\5206\9694\7684\9759\6001\503C\5217\8868\3002</p>'),
unistr('<p>\6CE8\FF1A\503C\7684\6307\5B9A\987A\5E8F\7528\4E8E\786E\5B9A\5B83\4EEC\7684\663E\793A\987A\5E8F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939577871312277)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107941880962312278)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107942517701312279)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938834985312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\4E3A\6B64\7B5B\9009\5668\786E\5B9A\5EFA\8BAE\3002</p>'),
unistr('<p>\6CE8\FF1A\4ECD\6309\7167\503C\5217\8868\7684\53EF\89C1\6761\76EE\68C0\67E5\63D0\4F9B\7684\503C\FF0C\5E76\4E14\4EC5\5F53\5B58\5728\5339\914D\9879\65F6\624D\4F7F\7528\63D0\4F9B\7684\503C\3002'),
unistr('\5982\679C\672A\627E\5230\67D0\4E2A\503C\FF0C\5219\5C06\8DF3\8FC7\5B83\FF0C\5E76\68C0\67E5\4E0B\4E00\4E2A\503C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938984906312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939082493312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\503C\5217\8868\4E2D\9009\53D6<strong>\7B2C\4E00\4E2A</strong>\53EF\89C1\6761\76EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939389119312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939406200312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939171669312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107939251617312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9017\53F7\5206\9694\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107938758643312276)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207554793312489)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\663E\793A\5728\4E0B\8F7D\6587\4EF6\9876\90E8\7684\6587\672C\3002\53EF\4EE5\8F93\5165\6709\5173\6587\4EF6\4E2D\6570\636E\7684\6570\636E\5206\7C7B\3001\6CD5\5F8B\6216\8B66\544A\6D88\606F\3002</p>'),
unistr('        <p>\6CE8 - \8F93\5165\7684\6587\672C\5747\4EE5\62A5\8868\4E0B\8F7D\683C\5F0F\5305\542B\8FDB\6765\3002\5982\679C\542F\7528\4E86 CSV \4E0B\8F7D\FF0C\5219\5B9A\4E49\7684\6587\672C\5C06\4F7F CSV \6587\4EF6\683C\5F0F\5931\6548\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207409582312489)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8865\5145\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222712103312500)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5E0C\671B\5728\8BE6\7EC6\4FE1\606F\89C6\56FE\4E2D\5C06\5217\6807\9898\6587\672C\7528\4F5C\6807\7B7E, \5219\6307\5B9A\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108222674235312500)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5217\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278042101312546)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6B64\8868\683C\5F0F\8868\5355\5217\7684\57FA\7840\3002</p>'),
unistr('<p>\9009\5B9A\5185\5BB9\786E\5B9A\6B64\5217\662F\5426\4E3A\8868\683C\5F0F\8868\5355\5185\7684\53EF\66F4\65B0\5217\3002'),
unistr('\53EA\6709\5B9A\4E49\4E86\591A\884C\66F4\65B0\6216\5B9E\65BD\4E86 PL/SQL \8FC7\7A0B\6765\5904\7406\66F4\65B0\7684\6570\636E\65F6, \624D\80FD\6267\884C\66F4\65B0\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445445055312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\9009\53D6\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613889282312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\65E5\671F\6216\5229\7528\65E5\671F\9009\53D6\5668\9009\62E9\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445361289312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\9009\53D6\5668 (\7ECF\5178)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613908418312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\65E5\671F\6216\5229\7528\65E5\671F\9009\53D6\5668\9009\62E9\65E5\671F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445293988312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C (\4FDD\5B58\72B6\6001)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612513775312813)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217\503C\5E76\4FDD\5B58\5728\4F1A\8BDD\72B6\6001\7684\503C\4E2D\3002\53EF\5728\9875\5904\7406\4E2D\5229\7528\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446907531312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D BLOB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612986402312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\4EE5\4E0B\8F7D\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446453456312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614022157312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5217, \4F46\53EF\5F15\7528\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445967690312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\5217 (\4FDD\5B58\72B6\6001)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108614118812312815)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A\5217, \4F46\53EF\5F15\7528\5217\3002\53EF\5728\9875\5904\7406\4E2D\5229\7528\6B64\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446817457312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612896095312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\56FE\50CF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446716790312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612730658312813)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108447020496312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4\56FE\5F62')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613049996312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\663E\793A\4E3A\767E\5206\6BD4\56FE\5F62\3002\68C0\7D22\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 100 \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446581841312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612422417312813)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446609512312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAF\6587\672C (\57FA\4E8E\503C\5217\8868)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612684778312813)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4ECE\6307\5B9A\7684\503C\5217\8868\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446084286312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F LOV (\663E\793A\8FD4\56DE\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613582440312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5F39\51FA\5F0F\5217\8868\4E2D\9009\62E9\503C\3002\663E\793A\503C\5217\8868\4E2D\7684\8FD4\56DE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446164357312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F LOV (\663E\793A\663E\793A\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613470579312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5F39\51FA\5F0F\5217\8868\4E2D\9009\62E9\503C\3002\663E\793A\503C\5217\8868\4E2D\7684\663E\793A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445835973312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\9009\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613647442312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\6307\5B9A\7684\503C\5217\8868\9009\62E9\5355\4E2A\5355\9009\7EC4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446319997312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108612337190312813)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6BCF\884C\5F00\5934\5305\542B\590D\9009\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445769784312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613362490312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\6307\5B9A\7684\503C\5217\8868\9009\62E9\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108446292688312684)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\5355\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613713282312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\4E2D\6216\53D6\6D88\9009\4E2D\5355\4E2A\590D\9009\6846\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445532689312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613102176312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\503C\8F93\5165\5230\6587\672C\5B57\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108445620235312683)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108613264791312814)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\503C\8F93\5165\5230\6587\672C\533A\57DF\5B57\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108277992707312546)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000874255312326)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\201C\76EE\6807\201D\53EF\8C03\7528\6A21\5F0F\5BF9\8BDD\6846\3002\53EF\4EE5\8F93\5165\5728\8C03\7528\6B64\5206\652F\65F6\8C03\7528\7684\76EE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108000748166312326)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581324540312789)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6A21\677F\9009\9879\4EE5\5B9A\5236\6B64\7EC4\4EF6\7684\7528\6237\754C\9762\3002</p>'),
unistr('<p>\60A8\8FD8\53EF\4EE5\5728\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\4F7F\7528<strong>\5B9E\65F6\6A21\677F\9009\9879</strong>\6765\4FEE\6539\6A21\677F\9009\9879\3002'),
unistr('\4F7F\7528\201C\5B9E\65F6\6A21\677F\9009\9879\201D\53EF\4EE5\5B9E\65F6\5B9A\5236\5E94\7528\7A0B\5E8F, \8BA9\60A8\80FD\591F\9884\89C8\548C\5E94\7528\4E0D\540C\9009\9879\3002'),
unistr('\8981\8BBF\95EE\201C\5B9E\65F6\6A21\677F\9009\9879\201D, \8BF7\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\8FD0\884C\5E94\7528\7A0B\5E8F, \7136\540E\5728\5F00\53D1\8005\5DE5\5177\680F\4E2D\5355\51FB<em>\5FEB\901F\7F16\8F91</em>\3002'),
unistr('\5C06\9F20\6807\60AC\505C\5728\4E00\4E2A\9875\7EC4\4EF6\4E0A, \4F8B\5982\533A\57DF, \7136\540E\5355\51FB\663E\793A\5728\5DE6\4E0A\89D2\7684\6273\624B\56FE\6807 ( <span class="a-Icon icon-util" aria-hidden="true"></span> )\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581251713312789)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581540111312789)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6A21\677F\9009\9879\4EE5\5B9A\5236\6B64\7EC4\4EF6\7684\7528\6237\754C\9762\3002</p>'),
unistr('<p>\60A8\8FD8\53EF\4EE5\5728\8FD0\884C\5E94\7528\7A0B\5E8F\65F6\4F7F\7528<strong>\5B9E\65F6\6A21\677F\9009\9879</strong>\6765\4FEE\6539\6A21\677F\9009\9879\3002'),
unistr('\4F7F\7528\201C\5B9E\65F6\6A21\677F\9009\9879\201D\53EF\4EE5\5B9E\65F6\5B9A\5236\5E94\7528\7A0B\5E8F, \8BA9\60A8\80FD\591F\9884\89C8\548C\5E94\7528\4E0D\540C\9009\9879\3002'),
unistr('\8981\8BBF\95EE\201C\5B9E\65F6\6A21\677F\9009\9879\201D, \8BF7\4ECE\5E94\7528\7A0B\5E8F\6784\5EFA\5668\8FD0\884C\5E94\7528\7A0B\5E8F, \7136\540E\5728\5F00\53D1\8005\5DE5\5177\680F\4E2D\5355\51FB<em>\5FEB\901F\7F16\8F91</em>\3002'),
unistr('\5C06\9F20\6807\60AC\505C\5728\4E00\4E2A\9875\7EC4\4EF6\4E0A, \4F8B\5982\533A\57DF, \7136\540E\5355\51FB\663E\793A\5728\5DE6\4E0A\89D2\7684\6273\624B\56FE\6807 ( <span class="a-Icon icon-util" aria-hidden="true"></span> )\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581450105312789)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829635638312192)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\6A21\677F\5185\7684\5360\4F4D\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829588384312192)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\5360\4F4D\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262921146312534)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\62A5\8868\7684\6A21\677F\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442166320312680)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442298203312680)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\76F4\63A5\4E0E\4EFB\4F55\4E3B\9898\5173\8054\7684\9884\5B9A\4E49\62A5\8868\6A21\677F\3002\56E0\4E3A\8FD9\4E9B\9884\5B9A\4E49\6A21\677F\4E0E\5F53\524D\4E3B\9898\4E4B\95F4\6CA1\6709\5173\8054, \6240\4EE5\5373\4F7F\66F4\6539\5E94\7528\7A0B\5E8F\4E3B\9898, \62A5\8868\5E03\5C40\4E5F\4FDD\6301\4E0D\53D8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108441936952312680)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108442026337312680)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\6B64\9875\7528\6237\754C\9762\7684\5F53\524D\4E3B\9898\5728\5BF9\5E94\4E3B\9898\4E2D\63D0\4F9B\7684\62A5\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108262805733312534)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770198501312935)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6839\636E\6307\5B9A\7684<strong>\641C\7D22\7C7B\578B</strong>\FF0C\8F93\5165\4E00\4E2A\6216\4E00\7EC4\7528\4E8E\6587\672C\641C\7D22\7684\6570\636E\5E93\5217\540D\3002</p>'),
'<ul>',
unistr('  <li><strong>\884C\641C\7D22</strong>\FF1A\8F93\5165\7528\4E8E\6587\672C\641C\7D22\7684\9017\53F7\5206\9694\7684\4E00\7EC4 VARCHAR2 \7C7B\578B\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\FF1B\5982\679C\672A\6307\5B9A\5217\FF0C\5219\5C06\81EA\52A8\4F7F\7528\6240\6709 VARCHAR2 \5217\3002</li>'),
unistr('  <li><strong>Oracle Text</strong>\FF1A\8F93\5165\5305\542B Oracle Text \7D22\5F15\7684\6570\636E\5E93\5217\540D\FF08\533A\5206\5927\5C0F\5199\FF09\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770070340312935)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041955325312356)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E0E\5F53\524D\7528\6237\754C\9762\5173\8054\7684\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108041851984312356)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189870432312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\523B\5EA6\6807\7B7E\76F8\5BF9\4E8E\7ED8\56FE\533A\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108190022305312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189945559312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189718105312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189497104312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\5448\73B0\523B\5EA6\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189354567312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189698938312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6307\5B9A\56FE\8868\662F\5426\5C06\81EA\52A8\65CB\8F6C\6807\7B7E 90 \5EA6\4EE5\4FBF\9002\5408\8F74\4E0A\7684\66F4\591A\6807\7B7E\3002'),
unistr('        \65CB\8F6C\5C06\4EC5\9002\7528\4E8E\6C34\5E73\8F74\7684\5206\7C7B\6807\7B7E\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108189567235312474)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65CB\8F6C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560276596312773)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0E\6807\51C6\76F8\540C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691047079312874)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6D45\8272\548C\6DF1\8272\6A21\5F0F\4F7F\7528\76F8\540C\80CC\666F\5730\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514873607312737)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5728\542F\7528\6697\6A21\5F0F\65F6\8981\7528\4F5C\80CC\666F\5730\56FE\7684\5E73\94FA\5C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515705420312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle BI \4E16\754C\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515844320312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E HERE \5730\56FE\6570\636E\7684\975E\5E72\6270\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\4F4D\7F6E\4E0A\4E0B\6587\FF0C\5E76\4E14\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 Oracle USA \63D0\4F9B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515372968312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OpenStreetMap \4EAE\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515450327312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\8BE6\7EC6\7684\4F4D\7F6E\4E0A\4E0B\6587\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514919030312737)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OpenStreetMap \6697\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515076693312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6D45\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515127012312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OpenStreetMap \6B63\7535\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515224976312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6697\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515505285312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle \4E16\754C\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108515621881312738)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E HERE \5730\56FE\6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\4F4D\7F6E\4E0A\4E0B\6587\FF0C\5E76\4E14\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 Oracle USA \63D0\4F9B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514761921312737)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6697\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513608318312736)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\80CC\666F\5730\56FE\7684\5E73\94FA\5C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514562147312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle BI \4E16\754C\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514625438312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E HERE \5730\56FE\6570\636E\7684\975E\5E72\6270\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\4F4D\7F6E\4E0A\4E0B\6587\FF0C\5E76\4E14\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 Oracle USA \63D0\4F9B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514160444312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OpenStreetMap \4EAE\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514276115312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\8BE6\7EC6\7684\4F4D\7F6E\4E0A\4E0B\6587\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513941961312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OpenStreetMap \6697\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514039342312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6697\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513775332312736)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OpenStreetMap \6B63\7535\5B50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513899125312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6D45\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514313985312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle \4E16\754C\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108514445430312737)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E HERE \5730\56FE\6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\4F4D\7F6E\4E0A\4E0B\6587\FF0C\5E76\4E14\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 Oracle USA \63D0\4F9B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513553206312736)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513047273312736)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\4F7F\7528\7684\80CC\666F\5730\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513337971312736)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513416734312736)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6\8981\7528\4E8E\80CC\666F\5730\56FE\7684\5730\56FE\5E73\94FA\5C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513127832312736)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108513218216312736)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9ED8\8BA4\80CC\666F\5730\56FE\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108512996306312736)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290695257312557)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5982\4F55\663E\793A\65F6\95F4\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450489131312687)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('12 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108450556341312687)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('24 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108290528343312557)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779380465312942)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8F74\7684\6807\9898\3002\6B64\6807\9898\4ECB\7ECD\4E86\5728\56FE\8868\7684\8F74\4E0A\8868\793A\7684\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930074171312269)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\5728\6D4F\89C8\5668\7A97\53E3\7684\6807\9898\680F\4E2D\663E\793A\7684\6807\9898\3002&PRODUCT_NAME. \5F15\64CE\5C06\4F7F\7528\5728\6B64\5904\6307\5B9A\7684\6807\9898\66FF\6362\9875\6A21\677F\4E2D\4F7F\7528\7684 <code>#TITLE#</code> \66FF\6362\5B57\7B26\4E32\3002\6B64\6807\9898\5C06\63D2\5165\5230 HTML \6807\8BB0 <code>&lt;TITLE&gt;</code> \548C <code>&lt;/TITLE&gt;</code> \4E4B\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107930911679312270)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\533A\57DF\6807\9898\3002\53EA\6709\5728\533A\57DF\6A21\677F\4E2D\5B9A\4E49\4E86\533A\57DF\6807\9898\540E, \624D\4F1A\663E\793A\6B64\533A\57DF\6807\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892331491312240)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9875\6807\9898\3002\5728\6D4F\89C8\5668\7A97\53E3\7684\6807\9898\680F\4E2D\663E\793A\9875\6807\9898\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107892264936312240)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588197798312794)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\6B64\7EC4\4EF6\662F\4F7F\7528\5217\663E\793A\FF0C\8FD8\662F\4EE5\9AD8\7EA7\683C\5F0F\663E\793A\FF08\4F7F\7528 HTML \8868\8FBE\5F0F\548C\652F\6301\7684\66FF\6362\5B57\7B26\4E32\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588021655312794)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588309427312794)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4F5C\6807\9898\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588205561312794)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588829112312795)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\6DFB\52A0\5230\6B64\7EC4\4EF6\7684\7C7B\3002\53EF\4EE5\6DFB\52A0\591A\4E2A\7C7B\FF0C\5E76\4F7F\7528\7A7A\683C\5206\9694\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588796631312795)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588657320312795)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&COLUMN_CLASS.</code> \548C <code>&EMPLOYEE_STATUS.</code> \66FF\6362\662F\5728\62A5\8868 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588588679312795)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108588459758312794)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HTML \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141658648312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5728\5DE5\5177\680F\4E2D\663E\793A\54EA\4E9B\9644\52A0\63A7\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142184895312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142263028312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\201C\64CD\4F5C\201D\83DC\5355\6309\94AE\FF0C\8BE5\6309\94AE\901A\5E38\5305\542B\4E00\7EC4\5168\9762\7684\9009\9879\3002\901A\8FC7\8FD9\4E9B\9009\9879\FF0C\6700\7EC8\7528\6237\53EF\4EE5\6839\636E\53EF\4F9B\4F7F\7528\7684\529F\80FD\6765\5B9A\5236\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142373506312437)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\91CD\7F6E\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142461226312437)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\201C\91CD\7F6E\201D\6309\94AE\3002\6309\4E0B\6B64\6309\94AE\65F6\FF0C\5C06\5220\9664\4EFB\4F55\5B9A\5236\8BBE\7F6E\FF08\4F8B\5982\8FC7\6EE4\5668\3001\5217\5BBD\5EA6\548C\6392\5E8F\FF09\FF0C\5E76\5C06\4ECE\670D\52A1\5668\91CD\65B0\52A0\8F7D\62A5\8868\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142562423312437)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4FDD\5B58\201D\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142687873312437)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\663E\793A\201C\4FDD\5B58\201D\6309\94AE\3002\6309\4E0B\6B64\6309\94AE\65F6\FF0C\5C06\4EC5\4FDD\5B58\5BF9\6B64\4EA4\4E92\5F0F\7F51\683C\6240\505A\7684\66F4\6539\FF0C\800C\65E0\9700\4FDD\5B58\6574\4E2A\9875\3002'),
unistr('        <p>\4EC5\5F53\4EA4\4E92\5F0F\7F51\683C\53EF\7F16\8F91\5E76\4E14\6700\7EC8\7528\6237\6709\6743\6DFB\52A0\3001\66F4\65B0\6216\5220\9664\5185\5BB9\65F6\FF0C\624D\5C06\663E\793A\201C\4FDD\5B58\201D\6309\94AE\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141756195312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5217\9009\62E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141874136312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E00\4E2A\4E0B\62C9\5217\8868\FF0C\5176\4E2D\5305\542B\663E\793A\7684\975E\6570\5B57\5217\3002\5982\679C\9009\62E9\4E86\67D0\5217\FF0C\5219\4EC5\9488\5BF9\6240\9009\5217\4E2D\7684\503C\6267\884C\641C\7D22\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141987993312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108142089790312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\641C\7D22\680F\4E2D\663E\793A\53EF\4F9B\8F93\5165\641C\7D22\6761\4EF6\7684\6587\672C\5B57\6BB5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141576627312436)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704120506312884)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108608697887312810)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704259425312884)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108246055193312519)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\793A\6B64\5217\662F\5426\662F\65F6\533A\8BC6\522B\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245905555312519)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\533A\8BC6\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279385318312548)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\62A5\8868\5217\5F15\7528\7684\5217\540D\3002'),
unistr('\6B64\5C5E\6027\7528\4E8E\4F7F\7528\201C\7528\6237\754C\9762\9ED8\8BA4\8BBE\7F6E\201D\5728\5E94\7528\7A0B\5E8F\4E2D\6BD4\8F83\5217\5F15\7528\3002'),
unistr('\5982\679C\53EF\80FD, \5728\5411\5BFC\521D\59CB\5316\6B64\5F15\7528\540E, \5C06\4EE5\624B\52A8\65B9\5F0F\5BF9\5176\8FDB\884C\7EF4\62A4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279298684312548)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279184797312548)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6B64\5217\5F15\7528\7684\8868\6216\89C6\56FE\3002'),
unistr('\6B64\5C5E\6027\7528\4E8E\4F7F\7528\201C\7528\6237\754C\9762\9ED8\8BA4\8BBE\7F6E\201D\5728\5E94\7528\7A0B\5E8F\4E2D\6BD4\8F83\5217\5F15\7528\3002'),
unistr('\5982\679C\53EF\80FD, \5728\5411\5BFC\521D\59CB\5316\6B64\5F15\7528\540E, \5C06\4EE5\624B\52A8\65B9\5F0F\5BF9\5176\8FDB\884C\7EF4\62A4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279025566312547)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278905246312547)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\62E5\6709\5F15\7528\8868\7684\65B9\6848\3002'),
unistr('\6B64\5C5E\6027\7528\4E8E\4F7F\7528\201C\7528\6237\754C\9762\9ED8\8BA4\8BBE\7F6E\201D\5728\5E94\7528\7A0B\5E8F\4E2D\6BD4\8F83\5217\5F15\7528\3002'),
unistr('\5982\679C\53EF\80FD, \5728\5411\5BFC\521D\59CB\5316\6B64\5F15\7528\540E, \5C06\4EE5\624B\52A8\65B9\5F0F\5BF9\5176\8FDB\884C\7EF4\62A4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108278847158312547)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\6240\6709\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230894299312507)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5728\4F7F\7528\94FE\63A5\5217\65F6\7528\4E8E\6807\8BC6\5F53\524D\884C\7684\5217\7684\7C7B\578B\3002'),
unistr('\9ED8\8BA4\60C5\51B5\4E0B, <strong>ROWID</strong> \7528\4E8E\552F\4E00\6807\8BC6\62A5\8868\4E2D\7684\884C\3002\4F46\662F, \60A8\4E5F\53EF\4EE5\901A\8FC7\9009\62E9<strong>\552F\4E00\5217</strong>\6765\4F7F\7528\5176\4ED6\5217\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108431082769312672)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108430961397312671)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'zh-cn'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230781598312507)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\6807\8BC6\884C\65B9\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231007690312507)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\4E8E\552F\4E00\6807\8BC6\6B64\7EC4\4EF6\7684\884C\7684\7B2C\4E00\5217\3002</p>'),
unistr('<p>\4E3A\5B9E\73B0\5411\540E\517C\5BB9\6027, <strong>ROWID</strong> \4E5F\5305\62EC\5728\53EF\7528\5217\7684\5217\8868\4E2D\3002</p>'),
unistr('<p>\6CE8: \5BF9\4E8E<em>\94FE\63A5\5217</em>\5C5E\6027\8BBE\7F6E\4E3A<strong>\94FE\63A5\5230\5355\884C\89C6\56FE</strong>\7684\4EA4\4E92\5F0F\62A5\8868, \53EA\80FD\9009\62E9\5355\4E2A\552F\4E00\5217\3002\5176\4ED6\7EC4\4EF6\6700\591A\652F\6301\9009\62E9\4E09\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108230924029312507)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231269553312507)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\4E8E\552F\4E00\6807\8BC6\6B64\7EC4\4EF6\7684\884C\7684\7B2C\4E8C\5217\3002\5F53\60A8\7684\8868\5177\6709\7531\4E24\90E8\5206\7EC4\6210\7684\4E3B\952E\65F6, \4F7F\7528\6B64\5C5E\6027\3002</p>'),
unistr('<p>\4E3A\5B9E\73B0\5411\540E\517C\5BB9\6027, <strong>ROWID</strong> \4E5F\5305\62EC\5728\53EF\7528\5217\7684\5217\8868\4E2D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231138052312507)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231436928312507)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\4E8E\552F\4E00\6807\8BC6\6B64\7EC4\4EF6\7684\884C\7684\7B2C\4E09\5217\3002\5F53\60A8\7684\8868\5177\6709\7531\4E09\90E8\5206\7EC4\6210\7684\4E3B\952E\65F6, \4F7F\7528\6B64\5C5E\6027\3002</p>'),
unistr('<p>\4E3A\5B9E\73B0\5411\540E\517C\5BB9\6027, <strong>ROWID</strong> \4E5F\5305\62EC\5728\53EF\7528\5217\7684\5217\8868\4E2D\3002</p>'),
unistr('<p>\6CE8: \5982\679C\8868\4E3B\952E\5177\6709\4E09\4E2A\4EE5\4E0A\7684\5217, \5219\60A8\9700\8981\901A\8FC7 <strong>ROWID</strong> \552F\4E00\6807\8BC6\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108231385089312507)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\5217 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118820186312418)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\6388\6743\65B9\6848\4EE5\9650\5236\53EF\4EE5\66F4\65B0\884C\7684\7528\6237\3002'),
unistr('\8981\4F7F\67D0\4E2A\6700\7EC8\7528\6237\53EF\4EE5\66F4\65B0\884C, \8BE5\7528\6237\7684\6B64\6388\6743\65B9\6848\5FC5\987B\6C42\503C\4E3A TRUE\3002'),
unistr('\5982\679C\672A\63D0\4F9B\6388\6743\65B9\6848, \5219\53EF\4EE5\7531\4EFB\4F55\7528\6237\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E2D\66F4\65B0\884C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108118760754312418)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006339674312330)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6B64\9875\7684\7528\6237\754C\9762\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006216895312330)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040970387312355)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6B64\9875\7684\7528\6237\754C\9762\7C7B\578B\3002\5BF9\4E8E\4E3B\8981\8BBE\8BA1\7528\4E8E\684C\9762\7528\9014\7684\9875, \8BF7\9009\62E9<strong>\684C\9762</strong>\3002\5BF9\4E8E\5176\4ED6\754C\9762 (\4F8B\5982\667A\80FD\624B\673A\6216\5E73\677F\7535\8111), \8BF7\9009\62E9\76F8\5E94\7684\7528\6237\754C\9762\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425107702312667)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\684C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108425268948312667)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('jQuery Mobile \667A\80FD\624B\673A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108040818197312355)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108256051876312528)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\5217\662F\5426\8FD8\663E\793A\5728\884C\6807\9898\4E2D\3002'),
unistr('\5305\62EC\5217\503C\53EF\5927\5927\63D0\9AD8\62A5\8868\4E2D\5448\73B0\7684\8868\5355\5B57\6BB5\7684\53EF\8BBF\95EE\6027\3002'),
unistr('\6307\5B9A\65F6, \8FD9\5C06\5BFC\81F4\884C\6807\9898\4E0E\5217\6807\9898\4E00\8D77\4F7F\7528\6765\5448\73B0\62A5\8868\4E2D\7684\8868\5355\5B57\6BB5\7684\6807\7B7E (\4F7F\7528\6B64 <code>''&lt;\5217\6807\9898&gt; : &lt;\884C\6807\9898&gt;''</code> \683C\5F0F)\3002</p>'),
unistr('<p>\4F8B\5982, \5047\5B9A\60A8\5728 EMP \8868\4E0A\5177\6709\62A5\8868\5E76\5C06 ENAME \5217\5B9A\4E49\4E3A\884C\6807\9898\3002\5BF9\4E8E ENAME \4E3A ''JONES'' \7684\884C, \6B64\884C\4E2D Salary \5B57\6BB5\7684\6807\7B7E\5C06\4E3A "Salary : JONES"\3002'),
unistr('\5C4F\5E55\9605\8BFB\5668\7528\6237\53EF\4EE5\901A\8FC7\6B64\65B9\6CD5\6309\8868\5355\5B57\6BB5\5728\62A5\8868\4E2D\8FDB\884C\5BFC\822A, \5E76\4E14\8FD8\80FD\4E86\89E3\54EA\4E9B\8868\5355\5B57\6BB5\4E0E\54EA\4E00\884C\76F8\5173\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108255934002312528)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4F5C\884C\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284302929312552)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\662F\5426\8981\4E3A\56FE\6807\89C6\56FE\5B9A\4E49\5B9A\5236\94FE\63A5\3002\4F7F\7528\6B64\9009\9879\53EF\4EE5\66F4\52A0\7075\6D3B\5730\5B9A\4E49\56FE\6807\89C6\56FE\7684\5185\5BB9, \5305\62EC\4F7F\7528\591A\5217\7684\80FD\529B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284283608312552)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003477118312328)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\6B64\9A8C\8BC1\9009\62E9\5173\8054\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003399042312328)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\7F16\8F91\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001957360312327)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\8981\4E3A\6B64\9A8C\8BC1\6D4B\8BD5\7684\7B49\5F0F\7C7B\578B\3002\53D6\51B3\4E8E\60A8\7684\9009\62E9, \9700\8981\4E00\4E2A\6216\591A\4E2A\9644\52A0\5C5E\6027\624D\80FD\5B8C\5168\5B9A\4E49\6B64\9A8C\8BC1\3002</p>'),
unistr('<p>\5982\679C\9A8C\8BC1\901A\8FC7\7B49\5F0F\6D4B\8BD5, \6216\8005\6C42\503C\7ED3\679C\4E3A\201C\771F\201D, \5219\4E0D\4F1A\663E\793A\9A8C\8BC1\9519\8BEF\6D88\606F\3002'),
unistr('\5982\679C\9A8C\8BC1\672A\80FD\901A\8FC7\7B49\5F0F\6D4B\8BD5, \6C42\503C\7ED3\679C\4E3A\201C\5047\201D, \6216\8005\8FD4\56DE\975E\7A7A\6587\672C\5B57\7B26\4E32, \5219\4F1A\663E\793A\9A8C\8BC1\9519\8BEF\6D88\606F\3002</p>'),
unistr('<p>\9A8C\8BC1\5931\8D25\4E0D\4F1A\505C\6B62\5BF9\540E\7EED\9A8C\8BC1\6C42\503C, \56E0\6B64, \6BCF\4E2A\540E\7EED\9A8C\8BC1\53EF\80FD\4F1A\5F15\53D1\5176\4ED6\9A8C\8BC1\9519\8BEF\6D88\606F\3002\5982\679C\8981\505C\6B62\6267\884C\540E\7EED\9A8C\8BC1, \5219\9700\8981\5728\7B2C\4E00\4E2A\5931\8D25\7684\9A8C\8BC1\4E2D\6DFB\52A0\5176\4ED6\903B\8F91, \4F8B\5982\5C06\9875\9879\8BBE\7F6E\4E3A\7279\5B9A\503C, \7136\540E\6839\636E\9700\8981\589E\5F3A\540E\7EED\9A8C\8BC1\7684\6761\4EF6\903B\8F91\3002\5982\679C\5BF9\4E00\4E2A\6216\591A\4E2A\9A8C\8BC1\6C42\503C\5931\8D25, \5219\4E0D\6267\884C\540E\7EED\5904\7406\548C\5206\652F\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458603594312693)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458710674312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C SQL \67E5\8BE2\672A\8FD4\56DE\884C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664878604312854)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108664912915312854)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\771F\201D\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\8868\8FBE\5F0F\7684\6C42\503C\7ED3\679C\4E3A\201C\5047\201D\FF0C\5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459284263312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\FF08\8FD4\56DE\5E03\5C14\503C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459349480312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\201C\771F\201D\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\201C\5047\201D\FF0C\5219\9A8C\8BC1\5931\8D25\3002<br>'),
unistr('\6CE8\FF1A\4ECE\8BE5\51FD\6570\8FD4\56DE\7684\7ED3\679C\5FC5\987B\662F\5E03\5C14\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459419875312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\4F53\FF08\8FD4\56DE\9519\8BEF\6587\672C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459579436312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\7A7A\5B57\7B26\4E32\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\51FD\6570\4F53\8FD4\56DE\975E\7A7A\5B57\7B26\4E32\FF0C\5219\9A8C\8BC1\5931\8D25\3002\8FD4\56DE\7684\5B57\7B26\4E32\663E\793A\4E3A\9A8C\8BC1\7684\9519\8BEF\6D88\606F\3002<br>'),
unistr('\6CE8\FF1A\4ECE\8BE5\51FD\6570\8FD4\56DE\7684\7ED3\679C\5FC5\987B\662F\6587\672C\5B57\7B26\4E32\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460221818312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460300539312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\5305\542B\7A7A\683C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\5305\542B\7A7A\683C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462231911312697)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\81F3\5C11\5305\542B\503C\4E2D\7684\4E00\4E2A\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462361022312697)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\81F3\5C11\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4E00\4E2A\5B57\7B26, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E0D\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4EFB\4F55\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462408214312697)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\503C\4E2D\7684\4EFB\4F55\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462516057312697)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4EFB\4F55\5B57\7B26, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\81F3\5C11\5305\542B\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4E00\4E2A\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462069984312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\53EA\5305\542B\5728\503C\4E2D\6307\5B9A\7684\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462142065312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\53EA\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\627E\5230\7684\5B57\7B26, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\5305\542B\4E0D\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D\7684\4EFB\4F55\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461241383312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 = \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461354733312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461646043312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461700466312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461455298312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 != \503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461519913312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\7B49\4E8E\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\4E2D\7684\6587\672C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461873616312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\5305\542B\5728\503C\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461983277312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\5B8C\5168\5305\542B\5728\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6587\672C\4E2D, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460496169312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460567795312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\662F\4EC5\5305\542B\5B57\6BCD\548C\6570\5B57\4E14\4E0D\5305\542B\7279\6B8A\5B57\7B26\7684\5B57\6BCD\6570\5B57, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\5305\542B\7279\6B8A\5B57\7B26, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460885106312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460908812312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\662F\6709\6548\65E5\671F, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E0D\662F\6709\6548\65E5\671F, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460673822312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460780882312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\662F\6570\5B57, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\5305\542B\975E\6570\5B57\5B57\7B26 (\5305\62EC\7A7A\683C, \524D\5BFC\7A7A\683C\9664\5916), \5219\9A8C\8BC1\5931\8D25\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461042576312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\662F\6709\6548\65F6\95F4\6233')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108461114689312696)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\662F\6709\6548\65F6\95F4\6233, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E0D\662F\6709\6548\65F6\95F4\6233, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459687815312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459780682312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\4E3A\7A7A, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E3A\7A7A, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459882785312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459921936312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\4E3A\7A7A\548C\6570\5B57\96F6, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E3A\7A7A\6216\6570\5B57\96F6, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460015203312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\4E0D\4E3A\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108460194485312695)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\4E0D\4E3A\6570\5B57\96F6, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C\9879\503C\4E3A\6570\5B57\96F6, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458898018312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FD4\56DE\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108458971566312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C SQL \67E5\8BE2\672A\8FD4\56DE\884C, \5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C SQL \67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C, \5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459033952312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108459161610312694)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C PL/SQL \4EE3\7801\6267\884C\65F6\6CA1\6709\4EA7\751F\9519\8BEF\FF0C\5219\9A8C\8BC1\901A\8FC7\3002<br>'),
unistr('\5982\679C PL/SQL \8868\8FBE\5F0F\6267\884C\65F6\4EA7\751F\9519\8BEF\FF0C\5219\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462655628312697)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\5339\914D\6B63\5219\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108462749017312697)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\9879\503C\5339\914D\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6B63\5219\8868\8FBE\5F0F, \5219\9A8C\8BC1\901A\8FC7\3002'),
unistr('\5982\679C\9879\503C\4E0D\5339\914D\60A8\8F93\5165\5230<em>\503C</em>\5C5E\6027\7684\6B63\5219\8868\8FBE\5F0F, \5219\9A8C\8BC1\5931\8D25\3002<br>'),
unistr('\6CE8: \6B63\5219\8868\8FBE\5F0F\4F7F\60A8\53EF\4EE5\901A\8FC7\4F7F\7528\6807\51C6\5316\8BED\6CD5\60EF\4F8B\800C\4E0D\53EA\662F\76F4\63A5\5B57\7B26\6BD4\8F83\6765\5728\5B57\7B26\4E32\6570\636E\4E2D\641C\7D22\6A21\5F0F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001851211312327)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187034775312472)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8F74\57FA\7EBF\662F\5F00\59CB\4E8E\6700\5C0F\6570\636E\503C\8FD8\662F\5F00\59CB\4E8E\96F6\3002\4EC5\9002\7528\4E8E\6570\5B57\6570\636E\8F74\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187153510312472)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108187272806312472)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108186944863312472)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7EBF\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218758446312497)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\96C6\5408\540D\79F0\3002\6B64\53C2\6570\503C\7684\6E90\5C06\57FA\4E8E\96C6\5408\7B2C\4E00\884C\7684 CLOB \5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218650962312497)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173390698312461)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E3A\56FE\8868\4E0A\7684\503C\8BBE\7F6E\683C\5F0F\65F6\5C06\4F7F\7528\7684\8D27\5E01\3002'),
unistr('        \6B64\503C\5E94\4E3A ISO 4217 \5B57\6BCD\8D27\5E01\4EE3\7801\3002\5982\679C\683C\5F0F\8BBE\7F6E\4E3A\8D27\5E01\FF0C\4F46\672A\5728<strong>\8D27\5E01</strong>\5C5E\6027\4E2D\5B9A\4E49\8D27\5E01\FF0C\5448\73B0\56FE\8868\65F6\5C06\81EA\52A8\4ECE\5E94\7528\7A0B\5E8F\8BED\8A00\6D3E\751F\8D27\5E01\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173270539312461)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D27\5E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299412139312564)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5411\56FE\8868\4E0A\7684\6570\5B57\503C\5E94\7528\7684\5C0F\6570\4F4D\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108287098911312554)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\503C\6807\7B7E\4E2D\4F7F\7528\7684\5C0F\6570\4F4D\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108286917398312554)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\6570\4F4D\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675777235312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676188798312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676075769312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675928420312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676225000312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675887066312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108675617526312862)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173758869312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\56FE\8868\4E0A\7684\503C\7684\7F29\653E\884C\4E3A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173983750312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174278807312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5341\4EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174128505312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\4E07')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173841445312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174412275312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5343\4E07\4EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174026355312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5343')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108174398555312462)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E07\4EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173650898312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\7F29\653E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299336012312564)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\8981\5411\56FE\8868\4E0A\7684\503C\5E94\7528\7684\683C\5F0F\7C7B\578B\3002'),
unistr('        <strong>\5C0F\6570</strong>\3001<strong>\767E\5206\6BD4</strong>\6216<strong>\8D27\5E01</strong>\683C\5F0F\4EC5\5E94\7528\4E8E\6570\5B57\503C\3002'),
unistr('        <strong>\65E5\671F</strong>\3001<strong>\65F6\95F4</strong>\548C<strong>\65E5\671F\65F6\95F4</strong>\683C\5F0F\5C06\4EC5\5E94\7528\4E8E\56FE\8868\4E0A\76F8\5E94\6570\636E\7C7B\578B\7684\503C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171795897312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\5E94\7528\5230\56FE\8868\4E0A\503C\7684\6570\5B57, \65E5\671F\548C/\6216\65F6\95F4\7C7B\578B\7684\683C\5F0F\8BBE\7F6E\3002\5BF9\4E8E\65E5\671F\548C/\6216\65F6\95F4\683C\5F0F\8BBE\7F6E, \8BF7\786E\4FDD\6839\636E\56FE\8868\6570\636E\5C06\56FE\8868\5C5E\6027<strong>\65F6\95F4\8F74\7C7B\578B</strong>\8BBE\7F6E\4E3A\4EE5\4E0B\503C\4E4B\4E00: <strong>\5DF2\542F\7528</strong>, <strong>\6DF7\5408\9891\7387</strong>\6216<strong>\8DF3\8FC7\95F4\9699</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173009677312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D27\5E01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310348315312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\6570\5B57\683C\5F0F\5316\4E3A\8D27\5E01\65F6, \9700\8981\8BBE\7F6E\201C\8D27\5E01\201D\5C5E\6027\4EE5\6307\5B9A\683C\5F0F\5316\6570\5B57\65F6\5C06\4F7F\7528\7684\8D27\5E01\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172192486312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F - \5B8C\6574\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309229621312572)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65E5\671F\683C\5F0F\5316\4E3A\5B8C\6574\683C\5F0F\65F6, \683C\5F0F\5316\65E5\671F\5C06\5305\542B\957F\5DE5\4F5C\65E5 (EEEE), \5E74 (y), \957F\6708 (MMMM), \65E5 (d)\3002\4F8B\5982, Wednesday, January 6, 2016\3002'),
unistr('        \5BF9\4E8E\4E00\4E9B\8BED\8A00, \4E0D\4F7F\7528\957F\6708; \4F8B\5982, \5728\201C\65E5\8BED\201D\4E2D, \6A21\5F0F\4F7F\7528\6570\5B57\6708\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172067120312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F - \957F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309184300312572)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\65E5\671F\683C\5F0F\5316\4E3A\957F\683C\5F0F\65F6, \683C\5F0F\5316\65E5\671F\5C06\5305\542B\5E74, \957F\6708, \65E5\3002\4F8B\5982, January 6, 2016\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171982296312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F - \4E2D\7B49\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309054460312572)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65E5\671F\683C\5F0F\5316\4E3A\4E2D\7B49\683C\5F0F\65F6, \683C\5F0F\5316\65E5\671F\5C06\5305\542B\5E74, \7F29\5199\6708 (MMM), \65E5\3002\4F8B\5982, Jan 6, 2016\3002'),
unistr('        \5BF9\4E8E\4E00\4E9B\8BED\8A00, \4E0D\4F7F\7528\7F29\5199\6708; \5728\8FD9\79CD\60C5\51B5\4E0B, \4E2D\7B49\683C\5F0F\5C06\5305\542B\6570\5B57\6708 (MM/M)\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171853863312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F - \77ED\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108308951627312572)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\65E5\671F\683C\5F0F\5316\4E3A\77ED\683C\5F0F\65F6, \683C\5F0F\5316\65E5\671F\5C06\5305\542B\5E74, \6570\5B57\6708 (MM/M), \65E5\3002\4F8B\5982, 1/6/16\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310020792312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\65F6\95F4 - \5B8C\6574\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310166218312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65E5\671F\65F6\95F4\683C\5F0F\5316\4E3A\5B8C\6574\683C\5F0F\65F6, \683C\5F0F\5316\7684\65E5\671F\65F6\95F4\5C06\5305\542B\957F\5DE5\4F5C\65E5 (EEEE), \5E74 (y), \957F\6708 (MMMM), \65E5 (d), \5C0F\65F6 (h/H), \5206\949F (mm), \79D2 (ss) \548C\65F6\533A (zzzz)\3002\4F8B\5982, Wednesday, January 6, 2016 7 h 30 min 21 s\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172831056312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\65F6\95F4 - \957F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309956934312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65E5\671F\65F6\95F4\683C\5F0F\5316\4E3A\957F\683C\5F0F\65F6, \683C\5F0F\5316\7684\65E5\671F\65F6\95F4\5C06\5305\542B\5E74, \957F\6708, \65E5, \5C0F\65F6, \5206\949F, \79D2\548C\65F6\533A (z)\3002\4F8B\5982, Jan 6, 2016 7:30:21 AM\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172728549312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\65F6\95F4 - \4E2D\7B49\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309829190312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65E5\671F\65F6\95F4\683C\5F0F\5316\4E3A\4E2D\7B49\683C\5F0F\65F6, \683C\5F0F\5316\7684\65E5\671F\65F6\95F4\5C06\5305\542B\5E74, \7F29\5199\6708 (MMM), \65E5, \5C0F\65F6, \5206\949F, \79D2\548C\65F6\533A (z)\3002\4F8B\5982, Jan 6, 2016 7:30:21 AM\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172606631312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\65F6\95F4 - \77ED\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309779923312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65E5\671F\65F6\95F4\683C\5F0F\5316\4E3A\77ED\683C\5F0F\65F6, \683C\5F0F\5316\7684\65E5\671F\65F6\95F4\5C06\5305\542B\5E74, \6570\5B57\6708 (MM/M), \65E5, \5C0F\65F6, \5206\949F\3002\4F8B\5982, 1/6/16 7:30 AM\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172919118312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310283074312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\6570\5B57\683C\5F0F\5316\4E3A\5C0F\6570\65F6, \5C0F\6570\70B9\7B26\53F7\66FF\6362\4E3A\533A\57DF\8BBE\7F6E\7684\6700\9002\5408\7B26\53F7\3002\5728\201C\82F1\8BED\201D\4E2D, \6B64\7B26\53F7\4E3A\5C0F\6570\70B9 ("."), \800C\5728\8BB8\591A\533A\57DF\8BBE\7F6E\4E2D, \6B64\7B26\53F7\4E3A\5C0F\6570\70B9\9017\53F7 (",")\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173192081312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108310487856312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\6570\5B57\683C\5F0F\5316\4E3A\767E\5206\6BD4\65F6, \56FE\8868\4E0A\7684\503C\5C06\4E58\4EE5 100 \4EE5\683C\5F0F\5316\4E3A\767E\5206\6BD4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172529136312461)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4 - \5B8C\6574\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309675780312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65F6\95F4\683C\5F0F\5316\4E3A\5B8C\6574\683C\5F0F\65F6, \683C\5F0F\5316\65F6\95F4\5C06\5305\542B\5C0F\65F6 (h/H), \5206\949F (mm), \79D2 (ss) \548C\65F6\533A (zzzz)\3002\4F8B\5982, 7 h 30 min 21 s\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172475904312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4 - \957F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309511742312573)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65F6\95F4\683C\5F0F\5316\4E3A\957F\683C\5F0F\65F6, \683C\5F0F\5316\65F6\95F4\5C06\5305\542B\5C0F\65F6, \5206\949F, \79D2\548C\65F6\533A (z)\3002\4F8B\5982, 7:30:21 AM\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172378891312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4 - \4E2D\7B49\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309420680312572)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65F6\95F4\683C\5F0F\5316\4E3A\4E2D\7B49\683C\5F0F\65F6, \683C\5F0F\5316\65F6\95F4\5C06\5305\542B\5C0F\65F6, \5206\949F, \79D2\3002\4F8B\5982, 7:30:21 AM\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108172213559312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4 - \77ED\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108309376898312572)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F53\65F6\95F4\683C\5F0F\5316\4E3A\77ED\683C\5F0F\65F6, \683C\5F0F\5316\65F6\95F4\5C06\5305\542B\5C0F\65F6, \5206\949F\3002\4F8B\5982, 7:30 AM\3002'),
unistr('        \5C0F\65F6\683C\5F0F\53D6\51B3\4E8E\5E94\7528\7A0B\5E8F\8BED\8A00\662F\5426\4F7F\7528 12 \5C0F\65F6\5236\65F6\95F4\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171699416312460)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677736145312863)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678052271312864)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677901273312864)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677883679312864)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678182158312864)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677649282312863)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215612640312495)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215574383312495)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677343473312863)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677232598312863)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678971810312864)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678876712312864)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677148253312863)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677021583312863)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676987671312863)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678751034312864)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678638163312864)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678572781312864)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171537750312460)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\56FE\8868\7684\6700\5C0F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108171438683312460)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299586576312564)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8981\5411\56FE\8868\4E0A\7684\6570\5B57\503C\5E94\7528\7684\6570\5B57\6A21\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108791209121312958)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\4EE5\534E\6C0F\5EA6\8868\793A\6E29\5EA6\7684\6570\5B57\6A21\5F0F, \4F8B\5982 15&deg;F:</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>\4EE5\7279\5B9A\683C\5F0F\8868\793A\6570\5B57\7684\6570\5B57\6A21\5F0F, \4F8B\5982, 12,30,00:</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>\4EE5\6BEB\7C73\4E3A\5355\4F4D\8868\793A\6570\5B57\7684\6570\5B57\6A21\5F0F:</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>\4EE5\5E74\6708\683C\5F0F\8868\793A\65E5\671F\7684\65E5\671F\6A21\5F0F, \4F8B\5982 2016 \5E74 7 \6708:</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>\4EE5\6708\6765\8868\793A\65E5\671F\7684\65E5\671F\6A21\5F0F, \4F8B\5982, 7 \6708:</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173516574312461)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\53EF\9009\7684\672C\5730\5316\6570\5B57\6216\65E5\671F\6A21\5F0F\FF0C\5728\6A21\5F0F\4E2D\4F7F\7528\7684\5B57\7B26\9075\5FAA Unicode CLDR \65E5\671F\65F6\95F4\683C\5F0F\3002'),
unistr('        \63D0\4F9B\6B64\9879\65F6\FF0C\5C06\8986\76D6\6240\9009\7684\201C\683C\5F0F\201D\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108173496273312461)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676883097312863)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676755693312863)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676654493312863)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678410464312864)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678337772312864)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108678279615312864)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644965766312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\56FE\8868\4E0A\5E94\5F53\663E\793A\503C\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644345922312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645073031312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\5728\56FE\8868\7684\9ED8\8BA4\4F4D\7F6E\4E2D\FF0C\8FD9\5728\7ED8\56FE\533A\7684\5916\90E8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644444241312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645181839312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\5728\56FE\8868\4E0A\7684\6307\793A\5668\7684\4E2D\5FC3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644523768312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6307\793A\5668\8FB9\7F18\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645238474312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\5728\56FE\8868\4E0A\7684\6307\793A\5668\7684\8FB9\7F18\5185\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644688244312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6307\793A\5668\8FB9\7F18\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645320239312051)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\5728\56FE\8868\4E0A\7684\6307\793A\5668\7684\8FB9\7F18\5916\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644795734312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7ED8\56FE\533A\5916')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645494827312051)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\5728\56FE\8868\7684\7ED8\56FE\533A\5916\90E8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644829326312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645582365312051)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5982\679C\5448\73B0\6807\7B7E\FF0C\5219\503C\5C06\4E0E\6807\7B7E\663E\793A\5728\540C\4E00\4F4D\7F6E\4E2D\3002\5982\679C\4E0D\5448\73B0\6807\7B7E\FF0C\5219\503C\5C06\663E\793A\5728\56FE\8868\7684\7ED8\56FE\533A\5916\90E8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644203660312050)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215873926312495)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\8981\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\7684\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215736587312495)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677527153312863)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108677488454312863)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679190396312865)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108679072245312864)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215457987312495)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\7684 SQL \67E5\8BE2\3002\5982\679C\8FD4\56DE\4E86\591A\884C, \5219\4F7F\7528\7B2C\4E00\884C\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215305549312495)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902756315312248)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\5E76\4E14\9875\9879\53EF\89C1\FF0C\5219\5728\63D0\4EA4\9875\65F6\FF0C&PRODUCT_NAME. \5C06\81EA\52A8\6267\884C NOT NULL \9A8C\8BC1\3002</p>'),
unistr('<p>\901A\8FC7\5728\201C\5171\4EAB\7EC4\4EF6\201D>\201C\6587\672C\6D88\606F\201D\4E2D\5B9A\4E49\540D\4E3A <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> \7684\6D88\606F\FF0C\53EF\4EE5\4F7F\7528\7279\5B9A\4E8E\5E94\7528\7A0B\5E8F\7684\9519\8BEF\6D88\606F\66FF\6362\9884\5B9A\4E49\7684\9519\8BEF\6587\672C\3002</p>'),
unistr('<p>\6D88\606F\7684\663E\793A\4F4D\7F6E\7531\5E94\7528\7A0B\5E8F\7EA7\8BBE\7F6E<strong>\9ED8\8BA4\9519\8BEF\663E\793A\4F4D\7F6E</strong>\5B9A\4E49\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107902667027312248)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676511235312863)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\5E76\4E14\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\8FD4\56DE "YES"\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676449667312863)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \8868\8FBE\5F0F\FF0C\5B83\751F\6210\7684\503C\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108676322668312862)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215277571312494)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4F5C\6B64\53C2\6570\503C\7684\6E90\7684\9759\6001\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215182927312494)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297595808312563)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\503C\5E94\5982\4F55\663E\793A\5728\56FE\8868\4E0A\FF08\6570\5B57\6216\603B\8BA1\503C\7684\767E\5206\6BD4\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297321509312562)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299856019312564)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\4E3A\56FE\8868\4E0A\7684\4E00\4E2A\6570\5B57\3002</p><p>\6CE8\FF1A<strong>\683C\5F0F</strong>\5C5E\6027\5E94\5F53\4EC5\7528\6765\5C06\5B9A\5236\5C0F\6570\6216\8D27\5E01\683C\5F0F\5E94\7528\4E8E\56FE\8868\4E0A\663E\793A\7684\6807\7B7E\548C\503C\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297435853312562)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108299964935312564)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\503C\5C06\663E\793A\4E3A\4ECB\4E8E 0% \548C 100% \4E4B\95F4\7684\4E00\4E2A\767E\5206\6BD4\3002</p><p>\6CE8\FF1A\5F53<strong>\683C\5F0F</strong>\8BBE\7F6E\4E3A<strong>\767E\5206\6BD4</strong>\65F6\FF0C\56FE\8868\4E0A\7684\503C\5C06\4E58\4EE5 100 \4EE5\683C\5F0F\5316\4E3A\767E\5206\6BD4\3002\5982\679C\8981\4F7F\7528\201C\683C\5F0F\201D\5C5E\6027\FF0C\8BF7\786E\4FDD\201C\6807\7B7E\7C7B\578B\201D\8BBE\7F6E\4E3A\6570\5B57\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108297240180312562)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213624813312493)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\586B\5145\6B64\53C2\6570\7684\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218452870312497)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408 (CLOB)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218509235312497)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\8F93\5165<em>\96C6\5408</em>\7684\7B2C\4E00\884C\7684 CLOB \5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495524626312722)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6E90\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495652636312722)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 REST \6570\636E\6E90\4E2D\5B9A\4E49\4E3A\9ED8\8BA4\503C\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213966033312493)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214020331312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6240\9009<em>\9879</em>\7684\4F1A\8BDD\72B6\6001\4E2D\5B58\653E\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214905833312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108215034469312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\672A\6307\5B9A\503C\800C\8BBE\7F6E\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214396440312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214491070312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\6267\884C\8F93\5165\7684 <em>PL/SQL \8868\8FBE\5F0F</em>\6240\751F\6210\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214502331312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214692746312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>PL/SQL \51FD\6570\4F53</em>\8FD4\56DE\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214743652312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214870521312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\7684<em>\9996\9009\9879</em>\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214196094312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2 (\8FD4\56DE\5355\4E2A\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108214218981312494)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\4ECE\8F93\5165\7684 <em>SQL \67E5\8BE2</em>\8FD4\56DE\7684\7B2C\4E00\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213722099312493)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213851776312493)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\8F93\5165\5230<em>\9759\6001\503C</em>\7684\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213522212312493)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666780261312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\5BF9\6240\8F93\5165\7684\8868\8FBE\5F0F\8FDB\884C\6C42\503C\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667103027312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667034274312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666967927312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667222629312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666824950312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666676058312855)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668712346312857)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669067050312857)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668904315312857)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668843151312857)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669184250312857)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668669234312857)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665177606312854)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7528\4E8E\6267\884C\6240\8F93\5165\7684\51FD\6570\4F53\7684\8BED\8A00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665455720312854)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665309283312854)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'zh-cn'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665213166312854)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665533503312854)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665089967312854)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361515101312614)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\6B64\9A8C\8BC1\4E2D\4F7F\7528\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361419578312613)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668338654312856)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668205651312856)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669979091312858)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669852114312857)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666300466312855)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Java \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666282814312855)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 Java \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668118106312856)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668066271312856)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667950083312856)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669719858312857)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669612190312857)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669595206312857)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666143221312855)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\6307\5B9A\7684\9519\8BEF\6D88\606F\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666029968312854)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665940920312854)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 JavaScript \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786440603312954)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\6307\5B9A\7684\9519\8BEF, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361369692312613)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\FF0C\5B83\5F15\53D1\7684\9519\8BEF\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361285430312613)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\53D1\9519\8BEF\7684 PL/SQL \4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667862345312856)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \6216\8005\662F\7ECF\7406\65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667753845312856)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667696953312856)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669412521312857)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669393208312857)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108669219663312857)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665814191312854)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\6307\5B9A\7684\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665761620312854)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 PL/SQL \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108665655534312854)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 PL/SQL \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668520484312856)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108668460591312856)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670135395312858)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\5E03\5C14\503C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108670020895312858)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666528852312855)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 Python \51FD\6570\4F53\FF0C\5B83\8FD4\56DE\7684\9519\8BEF\6D88\606F\6587\672C\4F5C\4E3A\6B64\9A8C\8BC1\7684\57FA\7840\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108666476400312855)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\9519\8BEF\6587\672C\7684 Python \51FD\6570\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361946571312614)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\5339\914D\4E3A\6B64\9A8C\8BC1\6307\5B9A\7684\9879\7684\6B63\5219\8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361874771312614)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5219\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667520267312856)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\8981\5728\5458\5DE5\662F\7ECF\7406\6216\8005\90E8\95E8\4F4D\4E8E\829D\52A0\54E5\65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667427702312856)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \8868\8FBE\5F0F\4EE5\5B9A\4E49\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108667382237312855)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786397930312954)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>\5BF9\4E8E<strong>\5DF2\8FD4\56DE\884C</strong>, \8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 30 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>\5BF9\4E8E<strong>\672A\8FD4\56DE\884C</strong>, \8981\5728\5458\5DE5\4F4D\4E8E\90E8\95E8 40 \65F6\901A\8FC7\9A8C\8BC1\800C\4E0D\5F15\53D1\9519\8BEF\6D88\606F, \8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361130060312613)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165 SQL \67E5\8BE2\4EE5\5B9A\4E49\6B64\9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361041567312613)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361780258312614)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\7528\4E8E\4E0E\4E3A\6B64\9A8C\8BC1\6307\5B9A\7684\9879\5217\503C\8FDB\884C\6BD4\8F83\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108361643412312614)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492405668312719)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06\5E94\7528\7A0B\5E8F\7684\4F7F\7528\9650\5236\4E3A\7279\5B9A\529E\516C\65F6\95F4</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985176313312311)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5728\4F1A\8BDD\536B\58EB\6210\529F\8FD4\56DE\4E4B\540E\8C03\7528\7684\51FD\6570\7684\540D\79F0\3002'),
unistr('\8BE5\51FD\6570\53EF\4EE5\5728 "PL/SQL \4EE3\7801" \5C5E\6027\6216\6570\636E\5E93\4E2D\5B9A\4E49\3002'),
unistr('\7ED3\679C\5FC5\987B\662F\5E03\5C14\503C, "\771F" \8868\793A\5DF2\9A8C\8BC1\7528\6237, "\5047" \8868\793A\7528\6237\7684\9A8C\8BC1\5931\8D25\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107985019899312311)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\51FD\6570\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922775317312264)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\6240\6709\6682\6302\64CD\4F5C\5747\7B49\5F85\5F53\524D\64CD\4F5C\7684\7ED3\679C\3002'),
unistr('\5982\679C\6682\6302\64CD\4F5C\4F9D\8D56\4E8E\6B64\64CD\4F5C\7684\7ED3\679C\FF0C\5219\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\FF0C'),
unistr('\5982\679C\6CA1\6709\76F8\5173\6027\FF0C\5B83\4EEC\53EF\4EE5\5F02\6B65\65B9\5F0F\6267\884C\800C\65E0\9700\7B49\5F85\FF0C\5219\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\3002</p>'),
unistr('<p>\6CE8\FF1A\7279\5B9A\64CD\4F5C\7684\6267\884C\987A\5E8F\7531\4E3A\6BCF\4E2A\64CD\4F5C\6307\5B9A\7684\5E8F\5217\53F7\786E\5B9A\3002'),
unistr('\8981\786E\4FDD\64CD\4F5C\4EE5\76F8\540C\7684\987A\5E8F\8FD0\884C\FF0COracle \5EFA\8BAE\5E8F\5217\53F7\5BF9\4E8E\6240\6709\201C\771F\201D\64CD\4F5C\548C\6240\6709\201C\5047\201D\64CD\4F5C\552F\4E00\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107922642248312264)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B49\5F85\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010716401312333)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BC6 REST \6570\636E\6E90\662F\5426\5177\6709\672C\5730\540C\6B65\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010695796312333)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\5177\6709\540C\6B65\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108213455443312493)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010921326312333)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\542F\7528\6B64\9879\5C06\4F7F\7528\672C\5730\8868\FF08\5728 REST \6570\636E\6E90\7684<strong>\540C\6B65</strong>\90E8\5206\4E2D\914D\7F6E\FF09\FF0C\800C\975E\8BBF\95EE\5916\90E8 REST \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010848356312333)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\540C\6B65\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896950651312244)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5C06\89E6\53D1\52A8\6001\64CD\4F5C\7684\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896855141312244)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001672644312327)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5E0C\671B\6B64\9875\5904\7406\7EC4\4EF6\4EC5\5728\5355\51FB\6307\5B9A\6309\94AE\65F6\6267\884C, \8BF7\4ECE\5217\8868\4E2D\9009\62E9\6309\94AE\3002\53EF\4EE5\5408\5E76\6B64\6309\94AE\6761\4EF6\4E0E\5176\4ED6\6761\4EF6\4EE5\8FDB\4E00\6B65\7EC6\5316\6B64\9875\5904\7406\7EC4\4EF6\7684\6267\884C\65F6\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108001597177312326)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6309\4E0B\6309\94AE\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758398310312926)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5C06\89E6\53D1\52A8\6001\64CD\4F5C\7684\4E00\5217\6216\591A\5217\3002'),
unistr('\5BF9\4E8E\591A\4E2A\5217\FF0C\7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\5217\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C\FF0C\5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7\FF0C\540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\5217\540D\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758273784312926)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897363072312244)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 DOM \5BF9\8C61 (<code>document</code>, <code>window</code>) \6216 DOM \5BF9\8C61\7684 <em>id</em> (<code>myElementID</code>) \4F5C\4E3A\7528\4E8E\89E6\53D1\52A8\6001\64CD\4F5C\7684\5143\7D20\3002</p>'),
unistr('<p>\6CE8: <em>DOM \5BF9\8C61</em>\5DF2\8FC7\65F6, \5E94\66FF\6362\4E3A <em>JavaScript \8868\8FBE\5F0F</em>\6216 <em>jQuery \9009\62E9\5668</em>\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897256270312244)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DOM \5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897123550312244)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5C06\89E6\53D1\52A8\6001\64CD\4F5C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897046893312244)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754006055312923)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8FD4\56DE\5BF9\6D4F\89C8\5668\7684 <code>window</code> DOM \5BF9\8C61\7684\5F15\7528\3002</dt>'),
'<dd><code>window</code></dd>',
unistr('<dt>\8FD4\56DE\5BF9\6D4F\89C8\5668\7684 <code>document</code> DOM \5BF9\8C61\7684\5F15\7528\3002</dt>'),
'<dd><code>document</code></dd>',
unistr('<dt>jQuery \9009\62E9\5668\9009\62E9\7C7B\4E3A ''alert'' \7684\6240\6709 DIV \5143\7D20, \7136\540E\8FD4\56DE\5305\542B\5176\6240\6709\7236\7EA7\7684 jQuery \5BF9\8C61\3002</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753974858312922)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5C06\6C42\503C\7684 JavaScript \8868\8FBE\5F0F\4EE5\8FD4\56DE\5355\4E2A DOM \5BF9\8C61, DOM \5BF9\8C61\6570\7EC4\6216\5355\4E2A jQuery \5BF9\8C61\4F5C\4E3A\89E6\53D1\52A8\6001\64CD\4F5C\7684\5143\7D20\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753877901312922)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408726332312651)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\9009\62E9 DOM ID \4E3A <code>my_id</code> \7684\9875\5143\7D20</dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>\9009\62E9\7C7B\4E3A <code>my_class</code> \7684\6240\6709\9875\5143\7D20</dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>\9009\62E9\6240\6709\4F5C\4E3A\8F93\5165\7684\9875\5143\7D20</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897501084312244)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 jQuery \9009\62E9\5668\8BED\6CD5\4EE5\8FD4\56DE\4E00\4E2A\6216\591A\4E2A\7528\4E8E\89E6\53D1\52A8\6001\64CD\4F5C\7684\9875\5143\7D20\3002jQuery \5E93\63D0\4F9B\4E86\529F\80FD\975E\5E38\5F3A\5927\7684\9009\62E9\5668\8BED\6CD5, \4ECE\800C\63D0\4F9B\4E00\79CD\4ECE\9875\4E2D\8F7B\677E\8BBF\95EE\4E00\4E2A\6216\591A\4E2A\5143\7D20\7684\65B9\6CD5\3002</p>'),
unistr('<p>\6709\5173\9009\62E9\5668\8BED\6CD5\7684\8FDB\4E00\6B65\4FE1\606F, \8BF7\53C2\9605 <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">jQuery \4E3B\9875</a>\4E0A\63D0\4F9B\7684\5B98\65B9\6587\6863\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107897458946312244)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('jQuery \9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108134122290312430)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\5728\8D85\8FC7\4E86<strong>\8981\5904\7406\7684\6700\5927\884C\6570</strong>\9650\5236\65F6\663E\793A\7684\6587\672C\6D88\606F\3002'),
unistr('\9ED8\8BA4\6D88\606F\6307\793A\6700\7EC8\7528\6237\6DFB\52A0\989D\5916\7684\8FC7\6EE4\5668\4EE5\9650\5236\8981\5904\7406\7684\8BB0\5F55\6570\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108279481614312548)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\67E5\8BE2\8FD4\56DE\7684\884C\6570\591A\4E8E\8F93\5165\7684\6700\5927\884C\8BA1\6570\65F6\663E\793A\7684\6587\672C\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108560804033312774)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\8D85\8FC7\4E86\5C42\7684<strong>\8981\5904\7406\7684\6700\5927\884C\6570</strong>\9650\5236\65F6\FF0C\5728<strong>\6D88\606F</strong>\533A\57DF\4E2D\663E\793A\7684\6587\672C\6D88\606F\3002\5C06 <strong>#MAX_ROW_COUNT#</strong> \66FF\6362\7528\4E8E\5B9E\9645\63D0\53D6\7684\884C\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264742700312535)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5F53\5B58\5728\591A\4E2A\62A5\8868\884C\65F6\5C06\663E\793A\7684\6587\672C\6D88\606F\3002'),
unistr('\4F7F\7528\6B64\65B9\6CD5\53EF\4EE5\66FF\4EE3\9875\7801, \5C24\5176\662F\7528\4E8E\62A5\8868\901A\5E38\53EA\6709\4E00\4E2A\79BB\6563\8BB0\5F55\96C6\7684\60C5\51B5\3002'),
unistr('\5982\679C\62A5\8868\67E5\8BE2\8FD4\56DE\5176\4ED6\884C, \5219\6B64\6D88\606F\53EF\7528\4E8E\5411\6700\7EC8\7528\6237\53D1\9001\5F02\5E38\9884\8B66, \800C\4E0D\662F\7B80\5355\663E\793A\7A0D\6709\4E0D\540C\7684\9875\7801\63A7\4EF6\3002'),
unistr('\60A8\7684\6587\672C\6D88\606F\53EF\4EE5\5BB9\6613\5730\5408\5E76 "\64CD\4F5C\8C03\7528", \4EE5\4FBF\5411\6700\7EC8\7528\6237\63D0\4F9B\6709\5173\5982\4F55\5BF9\6B64\5F02\5E38\67E5\8BE2\7ED3\679C\8FDB\884C\54CD\5E94\7684\6307\5BFC, \5E76\4E14\53EF\4EE5\5305\542B\9875\6216 URL \94FE\63A5\3002</p>'),
unistr('<p>\53EF\4EE5\5728\6D88\606F\4E2D\4F7F\7528\4E0B\5217\9875\7801\66FF\6362\5B57\7B26\4E32:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>\663E\793A\7684\884C\6570 (\9875\5927\5C0F)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>"\884C X - Y, \5171 Z \884C" \4E2D\7684 "Z"</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"\884C X - Y, \5171 Z \884C" \4E2D\7684 "X"</dd>'),
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
unistr('    <dd>"\884C X - Y, \5171 Z \884C" \4E2D\7684 "Y"</dd>'),
'  <dt><code>#ROW_RANGES"</code></dt>',
unistr('    <dd>\663E\793A: \884C 1-15 16-30 30-32</dd>'),
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>\4E0E\884C\8303\56F4\7684\4F5C\7528\76F8\540C, \4F46\5728\9009\62E9\5217\8868\4E2D<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
unistr('    <dd>\9875\96C6: 1 2 3 4 5 6</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108264626509312535)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\66F4\591A\6570\636E\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108738409103312911)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\56FE\8868\67E5\8BE2\672A\8FD4\56DE\4EFB\4F55\884C\7684\60C5\51B5\4E0B\8981\663E\793A\7684\6587\672C\6D88\606F\3002\5982\679C\7559\7A7A, Oracle JET \5C06\81EA\52A8\4F7F\7528\9ED8\8BA4\6D88\606F "\6CA1\6709\53EF\663E\793A\7684\6570\636E"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691246122312874)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5F53\5C42\67E5\8BE2\672A\8FD4\56DE\4EFB\4F55\884C\65F6\5728<strong>\6D88\606F</strong>\533A\57DF\4E2D\663E\793A\7684\6587\672C\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228813789312505)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\5728\67E5\8BE2\672A\8FD4\56DE\4EFB\4F55\884C\65F6\663E\793A\7684\6587\672C\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108228745625312505)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6570\636E\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896725139312244)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5C06\89E6\53D1\52A8\6001\64CD\4F5C\7684\533A\57DF\7684\540D\79F0\3002'),
unistr('\4F8B\5982, \8FD9\53EF\4EE5\662F ''\4EA4\4E92\5F0F\62A5\8868'' \533A\57DF, \6B64\533A\57DF\4E0E ''\5237\65B0\540E'' \4E8B\4EF6\4E00\8D77\4F7F\7528\6765\5B9A\4E49\53EA\8981\62A5\8868\5237\65B0\5C31\5C06\89E6\53D1\7684\52A8\6001\64CD\4F5C\3002</p>'),
unistr('<p>\5982\679C\8981\4E3A\533A\57DF\4E2D\7684\591A\4E2A\9875\9879\5B9A\4E49\7C7B\4F3C\884C\4E3A, \5219\901A\8FC7\533A\57DF\89E6\53D1\52A8\6001\64CD\4F5C\53EF\80FD\975E\5E38\6709\7528\3002\4F46\662F, \8FD9\4EC5\9002\7528\4E8E\7531\6B64\533A\57DF\4E2D\7684\9879\5F15\53D1\7684\67D0\4E9B\4E8B\4EF6\3002'),
unistr('\6709\5173\652F\6301\6B64\7C7B\578B\5B9A\4E49\7684\4E8B\4EF6\5217\8868\4EE5\53CA\5982\4F55\4F7F\7528\8FD9\4E9B\4E8B\4EF6\7684\793A\4F8B, \8BF7\53C2\9605\201C\64CD\4F5C\201D\9875\4E0A\201C\4E8B\4EF6\8303\56F4\201D\7684<em>\53D7\5F71\54CD\7684\5143\7D20</em> &gt; <em>\9009\62E9\7C7B\578B</em>\7684\9879\5E2E\52A9\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896625196312243)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896554950312243)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\7528\4E8E\89E6\53D1\4E8B\4EF6\7684\9875\5143\7D20\6216\6784\9020\7684\7C7B\578B\3002\6709\5173\4F7F\7528\7279\5B9A\9009\62E9\7C7B\578B\7684\793A\4F8B, \8BF7\53C2\9605\5173\8054\5C5E\6027\7684\76F8\5173\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408439234312651)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709877972312888)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\6309\94AE\89E6\53D1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108756593265312925)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710056260312888)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7531\4E00\5217\6216\591A\5217\89E6\53D1\3002'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
unistr('        p_help_text     => q''~<p>\7531 DOM \5BF9\8C61 (<code>document</code>, <code>window</code>) \6216 DOM \5BF9\8C61\7684 <em>id</em> (<code>myElementID</code>) \89E6\53D1\3002</p>'),
unistr('        <p>\6CE8: <em>DOM \5BF9\8C61</em>\5DF2\8FC7\65F6, \5E94\4F7F\7528 <em>JavaScript \8868\8FBE\5F0F</em>\6216 <em>jQuery \9009\62E9\5668</em>\66FF\4EE3\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408306059312651)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709771179312888)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E00\4E2A\6216\591A\4E2A\9875\9879\89E6\53D1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108753200228312922)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('JavaScript \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710296011312889)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531 JavaScript \8868\8FBE\5F0F\8FD4\56DE\7684\9875\5143\7D20\89E6\53D1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408676313312651)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('jQuery \9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108710159107312888)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531 jQuery \9009\62E9\5668\8FD4\56DE\7684\4E00\4E2A\6216\591A\4E2A\9875\5143\7D20\89E6\53D1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108408525803312651)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108709997952312888)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\533A\57DF\89E6\53D1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107896481860312243)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107952226864312286)
,p_name=>'PENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6682\6302')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042683937312357)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6682\6302\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051387553312364)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6682\6302\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073475498312382)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071378822312380)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073556379312382)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B8C\6210\767E\5206\6BD4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108030595692312348)
,p_name=>'PIE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052667479312365)
,p_name=>'PKC1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052784940312365)
,p_name=>'PKC2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\952E\5217 2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744904828312915)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4F9B\5B89\88C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745077306312916)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4F9B\5347\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745123583312916)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\4EA7\529B/\793A\4F8B\5E94\7528\7A0B\5E8F\4E8B\4EF6\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748592184312918)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\7528\6237 - %1 \4E2A\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788299488312956)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\4E0B\5148\51B3\6761\4EF6\68C0\67E5\5931\8D25\3002\5728\89E3\51B3\8FD9\4E9B\95EE\9898\4E4B\524D\FF0C\5C06\65E0\6CD5\7EE7\7EED\5B89\88C5\6B64\5E94\7528\7A0B\5E8F\53CA\5176\652F\6301\5BF9\8C61\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788474260312956)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BF9\8C61\5DF2\5B58\5728: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788376081312956)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6240\9700\6743\9650: <br />'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108773587815312938)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\9875\53EF\4EE5\63A7\5236 Application Express \5DE5\4F5C\533A\7BA1\7406\5458\3001\5E94\7528\7A0B\5E8F\5F00\53D1\8005\548C\6700\7EC8\7528\6237\7684\8BBF\95EE\6743\9650\3002</p>'),
'',
unistr('<p><strong>\5DE5\4F5C\533A\7BA1\7406\5458</strong>\53EF\4EE5\5B89\88C5\3001\5220\9664\6216\5347\7EA7\5E94\7528\7A0B\5E8F\FF0C\8FD8\53EF\4EE5\7BA1\7406\7528\6237\5E10\6237\53CA\5F00\53D1\670D\52A1\3002</p>'),
'',
unistr('<p><strong>\5F00\53D1\8005</strong>\53EF\4EE5\5B89\88C5\3001\5220\9664\6216\5347\7EA7\5E94\7528\7A0B\5E8F\3002</p>'),
'',
unistr('<p><strong>\6700\7EC8\7528\6237</strong>\6CA1\6709\5F00\53D1\6743\9650\FF0C\53EA\80FD\8BBF\95EE\4E0D\4F7F\7528\5916\90E8\9A8C\8BC1\65B9\6848\7684\5E94\7528\7A0B\5E8F\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744896823312915)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\4ECE\4E0B\9762\7684\5217\8868\4E2D\9009\62E9\5DE5\4F5C\533A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108014557853312336)
,p_name=>'PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828372224312191)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PLSQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081270970312388)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\8FD4\56DE SQL \8BED\53E5\7684 PL/SQL \51FD\6570\4F53\7684\503C\5217\8868\5305\542B\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774354393312149)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020860258312340)
,p_name=>'PLSQL_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \533A\57DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315899775312578)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108294298561312560)
,p_name=>'PLUGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698436847312880)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698160988312879)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6548\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698310295312880)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749296474312919)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697906628312879)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689269479312873)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698265332312879)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698079799312879)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248178705312521)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' [\5DF2\8FC7\65F6]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108034348483312350)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' [\63D2\4EF6]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580659494312789)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' [\65E7]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200785833312483)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580484311312001)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648171726312053)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647564187312052)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345757241312601)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647612755312052)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064910446312375)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810150198312973)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\60A8\6B63\5728\8F93\5165 URL, \8BF7\4F7F\7528 <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> \548C <code>&amp;DEBUG.</code> \66FF\6362\5B57\7B26\4E32\4EE5\53CA <code>&amp;COLUMN_NAME.</code> \8BED\6CD5\5728\76EE\6807\9875\4E0A\8BBE\7F6E\884C ID \6216\4E3B\952E, \6216\8005\8BBE\7F6E\9644\52A0\5C5E\6027\503C\3002</p>'),
unistr('<p><strong>\793A\4F8B</strong></p>'),
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
unistr('<p>\6709\5173 <code>f?p</code> \8BED\6CD5\7684\8BE6\7EC6\4FE1\606F, \8BF7\67E5\770B Application Express Builder User''s Guide\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108066067506312376)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\63D2\4EF6\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397711855312642)
,p_name=>'PNONUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F8E\56FD\4EE5\5916\7684\96C7\5458\4EBA\6570\767E\5206\6BD4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776157567312150)
,p_name=>'POPUP_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114687910312415)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075056916312383)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\540E\5904\7406')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074855980312383)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\524D\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958172573312291)
,p_name=>'PRECISION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CBE\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295472940312561)
,p_name=>'PREFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767278248312144)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767880255312144)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\9700\8981\6267\884C\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767534197312144)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64A4\9500\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633339491312042)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F\4E2D\7684\9996\9009\9879\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107633492485312042)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F 1 \4E2D\7684\9996\9009\9879\503C\4E0D\7B49\4E8E\8868\8FBE\5F0F 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107735432740312119)
,p_name=>'PRESENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\793A\5F62\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795043073312165)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\524D\4E0D\80FD\4F7F\7528\62A5\8868\6253\5370, \6CA1\6709\914D\7F6E\6253\5370\670D\52A1\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043086967312357)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7 (\9700\8981 Oracle BI Publisher)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043141468312357)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028235421312346)
,p_name=>'PRIORITIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\786E\5B9A\4F18\5148\7EA7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038756710312354)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6B63\95EE\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038671259312354)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\73B0\95EE\9898')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773085708312148)
,p_name=>'PROCEDURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686538342312870)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550632058311977)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\4EE3\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107550721256311977)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637354318312044)
,p_name=>'PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570878224311992)
,p_name=>'PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5904\7406\60A8\7684\8BF7\6C42, \8BF7\7A0D\5019')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360359133312613)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760632923312928)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA7\54C1\95E8\6237')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775492427312939)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\793A: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590413996312009)
,p_name=>'PROVIDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\65B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590509551312009)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\65B9\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047449164312361)
,p_name=>'PROVISIONED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5DF2\9884\914D'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161957773312452)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\9884\914D\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043275287312357)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\5E26\6709\7535\5B50\90AE\4EF6\9A8C\8BC1\7684\7528\6237\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043436386312357)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\624B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043314720312357)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\7528\6237\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781621202312155)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782650008312155)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\8868\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782888864312155)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\7A7A\95F4\7684\6570\636E\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781465280312154)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781802368312155)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782789030312155)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'zh-cn'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781107023312154)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780926095312154)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\9884\914D\65B0 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782446889312155)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782296921312155)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7528\73B0\6709\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782132236312155)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782527857312155)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781242979312154)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781383510312154)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF\6307\5B9A\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781902087312155)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781751411312155)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781061396312154)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782387311312155)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086458908312393)
,p_name=>'PROXY_SERVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE3\7406\670D\52A1\5668')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768320953312145)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\5237\65B0\4EE5\4E0B\9879\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768401383312145)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6B63\786E, \5219\5355\51FB\201C\5168\90E8\5237\65B0\201D\3002\5426\5219, \5355\51FB\201C\53D6\6D88\201D\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392133996312638)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387869829312634)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\5220\9664\5DE5\4F5C\533A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387620646312634)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5F00\59CB\5220\9664\5DE5\4F5C\533A%1\7684\8868\7A7A\95F4%0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387267253312634)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\5220\9664\5DE5\4F5C\533A%1\7684\7528\6237%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386808854312634)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\6E05\9664\5DE5\4F5C\533A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392058536312638)
,p_name=>'PURGE.BYTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\8282')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388150256312635)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5DE5\4F5C\533A%0\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387723736312634)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5DE5\4F5C\533A%1\7684\8868\7A7A\95F4%0\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387558957312634)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5DE5\4F5C\533A%1\7684\7528\6237%0\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386650505312633)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5C0A\656C\7684 Oracle APEX \7528\6237\FF1A'),
'',
unistr('%1 \4E0A\7684\5DE5\4F5C\533A %0 \663E\793A\6700\8FD1\6CA1\6709\4EFB\4F55\6D3B\52A8\3002\60A8\7684\4E0D\6D3B\52A8\5DE5\4F5C\533A\5F53\524D\5DF2\5B89\6392\5728 %2 \5F53\5929\6216\4E4B\540E\6E05\9664\3002'),
'',
unistr('\8981\907F\514D\60A8\7684\5DE5\4F5C\533A\88AB\5220\9664\FF0C\8BF7\5355\51FB\4E0B\9762\7684 URL\FF0C\7136\540E\9009\62E9\60A8\4E0D\5E0C\671B\6E05\9664\5DE5\4F5C\533A\3002\60A8\5FC5\987B\5728\63A5\4E0B\6765\7684 %3 \5929\5185\6267\884C\6B64\64CD\4F5C\3002\5982\679C\4E0D\518D\9700\8981\6B64\5DE5\4F5C\533A\FF0C\5219\65E0\9700\6267\884C\4EFB\4F55\64CD\4F5C\3002'),
'',
unistr('\786E\8BA4\94FE\63A5\FF1A%4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386735212312633)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6E05\9664\7684 Oracle APEX \5DE5\4F5C\533A\FF1A%1 \4E0A\7684\5DE5\4F5C\533A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387974991312634)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5DE5\4F5C\533A%0\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108698879960312880)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5DE5\4F5C\533A%1\7684\8868\7A7A\95F4%0\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387468683312634)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5DE5\4F5C\533A%1\7684\7528\6237%0\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384728495312632)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4E0D\6D3B\52A8\5929\6570\81F3\5C11\4E3A %1 \7684\5DE5\4F5C\533A%0\6DFB\52A0\5230\6E05\9664\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384841077312632)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56E0\6700\8FD1\6D3B\52A8\800C\4ECE\6E05\9664\5217\8868\4E2D\5220\9664\5DE5\4F5C\533A%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384903064312632)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5C06\7535\5B50\90AE\4EF6\53D1\9001\5230%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385304512312632)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5C06\5DE5\4F5C\533A%0\4ECE\4FDD\7559\5217\8868\79FB\5230\6E05\9664\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391232840312637)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\8282')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388675737312635)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391177136312637)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390851288312637)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388529130312635)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388929687312635)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4ECE\6E05\9664\5217\8868\4E2D\5220\9664 (\56E0\6700\8FD1\6D3B\52A8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389639195312636)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\56DE\6E05\9664\5217\8868 (\4EE5\524D\4FDD\7559\4F46\5728 %0 \5929\5185\65E0\6D3B\52A8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389332468312635)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\6DFB\52A0\5230\6E05\9664\5217\8868 (\5728 %0 \5929\5185\65E0\6D3B\52A8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390258513312636)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5728\5F53\5929\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389128251312635)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\7559 (\7BA1\7406\5458\5DF2\8BF7\6C42\4E0D\6E05\9664\5DE5\4F5C\533A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389874880312636)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\5728 %0 \5929\540E\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390965803312637)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390783039312637)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390387411312636)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5269\4F59\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385148513312632)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8BB0\5F55\6765\81EA\7535\5B50\90AE\4EF6%0\7684\54CD\5E94, \503C\4E3A %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391879662312637)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386942926312634)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5DE5\4F5C\533A%2\7684\65B9\6848%0\7684\72B6\6001\8BBE\7F6E\4E3A\72B6\6001%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387088615312634)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5DE5\4F5C\533A%2\7684\8868\7A7A\95F4%0\7684\72B6\6001\8BBE\7F6E\4E3A\72B6\6001%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397345865312642)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \6BCF\65E5\5DE5\4F5C\533A\6E05\9664\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391901351312638)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\7A7A\95F4\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392456940312638)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\56DE\6E05\9664\5217\8868\7684\5DE5\4F5C\533A (\4EE5\524D\4FDD\7559\4F46\5728 %0 \5929\5185\65E0\6D3B\52A8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392397181312638)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\6DFB\52A0\5230\6E05\9664\5217\8868\7684\5DE5\4F5C\533A (\5728 %0 \5929\5185\65E0\6D3B\52A8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391361535312637)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6E05\9664\5DE5\4F5C\533A\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391567745312637)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5728\5F53\5929\6E05\9664\7684\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392559952312638)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4ECE\6E05\9664\5217\8868\4E2D\5220\9664\7684\5DE5\4F5C\533A (\56E0\6700\8FD1\6D3B\52A8)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392678227312638)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\7559\7684\5DE5\4F5C\533A (\7BA1\7406\5458\5DF2\8BF7\6C42\4E0D\6E05\9664\5DE5\4F5C\533A)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392291551312638)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\5728 %0 \5929\540E\6E05\9664\7684\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391789477312637)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388408566312635)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\5DE5\4F5C\533A%0\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690312319312873)
,p_name=>'PURGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775027430312939)
,p_name=>'PURGE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152545861312445)
,p_name=>'QB_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&nbsp;\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107829711242312193)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\6709\6548\67E5\8BE2\4EE5\67E5\770B\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152378288312445)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0\5DF2\7531\67E5\8BE2\6784\5EFA\5668\6216 SQL \547D\4EE4\5904\7406\5668\4E2D\7684\73B0\6709\67E5\8BE2\4F7F\7528\3002<br>\8BF7\9009\62E9\4E00\4E2A\65B0\7684\540D\79F0\5E76\518D\6B21\4FDD\5B58\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011023349312334)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\987B\4FDD\5B58\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991288441312316)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\5DF2\4FDD\5B58\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157895613312449)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157973611312449)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110649755312411)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\76F4\89C2\67E5\8BE2\6784\5EFA\5668\65E0\6CD5\6253\5F00\5F53\524D\7684\67E5\8BE2\3002<br>'),
unistr('\5355\51FB\201C\521B\5EFA\201D\53EF\7528\65B0\7684\67E5\8BE2\66FF\6362\5F53\524D\7684\67E5\8BE2, \4E5F\53EF\4EE5\5355\51FB\201C\8FD4\56DE\201D\4EE5\4FDD\7559\5F53\524D\7684\67E5\8BE2\3002')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110566308312411)
,p_name=>'QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635684881312043)
,p_name=>'QUERY BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\6784\5EFA\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802581254312171)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\67E5\8BE2, \672A\627E\5230 select \8BED\53E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635453775312043)
,p_name=>'QUESTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EE\9898')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354873330312608)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57\683C\5F0F\63A9\7801: 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160891431312451)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E Quick SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160931567312451)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Quick SQL \63D0\4F9B\4E86\4E00\79CD\5FEB\6377\7684\65B9\6CD5\FF0C\53EF\4EE5\4E3A\4ECE\7F29\8FDB\6587\672C\6587\6863\521B\5EFA\5173\7CFB\6570\636E\6A21\578B\751F\6210\6240\9700\7684 SQL\3002\6B64\5DE5\5177\65E8\5728\51CF\5C11\521B\5EFA SQL \8868\3001\89E6\53D1\5668\548C\7D22\5F15\7ED3\6784\6240\9700\7684\65F6\95F4\53CA\5DE5\4F5C\3002\6B64\5DE5\5177\5E76\975E\8BBE\8BA1\7528\4E8E\53D6\4EE3\6570\636E\5EFA\6A21\FF0C\5B83\53EA\662F\4E00\79CD\4E3A\7B80\5355\8868\548C\89C6\56FE\5FEB\901F\5F00\53D1\811A\672C\7684\65B9\6CD5\3002\751F\6210 SQL \4E4B\540E\FF0C\53EF\4EE5\5BF9\5176\8FDB\884C\8C03\6574\548C\6269\5C55\3002</p>'),
'',
unistr('<p>\5E38\89C1\7528\4F8B\FF1A'),
'<ul>',
unistr('  <li>\5FEB\901F\521B\5EFA\53EF\9760\7684\6570\636E\6A21\578B</li>'),
unistr('  <li>\5C06\7CBE\7B80 Quick SQL \8BED\6CD5\53E6\5B58\4E3A\6A21\578B\FF0C\4EE5\5BF9\6A21\578B\66F4\6539\8FDB\884C\8FED\4EE3\6216\8005\7528\4F5C\6A21\677F\6A21\578B\6765\5FEB\901F\5F00\59CB\4E0B\4E00\4E2A\6A21\578B\8BBE\8BA1</li>'),
unistr('  <li>\8F7B\677E\751F\6210\968F\673A\6570\636E</li>'),
unistr('  <li>\4F7F\7528\63D0\4F9B\7684\793A\4F8B\4E86\89E3 SQL \521B\5EFA\8868\3001\9009\62E9\3001\63D2\5165\3001\7D22\5F15\3001\89E6\53D1\3001PL/SQL \7A0B\5E8F\5305\548C\67E5\770B\8BED\6CD5</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053720359312366)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B64\8BBE\7F6E\63A7\5236\751F\6210\7684\8BED\6CD5\4EE5\652F\6301\5BA1\8BA1\5217\3002\7279\522B\662F\542F\7528\4E86\5BA1\8BA1\5217\65F6\FF0C\5C06\751F\6210\89E6\53D1\5668\4EE5\7EF4\62A4\521B\5EFA\884C\7684\7528\6237\548C\4E0A\6B21\66F4\65B0\884C\7684\7528\6237\3002\5728\542F\7528\65F6\FF0C\5C06\4F7F\7528\4EE5\4E0B\51FD\6570\FF1A'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053887218312366)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\542F\7528\65F6\FF0C\5C06\4F7F\7528\4EE5\4E0B\51FD\6570\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108053949403312366)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6240\6709\8868\4E0A\751F\6210 PL/SQL API \7528\4E8E\521B\5EFA\3001\63D2\5165\3001\66F4\65B0\3001\5220\9664\548C\67E5\8BE2\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054035942312366)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\521B\5EFA\7684\6BCF\4E2A\8868\4E2D\6DFB\52A0\989D\5916\7684 created\3001created_by\3001updated \548C updated_by \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054112117312366)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\542F\7528\65F6\FF0C\521B\5EFA\7684\6240\6709\8868\5747\538B\7F29\3002\9ED8\8BA4\503C\4E3A\4E0D\538B\7F29\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054221675312366)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\4E86\5BA1\8BA1\5217\65F6\FF0C\7528\4E8E\8DDF\8E2A\521B\5EFA\884C\7684\7528\6237\7684\9ED8\8BA4\5217\4E3A CREATED_BY\3002\4F7F\7528\6B64\8BBE\7F6E\53EF\4EE5\8986\76D6\9ED8\8BA4\5BA1\8BA1\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108054328542312366)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528\4E86\5BA1\8BA1\5217\65F6\FF0C\7528\4E8E\8DDF\8E2A\521B\5EFA\884C\7684\7528\6237\7684\9ED8\8BA4\5217\4E3A CREATED\3002\4F7F\7528\6B64\8BBE\7F6E\53EF\4EE5\8986\76D6\9ED8\8BA4\5BA1\8BA1\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108056308152312368)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\60C5\51B5\4E0B\4E3A\4F7F\7528 Oracle DATE \6570\636E\7C7B\578B\521B\5EFA\7684\6240\6709 DATE \5217\3002\4F7F\7528\6B64\8BBE\7F6E\53EF\8986\76D6\8BE5\9ED8\8BA4\503C\3002\6709\6548\503C\4E3A\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108058660224312370)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\8BED\6CD5\5E94\4E0E\4E4B\517C\5BB9\7684\6570\636E\5E93\7248\672C\3002\6709\6548\503C\4E3A\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063048971312374)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730621785312905)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\95E8\548C\5458\5DE5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731267415312905)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CBE\7B80 SQL \8BED\6CD5\FF0C\7528\4E8E\521B\5EFA\5E26\6709 SQL \8054\63A5 VIEW \7684 DEPARTMENTS \548C EMPLOYEES \8868\3002\8FD8\4F7F\7528 /INSERT \8BED\6CD5\751F\6210\4E86\968F\673A\6570\636E\3002/NN \6DFB\52A0 NOT NULL SQL \5217\7EA6\675F\6761\4EF6\3002\4F7F\7528\7F29\8FDB\7684\5217\8868\5B9A\4E49\8868\3001\5217\548C\5B50\8868\3002\4E3B\952E\5217\548C\5916\952E\5217\4F1A\81EA\52A8\6DFB\52A0\3002\65E0\9700\63D0\4F9B\4EFB\4F55\4E3B\952E\5217\6216\5916\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983124850312309)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108061781516312373)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC SQL \547D\4EE4\4EE5\5220\9664\521B\5EFA\7684\5404\4E2A\6570\636E\5E93\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730851363312905)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5458\5DE5\6280\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731087583312905)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA DEPARTMENTS\3001EMPLOYEES \548C SKILLS \8868\FF0C\5E76\4F7F\7528\7F29\8FDB\6765\8BC6\522B\7236\8868\548C\5B50\8868\3002\4F7F\7528\7CBE\7B80\8BED\6CD5 VC255 \6765\6307\5B9A SQL \6570\636E\7C7B\578B\3002\4F7F\7528 /INSERT \8BED\6CD5\751F\6210\968F\673A\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982904229312309)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161260145312451)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063755766312374)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\4E3A\5404\4E2A\8868\751F\6210 ID \4E3B\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161080354312451)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5165\95E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161160298312451)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4E0D\5E26\4EFB\4F55\7F29\8FDB\7684\7236\8868\540D\79F0\3002\8F93\5165\5E26 2 \4E2A\6216\66F4\591A\7A7A\683C\7684\4E00\81F4\7F29\8FDB\7684\8868\5217\3002\901A\5E38\6700\597D\662F\4E0D\6307\5B9A\4E3B\952E\FF0C\7CFB\7EDF\5C06\4E3A\60A8\751F\6210\4E3B\952E\3002\53EA\9700\5728\7236\8868\4E0B\7F29\8FDB\5B50\8868\5373\53EF\521B\5EFA\7236\5B50\5173\7CFB\3002</p>'),
'',
unistr('<p>\6570\636E\7C7B\578B\901A\5E38\9ED8\8BA4\4E3A VARCHAR2\FF0C\5982\679C\60A8\5E0C\671B\4F7F\7528\4E0D\540C\6570\636E\7C7B\578B\7684\5217\FF0C\5219\5728\5217\540D\7684\7ED3\5C3E\6DFB\52A0\7A7A\683C\548C NUM\3001INT \6216 DATE\3002\6839\636E\5217\540D\4E2D\5305\542B\7684\82F1\8BED\6587\672C\FF0C\5728\672A\6307\5B9A\4EFB\4F55\6570\636E\7C7B\578B\65F6\FF0C\7CFB\7EDF\5C06\6839\636E\83B7\5F97\7684\4FE1\606F\63A8\65AD\67D0\4E9B\5217\540D\3002\4F8B\5982\FF0C\5982\679C\5217\540D\5305\542B\5355\8BCD DATE\FF0C\5219\8BE5\5217\662F\65E5\671F\6570\636E\7C7B\578B\FF0C\5982\679C\5217\540D\5305\542B\5355\8BCD NUMBER \6216 NUM\FF0C\5219\8BE5\5217\662F\6570\5B57\6570\636E\7C7B\578B\3002\5982\679C\8981\6307\5B9A\7279\5B9A VARCHAR2 \957F\5EA6\FF0C\5219\8F93\5165 "VCn"\FF0C\5176\4E2D "n" \662F VARCHAR2 \7684\957F\5EA6\3002\5355\51FB\201C\8BED\6CD5\201D\6309\94AE\5C06\663E\793A\53EF\7528\7684\8BED\6CD5\3002\5BF9\8C61\540D\79F0\5C06\81EA\52A8\683C\5F0F\5316\FF0C\4F7F')
||unistr('\7528\4E0B\5212\7EBF\66FF\6362\7A7A\683C\FF0C\8FD9\6837\60A8\53EF\4EE5\5728\5217\548C\8868\540D\4E2D\4F7F\7528\7A7A\683C\3002</p>'),
'',
unistr('<p>\5355\51FB\201C\8BBE\7F6E\201D\6309\94AE\53EF\67E5\770B\591A\4E2A\751F\6210\9009\9879\3002\60A8\53EF\4EE5\81EA\52A8\6DFB\52A0\201CWho \5217\201D\FF0C\4F8B\5982\FF0C\8C01\521B\5EFA\6216\4E0A\6B21\66F4\65B0\4E86\6307\5B9A\884C\4EE5\53CA\5728\4EC0\4E48\65F6\5019\3002\60A8\53EF\4EE5\6DFB\52A0\6BCF\6B21\884C\66F4\65B0\65F6\81EA\52A8\9012\589E 1 \7684\884C\987A\5E8F\5217\3002\884C\987A\5E8F\5BF9\4E8E\7B80\5316\68C0\6D4B\4E22\5931\66F4\65B0\7684\64CD\4F5C\975E\5E38\6709\7528\3002\8FD8\53EF\4EE5\751F\6210 PL/SQL API\FF0C\8FD9\5411\6BCF\4E2A\8868\63D0\4F9B\4E00\4E2A\7A0B\5E8F\5305\FF0C\5E76\63D0\4F9B\4E86\7528\4E8E\67E5\8BE2\3001\63D2\5165\3001\66F4\65B0\548C\5220\9664\884C\7684\8FC7\7A0B\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735941601312909)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210 PL/SQL \7A0B\5E8F\5305 API\FF0C\4EE5\4FBF\5728\8868\4E2D\67E5\8BE2\3001\63D2\5165\3001\66F4\65B0\548C\5220\9664\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736041198312909)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0 Oracle \5BA1\8BA1\FF0C\9ED8\8BA4\60C5\51B5\4E0B\4E3A AUDIT ALL ON [TABLE NAME]\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736126914312909)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8\6DFB\52A0 UPDATED\3001UPDATED_BY\3001INSERTED \548C INSERTED_BY \5217\4EE5\53CA\89E6\53D1\903B\8F91\FF0C\4EE5\8BBE\7F6E\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735375006312908)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5217\4E0A\6DFB\52A0 between \68C0\67E5\7EA6\675F\6761\4EF6\FF0C\4F8B\5982 /between 1 and 100')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734748999312908)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5177\6709\4EE5\9017\53F7\6216\7A7A\683C\5206\9694\503C\7684\68C0\67E5\7EA6\675F\6761\4EF6\FF0C\4F8B\5982 /check Yes, No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064888087312375)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6B64\503C\4E3A\6307\5B9A\8868\7684\6240\6709\5217\6DFB\52A0\524D\7F00\3002\5982\679C\672A\63D0\4F9B\FF0C\5219\81EA\52A8\6DFB\52A0\4E0B\5212\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108104924295312407)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735722973312908)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\65B9\62EC\53F7\62EC\8D77\6CE8\91CA\FF0C\6216\8005\4F7F\7528 -- \8BED\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736205942312909)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\538B\7F29\7684\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734860442312908)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\6570\636E\65F6\FF0C\5C06\6B64\5217\8BBE\7F6E\4E3A\5E38\6570\3002\4F8B\5982 /constant NYC\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568198079312779)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\5217\4E3A\7A7A\503C\FF0C\5219\6DFB\52A0\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064738533312375)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0 BLOB \5217\548C _FILENAME\3001_CHARSET\3001_MIMETYPE\3001_LASTUPD \5217\FF0C\8FD9\4E9B\5217\53EF\589E\5F3A\901A\8FC7\6D4F\89C8\5668\4E0B\8F7D\6587\4EF6\7684\80FD\529B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735504829312908)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\952E\5F15\7528\FF0C\4F8B\5982 /references table_name\3002\8BF7\6CE8\610F\FF0C\53EF\4EE5\5F15\7528\4E0D\5C5E\4E8E\6A21\578B\7684\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735401177312908)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 select * from table \65F6\4E0D\663E\793A\9690\85CF\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108328756093312588)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5728\5173\8054\7684\5217\4E0A\521B\5EFA\975E\552F\4E00\7D22\5F15\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736302026312909)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\5E26\6709\968F\673A\6570\636E\7684 <strong>NN</strong> SQL INSERT \8BED\53E5\FF0C\4F8B\5982\FF1A/INSERT 20\3002\FF08\6700\5927\503C = 1000\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735199577312908)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F3A\5236\5217\503C\4F7F\7528\5C0F\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735868619312909)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('NNN \8868\793A\4ECB\4E8E 1 \4E0E 32767 \4E4B\95F4\7684\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735235131312908)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5217\4E0A\6DFB\52A0\975E\7A7A\503C\7EA6\675F\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735697618312908)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217\8BC6\522B\4E3A\8868\7684\4E3B\952E\3002\5EFA\8BAE\4E0D\8981\624B\52A8\6307\5B9A\4E3B\952E\FF0C\800C\662F\8BA9\5E94\7528\7A0B\5E8F\81EA\52A8\521B\5EFA\4E3B\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736557669312909)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 Oracle REST Data Services (ORDS) \751F\6210\542F\7528 REST \7684\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108736472704312909)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3A\6BCF\4E2A\8868\751F\6210\6570\636E\4E4B\540E\751F\6210 SQL SELECT \8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870469666312223)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\8868\7EA7\522B\552F\4E00\7EA6\675F\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734653512312908)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\552F\4E00\7EA6\675F\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108735034944312908)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F3A\5236\5217\503C\4F7F\7528\5927\5199')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734916626312908)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\6570\636E\65F6\4F7F\7528\7684\503C\5217\8868\FF0C\4EE5\9017\53F7\5206\9694\3002\4F8B\5982 /values 1, 2, 3, 4 \6216 /values Yes, No\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108163694961312453)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6570\636E\5E93\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191580162312476)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5B8C\6210\8F93\5165\7CBE\7B80 Quick SQL \5E76\5E94\7528\5408\9002\7684\8BBE\7F6E\540E\FF0C\60A8\5C31\53EF\4F7F\7528 SQL \6765\521B\5EFA\6570\636E\5E93\5BF9\8C61\FF0C\5E76\53EF\4EE5\4F7F\7528\968F\673A\6570\636E\586B\5145\8868\3002\6309\7167\4EE5\4E0B\6B65\9AA4\64CD\4F5C\FF1A<br>'),
'<ol>',
unistr('  <li>\5355\51FB<strong>\4FDD\5B58\6A21\578B</strong>\5C06\7CBE\7B80 Quick SQL \8BED\6CD5\53E6\5B58\4E3A\6A21\578B\FF0C\4EE5\4FBF\5C06\6765\91CD\7528\3002</li>'),
unistr('  <li>\8F93\5165\6A21\578B\540D\79F0\3002</li>'),
unistr('  <li>\5355\51FB<strong>\4FDD\5B58 SQL \811A\672C</strong>\5C06\8F93\51FA\53E6\5B58\4E3A\811A\672C\3002</li>'),
unistr('  <li>\8F93\5165\811A\672C\540D\79F0\3002</li>'),
unistr('  <li>\5355\51FB<strong>\68C0\67E5\5E76\8FD0\884C</strong>\5BFC\822A\5230\811A\672C\7F16\8F91\5668\3002</li>'),
unistr('  <li>\5728\811A\672C\7F16\8F91\5668\4E2D\FF0C\68C0\67E5\811A\672C\5185\5BB9\7684\6B63\786E\6027\3002</li>'),
unistr('  <li>\5355\51FB<strong>\8FD0\884C</strong>\521B\5EFA\6570\636E\5E93\5BF9\8C61\3002</li>'),
unistr('  <li>\5728\811A\672C\786E\8BA4\9875\4E0A\FF0C\5355\51FB<strong>\7ACB\5373\8FD0\884C</strong>\3002</li>'),
unistr('  <li>\5728\7ED3\679C\9875\4E0A\FF0C\68C0\67E5\5DF2\5904\7406\3001\6210\529F\548C\51FA\73B0\9519\8BEF\7684\8BED\53E5\3002<br>'),
unistr('  \5982\679C\62A5\544A\4E86\4EFB\4F55\9519\8BEF\FF0C\8BF7\6D4F\89C8\7ED3\679C\9875\4EE5\67E5\770B\7279\5B9A Oracle \9519\8BEF\6D88\606F\3002</li>'),
unistr('  <li>\FF08\53EF\9009\FF09\5355\51FB<strong>\4ECE\811A\672C\521B\5EFA\5E94\7528\7A0B\5E8F</strong>\8F6C\5230\521B\5EFA\5E94\7528\7A0B\5E8F\5411\5BFC\FF0C\5E76\6839\636E\5728\811A\672C\4E2D\6307\5B9A\7684\8868\548C\89C6\56FE\81EA\52A8\751F\6210\9875\3002</li>'),
'</ol>',
'</p>',
'',
unistr('<p><em><strong>\6CE8\FF1A</strong>\5982\679C\60A8\5E0C\671B\4EE5\540E\66F4\65B0\76F8\540C\7684\7CBE\7B80 SQL\FF0COracle \5EFA\8BAE\60A8\5C06\7CBE\7B80 SQL \4E0B\8F7D\5230\60A8\7684\8BA1\7B97\673A\3002\5982\679C\60A8\6307\5B9A\4E86\4EFB\610F\8BBE\7F6E\FF0C\8BF7\5BFC\822A\5230\201COracle SQL \8F93\51FA\201D\7A97\683C\5E95\90E8\FF0C\5E76\5C06\4EE5 <code># settings =</code> \5F00\5934\7684\884C\590D\5236\5230\201C\7CBE\7B80 Quick SQL\201D\7A97\683C\9876\90E8\3002<br>'),
unistr('\5355\51FB<strong>\4E0B\8F7D</strong>\53EF\5C06 SQL \6587\4EF6\4FDD\5B58\5230\60A8\7684\8BA1\7B97\673A\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062746524312373)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\7528\4E8E\63D2\5165\4F7F\7528\6B64\8BED\8A00\7684\8BED\53E5\7684\6570\636E\3002\9ED8\8BA4\503C\4E3A\82F1\8BED\3002\652F\6301\7684\8BED\8A00\5305\62EC\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108062923415312373)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\4E3A\6570\636E\5E93\5BF9\8C61\540D\79F0\4F7F\7528\8F83\957F\7684\6807\8BC6\7B26\3002\5728\542F\7528\65F6\FF0C\8F83\957F\7684\6807\8BC6\7B26\5141\8BB8\6700\5927\957F\5EA6\4E3A 128 \4E2A\5B57\7B26\7684\5BF9\8C61\540D\79F0\3002\672A\542F\7528\65F6\FF0C\5BF9\8C61\540D\79F0\7684\6700\5927\957F\5EA6\4E3A 30 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063167935312374)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5141\8BB8\4E3A\6570\636E\5E93\5BF9\8C61\540D\79F0\4F7F\7528\8F83\957F\7684\6807\8BC6\7B26\3002\8F83\957F\7684\6807\8BC6\7B26\5141\8BB8 VARCHAR2 \5217\6570\636E\7C7B\578B\7684\6700\5927\957F\5EA6\4E3A 32767 \4E2A\5B57\7B26\3002\672A\8BBE\7F6E\65F6\FF0CVARCHAR2 \5217\4E8B\4EF6\7C7B\578B\7684\6700\5927\957F\5EA6\4E3A 4000 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063264358312374)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8BBE\7F6E\63A7\5236\5916\952E ON DELETE \8BBE\7F6E\3002\6709\6548\503C\5305\62EC\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063385277312374)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\542F\7528\65F6\FF0C\5C06\5FFD\7565\901A\8FC7\7528\6237\754C\9762\63A7\5236\53F0\8BBE\7F6E\7684\6240\6709\5E94\7528\7A0B\5E8F\8BBE\7F6E\FF0C\4EC5\4F7F\7528\811A\672C\4E2D\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063440431312374)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\5982\4F55\8BBE\7F6E\4E3B\952E\3002\53EF\4EE5\4F7F\7528 SYS_GUID\3001\6807\8BC6\5217\6216\5E8F\5217\8BBE\7F6E\4E3B\952E\3002\6709\6548\503C\5305\62EC\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063685563312374)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\8868\540D\4E3A\4E3B\952E\6570\636E\5E93\8868\5217\6DFB\52A0\524D\7F00\3002\4F8B\5982\FF0CEMPLOYEE \8868\7684\4E3B\952E\5C06\4E3A EMPLOYEE_ID\3002\4E0D\8BBE\7F6E\540D\79F0\65F6\FF0C\9690\5F0F\521B\5EFA\7684\4E3B\952E\5217\5C06\4E3A ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063516560312374)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5BF9\8C61\524D\7F00\3002\5982\679C\672A\63D0\4F9B\FF0C\5C06\9644\52A0\4E0B\5212\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730732186312905)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA7\54C1\9500\552E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731355997312905)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CBE\7B80\8BED\6CD5\FF0C\7528\4E8E\521B\5EFA\5E26\6709 PRODUCTS\3001CUSTOMERS\3001CHANNELS\3001PROMOTIONS \548C SALES \8868\7684\661F\5F62\65B9\6848\3002SALES \8868\5305\542B\5BF9\5176\4ED6\8868\7684\5916\952E\5F15\7528\3002\8FD8\521B\5EFA\4E86\8054\63A5\5168\90E8 5 \4E2A\8868\7684 SQL VIEW\3002\53E6\5916\751F\6210\4E86\968F\673A\793A\4F8B\6570\636E\3002\4F7F\7528 NUM \8BED\6CD5\6765\786E\5B9A\6570\503C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730540539312905)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\76EE\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731110875312905)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA PROJECT_MANAGEMENT \548C\56DB\4E2A\4ECE\8868\3002\4F7F\7528 /VIEW \8BED\6CD5\521B\5EFA\4E86\4E24\4E2A\89C6\56FE\3002\8FD8\4F7F\7528 /CHECK \8BED\6CD5\6DFB\52A0\4E86\6570\636E\5E93 CHECK \7EA6\675F\6761\4EF6\3002\53E6\5916\4F7F\7528 #APEX \8BBE\7F6E\63A7\5236 SQL \8BED\6CD5\751F\6210\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063833808312374)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6240\6709\5E94\7528\7A0B\5E8F\8BBE\7F6E\91CD\7F6E\4E3A\9ED8\8BA4\503C\3002\5305\62EC\6B64\9879\65F6\FF0C\5C06\5FFD\7565\4F1A\8BDD\5F53\524D\6D3B\52A8\7684\6240\6709\5E94\7528\7A0B\5E8F\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108063940479312374)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\521B\5EFA\7684\6BCF\4E2A\8868\FF0C\6DFB\52A0\751F\6210\5B57\6BCD\6570\5B57\6807\8BC6\7B26\7684 ROW_KEY \5217\3002ROW_KEY \5217\7684\503C\5C06\7531\751F\6210\7684\6570\636E\5E93\8868\89E6\53D1\5668\903B\8F91\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064187350312374)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\6BCF\4E2A\8868\FF0C\6DFB\52A0\5728\6BCF\6B21\66F4\65B0\65F6\9012\589E 1 \7684 ROW_VERSION \5217\3002\5728\542F\7528\65F6\FF0C\5C06\751F\6210\6570\636E\5E93\8868\89E6\53D1\5668\903B\8F91\FF0C\4EE5\4FBF\5728\66F4\65B0\65F6\9012\589E\884C\7248\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064237349312374)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\65B9\6848\540D\4F5C\4E3A\5BF9\8C61\540D\7684\524D\7F00\3002\9ED8\8BA4\503C\662F\5BF9\8C61\540D\6CA1\6709\65B9\6848\524D\7F00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064041717312374)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\6BCF\4E2A\8868\FF0C\6DFB\52A0 TENANT_ID \5217\4EE5\652F\6301\591A\79DF\6237\5E94\7528\7A0B\5E8F\3002\6B64\5217\7684\503C\76F4\63A5\6DFB\52A0\5230\8868\4E2D\FF0C\7EF4\62A4\6B64\503C\7684\673A\5236\9700\8981\7531\5F00\53D1\8005\63D0\4F9B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064685579312375)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\9009\62E9\6CA1\6709\5217\8BED\4E49\FF0C\6216\8005\4E3A BYTE \6216 CHAR \8BED\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107983029696312309)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046265518312360)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\60A8\53EF\4EE5\8F93\5165\5185\5D4C\8BBE\7F6E\6765\660E\786E\8BBE\7F6E SQL \8BED\6CD5\751F\6210\9009\9879\3002\6216\8005\FF0C\60A8\53EF\4EE5\5355\51FB\4F4D\4E8E\53F3\4FA7\7A97\683C\9876\90E8\7684<strong>\8BBE\7F6E</strong>\4EE5\58F0\660E\65B9\5F0F\8BBE\7F6E\751F\6210\9009\9879\3002</p>'),
'',
unistr('<p>\76F4\63A5\5728\201C\7CBE\7B80 Quick SQL\201D\7A97\683C\4E2D\8F93\5165\8BBE\7F6E\53EF\786E\4FDD\5373\4F7F\4E0B\8F7D\811A\672C\5E76\5728\4EE5\540E\5C06\5176\7C98\8D34\56DE\6765\FF0C\60A8\4ECD\4F7F\7528\76F8\540C\7684 SQL \751F\6210\9009\9879\3002\4F8B\5982\FF0C\8F93\5165\4EE5\4E0B\5185\5BB9\4E3A\6240\6709\8868\540D\6DFB\52A0 TEST \524D\7F00\5E76\4E3A\65B9\6848 OBE \6267\884C\751F\6210\64CD\4F5C\FF1A<br>'),
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
unistr('\6B64\5916\FF0C\5728\5355\72EC\884C\4E0A\8F93\5165\5404\4E2A\8BBE\7F6E\53EF\5F97\5230\76F8\540C\7ED3\679C\FF1A<br>'),
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>\6CE8\FF1A</strong>\8BBE\7F6E\5FC5\987B\5728\65B0\884C\4E0A\5F00\59CB\FF0C\4EE5 <code># settings = </code> \5F00\5934\53EF\8F93\5165\591A\4E2A\8BBE\7F6E\FF0C\6216\8005\4EE5 <code># </code> \5F00\5934\53EF\6BCF\884C\8F93\5165\4E00\4E2A\8BBE\7F6E\3002\6240\6709\503C\4E0D\533A\5206\5927\5C0F\5199\3002\4E3A\6E05\695A\8D77\89C1\FF0C\53EF\4EE5\6DFB\52A0\62EC\53F7\3001\7A7A\683C\548C\9017\53F7\FF0C\4F46\4F1A\5FFD\7565\8FD9\4E9B\5B57\7B26\3002\8981\751F\6210\6240\6709\8BBE\7F6E\FF0C\8BF7\4F7F\7528 <code># verbose: true</code>\3002</em> '),
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982784758312309)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752564547312921)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752695299312921)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA ASSIGNEES \548C TODOS \8868\3002\4EE5\6B64\4E3A\8D77\70B9\53EF\4EE5\5728\51E0\5206\949F\5185\521B\5EFA\5B9A\5236\7684\5F85\529E\4E8B\9879\7CFB\7EDF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064365343312375)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\542F\7528\65F6\FF0C\5BA1\8BA1\5217\4F7F\7528\6B64\8BBE\7F6E\8986\76D6\9ED8\8BA4\5BA1\8BA1\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064467877312375)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\542F\7528\65F6\FF0C\5BA1\8BA1\5217\4F7F\7528\6B64\8BBE\7F6E\8986\76D6\9ED8\8BA4\5BA1\8BA1\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108064553922312375)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\663E\793A\6240\6709\8BBE\7F6E\FF0C\800C\4E0D\53EA\662F\4E0D\540C\4E8E\9ED8\8BA4\503C\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107982803265312309)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\4FDD\89C6\56FE\540D\79F0\4E0D\5305\542B\7A7A\683C\FF0C\5E76\4E14\8868\540D\4E0D\5305\542B\7A7A\683C\3002\4F7F\7528\7A7A\683C\6216\9017\53F7\5206\9694\8868\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108191691036312476)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831096755312194)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038983103312354)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714358455312103)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831403579312194)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714296737312103)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309 %0 \7EDF\8BA1\7684\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107712908320312102)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831324219312194)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039026148312354)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206927989312488)
,p_name=>'QUICK_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>'Quick SQL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548678674311975)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \8303\56F4\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548747456311975)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \8303\56F4\67F1\72B6\56FE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108864255779313015)
,p_name=>'READERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BFB\8005')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780585812312950)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\5206\914D\9879: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572023810311993)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\5206\914D\9875')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107957471667312290)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56DE\6536\7AD9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161397656312452)
,p_name=>'REDIRECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161544115312452)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6309\94AE\5C06\91CD\5B9A\5411\5230 URL, \5F88\53EF\80FD\4F7F\9875\65E0\6CD5\63D0\4EA4\3002\5982\679C\5E0C\671B\6309\94AE\63D0\4EA4\9875, \8BF7\4E0D\8981\6807\8BC6\91CD\5B9A\5411\9875\6216 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827718161312191)
,p_name=>'REDIRECT_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293445671312559)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\5E94\7528\7A0B\5E8F %0, \9875 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827657273312191)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\9875 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635290681312043)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635359496312043)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108008627508312332)
,p_name=>'REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\7684')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636241406312044)
,p_name=>'REGEN_VER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\65B0\751F\6210\9A8C\8BC1\4EE3\7801')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011217411312334)
,p_name=>'REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155793246312447)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6309\94AE\7684\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108075267221312383)
,p_name=>'REGION CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068466329312378)
,p_name=>'REGION CONTENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614179757312027)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\6309\94AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107637218061312044)
,p_name=>'REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795212577312165)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5217\8868\6A21\677F\8986\76D6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019571922312340)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\663E\793A\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537978572311967)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283828355312552)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556102337311981)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108003847288312328)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580321198312001)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\4E0A\8F7D\5217\6620\5C04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017912668312338)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\663E\793A\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348558301312603)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9762\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137846013312433)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539031661311968)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145019259312439)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258705282312530)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998267037312324)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716684506312893)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5207\6362\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580280943312001)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716749650312893)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\6392\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284052775312552)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107537487422311966)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720501178312896)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358566125312611)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283429258312551)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868 (HTML - \65E7)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108254595334312527)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108358637988312611)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283328919312551)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868 (SVG - \65E7)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108258880765312530)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\683C\5F0F\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108283922245312552)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538220088311967)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107704204343312096)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023215256312342)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\62D2\7EDD\6216\91CD\590D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108043933721312358)
,p_name=>'RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590719401312009)
,p_name=>'RELEASED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\5E03\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073801715312382)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073772668312382)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\7684\53D1\884C\7248\6982\8981: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749121344312919)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790236950312957)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4F9B PL/SQL Web \5DE5\5177\5305 %0 <a href="%1" target="_blank">[\66F4\591A\4FE1\606F]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790040828312957)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4F9B\8865\4E01\7A0B\5E8F\96C6 %0 <a href="%1" target="_blank">[\66F4\591A\4FE1\606F]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790101931312957)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4F9B Oracle APEX %0 <a href="%1" target="_blank">[\66F4\591A\4FE1\606F]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108749093145312919)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF\662F\6700\65B0\7684')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690545253312874)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56E0\6D3B\52A8\800C\88AB\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590239184312009)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108581689002312789)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5220\9664\5E94\7528\7A0B\5E8F\5B9A\4E49\4EE5\53CA\6240\6709\5DF2\521B\5EFA\7684\652F\6301\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108089519740312395)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\5220\9664\5DE5\4F5C\533A\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153795949312446)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5217 %0 \91CD\547D\540D\4E3A %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153959168312446)
,p_name=>'RENAME_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\8868 %0 \91CD\547D\540D\4E3A %1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870840354312224)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\533A\57DF\6309\94AE\91CD\65B0\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885940411312235)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\5BFC\822A\680F\6761\76EE\91CD\65B0\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870926904312224)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\533A\57DF\91CD\65B0\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870530297312223)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\533A\57DF\9879\91CD\65B0\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107885862940312235)
,p_name=>'REORDER_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\9009\9879\5361\91CD\65B0\6392\5E8F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991104504312315)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774270523312938)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\522B\540D: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991421932312316)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108081881312409)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082806025312389)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5217\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082468896312389)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\8868\5355\548C\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047254743312360)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5DF2\751F\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114990146312415)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\5E03\5C40')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107943625629312280)
,p_name=>'REPORT_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E %0 \7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108108392238312410)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9875\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699871232312092)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\6709\6548\3002\5DF2\5BF9\7ED1\5B9A\53D8\91CF\8FDB\884C\8BED\6CD5\5206\6790\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114897047312415)
,p_name=>'REPORT_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948451697312283)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 1 - \4E0B\8F7D XML \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948522265312283)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 2 - \8BBE\8BA1\62A5\8868\5E03\5C40\5E76\4FDD\5B58\4E3A RTF \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948736836312283)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 2 - \4E0A\8F7D XSL-FO \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107948628929312283)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B65\9AA4 3 - \4E0A\8F7D RTF \6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080969005312388)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\53D6\62A5\8868\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149030951312442)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082945129312389)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088149242312394)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\201C\57FA\4E8E Web \670D\52A1\7684\62A5\8868\201D\9875\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004773659312329)
,p_name=>'REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078445007312386)
,p_name=>'REQUESTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342638319312599)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A "%1" \7684%0\5DF2\8BF7\6C42\66F4\6539\9644\52A0%2\7684\6570\636E\5E93\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342559287312599)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5DF2\4E3A\5177\6709%2\7684\5DE5\4F5C\533A "%1" \8BF7\6C42\4E86\65B0\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342436332312599)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\8BF7\6C42\5927\5C0F\4E3A %2 \7684\65B0\5DE5\4F5C\533A "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592414413312010)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \8BF7\6C42\65B0\5DE5\4F5C\533A "%1"')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031560159312348)
,p_name=>'RESEARCHING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8C03\7814')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567049658311989)
,p_name=>'RESET_4000'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613985523312027)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\4E3A\7A7A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107598860475312015)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D44\6E90\7BA1\7406\5668\4F7F\7528\8005\7EC4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296660860312562)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\9650\7684\8BBF\95EE\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867116396312221)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9650\5236 - \4E0D\80FD\4ECE\6D4F\89C8\5668\8BBE\7F6E')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084714233312391)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\5F15\7528\5DF2\6DFB\52A0\81F3\5E94\7528\7A0B\5E8F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696741326312090)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495399211312721)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>APEX RESTful \670D\52A1\5904\4E8E\53EA\8BFB\6A21\5F0F\3002</p>'),
'',
unistr('<p>\60A8\53EF\4EE5\6309\7167\5176\5B9A\4E49\4F7F\7528\57FA\4E8E APEX \7684 RESTful \670D\52A1\3002\4F46\662F, Oracle \63A8\8350\901A\8FC7\5355\51FB<strong>\8FC1\79FB\5230 ORDS RESTful \670D\52A1</strong>, \5C06\8FD9\4E9B\670D\52A1\8FC1\79FB\5230 ORDS\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491991566312719)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230 ORDS \7684\5F53\524D\8FD0\884C\7248\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696159921312089)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495284374312721)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\64CD\4F5C\4E3A\6240\9009\65B9\6848\53D6\6D88\6CE8\518C\5E76\5220\9664\5168\90E8 ORDS REST \670D\52A1\5B9A\4E49\3002\6B64\64CD\4F5C\65E0\6CD5\64A4\6D88\3002</p>'),
'',
unistr('<p>\662F\5426\786E\5B9E\8981\53D6\6D88\6CE8\518C\6B64\65B9\6848\FF1F</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107945223076312281)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7ECF\4E3A\53E6\4E00\5DE5\4F5C\533A\5B9A\4E49\4E86\5177\6709\6B64\503C\7684 APEX \8DEF\5F84\524D\7F00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006566091312330)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\65B9\6848\522B\540D\5DF2\7531\53E6\4E00\65B9\6848\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696004114312089)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731709179312905)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528\5BF9\8C61\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679855362312077)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Glob (*) \5B57\7B26\53EA\80FD\4F5C\4E3A\6700\540E\4E00\4E2A\5B57\7B26\51FA\73B0\5728\8DEF\7531\6A21\5F0F\4E2D\FF0C\5E76\4E14\5176\524D\9762\53EA\80FD\662F\4E00\4E2A\5DF2\547D\540D\53C2\6570\6216\4E00\4E2A\6B63\659C\6760 (/)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344846591312601)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\5904\7406\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345049470312601)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\5904\7406\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314537404312576)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\671F\5904\7406\7A0B\5E8F ID, \4F46\6536\5230\4E86 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344939339312601)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\5904\7406\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679745061312077)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8DEF\7531\6A21\5F0F\7684\6587\5B57\90E8\5206\4E2D\53D1\73B0\4E86\65E0\6548\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716626272312105)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\6388\6743')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764634683312931)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">\5355\51FB\201C\8FC1\79FB\201D\6309\94AE\4F1A\5C06\6240\6709\57FA\4E8E APEX \7684 REST \670D\52A1\7684\5143\6570\636E\590D\5236\5230 ORDS\3002\57FA\4E8E APEX \7684\73B0\6709\670D\52A1\7684\5B9A\4E49\5C06\4FDD\6301\4E0D\53D8\FF0C\4F46\662F\53EA\8981 ORDS \4E2D\5B58\5728\5339\914D\7684\670D\52A1\5C31\4E0D\4F1A\6267\884C\8FD9\4E9B\57FA\4E8E APEX \7684\73B0\6709\670D\52A1\3002'),
'',
unistr('\5EFA\8BAE\5728\8FC1\79FB\540E\9A8C\8BC1\548C\6D4B\8BD5\8FC1\79FB\7684\57FA\4E8E ORDS \7684\670D\52A1\3002\9A8C\8BC1\540E\FF0C\5BFC\51FA\5E76\5220\9664\57FA\4E8E APEX \7684\670D\52A1\3002</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764572699312931)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX \68C0\6D4B\5230\60A8\7684\5DE5\4F5C\533A\5B58\5728 URI \524D\7F00\4E3A NULL \7684 2 \4E2A\6216\591A\4E2A\57FA\4E8E APEX \7684 REST \6A21\5757\3002ORDS \4E0D\5141\8BB8\591A\4E2A\6A21\5757\5177\6709\76F8\540C\7684\57FA\7840 URI \524D\7F00\3002</p>'),
'',
unistr('<p>\4E3A\4E86\5C06\8FD9\4E9B\670D\52A1\8FC1\79FB\5230 ORDS\FF0C\5C06\5E94\7528\4EE5\4E0B\89C4\5219\FF1A</p>'),
'',
'<ul>',
unistr('<li>\6240\6709\53D7\5F71\54CD\7684\6A21\5757\90FD\5C06\6298\53E0\5230\540D\4E3A <em><strong>merged.apex.rest.services</strong></em> \7684\5355\4E2A ORDS \6A21\5757\4E2D\3002</li>'),
unistr('<li>\5982\679C\8981\5408\5E76\7684\57FA\4E8E APEX \7684\6A21\5757\4E2D<strong><em>\6709</em></strong>\5DF2\53D1\5E03\7684\6A21\5757\FF0C\65B0\7684\5408\5E76\6A21\5757<strong><em>\4E5F\4F1A\53D1\5E03</em></strong>\3002</li>'),
unistr('<li>\5982\679C\8981\5408\5E76\7684\57FA\4E8E APEX \7684\6A21\5757\4E2D<strong><em>\6CA1\6709</em></strong>\5DF2\53D1\5E03\7684\6A21\5757\FF0C\65B0\7684\5408\5E76\6A21\5757<strong><em>\4E0D\4F1A\53D1\5E03</em></strong>\3002</li>'),
unistr('<li>\4E0E\8981\5408\5E76\7684\57FA\4E8E APEX \7684\6A21\5757\5173\8054\7684<strong><em>\6240\6709\89D2\8272</em></strong>\90FD<strong><em>\5C06\5206\914D\5230\65B0\7684\5408\5E76\6A21\5757</em></strong>\3002</li>'),
unistr('<li>\5408\5E76\6A21\5757\7684<strong><em>\5206\9875\5927\5C0F</em></strong>\5C06\8BBE\7F6E\4E3A\8981\5408\5E76\6A21\5757\4E2D\7684<strong><em>\6700\5927\5206\9875\5927\5C0F</em></strong>\3002</li>'),
unistr('<li>\5982\679C\5B58\5728\57FA\7840 URI \4E3A NULL \4E14\6A21\677F URI \91CD\590D\7684 APEX \6A21\5757\FF0C\5C06\51FA\73B0\4EE5\4E0B\60C5\51B5\FF1A'),
'',
'<ul>',
unistr('<li>\6700\8FD1\66F4\65B0\7684\6A21\677F\5C06\4FDD\6301\91CD\590D URI</li>'),
unistr('<li>\6240\6709\5176\4ED6\6A21\677F\5C06\5177\6709\524D\7F00 dup001_*</li>'),
unistr('<li>\6A21\677F\6CE8\91CA\5C06\5305\542B\8FC1\51FA\6A21\677F\7684\539F\59CB\6A21\5757\540D\79F0\4EE5\53CA\539F\59CB\6A21\677F URI</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764482838312931)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX \68C0\6D4B\5230\60A8\7684\5DE5\4F5C\533A\5B58\5728 URI \524D\7F00\4E3A NULL \7684 2 \4E2A\6216\591A\4E2A\57FA\4E8E APEX \7684 REST \6A21\5757\3002ORDS \4E0D\5141\8BB8\591A\4E2A\6A21\5757\5177\6709\76F8\540C\7684\57FA\7840 URI \524D\7F00\3002</p>'),
'',
unistr('<p>\5F53\524D\4E0D\80FD\5C06\57FA\4E8E APEX \7684 REST \670D\52A1\8FC1\79FB\5230 ORDS\3002ORDS \7248\672C 18.2 \53CA\66F4\9AD8\7248\672C\63D0\4F9B\8FC1\79FB\529F\80FD\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731419034312905)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5757\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344223543312600)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\6A21\5757')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344421171312600)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\6A21\5757')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314388182312576)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\671F\6A21\5757 ID, \4F46\6536\5230\4E86 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344345737312600)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\6A21\5757')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679581621312077)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DEF\7531\6A21\5F0F\5185\7684\67D0\4E2A\5DF2\547D\540D\53C2\6570\5305\542B\65E0\6548\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108561514293312774)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\65B9\6848\672A\6CE8\518C\5230 ORDS RESTful Data Services\3002\8981\6CE8\518C\6B64\65B9\6848, \8BF7\5355\51FB<strong>\5C06\65B9\6848\6CE8\518C\5230 ORDS</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679966451312077)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \4E0E URI \6216 ROUTE \6837\5F0F\6A21\5F0F\4E0D\5339\914D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680044820312077)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B83\4E0D\5141\8BB8\5177\6709\591A\4E2A\8FDE\7EED\6B63\659C\6760\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679483220312077)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\5BF9\8DEF\7531\6A21\5F0F\4F7F\7528\67E5\8BE2\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583447081312003)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>APEX \5F53\524D\6B63\5728 CDB \4E2D\8FD0\884C\3002\65E0\6CD5\5728 CDB \4E2D\5B9A\4E49\57FA\4E8E ORDS \7684 REST \670D\52A1\3002</p><p>\60A8\53EF\4EE5\7EE7\7EED\4F7F\7528\57FA\4E8E APEX \7684 RESTful \670D\52A1\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108495168575312721)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5F53\524D\5DF2\5B89\88C5 ORDS \7248\672C (%0) \4E0D\652F\6301\5728 Application Express \4E2D\542F\7528\57FA\4E8E ORDS \7684 RESTful \670D\52A1\6240\9700\7684\5168\90E8\529F\80FD\3002\5FC5\987B\5B89\88C5\7684\6700\4F4E\7248\672C\4E3A %1\3002</p>'),
unistr('<p>\60A8\53EF\4EE5\7EE7\7EED\4F7F\7528\57FA\4E8E APEX \7684 RESTful \670D\52A1\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679606206312077)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\9009\7684 (?) \5B57\7B26\53EA\80FD\4F5C\4E3A\6700\540E\4E00\4E2A\5B57\7B26\51FA\73B0\5728\8DEF\7531\6A21\5F0F\4E2D\FF0C\5E76\4E14\5176\524D\9762\5FC5\987B\662F\4E00\4E2A\5DF2\547D\540D\53C2\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678417767312076)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\7CFB\7EDF\627E\4E0D\5230 ORDS_METADATA \65B9\6848\FF0C\9700\8981\6709\8BE5\65B9\6848\624D\80FD\542F\7528 ORDS REST \5DE5\4F5C\5BA4\3002\6709\5173\5B89\88C5\6B65\9AA4\FF0C\8BF7\53C2\9605\300AOracle REST Data Services Installation Guide\300B\3002</p> <p>\60A8\53EF\4EE5\7EE7\7EED\4F7F\7528\57FA\4E8E APEX \7684 RESTful \670D\52A1\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696615296312090)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90E8\5206\53D7\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678328827312076)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\6B64\7CFB\7EDF\5F53\524D\6B63\5728\4F7F\7528 Oracle \5D4C\5165\5F0F PL/SQL \7F51\5173\3002\5FC5\987B\5B89\88C5\7248\672C %0 \6216\66F4\9AD8\7248\672C\7684 Oracle REST Data Services\FF0C\624D\80FD\8BBF\95EE ORDS REST \5DE5\4F5C\5BA4\3002</p> <p>\60A8\53EF\4EE5\7EE7\7EED\4F7F\7528\57FA\4E8E APEX \7684 RESTful \670D\52A1\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731571595312905)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345405804312601)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345698981312601)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345525121312601)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696264067312090)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\53D1\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697359330312090)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\64CD\4F5C\5C06\5728\5F53\524D\6240\9009\65B9\6848\4E2D\5220\9664\5E76\91CD\65B0\521B\5EFA <strong>oracle.example.hr</strong> \6A21\5757\548C\76F8\5173\6570\636E\5E93\5BF9\8C61\3002\4E4B\524D\6240\505A\7684\6240\6709\66F4\6539\6216\6DFB\52A0\90FD\5C06\4E22\5931\5E76\4E14\65E0\6CD5\64A4\6D88\3002</p>'),
unistr('<p>\662F\5426\786E\5B9E\8981\91CD\7F6E\793A\4F8B\670D\52A1\FF1F</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731630991312905)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345182317312601)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345316693312601)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345218924312601)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716544903312105)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716703707312105)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492136510312719)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\7684\811A\672C\592A\5927\3002Application Express \7684\9650\5236\4E3A 32MB (32767 \5B57\8282)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696431863312090)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D7\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314409908312576)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\671F\53C2\6570\7684\5E8F\5217 ID, \4F46\6536\5230\4E86 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731934629312906)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108731839771312906)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732057586312906)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344580624312600)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344736425312600)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314688426312577)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\671F\6A21\677F ID, \4F46\6536\5230\4E86 NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614676440312027)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URI \6A21\677F\4E0D\80FD\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344601426312600)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696939478312090)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697009824312090)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5757')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697111377312090)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107697298404312090)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720444899312896)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('RESTful \6570\636E\670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696805540312090)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4F7F\7528\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696364023312090)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\53D6\6D88\53D1\5E03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107696533412312090)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53D7\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679317166312077)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\4E2A\6216\591A\4E2A URI \53D8\91CF\6709\8BED\6CD5\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108295509881312561)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\52A0\8F7D\7684\811A\672C\662F\57FA\4E8E APEX \7684 RESTful \670D\52A1\5BFC\51FA\9879\3002\65E0\6CD5\4F7F\7528 ORDS RESTful \670D\52A1\5BFC\5165\9875\6765\52A0\8F7D\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559193004312773)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\52A0\8F7D\7684\811A\672C\662F\57FA\4E8E ORDS \7684 RESTful \670D\52A1\5BFC\51FA\9879\3002\65E0\6CD5\4F7F\7528 APEX RESTful \670D\52A1\5BFC\5165\9875\6765\52A0\8F7D\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732100668312906)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5230\526A\8D34\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108732229168312906)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5B8C\6574 URL \590D\5236\5230\526A\8D34\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690439621312873)
,p_name=>'RETAINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\7559')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805189139312173)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5230 %0 \767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810432754312973)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\503C: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031817734312349)
,p_name=>'REVIEWING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\590D\67E5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108293248612312559)
,p_name=>'ROLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811375061312178)
,p_name=>'ROLLBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56DE\9000\8BED\53E5\4E0D\9002\7528\3002\6240\6709\8BED\53E5\90FD\81EA\52A8\63D0\4EA4\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155192210312447)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%1 \79D2\540E\8FD4\56DE\4E86 %0 \884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107635035638312043)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\7684\884C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245804318312519)
,p_name=>'RUN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560111798311984)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\548C\5F00\53D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011306326312334)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248660778312522)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\5E94\7528\7A0B\5E8F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808090249312175)
,p_name=>'RUN_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250620473312523)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\9875: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107614273775312027)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208474173312489)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FD\5BB6/\5730\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208793539312489)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FD\5BB6/\5730\533A\3001\4EBA\53E3\548C\9996\90FD\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795844896312166)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'zh-cn'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795935277312166)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C EMP \548C DEPT \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208519585312489)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\7EA7\65B9\7A0B\5F0F\8D5B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208931188312490)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\7EA7\65B9\7A0B\5F0F\8D5B\4E16\754C\51A0\519B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689739461312873)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5065\5EB7\72B6\51B5\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689880446312873)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\4E3A\533B\7597\63D0\4F9B\5546\63D0\4F9B\7B80\5316\7684\60A3\8005\62A5\544A\7684\5065\5EB7\72B6\51B5\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796066749312166)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('HR \6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796151049312166)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\5E38\7531 Oracle Education \4F7F\7528\7684\4E00\822C HR \8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248700490312522)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\8BA2\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248858944312522)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA2\6237\3001\5B58\50A8\3001\4EA7\54C1\548C\8BA2\5355\7684\96C6\5408\3002\6B64\6570\636E\96C6\5305\62EC\4EA7\54C1\8BF4\660E\4EE5\53CA\5B58\50A8\6240\5728\7ECF\5EA6/\7EAC\5EA6\7684 JSON \6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795647828312165)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\76EE\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107795704539312165)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\76EE\3001\91CC\7A0B\7891\3001\4EFB\52A1\7B49\7B49\7684\96C6\5408\3002\6B64\6570\636E\96C6\5305\62EC\4E3B\4ECE\5173\7CFB\FF0C\4EE5\53CA\4E00\4E2A\7528\4E8E\7ED8\5236\56FE\8868\7684\6709\7528\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796208776312166)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\7535\5B50\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796347364312166)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5177\6709\672A\89C4\8303\5316\6570\636E\7684\5355\4E2A\8868\FF0C\5176\4E2D\5305\542B\201C\4EFB\52A1\201D\3001\201C\65E5\671F\201D\3001\201C\72B6\6001\201D\3001\201C\5206\914D\7ED9\201D\3001\201C\6210\672C\201D\548C\201C\9884\7B97\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208365542312489)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\7403')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208848069312490)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\6EE1\8D2F\8D5B\4E8B\7684\7537\5B50\548C\5973\5B50\51A0\4E9A\519B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208615298312489)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E16\754C\676F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209013946312490)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DB3\7403\4E16\754C\676F\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092269475312397)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B Websheet')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079002201312386)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079154723312386)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079269237312386)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A\5DF2\4FDD\5B58\7684\62A5\8868...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078721744312386)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078027774312385)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E13\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078126403312385)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E13\7528\8BA2\9605')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078645888312386)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078921872312386)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108078889709312386)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\7C7B\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723078222312110)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723212233312110)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723173070312110)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\6761\76EE\5DF2\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722971640312110)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722840476312110)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\5305\5C51\5DF2\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694831372312088)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694710577312088)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051286969312364)
,p_name=>'SCHEMAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162777714312453)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('wwv_flow_companies \65B9\6848\63D2\5165\5F02\5E38\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161717305312452)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848 "%0" \53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161831231312452)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848 "%0" \4E0E\73B0\6709\7528\6237\51B2\7A81, \56E0\6B64\6B64\65F6\4E0D\53EF\7528, \4E5F\65E0\6CD5\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959465463312291)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776294274312150)
,p_name=>'SCHEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730380027312904)
,p_name=>'SCREEN_READER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C4F\5E55\9605\8BFB\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108082325814312389)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C4F\5E55\9605\8BFB\5668\5207\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112986110312413)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6587\4EF6\662F\4ECE\53E6\4E00\4E2A\5DE5\4F5C\533A (%0) \4E2D\5BFC\51FA\7684, \53EF\80FD\6765\81EA\53E6\4E00\4E2A %1 \6570\636E\5E93\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754523223312923)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C %0 \5DF2\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754441887312923)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C %0 \5DF2\53D6\6D88\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763682795312930)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\672A\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108039654972312354)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
unistr('\4E3A\8BF4\660E\5BF9\8C61, \8BF7\5728\4E0A\9762\7684\547D\4EE4\7A97\683C\4E2D\952E\5165 <br><br> '),
'',
unistr('DESCRIBE &lt \5BF9\8C61\540D &gt, \7136\540E\5355\51FB\201C\8FD0\884C\201D\3002'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069123765312378)
,p_name=>'SC_NAME_NN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\540D\4E0D\80FD\4E3A\7A7A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081128852312388)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
unistr('\65E0\6CD5\627E\5230\8981\8BA2\9605\7684\5BF9\8C61\3002</pre>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071726152312380)
,p_name=>'SC_SC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\76F4\89C2\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006171909312330)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8BED\53E5\6B63\5728\8FD0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071676848312380)
,p_name=>'SC_VQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F4\89C2\67E5\8BE2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694142817312876)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\680F\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114181344312414)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5B57\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959872481312292)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\67E5\8BE2\4E2D\6CA1\6709 varchar \5217\3002\65E0\6CD5\542F\7528\641C\7D22\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107949289344312284)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\53EF\4EE5\641C\7D22\7684 varchar \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108114042429312414)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\751F\4EA7\529B\548C\793A\4F8B\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108508516656312732)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\7ED3\679C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696037475312878)
,p_name=>'SECTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\6BB5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755055594312134)
,p_name=>'SECURITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046380512312360)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\6027\5206\914D\4EBA\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397223579312642)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\7EC4 ID (\5DE5\4F5C\533A\6807\8BC6) \65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044437134312358)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086352588312392)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072863064312381)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\662F\516C\5171\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046743691312360)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\72B6\6001')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072349308312381)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\9644\52A0\62A5\8868')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607576389312022)
,p_name=>'SELECT_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\9009')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107953533710312287)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562095491311986)
,p_name=>'SELECT_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\8868\4E2D\9009\62E9\4E00\4E2A\65E5\671F\3002\5F53\524D\6708 = %0, \5F53\524D\5E74 = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580503855312789)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\52A8\6001\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764623317312142)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764533660312142)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764496398312142)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764377161312142)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764771001312142)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781553392312951)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\884C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108216940240312496)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\4E0B\9762\9009\62E9\5DE5\4F5C\533A\4EE5\6253\5F00 Application Express \5F00\53D1\73AF\5883\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140539672312435)
,p_name=>'SELF_SERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140404085312435)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\7535\5B50\90AE\4EF6\9A8C\8BC1\7684\81EA\52A9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754130922312923)
,p_name=>'SEPARATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9694\7B26')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773101871312148)
,p_name=>'SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108201520410312484)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638460067312045)
,p_name=>'SERIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042912316312357)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586074068312005)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7AD9\70B9\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023018242312342)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780707697312154)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\533A\5206\5927\5C0F\5199\7684\9A8C\8BC1\4EE3\7801, \7136\540E\5355\51FB<strong>\63D0\4EA4\8BF7\6C42</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779667425312153)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780617708312154)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779592876312153)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779976670312153)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779791633312153)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779366323312153)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BA1\6279\7406\7531')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779828832312153)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\59D3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779281799312153)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780446732312154)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780023837312153)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780252242312154)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7528\73B0\6709\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780150385312153)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780574387312154)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779140813312153)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780373226312154)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107972016119312301)
,p_name=>'SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074764704312383)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615750317312028)
,p_name=>'SESSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138467917312433)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F13\51B2\533A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138220529312433)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'zh-cn'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137942345312433)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138372008312433)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\78C1\76D8:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138108786312433)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\65F6:   ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138054239312433)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699349575312092)
,p_name=>'SET_BINDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\67E5\8BE2\65F6\5FC5\987B\8BBE\7F6E\6240\6709\7ED1\5B9A\53D8\91CF\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601569623312017)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\53D1\884C\7248 %2 \7684\5206\914D\7ED9%1\7684%0\672A\5B8C\6210\529F\80FD\7684\622A\6B62\65E5\671F\8BBE\7F6E\4E3A\91CC\7A0B\7891\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721310752312109)
,p_name=>'SET_MILESTONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\91CC\7A0B\7891')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601867809312018)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5177\6709\7F3A\5C11\91CC\7A0B\7891\7684\529F\80FD\8BBE\7F6E\4E3A\53D1\884C\7248 %2 \7684\5206\914D\7ED9 %1 \7684 %0 \672A\5B8C\6210\529F\80FD\7684\91CC\7A0B\7891 (%3)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107601747113312018)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\53D1\884C\7248 %2 \7684\5206\914D\7ED9%1\7684%0\672A\5B8C\6210\529F\80FD\7684\91CC\7A0B\7891 (\4E0E\8FC7\671F\91CC\7A0B\7891\5BF9\5E94) \8BBE\7F6E\4E3A\91CC\7A0B\7891 (%3)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720907872312108)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\672A\5B8C\6210\529F\80FD\5C06\5206\914D\7ED9\6240\9009\91CC\7A0B\7891\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721426329312109)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\672A\5B8C\6210\529F\80FD\622A\6B62\65E5\671F\5C06\8BBE\7F6E\4E3A\91CC\7A0B\7891\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758623755312926)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\9996\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721611710312109)
,p_name=>'SET_RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\53D1\884C\7248')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137219266312433)
,p_name=>'SHARED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316410318312578)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074426778312382)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\52A8\6001\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570989173311993)
,p_name=>'SHARED POOL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\6C60')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108074358273312382)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\9759\6001\503C\5217\8868\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645922723312051)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313701282312576)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\4EAB\9A8C\8BC1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776367059312151)
,p_name=>'SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108218956372312497)
,p_name=>'SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FEB\6377\65B9\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108025922816312344)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5927\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108029050979312346)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5927\8FDB\5EA6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774890018312149)
,p_name=>'SIMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020481184312340)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\5355\56FE\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097557492312401)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('16 \5C0F\65F6\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157042073312448)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5929\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156907895312448)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5C0F\65F6\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776921931312940)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('16 \5C0F\65F6\4E4B\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157112299312448)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5468\4E4B\524D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107612558515312026)
,p_name=>'SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5C0F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733365349312907)
,p_name=>'SL.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729495340312904)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5E94\7528\7A0B\5E8F %1 \4E2D\7684\9875 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729509991312904)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\5E94\7528\7A0B\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559334491312773)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230 1 \4E2A\5339\914D\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108559438383312773)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230 %0 \4E2A\5339\914D\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108576774253312786)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5339\914D\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733455431312907)
,p_name=>'SL.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108250773234312523)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296055779312561)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22 %0 \7684\6240\6709\5E94\7528\7A0B\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729883496312904)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5E94\7528\7A0B\5E8F\4E2D\641C\7D22 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108491568619312718)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\81F3\5C11\8F93\5165\4E24\4E2A\5B57\6BCD\624D\80FD\8FDB\884C\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729751826312904)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\9875\9762\4E2D\641C\7D22 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729920186312904)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5C0F\7EC4\5F00\53D1\4E2D\641C\7D22 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730054571312904)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\7528\6237 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108730145493312904)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5DE5\4F5C\533A\4E2D\641C\7D22 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108729686688312904)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \7684\5171\4EAB\7EC4\4EF6')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108022937052312342)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6F\4EF6\7F3A\9677')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108027945423312346)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\4E9B\9700\8981')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355397747312609)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90\6807\8BC6\7B26')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162096885312452)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\6709\7A7A\95F4\4F7F\7528\60C5\51B5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011573556312334)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \4E0D\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219387296312498)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108155082200312447)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \547D\4EE4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050391045312363)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \547D\4EE4\5386\53F2\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828281839312191)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088616249312394)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088396074312394)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088467914312394)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088279048312394)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088577129312394)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D8\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374031614312623)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5E94\7528\7A0B\5E8F\542F\7528 SQL \548C PL/SQL \8BBF\95EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374153501312623)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5B9E\4F8B\542F\7528 SQL \548C PL/SQL \8BBF\95EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773916649312149)
,p_name=>'SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579939661312001)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\65E0\6548, \672A\627E\5230 select \8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875429190312227)
,p_name=>'SQL_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678848366312076)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9644\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767645693312144)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768167649312144)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528\6392\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767325726312144)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767729223312144)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\6392\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678729674312076)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767495612312144)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107767951237312144)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B21\7EA7\6392\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768002652312144)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050518831312363)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \811A\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050488217312363)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \811A\672C\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360113702312612)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\5728\5141\8BB8\7684\8868\5217\8868\4E2D\5B9A\4E49\4EE5\4E0B\6570\636E\5E93\5BF9\8C61: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050616385312363)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830553023312193)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\522B\540D\5DF2\7531\5176\4ED6\5BF9\8C61\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107830400124312193)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\63D0\4F9B\7684\5BF9\8C61\522B\540D\65E0\6548\3002\6709\6548\522B\540D\53EA\80FD\5305\542B\5B57\6BCD\3001\6570\5B57\3001\4E0B\5212\7EBF\548C\77ED\5212\7EBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144171786312438)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\65B9\6848\672A\6CE8\518C\5230 ORDS RESTful \6570\636E\670D\52A1\3002\8981\6CE8\518C\6B64\65B9\6848\FF0C\8BF7\5BFC\822A\81F3 <strong>RESTful \670D\52A1 > ORDS RESTful \670D\52A1</strong>\FF0C\7136\540E\5355\51FB<strong>\5C06\65B9\6848\6CE8\518C\5230 ORDS</strong> \6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159152474312450)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('APEX \5F53\524D\6B63\5728 CDB \4E2D\8FD0\884C\3002\65E0\6CD5\5728 CDB \4E2D\5B9A\4E49\57FA\4E8E ORDS \7684 REST \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158920535312450)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\5B89\88C5\7684 ORDS \7248\672C (%0) \4E0D\652F\6301\8BBF\95EE\542F\7528 REST \7684\6570\636E\5E93\5BF9\8C61\6240\9700\7684\6240\6709\529F\80FD\3002\5FC5\987B\81F3\5C11\5B89\88C5\7248\672C %1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158759715312449)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF\627E\4E0D\5230 ORDS_METADATA \65B9\6848\FF0C\9700\8981\6709\8BE5\65B9\6848\624D\80FD\542F\7528 ORDS RESTful \670D\52A1\3002\6709\5173\5B89\88C5\6B65\9AA4\FF0C\8BF7\53C2\9605\300AOracle REST Data Services Installation Guide\300B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159036642312450)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ORDS \7248\672C <strong>%0</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158888071312450)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\7CFB\7EDF\5F53\524D\6B63\5728\4F7F\7528 Oracle \5D4C\5165\5F0F PL/SQL \7F51\5173\3002\5FC5\987B\5B89\88C5\7248\672C %0 \6216\66F4\9AD8\7248\672C\7684 Oracle REST Data Services\FF0C\624D\80FD\8BBF\95EE\542F\7528 REST \7684\6570\636E\5E93\5BF9\8C61\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548801314311975)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \5806\53E0\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107548919448311975)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \5806\53E0\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549044010311975)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2D \5806\53E0\6C34\5E73\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107549193105311976)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('3D \5806\53E0\6C34\5E73\67F1\72B6\56FE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315259228312577)
,p_name=>'STANDARD _TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316994062312578)
,p_name=>'STANDARD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107755160121312135)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\96C6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641378692312047)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5E94\7528\7A0B\5E8F\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641245024312047)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5DE5\4F5C\533A\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811938570312974)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\81F3\5C11\4E00\4E2A\5173\952E\5B57, \5176\4E2D\81F3\5C11\5305\542B\4E24\4E2A\5B57\7B26\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812090345312974)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\4EFB\4F55\4E0E\60A8\7684\641C\7D22\67E5\8BE2\5339\914D\7684\7ED3\679C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107828061408312191)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5206\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160512909312451)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\76F8\5173\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572155272311993)
,p_name=>'STATIC_HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001 HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555688636311981)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108019206432312339)
,p_name=>'STATIC_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\533A\57DF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108083811391312390)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001\66FF\6362\5B57\7B26\4E32')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774649606312939)
,p_name=>'STATUS_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955015927312288)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001\5DF2\4FEE\6539')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070478765312379)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\6761\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763727921312930)
,p_name=>'STEAL_LOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F3A\5360\9501\5B9A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615439223312028)
,p_name=>'STORAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\50A8:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774028877312149)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\6784\5316\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107875272004312227)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\6784\5316\62A5\8868')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108161402209312452)
,p_name=>'SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954969721312288)
,p_name=>'SUBMITTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107870747437312224)
,p_name=>'SUBMIT_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080649765312387)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\53CD\9988')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012711819312335)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5C5E\5F53\524D\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108012806608312335)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\5C5E\975E\5F53\524D\6761\76EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789585448312957)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\7684\4E3B\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789773496312957)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108789662817312957)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\8D44\6599\6863\6848\5E93')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757210546312136)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757558352312136)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\6388\6743\65B9\6848\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757798518312136)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6388\6743\65B9\6848\8BA2\9605\6B64\6388\6743\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757635347312136)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\6388\6743\65B9\6848\7684\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559645806311984)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559998350311984)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\6570\636E\52A0\8F7D\5B9A\4E49\7684\201C\4E3B\201D\526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559834509311984)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6570\636E\52A0\8F7D\5B9A\4E49\8BA2\9605\6B64\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107559766729311984)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\5B9A\4E49\7684\6570\636E\52A0\8F7D\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756669262312136)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756720720312136)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\9879\5E2E\52A9\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756921275312136)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\9879\8BA2\9605\6B64\9879\5E2E\52A9\6587\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107756817045312136)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\9879\5E2E\52A9\6587\672C\7684\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759253692312138)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759351563312138)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\503C\5217\8868\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759513481312138)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\503C\5217\8868\7684\503C\5217\8868\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759400713312138)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\503C\5217\8868\7684\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647389797312052)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107760818386312139)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\5BFC\822A\680F\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761434676312139)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5BFC\822A\680F\8BA2\9605\6B64\5BFC\822A\680F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761154369312139)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\5BFC\822A\680F\7684\5BFC\822A\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646942525312052)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647018921312052)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\63D2\4EF6\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647220678312052)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8BA2\9605\6B64\63D2\4EF6\7684\63D2\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647122483312052)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\63D2\4EF6\7684\63D2\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758051340312137)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758212791312137)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\5FEB\6377\65B9\5F0F\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758540998312137)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\5FEB\6377\65B9\5F0F\8BA2\9605\6B64\5FEB\6377\65B9\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758436877312137)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\5FEB\6377\65B9\5F0F\7684\5FEB\6377\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752825354312133)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753083916312133)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\6A21\677F\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753100317312133)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6A21\677F\8BA2\9605\6B64\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107752939748312133)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763995876312141)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\6A21\677F\7684\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728340119312903)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\5E94\7528\7A0B\5E8F\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108770976334312936)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6807\51C6\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728794091312903)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\4E3B\9898\7684 "\4E3B" \526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728668842312903)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3B\9898\8BA2\9605\6B64\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728491698312903)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108728581740312903)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\4E3B\9898\7684\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136203346312432)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136399911312432)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64 REST \6570\636E\6E90\7684\201C\4E3B\201D\526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136599849312432)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8BA2\9605\6B64\6E90\7684 REST \6570\636E\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108136486977312432)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\6E90\7684 REST \6570\636E\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762951533312140)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\81EA\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763746336312141)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD9\662F\6B64\6309\94AE\6A21\677F\7684 "\4E3B" \526F\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764162410312141)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6A21\677F\8BA2\9605\6B64\6309\94AE\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764098943312141)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\6B64\6309\94AE\6A21\677F\7684\6309\94AE\6A21\677F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107590966837312009)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362\5B57\7B26\4E32\4F7F\7528\60C5\51B5')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991654106312316)
,p_name=>'SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108068193982312378)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107954074759312287)
,p_name=>'SUCCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820760200312185)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C07\5DF2\622A\65AD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817052771312182)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6267\884C\547D\4EE4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819819527312184)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E0B\6587\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820053953312184)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\6570\636E\5E93\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819999025312184)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\6570\636E\5E93\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820927587312185)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815961447312181)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818842522312183)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820584118312185)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D22\5F15\7C7B\578B\5DF2\6539\53D8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819760324312184)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D22\5F15\7C7B\578B\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816348614312181)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D22\5F15\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819181068312183)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7D22\5F15\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816692369312182)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\5B9E\4F53\5316\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819275790312184)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F53\5316\89C6\56FE\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820814872312185)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305\5DF2\53D8\66F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816101089312181)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\7A0B\5E8F\5305\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816217827312181)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818172531312183)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821085081312185)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816002947312181)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818949990312183)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816780212312182)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819371888312184)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89D2\8272\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817509649312182)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 %0 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817389969312182)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D2\5165 %0 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817245805312182)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \884C\5DF2\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821149884312186)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816808846312182)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818564462312183)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542573710311970)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542471266311970)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542357417311970)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5DF2\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577338708311998)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5904\7406\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816960429312182)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\4E49\8BCD\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819483845312184)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\4E49\8BCD\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818684257312183)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815599764312181)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818000543312183)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820181219312184)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5DF2\91CD\547D\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820637746312185)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\88AB\622A\65AD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820499044312185)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5668\5DF2\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815894703312181)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5668\5DF2\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819583465312184)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5668\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820300635312185)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B\5DF2\53D8\66F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816484730312181)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819632253312184)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821247330312186)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107816527384312182)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818299684312183)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107820288764312184)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE\5DF2\53D8\66F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815697133312181)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE\5DF2\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818340427312183)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE\5DF2\5220\9664\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108160191752312451)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\652F\6301\5BF9\8C61')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696825061312878)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\6539\5BF9\8C61\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108696994010312878)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61\4E0D\518D\5B58\5728\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020778405312340)
,p_name=>'SVG CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SVG \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110291107312411)
,p_name=>'SVG PLUGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5B89\88C5 SVG \67E5\770B\5668\4EE5\67E5\770B\56FE\8868\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540849881311969)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\7F16\8F91\7A7A\7684 SQL \811A\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540929036311969)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\7F16\8F91\8D85\8FC7 30,000 \5B57\8282\7684\811A\672C\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773203794312148)
,p_name=>'SYNONYM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\4E49\8BCD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374528987312624)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\540C\4E49\8BCD)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153468504312445)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\4E49\8BCD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284681576312552)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955136608312288)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\7EDF\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107955288384312288)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FEE\6539\7CFB\7EDF\72B6\6001')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773320524312148)
,p_name=>'TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108021312731312341)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\662F\6709\6548\7684\8868\540D\6216\89C6\56FE\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051139640312364)
,p_name=>'TABLESPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\7A7A\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772347466312148)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\8868)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108067526244312377)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\540D %0 \8D85\8FC7\4E86\5141\8BB8\7684\5927\5C0F\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080455636312387)
,p_name=>'TABULAR_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\683C\5F0F\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086973756312393)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\8868\683C\5F0F\8868\5355\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107768275223312144)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \7236\9009\9879\5361\76EE\6807 "%0" \5F15\7528\4E86\4E0D\5B58\5728\7684\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759902662312138)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758860024312137)
,p_name=>'TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315101957312577)
,p_name=>'TAB_SETS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107759032311312137)
,p_name=>'TAB_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\6587\672C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775832248312939)
,p_name=>'TAG_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600308715312017)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813981616312976)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\9875 ID \6216\5B9A\5236 URL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108024023294312343)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\52A1\5B8C\6210')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048281801312361)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\7EC4\5F00\53D1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107753820994312134)
,p_name=>'TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803094760312967)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007700942312331)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007829453312331)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802733078312967)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\6A21\677F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802954322312967)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\6A21\677F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107536482459311966)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007499095312331)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F\6B63\6587 (1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007540001312331)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F\6B63\6587 (2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007616647312331)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6A21\677F\6B63\6587 (3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108802810797312967)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\89C8\6A21\677F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006642009312330)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006763134312330)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006895232312330)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108006984745312331)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007001928312331)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007168492312331)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007237078312331)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108007304836312331)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4F4D\7F6E 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108510372435312734)
,p_name=>'TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108140660105312435)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107570439258311992)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\6A21\677F\5E94\7528\7A0B\5E8F\521B\5EFA\5E94\7528\7A0B\5E8F\671F\95F4\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207632789312489)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9A71\52A8\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138716738312434)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138617745312434)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E38\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108582685683312790)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138504893312434)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\822C\4FE1\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699752977312881)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\5339\914D\7684\6A21\677F\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707454764312886)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \672A\9009\62E9\9009\9879 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108683915285312868)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6A21\677F\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790389506312957)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F\9009\9879\4E0D\5339\914D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811416203312974)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6A21\677F\5DF2\8BA2\9605\5230\4E3B\4E3B\9898\4E2D\7684\5BF9\5E94\6A21\677F\3002\8981\4FEE\6539\6B64\6A21\677F, \8BF7\7F16\8F91\4E3B\6A21\677F, \7136\540E\5237\65B0\4E3B\9898\3002\6B64\5916, \60A8\53EF\4EE5\521B\5EFA\6B64\6A21\677F\7684\672C\5730\672A\8BA2\9605\526F\672C\3002\53D6\6D88\8BA2\9605\7684\6A21\677F\53EF\4EE5\7F16\8F91, \5728\5237\65B0\4E3B\9898\65F6\4E0D\4F1A\88AB\8986\76D6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811367054312974)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6B64\6A21\677F\662F\8BE5\5E94\7528\7A0B\5E8F\7684\672C\5730\6A21\677F, \5DF2\53D6\6D88\8BA2\9605\3002'),
unistr('\5728\8BA2\9605\5173\8054\7684\4E3B\9898\65F6, \65E0\6CD5\8BA2\9605\5404\4E2A\6A21\677F\3002'),
unistr('\4F5C\4E3A\5B9A\4E49\672C\5730\6A21\677F\7684\66FF\4EE3\65B9\5F0F, \53EF\4EE5\5C06\65B0\6A21\677F\6DFB\52A0\5230\4E3B\4E3B\9898, \7136\540E\8F7B\677E\5730\63A8\9001\6216\63D0\53D6\5230\6B64\5E94\7528\7A0B\5E8F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765061480312142)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4F5C\4E3A\5E94\7528\7A0B\5E8F\9ED8\8BA4\6A21\677F\8FDB\884C\5F15\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765235817312142)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4F5C\4E3A\9519\8BEF\6A21\677F\8FDB\884C\5F15\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765479050312142)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5F15\7528\6B64\9875\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765506727312142)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\6A21\677F\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765334691312142)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5728\9875\4E2D\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107765164210312142)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\6253\5370\673A\53CB\597D\7684\6A21\677F\8FDB\884C\5F15\7528\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107959619134312292)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E34\65F6\8868\7A7A\95F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107821332448312186)
,p_name=>'TEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046151277312360)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\5206\914D\4EBA\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108044302215312358)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046570555312360)
,p_name=>'TESTING_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108112827855312413)
,p_name=>'TEST_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4B\8BD5\67E5\8BE2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108316354863312578)
,p_name=>'TEXT FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\6587\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107714563132312104)
,p_name=>'THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107641131469312047)
,p_name=>'THEME FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315988236312578)
,p_name=>'THEME IMAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108777026504312940)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\517C\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568364434312779)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107708927869312099)
,p_name=>'THEMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811556424312974)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\4E8E\5728\4E3B\9898\7EA7\522B\8BA2\9605\5230\5176\4ED6\4E3B\9898\7684\67D0\4E2A\4E3B\9898, \65E0\6CD5\53D6\6D88\8BA2\9605\5C5E\4E8E\8BE5\4E3B\9898\4E00\90E8\5206\7684\5404\4E2A\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811838689312974)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\65E0\6CD5\8F6C\6362\5230\4F7F\7528\57FA\4E8E\9009\9879\5361\7684\5BFC\822A\7684\4E3B\9898, \56E0\4E3A\5B83\4F7F\7528\57FA\4E8E\5217\8868\7684\5BFC\822A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108811713839312974)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\65E0\6CD5\8F6C\6362\5230\4F7F\7528\57FA\4E8E\5217\8868\7684\5BFC\822A\7684\4E3B\9898, \56E0\4E3A\5B83\4F7F\7528\4E24\7EA7\9009\9879\5361\3002\8BF7\66F4\65B0\5E94\7528\7A0B\5E8F\5E76\5C06\5F53\524D\9009\9879\5361\8BBE\7F6E\66F4\6539\4E3A\4F7F\7528\4E00\7EA7\9009\9879\5361, \7136\540E\518D\5207\6362\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108028106494312346)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\684C\9762\4E3B\9898\65E0\6CD5\5207\6362\4E3A\79FB\52A8\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934535884312273)
,p_name=>'THEME_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\7C7B\578B')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108775200823312939)
,p_name=>'TITLE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023498986312342)
,p_name=>'TO DO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070246921312379)
,p_name=>'TODO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049927948312363)
,p_name=>'TODOS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599524893312016)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879\5B8C\6210 (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108354910279312608)
,p_name=>'TODO_DASH_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6761\76EE, %1 \672A\5B8C\6210, %2 \4E2A\5DF2\5B8C\6210\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355089555312608)
,p_name=>'TODO_DASH_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6761\76EE\5DF2\90E8\5206\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355134198312609)
,p_name=>'TODO_DASH_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6761\76EE\5DF2\90E8\5206\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048711482312362)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\65B9\6848\62A5\544A\7684\884C\8BA1\6570\6700\591A\7684\524D %0 \4E2A\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073334523312382)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070842293312380)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CC\7A0B\7891\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108073288946312382)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5F00\603B\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048813971312362)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\5448\73B0\65F6\95F4 (\79D2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690711501312874)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\6E05\9664 (\5728\540E 7 \5929\5185)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071936374312381)
,p_name=>'TO_DOS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108377035837312626)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F85\529E\4E8B\9879\5B8C\6210\767E\5206\6BD4 (%0/%1):')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775337151312150)
,p_name=>'TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198135497312481)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6839\636E\73B0\6709\9879\5F00\59CB\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198269045312481)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6839\636E SQL \67E5\8BE2\5F00\59CB\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198405286312481)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\6811\503C\4E3A NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108198308684312481)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6839\636E\9759\6001\503C\5F00\59CB\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688560734312084)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\6811\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107773406416312148)
,p_name=>'TRIGGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E6\53D1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650283931312054)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\4E0D\80FD\4E0E\73B0\6709\9009\9879\5361\540C\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156294388312448)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID \548C\5F53\524D\7684\5B89\5168\7EC4 ID \4E0D\4E00\81F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650113315312054)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\7EC4 ID 20 \662F\4E3A\5DE5\4F5C\533A ''ORACLE'' \4FDD\7559\7684')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108154141475312446)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\622A\65AD\8868 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108199045888312482)
,p_name=>'TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108200902051312483)
,p_name=>'TYPE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108149578750312442)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\9879\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156182062312447)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6570\636E\5E93\5217\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108042589012312357)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DF3\81F3\4E3B\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563387330311987)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\684C\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563492078311987)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563543104311987)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('jQuery Mobile \5E73\677F\7535\8111')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563681408311987)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'zh-cn'
,p_message_text=>'jQuery Mobile Smartphone for PhoneGap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563741912311987)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'zh-cn'
,p_message_text=>'jQuery Mobile Tablet for PhoneGap'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107721527204312109)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\786E\5B9A\91CC\7A0B\7891\65E5\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092798519312397)
,p_name=>'UNASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5206\914D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115788827312415)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\672A\9A8C\8BC1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296837301312562)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528 (\91CD\5B9A\5411\5230 URL)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108296731004312562)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528 (\72B6\6001\4EE5 PL/SQL \663E\793A)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031288054312348)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8003\8651\4E2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646208661312051)
,p_name=>'UNEXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5931\6548\7684')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157794960312449)
,p_name=>'UNLOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245712867312519)
,p_name=>'UNLOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9501\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610317086312024)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\9501\5B9A\7684\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107607306977312022)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88\9501\5B9A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107867221982312221)
,p_name=>'UNRESTRICTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\9650\5236')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822099612312186)
,p_name=>'UP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775183229312150)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\66F4\65B0\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108355234685312609)
,p_name=>'UPDATED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805343155312173)
,p_name=>'UPDATED_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207813318312489)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\5230\5E94\7528\7A0B\5E8F\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108207908818312489)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\5230\7248\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707384487312886)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\662F\652F\6301\7684\65E5\671F\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378161036312627)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\65E5\671F\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758481206312926)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\7EA7\4E4B\540E, \8BF7\786E\4FDD\5C06\7CFB\5217\5C5E\6027\201C\6807\7B7E\5217\201D\6620\5C04\5230\201C\65E5\671F/\65F6\95F4\6233\201D\5217\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775236257312150)
,p_name=>'URL'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108011775470312334)
,p_name=>'URL LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \94FE\63A5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108035388527312351)
,p_name=>'USERID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 ID')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051611339312364)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\7528\6237, \6700\8FD1\7684\7528\6237\521B\5EFA\4E8E %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156535201312448)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\5168\5C40\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108046049050312359)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\5206\914D\4EBA\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108045567131312359)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\5F71\54CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047042693312360)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\754C\9762\72B6\6001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107664959286312066)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\9875\53EF\4EE5\63A7\5236 Application Express \5DE5\4F5C\533A\7BA1\7406\5458, \5E94\7528\7A0B\5E8F\5F00\53D1\8005\548C\6700\7EC8\7528\6237\7684\8BBF\95EE\6743\9650\3002</p>'),
'',
unistr('<p><strong>\5DE5\4F5C\533A\7BA1\7406\5458</strong>\53EF\4EE5\521B\5EFA\548C\4FEE\6539\5E94\7528\7A0B\5E8F\548C\6570\636E\5E93\5BF9\8C61, \8FD8\53EF\4EE5\7BA1\7406\7528\6237\5E10\6237, \7EC4\53CA\5F00\53D1\670D\52A1\3002</p>'),
'',
unistr('<p><strong>\5F00\53D1\8005</strong>\53EF\4EE5\521B\5EFA\548C\4FEE\6539\5E94\7528\7A0B\5E8F\548C\6570\636E\5E93\5BF9\8C61\3002</p>'),
'',
unistr('<p><strong>\6700\7EC8\7528\6237</strong>\6CA1\6709\5F00\53D1\6743\9650, \53EA\80FD\8BBF\95EE\4E0D\4F7F\7528\5916\90E8\9A8C\8BC1\65B9\6848\7684\5E94\7528\7A0B\5E8F\3002</p>'),
'',
unistr('<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">\4E86\89E3\8BE6\7EC6\4FE1\606F...</a></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689105206312084)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\9875\53EF\4EE5\63A7\5236 Application Express \6700\7EC8\7528\6237\7684\8BBF\95EE\6743\9650\3002</p>'),
'',
unistr('<p><strong>\6700\7EC8\7528\6237</strong>\6CA1\6709\5F00\53D1\6743\9650, \53EA\80FD\8BBF\95EE\4E0D\4F7F\7528\5916\90E8\9A8C\8BC1\65B9\6848\7684\5E94\7528\7A0B\5E8F\3002</p>'),
'',
unistr('<p>\4F7F\7528 Identity Console \7BA1\7406<strong>\5DE5\4F5C\533A\7BA1\7406\5458</strong>\548C<strong>\5F00\53D1\8005</strong>\3002\6BCF\5F53\5DE5\4F5C\533A\7BA1\7406\5458\6216\5F00\53D1\8005\767B\5F55 Application Express \65F6, \5C31\4F1A\521B\5EFA\4E00\4E2A "shadow" \5E10\6237\3002\53EF\6839\636E\9700\8981\5220\9664\8FD9\4E9B "shadow" \7528\6237\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776650150312151)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5185\7F6E\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776497940312151)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9875 %0 \4F5C\4E3A\767B\5F55\9875\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139422770312434)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528<strong>\6E05\9664\9AD8\901F\7F13\5B58</strong>\5C5E\6027\53EF\4EE5\5220\9664\9017\53F7\5206\9694\9875\5217\8868\7684\4F1A\8BDD\72B6\6001\3002\4E5F\53EF\4F7F\7528\4E0B\9762\7684\6E05\9664\9AD8\901F\7F13\5B58\8BED\6CD5:'),
'<ul>',
unistr('<li>RIR - \91CD\7F6E\4EA4\4E92\5F0F\62A5\8868</li>'),
unistr('<li>CIR - \6E05\9664\4EA4\4E92\5F0F\62A5\8868</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108162467347312452)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\73B0\6709\65B9\6848')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784151413312953)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784448527312953)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE3\7801\7F16\8F91\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784322534312953)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784293730312953)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\5316')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785526629312954)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\4E3B\9898\6837\5F0F\5C06\91CD\7F6E\672A\4FDD\5B58\7684\66F4\6539\3002\6B64\64CD\4F5C\65E0\6CD5\64A4\6D88\3002\662F\5426\7EE7\7EED?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812842814312975)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\4E3B\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784036000312953)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783834293312952)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783299502312952)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\8BA4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812512745312975)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783643479312952)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783707476312952)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812440044312974)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr(' \60A8\5BF9\53EA\8BFB\4E3B\9898\8FDB\884C\4E86\66F4\6539\3002\5982\679C\60A8\5C06\8BE5\4E3B\9898\8BBE\7F6E\4E3A\5F53\524D\4E3B\9898, \5219\6240\505A\7684\66F4\6539\5C06\88AB\64E6\9664\3002\662F\5426\786E\5B9E\8981\7EE7\7EED?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783937770312952)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6837\5F0F\540D\79F0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783336250312952)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812605461312975)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783540860312952)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809196365312972)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4E0B\9762\7684\4EE3\7801\884C\7C98\8D34\5230 JS \63A7\5236\53F0\4E2D, \4EE5\4FBF\5C06\5F53\524D\914D\7F6E\52A0\8F7D\5230\4E3B\9898\6EDA\52A8\6761:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809229336312972)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6EDA\52A8\6761\5FC5\987B\5DF2\6253\5F00\5E76\4E14\5F53\524D\6837\5F0F\5FC5\987B\6709\6548, \624D\80FD\8F93\51FA\914D\7F6E\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697270723312879)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6BD4\5EA6\FF1A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790628704312958)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5931\8D25')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793084525312960)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9002\7528\4E8E\5927\4E8E 18 \78C5\7684\6587\672C\6216\5927\4E8E 14 \78C5\7684\7C97\4F53')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790701947312958)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6839\636E Web \5185\5BB9\53EF\8BBF\95EE\6027\6307\5357 (WCAG) 2.0 \4E2D\9002\7528\4E8E\5E38\89C4\5927\5C0F\5B57\4F53\7684\989C\8272\5BF9\6BD4\5EA6\6267\884C\9A8C\8BC1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790592608312958)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108790431248312958)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272\5BF9\6BD4\5EA6\4FE1\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812391294312974)
,p_name=>'UTR.CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785314468312954)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236 CSS')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785428969312954)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\4EE3\7801\5C06\5305\542B\5728\6837\5F0F\8868\672B\5C3E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108794246886312960)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64 CSS \4EE3\7801\4F1A\9690\85CF\201C\4E3B\9898\6EDA\52A8\6761\201D\5BF9\8BDD\6846\3002\672A\5C06\5176\5E94\7528\5230\8BE5\9875\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375032638312624)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375369834312624)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E\6587\4EF6\6216\5355\51FB\4EE5\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375546359312625)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 LESS \7F16\8BD1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783462097312952)
,p_name=>'UTR.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785991887312954)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\4E3B\9898\6837\5F0F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793948557312960)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\4E00\4E2A\6216\591A\4E2A CSS \6587\4EF6 URL \65F6\51FA\9519\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785797622312954)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\4E3B\9898\6837\5F0F\7684 LESS \4EE3\7801\65E0\6548\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786180484312954)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\52A0\8F7D\4E3B\9898\6837\5F0F\3002\8BF7\786E\4FDD\5E94\7528\7A0B\5E8F\6784\5EFA\5668\7A97\53E3\4ECD\6253\5F00, \5E76\4E14\60A8\7684\4F1A\8BDD\6709\6548\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812771892312975)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\4E3B\9898\65E0\6CD5\7528\4F5C\5E94\7528\7A0B\5E8F\7684\5F53\524D\4E3B\9898!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785607005312954)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\4E3B\9898\6837\5F0F\4E0D\652F\6301\4E3B\9898\6EDA\52A8\6761\5B9A\5236')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785885169312954)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\4E3B\9898\6CA1\6709\4E3B\9898\6837\5F0F\3002\8BF7\9009\62E9\5177\6709\4E3B\9898\6837\5F0F\7684\4E3B\9898\4EE5\4F7F\7528\4E3B\9898\6EDA\52A8\6761\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108786072804312954)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\4E3B\9898\6837\5F0F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686205142312870)
,p_name=>'UTR.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793178844312960)
,p_name=>'UTR.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793280523312960)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5229\7528\4E3B\9898\6EDA\52A8\6761\53EF\4EE5\4E3A\5404\79CD\5E94\7528\7A0B\5E8F\7EC4\4EF6\9009\53D6\989C\8272\548C\8BBE\7F6E\6837\5F0F, \4ECE\800C\8F7B\677E\5730\5B9A\5236\5E94\7528\7A0B\5E8F\7528\6237\754C\9762\3002\5E94\7528\7A0B\5E8F\53EF\4EE5\5B9A\4E49\4EFB\4F55\6570\91CF\7684\4E3B\9898\6837\5F0F, \53EA\6709 ''\5F53\524D'' \4E3B\9898\6837\5F0F\4F1A\7528\4E8E\5411\6700\7EC8\7528\6237\663E\793A\5E94\7528\7A0B\5E8F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793367792312960)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5728\505A\51FA\66F4\6539\540E, \53EF\4EE5\8F7B\677E\5730\8FD8\539F\5C5E\6027, \5BF9\4E8E\5B8C\6574\7684\4E3B\9898\6837\5F0F\53EF\4EE5\6309\201C\91CD\7F6E\201D\6309\94AE, \800C\5BF9\4E8E\7EC4\53EF\4EE5\6309\91CD\7F6E\56FE\6807\3002'),
'',
unistr('\5BF9\4E8E\5141\8BB8\9009\62E9\524D\666F\8272\548C\80CC\666F\8272\7684\5C5E\6027, \4E24\79CD\989C\8272\9009\9879\524D\9762\7684\590D\9009\6846\6307\793A\6839\636E Web \5185\5BB9\53EF\8BBF\95EE\6027\6307\5357 (WCAG) 2.0 \63D0\4F9B\7684\989C\8272\5BF9\6BD4\5EA6\4FE1\606F\3002\66F4\9AD8\7684\8BA1\7B97\5BF9\6BD4\5EA6\5206\6570\6307\793A\989C\8272\7EC4\5408\7684\53EF\8BBF\95EE\6027\66F4\4F73\3002')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108570110926312781)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\7F16\8F91\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094881720312399)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F3A\8C03\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804971385312969)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808406368312971)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809051125312972)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D3B\52A8\72B6\6001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806958565312970)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108094934361312399)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FBD\7AE0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804892719312969)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804778927312969)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\5F3A\8C03\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809348428312972)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\5185\5BB9\6700\5927\5BBD\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805517791312969)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FB9\6846\534A\5F84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803642924312968)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807118414312970)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807995041312971)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 10')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776442751312940)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 11')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776567421312940)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 12')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776641437312940)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 13')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776728129312940)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 14')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108776865010312940)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 15')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807292033312971)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808052590312971)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807348624312971)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807412000312971)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807536534312971)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807637881312971)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807704974312971)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807813485312971)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272 9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803736512312968)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BB9\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808167550312971)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BB9\5668\8FB9\6846\534A\5F84')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805950155312970)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5371\9669')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806335177312970)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805214616312969)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\5FC3\5927\7EB2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806745206312970)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\524D\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813527147312975)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803484141312968)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5C40\989C\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108807003818312970)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804636680312969)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\5F3A\8C03\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108097385472312401)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\9AD8\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805781352312969)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70ED\95E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808734525312972)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60AC\505C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808843138312972)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60AC\505C\72B6\6001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808311464312971)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806453381312970)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FE1\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804502877312968)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813611770312975)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813762528312975)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803836509312968)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E03\5C40')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805423775312969)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\4FA7\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805136144312969)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\989C\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806679787312970)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83DC\5355')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108799639578312965)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83DC\5355')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108141459285312436)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83DC\5355\9879\60AC\505C\72B6\6001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803930643312968)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808290654312971)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\6811')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805636523312969)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5E38')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808527844312971)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\6D3B\52A8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804283223312968)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\8272\677F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805889571312969)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970797235312300)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981\5F3A\8C03\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803531050312968)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805348255312969)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788596738312956)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\548C\7F51\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705706858312885)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\80CC\666F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705669169312885)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587\9875\7709')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706498549312886)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706609370312886)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\538B\7F29')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706511082312886)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\FF08\9ED8\8BA4\503C\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690195129312873)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E03\5C40')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693705099312876)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693559801312876)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FB9\5230\8FB9\FF08\9ED8\8BA4\503C\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693666891312876)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D6E\52A8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690002557312873)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693377561312876)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693413519312876)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\8272\6B63\6587')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706864597312886)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\8272\FF08\9ED8\8BA4\503C\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108693290493312876)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D45\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706995323312886)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D45\8272\FF08\9ED8\8BA4\503C\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108689959616312873)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA7\54C1\7EC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705425654312885)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C73\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705043343312885)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E01\9999\7D2B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704481333312884)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\6027\FF08\9ED8\8BA4\503C\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704920453312885)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D77\6D0B\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704510593312884)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9E45\5375\77F3\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704784521312884)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\677E\6728\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705361292312885)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9752\7D2B\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705121237312885)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73AB\7470\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705263368312885)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D6D\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704628360312884)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\77F3\677F\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704895795312884)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DF1\9752\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705546572312885)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108704304942312884)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Redwood \9009\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107886152530312235)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107970832683312300)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F85\52A9\5F3A\8C03\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808697745312972)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108808978268312972)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\5B9A\72B6\6001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806294065312970)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\5355')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804020236312968)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7701/\5E02/\81EA\6CBB\533A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806115662312970)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806891237312970)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108805020135312969)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\680F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108806052858312970)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108686399003312870)
,p_name=>'UTR.LOADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\52A0\8F7D...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107688778507312084)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338413246312596)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338325985312595)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\53EF\4EE5\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\4E2D\7F16\8F91\5FBD\6807\6807\8BB0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376053778312625)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\52A0\8F7D\5FBD\6807\6570\636E\3002\8BF7\786E\4FDD\5E94\7528\7A0B\5E8F\6784\5EFA\5668\7A97\53E3\4ECD\6253\5F00\FF0C\5E76\4E14\60A8\7684\4F1A\8BDD\6709\6548\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338267264312595)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378247389312627)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\52A0\8F7D\56FE\50CF\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338197613312595)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF\548C\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375674984312625)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\9009\62E9\5C0F\4E8E %0KB \7684\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338023197312595)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375753073312625)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\5141\8BB8\56FE\50CF\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374952692312624)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\5FBD\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375881448312625)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4FDD\5B58\5FBD\6807\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375911695312625)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\4FDD\5B58\5FBD\6807\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337999226312595)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337750495312595)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337607566312595)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E\6587\4EF6\6216\5355\51FB\4EE5\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568440828312779)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5FBD\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375482647312624)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\5141\8BB8 JSON \6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801212531312966)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76F8\90BB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801073979312966)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\7840 RGB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813350567312975)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801165651312966)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801610522312966)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95F4\9694')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801425110312966)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56DB\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801363212312966)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E09\5206')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108801504188312966)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8865\5145')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096794355312400)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C1A\672A\4FDD\5B58\5FBD\6807\66F4\6539\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108096809087312401)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5C1A\672A\4FDD\5B58\4E3B\9898\66F4\6539\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804482649312968)
,p_name=>'UTR.REDO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\505A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785113211312953)
,p_name=>'UTR.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785240010312954)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9E\8981\91CD\7F6E CSS? \6240\6709\66F4\6539\5747\5C06\4E22\5931\3002\6B64\64CD\4F5C\65E0\6CD5\64A4\6D88\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812947123312975)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\6837\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784883563312953)
,p_name=>'UTR.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784925819312953)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\540D\79F0\4EE5\91CD\547D\540D\5F53\524D\4E3B\9898\6837\5F0F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108785066606312953)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\66F4\65B0\4E3B\9898\6837\5F0F!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784517554312953)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53E6\5B58\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784673877312953)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\65B0\4E3B\9898\6837\5F0F\7684\540D\79F0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108784779749312953)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\4E3B\9898\6837\5F0F!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108800930923312966)
,p_name=>'UTR.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108568519923312780)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E3B\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108812243797312974)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5F53\524D\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813036893312975)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\4E3A\5F53\524D\4E3B\9898\6837\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813195322312975)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\4E3B\9898\73B0\5728\662F\5E94\7528\7A0B\5E8F\7684\5F53\524D\4E3B\9898\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813292621312975)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5BF9\53EA\8BFB\4E3B\9898\8FDB\884C\4E86\66F4\6539\3002\5982\679C\60A8\5C06\8BE5\4E3B\9898\8BBE\7F6E\4E3A\5E94\7528\7A0B\5E8F\7684 "\5F53\524D" \4E3B\9898, \5219\6240\505A\7684\66F4\6539\5C06\88AB\64E6\9664\3002\662F\5426\786E\5B9E\8981\7EE7\7EED?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337514969312595)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FBD\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337415308312595)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108783145919312952)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6EDA\52A8\6761')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793881226312960)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108793774268312960)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\516C\5171\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810037670312973)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8272\73AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804365924312968)
,p_name=>'UTR.UNDO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375161302312624)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108375214749312624)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\914D\7F6E\6587\4EF6')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785007248312157)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1812 \8F6C\6362\5E94\7528\7A0B\5E8F\522B\540D (%0) \65F6\51FA\73B0\610F\5916\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774025812312938)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566232393311989)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6240\6709\9875\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566303117311989)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6240\6709\9875\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107713863426312103)
,p_name=>'VIEWS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314228575312576)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8C03\8BD5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107589231144312008)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158493558312449)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584288928312004)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342753646312599)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\5386\53F2\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733186377312907)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107772462759312148)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\89C6\56FE)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108763896555312930)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\9501\5B9A\5386\53F2\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694647469312877)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64 SQL \67E5\8BE2\7528\4E8E\751F\6210\5728\5355\51FB<strong>\67E5\770B XML</strong> \6309\94AE\540E\663E\793A\7684 XML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566803774311989)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6B64\7C7B\578B\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108337839335312595)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B "%0" \9875\66F4\6539\5386\53F2\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679042591312076)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B%0\7684\6D3B\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108086613340312393)
,p_name=>'VPD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\865A\62DF\4E13\7528\6570\636E\5E93 (VPD)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098691954312402)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5B89\88C5\5E94\7528\7A0B\5E8F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779884337312949)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5220\9664\5E94\7528\7A0B\5E8F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108780076146312949)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\53D6\6D88\9501\5B9A\5E94\7528\7A0B\5E8F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108779988956312949)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\66F4\65B0\5E94\7528\7A0B\5E8F...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098722469312402)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098833940312402)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\88C5\652F\6301\5BF9\8C61')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208230686312489)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5339\914D\7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108208103949312489)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4E2A\5339\914D\9879')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553552100311979)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554518213311980)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4ECE\76EE\5F55\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554327274311980)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108020286517312340)
,p_name=>'WEBSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>'Websheet'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050808291312363)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760262971312927)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'zh-cn'
,p_message_text=>'AnyCo IT Department'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760152924312927)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('AnyCo IT Department \9488\5BF9\57FA\4E8E Web \7684\5185\5BB9\5171\4EAB\548C\4E1A\52A1\5173\952E\6570\636E\62A5\544A, \91CD\70B9\5F3A\8C03\4E86\5982\4F55\4F7F\7528 Websheets \7684\7279\6027\548C\529F\80FD\3002\6B64\793A\4F8B Websheet \5E94\7528\7A0B\5E8F\5305\542B\591A\79CD\6570\636E\7F51\683C\5E76\6F14\793A\4E86\5982\4F55\5C06\6570\636E\5305\542B\5728\5D4C\5165\62A5\8868\548C\56FE\8868\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108705968099312885)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'zh-cn'
,p_message_text=>'Big Cats'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706299274312886)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Big Cats \91CD\70B9\5F3A\8C03\4E86 Websheets \7684\4F17\591A\7279\6027\548C\529F\80FD, \5305\62EC\5D4C\5165\56FE\50CF\548C\9875\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620335842312032)
,p_name=>'WEBSHEETS'
,p_message_language=>'zh-cn'
,p_message_text=>'Websheets'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396792536312641)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F\7531\5C06\6587\672C\548C\6570\636E\7EC4\5408\8D77\6765\7684 Web \9875\7EC4\6210\3002\8FD9\4E9B\5E94\7528\7A0B\5E8F\662F\9AD8\5EA6\52A8\6001\7684, \53EF\7531\76F8\5E94\7684\7528\6237\5B9A\4E49\3002\8FD9\4E9B\5E94\7528\7A0B\5E8F\63D0\4F9B\5BFC\822A\63A7\4EF6, \641C\7D22\529F\80FD\4EE5\53CA\6DFB\52A0\6CE8\89E3 (\4F8B\5982\6587\4EF6, \6CE8\91CA\548C\6807\8BB0\7B49) \7684\529F\80FD\3002\53EF\4F7F\7528\8BBF\95EE\63A7\5236\5217\8868\548C\591A\79CD\5185\7F6E\9A8C\8BC1\6A21\578B\6765\786E\4FDD\8FD9\4E9B\5E94\7528\7A0B\5E8F\7684\5B89\5168\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396857869312641)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F\4F7F\4E00\7EC4\8D21\732E\8005\53EA\9700\4F7F\7528 Web \6D4F\89C8\5668\5373\53EF\5FEB\901F\5730\6784\5EFA\5305\62EC\62A5\8868\548C\56FE\8868\7684\4FE1\606F\9875\3002\7528\6237\53EF\4EE5\8F7B\677E\5730\7EF4\62A4\6587\672C\548C\672C\5730\6570\636E (\79F0\4E3A\6570\636E\7F51\683C) \4EE5\53CA\6765\81EA SQL \67E5\8BE2\7684\89C6\56FE\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396913380312641)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F\5728\529F\80FD\4E0A\4E0E WIKI \7C7B\4F3C\3002\4E0D\8FC7, \5B83\4EEC\4E13\95E8\9488\5BF9\6570\636E\96C6\6210\548C\663E\793A\8FDB\884C\4E86\4F18\5316\3002\4F8B\5982, \60A8\53EF\4EE5\5B9A\4E49\4E00\4E2A\6570\636E\7F51\683C\6765\5B58\50A8\8868\683C\5F0F\4FE1\606F, \6839\636E\73B0\6709\8868\5B9A\4E49\4E00\4E2A\62A5\8868, \6216\8005\53EA\662F\4F7F\7528 SQL \6807\8BB0\5728\9875\4E2D\663E\793A\6570\636E\5E93\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397049937312642)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C\662F\4E0E\7535\5B50\8868\683C\7C7B\4F3C\7684 Websheet \7EC4\4EF6, \4F7F\60A8\53EF\4EE5\8F7B\677E\5730\7EF4\62A4\8868\683C\5F0F\4FE1\606F\3002\4E0D\8FC7, \8BE5\7EC4\4EF6\7684\4E00\4E2A\8F83\5927\4E0D\540C\4E4B\5904\5728\4E8E, \6240\6709 Websheet \6570\636E\90FD\96C6\4E2D\5B58\50A8\5728 Oracle \6570\636E\5E93\4E2D, \800C\4E0D\662F\5B58\50A8\5728\672C\5730\6587\4EF6\4E2D\3002\5229\7528\6570\636E\7F51\683C, \60A8\53EF\4EE5\5411\6BCF\4E2A\6570\636E\884C\6DFB\52A0\6CE8\89E3, \5305\62EC\6587\4EF6, \6CE8\91CA, \6807\8BB0\548C\94FE\63A5\3002\6B64\5916, \8FD8\6709\4E00\4E2A\9644\52A0\7684\597D\5904, \5C31\662F\53EF\4F7F\7528\5E94\7528\7A0B\5E8F\641C\7D22\529F\80FD\641C\7D22\6240\6709\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397447793312642)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('SQL \6807\8BB0\4F7F\7528\6237\53EF\4EE5\8F7B\677E\5730\5C06\62A5\8868\5D4C\5165\57FA\4E8E\9488\5BF9\6570\636E\5E93\8868\7F16\5199\7684 SQL \8BED\53E5\7684\9875\4E2D\3002\5229\7528 SQL, \7528\6237\53EF\4EE5\8F7B\677E\5730\76F4\63A5\4ECE\5E38\7528\7684\8868\4E2D\68C0\7D22\6570\636E\3002\4F8B\5982, \8981\67E5\770B\6240\6709\8FC7\671F\7684\672A\89E3\51B3 Bug, \8BF7\4F7F\7528\4EE5\4E0B\6807\8BB0: '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('\6BCF\6B21\67E5\770B\9875\65F6\90FD\4F1A\6267\884C\6B64\67E5\8BE2, \4ECE\800C\63D0\4F9B\4E86\52A8\6001\6570\636E, \800C\4E0D\662F\66F4\5E38\89C1\7684\65F6\95F4\5FEB\7167\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397144881312642)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Websheet \5E94\7528\7A0B\5E8F\6709\52A9\4E8E\5171\4EAB\5185\5BB9, \5E76\4E14\63D0\4F9B\4E86\4FE1\606F\6027\7684\57FA\672C\62A5\544A\529F\80FD\3002Websheet \5E94\7528\7A0B\5E8F\7684\6240\6709\7ED3\6784\548C\5185\5BB9\5747\7531\7528\6237 (\5373\8D21\732E\8005\548C\7BA1\7406\5458) \63A7\5236\3002\76F8\6BD4\4E4B\4E0B, \6570\636E\5E93\5E94\7528\7A0B\5E8F\5219\7528\4E8E\66F4\6B63\5F0F, \590D\6742\548C\4E13\4E1A\7684\6570\636E\7EF4\62A4\548C\62A5\544A\7528\9014\3002\6570\636E\5E93\5E94\7528\7A0B\5E8F\7684\7ED3\6784\7531\5F00\53D1\8005\63A7\5236, \800C\5185\5BB9\901A\5E38\7531\6700\7EC8\7528\6237\63A7\5236\3002'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396278758312641)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC0\4E48\662F Websheet?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396488529312641)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\4EC0\4E48\8981\521B\5EFA Websheet \5E94\7528\7A0B\5E8F?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396507163312641)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F\4E0E WIKI \6709\4F55\4E0D\540C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396671502312641)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F\662F\5426\662F\8054\673A\7535\5B50\8868\683C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397583149312642)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC0\4E48\662F SQL \6807\8BB0?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396320529312641)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F\4E0E\6570\636E\5E93\5E94\7528\7A0B\5E8F\6709\4F55\4E0D\540C?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107679110960312077)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B89\88C5\7EC4\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781906106312951)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108760929524312928)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604943456312020)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348326463312603)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0 \5F53\524D\4E0D\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051976252312364)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342820320312599)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\4E0A\6B21\66F4\65B0\4E8E %0, \7531%1\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108342942083312599)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\521B\5EFA\4E8E %0, \7531%1\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706307819312886)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5373\5C06\5B89\88C5\793A\4F8B Websheet \5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108774880077312939)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>'Websheet: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108335270854312593)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4E0A\6B21\66F4\65B0\4E8E %0, \7531%1\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108050758391312363)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \975E BLOB \6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745972373312916)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5BF9\8C61\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095548613312400)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5E94\7528\7A0B\5E8F %0 \5DF2\5B89\88C5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359825827312612)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\4E0B\5BF9\8C61\53EF\4F7F\7528 SQL \6807\8BB0\8BED\8A00\7684\6807\8BB0\8FDB\884C\67E5\8BE2\6216\8005\53EF\5728\62A5\8868\5185\4F7F\7528\3002\53CC\5F15\53F7\7528\4E8E\6807\8BC6\533A\5206\5927\5C0F\5199\7684\5BF9\8C61\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108049256134312362)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \9875\8BBF\95EE\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108080144417312387)
,p_name=>'WEB_SERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107774633920312149)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\7ED3\679C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540021503311968)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Cloud Applications (SaaS) REST Service'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539889701311968)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B80\5355 HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540153322311969)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Cloud Infrastructure (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539948331311968)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600130252312016)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210\6B64\6CE8\518C\5411\5BFC\4EE5\8BF7\6C42 Oracle APEX \5DE5\4F5C\533A\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091652391312397)
,p_name=>'WHITE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767D\8272\6587\672C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632736265312041)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\672A\6765 1 \5929\5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108699601117312881)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\672A\6765 %0 \5929\5185')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051766915312364)
,p_name=>'WITH_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709 Admin \9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107775087533312150)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\5FEB\6377\65B9\5F0F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108157444922312448)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F\4E2D\5DF2\5B58\5728\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108156881407312448)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5\9875\7801\662F\4FDD\7559\7684\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107808148227312175)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\9009\5B9A\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685196927312081)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6CE8\91CA\6389')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542605178311971)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9875')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580479060312788)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5361\7247\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556051905311981)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5361\7247')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383518852312631)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7ECF\5178\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348782313312604)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5206\9762\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384063917312631)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8868\5355\548C\5217\8868\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384443075312632)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\57FA\4E8E\8FC7\7A0B\7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384310619312632)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\57FA\4E8E SQL \67E5\8BE2\7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384243367312631)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758521785312926)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\57FA\4E8E Web \670D\52A1\7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107562938053311986)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383422172312631)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4EA4\4E92\5F0F\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383338768312631)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4EA4\4E92\5F0F\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554292596311980)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5730\56FE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383617952312631)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\4E3B\4ECE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383888652312631)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383928202312631)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E26\6709\8868\5355\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561819731311985)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\667A\80FD\7B5B\9009\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107563045840311986)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108384148477312631)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8868\683C\5F0F\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108383792718312631)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\57FA\4E8E Web \670D\52A1\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728151782312114)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5411\5BFC\9700\8981\57FA\4E8E\901A\7528\4E3B\9898\7684\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542167369311970)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\8868\5355 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107542096266311970)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\8868\5355 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138951168312434)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108138867059312434)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152638096312445)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 - \4FDD\5B58\4EA4\4E92\5F0F\7F51\683C\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145456073312439)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5178\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145368407312439)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145246917312439)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145642962312439)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108145515967312439)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E Web \670D\52A1\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107748669002312130)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069314673312379)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\73B0\9A8C\8BC1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069211939312378)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108102791551312405)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\5411\5BFC\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108809563644312972)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5BFC\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108088001044312394)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\521B\5EFA\5411\5BFC\62A5\8868\9875\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107776719516312151)
,p_name=>'WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076618348312384)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139100832312434)
,p_name=>'WORKSPACES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048004406312361)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108048398249312361)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\5E94\7528\7A0B\5E8F\6D3B\52A8\6982\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108690848617312874)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\5DE5\4F5C\533A\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047337838312360)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359429381312612)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\56FE\50CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139621900312434)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107958060666312290)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617055676312029)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107586111518312006)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108284755840312552)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047190375312360)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108196059413312479)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\8986\76D6 ID')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108079588339312386)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047980394312361)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107636110130312044)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8BF7\6C42\5F97\5230\6279\51C6\540E\FF0C\60A8\5C06\6536\5230\4E00\5C01\7528\4E8E\6FC0\6D3B\5DE5\4F5C\533A\7684\7535\5B50\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139392735312434)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108051886148312364)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A Websheets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108047655207312361)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5DE5\4F5C\533A\6982\8981')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023668591312342)
,p_name=>'WORK_INITIATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\5DF2\542F\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108023751162312343)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\8FDB\884C\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108031785810312349)
,p_name=>'WRITING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\7F16\5199')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108695061668312877)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108694937015312877)
,p_name=>'WS.READER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BFB\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087404417312393)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Web \670D\52A1\5F15\7528\5DF2\6DFB\52A0\81F3\5E94\7528\7A0B\5E8F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576588322311998)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\63A7\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320507922312581)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758747038312926)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8DB3\591F\7684\7A7A\95F4, \65E0\6CD5\6DFB\52A0\6587\4EF6\3002\8F6C\81F3\7BA1\7406\9875, \7136\540E\8F6C\5230\7BA1\7406\670D\52A1\5E76\5355\51FB\8BF7\6C42\5B58\50A8, \4EE5\8BF7\6C42\989D\5916\7684\5B58\50A8\7A7A\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343980365312600)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378861575312627)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\589E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108344043447312600)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343439302312599)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343821881312600)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388031246312634)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576344735311998)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320182686312581)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107568884814311991)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D\53EA\80FD\5305\542B\5B57\6BCD\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107580053879312001)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D\8FC7\957F\3002\957F\5EA6\9650\5236\4E3A 255 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385065639312632)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378924489312627)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\89E3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576416820311998)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393565862312639)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\663E\793A\7C7B\578B\4E0D\80FD\4F7F\7528\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395970781312641)
,p_name=>'WS_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380387408312628)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\5217\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396197020312641)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\66F4\6539\62A5\8868\67E5\8BE2\3002\5982\679C\5C06\5217\6DFB\52A0\5230\67E5\8BE2, \5219\5728\62A5\8868\8FD0\884C\65F6\4E0D\663E\793A\8FD9\4E9B\5217\3002\60A8\5C06\9700\8981\4F7F\7528\201C\64CD\4F5C\201D\83DC\5355, \7136\540E\9009\62E9\5217\6216\5355\51FB<strong>\91CD\7F6E</strong>\3002\5982\679C\5220\9664\67E5\8BE2\4E2D\7684\4EFB\4F55\5217, \5219\5C06\7981\7528\73B0\6709\7684\8FC7\6EE4\5668, \7A81\51FA\663E\793A\89C4\5219\4EE5\53CA\5F15\7528\8FD9\4E9B\5217\7684\5176\4ED6\62A5\8868\8BBE\7F6E\3002\8BF7\786E\8BA4\60A8\7684\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573902893311995)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380802737312629)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343711406312600)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755389920312924)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D\5DF2\5B58\5728\3002\8BF7\8F93\5165\5176\4ED6\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343654421312600)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381892755312630)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\8BA4\6267\884C\6B64\5220\9664\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393331517312639)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\5217\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394671157312640)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\8981\66F4\6539\503C\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394852520312640)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\8981\66FF\6362\503C\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393932059312639)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\5217\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393276014312639)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\8981\7F16\8F91\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394027328312639)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\8981\5220\9664\7684\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379832947312628)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9017\53F7\5206\9694\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381518332312629)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\9017\53F7\5206\9694\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392905289312638)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\786E\8BA4\5220\9664\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108768735972312934)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691897306312875)
,p_name=>'WS_COPY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306466794312570)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\65B0\9875\4F5C\4E3A\526F\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329595882312588)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8BF7\6C42\521B\5EFA\5177\6709\4EE5\4E0B\5C5E\6027\7684 Websheet\3002\8BF7\786E\8BA4\60A8\7684\9009\62E9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305859343312569)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\56FE\8868\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084889254312391)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305959643312570)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6570\636E\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380012599312628)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306108768312570)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5BFC\822A\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306325371312570)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107610008429312024)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA PL/SQL \533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108305714676312569)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306027745312570)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6587\672C\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380100002312628)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576105894311997)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553437754311979)
,p_name=>'WS_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108065977197312376)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FBE\5230\8BE5\5217\7C7B\578B\53EF\7528\7684\6700\5927\5217\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108755561907312924)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\73B0\91CD\590D\7684\5217\540D\3002\5217\540D\5FC5\987B\552F\4E00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108720906255312897)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C\540D\79F0\5DF2\5B58\5728\3002\8BF7\8F93\5165\5176\4ED6\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380296874312628)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379974048312628)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782456573312951)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\4E49\6570\636E\7F51\683C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381658167312629)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108315587440312577)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386081833312633)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381753148312630)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\4E0E\6570\636E\4E00\8D77\6C38\4E45\5220\9664\7684\5217:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599096708312016)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\5217\5FC5\987B\662F\6570\636E\7F51\683C\7684\4E3B\952E\624D\80FD\663E\793A\7F16\8F91\6216\6DFB\52A0\884C\94FE\63A5\3002\8BF7\5728 select \8BED\53E5\4E2D\6DFB\52A0 "APXWS_DATA_GRID_PK" \66FF\6362\4F5C\4E3A\7B2C\4E00\5217\4EE5\5305\62EC\4E3B\952E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107592304712312010)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\5FC5\987B\4EC5\5F15\7528\6570\636E\7F51\683C\4E00\6B21\624D\80FD\663E\793A\7F16\8F91\6216\6DFB\52A0\884C\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599143870312016)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\5305\542B\591A\4E2A select \8BED\53E5\3002\8BF7\5728 select \8BED\53E5\4E2D\6DFB\52A0 "APXWS_DATA_GRID_PK" \66FF\6362\4F5C\4E3A\7B2C\4E00\5217\4EE5\663E\793A\7F16\8F91\6216\6DFB\52A0\884C\94FE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108397624388312642)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQLVALUE \6807\8BB0\8BED\6CD5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108144783065312439)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \6807\8BB0\8BED\6CD5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379401612312628)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379371252312628)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\6863')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320031593312581)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4E3A\4E3B\952E\9009\62E9\540C\4E00\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378625508312627)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9644\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691967009312875)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575292360311997)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574850342311996)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108306264251312570)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108692077753312875)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\67E5\8BE2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313429427312576)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108376804813312626)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575389719311997)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639163552312046)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615318811312028)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382277330312630)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108314011265312576)
,p_name=>'WS_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF%0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391620789312637)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395324317312640)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\9519\8BEF\6D88\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345898882312601)
,p_name=>'WS_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321691653312582)
,p_name=>'WS_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108804102039312968)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\5FC5\987B\5177\6709\67D0\4E2A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385661474312633)
,p_name=>'WS_FILL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385767579312633)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E0A\8FF0\5355\5143\4E2D\7684\5217\503C\586B\5145\7A7A\503C\5217\7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385477212312632)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300538442312565)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528 Websheet \5E94\7528\7A0B\5E8F, \6700\7EC8\7528\6237\65E0\9700\5F00\53D1\8005\534F\52A9\5C31\53EF\4EE5\7BA1\7406\7ED3\6784\5316\548C\975E\7ED3\6784\5316\6570\636E\3002\901A\8FC7 Websheet, \7528\6237\53EF\4EE5:'),
'<ul>',
unistr('<li>\53EA\9700\4F7F\7528 Web \6D4F\89C8\5668\5373\53EF\5728 Web \4E0A\521B\5EFA\548C\5171\4EAB\5185\5BB9\3002</li>'),
unistr('<li>\6309\5C42\6B21\7EC4\7EC7\9875\548C\4EA4\53C9\94FE\63A5\5404\4E2A\9875\3002</li>'),
unistr('<li>\4F7F\7528\79F0\4E3A\201C\6570\636E\7F51\683C\201D\7684\5D4C\5165\529F\80FD\521B\5EFA\548C\7BA1\7406\8868\683C\5F0F\6570\636E\3002</li>'),
unistr('<li>\6839\636E\6570\636E\5E93\4E2D\7684\73B0\6709\6570\636E\7ED3\6784, \4F7F\7528 SQL \521B\5EFA\4EA4\4E92\5F0F\62A5\8868\3002</li>'),
unistr('<li>\5C06\9875\4E2D\7684\6570\636E\7F51\683C\548C\62A5\8868\6570\636E\4F5C\4E3A\56FE\8868\6216\62A5\8868\516C\5F00\3002</li>'),
unistr('<li>\4F7F\7528\6587\4EF6, \6807\8BB0\548C\6CE8\91CA\5BF9\9875\8FDB\884C\6CE8\89E3\3002\53EF\5728\9875\5185\5BB9\4E2D\5185\5D4C\663E\793A\5173\8054\7684\56FE\50CF\3002</li>'),
unistr('<li>\641C\7D22\9875\5185\5BB9 (\4F7F\7528\5185\7F6E\641C\7D22\529F\80FD)\3002</li>'),
unistr('<li>\7BA1\7406\54EA\4E9B\7528\6237\53EF\4EE5\767B\5F55\3002\5728\767B\5F55\4E4B\540E, \7BA1\7406\54EA\4E9B\7528\6237\53EF\4EE5\8BFB\53D6, \7F16\5199\6216\7BA1\7406\5E94\7528\7A0B\5E8F (\9A8C\8BC1\548C\6388\6743)\3002</li>'),
'</ul>',
unistr('<p>\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\5355\51FB\201C\5E2E\52A9\201D\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380447219312629)
,p_name=>'WS_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386479473312633)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394378007312639)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\7EC4\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380779168312629)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381135992312629)
,p_name=>'WS_HEIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394586922312640)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393128644312638)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351372170312606)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C\540D\79F0\6216\522B\540D\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321880351312582)
,p_name=>'WS_LINKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387157637312634)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320325407312581)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5\5230\6B64\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385939019312633)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\987A\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393765799312639)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\540D\5DF2\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379744692312628)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393806940312639)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\503C\5217\8868\5B9A\4E49\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381337887312629)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\503C\5217\8868\53EF\4EE5\9650\5236\7528\6237\53EF\8F93\5165\7684\5217\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381471874312629)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\201C\7F16\8F91\5217\5C5E\6027\201D\5C06\5B9A\4E49\7684\503C\5217\8868\4E0E\5217\76F8\5173\8054\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393440515312639)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A\6240\9009\663E\793A\7C7B\578B\5B9A\4E49\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393605690312639)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\503C\5217\8868\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379643175312628)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321457922312582)
,p_name=>'WS_MAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381069238312629)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108153006427312445)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5BBD\5EA6\4E0D\80FD\5927\4E8E 4000\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378751181312627)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\5316')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343553162312600)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706128588312885)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\4E0D\7B26\5408\65E5\671F\683C\5F0F%1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394438656312640)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\65B0\6570\636E\7F51\683C\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108319989694312581)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382013410312630)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\5217\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575940901311997)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386226045312633)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\6570\636E\7F51\683C\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386353266312633)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379588726312628)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381202134312629)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E\5F53\524D\503C\65B0\5EFA\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575777287311997)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576079480311997)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575600513311997)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388264270312635)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\9A8C\8BC1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395731300312640)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281223440312549)
,p_name=>'WS_NOTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321705265312582)
,p_name=>'WS_NOTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281345673312550)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA\5FC5\987B\5177\6709\67D0\4E2A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575570787311997)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575121228311997)
,p_name=>'WS_NO_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574011200311995)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\4EFB\4F55\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574911339311996)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575492995311997)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379200785312628)
,p_name=>'WS_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395620762312640)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E7\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385841265312633)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346082231312601)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615117546312028)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108346192010312602)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575860740311997)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\76EE\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576284795311998)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5386\53F2\8BB0\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744238706312915)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\5B50\9875\7684\5206\5C42\9875\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691595816312874)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108392860913312638)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\67E5\8BE2\8FD4\56DE\7684\884C\6570\8D85\8FC7\4E86 10,000, \8BF7\8FC7\6EE4\6570\636E\4EE5\786E\4FDD\83B7\5F97\5B8C\6574\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359748659312612)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\67E5\8BE2\5185\90E8\5E94\7528\7A0B\5E8F\5BF9\8C61\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380666136312629)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\8BFB')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395496825312640)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\9762\5217\51FA\4E86\6700\8FD1\7684\66F4\6539:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691795456312874)
,p_name=>'WS_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385562192312632)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362\4E3A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395525713312640)
,p_name=>'WS_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386185874312633)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B\7A7A\5217\7684\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703775016312884)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0 \521B\5EFA\4E8E %1, \7531 %2 \521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703647832312884)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5173\952E\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108703848827312884)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9\4E0A\6B21\66F4\65B0\4E8E %0, \7531%1\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394761556312640)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\8981\8BBE\7F6E\5217\503C\7684\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321508422312582)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108393085101312638)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\9009\62E9\8981\5220\9664\7684\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329612162312588)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\521B\5EFA\793A\4F8B\4E3B\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108343336672312599)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\5E76\6DFB\52A0\53E6\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745252987312916)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\62A5\8868 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108345968866312601)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\6BB5\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107615042436312028)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\533A\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108329714136312589)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\6BB5\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108382147226312630)
,p_name=>'WS_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108385298433312632)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380553660312629)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108302186353312566)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62A5\8868\540D\79F0\4EE5\67E5\770B\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394205590312639)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217\5FC5\987B\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394129247312639)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\5E8F\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108381939723312630)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5217\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752213529312921)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Oracle \9690\79C1\653F\7B56</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744780524312915)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB\4E0B\9762\7684\201C\4E0B\4E00\6B65\201D\6309\94AE\FF0C\5373\8868\793A\60A8\4E86\89E3\5E76\540C\610F\5728\4E0D\8FDD\53CD <a href="https://www.oracle.com/us/legal/terms/index.html" target="_new">Oracle.com \4F7F\7528\6761\6B3E</a>\7684\60C5\51B5\4E0B\4F7F\7528 Oracle \7F51\7AD9\3002\6709\5173 Oracle \6536\96C6\548C\4F7F\7528\60A8\7684\4E2A\4EBA\4FE1\606F\7684\8BE6\7EC6\4FE1\606F\FF0C\5305\62EC\8BBF\95EE\3001\4FDD\7559\3001\4FEE\6539\3001\5220\9664\3001\5B89\5168\6027\3001\8DE8\5883\4F20\8F93\4EE5\53CA\5176\4ED6\4E3B\9898\7684\4FE1\606F\FF0C\8BF7\8BBF\95EE <a href="https://www.oracle.com/legal/privacy/index')
||unistr('.html" target="_new">Oracle \9690\79C1\653F\7B56\3002</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379177339312628)
,p_name=>'WS_STRING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B57\7B26\4E32')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108394932347312640)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\8981\67E5\627E\7684\5B57\7B26\4E32\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321953813312582)
,p_name=>'WS_TAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691664898312874)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362\590D\9009\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388312053312635)
,p_name=>'WS_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108386502202312633)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5206\914D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108379082717312627)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\552F\4E00\6807\8BC6\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108387375721312634)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395003621312640)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A URL \76EE\6807\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395865325312641)
,p_name=>'WS_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108750577288312920)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\592A\957F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108706080292312885)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108281137646312549)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\5FC5\9700\7684\503C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391406584312637)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395191867312640)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\9A8C\8BC1\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389247570312635)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\4E0D\7B49\4E8E\8868\8FBE\5F0F\4E2D\7684\5B57\7B26\4E32\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108395233075312640)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\9A8C\8BC1\5E8F\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388895117312635)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\81F3\5C11\5305\542B\8868\8FBE\5F0F\4E2D\7684\4E00\4E2A\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390554571312636)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\662F\5B57\6BCD\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389924421312636)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\5305\542B\5728\8868\8FBE\5F0F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390037190312636)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\662F\975E\96F6\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389708630312636)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\4E0D\5305\542B\5728\8868\8FBE\5F0F\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390400380312636)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\4E0D\4E3A\7A7A\503C\6216\96F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390109837312636)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\4E0D\5305\542B\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108390667012312636)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108391063968312637)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\662F\6709\6548\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389589906312636)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\7B49\4E8E\8868\8FBE\5F0F\4E2D\7684\5B57\7B26\4E32\6587\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389491375312636)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\4E0D\5305\542B\8868\8FBE\5F0F\4E2D\7684\4EFB\4F55\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108388737247312635)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108389020969312635)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5217\53EA\5305\542B\8868\8FBE\5F0F\4E2D\7684\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108396087721312641)
,p_name=>'WS_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108744163742312915)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6570\636E\7F51\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378399723312627)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378599320312627)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108378463327312627)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320200841312581)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D\5DF2\5B58\5728\3002\8BF7\8F93\5165\5176\4ED6\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108691420299312874)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Websheet \5C5E\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108300678639312565)
,p_name=>'WS_WELCOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B22\8FCE\4F7F\7528 Websheets')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108380943479312629)
,p_name=>'WS_WIDTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BBD\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320784330312581)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321198820312582)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321325743312582)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320943713312582)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5E26\6CE8\91CA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320690450312581)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321080754312582)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\94FE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108321213421312582)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\4F4D\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108320816360312581)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\6CE8\91CA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108072475655312381)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\67E5\8BE2\5FC5\987B\81F3\5C11\5305\542B\4E00\4E2A\65E5\671F\6216\65F6\95F4\6233\5217, \8BF7\68C0\67E5\60A8\7684\67E5\8BE2\3002(%0) </p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807732412312175)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\952E\5B57\5FC5\987B\662F 8, 16 \6216 24 \5B57\8282\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576912840311998)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5DE5\4F5C\533A\4E2D\4E0D\5B58\5728\5E94\7528\7A0B\5E8F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577152811311998)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\8868 %0 \5931\8D25\3002\767B\5F55\8868 %1 \65F6\51FA\9519\3002\5FC5\987B\5148\5220\9664\6B64\8868\FF0C\7136\540E\518D\91CD\65B0\8FD0\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576854043311998)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\751F\6210\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107576788151311998)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5DF2\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577272084311998)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\8868 %0 \5DF2\5B58\5728\3002\5FC5\987B\5148\5220\9664\6B64\8868\FF0C\7136\540E\518D\91CD\65B0\8FD0\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107577023797311998)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\5305\542B\7684\5217\90FD\662F\4E0D\53D7\652F\6301\7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554105969311979)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \65B9\6848\9700\8981\5BF9 DATA_PUMP_DIR \76EE\5F55\7684 READ \548C WRITE \6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107558403050311983)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\7684\5BF9\8C61\5B58\50A8\5E93\6587\4EF6\592A\5927\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545511484311973)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 DBMS_CLOUD \8BF7\6C42\65F6\51FA\73B0\5185\90E8\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107545657962311973)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\8C61\5B58\50A8\5E93\5F15\7528\7684\8EAB\4EFD\8BC1\660E\7C7B\578B\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554058495311979)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \65B9\6848\9700\8981\5BF9 DATA_PUMP_DIR \76EE\5F55\7684\8BBF\95EE\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557061724311982)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DBMS_CLOUD \7A0B\5E8F\5305\5728\6B64\7CFB\7EDF\4E0A\4E0D\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553987783311979)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \65B9\6848\9700\8981\5BF9 DBMS_CLOUD \7A0B\5E8F\5305\7684 EXECUTE \6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789418100312161)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\9519\8BEF: \51FD\6570\4F53\4E0D\80FD\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789506007312161)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782045075312155)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F=%0 \5F53\524D\5DE5\4F5C\533A=%1 \8BF7\6C42\7684\5DE5\4F5C\533A=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107781529580312154)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1014 \672A\627E\5230\5E94\7528\7A0B\5E8F\3002\5DE5\4F5C\533A\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783624316312156)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F=%0 \9875=%1 \8BF7\6C42=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777624703312152)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1082 \6267\884C\6388\6743\65B9\6848\4EE3\7801\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778401295312152)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1007 \5206\652F\70B9\4E0D\80FD\4E3A\7A7A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778516981312152)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1008 \6267\884C\5206\652F\5230\9875 %0 \65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107538975227311968)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-7746 \65E0\6CD5\5904\7406\4ECE\5BF9\8BDD\6846\9875\5230\4E0D\540C\9875\6A21\5F0F\7684\9875\7684\5206\652F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786891335312158)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\6309\94AE\6A21\677F ID=%0 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777270253312151)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\5355\51FB<a href="%0">\6B64\5904</a>\53EF\767B\5F55</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777909988312152)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1030 \6267\884C\8BA1\7B97\8868\8FBE\5F0F\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778043898312152)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1004 \65E0\6CD5\8BA1\7B97\51FD\6570\3002computation_point=%0 computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777854362312152)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1003 \6267\884C\8BA1\7B97\67E5\8BE2\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777714115312152)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1001 \521B\5EFA\9879 FSP_PROCESS_STATE_%0 \65F6\51FA\73B0\610F\5916\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777409268312151)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1001 make_deeplinking_item \4F1A\8BDD=%0 \4E2D\51FA\73B0\610F\5916\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779081465312153)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('p_company \6216 wwv_flow_company cookie \5E94\5305\542B\5E94\7528\7A0B\5E8F\6240\6709\8005\7684\5B89\5168\7EC4 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783326200312156)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-7621 \65E0\6CD5\5728\63A5\53D7\5E94\7528\7A0B\5E8F\65F6\786E\5B9A\5E94\7528\7A0B\5E8F (%0) \7684\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783458369312156)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('p_company \6216 wwv_flow_company cookie \5E94\5305\542B\5E94\7528\7A0B\5E8F\6240\6709\8005\7684\5B89\5168\7EC4 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778811818312152)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1011 \65E0\6548\7684\6C42\503C\7C7B\578B: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786793885312158)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('fetch_value \4E2D\51FA\73B0\5E94\7528\7A0B\5E8F\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777565398312151)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1902 \5728 find_item_name \4F8B\884C\7A0B\5E8F\4E2D\9879 ID \4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778303658312152)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1021 \65E0\6CD5\8FD0\884C "\8FD4\56DE\5E03\5C14\503C\7684\51FD\6570\4F53" \9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778205172312152)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1024 \65E0\6CD5\8FD0\884C "\8FD4\56DE\6587\672C\7684\51FD\6570\4F53" \9A8C\8BC1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778930524312153)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1812 \5206\914D G_FLOW_ID (%0) \65F6\51FA\73B0\610F\5916\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783585594312156)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-9988 \4E3A\6B64\8BF7\6C42\63D0\4F9B\7684\4FE1\606F\4E0D\8DB3: \53EF\80FD\662F\7531\4E8E\672A\7B49\5F85\4E0A\4E00\9875\5B8C\5168\52A0\8F7D\9020\6210\7684\3002\8BF7\6309\6D4F\89C8\5668\7684\540E\9000\548C\91CD\65B0\52A0\8F7D\6309\94AE, \6216\5BFC\822A\5230\5E94\7528\7A0B\5E8F\4E3B\9875\4EE5\7EE7\7EED\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107779414454312153)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1555 \672A\767B\5F55\5230 Oracle Login Server\3002\672A\6807\8BC6\516C\5171\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783011222312156)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777132550312151)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\767B\5F55\3002\9A8C\8BC1\6240\9700\7684 Cookie \7F3A\5931\6216\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784079099312156)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1777: \63D0\4F9B\7684\9875 %0 \6CA1\6709\8981\5206\652F\5230\7684\9875\3002\8BF7\5411\60A8\7684\5E94\7528\7A0B\5E8F\7BA1\7406\5458\62A5\544A\6B64\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783115274312156)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1013 \7528\6237 %0 \6CA1\6709\6267\884C\6240\5C1D\8BD5\64CD\4F5C\7684\6743\9650\3002\9700\8981\89D2\8272 %1, \8BF7\4E0E\60A8\7684\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608961127312023)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6821\9A8C\548C\88AB\4F20\9012\5230\663E\793A\8FC7\7A0B, \5219\53EF\4EE5\7528\53C2\6570\8BF7\6C42\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609196807312023)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\6709\4F7F\7528 "\5206\652F\5230\9875" \7C7B\578B\5206\652F, \624D\53EF\4EE5\4ECE\53E6\4E00\9875\8BBF\95EE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609084981312023)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\6709\5728\6CA1\6709\53C2\6570\65F6\624D\80FD\8BBF\95EE\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107609389473312023)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570\5DF2\4F20\9012\5230\4E0D\63A5\53D7\53C2\6570 (\8BF7\6C42, \6E05\9664\9AD8\901F\7F13\5B58, \9879\503C) \7684\9875\4E2D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608824605312023)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\6CA1\6709\4FDD\62A4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107782920736312155)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\542F\7528\6240\9700\7684\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784169570312156)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<a href="f?p=%0">\91CD\65B0\542F\52A8\5E94\7528\7A0B\5E8F</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107777332743312151)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1001 \4FDD\5B58\4F8B\884C\7A0B\5E8F\65F6\51FA\73B0\610F\5916\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778743493312152)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1910 \5BF9\6807\9898\6587\672C\4E2D\7684 SQL \8868\8FBE\5F0F\6C42\503C\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809926662312177)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5B9A\5411\5230\4E3B\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107783259583312156)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1512 \65E0\6CD5\89E3\6790\9875\522B\540D (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787054597312159)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BBE\7F6E timed_statistics: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107786926390312159)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8DDF\8E2A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107780821105312154)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1444 \4E0D\652F\6301\7684\9A8C\8BC1\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107778162424312152)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1006 \9A8C\8BC1\4F8B\884C\7A0B\5E8F\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789619428312161)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817877139312183)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5F00\53D1\8005\89D2\8272\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817713088312182)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\63D0\53D6\67E5\627E\7528\6237\4FE1\606F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017844960312338)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \7528\6237 %0 \4E0D\5177\6709\4EFB\4F55\5F00\53D1\8005\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684997244312081)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\517C\5BB9 (\5E94\8BE5\80FD\591F\987A\5229\5730\8FD0\884C\6B64\5BFC\5165\3002)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563157865312776)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8EAB\4EFD\8BC1\660E "%0" (\9759\6001 ID) \7684\8B66\544A:'),
'',
unistr('- Application Express \5BFC\51FA\6587\4EF6\4E0D\5305\542B\8EAB\4EFD\8BC1\660E\4FE1\606F\3002'),
unistr('- \5BFC\5165\5E94\7528\7A0B\5E8F\4E4B\540E, \4F7F\7528 APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL'),
unistr('- \8FC7\7A0B\8BBE\7F6E\8EAB\4EFD\8BC1\660E\3002\8BE5\8EAB\4EFD\8BC1\660E\6B63\5728\4F7F\7528'),
unistr('- \9759\6001 ID "%0" \5F15\7528')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680474000312077)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\7248\672C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152922168312445)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5E94\7528\7A0B\5E8F %0, \5B83\5B89\88C5\5728\5176\4ED6\5DE5\4F5C\533A\4E2D!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684589665312081)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9A8C\8BC1\65B9\6848 (\540D\79F0="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683194950312080)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5206\652F (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684343601312080)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA Bug (id="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681610597312078)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6784\5EFA\9009\9879 (\540D\79F0=%0) \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681736941312078)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\6784\5EFA\9009\9879 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683050392312079)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6309\94AE (\540D\79F0="%0" ID="%1") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038455867312354)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\52A8\6001\64CD\4F5C (\5B50\64CD\4F5C\540D\79F0="%0" ID="%1") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038361838312353)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\52A8\6001\64CD\4F5C (\9875="%0" \540D\79F0="%1" ID="%2") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107722519415312110)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\9875=%0 \9879="%1" ID="%2" \4E0E\73B0\6709\5E94\7528\7A0B\5E8F\7EA7\522B\7684\9879\540C\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682203995312079)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\8BA1\7B97\9879="%0" \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682129651312079)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\9879 ID="%0" \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639402149312046)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\63D2\4EF6\5C5E\6027 (ID="%0") \65F6\51FA\9519	')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108052308987312364)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\63D2\4EF6\5C5E\6027\503C (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639325370312046)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\63D2\4EF6 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695704807312089)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\63D2\4EF6\4E8B\4EF6 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681936622312079)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\5904\7406 ID ="%0" \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727147258312902)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\6A21\677F\9009\9879 id="%0" \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727077028312902)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\6A21\677F\9009\9879\7EC4 id="%0" \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684169224312080)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\5355\5DF2\6DFB\52A0\5230\73B0\6709\9875 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659127850312061)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BFC\5165\6570\636E\5E93\5BF9\8C61\5B89\88C5\5C5E\6027 (id="%0")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659276705312061)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5B89\88C5\811A\672C (id="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683889400312080)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\7C7B\578B\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683601725312080)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F\7FFB\8BD1\6620\5C04\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581404369312002)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA id="%0" \7684\503C\5217\8868\5217\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682622297312079)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\503C\5217\8868 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681841976312079)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5BFC\822A\680F\9879 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683327999312080)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875\8BA1\7B97 (\9875=%0 \9879="%1" ID="%2") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682749233312079)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875 (\540D\79F0="%0" ID="%1") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108092531705312397)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875\7EC4\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684079471312080)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0 \5DF2\5177\6709\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682854336312079)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875 %0 \5E2E\52A9\6587\672C\65F6\51FA\9519:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683275848312080)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF (\9875=%0 \9879="%1" ID="%2")')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682984397312079)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\9875 (\540D\79F0="%0" ID="%1") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683776679312080)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5173\4E8E\8868 "%0" \7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683599167312080)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875\5904\7406 (\9875=%0 \540D\79F0="%1") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683494906312080)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875\9A8C\8BC1 (\9875=%0 \540D\79F0="%1") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682520778312079)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\7236\9009\9879\5361 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682025471312079)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\5904\7406 SQL (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107683905991312080)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\9875 %0 \5DF2\5B58\5728, \62A5\8868\533A\57DF\5DF2\6DFB\52A0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684286479312080)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\521B\5EFA\9875 %0, \56E0\4E3A\5B83\5DF2\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684444282312081)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5FEB\6377\65B9\5F0F (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682392020312079)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6807\51C6\9009\9879\5361 (ID="%0") \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107682408934312079)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\9009\9879\5361\96C6 %1 \91CD\547D\540D\4E3A %0 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681563433312078)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\6A21\677F (\540D\79F0=%0) \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680335608312077)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\6269\5C55\7684 API:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684807343312081)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5BFC\51FA\6587\4EF6\4E0E\60A8\5C1D\8BD5\5C06\6587\4EF6\5BFC\5165\5230\7684 Application Express \7248\672C\4E0D\517C\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681331602312078)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6CA1\6709 p_id \503C\7684\60C5\51B5\4E0B\8C03\7528\8FC7\7A0B %0 -- \5FC5\987B\63D0\4F9B\5E94\7528\7A0B\5E8F ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540603776311969)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID "%0" \4E0D\5728\5141\8BB8\7684\8303\56F4\5185 (%1 - %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152495858312445)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528\5E94\7528\7A0B\5E8F ID "%0", \8303\56F4 (%1 - %2) \5DF2\88AB\4FDD\7559')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684720165312081)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID %0 \662F\4E3A Oracle Corporation \4FDD\7559\7684 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107540720020311969)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F ID "%0" \662F\5176\4ED6\5DE5\4F5C\533A\4E2D\7684\4FDD\7559 ID, \4E0D\80FD\7528\4E8E\6B64\5904')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681406506312078)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5220\9664\5E94\7528\7A0B\5E8F %0\3002\5C06\4E0D\5C1D\8BD5\6267\884C\5BFC\5165\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680509555312078)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5BFC\5165\4E0E\4EE5\4E0B\7248\672C\517C\5BB9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110945946312412)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BFC\5165\811A\672C\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681067387312078)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\7528\6237\540D, \5BC6\7801\6216\5DE5\4F5C\533A\7EC4\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680602711312078)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\5E94\7528\7A0B\5E8F\5BFC\5165\672A\63D0\4F9B\5BFC\51FA\7248\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563065122312775)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\5177\6709\9759\6001 ID "%0" \7684\8FDC\7A0B\670D\52A1\5668\63D0\4F9B\503C\3002\8BF7\5148\4F7F\7528 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER, \7136\540E\5B89\88C5\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110892464312412)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107685062971312081)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\517C\5BB9 (\5BFC\51FA\5185\5BB9\53EF\80FD\5305\542B\60A8\7684 %0 \7248\672C\4E0D\652F\6301\7684\8C03\7528\3002)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563401091312776)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8FDC\7A0B\670D\52A1\5668 "%0" (\9759\6001 ID) \7684\8B66\544A\3002'),
'',
unistr('- \5DF2\4F7F\7528 APEX_APPLICATION_INSTALL \8BBE\7F6E\6B64\8FDC\7A0B\670D\52A1\5668\7684\5C5E\6027\3002'),
unistr('- \8BF7\6CE8\610F, \5176\4ED6\5E94\7528\7A0B\5E8F\4E5F\4F1A\4F7F\7528\6B64\8FDC\7A0B\670D\52A1\5668\5BF9\8C61\3002'),
'',
unistr('\56E0\6B64, \5DF2\66F4\65B0\5DE5\4F5C\533A\8FDC\7A0B\670D\52A1\5668\5C5E\6027\3002'),
unistr('- \57FA\672C URL:      %1'),
unistr('- HTTPS \4E3B\673A:    %2'),
unistr('- ORDS \65F6\533A:     %3')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563328673312776)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8FDC\7A0B\670D\52A1\5668 "%0" (\9759\6001 ID) \7684\8B66\544A\3002'),
'',
unistr('- PROMPT_ON_INSTALL \5C5E\6027\8BBE\7F6E\4E3A YES\3002'),
unistr('- \672A\968F APEX_APPLICATION_INSTALL \63D0\4F9B\4EFB\4F55\5C5E\6027\3002'),
'',
unistr('\56E0\6B64, \5DE5\4F5C\533A\8FDC\7A0B\670D\52A1\5668\8BBE\7F6E\4FDD\6301\4E0D\53D8\3002'),
unistr('- \57FA\672C URL:      %1'),
unistr('- HTTPS \4E3B\673A:    %2'),
unistr('- ORDS \65F6\533A:     %3'),
'',
unistr('\4F7F\7528 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER \66F4\6539\5C5E\6027\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108563291486312776)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8FDC\7A0B\670D\52A1\5668 "%0" (\9759\6001 ID) \7684\8B66\544A\3002'),
'',
unistr('- PROMPT_ON_INSTALL \5C5E\6027\8BBE\7F6E\4E3A NO\3002'),
unistr('- \6765\81EA\5E94\7528\7A0B\5E8F\5BFC\5165\6587\4EF6\7684\8BBE\7F6E\4E0D\540C\4E8E\73B0\6709\5C5E\6027\3002'),
unistr('- \6B64\8FDC\7A0B\670D\52A1\5668\4E5F\7531\8BE5\5DE5\4F5C\533A\4E2D\7684\5176\4ED6\5E94\7528\7A0B\5E8F\4F7F\7528\3002'),
'',
unistr('\56E0\6B64, \5DE5\4F5C\533A\8FDC\7A0B\670D\52A1\5668\8BBE\7F6E\4FDD\6301\4E0D\53D8\3002'),
unistr('- \57FA\672C URL:      %1'),
unistr('- HTTPS \4E3B\673A:    %2'),
unistr('- ORDS \65F6\533A:     %3'),
'',
unistr('\4F7F\7528 APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER \66F4\6539\5C5E\6027\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108110796810312411)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348975836312604)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06\53CD\9988\5BFC\5165\540C\4E00\7CFB\7EDF!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108111069434312412)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\5927\5C0F (%0 \5B57\8282) \8D85\8FC7\4E86\5141\8BB8\7684\6700\5927\5927\5C0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107684690975312081)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8BBE\7F6E\5305\53D8\91CF g_security_group_id\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107681222411312078)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8BBE\7F6E\5305\53D8\91CF g_security_group_id \4EE5\5BFC\5165\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680813380312078)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5EFA\7ACB\60A8\5F15\64CE\7684\4E0A\4E00 API \7248\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680732099312078)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5EFA\7ACB\60A8\7684\5F15\64CE\7248\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107680972645312078)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\9700\8981\5347\7EA7\4EE5\5BFC\5165\6B64\5E94\7528\7A0B\5E8F\5BFC\51FA\7684\5185\5BB9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108348890415312604)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\90E8\7F72\7CFB\7EDF\5BFC\51FA\53CD\9988!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553256841311979)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528 REST \6570\636E\6E90\7684\81EA\52A8\5316\65E0\6CD5\4ECE\5176\4ED6\5E94\7528\7A0B\5E8F\590D\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107551607867311978)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729725246312115)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729626412312115)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729835848312115)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\542F\7528 REST \7684 SQL \670D\52A1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729545225312115)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\8868\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107729914906312115)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B REST \6570\636E\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730080210312115)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B WHERE \6216 ORDER BY \5B50\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785186881312157)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801438766312170)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\62E9\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785419424312157)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<span class="tiny">\672A\627E\5230\9875\3002</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785218479312157)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785547057312158)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 <font size=-2>\9875</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971774834312301)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\8BA1\6570:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107971824743312301)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785345942312157)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL %0 %1 \5305\542B %2 \884C\6E90\4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220423407312498)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B SQL \4E0D\652F\6301\4EE3\7801\5B8C\6210\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108219743912312498)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B SQL \4E0D\652F\6301\67E5\8BE2\6784\5EFA\5668\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817948985312183)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\53EF\66F4\65B0\62A5\8868\8FDB\884C\8BED\6CD5\5206\6790\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108752801870312922)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4ECE\5BF9\8BDD\6846\9875\91CD\5B9A\5411\5230\6B63\5E38\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789838779312161)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E9F\5F03')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789753595312161)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6E05\9664 %0 \4E2A\91CD\590D\7684\4F1A\8BDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758129840312137)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\80FD\66F4\6539\60A8\81EA\5DF1\7684\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758302986312137)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\66F4\6539\5BC6\7801\8BF7\6C42\65F6\51FA\73B0\610F\5916\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757844951312137)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\63D0\4F9B\5BC6\7801\548C\786E\8BA4\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107757990116312137)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\4E0D\5339\914D, \8BF7\91CD\8BD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758942093312137)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle \9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107758602481312137)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1025 \5904\7406 PLSQL \8868\8FBE\5F0F\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649505204312054)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\6210\5458\5C5E\6027\7F16\53F7 %0 \65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790294101312161)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\7684\6761\4EF6\65E0\6548/\6761\4EF6\4E0D\5B58\5728: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790026151312161)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\51FD\6570\4F53\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789968848312161)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684 PL/SQL \8868\8FBE\5F0F\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790115096312161)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684 SQL \8868\8FBE\5F0F\6761\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804389016312172)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C wwv_flow_copy %0 >> %1 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539302986311968)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7FFB\8BD1\540E\7684\5E94\7528\7A0B\5E8F ID \65E0\6548\3002\6B64\5E94\7528\7A0B\5E8F ID \6B63\5728\7531\73B0\6709\5E94\7528\7A0B\5E8F\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804213274312172)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8BBE\7F6E\5B89\5168\7EC4 ID (\5DE5\4F5C\533A\6807\8BC6)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091918875312397)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F "%0" \517C\5BB9\6A21\5F0F\5FC5\987B\81F3\5C11\4E3A 21.2 \624D\80FD\5237\65B0\4E3B\9898\3002\53EF\4EE5\4ECE\5E94\7528\7A0B\5E8F\5B9A\4E49\7684\201C\5C5E\6027\201D\4E0B\66F4\6539\517C\5BB9\6A21\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108788661754312956)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\4E3B\9898\4E0E\6240\9009\4E3B\4E3B\9898\4E0D\517C\5BB9, \4E3B\9898\6807\8BC6\7B26\4E0D\5339\914D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108217313709312496)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5237\65B0\6A21\677F, \56E0\4E3A\672A\627E\5230\7236\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657572537312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\9A8C\8BC1\65B9\6848\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656966758312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\6309\94AE\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811106805312177)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\65E5\5386\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656702240312059)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\5B57\6BB5\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657675899312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\9879\5E2E\52A9\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656540428312059)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\5217\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657420947312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\503C\5217\8868\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657048647312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\9762\5305\5C51\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657354546312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\5BFC\822A\680F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656305958312059)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\9875\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656838159312059)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656499497312059)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\533A\57DF\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656692766312059)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\62A5\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657172012312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\5B89\5168\65B9\6848\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657207410312060)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\53D1\5E03\5FEB\6377\65B9\5F0F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654742465312058)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\9A8C\8BC1\65B9\6848\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653674022312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\6309\94AE\6A21\677F\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107811012465312177)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\65E5\5386\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652991391312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5B57\6BB5\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654889836312058)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\9879\5E2E\52A9\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652782829312056)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5217\8868\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653383037312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\503C\5217\8868\5F15\7528 ID\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653523284312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\9762\5305\5C51\6A21\677F\5F15\7528 ID\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653241325312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5BFC\822A\680F\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652521423312056)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\9875\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653459748312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\5F15\7528 ID\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652646093312056)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\533A\57DF\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652811827312056)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\62A5\8868\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653076210312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5B89\5168\65B9\6848\5F15\7528 ID\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107653193134312057)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5FEB\6377\65B9\5F0F\5F15\7528 ID\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656110613312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\9A8C\8BC1\65B9\6848\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655661661312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\6309\94AE\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108748457583312918)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\65E5\5386\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655310018312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\5B57\6BB5\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656282945312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\9879\5E2E\52A9\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655181253312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\5217\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107656082546312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\503C\5217\8868\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655519101312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\9762\5305\5C51\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655945537312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\5BFC\822A\680F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107654976168312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\9875\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655429039312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655055160312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\533A\57DF\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655200596312058)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\62A5\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655730867312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\5B89\5168\65B9\6848\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107655892320312059)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\5FEB\6377\65B9\5F0F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108727511860312902)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA2\9605\4E3B\9898\9009\9879\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818497577312183)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C wwv_flow_copy_page %0 >> %1 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804573367312172)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C wwv_flow_copy_page_item %0 >> %1 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677528089312075)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\627E\5230\8981\590D\5236\7684 %0 (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004834863312329)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0\4E3A %0 \7684\5FEB\6377\65B9\5F0F\5DF2\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804961375312173)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\8981\590D\5236\7684\5FEB\6377\65B9\5F0F (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805975961312173)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\62A5\8868\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806528690312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\8BA1\7B97\9009\9879\5361\76EE\6807) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809856729312176)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\9A8C\8BC1\65B9\6848) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107809730116312176)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\6388\6743\65B9\6848) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807303723312175)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\6309\94AE\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806805792312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\5B57\6BB5\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807199110312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\5217\8868\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807518201312175)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\503C\5217\8868) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807242526312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\9762\5305\5C51\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807406332312175)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\5BFC\822A\680F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806770562312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\9875\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807004908312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\533A\57DF\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806949009312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\62A5\8868\6A21\677F) \65F6\51FA\9519: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807652704312175)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\590D\5236\5B89\5168\65B9\6848) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805837798312173)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\5B57\6BB5\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806175468312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\5217\8868\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806243371312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\9762\5305\5C51\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805614383312173)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\9875) \65F6\51FA\9519: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806680073312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\7236\9009\9879\5361) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805730997312173)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\9875\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806331134312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\5F39\51FA\5F0F\503C\5217\8868\6A21\677F) \65F6\51FA\9519: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806043110312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\533A\57DF\6A21\677F) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107806414256312174)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\5E94\7528\7A0B\5E8F (\521B\5EFA\6807\51C6\9009\9879\5361) \65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107805576914312173)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1 %0 \9519\8BEF: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004665983312329)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004527501312329)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528 MRD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108004425087312329)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528 MRU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991754482312316)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069481311312379)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\8868\5355\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108095998711312400)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5168\5C40\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108580395118312788)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\4EA4\4E92\5F0F\7F51\683C\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069629255312379)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\9875\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069573055312379)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\8868\683C\5F0F\8868\5355\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069715241312379)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE %0 \63D0\53D6\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113146705312413)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\7528\6237\540D Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108209105055312490)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\822A\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069075366312378)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83DC\5355\9875 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108069889026312379)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 %0 \7684\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108158176489312449)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\884C\7248 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997316851312323)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9690\85CF\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107990814403312315)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\62A5\8868\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108085652396312392)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\7684\62A5\8868\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081778005312388)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\884C\811A\672C: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113098444312413)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\7528\6237\540D Cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998553008312324)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4ECE\5E94\7528\7A0B\5E8F\4F1A\8BDD\4E2D\8C03\7528\6B64\8FC7\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107560294781311984)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\5C06\8EAB\4EFD\8BC1\660E\7528\4E8E\6B64 URL \7AEF\70B9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553763007311979)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\4E2D\7684 URL \5FC5\987B\4EE5 http:// \6216 https:// \5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108099091714312402)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \7684\8EAB\4EFD\8BC1\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807872900312175)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664 css: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113763706312414)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\4E0D\652F\6301\62D6\653E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789305362312160)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670825447312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\536B\58EB\51FD\6570\5C06\5185\7F6E\4F1A\8BDD\9A8C\8BC1\68C0\67E5\7684\5E03\5C14\503C\7ED3\679C\8FD4\56DE\7ED9\5F15\64CE\3002\5982\679C\7ED3\679C\4E3A\201C\771F\201D, \5F15\64CE\5C06\7EE7\7EED\663E\793A\6216\63A5\53D7\6B64\9875\3002\5982\679C\7ED3\679C\4E3A\201C\5047\201D, \5F15\64CE\5C06\91CD\5B9A\5411\81F3\6B64\9A8C\8BC1\65B9\6848\4E2D\6307\5B9A\7684\65E0\6548\4F1A\8BDD\9875\6216 URL (\53C2\89C1\4E0B\6587)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672148122312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9875\536B\58EB\51FD\6570\8FD4\56DE\201C\771F\201D, \5219\7EE7\7EED\5448\73B0\9875\6216\5904\7406\9875\3002\5982\679C\7ED3\679C\4E3A\201C\5047\201D, \5F15\64CE\5FC5\987B\9000\51FA, \56E0\4E3A\5728\9A8C\8BC1\65B9\6848\4E2D\6CA1\6709\6307\5B9A\65E0\6548\4F1A\8BDD\76EE\6807\3002\5728\8FD9\79CD\60C5\51B5\4E0B, \5047\5B9A\7528\6237\63D0\4F9B\7684\9875\536B\58EB\51FD\6570\5DF2\91CD\5B9A\5411\81F3 %0 \73AF\5883\4EE5\5916\7684\767B\5F55\9875, \53EF\80FD\91CD\5B9A\5411\81F3\5916\90E8\9A8C\8BC1 portal\3002\6B64\51FD\6570\8FD8\5E94\8BBE\7F6E\5168\5C40\53D8\91CF g_unrecoverable_error := true \4EE5\6307\793A\5F15\64CE\9000\51FA\5E76\4E14\4E0D\663E\793A\9519\8BEF\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672252864312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\64CE\5C06\6267\884C\4EE5\4E0B\4EE3\7801, \6B64\4EE3\7801\5DF2\6307\5B9A\4E3A\6B64\9A8C\8BC1\65B9\6848\7684\9A8C\8BC1\524D\5904\7406:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672396890312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F5C\4E3A\4E0D\8FD4\56DE\503C\7684\533F\540D\5757\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672499336312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\65B9\6848\4E2D\672A\6307\5B9A\5B9A\5236\7684\9A8C\8BC1\524D\4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672606663312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EFB\4F55\8F93\5165\5230\767B\5F55\8868\5355\4E2D\7684\7528\6237\540D/\5BC6\7801\7EC4\5408\90FD\5C06\89C6\4E3A\6709\6548\3002\8F93\5165\7684\7528\6237\540D\5C06\4F5C\4E3A\4F1A\8BDD\671F\95F4\7684\767B\5F55\7528\6237\7684\540D\79F0\3002\6B64\6280\672F\5BF9\4E8E\5728\5EFA\7ACB\4EFB\4F55\5B9E\9645\7528\6237\5E10\6237\4E4B\524D\5F00\53D1\60A8\7684\5E94\7528\7A0B\5E8F\975E\5E38\6709\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672702631312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9488\5BF9\5E94\7528\7A0B\5E8F\6784\5EFA\5668 (cookie \7528\6237) \5E10\6237\68C0\67E5\8F93\5165\767B\5F55\8868\5355\7684\7528\6237\540D\548C\5BC6\7801\3002\5728\5DE5\4F5C\533A\4E2D\4F7F\7528\76F8\540C\7684\5E10\6237\767B\5F55\5230 %0\3002\5F53\5E94\7528\7A0B\5E8F\7684\7528\6237\662F\5728\76F8\540C\6570\636E\5E93\548C\5DE5\4F5C\533A\4E2D\62E5\6709 %0 \5E10\6237\7684\5F00\53D1\8005\65F6, \6B64\6280\672F\975E\5E38\6709\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605067022312020)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9488\5BF9 Oracle \6570\636E\5E93\5E10\6237\68C0\67E5\8F93\5165\767B\5F55\8868\5355\7684\7528\6237\540D\548C\5BC6\7801\3002\5F53\5E94\7528\7A0B\5E8F\7528\6237\5728\6570\636E\5E93\4E2D\6709\5E10\6237\65F6, \6B64\6280\672F\975E\5E38\65B9\4FBF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672833497312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6B64\9A8C\8BC1\65B9\6848\4E2D\6307\5B9A\7684 LDAP \76EE\5F55\68C0\67E5\8F93\5165\767B\5F55\8868\5355\7684\7528\6237\540D\548C\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672995060312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \53C2\6570\8BBE\7F6E\4E3A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673693976312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\4EE5\4E0B\7528\4E8E\9A8C\8BC1\8EAB\4EFD\8BC1\660E\7684\5B9A\5236\4EE3\7801:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673810748312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\68C0\67E5\5185\7F6E\767B\5F55\9875\4F7F\7528\7684\4F1A\8BDD\7684\5185\7F6E\4F1A\8BDD\8868\3002\5982\679C\6B64\4F1A\8BDD\5DF2\5B58\5728\5E76\4E14\4E0D\4E3A\5176\4ED6\7528\6237\6240\62E5\6709, \8BF7\7ACB\5373\5C06\5176\6807\8BB0\4E3A\5C5E\4E8E\5DF2\9A8C\8BC1\7684\7528\6237 (\4F7F\7528\6765\81EA\767B\5F55\8868\5355\7684\7528\6237\540D)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670964967312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\536B\58EB\51FD\6570\5C06\5BF9\5185\7F6E\4F1A\8BDD\9A8C\8BC1\68C0\67E5\7684\5E03\5C14\503C\7ED3\679C\4E0E\7528\6237\63D0\4F9B\7684\4F1A\8BDD\9A8C\8BC1\68C0\67E5\7ED3\679C\6267\884C AND \64CD\4F5C, \7136\540E\5C06\7ED3\679C\8FD4\56DE\7ED9\5F15\64CE\3002\5982\679C\7ED3\679C\4E3A\201C\771F\201D, \5F15\64CE\5C06\7EE7\7EED\663E\793A\6216\63A5\53D7\6B64\9875\3002\5982\679C\7ED3\679C\4E3A\201C\5047\201D, \5F15\64CE\5C06\91CD\5B9A\5411\81F3\6B64\9A8C\8BC1\65B9\6848\4E2D\6307\5B9A\7684\65E0\6548\4F1A\8BDD\76EE\6807 (\53C2\89C1\4E0B\6587)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673940339312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\540D\4E3A %0 \7684 cookie \8BBE\7F6E\4E3A\8FD9\6837\7684\503C: \8BE5\503C\7528\4E8E\5728\5185\90E8\4F1A\8BDD\8868\4E2D\5B9A\4F4D\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674072326312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\8981\91CD\5B9A\5411\5230\4E0B\4E00\4E2A URL \7684 URL\3002\5982\679C "\6DF1\94FE\63A5" \7531\5448\73B0\5F15\64CE\8BB0\5F55\5728\4F1A\8BDD\72B6\6001\4E2D, \5219\5C06\6B64\4F5C\4E3A\8981\8F6C\5230\7684 URL\3002\5426\5219\5C06\8F6C\5230\6307\5B9A\4F5C\4E3A\5E94\7528\7A0B\5E8F\4E3B\9875\94FE\63A5\5C5E\6027\7684 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674268850312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\4E86\8EAB\4EFD\8BC1\660E\4EE5\540E, \5F15\64CE\5C06\6267\884C\4EE5\4E0B\6307\5B9A\4E3A\6B64\9A8C\8BC1\65B9\6848\7684\9A8C\8BC1\540E\5904\7406\7684\4EE3\7801:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674347371312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\4F5C\4E3A\4E0D\8FD4\56DE\503C\7684\533F\540D\5757\6267\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674493839312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\65B9\6848\4E2D\5C1A\672A\6307\5B9A\5B9A\5236\7684\9A8C\8BC1\540E\4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674507897312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\81F3\4E0A\9762\786E\5B9A\7684 URL\3002\8FD9\6807\5FD7\7740\4F7F\7528\5185\7F6E\767B\5F55\9875\4EE5\53CA\5B83\6240\8C03\7528\7684 API \7684\767B\5F55\5904\7406\7684\7ED3\675F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671014118312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5B9A\5236\903B\8F91\6765\6267\884C\9875\536B\58EB\4EFB\52A1\3002\5BF9\4E8E\6BCF\4E2A\9875\8BF7\6C42, \5F15\64CE\5C06\6267\884C\4EE5\4E0B\4EE3\7801:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671105404312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EE5\4E0A\5757\7684\5E03\5C14\503C\7ED3\679C\5C06\8FD4\56DE\5F15\64CE\3002\5982\679C\7ED3\679C\4E3A\201C\771F\201D, \5F15\64CE\5C06\7EE7\7EED\663E\793A\6216\63A5\53D7\6B64\9875\3002\5982\679C\7ED3\679C\4E3A\201C\5047\201D, \5F15\64CE\5C06\91CD\5B9A\5411\81F3\6B64\9A8C\8BC1\65B9\6848\4E2D\6307\5B9A\7684\65E0\6548\4F1A\8BDD\76EE\6807 (\53C2\89C1\4E0B\6587)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671244025312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\9A8C\8BC1\7684\5185\7F6E\65B9\6CD5\9002\7528\4E8E\4F7F\7528 API \8C03\7528\7684 %0 \5F00\53D1\8005:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671342693312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E03\5C14\503C\51FD\6570\7ED3\679C\53EF\4EE5\4E0E\5728\9A8C\8BC1\65B9\6848\4E2D\6307\5B9A\7684\7528\6237\63D0\4F9B\7684\9875\536B\58EB\51FD\6570\4E2D\7684\5176\4ED6\68C0\67E5\76F8\7ED3\5408\3002\5982\679C\8C03\7528\4E86\6B64 API, \5219\5B83\68C0\67E5\540D\4E3A %0 \7684 cookie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671484428312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\6B64 cookie \5B58\5728, \5E76\4E14\5176\89E3\7801\503C\4F4D\4E8E\5185\90E8\4F1A\8BDD\8868\7684\884C\4E2D, \5219\8BA4\4E3A\6B64\4F1A\8BDD\6709\6548, \800C\4E14\5C06\201C\771F\201D\503C\8FD4\56DE\7ED9\8C03\7528\5B83\7684\9875\536B\58EB\51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671636071312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\9875\536B\58EB\51FD\6570\8FD4\56DE\201C\771F\201D, \5219\7EE7\7EED\5448\73B0\9875\6216\5904\7406\9875\3002\5982\679C\7ED3\679C\4E3A\201C\5047\201D, \5219\5F15\64CE\5C06\663E\793A\9875 %0, \7531\4E8E\8BE5\9875\5728\6B64\9A8C\8BC1\65B9\6848\4E2D\6307\5B9A\4E3A\65E0\6548\4F1A\8BDD\9875, \56E0\6B64\5C06\5176\89C6\4E3A\6B64\5E94\7528\7A0B\5E8F\7684\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672039550312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\536B\58EB\51FD\6570\5C06\5E03\5C14\503C\7ED3\679C\8FD4\56DE\5230\5F15\64CE\3002\5982\679C\7ED3\679C\4E3A\201C\771F\201D, \5219\7EE7\7EED\5448\73B0\9875\6216\5904\7406\9875\3002\5982\679C\7ED3\679C\4E3A\201C\5047\201D, \5219\5F15\64CE\5C06\91CD\5B9A\5411\5230 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674637932312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\7684\5178\578B\65B9\6CD5\662F\5305\542B\4E00\4E2A\767B\5F55\8868\5355\6765\6355\83B7\7528\6237\7684\8EAB\4EFD\8BC1\660E\3002\7136\540E\6B64\9875\7684\63D0\4EA4\540E\5904\7406\5C06\8C03\7528\9A8C\8BC1\6A21\5757\6765\9A8C\8BC1\6B64\8EAB\4EFD\8BC1\660E\3002\9A8C\8BC1\5B8C\6210\540E, \6B64\9875\5C06\6267\884C\4EFB\4F55\4F1A\8BDD\6CE8\518C\548C cookie \8BBE\7F6E\4EFB\52A1\3002\6700\540E, \5B83\5C06\91CD\5B9A\5411\81F3\5E94\7528\7A0B\5E8F\7684\8D77\59CB\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674784956312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 API: \6B64\7C7B\63D0\4EA4\540E\5904\7406\53EF\4EE5\8C03\7528 wwv_flow_custom_auth_std \6765\6267\884C\521A\624D\4ECB\7ECD\7684\6240\6709\8FD9\4E9B\6B65\9AA4\3002\6709\4E24\4E2A\53EF\7528\7684\5165\53E3\70B9:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674840529312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\7528\767B\5F55\8FC7\7A0B, \4F7F\5F15\64CE\4E3A\60A8\6267\884C\6240\6709\6B65\9AA4\3002\5F15\64CE\5C06\4F7F\7528\5185\7F6E\7684\4F1A\8BDD\8868\5E76\4E3A\60A8\6267\884C\4F1A\8BDD\6CE8\518C\548C cookie \8BBE\7F6E\3002\5728\9A8C\8BC1\65B9\6848\4E2D\63D0\4F9B\7684\6240\6709\5B9A\5236\4EE3\7801\90FD\5C06\5728\9A8C\8BC1\524D, \9A8C\8BC1\8FC7\7A0B\4E2D\6216\9A8C\8BC1\540E\8FD0\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674986394312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\60A8\6B63\5728\81EA\5DF1\6267\884C\9A8C\8BC1, \4F46\5E0C\671B %0 \4E3A\60A8\5904\7406\6240\6709\7684\9A8C\8BC1\540E\4E8B\52A1, \8BF7\8C03\7528 post_login \8FC7\7A0B\3002\4F7F\7528\8FD9\4E24\4E2A\5165\53E3\70B9, \60A8\53EF\4EE5\4F7F\7528\4EFB\4F55\5185\7F6E\767B\5F55\5904\7406\6B65\9AA4, \5E76\7ED3\5408\4F7F\7528\81EA\5DF1\7684\767B\5F55\9875\4EE5\53CA\5728\8BE5\9875\4E0A\8FD0\884C\7684\4EFB\4F55\5904\7406\3002\8BF7\8BB0\4F4F, \5982\679C\4F7F\7528\5185\7F6E\9A8C\8BC1\540E\5904\7406, \8FD8\53EF\4EE5\5229\7528\5185\7F6E\9875\536B\58EB\548C\4F1A\8BDD\9A8C\8BC1\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671758207312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\7F6E\767B\5F55\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675080009312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\90E8\767B\5F55\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675895886312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL %0 \672A\5C06 %1 \5E94\7528\7A0B\5E8F\9875\6307\5B9A\4E3A\65E0\6548\7684\4F1A\8BDD\76EE\6807\3002\6B64\5916, \9A8C\8BC1\65B9\6848\4E2D\4E0D\5B58\5728\767B\5F55\5904\7406\503C\3002\6B64\9875\8D1F\8D23\6267\884C\4EE5\4E0B\6B65\9AA4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675910226312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6CE8\610F, \9664\975E\5728\6B64 URL \4E0A\8C03\7528\7684\670D\52A1\4F7F\7528 %0 wwv_custom_auth_std API \6765\5E2E\52A9\60A8\6267\884C\4F1A\8BDD\6CE8\518C\4EFB\52A1, \5426\5219\60A8\7684\5E94\7528\7A0B\5E8F\5C06\65E0\6CD5\4F7F\7528\5185\7F6E\9875\536B\58EB\6216\4F1A\8BDD\9A8C\8BC1\5904\7406\3002\60A8\5FC5\987B\6309\7167\81EA\5DF1\8BBE\8BA1\7684\65B9\5F0F\6765\6267\884C\6B64\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676234082312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL %0 \672A\5C06 %1 \5E94\7528\7A0B\5E8F\9875\6307\5B9A\4E3A\65E0\6548\4F1A\8BDD\76EE\6807\3002\6B64\9875\8D1F\8D23\6267\884C\4EE5\4E0B\6B65\9AA4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676317296312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848\4E2D\4E3A\767B\5F55\5904\7406\8BBE\7F6E\7684\503C\5982\4E0B\6240\793A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676479438312075)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\65B9\6848\4E2D\6307\5B9A\7684\767B\5F55\9875\662F\8BE5\5E94\7528\7A0B\5E8F\4E2D\7684\9875 [%0]\3002\6B64\9875\8D1F\8D23\6267\884C\4EE5\4E0B\6B65\9AA4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676575003312075)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F46\662F, \5728\9A8C\8BC1\65B9\6848\4E2D\6CA1\6709\767B\5F55\5904\7406\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676643774312075)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\6B64\9875\662F\5E94\7528\7A0B\5E8F\7684\6307\5B9A\767B\5F55\9875, \56E0\6B64\5F53\521D\6B21\663E\793A\6B64\9875\65F6\4E0D\53EF\80FD\5BF9\5176\6267\884C\67D0\4E9B\64CD\4F5C, \56E0\4E3A\5C1A\672A\8FDB\884C\7528\6237\9A8C\8BC1\3002\800C\4E14, \5F53\67D0\4E9B\4F1A\8BDD\72B6\6001\548C\4F1A\8BDD\6807\8BC6\53D8\91CF\4F4D\4E8E\5728\9A8C\8BC1\540E\5904\7406\7684\666E\901A\9875\4E0A\65F6, \5B83\4EEC\4E0D\53EF\7528\4E8E\9875\8BA1\7B97\6216\5904\7406\3002\7531\4E8E\8FD9\4E9B\539F\56E0, \5728\9A8C\8BC1\65B9\6848\4E2D\6309\9875\7801\6392\5217\7684\767B\5F55\9875\8BF4\660E\53EA\9002\7528\4E8E\5177\6709\5F88\5C11\529F\80FD\6216\6CA1\6709\529F\80FD\7684\9875 (\9664\767B\5F55\8868\5355\5904\7406\5916)\3002\5982\679C\60A8\5E0C\671B\767B\5F55\9875\7684\72B6\6001\66F4\52A0\6D3B\8DC3, \8BF7\4F7F\7528\201C\9A8C\8BC1\65B9\6848\5411\5BFC\201D\4E2D\7684\767B\5F55 URL \6307\5B9A\6216\7F16\8F91\9875\3002\53EA\8981\60A8\8BB0\4F4F\4F7F\7528\6784\5EFA\5668\4E2D\7684\9875\5C5E\6027\8868\5355\5C06\516C\5171\9875\5C5E\6027\8BBE\7F6E\4E3A ''\662F - \6B64\9875\662F\516C\5171\7684'', \5219\9875\4E2D\7684\65E5\5FD7\5C31\80FD\591F\4F7F\7528\9664\4F5C')
||unistr('\4E3A\5E94\7528\7A0B\5E8F\4E2D\767B\5F55\9875\4E4B\5916\7684\6240\6709 %0 \529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675187759312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9A8C\8BC1\65B9\6848\65E2\4E0D\6307\5B9A\767B\5F55\9875\4E5F\4E0D\6307\5B9A\7528\4F5C\65E0\6548\4F1A\8BDD\76EE\6807\7684 URL\3002\8FD9\610F\5473\7740\7531\9875\536B\58EB\51FD\6570\5904\7406\8FD9\79CD\60C5\51B5\3002\53EF\80FD\91CD\5B9A\5411\5230\4E00\6B21\767B\5165 portal, \4E5F\53EF\80FD\91CD\5B9A\5411\5230\5176\4ED6\767B\5F55\670D\52A1\5668\3002\6B64\5916, \9A8C\8BC1\65B9\6848\4E2D\4E0D\5B58\5728\767B\5F55\5904\7406\503C\3002\5982\679C\8FD9\4E0D\662F\60A8\60F3\8981\7684\7ED3\679C, \8BF7\7F16\8F91\6B64\9A8C\8BC1\65B9\6848, \5E76\63D0\4F9B\65E0\6548\4F1A\8BDD\9875\6216 URL, \7136\540E\91CD\65B0\68C0\67E5\6B64\56FE\8868\89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675269140312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9A8C\8BC1\65B9\6848\65E2\4E0D\6307\5B9A\767B\5F55\9875\4E5F\4E0D\6307\5B9A\7528\4F5C\4E3A\65E0\6548\4F1A\8BDD\76EE\6807\7684 URL\3002\8FD9\610F\5473\7740\7531\9875\536B\58EB\51FD\6570\5904\7406\8FD9\79CD\60C5\51B5\3002\53EF\80FD\91CD\5B9A\5411\5230\4E00\6B21\767B\5165 portal, \4E5F\53EF\80FD\91CD\5B9A\5411\5230\5176\4ED6\767B\5F55\670D\52A1\5668\3002\4F46\662F, \9A8C\8BC1\65B9\6848\4E2D\5B58\5728\4E3A\767B\5F55\5904\7406\8BBE\7F6E\7684\503C, \5982\4E0B\6240\793A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675342071312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL %0 \5C06 %1 \5E94\7528\7A0B\5E8F\9875\6307\5B9A\4E3A\65E0\6548\4F1A\8BDD\76EE\6807\3002\4F46\662F, \5728\9A8C\8BC1\65B9\6848\4E2D\6CA1\6709\767B\5F55\5904\7406\503C\3002\6B64\9875\8D1F\8D23\6267\884C\4EE5\4E0B\6B65\9AA4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675405640312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\4F7F %0 \5F15\64CE\80FD\663E\793A\6216\63A5\53D7\5E94\7528\7A0B\5E8F\4E2D\7684\767B\5F55\9875, \5FC5\987B\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\7684\201C\9875\5C5E\6027\201D\9875\4E0A\9009\62E9\9875\5C5E\6027 ''\662F - \6B64\9875\662F\516C\5171\7684''\3002\5982\679C\60A8\672A\6267\884C\6B64\64CD\4F5C, \5219\5F15\64CE\5C06\5C1D\8BD5\5728\663E\793A\9875\4E4B\524D\6267\884C\9875\536B\58EB\51FD\6570\3002\5982\679C\60A8\5C1A\672A\767B\5F55, \5219\5C1D\8BD5\91CD\5B9A\5411\5230\76F8\540C\7684 URL\3002\8FD9\5C06\9020\6210\6076\6027\5FAA\73AF\3002\5982\679C\60A8\7F16\5199\81EA\5DF1\7684\9875\536B\58EB\51FD\6570\4EE3\7801, \5219\9700\8981\5728\5F53\524D\9875\662F\6B64\767B\5F55\9875\65F6\8FDB\884C\8BC6\522B, \5E76\4EE5\4E0E\5176\4ED6\9875\4E0D\540C\7684\65B9\5F0F\6765\5904\7406\5B83\3002\6700\597D\53EF\4EE5\901A\8FC7\9875\7801\6765\6807\8BC6\5B83\3002\66F4\5E38\7528\7684\65B9\6CD5\662F\4F7F\7528\5E03\5C14\503C\51FD\6570 wwv_flow_custom_auth.current_page_is_public ')
||unistr('\6765\8BC6\522B\5E94\7528\7A0B\5E8F\4E2D\767B\5F55\9875\6216\4EFB\4F55\5176\4ED6\9875\7684\6B64\516C\5171\5C5E\6027\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675562175312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55 URL %0 \5C06 %1 \5E94\7528\7A0B\5E8F\9875\6307\5B9A\4E3A\65E0\6548\4F1A\8BDD\76EE\6807\3002\6B64\9875\8D1F\8D23\6267\884C\4EE5\4E0B\6B65\9AA4:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675635525312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\65B9\6848\4E2D\4E3A\767B\5F55\5904\7406\8BBE\7F6E\7684\503C\5982\4E0B\6240\793A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107675796888312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7528\6237\9A8C\8BC1\4E4B\540E, Oracle Application Server Single Sign-On Server \5C06\91CD\5B9A\5411\56DE\6B64\5E94\7528\7A0B\5E8F\3002\5728 %0 \65B9\6848\4E2D, \5165\53E3\70B9\662F wwv_flow_custom_auth_sso.process_success \8FC7\7A0B\3002%0 \6CE8\518C\4E3A Oracle Application Server Single Sign-On \5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F, \5E76\4E14\53EF\4EE5\7BA1\7406\767B\5F55\670D\52A1\5668\7684\6240\6709\63A5\53E3\3002\7136\800C, \5982\679C\60A8\559C\6B22\5728\81EA\5DF1\7684\65B9\6848\4E2D\6CE8\518C\81EA\5DF1\7684\5E94\7528\7A0B\5E8F, \4E5F\53EF\4EE5\8FD9\6837\505A\3002\60A8\65E2\53EF\4EE5\7F16\5199\81EA\5DF1\7684\9875\536B\58EB, ')
||unistr('\4E5F\53EF\4EE5\57FA\4E8E Portal-SSO \65B9\6848, \4ECE\9A8C\8BC1\65B9\6848\5E93\7B80\5355\521B\5EFA\4E00\4E2A\9A8C\8BC1\65B9\6848 (\6211\7684\5E94\7528\7A0B\5E8F\4F5C\4E3A\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F)\3002\6240\5F97\65B9\6848\5C06\8C03\7528\5185\7F6E SSO \9875\536B\58EB wwv_flow_custom_auth_std.portal_sso_sentry_v1\3002\5728\5411 Oracle Application Server Single Sign-On \6CE8\518C\65F6, \6B64\51FD\6570\8981\6C42\5F53\524D\7684\9A8C\8BC1\65B9\6848\77E5\9053\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\7684\540D\79F0\3002\201C\521B\5EFA\9A8C\8BC1\65B9\6848\5411\5BFC\201D\5C06\8981\6C42\60A8\63D0\4F9B\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\7684\540D\79F0, \6216\53EF\4EE5\5728\521B\5EFA\540E, \901A\8FC7\7F16\8F91\65B9\6848\6DFB\52A0\6216\66F4\6539\540D\79F0\3002\8F93\5165')
||unistr('\7684\540D\79F0\5FC5\987B\4E0E\6CE8\518C\7684\540D\79F0\5B8C\5168\76F8\540C (\6CE8\610F\5927\5C0F\5199)\3002\60A8\8FD8\9700\8981\7F16\5199\81EA\5DF1\7684 URLC \63A5\6536\65B9\8FC7\7A0B, \5E76\4ECE\4E2D\8C03\7528 wwv_flow_custom_auth_sso.process_success API, \4ECE\800C\5728\60A8\5411 Oracle Application Server Single Sign-On \6CE8\518C\5E94\7528\7A0B\5E8F\65F6\4F20\9012\8BE5\5E94\7528\7A0B\5E8F\7684\540D\79F0\3002\6B64\64CD\4F5C\5C06\5728\9A8C\8BC1\4E4B\540E\5411 %0 \6267\884C\4F1A\8BDD\6CE8\518C\3002\5982\679C\60A8\7F16\5199\81EA\5DF1\7684\9875\536B\58EB, \5219\53EF\4EE5\8C03\7528 wwv_flow_custom_auth_sso.portal_sso_redirect AP')
||unistr('I, \4EE5\4FBF\5728\9875\536B\58EB\786E\5B9A\9700\8981\8FDB\884C\9A8C\8BC1\65F6, \91CD\5B9A\5411\5230\767B\5F55\670D\52A1\5668\3002\60A8\5FC5\987B\5C06\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\7684\6CE8\518C\540D\79F0\4F20\9012\5230\6B64\8FC7\7A0B\3002\6709\5173\8BE6\7EC6\8D44\6599, \8BF7\53C2\9605 %0 \6587\6863\548C %1 \6587\6863\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676167585312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\540E\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107676073626312074)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\524D\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670512785312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5185\7F6E\903B\8F91, \68C0\67E5\540D\4E3A [%0] \7684 cookie\3002\5982\679C\6B64 cookie \5B58\5728\5E76\4E14\5176\89E3\7801\540E\7684\503C\4F4D\4E8E\5185\90E8\4F1A\8BDD\8868\7684\884C\4E2D, \5219\8BA4\4E3A\6B64\4F1A\8BDD\6709\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670708839312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\8FD4\56DE\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107672519829312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8EAB\4EFD\8BC1\660E\9A8C\8BC1 (\9A8C\8BC1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107674173023312073)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\9A8C\8BC1\540E\5904\7406')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667229620312068)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login \7684\5165\53E3\70B9\53C2\6570\975E\6CD5 -- p_flow_page:p_session_id:p_entry_point:%0:%1:%2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667158987312067)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login \7684 p_session_id \53C2\6570\4E3A\7A7A -- p_flow_page:%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667027010312067)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FD0\884C\9A8C\8BC1\8EAB\4EFD\8BC1\660E\68C0\67E5\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671545334312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\4F1A\8BDD\76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673237003312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \641C\7D22\57FA\7840:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673315635312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8C03\7528 DBMS_LDAP.SIMPLE_BIND_S \4E4B\524D\4F7F\7528\4E0B\9762\7684\5757\6765\8C03\7528\51FD\6570\3002\5728\767B\5F55\8868\5355\4E2D\6355\83B7\7684\7528\6237\540D\5C06\4F20\9001\5230\6B64\51FD\6570, \7136\540E\4F7F\7528\51FD\6570\8FD4\56DE\7684\503C\6765\66FF\6362 LDAP \641C\7D22\57FA\7840\4E2D\7684 %LDAP_USER% (\53C2\89C1\4E0A\6587)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673471203312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\4EE3\7801\5757\5FC5\987B\6709\6B64\7B7E\540D:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673514300312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6B64\529F\80FD\53EF\5C06\767B\5F55\8868\5355\4E2D\8F93\5165\7684\7528\6237\540D\8F6C\6362\4E3A\4E0E LDAP \76EE\5F55\6761\76EE\5339\914D\7684\4EFB\610F\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673077588312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \4E3B\673A:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673176163312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LDAP \7AEF\53E3:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670043473312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5E94\7528\7A0B\5E8F (%0) \5C06\9875 %1 \4F5C\4E3A\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670159782312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\6B21\8BF7\6C42 %0 \9875\65F6, \4E0D\518D\6267\884C\8FDB\4E00\6B65\7684\9A8C\8BC1\68C0\67E5\800C\662F\663E\793A\6216\63A5\53D7\6B64\9875\3002\8FD9\6837\53EF\4EE5\5728\6267\884C\9A8C\8BC1\524D\663E\793A\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669904258312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\9875\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670218349312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\536B\58EB\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670333176312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5185\7F6E\903B\8F91\6765\6267\884C\9875\536B\58EB\4EFB\52A1\3002\5BF9\4E8E\6BCF\4E2A\9875\8BF7\6C42, \9875\536B\58EB\51FD\6570\6267\884C\4F1A\8BDD\9A8C\8BC1\5E76\8BA1\7B97\8FD4\56DE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107673743775312072)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\540E\5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670605932312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\7528\6237\63D0\4F9B\7684\9644\52A0\4EE3\7801\6765\786E\5B9A\4F1A\8BDD\662F\5426\6709\6548\3002\4E0A\9762\7684\5185\7F6E\4F1A\8BDD\9A8C\8BC1\68C0\67E5\8FD4\56DE\4E86\201C\771F\201D\7ED3\679C\540E, \6267\884C\4EE5\4E0B\4EE3\7801\5E76\8BB0\4F4F\5B83\7684\5E03\5C14\8FD4\56DE\503C:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107670477374312070)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671836321312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Application Server Single Sign-On \670D\52A1\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107671930417312071)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'zh-cn'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107818715074312183)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557179731311982)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\4F5C\4E1A\5DF2\542F\52A8\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728021838312114)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\4E0D\652F\6301\5927\4E8E %1 MB \7684 %0 \6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108113613557312414)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684 SQL \8868\8FBE\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647490465312052)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6790 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647881555312053)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107807986845312175)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\683C\5F0F\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787511684312159)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8C03\8BD5:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787602367312159)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\7248\672C\4E0D\652F\6301\7684\529F\80FD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784777234312157)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1101 \65E0\6CD5\5904\7406\8FD4\56DE\67E5\8BE2\7684\51FD\6570\4F53\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787845765312159)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF 4323- \8BF7\6C42\5E2E\52A9\672A\63D0\4F9B\663E\793A\5E2E\52A9\7684\6570\5B57\9875 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784550589312157)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1025 \5904\7406 PLSQL \8868\8FBE\5F0F\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784683555312157)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F=%0 \9875=%1 SQLERRM=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787392417312159)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6253\5370\5FEB\6377\65B9\5F0F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784854089312157)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1108 \65E0\6CD5\5904\7406\9879\7684\5F53\524D\6761\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787439684312159)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\56FE\8868\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107937605012312275)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5448\73B0\7EC4\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107581793041312002)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\52A8\6001\5217\8868\533A\57DF\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787781474312159)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERROR 4322- \8BF7\6C42\5E2E\52A9\6240\4F7F\7528\7684\8BED\6CD5\4E0D\6B63\786E\3002\5728\8981\6C42\6709\6548\9875\7801\65F6\8BF7\6C42\4E3A\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814368331312180)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\7ED1\5B9A "%0"\3002\4E3A\591A\5B57\8282\9879\4F7F\7528\53CC\5F15\53F7, \6216\9A8C\8BC1\9879\7684\957F\5EA6\662F\5426\5C11\4E8E 30 \5B57\8282\3002\4F7F\7528 v() \8BED\6CD5\53EF\5F15\7528\957F\5EA6\8D85\8FC7 30 \5B57\8282\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352435025312606)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\4E3A\62A5\8868\5217\683C\5F0F\63A9\7801 DOWNLOAD:TABLE_NAME:BLOB_COLUMN \4E2D\7684 BLOB \5217\540D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707000012312886)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8868 %1 \4E2D\627E\4E0D\5230\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107810098734312177)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('DML \4E2D\51FA\73B0\9519\8BEF: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3\3002%4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107644077040312050)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6267\884C\63D2\5165\64CD\4F5C\3002%0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107965542352312296)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 %1 \7684\6570\5B57\503C %0 \65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650797750312055)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6B64\5BF9\8C61\7684 %0 \64CD\4F5C\65E0\6548\3002 (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351593620312606)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\6240\6709\8005\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351633481312606)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351489150312606)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\8DDF\8E2A "%2" \66F4\65B0\7684\4E0A\6B21\66F4\65B0\6570\636E\5217 "%0" \7684\6570\636E\7C7B\578B "%1" \5FC5\987B\4E3A\65E5\671F\6216\65F6\95F4\6233\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351743911312606)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF: \5FC5\987B\4ECE\5305\542B FILE \7C7B\578B\7684\9879\540D\7684\8868\5355\9875\4E2D\8C03\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352026270312606)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\683C\5F0F\63A9\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352521461312606)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\4E3A\62A5\8868\5217\683C\5F0F\63A9\7801 DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME \4E2D\7684\4E3B\952E 1 \5217\540D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108707197524312886)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\8868\6216\89C6\56FE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352359189312606)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\4E3A\62A5\8868\5217\683C\5F0F\63A9\7801 DOWNLOAD:TABLE_NAME \4E2D\7684\8868\540D...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352231686312606)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801\5FC5\987B\81F3\5C11\5305\542B 4 \4E2A\53C2\6570, \4E2D\95F4\7528\5192\53F7\5206\9694')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352114544312606)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801\5FC5\987B\4EE5 DOWNLOAD \6216 IMAGE \5F00\5934')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997693266312324)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5BF9\4E8E SQL \67E5\8BE2\65E0\6548\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642958884312049)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\5BF9 REST \6570\636E\6E90\6267\884C\6B64\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997508394312324)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \67E5\8BE2\4E2D\9009\62E9\4E86\9519\8BEF\7684\5217\6570\3002\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605\5C5E\6027\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107553011768311979)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\7684 SQL \8BED\53E5\4E2D\7684\6570\636E\7C7B\578B\9519\8BEF\3002\5217\53F7 %1 \4E3A %2, \4F46\5E94\4E3A %3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098567267312402)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5DF2\5728 SQL \67E5\8BE2\4E2D\4F7F\7528\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098490208312402)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5BF9\4E8E LOV SQL \67E5\8BE2\65E0\6548\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\6709\6548\7684\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098206870312402)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\5728 "%0" \4E2D\8FD4\56DE\4E86\67E5\8BE2\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098324532312402)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \67E5\8BE2\4E2D\9009\62E9\4E86\9519\8BEF\7684\5217\6570\3002\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605\5C5E\6027\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552544961311978)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301 REST \6570\636E\6E90\7C7B\578B %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107554449786311980)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\540D\91CD\590D\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746856464312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746643059312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E38\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746360897312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747427913312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\952E\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747391406312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\4F53\5316\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746971625312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A0B\5E8F\5305')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746738049312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746287872312916)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747078457312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747100794312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747522374312918)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746426372312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108746502262312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D8\91CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108747201522312917)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311444737312574)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BF9 LOV SQL \67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108076280618312384)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\7684\67E5\8BE2\8FC7\6EE4\5668\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312373699312575)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5DF2\5728 LOV SQL \67E5\8BE2\4E2D\4F7F\7528\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312201199312575)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5BF9\4E8E LOV SQL \67E5\8BE2\65E0\6548\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\6709\6548\7684\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311311535312574)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 LOV SQL \67E5\8BE2\4E2D\9009\62E9\4E86\9519\8BEF\7684\5217\6570\3002\8BF7\53C2\9605\793A\4F8B\4EE5\4E86\89E3\6709\6548\7684\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650561933312055)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\5668\5728\8BD5\56FE\5220\9664\6587\4EF6 "%0" \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650620187312055)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\6587\4EF6 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650382444312054)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5199\5165\7269\7406\6587\4EF6\76EE\5F55 "%0" \65F6\51FA\9519\3002(%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785812647312158)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8D85\51FA\975E\5185\90E8\5DE5\4F5C\533A\6587\4EF6\7684\6700\5927\5927\5C0F\9650\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650420271312055)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8981\5199\5165\7684 ID \4E3A %0 \7684\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107785717412312158)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8D85\51FA\6240\6709\5DE5\4F5C\533A\6587\4EF6\7684\6700\5927\5927\5C0F\9650\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107819049909312183)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\5F00\53D1\8005\89D2\8272\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695022709312089)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\4EE5\4E0B\539F\56E0\800C\672A\521B\5EFA\7528\6237: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108359614251312612)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \662F\65E0\6548\7684\7535\5B50\90AE\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812786640312179)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26 js \91CD\5B9A\5411\7684\201C\9009\62E9\5217\8868\201D\7C7B\578B\7684\9879%0\6CA1\6709\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812682444312179)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\9009\62E9\5217\8868\201D\7C7B\578B\7684\9879%0\6CA1\6709\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812853350312179)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26 URL \91CD\5B9A\5411\7684\201C\9009\62E9\5217\8868\201D\7C7B\578B\7684\9879%0\6CA1\6709\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812957345312179)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6307\5411\9875\7684 URL \91CD\5B9A\5411\7684\201C\9009\62E9\5217\8868\201D\7C7B\578B\7684\9879%0\6CA1\6709\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787262181312159)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\9879 %0 - %1, \5E8F\5217: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784371924312157)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1904 \65E0\6CD5\8BA1\7B97\9879\9ED8\8BA4\503C: \7C7B\578B = \51FD\6570\4F53 computation_type= %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784292639312156)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1020 PLSQL \9879\5904\7406 (\51FD\6570) \4E2D\51FA\73B0\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784415930312157)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62FC\5199\68C0\67E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787149966312159)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06\503C "%0" \8F6C\6362\4E3A\65E5\671F\683C\5F0F\63A9\7801 %1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552216844311978)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528 REST \7684 SQL \6216 REST \6570\636E\6E90\4E0D\652F\6301 BLOB \6570\636E\7C7B\578B\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552457835311978)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\63D0\53D6\533A\57DF ID %s \7684\5143\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108032431163312349)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\8868\5355 DML \5904\7406\6216\521D\59CB\5316\5904\7406\5206\914D\8868\5355\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038109727312353)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\65E7\8868\5355\9875\8FC1\79FB\5230\8868\5355\533A\57DF\65F6\51FA\9519\FF1A\65E0\6CD5\63CF\8FF0 DML \5904\7406\4E2D\5F15\7528\7684\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107769324939312145)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E22\5931\7684\66F4\65B0\68C0\6D4B\672A\627E\5230\6821\9A8C\548C\3002\53EA\80FD\5BF9\73B0\6709\884C\6267\884C UPDATE \6216 DELETE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108338768941312596)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\9488\5BF9\542F\7528\4E86\540C\6B65\7684 REST \6E90\6267\884C\8868\5355 DML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552112233311978)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\8868\5355\533A\57DF %0 \5B9A\4E49\4E3B\952E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107552336374311978)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 %0 \5177\6709\9519\8BEF\7684\6570\636E\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107720310202312108)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6240\9009\7684 %0 \4E2D\5B58\5728\57DF\7D22\5F15\3002\201C\751F\6210 DDL\201D\65E0\6CD5\751F\6210\57DF\7D22\5F15\7684 DDL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658897157312061)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Rem \65E0\6CD5\751F\6210 %0 %1 \7684 DDL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107689501340312084)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\751F\6210 DDL \7684 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659017377312061)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Save_ddl \9519\8BEF %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107646696391312052)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06 DDL \4FDD\5B58\4E3A\811A\672C\6587\4EF6\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658956402312061)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9 DDL \811A\672C\8FDB\884C\8BED\6CD5\5206\6790\65F6\51FA\9519\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813099805312179)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF, \5305\540D %0 \65E0\6548\6216\5DF2\88AB\4F7F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794151280312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \5E94\7528\7A0B\5E8F %0 \7684\8868 API, \751F\6210\65F6\95F4 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792821309312163)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7528\4EE5\4E0B\8FC7\7A0B\521B\5EFA PL/SQL \5305 %0:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793730353312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\5C06\6570\636E\63D2\5165 %0, \9700\8981\63D0\4F9B\4E3B\952E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793848210312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\66F4\65B0\7531\4E3B\952E\6807\8BC6\7684 %0 \4E2D\7684\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793907794312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\57FA\4E8E\4E3B\952E\5220\9664 %0 \4E2D\7684\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107794063921312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\57FA\4E8E\4E3B\952E\68C0\7D22%0\4E2D\7684\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793654256312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793493864312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D\6B63\6587')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793306233312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793277399312163)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793074096312163)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866839482312221)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \7A0B\5E8F\5305\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866908179312221)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \7A0B\5E8F\5305\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793139510312163)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792949738312163)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107793558869312164)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B50\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866378369312220)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \4E3A\8868 "%0" \521B\5EFA\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866555739312220)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \4E3A\8868 "%0" \5220\9664\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866606840312220)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \4E3A\8868 "%0" \83B7\53D6\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866783531312220)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \4E3A\8868 "%0" \6784\5EFA MD5 \51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107866442363312220)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('-- \4E3A\8868 "%0" \66F4\65B0\8FC7\7A0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813126725312179)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350877551312605)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\5B9A\4E49\5DE5\4F5C\533A\7684\6E90\6807\8BC6\7B26!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108350970966312605)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\90E8\7F72\7CFB\7EDF!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691152799312086)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7EC4\4EF6 <strong>%0</strong> \65E0\6CD5\5728<strong>\5217 %1</strong> \4E2D\5448\73B0, \56E0\4E3A\8BE5\5217\4E2D\5DF2\5B58\5728\5176\4ED6\7EC4\4EF6\3002</p>'),
unistr('<p>\901A\5E38, \5C06\201C\5217\201D\8BBE\7F6E\4E3A<strong>\81EA\52A8</strong>\5C06\4FEE\590D\6B64\95EE\9898\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108795434775312961)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\65E0\6CD5\5448\73B0\9875\9879 <strong>%0</strong> \7684\6807\7B7E, \56E0\4E3A\6B64\9875\9879\7684\6807\7B7E\5217\8DE8\8DDD\7F51\683C\8BBE\7F6E\65E0\6548\3002\8BE5\9879\8BBE\7F6E\4E3A\4F7F\7528<strong>\6807\7B7E\5217\8DE8\8DDD %1</strong> \663E\793A\3002\4E0D\652F\6301\6B64\8BBE\7F6E, \56E0\4E3A\9875\9879\81EA\8EAB\4EC5\5177\6709 <strong>%2 \4E2A\53EF\7528\5217</strong>\3002</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690989472312085)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65E0\6CD5\5448\73B0\7EC4\4EF6 <strong>%0</strong>, \56E0\4E3A\6B64\7EC4\4EF6\7684\7F51\683C\8BBE\7F6E\65E0\6548\3002\8BE5\7EC4\4EF6\8BBE\7F6E\4E3A\5728<strong>\5217 %1</strong> \4E2D\663E\793A, <span>\5217\8DE8\8DDD\4E3A %2</strong>\3002\4E0D\652F\6301\6B64\8BBE\7F6E, \56E0\4E3A\6B64\9875\4E0A\7684\7F51\683C\4EC5\6700\591A\652F\6301 <strong>%3 \5217</strong>\3002</p>'),
unistr('<p>\901A\5E38, \9488\5BF9\6240\6709\7EC4\4EF6\5C06\201C\5217\201D\548C\201C\5217\8DE8\8DDD\201D\8BBE\7F6E\4E3A<strong>\81EA\52A8</strong>\5C06\4FEE\590D\6B64\95EE\9898\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107691008641312085)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65E0\6CD5\5448\73B0\7EC4\4EF6 <strong>%0</strong>, \56E0\4E3A\6B64\7EC4\4EF6\7684\7F51\683C\8BBE\7F6E\65E0\6548\3002\8BE5\7EC4\4EF6\8BBE\7F6E\4E3A\5728<strong>\5217 %1</strong> \4E2D\663E\793A, <strong>\5217\8DE8\8DDD\4E3A %2</strong>\3002\4E0D\652F\6301\6B64\8BBE\7F6E, \56E0\4E3A\6B64\9875\4E0A\7684\7F51\683C\4EC5\652F\6301 <strong>%3 \5217</strong>\3002</p>'),
unistr('<p>\901A\5E38, \9488\5BF9\6240\6709\7EC4\4EF6\5C06\201C\5217\201D\548C\201C\5217\8DE8\8DDD\201D\8BBE\7F6E\4E3A<strong>\81EA\52A8</strong>\5C06\4FEE\590D\6B64\95EE\9898\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573143970311994)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2 \5929 DBA \901F\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107573074209311994)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2 \5929\901F\6210\548C\5F00\53D1\8005\6307\5357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539401079311968)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7BA1\7406\6307\5357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539597521311968)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('API \53C2\8003')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115372644312415)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108109329159312410)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115429674312415)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107572974025311994)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6784\5EFA\5668\7528\6237\6307\5357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221325418312499)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\6B21\521B\5EFA\7D22\5F15\53EF\80FD\4F1A\6301\7EED\51E0\79D2\949F\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539623555311968)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8FC1\79FB\6307\5357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115101220312415)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6587\6863\6620\5C04\6587\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108115559400312415)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107539715484311968)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SQL \5DE5\4F5C\5BA4\548C\5B9E\7528\7A0B\5E8F\6307\5357')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822266594312187)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\89C4\8303\5316\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107998438894312324)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\8981\5BFC\5165\7684\65B9\6848\7684\8BBF\95EE\6743\9650\3002\5BFC\5165\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822113142312186)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6CA1\6709 p_table_id \7684\60C5\51B5\4E0B\8C03\7528 remove_table_hint, \5FC5\987B\63D0\4F9B\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107727949761312114)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5B89\88C5\5DE5\4F5C\533A\65F6\9047\5230\53E6\4E00\4E2A create_company \8C03\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690789583312085)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GET_BLOCK \9519\8BEF\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690663992312085)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GET_STMT \9519\8BEF\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690833190312085)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\627E\5230\6587\4EF6\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556965650311982)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Zip \5F52\6863\6587\4EF6\65E0\6548\FF0C\672A\627E\5230\5B89\88C5\6E05\5355\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694235503312088)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5BF9 %0 \65B9\6848\6CA1\6709\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107690573058312085)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\672A\6210\529F\6267\884C\8BED\53E5\3002 %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107730528231312116)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5BFC\51FA\6587\4EF6\4E2D\7684\5927\5757\5185\68C0\6D4B\5230 remove_page \8FC7\7A0B\7684 API \8C03\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991810934312316)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9879\4E0D\5B58\5728\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608669917312023)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E Application Express \6587\4EF6\4E0D\662F\6700\65B0\7684, \60A8\7684\73AF\5883\5B58\5728\95EE\9898! \5DF2\52A0\8F7D #LOADED_VERSION# \7248\672C\7684\6587\4EF6, \4F46\9884\671F\52A0\8F7D %0\3002\8BF7\786E\8BA4\60A8\5DF2\6309\7167\5B89\88C5\6307\5357\4E2D\7684\8BF4\660E\5C06\56FE\50CF\76EE\5F55\590D\5236\5230\5E94\7528\7A0B\5E8F\670D\52A1\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608504886312023)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E Application Express \6587\4EF6\5C1A\672A\52A0\8F7D, \60A8\7684\73AF\5883\5B58\5728\95EE\9898\3002\8BF7\786E\8BA4\60A8\5DF2\6309\7167\5B89\88C5\6307\5357\4E2D\7684\8BF4\660E\5C06\56FE\50CF\76EE\5F55\590D\5236\5230\5E94\7528\7A0B\5E8F\670D\52A1\5668\3002\53E6\5916, \8BF7\786E\8BA4\56FE\50CF\524D\7F00\8DEF\5F84\6B63\786E\3002\5F53\524D\8DEF\5F84\4E3A %0 (\5B83\5E94\540C\65F6\5305\542B\5F00\59CB\6B63\659C\6760\548C\7ED3\675F\6B63\659C\6760, \4F8B\5982\9ED8\8BA4\7684 /i/)\3002\5982\679C\60A8\9700\8981\66F4\6539\5B83, \8BF7\4F7F\7528 SQL \811A\672C reset_image_prefix.sql\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812166928312178)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\672A\6388\6743\7684\60C5\51B5\4E0B\5C1D\8BD5\901A\8FC7\65B9\6848 %1 \5728\5E94\7528\7A0B\5E8F %2 \4E2D\8FD0\884C\4F5C\4E1A %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822788430312187)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\96C6\5408: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822386307312187)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822432462312187)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E\6570\636E\7C7B\578B\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822625165312187)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\6570\636E\7C7B\578B\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822599698312187)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\6700\5927\5217\957F\5EA6\9519\8BEF 1: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108010461325312333)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\63D2\5165\8D85\8FC7 32KB \6570\636E\7684\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822881540312187)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \5BF9 %1 \65B9\6848\4E0D\5177\6709\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813874098312180)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\9875\5206\652F\6761\4EF6\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813795373312179)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\9875\6309\94AE\6761\4EF6\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813580663312179)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\5E94\7528\7A0B\5E8F\8BA1\7B97\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813485959312179)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5728\53EA\63D0\4F9B\6761\4EF6\7C7B\578B\65F6\66F4\65B0\5E94\7528\7A0B\5E8F\5904\7406\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814247571312180)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\62FC\9519\7684\5355\8BCD\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813349216312179)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\5BFC\822A\680F\663E\793A\6761\4EF6\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813946571312180)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\9875\8BA1\7B97\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814124905312180)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\9875\5904\7406\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813602899312179)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\9875\5B50\6807\9898\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814059154312180)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\9875\9A8C\8BC1\7C7B\578B\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108360762290312613)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0: \5982\679C "\5EF6\8FDF\52A0\8F7D" \8BBE\7F6E\4E3A\201C\662F\201D, \5219\53EA\80FD\4F7F\7528 "\7EA7\8054 LOV \7236\9879"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351998762312606)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF: \6BCF\9875\6700\591A\53EA\80FD\58F0\660E\4E00\4E2A DML \5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351870077312606)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF: \6CA1\6709\627E\5230\9875%0\7684\76F8\5E94 DML \5904\7406')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108352977005312607)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5FC5\987B\5305\542B\4F5C\4E3A\6E90\7684\6709\6548 BLOB \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313619289312576)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A\9879%0\6307\5B9A\53D1\51FA HTML \7684 PL/SQL \4EE3\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823701658312188)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6210\6279\6536\96C6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823463802312188)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\68C0\67E5\662F\5426\5DF2\5BF9\4EE3\7801\8FDB\884C\8BED\6CD5\5206\6790: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823559446312188)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FD0\884C\63A7\5236\6587\4EF6: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824224423312188)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\68C0\67E5\63A7\5236\6587\4EF6\7EDF\8BA1\4FE1\606F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824105246312188)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\5DF2\7ECF\8FC7\8BED\6CD5\5206\6790\7684\4FE1\606F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824000078312188)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6210\529F\6267\884C\8BED\53E5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107822932384312187)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\627E\5230\6587\4EF6\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823175438312187)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\8BED\53E5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789265235312160)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %2 \7684\884C\957F\5EA6 %0 \8D85\51FA\4E86\6700\5927\503C %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823921453312188)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \521B\5EFA\7684\5305\4F53\5E26\6709\7F16\8BD1\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823617437312188)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FD0\884C\4EE3\7801: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823882879312188)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FD0\884C\8BED\53E5: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823245936312187)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06\53C2\6570\4FDD\5B58\5230\6570\636E\5E93: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823043547312187)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\4EE3\7801\5757: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107823388969312187)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\9A8C\8BC1\6587\4EF6 "%0"\3002%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824389496312188)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BF9\6587\4EF6\8FDB\884C\8BED\6CD5\5206\6790\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206764314312488)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\63D2\4EF6%0\5B9A\4E49\9A8C\8BC1\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206841132312488)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\63D2\4EF6%0\5B9A\4E49\6CE8\9500\540E\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108206673725312488)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\63D2\4EF6%0\5B9A\4E49\4F1A\8BDD\536B\58EB\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759962229312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759163513312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\52A8\6001\64CD\4F5C\5B9A\4E49')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758849725312926)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759097279312926)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5B9A\5411\5230 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108758992049312926)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759553573312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\9AD8\901F\7F13\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311522237312574)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('LOV \67E5\8BE2\65E0\6548, \9700\8981\663E\793A\503C\548C\8FD4\56DE\503C, \5E76\4E14\5217\540D\4E0D\80FD\76F8\540C\3002\5982\679C\67E5\8BE2\5305\542B\5185\5D4C\67E5\8BE2, \5219 SQL \8BED\53E5\4E2D\7684\7B2C\4E00\4E2A FROM \5B50\53E5\4E0D\80FD\5C5E\4E8E\8BE5\5185\5D4C\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313271922312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BF9\533A\57DF\6E90\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694341338312088)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BF9 SQL \67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790! %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108782863562312952)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311603300312574)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9759\6001 LOV \65E0\6548, \9700\8981\663E\793A\503C\548C\8FD4\56DE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108247209196312520)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868, \89C6\56FE\6216\540C\4E49\8BCD\4E0D\5B58\5728!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107693893823312088)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311979226312574)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A\6B64\201C\663E\793A\4E3A\201D\7C7B\578B\7684\9879\6307\5B9A\503C\5217\8868 (LOV) \67E5\8BE2\6216\547D\540D\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311811750312574)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3\5C11\9700\8981\4E24\4E2A LOV \5217\7684\9879\7C7B\578B\624D\652F\6301\4F7F\7528\547D\540D\7684\503C\5217\8868 (LOV)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694543251312088)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\6574\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107694424327312088)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5FC5\987B\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759244195312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620173848312032)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7684\6570\636E\7C7B\578B\9519\8BEF\3002\6B64\5C5E\6027\8981\6C42\5217\4E3A\4EE5\4E0B\6570\636E\7C7B\578B\4E4B\4E00: %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107608434617312023)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4E0D\5B58\5728\6216\533A\57DF\6E90\67E5\8BE2\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620218183312032)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7C7B\578B\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312865318312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A\6B64\533A\57DF\7C7B\578B\7684\533A\57DF\6307\5B9A\533A\57DF\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312914971312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5DF2\5728\533A\57DF\6E90\67E5\8BE2\4E2D\4F7F\7528\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313074376312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5BF9\4E8E\533A\57DF\6E90\67E5\8BE2\65E0\6548\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313130360312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\533A\57DF\6E90\67E5\8BE2\4E2D\9009\62E9\4E86\9519\8BEF\7684\5217\6570\3002\8BF7\53C2\9605\793A\4F8B\4EE5\4E86\89E3\6709\6548\7684\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759461464312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759382475312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\6B64\9875\7684\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759603803312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\8FD9\4E9B\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312516260312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5DF2\5728 SQL \67E5\8BE2\4E2D\4F7F\7528\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108312413515312575)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\540D "%0" \5BF9\4E8E SQL \67E5\8BE2\65E0\6548\3002\8BF7\786E\4FDD\5BF9\5217\4F7F\7528\552F\4E00\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107695459507312089)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \67E5\8BE2\4E2D\9009\62E9\4E86\9519\8BEF\7684\5217\6570\3002\6709\5173\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605\5C5E\6027\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108311784354312574)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81F3\5C11\9700\8981\4E24\4E2A LOV \5217\7684\9879\7C7B\578B\624D\652F\6301\9759\6001\503C\5217\8868 (LOV)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759853328312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('URL \76EE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108759707946312927)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\8FD9\4E9B\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814446091312180)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1711 \65E0\6CD5\8F6C\6362\8BF7\6C42\4E2D\7684\5F39\51FA\5F0F lov ID\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814560916312180)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1721 \5728\8BF7\6C42\4E2D\672A\627E\5230\5F39\51FA\5F0F lov ID \7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107588320813312007)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\6307\5B9A\7684 URL \4E0D\6B63\786E\6216\9700\8981\6307\5B9A\4EE3\7406 URL, \65E0\6CD5\8BBF\95EE\6253\5370\5F15\64CE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492975251312719)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4EE5\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493313701312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\4EE5\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493466894312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493064100312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\5DE6\4FA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492665849312719)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868\641C\7D22\680F\53F3\4FA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493129244312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\53F3\4FA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493270400312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492740041312719)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108492813585312719)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\7684\9876\90E8\548C\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493574785312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7709\4E4B\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493603936312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\811A\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716168272312893)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\7EC4\4EF6! \5B83\53EF\80FD\5DF2\88AB\5176\4ED6\7528\6237\5220\9664\3002\8BF7\91CD\65B0\52A0\8F7D\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716050838312893)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\7EC4\4EF6 ''%0'' \5F15\7528\4E86\6B64\7EC4\4EF6, \56E0\6B64\65E0\6CD5\5220\9664!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108715907420312893)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\7B2C %1 \9875\4E0A\7684\7EC4\4EF6 ''%0'' \5F15\7528\4E86\6B64\7EC4\4EF6, \56E0\6B64\65E0\6CD5\5220\9664!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716254513312893)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027\5DF2\88AB\5176\4ED6\7528\6237\66F4\6539! \8BF7\91CD\65B0\52A0\8F7D\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716448835312893)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C5E\6027\5728\6B64\4E0A\4E0B\6587\4E2D\4E0D\53EF\7528!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108716303264312893)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\4EF6\5DF2\88AB\5176\4ED6\7528\6237\66F4\6539, \6B64\5C5E\6027\4E0D\518D\5B58\5728! \8BF7\91CD\65B0\52A0\8F7D\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210695698312491)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\5728 "%0" \4E2D\8FD4\56DE\4E86\67E5\8BE2\7ED3\679C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803271056312967)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\5BF9 "%0" \4E2D\7684\8FD4\56DE\67E5\8BE2\7ED3\679C\8FDB\884C\8BED\6CD5\5206\6790\3002\5982\679C\60A8\8BA4\4E3A\67E5\8BE2\7684\8BED\6CD5\6B63\786E, \8BF7\9009\4E2D\4E0B\9762\7684 "\4F7F\7528\4E00\822C\5217\540D" \590D\9009\6846, \4EE5\5728\4E0D\8FDB\884C\8BED\6CD5\5206\6790\7684\60C5\51B5\4E0B\7EE7\7EED\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108754612369312923)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\662F\552F\4E00\7684!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493798577312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6A21\677F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108210595469312491)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \5757\5C1A\672A\8FD4\56DE\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108803301785312968)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('pl/sql \5757\672A\8FD4\56DE\4EFB\4F55\67E5\8BE2\3002\5982\679C\60A8\8BA4\4E3A\4EE3\7801\7684\8BED\6CD5\6B63\786E, \8BF7\9009\4E2D\4E0B\9762\7684 "\4F7F\7528\4E00\822C\5217\540D" \590D\9009\6846, \4EE5\5728\4E0D\8FDB\884C\8BED\6CD5\5206\6790\7684\60C5\51B5\4E0B\7EE7\7EED\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493906403312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9762\88AB\5176\4ED6\7528\6237\9501\5B9A!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108493897464312720)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5F53\524D\7531 %0 \9501\5B9A! \65E0\6CD5\4FDD\5B58\4EFB\4F55\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108100826361312404)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64 %0 \7684\65B9\6848\5DF2\4E0D\5B58\5728, \56E0\6B64\65E0\6CD5\6269\5C55\8868\7A7A\95F4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814693656312180)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('drop_tablespace \9519\8BEF, p_name \4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814800966312180)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('drop_user \6CA1\6709 l_username, \56E0\6B64\51FA\73B0\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108810208416312973)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\5BC6 Wallet \672A\6253\5F00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107613494360312026)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F20\9012\7ED9 wwv_flow_provision.create_user \7684\5BC6\7801\5B57\7B26\4E32\975E\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815457481312181)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('remove_provisioned_company \4E2D\51FA\73B0\9519\8BEF\3002\5DE5\4F5C\533A\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815259366312181)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\8868\7A7A\95F4\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815178817312180)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\7528\6237\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814761347312180)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\8868\7A7A\95F4\3002\9519\8BEF: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107814964507312180)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5220\9664\7528\6237\3002\9519\8BEF: %0 \005Cnsql:\005Cn %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815374803312181)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6388\4E88\521D\59CB\6743\9650\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107579653080312000)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\65F6\65E0\6CD5\521B\5EFA\8868\7A7A\95F4\3002\8BF7\7A0D\540E\91CD\8BD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815066755312180)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658089043312060)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 "MAKE_REQUEST" \9636\6BB5\81EA\52A8\9884\914D\5931\8D25')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677603151312075)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\786E\5B9A\6307\5B9A\5DE5\4F5C\533A ID = "%0"'),
unistr('\7684\5B89\5168\7EC4 ID')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658368248312061)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A %0 \662F\4FDD\7559\540D\79F0, \8BF7\6C42\88AB\62D2\7EDD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658178842312060)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\7528\6237\6DFB\52A0\5230\5DE5\4F5C\533A %0 \65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107815713616312181)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797574561312167)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1A\672A\5B9E\65BD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657860820312060)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5DE5\4F5C\533A ID \4E3A %0 \7684\5DE5\4F5C\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657983916312060)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A\5DE5\4F5C\533A ID: %0 \7684\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677774380312076)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528\6B64\8BBE\5907\5220\9664\5DE5\4F5C\533A\7684\6700\540E\4E00\4E2A\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658787866312061)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\8BF7\6C42 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658590834312061)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\5904\7406\8BF7\6C42 %0\3002  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658209450312061)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8BF7\6C42\5DF2\7ECF\5904\7406\6216\6B63\5728\5904\7406\3002 \72B6\6001\5FC5\987B\7B49\4E8E "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107678063527312076)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5DE5\4F5C\533A %1 \4E2D\4E0D\5B58\5728\7528\6237\540D %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677903972312076)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5141\8BB8\91CD\7F6E\4E0E\5DE5\4F5C\533A\4E0D\5173\8054\7684\65B9\6848\7684\5BC6\7801\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107677800775312076)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\91CD\7F6E\65B9\6848 %0 \7684\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658674897312061)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\5904\7406\8BF7\6C42 %0, \56E0\4E3A %2 \8868\4E2D\5B58\5728\65B9\6848 %1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107658430709312061)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848\540D %0 \662F\4FDD\7559\65B9\6848, \4E0D\80FD\9884\914D\6B64\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107657705012312060)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \6CA1\6709 %1 \65B9\6848\7684\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617725284312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620570866312032)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6790')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603423372312019)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\6570\636E\5E93\5E10\6237\8EAB\4EFD\8BC1\660E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107634547573312042)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6B64\5E94\7528\7A0B\5E8F\4E2D\4F7F\7528\5185\90E8 %0 \5E10\6237\8EAB\4EFD\8BC1\660E\548C\767B\5F55\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108313879761312576)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 Oracle Application Server Single Sign-On\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617867736312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617688024312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619806112312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6E05\9664\9AD8\901F\7F13\5B58\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697422241312879)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107647977247312053)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5206\6790\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666109981312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6309\94AE\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666939631312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\56FE\8868\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665588840312066)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667382971312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\4E3B\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666718489312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\63D2\5165\8868\5355\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665779775312066)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6807\7B7E\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667461126312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5217\8868\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667519172312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5217\8868\9879\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665464802312066)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5217\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666596968312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\9762\5305\5C51\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666007418312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\9762\5305\5C51\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667965061312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6A21\5757\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666442737312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5BFC\822A\680F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618019850312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620793517312032)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665693289312066)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\9875\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665974908312066)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\533A\57DF\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666682903312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\62A5\8868\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107665893789312066)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\62A5\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667637418312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6210\529F\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666368284312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6807\51C6\9009\9879\5361\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666872737312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\66F4\65B0\8868\5355\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619730778312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\8868\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697606091312879)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\662F\6709\6548\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667786135312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5B9A\4E49\7528\4E8E\521B\5EFA\5E94\7528\7A0B\5E8F\7684\9ED8\8BA4\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107622231486312033)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\663E\793A\9875\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619201400312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\663E\793A\67D0\9875\7684\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619572931312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617960703312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618776598312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165\53E6\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620069932312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5411 %0 \63D2\5165\4E00\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618620748312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6210\529F\63D2\5165\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108081800761312388)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618429825312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018090624312339)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\65F6\95F4\6233\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619487808312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \9762\5305\5C51')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618329432312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5FC5\987B\6709\67D0\4E9B\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697591892312879)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107666278525312067)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107620694774312032)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\544A\548C\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619699772312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\663E\793A\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619908833312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\91CD\7F6E\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618932721312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\4E3B\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619391062312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617485446312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734535719312908)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\6240\6709\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733749473312907)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108733524303312907)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\5C0F\7EC4\5F00\53D1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108734295432312907)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107617594007312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\663E\793A\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107621995468312033)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\663E\793A\9762\5305\5C51\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107619064571312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618528667312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108697729998312879)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\662F\6709\6548\65F6\95F4\6233\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618232951312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618159671312030)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107667829517312068)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\80FD\6784\5EFA\4F7F\7528\4E00\7EA7\9009\9879\5361\7684\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107618817668312031)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648914712312053)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649007208312053)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\652F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107813291547312179)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107639293675312046)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5D4C\5957\5217\8868\4EC5\652F\6301 "\5BA2\6237\7AEF" \641C\7D22\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801314068312170)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\610F\5916\9519\8BEF %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107784952974312157)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \672A\627E\5230\6811\6839\8282\70B9 ID "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997261219312323)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDC\7A0B SQL \5904\7406\671F\95F4\5F15\53D1\4E86 PLSQL \4EE3\7801\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107557289689311982)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\5361\7247\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108139044332312434)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5B9E\4F8B\542F\7528 RESTful \8BBF\95EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137309653312433)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\8BE5\533A\57DF, \6216\8005\8BE5\533A\57DF\672A\542F\7528 REST\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108137441184312433)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6307\5B9A\8F93\51FA\65B9\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107787958797312159)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\662F\5FC5\9700\7684\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788023141312159)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\662F\5FC5\9700\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788188020312159)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\7528\6237\540D "%0" \6216\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017479492312338)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D2\5165 %0 \4E2A\65B0\5C5E\6027, \53EF\80FD\9700\8981\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017557443312338)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6E05\9664 %0 \4E2A\5C5E\6027, \4E0D\518D\9700\8981\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649819417312054)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79CD\5B50\5220\9664\9519\8BEF: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649770438312054)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79CD\5B50\63D2\5165\9519\8BEF: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017616139312338)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5171\6709 %0 \4E2A\5C5E\6027\53EF\80FD\9700\8981\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649606527312054)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5E94\7528\7A0B\5E8F %1 \7684 %0 \7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108017350042312338)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0 %0 \4E2A\73B0\6709\5C5E\6027, \53EF\80FD\9700\8981\7FFB\8BD1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824485280312188)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108087888435312394)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2D\65E0\7D22\5F15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018541184312339)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\6570\636E\5DF2\9644\52A0 <b id="incompl_success_row_count"></b> \4E2A\65B0\6587\6863\3002\5DF2\62D2\7EDD <b class="u-danger-text" id="incompl_fail_row_count"></b> \4E2A\6587\6863\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018360243312339)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\6570\636E\5DF2\9644\52A0 <b id="success_row_count"></b> \4E2A\65B0\6587\6863\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556361178311981)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018706171312339)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556517459311981)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556211721311981)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\952E\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556681331311981)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\6B21\4FEE\6539\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107556493132311981)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECB\8D28\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561661898311985)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6307\5357\4E0D\53EF\7528\3002\96C6\5408\4E0D\542B\4EFB\4F55\6570\636E\6216\5C1A\672A\521B\5EFA\4EFB\4F55 JSON \641C\7D22\7D22\5F15\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555525659311981)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D JSON\3001TXT \6216 ZIP \6587\4EF6\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107561710357311985)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408\5143\6570\636E\4E0D\53EF\7528\3002\8BF7\68C0\67E5\96C6\5408\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018679962312339)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\6570\636E\88AB <b id="incompl_success_row_count"></b> \4E2A\65B0\6587\6863\66FF\6362\3002\5DF2\62D2\7EDD <b class="u-danger-text" id="incompl_fail_row_count"></b> \4E2A\6587\6863\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018417194312339)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408 <code>%0</code> \4E2D\7684\6570\636E\88AB <b id="success_row_count"></b> \4E2A\65B0\6587\6863\66FF\6362\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802214175312171)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\8F74\95F4\9694\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802099980312170)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201C\8F74\6700\5927\503C\201D\5FC5\987B\5927\4E8E\201C\8F74\6700\5C0F\503C\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802475052312171)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201C\8F74\6700\5927\503C\201D\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802300640312171)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201C\8F74\6700\5C0F\503C\201D\5FC5\987B\5927\4E8E\6216\7B49\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802184302312171)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25: \6761\5BBD\5EA6\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801700876312170)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803758305312172)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803520630312172)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570: \65E0\6CD5\5728\5E94\7528\7A0B\5E8F\6784\5EFA\5668\5185\5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802688979312171)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201C\6761\95F4\8DDD\201D \5FC5\987B\5927\4E8E\6216\7B49\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801895429312170)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25: \8981\663E\793A\7684\6700\5927\884C\6570\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107804022432312172)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\66F4\591A\6570\636E, \4F46\662F\663E\793A\7684\503C\4E0D\80FD\8D85\8FC7 30 \4E2A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803677330312172)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\9519\8BEF: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803971243312172)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SVG \56FE\8868\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803825815312172)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA1\7B97\56FE\5F62\5360\6709\8005\4F4D\7F6E: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803428194312172)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\989C\8272: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802829250312171)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25: X \8F74\95F4\9694\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803273898312171)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201CX \8F74\6700\5927\503C\201D\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803060965312171)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201CX \8F74\6700\5C0F\503C\201D\5FC5\987B\5927\4E8E\6216\7B49\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802961066312171)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25: Y \8F74\95F4\9694\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107802767240312171)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201CY \8F74\6700\5927\503C\201D\5FC5\987B\5927\4E8E\8F74\6700\5C0F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803360225312171)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201CY \8F74\6700\5927\503C\201D\5FC5\987B\5927\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107803164161312171)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25:\201CY \8F74\6700\5C0F\503C\201D\5FC5\987B\5927\4E8E\6216\7B49\4E8E\96F6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107799928693312169)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6210\5458\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604163806312019)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\963B\585E %0 \547D\4EE4\3002\65E0\6CD5\4ECE SQL \5DE5\4F5C\5BA4\8FD0\884C\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796873183312166)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \5BF9 %1 \65B9\6848\4E0D\5177\6709\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616874800312029)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\6848 %0 \5BF9\8868\6216\89C6\56FE %1 \4E0D\5177\6709\9009\62E9\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800197066312169)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\811A\672C\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107796966825312166)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\8BA1\5212\8868, \4EE5\4FBF\4E8E\89E3\91CA\8BA1\5212\8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797481406312167)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\811A\672C\6587\4EF6\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797051117312166)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7B2C %0 \884C\51FA\9519: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797224978312167)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\811A\672C\63D2\5165\6587\4EF6\8868\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108745345058312916)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\884C ID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797399686312167)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\811A\672C\8FDB\884C\8BED\6CD5\5206\6790\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107797194186312167)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\4E2D\4E0D\5B58\5728\65B9\6848 "%0"\3002\8BF7\4E0E\5DE5\4F5C\533A\7BA1\7406\5458\8054\7CFB, \4EE5\4E3A\60A8\8BBE\7F6E\6B63\786E\7684\9ED8\8BA4\65B9\6848\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597610914312014)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('run_sql_arr \4E2D\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800017776312169)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\6210\5458\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107616722143312029)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\884C\591A\4E8E 32767 \5B57\8282')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583627796312004)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107832474373312195)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584643000312004)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107585024032312005)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \79D2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583709764312004)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\6267\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642527056312048)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\8BF7\6C42\8FD0\884C\7684\811A\672C\5305\542B\672A\77E5\8BED\53E5\3002\8BF7\5220\9664\4EE5\4E0B\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584741381312004)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\8FDB\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107642493344312048)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107604077148312019)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1004 \811A\672C\6700\591A\53EF\4EE5\5D4C\5957 %0 \5C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605358973312020)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1005 \811A\672C\8F93\51FA\8FBE\5230\6700\5927\5927\5C0F\9650\5236\3002\8BF7\66F4\6539\811A\672C\4EE5\751F\6210\8F83\5C0F\7684\8F93\51FA, \6216\4E0E\7BA1\7406\5458\8054\7CFB\4EE5\589E\52A0\811A\672C\7ED3\679C\5927\5C0F\7684\6700\5927\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933554077312272)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\811A\672C\8D85\8FC7\4E86\5141\8BB8\7684\6700\5927 %0 \5B57\8282\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107605404004312020)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1005 \811A\672C\8F93\51FA\8FBE\5230\5DE5\4F5C\533A\7ED3\679C\5927\5C0F\7684\6700\5927\9650\5236\3002\8BF7\5220\9664\73B0\6709\7ED3\679C, \6216\4E0E\7BA1\7406\5458\8054\7CFB\4EE5\589E\52A0\5DE5\4F5C\533A\7ED3\679C\5927\5C0F\7684\6700\5927\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107868573032312222)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F13\51B2\533A\4E2D\6CA1\6709\8981\8FD0\884C\7684\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107599300781312016)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SELECT \8BED\53E5\4E0D\80FD\5927\4E8E 32KB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584863439312004)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584999636312005)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107600215715312016)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9009\62E9 %0 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827584683312191)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\8BF7\6C42\8FD0\884C\7684\811A\672C\4E0D\5305\542B\4EFB\4F55\53EF\8FD0\884C\7684\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597485732312014)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FD0\884C\811A\672C\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107597551683312014)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('run_statement \4E2D\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107827474140312191)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\8BF7\6C42\8FD0\884C\7684\811A\672C\5305\542B SQL \5DE5\4F5C\5BA4\5C06\5FFD\7565\7684\8BED\53E5\3002\8BF7\786E\8BA4\8BF7\6C42\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107603907646312019)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1001 \672A\627E\5230\811A\672C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107583509233312003)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831925422312194)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5\8BED\53E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107831729790312194)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0% \5DF2\4F7F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817496699312182)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E SQL \8BED\6CD5\65E0\6548\5BFC\81F4\5305\521B\5EFA\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817184410312182)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E SQL \8BED\6CD5\65E0\6548\5BFC\81F4\8868\521B\5EFA\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650007016312054)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540C\6B65\9519\8BEF: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973564850312302)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107973478634312302)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F15\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107648350371312053)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C1D\8BD5\8BBF\95EE\7684\8868\683C\5F0F\8868\5355\5217\5C06\6620\5C04\5230 PL/SQL \6570\7EC4 apex_application.g_f%0, \4F46\4EC5\652F\6301\4FDD\5B58\72B6\6001\7684 %1 \5217\3002\8BF7\51CF\5C11\4FDD\5B58\72B6\6001\7684\5217\7684\6570\76EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108211068633312491)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\65B0\7684\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996419547312323)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\65B0\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997091095312323)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\9009\9879\5361\96C6 (\7528\4E8E\5728\65B0\9009\9879\5361\96C6\5185\521B\5EFA\6807\51C6\9009\9879\5361)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824715966312189)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\7236\9009\9879\5361 ID = %0 \7684\65B0\9009\9879\5361\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824690069312189)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\9009\9879\5361 ID = %0 \7684\65E7\9009\9879\5361\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824859548312189)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 ID: %0 \4E0D\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996510554312323)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7236\9009\9879\5361\3002\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996998888312323)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4E0E\7236\9009\9879\5361\76F8\5173\8054\3002\5C06\5B83\663E\793A\4E3A\201C\4F2A\7236\9009\9879\5361\201D, \4EE5\4FBF\60A8\53EF\4EE5\5728\6B64\9009\9879\5361\96C6\5185\7F16\8F91\6807\51C6\9009\9879\5361\3002 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107997114921312323)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6807\51C6\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996791864312323)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996621882312323)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\4F2A\7236\9009\9879\5361')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824554965312188)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8BBE\7F6E\5B89\5168\7EC4 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107824907231312189)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A\9009\9879\5361 ID = %0 \6307\5B9A\65B0\7684\9009\9879\5361\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996305067312323)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6\9009\9879\5361\3002\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996264579312323)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\8FD8\53EF\5BF9\5E94\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996144025312323)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\5BF9\5E94\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107996831464312323)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651267609312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F "%1" \5DE5\4F5C\533A "%2" \4E2D\672A\627E\5230\8981\590D\5236\7684\6309\94AE\6A21\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652156788312056)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\6309\94AE\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107817649685312182)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650919456312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F "%1" \5DE5\4F5C\533A "%2" \4E2D\672A\627E\5230\8981\590D\5236\7684\5B57\6BB5\6A21\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651843585312056)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\5B57\6BB5\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651738928312056)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\5217\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651109838312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F "%1" \7684\5DE5\4F5C\533A "%2" \4E2D\672A\627E\5230\8981\590D\5236\7684\9762\5305\5C51\6A21\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651998150312056)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\9762\5305\5C51\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651469477312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\9875\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107652065222312056)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\5F39\51FA\5F0F\503C\5217\8868\6A21\677F\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107934487429312273)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F "%1" \5DE5\4F5C\533A "%2" \4E2D\672A\627E\5230\8981\590D\5236\7684\5F39\51FA\5F0F\6A21\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651564872312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\533A\57DF\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651619996312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362\62A5\8868\6A21\677F\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107650815334312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\627E\5230\8981\590D\5236\7684\6A21\677F (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107651312926312055)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66FF\6362 %0 \6A21\677F\3002 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108764349270312931)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898\6837\5F0F\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781835544312951)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\66F4\65B0\6837\5F0F, \8BE5\6837\5F0F\4E3A\53EA\8BFB!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108781793451312951)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0\5DF2\7531\73B0\6709\6837\5F0F\4F7F\7528!')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107649990249312054)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79CD\5B50\66F4\65B0\9519\8BEF: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108098963213312402)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Application Express \6B63\5728\5347\7EA7\5230\8F83\65B0\7684\7248\672C\3002\5728\5347\7EA7\5B8C\6210\524D, \7981\6B62\5BF9\5E94\7528\7A0B\5E8F\8FDB\884C\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762199097312140)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567454694311990)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\53D1\73B0\5E94\7528\7A0B\5E8F %0, \8BF7\4EE5\6570\636E\5E93\7528\6237 %1 \8EAB\4EFD\767B\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567560217311990)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\53D1\73B0\5E94\7528\7A0B\5E8F %0 \9875 %1, \8BF7\4EE5\6570\636E\5E93\7528\6237 %2 \8EAB\4EFD\767B\5F55\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763128141312141)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\5386')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791146632312162)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\590D\9009\6846\67E5\8BE2\8FDB\884C\6C42\503C\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763207933312141)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790762511312162)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF:\201C\4EC5\663E\793A\201D\503C\5217\8868\5FC5\987B\9009\62E9\4E24\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107761955724312140)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\786E\5B9A\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763540669312141)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812527329312179)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\5F39\51FA\5F0F\503C\5217\8868\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790468182312161)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\67E5\8BE2\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790579678312161)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\503C\5217\8868\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791072996312162)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521D\59CB\5316\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716385933312105)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\67E5\8BE2\65E0\6548, \9700\8981\663E\793A\503C\548C\8FD4\56DE\503C, \5217\540D\4E0D\80FD\76F8\540C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763601570312141)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301 JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763848498312141)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107764276011312141)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\503C\5217\8868\67E5\8BE2\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763072003312141)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762618256312140)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\5339\914D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763333959312141)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812233424312178)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\5FC5\987B\4EE5 "select" \5F00\5934\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790336306312161)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4F7F\7528\8FC7\6EE4\5668\751F\6210\5F39\51FA\5F0F\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812486172312178)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\5F39\51FA\5F0F\503C\5217\8868\65F6\51FA\9519, \8FC7\6EE4\5668\4E3A: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107812396558312178)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\5316\5F39\51FA\5F0F\503C\5217\8868\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790831927312162)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\9A8C\8BC1\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790921159312162)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868\6821\9A8C\548C\9A8C\8BC1\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762774606312140)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107762340806312140)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107763489418312141)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\641C\7D22\201D\5BF9\8BDD\6846')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108374406334312624)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\50CF\65F6\51FA\9519\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791601947312162)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792018188312163)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\76EE\7B26\53F7\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792438784312163)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\5DE6\7F29\8FDB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792598553312163)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\53F3\7F29\8FDB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791710996312162)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792291163312163)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C45\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792189168312163)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE6\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792362009312163)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3\5BF9\9F50')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791926279312162)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\53F7\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107791886569312162)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\5212\7EBF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107790668375312162)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\7ED1\5B9A "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107567351902311990)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\53D1\73B0 Websheet \5E94\7528\7A0B\5E8F %0, \8BF7\4EE5\6570\636E\5E93\7528\6237 %1 \8EAB\4EFD\767B\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107991339347312316)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\63D0\4F9B\7684 URL \65E0\6548, \73AF\5883\8981\6C42\5BF9 HTTP \8BF7\6C42\4F7F\7528\6709\6548\7684\4EE3\7406\670D\52A1\5668\5730\5740, \8BF7\6C42\8D85\65F6, \6216\8005\9700\8981\4E3A HTTPS \8BF7\6C42\914D\7F6E wallet, \56E0\6B64\65E0\6CD5\8BBF\95EE Web \670D\52A1\3002SQLERRM: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638004090312045)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\63D0\4F9B\7684 URL \65E0\6548, \73AF\5883\8981\6C42\5BF9 HTTP \8BF7\6C42\4F7F\7528\6709\6548\7684\4EE3\7406\670D\52A1\5668\5730\5740\800C\60A8\6CA1\6709\4E3A\6B64\5E94\7528\7A0B\5E8F\5B9A\4E49\4E00\4E2A\5730\5740, \6216\8005\5FC5\987B\4E3A\6B64 &PRODUCT_NAME. \5B9E\4F8B\914D\7F6E wallet \4EE5\8FDB\884C HTTPS \8BF7\6C42, \56E0\6B64\65E0\6CD5\68C0\7D22 WSDL \6587\6863\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638794641312046)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\5DF2\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220763937312499)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6DFB\52A0\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107632587899312041)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6309\94AE\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669079144312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\65E5\5386\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668788594312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\56FE\8868\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108351102168312605)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5B8C\6210\6570\636E\52A0\8F7D\5904\7406\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669423532312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA Excel \56FE\8868\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669181167312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\57FA\4E8E\7B49\503C\8054\63A5\7684\8868\5355\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668392449312068)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\57FA\4E8E SP \7684\8868\5355\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668484760312068)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\57FA\4E8E\8868\7684\8868\5355\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668502408312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\63D2\5165\8868\5355\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108152829276312445)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA Oracle JET \56FE\8868\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107555490782311980)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\4E3B\4ECE\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108038254251312353)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\52A8\6001\64CD\4F5C\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668667551312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\67E5\8BE2\548C\66F4\65B0\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668932353312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\62A5\8868\9875\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669543680312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6982\8981\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669679859312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA SVG \56FE\8868\9875\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669398078312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\6811\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668285688312068)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\53EF\66F4\65B0\7684\62A5\8868\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669288726312069)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\201C\521B\5EFA\5411\5BFC\7684\5411\5BFC\201D\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220660782312499)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5904\7406\5220\9664\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221037648312499)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 #MRD_COUNT# \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574410088311995)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574341767311995)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C\201D\5904\7406\9700\8981\6B64\6309\94AE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107574269343311995)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C\201D\5904\7406\9700\8981\6B64\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107575031130311996)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FD0\884C\201C\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C\201D\5904\7406\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107584143185312004)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9E\8981\9000\51FA\6B64\9875\800C\4E0D\8FDB\884C\4FDD\5B58?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933413364312272)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\6B21\7EA7\952E\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107933340154312272)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\83B7\53D6\4E3B\952E\9879\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668830676312069)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\7C7B\578B\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107947465312312282)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868\5DF2\7ECF\5B58\5728\3002\6BCF\9875\53EA\80FD\6DFB\52A0\4E00\4E2A\4EA4\4E92\5F0F\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107659310606312061)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521B\5EFA\201C\83B7\53D6\4E0B\4E00\4E2A\6216\4E0A\4E00\4E2A\4E3B\952E\503C\201D\5904\7406\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220571268312499)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\6B64\9875\7684\5E2E\52A9\4FE1\606F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668144519312068)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107668086419312068)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\9519\8BEF 2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221145509312499)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\8BF7\6C42\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221440031312499)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\6811')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108221276261312499)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811\6839\8282\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638594409312045)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\63D0\53D6\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107638680788312045)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5904\7406\8868 %0 \7684\884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107669791573312069)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\66F4\65B0\7684 SQL \67E5\8BE2\5DF2\5B58\5728\3002\6BCF\9875\53EA\80FD\6DFB\52A0\4E00\4E2A\53EF\66F4\65B0\7684 SQL \67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220855715312499)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5E94\7528\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108220990950312499)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0 #MRU_COUNT# \884C, \5DF2\63D2\5165 #MRI_COUNT# \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091303584312396)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\6388\6743\65B9\6848')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091183571312396)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108090946297312396)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091298264312396)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\73B0\6709\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108091087036312396)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\73B0\6709\503C\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107792789663312163)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\62A5\8868\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108248974446312522)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\8BA1 %0 GB | \5DF2\4F7F\7528 %1 GB | \5DF2\7528\767E\5206\6BD4 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107566061422311989)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\65B0\7684 PGA \805A\96C6\76EE\6807\65F6\51FA\9519\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107565865649311988)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\65B0\7684 SGA \76EE\6807\65F6\51FA\9519\3002 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108813405210312975)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 %0 \65F6\51FA\9519: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788420260312160)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788330494312160)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5750\6807\8F74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788916315312160)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107789028078312160)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788834471312160)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788608932312160)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788772274312160)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788226518312160)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107788567103312160)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107723997100312111)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790, \6E38\6807\5C1A\672A\6253\5F00\6216\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570\672A\8FD4\56DE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108084465162312391)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\5305\542B\91CD\590D\7684\522B\540D, \4F46\7528\4E8E\62A5\8868\7684\67E5\8BE2\8981\6C42\4F7F\7528\552F\4E00\7684\522B\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107716040967312105)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\5904\7406\8FD4\56DE\67E5\8BE2\7684\51FD\6570\4F53:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801928841312170)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\67E5\8BE2\4E2D\5B9A\4E49\7684\5217\6570\65E0\6548, \6B64\533A\57DF\7C7B\578B\9700\8981 %0 \5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724035830312111)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8FD4\56DE SQL \67E5\8BE2\7684\51FD\6570: \65E0\6CD5\5728\6784\5EFA\5668\5185\5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790\3002\5982\679C\60A8\8BA4\4E3A\67E5\8BE2\7684\8BED\6CD5\6B63\786E, \53EF\9009\4E2D\533A\57DF\6E90\4E0B\9762\7684<strong>\4E00\822C\5217</strong>\590D\9009\6846, \4EE5\5728\4E0D\8FDB\884C\8BED\6CD5\5206\6790\7684\60C5\51B5\4E0B\7EE7\7EED\6267\884C\3002<br/>'),
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107724177715312111)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<p>\65E0\6CD5\5728\6784\5EFA\5668\5185\5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790\3002\5982\679C\60A8\8BA4\4E3A\67E5\8BE2\7684\8BED\6CD5\6B63\786E, \53EF\9009\4E2D\533A\57DF\6E90\4E0B\9762\7684 ''''\4E00\822C\5217'''' \590D\9009\6846, \4EE5\5728\4E0D\8FDB\884C\8BED\6CD5\5206\6790\7684\60C5\51B5\4E0B\7EE7\7EED\6267\884C\3002%0</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800447796312169)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\5355\8BCD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801003517312170)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\5230\5B57\5178')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800909895312170)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\66F4\6539')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800893786312170)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800780629312169)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B8C\6210')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108159647168312450)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4EA4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800649040312169)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5B57\5178\4E2D\5DF2\5B58\5728 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801220173312170)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\65B0\5355\8BCD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107801151195312170)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\53D6\5355\8BCD A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108018802884312339)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62FC\5199\68C0\67E5\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107800560519312169)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5C06 %0 \6DFB\52A0\5230\60A8\7684\5B57\5178\4E2D\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107645893103312051)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('XML \52A0\8F7D\9519\8BEF\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108070795394312380)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\9644\52A0\7684%0\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108071558285312380)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A Bug \6CA1\6709\4FEE\590D\5B8C\6210\65E5\671F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108245559037312519)
,p_name=>'YEARLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107699294529312092)
,p_name=>'YES_BY_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F, \6309\7528\6237')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(107728369242312114)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\7535\5B50\90AE\4EF6\5730\5740\5DF2\7531\67D0\4E2A\7528\6237\5728\4EE5\4E0B\5DE5\4F5C\533A\4E2D\6CE8\518C:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(108009728313312333)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5F53\524D\5DF2\6CE8\9500\3002')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4417)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>unistr('\9762\5305\5C51')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\5F53\524D\9875\7684\9762\5305\5C51\7EBF\7D22\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>unistr('\5217\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\57FA\4E8E\9759\6001\6216\52A8\6001\5217\8868\663E\793A\503C\3002\901A\5E38\8FD9\4E9B\7528\4E8E\5BFC\822A\5230\5E94\7528\7A0B\5E8F\4E2D\7684\9875\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('\201C\53D6\6D88\201D\5BF9\8BDD\6846')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53D6\6D88\5F53\524D\5BF9\8BDD\6846\9875\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('\5173\95ED\5BF9\8BDD\6846')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5173\95ED\5F53\524D\5BF9\8BDD\6846\9875\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4417)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8981\8FD4\56DE\7684\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7531\5BF9\8BDD\6846\8FD4\56DE\7684\4E00\4E2A\6216\591A\4E2A\9875\9879\7684\540D\79F0\3002\5BF9\4E8E\591A\4E2A\9879, \8BF7\4F7F\7528\9017\53F7\5206\9694\5404\4E2A\9879\540D\3002</p>'),
unistr('<p>\53EF\4EE5\901A\8FC7\5B9A\4E49\52A8\6001\64CD\4F5C\5728\6253\5F00\5BF9\8BDD\6846\7684\5143\7D20\4E0A\89E6\53D1<strong>\5BF9\8BDD\6846\5DF2\5173\95ED</strong>\4E8B\4EF6, \5E76\4F7F\7528<strong>\5BF9\8BDD\6846\8FD4\56DE\9879</strong>\7684\64CD\4F5C<strong>\8BBE\7F6E\503C</strong>\548C<em>\8BBE\7F6E\7C7B\578B</em>, \4ECE\800C\8BBF\95EE\8FD4\56DE\7684\9879\503C\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('\533A\57DF\663E\793A\9009\62E9\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\6C34\5E73\5217\8868\4E2D\663E\793A\533A\57DF\540D\79F0, \4F7F\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\4E00\4E2A\533A\57DF\8FDB\884C\663E\793A\5E76\9690\85CF\5176\4ED6\533A\57DF\3002\53EA\6709<em>\533A\57DF\663E\793A\9009\62E9\5668</em>\8BBE\7F6E\4E3A<strong>\662F</strong>\7684\9875\533A\57DF\624D\4F1A\663E\793A\5728\6B64\533A\57DF\4E2D\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4417)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5305\62EC\6ED1\5757')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\663E\793A\7684\533A\57DF\540D\79F0\8D85\8FC7\533A\57DF\7684\5BBD\5EA6, \5219\52A8\6001\5730\5411\533A\57DF\6DFB\52A0\6ED1\5757\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4417)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9<em>\533A\57DF\663E\793A\9009\62E9\5668</em>\8BBE\7F6E\4E3A<strong>\662F</strong>\7684\533A\57DF\5728\9875\4E0A\7684\663E\793A\65B9\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\67E5\770B\5355\4E2A\533A\57DF')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('\5C06\533A\57DF\663E\793A\4E3A\9009\9879\5361\3002\9009\62E9\67D0\4E2A\9009\9879\5361\65F6\5C06\4F7F\5BF9\5E94\7684\533A\57DF\53EF\89C1, \5E76\9690\85CF\5176\4ED6\9009\5B9A\5185\5BB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\6EDA\52A8\7A97\53E3')
,p_return_value=>'JUMP'
,p_help_text=>unistr('\59CB\7EC8\5728\9875\4E0A\663E\793A\6240\6709\533A\57DF\3002\9009\62E9\67D0\4E2A\9009\9879\5361\65F6, \60A8\7684\7A97\53E3\5C06\6EDA\52A8\5230\5BF9\5E94\7684\533A\57DF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4417)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5305\542B ''\5168\90E8\663E\793A''')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('\5BF9 "\5168\90E8\663E\793A" \9009\9879\5361\8FDB\884C\9884\7F6E, \5728\9009\4E2D\8BE5\9009\9879\5361\65F6, \5C06\663E\793A\9875\4E0A\7684\6240\6709\533A\57DF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4417)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8BB0\4F4F\4E0A\6B21\9009\62E9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\5728\52A0\8F7D\9875\65F6, \5C06\663E\793A\4E0A\6B21\9009\62E9\7684\533A\57DF\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\6E90\81EA URL \7684\8FDC\7A0B\5185\5BB9\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4417)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8FDC\7A0B\5185\5BB9\7684 URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4417)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5305\542B\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\5728\9875\4E2D\5305\62EC\6765\81EA URL \7684\8FDC\7A0B\5185\5BB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4417)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>unistr('\4F5C\4E3A iFrame \5D4C\5165\8FDC\7A0B\5185\5BB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5185\5D4C (\8F6C\4E49\7279\6B8A\5B57\7B26)')
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('\5728\5448\73B0\9875\65F6\8BFB\53D6\8FDC\7A0B\5185\5BB9\5E76\5D4C\5165\6B64\5185\5BB9, \4F46\5BF9\7279\6B8A HTML \5B57\7B26\8FDB\884C\8F6C\4E49\4EE5\7981\6B62\8DE8\7AD9\70B9\811A\672C\7F16\5199\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5185\5D4C (\65E0\8F6C\4E49)')
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('\5728\5448\73B0\9875\65F6\8BFB\53D6\8FDC\7A0B\5185\5BB9\5E76\5D4C\5165\6B64\5185\5BB9\3002\53EA\6709\5728\80FD\591F\5B8C\5168\4FE1\4EFB\8FDC\7A0B\5185\5BB9\65F6, \624D\5E94\9009\62E9\6B64\9009\9879, \56E0\4E3A\4E0D\6267\884C HTML \8F6C\4E49\3002\8FD9\53EF\80FD\4F1A\4F7F\533A\57DF\6613\906D\5230\8DE8\7AD9\70B9\811A\672C\7F16\5199\7684\653B\51FB\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4417)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('IFrame \5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>unistr('\4E3A iFrame \6807\8BB0\8F93\5165\5176\4ED6 HTML \5143\7D20\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4417)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\653E\5F03\4EE5\4E0B\4F4D\7F6E\4E4B\524D\7684 HTML:')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\4ECE\8F83\5927\7684\6587\6863\4E2D\526A\8F91 HTML \90E8\5206\65F6\4F7F\7528\6B64\5C5E\6027\3002\8F93\5165\6807\8BC6\76EE\6807\90E8\5206\7684\5F00\5934\7684\5B57\7B26\4E32, \6216\5F00\59CB\820D\5F03 HTML \7684\70B9\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4417)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\653E\5F03\4EE5\4E0B\4F4D\7F6E\4E4B\540E\7684 HTML:')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('\4F7F\7528\6B64\5C5E\6027\53EF\4ECE\8F83\5927\7684 HTML \6587\6863\4E2D\526A\8F91 HTML \90E8\5206\3002\8F93\5165\6807\8BC6\76EE\6807\90E8\5206\7684\7ED3\5C3E\7684\5B57\7B26\4E32, \6216\5F00\59CB\820D\5F03\5269\4F59 HTML \7684\70B9\3002\6807\8BC6\76EE\6807\90E8\5206\7684\7ED3\5C3E\7684\5B57\7B26\4E32\4E0D\5305\62EC\5728\8FD4\56DE\7684\6587\672C\4E2D\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>unistr('\5E2E\52A9\6587\672C')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\5728\4E13\7528\201C\5E2E\52A9\201D\9875\4E0A\4F7F\7528\7684\7279\6B8A\201C\5E2E\52A9\201D\533A\57DF\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>unistr('\5206\9762\641C\7D22')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\57FA\4E8E\5173\8054\5206\9762\641C\7D22\6E90\7684\533A\57DF\FF0C\53EF\4E3A\6700\7EC8\7528\6237\63D0\4F9B\5927\91CF\9762\FF0C\4EE5\5728\8FD0\884C\65F6\7F29\5C0F\641C\7D22\7ED3\679C\8303\56F4\3002</p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6279\91CF\9762\66F4\6539')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5728\5206\9762\641C\7D22\62A5\8868\4E0A\6279\91CF\5E94\7528\6240\9009\9762\8FD8\662F\5355\72EC\5E94\7528\6240\9009\9762\3002\5982\679C\8BBE\7F6E\4E3A\201C\662F\201D\FF0C\5219\5728\5355\51FB\201C\5E94\7528\201D\6309\94AE\65F6\8FC7\6EE4\62A5\8868\3002\5982\679C\8BBE\7F6E\4E3A\201C\5426\201D\FF0C\5219\5728\6BCF\5F53\53D1\751F\4EFB\4F55\9762\503C\66F4\6539\65F6\7ACB\5373\8FC7\6EE4\62A5\8868\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\663E\793A\5F53\524D\9762')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\662F\5426\663E\793A\5F53\524D\9762\533A\57DF\3002\5F53\524D\9762\533A\57DF\5217\51FA\5F53\524D\9009\62E9\7684\9762\FF0C\7528\6237\53EF\4EE5\8F7B\677E\5730\5355\72EC\5220\9664\5404\4E2A\9762\6216\4E00\6B21\6027\5220\9664\6240\6709\9762\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>unistr('\5F53\524D\9762\5217\8868\663E\793A\5728\5206\9762\641C\7D22\533A\57DF\9876\90E8\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\4E0D\663E\793A\5F53\524D\9762\5217\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9009\62E9\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\5728\6B64\9009\62E9\5668\6307\5B9A\7684\5143\7D20\4E2D\663E\793A\5F53\524D\9762\533A\57DF\3002\8FD9\6837\FF0C\60A8\53EF\4EE5\5C06\5F53\524D\9762\533A\57DF\653E\5728\9875\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5F53\524D\9762\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('\8FD9\662F\9875\9762\4E0A\5C06\4F9B\5206\9762\641C\7D22\533A\57DF\663E\793A\5F53\524D\9762\7684\5143\7D20\7684\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\663E\793A\603B\884C\6570')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\663E\793A\603B\884C\6570\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\4E0D\663E\793A\603B\884C\6570\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>unistr('\5728\5F53\524D\9762\533A\57DF\9876\90E8\663E\793A\603B\884C\6570\FF1B\5982\679C\201C\663E\793A\5F53\524D\9762\201D\4E3A\201C\5426\201D\FF0C\5219\5728\5206\9762\641C\7D22\533A\57DF\9876\90E8\663E\793A\603B\884C\6570\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9009\62E9\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\5728\6B64\9009\62E9\5668\6307\5B9A\7684\5143\7D20\4E2D\663E\793A\603B\884C\6570\FF08\65E0\4EFB\4F55\6807\7B7E\FF09\3002\8FD9\6837\FF0C\60A8\53EF\4EE5\5C06\603B\884C\6570\653E\5728\9875\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\603B\884C\6570\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\7528\4E8E\603B\884C\6570\7684\6807\7B7E\3002\5982\679C\6B64\5904\672A\63D0\4F9B\6807\7B7E\FF0C\5219 APEX \5C06\4F7F\7528 APEX.FS.TOTAL_ROW_COUNT_LABEL \6587\672C\6D88\606F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\603B\884C\6570\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\8FD9\662F\9875\9762\4E0A\5C06\4F9B\5206\9762\641C\7D22\533A\57DF\663E\793A\603B\884C\6570\7684\5143\7D20\7684\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('\7B80\6D01\6570\5B57\9608\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\4E00\4E2A\9608\503C\FF0C\5982\679C\8D85\8FC7\8BE5\503C\FF0C\5219\4F1A\4F7F\7528\7B80\6D01\6570\5B57\683C\5F0F\663E\793A\9762\8BA1\6570\3002\901A\8FC7\4F7F\7528\7B80\6D01\6570\5B57\683C\5F0F\FF0C\503C <strong>1,234</strong> \5C06\663E\793A\4E3A <strong>1K</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\663E\793A\56FE\8868')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\663E\793A\9762\503C\56FE\8868\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5BF9\8BDD\6846')
,p_return_value=>'Y'
,p_help_text=>unistr('\5728\65E0\6A21\5F0F\5BF9\8BDD\6846\4E2D\663E\793A\9762\503C\56FE\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\7528\6237\6CA1\6709\53EF\663E\793A\9762\503C\56FE\8868\7684\6309\94AE\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9009\62E9\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\9762\503C\56FE\8868\5C06\6DFB\52A0\5230\6B64\9009\62E9\5668\6307\5B9A\7684\5143\7D20\3002\8FD9\6837\FF0C\5728\521B\5EFA\9762\503C\56FE\8868\9762\677F\65F6\FF0C\60A8\53EF\4EE5\5C06\56FE\8868\653E\5728\9875\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\56FE\8868\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('\8FD9\662F\9875\9762\4E0A\5C06\4F9B\5206\9762\641C\7D22\533A\57DF\663E\793A\9762\56FE\8868\7684\5143\7D20\7684\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\663E\793A\524D N \4E2A\503C\7684\56FE\8868')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('\63D0\4F9B\8981\5728\6BCF\4E2A\9762\7684\56FE\8868\4E2D\663E\793A\7684\503C\6570\91CF\3002\5982\679C\503C\4E3A <strong>10</strong>\FF0C\5219\610F\5473\7740\9762\56FE\8868\5C06\6309\7167\9762\4E0B\7684\987A\5E8F\663E\793A<em>\524D 10</em> \9879\3002\542F\7528\9762\5C5E\6027\201C\6309\6570\91CF\4ECE\591A\5230\5C11\6392\5E8F\201D\65F6\FF0C\8FD9\5C06\662F\6309\51FA\73B0\6B21\6570\5217\51FA\7684<em>\524D 10</em> \9879\3002\5728\5F53\524D\6D3B\52A8\7684\6D4F\89C8\5668\4F1A\8BDD\4E2D\FF0C\60A8\53EF\80FD\4E0D\4F1A\7ACB\5373\770B\5230\5BF9\6B64\5C5E\6027\7684\66F4\6539\3002\6B64\503C\4EE5\53CA\7528\6237\9009\62E9\7684\997C\56FE\6216\6761\5F62\56FE\90FD\4FDD\5B58\5728\6D4F\89C8\5668\4F1A\8BDD\4E2D\3002\8981\67E5\770B\66F4\6539\6B64\5C5E\6027\7684\6548\679C\FF0C\8BF7\4F7F\7528\94FE\63A5\5BF9\8BDD\6846\4E2D\7684\201C\91CD\7F6E\533A\57DF\201D\6216\9AD8\901F\7F13\5B58\63A7\5236\9009\9879\FF08\4F8B\5982\4F7F\7528\5411\5BFC\751F\6210\7684\201C\91CD\7F6E\201D\6309\94AE\FF09\91CD\7F6E\62A5\8868\3002')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('\5220\9664\56FE\8868\4E4B\540E')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('\6DFB\52A0\56FE\8868\4E4B\524D')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4417)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4417)
,p_name=>'facetschange'
,p_display_name=>unistr('\9762\66F4\6539')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>unistr('SAML \767B\5F55')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('\7528\4E8E\4E3A\8BF7\6C42\7B7E\540D\7684\8EAB\4EFD\8BC1\660E\5B58\50A8')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5305\542B\7528\4E8E\4E3A\5411\8EAB\4EFD\63D0\4F9B\65B9\53D1\9001\7684\6D88\606F\7B7E\540D\7684\516C\5171\8BC1\4E66\548C\79C1\6709\5BC6\94A5\7684\8EAB\4EFD\8BC1\660E\5B58\50A8\3002'),
unistr('\60A8\9700\8981\5728\8EAB\4EFD\63D0\4F9B\65B9\6CE8\518C\8BC1\4E66\3002'),
unistr('&PRODUCT_NAME. \4F7F\7528\79C1\6709\5BC6\94A5\4E3A\8BF7\6C42\7B7E\540D\3002'),
unistr('\867D\7136\6B64\5C5E\6027\662F\53EF\9009\5C5E\6027\FF0C\4F46\51FA\4E8E\5B89\5168\539F\56E0\FF0C\5EFA\8BAE\4E3A\8BF7\6C42\7B7E\540D\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\4EE5\4E0B\9879\7684 SAML \5C5E\6027')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('\6307\5B9A\662F\4F7F\7528\5B9E\4F8B\7EA7\8FD8\662F\7279\5B9A\4E8E\5E94\7528\7A0B\5E8F\7684 SAML \914D\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5B9E\4F8B')
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5BF9\6574\4E2A &PRODUCT_NAME. \5B9E\4F8B\4F7F\7528\5171\4EAB SAML \914D\7F6E\3002'),
unistr('\8FD9\8981\6C42\5B9E\4F8B\7BA1\7406\5458\914D\7F6E\4E86\5B9E\4F8B\7EA7 SAML \5C5E\6027\3002'),
unistr('\5426\5219\FF0C\60A8\5C06\6536\5230\8FD0\884C\65F6\9519\8BEF\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5E94\7528\7A0B\5E8F')
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('\4F7F\7528\7279\5B9A\4E8E\5E94\7528\7A0B\5E8F\7684 SAML \914D\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\8EAB\4EFD\63D0\4F9B\65B9\5355\70B9\767B\5F55 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('\9009\62E9\8EAB\4EFD\63D0\4F9B\65B9\7684\5355\70B9\767B\5F55 POST URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\8EAB\4EFD\63D0\4F9B\65B9\5355\70B9\6CE8\9500 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\8EAB\4EFD\63D0\4F9B\65B9\7684\5355\70B9\6CE8\9500 POST URL\3002'),
unistr('\5982\679C\4E3A\7A7A\FF0C\5219\5C06\4F7F\7528\5355\70B9\767B\5F55 URL\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\8EAB\4EFD\63D0\4F9B\65B9\53D1\5E03\8005')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\8EAB\4EFD\63D0\4F9B\65B9\7684\201C\53D1\5E03\8005\201D\503C\3002'),
unistr('&PRODUCT_NAME. \5C06\5728\6765\81EA\8EAB\4EFD\63D0\4F9B\65B9\7684\6D88\606F\4E2D\9A8C\8BC1\6B64\503C\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\7528\6237\540D\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5305\542B\7528\6237\540D\7684 SAML \5C5E\6027\3002'),
unistr('\9ED8\8BA4\4E3A "Assertion/Subject/NameID" \8282\70B9\7684\503C\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>unistr('\8EAB\4EFD\63D0\4F9B\65B9\7684\7B7E\540D\8BC1\4E66')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\8EAB\4EFD\63D0\4F9B\65B9\7528\4E8E\4E3A\6D88\606F\7B7E\540D\7684\8BC1\4E66\3002'),
unistr('&PRODUCT_NAME. \4F7F\7528\6B64\8BC1\4E66\9A8C\8BC1\6765\81EA\8EAB\4EFD\63D0\4F9B\65B9\7684\54CD\5E94\6D88\606F\3002'),
unistr('\867D\7136\6B64\5C5E\6027\662F\53EF\9009\5C5E\6027\FF0C\4F46\51FA\4E8E\5B89\5168\539F\56E0\FF0C\5EFA\8BAE\9A8C\8BC1\54CD\5E94\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4417)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5C06\7528\6237\540D\8F6C\6362\4E3A\5927\5199')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\914D\7F6E\662F\5426\5E94\5C06\7528\6237\540D\5C5E\6027\503C\8F6C\6362\4E3A\5927\5199\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>unistr('\8F93\5165\5B57\6BB5')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4417)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6BD4\8F83\8FD0\7B97\7B26')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7B49\4E8E')
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5C0F\4E8E')
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\5C0F\4E8E\7B49\4E8E')
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\5927\4E8E')
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>60
,p_display_value=>unistr('\5927\4E8E\7B49\4E8E')
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>70
,p_display_value=>unistr('\5F00\5934\4E3A')
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_display_sequence=>80
,p_display_value=>unistr('\5305\542B')
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4417)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\533A\5206\5927\5C0F\5199')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4417)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\503C\5927\5C0F\5199')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5982\679C\6240\6709\6570\636E\503C\90FD\5DF2\7ECF\5C0F\5199\6216\5927\5199\FF0C\5219\53EF\4EE5\5728\6B64\5904\58F0\660E\3002\6700\7EC8\7528\6237\63D0\4F9B\7684\8FC7\6EE4\5668\5C06\81EA\52A8\8F6C\6362\4E3A\6240\58F0\660E\7684\5927\5C0F\5199\FF0C\4EE5\4FBF\6700\7EC8\7528\6237\4F53\9A8C\4E0D\533A\5206\5927\5C0F\5199\7684\641C\7D22\FF0C\800C\6570\636E\5E93\5B9E\9645\4E0A\6267\884C\666E\901A\7684\533A\5206\5927\5C0F\5199\7684\641C\7D22\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6DF7\5408\5927\5C0F\5199')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5C0F\5199')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5927\5199')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4417)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5F53\524D\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>unistr('\9488\5BF9 %0 \8FDB\884C\8FC7\6EE4')
,p_help_text=>unistr('\63D0\4F9B\8981\5728\5F53\524D\7684\9762\533A\57DF\4E2D\9488\5BF9\6B64\9762\663E\793A\7684\6587\672C\3002\5F53\524D\503C\53EF\4EE5\662F\5177\6709 <strong>%0</strong> \5360\4F4D\7B26\7684\5F15\7528\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4417)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\524D\7F00\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\8981\5728\8F93\5165\5B57\6BB5\524D\9762\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4417)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\540E\7F00\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\8981\5728\8F93\5165\5B57\6BB5\540E\9762\663E\793A\7684\6587\672C\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>unistr('\5361\7247')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\57FA\4E8E SQL \67E5\8BE2\7684\62A5\8868\FF0C\663E\793A\5361\7247\4E2D\6BCF\4E00\884C\7684\6570\636E\3002\4F7F\7528\5361\7247\FF0C\53EF\4EE5\8F7B\677E\5730\53EF\89C6\5316\5185\5BB9\5757\4E2D\7684\6570\636E\3002\60A8\53EF\4EE5\6309\58F0\660E\65B9\5F0F\5B9A\5236\6807\5934\3001\4ECB\8D28\3001\6B63\6587\6216\64CD\4F5C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4417)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4417)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4417)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('\9875\66F4\6539')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4417)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9875\7801\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\65E0\5206\9875')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9875\5927\5C0F\548C\63D0\53D6\504F\79FB')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7075\6D3B\8BBE\7F6E\5206\9875\FF0C\5176\4E2D REST API \5141\8BB8\4F7F\7528<em>\9875\5927\5C0F</em>\548C<em>\504F\79FB</em>\FF08\201C\5F00\59CB\884C\201D\FF09\53C2\6570\8BF7\6C42\7279\5B9A\7684\4E00\7EC4\884C\3002URL \901A\5E38\5982\4E0B\4F8B\6240\793A\FF0C\5176\8DF3\8FC7 <strong>20</strong> \884C\5E76\63D0\53D6\63A5\4E0B\6765\7684 <strong>100</strong> \884C\FF1A</p>'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9875\5927\5C0F\548C\9875\7801')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8BBE\7F6E\5206\9875\FF0C\5176\4E2D REST API \5141\8BB8\4F7F\7528<em>\9875\5927\5C0F</em>\548C<em>\9875\7801</em>\53C2\6570\8BF7\6C42\4E00\7EC4\884C\3002URL \901A\5E38\5982\4E0B\4F8B\6240\793A\FF0C\5176\8BF7\6C42\9875\7801\4E3A <strong>2</strong>\FF0C\4E14\9875\5927\5C0F\4E3A <strong>100</strong> \7684\9875\FF0C\4ECE\800C\5BFC\81F4\8FD4\56DE\7B2C 101 \884C\5230\7B2C 200 \884C\3002'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9875\7801')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8BBE\7F6E\5206\9875\FF0C\5176\4E2D REST API \5141\8BB8\4F7F\7528<em>\9875</em>\53C2\6570\8BF7\6C42\4E00\7EC4\884C\3002URL \901A\5E38\5982\4E0B\4F8B\6240\793A\FF0C\5176\8BF7\6C42\9875\7801\4E3A <strong>2</strong> \7684\9875\3002\5982\679C REST API \4F7F\7528\56FA\5B9A\9875\5927\5C0F <strong>20</strong>\FF0C\5C06\8FD4\56DE\7B2C 21 \884C\5230\7B2C 40 \884C\3002'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9875\5927\5C0F URL \53C2\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B URL \53C2\6570\4EE5\6307\5B9A\8981\4ECE REST API \8BF7\6C42\7684<em>\9875\5927\5C0F</em>\3002\5178\578B\503C\4E3A <strong>limit</strong>\3001<strong>page_size</strong> \6216 </strong>per_page</strong>\3002</p>'),
unistr('<p><em>\8BF7\52FF\5728 REST \6570\636E\6E90<strong>\53C2\6570</strong></em>\4E2D\6DFB\52A0\6B64\53C2\6570\3002&PRODUCT_NAME. \5C06\5728\6267\884C HTTP \8BF7\6C42\65F6\81EA\52A8\6DFB\52A0\6B64\53C2\6570\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9875\5927\5C0F\6700\5927\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\884C')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B REST API \5141\8BB8\63D0\53D6\7684\6BCF\9875\6700\5927\884C\6570\3002&PRODUCT_NAME. \4E0D\4F1A\5C1D\8BD5\6BCF\9875\8BF7\6C42\66F4\591A\884C\3002</p>'),
unistr('<p>\786E\4FDD REST API <em>\786E\5B9E\8FD4\56DE</em>\8BE5\884C\6570\FF0C\56E0\4E3A\5982\679C\54CD\5E94\5305\542B\7684\884C\6570\5C0F\4E8E\8BF7\6C42\7684\884C\6570\FF0C\5219 &PRODUCT_NAME. \5047\5B9A\8BF7\6C42\7684\9875\4E3A\6700\540E\4E00\9875\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9875\7801 URL \53C2\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B URL \53C2\6570\4EE5\6307\5B9A\8981\4ECE REST API \8BF7\6C42\7684<em>\9875\7801</em>\3002\5178\578B\503C\4E3A <strong>page</strong>\3002</p>'),
unistr('<p><em>\8BF7\52FF\5728 REST \6570\636E\6E90<strong>\53C2\6570</strong></em>\4E2D\6DFB\52A0\6B64\53C2\6570\3002&PRODUCT_NAME. \5C06\5728\6267\884C HTTP \8BF7\6C42\65F6\81EA\52A8\6DFB\52A0\6B64\53C2\6570\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7B2C\4E00\9875\7684\7D22\5F15')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\6307\5B9A REST API \662F\4ECE\7D22\5F15 <strong>"0"</strong> \8FD8\662F <strong>"1"</strong> \5F00\59CB\5BF9\9875\8BA1\6570\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4417)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API \5C06\7B2C\4E00\9875\79F0\4E3A\9875 <strong>1</strong>\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4417)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('REST API \5C06\7B2C\4E00\9875\79F0\4E3A\9875 <strong>0</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\56FA\5B9A\9875\5927\5C0F')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>unistr('\884C')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B\7531 REST API \786E\5B9A\7684<em>\9875\5927\5C0F</em>\FF08\6BCF\9875\884C\6570\FF09\3002</p>'),
unistr('<p>\901A\5E38\FF0C\6B64\4FE1\606F\4F4D\4E8E REST API \7684\6587\6863\4E2D\3002\786E\4FDD\5728\6B64\5904\6307\5B9A\6B63\786E\7684\503C\FF1A\5982\679C\503C\4E0D\51C6\786E\FF0C&PRODUCT_NAME. \4ECE REST API \63D0\53D6\6570\636E\65F6\FF0C\884C\5C06\7F3A\5931\6216\91CD\590D\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\504F\79FB URL \53C2\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>unistr('\884C')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D0\4F9B URL \53C2\6570\4EE5\6307\5B9A<em>\504F\79FB</em>\FF0C\5176\8868\793A\5728\8FD4\56DE\7B2C\4E00\884C\4E4B\524D\8981\8DF3\8FC7\7684\884C\3002</p>'),
unistr('<p><em>\8BF7\52FF\5728 REST \6570\636E\6E90<strong>\53C2\6570</strong></em>\4E2D\6DFB\52A0\6B64\53C2\6570\3002&PRODUCT_NAME. \5C06\5728\6267\884C HTTP \8BF7\6C42\65F6\81EA\52A8\6DFB\52A0\6B64\53C2\6570\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\884C\504F\79FB\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9<strong>\504F\79FB</strong>\53C2\6570\662F\6307\5B9A<em>\8981\8DF3\8FC7\7684\884C\6570</em>\8FD8\662F<em>\8981\63D0\53D6\7684\7B2C\4E00\884C</em>\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\8DF3\8FC7\7684\884C\6570')
,p_return_value=>'OFFSET'
,p_help_text=>unistr('\504F\79FB\503C\6307\793A\8981\8DF3\8FC7\7684\884C\6570\3002\4F8B\5982\FF0C\5982\679C\63D0\4F9B\503C 100\FF0C\5219 REST API \8FD4\56DE\4ECE\7D22\5F15 101 \5F00\59CB\7684\884C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8981\63D0\53D6\7684\7B2C\4E00\884C')
,p_return_value=>'START'
,p_help_text=>unistr('\504F\79FB\503C\6307\793A\5F00\59CB\63D0\53D6\7684\884C\3002\4F8B\5982\FF0C\5982\679C\63D0\4F9B\503C 100\FF0C\5219 REST API \8FD4\56DE\503C\5C06\8DF3\8FC7 99 \884C\FF0C\4ECE\7D22\5F15 100 \5F00\59CB\63D0\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\8FD8\6709\66F4\591A\884C\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C REST API \8FD4\56DE\4EE5\4E0B JSON \54CD\5E94\FF1A</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\4E3A <strong>metadata.pagination.moreRows</strong>\3002'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\54CD\5E94 REST API \8FD4\56DE\5173\4E8E\662F\5426\8FD8\6709\5176\4ED6\9875\7684\4FE1\606F\FF0C\5219\63D0\4F9B<em>\9009\62E9\5668</em>\4EE5\5728\6B64\5904\63D0\53D6\6B64\5C5E\6027\3002</p>'),
unistr('<p>\4E0D\9700\8981\6307\5B9A<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\FF0C\4F46\662F\5B83\6709\52A9\4E8E &PRODUCT_NAME. \5728\5DF2\63D0\53D6\6240\6709\6570\636E\65F6\4FDD\5B58\5176\4ED6 HTTP \8BF7\6C42\FF08\4E0D\8FD4\56DE\4EFB\4F55\6570\636E\7684\8BF7\6C42\FF09\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\8FD8\6709\66F4\591A\884C - \5982\679C\503C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\5982\4F55\89E3\91CA<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\5F15\7528\7684\54CD\5E94\5C5E\6027\7684\503C\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7B49\4E8E')
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F53<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\5F15\7528\7684\54CD\5E94\5C5E\6027\7B49\4E8E\67D0\4E2A\503C\65F6\FF0C\5047\5B9A\8FD8\6709\66F4\591A\884C\53EF\7528\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4E0D\4E3A\7A7A\503C')
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('\5F53<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\5F15\7528\7684\54CD\5E94\5C5E\6027\5B58\5728\4E14\4E0D\4E3A\7A7A\65F6\FF0C\5047\5B9A\8FD8\6709\66F4\591A\884C\53EF\7528\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\8FD8\6709\66F4\591A\884C - \5C5E\6027\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>\5982\679C<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\5F15\7528\7684\54CD\5E94\5C5E\6027\5305\542B\6B64\503C\FF0C\5219 &PRODUCT_NAME. \5047\5B9A\8FD8\6709\66F4\591A\884C\53EF\7528\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4417)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\603B\884C\6570\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C REST API \8FD4\56DE\4EE5\4E0B JSON \54CD\5E94 ...</p>'),
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('... <strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong> \4E3A <strong>metadata.pagination.totalRows</strong>\3002'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C REST API \5728\54CD\5E94\4E2D\8FD4\56DE<em>\603B\884C\6570</em>\FF08\6240\6709\9875\7684\603B\884C\6570\FF09\FF0C\5219\63D0\4F9B<em>\9009\62E9\5668</em>\4EE5\5728\6B64\5904\63D0\53D6\6B64\5C5E\6027\3002</p>'),
unistr('<p>\4E0D\9700\8981\6307\5B9A<strong>\8FD8\6709\66F4\591A\884C\9009\62E9\5668</strong>\FF1B<em>\53EA\8981\672A\8FDB\4E00\6B65\7B5B\9009\6570\636E</em>\FF0C\8BE5\9009\62E9\5668\5C31\53EF\4EE5\663E\793A &PRODUCT_NAME. \7EC4\4EF6\4E2D\7684\603B\884C\6570\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('\5DF2\8FDB\884C\5730\7406\7F16\7801\7684\5730\5740')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\9879\7C7B\578B\63D0\4F9B\5730\7406\7F16\7801\FF08\5C06\90AE\653F\5730\5740\8F6C\6362\4E3A\5750\6807\FF09\529F\80FD\3002<p>'),
unistr('<p>\5730\7406\7F16\7801\662F\7531<em>\6D4F\89C8\5668</em>\6267\884C\7684\FF0C\6D4F\89C8\5668\5411 <strong>Oracle Elocation</strong> \5730\7406\7F16\7801\670D\52A1 (elocation.oracle.com) \53D1\51FA REST \8BF7\6C42\3002\56E0\6B64\FF0C\6D4F\89C8\5668\5FC5\987B\8FDE\63A5\5230 Internet \624D\80FD\8FDB\884C\5730\7406\7F16\7801\3002</p>'),
unistr('<p>\5730\7406\7F16\7801\8F93\5165\6570\636E\6765\81EA\5176\4ED6\9875\9879\FF0C\8FD9\4E9B\9879\6620\5C04\5230\5730\5740\90E8\5206\FF0C\5982\8857\9053\3001\95E8\724C\53F7\3001\90AE\653F\7F16\7801\6216\57CE\5E02\3002\5730\7406\7F16\7801\5668\5C06\663E\793A\4E00\4E2A\5F39\51FA\7A97\53E3\FF0C\5176\4E2D\5305\542B\53EF\80FD\7684\5339\914D\9879\7684\5217\8868\3002\9009\62E9\5339\914D\9879\540E\FF0C\9879\7684\4F1A\8BDD\72B6\6001\503C\5C06\662F\91C7\7528 GeoJSON \683C\5F0F\7684\5730\5740\5750\6807\3002\5982\679C\542F\7528\4E86<strong>\6E05\7406\5730\5740</strong>\FF0C\5219\5730\5740\90E8\5206\9875\9879\5C06\88AB\4ECE\5730\7406\7F16\7801\670D\52A1\63A5\6536\7684\5DF2\6E05\7406\503C\8986\76D6\3002</p>'),
unistr('<p>\5BF9\4E8E\66F4\7B80\5355\7684\7528\4F8B\FF0C<strong>\975E\7ED3\6784\5316\5730\5740</strong>\6A21\5F0F\53EA\5141\8BB8\6620\5C04\4E00\4E2A\6587\672C\5B57\6BB5\6216\6587\672C\533A\57DF\FF0C\6700\7EC8\7528\6237\5728\5176\4E2D\8F93\5165\5730\5740\90E8\5206\FF0C\7528\9017\53F7\5206\9694\3002\5728\8FD9\79CD\60C5\51B5\4E0B\FF0C<strong>\6E05\7406\5730\5740</strong>\6A21\5F0F\4E0D\53EF\7528\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5730\7406\7F16\7801\5668\5339\914D\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p><strong>\5339\914D\6A21\5F0F</strong>\786E\5B9A\8F93\5165\5730\5740\7684\5C5E\6027\4E0E\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\7684\5339\914D\7A0B\5EA6\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5B8C\5168\5339\914D')
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>\63D0\4F9B\7684\6240\6709\5730\5740\90E8\5206\5FC5\987B\5339\914D\3002\4F46\662F\FF0C\5982\679C\95E8\724C\53F7\3001\8857\9053\540D\79F0\6216\8857\9053\7C7B\578B\4E0D<em>\5B8C\5168</em>\5339\914D\FF0C\5219\8FD4\56DE\4EE5\4E0B\9879\4E2D\7684\7B2C\4E00\4E2A\5339\914D\9879\FF1A\90AE\653F\7F16\7801\3001\57CE\5E02\6216\57CE\9547\548C\7701/\81EA\6CBB\533A/\76F4\8F96\5E02\3002\4F8B\5982\FF0C\5982\679C\8857\9053\540D\79F0\4E0D\6B63\786E\FF0C\4F46\6307\5B9A\4E86\6709\6548\7684\90AE\653F\7F16\7801\FF0C\5219\8FD4\56DE\90AE\653F\7F16\7801\4E2D\7684\4F4D\7F6E\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\653E\5BBD\8857\9053\7C7B\578B')
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>\63D0\4F9B\7684<em>\8857\9053\7C7B\578B</em>\53EF\4EE5\4E0E\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\4E0D\540C\3002\4F8B\5982\FF0C<strong>Main Street</strong> \6216 <strong>Main Blvd</strong> \4E0E <strong>Main St</strong> \5339\914D\FF0C\524D\63D0\662F\76F8\5173\533A\57DF\4E2D\6CA1\6709\5176\4ED6 <strong>Main Blvd</strong> \6216 <strong>Main Street</strong>\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\653E\5BBD\95E8\724C\53F7')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>\95E8\724C\53F7\548C\8857\9053\7C7B\578B\53EF\4EE5\4E0E\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\4E0D\540C\3002\4F8B\5982\FF0C<strong>123 Main St</strong> \4E0E <strong>123 Main Lane</strong> \548C <strong>124 Main St</strong> \5339\914D\FF0C\53EA\8981\6CA1\6709\6B67\4E49\6216\5176\4ED6\5339\914D\9879\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\653E\5BBD\8857\9053\540D\79F0')
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>\8857\9053\7684<em>\57FA\672C\540D\79F0</em>\3001\95E8\724C\53F7\548C\8857\9053\7C7B\578B\53EF\4EE5\4E0E\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\4E0D\540C\3002\4F8B\5982\FF0C<strong>Pleasant Vale</strong> \4E0E <strong>Pleasant Valley</strong> \5339\914D\FF0C\53EA\8981\6570\636E\4E2D\6CA1\6709\6B67\4E49\6216\5176\4ED6\5339\914D\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\653E\5BBD\90AE\653F\7F16\7801')
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>\90AE\653F\7F16\7801\FF08\5982\679C\63D0\4F9B\FF09\3001\8857\9053\540D\79F0\3001\8857\9053\7C7B\578B\548C\95E8\724C\53F7\53EF\4EE5\4E0E\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\4E0D\540C\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4417)
,p_display_sequence=>60
,p_display_value=>unistr('\5168\90E8\653E\5BBD')
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>\5730\5740\53EF\4EE5\5728\6307\5B9A\7684\57CE\5E02\4E4B\5916\FF0C\53EA\8981\5B83\5728\540C\4E00\4E2A\53BF\5185\3002\8FD8\5305\62EC<strong>\653E\5BBD\90AE\653F\7F16\7801</strong>\7684\7279\6027\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\5750\6807')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>\786E\5B9A\662F\5426\5728\5730\7406\7F16\7801\7ED3\679C\5F39\51FA\5BF9\8BDD\6846\4E2D\663E\793A\5730\5740\5750\6807\FF08\7ECF\5EA6\548C\7EAC\5EA6\FF09\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5730\56FE\9884\89C8')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\662F\5426\5141\8BB8\5728\5730\56FE\4E0A\9884\89C8\5DF2\8FDB\884C\5730\7406\7F16\7801\7684\5730\5740\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7ED3\679C\5F39\51FA\7A97\53E3')
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\5730\7406\7F16\7801\7ED3\679C\5F39\51FA\7A97\53E3\4E2D\663E\793A\5730\56FE\FF0C\4EE5\4FBF\7528\6237\53EF\4EE5\5728\9009\62E9\7ED3\679C\4E4B\524D\67E5\770B\4F4D\7F6E\3002</p>'),
unistr('<p>\4EC5\5F53\542F\7528\201C\663E\793A\4E3A - \7F51\683C\89C6\56FE\201D\65F6\FF0C\624D\652F\6301\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9879')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\663E\793A\53EF\5728\9879\4F4D\7F6E\53EF\89C6\5316\5730\5740\4F4D\7F6E\7684\5730\56FE\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\80CC\666F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\53D6\8981\5728\5176\4E0A\663E\793A\5730\7406\7F16\7801\7ED3\679C\7684\80CC\666F\5730\56FE\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\9ED8\8BA4\503C')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\9ED8\8BA4\5730\56FE\80CC\666F\3002</p>'),
unistr('<p>\5B83\9488\5BF9\6DF1\8272\4E3B\9898\4F7F\7528\201COpenStreetMap \4EAE\8272\201D\6216\201COpenStreetMap \6697\8272\201D\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4417)
,p_display_sequence=>10
,p_display_value=>unistr('OpenStreetMap \4EAE\8272')
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\8BE6\7EC6\7684\4F4D\7F6E\4E0A\4E0B\6587\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4417)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap \6697\8272')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6697\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4417)
,p_display_sequence=>30
,p_display_value=>unistr('OpenStreetMap \6B63\7535\5B50')
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6D45\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4417)
,p_display_sequence=>40
,p_display_value=>unistr('Oracle \4E16\754C\5730\56FE')
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E HERE \5730\56FE\6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\4F4D\7F6E\4E0A\4E0B\6587\FF0C\5E76\4E14\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 Oracle USA \63D0\4F9B\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9AD8\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\50CF\7D20')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6240\663E\793A\5730\56FE\7684\9AD8\5EA6\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002</p>'),
unistr('<p>\5730\56FE\7684\9ED8\8BA4\9AD8\5EA6\662F\57FA\4E8E\5730\56FE\7684\5BBD\5EA6\6309\7167 3:2 \7684\7EB5\6A2A\6BD4\8BA1\7B97\7684\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>unistr('\663E\793A\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\5730\7406\7F16\7801\7ED3\679C\7684\663E\793A\65B9\5F0F\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5217\8868\89C6\56FE')
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>\5C06\5728\5217\8868\89C6\56FE\4E2D\663E\793A\7ED3\679C\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\7F51\683C\89C6\56FE')
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>\5C06\5728\7F51\683C\89C6\56FE\4E2D\663E\793A\7ED3\679C\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('\7ED3\6784\5316\5730\5740')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5730\5740\90E8\5206\662F\4EE5<em>\7ED3\6784\5316</em>\8FD8\662F<em>\975E\7ED3\6784\5316</em>\65B9\5F0F\63D0\4F9B\7ED9\5730\7406\7F16\7801\670D\52A1\3002</p>'),
unistr('<p>\7ED3\6784\5316\610F\5473\7740\663E\5F0F\9875\9879\6620\5C04\5230\5730\5740\90E8\5206\FF08\5982\8857\9053\3001\90AE\653F\7F16\7801\3001\57CE\5E02\6216\533A\57DF\FF09\3002\8FD9\5C06\5BFC\81F4\66F4\51C6\786E\7684\5730\7406\7F16\7801\7ED3\679C\FF0C\5E76\4E14\8FD8\5141\8BB8\5C06'),
unistr('\66F4\6B63\7684\5730\5740\9988\9001\56DE\5230\8FD9\4E9B\9875\9879\3002</p>'),
unistr('<p>\975E\7ED3\6784\5316\610F\5473\7740\6574\4E2A\5730\5740\53EA\4F7F\7528\4E00\9879\FF1B\5404\4E2A\90E8\5206\7528\9017\53F7\5206\9694\3002\6B64\6A21\5F0F\4E0D\5141\8BB8\5C06\66F4\6B63\7684\5730\5740\9988\9001\56DE\5230\9875\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\56FD\5BB6/\5730\533A\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\662F\4F7F\7528\9759\6001\56FD\5BB6/\5730\533A\8FDB\884C\5730\7406\7F16\7801\FF0C\8FD8\662F\4ECE\9879\6D3E\751F\56FD\5BB6/\5730\533A\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9759\6001')
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>\4F7F\7528\9009\62E9\5217\8868\4E2D\7684\9759\6001\56FD\5BB6/\5730\533A\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9879')
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>\4ECE\5E94\7528\7A0B\5E8F\9879\6216\9875\9879\83B7\53D6\56FD\5BB6/\5730\533A\3002\9879\5FC5\987B\5305\542B\56FD\5BB6/\5730\533A\7684 2 \4F4D ISO \4EE3\7801\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\56FD\5BB6/\5730\533A')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('<li><strong>US</strong>\FF1A\7F8E\56FD</li>'),
unistr('<li><strong>UK</strong>\FF1A\82F1\56FD</li>'),
unistr('<li><strong>DE</strong>\FF1A\5FB7\56FD</li>'),
unistr('<li><strong>AT</strong>\FF1A\5965\5730\5229</li>'),
'</ul>'))
,p_help_text=>unistr('<p>\9009\53D6\8981\4ECE\4E2D\83B7\53D6\7528\4E8E\5730\7406\7F16\7801\7684\56FD\5BB6/\5730\533A\7684\9875\9879\6216\5E94\7528\7A0B\5E8F\9879\3002\8BE5\9879\5FC5\987B\5305\542B\56FD\5BB6/\5730\533A\7684 2 \4F4D ISO \4EE3\7801\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\56FD\5BB6/\5730\533A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\53D6\8981\7528\4E8E\5730\7406\7F16\7801\7684\56FD\5BB6/\5730\533A\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7F8E\56FD')
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\82F1\56FD')
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5FB7\56FD')
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\6CD5\56FD')
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\610F\5927\5229')
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>60
,p_display_value=>unistr('\52A0\62FF\5927')
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>70
,p_display_value=>unistr('\8377\5170')
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>80
,p_display_value=>unistr('\6BD4\5229\65F6')
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>90
,p_display_value=>unistr('\5965\5730\5229')
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>100
,p_display_value=>unistr('\745E\58EB')
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>110
,p_display_value=>unistr('\897F\73ED\7259')
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>120
,p_display_value=>unistr('\8461\8404\7259')
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>130
,p_display_value=>unistr('\4FC4\7F57\65AF\8054\90A6')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>140
,p_display_value=>unistr('\7231\6C99\5C3C\4E9A')
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>150
,p_display_value=>unistr('\5370\5EA6')
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>160
,p_display_value=>unistr('\58A8\897F\54E5')
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>170
,p_display_value=>unistr('\6FB3\5927\5229\4E9A')
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>180
,p_display_value=>unistr('\5DF4\897F')
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>190
,p_display_value=>unistr('\667A\5229')
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>200
,p_display_value=>unistr('\6377\514B\5171\548C\56FD')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>210
,p_display_value=>unistr('\632A\5A01')
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>220
,p_display_value=>unistr('\82AC\5170')
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>230
,p_display_value=>unistr('\4E39\9EA6')
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>240
,p_display_value=>unistr('\4E2D\56FD\9999\6E2F')
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>250
,p_display_value=>unistr('\7231\5C14\5170')
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>260
,p_display_value=>unistr('\62C9\8131\7EF4\4E9A')
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>270
,p_display_value=>unistr('\7F57\9A6C\5C3C\4E9A')
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>280
,p_display_value=>unistr('\54E5\4F26\6BD4\4E9A')
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>290
,p_display_value=>unistr('\6CE2\5170')
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>300
,p_display_value=>unistr('\963F\62C9\4F2F\8054\5408\914B\957F\56FD')
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>310
,p_display_value=>unistr('\5308\7259\5229')
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>320
,p_display_value=>unistr('\6C99\7279\963F\62C9\4F2F')
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4417)
,p_display_sequence=>330
,p_display_value=>unistr('\5357\975E')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('\5730\5740\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\975E\7ED3\6784\5316\5730\5740\90E8\5206\FF08\7528\9017\53F7\5206\9694\FF09\7684\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>unistr('\8857\9053\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\5730\5740\7684<em>\8857\9053</em>\90E8\5206\7684\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('\95E8\724C\53F7\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\5730\5740\7684<em>\95E8\724C\53F7</em>\90E8\5206\7684\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('\57CE\5E02\5B50\533A\57DF\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\5730\5740\7684<em>\5B50\533A\57DF\FF08\5728\57CE\5E02\5185\FF09</em>\90E8\5206\7684\9879\3002</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>unistr('\57CE\5E02\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\5730\5740\7684<em>\57CE\5E02</em>\90E8\5206\7684\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\90AE\653F\7F16\7801\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\5730\5740\7684<em>\90AE\653F\7F16\7801</em>\90E8\5206\7684\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('\533A\57DF\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\9009\53D6\5305\542B\5730\5740\7684<em>\533A\57DF\FF08\7701/\81EA\6CBB\533A/\76F4\8F96\5E02\FF09</em>\90E8\5206\7684\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\6E05\7406\5730\5740')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\542F\7528\6B64\5F00\5173\53EF\5C06\5730\5740\6570\636E\4ECE\5730\7406\7F16\7801\670D\52A1\9988\9001\56DE\5230\6620\5C04\9879\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>unistr('\5339\914D\5411\91CF\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\5730\7406\7F16\7801\5668\9009\53D6\4E00\4E2A\8981\5C06<em>\5339\914D\5411\91CF</em>\8FD4\56DE\5230\5176\4E2D\7684\9875\9879\3002\5339\914D\5411\91CF\662F\4E00\4E2A 17 \4F4D\7684\5B57\7B26\4E32\FF0C\5176\4E2D\5305\542B\6709\5173\5982\4F55\5C06\6BCF\4E2A\5730\5740\5C5E\6027\4E0E\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\8FDB\884C\5339\914D\7684\8BE6\7EC6\4FE1\606F\3002</p>'),
unistr('<p><strong>\5339\914D\5411\91CF\6570\5B57\53EF\4EE5\5177\6709\4EE5\4E0B\503C\FF1A</strong></p>'),
'<ul>',
unistr('<li><p>0\FF1A\8F93\5165\5C5E\6027\4E0D\4E3A\7A7A\503C\5E76\4E14\4E0E\975E\7A7A\503C\5339\914D\3002</p></li>'),
unistr('<li><p>1\FF1A\8F93\5165\5C5E\6027\4E3A\7A7A\503C\5E76\4E14\4E0E\7A7A\503C\5339\914D\3002</p></li>'),
unistr('<li><p>2\FF1A\8F93\5165\5C5E\6027\4E0D\4E3A\7A7A\503C\5E76\4E14\5C06\66FF\6362\4E3A\5176\4ED6\975E\7A7A\503C\3002</p></li>'),
unistr('<li><p>3\FF1A\8F93\5165\5C5E\6027\4E0D\4E3A\7A7A\503C\5E76\4E14\5C06\66FF\6362\4E3A\7A7A\503C\3002</p></li>'),
unistr('<li><p>4\FF1A\8F93\5165\5C5E\6027\4E3A\7A7A\503C\5E76\4E14\5C06\66FF\6362\4E3A\975E\7A7A\503C\3002</p></li>'),
'</ul>',
'<br>',
unistr('<p><strong>\5339\914D\5411\91CF\6570\5B57\4EE5\53CA\4E0E\6BCF\4E2A\6570\5B57\76F8\5BF9\5E94\7684\5730\5740\5C5E\6027\FF1A</strong></p>'),
'<ul>',
unistr('<li><p>3\FF1A\5730\5740\70B9\FF08\5728\7528\4E8E\5730\7406\7F16\7801\7684\6570\636E\4E2D\5339\914D\7684\786E\5207\5730\5740\FF09</p></li>'),
unistr('<li><p>4\FF1A\666F\70B9\540D\79F0</p></li>'),
unistr('<li><p>5\FF1A\95E8\724C\53F7</p></li>'),
unistr('<li><p>6\FF1A\8857\9053\524D\7F00</p></li>'),
unistr('<li><p>7\FF1A\8857\9053\540D\79F0</p></li>'),
unistr('<li><p>8\FF1A\8857\9053\540E\7F00</p></li>'),
unistr('<li><p>9\FF1A\8857\9053\7C7B\578B</p></li>'),
unistr('<li><p>10\FF1A\4E8C\7EA7\5355\4F4D</p></li>'),
unistr('<li><p>11\FF1A\57CE\5E02</p></li>'),
unistr('<li><p>14\FF1A\533A\57DF</p></li>'),
unistr('<li><p>15\FF1A\56FD\5BB6/\5730\533A</p></li>'),
unistr('<li><p>16\FF1A\90AE\653F\7F16\7801</p></li>'),
unistr('<li><p>17\FF1A\90AE\653F\9644\52A0\4EE3\7801 </p></li>'),
unistr('<li><p><em>\5176\4ED6\6570\5B57\5C1A\672A\4F7F\7528\3002</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\89E6\53D1\5730\7406\7F16\7801')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\786E\5B9A\4F55\65F6\89E6\53D1\5730\7406\7F16\7801\3002\8FD9\5305\62EC\6D4F\89C8\5668\6267\884C\5BF9\5730\7406\7F16\7801\670D\52A1\7684 REST \8BF7\6C42\FF0C\5E76\663E\793A\5305\542B\53EF\80FD\5339\914D\9879\7684\5F39\51FA\7A97\53E3\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\81EA\52A8')
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\63D0\4EA4\9875\9762\524D\4F1A\81EA\52A8\89E6\53D1\5730\7406\7F16\7801\3002</p>'),
unistr('<p>\5982\679C\76F8\5173\9879\7684\503C\66F4\6539\FF0C\4F8B\5982 <em>P1_STREET</em> \7684\503C\66F4\6539\FF0C\4E14\5C1A\672A\6267\884C\5730\7406\7F16\7801\FF1B\6216\672A\9009\62E9\6709\6548\5730\5740\FF0C\7CFB\7EDF\4F1A\786E\4FDD\81EA\52A8\89E6\53D1\5730\7406\7F16\7801\3002\5728\8FD9\79CD\60C5\51B5\4E0B\FF0C\7CFB\7EDF\4F1A\4E2D\65AD\5F53\524D\9875\9762\7684\63D0\4EA4\6D41\FF0C\5E76\663E\793A\5305\542B\53EF\80FD\5339\914D\9879\7684\5F39\51FA\7A97\53E3\3002\5982\679C\7528\6237\9009\62E9\4E86\5339\914D\7ED3\679C\FF0C\53EF\4EE5\91CD\65B0\63D0\4EA4\9875\9762\800C\4E0D\518D\53D1\751F\5176\4ED6\4E2D\65AD\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\52A8\6001\64CD\4F5C')
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>\5FC5\987B\901A\8FC7\5411\9875\4E2D\6DFB\52A0\52A8\6001\64CD\4F5C<em>\89E6\53D1\5730\7406\7F16\7801</em>\6765\89E6\53D1\5730\7406\7F16\7801\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4417)
,p_display_sequence=>30
,p_display_value=>unistr('jQuery \9009\62E9\5668')
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>\57FA\4E8E\9009\62E9\5668\6240\9488\5BF9\7684 DOM \5143\7D20\4E0A\7684\4E8B\4EF6\89E6\53D1\5730\7406\7F16\7801\3002\5982\679C\5F15\7528\4E86\8F93\5165\5B57\6BB5\FF0C\5219\4F1A\5728\5143\7D20<em>\66F4\6539\65F6</em>\89E6\53D1\5730\7406\7F16\7801\FF1B\5982\679C\5F15\7528\4E86\6309\94AE\FF0C\5219\5C06\5728<em>\5355\51FB\65F6</em>\89E6\53D1\5730\7406\7F16\7801\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><em>P1_STREET</em> \548C <em>P1_ZIP_CODE</em> \9879\66F4\6539\65F6\6267\884C\8FDB\7A0B\FF0CjQuery \9009\62E9\5668\FF1A</p>'),
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>\63D0\4F9B jQuery \9009\62E9\5668\FF0C\8BE5\9009\62E9\5668\5F15\7528\53EF\89E6\53D1\5730\7406\7F16\7801\7684\5143\7D20\3002\6309\94AE\5C06<em>\5728\5355\51FB\65F6</em>\89E6\53D1\5730\7406\7F16\7801\FF0C\5176\4ED6\5143\7D20\5C06<em>\5728\66F4\6539\65F6</em>\89E6\53D1\3002</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('\5730\7406\7F16\7801\54CD\5E94')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4417)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4417)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('\7ED3\679C\9009\62E9')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>unistr('\667A\80FD\7B5B\9009\5668')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>\57FA\4E8E\5173\8054\667A\80FD\7B5B\9009\5668\6E90\7684\533A\57DF\FF0C\53EF\4E3A\6700\7EC8\7528\6237\63D0\4F9B\5927\91CF\7B5B\9009\5668\FF0C\4EE5\5728\8FD0\884C\65F6\7F29\5C0F\641C\7D22\7ED3\679C\8303\56F4\3002</p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5927\5EFA\8BAE\6761\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\8981\663E\793A\7684\6700\5927\5EFA\8BAE\6761\6570\3002\5982\679C\672A\6307\5B9A\FF0C\5219\4F7F\7528\9ED8\8BA4\503C 5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\66F4\591A\7B5B\9009\5668\5EFA\8BAE\6761')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\672A\663E\793A\4E3A\5EFA\8BAE\6761\7684\7B5B\9009\5668\662F\5426\53EF\901A\8FC7\201C\66F4\591A\7B5B\9009\5668\201D\4E0B\62C9\83DC\5355\6309\94AE\6765\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\7B80\6D01\6570\5B57\9608\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('\63D0\4F9B\4E00\4E2A\9608\503C\FF0C\5982\679C\8D85\8FC7\8BE5\503C\FF0C\5219\4F1A\4F7F\7528\7B80\6D01\6570\5B57\683C\5F0F\663E\793A\8BA1\6570\3002\901A\8FC7\4F7F\7528\7B80\6D01\6570\5B57\683C\5F0F\FF0C\503C <strong>1,234</strong> \5C06\663E\793A\4E3A <strong>1K</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\663E\793A\603B\884C\6570')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\663E\793A\603B\884C\6570\7684\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\4E0D\663E\793A\603B\884C\6570\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>unistr('\5728\5EFA\8BAE\6761\4E0B\9762\663E\793A\603B\884C\6570\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9009\62E9\5668')
,p_return_value=>'E'
,p_help_text=>unistr('\5728\6B64\9009\62E9\5668\6307\5B9A\7684\5143\7D20\4E2D\663E\793A\603B\884C\6570\FF08\65E0\4EFB\4F55\6807\7B7E\FF09\3002\8FD9\6837\FF0C\60A8\53EF\4EE5\5C06\603B\884C\6570\653E\5728\9875\9762\4E0A\7684\4EFB\4F55\4F4D\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\603B\884C\6570\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\7528\4E8E\603B\884C\6570\7684\6807\7B7E\3002\5982\679C\6B64\5904\672A\63D0\4F9B\6807\7B7E\FF0C\5219 APEX \5C06\4F7F\7528 APEX.FS.TOTAL_ROW_COUNT_LABEL \6587\672C\6D88\606F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\603B\884C\6570\9009\62E9\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('\8FD9\662F\9875\9762\4E0A\5C06\4F9B\667A\80FD\7B5B\9009\5668\533A\57DF\663E\793A\603B\884C\6570\7684\5143\7D20\7684\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4417)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4417)
,p_name=>'facetschange'
,p_display_name=>unistr('\7B5B\9009\5668\66F4\6539')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4417)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4417)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4417)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4417)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8FD4\56DE\65E7 ORDS JSON')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64 ORDS REST \670D\52A1\4EE5 <em>ORDS \65E7 JSON \8868\793A\5F62\5F0F</em>\8FD4\56DE\6570\636E\FF0C\5219\542F\7528\6B64\9009\9879\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>unistr('\641C\7D22')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\6587\672C\5B57\6BB5\FF0C\4EE5\5141\8BB8\6700\7EC8\7528\6237\5728\5206\9762\641C\7D22\533A\57DF\4E2D\641C\7D22\9762\7684\5217\8868\6761\76EE\3002\4E00\4E2A\5206\9762\641C\7D22\533A\57DF\652F\6301\4E00\4E2A\641C\7D22\9762\FF0C\65E0\8BBA\5176\5E8F\5217\4E3A\4F55\FF0C\59CB\7EC8\4F4D\4E8E\9762\5217\8868\9876\90E8\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4417)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\641C\7D22\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\884C\641C\7D22')
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4417)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4417)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8F93\5165\5B57\6BB5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5206\9762\641C\7D22\533A\57DF\9876\90E8')
,p_return_value=>'FACET'
,p_help_text=>unistr('\5C06\5728\5206\9762\641C\7D22\533A\57DF\9876\90E8\9762\4E0A\65B9\5448\73B0\4E00\4E2A\641C\7D22\5B57\6BB5\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5916\90E8\9875\9879')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('\53EF\4EE5\4F7F\7528\5173\8054\7684\201C\5916\90E8\9875\9879\201D\5C5E\6027\9009\62E9\9875\9879\FF0C\4EE5\7528\4F5C\5206\9762\641C\7D22\533A\57DF\7684\641C\7D22\5B57\6BB5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4417)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5916\90E8\9875\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4417)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6298\53E0\7684\641C\7D22\5B57\6BB5')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\201C\667A\80FD\7B5B\9009\5668\201D\641C\7D22\5B57\6BB5\6700\521D\662F\5426\5904\4E8E\6298\53E0\72B6\6001\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>unistr('\5730\56FE')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4417)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4417)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4417)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4417)
,p_name=>'spatialmapchanged'
,p_display_name=>unistr('\5DF2\66F4\6539\5730\56FE')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4417)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4417)
,p_name=>'spatialmapclick'
,p_display_name=>unistr('\5DF2\5355\51FB\5730\56FE')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4417)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4417)
,p_name=>'spatialmapinitialized'
,p_display_name=>unistr('\5DF2\521D\59CB\5316\5730\56FE')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4417)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4417)
,p_name=>'spatialmapobjectclick'
,p_display_name=>unistr('\5DF2\5355\51FB\5730\56FE\5BF9\8C61')
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>unistr('\8868\5355')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\652F\6301\5404\79CD\6570\636E\6E90\7684\8868\5355\533A\57DF\3002\6B64\8868\5355\533A\57DF\5B58\653E\6709\5173\6570\636E\6E90\FF08\53EF\4EE5\662F\672C\5730\7684\3001\8FDC\7A0B\7684\6216 REST \670D\52A1\FF09\7684\4FE1\606F\5E76\4E14\5177\6709\5206\914D\7ED9\5B83\7684\9875\9879\3002\6BCF\4E2A\9879\90FD\5206\914D\7ED9\4E00\4E2A\8868\5355\533A\57DF\548C\4E00\4E2A\663E\793A\533A\57DF\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4417)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4417)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>unistr('\8868\5355 - \81EA\52A8\884C\5904\7406 (DML)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\63D2\5165\3001\66F4\65B0\6216\5220\9664\8868\5355\533A\57DF\884C\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76EE\6807\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\4E3A\4FDD\5B58\5BF9\8868\5355\533A\57DF\6240\505A\7684\6570\636E\66F4\6539\800C\6267\884C\7684\884C\5904\7406\6280\672F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\533A\57DF\6E90')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165, \66F4\65B0\548C\5220\9664\64CD\4F5C\4F7F\7528\533A\57DF\6E90 SQL \67E5\8BE2\3002</p>'),
unistr('<p>\6CE8 - \5BF9\4E8E\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\7684\5217, \786E\4FDD<strong>\4EC5\67E5\8BE2</strong>\8BBE\7F6E\4E3A<code>\662F</code>\4EE5\6392\9664\8FD9\4E9B\5217\800C\4E0D\8FDB\884C\5904\7406\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8868/\89C6\56FE')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165, \66F4\65B0\548C\5220\9664\64CD\4F5C\4F7F\7528\7684\8868\6216\89C6\56FE\4E0D\540C\4E8E\533A\57DF\6E90 SQL \67E5\8BE2\4E2D\5B9A\4E49\7684\8868\6216\89C6\56FE\3002'),
unistr('\4F8B\5982, SQL \67E5\8BE2\4ECE\8868\8054\63A5\7684\89C6\56FE\6216\53EF\8FDE\63A5\7684\89C6\56FE\68C0\7D22\6570\636E, \5E76\4E14\9700\8981\5BF9\5355\4E2A\57FA\8868\6216\53EF\66F4\65B0\89C6\56FE\6267\884C DML \5904\7406\3002</p>'),
unistr('<p>\6CE8 - \5BF9\4E8E\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\7684\5217, \786E\4FDD<strong>\4EC5\67E5\8BE2</strong>\8BBE\7F6E\4E3A<code>\662F</code>\4EE5\6392\9664\8FD9\4E9B\5217\800C\4E0D\8FDB\884C\5904\7406\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \4EE3\7801')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5904\7406\64CD\4F5C\57FA\4E8E\5B9A\5236 PL/SQL \4EE3\7801\3002\4F7F\7528\6B64\9009\9879\53EF\4EE5\6267\884C\4EFB\4F55 PL/SQL \4EE3\7801\4EE5\5728\57FA\7840\6570\636E\5E93\4E2D\5B9E\65BD\4EFB\4F55\6570\636E\64CD\7EB5\3002</p>'),
unistr('<p>\5F53\4F7F\7528\6570\636E\5E93\7A0B\5E8F\5305 (\4F8B\5982\8868 API \6216 RESTful Web \670D\52A1\8C03\7528) \5B9E\65BD\4E1A\52A1\903B\8F91\65F6, \5E94\4F7F\7528\6B64\9009\9879\3002</p>'),
unistr('<p>\6CE8 - \5C06\4E3A\5DF2\63D2\5165, \5DF2\66F4\65B0\6216\5DF2\5220\9664\7684\6BCF\4E00\884C\8C03\7528 PL/SQL \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4417)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7528\4E8E\6267\884C\63D2\5165/\66F4\65B0/\5220\9664\7684 PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 PL/SQL \4EE3\7801\4EE5\5904\7406\5728\8868\5355\533A\57DF\4E2D\64CD\7EB5\7684\6BCF\4E00\884C\6570\636E\3002</p>'),
unistr('<p>\4F7F\7528\5217\540D\4F5C\4E3A\7ED1\5B9A\53D8\91CF\6765\8BBF\95EE\5217\503C\3002\7CFB\7EDF\53D8\91CF <code>APEX$ROW_STATUS</code> \8FD4\56DE\884C\7684\72B6\6001\FF0C\53EF\7528\4E8E\68C0\67E5\662F\5426\5DF2\521B\5EFA\3001\66F4\65B0\6216\5220\9664\4E86\884C\FF08\8BF7\53C2\9605\4EE5\4E0B\793A\4F8B\6765\4E86\89E3\5982\4F55\68C0\67E5\6B64\9879\FF09\3002</p>'),
unistr('<p><em>\6CE8\FF1A</em>\5982\679C\7531\89E6\53D1\5668\6216\8005\5728 PL/SQL \4EE3\7801\4E2D\586B\5145\4E86\4E3B\952E\5217\FF0C\5219\9700\8981\5C06\65B0\503C\5206\914D\5230\4E3B\952E\5217\7684\7ED1\5B9A\53D8\91CF\FF0C\56E0\4E3A &PRODUCT_NAME. \4F7F\7528\8FD9\4E9B\503C\5728\63D2\5165\6216\66F4\65B0\4E4B\540E\63D0\53D6\884C\3002</p>'),
unistr('<p>Oracle \5EFA\8BAE\8C03\7528 PL/SQL \7A0B\5E8F\5305\5185\7684\8FC7\7A0B\6216\51FD\6570\FF0C\4EE5\4FBF\4E8E\91CD\7528\548C\7EF4\62A4\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9632\6B62\4E22\5931\66F4\65B0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5904\7406\662F\5426\5E94\5728\591A\4E2A\7528\6237\66F4\65B0\540C\4E00\6761\6570\636E\5E93\8BB0\5F55\65F6\786E\4FDD\66F4\65B0\4E0D\4E22\5931\3002</p> '),
unistr('<p>\5982\679C\4E24\4E2A\6216\66F4\591A\4EBA\5458\5C1D\8BD5\66F4\65B0\540C\4E00\6570\636E\5E76\4E14\6700\540E\7684\66F4\65B0\8986\76D6\7B2C\4E00\4E2A\7528\6237\6240\505A\7684\66F4\65B0\6765\4FDD\5B58\66F4\6539, \66F4\65B0\4F1A\4E22\5931\3002\4E3A\9632\6B62\53D1\751F\8FD9\79CD\60C5\51B5, \66F4\65B0\4F1A\68C0\67E5\6570\636E\5E93\4E2D\7684\73B0\6709\5217\503C\4EE5\53CA\6700\521D\67E5\8BE2\884C\65F6\68C0\7D22\5230\7684\76F8\5E94\503C\3002</p>'),
unistr('<p>\4F8B\5982:'),
'  <ol>',
unistr('    <li>\7528\6237 A \67E5\8BE2\96C7\5458 (EMP) \8BB0\5F55\3002</li>'),
unistr('    <li>\7528\6237 B \67E5\8BE2\76F8\540C\7684\96C7\5458\8BB0\5F55\3002</li>'),
unistr('    <li>\7528\6237 B \66F4\65B0 EMPNO = 7839 \7684\96C7\5458\8BE6\7EC6\4FE1\606F\5E76\5411\6570\636E\5E93\5E94\7528 (\63D0\4EA4) \66F4\6539\3002</li>'),
unistr('    <li>\7528\6237 A \66F4\65B0 EMPNO = 7839 \7684\96C7\5458\8BE6\7EC6\4FE1\606F\5E76\5C1D\8BD5\5411\6570\636E\5E93\5E94\7528\66F4\6539\3002</li>'),
'  </ol>',
unistr('\5982\679C\7528\6237 A \6210\529F\66F4\65B0\76F8\540C\7684\884C, \5219\7528\6237 B \6240\505A\7684\66F4\6539\5C06\4E22\5931\3002'),
unistr('\5F53\7528\6237 A \5C1D\8BD5\4FDD\5B58\96C7\5458\884C\65F6, \6570\636E\5E93\4E2D\7684\6570\636E\4E0D\540C\4E8E\7528\6237 A \6700\521D\67E5\8BE2\5230\7684\6570\636E\3002\5728\4E0A\9762\7684\6B65\9AA4 1 \4E2D, \53EF\4EE5\6355\83B7\7528\6237 A \6700\521D\67E5\8BE2\7684\5217\503C\3002\7136\540E\5728\4E0A\9762\7684\6B65\9AA4 4 \4E2D, \8FD9\4E9B\503C\53EF\4E0E\6570\636E\5E93\4E2D\7684\5F53\524D\503C\8FDB\884C\6BD4\8F83\3002\6B64\6BD4\8F83\5C06\5BF9\7528\6237 A \5F15\53D1\9519\8BEF, \56E0\4E3A\6570\636E\5E93\503C\7531\7528\6237 B \5728\6B65\9AA4 3 \4E2D\8FDB\884C\4E86\66F4\65B0\3002\8FD9\53EF\9632\6B62\7528\6237\8986\76D6\5176\4ED6\7528\6237\5BF9\76F8\540C\884C\6240\505A\7684\66F4\6539\3002</p>'),
unistr('<p>\6CE8 - \6839\636E<strong>\4E22\5931\7684\66F4\65B0\7C7B\578B</strong>\7684\8BBE\7F6E, \5728\201C\4EA4\4E92\5F0F\7F51\683C\7684\5C5E\6027\201D\533A\57DF\4E2D\6307\5B9A\5982\4F55\68C0\6D4B\4E22\5931\7684\66F4\65B0\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\9501\5B9A\884C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\5728\5904\7406\6BCF\4E00\884C\4E4B\524D\662F\5426\5728\57FA\7840\8868\4E2D\9501\5B9A\8981\66F4\65B0\6216\5220\9664\7684\76F8\5E94\884C\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C06\4F7F\7528 SELECT ... FOR UPDATE \9501\5B9A\8981\66F4\65B0\6216\5220\9664\7684\884C\76F4\81F3\63D0\4EA4\4E8B\52A1\5904\7406, \4ECE\800C\963B\6B62\5BF9\8FD9\4E9B\884C\6267\884C\5176\4ED6\4E8B\52A1\5904\7406\3002</p>'),
unistr('<p>\6CE8 - \5982\679C\5F15\53D1\9519\8BEF (\4F8B\5982, \53EF\66F4\65B0\7684\89C6\56FE\4E0D\652F\6301\9501\5B9A), \53EF\4EE5\4F7F\7528 PL/SQL \4EE3\7801\9501\5B9A\9A71\52A8\8868\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\5C06\4E0D\9501\5B9A\884C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4417)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \4EE3\7801')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\5B9A\5236 PL/SQL \4EE3\7801\5C06\7528\4E8E\9501\5B9A\884C, \76F4\81F3\63D0\4EA4\4E8B\52A1\5904\7406\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7528\4E8E\9501\5B9A\884C\7684 PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('\8F93\5165 PL/SQL \4EE3\7801\4EE5\9501\5B9A\8981\66F4\65B0\548C\5220\9664\7684\6570\636E\5E93\8868\884C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4417)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\63D2\5165\540E\8FD4\56DE\4E3B\952E')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\662F\5426\5E94\5F53\5728\884C\63D2\5165\5230\6570\636E\5E93\4E4B\540E\5C06\4E3B\952E\5217\8FD4\56DE\5230\5BF9\5E94\7684\533A\57DF\9879\3002'),
unistr('\901A\5E38\FF0C\5F53\4ECE\6570\636E\5E93\89E6\53D1\5668\6216 Oracle Database 12 <em>c</em> \6807\8BC6\5217\586B\5145\4E3B\952E\5217\65F6\FF0C\5E94\4F7F\7528\6B64\9009\9879\3002</p>'),
unistr('<p>\6CE8 - \5982\679C\5F15\53D1\4E86\9519\8BEF\FF0C\5E76\4E14\6307\5B9A\4E0D\5141\8BB8\4F7F\7528 RETURNING INTO \5B50\53E5\FF0C\5219\5FC5\987B\5C06\6B64\9009\9879\8BBE\7F6E\4E3A\201C\5426\201D\5E76\9884\5148\586B\5145\4E3B\952E\5217\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>unistr('\8868\5355 - \521D\59CB\5316')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\521D\59CB\5316\8868\5355\533A\57DF\9879\7684\5904\7406\3002\521D\59CB\5316\53EF\4EE5\4F7F\7528\4E3B\952E\503C\6216\8868\5355\533A\57DF\9879\7684\7B80\5355\521D\59CB\5316\4ECE\533A\57DF\6E90\63D0\53D6\6570\636E\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4417)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4E0B\4E00\4E2A\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4417)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4E0A\4E00\4E2A\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4417)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5F53\524D\884C/\603B\8BA1\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>unistr('\6570\636E\52A0\8F7D')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\5C06\6570\636E\52A0\8F7D\5230\76EE\6807\8868\6216\96C6\5408\4E2D\7684\5904\7406\FF08\6839\636E\7ED9\5B9A\6570\636E\52A0\8F7D\5B9A\4E49\FF09\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4ECE\201C\5171\4EAB\7EC4\4EF6\201D\4E2D\9009\62E9<em>\6570\636E\52A0\8F7D\5B9A\4E49</em>\3002\8FDE\540C\5176\4ED6\5C5E\6027\4E00\8D77\FF0C\6570\636E\52A0\8F7D\5B9A\4E49\5B9A\4E49\4E86\76EE\6807\8868\6216\96C6\5408\3001\52A0\8F7D\65B9\6CD5\548C<em>\6570\636E\6982\8981\6587\4EF6</em>\3002\6240\6709\5217\540D\3001\5217\6620\5C04\548C\6570\636E\7C7B\578B\4FE1\606F\90FD\5B58\50A8\5728\6570\636E\6982\8981\6587\4EF6\4E2D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6E90\6570\636E\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\8981\52A0\8F7D\7684\6570\636E\6E90\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6587\4EF6\6D4F\89C8\9879')
,p_return_value=>'FILE'
,p_help_text=>unistr('\9009\53D6\5F53\524D\9875\4E0A\7684\6587\4EF6\6D4F\89C8\9879\7684\540D\79F0\3002APEX \5C06\4ECE\6240\9009\6587\4EF6\52A0\8F7D\6570\636E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\6587\672C\533A\57DF\9879\540D')
,p_return_value=>'TEXT'
,p_help_text=>unistr('\9009\53D6\6587\672C\533A\57DF\9879\7684\540D\79F0\FF0C\8BE5\9879\5305\542B\8981\52A0\8F7D\7684\6570\636E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4417)
,p_display_sequence=>30
,p_display_value=>unistr('SQL \67E5\8BE2')
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('\63D0\4F9B SQL \67E5\8BE2\FF0C\8FD4\56DE\5305\542B\8981\52A0\8F7D\7684\6570\636E\7684 CLOB \6216 BLOB\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6587\4EF6\6D4F\89C8\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('\9009\53D6\8981\4ECE\4E2D\52A0\8F7D\6570\636E\7684\6587\4EF6\6D4F\89C8\9879\3002\8BE5\9879\5FC5\987B\4F7F\7528 <strong>APEX_APPLICATION_TEMP_FILES</strong> \4F5C\4E3A\5176<strong>\5B58\50A8\7C7B\578B</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6587\672C\533A\57DF\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\9009\53D6\6587\672C\533A\57DF\9879\7684\540D\79F0\FF0C\8BE5\9879\5305\542B\8981\52A0\8F7D\7684\6570\636E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('SQL \67E5\8BE2')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>unistr('\63D0\4F9B\8FD4\56DE\4E00\884C\548C\4E00\5217\7684 SQL \67E5\8BE2\FF0C\67E5\8BE2\7ED3\679C\5305\542B\8981\4ECE\4E2D\52A0\8F7D\6570\636E\7684 BLOB \6216 CLOB\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5305\542B XLSX \5DE5\4F5C\8868\540D\7684\9875\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4E8E\663E\793A\4E0A\8F7D\7684 XLSX \6587\4EF6\4E2D\53EF\7528\5DE5\4F5C\8868\7684\9009\62E9\5217\8868\6216\5F39\51FA\5F0F LOV \9879\5C06\4F7F\7528\4EE5\4E0B<em>\503C\5217\8868 SQL \67E5\8BE2</em>\FF08<strong>PX_FILE</strong> \662F\7528\4E8E\4E0A\8F7D XLSX \6587\4EF6\7684\6587\4EF6\6D4F\89C8\9879\FF09\3002</p><p>\8BF7\6CE8\610F\FF0C<strong>SHEET_FILE_NAME</strong> \5C5E\6027\5FC5\987B\7528\4F5C LOV \8FD4\56DE\5217\3002</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>\63D0\4F9B\5305\542B\5DE5\4F5C\8868\540D\7684\9875\9879\FF0C\4EE5\4F9B\52A0\8F7D XLSX \6587\4EF6\4F7F\7528\3002\6570\636E\5C06\4ECE\6307\5B9A\7684\5DE5\4F5C\8868\52A0\8F7D\3002\5982\679C\672A\63D0\4F9B\FF0CAPEX \5C06\4ECE XLSX \6587\4EF6\4E2D\7684\7B2C\4E00\4E2A\5DE5\4F5C\8868\52A0\8F7D\6570\636E\3002</p><p>\901A\5E38\FF0C\4F7F\7528<em>\9009\62E9\5217\8868</em>\9879\5B9E\73B0\6B64\76EE\7684\FF1A\5728<em>\503C\5217\8868\67E5\8BE2</em>\4E2D\FF0C\4F7F\7528 <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> \68C0\7D22\5DE5\4F5C\8868\663E\793A\540D\79F0\548C\5185\90E8\540D\79F0\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5DF2\5904\7406\884C\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9009\53D6\5DF2\4E0A\8F7D\FF08\548C\5DF2\5904\7406\FF09\884C\7684\6570\91CF\8981\5B58\50A8\5230\7684\9875\9879\3002\8BE5\503C\5728\6570\636E\52A0\8F7D\8FC7\7A0B\5B8C\6210\540E\53EF\7528\FF0C\5E76\53EF\7528\4E8E\5728\6D88\606F\4E2D\663E\793A\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4417)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9519\8BEF\884C\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9009\53D6\9519\8BEF\884C\7684\6570\91CF\8981\5B58\50A8\5230\7684\9875\9879\3002\8BE5\503C\5728\6570\636E\52A0\8F7D\8FC7\7A0B\5B8C\6210\540E\53EF\7528\FF0C\5E76\53EF\7528\4E8E\5728\6D88\606F\4E2D\663E\793A\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>unistr('\8303\56F4\56FE')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\663E\793A\4E00\4E2A\5E26\6709\5185\7F6E\503C\5217\8868\9009\62E9\5668\7684\9879\3002\9762\652F\6301\5355\9009\6216\591A\9009\4EE5\53CA\624B\52A8\8F93\5165\3002\5BF9\4E8E\5355\9009\652F\6301\FF0C\4EE5\5355\9009\7EC4\9009\9879\65B9\5F0F\663E\793A\591A\4E2A\503C\FF0C\4EE5\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\5355\4E2A\503C\3002\5BF9\4E8E\591A\9009\652F\6301\FF0C\4EE5\590D\9009\6846\65B9\5F0F\663E\793A\591A\4E2A\503C\FF0C\4EE5\5141\8BB8\6700\7EC8\7528\6237\9009\62E9\591A\4E2A\503C\3002\5BF9\4E8E\624B\52A8\8F93\5165\652F\6301\FF0C\5C06\5728\9762\4E0B\65B9\5448\73B0\6587\672C\5B57\6BB5\FF0C\4EE5\5141\8BB8\6700\7EC8\7528\6237\624B\52A8\8F93\5165\8981\7528\4E8E\5BF9\8FC7\6EE4\533A\57DF\8FDB\884C\8FC7\6EE4\7684\503C\8303\56F4\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9009\62E9\591A\4E2A\6587\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\9762\662F\5426\652F\6301\9009\62E9\591A\4E2A\5217\8868\6761\76EE\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\9762\5C06\4EE5\590D\9009\6846\65B9\5F0F\5448\73B0\4EE5\652F\6301\591A\9009\3002\8BBE\7F6E\4E3A<strong>\7981\7528</strong>\65F6\FF0C\9762\5C06\4EE5\5355\9009\7EC4\9009\9879\65B9\5F0F\5448\73B0\4EE5\652F\6301\5355\9009\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\624B\52A8\8F93\5165')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\8303\56F4\9762\662F\5426\652F\6301\624B\52A8\8F93\5165\3002\8BBE\7F6E\4E3A<strong>\542F\7528</strong>\65F6\FF0C\5C06\5728\9762\4E0B\65B9\5448\73B0\6587\672C\5B57\6BB5\FF0C\4EE5\5141\8BB8\6700\7EC8\7528\6237\624B\52A8\8F93\5165\8981\7528\4E8E\5BF9\8FC7\6EE4\533A\57DF\8FDB\884C\8FC7\6EE4\7684\503C\8303\56F4\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\8303\56F4\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\8F93\5165\8981\5728\624B\52A8\8F93\5165\6587\672C\5B57\6BB5\4E4B\95F4\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5F53\524D\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('0% \5230 %1')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5F53\524D\6807\7B7E\6253\5F00 - \4E0A\9650')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('\9AD8\4E8E %0')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5F53\524D\6807\7B7E\6253\5F00 - \4E0B\9650')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>unistr('\4F4E\4E8E %0')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4417)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4417)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>unistr('\663E\793A\5730\56FE')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4EE5 GeoJSON \70B9\683C\5F0F\663E\793A\57FA\4E8E\5750\6807\7684\5730\56FE\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\80CC\666F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\8981\4F7F\7528\7684\80CC\666F\5730\56FE\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9ED8\8BA4\503C')
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\9ED8\8BA4\5730\56FE\80CC\666F\3002</p>'),
unistr('<p>\5B83\9488\5BF9\6DF1\8272\4E3B\9898\4F7F\7528\201COpenStreetMap \4EAE\8272\201D\6216\201COpenStreetMap \6697\8272\201D\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4417)
,p_display_sequence=>20
,p_display_value=>unistr('OpenStreetMap \4EAE\8272')
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\8BE6\7EC6\7684\4F4D\7F6E\4E0A\4E0B\6587\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4417)
,p_display_sequence=>30
,p_display_value=>unistr('OpenStreetMap \6697\8272')
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6697\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4417)
,p_display_sequence=>40
,p_display_value=>unistr('OpenStreetMap \6B63\7535\5B50')
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E OpenStreetMap \6570\636E\7684\975E\5E72\6270\6D45\8272\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 KlokanTech.com \548C OpenMapTiles \5185\5BB9\63D0\4F9B\8005\63D0\4F9B\FF0C\6D3E\751F\81EA\201CMapbox \5F00\653E\6837\5F0F\201D\3002\6839\636E BSD/CC-BY \8BB8\53EF\6388\6743\4F7F\7528\3002\7531 Stamen Design \63D0\4F9B\7684\5236\56FE\6CD5\6839\636E CC0 \6388\6743\4F7F\7528\3002</p>'),
unistr('<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">\5728 GitHub \4E0A\67E5\770B</a></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4417)
,p_display_sequence=>50
,p_display_value=>unistr('Oracle \4E16\754C\5730\56FE')
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E HERE \5730\56FE\6570\636E\7684\901A\7528\57FA\672C\5730\56FE\3002\6B64\57FA\672C\5730\56FE\6837\5F0F\4E3A\60A8\7684\6570\636E\63D0\4F9B\4F4D\7F6E\4E0A\4E0B\6587\FF0C\5E76\4E14\53EF\589E\5F3A\6570\636E\7684\53EF\89C6\5316\3002</p>'),
unistr('<p>\6837\5F0F\65B9\6848\548C\5B9A\4E49\7531 Oracle USA \63D0\4F9B\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7F29\653E\7EA7\522B')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6B64\5C42\53D8\4E3A\53EF\89C1\7684\7F29\653E\7EA7\522B\3002</p>'),
'<p>',
unistr('\6700\5C0F\503C\FF1A1<br>'),
unistr('\6700\5927\503C\FF1A18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\663E\793A\6807\8BB0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\6307\5B9A\662F\5426\5E94\663E\793A\6807\8BB0\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6807\8BB0\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6807\8BB0\586B\5145\989C\8272\3002</p>'),
unistr('<p>\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5\3001RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz\FF08# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57\FF09\FF0C\5176\4E2D xx\3001yy \548C zz \5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx)\FF0C\5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57\FF0C\5206\522B\8868\793A\7EA2\8272\3001\7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\6240\663E\793A\7684\6807\8BB0\6307\5B9A\5DE5\5177\63D0\793A\6587\672C\3002</p>'),
unistr('<p>\5DE5\5177\63D0\793A\5C5E\6027\652F\6301 HTML \548C APEX \6A21\677F\6307\4EE4\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\663E\793A\5730\56FE\63A7\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5E94\663E\793A\5730\56FE\63A7\4EF6\3002</p>'),
unistr('<p>\8FD9\4F1A\5411\5730\56FE\4E2D\6DFB\52A0\7F29\653E\548C\65CB\8F6C\63A7\4EF6\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\4EA4\4E92\5F0F\5730\56FE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5730\56FE\662F\5426\5E94\4E3A\4EA4\4E92\5F0F\3002</p>'),
unistr('<p>\5982\679C\8BBE\7F6E\4E3A\201C\5426\201D\FF0C\5219\4F1A\521B\5EFA\6CA1\6709\4EA4\4E92\6027\7684\9759\6001\5730\56FE\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4417)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9AD8\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('\50CF\7D20')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\6240\663E\793A\5730\56FE\7684\9AD8\5EA6\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002</p>'),
unistr('<p>\5730\56FE\7684\9ED8\8BA4\9AD8\5EA6\662F\57FA\4E8E\5730\56FE\7684\5BBD\5EA6\6309\7167 3:2 \7684\7EB5\6A2A\6BD4\8BA1\7B97\7684\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>unistr('\5B58\5728 SQL \67E5\8BE2')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5982\679C\67E5\8BE2\81F3\5C11\8FD4\56DE\4E00\884C, \5219\6388\6743\65B9\6848\901A\8FC7; \5982\679C\67E5\8BE2\4E0D\8FD4\56DE\884C, \5219\6388\6743\65B9\6848\5931\8D25\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4417)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL \67E5\8BE2')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('\5982\679C\67E5\8BE2\81F3\5C11\8FD4\56DE\4E00\884C, \5219\6388\6743\65B9\6848\901A\8FC7; \5982\679C\67E5\8BE2\4E0D\8FD4\56DE\884C, \5219\6388\6743\65B9\6848\5931\8D25\3002')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>unistr('\4E0D\5B58\5728 SQL \67E5\8BE2')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5982\679C\67E5\8BE2\4E0D\8FD4\56DE\884C, \5219\6388\6743\65B9\6848\901A\8FC7; \5982\679C\67E5\8BE2\8FD4\56DE\4E00\884C\6216\591A\884C, \5219\6388\6743\65B9\6848\5931\8D25\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4417)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('SQL \67E5\8BE2')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('\5982\679C\67E5\8BE2\81F3\5C11\8FD4\56DE\4E00\884C, \5219\6388\6743\65B9\6848\5931\8D25; \5982\679C\67E5\8BE2\4E0D\8FD4\56DE\884C, \5219\6388\6743\65B9\6848\6210\529F\3002')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>unistr('\9879\4E3A\7A7A\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9879\503C\4E3A\7A7A\503C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4417)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9879\7684\503C\4E3A\7A7A\503C, \5219\6388\6743\6210\529F; \5426\5219, \6388\6743\5C06\5931\8D25\3002')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>unistr('\9879\4E0D\4E3A\7A7A\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9879\503C\4E0D\4E3A\7A7A\503C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4417)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9879\7684\503C\4E0D\4E3A\7A7A\503C, \5219\6388\6743\6210\529F; \5426\5219, \6388\6743\5C06\5931\8D25')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \51FD\6570')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8FD4\56DE\201C\771F\201D\6216\201C\5047\201D\7684 PL/SQL \51FD\6570\4F53\3002\8FD4\56DE\201C\5047\201D\503C\5219\6388\6743\65B9\6848\5931\8D25\3002\8FD4\56DE\201C\771F\201D\503C\5219\6388\6743\65B9\6848\901A\8FC7\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4417)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL \51FD\6570\4F53')
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8FD4\56DE\201C\771F\201D\6216\201C\5047\201D\7684 PL/SQL \51FD\6570\4F53\3002\8FD4\56DE\201C\5047\201D\5219\6388\6743\65B9\6848\5931\8D25\3002\8FD4\56DE\201C\771F\201D\5219\6388\6743\65B9\6848\901A\8FC7\3002'),
'<p/>',
unistr('\793A\4F8B:'),
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>unistr('\9996\9009\9879\7B49\4E8E\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9996\9009\9879\7684\503C\7B49\4E8E\503C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4417)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9996\9009\9879\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9996\9009\9879\7684\503C\7B49\4E8E\4EE5\4E0B\5B57\6BB5\4E2D\7684\503C, \5219\6388\6743\6210\529F; \5982\679C\4E0D\540C, \5219\6388\6743\5931\8D25')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4417)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\53C2\89C1\4E0A\6587')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\9996\9009\9879\4E0D\7B49\4E8E\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9996\9009\9879\7684\503C\4E0D\7B49\4E8E\503C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4417)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9996\9009\9879\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9996\9009\9879\7684\503C\4E0D\540C\4E8E\4EE5\4E0B\5B57\6BB5\4E2D\7684\503C, \5219\6388\6743\6210\529F; \5982\679C\7B49\4E8E, \5219\6388\6743\5931\8D25')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4417)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\53C2\89C1\4E0A\6587')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>unistr('\9879\7B49\4E8E\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\9879\503C\7B49\4E8E\503C\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4417)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9879\7684\503C\7B49\4E8E\4EE5\4E0B\5B57\6BB5\4E2D\7684\503C, \5219\6388\6743\6210\529F; \5982\679C\4E0D\540C, \5219\6388\6743\5931\8D25')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4417)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\53C2\89C1\4E0A\6587')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>unistr('\9879\4E0D\7B49\4E8E\503C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9879\7684\503C\4E0D\7B49\4E8E\503C\3002</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4417)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6B64\9879\7684\503C\4E0D\540C\4E8E\4EE5\4E0B\5B57\6BB5\4E2D\7684\503C, \5219\6388\6743\6210\529F; \5982\679C\7B49\4E8E, \5219\6388\6743\5931\8D25')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4417)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\53C2\89C1\4E0A\6587')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('\89E6\53D1\5730\7406\7F16\7801')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\624B\52A8\89E6\53D1<em>\5DF2\8FDB\884C\5730\7406\7F16\7801\7684\5730\5740</em>\9879\7684\5730\7406\7F16\7801\641C\7D22\3002</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>unistr('\793E\4EA4\767B\5F55')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\652F\6301\901A\8FC7 Google\3001Facebook\3001\4E00\822C OpenID Connect \548C\4E00\822C OAuth2 \8EAB\4EFD\63D0\4F9B\65B9\8FDB\884C\9A8C\8BC1\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8EAB\4EFD\8BC1\660E\5B58\50A8')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5305\542B\9A8C\8BC1\63D0\4F9B\65B9\7684\5BA2\6237\673A ID \548C\5BC6\94A5\7684\8EAB\4EFD\8BC1\660E\5B58\50A8\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9A8C\8BC1\63D0\4F9B\7A0B\5E8F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_display_sequence=>10
,p_display_value=>unistr('OpenID Connect \63D0\4F9B\65B9')
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('\4F7F\7528\57FA\4E8E OpenID Connect \7684\9A8C\8BC1\63D0\4F9B\65B9\3002\5FC5\987B\5728\4E0B\9762\8F93\5165\63D0\4F9B\65B9\7684 OpenID \641C\7D22 URL\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4E00\822C OAuth2 \63D0\4F9B\65B9')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('\4F7F\7528 OAuth2 \9A8C\8BC1\63D0\4F9B\65B9\3002\5FC5\987B\5728\4E0B\9762\8F93\5165\6388\6743\3001\4EE4\724C\548C userinfo \7AEF\70B9\7684 URL\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('\4E3A Google \767B\5F55\4F7F\7528\9884\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('\4E3A Facebook \767B\5F55\4F7F\7528\9884\5B9A\4E49\7684\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\641C\7D22 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>unistr('\8F93\5165 OpenID Connect \63D0\4F9B\65B9\7684\641C\7D22 URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6388\6743\7AEF\70B9 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('\8F93\5165 OAuth2 \63D0\4F9B\65B9\7684\6388\6743\7AEF\70B9 URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\4EE4\724C\7AEF\70B9 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('\8F93\5165 OAuth2 \63D0\4F9B\65B9\7684\4EE4\724C\7AEF\70B9 URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\7528\6237\4FE1\606F\7AEF\70B9 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('\8F93\5165 OAuth2 \63D0\4F9B\65B9\7684\7528\6237\4FE1\606F\7AEF\70B9 URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8303\56F4')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>unistr('\7535\5B50\90AE\4EF6,\6982\8981\6587\4EF6')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F93\5165\4E3A\767B\5F55\7528\6237\8BF7\6C42\7684\6743\9650\5217\8868\FF08\4EE5\9017\53F7\5206\9694\FF09\3002'),
unistr('\53EF\63A5\53D7\7684\503C\53D6\51B3\4E8E\9A8C\8BC1\63D0\4F9B\65B9\3002'),
unistr('\5BF9\4E8E OpenID Connect \548C Google\FF0CApplication Express \81EA\52A8\6DFB\52A0 "openid" \8303\56F4\3002'),
unistr('\9A8C\8BC1\63D0\4F9B\65B9\6839\636E\8FD9\4E9B\6743\9650\8FD4\56DE\7528\6237\5C5E\6027\3002'),
unistr('\60A8\53EF\4EE5\5C06\8FD9\4E9B\5C5E\6027\6620\5C04\5230\5E94\7528\7A0B\5E8F\9879\FF0C\4E5F\53EF\4EE5\4F7F\7528\9A8C\8BC1\540E\8FC7\7A0B\901A\8FC7 APEX_JSON.GET_% \51FD\6570\5904\7406\8FD9\4E9B\5C5E\6027\3002'),
'</p><p>',
unistr('\6B64\5904\5217\51FA\4E86 OpenID Connect \8303\56F4\548C\5C5E\6027\FF08\4E5F\79F0\4E3A\58F0\660E\FF09\FF1Ahttps://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\9A8C\8BC1 URI \53C2\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('\8F93\5165\9A8C\8BC1 URI \7684\53EF\9009\53C2\6570\3002\6709\5173\652F\6301\7684\53C2\6570, \8BF7\53C2\8003\9A8C\8BC1\63D0\4F9B\65B9\7684\6587\6863\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\7528\6237\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F93\5165\5305\542B\7528\6237\540D\7684\5C5E\6027\FF0C\6216\5305\542B\4E00\4E2A\6216\591A\4E2A\7528 "#" \5305\56F4\7684\5C5E\6027\66FF\6362\7684\81EA\7531\6587\672C\3002'),
unistr('\60A8\53EF\4EE5\4F7F\7528 #APEX_AUTH_NAME# \5F15\7528\9A8C\8BC1\65B9\6848\7684\540D\79F0\3002'),
unistr('\4F8B\5982\FF0C\4F7F\7528 "#email# (#APEX_AUTH_NAME#)" \65F6\FF0C\5F97\5230\7684\7528\6237\540D\5305\542B\7535\5B50\90AE\4EF6\5730\5740\4EE5\53CA\4F9D\6B21\540E\63A5\7684 " ("\3001\9A8C\8BC1\65B9\6848\540D\79F0\548C ")"\FF0C\4F8B\5982 "jane.doe@example.com (Google)"\3002'),
'</p><p>',
unistr('\6709\5173\652F\6301\7684\5C5E\6027\FF0C\8BF7\53C2\9605\9A8C\8BC1\63D0\4F9B\65B9\7684\6587\6863\3002'),
unistr('\8BF7\6CE8\610F\FF0C\60A8\9700\8981\8BBE\7F6E\6240\9700\7684\8303\56F4\FF0C\5426\5219\9A8C\8BC1\63D0\4F9B\65B9\4E0D\4F1A\53D1\9001\6240\6709\5C5E\6027\3002'),
unistr('\6B64\5904\5217\51FA\4E86 OpenID Connect \8303\56F4\548C\5C5E\6027\FF08\4E5F\79F0\4E3A\58F0\660E\FF09\FF1Ahttps://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\9644\52A0\7528\6237\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>unistr('\94FE\63A5,\56FE\7247,\7535\5B50\90AE\4EF6')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\8F93\5165\4EE5\9017\53F7\5206\9694\7684\9644\52A0\7528\6237\6570\636E\5C5E\6027\5217\8868\3002'),
'</p><p>',
unistr('\6709\5173\652F\6301\7684\5C5E\6027\FF0C\8BF7\53C2\9605\9A8C\8BC1\63D0\4F9B\65B9\7684\6587\6863\3002'),
unistr('\8BF7\6CE8\610F\FF0C\60A8\9700\8981\8BBE\7F6E\6240\9700\7684\8303\56F4\FF0C\5426\5219\9A8C\8BC1\63D0\4F9B\65B9\4E0D\4F1A\53D1\9001\6240\6709\5C5E\6027\3002'),
unistr('\6B64\5904\5217\51FA\4E86 OpenID Connect \8303\56F4\548C\5C5E\6027\FF08\4E5F\79F0\4E3A\58F0\660E\FF09\FF1Ahttps://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('\5C06\7528\6237\540D\8F6C\6362\4E3A\5927\5199')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\914D\7F6E\662F\5426\5E94\5C06\7528\6237\540D\5C5E\6027\503C\8F6C\6362\4E3A\5927\5199\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('\4EE4\724C\9A8C\8BC1\65B9\6CD5')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8F93\5165\8EAB\4EFD\8BC1\660E\7684\5BA2\6237\7AEF ID \548C\5BA2\6237\7AEF\5BC6\94A5\4F20\9012\81F3\670D\52A1\5668\7684\65B9\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\57FA\672C\9A8C\8BC1')
,p_return_value=>'BASIC'
,p_help_text=>unistr('\53D1\9001\57FA\672C\9A8C\8BC1\6807\5934\4E2D\7684\5BA2\6237\7AEF ID \548C\5BA2\6237\7AEF\5BC6\94A5\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4417)
,p_display_sequence=>22
,p_display_value=>unistr('\57FA\672C\9A8C\8BC1\548C\6B63\6587\4E2D\7684\5BA2\6237\7AEF ID')
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('\53D1\9001\57FA\672C\9A8C\8BC1\6807\5934\4E2D\7684\5BA2\6237\7AEF ID \548C\5BA2\6237\7AEF\5BC6\94A5\FF0C\4F46\540C\65F6\4E5F\53D1\9001\8BF7\6C42\6B63\6587\4E2D\7684\5BA2\6237\7AEF ID\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\6B63\6587\4E2D\7684\5BA2\6237\7AEF ID \548C\5BA2\6237\7AEF\5BC6\94A5')
,p_return_value=>'BODY'
,p_help_text=>unistr('\53D1\9001\8BF7\6C42\6B63\6587\4E2D\7684\5BA2\6237\7AEF ID \548C\5BA2\6237\7AEF\5BC6\94A5\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\6B63\6587\4E2D\7684\5BA2\6237\673A ID')
,p_return_value=>'CLID'
,p_help_text=>unistr('\4EC5\5728\8BF7\6C42\6B63\6587\4E2D\53D1\9001\5BA2\6237\673A ID\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>unistr('\9A8C\8BC1\5C5E\6027')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\542F\7528\FF0C&PRODUCT_NAME. \5C06\67E5\627E\5C5E\6027 "#name#_verified"\FF08\4F8B\5982\FF0C\7528\4E8E\5C5E\6027 "email" \7684 "email_verified"\FF09\3002'),
unistr('OpenID \5B9A\4E49\8EAB\4EFD\63D0\4F9B\65B9\5BF9\672A\9A8C\8BC1\7684 "email" \548C "phone_number" \5C5E\6027\53D1\9001 <code>"#name#_verified":false</code>\3002'),
unistr('&PRODUCT_NAME. \5FFD\7565\6B64\7C7B\672A\9A8C\8BC1\7684\5C5E\6027\3002'),
unistr('\5982\679C "#name#" \662F\7528\6237\540D\5C5E\6027\FF0C\90A3\4E48\8FD9\5C06\5BFC\81F4\9A8C\8BC1\5931\8D25\3002'),
'</p><p>',
unistr('\5982\679C\8EAB\4EFD\63D0\4F9B\65B9\8BA9\653B\51FB\8005\8F93\5165\672A\9A8C\8BC1\7684\6570\636E\4F9B\5E94\7528\7A0B\5E8F\7528\6765\8FDB\884C\9A8C\8BC1\FF0C\5219'),
unistr('\4ED6\4EEC\53EF\4EE5\6A21\62DF\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\7528\6237\3002'),
unistr('\201C\9A8C\8BC1\5C5E\6027\201D\68C0\67E5\53EF\9632\6B62\6B64\60C5\51B5\3002'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4417)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>unistr('\5C06\9644\52A0\7528\6237\5C5E\6027\6620\5C04\5230')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\63D0\4F9B<em>\9644\52A0\7528\6237\5C5E\6027</em>\6620\5C04\5230\7684\5E94\7528\7A0B\5E8F\9879\540D\79F0\7684\5217\8868\FF08\4EE5\9017\53F7\5206\9694\FF09\3002\4F8B\5982\FF0C\5982\679C\60A8\8BBE\7F6E'),
'<ul>',
unistr('<li>\9644\52A0\7528\6237\5C5E\6027\FF1Aemail,profile,picture</li>'),
unistr('<li>\5C06\9644\52A0\7528\6237\5C5E\6027\6620\5C04\5230\FF1AG_EMAIL,G_PROFILE,G_PICTURE</li>'),
'</ul>',
unistr('\5219 APEX \5C06\81EA\52A8\4E3A\76F8\5E94\9879\4FDD\5B58\4F1A\8BDD\72B6\6001\4E2D\7684\5C5E\6027\503C\3002')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>unistr('\5217\8868\89C6\56FE')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\6613\4E8E\5BFC\822A\7684\5217\8868\4E2D\663E\793A\6570\636E\3002\60A8\8FD8\53EF\4EE5\5305\542B\8BB8\591A\529F\80FD\6765\589E\5F3A\5217\8868\89C6\56FE\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\529F\80FD')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\4E3A\6B64\5217\8868\89C6\56FE\542F\7528\7684\529F\80FD\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\9AD8\7EA7\683C\5F0F')
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\663E\793A\56FE\50CF')
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\663E\793A\5217\8868\5206\9694\6761')
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\6709\62C6\5206\6309\94AE')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>55
,p_display_value=>unistr('\542F\7528\641C\7D22')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>65
,p_display_value=>unistr('\662F\5D4C\5957\5217\8868\89C6\56FE')
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_display_sequence=>70
,p_display_value=>unistr('\5185\5D4C\5217\8868')
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6587\672C\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\9009\62E9\5305\542B\5217\8868\89C6\56FE\6761\76EE\4E3B\5185\5BB9\7684\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5217\8868\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5BA2\6237\673A\6839\636E\5217\8868\9879\6587\672C\521B\5EFA\5206\9694\6761</dt>'),
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
unistr('<dt>\66F4\6539\56FE\6807</dt>'),
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>\66F4\6539\62C6\5206\6309\94AE\56FE\6807</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\8F93\5165\8981\5728\5217\8868\5143\7D20\4E0A\8BBE\7F6E\7684\5176\4ED6\5C5E\6027\3002\6709\5173\5F71\54CD\6B64\5217\8868\89C6\56FE\7684\4E00\4E9B\5C5E\6027\FF0C\8BF7\53C2\89C1\793A\4F8B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5217\8868\6761\76EE\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\8BBE\7F6E\8981\5220\9664\7684\5217\8868\6761\76EE\94FE\63A5\56FE\6807\3002</dt>'),
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\8F93\5165\8981\5728\6B64\5217\8868\9879\5143\7D20\4E0A\8BBE\7F6E\7684\5176\4ED6\5C5E\6027\3002\6709\5173\5F71\54CD\6B64\5217\8868\89C6\56FE\7684\4E00\4E9B\5C5E\6027\FF0C\8BF7\53C2\89C1\793A\4F8B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6587\672C\683C\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\96C7\5458\7684\59D3\540D\5E76\5728\5176\4E0B\663E\793A\96C7\4F63\65E5\671F</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
unistr('&lt;p&gt;\96C7\4F63\65E5\671F: &amp;HIREDATE.&lt;/p&gt;'),
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 HTML \6807\8BB0\4EE5\5448\73B0\5217\8868\89C6\56FE\6761\76EE\7684\4E3B\5185\5BB9\3002</p>'),
unistr('<p>\8981\5F15\7528\5217\8868\89C6\56FE SQL \8BED\53E5\7684\5217\503C\FF0C\8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\8865\5145\4FE1\606F\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('\9009\62E9\5305\542B\5217\8868\89C6\56FE\6761\76EE\8865\5145\4FE1\606F\7684\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8865\5145\4FE1\606F\683C\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EE5\7C97\4F53\663E\793A\85AA\6C34</dt>'),
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 HTML \6807\8BB0\4EE5\5448\73B0\5217\8868\89C6\56FE\6761\76EE\7684\8865\5145\4FE1\606F\3002</p>'),
unistr('<p>\8981\5F15\7528\5217\8868\89C6\56FE SQL \8BED\53E5\7684\5217\503C\FF0C\8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8BA1\6570\5668\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5305\542B\8981\5728\8BA1\6570\6C14\6CE1\4E2D\663E\793A\7684\503C\7684\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\56FE\50CF\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\663E\793A\7684\56FE\50CF\7C7B\578B\4EE5\53CA\8BFB\53D6\8BE5\56FE\50CF\7684\4F4D\7F6E\3002\663E\793A\7684\56FE\50CF\53EF\4EE5\662F\5927\5C0F\4E3A 16x16 \7684\56FE\6807, \4E5F\53EF\4EE5\662F\5927\5C0F\4E3A 80x80 \7684\7F29\7565\56FE\3002\56FE\50CF\6765\6E90\53EF\4EE5\662F\6570\636E\5E93 BLOB \5217\6216\9759\6001\6587\4EF6\7684 URL\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\56FE\6807\5B58\50A8\5728 BLOB \4E2D')
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\56FE\6807\8BFB\53D6\81EA URL')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\56FE\50CF\5B58\50A8\5728 BLOB \4E2D')
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\56FE\50CF\8BFB\53D6\81EA URL')
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\56FE\50CF BLOB \5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\9009\62E9\5305\542B\56FE\50CF\7684\6570\636E\7C7B\578B\4E3A BLOB \7684\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\56FE\50CF\4E3B\952E\5217 1')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('\9009\62E9\7528\4E8E\67E5\627E\56FE\50CF\7684\4E3B\952E\5217\6216\552F\4E00\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\56FE\50CF\4E3B\952E\5217 2')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\9009\62E9\7528\4E8E\67E5\627E\56FE\50CF\7684\7B2C\4E8C\4E3B\952E\5217\6216\552F\4E00\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\56FE\50CF URL \5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>unistr('\9009\62E9\5305\542B\56FE\6807/\56FE\50CF URL \7684\6570\636E\5E93\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\5217\8868\5206\9694\6761\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('\9009\62E9\5305\542B\5206\9694\6761\7684\6570\636E\5E93\5217\3002\5206\9694\6761\503C\6BCF\6B21\53D1\751F\53D8\5316\65F6, \90FD\5C06\5728\5217\8868\89C6\56FE\6761\76EE\4E4B\95F4\663E\793A\65B0\7684\5206\9694\6761\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\5217\8868\5206\9694\6761\683C\5F0F\8BBE\7F6E')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5C06\90E8\95E8\540D\79F0\548C\5458\5DE5\6570\663E\793A\4E3A\5FBD\7AE0</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 HTML \6807\8BB0\4EE5\5448\73B0\5217\8868\89C6\56FE\7684\5206\9694\6761\3002</p>'),
unistr('<p>\8981\5F15\7528\5217\8868\89C6\56FE SQL \8BED\53E5\7684\5217\503C\FF0C\8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>unistr('\94FE\63A5\76EE\6807')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F93\5165\5728\7528\6237\5355\51FB\5217\8868\6761\76EE\65F6\8981\8C03\7528\7684\76EE\6807\9875\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('\62C6\5206\6309\94AE\76EE\6807')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F93\5165\5728\7528\6237\5355\51FB\5217\8868\6761\76EE\65F6\8981\8C03\7528\7684\76EE\6807\9875\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>unistr('\641C\7D22\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\6267\884C\641C\7D22\3002</p>'),
unistr('<p>\7528\6237\5F00\59CB\952E\5165\65F6\FF0C\5C06\7ACB\5373\6267\884C\5BA2\6237\7AEF\641C\7D22\3002\5BF9\4E8E\57FA\4E8E\6240\6709\670D\52A1\5668\7684\641C\7D22\FF0C\7528\6237\5FC5\987B\6309 Enter \624D\80FD\663E\793A\641C\7D22\7ED3\679C\3002\4EC5\57FA\4E8E\670D\52A1\5668\7684\641C\7D22\8003\8651\4E3A\5E94\7528\7A0B\5E8F\5B9A\4E49\7684\201C\5B57\7B26\503C\6BD4\8F83\201D\5168\7403\5316\5C5E\6027\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5BA2\6237\7AEF')
,p_return_value=>'CLIENT'
,p_help_text=>unistr('\8981\6267\884C\57FA\4E8E\6D4F\89C8\5668\7684\641C\7D22, \6240\6709\5217\8868\89C6\56FE\6761\76EE\90FD\5FC5\987B\52A0\8F7D\5230\6D4F\89C8\5668\4E2D (\8BF7\6CE8\610F, \5728\8FD9\79CD\60C5\51B5\4E0B, \5FFD\7565 "\63D0\53D6\7684\884C\6570" \5C5E\6027)\3002\4EC5\5BF9\5C11\91CF\5217\8868\6761\76EE\4F7F\7528\6B64\641C\7D22\9009\9879, \4EE5\907F\514D\4E0D\5FC5\8981\7684\957F\65F6\95F4\9875\52A0\8F7D\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\670D\52A1\5668: \5B8C\5168\5339\914D\4E14\533A\5206\5927\5C0F\5199')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>unistr('\641C\7D22\5C06\4F7F\7528 LIKE [\641C\7D22\503C]% \67E5\8BE2\7ED3\679C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\670D\52A1\5668: \5B8C\5168\5339\914D\4E14\5FFD\7565\5927\5C0F\5199')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('\641C\7D22\5C06\4F7F\7528 LIKE UPPER([\641C\7D22\503C])% \67E5\8BE2\7ED3\679C\3002\5C06\4E0D\4F7F\7528\5217\4E0A\7684\73B0\6709\7D22\5F15, \9664\975E\5176\57FA\4E8E\51FD\6570\7684\7D22\5F15\4F7F\7528\7684\662F UPPER \8868\8FBE\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\670D\52A1\5668: \7C7B\4F3C\5339\914D\4E14\533A\5206\5927\5C0F\5199')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('\641C\7D22\5C06\4F7F\7528 LIKE %[\641C\7D22\503C]% \67E5\8BE2\7ED3\679C\3002\8FD9\5C06\963B\6B62\4F7F\7528\8BE5\5217\4E0A\7684\73B0\6709\7D22\5F15\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4417)
,p_display_sequence=>60
,p_display_value=>unistr('\670D\52A1\5668: \7C7B\4F3C\5339\914D\4E14\5FFD\7565\5927\5C0F\5199')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('\641C\7D22\5C06\4F7F\7528 LIKE %UPPER([\641C\7D22\503C])% \67E5\8BE2\7ED3\679C\3002\8FD9\5C06\963B\6B62\4F7F\7528\8BE5\5217\4E0A\7684\73B0\6709\7D22\5F15\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>unistr('\641C\7D22\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\9009\62E9\641C\7D22\6240\7528\7684\5907\7528\6570\636E\5E93\5217\3002\5982\679C\672A\6307\5B9A\4EFB\4F55\5185\5BB9, \5219\5C06\4F7F\7528\6587\672C\5217\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('\641C\7D22\6846\5360\4F4D\7B26')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('\8F93\5165\5728\641C\7D22\6846\4E2D\663E\793A\7684\6587\672C\3002\5982\679C\672A\6307\5B9A\503C, \5219\5C06\4F7F\7528\7CFB\7EDF\6D88\606F <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong> \7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>unistr('\5D4C\5957\5217\8868\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('\9009\62E9\5305\542B\5D4C\5957\67E5\8BE2\5C42\6B21\7EA7\522B\7684\6570\636E\5E93\5217\3002\5982\679C\4F7F\7528 CONNECT BY \67E5\8BE2, \5219\4F7F\7528\4F2A\5217 <code>LEVEL</code>\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4417)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\6240\6709\96C7\5458, \6309\59D3\540D\6392\5E8F</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\663E\793A\5F53\524D\90E8\95E8\7684\6240\6709\96C7\5458, \6309\59D3\540D\6392\5E8F</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\4F7F\7528\7ED1\5B9A\53D8\91CF\5F15\7528\9875\9879\65F6, \8BF7\5C06\5176\6307\5B9A\4E3A<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\3002</p>'),
'</dd>',
unistr('<dt>\4F7F\7528 ROWID \4F5C\4E3A\4E3B\952E\5217</dt>'),
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
unistr('<p>\4F7F\7528 ROWID \65F6, \9700\8981\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\8FD4\56DE\6240\6709\96C7\5458\7684\5D4C\5957\67E5\8BE2</dt>'),
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('\5173\95ED\533A\57DF')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5173\95ED\67D0\4E2A\652F\6301\6253\5F00\4E14\5DF2\6253\5F00\7684\533A\57DF\FF08\4F8B\5982\5185\5D4C\5BF9\8BDD\6846\3001\5185\5D4C\5F39\51FA\7A97\53E3\6216\53EF\6298\53E0\533A\57DF\FF09\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('\6253\5F00\533A\57DF')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6253\5F00\67D0\4E2A\652F\6301\6253\5F00\7684\533A\57DF\FF08\4F8B\5982\5185\5D4C\5BF9\8BDD\6846\3001\5185\5D4C\5F39\51FA\7A97\53E3\6216\53EF\6298\53E0\533A\57DF\FF09\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('\5728\89D2\8272\6216\7EC4\4E2D')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4417)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540D\79F0')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\4E00\4E2A\6216\591A\4E2A\7528\9017\53F7\5206\9694\7684\7EC4\540D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4417)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5E94\7528\7A0B\5E8F\89D2\8272')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5DE5\4F5C\533A\7EC4')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5B9A\5236')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4417)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('\4E0D\5728\89D2\8272\6216\7EC4\4E2D')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4417)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\540D\79F0')
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\4E00\4E2A\6216\591A\4E2A\7528\9017\53F7\5206\9694\7684\7EC4\540D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4417)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5E94\7528\7A0B\5E8F\89D2\8272')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5DE5\4F5C\533A\7EC4')
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5B9A\5236')
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>unistr('\65E5\671F\9009\53D6\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\4E00\4E2A\5E26\6709\65E5\5386\56FE\6807\7684\6587\672C\5B57\6BB5\3002\6700\7EC8\7528\6237\53EF\4EE5\5C06\65E5\671F\76F4\63A5\8F93\5165\5230\6587\672C\9879, \4E5F\53EF\4EE5\5355\51FB\65E5\5386\56FE\6807\4ECE\5F39\51FA\5F0F\65E5\5386\4E2D\9009\62E9\65E5\671F\5E76\9009\62E9\6027\5730\9009\62E9\65F6\95F4\3002</p>'),
unistr('<p>\4EC5\5F53\6B64\9879\7684<em>\683C\5F0F\63A9\7801</em>\5305\542B\65F6\95F4\7EC4\4EF6\65F6, \624D\4F1A\5728\5F39\51FA\5F0F\65E5\5386\4E2D\663E\793A\65F6\95F4\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5916\89C2')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63A7\5236\7528\4E8E\9009\62E9\65E5\671F\7684\65E5\5386\7684\5916\89C2</p>'),
unistr('<p>\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\663E\793A\5468')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\662F\5426\663E\793A\4E00\5E74\4E2D\7684\7B2C\51E0\5468\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\6708\9009\53D6\5668')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\6708\4EFD\662F\5426\5E94\5448\73B0\4E3A\6309\94AE\FF08\800C\4E0D\662F\6587\672C\FF09\4EE5\5141\8BB8\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5E74\9009\53D6\5668')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\5E74\4EFD\662F\5426\5E94\5448\73B0\4E3A\6309\94AE\FF08\800C\4E0D\662F\6587\672C\FF09\4EE5\5141\8BB8\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6708\4EFD\4E4B\5916\7684\65E5\671F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\793A\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\65E5\671F\7684\884C\4E3A</p>'),
unistr('<p>\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9690\85CF')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\7684\65E5\671F\5C06\9690\85CF\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\53EF\9009\62E9')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\7684\65E5\671F\5C06\53EF\89C1\5E76\53EF\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\53EF\89C1')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\7684\65E5\671F\5C06\53EF\89C1\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\65F6\95F4\589E\91CF')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>unistr('\5206\949F')
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65F6\95F4\9009\62E9\63A7\4EF6\4F7F\7528\7684\65F6\95F4\589E\91CF\FF0C\4EE5\5206\949F\4E3A\5355\4F4D\3002\6CE8\FF1A\6B64\8BBE\7F6E\53EA\662F\63A7\5236\7528\4E8E\9009\62E9\65F6\95F4\7684\63A7\4EF6\FF0C\60A8\4ECD\7136\53EF\4EE5\624B\52A8\8F93\5165\548C\4FDD\5B58\4E0D\7B26\5408\8FD9\4E9B\589E\91CF\7684\65F6\95F4\3002</p>'),
unistr('<p>\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\FF0C\5E76\4E14\201C\663E\793A\65F6\95F4\201D\4E3A\542F\7528\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\4F55\65F6\663E\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\63A7\5236\4F55\65F6\663E\793A\65E5\5386\5F39\51FA\7A97\53E3\3002\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9879\805A\7126')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\5F53\9879\83B7\5F97\7126\70B9\6216\5355\51FB\65E5\5386\56FE\6807\65F6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\56FE\6807\5355\51FB')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\4EC5\5F53\5355\51FB\65E5\5386\56FE\6807\65F6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\663E\793A\65F6\95F4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\5426\5305\62EC\65F6\95F4\4FE1\606F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\663E\793A\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\65E5\671F\9009\53D6\5668\7684\663E\793A\6A21\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5F39\51FA')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\5728\9879\83B7\5F97\7126\70B9\6216\5355\51FB\65E5\5386\56FE\6807\65F6\FF0C\5C06\5728\5F39\51FA\7A97\53E3\4E2D\663E\793A\65E5\5386\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5185\5D4C')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\65E5\5386\59CB\7EC8\5185\5D4C\663E\793A\5728\9875\4E0A\3002\4E0D\663E\793A\6587\672C\5B57\6BB5, \5E76\4E14\5F53\524D\65E5\671F\9009\62E9\7A81\51FA\663E\793A\5728\65E5\5386\4E2D\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\672C\673A HTML')
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\6D4F\89C8\5668\652F\6301\FF0C\5219\4F7F\7528\672C\673A HTML \8F93\5165\65E5\671F\7C7B\578B\8FDB\884C\5448\73B0\3002\7981\7528\201C\663E\793A\65F6\95F4\201D\65F6\FF0C\6B64\9879\5448\73B0 ''date'' \7C7B\578B\FF1B\542F\7528\201C\663E\793A\65F6\95F4\201D\65F6\FF0C\6B64\9879\5448\73B0 ''datetime-local'' \7C7B\578B\3002\6CE8\FF1A\8FD9\4E9B\65E5\671F\7C7B\578B\7684\786E\5207\663E\793A\53D6\51B3\4E8E\6D4F\89C8\5668\3002\5728\79FB\52A8\8BBE\5907\4E0A\4F7F\7528\5E94\7528\7A0B\5E8F\65F6\FF0C\672C\673A HTML \53EF\80FD\662F\9996\9009\9009\9879\3002</p>'),
unistr('<p>\8BF7\6CE8\610F\FF0C\4F7F\7528\201C\672C\673A HTML\201D\65F6\FF0C\7531\4E8E\672C\673A\65E5\671F\7C7B\578B\5BF9\6240\9700\7684\65E5\671F\683C\5F0F\6709\975E\5E38\5177\4F53\7684\8BBE\7F6E\FF0C\56E0\6B64 APEX \5C06\81EA\52A8\8BBE\7F6E\9879\7684\201C\683C\5F0F\63A9\7801\201D\FF0C\60A8\5C06\65E0\6CD5\66F4\6539\5B83\3002\4F46\662F\FF0C\8FD9\5C06\4E0D\662F\663E\793A\7ED9\6700\7EC8\7528\6237\7684\683C\5F0F\3002\6700\7EC8\7528\6237\5C06\770B\5230\9002\5408\5176\5F53\524D\533A\57DF\8BBE\7F6E\7684\683C\5F0F\7684\65E5\671F\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6700\5C0F\65E5\671F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6B64\9879\662F\5426\5177\6709\6700\5C0F\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
,p_help_text=>unistr('\672A\5B9A\4E49\6700\5C0F\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9879')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\52A8\6001\5730\4ECE\5176\4ED6\9879\7684\503C\6D3E\751F\6700\5C0F\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\6001')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\6700\5C0F\65E5\671F\662F\9759\6001\503C\FF0C\53EF\4EE5\5B9A\4E49\4E3A\7EDD\5BF9\503C\FF0C\6216\8005\5B9A\4E49\4E3A\76F8\5BF9\4E8E\5F53\5929\65E5\671F\7684\76F8\5BF9\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9759\6001\6700\5C0F\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\53EF\4EE5\8F93\5165\6216\9009\62E9\7684\6700\5C0F\65E5\671F\3002</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7EDD\5BF9\503C, \6216\76F8\5BF9\4E8E\4ECA\5929\65E5\671F\7684\76F8\5BF9\503C (\4F8B\5982 <code>+7d</code>), \6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C (\5047\5B9A\66FF\6362\9879\8FD4\56DE\6B63\786E\7684\65E5\671F\683C\5F0F\6216\76F8\5BF9\503C)\3002</p>'),
unistr('<p>\76F8\5BF9\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5468\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5929\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6700\5C0F\65E5\671F\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\786E\5B9A\6700\5C0F\5141\8BB8\503C\7684\9879\3002\8FD9\5FC5\987B\662F\5F53\524D\9875\6216\5168\5C40\9875\4E0A\7684\9875\9879\3002<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6700\5927\65E5\671F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6B64\9879\662F\5426\5177\6709\6700\5927\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
,p_help_text=>unistr('\672A\5B9A\4E49\6700\5927\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9879')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\52A8\6001\5730\4ECE\5176\4ED6\9879\7684\503C\6D3E\751F\6700\5927\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\6001')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\6700\5927\65E5\671F\662F\9759\6001\503C\FF0C\53EF\4EE5\5B9A\4E49\4E3A\7EDD\5BF9\503C\FF0C\6216\8005\5B9A\4E49\4E3A\76F8\5BF9\4E8E\5F53\5929\65E5\671F\7684\76F8\5BF9\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\9759\6001\6700\5927\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\53EF\4EE5\8F93\5165\6216\9009\62E9\7684\6700\5927\65E5\671F\3002</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7EDD\5BF9\503C, \6216\76F8\5BF9\4E8E\4ECA\5929\65E5\671F\7684\76F8\5BF9\503C (\4F8B\5982 <code>+7d</code>), \6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C (\5047\5B9A\66FF\6362\9879\8FD4\56DE\6B63\786E\7684\65E5\671F\683C\5F0F\6216\76F8\5BF9\503C)\3002</p>'),
unistr('<p>\76F8\5BF9\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5468\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5929\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6700\5927\65E5\671F\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>\786E\5B9A\6700\5927\5141\8BB8\503C\7684\9879\3002\8FD9\5FC5\987B\662F\5F53\524D\9875\6216\5168\5C40\9875\4E0A\7684\9875\9879\3002<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\591A\4E2A\6708')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('\65E5\5386\662F\5426\663E\793A\591A\4E2A\6708\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\6708\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\4E00\6B21\663E\793A\7684\6708\6570\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\4F7F\7528\9ED8\8BA4\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\4F7F\7528\5728\201C\5171\4EAB\7EC4\4EF6\201D>\201C\7EC4\4EF6\8BBE\7F6E\201D\4E2D\4E3A\6B64\7EC4\4EF6\5B9A\4E49\7684\9ED8\8BA4\503C\8FD8\662F\4F7F\7528\5B9A\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\5916\89C2')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63A7\5236\7528\4E8E\9009\62E9\65E5\671F\7684\65E5\5386\7684\5916\89C2</p>'),
unistr('<p>\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\663E\793A\5468')
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('\662F\5426\663E\793A\4E00\5E74\4E2D\7684\7B2C\51E0\5468\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\6708\9009\53D6\5668')
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('\6708\4EFD\662F\5426\5E94\5448\73B0\4E3A\6309\94AE\FF08\800C\4E0D\662F\6587\672C\FF09\4EE5\5141\8BB8\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5E74\9009\53D6\5668')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('\5E74\4EFD\662F\5426\5E94\5448\73B0\4E3A\6309\94AE\FF08\800C\4E0D\662F\6587\672C\FF09\4EE5\5141\8BB8\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\6708\4EFD\4E4B\5916\7684\65E5\671F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\793A\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\65E5\671F\7684\884C\4E3A</p>'),
unistr('<p>\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9690\85CF')
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\7684\65E5\671F\5C06\9690\85CF\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\53EF\9009\62E9')
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\7684\65E5\671F\5C06\53EF\89C1\5E76\53EF\9009\62E9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\53EF\89C1')
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('\5F53\524D\67E5\770B\6708\4EFD\4E4B\5916\7684\65E5\671F\5C06\53EF\89C1\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\65F6\95F4\589E\91CF')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>unistr('\5206\949F')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65F6\95F4\9009\62E9\63A7\4EF6\4F7F\7528\7684\65F6\95F4\589E\91CF\FF0C\4EE5\5206\949F\4E3A\5355\4F4D\3002\6CE8\FF1A\6B64\8BBE\7F6E\53EA\662F\63A7\5236\7528\4E8E\9009\62E9\65F6\95F4\7684\63A7\4EF6\FF0C\60A8\4ECD\7136\53EF\4EE5\624B\52A8\8F93\5165\548C\4FDD\5B58\4E0D\7B26\5408\8FD9\4E9B\589E\91CF\7684\65F6\95F4\3002</p>'),
unistr('<p>\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\FF0C\5E76\4E14\201C\663E\793A\65F6\95F4\201D\4E3A\542F\7528\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4417)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\4F55\65F6\663E\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\63A7\5236\4F55\65F6\663E\793A\65E5\5386\5F39\51FA\7A97\53E3\3002\6CE8\FF1A\4EC5\5F53\201C\663E\793A\4E3A\201D\4E3A\201C\5F39\51FA\201D\6216\201C\5185\5D4C\201D\65F6\FF0C\624D\4F7F\7528\6B64\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9879\805A\7126')
,p_return_value=>'FOCUS'
,p_help_text=>unistr('\5F53\9879\83B7\5F97\7126\70B9\6216\5355\51FB\65E5\5386\56FE\6807\65F6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\56FE\6807\5355\51FB')
,p_return_value=>'IMAGE'
,p_help_text=>unistr('\4EC5\5F53\5355\51FB\65E5\5386\56FE\6807\65F6\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>unistr('\590D\9009\6846')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\7528\6237\53EF\4EE5\9009\4E2D\6216\53D6\6D88\9009\4E2D\7684\5355\4E2A\590D\9009\6846\3002\5B9A\4E49\7684\9009\4E2D\503C\6216\672A\9009\4E2D\503C\5728\63D0\4EA4\540E\5B58\50A8\5728\4F1A\8BDD\72B6\6001\4E2D\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4417)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9009\4E2D\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6700\7EC8\7528\6237\9009\4E2D\8BE5\590D\9009\6846\FF0C\5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4417)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\672A\9009\4E2D\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\7528\6237\53D6\6D88\9009\4E2D\8BE5\590D\9009\6846\FF0C\5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\5982\679C\5E0C\671B\5728\9009\4E2D\65F6\5B58\50A8<code>\7A7A\503C</code>\FF0C\6B64\5C5E\6027\4E5F\53EF\4EE5\7559\7A7A\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4417)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\9ED8\8BA4\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\4F7F\7528\5728\201C\5171\4EAB\7EC4\4EF6\201D>\201C\7EC4\4EF6\8BBE\7F6E\201D\4E2D\4E3A\6B64\7EC4\4EF6\5B9A\4E49\7684\9ED8\8BA4\503C\8FD8\662F\4F7F\7528\5B9A\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4417)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9009\4E2D\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5982\679C\7528\6237\9009\4E2D\8BE5\590D\9009\6846\FF0C\5219\8F93\5165\9875\9879\4E2D\5B58\50A8\7684\503C\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002</p>'),
'<p>',
unistr('\5728\201C\5206\9762\641C\7D22\201D\9875\4E0A\FF0C\5982\679C\9762<em>\57FA\4E8E\503C\5217\8868</em>\5BF9\67E5\8BE2\5217\8FDB\884C\8FC7\6EE4\FF0C\5219\6B64\503C\5FC5\987B\4E0E LOV \663E\793A\503C\548C\8FD4\56DE\503C<em>\5747</em>\5339\914D\3002\5982\679C\663E\793A\503C\548C\8FD4\56DE\503C\4E0D\540C\FF0C\5219\5C06\65E0\6CD5\9488\5BF9\6B64\5217\4F7F\7528\6B64\9762\7C7B\578B - \8BF7\6539\7528<strong>\590D\9009\6846\7EC4</strong>\9762\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4417)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\672A\9009\4E2D\7684\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\7528\6237\53D6\6D88\9009\4E2D\8BE5\590D\9009\6846\FF0C\5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\5982\679C\5E0C\671B\5728\53D6\6D88\9009\4E2D\65F6\5B58\50A8<code>\7A7A\503C</code>\FF0C\6B64\5C5E\6027\4E5F\53EF\4EE5\7559\7A7A\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002</p>'),
unistr('<p><em>\6CE8\FF1A\5982\679C\4F7F\7528\4E0E<strong>\9009\4E2D\7684\503C</strong>\6216<strong>\672A\9009\4E2D\7684\503C</strong>\5747\4E0D\5339\914D\7684\503C\586B\5145\4E86\9875\9879\FF0C\5219\4F7F\7528\6B64\503C\3002</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>unistr('\4EA4\4E92\5F0F\7F51\683C')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E SQL \67E5\8BE2\7684\7EFC\5408\7684\8054\673A\591A\884C\533A\57DF, \6B64\533A\57DF\5411\6700\7EC8\7528\6237\63D0\4F9B\8BB8\591A\7528\4E8E\5728\8FD0\884C\65F6\5B9A\5236\8BBE\7F6E\7684\529F\80FD\3002'),
unistr('\6B64\533A\57DF\53EF\5B9A\4E49\4E3A\53EF\7F16\8F91\6216\53EA\8BFB\3002</p>'),
unistr('<p>\60A8\53EF\4EE5\5B9A\4E49\5355\4E2A\4EA4\4E92\5F0F\7F51\683C\5E76\4F7F\6700\7EC8\7528\6237\53EF\4EE5\64CD\7EB5\663E\793A\7684\6570\636E\4EE5\6EE1\8DB3\5176\7279\5B9A\7684\8981\6C42, \800C\4E0D\662F\60A8\9700\8981\6839\636E\4E0D\540C\6807\51C6\5F00\53D1\82E5\5E72\4E2A\7C7B\4F3C\533A\57DF\6765\6EE1\8DB3\8FD9\4E9B\76F8\540C\7684\8981\6C42\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'apexbeginrecordedit'
,p_display_name=>unistr('\884C\521D\59CB\5316')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'gridpagechange'
,p_display_name=>unistr('\9875\66F4\6539')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'interactivegridmodechange'
,p_display_name=>unistr('\6A21\5F0F\66F4\6539')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'interactivegridreportchange'
,p_display_name=>unistr('\62A5\8868\66F4\6539')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'interactivegridsave'
,p_display_name=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('\9009\62E9\66F4\6539')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4417)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4417)
,p_name=>'interactivegridviewchange'
,p_display_name=>unistr('\89C6\56FE\66F4\6539')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>unistr('\884C\9009\62E9\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\4EA4\4E92\5F0F\7F51\683C\7684\6BCF\4E00\884C\4E0A\663E\793A\4E00\4E2A\590D\9009\6846, \7528\4E8E\9009\62E9\7279\5B9A\884C\8FDB\884C\884C\64CD\7EB5\3002</p>'),
unistr('<p>\9ED8\8BA4\60C5\51B5\4E0B, APEX$ROW_SELECTOR \5217\8BBE\7F6E\4E3A\201C\884C\9009\62E9\5668\201D\7C7B\578B\3002\4F7F\4EA4\4E92\5F0F\7F51\683C\53EF\7F16\8F91\65F6\81EA\52A8\6DFB\52A0\6B64\5217\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4417)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\542F\7528\591A\9009')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\5141\8BB8\9009\62E9\591A\884C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4417)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\663E\793A\5168\9009')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\5141\8BB8\7528\6237\4F7F\7528 Ctrl+A \9009\62E9\6240\6709\884C, \6216\8005\5728<em>\9690\85CF\63A7\4EF6</em>\4E3A<em>\5426</em>\65F6\4F7F\7528\5217\6807\9898\4E2D\7684\590D\9009\6846\6765\9009\62E9\6240\6709\884C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4417)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9690\85CF\63A7\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\9690\85CF\6BCF\4E00\884C\4E0A\663E\793A\7684\590D\9009\6846\6216\5355\9009\63A7\4EF6\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('\64CD\4F5C\83DC\5355')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\4EA4\4E92\5F0F\7F51\683C\7684\6BCF\4E00\884C\4E0A\663E\793A\64CD\4F5C\56FE\6807\FF08\6C49\5821\FF09\3002'),
unistr('\64CD\4F5C\83DC\5355\5305\62EC\201C\5355\884C\89C6\56FE\201D\3001\201C\6DFB\52A0\884C\201D\3001\201C\5220\9664\884C\201D\548C\201C\5237\65B0\884C\201D\7B49\9009\9879\FF0C\5177\4F53\53D6\51B3\4E8E\7F51\683C\5C5E\6027\548C\6700\7EC8\7528\6237\6388\6743\3002\6700\7EC8\7528\6237\53EF\4F7F\7528\8FD9\4E9B\83DC\5355\9009\9879\5BF9\7F51\683C\4E2D\7684\5F53\524D\884C\6267\884C\7279\5B9A\64CD\4F5C\3002</p>'),
unistr('<p>\64CD\4F5C\83DC\5355\53EF\4EE5\7528\4E8E\53EF\7F16\8F91\548C\4E0D\53EF\7F16\8F91\7684\4EA4\4E92\5F0F\7F51\683C\4E2D\FF0C\4F46\76F8\5E94\7684\83DC\5355\9009\9879\4F1A\6709\6240\4E0D\540C\3002\5BF9\4E8E\4E0D\53EF\7F16\8F91\7684\4EA4\4E92\5F0F\7F51\683C\FF0C\83DC\5355\5C06\5305\62EC\4E00\90E8\5206\9009\9879\FF0C\4F8B\5982\201C\5355\884C\89C6\56FE\201D\548C\201C\5237\65B0\884C\201D\FF0C\4F46\4E0D\5305\542B\5982\201C\6DFB\52A0\884C\201D\548C\201C\5220\9664\884C\201D\7B49\53EF\7F16\8F91\7684\7279\5B9A\64CD\4F5C\3002</p>'),
unistr('<p>\5C06\4EA4\4E92\5F0F\7F51\683C\8BBE\4E3A\53EF\7F16\8F91\65F6\FF0C\5C06\81EA\52A8\6DFB\52A0 APEX$ROW_ACTION \5217\5E76\5C06\5176\8BBE\7F6E\4E3A\201C\64CD\4F5C\83DC\5355\201D\7C7B\578B\3002\5BF9\4E8E\4E0D\53EF\7F16\8F91\7684\4EA4\4E92\5F0F\7F51\683C\FF0C\5FC5\987B\624B\52A8\6DFB\52A0\6B64\5217\3002</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>unistr('\56FE\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4F7F\7528\5404\79CD\5185\7F6E\56FE\8868\7C7B\578B\663E\793A\6570\636E\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4417)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4417)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>unistr('\9690\85CF')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\9690\85CF\53D7\5F71\54CD\7684\5143\7D20\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4417)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9690\85CF\540C\4E00\884C\4E0A\7684\6240\6709\9875\9879')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\9690\85CF\4E0E\53D7\5F71\54CD\5143\7D20\4F4D\4E8E\540C\4E00\884C\4E0A\7684\6240\6709\9875\9879\548C\6807\7B7E\3002</p>'),
unistr('<p>\6CE8: \6B64\5C5E\6027\4E0D\9002\7528\4E8E\672A\4F7F\7528\8868\7F51\683C\6765\663E\793A\8868\5355\9879\7684\9875\4E0A\7684\9879\3002\8FD9\5305\62EC\4EFB\4F55\4F7F\7528\79FB\52A8\9875\6A21\677F\7684\9875\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>unistr('\542F\7528')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\542F\7528\53D7\5F71\54CD\7684\5143\7D20\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>unistr('\7981\7528')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\7981\7528\53D7\5F71\54CD\7684\5143\7D20\3002\7981\7528\540E\5C06\65E0\6CD5\7F16\8F91\8FD9\4E9B\5143\7D20, \56E0\6B64\5728\63D0\4EA4\9875\65F6\8FD9\4E9B\5143\7D20\4E0D\4FDD\7559\9879\503C\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>unistr('\8BBE\7F6E\503C')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\8BBE\7F6E\53D7\5F71\54CD\5143\7D20\7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8BBE\7F6E\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\6D3E\751F\503C\8FDB\884C\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9759\6001\5206\914D')
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\8BBE\7F6E\5355\4E2A\9759\6001\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_display_sequence=>15
,p_display_value=>unistr('JavaScript \8868\8FBE\5F0F')
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('\8BBE\7F6E\4ECE JavaScript \6D3E\751F\6216\8BA1\7B97\5F97\5230\7684\4E00\4E2A\6216\591A\4E2A\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_display_sequence=>20
,p_display_value=>unistr('SQL \8BED\53E5')
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('\6839\636E SQL \67E5\8BE2\7684\7ED3\679C\8BBE\7F6E\4E00\4E2A\6216\591A\4E2A\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_display_sequence=>40
,p_display_value=>unistr('PL/SQL \8868\8FBE\5F0F')
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('\6839\636E PL/SQL \8868\8FBE\5F0F\7684\7ED3\679C\8BBE\7F6E\5355\4E2A\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_display_sequence=>50
,p_display_value=>unistr('PL/SQL \51FD\6570\4F53')
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('\6839\636E PL/SQL \51FD\6570\4F53\7684\7ED3\679C\8BBE\7F6E\5355\4E2A\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_display_sequence=>60
,p_display_value=>unistr('\5BF9\8BDD\6846\8FD4\56DE\9879')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\6839\636E\5BF9\8BDD\6846\7684\8FD4\56DE\9879\8BBE\7F6E\5355\4E2A\503C\3002\6CE8: \4EC5\5F53\4E3A<strong>\5BF9\8BDD\6846\5DF2\5173\95ED</strong>\4E8B\4EF6\89E6\53D1\52A8\6001\64CD\4F5C\65F6, \6B64\7C7B\578B\624D\6709\6548\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('\8F93\5165\9759\6001\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('SQL \8BED\53E5')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>\5728\6B64\793A\4F8B\4E2D, \5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\8F93\5165 <code>P1_DEPTNO</code>\3002\8FD8\5E94\5206\522B\4E3A <code>loc</code> \548C <code>dname</code> \5217\5404\9009\62E9\4E00\4E2A<em>\53D7\5F71\54CD\7684\5143\7D20</em>, \4F8B\5982 P1_LOC \548C P1_DNAME\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8FD4\56DE\7684\5217\6570\5728 1 \5230 100 \4E4B\95F4\7684 SQL \8BED\53E5\3002\4F7F\7528 SQL \8BED\53E5\9009\62E9\7684\5217\7684\4F4D\7F6E\9700\8981\4E0E\5728<strong>\53D7\5F71\54CD\7684\5143\7D20</strong>\4E2D\9009\62E9\7684\9875\9879\76F8\5BF9\5E94\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\7ED1\5B9A\8BED\6CD5\5F15\7528\9875\6216\5E94\7528\7A0B\5E8F\9879, \524D\63D0\662F\60A8\5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\5305\62EC\8FD9\4E9B\9879</p>'),
unistr('<p><em>\6CE8: \5982\679C SQL \8BED\53E5\53EA\8FD4\56DE\4E00\884C, \5219\8BBE\7F6E\4E3A\503C\3002\5982\679C\8FD4\56DE\4E86\591A\884C, \5219\503C\96C6\662F\6240\6709\884C\6784\6210\7684\9017\53F7\5206\9694\7684\5B57\7B26\4E32, \6BCF\4E2A\503C\4E0E\4E00\884C\5BF9\5E94\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('PL/SQL \8868\8FBE\5F0F')
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>\5728\6B64\793A\4F8B\4E2D, \5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\8F93\5165 <code>P1_SAL</code>\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\8BBE\7F6E\503C\7684 PL/SQL \8868\8FBE\5F0F\3002</p>'),
unistr('<p>\53EF\4EE5\5F15\7528\9875\6216\5E94\7528\7A0B\5E8F\9879, \524D\63D0\662F\60A8\5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\5305\62EC\8FD9\4E9B\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('JavaScript \8868\8FBE\5F0F')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\4EE3\7801\53EF\4EE5\8BBF\95EE\4EE5\4E0B\4E0E\52A8\6001\64CD\4F5C\76F8\5173\7684\5C5E\6027:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\5BF9\89E6\53D1\52A8\6001\64CD\4F5C\7684\5143\7D20\7684 DOM \5BF9\8C61\7684\5F15\7528\3002</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\5305\542B\6240\6709\53D7\5F71\54CD\5143\7D20\7684 jQuery \5BF9\8C61\3002</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\5305\542B\64CD\4F5C\540D\79F0\53CA\5176\4ED6\5C5E\6027\503C\7B49\8BE6\7EC6\4FE1\606F\7684\64CD\4F5C\5BF9\8C61\3002</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\89E6\53D1\4E86\4E8B\4EF6\7684\4E8B\4EF6\5BF9\8C61\3002\6CE8: \5728\52A0\8F7D\65F6\6B64\5C5E\6027\7B49\4E8E ''\52A0\8F7D''\3002</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\53EF\4ECE\4E8B\4EF6\5904\7406\7A0B\5E8F\4F20\9012\7684\5176\4ED6\53EF\9009\6570\636E\3002</dd>'),
'</dl>'))
,p_help_text=>unistr('\8F93\5165\7528\4E8E\8BBE\7F6E\503C\7684 JavaScript \8868\8FBE\5F0F\3002\6B64\8868\8FBE\5F0F\53EF\4EE5\751F\6210\5355\503C, \4E5F\53EF\4EE5\5F97\5230\503C\6570\7EC4 (\5176\4E2D, \8BBE\7F6E\7684\9879\652F\6301\591A\4E2A\503C, \4F8B\5982\201C\5F80\8FD4\201D)\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('PL/SQL \51FD\6570\4F53')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>\5728\6B64\793A\4F8B\4E2D, \5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\8F93\5165 <code>P1_SAL</code> \548C <code>P1_JOB</code>\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\8BBE\7F6E\503C\7684 PL/SQL \51FD\6570\4F53\3002</p>'),
unistr('<p>\53EF\4EE5\5F15\7528\9875\6216\5E94\7528\7A0B\5E8F\9879, \524D\63D0\662F\60A8\5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\5305\62EC\8FD9\4E9B\9879\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\8981\63D0\4EA4\7684\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('\8F93\5165\6267\884C\6B64\64CD\4F5C\65F6\8981\63D0\4EA4\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8F6C\4E49\7279\6B8A\5B57\7B26')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('\6307\5B9A\662F\5426\5BF9 HTML \7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002Oracle \5F3A\70C8\5EFA\8BAE\5C06\6B64\5C5E\6027\8BBE\7F6E\4E3A<strong>\662F</strong>, \4EE5\9632\6B62\8DE8\7AD9\70B9\811A\672C (XSS) \653B\51FB\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\9690\85CF\66F4\6539\4E8B\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\5728<strong>\8981\8FD4\56DE\7684\9875\9879</strong>\4E2D\6307\5B9A\7684\9879\4E0A\7981\6B62\66F4\6539\4E8B\4EF6\3002\8FD9\5C06\9632\6B62\4E3A\8FD9\4E9B\9879\89E6\53D1\540E\7EED\57FA\4E8E<em>\66F4\6539</em>\7684\52A8\6001\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4417)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>unistr('\8FD4\56DE\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\8BBE\7F6E\503C\7684\5BF9\8BDD\6846\8FD4\56DE\7684\9875\9879\540D\79F0\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('\6267\884C JavaScript \4EE3\7801')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4F7F\60A8\53EF\4EE5\5B9A\4E49\6216\8C03\7528\5B9A\5236\7684\7279\5B9A\4E8E\9875\7684 JavaScript \4EE3\7801, \4EE5\4FBF\5728\52A8\6001\64CD\4F5C\6846\67B6\4E2D\4F7F\7528\3002\5982\679C\8981\5B9A\4E49\4EC5\7279\5B9A\4E8E\67D0\4E00\9875\7684 JavaScript \4EE3\7801, \5219\53EF\4EE5\4F7F\7528\9875\7EA7\5C5E\6027<em>\51FD\6570\548C\5168\5C40\53D8\91CF\58F0\660E</em>\6765\5B9A\4E49\6B64\9879\3002\4F7F\7528\6B64\5C5E\6027\5B9A\4E49\7684\51FD\6570\548C\53D8\91CF\53EF\4EE5\968F\540E\4ECE\6B64\64CD\4F5C\5F15\7528\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4417)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4EE3\7801')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6B64\4EE3\7801\53EF\4EE5\8BBF\95EE\4EE5\4E0B\4E0E\52A8\6001\64CD\4F5C\76F8\5173\7684\5C5E\6027:</p>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>\5BF9\89E6\53D1\52A8\6001\64CD\4F5C\7684\5143\7D20\7684 DOM \5BF9\8C61\7684\5F15\7528\3002</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
unistr('    <dd>\5305\542B\6240\6709\53D7\5F71\54CD\5143\7D20\7684 jQuery \5BF9\8C61\3002</dd>'),
'  <dt><code>this.action</code></dt>',
unistr('    <dd>\5305\542B\64CD\4F5C\540D\79F0\53CA\5176\4ED6\5C5E\6027\503C\7B49\8BE6\7EC6\4FE1\606F\7684\64CD\4F5C\5BF9\8C61\3002</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>\89E6\53D1\4E86\4E8B\4EF6\7684\4E8B\4EF6\5BF9\8C61\3002\6CE8: \5728\52A0\8F7D\65F6\6B64\5C5E\6027\7B49\4E8E ''\52A0\8F7D''\3002</dd>'),
'  <dt><code>this.data</code></dt>',
unistr('    <dd>\53EF\4ECE\4E8B\4EF6\5904\7406\7A0B\5E8F\4F20\9012\7684\5176\4ED6\53EF\9009\6570\636E\3002</dd>'),
'</dl>'))
,p_help_text=>unistr('\8F93\5165\7279\5B9A\4E8E\9875\6216\52A8\6001\64CD\4F5C\7684\4EFB\4F55\5B9A\5236 JavaScript\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>unistr('\4EA4\4E92\5F0F\7F51\683C - \81EA\52A8\884C\5904\7406 (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\63D2\5165, \66F4\65B0\6216\5220\9664\4EA4\4E92\5F0F\7F51\683C\884C\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76EE\6807\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\4E3A\4FDD\5B58\5BF9\4EA4\4E92\5F0F\7F51\683C\6240\505A\7684\6570\636E\66F4\6539\800C\6267\884C\7684\884C\5904\7406\6280\672F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\533A\57DF\6E90')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165, \66F4\65B0\548C\5220\9664\64CD\4F5C\4F7F\7528\533A\57DF\6E90 SQL \67E5\8BE2\3002</p>'),
unistr('<p>\6CE8 - \5BF9\4E8E\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\7684\5217, \786E\4FDD<strong>\4EC5\67E5\8BE2</strong>\8BBE\7F6E\4E3A<code>\662F</code>\4EE5\6392\9664\8FD9\4E9B\5217\800C\4E0D\8FDB\884C\5904\7406\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8868/\89C6\56FE')
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\63D2\5165, \66F4\65B0\548C\5220\9664\64CD\4F5C\4F7F\7528\7684\8868\6216\89C6\56FE\4E0D\540C\4E8E\533A\57DF\6E90 SQL \67E5\8BE2\4E2D\5B9A\4E49\7684\8868\6216\89C6\56FE\3002'),
unistr('\4F8B\5982, SQL \67E5\8BE2\4ECE\8868\8054\63A5\7684\89C6\56FE\6216\53EF\8FDE\63A5\7684\89C6\56FE\68C0\7D22\6570\636E, \5E76\4E14\9700\8981\5BF9\5355\4E2A\57FA\8868\6216\53EF\66F4\65B0\89C6\56FE\6267\884C DML \5904\7406\3002</p>'),
unistr('<p>\6CE8 - \5BF9\4E8E\4E0D\53EF\63D2\5165\6216\4E0D\53EF\66F4\65B0\7684\5217, \786E\4FDD<strong>\4EC5\67E5\8BE2</strong>\8BBE\7F6E\4E3A<code>\662F</code>\4EE5\6392\9664\8FD9\4E9B\5217\800C\4E0D\8FDB\884C\5904\7406\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \4EE3\7801')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5904\7406\64CD\4F5C\57FA\4E8E\5B9A\5236 PL/SQL \4EE3\7801\3002\4F7F\7528\6B64\9009\9879\53EF\4EE5\6267\884C\4EFB\4F55 PL/SQL \4EE3\7801\4EE5\5728\57FA\7840\6570\636E\5E93\4E2D\5B9E\65BD\4EFB\4F55\6570\636E\64CD\7EB5\3002</p>'),
unistr('<p>\5F53\4F7F\7528\6570\636E\5E93\7A0B\5E8F\5305 (\4F8B\5982\8868 API \6216 RESTful Web \670D\52A1\8C03\7528) \5B9E\65BD\4E1A\52A1\903B\8F91\65F6, \5E94\4F7F\7528\6B64\9009\9879\3002</p>'),
unistr('<p>\6CE8 - \5C06\4E3A\5DF2\63D2\5165, \5DF2\66F4\65B0\6216\5DF2\5220\9664\7684\6BCF\4E00\884C\8C03\7528 PL/SQL \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4417)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7528\4E8E\6267\884C\63D2\5165/\66F4\65B0/\5220\9664\7684 PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 PL/SQL \4EE3\7801\4EE5\5904\7406\5728\4EA4\4E92\5F0F\7F51\683C\4E2D\64CD\7EB5\7684\6BCF\4E00\884C\6570\636E\3002</p>'),
unistr('<p>\4F7F\7528\5217\540D\4F5C\4E3A\7ED1\5B9A\53D8\91CF\6765\8BBF\95EE\5217\503C\3002\7CFB\7EDF\53D8\91CF <code>APEX$ROW_STATUS</code> \8FD4\56DE\884C\7684\72B6\6001, \53EF\7528\4E8E\68C0\67E5\662F\5426\5DF2\521B\5EFA, \66F4\65B0\6216\5220\9664\4E86\884C (\8BF7\53C2\9605\4EE5\4E0B\793A\4F8B\4EE5\4E86\89E3\5982\4F55\68C0\67E5\6B64\9879)\3002</p>'),
unistr('<p><em>\6CE8:</em> \5982\679C\7531\89E6\53D1\5668\6216\8005\5728 PL/SQL \4EE3\7801\4E2D\586B\5145\4E86\4E3B\952E\5217, \5219\9700\8981\5C06\65B0\503C\5206\914D\5230\4E3B\952E\5217\7684\7ED1\5B9A\53D8\91CF, \56E0\4E3A &PRODUCT_NAME. \4F7F\7528\8FD9\4E9B\503C\5728\63D2\5165\6216\66F4\65B0\4E4B\540E\63D0\53D6\884C\3002</p>'),
unistr('<p>Oracle \5EFA\8BAE\8C03\7528 PL/SQL \7A0B\5E8F\5305\5185\7684\8FC7\7A0B\6216\51FD\6570, \4EE5\4FBF\4E8E\91CD\7528\548C\7EF4\62A4\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9632\6B62\4E22\5931\66F4\65B0')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5904\7406\662F\5426\5E94\5728\591A\4E2A\7528\6237\66F4\65B0\540C\4E00\6761\6570\636E\5E93\8BB0\5F55\65F6\786E\4FDD\66F4\65B0\4E0D\4E22\5931\3002</p> '),
unistr('<p>\5982\679C\4E24\4E2A\6216\66F4\591A\4EBA\5458\5C1D\8BD5\66F4\65B0\540C\4E00\6570\636E\5E76\4E14\6700\540E\7684\66F4\65B0\8986\76D6\7B2C\4E00\4E2A\7528\6237\6240\505A\7684\66F4\65B0\6765\4FDD\5B58\66F4\6539, \66F4\65B0\4F1A\4E22\5931\3002\4E3A\9632\6B62\53D1\751F\8FD9\79CD\60C5\51B5, \66F4\65B0\4F1A\68C0\67E5\6570\636E\5E93\4E2D\7684\73B0\6709\5217\503C\4EE5\53CA\6700\521D\67E5\8BE2\884C\65F6\68C0\7D22\5230\7684\76F8\5E94\503C\3002</p>'),
unistr('<p>\4F8B\5982:'),
'  <ol>',
unistr('    <li>\7528\6237 A \67E5\8BE2\96C7\5458 (EMP) \8BB0\5F55\3002</li>'),
unistr('    <li>\7528\6237 B \67E5\8BE2\76F8\540C\7684\96C7\5458\8BB0\5F55\3002</li>'),
unistr('    <li>\7528\6237 B \66F4\65B0 EMPNO = 7839 \7684\96C7\5458\8BE6\7EC6\4FE1\606F\5E76\5411\6570\636E\5E93\5E94\7528 (\63D0\4EA4) \66F4\6539\3002</li>'),
unistr('    <li>\7528\6237 A \66F4\65B0 EMPNO = 7839 \7684\96C7\5458\8BE6\7EC6\4FE1\606F\5E76\5C1D\8BD5\5411\6570\636E\5E93\5E94\7528\66F4\6539\3002</li>'),
'  </ol>',
unistr('\5982\679C\7528\6237 A \6210\529F\66F4\65B0\76F8\540C\7684\884C, \5219\7528\6237 B \6240\505A\7684\66F4\6539\5C06\4E22\5931\3002'),
unistr('\5F53\7528\6237 A \5C1D\8BD5\4FDD\5B58\96C7\5458\884C\65F6, \6570\636E\5E93\4E2D\7684\6570\636E\4E0D\540C\4E8E\7528\6237 A \6700\521D\67E5\8BE2\5230\7684\6570\636E\3002\5728\4E0A\9762\7684\6B65\9AA4 1 \4E2D, \53EF\4EE5\6355\83B7\7528\6237 A \6700\521D\67E5\8BE2\7684\5217\503C\3002\7136\540E\5728\4E0A\9762\7684\6B65\9AA4 4 \4E2D, \8FD9\4E9B\503C\53EF\4E0E\6570\636E\5E93\4E2D\7684\5F53\524D\503C\8FDB\884C\6BD4\8F83\3002\6B64\6BD4\8F83\5C06\5BF9\7528\6237 A \5F15\53D1\9519\8BEF, \56E0\4E3A\6570\636E\5E93\503C\7531\7528\6237 B \5728\6B65\9AA4 3 \4E2D\8FDB\884C\4E86\66F4\65B0\3002\8FD9\53EF\9632\6B62\7528\6237\8986\76D6\5176\4ED6\7528\6237\5BF9\76F8\540C\884C\6240\505A\7684\66F4\6539\3002</p>'),
unistr('<p>\6CE8 - \6839\636E<strong>\4E22\5931\7684\66F4\65B0\7C7B\578B</strong>\7684\8BBE\7F6E, \5728\201C\4EA4\4E92\5F0F\7F51\683C\7684\5C5E\6027\201D\533A\57DF\4E2D\6307\5B9A\5982\4F55\68C0\6D4B\4E22\5931\7684\66F4\65B0\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\9501\5B9A\884C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\5728\5904\7406\6BCF\4E00\884C\4E4B\524D\662F\5426\5728\57FA\7840\8868\4E2D\9501\5B9A\8981\66F4\65B0\6216\5220\9664\7684\76F8\5E94\884C\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\662F')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C06\4F7F\7528 SELECT ... FOR UPDATE \9501\5B9A\8981\66F4\65B0\6216\5220\9664\7684\884C\76F4\81F3\63D0\4EA4\4E8B\52A1\5904\7406, \4ECE\800C\963B\6B62\5BF9\8FD9\4E9B\884C\6267\884C\5176\4ED6\4E8B\52A1\5904\7406\3002</p>'),
unistr('<p>\6CE8 - \5982\679C\5F15\53D1\9519\8BEF (\4F8B\5982, \53EF\66F4\65B0\7684\89C6\56FE\4E0D\652F\6301\9501\5B9A), \53EF\4EE5\4F7F\7528 PL/SQL \4EE3\7801\9501\5B9A\9A71\52A8\8868\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5426')
,p_return_value=>'N'
,p_help_text=>unistr('\5C06\4E0D\9501\5B9A\884C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4417)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \4EE3\7801')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('\5B9A\5236 PL/SQL \4EE3\7801\5C06\7528\4E8E\9501\5B9A\884C, \76F4\81F3\63D0\4EA4\4E8B\52A1\5904\7406\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7528\4E8E\9501\5B9A\884C\7684 PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('\8F93\5165 PL/SQL \4EE3\7801\4EE5\9501\5B9A\8981\66F4\65B0\548C\5220\9664\7684\6570\636E\5E93\8868\884C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4417)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\63D2\5165\540E\8FD4\56DE\4E3B\952E')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\662F\5426\5E94\5F53\5728\4EA4\4E92\5F0F\7F51\683C\884C\63D2\5165\5230\6570\636E\5E93\4E4B\540E\5C06\4E3B\952E\5217\8FD4\56DE\5230\5BF9\5E94\7684\8BE5\884C\3002'),
unistr('\901A\5E38\FF0C\5F53\4ECE\6570\636E\5E93\89E6\53D1\5668\6216 Oracle Database 12 <em>c</em> \6807\8BC6\5217\586B\5145\4E3B\952E\5217\65F6\FF0C\5E94\4F7F\7528\6B64\9009\9879\3002</p>'),
unistr('<p>\6CE8 - \5982\679C\5F15\53D1\4E86\9519\8BEF\FF0C\5E76\4E14\6307\5B9A\4E0D\5141\8BB8\4F7F\7528 RETURNING INTO \5B50\53E5\FF0C\5219\5FC5\987B\5C06\6B64\9009\9879\8BBE\7F6E\4E3A\201C\5426\201D\5E76\9884\5148\586B\5145\4E3B\952E\5217\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>unistr('\6DFB\52A0\7C7B')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C06\4E00\4E2A\6216\591A\4E2A CSS \7C7B\6DFB\52A0\5230\53D7\5F71\54CD\7684\5143\7D20\4E2D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4417)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5411\53D7\5F71\54CD\5143\7D20\7684 HTML \6807\8BB0\6DFB\52A0 CSS \7C7B <code>articlenumber</code> \548C <code>highlight</code>:'),
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('\6307\5B9A\4E00\4E2A\6216\591A\4E2A\5C06\5E94\7528\4E8E\53D7\5F71\54CD\5143\7D20\7684\7C7B\3002\5982\679C\6307\5B9A\591A\4E2A\7C7B, \8BF7\7528\7A7A\683C\5206\9694\7C7B\540D\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>unistr('\5220\9664\7C7B')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4ECE\53D7\5F71\54CD\7684\5143\7D20\4E2D\5220\9664\4E00\4E2A\6216\591A\4E2A CSS \7C7B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4417)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>\6307\5B9A\4E00\4E2A\6216\591A\4E2A\5C06\4ECE\53D7\5F71\54CD\5143\7D20\4E2D\5220\9664\7684\7C7B\540D\3002\5982\679C\6307\5B9A\591A\4E2A\7C7B\540D, \8BF7\7528\7A7A\683C\5206\9694\7C7B\540D\3002\7559\7A7A\53EF\4ECE\53D7\5F71\54CD\5143\7D20\4E2D\5220\9664\6240\6709\7C7B\540D\3002</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>unistr('\8BBE\7F6E\6837\5F0F')
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4E3A\53D7\5F71\54CD\7684\5143\7D20\8BBE\7F6E\6837\5F0F (CSS) \5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4417)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6837\5F0F\540D\79F0')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\4E3A\53D7\5F71\54CD\5143\7D20\8BBE\7F6E\7684\6837\5F0F (CSS) \5C5E\6027\7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4417)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\4E3A\53D7\5F71\54CD\5143\7D20\8BBE\7F6E\7684\6837\5F0F\5C5E\6027\7684\503C\3002\7559\7A7A\53EF\4ECE\53D7\5F71\54CD\5143\7D20\4E2D\5220\9664\6837\5F0F\5C5E\6027\3002')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>unistr('\5B9A\5236')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5141\8BB8\60A8\5B9A\4E49\81EA\5DF1\7684 PL/SQL \51FD\6570\7528\4E8E\786E\5B9A\7528\6237\9A8C\8BC1\7684\9A8C\8BC1\65B9\6848\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\536B\58EB\51FD\6570\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728 ''PL/SQL \4EE3\7801'' \5185\6307\5B9A\8FD4\56DE\5E03\5C14\503C\7684 PL/SQL \4EE3\7801 -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>\6307\5B9A PL/SQL \6570\636E\5E93\51FD\6570 - </p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\5F00\59CB\5411 &PRODUCT_NAME. \5F15\64CE\53D1\51FA\4EFB\4F55\8BF7\6C42\65F6 (\4F8B\5982\5728\663E\793A\6216\5904\7406\6BCF\4E00\9875\4E4B\524D) \6216\5728\53D1\51FA AJAX \8BF7\6C42\65F6, \7531\6B64\5F15\64CE\6267\884C\7684\51FD\6570\7684\540D\79F0\3002'),
unistr('\5B83\53EF\4EE5\5728\9A8C\8BC1\7684 PL/SQL \4EE3\7801\4E2D\5B9A\4E49, \53EF\4EE5\4F4D\4E8E\7A0B\5E8F\5305\5185, \4E5F\53EF\4EE5\4F5C\4E3A\5B58\50A8\51FD\6570\3002</p>'),
unistr('<p>\5982\679C\6B64\51FD\6570\8FD4\56DE\201C\5047\201D(\8868\793A\6B64\7528\6237\53EF\80FD\5C1A\672A\767B\5F55), \8FD9\4F1A\5C06\4F1A\8BDD\6807\8BB0\4E3A\65E0\6548, \5E76\4E14\7CFB\7EDF\5C06\8C03\7528<em>\65E0\6548\4F1A\8BDD\8FC7\7A0B</em>\3002'),
unistr('\6B64\540E, &PRODUCT_NAME. \5C06\91CD\5B9A\5411\5230 ''\4F1A\8BDD\65E0\6548 > \8F6C\5230'' \4E2D\5B9A\4E49\7684 URL\3002'),
unistr('\5982\679C\6B64\5B57\6BB5\7684\503C\4E3A\7A7A,'),
unistr('\5219\5C06\8C03\7528\5185\90E8\9ED8\8BA4\536B\58EB\51FD\6570, \6B64\51FD\6570\5C1D\8BD5\901A\8FC7\6BD4\8F83 URL \4E2D\7684\4F1A\8BDD ID \4E0E\9A8C\8BC1\65B9\6848 cookie \4E2D\7684\4F1A\8BDD\4FE1\606F (\5982\679C\6BD4\8F83\5931\8D25, \5C06\9000\56DE\4F7F\7528 &PRODUCT_NAME. \6784\5EFA\5668 cookie) \6765\5EFA\7ACB\6709\6548\4F1A\8BDD\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4F1A\8BDD\8FC7\7A0B\540D\65E0\6548')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\68C0\6D4B\5230\65E0\6548\4F1A\8BDD\65F6\8C03\7528\7684 PL/SQL \8FC7\7A0B\7684\540D\79F0\3002</p>'),
'',
unistr('<p>\53EF\4EE5\5F15\7528\6570\636E\5E93\4E2D\7684\533F\540D PL/SQL \4EE3\7801\5757\7684\51FD\6570, \7A0B\5E8F\5305\51FD\6570\6216\72EC\7ACB\51FD\6570\3002\4F8B\5982: <code>invalid_session_basic_auth</code></p>'),
'',
unistr('<p>\5F15\7528\6570\636E\5E93 PL/SQL \7A0B\5E8F\5305\6216\72EC\7ACB\51FD\6570\65F6, \53EF\4EE5\4F7F\7528 <code>#OWNER#</code> \66FF\6362\5B57\7B26\4E32\6765\5F15\7528\5F53\524D\5E94\7528\7A0B\5E8F\7684\8BED\6CD5\5206\6790\65B9\6848\3002\4F8B\5982: <code>#OWNER#.invalid_session_basic_auth</code></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9A8C\8BC1\51FD\6570\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\201CPL/SQL \4EE3\7801\201D\6587\672C\533A\57DF\4E2D\8F93\5165\4EE5\4E0B\4EE3\7801</p>'),
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
unistr('<p>\5E76\5C06 <code>my_authentication</code> \4F5C\4E3A\201C\9A8C\8BC1\51FD\6570\201D\3002')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5728\767B\5F55\9875\4E0A\8F93\5165\7528\6237\7684\7528\6237\540D\548C\5BC6\7801\540E\5C06\5BF9\5176\8FDB\884C\9A8C\8BC1\7684\51FD\6570\7684\540D\79F0\3002'),
unistr('\5982\679C\4E0D\8F93\5165\4EFB\4F55\503C, \5C06\5141\8BB8\4EFB\4F55\7528\6237\540D/\5BC6\7801\6210\529F\901A\8FC7\3002'),
unistr('\51FD\6570\672C\8EAB\53EF\4EE5\5728\9A8C\8BC1\7684 ''PL/SQL \4EE3\7801'' \6587\672C\533A\57DF\4E2D\5B9A\4E49, \53EF\4EE5\4F4D\4E8E\7A0B\5E8F\5305\5185, \4E5F\53EF\4EE5\4F5C\4E3A\5B58\50A8\51FD\6570\3002</p>'),
'',
unistr('<p>\6B64\51FD\6570\5FC5\987B\5411\8C03\7528\51FD\6570\7684\767B\5F55\8FC7\7A0B\8FD4\56DE\5E03\5C14\503C\3002\5B83\5177\6709\4E24\4E2A\8F93\5165\53C2\6570 ''p_username'' \548C ''p_password'', \5B83\4EEC\53EF\7528\4E8E\8BBF\95EE\6700\7EC8\7528\6237\5728\767B\5F55\9875\4E0A\8F93\5165\7684\503C\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6CE8\9500\540E\8FC7\7A0B\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728 ''PL/SQL \4EE3\7801'' \6587\672C\533A\57DF\4E2D\8F93\5165\4EE5\4E0B\4EE3\7801</p>'),
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
unistr('<p>\4EE5\53CA <code>my_post_logout</code> \4F5C\4E3A ''\6CE8\9500\540E\8FC7\7A0B''\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6700\7EC8\7528\6237\5355\51FB\6CE8\9500 URL \4E4B\540E\8C03\7528\7684\8FC7\7A0B\7684\540D\79F0\3002\6B64\8FC7\7A0B\53EF\4EE5\5728\767B\5F55\4E2D\4F7F\7528\3002'),
unistr('\8FC7\7A0B\672C\8EAB\53EF\4EE5\5728\9A8C\8BC1\7684 ''PL/SQL \4EE3\7801'' \6587\672C\533A\57DF\4E2D\5B9A\4E49, \53EF\4EE5\4F4D\4E8E\7A0B\5E8F\5305\5185, \4E5F\53EF\4EE5\4F5C\4E3A\5B58\50A8\51FD\6570\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\542F\7528\65E7\9A8C\8BC1\5C5E\6027')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5C06\6B64\9009\62E9\5217\8868\8BBE\7F6E\4E3A "\662F", \5219\5176\4ED6\9A8C\8BC1\5C5E\6027\5C06\53EF\89C1\3002'),
unistr('\8FD9\4E9B\5C5E\6027\4E3B\8981\4E0E\4ECE &PRODUCT_NAME. 4.0 \548C\66F4\65E9\7248\672C\4E2D\79FB\690D\8FC7\6765\7684\5B9A\5236\9A8C\8BC1\76F8\5173\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('SSO \5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\540D\79F0')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\5229\7528 Oracle Application Server Single Sign-On \8FDB\884C\9A8C\8BC1, \800C\60A8\7684\5E94\7528\7A0B\5E8F\662F SSO \7684\6CE8\518C\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F, \5219\8F93\5165\7684\540D\79F0\5FC5\987B\4E0E\60A8\5728\5411 SSO \6CE8\518C\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\65F6\4F7F\7528\7684\540D\79F0\5B8C\5168\76F8\540C\3002'),
'',
unistr('\5982\679C\5C06 Application Express \4F5C\4E3A\6CE8\518C\7684\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F, \8BF7\5C06\6B64\5B57\6BB5\7559\7A7A\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP \4E3B\673A')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP \76EE\5F55\670D\52A1\5668\7684\4E3B\673A\540D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('LDAP \7AEF\53E3')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('LDAP \76EE\5F55\4E3B\673A\7684\7AEF\53E3\53F7\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\4F7F\7528 SSL')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\662F\5426\4F7F\7528 SSL \7ED1\5B9A\5230 LDAP \76EE\5F55\3002\5982\679C\9009\62E9\5E26\9A8C\8BC1\7684 SSL, \5219\5FC5\987B\4E3A Application Express \5B9E\4F8B\914D\7F6E Wallet\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4417)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5E26\9A8C\8BC1\7684 SSL')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\65E0 SSL')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('LDAP DN \5B57\7B26\4E32')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\7CBE\786E DN</dt>'),
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
unistr('  <dt>\975E\7CBE\786E DN (\641C\7D22\57FA\7840)</dt>'),
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('\5982\679C\4F7F\7528\7CBE\786E DN, \5219\8F93\5165\7528\4E8E\6784\9020 DBMS_LDAP.SIMPLE_BIND_S \7684\5168\9650\5B9A\552F\4E00\5224\522B\540D (DN) \5B57\7B26\4E32\7684\6A21\5F0F, \5982\679C\4F7F\7528\975E\7CBE\786E DN, \5219\8F93\5165\641C\7D22\57FA\7840\3002\4F7F\7528 <strong>%LDAP_USER%</strong> \4F5C\4E3A\7528\6237\540D\7684\5360\4F4D\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\4F7F\7528\7CBE\786E\7684\552F\4E00\5224\522B\540D (DN)')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\9009\62E9 LDAP \552F\4E00\5224\522B\540D (DN) \5B57\7B26\4E32\662F\7CBE\786E\7684\8FD8\662F\975E\7CBE\786E\7684\3002\5982\679C\662F\975E\7CBE\786E\7684, \5219 LDAP \552F\4E00\5224\522B\540D (DN) \662F\641C\7D22\57FA\7840\5E76\4E14\60A8\5FC5\987B\63D0\4F9B\641C\7D22\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\641C\7D22\8FC7\6EE4\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('\8F93\5165\4E0D\4F7F\7528\7CBE\786E\552F\4E00\5224\522B\540D (DN) \65F6\7684\641C\7D22\8FC7\6EE4\5668\3002\4F7F\7528 <code>%LDAP_USER%</code> \4F5C\4E3A\7528\6237\540D\7684\5360\4F4D\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('LDAP \7528\6237\540D\7F16\8F91\51FD\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EE5\4E0B\4EE3\7801\8C03\7528\5C06 DN \5B57\7B26\4E32\4E2D\7684\6240\6709 "." \66FF\6362\4E3A "_" \7684\51FD\6570:</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('\53EF\4EE5\63D0\4F9B\5176\4ED6\8981\6267\884C\7684\4EE3\7801\6765\5C06\7528\6237\540D\8F6C\6362\4E3A\5B8C\5168\9002\5408\4E8E LDAP \76EE\5F55\6761\76EE\6216 LDAP \7528\6237\540D\7684\683C\5F0F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4417)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\7528\6237\540D\8F6C\4E49')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5728\66FF\6362 LDAP \552F\4E00\5224\522B\540D\548C\641C\7D22\5B57\7B26\4E32\4E2D\7684 <code><strong>%LDAP_USER%</strong></code> \4E4B\524D,'),
unistr('&PRODUCT_NAME. \53EF\4EE5\81EA\52A8\5BF9\7528\6237\540D\4E2D\7684\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6807\51C6')
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6839\636E RFC 4514 (\9002\7528\4E8E\552F\4E00\5224\522B\540D) \548C RFC 4515 (\9002\7528\4E8E\641C\7D22\5B57\7B26\4E32) \5BF9\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\6B64\5916, \8FD8\4F1A\5BF9 unicode \5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\8FD9\662F\6700\5B89\5168\7684\8BBE\7F6E, \4F46\53EF\80FD\4F1A\4F7F\67D0\4E9B LDAP \670D\52A1\5668\51FA\73B0\95EE\9898\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4EC5\7279\6B8A\5B57\7B26')
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6839\636E RFC 4514 (\9002\7528\4E8E\552F\4E00\5224\522B\540D) \548C RFC 4515 (\9002\7528\4E8E\641C\7D22\5B57\7B26\4E32) \5BF9\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\4E0D\4F1A\5BF9 unicode \5B57\7B26\8FDB\884C\8F6C\4E49\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\65E0\8F6C\4E49')
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0D\4F1A\5BF9\4EFB\4F55\5B57\7B26\8FDB\884C\8F6C\4E49\3002\6B64\8BBE\7F6E\53EF\80FD\4E0D\5B89\5168,'),
unistr('\9664\975E\91C7\7528<strong>\7528\6237\540D\7F16\8F91\51FD\6570</strong>,'),
unistr('\6B64\51FD\6570\5DF2\5BF9\7528\6237\540D\8FDB\884C\8F6C\4E49 (\4F8B\5982, \4F7F\7528 <code>apex_escape.ldap_dn</code> \6216 <code>apex_escape.ldap_search_filter</code>)\3002')))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('\6267\884C\4EE3\7801')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\7528\4E8E\6267\884C PL/SQL \4EE3\7801\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('\5173\95ED\5BF9\8BDD\6846')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\7528\4E8E\5173\95ED\5F53\524D\6A21\5F0F\6216\65E0\6A21\5F0F\5BF9\8BDD\6846\9875\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4417)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8981\8FD4\56DE\7684\9879 ')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\7531\5BF9\8BDD\6846\8FD4\56DE\7684\4E00\4E2A\6216\591A\4E2A\9875\9879\7684\540D\79F0\3002\5BF9\4E8E\591A\4E2A\9879, \8BF7\4F7F\7528\9017\53F7\5206\9694\5404\4E2A\9879\540D\3002</p>'),
unistr('<p>\53EF\4EE5\901A\8FC7\5B9A\4E49\52A8\6001\64CD\4F5C\5728\6253\5F00\5BF9\8BDD\6846\7684\5143\7D20\4E0A\89E6\53D1<strong>\5BF9\8BDD\6846\5DF2\5173\95ED</strong>\4E8B\4EF6, \5E76\4F7F\7528<strong>\5BF9\8BDD\6846\8FD4\56DE\9879</strong>\7684\64CD\4F5C<strong>\8BBE\7F6E\503C</strong>\548C<em>\8BBE\7F6E\7C7B\578B</em>, \4ECE\800C\8BBF\95EE\8FD4\56DE\7684\9879\503C\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('\6E05\9664\4F1A\8BDD\72B6\6001')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\7528\4E8E\6E05\9664 &PRODUCT_NAME. \5185\5B58\50A8\7684\4F1A\8BDD\72B6\6001\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4417)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\8981\6E05\9664\7684\4F1A\8BDD\72B6\6001\7C7B\578B\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_display_sequence=>1
,p_display_value=>unistr('\6E05\9664\5F53\524D\9875\4E0A\7684\6240\6709\9879')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_display_sequence=>3
,p_display_value=>unistr('\6E05\9664\9875\4E0A\7684\6240\6709\9879')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\6E05\9664\9879  ')
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_display_sequence=>7
,p_display_value=>unistr('\6E05\9664\5F53\524D\4F1A\8BDD')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_display_sequence=>9
,p_display_value=>unistr('\6E05\9664\5F53\524D\5E94\7528\7A0B\5E8F')
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6E05\9664\5E94\7528\7A0B\5E8F')
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4417)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5E94\7528\7A0B\5E8F')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('\8F93\5165\9017\53F7\5206\9694\7684\5E94\7528\7A0B\5E8F ID \7684\5217\8868, \4F8B\5982 <code>100,101,105</code>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4417)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('\9009\62E9\8981\4ECE\4F1A\8BDD\72B6\6001\4E2D\6E05\9664\7684\9875\9879, \4F8B\5982 <code>P1_EMPNO,P1_ENAME</code>\3002\5BF9\4E8E\591A\4E2A\9879, \7528\9017\53F7\5206\9694\6BCF\4E2A\9879\540D\79F0\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4417)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9875')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('\8F93\5165\9017\53F7\5206\9694\7684\9875\7801\7684\5217\8868, \4F8B\5982 <code>1,2,5</code>\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('\91CD\7F6E\9875\7801')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\91CD\7F6E\5F53\524D\9875\4E0A\7684\62A5\8868\9875\7801\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4417)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\76EE\6807')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\662F\5E94\91CD\7F6E\6240\6709\9875, \67D0\4E9B\9875\8FD8\662F\5F53\524D\9875\4E0A\7684\9875\7801\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6B64\9875')
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9875')
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\6240\6709\9875')
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4417)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9875')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('\8F93\5165\9017\53F7\5206\9694\7684\9875\7801\7684\5217\8868\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>unistr('\8868\683C\5F0F\8868\5355 - \6DFB\52A0\884C')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\7528\4E8E\5411\8868\683C\5F0F\8868\5355\533A\57DF\4E2D\6DFB\52A0\884C\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4417)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\884C\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\884C\6570\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('\8868\683C\5F0F\8868\5355 - \591A\884C\66F4\65B0')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\7528\4E8E\66F4\65B0\8868\683C\5F0F\8868\5355\533A\57DF\4E2D\7684\591A\884C\7684\5904\7406\3002\6B64\5904\7406\8FD8\5C06\63D2\5165\5728\6B64\533A\57DF\4E2D\6DFB\52A0\7684\8BB0\5F55\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4417)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4417)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4417)
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4417)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4417)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5305\542B\4E3B\952E\503C\7684\5217\3002\5BF9\4E8E\4E3B\952E\90E8\5206\591A\4E8E\4E24\4E2A\7684\8868, \9009\62E9 <strong>ROWID</strong>\3002</p>'),
unistr('<p>\4E3B\952E\7528\4E8E\6807\8BC6\8981\66F4\65B0\7684\884C, \5E76\4E14\5728\8868\683C\5F0F\8868\5355\4E2D\4E0D\53EF\7F16\8F91\3002\5BF9\4E8E\65B0\884C, \4E3B\952E\503C\5FC5\987B\4E3A\7A7A\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4417)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6B21\7EA7\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\7B2C\4E8C\4E3B\952E\503C\7684\5217\3002\4EC5\5F53\4E3B\952E\7531\4E24\5217\7EC4\6210\65F6, \624D\5E94\586B\5145\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4417)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8FD0\884C\65F6 Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\4EE5\4E0B\8BED\53E5\9650\5236\90E8\95E8:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\8F93\5165\5C06\9644\52A0\5230\751F\6210\7684\6240\6709 INSERT \548C UPDATE \8BED\53E5\7684 SQL WHERE \5B50\53E5\3002\4F7F\7528\6B64\5C5E\6027\53EF\9650\5236\5728\81EA\52A8\751F\6210\7684 SQL \8C03\7528\4E2D\4F7F\7528\7684\8BB0\5F55\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>unistr('\81EA\52A8\884C\63D0\53D6')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\7528\4E8E\4ECE\5355\4E2A\6570\636E\5E93\8868\6216\89C6\56FE\68C0\7D22\8BB0\5F55\7684\5904\7406\3002\6B64\5904\7406\7528\4E8E\4E3A\8868\5355\9879\586B\5145<strong>\6570\636E\5E93\5217</strong>\7C7B\578B\7684\6E90\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4417)
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\4E3B\952E\503C\7684\5217\3002\5BF9\4E8E\4E3B\952E\90E8\5206\591A\4E8E\4E24\4E2A\7684\8868, \9009\62E9 <strong>ROWID</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6B21\7EA7\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\7B2C\4E8C\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>unistr('\6B21\7EA7\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4417)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\9009\62E9\5305\542B\7B2C\4E8C\4E3B\952E\503C\7684\5217\3002\4EC5\5F53\4E3B\952E\7531\4E24\5217\7EC4\6210\65F6, \624D\5E94\586B\5145\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\7248\672C\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4417)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6807\8BC6\884C\7248\672C\7684\5217, \6B64\5217\4E0D\9700\8981\5728\9875\4E0A\663E\793A\3002\5C06\6B64\5C5E\6027\7559\7A7A\53EF\4F7F\7528\5185\7F6E\7684\6821\9A8C\548C\3002</p>'),
unistr('<p>\64CD\4F5C\9501\5B9A\4F7F\7528\4E22\5931\7684\66F4\65B0\68C0\6D4B\529F\80FD\6765\786E\4FDD\53EF\4EE5\5E76\53D1\8BBF\95EE\6570\636E\7684\5E94\7528\7A0B\5E8F\4E2D\7684\6570\636E\5B8C\6574\6027\3002&PRODUCT_NAME. \53EF\4EE5\4F7F\7528\5185\7F6E\6821\9A8C\548C\6765\6267\884C\4E22\5931\7684\66F4\65B0\68C0\6D4B, \5E76\786E\5B9A\884C\7684\7248\672C\3002\6821\9A8C\548C\662F\7279\5B9A\8868\884C\7684\6240\6709\5217\503C\7684\6563\5217\51FD\6570\3002\4ECE\6570\636E\5E93\67E5\8BE2\8BB0\5F55\65F6\4F1A\68C0\7D22\6821\9A8C\548C, \7136\540E\5728<em>\81EA\52A8\884C\5904\7406</em>\8FC7\7A0B\4E2D\5C06\5176\4E0E\6570\636E\5E93\4E2D\5F53\524D\8BB0\5F55\7684\6563\5217\8FDB\884C\6BD4\8F83\3002\5982\679C\4E24\4E2A\503C\76F8\540C, \5219\66F4\65B0\7EE7\7EED, \5426\5219\201C\81EA\52A8\884C\5904\7406\201D\4F1A\5F15\53D1\9519\8BEF\3002</p>'),
unistr('<p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\6307\5B9A\4E00\5217\6765\5B58\653E\884C\7248\672C, \4F5C\4E3A\4F7F\7528\5185\7F6E\6821\9A8C\548C\5904\7406\7684\66FF\4EE3\65B9\6CD5\3002\6BCF\5F53\66F4\65B0\6570\636E\5E93\4E2D\7684\8BB0\5F55\65F6\90FD\5E94\66F4\65B0\6B64\5217\3002Oracle \5EFA\8BAE\5728\8868\4E0A\5B9E\65BD ''\66F4\65B0\4E4B\524D'' \6570\636E\5E93\89E6\53D1\5668\8FDB\884C\9012\589E, \5426\5219\66F4\65B0\884C\7248\672C\5217\3002\7CFB\7EDF\5C06\5047\5B9A NUMBER \5217\5305\542B\884C\7684\5E8F\5217\53F7\3002\4F46\662F, \4E5F\53EF\4EE5\4F7F\7528 DATE \548C TIMESTAMP \5217\3002\4F7F\7528\4E00\5217\7684\597D\5904\662F, &PRODUCT_NAME. \5F15\64CE\4E0D\9700\8981\6267\884C\5B8C\6574\884C\7684\6563\5217\64CD\4F5C, \53EA\9700\6BD4\8F83\4E00\5217\503C\5373\53EF\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8FD0\884C\65F6 Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\4EE5\4E0B\8BED\53E5\9650\5236\90E8\95E8:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\8F93\5165\5C06\9644\52A0\5230\751F\6210\7684 SELECT \8BED\53E5\7684 SQL WHERE \5B50\53E5\3002\4F7F\7528\6B64\5C5E\6027\53EF\9650\5236\5728\81EA\52A8\751F\6210\7684 SQL \8C03\7528\4E2D\4F7F\7528\7684\8BB0\5F55\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4417)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\63D0\53D6\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\5B58\5728\6B64\9009\9879\53EA\662F\4E3A\4E86\5B9E\73B0\5411\540E\517C\5BB9\3002'),
unistr('\65B0\5E94\7528\7A0B\5E8F\5E94\59CB\7EC8\5C06\6B64\8BBE\7F6E\7559\7A7A\3002'),
unistr('\9009\9879 "\663E\793A\65F6\8BBE\7F6E\5185\5B58\9AD8\901F\7F13\5B58" \5DF2\8FC7\65F6, \4E0D\5728\4F7F\7528\6B64 &PRODUCT_NAME. \53D1\884C\7248\751F\6210\7684\5904\7406\4E2D\52A0\4EE5\5229\7528\3002'),
'</p>',
'<p>',
unistr('\5F53\201C\81EA\52A8\884C\63D0\53D6\201D\5904\7406\9009\62E9\884C\65F6, \4F1A\5C06\76F8\5E94\7684\9875\9879\8BBE\7F6E\4E3A\6240\63D0\53D6\7684\5217\503C\3002DML \63D0\53D6\6A21\5F0F\8BBE\7F6E\51B3\5B9A\8FD9\79CD\60C5\51B5\53D1\751F\7684\65F6\95F4\3002\5728\63D0\53D6\884C\540E, \9ED8\8BA4\6A21\5F0F\5C06\7ACB\5373\66F4\65B0\5185\5B58\4E2D\7684\4F1A\8BDD\72B6\6001\3002\800C\6A21\5F0F ''\663E\793A\65F6\8BBE\7F6E\5185\5B58\9AD8\901F\7F13\5B58'' \53EA\6709\5728\5448\73B0\9879\65F6\624D\66F4\65B0\6B64\4F1A\8BDD\72B6\6001\3002\5728\884C\63D0\53D6\4E0E\9879\5448\73B0\4E4B\95F4\7684\65F6\6BB5\5185, \5982\679C\9700\8981\4F7F\7528\7ED1\5B9A\53D8\91CF\6216 <code>v(''ITEM_NAME'')</code> \8BED\6CD5\5F15\7528\9879\7684\63D0\53D6\503C, \5219\5FC5\987B\4F7F\7528\9ED8\8BA4\63D0\53D6\6A21\5F0F\3002\5728\521B\5EFA\65B0\7684\201C\81EA\52A8\884C\63D0\53D6\201D\5904\7406\65F6, \4F1A\5C06\5176\63D0\53D6\6A21\5F0F\8BBE\7F6E\4E3A\6B64\9ED8\8BA4\6A21\5F0F\3002\9664\975E\60A8\7684\9875\903B\8F91\4F9D\8D56\4E8E ''\663E\793A\65F6'' \884C\4E3A, \5426\5219,')
||unistr(' \5EFA\8BAE\60A8\5C06\6B64\5904\7406\66F4\65B0\4E3A\4F7F\7528\9ED8\8BA4\884C\4E3A, \8FD9\6837, \53EF\4EE5\6309\6700\7075\6D3B\7684\65B9\5F0F\5728\5448\73B0\9875\7684\8FC7\7A0B\4E2D\5F15\7528\63D0\53D6\7684\5217\503C\3002'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8BBE\7F6E\663E\793A\65F6\5185\5B58\9AD8\901F\7F13\5B58 [\5DF2\8FC7\65F6]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>unistr('Web \670D\52A1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\4F7F\7528\6307\5B9A Web \670D\52A1\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4417)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Web \670D\52A1\64CD\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('\9009\62E9 Web \670D\52A1\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4417)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7ED3\679C\5B58\50A8\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9879')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\96C6\5408')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4417)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\96C6\5408\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>unistr('\8868\5355\9875\7801')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4E8E\4ECE\6570\636E\5E93\8868\6216\89C6\56FE\4E2D\68C0\7D22\4E0A\4E00\6761\6216\4E0B\4E00\6761\8BB0\5F55\7684\5904\7406\3002\6B64\5904\7406\53EF\7528\4E8E\63D0\4F9B\8868\5355\9875\4E0A\7684\9875\7801, \4EE5\4FBF\6700\7EC8\7528\6237\5728\65E0\9700\5BFC\822A\56DE\62A5\8868\7684\60C5\51B5\4E0B\5C31\80FD\68C0\7D22\4E0A\4E00\6761\6216\4E0B\4E00\6761\8BB0\5F55\3002</p>'),
unistr('<p><em>\6CE8: \5982\679C\8868\5355\5141\8BB8\66F4\65B0\6570\636E, \5219\60A8\901A\5E38\5E94\786E\4FDD\5728\6267\884C\6B64\9875\7801\5904\7406\4E4B\524D\6267\884C\76F8\5E94\7684\8868\5355\5904\7406\3002\5426\5219, \5F53\6700\7EC8\7528\6237\5BFC\822A\5230\5176\4ED6\8BB0\5F55\65F6\5176\6240\505A\7684\4EFB\4F55\66F4\65B0\90FD\5C06\4E22\5931\3002</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4417)
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\5B58\653E\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\4E3B\952E\503C\7684\5217\3002\5BF9\4E8E\4E3B\952E\90E8\5206\591A\4E8E\4E24\4E2A\7684\8868, \9009\62E9 <strong>ROWID</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\6B21\7EA7\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F93\5165\5B58\653E\7B2C\4E8C\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\6B21\7EA7\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4417)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\9009\62E9\5305\542B\7B2C\4E8C\4E3B\952E\503C\7684\5217\3002\4EC5\5F53\4E3B\952E\7531\4E24\5217\7EC4\6210\65F6, \624D\5E94\586B\5145\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5BFC\822A\987A\5E8F\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4417)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5305\542B\5BFC\822A\987A\5E8F\503C\7684\5217\3002</p>'),
unistr('<p>\6B64\5217\7528\4E8E\786E\5B9A\4E0A\4E00\884C\548C\4E0B\4E00\884C\3002\56E0\6B64, \8BF8\5982 <code>DISPLAY_SEQ</code> \8FD9\6837\7684\5217\662F\8981\4F7F\7528\7684\7406\60F3\5217\3002\5F53\60A8\5E0C\671B\6309\8BB0\5F55\7684\521B\5EFA\5E8F\5217\5BF9\8BB0\5F55\8FDB\884C\6392\5E8F\65F6, \53EF\4EE5\4F7F\7528\8BF8\5982 <code>CREATED</code> \6216 <code>ID</code> \8FD9\6837\7684\5217 (\5982\679C\6309\7CFB\5217\586B\5145\6216\57FA\4E8E Oracle Database 12<em>c</em> Identity \5217\586B\5145)\3002\4E0D\8FC7, \60A8\53EF\4EE5\7075\6D3B\5730\5BF9\4EFB\610F\4E24\5217 (\4F8B\5982 <code>JOB</code> \548C <code>DEPTNO</code>) ')
||unistr('\4E0A\7684\8BB0\5F55\8FDB\884C\6392\5E8F\3002</p>'),
unistr('<p><em>\6CE8: \5BFC\822A\987A\5E8F\5217\5E94\4E0E\7528\4E8E\5BF9\62A5\8868\8FDB\884C\6392\5E8F\7684\9ED8\8BA4\5217\76F8\5339\914D, \6700\7EC8\7528\6237\4ECE\62A5\8868\5BFC\822A\5230\6B64\8868\5355\3002\6B64\5916, \60A8\5E94\786E\4FDD\6700\7EC8\7528\6237\4E86\89E3\5982\4F55\786E\5B9A\4E0A\4E00\884C\548C\4E0B\4E00\884C, \4F8B\5982, \901A\8FC7\4F7F\7528\6309\94AE\6807\7B7E\6216\5E2E\52A9\6587\672C\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6B21\7EA7\5BFC\822A\987A\5E8F\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\7B2C\4E8C\5BFC\822A\987A\5E8F\503C\7684\5217\3002\4EC5\5F53\5BFC\822A\952E\7531\4E24\5217\7EC4\6210\65F6, \624D\5E94\586B\5145\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\4E0B\4E00\4E2A\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\5B58\653E<em>\4E0B\4E00\6761</em>\8BB0\5F55\7684\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\4E0A\4E00\4E2A\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\5B58\653E<em>\4E0A\4E00\6761</em>\8BB0\5F55\7684\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\4E0B\4E00\4E2A\6B21\7EA7\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F93\5165\5B58\653E<em>\4E0B\4E00\6761</em>\8BB0\5F55\7684\7B2C\4E8C\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\4E0A\4E00\4E2A\6B21\7EA7\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F93\5165\5B58\653E<em>\4E0A\4E00\6761</em>\8BB0\5F55\7684\7B2C\4E8C\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('\5F53\524D\884C\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\5B58\653E\603B\8BB0\5F55\8BA1\6570\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('<p>\5982\679C\60A8\7684\7ED3\679C\96C6\5305\542B\7684\884C\6570\5927\4E8E 10,000, \5B9A\4E49\6B64\9879\53EF\80FD\4F1A\964D\4F4E\6027\80FD\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4417)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('\8FD0\884C\65F6 Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>unistr('\8F93\5165\9650\5236\67E5\8BE2\8FD4\56DE\7684\8BB0\5F55\7684 SQL \8BED\53E5\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>unistr('\65E7 Web \670D\52A1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\7528\4E8E\4F7F\7528\6307\5B9A Web \670D\52A1\7684\5904\7406\3002Oracle \5EFA\8BAE\5C06\6B64\5904\7406\66F4\65B0\4E3A <strong>Web \670D\52A1</strong>\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4417)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Web \670D\52A1\5F15\7528')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165 Web \670D\52A1\5F15\7528\7F16\53F7\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4417)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7ED3\679C\5B58\50A8\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9879')
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\96C6\5408')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4417)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\96C6\5408\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>unistr('\6587\672C\533A\57DF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\591A\884C\6587\672C\533A\57DF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4417)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\53EF\8C03\6574\5927\5C0F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\5141\8BB8\4F7F\7528\9F20\6807\8C03\6574\6587\672C\533A\57DF\7684\5927\5C0F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4417)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\81EA\52A8\8C03\6574\9AD8\5EA6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6587\672C\533A\57DF\7684\9AD8\5EA6\662F\5426\56E0\663E\793A\7684\6587\672C\91CF\4E0D\540C\800C\5F02\3002\4F7F\7528\6B64\9009\9879\53EF\4EE5\6309\6570\636E\91CF\7F29\653E\6587\672C\533A\57DF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4417)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5B57\7B26\8BA1\6570\5668')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\5728\6587\672C\533A\57DF\4E0B\65B9\663E\793A\8BA1\6570\5668\3002\8BA1\6570\5668\663E\793A\5728\5B57\6BB5\4E2D\8F93\5165\7684\5B57\7B26\6570\548C\5141\8BB8\7684\603B\5B57\7B26\6570\FF0C\4F8B\5982 <code>123/4000</code>\3002\542F\7528\6B64\9879\65F6\FF0C\5FC5\987B\6307\5B9A\201C\6700\5927\957F\5EA6\201D\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4417)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\622A\53D6\7A7A\683C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\63D0\4EA4\9875\540E\5982\4F55\622A\53D6\9879\503C\3002\6B64\8BBE\7F6E\5C06\4ECE\8F93\5165\7684\6587\672C\4E2D\622A\53D6\7A7A\683C, \5236\8868\7B26\548C\6362\884C\7B26\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\524D\5BFC')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5C3E\968F')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\524D\5BFC\548C\5C3E\968F')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>unistr('\7ECF\5178\62A5\8868')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\57FA\4E8E SQL \67E5\8BE2\7684\7B80\5316\62A5\8868\3002\7ECF\5178\62A5\8868\7C7B\4F3C\4E8E\4EA4\4E92\5F0F\62A5\8868, \4F46\4E0D\5305\542B\8BB8\591A\9002\7528\4E8E\4EA4\4E92\5F0F\62A5\8868\7684\6700\7EC8\7528\6237\5B9A\5236\9009\9879\3002')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4417)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>unistr('\8868\683C\5F0F\8868\5355')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\4EE5\7F51\683C\5E03\5C40\663E\793A\591A\884C\6570\636E, \5176\4E2D, \6700\7EC8\7528\6237\53EF\4EE5\76F4\63A5\5728\7F51\683C\5143\7D20\4E2D\66F4\65B0\503C\3002')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4417)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4417)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>unistr('\4EA4\4E92\5F0F\62A5\8868')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E SQL \67E5\8BE2\7684\7EFC\5408\8054\673A\62A5\8868, \6B64\62A5\8868\5411\6700\7EC8\7528\6237\63D0\4F9B\8BB8\591A\7528\4E8E\5728\8FD0\884C\65F6\5B9A\5236\62A5\8868\5E03\5C40\7684\529F\80FD\3002\60A8\53EF\4EE5\901A\8FC7\542F\7528\6216\7981\7528\5404\79CD\62A5\8868\5B9A\5236\9009\9879\6765\63A7\5236\6700\7EC8\7528\6237\529F\80FD\3002</p>'),
unistr('<p>\60A8\53EF\4EE5\5B9A\4E49\5355\4E2A\4EA4\4E92\5F0F\62A5\8868\5E76\4F7F\6700\7EC8\7528\6237\53EF\4EE5\64CD\7EB5\663E\793A\7684\6570\636E\4EE5\6EE1\8DB3\5176\7279\5B9A\7684\62A5\8868\8981\6C42, \800C\4E0D\662F\60A8\9700\8981\6839\636E\4E0D\540C\6807\51C6\5F00\53D1\82E5\5E72\4E2A\7C7B\4F3C\62A5\8868\6765\6EE1\8DB3\8FD9\4E9B\76F8\540C\7684\8981\6C42\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4417)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\201C\64CD\4F5C\201D\83DC\5355\7ED3\6784')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\201C\64CD\4F5C\201D\83DC\5355\7ED3\6784\662F\5426\5C06\4E0E\4EA4\4E92\5F0F\7F51\683C\7EC4\4EF6\4FDD\6301\4E00\81F4, \6216\8005\662F\5426\5C06\4F7F\7528\65E7\7ED3\6784\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E7\5F0F')
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4EA4\4E92\5F0F\7F51\683C')
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4417)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>unistr('\9759\6001\5185\5BB9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\663E\793A\9875\9879\7684\6587\672C\5185\5BB9\6216\533A\57DF\5BB9\5668\3002\8981\8F93\51FA HTML \6807\8BB0\5E76\4E14\4E0D\5BF9\5185\5BB9\8FDB\884C\8F6C\4E49, \8BF7\5C06<em>\8F93\51FA\4E3A</em>\8BBE\7F6E\4E3A <strong>HTML</strong>\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4417)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>unistr('\5C55\5F00\5FEB\6377\65B9\5F0F')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('\6307\5B9A &PRODUCT_NAME. \662F\5426\5728 HTML \6B63\6587\4E2D\5C55\5F00\5FEB\6377\65B9\5F0F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4417)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\8F93\51FA\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\8F93\51FA\6587\672C\5185\5BB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6587\672C (\8F6C\4E49\7279\6B8A\5B57\7B26)')
,p_return_value=>'TEXT'
,p_help_text=>unistr('\53D1\51FA\533A\57DF\6E90\65F6, &PRODUCT_NAME. \4F1A\5BF9 <code>"<", ">", "&"</code> \7B49\7279\6B8A HTML \5B57\7B26\8FDB\884C\8F6C\4E49\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4417)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('\53D1\51FA\533A\57DF\6E90\65F6, &PRODUCT_NAME. \4F1A\5305\62EC HTML \6807\8BB0\3002\8FD9\53EF\80FD\4F1A\4F7F\533A\57DF\6613\906D\5230\8DE8\7AD9\70B9\811A\672C\7F16\5199\7684\653B\51FB\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4417)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\663E\793A\6362\884C\7B26')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('\6307\5B9A\533A\57DF\6E90\4E2D\7684\6362\884C\7B26\662F\5426\5BFC\81F4\533A\57DF\8F93\51FA\4E2D\7684\6362\884C\7B26\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4417)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4417)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('PL/SQL \52A8\6001\5185\5BB9')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A PL/SQL \4EE3\7801\7684 HTML \8F93\51FA\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4417)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4417)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>unistr('SVG \56FE\8868')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\5728 SVG \56FE\8868\4E2D\663E\793A\6570\636E\3002\6B64\533A\57DF\7C7B\578B\5DF2\8FC7\65F6\3002\8BF7\5C06<em>\56FE\8868</em>\533A\57DF\7C7B\578B\7528\4E8E\65B0\56FE\8868\533A\57DF\3002Oracle \5EFA\8BAE\60A8\4F7F\7528<em>\5347\7EA7\5E94\7528\7A0B\5E8F</em>\5C06\8FD9\4E9B\533A\57DF\66F4\65B0\4E3A\7B49\540C\7684\56FE\8868\533A\57DF\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4417)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4417)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>unistr('\7B80\5355\56FE\8868')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\5728 HTML \56FE\8868\4E2D\663E\793A\6570\636E\3002\6B64\533A\57DF\7C7B\578B\5DF2\8FC7\65F6\3002\8BF7\5C06<em>\56FE\8868</em>\533A\57DF\7C7B\578B\7528\4E8E\65B0\56FE\8868\533A\57DF\3002Oracle \5EFA\8BAE\60A8\4F7F\7528<em>\5347\7EA7\5E94\7528\7A0B\5E8F</em>\5C06\8FD9\4E9B\533A\57DF\66F4\65B0\4E3A\7B49\540C\7684\56FE\8868\533A\57DF\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>unistr('\6811')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\57FA\4E8E\8BB0\5F55\4E4B\95F4\7684\7236\5B50\5173\7CFB\4EE5\5206\5C42\7ED3\6784\663E\793A\6570\636E\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>unistr('\6FC0\6D3B\8282\70B9\94FE\63A5\65B9\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\5728\6811\4E0A\6FC0\6D3B\8282\70B9\94FE\63A5\6240\9700\7684\64CD\4F5C\3002\6811\4E3B\8981\7528\4E8E\9009\62E9/\663E\793A\6216\5BFC\822A\3002\5982\679C\5C06\6811\540C\65F6\7528\4E8E\9009\62E9\548C\5BFC\822A, \5EFA\8BAE\5C06\6B64\9879\8BBE\7F6E\4E3A\201C\53CC\51FB\201D, \8FD9\6837\5355\51FB\5C31\53EA\662F\9009\62E9\8BE5\8282\70B9\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5355\51FB')
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\53CC\51FB')
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('\9009\62E9\7684\8282\70B9\9875\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5E0C\671B\7528\4E8E\5B58\653E\6240\9009\8282\70B9\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('<p>\6B64\9879\5B58\653E\4E0A\6B21\6240\9009\8282\70B9\7684\503C, \53EF\7528\4E8E\4FDD\5B58\6811\72B6\6001\3002\6240\9009\8282\70B9\7684\503C\53EF\4EE5\901A\8FC7\8282\70B9\94FE\63A5\5C5E\6027\6216\901A\8FC7\9875\5904\7406\4FDD\5B58\5230\6240\9009\9879\3002\91CD\65B0\52A0\8F7D\9875\65F6, \6B64\6811\5C06\6253\5F00\5230\6240\9009\8282\70B9\503C\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\662F\5426\663E\793A\5DE5\5177\63D0\793A, \4EE5\53CA\5DE5\5177\63D0\793A\7684\6E90\3002\5982\679C\5B9A\4E49\4E86\5DE5\5177\63D0\793A, \5219\5728\6700\7EC8\7528\6237\5C06\7126\70B9\79FB\52A8\5230\6216\5C06\9F20\6807\60AC\505C\5728\6811\8282\70B9\6807\7B7E\4E4B\4E0A\65F6\4F1A\663E\793A\5DE5\5177\63D0\793A\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0')
,p_return_value=>'N'
,p_help_text=>unistr('\5C06\4E0D\663E\793A\5DE5\5177\63D0\793A\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\65E7\6A21\677F')
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('\901A\8FC7\4EE5\4E0B\6570\636E\6E90\5217\66FF\6362\4F7F\7528\9759\6001\5DE5\5177\63D0\793A\503C\FF1A#VALUE#\3001#TITLE#\3001#LINK# \548C #TOOLTIP#')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4417)
,p_display_sequence=>30
,p_display_value=>unistr('HTML \8868\8FBE\5F0F')
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('\63D0\4F9B HTML \8868\8FBE\5F0F\4EE5\7528\4F5C\5DE5\5177\63D0\793A\3002\5C06\6267\884C\66FF\6362\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\6570\636E\5E93\5217')
,p_return_value=>'DB'
,p_help_text=>unistr('\4F7F\7528<strong>\5DE5\5177\63D0\793A\5217</strong>\7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>unistr('\5DE5\5177\63D0\793A\503C')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('\8F93\5165\5728\6700\7EC8\7528\6237\5C06\9F20\6807\60AC\505C\5728\6811\5143\7D20\4E4B\4E0A\65F6\663E\793A\7684\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>unistr('\9759\6001\6811 ID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6811\7684\53EF\9009\552F\4E00\6807\8BC6\7B26\3002</p>'),
unistr('<p>\6700\597D\662F\5411\533A\57DF\63D0\4F9B\9759\6001 ID \5E76\4F7F\7528 apex.region("<i>static-id</i>").widget() API \6765\8BBF\95EE\6811\5143\7D20\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>unistr('\56FE\6807\7C7B\578B CSS \7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>CSS \7C7B\7528\4E8E\6307\5B9A\4E3A\6240\6709\8282\70B9\4F7F\7528\7684\56FE\6807\7C7B\578B\3002\6B64\7C7B\5728 CSS \89C4\5219\4E2D\7528\4E8E\6307\5B9A\8BE5\7C7B\578B\7684\6240\6709\56FE\6807\7684\5C5E\6027\3002\56FE\6807\7C7B\578B\4E0E\533A\57DF\6E90\7684\56FE\6807\5217\503C\4E00\8D77\786E\5B9A\7528\4E8E\5404\4E2A\8282\70B9\7684\56FE\6807 CSS \7C7B\3002</p>'),
unistr('<p>\5178\578B\503C\5305\62EC:</p>'),
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong>: \5141\8BB8\4F7F\7528\5C11\91CF\7684\5185\7F6E APEX \56FE\6807, \4F8B\5982 <code>icon-circle</code> \6216 <code>icon-tree-folder</code>\3002</li>'),
unistr('<li><strong><code>fa</code></strong>: \5141\8BB8\4F7F\7528\5B57\4F53 APEX \6216 Font Awesome \56FE\6807\3002\901A\7528\4E3B\9898\63D0\4F9B\4E86\8FD9\4E9B\56FE\6807\5E93\4E4B\4E00\4EE5\4F9B\4F7F\7528\3002</li>'),
'</ul>',
unistr('<p>\5982\679C\672A\63D0\4F9B\503C, \5219\6CA1\6709\56FE\6807\7C7B\578B\3002\5982\679C\9700\8981, \53EF\5728\56FE\6807\5217\4E2D\5305\62EC\56FE\6807\7C7B\578B CSS \7C7B\3002\4F8B\5982, \56FE\6807\5217\503C\53EF\4EE5\4E3A "fa fa-user"\3002'),
unistr('\5BF9\4E8E\6811, \5982\679C\6CA1\6709\56FE\6807\8BBE\7F6E\4E86\56FE\6807\7C7B\578B, \5E76\4E14\201C\9ED8\8BA4\56FE\6807\201D\5C5E\6027\8BBE\7F6E\4E3A\7A7A, \5219\5728 SQL \67E5\8BE2\6E90\4E2D, \56FE\6807\5217\5E94\4E3A\7A7A\503C\3002'),
unistr('\5B9A\5236\6216\7B2C\4E09\65B9\4E3B\9898\53EF\80FD\4F1A\6709\81EA\5DF1\7684\5B57\4F53\6216 CSS \7CBE\7075\56FE\6807\5E93, \5E76\4F7F\7528\4E0E\6B64\5904\6307\5B9A\4E0D\540C\7684\56FE\6807\7C7B\578B/\524D\7F00\7C7B\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>unistr('\9ED8\8BA4\56FE\6807 CSS \7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>\5982\679C\5B57\4F53 APEX \7684\56FE\6807\7C7B\578B\4E3A <code>fa</code>, \5219\53EF\4EE5\4F7F\7528\7C7B\4F3C\4E8E\4EE5\4E0B\7684\503C: <code>fa-user-circle-o</code>, <code>fa-file-o</code> \6216 <code>fa-arrow-circle-right</code>\3002\6709\5173\6240\6709\56FE\6807\7684\5217\8868, \8BF7\53C2\9605\901A\7528\4E3B\9898\5E94\7528\7A0B\5E8F\3002</p>')
,p_help_text=>unistr('SQL \67E5\8BE2\56FE\6807\5217\4E3A\7A7A\503C\65F6\4F7F\7528\7684\9ED8\8BA4\56FE\6807\3002\8BE5\503C\662F\6307\5B9A\6240\770B\5230\56FE\6807\7684 CSS \7C7B\540D\3002\53EF\80FD\503C\53D6\51B3\4E8E\56FE\6807\7C7B\578B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>unistr('\8282\70B9\6807\7B7E\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5305\542B\8282\70B9\6807\7B7E\503C\7684\6570\636E\6E90\5217\3002\8BE5\503C\4E0D\80FD\5305\542B\6807\8BB0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('\5C42\6B21\7EA7\522B\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9009\62E9\5305\542B\8282\70B9\7684\5C42\6B21\7EA7\522B\503C\7684\6570\636E\6E90\5217\3002\5C06<strong>\5C42\6B21</strong>\5C5E\6027\8BBE\7F6E\4E3A<strong>\672A\8BA1\7B97</strong>\65F6\662F\5FC5\9700\7684\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>unistr('\56FE\6807 CSS \7C7B\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5305\542B\8981\5E94\7528\5230\8282\70B9\7684\56FE\6807 CSS \7C7B\503C\7684\6570\636E\6E90\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>unistr('\8282\70B9 ID \5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9009\62E9\5305\542B\8282\70B9\7684 ID \7684\6570\636E\6E90\5217\3002\5728\7531 Application Express \8BA1\7B97\5C42\6B21\65F6\9700\8981\6B64\9879\3002\901A\5E38\5728\6B64\5904\9009\62E9\4E3B\952E\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>unistr('\7236\5173\952E\5B57\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9009\62E9\5305\542B\8282\70B9\7684\7236\5173\952E\5B57\503C\7684\6570\636E\6E90\5217\3002\5728\7531 Application Express \8BA1\7B97\5C42\6B21\65F6\9700\8981\6B64\9879\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>unistr('\8282\70B9\72B6\6001\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('\9009\62E9\5305\542B\8282\70B9\72B6\6001\503C\7684\6570\636E\6E90\5217\3002\5C06<strong>\5C42\6B21</strong>\5C5E\6027\8BBE\7F6E\4E3A<strong>\672A\8BA1\7B97</strong>\65F6\662F\5FC5\9700\7684\3002\5BF9\4E8E\53F6\8282\70B9\FF0C\8BE5\5217\5FC5\987B\5305\542B <strong>0</strong>\FF0C\5BF9\4E8E\5177\6709\5B50\96C6\7684\8282\70B9\FF0C\5FC5\987B\5305\542B <strong>1</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('\5F00\59CB\6811\7684\503C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6B64\5C5E\6027\786E\5B9A\5982\4F55\8BA1\7B97\6811\7684\6839\3002\5C06\5176<strong>\7236\5173\952E\5B57</strong>\5217\5305\542B\6B64\5904\6240\5B9A\4E49\503C\7684\8282\70B9\89C6\4E3A\6839\8282\70B9\3002\53EF\4EE5\6709\591A\4E2A\6839\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6839\636E\73B0\6709\9879')
,p_return_value=>'ITEM'
,p_help_text=>unistr('\4F7F\7528\9879\503C\6765\5F00\59CB\6811\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\57FA\4E8E SQL \67E5\8BE2')
,p_return_value=>'SQL'
,p_help_text=>unistr('\4F7F\7528 SQL \67E5\8BE2\8FD4\56DE\7684\503C\6765\5F00\59CB\6811\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\6839\636E\9759\6001\503C')
,p_return_value=>'STATIC'
,p_help_text=>unistr('\4F7F\7528\9759\6001\503C\6765\5F00\59CB\6811\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\503C\4E3A NULL')
,p_return_value=>'NULL'
,p_help_text=>unistr('\4F7F\7528 SQL NULL \6765\5F00\59CB\6811\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('\9009\62E9\9879\FF0C\8BE5\9879\5305\542B\5F00\59CB\6811\6240\7528\7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>unistr('SQL \67E5\8BE2')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\6307\5B9A SQL \67E5\8BE2\4EE5\786E\5B9A\5F00\59CB\6811\6240\7528\7684\503C\3002SQL \67E5\8BE2\59CB\7EC8\5728<em>\672C\5730\6570\636E\5E93</em>\4E2D\6267\884C\FF0C\5FC5\987B\8FD4\56DE\4E14\53EA\8FD4\56DE\4E00\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>unistr('\9759\6001\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\7528\4E8E\5F00\59CB\6811\7684\9759\6001\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>unistr('\8282\70B9\503C\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\6570\636E\6E90\5217\FF0C\8BE5\5217\5305\542B\8282\70B9\201C\503C\201D\7684\503C\3002\6B64\503C\4E0D\663E\793A\FF0C\800C\662F\6DFB\52A0\5230\53EF\4F7F\7528 JavaScript \8BBF\95EE\7684\6811\9002\914D\5668\8282\70B9 ID \5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>unistr('\94FE\63A5')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\5355\51FB\8282\70B9\65F6\8981\6267\884C\7684\94FE\63A5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>unistr('\5DE5\5177\63D0\793A\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>unistr('\9009\62E9\5305\542B\8282\70B9\5DE5\5177\63D0\793A\503C\7684\6570\636E\6E90\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>unistr('\5C42\6B21')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\660E Application Express \662F\5426\5E94\4ECE\6570\636E\8BA1\7B97\6811\5C42\6B21\FF0C\6216\8005\6570\636E\662F\5426\5DF2\5305\542B\6240\6709\5C42\6B21\4FE1\606F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\4F7F\7528 SQL \8BA1\7B97')
,p_return_value=>'SQL'
,p_help_text=>unistr('\4F7F\7528 SQL START WITH CONNECT BY \5B50\53E5\8BA1\7B97\5C42\6B21\3002\9700\8981\63D0\4F9B<strong>\7236\5173\952E\5B57\5217</strong>\3002\4EC5\5728 SQL \67E5\8BE2<em>\5C1A\4E0D</em>\5305\542B START WITH CONNECT BY \5B50\53E5\65F6\4F7F\7528\6B64\9009\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\672A\8BA1\7B97')
,p_return_value=>'LEVEL'
,p_help_text=>unistr('\6240\6709\5C42\6B21\4FE1\606F\5DF2\5305\542B\5728\6570\636E\4E2D\3002\6B64\9009\9879\9700\8981\6620\5C04<strong>\8282\70B9\7EA7\522B</strong>\548C<strong>\8282\70B9\72B6\6001</strong>\5217\3002<strong>\8282\70B9\7EA7\522B</strong>\5FC5\987B\5305\542B\6570\503C\5F62\5F0F\7684\5C42\6B21\7EA7\522B\FF1B<strong>\8282\70B9\72B6\6001</strong>\5BF9\4E8E\53F6\8282\70B9\5FC5\987B\5305\542B <strong>0</strong>\FF0C\5BF9\4E8E\975E\53F6\8282\70B9\5FC5\987B\5305\542B <strong>1</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>unistr('\94FE\63A5\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\9009\62E9\6570\636E\6E90\5217\FF0C\8BE5\5217\5305\542B\5728\5355\51FB\8282\70B9\65F6\6240\6267\884C\94FE\63A5\7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>unistr('\540C\7EA7\6392\5E8F\65B9\5F0F')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('\9009\62E9\7528\4E8E\5728\7236\8282\70B9\4E2D\6392\5E8F\5B50\96C6\7684\6570\636E\6E90\5217\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 JavaScript \51FD\6570, \8BE5\51FD\6570\83B7\53D6\6811\7684\9009\9879\5BF9\8C61, \4FEE\6539\5BF9\8C61\5E76\8FD4\56DE\5BF9\8C61\3002\8FD9\53EF\5728 treeView \5C0F\90E8\4EF6\7684\521D\59CB\5316\671F\95F4, \7528\4E8E\5BF9\6811\8FDB\884C\9AD8\7EA7\5B9A\5236\3002\6709\5173\53EF\7528\9009\9879, \8BF7\53C2\9605 treeView \5C0F\90E8\4EF6 JavaScript API \6587\6863\3002<p>'),
unistr('<p>\7531\6811\533A\57DF\5B9A\4E49\7684\5176\4ED6\9009\9879:</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong>: \7528\4E8E\5B9A\4E49\5B9A\5236\7684 nodeAdapter\3002\6B64\51FD\6570\83B7\53D6\4E0E makeDefaultNodeAdapter \76F8\540C\7684\53C2\6570, \5E76\4E14\5FC5\987B\8FD4\56DE treeNodeAdapter \63A5\53E3\3002</li>'),
unistr('<li><strong>initialSelectedNodeId</strong>: \8981\9009\62E9\7684\8282\70B9\7684\503C\3002\6B64\9879\6839\636E\201C\9009\62E9\7684\8282\70B9\9875\9879\201D\5C5E\6027\8BBE\7F6E\3002</li>'),
unistr('<li><strong>nodeHasTooltip</strong>: \6B64\9879\6839\636E\201C\5DE5\5177\63D0\793A\201D\5C5E\6027\8FDB\884C\8BBE\7F6E\3002\5982\679C\8282\70B9\6709\5DE5\5177\63D0\793A\5219\4E3A true, \5426\5219\4E3A false\3002</li>'),
unistr('<li><strong>regionStaticId</strong>: \8FD9\662F\7528\4E8E\6B64\533A\57DF\7684\5143\7D20 ID\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\201C\5C42\6B21\201D\5C5E\6027\8BBE\7F6E\4E3A\201C\4F7F\7528 SQL \8BA1\7B97\201D\65F6</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
unistr('<p>\4E3A\201C\8282\70B9 ID \5217\201D\5C5E\6027\6307\5B9A EMPNO\FF0C\4E3A\201C\7236\5173\952E\5B57\5217\201D\5C5E\6027\6307\5B9A MGR</p>'),
'</dd>',
unistr('<dt>\201C\5C42\6B21\201D\5C5E\6027\8BBE\7F6E\4E3A\201C\672A\8BA1\7B97\201D\65F6</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>\4E3A\201C\8282\70B9\72B6\6001\5217\201D\5C5E\6027\6307\5B9A STATUS\FF0C\4E3A\201C\5C42\6B21\7EA7\522B\5217\201D\5C5E\6027\6307\5B9A LEVEL\3002</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4417)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4417)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('\9009\62E9\66F4\6539')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>unistr('\65E5\5386')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5728\5404\79CD\65E5\5386\89C6\56FE\4E0A\663E\793A\57FA\4E8E\65E5\671F\7684\6761\76EE\3002</p>'),
unistr('<p>\5F53\521B\5EFA\65B0\533A\57DF\65F6, \60A8\5E94\4F7F\7528<em>\65E5\5386</em>\800C\975E\6B64\533A\57DF\7C7B\578B\3002\7ECF\5178\65E5\5386\533A\57DF\901A\5E38\662F\90A3\4E9B\5728 &PRODUCT_NAME. \53D1\884C\7248 4.2 \6216\65E9\671F\7248\672C\4E2D\521B\5EFA\7684\533A\57DF\3002</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4417)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4417)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>unistr('\7ECF\5178\6811')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E\8BB0\5F55\4E4B\95F4\7684\7236\5B50\5173\7CFB\4EE5\5206\5C42\7ED3\6784\663E\793A\6570\636E\3002</p>'),
unistr('<p>\5F53\521B\5EFA\65B0\533A\57DF\65F6, \60A8\5E94\4F7F\7528<em>\6811</em>\800C\975E\6B64\533A\57DF\7C7B\578B\3002</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4417)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6811\7EC4\4EF6 ID')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('\5C55\5F00\6811')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\6811\533A\57DF\4E2D\5C55\5F00\5F53\524D\8282\70B9\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('\9690\85CF\6811')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\6811\533A\57DF\4E2D\6298\53E0\5F53\524D\8282\70B9\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>unistr('\5BC6\7801')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A HTML \5BC6\7801\8868\5355\5143\7D20\3002\5F53\6700\7EC8\7528\6237\8F93\5165\6587\672C\65F6, \4F1A\4E3A\8BE5\5B57\7B26\663E\793A\4E00\4E2A\9ED1\70B9\800C\4E0D\662F\8F93\5165\7684\5B9E\9645\5B57\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4417)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6309 Enter \65F6\63D0\4EA4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\6B64\5B57\6BB5\4E2D\65F6\6309 <em>Enter</em> \952E\662F\5426\4F1A\81EA\52A8\63D0\4EA4\9875\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>unistr('\505C\6B62\548C\542F\52A8\7F51\683C\5E03\5C40')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4E8E\505C\6B62\4EE5\524D\7684 HTML \8868\5E76\542F\52A8\65B0\7684 HTML \8868\7684\65E7\9879\3002\5728 &PRODUCT_NAME. \53D1\884C\7248 xx \4E2D\5F15\5165<em>\7F51\683C\5E03\5C40</em>\4E4B\524D, \6B64\9879\7C7B\578B\5E7F\6CDB\7528\4E8E\5B9A\5236\9875\9879\7684\663E\793A\3002</p>'),
unistr('<p>Oracle \5EFA\8BAE\5220\9664\8FD9\4E9B\65E7\9879\7C7B\578B, \5E76\9488\5BF9\6B64\533A\57DF\4E2D\663E\793A\7684\4E0B\4E00\4E2A\9875\9879\5C06<em>\5F00\59CB\65B0\7F51\683C</em>\66F4\65B0\4E3A<strong>\662F</strong>\3002\8FD9\5728\529F\80FD\4E0A\7B49\540C\4E8E\201C\505C\6B62\548C\542F\52A8\7F51\683C\5E03\5C40\201D\9879\3002</p>')))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>unistr('\5237\65B0')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\89E6\53D1\53D7\5F71\54CD\5143\7D20\7684\5237\65B0\3002\5E76\975E\6240\6709\5143\7D20\5747\652F\6301\5237\65B0\64CD\4F5C\3002\60A8\53EF\4EE5\4F7F\7528\6B64\64CD\4F5C\5237\65B0\4EA4\4E92\5F0F\62A5\8868, \7ECF\5178\62A5\8868\53CA\6240\6709\5E26\6709\7EA7\8054 LOV \652F\6301\7684\9879\7C7B\578B\4E2D\7684\5185\5BB9\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>unistr('\663E\793A')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\663E\793A\53D7\5F71\54CD\7684\5143\7D20\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4417)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5168\90E8\663E\793A\5728\540C\4E00\884C\4E0A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\663E\793A\4E0E\53D7\5F71\54CD\5143\7D20\4F4D\4E8E\540C\4E00\884C\4E0A\7684\6240\6709\9875\9879\548C\6807\7B7E\3002</p>'),
unistr('<p>\6CE8: \6B64\5C5E\6027\4E0D\9002\7528\4E8E\672A\4F7F\7528\8868\7F51\683C\6765\663E\793A\8868\5355\9879\7684\9875\4E0A\7684\9879\3002\8FD9\5305\62EC\4EFB\4F55\4F7F\7528\79FB\52A8\9875\6A21\677F\7684\9875\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>unistr('HTTP \6807\5934\53D8\91CF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\5916\90E8\9A8C\8BC1, \5176\4E2D, \7528\6237\540D\5B58\50A8\5728 Web \670D\52A1\5668\8BBE\7F6E\7684 HTTP \6807\5934\53D8\91CF\4E2D\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4417)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTTP \6807\5934\53D8\91CF\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\5305\542B\7528\6237\540D\7684 HTTP \6807\5934\53D8\91CF\7684\540D\79F0\3002\5982\679C\672A\6307\5B9A, \5219\5C06\4F7F\7528 REMOTE_USER\3002</p>'),
'',
unistr('<p>HTTP \6807\5934\53D8\91CF\662F\7531 Web \670D\52A1\5668\8BBE\7F6E\7684\53D8\91CF\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4417)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7528\6237\540D\4E3A\7A7A\65F6\7684\64CD\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\6307\5B9A\5F53\5B58\50A8\5728 HTTP \6807\5934\53D8\91CF\4E2D\7684\7528\6237\540D\4E3A\7A7A\65F6\5E94\6267\884C\7684\64CD\4F5C\3002\53EF\7528\9009\9879\5982\4E0B:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\91CD\5B9A\5411\5230\5185\7F6E URL</strong>: \7528\4E8E\7531 Web \670D\52A1\5668\542F\52A8\767B\5F55\3002\5FC5\987B\8BBE\7F6E\6B64\5185\7F6E URL \4EE5\4FBF\53D7 Web \670D\52A1\5668\7684\4FDD\62A4, \4ECE\800C\5728\8C03\7528\65F6\5F3A\5236\767B\5F55\3002\767B\5F55\4E4B\540E, Web \670D\52A1\5668\5FC5\987B\5728 HTTP \6807\5934\53D8\91CF\4E2D\5B58\50A8\7ECF\8FC7\9A8C\8BC1\7684\7528\6237\540D, \4EE5\4F7F\5176\5BF9\9A8C\8BC1\65B9\6848\53EF\7528\3002\5185\7F6E URL \4E3A'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('\524D\7F00 <code>/apex/</code> \53D6\51B3\4E8E\670D\52A1\5668\914D\7F6E\3002'),
'</li>',
unistr('  <li><strong>\91CD\5B9A\5411\5230 URL</strong>: \7528\4E8E\542F\52A8\5916\90E8\670D\52A1\5668\4E0A\7684\767B\5F55, \8FD9\4F1A\968F\540E\5728 HTTP \6807\5934\53D8\91CF\4E2D\8BBE\7F6E\7ECF\8FC7\9A8C\8BC1\7684\7528\6237\540D\3002\5916\90E8\670D\52A1\5668\5E94\4F7F\7528\7531 <code>#CALLBACK#</code> \5360\4F4D\7B26\751F\6210\7684 URL \91CD\5B9A\5411\56DE\5E94\7528\7A0B\5E8F, \4EE5\4FBF\5728\5E94\7528\7A0B\5E8F\4E2D\5B8C\6210\9A8C\8BC1\3002</li>'),
unistr('  <li><strong>\663E\793A\9519\8BEF</strong>: \5C06\663E\793A\6307\5B9A\7684\9519\8BEF\6D88\606F\5E76\4E14\4E0D\5728\5E94\7528\7A0B\5E8F\4E2D\6267\884C\767B\5F55\3002</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\91CD\5B9A\5411\5230\5185\7F6E URL')
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\91CD\5B9A\5411\5230 URL')
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\663E\793A\9519\8BEF')
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4417)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('\6307\5B9A\5916\90E8\767B\5F55\670D\52A1\5668\7684 URL, \8BE5\670D\52A1\5668\5728 HTTP \6807\5934\53D8\91CF\4E2D\8BBE\7F6E\7ECF\8FC7\9A8C\8BC1\7684\7528\6237\540D\3002\5916\90E8\670D\52A1\5668\5E94\4F7F\7528\7531 <code>#CALLBACK#</code> \5360\4F4D\7B26\751F\6210\7684 URL \91CD\5B9A\5411\56DE\5E94\7528\7A0B\5E8F, \4EE5\4FBF\5728\5E94\7528\7A0B\5E8F\4E2D\5B8C\6210\9A8C\8BC1\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4417)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9519\8BEF\6D88\606F')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>unistr('\6307\5B9A\5F53 HTTP \6807\5934\53D8\91CF\4E0D\5305\542B\503C\6216\8005 HTTP \6807\5934\53D8\91CF\4E0D\5B58\5728\65F6\5E94\663E\793A\7684\9519\8BEF\6D88\606F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4417)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\9A8C\8BC1\7528\6237\540D')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\6307\5B9A\9A8C\8BC1 HTTP \6807\5934\53D8\91CF\4E2D\5B58\50A8\7684\7528\6237\540D\7684\9891\7387\3002\53EF\7528\9009\9879\5982\4E0B:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>\6BCF\4E2A\8BF7\6C42</strong>: \8981\6C42\53EA\8981 Web \670D\52A1\5668\6267\884C\767B\5F55\5C31\59CB\7EC8\8BBE\7F6E CGI \53D8\91CF\3002\5982\679C\7528\6237\540D\4E0E\5B58\50A8\5728\5F53\524D &PRODUCT_NAME. \4F1A\8BDD\4E2D\7684\7528\6237\540D\4E0D\540C, \5219\8BE5\4F1A\8BDD\5C06\5931\6548\5E76\542F\52A8\65B0\7684\767B\5F55\3002\8FD9\662F\6700\5B89\5168\7684\9009\9879, \56E0\4E3A\8FD9\4F1A\68C0\6D4B\6CE8\9500\6216\7528\6237\540D\66F4\6539\3002'),
'  </li>',
unistr('  <li><strong>\767B\5F55\540E</strong>: \5C06\53EA\5728 Web \670D\52A1\5668\6267\884C\767B\5F55\5E76\8C03\7528\56DE\8C03\4EE5\5B8C\6210\5E94\7528\7A0B\5E8F\4E2D\7684\9A8C\8BC1\540E, \624D\9A8C\8BC1\548C\5B58\50A8 &PRODUCT_NAME. \4F1A\8BDD\4E2D\7684\7528\6237\540D\3002\6709\5173\56DE\8C03\7684\4FE1\606F, \8BF7\53C2\9605 "\7528\6237\540D\4E3A\7A7A\65F6\7684\64CD\4F5C" \914D\7F6E\3002'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6BCF\4E2A\8BF7\6C42')
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\767B\5F55\540E')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4417)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('SSO \670D\52A1\5668\7684\6CE8\9500 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5BF9\4E8E\57FA\4E8E Oracle Access Manager \7684 SSO, \8F93\5165\793A\4F8B\5982\4E0B:</p>'),
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\9A8C\8BC1\65B9\6848\57FA\4E8E Oracle Access Manager \6216\7C7B\4F3C\7684\670D\52A1\5668,'),
unistr('\5219\60A8\53EF\4EE5\4F7F\7528\6B64\5C5E\6027\6307\5B9A\4ECE\4E2D\592E\4E00\6B21\767B\5165\670D\52A1\5668\6CE8\9500\7684 URL\3002</p>'),
'',
unistr('<p>\5C06\4F7F\7528\5E94\7528\7A0B\5E8F\767B\5F55\9875\7684\7F16\7801 URL \6765\66FF\6362\66FF\4EE3\53C2\6570 <code>%POST_LOGOUT_URL%</code>\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>unistr('HTML \8868\8FBE\5F0F')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\57FA\4E8E HTML \8868\8FBE\5F0F\663E\793A\4E0D\53EF\8F93\5165\7684\9879\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4417)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('HTML \8868\8FBE\5F0F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>\66F4\6539\80CC\666F\8272\548C\6587\672C\989C\8272</dt>'),
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
unistr('  <dt>\4F7F\7528\6807\9898 2</dt>'),
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>\4F7F\7528 SQL \67E5\8BE2\4E2D\7684\52A8\6001\7C7B</dt>'),
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
unistr('    \6B64\793A\4F8B\4E2D\7684 <code>&amp;COLUMN_CLASS!ATTR.</code> \548C <code>&amp;EMPLOYEE_STATUS.</code> \66FF\6362\5BF9\8C61\662F\5728 SQL \67E5\8BE2\4E2D\9009\62E9\7684\5217\3002</dd>'),
unistr('  <dt>\60AC\505C\65F6\663E\793A\56FE\50CF\548C\5DE5\5177\63D0\793A</dt>'),
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('\8F93\5165\5C06\663E\793A\5728\6B64\5217\4E2D\7684 HTML \8868\8FBE\5F0F\3002\4F7F\7528 <code>&amp;COLUMN.</code> \8BED\6CD5\53EF\4EE5\663E\793A HTML \5F62\5F0F\7684\5217\503C\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>unistr('\94FE\63A5')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C06\4E0D\53EF\8F93\5165\7684\9879\663E\793A\4E3A\94FE\63A5\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>unistr('\6E05\9664')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6E05\9664\53D7\5F71\54CD\7684\5143\7D20\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>unistr('\9884\8B66')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\6761\5E26\6709\5355\4E2A<em>\786E\5B9A</em>\6309\94AE\7684\9884\8B66\6D88\606F\3002\7528\4E8E\663E\793A\5FC5\987B\901A\8FC7\6309\6B64\6309\94AE\54CD\5E94\7684\4FE1\606F, \4F46\7EE7\7EED\6267\884C\4E8B\4EF6\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4417)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\6D88\606F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;\65E0\6CD5&lt;&#x2F;strong&gt;\5220\9664\5458\5DE5 &amp;P1_ENAME.\3002</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\9884\8B66\5BF9\8BDD\6846\4E2D\663E\793A\7684\6D88\606F\3002</p>'),
unistr('<p>\663E\793A\8BE5\5BF9\8BDD\6846\65F6\FF0C\5C06\5728\5BA2\6237\7AEF\6267\884C\9879\66FF\6362\3002</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4417)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\6807\9898')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>\FF08\53EF\9009\FF09\63D0\4F9B\5BF9\8BDD\6846\6807\9898\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4417)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6837\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\9ED8\8BA4\503C')
,p_help_text=>unistr('\6307\5B9A\5BF9\8BDD\6846\7684\6837\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\4FE1\606F')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5371\9669')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\8B66\544A')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\6210\529F')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4417)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\56FE\6807')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\53EF\9009\7684\5BF9\8BDD\6846\56FE\6807\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4417)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS \7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\5E94\7528\4E8E\5BF9\8BDD\6846\5BB9\5668\7684\53EF\9009 CSS \7C7B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4417)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\786E\5B9A\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F93\5165\201C\786E\5B9A\201D\6309\94AE\7684\6807\7B7E\3002\5982\679C\6CA1\6709\63D0\4F9B\FF0C\5219\5C06\4F7F\7528\6587\672C\6D88\606F <code>APEX.DIALOG.OK</code> \7684\503C\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>unistr('\786E\8BA4')
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\5E26\6709\201C\53D6\6D88\201D\548C\201C\786E\8BA4\201D\6309\94AE\7684\786E\8BA4\5BF9\8BDD\6846\3002\5982\679C\7528\6237\9009\62E9<em>\53D6\6D88</em>\FF0C\5219\4E0D\4F1A\6267\884C\6B63\5728\8FDB\884C\7684\64CD\4F5C\FF0C\5E76\4E14\53D6\6D88\5F53\524D\4E8B\4EF6\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\6D88\606F')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;\662F\5426\786E\5B9E&lt;&#x2F;strong&gt;\8981\5220\9664\5458\5DE5 &amp;P1_ENAME.\FF1F</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\786E\8BA4\5BF9\8BDD\6846\4E2D\663E\793A\7684\6D88\606F\3002</p>'),
unistr('<p>\663E\793A\8BE5\5BF9\8BDD\6846\65F6\FF0C\5C06\5728\5BA2\6237\7AEF\6267\884C\9879\66FF\6362\3002</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\6807\9898')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>\FF08\53EF\9009\FF09\63D0\4F9B\5BF9\8BDD\6846\6807\9898\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6837\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\9ED8\8BA4\503C')
,p_help_text=>unistr('\6307\5B9A\5BF9\8BDD\6846\7684\6837\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\4FE1\606F')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8B66\544A')
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5371\9669')
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\6210\529F')
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\56FE\6807')
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\53EF\9009\7684\5BF9\8BDD\6846\56FE\6807\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('CSS \7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\5E94\7528\4E8E\5BF9\8BDD\6846\5BB9\5668\7684\53EF\9009 CSS \7C7B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\786E\8BA4\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F93\5165\201C\786E\8BA4\201D\6309\94AE\7684\6807\7B7E\3002\5982\679C\6CA1\6709\63D0\4F9B\FF0C\5219\5C06\4F7F\7528\6587\672C\6D88\606F <code>APEX.DIALOG.OK</code> \7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4417)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\53D6\6D88\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F93\5165\201C\53D6\6D88\201D\6309\94AE\7684\6807\7B7E\3002\5982\679C\6CA1\6709\63D0\4F9B\FF0C\5219\5C06\4F7F\7528\6587\672C\6D88\606F <code>APEX.DIALOG.CANCEL</code> \7684\503C\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>unistr('\5BF9\4E0A\8F7D\6570\636E\8FDB\884C\8BED\6CD5\5206\6790')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\7528\4E8E\5BF9\51C6\5907\52A0\8F7D\5230\73B0\6709\8868\7684\5DF2\51C6\5907\7535\5B50\8868\683C\6570\636E\8FDB\884C\8BED\6CD5\5206\6790\7684\5904\7406\3002\6B64\5904\7406\7C7B\578B\662F\901A\8FC7<em>\6570\636E\52A0\8F7D</em>\7684\201C\521B\5EFA\9875\5411\5BFC\201D\751F\6210\7684\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4ECE\5171\4EAB\7EC4\4EF6\4E2D\9009\62E9\7528\4E8E\5B9A\4E49\8981\52A0\8F7D\7684\8868\7684\6570\636E\52A0\8F7D\5B9A\4E49\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4ECE\9879\5BFC\5165')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\9009\62E9\7684<em>\5BFC\5165\81EA</em>\9009\9879\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5206\9694\7B26\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\5206\9694\7B26</em>\6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5C01\95ED\7B26\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\5C01\95ED\7B26 (\53EF\9009)</em> \6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\7B2C\4E00\884C\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\7B2C\4E00\884C\5177\6709\5217\540D</em>\590D\9009\6846\503C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\8D27\5E01\7B26\53F7\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\8D27\5E01\7B26\53F7</em>\6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\7EC4\5206\9694\7B26\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\7EC4\5206\9694\7B26</em>\6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5C0F\6570\70B9\7B26\53F7\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\5C0F\6570\70B9\7B26\53F7</em>\6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6587\4EF6\540D\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\6587\4EF6\540D</em>\503C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\590D\5236\5E76\7C98\8D34\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\590D\5236\5E76\7C98\8D34\5E26\5206\9694\7B26\7684\65E5\671F</em>\6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\5B57\7B26\96C6\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\9009\62E9\7684<em>\6587\4EF6\5B57\7B26\96C6</em>\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4417)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('\65E5\671F\683C\5F0F\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\6700\7EC8\7528\6237\8F93\5165\7684<em>\65E5\671F\683C\5F0F</em>\6587\672C\7684\9875\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>unistr('\6570\636E\4E0A\8F7D\5217\6620\5C04')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\5C06\4E0A\8F7D\7684\7535\5B50\8868\683C\5217\6620\5C04\5230\8868\5217\3002\6B64\533A\57DF\7C7B\578B\662F\901A\8FC7<em>\6570\636E\52A0\8F7D</em>\7684\201C\521B\5EFA\9875\5411\5BFC\201D\751F\6210\7684\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4417)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5728<em>\6570\636E\52A0\8F7D</em>\5904\7406\4E2D\5B9A\4E49\7684\6570\636E\52A0\8F7D\5B9A\4E49\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>unistr('\51C6\5907\5DF2\4E0A\8F7D\6570\636E')
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\7528\4E8E\51C6\5907\5C06\7535\5B50\8868\683C\6570\636E\4E0A\8F7D\5230\73B0\6709\8868\7684\5904\7406\3002\6B64\5904\7406\7C7B\578B\662F\901A\8FC7<em>\6570\636E\52A0\8F7D</em>\7684\201C\521B\5EFA\9875\5411\5BFC\201D\751F\6210\7684\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4417)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4ECE\5171\4EAB\7EC4\4EF6\4E2D\9009\62E9\7528\4E8E\5B9A\4E49\8981\52A0\8F7D\7684\8868\7684\6570\636E\52A0\8F7D\5B9A\4E49\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4417)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\63D2\5165\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\8981\63D2\5165\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4417)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66F4\65B0\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\8981\66F4\65B0\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4417)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9519\8BEF\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\51FA\9519\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4417)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\590D\67E5\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\590D\67E5\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>unistr('\52A0\8F7D\5DF2\4E0A\8F7D\6570\636E')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\7528\4E8E\5C06\7ECF\8FC7\8BED\6CD5\5206\6790\7684\7535\5B50\8868\683C\6570\636E\52A0\8F7D\5230\73B0\6709\8868\6216\89C6\56FE\7684\5904\7406\3002\6B64\5904\7406\7C7B\578B\662F\901A\8FC7<em>\6570\636E\52A0\8F7D</em>\7684\201C\521B\5EFA\9875\5411\5BFC\201D\751F\6210\7684\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4417)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6570\636E\52A0\8F7D\5B9A\4E49')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\4ECE\5171\4EAB\7EC4\4EF6\4E2D\9009\62E9\7528\4E8E\5B9A\4E49\8981\52A0\8F7D\7684\8868\7684\6570\636E\52A0\8F7D\5B9A\4E49\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4417)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\63D2\5165\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\7528\4E8E\5B58\653E\63D2\5165\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4417)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66F4\65B0\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\7528\4E8E\5B58\653E\66F4\65B0\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4417)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9519\8BEF\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\7528\4E8E\5B58\653E\51FA\9519\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4417)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\590D\67E5\8BA1\6570\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\7528\4E8E\5B58\653E\590D\67E5\7684\8BB0\5F55\6570\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002'),
unistr('\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>unistr('Application Express \5E10\6237')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>\8F93\5165\60A8\7684 &PRODUCT_NAME. \5E10\6237\7684\7528\6237\540D\548C\5BC6\7801\3002\6BCF\4E2A\5DE5\4F5C\533A\90FD\6709\5404\81EA\7684\7528\6237\5E10\6237\8D44\6599\6863\6848\5E93\3002\60A8\6B63\5728\767B\5F55\7684\5E94\7528\7A0B\5E8F\5C5E\4E8E\5DE5\4F5C\533A &amp;F4155_WORKSPACE_NAME.\3002\8BF7\6CE8\610F, \5BC6\7801\533A\5206\5927\5C0F\5199\3002</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>unistr('\5F00\95E8\8EAB\4EFD\8BC1\660E')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5141\8BB8\4EFB\4F55\4EBA\8BBF\95EE\60A8\7684\5E94\7528\7A0B\5E8F\3002\8F93\5165\5728\6B64\4F1A\8BDD\671F\95F4\5C06\60A8\6807\8BC6\4E3A\5E94\7528\7A0B\5E8F\7528\6237\7684\4EFB\4F55\6807\8BC6\7B26\3002\6B64\64CD\4F5C\5C06\8BBE\7F6E APP_USER \53D8\91CF\7684\503C\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>unistr('\6570\636E\5E93\5E10\6237')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\6B64\9A8C\8BC1\65B9\6848\8981\6C42\672C\5730\6570\636E\5E93\4E2D\5B58\5728\6570\636E\5E93\7528\6237\FF08\65B9\6848\FF09\3002\4F7F\7528\6B64\65B9\6CD5\65F6\FF0C\5C06\4F7F\7528\6570\636E\5E93\8D26\6237\7684\7528\6237\540D\548C\5BC6\7801\6765\9A8C\8BC1\7528\6237\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>unistr('LDAP \76EE\5F55')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\4F7F\7528\9762\5411 LDAP \670D\52A1\5668\7684\9A8C\8BC1\8BF7\6C42\5BF9\7528\6237/\5BC6\7801\8FDB\884C\9A8C\8BC1\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4E3B\673A')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('LDAP \76EE\5F55\670D\52A1\5668\7684\4E3B\673A\540D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\7AEF\53E3')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('LDAP \76EE\5F55\4E3B\673A\7684\7AEF\53E3\53F7\3002\9ED8\8BA4\503C\4E3A 389\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4F7F\7528 SSL')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\662F\5426\4F7F\7528 SSL \7ED1\5B9A\5230 LDAP \76EE\5F55\3002\5982\679C\9009\62E9\5E26\9A8C\8BC1\7684 SSL, \5219\5FC5\987B\4E3A &PRODUCT_NAME. \5B9E\4F8B\914D\7F6E Wallet\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4417)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5E26\9A8C\8BC1\7684 SSL')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\65E0 SSL')
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\552F\4E00\5224\522B\540D (DN) \5B57\7B26\4E32')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\4F7F\7528\7CBE\786E DN, \5219\8F93\5165\7528\4E8E\6784\9020 DBMS_LDAP.SIMPLE_BIND_S \7684\5168\9650\5B9A\552F\4E00\5224\522B\540D (DN) \5B57\7B26\4E32\7684\6A21\5F0F, \5982\679C\4F7F\7528\975E\7CBE\786E DN, \5219\8F93\5165\641C\7D22\57FA\7840\3002\4F7F\7528 <strong>%LDAP_USER%</strong> \4F5C\4E3A\7528\6237\540D\7684\5360\4F4D\7B26\3002\4F8B\5982:'),
'<p>',
unistr('<strong>\7CBE\786E DN</strong>'),
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
unistr('<strong>\975E\7CBE\786E DN (\641C\7D22\57FA\7840)</strong>'),
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\4F7F\7528\7CBE\786E\7684\552F\4E00\5224\522B\540D (DN)')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9 LDAP \552F\4E00\5224\522B\540D (DN) \5B57\7B26\4E32\662F\7CBE\786E\7684\8FD8\662F\975E\7CBE\786E\7684\3002\5982\679C\662F\975E\7CBE\786E\7684, \5219 LDAP \552F\4E00\5224\522B\540D (DN) \662F\641C\7D22\57FA\7840\5E76\4E14\60A8\5FC5\987B\63D0\4F9B\641C\7D22\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\641C\7D22\8FC7\6EE4\5668')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\4E0D\4F7F\7528\7CBE\786E\552F\4E00\5224\522B\540D (DN) \65F6\7684\641C\7D22\8FC7\6EE4\5668\3002\4F7F\7528 <strong>%LDAP_USER%</strong> \4F5C\4E3A\7528\6237\540D\7684\5360\4F4D\7B26\3002\4F8B\5982:'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('LDAP \7528\6237\540D\7F16\8F91\51FD\6570')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\60A8\53EF\4EE5\63D0\4F9B\5176\4ED6\8981\6267\884C\7684\4EE3\7801\6765\5C06\7528\6237\540D\8F6C\6362\4E3A\5B8C\5168\9002\5408\4E8E LDAP \76EE\5F55\6761\76EE\6216 LDAP \7528\6237\540D\7684\683C\5F0F\3002'),
unistr('\7ED1\5B9A\53D8\91CF :USERNAME \5305\542B\6700\7EC8\7528\6237\6307\5B9A\7684\540D\79F0\3002'),
unistr('\4F8B\5982, \4E0B\5217\4EE3\7801\8C03\7528\5C06 DN \5B57\7B26\4E32\4E2D\7684\6240\6709 "." \66FF\6362\4E3A "_" \7684\51FD\6570:</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. \5C06\6839\636E\9A8C\8BC1\5C5E\6027<strong>\7528\6237\540D\8F6C\4E49</strong>\6765\8F6C\4E49\8FD4\56DE\7684\7528\6237\540D\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4417)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\7528\6237\540D\8F6C\4E49')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\901A\8FC7\5728 LDAP \552F\4E00\5224\522B\540D\548C\641C\7D22\5B57\7B26\4E32\4E2D\66FF\6362 <strong>%LDAP_USER%</strong>,'),
unistr('&PRODUCT_NAME. \53EF\4EE5\81EA\52A8\5BF9\7528\6237\540D\4E2D\7684\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
'<p/>',
unistr('\53EF\80FD\7528\4E8E\8F6C\4E49\7684\89C4\5219\5305\62EC:'),
'<ul>',
unistr('<li><strong>\6807\51C6</strong>:'),
unistr('\6839\636E RFC 4514 (\9002\7528\4E8E\552F\4E00\5224\522B\540D) \548C RFC 4515 (\9002\7528\4E8E\641C\7D22\5B57\7B26\4E32) \5BF9\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\6B64\5916, \8FD8\4F1A\5BF9 unicode \5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\8FD9\662F\6700\5B89\5168\7684\8BBE\7F6E, \4F46\53EF\80FD\4F1A\4F7F\67D0\4E9B LDAP \670D\52A1\5668\51FA\73B0\95EE\9898\3002</li>'),
unistr('<li><strong>\4EC5\9650\7279\6B8A\5B57\7B26</strong>:'),
unistr('\6839\636E RFC 4514 (\9002\7528\4E8E\552F\4E00\5224\522B\540D) \548C RFC 4515 (\9002\7528\4E8E\641C\7D22\5B57\7B26\4E32) \5BF9\7279\6B8A\5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\4E0D\4F1A\5BF9 unicode \5B57\7B26\8FDB\884C\8F6C\4E49\3002</li>'),
unistr('<li><strong>\4E0D\8F6C\4E49</strong>:'),
unistr('\4E0D\4F1A\5BF9\4EFB\4F55\5B57\7B26\8FDB\884C\8F6C\4E49\3002'),
unistr('\6B64\8BBE\7F6E\53EF\80FD\4E0D\5B89\5168,'),
unistr('\9664\975E\91C7\7528<strong>\7528\6237\540D\7F16\8F91\51FD\6570</strong>, '),
unistr('\8BE5\51FD\6570\5DF2\5BF9\7528\6237\540D\8FDB\884C\8F6C\4E49 (\4F8B\5982, \4F7F\7528 apex_escape.ldap_dn \6216 apex_escape.ldap_search_filter)\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6807\51C6')
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4EC5\7279\6B8A\5B57\7B26')
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\65E0\8F6C\4E49')
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\8FD9\4F1A\5C06\9A8C\8BC1\59D4\6D3E\7ED9 Oracle AS Single Sign-On (SSO) \670D\52A1\5668\3002\8981\4F7F\7528\6B64\9A8C\8BC1\65B9\6848, \7AD9\70B9\5FC5\987B\5DF2\5728 SSO \670D\52A1\5668\4E2D\6CE8\518C\6210\4E3A\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4417)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\540D\79F0')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\5229\7528 Oracle Application Server Single Sign-On \8FDB\884C\9A8C\8BC1, \800C\60A8\7684\5E94\7528\7A0B\5E8F\662F SSO \7684\6CE8\518C\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F, \5219\8F93\5165\7684\540D\79F0\5FC5\987B\4E0E\60A8\5728\5411 SSO \6CE8\518C\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\65F6\4F7F\7528\7684\540D\79F0\5B8C\5168\76F8\540C\3002'),
'</p>',
'<p>',
unistr('\5982\679C\5C06 &PRODUCT_NAME. \4F5C\4E3A\6CE8\518C\7684\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F, \8BF7\5C06\6B64\5B57\6BB5\7559\7A7A\3002'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4417)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('SSO \670D\52A1\5668\7684\6CE8\9500 URL')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E00\6B21\767B\5165\670D\52A1\5668\7684\6CE8\9500\8DEF\5F84, \4F8B\5982'),
unistr('<em>https://login.example.com/sso/logout</em>\3002'),
unistr('\4ECE\5E94\7528\7A0B\5E8F\4E2D\6CE8\9500\65F6, &PRODUCT_NAME. \5C06\4F7F\7528\6B64\503C, \5C06 ''?p_done_url='' \4E0E\5E94\7528\7A0B\5E8F\7684\767B\5F55 URL \8FDE\63A5\5728\4E00\8D77, \5E76\4F7F\7528\751F\6210\7684 URL \6CE8\9500\4E00\6B21\767B\5165, \7136\540E\518D\91CD\5B9A\5411\56DE\5E94\7528\7A0B\5E8F\3002')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4417)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>unistr('\65E0\9A8C\8BC1')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\91C7\7528\5F53\524D\6570\636E\5E93\7528\6237\3002\8FD9\53EF\4E0E\4F7F\7528\57FA\672C\9A8C\8BC1\7684 mod_plsql DAD \914D\7F6E\4E00\8D77\7528\6765\8BBE\7F6E\6570\636E\5E93\4F1A\8BDD\7528\6237\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4417)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7528\6237\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165 &PRODUCT_NAME. \4F1A\8BDD\7684\7528\6237\540D\3002\5982\679C\4E3A\7A7A\FF0C&PRODUCT_NAME. \5C06\4F7F\7528\6570\636E\5E93\4F1A\8BDD\7528\6237\FF08\901A\5E38\4E3A APEX_PUBLIC_USER\FF09\3002')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>unistr('\65E5\5386')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\5404\79CD\65E5\5386\89C6\56FE\4E0A\663E\793A\57FA\4E8E\65E5\671F\7684\6761\76EE\3002\5982\679C\5305\62EC\4E86\7ED3\675F\65E5\671F, \65E5\5386\53EF\4EE5\663E\793A\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6\3002\5982\679C\542F\7528\4E86 "\62D6\653E", \65E5\5386\8FD8\53EF\4EE5\76F4\63A5\66F4\65B0\8BB0\5F55\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Google \65E5\5386 API \5BC6\94A5 [\5DF2\8FC7\65F6]')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165 Google \65E5\5386 API \5BC6\94A5\4EE5\4F7F\6B64\5E94\7528\7A0B\5E8F\4E2D\7684\65E5\5386\80FD\591F\4E0E Google \65E5\5386\6570\636E\96C6\6210\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>unistr('\5F00\59CB\65E5\671F\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5217\FF0C\8BE5\5217\4FDD\5B58\6B64\65E5\5386\4E0A\4E8B\4EF6\7684\5F00\59CB\65E5\671F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\7ED3\675F\65E5\671F\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5B58\653E\6B64\65E5\5386\4E0A\6240\663E\793A\4E8B\4EF6\7684\7ED3\675F\65E5\671F\7684\5217\3002\5982\679C\6307\5B9A\4E86\6B64\5C5E\6027, \5219\6B64\65E5\5386\5C06\663E\793A\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>unistr('\663E\793A\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\5217\FF0C\8BE5\5217\4FDD\5B58\6B64\65E5\5386\4E0A\4E8B\4EF6\7684\663E\793A\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5B58\653E\65E5\5386\4E8B\4EF6\7684\4E3B\952E\503C\7684\5217\3002\5982\679C\8868\7684\4E3B\952E\5305\542B\591A\4E2A\90E8\5206, \5219\9009\62E9 <strong>ROWID</strong>\3002</p>'),
unistr('<p>\5728 <code>APEX$PK_VALUE</code> \66FF\6362\53D8\91CF\4E2D\8FD4\56DE\6B64\5217\7684\503C\3002\5728<em>\62D6\653E\4EE3\7801</em>\5C5E\6027\4E2D\4F7F\7528\6B64\53D8\91CF\53EF\9075\5FAA\65E5\5386\4E0A\7684\62D6\653E\64CD\4F5C\786E\5B9A\8981\66F4\65B0\7684\8BB0\5F55\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>unistr('\67E5\770B/\7F16\8F91\94FE\63A5')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F93\5165\5728\7528\6237\5355\51FB\73B0\6709\6761\76EE\65F6\8981\8C03\7528\7684\76EE\6807\9875\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\521B\5EFA\94FE\63A5')
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\7528\6237\5355\51FB\7A7A\5355\5143, \6216\8005\5728\73B0\6709\65E5\5386\6761\76EE\5916\90E8\5355\51FB\65F6\8981\8C03\7528\7684\76EE\6807\9875\3002</p>'),
unistr('<p>\5FC5\987B\4F7F\7528\7279\6B8A\7684\65E5\5386\66FF\4EE3\53D8\91CF <pre>&APEX$NEW_START_DATE.</pre> \548C <pre>&APEX$NEW_END_DATE.</pre> \5C06\6240\9009\65E5\671F\4ECE\65E5\5386\4F20\9012\5230\76EE\6807\9875\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>unistr('\62D6\653E')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5141\8BB8\5728\6B64\65E5\5386\4E0A\6267\884C\62D6\653E\64CD\4F5C\3002</p>'),
unistr('<p><em>\6CE8: \5982\679C\542F\7528\4E86\62D6\653E\64CD\4F5C, \5219\6709\6743\67E5\770B\6B64\65E5\5386\7684\4EFB\4F55\6700\7EC8\7528\6237\540C\65F6\4E5F\6709\6743\66F4\65B0\65E5\5386\6761\76EE\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('\62D6\653E PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\4EC5\5177\6709\5F00\59CB\65E5\671F\7684\793A\4F8B (\7528\4E8E\975E\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>\5177\6709\5F00\59CB\65E5\671F\548C\7ED3\675F\65E5\671F\7684\793A\4F8B\3002(\7528\4E8E\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 PL/SQL \4EE3\7801, \4EE5\4FBF\5728\4F7F\7528\62D6\653E\64CD\4F5C\66F4\65B0\65E5\5386\6761\76EE\65F6\66F4\65B0\57FA\7840\8868\6216\53EF\66F4\65B0\89C6\56FE\3002</p>'),
unistr('<p>\5982\679C\6B64\65E5\5386\663E\793A\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6 (\4E3A\201C\7ED3\675F\65E5\671F\201D\9009\62E9\4E00\5217), \5219 PL/SQL \4EE3\7801\8FD8\9700\8981\66F4\65B0\6B64\503C\3002\5982\679C\62D6\52A8\6574\4E2A\4E8B\4EF6, \5219\201C\7ED3\675F\65E5\671F\201D\7EF4\62A4\5F53\524D\6301\7EED\65F6\95F4\3002\5982\679C\62D6\52A8\4E8B\4EF6\7ED3\5C3E, \5219\66F4\65B0\4E8B\4EF6\7684\6301\7EED\65F6\95F4\3002\5728\8FD9\79CD\60C5\51B5\4E0B, \5F00\59CB\65E5\671F\5C06\4E0D\53D8, \4F46\7ED3\675F\65E5\671F\5C06\8FDB\884C\66F4\65B0\4EE5\53CD\6620\4FEE\8BA2\540E\7684\6301\7EED\65F6\95F4\3002</p>'),
unistr('<p>\65E5\5386\66FF\6362\53D8\91CF\5305\62EC:</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
unistr('    <dd>\8FD4\56DE\4FEE\8BA2\540E\7684\5F00\59CB\65E5\671F\3002\65E5\671F\683C\5F0F\4E3A <code>''YYYYMMDDHH24MISS''</code>, \5373\4F7F\6B64\65E5\5386\7684<em>\663E\793A\65F6\95F4</em>\4E3A<strong>\5426</strong>\4E5F\662F\5982\6B64\3002</dd>'),
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>\8FD4\56DE\57FA\4E8E\6301\7EED\65F6\95F4\7684\4E8B\4EF6\7684\4FEE\8BA2\540E\7ED3\675F\65E5\671F\3002\65E5\671F\683C\5F0F\4E3A <code>''YYYYMMDDHH24MISS''</code>, \5373\4F7F\6B64\65E5\5386\7684<em>\663E\793A\65F6\95F4</em>\4E3A<strong>\5426</strong>\4E5F\662F\5982\6B64\3002</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
unistr('    <dd>\8FD4\56DE\5728\4E3B\952E\5217\4E2D\6307\5B9A\7684\5217\7684\503C\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>unistr('\5176\4ED6\65E5\5386\89C6\56FE')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\8981\663E\793A\7684\5176\4ED6\65E5\5386\89C6\56FE\3002\59CB\7EC8\663E\793A\6708\89C6\56FE\3002</p>'),
unistr('<p>\6CE8: \5F53\201C\663E\793A\65F6\95F4\201D\6307\5B9A\4E3A<strong>\5426</strong>\65F6, \5468\89C6\56FE\548C\65E5\89C6\56FE\4E0D\53EF\7528\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\5217\8868')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\5BFC\822A')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\5BFC\51FA')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5728\65E5\5386\5E95\90E8\63D0\4F9B\54EA\4E9B\5BFC\51FA\94FE\63A5\3002</p>'),
unistr('<p><em>\6CE8: \8FD9\5C06\5BFC\51FA\5F53\524D\663E\793A\7684\6240\6709\65E5\5386\6761\76EE, \800C\4E0D\662F\5355\4E2A\65E5\5386\6761\76EE\3002</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4417)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4417)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4417)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>unistr('\65E5\5386\89C6\56FE\548C\5BFC\822A')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\8981\663E\793A\7684\65E5\5386\89C6\56FE\3002\5FC5\987B\81F3\5C11\9009\62E9<strong>\65E5</strong>, <strong>\5468</strong>\6216<strong>\6708</strong>\4E4B\4E00\3002\5982\679C\672A\9009\62E9, \5219\65E5\5386\5C06\81EA\52A8\663E\793A<strong>\6708</strong>\89C6\56FE\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6708')
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5468')
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5929')
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4417)
,p_display_sequence=>35
,p_display_value=>unistr('\5217\8868')
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\5BFC\822A')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Google \65E5\5386 ID')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>unistr('<p>Google \65E5\5386 ID: abc123@group.calendar.google.com</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\6B64\65E5\5386\4E0A\663E\793A\7684\65E5\5386\6570\636E\6E90\7684 Google \65E5\5386 ID\3002</p>'),
unistr('<p>\7531\4E8E Google \65E5\5386\5B58\5728\5B89\5168\9650\5236, \8FD9\4E9B\65E5\5386\5FC5\987B\662F\516C\5171\65E5\5386, \6216\53EF\4F9B\6B64\65E5\5386\7684\6240\6709\6700\7EC8\7528\6237\4F7F\7528\3002</p>'),
unistr('<p><em>\6CE8: \5FC5\987B\8F93\5165 Google \65E5\5386 API \5BC6\94A5\4EE5\4FBF Google \65E5\5386\6B63\5E38\8FD0\884C\3002\8F6C\5230\201C\5171\4EAB\7EC4\4EF6 > \7EC4\4EF6\8BBE\7F6E > \65E5\5386\201D\4EE5\4FBF\4E3A\5E94\7528\7A0B\5E8F\8BBE\7F6E\5BC6\94A5\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>unistr('\663E\793A\65F6\95F4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\662F\5426\5E94\663E\793A\65E5\671F\7684\65F6\95F4\90E8\5206\3002</p>'),
unistr('<p>\4EC5\5F53\201C\663E\793A\65F6\95F4\201D\8BBE\7F6E\4E3A<strong>\662F</strong>\65F6, \624D\4F1A\663E\793A\6BCF\5468\548C\6BCF\65E5\89C6\56FE\3002\5982\679C\5F00\59CB\65E5\671F\6216\7ED3\675F\65E5\671F\5217\4E0D\5305\542B\65F6\95F4\90E8\5206, \5219\5C06\663E\793A\4E3A 12:00 am\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>unistr('CSS \7C7B')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E\9879\76EE\72B6\6001\8BBE\7F6E\65E5\5386\6837\5F0F</p>'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9\5B58\653E\7528\4E8E\8BBE\7F6E\6B64\65E5\5386\4E0A\6240\663E\793A\4E8B\4EF6\6837\5F0F\7684 CSS \7C7B\7684\5217\3002<br>'),
unistr('\6709\8BB8\591A\9ED8\8BA4\7C7B\53EF\7528:'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('\8BF7\53C2\9605\6709\5173\6DFB\52A0\9644\52A0 CSS \7C7B\7684\6587\6863\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('REST Web \670D\52A1 (JSON)')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165 RESTful Web \670D\52A1\6E90\7684 URL \4EE5\663E\793A\5728\6B64\65E5\5386\4E0A\3002\6B64\65E5\5386\53EF\4EE5\5448\73B0\4ECE\5916\90E8\6E90 (\4F8B\5982 Oracle REST Data Services) \68C0\7D22\7684 JSON \6570\636E\3002\8FD9\4E9B Web \670D\52A1\5FC5\987B\662F\516C\5171\7684, \6216\53EF\4F9B\6B64\65E5\5386\7684\6240\6709\6700\7EC8\7528\6237\4F7F\7528\3002</p>'),
unistr('<p>\5E94\8BBE\7F6E JSON \6E90\7684\683C\5F0F\6765\5305\62EC:</p>'),
'<ol>',
unistr('<li>\4E8B\4EF6\5217\8868\6570\7EC4, \5305\542B - <code>items</code></li>'),
unistr('<li>\6BCF\4E2A\4E8B\4EF6\5BF9\8C61, \5305\542B - <code>{ id, title, start, allday, end, description }</code><br>title \548C start \5C5E\6027\662F\5FC5\9700\5C5E\6027\3002</li>'),
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('\8865\5145\4FE1\606F')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5728\5217\8868\89C6\56FE\548C\5DE5\5177\63D0\793A\4E2D\663E\793A\7684\9644\52A0 HTML\3002\4F7F\7528 &COLUMN. \8BED\6CD5\53EF\4EE5\7528 HTML \5F62\5F0F\663E\793A\5217\503C\3002</p>'),
unistr('<p>\6CE8:\201C\663E\793A\5DE5\5177\63D0\793A\201D\5FC5\987B\8BBE\7F6E\4E3A<strong>\662F</strong>\624D\80FD\5728\6BCF\6708, \6BCF\5468\548C\6BCF\65E5\89C6\56FE\4E2D\663E\793A\6B64\8865\5145\4FE1\606F\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>unistr('\663E\793A\5468\672B')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\662F\5426\4E3A\6B64\65E5\5386\663E\793A\661F\671F\516D\548C\661F\671F\65E5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>unistr('\65F6\95F4\683C\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>\9009\62E9\7528\4E8E\663E\793A\6B64\65E5\5386\4E8B\4EF6\7684\65F6\95F4\90E8\5206\7684\65F6\95F4\683C\5F0F\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9ED8\8BA4\503C')
,p_return_value=>'00'
,p_help_text=>unistr('\5229\7528\5728\201C\5168\7403\5316\201D\4E0B\8F93\5165\7684\5E94\7528\7A0B\5E8F\65F6\95F4\6233\683C\5F0F\3002\5982\679C\672A\586B\5145\6B64\5C5E\6027, \5219\5C06\4F7F\7528\6570\636E\5E93 NLS \8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4417)
,p_display_sequence=>20
,p_display_value=>unistr('12 \5C0F\65F6')
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528 12 \5C0F\65F6\5236\663E\793A\65F6\95F4, \5305\62EC a.m. (\6765\81EA\62C9\4E01\8BED <em>ante meridiem</em>, \8868\793A "\4E2D\5348\4E4B\524D") \548C p.m. (<em>post meridiem</em>, "\4E2D\5348\4E4B\540E"), \4F8B\5982 8:00 a.m. \548C 4:00 p.m.</p>'),
unistr('<p>a.m./p.m. \7684\5B9E\9645\663E\793A\683C\5F0F (\4F8B\5982\5927\5199\548C\53E5\70B9) \6D3E\751F\81EA\65F6\95F4\6233\683C\5F0F\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4417)
,p_display_sequence=>30
,p_display_value=>unistr('24 \5C0F\65F6')
,p_return_value=>'24'
,p_help_text=>unistr('\4F7F\7528 24 \5C0F\65F6\5236\663E\793A\65F6\95F4, \4F8B\5982 08:00 \548C 16:00\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>unistr('\663E\793A\5DE5\5177\63D0\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\7528\6237\5C06\9F20\6807\60AC\505C\5728\6B64\65E5\5386\4E2D\7684\4E8B\4EF6\4E0A\65B9\65F6\662F\5426\663E\793A\5DE5\5177\63D0\793A\3002</p>'),
unistr('<p><em>\4E0B\62C9\5BF9\8BDD\6846\5C06\663E\793A\4E8B\4EF6\540D\79F0, \8865\5145\4FE1\606F\548C\65E5\671F\8BE6\7EC6\4FE1\606F\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>unistr('\7B2C\4E00\5C0F\65F6')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\8F93\5165 0 \81F3 23 \4E4B\95F4\7684\6574\6570, \4EE5\6307\5B9A\5728\6BCF\5468\65E5\5386\548C\6BCF\5929\65E5\5386\4E0A\663E\793A\7684\7B2C\4E00\4E2A\5C0F\65F6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('\6700\5927\4E8B\4EF6\6570/\5929')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\5728\6BCF\6708\89C6\56FE\4E2D\4E3A\6BCF\5929\663E\793A\7684\6700\5927\4E8B\4EF6\6570\3002</p>'),
unistr('<p>\5982\679C\591A\4E8E\7279\5B9A\65E5\671F\7684\6307\5B9A\4E8B\4EF6\6570, \8BE5\65E5\671F\5C06\5305\542B<strong>\66F4\591A...</strong>\3002\5355\51FB\6B64\9879\5C06\663E\793A\4E00\4E2A\5177\6709\8BE5\7279\5B9A\65E5\671F\7684\6240\6709\4E8B\4EF6\7684\5F39\51FA\7A97\53E3\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('\591A\884C\4E8B\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9<strong>\662F</strong>\53EF\4F7F\4E8B\4EF6\663E\793A\5728\591A\884C\4E0A (\6839\636E\201C\663E\793A\5217\201D\6587\672C\7684\957F\5EA6)\3002</p>'),
unistr('<p>\5982\679C\53EA\5E0C\671B\6BCF\4E2A\4E8B\4EF6\90FD\663E\793A\5728\5355\884C\4E0A, \5E76\4E14\622A\65AD\4E0D\9002\5408\663E\793A\5BBD\5EA6\7684\6587\672C, \8BF7\9009\62E9<strong>\5426</strong>\3002\5B8C\6574\6587\672C\5C06\663E\793A\5728\5DE5\5177\63D0\793A\4E2D\3002</p>'),
unistr('<p>\6CE8: \591A\884C\4E8B\4EF6\8BBE\7F6E\53EA\5728\6708\89C6\56FE\4E2D\4F7F\7528\3002\5BF9\4E8E\5468\89C6\56FE\548C\65E5\89C6\56FE, \4E8B\4EF6\7684\6301\7EED\65F6\95F4\51B3\5B9A\4E86\6240\663E\793A\4E8B\4EF6\7684\9AD8\5EA6\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>unistr('\7248\672C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3 \5DF2\8FC7\65F6\FF0C\5F88\5FEB\5C06\88AB FullCalendar 5 \66FF\4EE3\3002\7ACB\5373\8FDB\884C\8FD9\4E00\5207\6362\662F\4E00\4E2A\4E0D\9519\7684\4E3B\610F\FF0C\8FD9\53EF\4EE5\907F\514D\60A8\7684\5E94\7528\7A0B\5E8F\5728\5C06\6765\7684\7248\672C\4E2D\6709\88AB\4E2D\65AD\7684\98CE\9669\3002\5982\679C\60A8\4F7F\7528\4E86\4EFB\4F55\5B9A\5236\521D\59CB\5316 Javascript \4EE3\7801\FF0C\8BF7\6CE8\610F\FF0CFullCalendar \7684 API \5DF2\66F4\6539\FF0C\60A8\7684\4EE3\7801\5F88\6709\53EF\80FD\9700\8981\8FDB\884C\8C03\6574\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4417)
,p_display_sequence=>10
,p_display_value=>unistr('FullCalendar 3 [\5DF2\8FC7\65F6]')
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
unistr('    pOptions.titleFormat      = "[Conference Schedule]";                                // \5B9A\5236\6807\9898'),
unistr('    pOptions.slotMinTime      = "07:00:00";                                             // \5728 minTime \4E4B\524D\9690\85CF\65F6\9699'),
unistr('    pOptions.slotMaxTime      = "18:00:00";                                             // \5728 maxTime \4E4B\540E\9690\85CF\65F6\9699'),
unistr('    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // \5468\89C6\56FE\5217\6807\9898'),
unistr('    pOptions.slotDuration     = "00:15:00";                                             // \5B9A\5236\65F6\9699\6301\7EED\65F6\95F4'),
unistr('    pOptions.weekNumbers      = true;                                                   // \663E\793A\5468\7F16\53F7'),
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4EE5\8986\76D6\6807\51C6 FullCalendar \521D\59CB\5316\5C5E\6027\3002\8BE5\51FD\6570\5FC5\987B\8FD4\56DE\5305\542B\65E5\5386\521D\59CB\5316\5C5E\6027\4F5C\4E3A\53C2\6570\7684\5BF9\8C61\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\57FA\4E8E\9879\76EE\72B6\6001\8BBE\7F6E\65E5\5386\6837\5F0F</p>,'),
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5B58\653E\7528\4E8E\8BBE\7F6E\6B64\65E5\5386\4E0A\6240\663E\793A\4E8B\4EF6\6837\5F0F\7684 CSS \7C7B\7684\5217\3002'),
unistr('\6709\8BB8\591A\9ED8\8BA4\7C7B\53EF\7528:</p>'),
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>\8BF7\53C2\9605\6709\5173\6DFB\52A0\9644\52A0 CSS \7C7B\7684\6587\6863\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_name=>'apexcalendardateselect'
,p_display_name=>unistr('\5DF2\9009\62E9\65E5\671F')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_name=>'apexcalendareventselect'
,p_display_name=>unistr('\5DF2\9009\62E9\4E8B\4EF6')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4417)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4417)
,p_name=>'apexcalendarviewchange'
,p_display_name=>unistr('\5DF2\66F4\6539\89C6\56FE')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('\8868\683C\5F0F\8868\5355 - \591A\884C\5220\9664')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\7528\4E8E\4ECE\8868\683C\5F0F\8868\5355\533A\57DF\4E2D\5220\9664\591A\884C\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4417)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4417)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4417)
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\53EF\66F4\65B0\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4417)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4417)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5305\542B\4E3B\952E\503C\7684\5217\3002\5BF9\4E8E\4E3B\952E\90E8\5206\591A\4E8E\4E24\4E2A\7684\8868, \9009\62E9 <strong>ROWID</strong>\3002</p>'),
unistr('<p>\4E3B\952E\7528\4E8E\6807\8BC6\8981\5220\9664\7684\884C, \5E76\4E14\5728\8868\683C\5F0F\8868\5355\4E2D\4E0D\53EF\7F16\8F91\3002\5BF9\4E8E\65B0\884C, \4E3B\952E\503C\5FC5\987B\4E3A\7A7A\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4417)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6B21\7EA7\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\7B2C\4E8C\4E3B\952E\503C\7684\5217\3002\4EC5\5F53\4E3B\952E\7531\4E24\5217\7EC4\6210\65F6, \624D\5E94\586B\5145\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4417)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\8FD0\884C\65F6 Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\4EE5\4E0B\8BED\53E5\9650\5236\90E8\95E8:'),
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('\8F93\5165\5C06\9644\52A0\5230\751F\6210\7684 DELETE \8BED\53E5\7684 SQL WHERE \5B50\53E5\3002\4F7F\7528\6B64\5C5E\6027\53EF\9650\5236\5728\81EA\52A8\751F\6210\7684 SQL \8C03\7528\4E2D\4F7F\7528\7684\8BB0\5F55\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>unistr('\7528\6237\9996\9009\9879')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\4E3A\6700\7EC8\7528\6237\8BBE\7F6E\7528\6237\9996\9009\9879\7684\5904\7406\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4417)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5904\7406\7C7B\578B\4EE5\91CD\7F6E\6216\8BBE\7F6E\7528\6237\9996\9009\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\91CD\7F6E\9996\9009\9879 (\5220\9664\5F53\524D\7528\6237\7684\6240\6709\9996\9009\9879)')
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8BBE\7F6E\4E3A\9879\503C')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\8BBE\7F6E\4E3A\9879\503C (\5982\679C\975E\7A7A\503C)')
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4417)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9996\9009\9879\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>unistr('\8F93\5165\9996\9009\9879\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4417)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('\9009\62E9\5B58\653E\9996\9009\9879\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>unistr('\81EA\52A8\884C\5904\7406 (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('\7528\4E8E\5728\5355\4E2A\6570\636E\5E93\8868\6216\53EF\66F4\65B0\89C6\56FE\4E2D\63D2\5165, \66F4\65B0\6216\5220\9664\8BB0\5F55\7684\5904\7406\3002\6B64\5904\7406\7528\4E8E\5904\7406\6E90\4E3A<strong>\6570\636E\5E93\5217</strong>\7C7B\578B\7684\8868\5355\9879\3002\4E3A\6B64\5904\7406\8F93\5165\7684\5C5E\6027\5E94\4E0E\5728<em>\81EA\52A8\884C\63D0\53D6</em>\5904\7406\4E2D\8F93\5165\7684\5C5E\6027\5173\8054\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4417)
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\5B58\653E\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\4E3B\952E\503C\7684\5217\3002\5BF9\4E8E\4E3B\952E\90E8\5206\591A\4E8E\4E24\4E2A\7684\8868, \9009\62E9 <strong>ROWID</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\6B21\7EA7\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F93\5165\5B58\653E\6B21\7EA7\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>unistr('\6B21\7EA7\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4417)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>unistr('\9009\62E9\5305\542B\7B2C\4E8C\4E3B\952E\503C\7684\5217\3002\4EC5\5F53\4E3B\952E\7531\4E24\5217\7EC4\6210\65F6, \624D\5E94\586B\5145\6B64\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\884C\7248\672C\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6807\8BC6\884C\7248\672C\7684\5217, \6B64\5217\4E0D\9700\8981\5728\9875\4E0A\663E\793A\3002\5C06\6B64\5C5E\6027\7559\7A7A\53EF\4F7F\7528\5185\7F6E\7684\6821\9A8C\548C\3002</p>'),
unistr('<p>\64CD\4F5C\9501\5B9A\4F7F\7528\4E22\5931\7684\66F4\65B0\68C0\6D4B\529F\80FD\6765\786E\4FDD\53EF\4EE5\5E76\53D1\8BBF\95EE\6570\636E\7684\5E94\7528\7A0B\5E8F\4E2D\7684\6570\636E\5B8C\6574\6027\3002&PRODUCT_NAME. \53EF\4EE5\4F7F\7528\5185\7F6E\6821\9A8C\548C\6765\6267\884C\4E22\5931\7684\66F4\65B0\68C0\6D4B, \5E76\786E\5B9A\884C\7684\7248\672C\3002\6821\9A8C\548C\662F\7279\5B9A\8868\884C\7684\6240\6709\5217\503C\7684\6563\5217\51FD\6570\3002\5728<em>\81EA\52A8\884C\63D0\53D6</em>\4E2D\4ECE\6570\636E\5E93\67E5\8BE2\8BB0\5F55\65F6\4F1A\68C0\7D22\6821\9A8C\548C, \7136\540E\5728\6B64\5904\7406\4E2D\5C06\5176\4E0E\6570\636E\5E93\4E2D\5F53\524D\8BB0\5F55\7684\6563\5217\8FDB\884C\6BD4\8F83\3002\5982\679C\4E24\4E2A\503C\76F8\540C, \5219\66F4\65B0\7EE7\7EED, \5426\5219\6B64\5904\7406\4F1A\5F15\53D1\9519\8BEF\3002</p>'),
unistr('<p>\4F7F\7528\6B64\5C5E\6027\53EF\4EE5\6307\5B9A\4E00\5217\6765\5B58\653E\884C\7248\672C, \4F5C\4E3A\4F7F\7528\5185\7F6E\6821\9A8C\548C\5904\7406\7684\66FF\4EE3\65B9\6CD5\3002\6BCF\5F53\66F4\65B0\6570\636E\5E93\4E2D\7684\8BB0\5F55\65F6\90FD\5E94\66F4\65B0\6B64\5217\3002Oracle \5EFA\8BAE\5728\8868\4E0A\5B9E\65BD<em>\66F4\65B0\4E4B\524D</em>\6570\636E\5E93\89E6\53D1\5668\8FDB\884C\9012\589E, \5426\5219\66F4\65B0\884C\7248\672C\5217\3002\7CFB\7EDF\5C06\5047\5B9A NUMBER \5217\5305\542B\884C\7684\5E8F\5217\53F7\3002\4F46\662F, \4E5F\53EF\4EE5\4F7F\7528 DATE \548C TIMESTAMP \5217\3002\4F7F\7528\4E00\5217\7684\597D\5904\662F, &PRODUCT_NAME. \5F15\64CE\4E0D\9700\8981\6267\884C\5B8C\6574\884C\7684\6563\5217\64CD\4F5C, \53EA\9700\6BD4\8F83\4E00\5217\503C\5373\53EF\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\8FD0\884C\65F6 Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9650\5236\90E8\95E8:</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\8F93\5165\5C06\9644\52A0\5230\751F\6210\7684\6240\6709 INSERT, UPDATE \548C DELETE \8BED\53E5\7684 SQL WHERE \5B50\53E5\3002\4F7F\7528\6B64\5C5E\6027\53EF\9650\5236\5728\81EA\52A8\751F\6210\7684 SQL \8C03\7528\4E2D\4F7F\7528\7684\8BB0\5F55\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\5C06\5173\952E\5B57\8FD4\56DE\5230\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\5B58\653E\4ECE SQL INSERT \8BED\53E5\8FD4\56DE\7684\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002</p>'),
unistr('<p>\6307\5B9A\6B64\5217\53EF\8FD4\56DE\5230\901A\8FC7\5E8F\5217\6216\6570\636E\5E93\89E6\53D1\5668\586B\5145\7684\4E3B\952E\5B57\6BB5\3002\901A\8FC7\5904\7406\5C06\6B64\503C\8BBE\7F6E\5230\4F1A\8BDD\72B6\6001\4E2D\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\5C06\6B21\7EA7\5173\952E\5B57\8FD4\56DE\5230\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\653E\4ECE SQL INSERT \8BED\53E5\8FD4\56DE\7684\7B2C\4E8C\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('\652F\6301\7684\64CD\4F5C')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\68C0\67E5\652F\6301\54EA\4E9B\6570\636E\64CD\7EB5\8BED\8A00 (DML) \64CD\4F5C\3002\5F53\8BF7\6C42\503C\662F\5217\51FA\7684\5176\4E2D\4E00\4E2A\503C\65F6, \6B64\6570\636E\64CD\7EB5\5904\7406\5C06\6267\884C DML\3002\5F53\4F7F\7528\6309\94AE\63D0\4EA4\6B64\9875\65F6, \5C06\4F7F\7528\8BE5\6309\94AE\8BBE\7F6E\8BF7\6C42\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\63D2\5165')
,p_return_value=>'I'
,p_help_text=>unistr('\7531\8BF7\6C42\503C\89E6\53D1: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\66F4\65B0')
,p_return_value=>'U'
,p_help_text=>unistr('\7531\8BF7\6C42\503C\89E6\53D1: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5220\9664')
,p_return_value=>'D'
,p_help_text=>unistr('\7531\8BF7\6C42\503C\89E6\53D1: DELETE, REMOVE, DELETE ROW, DROP')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4417)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>unistr('\9501\5B9A\884C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('<p>\9009\62E9\5728\5904\7406\6BCF\4E00\884C\4E4B\524D\662F\5426\5728\57FA\7840\8868\4E2D\9501\5B9A\8981\66F4\65B0\6216\5220\9664\7684\76F8\5E94\884C\3002</p>')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>unistr('\8BBE\7F6E\7126\70B9')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C06\7126\70B9\8BBE\7F6E\5230\53D7\5F71\54CD\7684\5143\7D20\3002\5982\679C\5B58\5728\591A\4E2A\5143\7D20, \5219\8FD9\5C06\9ED8\8BA4\4E3A\7B2C\4E00\4E2A\53D7\5F71\54CD\7684\5143\7D20\3002\4E0E<em>\663E\793A</em>\548C<em>\542F\7528</em>\64CD\4F5C\4E00\8D77\4F7F\7528\4EE5\5C06\7528\6237\76F4\63A5\8F6C\5230\9002\5F53\7684\9879\65F6, \8FD9\5C24\4E3A\6709\7528\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>unistr('\63D0\4EA4\9875')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\63D0\4EA4\6B64\9875\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4417)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\8BF7\6C42/\6309\94AE\540D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\63D0\4EA4\9875\7684\8BF7\6C42\503C\3002\5982\679C\67D0\4E2A\6309\94AE\89E6\53D1\4E86\52A8\6001\64CD\4F5C, \5219\5C06\6B64\503C\8BBE\7F6E\4E3A\6309\94AE\540D\79F0\3002\8FD9\53EF\4EE5\786E\4FDD\5728\9875\5904\7406\671F\95F4\9075\5B88\6309\94AE\7684<em>\6267\884C\9A8C\8BC1</em>\5C5E\6027\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4417)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\663E\793A\5904\7406')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\9875\63D0\4EA4\671F\95F4\5F53\524D\9875\662F\5426\7070\663E, \4EE5\53CA\662F\5426\663E\793A ''\6B63\5728\5904\7406'' \6837\5F0F\7684\52A8\753B\3002\8FD9\4F1A\975E\5E38\6709\7528, \53EF\4EE5\9632\6B62\957F\65F6\95F4\8FD0\884C\64CD\4F5C\671F\95F4\6700\7EC8\7528\6237\6267\884C\64CD\4F5C, \4F8B\5982, \6700\7EC8\7528\6237\5728\62A5\8868\5237\65B0\7F13\6162\65F6\5C1D\8BD5\91CD\65B0\5355\51FB\201C\641C\7D22\201D\6309\94AE\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>unistr('\6570\5B57\5B57\6BB5')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\663E\793A\6570\5B57\5B57\6BB5\3002\6B64\9879\7C7B\578B\81EA\52A8\9A8C\8BC1\503C\662F\5426\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4417)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5C0F\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\5141\8BB8\7684\6700\5C0F\503C\3002\6B64\503C\53EF\4EE5\662F\9759\6001\503C\6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4417)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5927\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\5141\8BB8\7684\6700\5927\503C\3002\6B64\503C\53EF\4EE5\662F\9759\6001\503C\6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4417)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6570\5B57\5BF9\9F50')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\5BF9\9F50\663E\793A\7684\6570\5B57\3002\5F53\9879\5448\73B0\4E3A<em>\53EA\8BFB</em>\6216\6307\5B9A\4E86 <strong>HTML \8868\5355\5143\7D20\5C5E\6027</strong>\65F6, \6B64\8BBE\7F6E\4E0D\9002\7528\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5DE6\5BF9\9F50')
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5C45\4E2D')
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\53F3\5BF9\9F50')
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>unistr('\6ED1\5757')
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\6ED1\5757\9879\7C7B\578B, \8FD9\4F7F\7528\6237\53EF\4EE5\901A\8FC7\5411\5DE6\6216\5411\53F3\6ED1\52A8\63A7\4EF6\6765\66F4\65B0\9879\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4417)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\6700\5C0F\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\5141\8BB8\7684\6700\5C0F\503C\3002\6B64\503C\53EF\4EE5\662F\9759\6001\503C\6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4417)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5927\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\5141\8BB8\7684\6700\5927\503C\3002\6B64\503C\53EF\4EE5\662F\9759\6001\503C\6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4417)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6B65\957F\589E\91CF')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5F3A\5236\6ED1\5757\5BF9\9F50\5230\7279\5B9A\589E\91CF\7684\503C\3002\6B64\503C\53EF\4EE5\662F\9759\6001\503C\6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C\3002')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4417)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\7A81\51FA\663E\793A\6240\9009\9879')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6ED1\5757\662F\5426\5C06\7A81\51FA\663E\793A\6ED1\8F68\76F4\5230\5F53\524D\7684\6ED1\5757\624B\67C4\4F4D\7F6E\3002')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\7528\4E8E\4ECE\5E94\7528\7A0B\5E8F\53D1\9001\7535\5B50\90AE\4EF6\5E76\9009\62E9\6027\5730\53D1\9001\4E00\4E2A\6216\591A\4E2A\9644\4EF6\7684\5904\7406\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\53D1\4EF6\4EBA')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\8981\663E\793A\4E3A\7535\5B50\90AE\4EF6\53D1\4EF6\4EBA\7684\7535\5B50\90AE\4EF6\5730\5740\3002\6B64\7535\5B50\90AE\4EF6\5730\5740\5FC5\987B\662F\6709\6548\5730\5740\3002\5426\5219, \5C06\4E0D\4F1A\53D1\9001\90AE\4EF6\3002\5982\679C\8981\4F7F\7528\52A8\6001\503C, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6536\4EF6\4EBA')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\901A\8FC7\6307\5B9A\4E00\4E2A\6216\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \8F93\5165\7535\5B50\90AE\4EF6\6536\4EF6\4EBA\3002\5BF9\4E8E\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002\5982\679C\8981\4F7F\7528\52A8\6001\503C, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6284\9001')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('\901A\8FC7\6307\5B9A\4E00\4E2A\6216\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \8F93\5165\6284\9001\7535\5B50\90AE\4EF6\6536\4EF6\4EBA\3002\5BF9\4E8E\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002\5982\679C\8981\4F7F\7528\52A8\6001\503C, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5BC6\9001')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('\901A\8FC7\6307\5B9A\4E00\4E2A\6216\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \8F93\5165\5BC6\4EF6\6284\9001\7535\5B50\90AE\4EF6\6536\4EF6\4EBA\3002\5BF9\4E8E\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \8BF7\4F7F\7528\9017\53F7\5206\9694\7684\5217\8868\3002\5982\679C\8981\4F7F\7528\52A8\6001\503C, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\56DE\590D')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('\8F93\5165\5E94\5C06\56DE\590D\53D1\9001\81F3\7684\7535\5B50\90AE\4EF6\5730\5740\3002\5982\679C\672A\6307\5B9A, \5219\5C06\4F7F\7528\5728<strong>\53D1\4EF6\4EBA</strong>\4E2D\8F93\5165\7684\7535\5B50\90AE\4EF6\5730\5740\3002\5982\679C\8981\4F7F\7528\52A8\6001\503C, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('\4E3B\9898')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4417)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('\8F93\5165\7535\5B50\90AE\4EF6\7684\4E3B\9898\3002\5982\679C\8981\5305\542B\52A8\6001\503C, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5, \4F8B\5982 <code>&amp;P6_PRODUCT_NAME.</code>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>unistr('\6B63\6587\7EAF\6587\672C')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7535\5B50\90AE\4EF6\7684\6587\672C\3002\5982\679C\6536\4EF6\4EBA\7684\7535\5B50\90AE\4EF6\5BA2\6237\673A\4E0D\652F\6301\591A\4FE1\606F\6587\672C\663E\793A, \8BF7\4F7F\7528\7EAF\6587\672C\683C\5F0F\3002\5982\679C\8981\5728\6587\672C\4E2D\5305\542B\52A8\6001\5185\5BB9, \8BF7\4F7F\7528\66FF\6362\8BED\6CD5, \4F8B\5982 <code>&amp;P6_PRODUCT_NAME.</code>\3002</p>'),
unistr('<p><em>\6CE8: SMTP/MIME \89C4\8303\89C4\5B9A\4EFB\4F55\5355\4E2A\884C\7684\957F\5EA6\90FD\4E0D\80FD\8D85\8FC7 1000 \4E2A\5B57\7B26\3002\4E3A\4E86\9075\5B88\6B64\9650\5236, \5FC5\987B\6DFB\52A0\4E00\4E2A\56DE\8F66\7B26\6216\6362\884C\7B26, \5C06\6587\672C\62C6\5206\4E3A\957F\5EA6\4E0D\8D85\8FC7 1000 \4E2A\5B57\7B26\7684\82E5\5E72\5757\3002\5982\679C\4E0D\8FD9\6837\505A, \5219\4F1A\5BFC\81F4\7535\5B50\90AE\4EF6\4E0D\6B63\786E, \8BF8\5982\90AE\4EF6\4E2D\53EA\5305\542B\90E8\5206\5185\5BB9\6216\51FA\73B0\65E0\5173\7684\611F\53F9\53F7\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>unistr('\6B63\6587 HTML')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4417)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6587\672C\FF0C\4EE5\4FBF\4EA7\751F\540C\65F6\5305\542B\7EAF\6587\672C\548C HTML \5185\5BB9\7684\591A\90E8\5206 HTML \90AE\4EF6\3002\6536\4EF6\4EBA\7535\5B50\90AE\4EF6\5BA2\6237\673A\7684\8BBE\7F6E\548C\529F\80FD\5C06\786E\5B9A\663E\793A\7684\5185\5BB9\3002\867D\7136\5927\591A\6570\73B0\4EE3\7535\5B50\90AE\4EF6\5BA2\6237\673A\90FD\80FD\591F\9605\8BFB HTML \683C\5F0F\7684\7535\5B50\90AE\4EF6\FF0C\4F46\8BF7\8BB0\4F4F\FF0C\6709\4E9B\7528\6237\4F1A\4E3A\4E86\89E3\51B3\5B89\5168\95EE\9898\800C\7981\7528\6B64\529F\80FD\3002\5982\679C\8981\5728\6587\672C\4E2D\5305\542B\52A8\6001\5185\5BB9\FF0C\8BF7\4F7F\7528\66FF\6362\8BED\6CD5\FF0C\4F8B\5982 <code>&amp;P6_PRODUCT_NAME.</code>\3002</p>'),
unistr('<p>\5728\4F7F\7528 &lt;img /&gt; \6807\8BB0\5F15\7528\56FE\50CF\65F6\FF0C\8BF7\8BB0\4F4F\8FD9\4E9B\56FE\50CF\5FC5\987B\53EF\4F9B\6536\4EF6\4EBA\7684\7535\5B50\90AE\4EF6\5BA2\6237\673A\8BBF\95EE\FF0C\4EE5\4FBF\6536\4EF6\4EBA\80FD\591F\770B\5230\56FE\50CF\3002\4F8B\5982\FF0C\5047\8BBE\60A8\6309\5982\4E0B\6240\793A\5F15\7528\7F51\7EDC\4E0A\4E00\4E2A\540D\4E3A hello.gif \7684\56FE\50CF\FF1A</p>'),
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>\5728\6B64\793A\4F8B\4E2D\FF0C\6B64\56FE\50CF\672A\9644\52A0\5230\7535\5B50\90AE\4EF6\FF0C\800C\662F\5728\7535\5B50\90AE\4EF6\4E2D\5F15\7528\3002\6536\4EF6\4EBA\82E5\8981\770B\5230\6B64\56FE\50CF\FF0C\5FC5\987B\80FD\591F\4F7F\7528 Web \6D4F\89C8\5668\8BBF\95EE\5B83\3002\5982\679C\6B64\56FE\50CF\4F4D\4E8E\9632\706B\5899\5185\90E8\FF0C\800C\6536\4EF6\4EBA\4F4D\4E8E\9632\706B\5899\5916\90E8\FF0C\5219\4E0D\4F1A\663E\793A\6B64\56FE\50CF\3002\56E0\6B64\FF0C\8BF7\907F\514D\4F7F\7528\56FE\50CF\3002\5982\679C\5FC5\987B\5305\542B\56FE\50CF\FF0C\8BF7\786E\4FDD\5305\542B ALT \5C5E\6027\FF0C\4EE5\4FBF\5728\56FE\50CF\4E0D\53EF\8BBF\95EE\65F6\63D0\4F9B\6587\672C\8BF4\660E\3002</p>'),
unistr('<p><em>\6CE8\FF1ASMTP/MIME \89C4\8303\89C4\5B9A\4EFB\4F55\5355\4E2A\884C\7684\957F\5EA6\90FD\4E0D\80FD\8D85\8FC7 1000 \4E2A\5B57\7B26\3002\4E3A\4E86\9075\5B88\6B64\9650\5236\FF0C\5FC5\987B\6DFB\52A0\4E00\4E2A\56DE\8F66\7B26\6216\6362\884C\7B26\FF0C\5C06\6587\672C\62C6\5206\4E3A\957F\5EA6\4E0D\8D85\8FC7 1000 \4E2A\5B57\7B26\7684\82E5\5E72\5757\3002\5982\679C\4E0D\8FD9\6837\505A\FF0C\5219\4F1A\5BFC\81F4\7535\5B50\90AE\4EF6\4E0D\6B63\786E\FF0C\8BF8\5982\90AE\4EF6\4E2D\53EA\5305\542B\90E8\5206\5185\5BB9\6216\51FA\73B0\65E0\5173\7684\611F\53F9\53F7\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\9644\4EF6 SQL')
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL \8BED\53E5\5FC5\987B\91C7\7528\4EE5\4E0B\683C\5F0F\FF1A</p>'),
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>\5217 mime_type \548C content_id \662F\53EF\9009\7684\3002\5982\679C\5B58\5728 content_id\FF0C\5219\5C06\4EE5\5185\5D4C\65B9\5F0F\9644\52A0\8BE5\6587\4EF6\FF0Ccontent_id \7684\503C\5C06\7528\4E8E\9644\4EF6\7684 CID\3002</p>'),
unistr('<p>\5982\679C content_id \5217\5305\542B\503C ''my_inline_content''\FF0C\5219\53EF\4EE5\4F7F\7528\4EE5\4E0B HTML \5C06\8BE5\56FE\50CF\5D4C\5165\5230\7535\5B50\90AE\4EF6\4E2D\FF1A</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
unistr('&nbsp;&nbsp;&lt;h1&gt;\4E00\4E9B\5D4C\5165\5F0F\5185\5BB9&lt;/h1&gt;'),
'&nbsp;&nbsp;&lt;p&gt;',
unistr('&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="\5185\5D4C\56FE\50CF" &gt;'),
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\7528\4E8E\8FD4\56DE\4E00\4E2A\6216\591A\4E2A BLOB \7684 SQL \8BED\53E5\FF0C\8FD9\4E9B BLOB \4F5C\4E3A\6587\4EF6\9644\52A0\5230\7535\5B50\90AE\4EF6\3002</p>'),
unistr('<p>\5982\679C content_id \5217\5305\542B\7A7A\503C\FF0C\5219\5173\8054\7684\6587\4EF6\5C06\4E3A\5E38\89C4\9644\4EF6\3002\6587\4EF6\FF08\4F8B\5982\6587\6863\6216 zip \5F52\6863\6587\4EF6\FF09\901A\5E38\4EE5\8FD9\79CD\65B9\5F0F\9644\52A0\3002</p>'),
unistr('<p>\5982\679C content_id \7684\503C\4E0D\662F\7A7A\503C\FF0C\5219\5173\8054\7684\6587\4EF6\5C06\6807\8BB0\4E3A\5185\5D4C\9644\52A0\3002content_id \5217\7684\503C\5C06\7528\4F5C\9644\4EF6\7684 CID\FF08\5185\5BB9 ID\FF09\3002\6B64 CID \503C\53EF\7528\4E8E\7535\5B50\90AE\4EF6\7684 HTML \4EE3\7801\4E2D\FF0C\4EE5\4FBF\5C06\56FE\50CF\76F4\63A5\5D4C\5165\5230\7535\5B50\90AE\4EF6\5185\5BB9\4E2D\3002\8BF7\6CE8\610F\FF0C\6709\4E9B\7535\5B50\90AE\4EF6\5BA2\6237\673A\65E0\6CD5\81EA\52A8\663E\793A\5185\5D4C\9644\4EF6\3002\53E6\8BF7\6CE8\610F\FF0C\7535\5B50\90AE\4EF6\6807\51C6\89C4\5B9A\4E86\5185\5BB9\6807\8BC6\7B26\683C\5F0F\7684\5404\79CD\8981\6C42\3002Oracle Application Express \4E0D\5F3A\5236\9075\5FAA\8FD9\4E9B\6807\51C6\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\7ACB\5373\53D1\9001')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\7ACB\5373\53D1\9001\6B64\7535\5B50\90AE\4EF6\3002\8FD9\8FD8\5C06\53D1\9001\5F53\524D\4F4D\4E8E &PRODUCT_NAME. \7535\5B50\90AE\4EF6\961F\5217\8868\4E2D\7684\6240\6709\7535\5B50\90AE\4EF6\3002\9ED8\8BA4\60C5\51B5\4E0B, &PRODUCT_NAME. \5C06\672A\53D1\9001\7684\7535\5B50\90AE\4EF6\5B58\50A8\5728\4E00\4E2A\8868\4E2D, \5E76\5B9A\671F\4F20\9001\8FD9\4E9B\7535\5B50\90AE\4EF6\4EE5\63D0\9AD8\7CFB\7EDF\6027\80FD\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>unistr('\7535\5B50\90AE\4EF6\6A21\677F')
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8981\4F7F\7528\7684\7535\5B50\90AE\4EF6\6A21\677F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>unistr('\5360\4F4D\7B26\503C')
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\6A21\677F\5360\4F4D\7B26\540D\79F0\4EE5\53CA\8981\66FF\6362\7684\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4417)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>unistr('\8BED\8A00\8986\76D6')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\6307\5B9A\4E86\8BED\8A00\4EE3\7801\FF0C\8FDB\7A0B\5C06\4ECE\6B64\8BED\8A00\7684\5E94\7528\7A0B\5E8F\7FFB\8BD1\4E2D\67E5\627E\6A21\677F\3002\5982\679C\4E0D\5B58\5728\7FFB\8BD1\FF0C\8FDB\7A0B\5C06\4F7F\7528\5E94\7528\7A0B\5E8F\7684\4E3B\8981\8BED\8A00\3002\652F\6301\66FF\6362\8BED\6CD5\3002</p>'),
unistr('<p>\652F\6301\8BED\8A00\4EE3\7801\5C42\6B21\3002\5982\679C\6307\5B9A\4E86\503C "fr-ca"\FF08\6CD5\8BED - \52A0\62FF\5927\FF09\FF0C\4F46\53EA\5B58\5728 "fr"\FF08\6CD5\8BED\FF09\7684\7FFB\8BD1\FF0C\5219\5C06\4F7F\7528\6B64\7FFB\8BD1\3002</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>unistr('\6587\4EF6\6D4F\89C8...')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\5E26\6709<em>\6D4F\89C8...</em> \6309\94AE\7684\6587\672C\5B57\6BB5\3002\7528\6237\4F7F\7528\201C\6D4F\89C8\201D\6309\94AE\53EF\4EE5\4ECE\672C\5730\6587\4EF6\7CFB\7EDF\4E2D\67E5\627E\5E76\4E0A\8F7D\6587\4EF6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>unistr('\5B58\50A8\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5B58\50A8\5DF2\4E0A\8F7D\6587\4EF6\7684\6570\636E\5E93\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7528\9879\6E90\5C5E\6027\6307\5B9A\7684 BLOB \5217')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('\5C06\5DF2\4E0A\8F7D\6587\4EF6\5B58\50A8\5728\7531<strong>\81EA\52A8\884C\5904\7406 (DML)</strong> \5904\7406\4F7F\7528\7684\8868\53CA\7528\9879\6E90\5C5E\6027\6307\5B9A\7684\5217\4E2D\3002\8BE5\5217\5FC5\987B\4E3A BLOB \6570\636E\7C7B\578B\3002\5982\679C\5DF2\4E0B\8F7D\6587\4EF6, \5219\5C06\4F7F\7528<strong>\81EA\52A8\884C\63D0\53D6</strong>\5904\7406\7684\8868\540D\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8868 APEX_APPLICATION_TEMP_FILES')
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C06\5DF2\4E0A\8F7D\6587\4EF6\5B58\50A8\5728\53EF\901A\8FC7\89C6\56FE APEX_APPLICATION_TEMP_FILES \8BBF\95EE\7684\4E34\65F6\4F4D\7F6E\4E2D\3002&PRODUCT_NAME. \5C06\5728\4F1A\8BDD\7ED3\675F\65F6\6216\4E0A\8F7D\8BF7\6C42\7ED3\675F\65F6\81EA\52A8\5220\9664\6587\4EF6, \5177\4F53\53D6\51B3\4E8E\60A8\4E3A<strong>\6587\4EF6\6E05\9664\4F4D\7F6E</strong>\9009\62E9\7684\5185\5BB9\3002</p>'),
unistr('<p>\5728<strong>\5141\8BB8\591A\4E2A\6587\4EF6</strong>\8BBE\7F6E\4E3A<strong>\5426</strong>\7684\60C5\51B5\4E0B\8BBF\95EE\6587\4EF6:</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
' where name = :<em>page item name</em>;',
'</pre>',
unistr('<p>\5728<strong>\5141\8BB8\591A\4E2A\6587\4EF6</strong>\8BBE\7F6E\4E3A<strong>\662F</strong>\7684\60C5\51B5\4E0B\8BBF\95EE\6587\4EF6:</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
'                        p_str => :<em>page item name</em>,',
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
unistr('        -- \5728\6B64\5904\6DFB\52A0\4EE3\7801, \5C06\4E0A\8F7D\7684\6587\4EF6\5B58\50A8\5728\60A8\81EA\5DF1\7684\8868\4E2D'),
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\8868 WWV_FLOW_FILES')
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5C06\5DF2\4E0A\8F7D\6587\4EF6\5B58\50A8\5728 &PRODUCT_NAME. \8868 <code>WWV_FLOW_FILES</code> \4E2D\3002</p>'),
unistr('<p>\8981\8BBF\95EE\8BE5\6587\4EF6, \8BF7\4F7F\7528:</p>'),
'<pre>',
'select *',
'  from wwv_flow_files',
' where name = :<em>page item name</em>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>unistr('MIME \7C7B\578B\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\50A8\5DF2\4E0A\8F7D\6587\4EF6\7684 mime \7C7B\578B\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002\4E0B\8F7D\6587\4EF6\540E, \6D4F\89C8\5668\4F7F\7528 mime \7C7B\578B\786E\5B9A\5E94\4F7F\7528\54EA\4E2A\5E94\7528\7A0B\5E8F\6765\663E\793A BLOB \7684\5185\5BB9\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>unistr('\6587\4EF6\540D\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\50A8\5DF2\4E0A\8F7D\6587\4EF6\7684\6587\4EF6\540D\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>unistr('\5B57\7B26\96C6\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\50A8\5DF2\4E0A\8F7D\6587\4EF6\7684\5B57\7B26\96C6\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002BLOB \7684\5B57\7B26\96C6\4E0D\4F1A\5728\4E0A\8F7D\65F6\81EA\52A8\8BBE\7F6E\3002\6700\7EC8\7528\6237\5E94\4E3A\8981\4E0A\8F7D\7684\6587\6863\8BBE\7F6E\5B57\7B26\96C6\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('\4E0A\6B21\66F4\65B0\7684 BLOB \5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\50A8\4E0A\8F7D\6587\4EF6\65F6\7684\5F53\524D\65F6\95F4\6233\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002\6B64\65E5\671F\503C\7528\4E8E\6D4F\89C8\5668\9AD8\901F\7F13\5B58\3002')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>unistr('\663E\793A\4E0B\8F7D\94FE\63A5')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\6307\5B9A\5728\6B64\9879\5173\8054\6709\975E\7A7A BLOB \65F6\662F\5426\663E\793A\4E0B\8F7D\94FE\63A5\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>unistr('\4E0B\8F7D\94FE\63A5\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\8F93\5165\8981\663E\793A\4E3A\4E0B\8F7D\94FE\63A5\4E00\90E8\5206\7684\6587\672C\3002\5982\679C\672A\6307\5B9A, \5219\663E\793A\5728 <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code> \7684\201C\6587\672C\6D88\606F\201D(\4F4D\4E8E\5171\4EAB\7EC4\4EF6\4E2D) \4E2D\5B58\50A8\7684\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>unistr('\5185\5BB9\5904\7406')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\6D4F\89C8\5668\5982\4F55\5728\4E0B\8F7D\65F6\5904\7406\5185\5BB9\3002</p>'),
unistr('<p><em>\6CE8: \5E76\975E\6240\6709\5185\5BB9\90FD\53EF\4EE5\5185\5D4C\663E\793A\3002\662F\5426\652F\6301\5185\5BB9\5185\5D4C\663E\793A\53D6\51B3\4E8E\6D4F\89C8\5668\662F\5426\652F\6301\7279\5B9A\7684 mime \7C7B\578B\3002</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5185\5D4C')
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9644\4EF6')
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>unistr('\6587\4EF6\6E05\9664\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\5B9A\4E49 &PRODUCT_NAME. \5E94\4F55\65F6\5220\9664\4E34\65F6\6587\4EF6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\4F1A\8BDD\7ED3\675F')
,p_return_value=>'SESSION'
,p_help_text=>unistr('\5728\5F53\524D &PRODUCT_NAME. \4F1A\8BDD\7ED3\675F\65F6\5220\9664\6587\4EF6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\8BF7\6C42\7ED3\675F')
,p_return_value=>'REQUEST'
,p_help_text=>unistr('\5728\5F53\524D HTTP \8BF7\6C42\7ED3\675F\65F6\5220\9664\6587\4EF6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('\5141\8BB8\591A\4E2A\6587\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\6B21\662F\5426\53EF\4EE5\4E0A\8F7D\591A\4E2A\6587\4EF6\3002</p>'),
'',
unistr('<p>\6CE8 - \5728\9875\9879\4E2D\5C06\591A\4E2A\6587\4EF6\540D\5B58\50A8\4E3A\5192\53F7\5206\9694\7684\5217\8868\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>unistr('\6587\4EF6\7C7B\578B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dt>\6307\793A\5E94\4EC5\63A5\53D7\56FE\50CF\6587\4EF6</dt>'),
'<dd><pre>image/*</pre></dd>',
unistr('<dt>\6307\793A\5E94\4EC5\63A5\53D7\56FE\50CF\548C\89C6\9891\6587\4EF6</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
unistr('<dt>\6307\793A\5E94\4EC5\63A5\53D7 PNG \56FE\50CF\6587\4EF6</dt>'),
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>unistr('\6307\5B9A\6587\4EF6\7C7B\578B\7684\9017\53F7\5206\9694\5217\8868, \6D4F\89C8\5668\53EF\80FD\4F7F\7528\8FD9\4E9B\6587\4EF6\7C7B\578B\6765\9650\5236\53EF\4E0A\8F7D\54EA\4E9B\6587\4EF6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>unistr('\663E\793A\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\4E00\79CD\663E\793A\6837\5F0F\FF08\8868\793A\5E94\5982\4F55\663E\793A\6587\4EF6\6D4F\89C8\9879\FF09\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5185\5D4C\6587\4EF6\6D4F\89C8')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\663E\793A\4E0E\9875\4E0A\7684\5176\4ED6\6587\672C\5B57\6BB5\548C\9879\76F8\4F3C\7684\6587\4EF6\6D4F\89C8\8F93\5165\5B57\6BB5\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5185\5D4C\653E\7F6E\533A\57DF')
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('\5C06\6587\4EF6\6D4F\89C8\8F93\5165\5B57\6BB5\663E\793A\4E3A\5185\5D4C\653E\7F6E\533A\57DF\FF0C\5176\4E2D\5305\542B\6807\9898\548C\8BF4\660E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5757\653E\7F6E\533A\57DF')
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('\5C06\6587\4EF6\6D4F\89C8\8F93\5165\5B57\6BB5\663E\793A\4E3A\5411\5BFC\6837\5F0F\7684\653E\7F6E\533A\57DF\FF0C\5176\4E2D\5305\542B\6807\9898\548C\8BF4\660E\4EE5\53CA\7528\4E8E\9009\62E9\6587\4EF6\7684\6309\94AE\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\672C\673A\6587\4EF6\6D4F\89C8')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\4F7F\7528\6D4F\89C8\5668\7684\672C\673A\683C\5F0F\663E\793A\6587\4EF6\6D4F\89C8\9879\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('\653E\7F6E\533A\57DF\6807\9898')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3A\653E\7F6E\533A\57DF\6307\5B9A\6807\9898\3002'),
unistr('\5982\679C\6B64\5B57\6BB5\7559\7A7A\FF0C\5219\9ED8\8BA4\60C5\51B5\4E0B\5C06\4F7F\7528\6587\672C\6D88\606F <code>APEX.ITEM.FILE.DROP_FILE</code> \6216 <code>APEX.ITEM.FILE.DROP_FILES</code>\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('\653E\7F6E\533A\57DF\8BF4\660E')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4E3A\653E\7F6E\533A\57DF\6307\5B9A\8BF4\660E\6587\672C\3002</p>'),
unistr('<p>\5982\679C\6B64\5B57\6BB5\7559\7A7A\FF0C\5219\9ED8\8BA4\60C5\51B5\4E0B\5C06\4F7F\7528\4EE5\4E0B\6587\672C\6D88\606F\FF0C\5177\4F53\53D6\51B3\4E8E\201C\663E\793A\4E3A\201D\5C5E\6027\3002</p>'),
unistr('<p><strong>\5757\653E\7F6E\533A\57DF</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
unistr('<p><strong>\5185\5D4C\653E\7F6E\533A\57DF</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4417)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('\6700\5927\6587\4EF6\5927\5C0F')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'KB'
,p_is_translatable=>false
,p_help_text=>unistr('\4E3A\901A\8FC7\6B64\9879\4E0A\8F7D\7684\6587\4EF6\8F93\5165\5E94\63A5\53D7\7684\6700\5927\6587\4EF6\5927\5C0F (KB)\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>unistr('\5217\8868\7BA1\7406\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\4E00\4E2A\5E26\6709\5F39\51FA\5F0F\503C\5217\8868\56FE\6807, <em>\6DFB\52A0</em>\548C<em>\5220\9664</em>\6309\94AE\4EE5\53CA\6240\9009\503C\5217\8868\7684\6587\672C\9879\3002</p>'),
unistr('<p>\60A8\53EF\4EE5\952E\5165\503C\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002\7136\540E\53EF\4EE5\5229\7528\8FD9\4E9B\6309\94AE\7BA1\7406\6240\9009\503C\3002\6240\9009\503C\5B58\50A8\5728\5355\4E2A\5192\53F7\5206\9694\7684\5B57\7B26\4E32\4E2D\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4417)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\63D0\53D6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\6253\5F00\5F39\51FA\5F0F LOV \65F6\5982\4F55\663E\793A\6570\636E\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\4E0D\63D0\53D6')
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\63D0\53D6\7B2C\4E00\4E2A\884C\96C6')
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\63D0\53D6\7B2C\4E00\4E2A\884C\96C6\5E76\8FC7\6EE4\5F53\524D\503C')
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4417)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4FDD\7559\5927\5C0F\5199')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\4FDD\7559\8F93\5165\7684\503C\8FD8\662F\5C06\5176\8F6C\6362\4E3A\5927\5199\3002</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4417)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('\65E7\81EA\52A8\884C\5904\7406')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('\7528\4E8E\5728\5355\4E2A\6570\636E\5E93\8868\6216\53EF\66F4\65B0\89C6\56FE\4E2D\63D2\5165, \66F4\65B0\6216\5220\9664\8BB0\5F55\7684\5904\7406\3002\6B64\5904\7406\7528\4E8E\5904\7406\6E90\4E3A<strong>\6570\636E\5E93\5217</strong>\7C7B\578B\7684\8868\5355\9879\3002Oracle \5EFA\8BAE\5C06\6B64\5904\7406\7C7B\578B\66F4\65B0\4E3A<strong>\81EA\52A8\884C\5904\7406 (DML)</strong>\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4417)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\652F\6301\54EA\4E9B\6570\636E\64CD\7EB5\8BED\8A00 (DML) \64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\63D2\5165')
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\66F4\65B0')
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5220\9664')
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4417)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8868\6240\6709\8005')
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\8868\6240\6709\8005 (\65B9\6848) \7684\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4417)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8868\540D')
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4417)
,p_help_text=>unistr('\8F93\5165\533A\5206\5927\5C0F\5199\7684\8868\6216\89C6\56FE\540D\79F0\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4417)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('\4E3B\952E\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\5B58\653E\4E3B\952E\5217\503C\7684\9875\6216\5E94\7528\7A0B\5E8F\9879\3002\60A8\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\5217\8868\4E2D\9009\53D6\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4417)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>unistr('\4E3B\952E\5217')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4417)
,p_help_text=>unistr('\9009\62E9\5305\542B\4E3B\952E\503C\7684\5217\3002\5982\679C\8868\7684\4E3B\952E\5305\542B\591A\4E2A\90E8\5206, \5219\9009\62E9 <strong>ROWID</strong>\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4417)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\8FD0\884C\65F6 Where \5B50\53E5')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9650\5236\90E8\95E8:</p>'),
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('\8F93\5165\5C06\9644\52A0\5230\751F\6210\7684\6240\6709 SELECT, UPDATE \548C DELETE \8BED\53E5\7684 SQL WHERE \5B50\53E5\3002\4F7F\7528\6B64\5C5E\6027\53EF\9650\5236\5728\81EA\52A8\751F\6210\7684 SQL \8C03\7528\4E2D\4F7F\7528\7684\8BB0\5F55\3002')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>unistr('\53D6\6D88\4E8B\4EF6')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\53D6\6D88\5F53\524D\4E8B\4EF6\3002')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>unistr('\65E5\671F\9009\53D6\5668 (jQuery)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\4E00\4E2A\5E26\6709\65E5\5386\56FE\6807\7684\6587\672C\5B57\6BB5\3002\6700\7EC8\7528\6237\53EF\4EE5\5C06\65E5\671F\76F4\63A5\8F93\5165\5230\6587\672C\9879, \4E5F\53EF\4EE5\5355\51FB\65E5\5386\56FE\6807\4ECE\5F39\51FA\5F0F\65E5\5386\4E2D\9009\62E9\65E5\671F\5E76\9009\62E9\6027\5730\9009\62E9\65F6\95F4\3002</p>'),
unistr('<p>\4EC5\5F53\6B64\9879\7684<em>\683C\5F0F\63A9\7801</em>\5305\542B\65F6\95F4\7EC4\4EF6\65F6, \624D\4F1A\5728\5F39\51FA\5F0F\65E5\5386\4E2D\663E\793A\65F6\95F4\3002</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7A81\51FA\663E\793A\7684\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8C03\7528\5F39\51FA\5F0F\65E5\5386\65F6\8981\7A81\51FA\663E\793A\7684\9ED8\8BA4\65E5\671F\503C\3002\5982\679C\672A\6307\5B9A, \5219\65E5\5386\5C06\7A81\51FA\663E\793A\5F53\524D\65E5\671F\548C\65F6\95F4\3002</p>'),
unistr('<p>\6B64\503C\53EF\4EE5\662F <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7EDD\5BF9\503C, \6216\76F8\5BF9\4E8E\4ECA\5929\65E5\671F\7684\76F8\5BF9\503C (\4F8B\5982 <code>+7d</code>), \6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C (\5047\5B9A\66FF\6362\9879\8FD4\56DE\6B63\786E\7684\65E5\671F\683C\5F0F\6216\76F8\5BF9\503C)\3002</p>'),
unistr('<p>\76F8\5BF9\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5468\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5929\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6700\5C0F\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\53EF\4EE5\8F93\5165\6216\9009\62E9\7684\6700\5C0F\65E5\671F\3002</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7EDD\5BF9\503C, \6216\76F8\5BF9\4E8E\4ECA\5929\65E5\671F\7684\76F8\5BF9\503C (\4F8B\5982 <code>+7d</code>), \6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C (\5047\5B9A\66FF\6362\9879\8FD4\56DE\6B63\786E\7684\65E5\671F\683C\5F0F\6216\76F8\5BF9\503C)\3002</p>'),
unistr('<p>\76F8\5BF9\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5468\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5929\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6700\5927\65E5\671F')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\53EF\4EE5\8F93\5165\6216\9009\62E9\7684\6700\5927\65E5\671F\3002</p>'),
unistr('<p>\65E5\671F\503C\53EF\4EE5\662F <code>''YYYY-MM-DDTHH24:MI:SS''</code> \6216 <code>''YYYYMMDDHH24MI''</code> \683C\5F0F\7684\7EDD\5BF9\503C, \6216\76F8\5BF9\4E8E\4ECA\5929\65E5\671F\7684\76F8\5BF9\503C (\4F8B\5982 <code>+7d</code>), \6216\4F7F\7528\66FF\6362\8BED\6CD5\7684\52A8\6001\503C (\5047\5B9A\66FF\6362\9879\8FD4\56DE\6B63\786E\7684\65E5\671F\683C\5F0F\6216\76F8\5BF9\503C)\3002</p>'),
unistr('<p>\76F8\5BF9\65E5\671F\503C\5305\62EC:</p>'),
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5E74\6570</dd>'),
'  <dt>m</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\6708\6570</dd>'),
'  <dt>w</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5468\6570</dd>'),
'  <dt>d</dt>',
unistr('    <dd>+ / - \8DDD\4ECA\5929\65E5\671F\7684\5929\6570</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\663E\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\4F55\65F6\663E\793A\65E5\671F\9009\53D6\5668\7684\5F39\51FA\5F0F\65E5\5386\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\83B7\5F97\7126\70B9\65F6')
,p_return_value=>'focus'
,p_help_text=>unistr('\5728\9879\83B7\5F97\7126\70B9\4E4B\540E\7ACB\5373\663E\793A\5F39\51FA\5F0F\65E5\5386\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5355\51FB\56FE\6807\65F6')
,p_return_value=>'button'
,p_help_text=>unistr('\5355\51FB\56FE\6807\65F6\663E\793A\5F39\51FA\5F0F\65E5\5386\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\4E8C\8005')
,p_return_value=>'both'
,p_help_text=>unistr('\5728\9879\83B7\5F97\7126\70B9\5E76\968F\540E\5355\51FB\56FE\6807\65F6, \7ACB\5373\663E\793A\5F39\51FA\5F0F\65E5\5386\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\5185\5D4C')
,p_return_value=>'inline'
,p_help_text=>unistr('\65E5\5386\59CB\7EC8\5185\5D4C\663E\793A\5728\9875\4E0A\3002\4E0D\663E\793A\6587\672C\5B57\6BB5, \5E76\4E14\5F53\524D\65E5\671F\9009\62E9\7A81\51FA\663E\793A\5728\65E5\5386\4E2D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\663E\793A\5176\4ED6\6708')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\663E\793A\4E0A\4E00\6708\7684\6700\540E\51E0\5929\65E5\671F\548C\4E0B\4E00\6708\7684\524D\51E0\5929\65E5\671F\3002\6700\540E\51E0\5929\65E5\671F\548C\524D\51E0\5929\65E5\671F\5B8C\5168\586B\5145\65E5\5386\7684\7B2C\4E00\884C\548C\6700\540E\4E00\884C\3002\4F8B\5982, \5982\679C\4E00\5468\7684\7B2C\4E00\5929\662F\661F\671F\65E5, \5E76\4E14\663E\793A\7684\5F53\524D\6708\7684\7B2C\4E00\5929\662F\661F\671F\4E09, \5219\661F\671F\65E5, \661F\671F\4E00\548C\661F\671F\4E8C\4F1A\663E\793A\4E0A\4E00\6708\7684\6700\540E\4E09\5929\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6708\6570')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
unistr('    <dd>\6C34\5E73\663E\793A\4E09\4E2A\6708\3002</dd>'),
'  <dt>[2,3]</dt>',
unistr('    <dd>\663E\793A\516D\4E2A\6708, \4E24\884C\4E09\5217\3002</dd>'),
'  <dt>[4,3]</dt>',
unistr('    <dd>\663E\793A\5341\4E8C\4E2A\6708, \56DB\884C\4E09\5217\3002</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\5F39\51FA\5F0F\65E5\5386\4E2D\663E\793A\7684\6708\6570\3002</p>'),
unistr('<p>\53EF\4EE5\8F93\5165\4E00\4E2A\6574\6570\503C\6216\4F7F\7528 <code>[<em>row,column</em>]</code> \7684\4E8C\7EF4\6570\7EC4, \4EE5\5B9A\4E49\8981\663E\793A\7684\884C\6570\548C\5217\6570</p>'),
unistr('<p><em>\6CE8: \663E\793A<strong>\7A81\51FA\663E\793A\7684\65E5\671F</strong>\4E4B\540E\7684\6708\4EFD\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\4EE5\4E0B\9879\7684\5BFC\822A\5217\8868')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\662F\5426\5728\5F39\51FA\5F0F\65E5\5386\5185\4E3A\6708\548C/\6216\5E74\63D0\4F9B\9009\62E9\5217\8868\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6708')
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5E74')
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\6708\548C\5E74')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4417)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5E74\8303\56F4')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>\4F7F\7528\7EDD\5BF9\5E74\4EFD\4EE5\5C06\5141\8BB8\7684\5E74\4EFD\9650\5236\5230 2000 \548C 2010 \4E4B\95F4 (\542B)\3002</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>\4F7F\7528\76F8\5BF9\65E5\671F\4EE5\5C06\5141\8BB8\7684\5E74\4EFD\9650\5236\5230\5F53\524D\5E74\7684\524D\540E\4E94\5E74\3002</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>\4F7F\7528\76F8\5BF9\65E5\671F\4EE5\5C06\5141\8BB8\7684\5E74\4EFD\9650\5236\5230\63A5\4E0B\6765\4E24\5E74\7684\4E0B\4E00\5E74\3002</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5F39\51FA\5F0F\65E5\5386\5185<strong>\5E74</strong>\9009\62E9\5217\8868\4E2D\663E\793A\7684\5141\8BB8\5E74\4EFD\8303\56F4\3002</p>'),
unistr('<p>\5E74\4EFD\503C\53EF\4EE5\662F <code>''YYYY:YYYY''</code> \683C\5F0F\7684\7EDD\5BF9\503C\6216\4F7F\7528 <code>''-nn:+nn''</code> \683C\5F0F\7684\76F8\5BF9\503C, \5176\4E2D <code>nn</code> \662F\6574\6570\503C\3002')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>unistr('\6587\672C\5B57\6BB5')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\663E\793A\6587\672C\5B57\6BB5\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4417)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\6309 Enter \65F6\63D0\4EA4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\5728\6B64\5B57\6BB5\4E2D\65F6\6309 <em>Enter</em> \952E\662F\5426\4F1A\81EA\52A8\63D0\4EA4\9875\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4417)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\5DF2\7981\7528')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\7981\7528\6B64\9879, \8FD9\53EF\4EE5\9632\6B62\6700\7EC8\7528\6237\66F4\6539\503C\3002</p>'),
unistr('<p>\4E0E\5220\9664 HTML \683C\5F0F\7684<em>\4EC5\663E\793A</em>\9879\7C7B\578B\4E0D\540C, \7981\7528\7684\6587\672C\9879\4ECD\4F7F\7528\76F8\540C\7684 HTML \683C\5F0F\663E\793A\3002\7981\7528\7684\6587\672C\9879\662F\9875\6E90\7684\4E00\90E8\5206, \5141\8BB8\8BC4\4F30\5176\4F1A\8BDD\72B6\6001\3002\76F8\53CD, \4F1A\8BDD\72B6\6001\4E2D\4E0D\5B58\50A8\4EC5\663E\793A\9879\3002</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4417)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('\63D0\4EA4\9875\65F6\53D1\9001')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\63D0\4EA4\9875\65F6\53D1\9001\5F53\524D\9879\503C\3002')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4417)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>unistr('\5B50\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\9009\62E9 HTML5 \6587\672C\5B50\7C7B\578B\3002\8FD9\4F7F\5177\6709\5C4F\4E0A\952E\76D8\7684\8BBE\5907\53EF\4EE5\663E\793A\7279\5B9A\4E8E\5B50\7C7B\578B\7684\4F18\5316\952E\76D8\5E03\5C40, \4EE5\65B9\4FBF\8F93\5165\6570\636E\3002\5728\9875\9879\503C\4EE5\53EA\8BFB\65B9\5F0F\5448\73B0\65F6, \5B50\7C7B\578B\7684\9009\62E9\8FD8\7528\4E8E\4F7F\7528\9875\9879\503C\5448\73B0\5408\9002\94FE\63A5\3002\4F7F\7528\7269\7406\952E\76D8\65F6, \6B64\5C5E\6027\4E0D\4F1A\66F4\6539\6587\672C\9879\6216\6570\636E\6761\76EE\3002'),
'</p>',
unistr('<p><strong><em>\6CE8:</strong> \6B64 HTML5 \529F\80FD\4EC5\5728\65B0\578B\6D4F\89C8\5668\4E2D\53EF\7528\3002\4E0E HTML5 \4E0D\517C\5BB9\7684\65E7\6D4F\89C8\5668\5C06\5FFD\7565\6B64\5C5E\6027\5E76\5C06\9875\9879\4F5C\4E3A\666E\901A\6587\672C\5B57\6BB5\5448\73B0\3002</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\6587\672C')
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7535\5B50\90AE\4EF6')
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\7535\8BDD\53F7\7801')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4417)
,p_display_sequence=>25
,p_display_value=>unistr('\641C\7D22')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4417)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4417)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>unistr('\622A\53D6\7A7A\683C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\63D0\4EA4\9875\540E\5982\4F55\622A\53D6\9879\503C\3002\6B64\8BBE\7F6E\5C06\4ECE\8F93\5165\7684\6587\672C\4E2D\622A\53D6\7A7A\683C, \5236\8868\7B26\548C\6362\884C\7B26\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\524D\5BFC')
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5C3E\968F')
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\524D\5BFC\548C\5C3E\968F')
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4417)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('\6587\672C\5927\5C0F\5199')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('\65E0\66F4\6539')
,p_help_text=>unistr('\9009\62E9\9879\503C\6587\672C\5927\5C0F\5199\7684\8F6C\6362\65B9\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5C0F\5199')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5927\5199')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>unistr('\9690\85CF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5305\62EC\5728\9875\6E90\5185\4F46\672A\5448\73B0\7684\9879\3002\9690\85CF\7684\9879\503C\4FDD\5B58\5728\4F1A\8BDD\72B6\6001\4E2D\3002\5B83\4EEC\901A\5E38\7528\4E8E\5B58\50A8\9875\5904\7406\6216\5176\4ED6\9875\9879\6240\9700\7684\503C, \4F46\4E0D\5E94\663E\793A\7ED9\6700\7EC8\7528\6237\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4417)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\503C\53D7\4FDD\62A4')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\4FDD\62A4\9879, \4EE5\7981\6B62\5728\6295\9012\9875\65F6\64CD\7EB5\503C\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>unistr('\663E\793A\56FE\50CF')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\5B58\50A8\5728\6570\636E\5E93 BLOB \5217\4E2D\7684\56FE\50CF\6216\57FA\4E8E\56FE\50CF URL \663E\793A\56FE\50CF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\57FA\4E8E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\4F55\5904\68C0\7D22\56FE\50CF\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5B58\50A8\5728\9875\9879\503C\4E2D\7684\56FE\50CF URL')
,p_return_value=>'URL'
,p_help_text=>unistr('\4ECE\5B58\50A8\5728\6307\5B9A\9875\9879\7684\4F1A\8BDD\72B6\6001\4E2D\7684\503C\8BFB\53D6\56FE\50CF URL\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\7528\9879\6E90\6307\5B9A\7684 BLOB \5217')
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('\4ECE<strong>\9879\6E90</strong>\5C5E\6027\4E2D\6307\5B9A\7684 BLOB \5217\8BFB\53D6\56FE\50CF\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\7531 SQL \8BED\53E5\8FD4\56DE\7684 BLOB \5217')
,p_return_value=>'SQL'
,p_help_text=>unistr('\6839\636E\6307\5B9A\7684 SQL \8BED\53E5\8FD4\56DE\7684 BLOB \5217\663E\793A\56FE\50CF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\66FF\4EE3\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>unistr('\8F93\5165\5728\6700\7EC8\7528\6237\5BFC\822A\5230\6B64\9879\65F6\7531\5C4F\5E55\9605\8BFB\5668\8BFB\53D6\7684\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\66FF\4EE3\6587\672C\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\5B58\653E\6B64\56FE\50CF\7684\66FF\4EE3\6587\672C\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002\5F53\6700\7EC8\7528\6237\5BFC\822A\5230\6B64\9879\65F6, \5C4F\5E55\9605\8BFB\5668\4F1A\8BFB\53D6\6B64\6587\672C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6587\4EF6\540D\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\5B58\653E\4E0E BLOB \5217\76F8\5173\8054\7684\6587\4EF6\540D\5217\503C\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\4E0A\6B21\66F4\65B0\7684 BLOB \5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5B58\653E\4E0A\6B21\66F4\65B0\6240\5173\8054 BLOB \65F6\7684\65E5\671F\5217\503C\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002</p>'),
unistr('<p>\6B64\503C\7528\4E8E\6D4F\89C8\5668\9AD8\901F\7F13\5B58, \5E76\786E\5B9A\81EA\6D4F\89C8\5668\4E0A\6B21\53D1\51FA\8BF7\6C42\4EE5\6765\56FE\50CF\662F\5426\5DF2\66F4\6539\3002\5982\679C\672A\66F4\65B0\56FE\50CF, \5219\4ECE\6D4F\89C8\5668\9AD8\901F\7F13\5B58\68C0\7D22\56FE\50CF (\5982\679C\53EF\7528)\3002</p>')))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>unistr('SQL \8BED\53E5')
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>unistr('\8F93\5165 SQL \8BED\53E5\7528\4E8E\8FD4\56DE\5305\542B\56FE\50CF\7684 BLOB \5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4417)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>unistr('MIME \7C7B\578B\5217')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('\8F93\5165\7528\4E8E\5B58\50A8\5DF2\4E0A\8F7D\6587\4EF6\7684 mime \7C7B\578B\7684\5927\5199\9875\6216\5E94\7528\7A0B\5E8F\9879\540D\79F0\3002\4E0B\8F7D\6587\4EF6\540E, \6D4F\89C8\5668\4F7F\7528 mime \7C7B\578B\786E\5B9A\5E94\4F7F\7528\54EA\4E2A\5E94\7528\7A0B\5E8F\6765\663E\793A BLOB \7684\5185\5BB9\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('\5E26\81EA\52A8\5B8C\6210\529F\80FD\7684\6587\672C\5B57\6BB5')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\5185\5D4C\5230\6587\672C\9879\7684\6587\672C\5B57\6BB5, \6B64\5B57\6BB5\57FA\4E8E\6700\7EC8\7528\6237\5DF2\8F93\5165\7684\6587\672C\663E\793A\53EF\80FD\503C\7684\5217\8868\3002\968F\7740\6700\7EC8\7528\6237\952E\5165\66F4\591A\6587\672C, \6B64\5217\8868\4F1A\8FDB\4E00\6B65\7EC6\5316\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\641C\7D22')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\5982\4F55\9488\5BF9\8F93\5165\7684\503C\6267\884C\641C\7D22\3002\4F7F\7528<em>\5EF6\8FDF\52A0\8F7D</em>\65F6, \6B64\8BBE\7F6E\4F1A\5BF9\67E5\8BE2\6027\80FD\4EA7\751F\5F71\54CD\3002</p>'),
unistr('<p><em>\6CE8: \9009\62E9<strong>\5305\542B\4E14\533A\5206\5927\5C0F\5199</strong>\6216<strong>\5305\542B\4E14\5FFD\7565\5927\5C0F\5199</strong>\65F6\5C06\7981\6B62\4F7F\7528\5217\7D22\5F15\3002</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5305\542B\4E14\533A\5206\5927\5C0F\5199')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168\5339\914D\4E14\533A\5206\5927\5C0F\5199')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5305\542B\4E14\5FFD\7565\5927\5C0F\5199')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\5B8C\5168\5339\914D\4E14\5FFD\7565\5927\5C0F\5199')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5EF6\8FDF\52A0\8F7D')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\4F7F\7528<em>\5EF6\8FDF\52A0\8F7D</em>\6280\672F\4ECE\6570\636E\5E93\68C0\7D22\5339\914D\7684\503C\3002\5EF6\8FDF\52A0\8F7D\4F1A\5728\6BCF\6B21\7528\6237\952E\5165\5B57\7B26\65F6\4ECE\6570\636E\5E93\68C0\7D22\5339\914D\7684\8BB0\5F55\3002\5426\5219, \4F1A\5728\52A0\8F7D\9875\65F6\52A0\8F7D\6240\6709\5217\8868\503C\3002</p>'),
unistr('<p>\5F53\60A8\5177\6709\5927\7684\9009\62E9\5217\8868\65F6, Oracle \5EFA\8BAE\4F7F\7528<em>\5EF6\8FDF\52A0\8F7D</em>, \56E0\4E3A\52A0\8F7D\5927\91CF\8BB0\5F55\53EF\80FD\4F1A\5F71\54CD\6700\521D\52A0\8F7D\9875\7684\65F6\95F4\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5217\8868\4E2D\7684\6700\5927\503C')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\8981\5728\9009\62E9\6846\4E2D\663E\793A\7684\9879\7684\6700\5927\6570\76EE\3002</p> '),
unistr('<p>\6B64\503C\53EF\4EE5\5E2E\52A9\907F\514D\5728\8FD4\56DE\592A\591A\884C\65F6\51FA\73B0\6027\80FD\95EE\9898, \8FD8\53EF\4EE5\5728\4EC5\8F93\5165\4E86\51E0\4E2A\5B57\6BCD\65F6\9632\6B62\51FA\73B0\975E\5E38\5927\7684\8FD4\56DE\96C6\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\6700\5C11\641C\7D22')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>unistr('\5B57\7B26')
,p_is_translatable=>false
,p_help_text=>unistr('<p>\6307\5B9A\5728\6267\884C\641C\7D22\4E4B\524D\5FC5\987B\8F93\5165\7684\6700\5C0F\5B57\7B26\6570\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>unistr('\9AD8\901F\7F13\5B58')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>\6307\5B9A\5728\4F7F\7528\5EF6\8FDF\52A0\8F7D\68C0\7D22\5339\914D\8BB0\5F55\65F6\662F\5426\9AD8\901F\7F13\5B58\641C\7D22\7ED3\679C\3002</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\5728\9875\9879\4E2D\663E\793A\5E76\5B58\50A8\540C\4E00\503C</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
unistr('<dt>\4F7F\7528\7ED1\5B9A\53D8\91CF\663E\793A\7279\5B9A\90E8\95E8\7684\96C7\5458</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4417)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4417)
,p_name=>'ojupdate'
,p_display_name=>unistr('\66F4\65B0')
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>unistr('\591A\4FE1\606F\6587\672C\7F16\8F91\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\5E26\6709\5168\9762\7684\6587\672C\683C\5F0F\9009\9879\7684\6587\672C\533A\57DF\3002\6700\7EC8\7528\6237\53EF\4EE5\589E\5F3A\4EE5\7C7B\4F3C\65B9\5F0F\663E\793A\7684\5185\5BB9\4EE5\4F7F\7528\5B57\5904\7406\5668, \4F8B\5982 Microsoft Word\3002\6700\7EC8\7528\6237\8FD8\53EF\4EE5\5728\6B64\9879\4E2D<em>\526A\5207\548C\7C98\8D34</em>\591A\4FE1\606F\6587\672C\683C\5F0F (RTF) \6587\4EF6\683C\5F0F\7684\6587\6863\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\54CD\5E94 [\5DF2\8FC7\65F6]')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\591A\4FE1\606F\6587\672C\7F16\8F91\5668\662F\5426\5E94\81EA\52A8\8C03\6574\5230\5BB9\5668\533A\57DF\5927\5C0F\3002\8FD9\9700\8981\5E94\7528\7A0B\5E8F\4F7F\7528\901A\7528\4E3B\9898\6216\5176\4ED6\54CD\5E94\5F0F\4E3B\9898\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5DE5\5177\680F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\7F16\8F91\5668\5185\53EF\7528\7684\6587\672C\683C\5F0F\9009\9879\7684\6570\76EE\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\57FA\672C')
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4E2D\95F4')
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5DE5\5177\680F\5DF2\5C55\5F00')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('\6307\5B9A\6700\521D\662F\5426\5728\6587\672C\533A\57DF\5185\5C55\5F00\7F16\8F91\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5916\89C2')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\7528\4E8E\8BBE\7F6E\7F16\8F91\5668\6837\5F0F\7684\7F16\8F91\5668\5916\89C2\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4417)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4417)
,p_display_sequence=>2
,p_display_value=>unistr('Moono \989C\8272')
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4417)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\5DE5\5177\680F\4F4D\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\5728\6587\672C\533A\57DF\4E2D\7684\4EC0\4E48\4F4D\7F6E\663E\793A\7F16\8F91\5668\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9876\90E8')
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5E95\90E8')
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>unistr('\7248\672C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CK Editor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4 \5DF2\8FC7\65F6\FF0C\5F88\5FEB\5C06\88AB CKEditor 5 \66FF\4EE3\3002\7ACB\5373\8FDB\884C\8FD9\4E00\5207\6362\662F\4E00\4E2A\4E0D\9519\7684\4E3B\610F\FF0C\4EE5\514D\60A8\7684\5E94\7528\7A0B\5E8F\5728\5C06\6765\7684\7248\672C\4E2D\6709\88AB\4E2D\65AD\7684\98CE\9669\3002\5982\679C\60A8\4F7F\7528\4E86\4EFB\4F55\5B9A\5236\521D\59CB\5316 Javascript \4EE3\7801\FF0C\8BF7\6CE8\610F\FF0CCKEditor \7684 API \5DF2\66F4\6539\FF0C\60A8\7684\4EE3\7801\5F88\6709\53EF\80FD\9700\8981\8FDB\884C\8C03\6574\3002</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4417)
,p_display_sequence=>10
,p_display_value=>unistr('CK Editor 4 [\5DF2\8FC7\65F6]')
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6700\5C0F\9AD8\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\8BBE\7F6E\53EF\7F16\8F91\533A\57DF\7684\6700\5C0F\9AD8\5EA6\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\6700\5927\9AD8\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\8BBE\7F6E\53EF\7F16\8F91\533A\57DF\7684\6700\5927\9AD8\5EA6\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002\5C06\6B64\5C5E\6027\7559\7A7A\5C06\4F7F\7F16\8F91\5668\968F\7740\60A8\7684\952E\5165\800C\65E0\9650\589E\5927\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>unistr('\683C\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\5728\591A\4FE1\606F\6587\672C\7F16\8F91\5668\4E2D\8F93\5165\7684\5185\5BB9\7684\8F93\51FA\683C\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4417)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('\5BF9\6B64\591A\4FE1\606F\6587\672C\7F16\8F91\5668\7684\6E90\548C\8F93\51FA\4F7F\7528 HTML\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4417)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>unistr('\5BF9\6B64\591A\4FE1\606F\6587\672C\7F16\8F91\5668\7684\6E90\548C\8F93\51FA\4F7F\7528 Markdown \683C\5F0F\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4417)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4417)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
unistr('    // \7981\7528\81EA\52A8\683C\5F0F\8BBE\7F6E\529F\80FD'),
'    options.editorOptions.removePlugins.push(''Autoformat'');',
unistr('    // \5E94\7528\5B9A\5236\5DE5\5177\680F'),
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('\8F93\5165 JavaScript \51FD\6570\4EE5\8986\76D6\6807\51C6\7F16\8F91\5668\914D\7F6E\3002\7279\5B9A\4E8E CKEditor5 \7684\9009\9879\5E94\5F53\5E94\7528\4E8E <code>options.editorOptions</code>\3002\6709\5173\66F4\591A\4FE1\606F\FF0C\8BF7\53C2\89C1 CKEditor5 API \6587\6863\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>unistr('\989C\8272\9009\62E9\5668')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5141\8BB8\7528\6237\9009\62E9\6216\8F93\5165\989C\8272\3002\53EF\4ECE\8272\8C31\9009\62E9\989C\8272\3002')
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>unistr('\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\989C\8272\9009\62E9\5668\4E2D\663E\793A\7684\4FE1\606F\91CF\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7B80\5355')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\4EC5\663E\793A\8272\8C31\63A7\4EF6\548C\989C\8272\9884\7F6E\503C\FF08\5982\679C\5B9A\4E49\4E86\FF09\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'FULL'
,p_help_text=>unistr('\663E\793A\5176\4ED6\5B57\6BB5\FF0C\4EE5\4FBF\60A8\4EE5\5982\4E0B\5F62\5F0F\67E5\770B\6216\8F93\5165\989C\8272\FF1A\5341\516D\8FDB\5236\3001HSL \6216 RGB \503C\4EE5\53CA\53EF\9009\7684 Alpha \503C\3002\5177\4F53\5F62\5F0F\53D6\51B3\4E8E\201C\503C\8FD4\56DE\5F62\5F0F\201D\3002\6B64\5916\FF0C\8FD8\663E\793A\521D\59CB\548C\5F53\524D\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('\663E\793A\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\989C\8272\9009\62E9\5668\7684\663E\793A\65B9\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5F39\51FA')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\53EF\4EE5\5728\6587\672C\6846\4E2D\8F93\5165\989C\8272\FF0C\4E5F\53EF\4EE5\4ECE\5F39\51FA\5F0F\989C\8272\9009\62E9\5668\4E2D\9009\62E9\989C\8272\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5185\5D4C')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\4EE5\5185\5D4C\65B9\5F0F\663E\793A\989C\8272\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\4EC5\989C\8272\5F39\51FA\7A97\53E3')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\4E00\4E2A\6309\94AE\5C06\6253\5F00\5F39\51FA\5F0F\989C\8272\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\672C\673A\989C\8272\9009\62E9\5668')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\672C\673A\6D4F\89C8\5668\989C\8272\8F93\5165\3002UI \53D6\51B3\4E8E\6D4F\89C8\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\9ED8\8BA4\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\4F7F\7528\5728\201C\5171\4EAB\7EC4\4EF6\201D>\201C\7EC4\4EF6\8BBE\7F6E\201D\4E2D\4E3A\6B64\7EC4\4EF6\5B9A\4E49\7684\9ED8\8BA4\503C\8FD8\662F\4F7F\7528\5B9A\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('\6A21\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\9009\62E9\989C\8272\9009\62E9\5668\4E2D\663E\793A\7684\4FE1\606F\91CF\3002</p>'),
unistr('<p>\8BF7\6CE8\610F\FF0C\5F53\201C\663E\793A\4E3A\201D\662F\201C\672C\673A\989C\8272\9009\62E9\5668\201D\65F6\FF0C\6B64\9879\4E0D\9002\7528\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7B80\5355')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\4EC5\663E\793A\8272\8C31\63A7\4EF6\548C\989C\8272\9884\7F6E\503C\FF08\5982\679C\5B9A\4E49\4E86\FF09\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'FULL'
,p_help_text=>unistr('\663E\793A\5176\4ED6\5B57\6BB5\FF0C\4EE5\4FBF\60A8\4EE5\5982\4E0B\5F62\5F0F\67E5\770B\6216\8F93\5165\989C\8272\FF1A\5341\516D\8FDB\5236\3001HSL \6216 RGB \503C\4EE5\53CA\53EF\9009\7684 Alpha \503C\3002\5177\4F53\5F62\5F0F\53D6\51B3\4E8E\201C\503C\8FD4\56DE\5F62\5F0F\201D\3002\6B64\5916\FF0C\8FD8\663E\793A\521D\59CB\548C\5F53\524D\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('\663E\793A\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\989C\8272\9009\62E9\5668\7684\663E\793A\65B9\5F0F\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5F39\51FA')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\53EF\4EE5\5728\6587\672C\6846\4E2D\8F93\5165\989C\8272\FF0C\4E5F\53EF\4EE5\4ECE\5F39\51FA\5F0F\989C\8272\9009\62E9\5668\4E2D\9009\62E9\989C\8272\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5185\5D4C')
,p_return_value=>'INLINE'
,p_help_text=>unistr('\4EE5\5185\5D4C\65B9\5F0F\663E\793A\989C\8272\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\4EC5\989C\8272\5F39\51FA\7A97\53E3')
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('\4E00\4E2A\6309\94AE\5C06\6253\5F00\5F39\51FA\5F0F\989C\8272\9009\62E9\5668\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\672C\673A\989C\8272\9009\62E9\5668')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('\672C\673A\6D4F\89C8\5668\989C\8272\8F93\5165\3002UI \53D6\51B3\4E8E\6D4F\89C8\5668\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\989C\8272\9884\7F6E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\989C\8272\9009\62E9\5668\662F\5426\5E94\663E\793A\4E00\7EC4\9884\5B9A\4E49\7684\989C\8272\3002\5982\679C\662F\FF0C\5B83\4EEC\662F\6765\81EA\4E3B\9898\8FD8\662F\5B9A\5236\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4E3B\9898\6837\5F0F\989C\8272')
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\5B9A\5236\989C\8272')
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\989C\8272')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8981\5728\989C\8272\9009\62E9\5668\5BF9\8BDD\6846\4E2D\663E\793A\7684\9884\7F6E\989C\8272\7684\5217\8868\3002'),
unistr('\7528\5206\53F7\5206\9694\989C\8272\3002')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5BF9\6BD4')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5141\8BB8\5C06\6B64\9879\7684\989C\8272\4E0E\5176\4ED6\9879\7684\989C\8272\6216\9759\6001\503C\8FDB\884C\6BD4\8F83\FF0C\5E76\5728\989C\8272\9009\62E9\5668 UI \4E2D\663E\793A\5B83\4EEC\4E4B\95F4\7684\5BF9\6BD4\5EA6\3002'),
unistr('\8FD9\6837\53EF\5E2E\52A9\7528\6237\9009\62E9\5177\6709\8DB3\591F\5BF9\6BD4\5EA6\7684\989C\8272\FF0C\4EE5\4FBF\6BCF\4E2A\4EBA\90FD\53EF\4EE5\770B\6E05\695A\3002')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9875\9879')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\9759\6001\989C\8272')
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\5BF9\6BD4\5EA6\9879')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('\8981\7528\4E8E\5BF9\6BD4\5EA6\6BD4\8F83\7684\9879\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5BF9\6BD4\5EA6\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('\8981\7528\4E8E\5BF9\6BD4\5EA6\6BD4\8F83\7684\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4417)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\503C\8FD4\56DE\5F62\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\6B64\9879\8FD4\56DE\7684\989C\8272\503C\7684\683C\5F0F\3002\5373\4F7F\4EE5\5176\4ED6\6709\6548\683C\5F0F\8F93\5165\989C\8272\FF0C\8BE5\989C\8272\4E5F\5C06\4EE5\6B64\683C\5F0F\663E\793A\3001\8FD4\56DE\548C\53D1\9001\5230\670D\52A1\5668\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5341\516D\8FDB\5236')
,p_return_value=>'HEX'
,p_help_text=>unistr('\5341\516D\8FDB\5236\989C\8272\503C\3002\4E0D\5141\8BB8\4F7F\7528 alpha \503C\3002\4F8B\5982 #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4417)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>unistr('\7528 rgb \51FD\6570\8868\793A\6CD5\8868\793A\7684\7EA2\8272\3001\7EFF\8272\3001\84DD\8272\3002\793A\4F8B rgb(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4417)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7528 rgb/rgba \51FD\6570\8868\793A\6CD5\8868\793A\7684\7EA2\8272\3001\7EFF\8272\3001\84DD\8272\FF0C\5E76\5177\6709\53EF\9009\7684 alpha\FF08\900F\660E\5EA6\FF09\503C\3002'),
unistr('\5982\679C\989C\8272\6CA1\6709 alpha\FF08alpha \7B49\4E8E 1\FF09\FF0C\5219\4F7F\7528 rgb \683C\5F0F\3002'),
unistr('\5982\679C\989C\8272\5177\6709 alpha\FF0C\5219\4F7F\7528 rgba \683C\5F0F\3002'),
unistr('\793A\4F8B rgba(34,68,238,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4417)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('\7528 hsl \51FD\6570\8868\793A\6CD5\8868\793A\7684\8272\5EA6\3001\9971\548C\5EA6\3001\4EAE\5EA6\3002\793A\4F8B hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4417)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7528 hsl/hsla \51FD\6570\8868\793A\6CD5\8868\793A\7684\8272\5EA6\3001\9971\548C\5EA6\3001\4EAE\5EA6\FF0C\5E76\5177\6709\53EF\9009\7684 alpha\FF08\900F\660E\5EA6\FF09\503C\3002'),
unistr('\5982\679C\989C\8272\6CA1\6709 alpha\FF08alpha \7B49\4E8E 1\FF09\FF0C\5219\4F7F\7528 hsl \683C\5F0F\3002'),
unistr('\5982\679C\989C\8272\5177\6709 alpha\FF0C\5219\4F7F\7528 hsla \683C\5F0F\3002'),
unistr('\793A\4F8B hsla(230,86,53,0.5)')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4417)
,p_display_sequence=>60
,p_display_value=>unistr('\4EFB\4F55 CSS \503C')
,p_return_value=>'CSS'
,p_help_text=>unistr('\4EFB\4F55\6709\6548\7684 CSS \989C\8272\683C\5F0F\FF0C\5305\62EC\989C\8272\540D\79F0\6216 CSS \53D8\91CF\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>unistr('\5F39\51FA\5F0F LOV')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\4E00\4E2A\5E26\6709\5F39\51FA\5F0F\503C\5217\8868\56FE\6807\7684\6587\672C\9879\3002\5F53\6700\7EC8\7528\6237\5355\51FB\6B64\56FE\6807\65F6, \4F1A\663E\793A\4E00\4E2A\5305\542B\641C\7D22\5B57\6BB5\548C\652F\6301\7684\503C\5217\8868\7684\5F39\51FA\7A97\53E3\3002</p>'),
unistr('<p>\5F39\51FA\5F0F LOV \6700\9002\5408\4E8E\5927\5217\8868, \56E0\4E3A\6700\7EC8\7528\6237\53EF\4EE5\8F93\5165\641C\7D22\6807\51C6\6765\51CF\5C11\663E\793A\7684\53EF\7528\503C\3002\5BF9\4E8E\76F8\5BF9\5C0F\7684\5217\8868, <em>\9009\62E9\5217\8868</em>\901A\5E38\66F4\9002\5408\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\663E\793A\4E3A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\663E\793A\5F39\51FA\5F0F\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6A21\5F0F\5BF9\8BDD\6846')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('\5C06\5728\6A21\5F0F\5BF9\8BDD\6846\4E2D\663E\793A\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5185\5D4C\5F39\51FA\7A97\53E3')
,p_return_value=>'POPUP'
,p_help_text=>unistr('\5C06\5728\5B57\6BB5\4E0B\7684\5185\5D4C\5F39\51FA\7A97\53E3\4E2D\663E\793A\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\521D\59CB\63D0\53D6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\6700\521D\5982\4F55\4E3A\503C\5217\8868\63D0\53D6\6570\636E\3002\8FD9\4EC5\5728\52A0\8F7D\9875\9762\6216\5237\65B0\9879\FF08\4F8B\5982\7531\4E8E\7EA7\8054\FF09\540E\9996\6B21\6253\5F00\5F39\51FA\7A97\53E3\65F6\9002\7528\3002\53E6\8BF7\53C2\9605\5C5E\6027\201C\6700\5C0F\5B57\7B26\6570\201D\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7528\6237\8BF7\6C42\65F6')
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('\5728\7528\6237\4F7F\7528\6216\4E0D\4F7F\7528\641C\7D22\8BCD\8FDB\884C\641C\7D22\4E4B\524D\FF0C\6700\521D\90FD\4E0D\63D0\53D6\4EFB\4F55\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\81EA\52A8')
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>unistr('\6700\521D\5728\4E0D\4F7F\7528\641C\7D22\8BCD\7684\60C5\51B5\4E0B\63D0\53D6\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\81EA\52A8\FF08\4F7F\7528\5F53\524D\503C\FF09')
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>unistr('\6700\521D\4F7F\7528\5F53\524D\503C\4F5C\4E3A\641C\7D22\8BCD\63D0\53D6\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\591A\4E2A\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\6B64\9879\53EF\4EE5\6709\591A\4E2A\503C\8FD8\662F\53EA\80FD\6709\5355\4E2A\503C\3002\591A\4E2A\503C\5C06\4EE5\9017\53F7\5206\9694\7684\5217\8868\5F62\5F0F\8FD4\56DE\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\624B\52A8\8F93\5165')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\662F\5426\5141\8BB8\624B\52A8\8F93\5165\3002\5982\679C\8BBE\7F6E\4E3A\201C\662F\201D\FF0C\5219\7528\6237\53EF\4EE5\4ECE\5F39\51FA\5F0F\503C\5217\8868\4E2D\9009\62E9\73B0\6709\503C\FF0C\4E5F\53EF\4EE5\624B\52A8\8F93\5165\503C\3002\8FD9\4E0E\7EC4\5408\6846\76F8\4F3C\3002\5982\679C\8BBE\7F6E\4E3A\201C\5426\201D\FF0C\5219\7528\6237\53EA\80FD\4ECE\5F39\51FA\5F0F\503C\5217\8868\4E2D\9009\62E9\503C\3002\8FD9\4E0E\9009\62E9\5217\8868\76F8\4F3C\3002\5141\8BB8\624B\52A8\8F93\5165\65F6\FF0C\5B83\662F\5BF9\5E94\503C\5217\8868\7684\8FD4\56DE\503C\FF0C\5FC5\987B\8F93\5165\6B64\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\952E\5165\65F6\641C\7D22')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\201C\662F\201D\FF0C\5C06\4F1A\968F\7740\60A8\5728\641C\7D22\5B57\6BB5\4E2D\952E\5165\5185\5BB9\800C\8FC7\6EE4\503C\5217\8868\3002\5982\679C\201C\5426\201D\FF0C\90A3\4E48\5728\7528\6237\6309\4E0B Enter \6216\201C\641C\7D22\201D\56FE\6807\6309\94AE\4E4B\524D\FF0C\4E0D\4F1A\8FC7\6EE4\503C\5217\8868\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\6700\5C0F\5B57\7B26\6570')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\6307\5B9A\5728\63D0\53D6\503C\5217\8868\4E4B\524D\641C\7D22\8BCD\4E2D\8981\6C42\7684\6700\5C0F\5B57\7B26\6570\3002\5728 LOV \67E5\8BE2\4EE3\4EF7\9AD8\6602\7684\60C5\51B5\4E0B\FF0C\8FD9\5BF9\4E8E\51CF\5C11\5B8C\6210\7684\641C\7D22\91CF\975E\5E38\6709\7528\3002\5217\8868\4E2D\7684\6240\6709\663E\793A\503C\5747\5E94\957F\4E8E\6B64\6700\5C0F\503C\FF0C\5426\5219\5C06\627E\4E0D\5230\5B83\4EEC\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0\6700\5C0F\503C (0)')
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4417)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4417)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4417)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4417)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4417)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6807\9898')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('\5F39\51FA\7A97\53E3\6807\9898\3002\5982\679C\7559\7A7A\FF0C\5C06\4F7F\7528\9ED8\8BA4\6807\9898\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\5F39\51FA\7A97\53E3\5BBD\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\5F39\51FA\7A97\53E3\7684\5BBD\5EA6\3002\5982\679C\7559\7A7A\FF0C\5C06\4F7F\7528\9ED8\8BA4\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\5F39\51FA\7A97\53E3\9AD8\5EA6')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\5F39\51FA\7A97\53E3\7684\9AD8\5EA6\3002\5982\679C\7559\7A7A\FF0C\5C06\4F7F\7528\9ED8\8BA4\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('\9644\52A0\8F93\51FA')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8FD4\56DE\6620\5C04\5230\5176\4ED6\9875\9879\4EE5\53CA\4EA4\4E92\5F0F\7F51\683C\5217\7684\9644\52A0\503C\5217\8868 (LOV) \5217\3002\5B9A\4E49 LOV \5217\540D\5230\9875\9879\540D\79F0\6216\4EA4\4E92\5F0F\7F51\683C\5217\9759\6001 ID \7684\6620\5C04\3002</p>'),
unistr('<p>\6CE8\FF1A\6B64\9879\4EC5\9002\7528 LOV \5B9A\4E49\5305\542B\9644\52A0\5217\7684\60C5\51B5\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>unistr('\5206\9694\7B26')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\63A5\53D7\5F39\51FA\5F0F LOV \9879\7684\9009\9879\5BF9\8C61\3001\4FEE\6539\5E76\8FD4\56DE\8BE5\5BF9\8C61\7684 JavaScript \51FD\6570\3002\8FD9\6837\FF0C\53EF\4EE5\5728\521D\59CB\5316\671F\95F4\5BF9\5F39\51FA\5F0F LOV \9879\5BF9\8BDD\6846\53CA\5176\5185\5BB9\8FDB\884C\9AD8\7EA7\5B9A\5236\3002</p>'),
'',
unistr('<p>\8FD9\4E9B\9009\9879\5C06\4F20\9012\5230 <code>popup</code> \5C0F\90E8\4EF6\6216 jQuery UI <code>dialog</code> \5C0F\90E8\4EF6\FF1A<br>'),
unistr('draggable\3001resizable\3001width\3001height\3001minWidth\3001minHeight\3001maxWidth \548C maxHeight<br>'),
unistr('\6709\5173\8BE6\7EC6\4FE1\606F\FF0C\8BF7\53C2\89C1 JQuery UI \5BF9\8BDD\6846\5C0F\90E8\4EF6\6587\6863\3002</p>'),
'',
unistr('<p>\7ED3\679C\663E\793A\5728\7B80\5355\5217\8868\4E2D\65F6\FF0C<code>defaultIconListOptions</code> \9009\9879\662F\4F20\9012\5230 <code>tableModelView</code> \5C0F\90E8\4EF6\7684\5BF9\8C61\3002\6709\5173\53EF\7528\9009\9879\FF0C\8BF7\53C2\89C1 APEX tableModelView \5C0F\90E8\4EF6\6587\6863\3002</p>'),
'',
unistr('<p>\7ED3\679C\663E\793A\5728\7F51\683C\4E2D\65F6\FF0C<code>defaultGridOptions</code> \9009\9879\662F\4F20\9012\5230 <code>grid</code> \5C0F\90E8\4EF6\7684\5BF9\8C61\3002'),
unistr('\6709\5173\53EF\7528\9009\9879\FF0C\8BF7\53C2\89C1 APEX \7F51\683C\5C0F\90E8\4EF6\6587\6863\3002</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4417)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('\6267\884C\670D\52A1\5668\7AEF\4EE3\7801')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5728\670D\52A1\5668\4E0A\6267\884C\4EE3\7801\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4417)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\8981\9488\5BF9\7B26\5408\52A0\85AA\6761\4EF6\7684\5458\5DE5\5C06\85AA\6C34\589E\52A0 3%\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
unistr('<p>\5728\672C\4F8B\4E2D\FF0C\9700\8981\5728<strong>\8981\63D0\4EA4\7684\9879</strong>\4E2D\8F93\5165 <code>P2_DEPTNO</code>\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\4E2A\5728\670D\52A1\5668\4E0A\6267\884C\7684\4EC5\9650\6267\884C\7684 PL/SQL \533F\540D\5757\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\7ED1\5B9A\8BED\6CD5\5F15\7528\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\9875\6216\5E94\7528\7A0B\5E8F\9879 (\4F8B\5982 <code>:P1_MY_ITEM</code>)\3002\8FD8\9700\8981\5C06\5F15\7528\7684\6240\6709\9879\5305\542B\5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4417)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>unistr('JavaScript \4EE3\7801')
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>\8981\9488\5BF9\7B26\5408\52A0\85AA\6761\4EF6\7684\5458\5DE5\5C06\85AA\6C34\589E\52A0 3%\FF0C\8BF7\4F7F\7528\4EE5\4E0B\8BED\53E5\FF1A</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
'  // placeholder for some complicated logic to calculate if employee needs a raise',
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
unistr('<p>\5728\672C\4F8B\4E2D\FF0C\9700\8981\5728<strong>\8981\63D0\4EA4\7684\9879</strong>\4E2D\8F93\5165 <code>P2_DEPTNO</code>\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\4E00\4E2A\5728\670D\52A1\5668\4E0A\6267\884C\7684\4EC5\9650\6267\884C\7684 JavaScript \5757\3002</p>'),
unistr('<p>\53EF\4EE5\4F7F\7528\7ED1\5B9A\8BED\6CD5\5F15\7528\5E94\7528\7A0B\5E8F\4E2D\7684\5176\4ED6\9875\6216\5E94\7528\7A0B\5E8F\9879\FF08\4F8B\5982 <code>apex.env.P1_MY_ITEM</code>\FF09\3002\8FD8\9700\8981\5C06\5F15\7528\7684\6240\6709\9879\5305\542B\5728<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\4E2D\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4417)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8981\63D0\4EA4\7684\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\63D0\4EA4\5230\670D\52A1\5668\5E76\7531\6B64\53EF\5728 <strong>PL/SQL \4EE3\7801</strong>\4E2D\4F7F\7528\7684\5927\5199\9875\9879\3002</p>'),
unistr('<p>\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4417)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\8981\8FD4\56DE\7684\9879')
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''New Value'');',
'</pre>',
'</p>',
unistr('<p>\5728\6B64\793A\4F8B\4E2D, \5728\6B64\5C5E\6027\4E2D\8F93\5165 <code>P1_MY_ITEM</code> \4EE5\4F7F ''New Value'' \663E\793A\5728\9875\4E0A\7684\6B64\9879\4E2D\3002</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\5927\5199\9875\9879, \8FD9\4E9B\9875\9879\5C06\5728\5BF9\670D\52A1\5668\7684\8C03\7528\8FD4\56DE\65F6\6839\636E\5176\5728\4F1A\8BDD\72B6\6001\4E2D\7684\5F53\524D\503C\8FDB\884C\8BBE\7F6E\3002\5982\679C <strong>PL/SQL \4EE3\7801</strong>\5728\4F1A\8BDD\72B6\6001\4E2D\8BBE\7F6E\4E00\4E2A\6216\591A\4E2A\9875\9879\7684\503C, \5219\60A8\9700\8981\5728\6B64\5C5E\6027\4E2D\5B9A\4E49\8FD9\4E9B\9879\3002</p>'),
unistr('<p>\53EF\4EE5\952E\5165\540D\79F0\6216\4ECE\53EF\7528\9879\5217\8868\4E2D\9009\53D6\3002'),
unistr('\5982\679C\4ECE\5217\8868\4E2D\9009\53D6\5E76\4E14\5DF2\5B58\5728\8F93\5165\7684\6587\672C, \5219\4F1A\5728\73B0\6709\6587\672C\7ED3\5C3E\653E\7F6E\4E00\4E2A\9017\53F7, \540E\8DDF\4ECE\5217\8868\8FD4\56DE\7684\9879\540D\79F0\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4417)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\9690\85CF\66F4\6539\4E8B\4EF6')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('\6307\5B9A\662F\5426\5728<strong>\8981\8FD4\56DE\7684\9875\9879</strong>\4E2D\6307\5B9A\7684\9879\4E0A\7981\6B62\66F4\6539\4E8B\4EF6\3002\8FD9\5C06\9632\6B62\4E3A\8FD9\4E9B\9879\89E6\53D1\540E\7EED\57FA\4E8E<em>\66F4\6539</em>\7684\52A8\6001\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4417)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>unistr('\8BED\8A00')
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>unistr('\4EC5\663E\793A')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\663E\793A\4E0D\53EF\8F93\5165\7684\6587\672C\9879\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4417)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>unistr('\63D0\4EA4\9875\65F6\53D1\9001')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\662F\5426\5E94\5728\63D0\4EA4\9875\65F6\53D1\9001\5F53\524D\9879\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4417)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\57FA\4E8E')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\786E\5B9A\663E\793A\7684\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\9879\503C')
,p_return_value=>'VALUE'
,p_help_text=>unistr('\663E\793A\9879\7684\5F53\524D\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\503C\5217\8868\7684\663E\793A\503C')
,p_return_value=>'LOV'
,p_help_text=>unistr('\4F7F\7528\503C\5217\8868\5C06\9875\9879\7684\5F53\524D\503C\6620\5C04\5230\5176\4ED6\663E\793A\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4417)
,p_display_sequence=>30
,p_display_value=>unistr('PL/SQL \4EE3\7801\7684\8F93\51FA')
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('\6307\5B9A\7684 PL/SQL \4EE3\7801\53D1\51FA\663E\793A\7684\8F93\51FA\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4417)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('PL/SQL \4EE3\7801')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528 <code>sys.htp.p</code> \6216 <code>sys.htp.prn</code> \8F93\5165 PL/SQL \4EE3\7801\4EE5\53D1\51FA HTML \4EE3\7801\3002</p>'),
unistr('<p>Oracle \5EFA\8BAE\4F7F\7528 <code>sys.htf.escape_sc</code> \5BF9\4ECE\6570\636E\5E93\68C0\7D22\7684\6570\636E\8FDB\884C\8F6C\4E49\4EE5\786E\4FDD\5BF9 HTML \6807\8BB0\8FDB\884C\8F6C\4E49\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4417)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\663E\793A\6362\884C\7B26')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\6307\5B9A\662F\5426\5728\8F93\51FA\4E2D\4FDD\7559\6362\884C\7B26\3002</p>'),
unistr('<p>\56E0\4E3A\663E\793A\5185\5BB9\4F1A\5448\73B0\4E3A HTML, \6240\4EE5\5728\8BBE\7F6E\4E3A<strong>\662F</strong>\65F6, \4F1A\5C06\663E\793A\503C\4E2D\7684\6362\884C\7B26\8F6C\6362\4E3A HTML \6362\884C\7B26, \4EE5\4F7F\5176\6B63\786E\663E\793A\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4417)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>unistr('\683C\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7EAF\6587\672C')
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4417)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4417)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4417)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4417)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('<strong>\793A\4F8B 1: \57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868\3002</strong>'),
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
unistr('<strong>\793A\4F8B 2: \9759\6001\5217\8868\793A\4F8B</strong>'),
'<ul>',
unistr('<li>STATIC:Yes;Y,No;N (\663E\793A Yes/No, \800C\975E Y \548C N)</li>'),
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>\793A\4F8B 3: \5E26\6709\4F7F\7528\7ED1\5B9A\53D8\91CF\7684\5176\4ED6\9650\5236\7684\503C\5217\8868</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('\661F\7EA7\8BC4\7EA7')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>\65B0\578B\661F\7EA7\8BC4\7EA7\9879</strong></p>'),
unistr('<p>\6B64\9879\4EE5\661F\53F7\6216\5176\4ED6\56FE\6807\7684\6570\91CF\65B9\5F0F\663E\793A\6570\503C\3002\6700\7EC8\7528\6237\53EF\4EE5\901A\8FC7\9009\62E9\6240\9700\661F\53F7\6570\6765\66F4\6539\503C\3002\53EF\4EE5\4F7F\7528\9F20\6807\5355\51FB\661F\53F7\6570\6216\4F7F\7528\952E\76D8\8C03\6574\8BE5\503C\3002</p>'),
unistr('<p>\53EF\4EE5\5728\7EC4\4EF6\8BBE\7F6E\6216\5355\4E2A\9879\8BBE\7F6E\4E2D\8C03\6574\8981\663E\793A\7684\56FE\6807\3001\80CC\666F\548C\524D\666F\989C\8272\3002\8981\4F7F\7528\5355\4E2A\9879\548C\989C\8272\FF0C\8BF7\5C06\5C5E\6027<strong>\4F7F\7528\7EC4\4EF6\9ED8\8BA4\503C</strong>\8BBE\7F6E\4E3A<strong>\5426</strong>\3002</p>'),
unistr('<p>\5BF9\4E8E\56FE\6807\FF0C\60A8\53EF\4EE5\4F7F\7528\60A8\7684\5E94\7528\7A0B\5E8F\4E2D\53EF\7528\7684\56FE\6807\5B57\4F53\4E2D\7684\4EFB\4F55\56FE\6807\3002\5BF9\4E8E\901A\7528\4E3B\9898\5E94\7528\7A0B\5E8F\FF0C\8BF7\4F7F\7528<em>\5B57\4F53 APEX</em> \5E93\4E2D\7684\56FE\6807\3002</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9ED8\8BA4\56FE\6807')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\9009\62E9\8981\4F7F\7528\7684\9ED8\8BA4\56FE\6807\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\6D3B\52A8\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\6D3B\52A8\661F\53F7\7684\9ED8\8BA4\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\4E0D\6D3B\52A8\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('\9009\62E9\4E0D\6D3B\52A8\661F\53F7\7684\9ED8\8BA4\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('\8BC4\7EA7\FF1A#VALUE# \661F\3002')
,p_help_text=>unistr('\6307\5B9A\7528\4E8E\5DE5\5177\63D0\793A\7684\6A21\677F\3002#VALUE# \66FF\6362\9879\5C06\66FF\6362\4E3A\5F53\524D\8BC4\7EA7\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\661F\53F7\6570')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\8981\663E\793A\7684\661F\53F7\603B\6570\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4417)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\4F7F\7528\9ED8\8BA4\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\4F7F\7528\5728\201C\5171\4EAB\7EC4\4EF6\201D>\201C\7EC4\4EF6\8BBE\7F6E\201D\4E2D\4E3A\6B64\7EC4\4EF6\5B9A\4E49\7684\9ED8\8BA4\503C\8FD8\662F\4F7F\7528\5B9A\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\56FE\6807')
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>unistr('\6307\5B9A\8981\4F7F\7528\7684\56FE\6807\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6D3B\52A8\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9009\62E9\6D3B\52A8\661F\53F7\7684\9ED8\8BA4\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\4E0D\6D3B\52A8\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9009\62E9\4E0D\6D3B\52A8\661F\53F7\7684\9ED8\8BA4\989C\8272\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\5DE5\5177\63D0\793A')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('\8BC4\7EA7\FF1A#VALUE# \661F\3002')
,p_help_text=>unistr('\6307\5B9A\7528\4E8E\5DE5\5177\63D0\793A\7684\6A21\677F\3002#VALUE# \66FF\6362\9879\5C06\66FF\6362\4E3A\5F53\524D\8BC4\7EA7\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\663E\793A\201C\6E05\9664\201D\6309\94AE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9009\62E9\662F\5426\663E\793A\201C\6E05\9664\201D\6309\94AE\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\663E\793A\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\9009\62E9\662F\5426\8981\5728\661F\53F7\65C1\8FB9\663E\793A\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4417)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('\53EA\8BFB\663E\793A')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\9879\4E3A\53EA\8BFB\65F6\8981\663E\793A\7684\5185\5BB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\661F\7EA7')
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\503C')
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\661F\7EA7\548C\503C')
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4417)
,p_display_sequence=>50
,p_display_value=>unistr('\5355\4E2A\661F\548C\503C')
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>unistr('\590D\9009\6846\7EC4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('\5C06\591A\4E2A\503C\663E\793A\4E3A\590D\9009\6846, \4ECE\800C\4F7F\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\591A\4E2A\503C\3002\663E\793A\4E3A\590D\9009\6846\7684\5404\9879\9700\8981\4E00\4E2A\503C\5217\8868\3002\4E0E\590D\9009\6846\5BF9\5E94\7684\503C\5B58\50A8\5728\5355\4E2A\5192\53F7\5206\9694\7684\5B57\7B26\4E32\4E2D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4417)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5217\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\7528\4E8E\663E\793A\590D\9009\6846\7684\5E03\5C40\5217\7684\6570\76EE\3002\4F8B\5982, \503C 2 \5C06\663E\793A\4E24\5217\590D\9009\6846\3002\9ED8\8BA4\60C5\51B5\4E0B, \6240\6709\503C\90FD\663E\793A\5728\4E00\5217\4E2D\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4417)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('\663E\793A\65B9\5411')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5982\4F55\5448\73B0\590D\9009\6846\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5782\76F4')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\6C34\5E73')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4417)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>unistr('\9009\62E9\5217\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\4E00\4E2A\5E26\6709\5185\7F6E\503C\5217\8868\9009\62E9\5668\7684\9879\3002\5F53\6700\7EC8\7528\6237\5355\51FB\6B64\9879\65F6, \5C06\76F4\63A5\4EE5\5185\5D4C\5230\5F53\524D\9879\7684\65B9\5F0F\663E\793A\652F\6301\7684\503C\5217\8868\3002</p>'),
unistr('<p>\201C\9009\62E9\5217\8868\201D\6700\9002\5408\4E8E\76F8\5BF9\5C0F\7684\79BB\6563\5217\8868\3002\6700\7EC8\7528\6237\53EF\4EE5\975E\5E38\5FEB\901F\5730\4ECE\5217\8868\4E2D\9009\62E9\503C, \800C\65E0\9700\5C06\7126\70B9\66F4\6539\5230\5F39\51FA\5F0F\5BF9\8BDD\6846\3002\5BF9\4E8E\5927\5217\8868, <em>\5F39\51FA\5F0F LOV</em> \901A\5E38\66F4\9002\5408\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\9009\5B9A\5185\5BB9\7684\9875\64CD\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\9009\5B9A\5217\8868\503C\65F6\6267\884C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_display_sequence=>1
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
,p_help_text=>unistr('\5728\503C\53D1\751F\66F4\6539\540E\4E0D\7ACB\5373\6267\884C\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\63D0\4EA4\9875')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\63D0\4EA4\9875\5E76\5C06\9875 REQUEST \8BBE\7F6E\4E3A\9875\9879\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_display_sequence=>7
,p_display_value=>unistr('\91CD\5B9A\5411\5E76\8BBE\7F6E\503C')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\6D4F\89C8\5668\5C06\91CD\5B9A\5411\5230\5F53\524D\9875\5E76\4E14\5F53\524D\9879\7684\4F1A\8BDD\72B6\6001\8BBE\7F6E\4E3A\6240\9009\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_display_sequence=>9
,p_display_value=>unistr('\91CD\5B9A\5411\5230\9875')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('\6D4F\89C8\5668\5C06\91CD\5B9A\5411\5230\6240\9009\503C\4E2D\5305\542B\7684\9875\3002\5217\8868\4E2D\7684\8FD4\56DE\503C\5FC5\987B\5305\62EC\6709\6548\7684\9875\7801\6216\9875\522B\540D\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\91CD\5B9A\5411\5230 URL')
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('\6D4F\89C8\5668\5C06\91CD\5B9A\5411\5230\6240\9009\503C\4E2D\5305\542B\7684 URL\3002\5217\8868\4E2D\7684\8FD4\56DE\503C\5FC5\987B\5305\62EC\6709\6548\7684 URL\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4417)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\5141\8BB8\591A\9009')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>unistr('\6307\5B9A\662F\53EF\4EE5\4ECE\503C\5217\8868\4E2D\9009\62E9\591A\4E2A\503C\8FD8\662F\53EA\80FD\9009\62E9\5355\4E2A\503C\3002\4EE5\9017\53F7\5206\9694\7684\5217\8868\5F62\5F0F\8FD4\56DE\591A\4E2A\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4417)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6267\884C\9A8C\8BC1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\6307\5B9A\63D0\4EA4\9875\65F6\662F\5426\6839\636E\9875\64CD\4F5C\8BBE\7F6E<strong>\63D0\4EA4\9875</strong>\6267\884C\9A8C\8BC1\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4417)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('\5217\5207\6362\62A5\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\62A5\8868, \6700\7EC8\7528\6237\53EF\4EE5\5728\6B64\62A5\8868\4E2D\9009\62E9\8981\5728\8FD0\884C\65F6\663E\793A\7684\5217\3002\6700\7EC8\7528\6237\968F\540E\53EF\4EE5\57FA\4E8E\8981\7528\4E8E\663E\793A\6B64\62A5\8868\7684\5C4F\5E55\7684\5BBD\5EA6\548C\65B9\5411\66F4\6539\5217\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\6B64\62A5\8868\5217\7684\57FA\7840\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7EAF\6587\672C')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\94FE\63A5')
,p_return_value=>'LINK'
,p_help_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\767E\5206\6BD4\56FE\5F62')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\5C06\5217\663E\793A\4E3A\767E\5206\6BD4\56FE\5F62\3002\68C0\7D22\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 100 \4E4B\95F4\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\76EE\6807')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F93\5165\5728\7528\6237\5355\51FB\73B0\6709\6761\76EE\65F6\8981\8C03\7528\7684\76EE\6807\9875\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\94FE\63A5\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\8F93\5165\8981\663E\793A\4E3A\94FE\63A5\7684 HTML \6587\672C\3002\4F7F\7528\56FE\50CF\6807\8BB0\53EF\4EE5\663E\793A\56FE\50CF, \6216\8005\4ECE\9ED8\8BA4\56FE\50CF\5217\8868\4E2D\9009\53D6\56FE\50CF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\94FE\63A5\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\6307\5B9A\8981\5305\542B\5728 <code>&lt;a href=...&gt;</code> \6807\8BB0\4E2D\7684\9644\52A0\5217\94FE\63A5\5C5E\6027, \5305\62EC\94FE\63A5\76EE\6807, \7C7B\6216\6837\5F0F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\80CC\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\80CC\666F\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\524D\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\524D\666F\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6761\5BBD\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\8F93\5165\6B64\6761\5F62\56FE\7684\5BBD\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\7528\4F5C\884C\6807\9898')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\8FD9\4F9B\53EF\8BBF\95EE\6027\7528\6765\786E\5B9A\80FD\591F\6700\597D\5730\4EE3\8868\884C\5185\5BB9\7684\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>unistr('\4F18\5148\7EA7')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\62A5\8868\57FA\4E8E\4E24\4E2A\8F93\5165\9690\85CF\548C\663E\793A\5217: \53EF\7528\5C4F\5E55\5BBD\5EA6, \6216\7528\6237\9009\4E2D\548C\53D6\6D88\9009\4E2D\54EA\4E9B\5217\663E\793A\5728\5217\9009\53D6\5668\83DC\5355\4E2D\3002\4E3A\8981\54CD\5E94\663E\793A\7684\6BCF\4E00\5217\9009\62E9\4F18\5148\7EA7\503C\3002\5217\9009\53D6\5668\83DC\5355\4E2D\5C06\63D0\4F9B\6307\5B9A\4E86\4F18\5148\7EA7\7684\6240\6709\5217\3002<p>'),
'',
unistr('<p>\8981\4F7F\67D0\4E00\5217\6301\4E45\5316, \4EE5\4F7F\5176\4ECE\4E0D\9690\85CF, \8BF7\9009\62E9<strong>\59CB\7EC8\663E\793A</strong>, \8FD9\8FD8\5C06\4ECE\5217\9009\53D6\5668\83DC\5355\4E2D\5220\9664\6B64\5217\3002</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\59CB\7EC8\663E\793A')
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>10
,p_display_value=>unistr('1 - \9690\85CF\6700\540E\4E00\4E2A')
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4417)
,p_display_sequence=>60
,p_display_value=>unistr('6 - \9690\85CF\7B2C\4E00\4E2A')
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5E03\5C40\9009\9879')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\68C0\67E5\5176\4ED6\62A5\8868\5E03\5C40\9009\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6761\7EB9')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\5728\6BCF\884C\4E0A\6DFB\52A0\66FF\4EE3\884C\6761\7EB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\7B14\753B')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\5728\6BCF\884C\4E4B\95F4\6DFB\52A0\6C34\5E73\7EBF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS \7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\5305\62EC\5728\7EC4\4EF6\4E2D\7684\4EE5\7A7A\683C\5206\9694\7684\9644\52A0 CSS \7C7B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5B9A\5236\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\8F93\5165\5C06\5305\542B\5728\8868 HTML \6807\8BB0\4E2D\7684\9644\52A0\5C5E\6027\3002\7C7B HTML \5C5E\6027\5DF2\751F\6210\FF0C\56E0\6B64\4E0D\5E94\63D0\4F9B\FF0C\8BF7\6539\7528\4E13\7528\7684 <em>CSS \7C7B</em>\5C5E\6027\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\5217\6309\94AE\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('\8FD9\662F\7528\4E8E\6253\5F00\5217\9009\62E9\5F39\51FA\7A97\53E3\7684\6309\94AE\7684\6807\7B7E\3002\5982\679C\672A\63D0\4F9B\6587\672C\FF0C\5219\4F7F\7528\9ED8\8BA4\6807\7B7E\3002')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4417)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\6240\6709\96C7\5458, \6309\59D3\540D\6392\5E8F</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\663E\793A\5F53\524D\90E8\95E8\7684\6240\6709\96C7\5458, \6309\59D3\540D\6392\5E8F</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\4F7F\7528\7ED1\5B9A\53D8\91CF\5F15\7528\9875\9879\65F6, \8BF7\5C06\5176\6307\5B9A\4E3A<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\3002</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>unistr('\5F80\8FD4')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\663E\793A\4E3A\4E00\4E2A\591A\9009\5217\8868, \6B64\5217\8868\5305\62EC\4E24\4E2A\5E26\6709\5217\8868\7684\6846\3002\5DE6\4FA7\5217\8868\663E\793A\5C1A\672A\9009\62E9\7684\6E90\503C\5217\8868, \53F3\4FA7\5217\8868\663E\793A\5F53\524D\9009\5B9A\503C\3002\6700\7EC8\7528\6237\53EF\4EE5\5728\5217\8868\4E2D\9009\62E9\4E00\4E2A\6216\591A\4E2A\503C, \7136\540E\4F7F\7528\5F80\8FD4\63A7\4EF6\79FB\52A8\6240\9009\503C\6216\6240\6709\503C\3002</p>'),
unistr('<p>\5F53\524D\503C\5B58\50A8\5728\5355\4E2A\5192\53F7\5206\9694\7684\5B57\7B26\4E32\4E2D\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4417)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\663E\793A\63A7\4EF6')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\5F80\8FD4\4E2D\95F4\663E\793A\7684\6570\636E\79FB\52A8\63A7\4EF6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5168\90E8')
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\4EC5\79FB\52A8')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\4EC5\6392\5E8F')
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4417)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4417)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4417)
,p_name=>'shuttlechangeorder'
,p_display_name=>unistr('\66F4\6539\987A\5E8F')
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>unistr('\5355\9009\7EC4')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C06\591A\4E2A\503C\663E\793A\4E3A\5355\9009\7EC4\9009\9879, \4ECE\800C\4F7F\6700\7EC8\7528\6237\53EF\4EE5\9009\62E9\5355\4E2A\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4417)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5217\6570')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\663E\793A\7684\5355\9009\7EC4\5217\7684\6570\76EE\3002\4F8B\5982, \503C <code>2</code> \5C06\663E\793A\4E24\5217, \56E0\6B64, \5982\679C\5B58\5728\4E94\4E2A\503C, \5219\663E\793A\5C06\8D85\8FC7\4E09\884C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4417)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\9009\5B9A\5185\5BB9\7684\9875\64CD\4F5C')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\5728\9009\5B9A\5355\9009\7EC4\503C\65F6\6267\884C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
,p_help_text=>unistr('\5728\503C\53D1\751F\66F4\6539\540E\4E0D\7ACB\5373\6267\884C\64CD\4F5C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\63D0\4EA4\9875')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('\63D0\4EA4\9875\5E76\5C06\9875 REQUEST \8BBE\7F6E\4E3A\9875\9879\540D\79F0\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\91CD\5B9A\5411\5E76\8BBE\7F6E\503C')
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('\6D4F\89C8\5668\5C06\91CD\5B9A\5411\5230\5F53\524D\9875\5E76\4E14\5F53\524D\9879\7684\4F1A\8BDD\72B6\6001\8BBE\7F6E\4E3A\6240\9009\503C\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4417)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\6267\884C\9A8C\8BC1')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('\6307\5B9A\63D0\4EA4\9875\65F6\662F\5426\6839\636E\9875\64CD\4F5C\8BBE\7F6E<strong>\63D0\4EA4\9875</strong>\6267\884C\9A8C\8BC1\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4417)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>unistr('\663E\793A\65B9\5411')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\7528\4E8E\663E\793A\5355\9009\7EC4\503C\7684\65B9\5411\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\5782\76F4')
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\6C34\5E73')
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4417)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\9690\85CF\5355\9009\6309\94AE')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4417)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4417)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\57FA\4E8E SQL \67E5\8BE2\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>\5177\6709\76F8\540C\7684\663E\793A\503C\548C\8FD4\56DE\503C\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5728\4E3A\663E\793A\503C\548C\8FD4\56DE\503C\9009\62E9\4E86\540C\4E00\5217\65F6, \4F7F\7528\5217\522B\540D\3002</p>'),
'</dd>',
unistr('<dt>\5177\6709\7ED1\5B9A\53D8\91CF\7684\503C\5217\8868</dt>'),
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>\6CE8: \5982\679C <code>P3_DEPTNO</code> \662F\540C\4E00\9875\4E0A\7684\53EF\4FEE\6539\9875\9879, \5219\5C06<em>\7EA7\8054 LOV \7236\9879</em>\5C5E\6027\8BBE\7F6E\4E3A <code>P3_DEPTNO</code>\3002</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>unistr('\91CD\6392\62A5\8868')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\54CD\5E94\62A5\8868, \6B64\62A5\8868\5C06\5217\8F6C\6362\4E3A\884C\4EE5\4FBF\4EE5\8F83\5C0F\7684\6D4F\89C8\5668 (\5C4F\5E55) \5927\5C0F\663E\793A\62A5\8868\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\7C7B\578B')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\9009\62E9\6B64\62A5\8868\5217\7684\57FA\7840\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7EAF\6587\672C')
,p_return_value=>'PLAIN'
,p_help_text=>unistr('\663E\793A\5217\503C\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\94FE\63A5')
,p_return_value=>'LINK'
,p_help_text=>unistr('\5C06\5217\663E\793A\4E3A\94FE\63A5\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_display_sequence=>30
,p_display_value=>unistr('\767E\5206\6BD4\56FE\5F62')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('\5C06\5217\663E\793A\4E3A\767E\5206\6BD4\56FE\5F62\3002\68C0\7D22\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 100 \4E4B\95F4\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\76EE\6807')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>\8F93\5165\5728\7528\6237\5355\51FB\73B0\6709\6761\76EE\65F6\8981\8C03\7528\7684\76EE\6807\9875\3002</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\94FE\63A5\6587\672C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\8F93\5165\8981\663E\793A\4E3A\94FE\63A5\7684 HTML \6587\672C\3002\4F7F\7528\56FE\50CF\6807\8BB0\53EF\4EE5\663E\793A\56FE\50CF, \6216\8005\4ECE\9ED8\8BA4\56FE\50CF\5217\8868\4E2D\9009\53D6\56FE\50CF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\94FE\63A5\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('\6307\5B9A\8981\5305\542B\5728 <code>&lt;a href=...&gt;</code> \6807\8BB0\4E2D\7684\9644\52A0\5217\94FE\63A5\5C5E\6027, \5305\62EC\94FE\63A5\76EE\6807, \7C7B\6216\6837\5F0F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\80CC\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\80CC\666F\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('\524D\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E3B\8981 HTML \989C\8272\4EE3\7801\7684\793A\4F8B\5305\62EC -'),
'<ul>',
unistr('  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;\9ED1\8272&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;\7EA2\8272&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;\9EC4\8272&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;\9178\6A59\8272&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;\6C34\7EFF\8272&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;\84DD\8272&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;\6D77\519B\84DD&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>'),
unistr('  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;\767D\8272&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>'),
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\524D\666F\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\6761\5BBD\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('\8F93\5165\6B64\6761\5F62\56FE\7684\5BBD\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('\7528\4F5C\884C\6807\9898')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('\8FD9\4F9B\53EF\8BBF\95EE\6027\7528\6765\786E\5B9A\80FD\591F\6700\597D\5730\4EE3\8868\884C\5185\5BB9\7684\5217\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5E03\5C40\9009\9879')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\68C0\67E5\5176\4ED6\62A5\8868\5E03\5C40\9009\9879\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\6761\7EB9')
,p_return_value=>'STRIPE'
,p_help_text=>unistr('\5728\6BCF\884C\4E0A\6DFB\52A0\66FF\4EE3\884C\6761\7EB9\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\7B14\753B')
,p_return_value=>'STROKE'
,p_help_text=>unistr('\5728\6BCF\884C\4E4B\95F4\6DFB\52A0\6C34\5E73\7EBF\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('CSS \7C7B')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\8981\5305\62EC\5728\7EC4\4EF6\4E2D\7684\4EE5\7A7A\683C\5206\9694\7684\9644\52A0 CSS \7C7B\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\5B9A\5236\5C5E\6027')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>\8F93\5165\5C06\5305\542B\5728\8868 HTML \6807\8BB0\4E2D\7684\9644\52A0\5C5E\6027\3002\7C7B HTML \5C5E\6027\5DF2\751F\6210\FF0C\56E0\6B64\4E0D\5E94\63D0\4F9B\FF0C\8BF7\6539\7528\4E13\7528\7684 <em>CSS \7C7B</em>\5C5E\6027\3002</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4417)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4417)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>\663E\793A\6240\6709\96C7\5458, \6309\59D3\540D\6392\5E8F</dt>'),
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
unistr('<dt>\663E\793A\5F53\524D\90E8\95E8\7684\6240\6709\96C7\5458, \6309\59D3\540D\6392\5E8F</dt>'),
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>\4F7F\7528\7ED1\5B9A\53D8\91CF\5F15\7528\9875\9879\65F6, \8BF7\5C06\5176\6307\5B9A\4E3A<strong>\8981\63D0\4EA4\7684\9875\9879</strong>\3002</p>'),
'</dd>',
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('\767E\5206\6BD4\56FE\5F62')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\5C06\503C\663E\793A\4E3A\767E\5206\6BD4\56FE\5F62\3002\68C0\7D22\7684\503C\5FC5\987B\4ECB\4E8E 0 \548C 100 \4E4B\95F4\3002')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4417)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\663E\793A\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\6307\5B9A\767E\5206\6BD4\503C\662F\5426\53EF\89C1\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4417)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\80CC\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\80CC\666F\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4417)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\524D\666F\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\524D\666F\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4417)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\6587\672C\989C\8272')
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8F93\5165\6B64\56FE\5F62\7684\6587\672C\6240\7528\7684\989C\8272\3002'),
unistr('\4F7F\7528\5341\516D\8FDB\5236\8868\793A\6CD5, RGB \989C\8272\4EE3\7801\6216 HTML \989C\8272\540D\79F0\6307\5B9A\989C\8272\3002</p>'),
unistr('<p>\5341\516D\8FDB\5236\8868\793A\6CD5\5B9A\4E49\4E3A #xxyyzz (# \540E\8DDF 3 \4E2A\4E24\4F4D\6570\7684\5341\516D\8FDB\5236\6570\5B57), \5176\4E2D xx, yy \548C zz \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\4E24\4E2A\5B57\7B26\7EC4\6210\7684\5341\516D\8FDB\5236\503C\3002'),
unistr('RGB \4EE3\7801\5B9A\4E49\4E3A RGB(xxx,xxx,xxx), \5176\4E2D xxx \662F\4ECB\4E8E 0 \548C 255 \4E4B\95F4\7684\6570\5B57, \5206\522B\8868\793A\7EA2\8272, \7EFF\8272\548C\84DD\8272\7684\5355\4E2A 8 \4F4D\5B57\8282\503C\3002</p>'),
unistr('<p>\5728 Internet \4E0A\641C\7D22 ''HTML \989C\8272\4EE3\7801'' \4EE5\67E5\627E\8981\4F7F\7528\7684\989C\8272\7684\7B49\6548\5341\516D\8FDB\5236\4EE3\7801\6216 RGB \4EE3\7801\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4417)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\6761\5BBD\5EA6')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>unistr('\50CF\7D20')
,p_is_translatable=>false
,p_help_text=>unistr('\8F93\5165\6B64\6761\5F62\56FE\7684\5BBD\5EA6 (\4EE5\50CF\7D20\4E3A\5355\4F4D)\3002')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>unistr('Markdown \7F16\8F91\5668')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E00\4E2A\6587\672C\533A\57DF\FF0C\8BE5\6587\672C\533A\57DF\652F\6301 Markdown \8F93\5165\3001\5E26\6709\6587\672C\683C\5F0F\9009\9879\3001\652F\6301\5305\542B\56FE\50CF\5E76\5177\6709\4E00\4E2A\7528\4E8E\67E5\770B\683C\5F0F\5316\6587\672C\7684\9884\89C8\9009\9879\3002\5728 Markdown \7F16\8F91\5668\4E2D\FF0C\53EF\4EE5\4F7F\7528\6613\4E8E\9605\8BFB\3001\6613\4E8E\7F16\5199\7684\7EAF\6587\672C\8FDB\884C\7F16\5199\FF0C\7136\540E\4F7F\7528\63D0\4F9B\7684\5404\79CD\9009\9879\4EE5\53CA\652F\6301\7684\8BED\6CD5\5C06\5176\8F6C\6362\4E3A\7ED3\6784\4E0A\6709\6548\7684 HTML\3002')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4417)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\5DE5\5177\680F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('\63D0\4F9B\591A\4E2A\7528\4E8E\4E3A Markdown \7F16\8F91\5668\914D\7F6E\5DE5\5177\680F\7684\9009\9879')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\7B80\5355')
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('\5728\5DE5\5177\680F\4E2D\663E\793A\57FA\672C\683C\5F0F\63A7\4EF6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\5B8C\5168')
,p_return_value=>'FULL'
,p_help_text=>unistr('\5728\5DE5\5177\680F\4E2D\663E\793A\4E00\7EC4\5B8C\6574\7684\683C\5F0F\63A7\4EF6\3002')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4417)
,p_display_sequence=>40
,p_display_value=>unistr('\65E0')
,p_return_value=>'NONE'
,p_help_text=>unistr('\9690\85CF\5DE5\5177\680F\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4417)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\8BED\6CD5\7A81\51FA\663E\793A')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\662F\5426\5BF9\7279\5B9A Markdown \5143\7D20\FF08\4F8B\5982\7C97\4F53\3001\659C\4F53\3001\4EE3\7801\5757\7B49\FF09\5E94\7528\8BED\6CD5\7A81\51FA\663E\793A\3002</p>'),
unistr('<p>\7A81\51FA\663E\793A\53EA\5BF9\5728 4000 \5B57\7B26\4EE5\4E0B\7684\5185\5BB9\6709\6548\3002</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4417)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4417)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>\8F93\5165\63A5\53D7 Markdown \7F16\8F91\5668\7684\914D\7F6E\5BF9\8C61\3001\4FEE\6539\5E76\8FD4\56DE\8BE5\5BF9\8C61\7684 JavaScript \51FD\6570\3002\8FD9\6837\FF0C\53EF\4EE5\5BF9 Markdown \7F16\8F91\5668\7684\5916\89C2\3001\529F\80FD\548C\884C\4E3A\FF08\5305\62EC\5DE5\5177\680F\3001\83DC\5355\548C\64CD\4F5C\FF09\8FDB\884C\9AD8\7EA7\5B9A\5236\3002<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4417)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4417)
,p_name=>'markdownified'
,p_display_name=>unistr('\5DF2\91C7\7528 Markdown \8FDB\884C\5904\7406')
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>unistr('\5207\6362')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('\663E\793A\4E3A\7FFB\8F6C\5207\6362\5F00\5173\3002')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\201C\542F\7528\201D\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('\5982\679C\6700\7EC8\7528\6237\9009\53D6<strong>\542F\7528</strong>\9009\9879, \5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\201C\542F\7528\201D\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E3A<strong>\542F\7528</strong>\9009\9879\663E\793A\7684\6587\672C\3002\5982\679C\672A\8F93\5165\6587\672C\FF0C\5219\4F7F\7528\7CFB\7EDF\9ED8\8BA4\6807\7B7E\3002'),
unistr('<p>\6CE8\FF1A\5982\679C\7EC4\4EF6\8BBE\7F6E\201C\663E\793A\6837\5F0F\201D\4E3A<strong>\5207\6362</strong>\FF0C\5219\6B64\5C5E\6027\4EC5\7528\4F5C\4EA4\4E92\5F0F\7F51\683C\5217\7684\663E\793A\503C\3002\5BF9\4E8E\666E\901A\9875\9879\FF0C\5B83\5C06\4E0D\663E\793A\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\201C\7981\7528\201D\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\7528\6237\9009\53D6<strong>\7981\7528</strong>\9009\9879, \5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002</p>'),
unistr('<p><em>\6CE8: \5982\679C\4F7F\7528\4E0E<strong>\201C\542F\7528\201D\503C</strong>\6216<strong>\201C\7981\7528\201D\503C</strong>\5747\4E0D\5339\914D\7684\503C\586B\5145\4E86\9875\9879, \5219\4F7F\7528\6B64\503C\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\201C\7981\7528\201D\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E3A<strong>\7981\7528</strong>\9009\9879\663E\793A\7684\6587\672C\3002\5982\679C\672A\8F93\5165\6587\672C\FF0C\5219\4F7F\7528\7CFB\7EDF\9ED8\8BA4\6807\7B7E\3002'),
unistr('<p>\6CE8\FF1A\5982\679C\7EC4\4EF6\8BBE\7F6E\201C\663E\793A\6837\5F0F\201D\4E3A<strong>\5207\6362</strong>\FF0C\5219\6B64\5C5E\6027\4EC5\7528\4F5C\4EA4\4E92\5F0F\7F51\683C\5217\7684\663E\793A\503C\3002\5BF9\4E8E\666E\901A\9875\9879\FF0C\5B83\5C06\4E0D\663E\793A\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>unistr('\663E\793A\6837\5F0F')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4417)
,p_display_sequence=>5
,p_display_value=>unistr('\5207\6362')
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4417)
,p_display_sequence=>10
,p_display_value=>unistr('\836F\4E38\6309\94AE')
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4417)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4417)
,p_display_sequence=>20
,p_display_value=>unistr('\9009\62E9\5217\8868')
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('\4F7F\7528\9ED8\8BA4\503C')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('\662F\4F7F\7528\5728\201C\5171\4EAB\7EC4\4EF6\201D>\201C\7EC4\4EF6\8BBE\7F6E\201D\4E2D\4E3A\6B64\7EC4\4EF6\5B9A\4E49\7684\9ED8\8BA4\503C\8FD8\662F\4F7F\7528\5B9A\5236\8BBE\7F6E\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('\201C\542F\7528\201D\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('\5982\679C\7528\6237\9009\53D6<strong>\542F\7528</strong>\9009\9879, \5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('\201C\542F\7528\201D\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E3A<strong>\542F\7528</strong>\9009\9879\663E\793A\7684\6587\672C\3002'),
unistr('<p>\6CE8\FF1A\5982\679C\7EC4\4EF6\8BBE\7F6E\201C\663E\793A\6837\5F0F\201D\4E3A<strong>\5207\6362</strong>\FF0C\5219\6B64\5C5E\6027\6CA1\6709\5F71\54CD\3002</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('\201C\7981\7528\201D\503C')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\5982\679C\7528\6237\9009\53D6<strong>\7981\7528</strong>\9009\9879, \5219\8F93\5165\5B58\50A8\5728\9875\9879\4E2D\7684\503C\3002\5982\679C\5E0C\671B\5728\9009\62E9\201C\7981\7528\201D\9009\9879\65F6\5B58\50A8<code>\7A7A\503C</code>, \6B64\5C5E\6027\4E5F\53EF\4EE5\7559\7A7A\3002\8BE5\503C\7684\957F\5EA6\6700\591A\4E3A 255 \4E2A\5B57\7B26\3002</p>'),
unistr('<p><em>\6CE8: \5982\679C\4F7F\7528\4E0E<strong>\201C\542F\7528\201D\503C</strong>\6216<strong>\201C\7981\7528\201D\503C</strong>\5747\4E0D\5339\914D\7684\503C\586B\5145\4E86\9875\9879, \5219\4F7F\7528\6B64\503C\3002</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4417)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4417)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\201C\7981\7528\201D\6807\7B7E')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4417)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8F93\5165\4E3A<strong>\7981\7528</strong>\9009\9879\663E\793A\7684\6587\672C\3002'),
unistr('<p>\6CE8\FF1A\5982\679C\7EC4\4EF6\8BBE\7F6E\201C\663E\793A\6837\5F0F\201D\4E3A<strong>\5207\6362</strong>\FF0C\5219\6B64\5C5E\6027\6CA1\6709\5F71\54CD\3002</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4417)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\684C\9762')
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4417
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4417)
,p_name=>unistr('\6D88\606F')
,p_step_title=>unistr('\6D88\606F')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4417)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
