prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4476
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4476 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4476
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116284119770403980')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'zh-cn'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4476)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113354'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4476)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4476)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4476)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4476)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4476)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4476)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.zh-cn'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4476)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4476)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4476)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4476)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4476)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4476)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.zh-cn'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4476)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4476)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4476)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4476)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4476)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4476)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.zh-cn'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4476)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4476)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.zh-cn'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4476)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4476)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.zh-cn'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4476)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4476)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.zh-cn'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4476)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4476)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4476)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.zh-cn'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4476
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4476)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4476)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4476)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4476
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4476)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4476
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4476)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4476
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4476)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4476
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4476)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4476
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4476)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4476
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4476
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4476)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4476)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4476)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4476)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4476)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4476)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4476)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4476)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4476)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4476)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4476)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4476)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4476)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4476)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4476)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4476)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4476)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4476)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4476)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4476)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4476)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4476)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4476
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4476)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4476)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4476)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4476)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4476)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4476
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4476)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4476
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4476)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4476
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4476)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4476
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4476)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4476
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4476)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4476
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4476)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4476)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4476)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4476)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4476)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4476)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4476)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4476)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4476)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4476
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4476)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4476)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4476)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4476)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4476)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4476)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4476)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4476
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4476)
,p_page_name=>'winlov'
,p_page_title=>unistr('\201C\641C\7D22\201D\5BF9\8BDD\6846')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\641C\7D22')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\5173\95ED')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\4E0B\4E00\6B65 &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \4E0A\4E00\6B65')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\884C #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4476
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4476)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4476
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4476)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4476)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4476)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4476)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4476)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4476)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4476)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4476)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4476)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4476)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4476)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4476)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4476)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4476)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4476)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4476)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4476)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4476)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4476)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4476)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4476)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4476)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4476)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4476)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4476)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4476)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4476)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4476)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4476)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4476)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4476)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4476)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4476)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4476)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4476)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4476)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4476)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4476)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4476)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4476)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4476)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4476)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4476)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4476)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4476)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4476)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4476)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4476)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4476)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4476)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4476)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4476)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4476)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4476)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4476)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4476)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4476)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4476)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4476)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4476)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4476)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4476)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4476)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4476)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4476)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4476)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4476)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4476)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4476)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4476)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4476)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4476)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4476)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4476)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4476)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4476)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4476)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4476)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4476)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4476)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4476)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4476)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4476)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4476)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4476)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4476)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4476)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4476)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4476)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4476)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4476)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4476)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4476)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4476)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4476)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4476)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4476)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4476)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4476)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4476)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4476)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4476)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4476)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4476)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4476)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4476)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4476)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4476)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4476)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4476)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4476)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4476)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4476)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4476)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4476)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4476)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4476)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4476)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4476)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4476)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4476)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4476)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4476)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4476)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4476)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4476)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4476)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4476)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4476)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4476)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4476)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4476)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4476)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4476)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4476)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4476)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4476)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4476)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4476)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4476)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4476)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4476)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4476)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4476)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4476)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4476)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4476)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4476)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4476)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4476)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4476)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4476)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4476)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4476)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4476)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4476)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4476)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4476)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4476)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4476)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4476)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4476)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4476)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4476)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4476)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4476)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4476)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4476)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4476)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4476)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4476)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4476)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773693374402786)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760765620402777)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406\5458')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760649805402777)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817983518402818)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D2\7EDD\8BBF\95EE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777679330402789)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\521B\5EFA\60A8\7684 %0 \5E10\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763254966402779)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237\5DF2\9501\5B9A\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753125503402772)
,p_name=>'AM_PM'
,p_message_language=>'zh-cn'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887510434402869)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895646379402875)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\FF08\6D3B\52A8\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865146759402852)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Ajax \8C03\7528\4E3A%1\8FD4\56DE\4E86\670D\52A1\5668\9519\8BEF%0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795903424402802)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\522B\540D "%0" \65E0\6CD5\8F6C\6362\4E3A\552F\4E00\7684\5E94\7528\7A0B\5E8F ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796085115402802)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\522B\540D\4E3A "%0" \7684\5E94\7528\7A0B\5E8F\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785623353402795)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1816 \8F6C\6362\5E94\7528\7A0B\5E8F\522B\540D p_flow_alias_or_id (%0) \65F6\51FA\73B0\610F\5916\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878510572402862)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\6821\9A8C\548C\63D0\4F9B\4E86\4E00\79CD\7B80\5355\65B9\6CD5\6765\786E\5B9A\662F\5426\8DE8\5DE5\4F5C\533A\90E8\7F72\4E86\540C\4E00\5E94\7528\7A0B\5E8F\3002\60A8\53EF\4EE5\6BD4\8F83\6B64\6821\9A8C\548C\4EE5\786E\5B9A\662F\5426\5B58\5728\5339\914D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771401483402785)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9A8C\8BC1\51FD\6570\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756849718402775)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9A8C\8BC1\51FD\6570\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920382468402893)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Cloud Identity Management \8FD4\56DE\7684\79DF\6237\540D\79F0 %0 \672A\7ECF\8FC7\57DF %1 \7684\6388\6743!<br/>\8BF7<a href="&LOGOUT_URL.">\91CD\65B0\767B\5F55</a>\5E76\6307\5B9A\5DF2\6388\6743\7684\79DF\6237\540D\79F0\6216\8005\66F4\6539 URL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754597023402773)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E10\6237 "%0" \6CA1\6709\5DE5\4F5C\533A "%1" \7684\5FC5\9700\5F00\53D1\6743\9650 (DB_DEVELOPER \6216 DB_ADMINISTRATOR)! <br/>\8BF7\5728\63D0\4F9B\6743\9650\4E4B\540E<a href="&LOGOUT_URL.">\91CD\65B0\767B\5F55</a>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753622914402772)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Oracle Cloud Identity Management \8FD4\56DE\7684\79DF\6237\540D\79F0\672A\7ECF\8FC7\5F53\524D\5DE5\4F5C\533A\7684\6388\6743!<br/> \8BF7<a href="&LOGOUT_URL.">\91CD\65B0\767B\5F55</a>\5E76\6307\5B9A\5DF2\6388\6743\7684\79DF\6237\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754617570402773)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\4E8E\5B89\5168\8003\8651, \4E0D\5141\8BB8\901A\8FC7 URL \4E2D\7684\57DF\8FD0\884C\6B64\5DE5\4F5C\533A\7684\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771124242402785)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8981\6C42\60A8\7684 DBA \8FD0\884C $OH/rdbms/admin/catldap.sql\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771010027402785)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SYS.DBMS_LDAP \5305\4E0D\5B58\5728\6216\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770902508402785)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\7F16\8F91 LDAP \7528\6237\529F\80FD\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771276775402785)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 LDAP \9A8C\8BC1\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772061832402785)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('login_page \8FC7\7A0B\7684 p_flow_page \53C2\6570\4E2D\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771610295402785)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login \4E2D\7684 p_session \65E0\6548 -- p_flow_page:%0 p_session_id:%1\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819584478402819)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('wwv_flow_custom_auth_std.login \7684\53C2\6570\683C\5F0F\4E0D\6B63\786E -- p_flow_page:p_session_id:p_entry_point:%0:%1:%2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771764716402785)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F20\9001\5230\767B\5F55\8FC7\7A0B\7684\7528\6237\540D\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760569138402777)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\7B49\5F85 <span id="apex_login_throttle_sec">%0</span> \79D2\540E\91CD\65B0\767B\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761893760402778)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\963B\6B62\767B\5F55\5C1D\8BD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817375250402817)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\9A8C\8BC1 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762167471402778)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B89\5168\7EC4 ID \4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771549219402785)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\9A8C\8BC1\540E\8FDB\7A0B\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771316353402785)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9A8C\8BC1\524D\8FDB\7A0B\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772532762402786)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\8BF7\5728\542F\52A8\201C\91CD\7F6E\5BC6\7801\201D\8BF7\6C42\7684\540C\4E00\6D4F\89C8\5668\4E2D\6253\5F00\6B64 URL\3002\5982\679C\60A8\5355\51FB\91CD\7F6E\5BC6\7801 URL \5E76\91CD\5B9A\5411\5230'),
unistr('\767B\5F55\9875\FF0C\8BF7\518D\6B21\542F\52A8\201C\91CD\7F6E\5BC6\7801\201D\FF0C\5E76\4F7F\6D4F\89C8\5668\4FDD\6301'),
unistr('\6253\5F00\72B6\6001\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917888456402891)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\5BC6\7801 URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754847682402773)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D44\6E90\7BA1\7406\5668\4F7F\7528\8005\7EC4%0\672A\6388\4E88%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754906591402773)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\4F7F\7528 DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \6388\4E88\7F3A\5C11\7684\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782950725402793)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4F1A\8BDD\536B\58EB\51FD\6570\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783012663402793)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4F1A\8BDD\9A8C\8BC1\51FD\6570\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783257101402793)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8981\6C42\60A8\7684 %0 \7BA1\7406\5458\914D\7F6E Oracle Application Server Single Sign-On \7684\5F15\64CE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792797406402800)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531 sso \8FD4\56DE\7684 %1 \4EE4\724C\4E2D\7684 %0 \975E\6CD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771975267402785)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\7F16\8F91\9A8C\8BC1\65B9\6848\5E76\6DFB\52A0\5E94\7528\7A0B\5E8F\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792441405402800)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \8FC7\7A0B\7684\975E\6CD5\8C03\7528\8005:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792666377402800)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('urlc \6807\8BB0\4E2D\7684\5E94\7528\7A0B\5E8F\4F1A\8BDD\65E0\6548: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792269853402800)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('portal_sso_redirect \4E2D\51FA\9519: \7F3A\5C11\5E94\7528\7A0B\5E8F\6CE8\518C\4FE1\606F: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783135141402793)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('WWSEC_SSO_ENABLER_PRIVATE \5305\4E0D\5B58\5728\6216\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115771858432402785)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5728\9A8C\8BC1\65B9\6848\4E2D\627E\5230\6CE8\518C\7684\5408\4F5C\4F19\4F34\5E94\7528\7A0B\5E8F\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792330264402800)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6309\7167\5B89\88C5\6307\5357\6CE8\518C\6B64\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783344553402793)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406 SSO \9A8C\8BC1\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892774737402873)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6388\6743\7684 URL\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782786458402793)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\9A8C\8BC1\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754784616402773)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A "%0" \4E0D\6D3B\52A8\3002\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755132045402773)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'zh-cn'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761541491402778)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\5B89\5168\68C0\67E5\62D2\7EDD\7684\8BBF\95EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761671971402778)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5B89\5168\68C0\67E5\62D2\7EDD\7684\8BBF\95EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761793568402778)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\6388\6743\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825123987402823)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\8FC7 %1 \7528 %0 \6253\9020')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825224542402823)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7231')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883082600402866)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\8BF4\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882850592402866)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883175497402866)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6 ID')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882713707402866)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882901671402866)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\6807\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773525987402786)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6821\9A8C\548C\5185\5BB9\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773484148402786)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6821\9A8C\548C\683C\5F0F\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837447208402832)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\590D\5236\5230\526A\8D34\677F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837111754402832)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\6D4F\89C8\5668\4E0D\652F\6301\4ECE\6309\94AE\6216\83DC\5355\590D\5236\3002\8BF7\5C1D\8BD5 Ctrl+C \6216 Command+C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825667564402823)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED\901A\77E5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881637194402865)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6BD4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876186431402860)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876042968402860)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880262161402864)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\989C\8272\3002\793A\4F8B\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875970566402860)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\989C\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876269105402860)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\989C\8272\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915489989402890)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915514233402890)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00 %0 \7684\5217\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895782448402875)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\FF08\5DF2\5B8C\6210\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788065785402797)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\4E0E\60A8\7684\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802445859402807)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0E\60A8\7684\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB\3002'),
unistr('\901A\8FC7\8C03\8BD5 ID "%0" \63D0\4F9B\6709\5173\6B64\610F\5916\4E8B\4EF6\7684\8BE6\7EC6\4FE1\606F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880593711402864)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5728\4FDD\5B58\4E4B\524D\66F4\6B63\9519\8BEF\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826581227402824)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230 %0 \4E2A\5339\914D\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826401616402824)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\5339\914D\9879')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896259712402876)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8FDB\5EA6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880982700402864)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('APEX_APPLICATION_TEMP_FILES \4E2D\4E0D\5B58\5728 %0 \9879\4E2D\6307\5B9A\7684\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869456832402855)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7528\6237\5F00\59CB\66F4\65B0\8FC7\7A0B\4EE5\540E, \6570\636E\5E93\4E2D\6570\636E\7684\5F53\524D\7248\672C\5DF2\7ECF\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838511479402833)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\52A0\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885524411402868)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\5904\7406\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885363144402868)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899417661402878)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217\FF1A\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885496080402868)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826969199402824)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\65E5\5386\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749589661402769)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749695853402769)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885729694402868)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885600798402868)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\65E5\671F\FF0C\4F8B\5982 %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753233890402772)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\4ECB\4E8E %0 \548C %1 \4E4B\95F4\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753343159402772)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\7B49\4E8E\6216\665A\4E8E %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753444786402772)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\7B49\4E8E\6216\65E9\4E8E %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830417020402827)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5927\4E8E\6307\5B9A\7684\6700\5927\65E5\671F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830880280402827)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \4E0D\7B26\5408\683C\5F0F%0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830334693402827)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5C0F\4E8E\6307\5B9A\7684\6700\5C0F\65E5\671F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830554271402827)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \4E0D\5728\6709\6548\8303\56F4 %0 \5230 %1 \5185\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830797995402827)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \4E0D\5728\6709\6548\5E74\8303\56F4 %0 \5230 %1 \5185\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880807397402864)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908020444402884)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910073698402886)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880608082402864)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880737528402864)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786916800402796)
,p_name=>'APEX.ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754396210402773)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\9519\8BEF\5904\7406\56DE\8C03\65F6\51FA\73B0\4EE5\4E0B\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763037975402779)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\9519\8BEF\9875\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755077530402773)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\90E8\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894856126402875)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4E0E\60A8\7684\7BA1\7406\5458\8054\7CFB\3002'),
unistr('\901A\8FC7\8C03\8BD5 ID "%0" \63D0\4F9B\6709\5173\6B64\610F\5916\4E8B\4EF6\7684\8BE6\7EC6\4FE1\606F\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889119408402870)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5E93\5DF2\6253\5F00\4F9B\53EA\8BFB\8BBF\95EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919740404402893)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ORA-28353: \65E0\6CD5\6253\5F00 wallet\3002\5E94\7528\7A0B\5E8F\6570\636E\5F53\524D\4E0D\53EF\8BBF\95EE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889250239402870)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62B1\6B49, \6B64\9875\4E0D\53EF\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756700495402775)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6280\672F\4FE1\606F\FF08\4EC5\5BF9\5F00\53D1\4EBA\5458\53EF\89C1\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852864295402843)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF\6D88\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866773491402853)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9700\683C\5F0F\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833418206402829)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\5DF2\5728\8BBF\95EE\63A7\5236\5217\8868\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833304881402829)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\786E\8BA4\5C06\4EE5\4E0B %0 \4E2A\7528\6237\6DFB\52A0\5230 <strong>%1</strong> \8BBF\95EE\63A7\5236\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833886705402829)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\91CD\590D\7684\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833523211402829)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740\4E2D\7F3A\5C11 @ \7B26\53F7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833676135402829)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740\4E2D\7F3A\5C11\53E5\70B9 (.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833708634402829)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\592A\957F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834049646402829)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\6709\5728\5E94\7528\7A0B\5E8F\8BBF\95EE\63A7\5236\5217\8868\4E2D\5B9A\4E49\7684\7528\6237\53EF\4EE5\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834153617402829)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\610F\5916\7684\8BBF\95EE\63A7\5236\5217\8868\8BBE\7F6E\503C\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833949007402829)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\901A\8FC7\9A8C\8BC1\7684\7528\6237\53EF\4EE5\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876776499402861)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876619170402861)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876993695402861)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\FF1A\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876888438402861)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\FF1A\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876529880402860)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6807\8BC6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869693573402855)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826188021402824)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5E94\7528\7B5B\9009\5668 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867256607402853)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752154779402771)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879948057402863)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752296792402771)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878663227402862)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751925864402771)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867725494402854)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867846936402854)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867954967402854)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885108542402868)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762 %0 \5F15\7528\7684\5217 %1 \4E0D\53EF\7528\6216\672A\6388\6743\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742317476402764)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\663E\793A\7684\7B5B\9009\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824377895402822)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\7ED3\679C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824495145402822)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9009\62E9 %0 \4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827008002402824)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8FC7\6EE4\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743801970402765)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B5B\9009\5668\5217\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883661548402866)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8D85\8FC7\9762 %1 \7684\4E0D\540C\503C\9650\5236 (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869235423402855)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9 DATE \6216 TIMESTAMP \5217\4E0D\652F\6301\9762 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867330073402853)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867453717402853)
,p_name=>'APEX.FS.GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868808640402854)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B49\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752938610402772)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752658709402772)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752731299402772)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\4E8E\6216\7B49\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752464984402771)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752545498402772)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\4E8E\6216\7B49\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752832858402772)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934\4E3A %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755351419402774)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\8F93\5165\5B57\6BB5\201D\9762\4E0D\652F\6301 %0 \6570\636E\7C7B\578B (%1)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745528298402766)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\503C\9762\9700\8981 12.2 \6216\66F4\9AD8\7248\672C\7684\6570\636E\5E93\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869082857402855)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\9762 %0 \63D0\4F9B\641C\7D22\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742483435402764)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A\7B5B\9009\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824501546402823)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\5F00\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868533288402854)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5230 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868697282402854)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868721375402854)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4E\4E8E %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824699078402823)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\7EC8\70B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887491341402869)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\9762 %0 \7684 LOV \9879 #%2 ("%1") \65E0\6548\FF08\7F3A\5C11 "|" \5206\9694\7B26\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868932630402855)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8303\56F4\9762 %0 \4E0D\652F\6301\624B\52A8\8F93\5165\FF0C\56E0\4E3A\5217\4E3A DATE \6216 TIMESTAMP\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868274513402854)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5230')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752041810402771)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\56FE\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821145952402820)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867690973402854)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867592493402853)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868443453402854)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751852044402771)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\56FE\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868025704402854)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\66F4\5C11')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868139382402854)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\66F4\591A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115868360686402854)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \661F\53CA\66F4\9AD8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826074244402824)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B5B\9009\5EFA\8BAE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869142682402855)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\4EC5\5BF9 NUMBER \5217\652F\6301\6587\672C\5B57\6BB5\9762 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742228597402764)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\884C\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885274298402868)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9762\641C\7D22\4E0D\652F\6301 %0 \6570\636E\7C7B\578B (%1)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877108212402861)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\5230\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834723607402830)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842330691402835)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\53E0\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834840814402830)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842248387402835)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920981111402894)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842027607402835)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664 %0 \884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912411791402887)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\7684\8EAB\4EFD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831760230402828)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835024729402830)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\6807\9898\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834904643402830)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831832778402828)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851869930402842)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\66F4\591A\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831532791402828)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835103449402830)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831918770402828)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'zh-cn'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832093552402828)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'zh-cn'
,p_message_text=>'%0 - %1/%2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888073017402870)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9875')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831608338402828)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912235393402887)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6DFB\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912354990402887)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\6539')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920719004402893)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0\FF0C\5217 %1\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920826549402894)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912169661402887)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835382690402830)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6807\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830980582402827)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\5B9A\4E86 %0 \4E2A\5355\5143')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832103351402828)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\9009\62E9 %0 \884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872423121402857)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\9009')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842138705402835)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835247701402830)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835472436402830)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835530137402830)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831002123402827)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831338571402828)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831124291402827)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831402681402828)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F\6392\5E8F %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115831273886402827)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841920267402835)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\8BA1 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768317328402783)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9 "%0" \7684 HTTP \8BF7\6C42\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909666080402885)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\9009\62E9\5217\8868 %0 \5217 %1 \884C\3002\4F7F\7528\7BAD\5934\952E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841869498402835)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217\8868 %0 \884C\3002\4F7F\7528\7BAD\5934\952E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920570276402893)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828600896402826)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829620866402826)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829586468402826)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914089637402889)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899518741402878)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901241491402879)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857673078402846)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\6587\672C\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858840790402847)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859949575402848)
,p_name=>'APEX.IG.AND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879308334402863)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8FD1\4F3C\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915092074402889)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\4E0D\540C\503C\8FD1\4F3C\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898143865402877)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9762\79EF\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900084721402878)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858964126402847)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6388\6743')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914195734402889)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\81EA\52A8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879735683402863)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914726849402889)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\5E73\5747\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897653667402877)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\8F74\6807\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897841305402877)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\6570\4F4D\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897703983402877)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\8F74\6807\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903893751402881)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898255255402877)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854245068402844)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECB\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905097605402882)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E24\8005')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898370545402877)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C14\6CE1\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829801424402826)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859879379402848)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\5206\5927\5C0F\5199')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915637317402890)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\533A\5206\5927\5C0F\5199)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886543488402869)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\5DF2\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830299918402827)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860972387402849)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857459988402846)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\67E5\8BE2\8D85\8FC7\4E86\6BCF\4E2A\56FE\8868\7684\6700\5927\6570\636E\70B9\6570 %0\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\57FA\672C\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828585553402826)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835843158402831)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897104093402876)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\76D8\4EF7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904090125402881)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\989C\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880167158402864)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\89C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859281249402848)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828713146402826)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905846063402883)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\7528\9014')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859388309402848)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\6742')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828912625402826)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854840936402844)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861174859402849)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835697011402831)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\5230\526A\8D34\677F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835707871402831)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B\590D\5236')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879199412402863)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879295251402863)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914921992402889)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\4E0D\540C\503C\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914842011402889)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\8BA1\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912581287402887)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857857463402847)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905664918402883)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905277635402882)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886387899402868)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\503C\65E0\6548')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855581730402845)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858547649402847)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858349248402847)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829773931402826)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906843655402883)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\786E\5B9A\8981\5220\9664\6B64\62A5\8868?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862957967402850)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861793891402849)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900185930402879)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860643738402849)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\4FE1\606F')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828236983402825)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE6\7EC6\8D44\6599\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888843269402870)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860344477402848)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854999280402844)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5305\542B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855156790402845)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934\4E0D\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898416600402877)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5706\73AF\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861369088402849)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760084583402777)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907879902402884)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772688599402786)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\542F\7528\4E0B\8F7D\683C\5F0F %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900847451402879)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\7684\805A\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900973602402879)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D\7684\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862868175402850)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861621969402849)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\590D\5236\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829399128402826)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899941536402878)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\56FE\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911418377402887)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5206\7EC4\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907443420402884)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\4EF6\6284\9001 (bcc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907647032402884)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907326564402884)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6284\9001 (cc)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907012125402884)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5DF2\53D1\9001\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907550646402884)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907207924402884)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\4EF6\4EBA (to)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860092745402848)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853249797402843)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B49\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906492234402883)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860194289402848)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906348760402883)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872337109402857)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\5DF2\51C6\5907\597D\3002\6B63\5728\5F00\59CB\4E0B\8F7D\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115835976891402831)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837055522402832)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\9009\62E9\7684\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836932274402831)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\586B\5145\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828825615402826)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859417945402848)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914457032402889)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900330932402879)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829038140402826)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857974781402847)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904930476402882)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906706403402883)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'zh-cn'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906667175402883)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'zh-cn'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819450847402819)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'zh-cn'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758753785402776)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'zh-cn'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862553494402850)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51BB\7ED3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860215332402848)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570\548C\8FD0\7B97\7B26')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898524695402877)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6F0F\6597\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879078632402863)
,p_name=>'APEX.IG.GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853835300402844)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853902777402844)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\4E8E\7B49\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860503094402849)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828097404402825)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F51\683C\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901126299402879)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860786881402849)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828332663402825)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905553176402882)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\4EF6\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904439774402882)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904606452402882)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898\5BF9\9F50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914300797402889)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909887343402886)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53EF\4EE5\76F4\63A5\5728\6B64\4EA4\4E92\5F0F\7F51\683C\4E2D\63D2\5165, \66F4\65B0\548C\5220\9664\6570\636E\3002</p>'),
'',
unistr('<p>\5355\51FB\201C\6DFB\52A0\884C\201D\6309\94AE\53EF\63D2\5165\65B0\884C\3002</p>'),
'',
unistr('<p>\53CC\51FB\7279\5B9A\5355\5143\53EF\7F16\8F91\73B0\6709\6570\636E\3002\5BF9\4E8E\8F83\5927\91CF\7684\7F16\8F91\5DE5\4F5C, \5355\51FB\201C\7F16\8F91\201D\53EF\8FDB\5165\7F16\8F91\6A21\5F0F\3002\5728\7F16\8F91\6A21\5F0F\4E2D, \53EF\4EE5\5355\51FB\6216\4F7F\7528\952E\76D8\6765\7F16\8F91\7279\5B9A\5355\5143\3002</p>'),
'',
unistr('<p>\4F7F\7528\201C\66F4\6539\201D\83DC\5355\53EF\590D\5236\548C\5220\9664\884C\3002\8981\542F\7528\201C\66F4\6539\201D\83DC\5355, \8BF7\4F7F\7528\590D\9009\6846\6765\9009\62E9\4E00\884C\6216\591A\884C\3002</p>'),
'',
unistr('<p>\5355\51FB\201C\66F4\6539\201D\83DC\5355\5E76\9009\62E9\201C\590D\5236\884C\201D\53EF\590D\5236\6240\9009\884C\3002\5355\51FB\201C\66F4\6539\201D\83DC\5355\5E76\9009\62E9\201C\5220\9664\884C\201D\53EF\5220\9664\6240\9009\884C\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911999428402887)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912014718402887)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4EA4\4E92\5F0F\7F51\683C\5728\53EF\641C\7D22, \53EF\5B9A\5236\7684\62A5\8868\4E2D\5448\73B0\4E00\7EC4\6570\636E\3002\60A8\53EF\4EE5\6267\884C\5404\79CD\64CD\4F5C\6765\9650\5236\8FD4\56DE\7684\8BB0\5F55, \5E76\66F4\6539\6570\636E\7684\663E\793A\65B9\5F0F\3002</p>'),
'',
unistr('<p>\4F7F\7528\201C\641C\7D22\201D\5B57\6BB5\53EF\4EE5\8FC7\6EE4\8FD4\56DE\7684\8BB0\5F55\3002\5355\51FB\201C\64CD\4F5C\201D\53EF\4EE5\8BBF\95EE\7528\4E8E\4FEE\6539\62A5\8868\5E03\5C40\7684\5404\79CD\9009\9879, \6216\8005\5728\663E\793A\7684\5217\4E0A\4F7F\7528\201C\5217\6807\9898\201D\83DC\5355\3002</p>'),
'',
unistr('<p>\4F7F\7528\201C\62A5\8868\8BBE\7F6E\201D\53EF\4FDD\5B58\5BF9\62A5\8868\6240\505A\7684\5B9A\5236\8BBE\7F6E\3002\8FD8\53EF\4EE5\4ECE\62A5\8868\4E2D\5C06\6570\636E\4E0B\8F7D\5230\5916\90E8\6587\4EF6, \6216\8005\901A\8FC7\7535\5B50\90AE\4EF6\5C06\6570\636E\53D1\9001\7ED9\60A8\81EA\5DF1\6216\5176\4ED6\4EBA\3002</p>'),
'',
unistr('<p>\5982\9700\4E86\89E3\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605 <em>Oracle Application Express End User''s Guide</em> \4E2D\7684 "Using Interactive Grids"\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911792810402887)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6982\89C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909776253402885)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\53EF\4EE5\4F7F\7528\5185\7F6E\529F\80FD\5B9A\5236\4EA4\4E92\5F0F\7F51\683C\FF0C\4F7F\5176\4EE5\5404\79CD\4E0D\540C\65B9\5F0F\663E\793A\6570\636E\3002</p>'),
'',
unistr('<p>\4F7F\7528\201C\5217\6807\9898\201D\83DC\5355\6216\201C\64CD\4F5C\201D\83DC\5355\53EF\786E\5B9A\8981\663E\793A\7684\5217\FF0C\4F7F\7528\4EC0\4E48\987A\5E8F\548C\51BB\7ED3\5217\3002\8FD8\53EF\4EE5\5B9A\4E49\5404\79CD\6570\636E\7B5B\9009\5668\5E76\5BF9\8FD4\56DE\7684\6570\636E\8FDB\884C\6392\5E8F\3002</p>'),
'',
unistr('<p>\4F7F\7528\201C\89C6\56FE\201D\6309\94AE\FF08\9760\8FD1\201C\641C\7D22\201D\5B57\6BB5\FF09\53EF\8BBF\95EE\53EF\80FD\7531\5E94\7528\7A0B\5E8F\5F00\53D1\4EBA\5458\5B9A\4E49\7684\5176\4ED6\6570\636E\89C6\56FE\3002\8FD8\53EF\4EE5\521B\5EFA\56FE\8868\6216\67E5\770B\73B0\6709\56FE\8868\3002</p>  '),
'',
unistr('<p><em>\6CE8\FF1A\5728\4EA4\4E92\5F0F\7F51\683C\5BF9\8BDD\6846\4E2D\5355\51FB<strong>\5E2E\52A9</strong>\53EF\83B7\53D6\6709\5173\6240\9009\529F\80FD\7684\66F4\8BE6\7EC6\4FE1\606F\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911807133402887)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\544A\529F\80FD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861516894402849)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\4EA4\4E92\5F0F\7F51\683C\201D\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908652611402885)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\805A\96C6\5217\3002\805A\96C6\503C\663E\793A\5728\6570\636E\7684\5E95\90E8\FF1B\5728\5B9A\4E49\4E86\63A7\5236\5206\6BB5\7684\60C5\51B5\4E0B\FF0C\663E\793A\5728\6BCF\4E2A\5206\6BB5\7684\5E95\90E8\3002</p>'),
'',
unistr('<p><strong>\201C\805A\96C6\201D\5217\8868</strong><br>'),
unistr('\201C\805A\96C6\201D\5217\8868\663E\793A\5B9A\4E49\7684\805A\96C6\3002\53D6\6D88\9009\62E9\4E00\4E2A\73B0\6709\805A\96C6\53EF\7981\7528\8BE5\805A\96C6\3002<br>'),
unistr('\5355\51FB\201C\6DFB\52A0\201D( &plus; ) \53EF\521B\5EFA\65B0\805A\96C6\FF0C\5355\51FB\201C\5220\9664\201D( &minus; ) \53EF\5220\9664\73B0\6709\805A\96C6\3002</p>'),
'',
unistr('<p><strong>\805A\96C6\8BBE\7F6E</strong><br>'),
unistr('\4F7F\7528\53F3\4FA7\7684\8868\5355\53EF\5B9A\4E49\805A\96C6\3002<br>'),
unistr('\9009\62E9\5217\540D\548C\805A\96C6\7C7B\578B\3002<br>'),
unistr('\FF08\53EF\9009\FF09\8F93\5165\805A\96C6\7684\5DE5\5177\63D0\793A\3002<br>'),
unistr('\5982\679C\5B9A\4E49\4E86\63A7\5236\5206\6BB5\FF0C\5219\9009\62E9<strong>\663E\793A\603B\4F53\503C</strong>\5C06\5728\6570\636E\5E95\90E8\663E\793A\603B\4F53\5E73\5747\503C\FF0C\603B\8BA1\6216\7C7B\4F3C\503C\3002</p>'),
'',
unistr('<p><em>\6CE8\FF1A\5728\201C\64CD\4F5C\201D\83DC\5355\4E2D\8BBF\95EE\201C\805A\96C6\201D\5BF9\8BDD\6846\FF0C\6216\8005\901A\8FC7\5355\51FB\5217\6807\9898\548C\201C\603B\548C\201D( &sum; ) \6765\8BBF\95EE\8BE5\5BF9\8BDD\6846\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910814647402886)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909376886402885)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\5B9A\4E49\4F5C\4E3A\5355\72EC\6570\636E\89C6\56FE\663E\793A\7684\56FE\8868\3002<br>'),
unistr('\9009\62E9\56FE\8868\7C7B\578B\548C\56FE\8868\5C5E\6027\3002</p>'),
unistr('<p><strong>\56FE\8868\5C5E\6027</strong></br>'),
unistr('\53EF\7528\7684\56FE\8868\5C5E\6027\56E0\56FE\8868\7C7B\578B\800C\5F02\3002</p>'),
'<p>',
'<ul>',
unistr('  <li>\9009\62E9\5305\542B\5C5E\6027\503C\7684\5217\FF1A'),
'    <ul>',
unistr('      <li>\6807\7B7E - \6BCF\4E2A\6570\636E\70B9\7684\6587\672C\3002</li>'),
unistr('      <li>\503C - \8981\7ED8\56FE\7684\6570\636E\3002</li>'),
unistr('      <li>\7CFB\5217 - \7528\4E8E\5B9A\4E49\591A\7CFB\5217\52A8\6001\67E5\8BE2\3002</li>'),
unistr('      <li>\5F00\76D8\4EF7 - \6BCF\65E5\80A1\7968\5F00\76D8\4EF7\FF08\4EC5\9650\80A1\7968\FF09\3002</li>'),
unistr('      <li>\6536\76D8\4EF7 - \6BCF\65E5\80A1\7968\6536\76D8\4EF7\FF08\4EC5\9650\80A1\7968\FF09\3002</li>'),
unistr('      <li>\9AD8\70B9 - \4E0A\9650\503C\FF08\4EC5\9650\8303\56F4\548C\80A1\7968\FF09\3002</li>'),
unistr('      <li>\4F4E\70B9 - \4E0B\9650\503C\FF08\4EC5\9650\8303\56F4\548C\80A1\7968\FF09\3002</li>'),
unistr('      <li>\6210\4EA4\91CF - \6BCF\65E5\80A1\7968\6210\4EA4\91CF\FF08\4EC5\9650\80A1\7968\FF09\3002</li>'),
unistr('      <li>\76EE\6807 - \76EE\6807\503C\FF08\4EC5\9650\6F0F\6597\56FE\FF09\3002</li>'),
unistr('      <li>X - x \8F74\503C\FF08\4EC5\9650\6C14\6CE1\56FE\548C\6563\70B9\56FE\FF09\3002</li>'),
unistr('      <li>Y - y \8F74\503C\FF08\4EC5\9650\6C14\6CE1\56FE\548C\6563\70B9\56FE\FF09\3002</li>'),
unistr('      <li>Z - \6761\5BBD\5EA6\6216\6C14\6CE1\534A\5F84\FF08\4EC5\9650\6761\5F62\56FE\3001\6C14\6CE1\56FE\548C\8303\56F4\FF09\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\65B9\5411 - \5782\76F4\6216\6C34\5E73\3002</li>'),
unistr('  <li>\805A\96C6 - \9009\62E9\5982\4F55\805A\96C6\56FE\8868\503C\3002</li>'),
unistr('  <li>\5806\53E0 - \6307\5B9A\662F\5426\5806\53E0\6570\636E\9879\3002</li>'),
unistr('  <li>\6392\5E8F\65B9\5F0F - \6309\6807\7B7E\6216\503C\6392\5E8F\3002'),
'    <ul>',
unistr('      <li>\65B9\5411 - \6309\503C\7684\5347\5E8F\6216\964D\5E8F\6392\5E8F\3002</li>'),
unistr('      <li>\7A7A\503C - \6307\5B9A\7A7A\503C\8BB0\5F55\5728\6392\5E8F\65F6\76F8\5BF9\4E8E\975E\7A7A\503C\8BB0\5F55\7684\4F4D\7F6E\3002</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\5C0F\6570\4F4D\6570</li>'),
unistr('  <li>\6807\7B7E\8F74\6807\9898</li>'),
unistr('  <li>\503C\8F74\6807\9898</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911262950402887)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908386631402884)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\9009\62E9\663E\793A\54EA\4E9B\5217\4EE5\53CA\6309\7167\4EC0\4E48\987A\5E8F\663E\793A\3002</p>'),
'',
unistr('<p>\53D6\6D88\9009\62E9\67D0\5217\53EF\9690\85CF\8BE5\5217\3002<br>'),
unistr('\901A\8FC7\5355\51FB\201C\4E0A\79FB\201D(&uarr;) \6216\201C\4E0B\79FB\201D(&darr;) \6765\5BF9\5217\91CD\65B0\6392\5E8F\3002<br>'),
unistr('\4F7F\7528\4E0B\62C9\9009\62E9\5668\53EF\5217\51FA\6240\6709\5217\3001\663E\793A\7684\5217\6216\672A\663E\793A\7684\5217\3002</p>'),
'',
unistr('<p>\FF08\53EF\9009\FF09\4F7F\7528\8868\5355\53EF\6307\5B9A\5217\7684\6700\5C0F\5BBD\5EA6\FF08\4EE5\50CF\7D20\4E3A\5355\4F4D\FF09\3002</p>'),
'',
unistr('<p><em>\6CE8\FF1A\8FD8\53EF\4EE5\901A\8FC7\5355\51FB\62D6\52A8\624B\67C4\FF08\4F4D\4E8E\5217\6807\9898\7684\5F00\5934\FF09\5E76\5411\5DE6\6216\5411\53F3\62D6\52A8\5217\FF0C\5BF9\6240\663E\793A\7684\5217\91CD\65B0\6392\5E8F\3002\53E6\5916\FF0C\53EF\4EE5\901A\8FC7\9009\62E9\4F4D\4E8E\6807\9898\4E4B\95F4\7684\5217\5206\9694\7B26\5E76\5C06\5176\5411\5DE6\6216\5411\53F3\79FB\52A8\FF0C\66F4\6539\6240\663E\793A\5217\7684\5217\5BBD\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911147601402886)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908738678402885)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\57FA\4E8E\5BF9\73B0\6709\5217\6267\884C\7684\6570\5B66\548C\51FD\6570\8BA1\7B97\5B9A\4E49\989D\5916\7684\5217\3002</p>'),
'',
unistr('<p><strong>\201C\8BA1\7B97\201D\5217\8868</strong><br>'),
unistr('\201C\8BA1\7B97\201D\5217\8868\663E\793A\5B9A\4E49\7684\8BA1\7B97\3002\53D6\6D88\9009\62E9\4E00\4E2A\73B0\6709\8BA1\7B97\53EF\7981\7528\8BE5\8BA1\7B97\3002<br>'),
unistr('\5355\51FB\201C\6DFB\52A0\201D( &plus; ) \53EF\6DFB\52A0\65B0\8BA1\7B97\FF0C\5355\51FB\201C\5220\9664\201D( &minus; ) \53EF\5220\9664\73B0\6709\8BA1\7B97\3002</p>'),
'',
unistr('<p><strong>\8BA1\7B97\8BBE\7F6E</strong><br>'),
unistr('\4F7F\7528\8868\5355\53EF\5B9A\4E49\8BA1\7B97\3002<br>'),
unistr('\8F93\5165\5217\8BE6\7EC6\4FE1\606F\FF0C\4F8B\5982\6807\9898\3001\6807\7B7E\FF0C\7136\540E\9009\62E9\5BF9\9F50\8BBE\7F6E\3002<br> '),
unistr('\4F7F\7528\201C\8868\8FBE\5F0F\201D\6587\672C\533A\57DF\4E3A\8BA1\7B97\8F93\5165\5217\548C\5173\8054\7684\51FD\6570\3002<br>'),
unistr('\4E3A\65B0\5217\9009\62E9\76F8\5E94\7684\6570\636E\7C7B\578B\FF0C\4EE5\53CA\53EF\9009\7684\683C\5F0F\63A9\7801\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910724974402886)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909092069402885)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\5728\4E00\5217\6216\591A\5217\4E0A\5B9A\4E49\63A7\5236\5206\6BB5\3002</p>'),
'',
unistr('<p><strong>\201C\63A7\5236\5206\6BB5\201D\5217\8868</strong><br>'),
unistr('\201C\63A7\5236\5206\6BB5\201D\5217\8868\663E\793A\5B9A\4E49\7684\63A7\5236\5206\6BB5\3002\53D6\6D88\9009\62E9\4E00\4E2A\73B0\6709\63A7\5236\5206\6BB5\53EF\7981\7528\8BE5\63A7\5236\5206\6BB5\3002<br>'),
unistr('\5355\51FB\201C\6DFB\52A0\201D( &plus; ) \53EF\5728\63A7\5236\5206\6BB5\4E2D\5305\62EC\65B0\5217\FF0C\5355\51FB\201C\5220\9664\201D( &minus; ) \53EF\4ECE\63A7\5236\5206\6BB5\4E2D\5220\9664\73B0\6709\5217\3002<br>'),
unistr('\8981\5BF9\5217\91CD\65B0\6392\5E8F\FF0C\8BF7\5355\51FB\201C\4E0A\79FB\201D( &uarr; ) \6216\201C\4E0B\79FB\201D( &darr; ) \4EE5\5C06\6240\9009\5217\76F8\5BF9\4E8E\5176\4ED6\5217\4E0A\79FB\548C\4E0B\79FB\3002</p>'),
'',
unistr('<p><strong>\63A7\5236\5206\6BB5\8BBE\7F6E</strong><br>'),
unistr('\4F7F\7528\8868\5355\53EF\5B9A\4E49\63A7\5236\5206\6BB5\5217\3002<br>'),
unistr('\9009\62E9\4E00\4E2A\63A7\5236\5206\6BB5\5217\FF0C\6392\5E8F\65B9\5411\4EE5\53CA\7A7A\503C\5217\FF08\6CA1\6709\4EFB\4F55\503C\7684\5217\FF09\7684\6392\5E8F\65B9\5F0F\3002</p>'),
'',
unistr('<p><em>\6CE8\FF1A\67E5\770B\4EA4\4E92\5F0F\7F51\683C\65F6\FF0C\53EF\4EE5\901A\8FC7\5355\51FB\201C\5217\6807\9898\201D\5E76\9009\62E9\63A7\5236\5206\6BB5\56FE\6807\6765\5B9A\4E49\63A7\5236\5206\6BB5\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910461598402886)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909279610402885)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\5C06\6240\6709\5F53\524D\884C\4E0B\8F7D\5230\5916\90E8\6587\4EF6\3002\8BE5\6587\4EF6\5C06\53EA\5305\542B\5F53\524D\663E\793A\7684\5217, \5E76\4F7F\7528\5E94\7528\5230\6570\636E\7684\6240\6709\8FC7\6EE4\5668\548C\6392\5E8F\3002</p>'),
'',
unistr('<p>\9009\62E9\6587\4EF6\683C\5F0F\5E76\5355\51FB\201C\4E0B\8F7D\201D\3002<br>'),
unistr('\6CE8: CSV \5C06\4E0D\5305\62EC\6587\672C\683C\5F0F\8BBE\7F6E, \4F8B\5982\805A\96C6\548C\63A7\5236\5206\6BB5\3002</p>'),
'',
unistr('<p>\8981\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001\6587\4EF6, \8BF7\9009\62E9\201C\4F5C\4E3A\7535\5B50\90AE\4EF6\53D1\9001\201D\5E76\8F93\5165\7535\5B50\90AE\4EF6\8BE6\7EC6\4FE1\606F (\6536\4EF6\4EBA, \4E3B\9898\548C\90AE\4EF6)\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910212012402886)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908448245402885)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\914D\7F6E\6570\636E\7B5B\9009\5668\6765\9650\5236\6240\8FD4\56DE\7684\884C\3002</p>'),
'',
unistr('<p><strong>\201C\7B5B\9009\5668\201D\5217\8868</strong><br>'),
unistr('\201C\7B5B\9009\5668\201D\5217\8868\663E\793A\5B9A\4E49\7684\7B5B\9009\5668\3002\53D6\6D88\9009\62E9\4E00\4E2A\73B0\6709\7B5B\9009\5668\53EF\7981\7528\8BE5\7B5B\9009\5668\3002<br>'),
unistr('\5355\51FB\201C\6DFB\52A0\201D( &plus; ) \53EF\521B\5EFA\65B0\7B5B\9009\5668\FF0C\5355\51FB\201C\5220\9664\201D( &minus; ) \53EF\5220\9664\73B0\6709\7B5B\9009\5668\3002</p>'),
'',
unistr('<p><strong>\7B5B\9009\5668\8BBE\7F6E</strong><br>'),
unistr('\4F7F\7528\8868\5355\53EF\5B9A\4E49\7B5B\9009\5668\5C5E\6027\3002<br>'),
unistr('\9009\62E9\5408\9002\7684\7B5B\9009\5668\7C7B\578B\FF1A<br>'),
unistr('&nbsp;&nbsp;&nbsp;\884C - \7B5B\9009\4EFB\610F\53EF\7B5B\9009\5217\4E2D\7684\8BCD\8BED\3002<br>'),
unistr('&nbsp;&nbsp;&nbsp;\5217 - \4F7F\7528\6307\5B9A\7684\8FD0\7B97\7B26\548C\503C\7B5B\9009\7279\5B9A\5217\3002</p>'),
'',
unistr('<p><em>\6CE8\FF1A\67E5\770B\4EA4\4E92\5F0F\7F51\683C\65F6\FF0C\53EF\4EE5\901A\8FC7\76F4\63A5\5728\201C\641C\7D22\201D\5B57\6BB5\4E2D\952E\5165\6765\5B9A\4E49\884C\7B5B\9009\5668\3002\5355\51FB\201C\9009\62E9\8981\641C\7D22\7684\5217\201D\53EF\5C06\641C\7D22\8303\56F4\9650\5236\4E3A\7279\5B9A\5217\3002\6B64\5916\FF0C\6253\5F00\201C\5217\6807\9898\201D\83DC\5355\5E76\9009\62E9\4E00\4E2A\503C\53EF\4EE5\521B\5EFA\5217\7B5B\9009\5668\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911061939402886)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908835144402885)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\67E5\770B\4E4B\524D\7684\67D0\4E2A\65F6\95F4\70B9\4E0A\5B58\5728\7684\6570\636E\3002</p>'),
unistr('<p>\8F93\5165\8FC7\53BB\7684\5206\949F\6570\53EF\4EE5\6267\884C\95EA\56DE\67E5\8BE2\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910634725402886)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911362650402887)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908952103402885)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\57FA\4E8E\8F93\5165\7684\6761\4EF6\7A81\51FA\663E\793A\6570\636E\884C\6216\5217\3002</p>'),
'',
unistr('<p><strong>\201C\7A81\51FA\663E\793A\201D\5217\8868</strong><br>'),
unistr('\201C\7A81\51FA\663E\793A\201D\5217\8868\663E\793A\5B9A\4E49\7684\7A81\51FA\663E\793A\3002\53D6\6D88\9009\62E9\4E00\4E2A\73B0\6709\7684\7A81\51FA\663E\793A\53EF\7981\7528\8BE5\7A81\51FA\663E\793A\3002<br>'),
unistr('\5355\51FB\201C\6DFB\52A0\201D( &plus; ) \53EF\521B\5EFA\65B0\7A81\51FA\663E\793A\FF0C\5355\51FB\201C\5220\9664\201D( &minus; ) \53EF\5220\9664\73B0\6709\7A81\51FA\663E\793A\3002</p>'),
'',
unistr('<p><strong>\7A81\51FA\663E\793A\8BBE\7F6E</strong><br>'),
unistr('\4F7F\7528\8868\5355\53EF\5B9A\4E49\7A81\51FA\663E\793A\5C5E\6027\3002<br>'),
unistr('\8F93\5165\540D\79F0\FF0C\9009\62E9\201C\884C\201D\6216\201C\5217\201D\FF0C\7136\540E\4E3A\80CC\666F\548C\6587\672C\9009\62E9 HTML \989C\8272\4EE3\7801\3002<br>'),
unistr('\9009\62E9\76F8\5E94\7684<strong>\6761\4EF6\7C7B\578B</strong>\53EF\7A81\51FA\663E\793A\7279\5B9A\6570\636E\FF1A<br>'),
unistr('&nbsp;&nbsp;&nbsp;\884C - \7A81\51FA\663E\793A\4EFB\610F\5217\4E2D\7684\8BCD\8BED\3002<br>'),
unistr('&nbsp;&nbsp;&nbsp;\5217 - \6839\636E\6307\5B9A\7684\8FD0\7B97\7B26\548C\503C\7A81\51FA\663E\793A\7279\5B9A\5217\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910519158402886)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909122482402885)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\4FDD\5B58\5BF9\5F53\524D\7F51\683C\5E03\5C40\548C\914D\7F6E\8FDB\884C\7684\66F4\6539\3002<br>'),
unistr('\5E94\7528\7A0B\5E8F\5F00\53D1\4EBA\5458\53EF\4EE5\5B9A\4E49\591A\4E2A\66FF\4EE3\62A5\8868\5E03\5C40\3002\5728\5141\8BB8\7684\60C5\51B5\4E0B\FF0C\60A8\548C\5176\4ED6\6700\7EC8\7528\6237\53EF\5C06\62A5\8868\4FDD\5B58\4E3A\201C\516C\5171\201D\62A5\8868\FF0C\8FD9\4F7F\5F97\8BE5\62A5\8868\5BF9\7F51\683C\7684\6240\6709\5176\4ED6\7528\6237\53EF\7528\3002\60A8\8FD8\53EF\4EE5\5C06\62A5\8868\4FDD\5B58\4E3A\53EA\6709\60A8\624D\80FD\67E5\770B\7684\201C\4E13\7528\201D\62A5\8868\3002</p>'),
unistr('<p>\4ECE\53EF\7528\7C7B\578B\4E2D\9009\62E9\FF0C\5E76\8F93\5165\6240\4FDD\5B58\62A5\8868\7684\540D\79F0\3002</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910391147402886)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\62A5\8868\5E2E\52A9'),
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908548984402885)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\6B64\5BF9\8BDD\6846\53EF\4EE5\8BBE\7F6E\663E\793A\987A\5E8F\3002</p>'),
'',
unistr('<p><strong>\201C\6392\5E8F\201D\5217\8868</strong><br>'),
unistr('\201C\6392\5E8F\201D\5BF9\8BDD\6846\663E\793A\914D\7F6E\7684\6392\5E8F\89C4\5219\5217\8868\3002<br>'),
unistr('\5355\51FB\201C\6DFB\52A0\201D( &plus; ) \53EF\521B\5EFA\6392\5E8F\5217\FF0C\5355\51FB\201C\5220\9664\201D( &minus; ) \53EF\5220\9664\6392\5E8F\5217\3002<br>'),
unistr('\5355\51FB\201C\4E0A\79FB\201D( &uarr; ) \548C\201C\4E0B\79FB\201D( &darr; ) \53EF\5C06\6240\9009\6392\5E8F\5217\76F8\5BF9\4E8E\5176\4ED6\6392\5E8F\5217\4E0A\79FB\548C\4E0B\79FB\3002</p>'),
'',
unistr('<p><strong>\6392\5E8F\8BBE\7F6E</strong><br>'),
unistr('\9009\62E9\4E00\4E2A\6392\5E8F\5217\FF0C\6392\5E8F\65B9\5411\4EE5\53CA\7A7A\503C\5217\FF08\6CA1\6709\4EFB\4F55\503C\7684\5217\FF09\7684\6392\5E8F\65B9\5F0F</p>'),
'',
unistr('<p><em>\6CE8\FF1A\6570\636E\53EF\6309\7167\672A\663E\793A\7684\5217\6392\5E8F\3002\4F46\662F\FF0C\5E76\975E\6240\6709\5217\5747\53EF\6392\5E8F\3002</em><br>'),
unistr('<em>\901A\8FC7\6309\5217\6807\9898\672B\5C3E\7684\4E0A\7BAD\5934\FF08\5347\5E8F\FF09\6216\4E0B\7BAD\5934\FF08\964D\5E8F\FF09\FF0C\53EF\5BF9\663E\793A\7684\5217\8FDB\884C\6392\5E8F\3002\8981\5C06\540E\7EED\7684\5217\6DFB\52A0\5230\73B0\6709\6392\5E8F\4E2D\FF0C\8BF7\6309\4F4F Shift \952E\5E76\5355\51FB\4E0A\7BAD\5934\6216\4E0B\7BAD\5934\3002</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910905834402886)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115910153557402886)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862486210402850)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829247896402826)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897254053402876)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\70B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898062940402877)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855458377402845)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860469192402848)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828158510402825)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853629140402843)
,p_name=>'APEX.IG.IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862060793402850)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\6D3B\52A8\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862199447402850)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\6D3B\52A8\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869782852402855)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\4EA4\4E92\5F0F\7F51\683C\8BF7\6C42\65F6\51FA\73B0\5185\90E8\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765528063402781)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 "%1" \4E0D\652F\6301\5217\8FC7\6EE4\5668\7C7B\578B "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909933071402886)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F\683C\5F0F\65E0\6548')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884179810402867)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C\4E0D\652F\6301\5728\5217 %0 \4E0A\5B9A\4E49\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884082251402867)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\662F\7528\4E8E\5B9A\4E49\4EA4\4E92\5F0F\7F51\683C\8FC7\6EE4\5668\7684\6709\6548\8FC7\6EE4\5668\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770691615402784)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57\683C\5F0F\65E0\6548')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912652434402888)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912760910402888)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903711408402881)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5F0F\5DF2\8BBE\7F6E\4E3A %0, \4F46\6CA1\6709\4E3A %0 \9009\62E9\4EFB\4F55\5217\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901044339402879)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896151396402876)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854476452402844)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8FC7\53BB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854681233402844)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\672A\6765')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853594112402843)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4E3A\7A7A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853430783402843)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7A7A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904525318402882)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896586023402876)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900404920402879)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843708731402836)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB 1 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843951405402837)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB 1 \5C0F\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844447572402837)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB 1 \5206\949F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843437914402836)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E2A\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843556528402836)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\5468')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843664971402836)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843827833402836)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5C0F\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844565472402837)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5206\949F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844355168402837)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \4E2A\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844214584402837)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5468')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843279356402836)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843396677402836)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53BB\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904734136402882)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\5143\5BF9\9F50')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904874953402882)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\7EC4\7528\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854042214402844)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854197363402844)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\4E8E\7B49\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898679024402877)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898761563402878)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905165672402882)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'zh-cn'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897306563402877)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F4E\70B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907707921402884)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9017\53F7\5206\9694\591A\4E2A\5730\5740')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855283742402845)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5339\914D\6B63\5219\8868\8FBE\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879687968402863)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915248706402889)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\6700\5927\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879833292402863)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915367674402889)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\4E2D\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879566645402863)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855341984402845)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880378848402864)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915161996402889)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\6700\5C0F\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855723157402845)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862352627402850)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5305\542B\7684\884C\6570\8D85\8FC7\4E86 %0, \8FD9\8D85\8FC7\4E86\5141\8BB8\7684\6700\5927\503C\3002\8BF7\5E94\7528\5176\4ED6\8FC7\6EE4\5668\4EE5\4FBF\67E5\770B\7ED3\679C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889050543402870)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\9875\5305\542B\591A\4E2A\4EA4\4E92\5F0F\7F51\683C\FF0C\5FC5\987B\6307\5B9A\533A\57DF\9759\6001 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858497947402847)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858627899402847)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\547D\540D\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842611786402836)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 1 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842463889402835)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 1 \5C0F\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844664542402837)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 1 \5206\949F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842963836402836)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E2A\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842840038402836)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\5468')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842778385402836)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115842520790402836)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5C0F\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844731002402837)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5206\949F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844053576402837)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \4E2A\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844168155402837)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5468')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843150581402836)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115843000276402836)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854314633402844)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4ECB\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853301840402843)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\7B49\4E8E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919510962402893)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ID \4E3A %0 \7684\533A\57DF\4E0D\662F\4EA4\4E92\5F0F\7F51\683C\533A\57DF, \6216\8005\5728\5E94\7528\7A0B\5E8F %1 \4E2D\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853726426402844)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854570238402844)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\8FC7\53BB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115854757118402844)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\672A\6765')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862247288402850)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900227911402879)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905380757402882)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\5B57')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900587249402879)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900606690402879)
,p_name=>'APEX.IG.ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852511269402843)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5206\949F\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908257313402884)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5F00\989C\8272\9009\62E9\5668: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897009516402876)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\76D8\4EF7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859558128402848)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\7B97\7B26')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896429192402876)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898868821402878)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115860880533402849)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115828486894402825)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115908116129402884)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 "%0" \5206\9694\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115898997702402878)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6781\5750\6807\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904223752402882)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\95F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904369499402882)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\5C3E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115904178430402881)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858724153402847)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859095105402847)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981\9ED8\8BA4\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875513192402860)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757715508402775)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\53EF\8BBF\95EE\6027\6807\8BB0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756461842402774)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A2A\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756525581402774)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EB5\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756342184402774)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\65B9\5411')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756271701402774)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'zh-cn'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756197154402774)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'zh-cn'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757891625402775)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755978262402774)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755812412402774)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756041440402774)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'zh-cn'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755724381402774)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5927\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745903249402767)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5265\9664\591A\4FE1\606F\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899028169402878)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96F7\8FBE\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899104162402878)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8303\56F4\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909401908402885)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863080441402850)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861818698402849)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867088396402853)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0\3001\9875 %1\3001\533A\57DF %2 \4E2D\4E0D\5B58\5728\4EA4\4E92\5F0F\7F51\683C\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829977332402827)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858162622402847)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918767466402892)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5220\9664\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918490464402892)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4E3A\6240\6709\7528\6237\4FDD\5B58\66FF\4EE3\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918323290402892)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4E3A\6240\6709\7528\6237\4FDD\5B58\9ED8\8BA4\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918609985402892)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\4E13\7528\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918509930402892)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4E3A\6240\6709\7528\6237\4FDD\5B58\516C\5171\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115867180717402853)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728\540D\79F0\4E3A %0 \7684\5DF2\4FDD\5B58\4EA4\4E92\5F0F\7F51\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852401150402843)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F\4E4B\524D\7684\62A5\8868\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852324335402843)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5206\949F\4E4B\524D\7684\62A5\8868\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792093724402800)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C\62A5\8868\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911609050402887)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868 - \7F16\8F91')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866956554402853)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5B58\5728 ID \4E3A %0 \7684\5DF2\4FDD\5B58\4EA4\4E92\5F0F\7F51\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115911558805402887)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868 - \53E6\5B58\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830063460402827)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919683471402893)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\9759\6001 ID %0 \4FDD\5B58\7684\4EA4\4E92\5F0F\7F51\683C\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914550832402889)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829159966402826)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863127291402850)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F\66F4\6539')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861919037402849)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F\884C')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859134857402847)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858082701402847)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\884C\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919221550402892)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\64CD\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920487819402893)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0 \7684\64CD\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115829404878402826)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872127632402857)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827673395402825)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827733457402825)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802228329402807)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B58\5728\540D\4E3A %0 \7684\5DF2\4FDD\5B58\62A5\8868\3002\8BF7\8F93\5165\65B0\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827856508402825)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E13\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827926323402825)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914216186402889)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53E6\5B58\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861237301402849)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\62A5\8868\8BBE\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899291747402878)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6563\70B9\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827561589402825)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906538460402883)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22: \6240\6709\6587\672C\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827451069402825)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905739999402883)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22: \5168\6587')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852271971402842)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22 ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895859311402875)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9 -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836087925402831)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888755788402870)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E3B\533A\57DF\4E2D\9009\62E9 1 \884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827356199402825)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\641C\7D22\7684\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918980007402892)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\64CD\4F5C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836202830402831)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\5143\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836130135402831)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\9009\62E9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907195810402884)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\7535\5B50\90AE\4EF6\53D1\9001')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899636819402878)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7CFB\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825349425402823)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877964906402862)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\603B\4F53\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862745053402850)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\884C\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861043062402849)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899735131402878)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919368053402892)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\5217\53EA\80FD\5B9A\4E49\4E00\4E2A\6392\5E8F\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919145003402892)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\6539\83DC\5355')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115900724210402879)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5806\53E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855051731402845)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\5934\4E3A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899395229402878)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80A1\4EF7\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820300574402820)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62C9\4F38\5217\5BBD\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115861465678402849)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115879472583402863)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920616624402893)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\7F51\683C\3002\62A5\8868\FF1A%0\FF0C\89C6\56FE\FF1A%1\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115914646410402889)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\4F53\603B\548C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897514087402877)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903998885402881)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\989C\8272')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830150091402827)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877835892402862)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\5177\63D0\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115858254364402847)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\578B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115862656184402850)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89E3\9664\51BB\7ED3')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859723082402848)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\5143')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906989470402883)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\672A\4FDD\5B58\7684\66F4\6539\3002\662F\5426\7EE7\7EED?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115859634330402848)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896609619402876)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901578005402880)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\503C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886473039402868)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\FF08\4E0D\80FD\66F4\6539\65F6\533A\FF09')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905493620402882)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897993366402877)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857702033402846)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895929158402875)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115897405022402877)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\4EA4\91CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855632226402845)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896029056402876)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\5217\5BBD (\50CF\7D20)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846894792402839)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4ECB\4E8E %1 \548C %2 \4E4B\95F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846536303402838)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5305\542B %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846606018402838)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5305\542B %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824746803402823)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5F00\5934\4E0D\4E3A %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845387308402838)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \7B49\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845568589402838)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5927\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845635320402838)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5927\4E8E\7B49\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846384607402838)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4F4D\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847500522402839)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847396308402839)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847166234402839)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847982785402839)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847790421402839)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848103372402840)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847493143402839)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847224085402839)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847073700402839)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847876713402839)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115847678582402839)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848022097402839)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849940328402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849779991402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849558048402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850363084402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850189271402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850500368402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849811925402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849630275402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849420380402840)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850294514402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850008316402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850432367402841)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846043273402838)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\4E3A\7A7A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845925117402838)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E3A\7A7A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845706457402838)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5C0F\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845827495402838)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5C0F\4E8E\7B49\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846103983402838)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \7C7B\4F3C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846739874402839)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5339\914D\6B63\5219\8868\8FBE\5F0F %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852606053402843)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846951818402839)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\4ECB\4E8E %1 \548C %2 \4E4B\95F4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845467709402838)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\7B49\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846418883402838)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\4F4D\4E8E %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848701943402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848531265402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848313404402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849170101402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848994655402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849315301402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848643479402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848426415402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848258609402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849094032402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115848869645402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115849236658402840)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851138374402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850935753402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850795118402841)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851535315402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851357442402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851762489402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851060804402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 1 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850800116402841)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 1 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115850698008402841)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 1 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851461456402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 1 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851292084402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 1 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851694256402842)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 1 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115846209700402838)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\7C7B\4F3C %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853199057402843)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4EE5 %1 \5F00\5934')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896796506402876)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855831095402845)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896845113402876)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896955851402876)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115905911308402883)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('2016 \5E74 1 \6708 12 \65E5\661F\671F\4E00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906082387402883)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E00\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906184440402883)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('16 \5C0F\65F6\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115906266211402883)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('16 \5C0F\65F6\4E4B\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761290097402778)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\7C7B\578B\65E0\6548\3002\652F\6301\7684\6587\4EF6\5927\5C0F\4E3A %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888152751402870)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D4F\89C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887876887402869)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887967036402870)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761013158402778)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761413040402778)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62D6\653E\6587\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762638157402779)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E00\4E2A\6587\4EF6\6216\5C06\6587\4EF6\653E\7F6E\5728\6B64\5904\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762743557402779)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6\6216\5C06\6587\4EF6\653E\7F6E\5728\6B64\5904\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762897372402779)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\4E00\4E2A\6587\4EF6\6216\5C06\6587\4EF6\653E\7F6E\5728\6B64\5904\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762985787402779)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6\6216\5C06\6587\4EF6\653E\7F6E\5728\6B64\5904\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761351811402778)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761149047402778)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\592A\5927\3002\6700\5927\6587\4EF6\5927\5C0F\4E3A %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748963379402769)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B\5730\5740\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747802171402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57CE\5E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748234325402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FD\5BB6/\5730\533A\4EE3\7801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747909256402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95E8\724C\53F7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748818063402769)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EAC\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748779447402769)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ECF\5EA6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748663820402769)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5730\56FE\4E0A\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748366486402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748002470402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\90AE\653F\7F16\7801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748110809402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7701/\81EA\6CBB\533A/\76F4\8F96\5E02')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747720176402768)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8857\9053')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747681122402768)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\7406\7F16\7801\7ED3\679C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760256442402777)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\8FDB\884C\5730\7406\7F16\7801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760360908402777)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\8FDB\884C\5730\7406\7F16\7801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748525373402769)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115748486483402769)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\5730\5740\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749011231402769)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9700\8981\63D0\4F9B %0\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918847930402892)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9\6587\672C: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812211384402814)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812378529402814)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\9009\4E2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758211698402776)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \4E0D\5728\6709\6548\8303\56F4 %0 \5230 %1 \5185\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758362564402776)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \4E0D\662F %0 \7684\500D\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757960238402775)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\4E0E\503C %0 \548C %1 \5339\914D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758198971402775)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836406459402831)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836524118402831)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758064318402775)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741415590402763)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870632327402856)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870791132402856)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741537248402763)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\6761\76EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874405508402859)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9AD8\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874768349402859)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874511098402859)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E38\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874885634402859)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9E\65F6\6A21\677F\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875479970402860)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\6B64\7EC4\4EF6\672A\5728\9875\4E0A\5448\73B0, \6A21\677F\9009\9879\4E0D\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874326772402859)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6A21\677F\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874691382402859)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749969338402770)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\5706\5F62')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751710175402771)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236\6837\5F0F\4E0D\662F\6709\6548\7684 JSON\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750222292402770)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8DDD\79BB\5DE5\5177')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750012390402770)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED8\5236\5706\5F62')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742605027402764)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\9762\641C\7D22\9700\8981\533A\57DF\7EA7\7684\6570\636E\6E90\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745222617402766)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\4F4D\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746380150402767)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\4F4D\7F6E\5750\6807\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743766828402765)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521D\59CB\4F4D\7F6E\5FC5\987B\4E3A\70B9\51E0\4F55\7ED3\6784\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746145066402767)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\91CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744732484402766)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C42')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878042717402862)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C42\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749307374402769)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742512894402764)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6D88\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746243130402767)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\82F1\91CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877099383402861)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\5305\542B\7684\884C\6570\8D85\8FC7\4E86 %0\FF0C\8FD9\8D85\8FC7\4E86\5141\8BB8\7684\6700\5927\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744540214402766)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\6761\6B3E</a> &nbsp;&nbsp; \5730\56FE\6570\636E &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743481131402765)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('SDO_GEOMETRY \6570\636E\7C7B\578B\5728\6B64\6570\636E\5E93\4E2D\4E0D\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744612185402766)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; OpenStreetMap \5185\5BB9\63D0\4F9B\8005 </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744869668402766)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\70B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878177019402862)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\70B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750190973402770)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\77E9\5F62\7F29\653E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749841518402770)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745132862402766)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\65B9\4F4D\91CD\7F6E\4E3A\5317')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825461400402823)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362\5230 2D \6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825543405402823)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362\5230 3D \6A21\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749757438402770)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362\7248\6743\58F0\660E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750361135402770)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\8DDD\79BB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744947474402766)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\653E\5927')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745052638402766)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F29\5C0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872548415402857)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C97\4F53')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873427812402858)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873082568402857)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5185\5D4C\4EE3\7801')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886689553402869)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165\56FE\50CF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886745242402869)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\5165\94FE\63A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872661172402857)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\659C\4F53')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887347617402869)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\94FE\63A5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873306271402858)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873289006402858)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\5217\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872705990402857)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\89C8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872898387402857)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\53EF\9884\89C8\7684\5185\5BB9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872916119402857)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\7EBF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873198581402858)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6392\5E8F\5217\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852065273402842)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115909574947402885)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\591A...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115851980881402842)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\52A0\8F7D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883771438402867)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\901A\77E5\6D88\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857070173402846)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\5C0F\4E8E\6216\7B49\4E8E 0% \7684\6570\5B57\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857121764402846)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\6709\6548\6570\5B57\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857230518402846)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \4E0D\7B26\5408\6570\5B57\683C\5F0F %0 (\793A\4F8B: %1)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856929930402846)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\5927\4E8E\6216\7B49\4E8E 0% \7684\6570\5B57\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856832791402846)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\662F\4ECB\4E8E %0 \548C %1 \4E4B\95F4\7684\6570\5B57\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852140054402842)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\65B0\7A97\53E3\4E2D\6253\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805342629402809)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5DF2\7ECF\63D0\4EA4, \65E0\6CD5\91CD\590D\63D0\4EA4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787905562402797)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\5E94\7528\7A0B\5E8F "%0" \9875 "%1"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821710324402821)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#LABEL# \5FC5\987B\5177\6709\503C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765066427402780)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871062008402856)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870932088402856)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\627E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871230304402856)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871104946402856)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757101369402775)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\81F3\5C11 %0 \4E2A\5B57\7B26\7684\641C\7D22\8BCD\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826608877402824)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F39\51FA\5F0F\503C\5217\8868: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757212077402775)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F93\5165\641C\7D22\8BCD\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757053931402775)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\7ED3\679C\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756974952402775)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844816450402837)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\8BCD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870894905402856)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881542214402865)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755512203402774)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\5230\4E3B\5C4F\5E55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751590622402771)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\60A8\7684\8BBE\5907\6216\6D4F\89C8\5668\76EE\524D\4F3C\4E4E\4E0D\652F\6301\5B89\88C5\6E10\8FDB\5F0F Web \5E94\7528\7A0B\5E8F\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">\5982\679C\60A8\7684\8BBE\5907\4E0A\5DF2\7ECF\5B89\88C5\4E86\6B64\5E94\7528\7A0B\5E8F\FF0C\8BF7\4ECE\4E3B\5C4F\5E55\6253\5F00\5B83\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751117743402771)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5E94\7528\7A0B\5E8F\529F\80FD\3002\8BF7\5C06\5B83\6DFB\52A0\5230\4E3B\5C4F\5E55\4E2D\4EE5\5728\5168\5C4F\6A21\5F0F\4E0B\4F7F\7528\5B83\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \70B9\51FB\5E95\90E8\5BFC\822A\4E2D\7684<strong>\83DC\5355</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \70B9\51FB<strong>\5B89\88C5</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \70B9\51FB<strong>\6DFB\52A0</strong>\8FDB\884C\786E\8BA4</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751283718402771)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5728 Chrome \6216 Edge \4E2D\53EF\83B7\5F97\6700\4F73\4F53\9A8C\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \70B9\51FB\5730\5740\680F\65C1\8FB9\7684<strong>\83DC\5355</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \70B9\51FB<strong>\5B89\88C5</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750814580402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5728 Safari \4E2D\53EF\83B7\5F97\6700\4F73\4F53\9A8C\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \70B9\51FB\5E95\90E8\5BFC\822A\4E2D\7684<strong>\5171\4EAB</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \70B9\51FB<strong>\5728 Safari \4E2D\6253\5F00</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750543197402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5E94\7528\7A0B\5E8F\529F\80FD\3002\8BF7\5C06\5B83\6DFB\52A0\5230\4E3B\5C4F\5E55\4E2D\4EE5\83B7\5F97\6700\4F73\4F53\9A8C\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \70B9\51FB\5730\5740\680F\65C1\8FB9\7684<strong>\5171\4EAB</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \70B9\51FB<strong>\6DFB\52A0\5230\4E3B\5C4F\5E55</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \70B9\51FB<strong style="color:#007AE1;">\6DFB\52A0</strong>\8FDB\884C\786E\8BA4</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750487737402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5E94\7528\7A0B\5E8F\529F\80FD\3002\8BF7\5C06\5B83\6DFB\52A0\5230\4E3B\5C4F\5E55\4E2D\4EE5\83B7\5F97\6700\4F73\4F53\9A8C\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \70B9\51FB\5E95\90E8\5BFC\822A\4E2D\7684<strong>\5171\4EAB</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \5411\4E0B\6EDA\52A8\5E76\70B9\51FB<strong>\6DFB\52A0\5230\4E3B\5C4F\5E55</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \70B9\51FB<strong style="color:#007AE1;">\6DFB\52A0</strong>\8FDB\884C\786E\8BA4</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745444479402766)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5E94\7528\7A0B\5E8F\529F\80FD\3002\8BF7\5C06\5B83\6DFB\52A0\5230\4E3B\5C4F\5E55\4E2D\4EE5\83B7\5F97\6700\4F73\4F53\9A8C\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \70B9\51FB\5730\5740\680F\65C1\8FB9\7684<strong>\66F4\591A</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \70B9\51FB<strong>\6DFB\52A0\5230\4E3B\5C4F\5E55</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \70B9\51FB<strong style="color:#007AE1;">\6DFB\52A0</strong>\8FDB\884C\786E\8BA4</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750739372402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5E94\7528\7A0B\5E8F\529F\80FD\3002\8BF7\5C06\5B83\6DFB\52A0\5230\4E3B\5C4F\5E55\4E2D\4EE5\83B7\5F97\6700\4F73\4F53\9A8C\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\70B9\51FB\5730\5740\680F\65C1\8FB9\7684<strong>\5171\4EAB</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\70B9\51FB<strong>\5728 Safari \4E2D\6253\5F00</strong></p>'),
'    </div>',
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750685292402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5E94\7528\7A0B\5E8F\529F\80FD\3002\8BF7\5C06\5B83\6DFB\52A0\5230\4E3B\5C4F\5E55\4E2D\4EE5\83B7\5F97\6700\4F73\4F53\9A8C\3002</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\70B9\51FB\5E95\90E8\5BFC\822A\4E2D\7684<strong>\5171\4EAB</strong>\56FE\6807</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\70B9\51FB<strong>\5728 Safari \4E2D\6253\5F00</strong></p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751443542402771)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5728 Chrome \4E2D\53EF\83B7\5F97\6700\4F73\4F53\9A8C\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \76EE\524D\4E0D\652F\6301\5B89\88C5 Web \5E94\7528\7A0B\5E8F\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115750975952402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5728 Chrome \6216 Edge \4E2D\53EF\83B7\5F97\6700\4F73\4F53\9A8C\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \76EE\524D\4E0D\652F\6301\5728 macOS \4E0A\5B89\88C5 Web \5E94\7528\7A0B\5E8F\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751021424402770)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5728 Chrome \6216 Edge \4E2D\53EF\83B7\5F97\6700\4F73\4F53\9A8C\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari \76EE\524D\4E0D\652F\6301\5728 macOS \4E0A\5B89\88C5 Web \5E94\7528\7A0B\5E8F\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751359642402771)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\6B64\7F51\7AD9\5177\6709\5728 Chrome \6216 Edge \4E2D\53EF\83B7\5F97\6700\4F73\4F53\9A8C\7684\5E94\7528\7A0B\5E8F\529F\80FD\3002</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox \76EE\524D\4E0D\652F\6301\5728 Windows \4E0A\5B89\88C5 Web \5E94\7528\7A0B\5E8F\3002</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753858332402772)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\65E0\6CD5\8FDE\63A5</h1>'),
unistr('    <p>\9700\8981\5177\6709 Internet \8FDE\63A5\624D\80FD\4F7F\7528\6B64\5E94\7528\7A0B\5E8F\3002</p>'),
unistr('    <button type="button">\91CD\8BD5</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753742867402772)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8FDE\63A5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893599215402874)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837997465402832)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916806622402891)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\9080\8BF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916696041402890)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839723553402833)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5929\7684\6BCF\65E5\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839505174402833)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\65F6\95F4\7684\6570\636E\6BCF\65E5\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884429049402867)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878825860402863)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769407437402784)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'zh-cn'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769241837402783)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'zh-cn'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769127649402783)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'zh-cn'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769328680402783)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'zh-cn'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768839151402783)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769085254402783)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E8B\4EF6\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916701170402891)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9080\8BF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884527841402867)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884264215402867)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887085185402869)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901348491402879)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\4E8B\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917085599402891)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\73B0\6709\4E8B\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916936842402891)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001\9080\8BF7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887144447402869)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895166921402875)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894911328402875)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917732062402891)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\5B57\6BB5\90FD\5FC5\987B\586B\5199\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917626797402891)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001\9080\8BF7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916590771402890)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895067994402875)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\4EF6\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768918220402783)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892824318402873)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\57FA\4E8E %0 \7684\8868\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839378703402833)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887264498402869)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECA\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885064648402868)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884336487402867)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839610291402833)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\5929\7684\5468\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839489184402833)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E26\6709\65F6\95F4\7684\6570\636E\5468\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884975157402867)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884607440402867)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884795846402867)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\66F4\591A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816822495402817)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540E\9000')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763177063402779)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\66F4\591A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765261805402781)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115884829668402867)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\66F4\591A...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886943922402869)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\533A\57DF ID %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765107879402780)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\4EFB\4F55\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789203950402798)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\91CD\7F6E\533A\57DF\9875\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757444159402775)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\533A\57DF\9875\7801\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878205976402862)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886891355402869)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\533A\57DF\7C7B\578B %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757366709402775)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\533A\57DF "#COMPONENT_NAME#" \65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821830625402821)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('#COLUMN_HEADER# \5FC5\987B\5177\6709\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916150085402890)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0, \591A\4FE1\606F\6587\672C\7F16\8F91\5668')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823919560402822)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\4FE1\606F\6587\672C HTML \6807\8BB0\8D85\8FC7\4E86\6B64\9879\7684\6700\5927\957F\5EA6\FF08\5B9E\9645\4E3A %0 \4E2A\5B57\7B26\FF0C\5141\8BB8 %1 \4E2A\5B57\7B26\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883837707402867)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875622874402860)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\590D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873964805402858)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7684\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873832257402858)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664\7A7A\503C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883943707402867)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837564464402832)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\79FB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837616507402832)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\79FB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873669426402858)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874255952402859)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873763234402858)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874028716402858)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874137118402858)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C %0 \884C, \5171 %1 \884C')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875730770402860)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5237\65B0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875800865402860)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F\66F4\6539')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115873565157402858)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\83DC\5355')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834503277402830)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F8B\5982 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742075157402764)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\518D\6B21\767B\5F55')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741944191402764)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\4F1A\8BDD\5DF2\7ED3\675F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742175862402764)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5EF6\957F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741739766402764)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\4F1A\8BDD\5C06\5728 %0 \7ED3\675F\3002\662F\5426\8981\5EF6\957F\FF1F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741831215402764)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\4F1A\8BDD\5C06\5728 %0 \7ED3\675F\FF0C\5E76\4E14\65E0\6CD5\5EF6\957F\3002\8BF7\7ACB\5373\4FDD\5B58\6240\6709\5DE5\4F5C\5185\5BB9\4EE5\907F\514D\4E22\5931\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894722210402875)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\6570\636E\5E93\4F1A\8BDD\6E05\9664\4EE3\7801\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787843385402797)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\6570\636E\5E93\4F1A\8BDD\8BBE\7F6E\4EE3\7801\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115761929481402778)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\4F1A\8BDD\5DF2\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893654076402874)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\5173\95ED\6B64\5BF9\8BDD\6846, \7136\540E\6309\6D4F\89C8\5668\7684\201C\91CD\65B0\52A0\8F7D\201D\6309\94AE\4EE5\83B7\53D6\65B0\4F1A\8BDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912965493402888)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\51FB<a href="%0">\6B64\5904</a>\4EE5\65B0\5EFA\4F1A\8BDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799527390402805)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839043012402833)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5728 Real Application Security \4F1A\8BDD\4E2D\4E3A\7528\6237 "%0" \542F\7528\52A8\6001\89D2\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785721785402795)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-99900 \65E0\6CD5\521B\5EFA\552F\4E00\7684\4F1A\8BDD ID: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802048218402807)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\72B6\6001\4FDD\62A4\8FDD\89C4: \8FD9\53EF\80FD\662F\56E0\4E3A\624B\52A8\53D8\66F4\4E86\53D7\4FDD\62A4\7684\9875\9879 %0\3002\5982\679C\60A8\4E0D\786E\5B9A\5BFC\81F4\6B64\9519\8BEF\7684\539F\56E0, \8BF7\4E0E\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB, \4EE5\83B7\53D6\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921174355402894)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\4FDD\62A4\8FDD\89C4: \5BFC\81F4\51FA\73B0\8FD9\79CD\60C5\51B5\7684\539F\56E0\53EF\80FD\662F\7531\4E8E\63D0\4EA4\5C1A\672A\5B8C\6210\52A0\8F7D\7684\9875, \6216\8005\624B\52A8\66F4\6539\4E86\53D7\4FDD\62A4\7684\9875\9879\3002\5982\9700\66F4\591A\5E2E\52A9, \8BF7\4E0E\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920112908402893)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5305\542B\4EE5\4E0B\65E0\6548\5B57\7B26\4E4B\4E00: &<>"/;,*|=% \6216 --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920239181402893)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5305\542B\4EE5\4E0B\65E0\6548\5B57\7B26\4E4B\4E00: &<>"/;,*|=% -- \6216\6362\884C\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919974321402893)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5305\542B\7279\6B8A\5B57\7B26\3002\53EA\5141\8BB8\4F7F\7528\5B57\7B26 a-Z\30010-9 \548C\7A7A\683C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115920075805402893)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\5305\542B <, > \6216 ", \8FD9\4E9B\662F\65E0\6548\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764164897402780)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\63D0\4F9B\7528\4E8E\663E\793A\9875\5904\7406\7684\6821\9A8C\548C, \5F53\5C06\4E00\4E2A\6216\591A\4E2A\8BF7\6C42, \6E05\9664\9AD8\901F\7F13\5B58\6216\53C2\6570\503C\4F5C\4E3A\53C2\6570\4F20\9012\65F6, \8BE5\9875\9700\8981\6821\9A8C\548C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796906535402803)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F1A\8BDD\72B6\6001\4FDD\62A4\8FDD\89C4: \8FD9\53EF\80FD\662F\56E0\4E3A\624B\52A8\53D8\66F4\4E86\5305\542B\6821\9A8C\548C\7684 URL, \6216\8005\4F7F\7528\4E86\5177\6709\4E0D\6B63\786E\7684\6216\7F3A\5931\6821\9A8C\548C\7684\94FE\63A5\3002\5982\679C\60A8\4E0D\786E\5B9A\5BFC\81F4\6B64\9519\8BEF\7684\539F\56E0, \8BF7\4E0E\5E94\7528\7A0B\5E8F\7BA1\7406\5458\8054\7CFB, \4EE5\83B7\53D6\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115874924338402859)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\9AD8\5BF9\6BD4\5EA6\6A21\5F0F\8BBE\7F6E\4E3A\201C\5173\95ED\201D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875068939402859)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\9AD8\5BF9\6BD4\5EA6\6A21\5F0F\8BBE\7F6E\4E3A\201C\5F00\542F\201D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793672312402801)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793846794402801)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793971719402801)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794022545402801)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794199880402801)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794251625402801)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794362731402801)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793588210402801)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793705098402801)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902614617402880)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903350386402881)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \5929\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902550236402880)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903470966402881)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \5C0F\65F6\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902339008402880)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903585565402881)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \5206\949F\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902962469402881)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903172903402881)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \4E2A\6708\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902427654402880)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903204596402881)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \79D2\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902780629402880)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903618087402881)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \5468\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902853250402880)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115903024879402881)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0 \5E74\5185')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742945032402764)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\7EBF]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743353826402765)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\591A\6761\7EBF]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743147848402765)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\591A\4E2A\70B9]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743521226402765)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\591A\4E2A\591A\8FB9\5F62]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743681352402765)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\51E0\4F55\7ED3\6784\5BF9\8C61]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742845187402764)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\70B9 (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743059193402765)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('[\591A\8FB9\5F62]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820277958402820)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\53E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820161485402819)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866690641402853)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664\8BC4\7EA7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856553736402846)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\6709\6548\7684\8BC4\7EA7\8303\56F4 1 - %1 \5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856682497402846)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\662F\6570\5B57')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852717767402843)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6210\529F\6D88\606F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915854749402890)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915794899402890)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901447598402879)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\5177\680F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916231333402890)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00/\6298\53E0\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916374681402890)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00/\6298\53E0\4FA7\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825959772402824)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\5BFC\822A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832916357402829)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832712242402828)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833070138402829)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832847568402829)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832609157402828)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833284346402829)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115833194579402829)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919470555402892)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\7684\5F00\59CB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781443675402792)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755212471402773)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5904\7406\8BF7\6C42\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834651475402830)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917533233402891)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\7B49\5F85\9875\5B8C\5168\52A0\8F7D, \7136\540E\91CD\8BD5\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877710104402862)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\5177\6709\672A\4FDD\5B58\7684\66F4\6539\3002')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758618471402776)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5\5DE5\4F5C\7C3F\6CA1\6709\6D3B\52A8\5DE5\4F5C\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758506692402776)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BE5\5DE5\4F5C\7C3F\672A\521D\59CB\5316\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758476476402776)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA XLSX \6587\4EF6\65F6\51FA\73B0\5185\90E8\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760911966402777)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892695862402873)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810194437402812)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\64CD\4F5C\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805824996402809)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805736466402809)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\201C\5206\7EC4\65B9\5F0F\201D\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839926005402834)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\900F\89C6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840005021402834)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\884C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780231774402791)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816338796402817)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797472271402803)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801785470402806)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797504778402803)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797772820402804)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797631630402803)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797330311402803)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798439574402804)
,p_name=>'APEXIR_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779522987402791)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762085992402778)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\6709\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889614405402871)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891212598402872)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3\9ED8\8BA4\503C\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792186387402800)
,p_name=>'APEXIR_AND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781603703402792)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775379608402788)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794943689402802)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891894006402872)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E73\5747\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883203457402866)
,p_name=>'APEXIR_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6761\5F62\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781030409402792)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECB\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774192278402787)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\80CC\666F\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776006216402788)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\84DD\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807775345402811)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E95\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776643756402789)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D6\6D88')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782519393402793)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\522B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774020909402787)
,p_name=>'APEXIR_CELL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\5143')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798342552402804)
,p_name=>'APEXIR_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808608439402811)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\5728\521D\59CB\5316...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115844937611402837)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\56FE\8868\6807\7B7E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857368223402846)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684\67E5\8BE2\8D85\8FC7\4E86\6BCF\4E2A\56FE\8868\7684\6700\5927\6570\636E\70B9\6570 %0\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\57FA\672C\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856245469402845)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\67E5\8BE2\7684\6700\5927\884C\8BA1\6570\5C06\9650\5236\57FA\672C\67E5\8BE2\4E2D\7684\884C\6570, \800C\4E0D\662F\663E\793A\7684\884C\6570\3002\60A8\7684\57FA\672C\67E5\8BE2\8D85\8FC7\4E86\6700\5927\884C\8BA1\6570 (%0)\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\57FA\672C\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779637381402791)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\8868\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115852903745402843)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\9009\4E2D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795384415402802)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\62A5\8868\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802778961402807)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E05\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776580235402789)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813995585402815)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886285519402868)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804778360402809)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\9898\83DC\5355')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808451525402811)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888566123402870)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806152431402810)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790281585402798)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791143260402799)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775013567402787)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791332375402799)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\8FC7\53BB\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799801560402805)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728\672A\6765\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791252107402799)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\8FC7\53BB\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799797067402805)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\672A\6765\7684')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774990682402787)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774848933402787)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774698053402787)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7C7B\4F3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775132638402787)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774719170402787)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\7C7B\4F3C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790551999402799)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5339\914D\6B63\5219\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795214370402802)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115855958460402845)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814265358402815)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5217\522B\540D\521B\5EFA\8BA1\7B97\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814348096402815)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'zh-cn'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814456272402815)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'zh-cn'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814579996402815)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'zh-cn'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760487729402777)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'zh-cn'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799168342402805)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806796008402810)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809742778402812)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894164875402874)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63A7\5236\4E2D\65AD\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757520732402775)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892331949402873)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\540C\503C\8BA1\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892232002402873)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864382516402851)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919039062402892)
,p_name=>'APEXIR_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808571917402811)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F\4E4B\524D\7684\62A5\8868\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882031574402865)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7F51\683C\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780372655402791)
,p_name=>'APEXIR_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812443284402814)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889493707402871)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\62A5\8868\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776708111402789)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780634050402791)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F\5426\8981\5220\9664\8FD9\4E9B\62A5\8868\8BBE\7F6E?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875330803402859)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\9ED8\8BA4\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806470107402810)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775480151402788)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782691894402793)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804656054402808)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5355\884C\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812913332402814)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\65B9\5411 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813832364402815)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776248610402788)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779420664402791)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A\7684\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812819431402814)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\62A5\8868\4E2D\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807671603402811)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799250216402805)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812740775402814)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878780211402862)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\5B58\5728\76F8\540C\6761\4EF6\7684\7A81\51FA\663E\793A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894348544402874)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\5217\91CD\590D\3002\900F\89C6\5217\7684\5217\8868\5FC5\987B\552F\4E00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894548842402874)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808793991402811)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\56FE\8868\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815398835402816)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815744219402816)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870136251402855)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\5206\7EC4\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815637332402816)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\7A81\51FA\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840221655402834)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91\900F\89C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889776405402871)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768447280402783)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890036799402871)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890285865402871)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B63\6587')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889961697402871)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6284\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890714427402872)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9891\7387')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772184872402785)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5E94\7528\7A0B\5E8F\914D\7F6E\7535\5B50\90AE\4EF6\3002\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863654035402851)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890322134402871)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\9644\52A0\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890141844402871)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864664641402851)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\7535\5B50\90AE\4EF6\4E3B\9898\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889823688402871)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6536\4EF6\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773838421402787)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\542F\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815510625402816)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\542F\7528/\7981\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815010303402816)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814669740402816)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815432814402816)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\793A\4F8B\FF1A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779313299402790)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\9664\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816033149402817)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00/\6298\53E0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813623743402815)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798723784402804)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809618357402812)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819952557402819)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\8868\8FBE\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916440301402890)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\8868\8FBE\5F0F\592A\957F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819887474402819)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816237797402817)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\8981\641C\7D22\7684\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799051350402804)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813450576402815)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\95EA\56DE\67E5\8BE2\53EF\4EE5\67E5\770B\4E4B\524D\7684\67D0\4E2A\65F6\95F4\70B9\4E0A\5B58\5728\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864050890402851)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE\6301\7EED\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865470471402852)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795198135402802)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\683C\5F0F\63A9\7801 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806382868402810)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814132385402815)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889359250402871)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570/\8FD0\7B97\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806015587402809)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FD\6570 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798584736402804)
,p_name=>'APEXIR_GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774324857402787)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EFF\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115757653404402775)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\7EC4\65B9\5F0F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890494161402871)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\5206\7EC4\65B9\5F0F\201D\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845059138402837)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\201C\5206\7EC4\65B9\5F0F\201D\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856107099402845)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Group By \67E5\8BE2\7684\6700\5927\884C\8BA1\6570\5C06\9650\5236\57FA\672C\67E5\8BE2\4E2D\7684\884C\6570, \800C\4E0D\662F\663E\793A\7684\884C\6570\3002\60A8\7684\57FA\672C\67E5\8BE2\8D85\8FC7\4E86\6700\5927\884C\8BA1\6570 (%0)\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\57FA\672C\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836746490402831)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\6392\5E8F\5206\7EC4')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894228664402874)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\6392\5E8F\987A\5E8F\5206\7EC4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779703913402791)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811383863402813)
,p_name=>'APEXIR_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803154016402807)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5229\7528\4EA4\4E92\5F0F\62A5\8868, \6700\7EC8\7528\6237\53EF\4EE5\5B9A\5236\62A5\8868\3002\7528\6237\53EF\4EE5\901A\8FC7\9009\62E9\5217, \5E94\7528\8FC7\6EE4\5668, \7A81\51FA\663E\793A\5E76\8FDB\884C\6392\5E8F, \6765\53D8\66F4\62A5\8868\6570\636E\7684\5E03\5C40\3002\6B64\5916, \7528\6237\8FD8\53EF\4EE5\5B9A\4E49\5206\6BB5, \805A\96C6, \56FE\8868, \5206\7EC4\65B9\5F0F\4EE5\53CA\6DFB\52A0\81EA\5DF1\7684\8BA1\7B97\3002\7528\6237\8FD8\53EF\4EE5\8BBE\7F6E\8BA2\9605, \4EE5\4FBF\6309\6307\5B9A\7684\65F6\95F4\95F4\9694\901A\8FC7\7535\5B50\90AE\4EF6\53D1\9001 HTML \683C\5F0F\7684\62A5\8868\3002\7528\6237\53EF\4EE5\521B\5EFA\62A5\8868\7684\591A\4E2A\53D8\4F53\5E76\5C06\5B83\4EEC\4FDD\5B58\4E3A\547D\540D\62A5\8868, \4EE5\4F9B\516C\4F17\6216\4E2A\4EBA\67E5\770B\3002'),
'<p/>',
unistr('\4E0B\9762\7684\90E8\5206\6C47\603B\4E86\53EF\5B9A\5236\4EA4\4E92\5F0F\62A5\8868\7684\65B9\5F0F\3002\8981\4E86\89E3\8BE6\7EC6\4FE1\606F, \8BF7\53C2\9605 <i>Oracle Application Express End User''s Guide</i></a> \4E2D\7684 "Using Interactive Reports"\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810224895402812)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\64CD\4F5C\201D\83DC\5355\663E\793A\5728\641C\7D22\680F\4E0A\201C\5F00\59CB\201D\6309\94AE\7684\53F3\4FA7\3002\4F7F\7528\6B64\83DC\5355\53EF\4EE5\5B9A\5236\4EA4\4E92\5F0F\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803928053402808)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\201C\805A\96C6\201D\662F\5BF9\5217\6267\884C\7684\6570\5B66\8BA1\7B97\3002\5728\6BCF\4E2A\63A7\5236\5206\6BB5\4E4B\540E\548C\62A5\8868\7684\7ED3\5C3E, \805A\96C6\663E\793A\5728\5B9A\4E49\5B83\4EEC\7684\5217\4E2D\3002\9009\9879\5305\62EC:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\805A\96C6</strong>, \7528\4E8E\9009\62E9\5148\524D'),
unistr('\5B9A\4E49\7684\805A\96C6\8FDB\884C\7F16\8F91\3002</li>'),
unistr('<li><strong>\51FD\6570</strong>, \662F\8981\6267\884C\7684\51FD\6570 (\4F8B\5982 SUM, MIN)\3002</li>'),
unistr('<li><strong>\5217</strong>, \7528\4E8E\9009\62E9\8981\5BF9\5176\5E94\7528\6570\5B66\51FD\6570\7684\5217\3002\5C06\53EA\663E\793A'),
unistr('\6570\5B57\5217\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804068716402808)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53EF\4EE5\4E3A\6BCF\4E2A\4FDD\5B58\7684\62A5\8868\5B9A\4E49\4E00\4E2A\56FE\8868\3002\5B9A\4E49'),
unistr('\4E4B\540E\FF0C\4F7F\7528\641C\7D22\680F\4E0A\7684\67E5\770B\56FE\6807\53EF\4EE5\5728\56FE\8868\89C6\56FE\548C\62A5\8868\89C6\56FE\4E4B\95F4\5207\6362\3002'),
unistr('\9009\9879\5305\62EC\FF1A'),
'<p>',
'</p><ul>',
unistr('<li><strong>\56FE\8868\7C7B\578B</strong>\FF0C\6807\8BC6\8981\5305\62EC\7684\56FE\8868\7C7B\578B\3002'),
unistr('\53EF\4EE5\9009\62E9\6C34\5E73\6761\5F62\56FE\3001\5782\76F4\6761\5F62\56FE\3001\997C\56FE\6216\6298\7EBF\56FE\3002</li>'),
unistr('<li><strong>\6807\7B7E</strong>\FF0C\7528\4E8E\9009\62E9\7528\4F5C\6807\7B7E\7684\5217\3002</li>'),
unistr('<li><strong>\6807\7B7E\7684\8F74\6807\9898</strong>\FF0C\5728\4E3A\201C\6807\7B7E\201D\9009\62E9\7684\5217\6240\5173\8054\7684\8F74\4E0A\663E\793A\7684'),
unistr('\6807\9898\3002\6B64\9879\5BF9\997C\56FE\4E0D\53EF\7528\3002</li>'),
unistr('<li><strong>\503C</strong>\FF0C\7528\4E8E\9009\62E9\8981\7528\4F5C\503C\7684\5217\3002\5982\679C\51FD\6570\4E3A'),
unistr('COUNT\FF0C\5219\4E0D\9700\8981\9009\62E9\201C\503C\201D\3002</li>'),
unistr('<li><strong>\503C\7684\8F74\6807\9898</strong>\FF0C\5728\4E3A\201C\503C\201D\9009\62E9\7684\5217\6240\5173\8054\7684\8F74\4E0A\663E\793A\7684'),
unistr('\6807\9898\3002\6B64\9879\5BF9\997C\56FE\4E0D\53EF\7528\3002</li>'),
unistr('<li><strong>\51FD\6570</strong>\FF0C\5BF9\4E3A\201C\503C\201D\9009\62E9\7684\5217\6267\884C\7684\53EF\9009\51FD\6570\3002</li>'),
unistr('<li><strong>\6392\5E8F</strong>\FF0C\7528\4E8E\5BF9\7ED3\679C\96C6\8FDB\884C\6392\5E8F\3002</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803346110402808)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5355\51FB\4EFB\610F\5217\6807\9898\53EF\4EE5\5C55\5F00\201C\5217\6807\9898\201D\83DC\5355\3002\9009\9879\5305\62EC\FF1A'),
'<p></p>',
'<ul>',
unistr('<li><strong>\5347\5E8F\6392\5E8F</strong>\56FE\6807\FF0C\7528\4E8E\6309\5217\7684\5347\5E8F\5BF9\62A5\8868\6392\5E8F\3002</li>'),
unistr('<li><strong>\964D\5E8F\6392\5E8F</strong>\56FE\6807\FF0C\7528\4E8E\6309\5217\7684\964D\5E8F\5BF9\62A5\8868\6392\5E8F\3002</li>'),
unistr('<li><strong>\9690\85CF\5217</strong>\FF0C\7528\4E8E\9690\85CF\5217\3002\5E76\975E\6240\6709\5217\90FD\53EF\4EE5\9690\85CF\3002\5982\679C\5217\65E0\6CD5\9690\85CF\FF0C\5C31\6CA1\6709\201C\9690\85CF\5217\201D\56FE\6807\3002</li>'),
unistr('<li><strong>\5206\9694\5217</strong>\FF0C\7528\4E8E\5728\5217\4E0A\521B\5EFA\5206\9694\7EC4\3002\8FD9\4F1A\4ECE\62A5\8868\4E2D\53D6\51FA\5217\4F5C\4E3A\4E3B\8BB0\5F55\3002</li>'),
unistr('<li><strong>\5217\4FE1\606F</strong>\FF0C\7528\4E8E\663E\793A\6709\5173\5217\7684\5E2E\52A9\6587\672C\FF08\5982\679C\53EF\7528\FF09\3002</li>'),
unistr('<li><strong>\6587\672C\533A\57DF</strong>\FF0C\7528\4E8E\8F93\5165\4E0D\533A\5206\5927\5C0F\5199\7684\641C\7D22\6807\51C6'),
unistr('\FF08\65E0\9700\901A\914D\7B26\FF09\3002\8F93\5165\4E00\4E2A\503C\5C06\51CF\5C11'),
unistr('\83DC\5355\5E95\90E8\7684\503C\5217\8868\3002\7136\540E\60A8\53EF\4EE5\4ECE'),
unistr('\5E95\90E8\9009\62E9\4E00\4E2A\503C\FF0C\6240\9009\7684\503C\5C06\4F7F\7528 ''='''),
unistr('\521B\5EFA\4E3A\8FC7\6EE4\5668\FF08\4F8B\5982\FF0C<code>column = ''ABC''</code>\FF09\3002\6216\8005\FF0C\60A8\53EF\4EE5\5355\51FB\624B\7535\7B52\56FE\6807\FF0C\7136\540E\8F93\5165\4E00\4E2A\503C\4EE5\4F7F\7528 ''LIKE'''),
unistr('\4FEE\9970\7B26\5C06\8BE5\503C\521B\5EFA\4E3A\8FC7\6EE4\5668\FF08\4F8B\5982\FF0C<code>column LIKE ''%ABC%''</code>\FF09\3002</li>'),
unistr('<li><b>\552F\4E00\503C\7684\5217\8868</b>\FF0C\5305\542B\6EE1\8DB3\8FC7\6EE4\6807\51C6'),
unistr('\7684\524D 500 \4E2A\552F\4E00\503C\3002\5982\679C\5217\4E3A\65E5\671F\5217\FF0C\5219\6539\4E3A'),
unistr('\663E\793A\65E5\671F\8303\56F4\5217\8868\3002\5982\679C\9009\62E9\4E00\4E2A\503C\FF0C\5219'),
unistr('\4F7F\7528 ''='' \521B\5EFA\8FC7\6EE4\5668\FF08\4F8B\5982\FF0C<code>column = ''ABC''</code>\FF09\3002</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803841025402808)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\7528\4E8E\5C06\8BA1\7B97\5217\6DFB\52A0\5230\62A5\8868\3002\8FD9\4E9B\53EF\4EE5\662F\6570\5B66\8BA1\7B97 (\4F8B\5982 <code>NBR_HOURS/24</code>) \6216\5728\73B0\6709\5217'),
unistr('\4E0A\5E94\7528\7684\6807\51C6 Oracle \51FD\6570\3002\5176\4E2D\90E8\5206\663E\793A\4E3A\793A\4F8B\548C\5176\4ED6\51FD\6570 (\4F8B\5982, <code>TO_DATE)</code> \4E5F\53EF\4EE5\4F7F\7528)\3002\9009\9879\5305\62EC:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\8BA1\7B97</strong>, \7528\4E8E\9009\62E9\5148\524D\5B9A\4E49\7684\8BA1\7B97\8FDB\884C\7F16\8F91\3002</li>'),
unistr('<li><strong>\5217\6807\9898</strong>, \662F\65B0\5217\7684\5217\6807\9898\3002</li>'),
unistr('<li><strong>\683C\5F0F\63A9\7801</strong>, \662F\5BF9\5217\5E94\7528\7684 Oracle \683C\5F0F\63A9\7801 (\4F8B\5982 S9999)\3002</li>'),
unistr('<li><strong>\8BA1\7B97</strong>, \662F\8981\6267\884C\7684\8BA1\7B97\3002\5728\8BA1\7B97\4E2D, \4F7F\7528\663E\793A\7684\522B\540D\6765\5F15\7528\5217\3002</li>'),
'</ul>',
unistr('<p>\5728\201C\8BA1\7B97\201D\4E4B\4E0B, \663E\793A\67E5\8BE2\4E2D\7684\5217\4EE5\53CA'),
unistr('\5173\8054\7684\522B\540D\3002\5355\51FB\5217\540D\6216\522B\540D\4F1A\5C06\5176\5305\542B'),
unistr('\5728\8BA1\7B97\4E2D\3002\5728\201C\5217\201D\7684\65C1\8FB9\662F\952E\533A\3002\6B64\952E\533A\7528\4F5C'),
unistr('\5E38\7528\952E\7684\5FEB\6377\65B9\5F0F\3002\6700\53F3\4FA7\662F\201C\51FD\6570\201D\3002</p>'),
unistr('<p>\4E0B\9762\7684\8BA1\7B97\793A\4F8B\6F14\793A\5982\4F55\663E\793A\603B\8865\507F:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\5176\4E2D A \4E3A ORGANIZATION, B \4E3A SALARY, C \4E3A COMMISSION)</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810324166402812)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\5728\4E00\5217\6216\591A\5217\4E0A\521B\5EFA\5206\9694\7EC4\3002\8FD9\5C06\4ECE\4EA4\4E92\5F0F\62A5\8868\4E2D\53D6\51FA\5217\5E76\5C06\5B83\4EEC\663E\793A\4E3A\4E3B\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804586945402808)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8981\6BCF\6B21\67E5\770B\4E00\884C\8BE6\7EC6\8D44\6599, \8BF7\5355\51FB\8981\67E5\770B\7684\884C\4E0A\7684\5355\884C\89C6\56FE\56FE\6807\3002\5982\679C\53EF\7528, \5219\5355\884C\89C6\56FE\5C06\59CB\7EC8\4E3A\7B2C\4E00\5217\3002\6839\636E\4EA4\4E92\5F0F\62A5\8868\7684\5B9A\5236, \5355\884C\89C6\56FE\53EF\4EE5\662F\6807\51C6\89C6\56FE\6216\5141\8BB8\66F4\65B0\7684\5B9A\5236\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804443257402808)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5141\8BB8\4E0B\8F7D\5F53\524D\7ED3\679C\96C6\3002\4E0B\8F7D\683C\5F0F'),
unistr('\4F1A\56E0\5B89\88C5\548C\62A5\8868\5B9A\4E49\7684\4E0D\540C\800C\5F02, \53EF\4EE5'),
unistr('\5305\62EC CSV, HTML, \7535\5B50\90AE\4EF6, XLS, PDF \6216 RTF\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803564292402808)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\901A\8FC7\6DFB\52A0\6216\4FEE\6539\67E5\8BE2\4E0A\7684 <code>WHERE</code> \5B50\53E5\6765\805A\7126\62A5\8868\3002\53EF\4EE5\6309\5217\6216\6309\884C\8FDB\884C\8FC7\6EE4\3002'),
unistr('<p>\5982\679C\6309\5217\8FDB\884C\8FC7\6EE4, \5219\9996\5148\9009\62E9\4E00\5217 (\4E0D\5FC5'),
unistr('\662F\663E\793A\7684\5217), \4ECE\6807\51C6 Oracle \8FD0\7B97\7B26 (=, !=, not in, between) \4E2D\8FDB\884C\9009\62E9, \7136\540E\8F93\5165\7528\4E8E\8FDB\884C\6BD4\8F83\7684\8868\8FBE\5F0F\3002\8868\8FBE\5F0F\533A\5206\5927\5C0F\5199\3002\4F7F\7528 % \4F5C\4E3A\901A\914D\7B26 (\4F8B\5982 <code>STATE_NAME'),
unistr('like A%)</code>\3002</p>'),
unistr('<p>\5982\679C\6309\884C\8FDB\884C\8FC7\6EE4, \5219\53EF\4EE5\4F7F\7528\5217\522B\540D\53CA\4EFB\4F55 Oracle \51FD\6570\6216\8FD0\7B97\7B26'),
unistr('(\4F8B\5982 <code>G = ''VA'' \6216 G = ''CT''</code>, \5176\4E2D <code>G</code>'),
unistr('\662F <code>CUSTOMER_STATE</code> \7684\522B\540D) \521B\5EFA\590D\6742 <code>WHERE</code> \5B50\53E5\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804180686402808)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\4F7F\7528\95EA\56DE\67E5\8BE2\53EF\4EE5\67E5\770B\4E4B\524D\7684\67D0\4E2A\65F6\95F4\70B9\4E0A\5B58\5728\7684\6570\636E\3002'),
unistr('\9ED8\8BA4\53EF\4EE5\95EA\56DE\7684\65F6\95F4\957F\5EA6\662F 3 \4E2A\5C0F\65F6 (\6216 180'),
unistr('\5206\949F), \4F46\5B9E\9645\7684\95EA\56DE\65F6\95F4\957F\5EA6\5C06\6839\636E\6570\636E\5E93\7684\4E0D\540C\800C\5F02\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865323540402852)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4F7F\7528\201C\683C\5F0F\201D\53EF\4EE5\5B9A\5236\62A5\8868\7684\663E\793A\3002'),
unistr('\201C\683C\5F0F\201D\5305\542B\4EE5\4E0B\5B50\83DC\5355\FF1A</p>'),
unistr('<ul><li>\6392\5E8F</li>'),
unistr('<li>\63A7\5236\5206\6BB5</li>'),
unistr('<li>\7A81\51FA\663E\793A</li>'),
unistr('<li>\8BA1\7B97</li>'),
unistr('<li>\805A\96C6</li>'),
unistr('<li>\56FE\8868</li>'),
unistr('<li>\5206\7EC4\65B9\5F0F</li>'),
unistr('<li>\900F\89C6</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863578299402851)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53EF\4EE5\4E3A\6BCF\4E2A\4FDD\5B58\7684\62A5\8868\5B9A\4E49\4E00\4E2A'),
unistr('\5206\7EC4\65B9\5F0F\89C6\56FE\3002\5B9A\4E49\4E4B\540E\FF0C\4F7F\7528\641C\7D22\680F\4E0A\7684\67E5\770B\56FE\6807\53EF\4EE5'),
unistr('\5728\5206\7EC4\65B9\5F0F\89C6\56FE\548C\62A5\8868\89C6\56FE\4E4B\95F4\5207\6362\3002\8981\521B\5EFA\5206\7EC4\65B9\5F0F\89C6\56FE\FF0C'),
unistr('\8BF7\9009\62E9\FF1A'),
'<p></p><ul>',
unistr('<li>\8981\5206\7EC4\7684\5217</li>'),
unistr('<li>\8981\805A\96C6\7684\5217\4EE5\53CA\8981\6267\884C\7684\51FD\6570 (average, sum, count \7B49)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803747927402808)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4E8E\5B9A\4E49\8FC7\6EE4\5668\3002\4F7F\7528\4E0E\8FC7\6EE4\5668\5173\8054\7684\7279\6027\7A81\51FA\663E\793A\6EE1\8DB3\8BE5\8FC7\6EE4\6807\51C6\7684\884C\3002\9009\9879\5305\62EC:</p>'),
'<ul>',
unistr('<li><strong>\540D\79F0</strong>, \4EC5\7528\4E8E\663E\793A\3002</li>'),
unistr('<li><strong>\5E8F\5217</strong>, \6807\8BC6\5BF9\89C4\5219\6C42\503C\65F6\4F7F\7528\7684\5E8F\5217\3002</li>'),
unistr('<li><strong>\542F\7528</strong>, \6807\8BC6\542F\7528\8FD8\662F\7981\7528\4E86\89C4\5219\3002</li>'),
unistr('<li><strong>\7A81\51FA\663E\793A\7C7B\578B</strong>, \6807\8BC6\5E94\7A81\51FA\663E\793A\884C\8FD8\662F'),
unistr('\5355\5143\3002\5982\679C\9009\62E9\201C\5355\5143\201D, \5219\7A81\51FA\663E\793A\5728'),
unistr('\7A81\51FA\663E\793A\6761\4EF6\4E2D\5F15\7528\7684\5217\3002</li>'),
unistr('<li><strong>\80CC\666F\8272</strong>, \662F\7A81\51FA\663E\793A\533A\57DF\7684\80CC\666F\7684\65B0\989C\8272\3002</li>'),
unistr('<li><strong>\6587\672C\989C\8272</strong>, \662F\7A81\51FA\663E\793A\533A\57DF\7684\6587\672C\7684\65B0\989C\8272\3002</li>'),
unistr('<li><strong>\7A81\51FA\663E\793A\6761\4EF6</strong>, \5B9A\4E49\8FC7\6EE4\6761\4EF6\3002</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741309108402763)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\53EF\4EE5\4E3A\6BCF\4E2A\4FDD\5B58\7684\62A5\8868\5B9A\4E49\4E00\4E2A\900F\89C6\89C6\56FE\3002\5B9A\4E49\4E4B\540E\FF0C\4F7F\7528\641C\7D22\680F\4E0A\7684\67E5\770B\56FE\6807\53EF\4EE5\5728\900F\89C6\89C6\56FE\548C\62A5\8868\89C6\56FE\4E4B\95F4\5207\6362\3002\8981\521B\5EFA\900F\89C6\89C6\56FE\FF0C\8BF7\9009\62E9\FF1A'),
'<p></p>',
'<ul>',
unistr('<li>\8981\900F\89C6\7684\5217</li>'),
unistr('<li>\8981\663E\793A\4E3A\884C\7684\5217</li>'),
unistr('<li>\8981\805A\96C6\7684\5217\4EE5\53CA\8981\6267\884C\7684\51FD\6570 (average, sum, count \7B49)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814818631402816)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\60A8\5B9A\5236\4E86\4EA4\4E92\5F0F\62A5\8868\FF0C\5219\62A5\8868\8BBE\7F6E\5C06\663E\793A'),
unistr('\5728\641C\7D22\680F\4E4B\4E0B\FF0C\62A5\8868\4E4B\4E0A\3002\4F7F\7528\5DE6\4FA7\7684\56FE\6807\53EF\4EE5\6298\53E0\548C\5C55\5F00\6B64\533A\57DF\3002'),
'<p>',
unistr('\5BF9\4E8E\6BCF\4E2A\62A5\8868\8BBE\7F6E\FF0C\60A8\53EF\4EE5\6267\884C\4EE5\4E0B\64CD\4F5C\FF1A'),
'</p><ul>',
unistr('<li>\901A\8FC7\5355\51FB\540D\79F0\6765\7F16\8F91\8BBE\7F6E\3002</li>'),
unistr('<li>\901A\8FC7\53D6\6D88\9009\4E2D\6216\9009\4E2D\201C\542F\7528/\7981\7528\201D\590D\9009\6846\6765\7981\7528/\542F\7528\8BBE\7F6E\3002\4F7F\7528\6B64\63A7\4EF6\53EF\4E34\65F6\5173\95ED\548C\5F00\542F\8BBE\7F6E\3002</li>'),
unistr('<li>\901A\8FC7\5355\51FB\201C\5220\9664\201D\56FE\6807\6765\5220\9664\8BBE\7F6E\3002</li>'),
'</ul>',
unistr('<p>\5982\679C\60A8\521B\5EFA\4E86\56FE\8868\3001\5206\7EC4\65B9\5F0F\6216\900F\89C6\FF0C\5219\53EF\4EE5\4F7F\7528\53F3\4FA7\663E\793A\7684'),
unistr('\201C\62A5\8868\89C6\56FE\201D\3001\201C\56FE\8868\89C6\56FE\201D\3001\201C\5206\7EC4\65B9\5F0F\89C6\56FE\201D\548C\201C\900F\89C6\89C6\56FE\201D\94FE\63A5\5728'),
unistr('\8FD9\4E9B\89C6\56FE\4E0E\57FA\7840\62A5\8868\4E4B\95F4\5207\6362\3002\5982\679C\60A8\6B63\5728\67E5\770B\56FE\8868\3001\5206\7EC4\65B9\5F0F\6216\900F\89C6\FF0C'),
unistr('\5219\8FD8\53EF\4EE5\4F7F\7528\201C\7F16\8F91\201D\94FE\63A5\6765\7F16\8F91\8BBE\7F6E\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804325244402808)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\62A5\8868\91CD\7F6E\56DE\9ED8\8BA4\8BBE\7F6E, \8FD9\5C06\5220\9664\4EFB\4F55\6240\505A\7684\5B9A\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865631444402852)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBE\7F6E\6BCF\9875\663E\793A\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804233163402808)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4FDD\5B58\5B9A\5236\7684\62A5\8868\4EE5\4F9B\5C06\6765\4F7F\7528\3002\60A8\9700\8981\63D0\4F9B\540D\79F0\548C\53EF\9009\8BF4\660E\FF0C\5E76\53EF\5C06\8BE5\62A5\8868\8BBE\4E3A\53EF\4F9B\516C\5171\FF08\5373\53EF\8BBF\95EE\4E3B\8981\9ED8\8BA4\62A5\8868\7684\6240\6709\7528\6237\FF09\8BBF\95EE\3002\53EF\4EE5\4FDD\5B58\56DB\79CD\7C7B\578B\7684\4EA4\4E92\5F0F\62A5\8868\FF1A</p>'),
'<ul>',
unistr('<li><strong>\4E3B\8981\9ED8\8BA4\503C</strong>\FF08\4EC5\9650\5F00\53D1\4EBA\5458\FF09\3002\201C\4E3B\8981\9ED8\8BA4\503C\201D\662F\6700\521D\663E\793A\7684\62A5\8868\3002\4E0D\80FD\91CD\547D\540D\6216\5220\9664\4E3B\8981\9ED8\8BA4\62A5\8868\3002</li>'),
unistr('<li><strong>\66FF\4EE3\62A5\8868</strong>\FF08\4EC5\9650\5F00\53D1\4EBA\5458\FF09\3002\5141\8BB8\5F00\53D1\4EBA\5458\521B\5EFA\591A\4E2A\62A5\8868\5E03\5C40\3002\53EA\6709\5F00\53D1\4EBA\5458\624D\80FD\4FDD\5B58\FF0C\91CD\547D\540D\6216\5220\9664\66FF\4EE3\62A5\8868\3002</li>'),
unistr('<li><strong>\516C\5171\62A5\8868</strong>\FF08\6700\7EC8\7528\6237\FF09\3002\53EF\7531\521B\5EFA\8BE5\62A5\8868\7684\7528\6237\4FDD\5B58\FF0C\91CD\547D\540D\6216\5220\9664\3002\5176\4ED6\7528\6237\53EF\4EE5\67E5\770B\62A5\8868\5E76\5C06\5E03\5C40\4FDD\5B58\4E3A\5176\4ED6\62A5\8868\3002</li>'),
unistr('<li><strong>\4E13\7528\62A5\8868</strong>\FF08\6700\7EC8\7528\6237\FF09\3002\53EA\6709\521B\5EFA\8BE5\62A5\8868\7684\7528\6237\624D\80FD\67E5\770B\FF0C\4FDD\5B58, \91CD\547D\540D\6216\5220\9664\5B83\3002</li>'),
'</ul>',
unistr('<p>\5982\679C\4FDD\5B58\5B9A\5236\7684\62A5\8868\FF0C\5219\4F1A\5728\884C\9009\62E9\5668\5DE6\4FA7\7684\641C\7D22\680F\4E2D\663E\793A\62A5\8868\9009\62E9\5668 (\5982\679C\542F\7528\4E86\6B64\529F\80FD)\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803227823402807)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\4E2A\62A5\8868\9875\9876\90E8\662F\641C\7D22\533A\57DF\3002\6B64\533A\57DF (\5373\641C\7D22\680F) \63D0\4F9B\4EE5\4E0B\529F\80FD:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866236691402853)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<li>\4F7F\7528<strong>\201C\64CD\4F5C\201D\83DC\5355</strong>\53EF\4EE5\5B9A\5236\62A5\8868\3002\8BF7\53C2\9605\540E\7EED\533A\6BB5\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865797271402852)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<li>\4F7F\7528<strong>\201C\9009\62E9\5217\201D\56FE\6807</strong>\53EF\4EE5\6807\8BC6\8981\641C\7D22\7684\5217 (\6216\5168\90E8\5217)\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866051049402852)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<li>\4F7F\7528<strong>\62A5\8868</strong>\53EF\4EE5\663E\793A\66FF\4EE3\9ED8\8BA4\62A5\8868\53CA\4FDD\5B58\7684\4E13\7528\6216\516C\5171\62A5\8868\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865933703402852)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<li>\4F7F\7528<strong>\884C\6570</strong>\53EF\4EE5\8BBE\7F6E\6BCF\9875\663E\793A\7684\8BB0\5F55\6570\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865833940402852)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>\5728<strong>\6587\672C\533A\57DF</strong>, \60A8\53EF\4EE5\8F93\5165\4E0D\533A\5206\5927\5C0F\5199\7684\641C\7D22\6807\51C6 (\652F\6301\901A\914D\7B26)\3002</li>'),
unistr('<li>\5355\51FB<strong>\201C\5F00\59CB\201D\6309\94AE</strong>\53EF\4EE5\6267\884C\641C\7D22\3002\5F53\5149\6807\4F4D\4E8E\641C\7D22\6587\672C\533A\57DF\5185\65F6, \70B9\51FB Enter \952E\4E5F\4F1A\6267\884C\641C\7D22\3002</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866192779402852)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<li><strong>\67E5\770B\56FE\6807</strong>\5728\56FE\6807\3001\62A5\8868\3001\8BE6\7EC6\4FE1\606F\3001\56FE\8868\3001\5206\7EC4\65B9\5F0F\548C\62A5\8868\7684\900F\89C6\89C6\56FE\FF08\5982\679C\5DF2\5B9A\4E49\FF09\4E4B\95F4\5207\6362\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882135625402865)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('<li>\4F7F\7528<strong>\7BA1\7406</strong>\53EF\4EE5\7BA1\7406\5C5E\6027, \5217, \884C\4EE5\53CA\67E5\770B\62A5\8868\6216\6570\636E\7F51\683C\7684\5386\53F2\8BB0\5F55\3002</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803404727402808)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\4FEE\6539\663E\793A\7684\5217\3002\663E\793A\53F3\4FA7\7684\5217, \9690\85CF\5DE6\4FA7\7684\5217\3002\4F7F\7528\6700\53F3\4FA7\7684\7BAD\5934\53EF\4EE5\5BF9\663E\793A\7684\5217\91CD\65B0\6392\5E8F\3002\8BA1\7B97\5217\5C06\6DFB\52A0\524D\7F00 <strong>**</strong>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803685255402808)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\7528\4E8E\66F4\6539\4F5C\4E3A\6392\5E8F\4F9D\636E\7684\5217\5E76\786E\5B9A\662F\6309'),
unistr('\5347\5E8F\8FD8\662F\964D\5E8F\6392\5217\3002\8FD8\53EF\4EE5\6307\5B9A\5982\4F55\5904\7406'),
unistr('<code>NULL</code>\3002\9ED8\8BA4\8BBE\7F6E\59CB\7EC8\5C06 <code>NULL</code> \663E\793A\5728\6700\540E\6216\59CB\7EC8\5C06\5176\663E\793A\5728\6700\524D\9762\3002\5F97\5230\7684\6392\5E8F\65B9\5F0F\5C06\663E\793A\5728'),
unistr('\62A5\8868\4E2D\5217\6807\9898\7684\53F3\4FA7\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863356970402850)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6DFB\52A0\8BA2\9605\65F6, \60A8\9700\8981\63D0\4F9B\7535\5B50\90AE\4EF6\5730\5740 (\6216\591A\4E2A\7535\5B50\90AE\4EF6\5730\5740, \7528\9017\53F7\5206\9694), \7535\5B50\90AE\4EF6\4E3B\9898, \9891\7387\53CA\5F00\59CB\548C\7ED3\675F\65E5\671F\3002\6240\751F\6210\7684\7535\5B50\90AE\4EF6\5305\62EC HTML \683C\5F0F\7684\4EA4\4E92\5F0F\62A5\8868, \5176\4E2D\5305\542B\4F7F\7528\6DFB\52A0\8BA2\9605\65F6\63D0\4F9B\7684\62A5\8868\8BBE\7F6E\7684\5F53\524D\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881936312402865)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\6570\636E\7F51\683C\57FA\672C\4E0A\662F\53EF\9AD8\5EA6\5B9A\5236\7684\53EF\7F16\8F91\62A5\8868\3002\7528\6237\53EF\4EE5\901A\8FC7\9009\62E9\5217, \5E94\7528\8FC7\6EE4\5668, \7A81\51FA\663E\793A\5E76\8FDB\884C\6392\5E8F, \6765\53D8\66F4\62A5\8868\6570\636E\7684\5E03\5C40\3002\6B64\5916, \7528\6237\8FD8\53EF\4EE5\5B9A\4E49\5206\6BB5, \805A\96C6, \56FE\8868, \5206\7EC4\65B9\5F0F\4EE5\53CA\6DFB\52A0\81EA\5DF1\7684\8BA1\7B97\3002\7528\6237\53EF\4EE5\521B\5EFA\62A5\8868\7684\591A\4E2A\53D8\4F53\5E76\5C06\5B83\4EEC\4FDD\5B58\4E3A\547D\540D\62A5\8868, \4EE5\4F9B\4E2A\4EBA\67E5\770B\3002'),
'<p/>',
unistr('\53EF\4EE5\4F7F\7528\641C\7D22\680F,\201C\64CD\4F5C\201D\83DC\5355,\201C\7BA1\7406\201D\83DC\5355\6216\201C\5217\6807\9898\201D\83DC\5355\5B9A\5236\6570\636E\7F51\683C\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893715166402874)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\64CD\4F5C\201D\83DC\5355\663E\793A\5728\641C\7D22\680F\4E0A\201C\5F00\59CB\201D\6309\94AE\7684\53F3\4FA7\3002\4F7F\7528\6B64\83DC\5355\53EF\4EE5\5B9A\5236\6570\636E\7F51\683C\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882496429402866)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\201C\6DFB\52A0/\7F16\8F91\884C\201D\9875')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882548967402866)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\8981\5411\6570\636E\7F51\683C\6DFB\52A0\884C, \8BF7\5355\51FB\201C\6DFB\52A0\884C\201D\3002\8981\7F16\8F91\884C\7684\8BE6\7EC6\8D44\6599, \8BF7\5728\8981\7F16\8F91\7684\884C\4E0A\5355\51FB\201C\7F16\8F91\884C\201D\56FE\6807 (\7B2C\4E00\5217)\3002\6B64\65F6\5C06\663E\793A\201C\6DFB\52A0/\7F16\8F91\884C\201D\9875, \5176\4E2D\663E\793A\4E86\6570\636E\7F51\683C\7684\5217\3002</p>'),
'',
unistr('<p>\7F16\8F91\884C\65F6, \53EF\4EE5\6267\884C\4EE5\4E0B\64CD\4F5C:</p>'),
'',
'<p><ul>',
unistr('<li><strong>\5220\9664</strong>\884C\3002</li>'),
unistr('<li><strong>\5E94\7528\66F4\6539</strong>\4EE5\4FDD\5B58\5BF9\884C\6240\505A\7684\66F4\6539\3002</li>'),
unistr('<li>\5728<strong>\64CD\4F5C</strong>\4E2D, \6DFB\52A0\884C, \6DFB\52A0\6587\4EF6, \6CE8\91CA, \94FE\63A5\6216\6807\8BB0\4EE5\53CA\590D\67E5\5386\53F2\8BB0\5F55\3002</li>'),
unistr('<li>\5BFC\822A\5230<strong>\540E\9762\548C\524D\9762</strong>\7684\884C\3002</li>'),
unistr('<li>\5728<strong>\7BA1\7406</strong>\4E2D, \8BBE\7F6E\5217\5C5E\6027, \5217\7EC4, \9A8C\8BC1\548C\503C\5217\8868\3002</li>'),
'</ul></p>',
'',
unistr('<p>\4F4D\4E8E\9875\5E95\90E8\7684\201C\6CE8\89E3\201D\533A\57DF\5C06\663E\793A\4E0E\5F53\524D\884C\5173\8054\7684\6240\6709\6587\4EF6, \6CE8\91CA, \94FE\63A5\6216\6807\8BB0\3002</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893851856402874)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\4E8E\5728\4E00\5217\6216\591A\5217\4E0A\521B\5EFA\5206\9694\7EC4\3002\8FD9\5C06\4ECE\6570\636E\7F51\683C\4E2D\53D6\51FA\5217\5E76\5C06\5B83\4EEC\663E\793A\4E3A\4E3B\8BB0\5F55\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882318375402866)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5141\8BB8\4E0B\8F7D\5F53\524D\7ED3\679C\96C6\3002\4E0B\8F7D\683C\5F0F'),
unistr('\5305\62EC CSV, HTML \6216\7535\5B50\90AE\4EF6\3002')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893958541402874)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\5982\679C\60A8\5B9A\5236\4E86\6570\636E\7F51\683C\62A5\8868, \5219\62A5\8868\8BBE\7F6E\5C06\663E\793A'),
unistr('\5728\641C\7D22\680F\4E4B\4E0B, \62A5\8868\4E4B\4E0A\3002\4F7F\7528\5DE6\4FA7\7684\56FE\6807\53EF\4EE5\6298\53E0\548C\5C55\5F00\6B64\533A\57DF\3002'),
'<p>',
unistr('\5BF9\4E8E\6BCF\4E2A\62A5\8868\8BBE\7F6E, \60A8\53EF\4EE5\6267\884C\4EE5\4E0B\64CD\4F5C:'),
'</p><ul>',
unistr('<li>\901A\8FC7\5355\51FB\540D\79F0\6765\7F16\8F91\8BBE\7F6E\3002</li>'),
unistr('<li>\901A\8FC7\53D6\6D88\9009\4E2D\6216\9009\4E2D\201C\542F\7528/\7981\7528\201D\590D\9009\6846\6765\7981\7528/\542F\7528\8BBE\7F6E\3002\4F7F\7528\6B64\63A7\4EF6\53EF\4E34\65F6\5173\95ED\548C\5F00\542F\8BBE\7F6E\3002</li>'),
unistr('<li>\901A\8FC7\5355\51FB\201C\5220\9664\201D\56FE\6807\6765\5220\9664\8BBE\7F6E\3002</li>'),
'</ul>',
unistr('<p>\5982\679C\60A8\521B\5EFA\4E86\56FE\8868\6216\5206\7EC4\65B9\5F0F, \5219\53EF\4EE5\4F7F\7528\53F3\4FA7\663E\793A\7684'),
unistr('\201C\62A5\8868\89C6\56FE\201D,\201C\56FE\8868\89C6\56FE\201D\548C\201C\5206\7EC4\65B9\5F0F\89C6\56FE\201D\94FE\63A5\5728'),
unistr('\8FD9\4E9B\89C6\56FE\4E0E\57FA\7840\62A5\8868\4E4B\95F4\5207\6362\3002\5982\679C\60A8\6B63\5728\67E5\770B\56FE\8868\6216\5206\7EC4\65B9\5F0F, '),
unistr('\5219\8FD8\53EF\4EE5\4F7F\7528\201C\7F16\8F91\201D\94FE\63A5\6765\7F16\8F91\8BBE\7F6E\3002</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882243398402865)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\4FDD\5B58\5B9A\5236\7684\6570\636E\7F51\683C\62A5\8868\5E03\5C40\4EE5\4F9B\5C06\6765\4F7F\7528\3002\60A8\9700\8981\63D0\4F9B\540D\79F0\548C\53EF\9009\8BF4\660E\3002\53EF\4EE5\4FDD\5B58\4E09\79CD\7C7B\578B\7684\6570\636E\7F51\683C\62A5\8868\5E03\5C40:</p>'),
'<ul>',
unistr('<li><strong>\4E3B\8981\9ED8\8BA4\503C</strong> (\4EC5\9650\7BA1\7406\5458)\3002\201C\4E3B\8981\9ED8\8BA4\503C\201D\662F\6700\521D\663E\793A\7684\5E03\5C40\3002\4E0D\80FD\91CD\547D\540D\6216\5220\9664\4E3B\8981\9ED8\8BA4\62A5\8868\3002</li>'),
unistr('<li><strong>\66FF\4EE3\62A5\8868</strong> (\4EC5\9650\7BA1\7406\5458)\3002\5141\8BB8\7BA1\7406\5458\521B\5EFA\591A\4E2A\62A5\8868\5E03\5C40\3002\53EA\6709\7BA1\7406\5458\624D\80FD\4FDD\5B58, \91CD\547D\540D\6216\5220\9664\66FF\4EE3\62A5\8868\3002</li>'),
unistr('<li><strong>\4E13\7528\62A5\8868</strong> (\6240\6709\7528\6237)\3002\521B\5EFA\8BE5\62A5\8868\5E03\5C40\7684\7528\6237\53EF\4EE5\67E5\770B, \4FDD\5B58, \91CD\547D\540D\6216\5220\9664\62A5\8868\3002</li>'),
'</ul>',
unistr('<p>\5982\679C\4FDD\5B58\5B9A\5236\7684\62A5\8868, \5219\4F1A\5728\884C\9009\62E9\5668\5DE6\4FA7\7684\641C\7D22\680F\4E2D\663E\793A\62A5\8868\9009\62E9\5668 (\5982\679C\542F\7528\4E86\6B64\529F\80FD)\3002</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808336111402811)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798954874402804)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809845298402812)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814936448402816)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\6761\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863910857402851)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773971086402787)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883432678402866)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6C34\5E73')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913028982402888)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \4E2A\4E0D\6D3B\52A8\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913123020402888)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\4E0D\6D3B\52A8\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804934464402809)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EA4\4E92\5F0F\62A5\8868\5E2E\52A9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815937373402816)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809349434402812)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\8868\8FBE\5F0F\65E0\6548\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768742328402783)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F\65E5\671F\5FC5\987B\665A\4E8E\5F00\59CB\65E5\671F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823633858402822)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\8868\8FBE\5F0F\65E0\6548\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891430066402872)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\6EE4\5668\67E5\8BE2\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913201961402888)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('1 \4E2A\65E0\6548\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913329904402888)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\65E0\6548\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864164017402851)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\FF08\5206\949F\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881162065402864)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\8FC7\53BB\7684 %1 \5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881399788402865)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5728\672A\6765\7684 %1 \5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881298043402865)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\8FC7\53BB\7684 %1 \5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881482248402865)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E0D\5728\672A\6765\7684 %1 \5185')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814008704402815)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\952E\533A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780128051402791)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807932105402811)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E\7684\8F74\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800430224402805)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB 1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800634033402806)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB 1 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800111692402805)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E2A\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800254635402805)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800385405402805)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800543231402806)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799934181402805)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FC7\53BB %0 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800032182402805)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53BB\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780072659402791)
,p_name=>'APEXIR_LINE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6298\7EBF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776827852402789)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EBF\5F62\9762\79EF\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891390584402872)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5730\56FE\5B9A\4F4D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808878066402811)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\8BA1\67E5\8BE2\4F1A\8D85\51FA\5141\8BB8\4F7F\7528\7684\8D44\6E90\4E0A\9650\3002\8BF7\4FEE\6539\62A5\8868\8BBE\7F6E, \7136\540E\91CD\8BD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791090954402799)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\62A5\8868\7684\6700\5927\884C\6570\662F %0 \884C\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\60A8\7684\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891992747402872)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892101659402873)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795029197402802)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F\4E4B\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892024817402873)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5C0F\503C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891093063402872)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864519848402851)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807102496402810)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807062768402810)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918276769402892)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\9875\5305\542B\591A\4E2A\4EA4\4E92\5F0F\62A5\8868, \5FC5\987B\6307\5B9A\533A\57DF\9759\6001 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775528996402788)
,p_name=>'APEXIR_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802997335402807)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\805A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913966679402888)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\7C7B\522B')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115803070493402807)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA\8BA1\7B97')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797859122402804)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800935252402806)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 1 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800761635402806)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 1 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801208869402806)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E2A\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801130981402806)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801091968402806)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115800890665402806)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801435954402806)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6765 %0 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801369921402806)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775840216402788)
,p_name=>'APEXIR_NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816179334402817)
,p_name=>'APEXIR_NONE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \65E0 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863756713402851)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\662F\6709\6548\7684\7535\5B50\90AE\4EF6\5730\5740\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812681719402814)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C\59CB\7EC8\5728\6700\524D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812533853402814)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C\59CB\7EC8\5728\6700\540E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813075937402814)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\503C\6392\5E8F %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809474032402812)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\95EA\56DE\65F6\95F4\5FC5\987B\4E3A\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809040185402812)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217\5FC5\987B\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813564909402815)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD0\7B97\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774420722402787)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A59\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883382673402866)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776344988402788)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5176\4ED6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759119957402776)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\65B9\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759829734402777)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A2A\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759940652402777)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EB5\5411')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759022208402776)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5927\5C0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759696532402777)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'zh-cn'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759549208402777)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'zh-cn'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759725010402777)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759311108402776)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'zh-cn'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759290652402776)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'zh-cn'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115759429604402776)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'zh-cn'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892441971402873)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\603B\8BA1\6570\7684\767E\5206\6BD4 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891676307402872)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\603B\548C\7684\767E\5206\6BD4 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890605374402872)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\8BA1\6570\7684\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890546237402871)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C\7684\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779987932402791)
,p_name=>'APEXIR_PIE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\997C\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839864321402834)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841342302402835)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\805A\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841522073402835)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5728\9009\62E9\4F5C\4E3A\884C\5217\7684\5217\4E0A\805A\96C6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840722603402834)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840530737402834)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841183823402835)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\900F\89C6\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741287736402763)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\67E5\8BE2\7684\6700\5927\884C\8BA1\6570\5C06\9650\5236\57FA\672C\67E5\8BE2\4E2D\7684\884C\6570\FF0C\800C\4E0D\662F\663E\793A\7684\884C\6570\3002\60A8\7684\57FA\672C\67E5\8BE2\8D85\8FC7\4E86\6700\5927\884C\8BA1\6570 (%0)\3002\8BF7\5E94\7528\8FC7\6EE4\5668\6765\51CF\5C11\57FA\672C\67E5\8BE2\4E2D\7684\8BB0\5F55\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841046304402834)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810403529402813)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\900F\89C6\5217\5305\542B\592A\591A\4E0D\540C\503C - \65E0\6CD5\751F\6210\900F\89C6 SQL\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863832334402851)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9884\89C8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797938949402804)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115889516561402871)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864873888402852)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758997526402776)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5305\62EC\53EF\8BBF\95EE\6027\6807\8BB0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745833459402767)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5265\9664\591A\4FE1\606F\6587\672C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822631960402821)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E13\7528')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780511973402791)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\516C\5171')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776130084402788)
,p_name=>'APEXIR_RED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EA2\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918196464402892)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\9759\6001 ID %0 \4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807297589402810)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807304960402810)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\5220\9664')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913476278402888)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806866143402810)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\63A7\5236\5206\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806504431402810)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806638144402810)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\95EA\56DE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913509569402888)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EC4\5220\9664\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806978492402810)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\7A81\51FA\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913681171402888)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\900F\89C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894682125402875)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664\62A5\544A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875230205402859)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\547D\540D\9ED8\8BA4\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816444823402817)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\547D\540D\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798294841402804)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892518072402873)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772712820402786)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\522B\540D %0 \4FDD\5B58\7684\4EA4\4E92\5F0F\62A5\8868\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822963013402821)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772800595402786)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ID \4E3A %0 \7684\5DF2\4FDD\5B58\4EA4\4E92\5F0F\62A5\8868\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115814779897402816)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795598003402802)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799490513402805)
,p_name=>'APEXIR_RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780780960402791)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\62A5\8868\8FD8\539F\4E3A\9ED8\8BA4\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775995622402788)
,p_name=>'APEXIR_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888613870402870)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528 ROWID \4F5C\4E3A REST \6570\636E\6E90\7684\4E3B\952E\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805985864402809)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865585194402852)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\9875\884C\6570')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840872978402834)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840603179402834)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841267830402835)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\884C\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841447736402835)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\5217\5FC5\987B\4E0D\540C\4E8E\900F\89C6\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820008708402819)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\8FC7\6EE4\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795690059402802)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7B2C %0 \884C, \5171 %1 \884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799629138402805)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\6587\672C\5305\542B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775244491402788)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810087611402812)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809947857402812)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\4FDD\5B58\7684\62A5\8868 = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812161105402814)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\62A5\8868\8BBE\7F6E\5C06\7528\4F5C\6240\6709\7528\6237\7684\9ED8\8BA4\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115875122991402859)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\9ED8\8BA4\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115799331945402805)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\62A5\8868')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913884804402888)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58\62A5\8868 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866500274402853)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115804825689402809)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\680F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115913764664402888)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\FF1A%0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872077667402857)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856055928402845)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776940627402789)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\5217 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798663791402804)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\5217')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780477814402791)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\51FD\6570 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805682920402809)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\201C\5206\7EC4\65B9\5F0F\201D\5217 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840336884402834)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\900F\89C6\5217 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891580843402872)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840410539402834)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('- \9009\62E9\884C\5217 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749125228402769)
,p_name=>'APEXIR_SEND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\9001')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755438339402774)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\7535\5B50\90AE\4EF6\53D1\9001')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775673475402788)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E8F\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798834735402804)
,p_name=>'APEXIR_SORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808174754402811)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5347\5E8F\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808221519402811)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\964D\5E8F\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894049469402874)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6392\5E8F\987A\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802689963402807)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A7A\683C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813785084402815)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\72B6\6001 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864238828402851)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890965170402872)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\675F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745361416402766)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6570\636E\65F6\8DF3\8FC7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115890860391402872)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D77\59CB\4E8E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891788313402872)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\548C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881754060402865)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF = %0, \62A5\8868 = %1, \89C6\56FE = %2, \663E\793A\7684\884C\5F00\5934 = %3, \663E\793A\7684\884C\672B\5C3E = %4, \603B\884C\6570 = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802369361402807)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF = %0\FF0C\62A5\8868 = %1\FF0C\89C6\56FE = %2\FF0C\663E\793A\7684\884C\5F00\5934 = %3\FF0C\663E\793A\7684\884C\672B\5C3E = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774501885402787)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\672C\989C\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791658652402799)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791541168402799)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791460221402799)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791818633402799)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791741733402799)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115791912241402799)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115894436130402874)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5207\6362')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807434452402810)
,p_name=>'APEXIR_TOP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9876\90E8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887622010402869)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5206\7EC4\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808904394402811)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A\540D\79F0\5FC5\987B\552F\4E00\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779210486402790)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\7684\6570\636E\7C7B\578B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807563802402811)
,p_name=>'APEXIR_UP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5411\4E0A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809103991402812)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\6709\6548\7684\989C\8272\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809244261402812)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\8F93\5165\6709\6548\7684\683C\5F0F\63A9\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115776433030402788)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115808010583402811)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\7684\8F74\6807\9898')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815830030402816)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700\7684\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779817114402791)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4\67F1\72B6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115883583457402866)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815142511402816)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\56FE\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870339283402856)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\8BE6\7EC6\4FE1\606F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115915982977402890)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\62A5\8868\5B9A\4E49 %0 \89C6\56FE\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870415375402856)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\5206\7EC4\65B9\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870260791402855)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\56FE\6807')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840128759402834)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\900F\89C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115815280028402816)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864443753402851)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798144509402804)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893185984402873)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893071435402873)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115892955088402873)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893373766402874)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893280060402873)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115893430277402874)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115891128064402872)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115774254587402787)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9EC4\8272')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115775789939402788)
,p_name=>'APEXIR_YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115807840810402811)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5305\542B\65E0\6548\5B57\7B26 < \6216 >\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115830618572402827)
,p_name=>'APEX_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115758848315402776)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FDD\53CD API \524D\7F6E\6761\4EF6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778347689402790)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\7981\7528\4E86\5173\8054\7684\6784\5EFA\9009\9879\FF0C\65E0\6CD5\83B7\53D6\5E94\7528\7A0B\5E8F\8BBE\7F6E %0 \7684\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778270077402790)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\7981\7528\4E86\5173\8054\7684\6784\5EFA\9009\9879\FF0C\65E0\6CD5\4E3A\5E94\7528\7A0B\5E8F\8BBE\7F6E %0 \8BBE\7F6E\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885998742402868)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E %0 \503C\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115885897091402868)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\5B9A\4E49\8BF7\6C42\7684\5E94\7528\7A0B\5E8F\8BBE\7F6E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886004435402868)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\8BBE\7F6E %0 \4E0D\80FD\8BBE\7F6E\4E3A\7A7A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766946239402782)
,p_name=>'BACK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540E\9000')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753982820402773)
,p_name=>'BUILDER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6784\5EFA\5668')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818018727402818)
,p_name=>'BUTTON LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE\6807\7B7E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753090149402772)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\94AE CSS \7C7B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782218622402793)
,p_name=>'BUTTON_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\7684\6309\94AE ID \5C06\4E3A\6309\94AE\7684\9759\6001 ID (\5982\679C\5B9A\4E49), \6216\8005\4E3A\5185\90E8\751F\6210\7684 ID (\5982\679C\672A\5B9A\4E49), \683C\5F0F\4E3A ''B'' || [\5185\90E8\6309\94AE ID]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745700645402767)
,p_name=>'CANDLESTICK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('K \7EBF\56FE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827259834402825)
,p_name=>'CENTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E2D\95F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777227637402789)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \8BF7\6C42')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768695902402783)
,p_name=>'CHECK$'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\9009\62E9\5668')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115887706949402869)
,p_name=>'CHECKED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\4E2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863277894402850)
,p_name=>'COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823791247402822)
,p_name=>'COMMENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\91CA')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805218679402809)
,p_name=>'CONTINUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7EE7\7EED')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767290308402782)
,p_name=>'COPYRIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7248\6743\6240\6709 (c) %0\FF0C\4FDD\7559\6240\6709\6743\5229\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810937925402813)
,p_name=>'COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\6570')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817620034402818)
,p_name=>'CREATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869937813402855)
,p_name=>'CREATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65F6\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870062303402855)
,p_name=>'CREATED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794836308402801)
,p_name=>'CREATED_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\65F6\95F4')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805458779402809)
,p_name=>'CUSTOM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816626269402817)
,p_name=>'CUSTOMIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B9A\5236')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818271518402818)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7528\6237 %0 \91CD\7F6E\9875\9996\9009\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818316159402818)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \7684\9996\9009\9879\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818144293402818)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\7528\6237 %0 \91CD\7F6E\9875\9996\9009\9879\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781953011402792)
,p_name=>'DAILY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\5929')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115753580892402772)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\7684\6587\4EF6\65E0\6548\6216\5177\6709\9519\8BEF\7684\6269\5C55\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777492482402789)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\7684 XML \6216 JSON \9009\62E9\5668\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746742286402767)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\6982\8981\6587\4EF6\548C\5DF2\4E0A\8F7D\6587\4EF6\4E0D\5305\542B\4EFB\4F55\76EE\6807\8868\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832497791402828)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\4E0A\8F7D\7684\6587\4EF6\4E2D\627E\4E0D\5230\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832599512402828)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5DE5\4F5C\8868 "%0" \4E2D\627E\4E0D\5230\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115752353227402771)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\6587\4EF6\4E0D\662F XLSX \6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115742758439402764)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5DF2\5B8C\6210\FF1A\5DF2\5904\7406 %0 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743906249402765)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5DF2\5B8C\6210\FF1A\5DF2\5904\7406 %0 \884C\FF0C\51FA\73B0 1 \4E2A\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744223910402765)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5DF2\5B8C\6210\FF1A\5DF2\5904\7406 %0 \884C\FF0C\51FA\73B0 %1 \4E2A\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744005718402765)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5DF2\5B8C\6210\FF1A\5DF2\5904\7406 1 \884C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747001124402767)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5DF2\5B8C\6210\FF1A\5DF2\5904\7406 1 \884C\FF0C\4F46\51FA\73B0\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744118954402765)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\52A0\8F7D\5DF2\5B8C\6210\FF1A\5DF2\5904\7406 1 \884C\FF0C\672A\51FA\73B0\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837739015402832)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\76EE\6807\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837812010402832)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E90\5217')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838627218402833)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F/\6570\5B57\683C\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902024942402880)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\68C0\7D22\67E5\627E\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115870548664402856)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E/\8868\6620\5C04')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838794191402833)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834268210402830)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8F6C\6362\89C4\5219\5931\8D25')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810544749402813)
,p_name=>'DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E5\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784613373402794)
,p_name=>'DAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784785145402794)
,p_name=>'DAYS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5929')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823481913402822)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\6B64\5E94\7528\7A0B\5E8F\542F\7528\8C03\8BD5\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115872260094402857)
,p_name=>'DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785443892402795)
,p_name=>'DELETE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5220\9664')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115745635894402766)
,p_name=>'DIAL_PCT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EEA\8868\76D8\FF08\767E\5206\6BD4\FF09')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760110482402777)
,p_name=>'DOWNLOAD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\8F7D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871322030402856)
,p_name=>'DUP_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868\4E2D\7684\7528\6237\540D\91CD\590D\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767725909402782)
,p_name=>'EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777161493402789)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\7535\5B50\90AE\4EF6\5730\5740 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762215401402778)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\7535\5B50\90AE\4EF6\5DF2\7531%0\53D1\9001\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871538885402856)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740\8FC7\957F\3002\957F\5EA6\9650\5236\4E3A 240 \4E2A\5B57\7B26\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805135651402809)
,p_name=>'ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834339741402830)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4E3A\90E8\5206\9875\5237\65B0\533A\57DF\8BBE\7F6E\9875\9879\6E90\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796646473402803)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\521B\5EFA\8005')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762550599402779)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5931\6548')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115756625298402774)
,p_name=>'FILE_EMPTY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6587\4EF6\4E3A\7A7A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836846879402831)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\8F7D\6587\4EF6\5927\5C0F\8D85\8FC7 %0 MB\3002\8BF7\4E0A\8F7D\8F83\5C0F\7684\6587\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764676022402780)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\9A8C\8BC1\5931\8D25\FF0C\4E00\4E2A\6216\591A\4E2A\6587\4EF6\672A\4E0A\8F7D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764746804402780)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\5B9E\4F8B\4E0D\5141\8BB8\672A\9A8C\8BC1\7684\7528\6237\4E0A\8F7D\6587\4EF6\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817735608402818)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\73B0 1 \4E2A\9519\8BEF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816936382402817)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\51FA\73B0 %0 \4E2A\9519\8BEF')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767121682402782)
,p_name=>'FORM_OF'
,p_message_language=>'zh-cn'
,p_message_text=>'%0/%1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801869756402806)
,p_name=>'GO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901602025402880)
,p_name=>'HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E2E\52A9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754027219402773)
,p_name=>'HOME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\9875')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784406160402794)
,p_name=>'HOUR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784558966402794)
,p_name=>'HOURS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C0F\65F6')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768565488402783)
,p_name=>'ICON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\56FE\6807 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818574441402818)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55\8EAB\4EFD\8BC1\660E\65E0\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115918044722402892)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53C2\6570 %0 \7684\503C\65E0\6548')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813252481402815)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\9ED8\8BA4\62A5\8868\8BBE\7F6E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813391646402815)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F5C\4E3A\547D\540D\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795782295402802)
,p_name=>'IR_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \9519\8BEF\3002%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795457195402802)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\8BA1\7B97\8868\5355\5BFC\822A\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773077304402786)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\4EA4\4E92\5F0F\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772449015402786)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F %0, \9875 %1 \548C\533A\57DF %2 \4E2D\4E0D\5B58\5728\4EA4\4E92\5F0F\62A5\8868\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115813133356402814)
,p_name=>'IR_STAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4EC5\5BF9\5F00\53D1\4EBA\5458\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801558721402806)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\67E5\8BE2\9700\8981\552F\4E00\5173\952E\5B57\6765\6807\8BC6\5404\884C\3002\63D0\4F9B\7684\5173\952E\5B57\4E0D\80FD\7528\4E8E\6B64\67E5\8BE2\3002\8BF7\5B9A\4E49\552F\4E00\5173\952E\5B57\5217\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801665815402806)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\67E5\8BE2\9700\8981\552F\4E00\5173\952E\5B57\6765\6807\8BC6\5404\884C\3002\63D0\4F9B\7684\5173\952E\5B57\65E0\6CD5\7528\4E8E\6B64\67E5\8BE2\3002\8BF7\7F16\8F91\62A5\8868\5C5E\6027\4EE5\5B9A\4E49\552F\4E00\5173\952E\5B57\5217\3002%0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838924509402833)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\6587\4EF6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838876554402833)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\6587\4EF6\62D6\653E\5728\6B64\5904\6216\8005')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767466138402782)
,p_name=>'ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796806243402803)
,p_name=>'ITEM_VALUE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811298849402813)
,p_name=>'LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\7B7E')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823356177402822)
,p_name=>'LANGUAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\8A00')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785167995402795)
,p_name=>'LAST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\540E\4E00\4E2A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764508149402780)
,p_name=>'LENGTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\957F\5EA6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817870370402818)
,p_name=>'LOGIN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856457147402846)
,p_name=>'MANAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7BA1\7406')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115921096115402894)
,p_name=>'MAXIMIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\5927\5316')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784258337402794)
,p_name=>'MINUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784368199402794)
,p_name=>'MINUTES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5206\949F')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871775775402857)
,p_name=>'MISSING_AT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740\4E2D\7F3A\5C11 "@"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871994878402857)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A: \6CA1\6709\4E3A\5E94\7528\7A0B\5E8F%1\4E2D\7684\201C\5BF9\8BDD\6846\201D\9875%0\5B9A\4E49\201C\5BF9\8BDD\6846\9875\201D\6A21\677F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871620321402856)
,p_name=>'MISSING_DOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6\5730\5740\57DF\4E2D\7F3A\5C11 "."\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820801427402820)
,p_name=>'MODULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6A21\5757')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777970321402789)
,p_name=>'MONTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781763016402792)
,p_name=>'MONTHLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\6708')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778053524402790)
,p_name=>'MONTHS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6708')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810896888402813)
,p_name=>'MOVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878346473402862)
,p_name=>'MOVE_FROM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8\81EA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878402538402862)
,p_name=>'MOVE_TO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79FB\52A8\81F3')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115798070603402804)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\591A\884C\5220\9664\64CD\4F5C\65F6\51FA\9519: \884C= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797056311402803)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\662F\516C\5171\7528\6237')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754242350402773)
,p_name=>'NAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\540D\79F0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811036608402813)
,p_name=>'NEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5EFA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777727848402789)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\8F6C\5230\4EE5\4E0B\4F4D\7F6E\6765\767B\5F55\5230 %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777839420402789)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0 %0 \5E10\6237\901A\77E5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901825584402880)
,p_name=>'NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820707461402820)
,p_name=>'NO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5426')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115916005779402890)
,p_name=>'NOBODY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\4EBA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785587051402795)
,p_name=>'NOT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826332705402824)
,p_name=>'NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E\7A7A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797122867402803)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\975E %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816770617402817)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\6570\636E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825814549402823)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\53EF\66F4\65B0\7684\62A5\8868\3002\53EA\80FD\5BF9 ''\53EF\66F4\65B0\7684\62A5\8868'' \7C7B\578B\7684\8868\683C\5F0F\8868\5355\6267\884C\591A\884C\66F4\65B0\548C\5220\9664\64CD\4F5C\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826798984402824)
,p_name=>'OK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822463163402821)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'zh-cn'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115919877121402893)
,p_name=>'ORA_06550'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ORA-06550: \884C %0, \5217 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869372932402855)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\4F7F\7528\7684 Web \6D4F\89C8\5668\5DF2\8FC7\65F6\3002\6709\5173\652F\6301\7684\6D4F\89C8\5668\5217\8868, \8BF7\53C2\9605 Oracle Application Express Installation Guide\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770725086402784)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\7684\884C\96C6\65E0\6548, \62A5\8868\7684\6E90\6570\636E\5DF2\4FEE\6539\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790873449402799)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\6709\6548\7684\9875\7801, \4F8B\5982 p?n=1234\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794408598402801)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794556138402801)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0B\4E00\4E2A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794644544402801)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115794791393402801)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A\96C6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901725862402880)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832371718402828)
,p_name=>'PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777077033402789)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\7684 %0 \5BC6\7801\5DF2\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766836764402782)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\4E0D\7B26\5408\6B64\7AD9\70B9\7684\5BC6\7801\590D\6742\6027\89C4\5219\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765926769402781)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65B0\5BC6\7801\4E2D\5FC5\987B\81F3\5C11\6709 %0 \4E2A\5B57\7B26\4E0E\65E7\5BC6\7801\4E0D\540C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766587052402781)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\4E0D\80FD\5305\542B\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766759396402782)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\4E2D\5305\542B\7981\6B62\7684\7B80\5355\5355\8BCD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766611717402782)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\4E0D\80FD\5305\542B\5DE5\4F5C\533A\540D\79F0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765878579402781)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5FC5\987B\81F3\5C11\5305\542B %0 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766079309402781)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5FC5\987B\81F3\5C11\5305\542B\4E00\4E2A\5B57\6BCD\5B57\7B26 (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766453740402781)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5FC5\987B\81F3\5C11\5305\542B\4E00\4E2A\5C0F\5199\7684\5B57\6BCD\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766183590402781)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5FC5\987B\81F3\5C11\5305\542B\4E00\4E2A\6570\5B57\5B57\7B26 (0123456789)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766257136402781)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5FC5\987B\81F3\5C11\5305\542B\4E00\4E2A\6807\70B9\5B57\7B26 (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115766303922402781)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\5FC5\987B\81F3\5C11\5305\542B\4E00\4E2A\5927\5199\7684\5B57\6BCD\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777516694402789)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801\91CD\7F6E\901A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764891451402780)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\80FD\4F7F\7528\6B64\5BC6\7801, \56E0\4E3A\5728\8FC7\53BB %0 \5929\5185\4F7F\7528\8FC7\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845132918402837)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115845226725402837)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822217112402821)
,p_name=>'PERCENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767E\5206\6BD4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792550932402800)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115901975348402880)
,p_name=>'PREVIOUS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E00\4E2A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837333995402832)
,p_name=>'PRINT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6253\5370')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821094638402820)
,p_name=>'PRIVILEGES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790958768402799)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\5F15\7528')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811197495402813)
,p_name=>'REPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820947014402820)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\544A\65F6\6BB5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902138234402880)
,p_name=>'REPORT_LABEL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821606328402821)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\62A5\8868\603B\8BA1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770843883402784)
,p_name=>'RESET'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796765360402803)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\9875\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825769064402823)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\7F6E\5BC6\7801')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802594802402807)
,p_name=>'RESTORE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD8\539F')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115834416218402830)
,p_name=>'RESULTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7ED3\679C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826864660402824)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8FD4\56DE\5E94\7528\7A0B\5E8F\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115827132512402824)
,p_name=>'RIGHT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53F3')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856748996402846)
,p_name=>'ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810708871402813)
,p_name=>'ROW_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C\8BA1\6570')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115826247430402824)
,p_name=>'SAVE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4FDD\5B58')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822893558402821)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66FF\4EE3\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823281207402822)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF4\660E')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822707886402821)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3B\8981\9ED8\8BA4\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823529716402822)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\8D85\8FC7 %0 \884C\53EF\7528\3002\6269\5927\884C\9009\62E9\5668\7684\53EF\67E5\770B\66F4\591A\884C\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888940662402870)
,p_name=>'SEARCH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\641C\7D22')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784189254402794)
,p_name=>'SECONDS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\79D2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822369342402821)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\9644\52A0\9879')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880030260402864)
,p_name=>'SELECT_ROW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\62E9\884C')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822088585402821)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5C4F\5E55\9605\8BFB\5668\6A21\5F0F\8BBE\7F6E\4E3A\201C\5173\95ED\201D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822121677402821)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C06\5C4F\5E55\9605\8BFB\5668\6A21\5F0F\8BBE\7F6E\4E3A\201C\6253\5F00\201D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818470708402818)
,p_name=>'SHOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881865535402865)
,p_name=>'SHOW_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\663E\793A')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115907967043402884)
,p_name=>'SIGN_IN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\767B\5F55')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115857510945402846)
,p_name=>'SIGN_OUT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CE8\9500')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811712823402813)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5929\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818970036402819)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \5929')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811697222402813)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5C0F\65F6\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818844892402819)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \5C0F\65F6')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811539883402813)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5206\949F\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818747857402818)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \5206\949F')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811910161402814)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2A\6708\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819189734402819)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \4E2A\6708')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819312835402819)
,p_name=>'SINCE_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\73B0\5728')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811471114402813)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \79D2\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115818624572402818)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \79D2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115811842109402814)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5468\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819082001402819)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \5468')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115812021904402814)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5E74\4E4B\524D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819219524402819)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECE\73B0\5728\8D77 %0 \5E74')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805572918402809)
,p_name=>'STANDARD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\51C6')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821956499402821)
,p_name=>'START_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F00\59CB\65E5\671F')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762449878402779)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\63A5\6536\7684\8FD9\5C01\7535\5B50\90AE\4EF6\6765\81EA\7531%0\521B\5EFA\7684\4EA4\4E92\5F0F\62A5\8868\8BA2\9605\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917189628402891)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA2\9605')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865276851402852)
,p_name=>'TAB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\9879\5361')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784070546402794)
,p_name=>'TITLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6807\9898')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767027991402782)
,p_name=>'TODAY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4ECA\5929')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821529009402820)
,p_name=>'TOTAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\603B\8BA1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768096959402783)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6700\591A\53EF\4EE5\9009\62E9 %0 \5217\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746592574402767)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\6298\53E0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746849931402767)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF\6240\6709\4E0B\7EA7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746448978402767)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5168\90E8\5C55\5F00')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746608233402767)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5C55\5F00\6240\6709\4E0B\7EA7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746958519402767)
,p_name=>'TREE.REPARENT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\91CD\5EFA\7236\7EA7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839177632402833)
,p_name=>'TREES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6811')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115882619311402866)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\9700')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115806278931402810)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6388\6743')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115853071014402843)
,p_name=>'UNAVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819788083402819)
,p_name=>'UNKNOWN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\77E5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763385954402779)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53D1\751F\4E86\65E0\6CD5\8BC6\522B\7684\9A8C\8BC1\9519\8BEF\3002')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765349354402781)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\4E0D\518D\5E0C\671B\63A5\6536\6B64\7535\5B50\90AE\4EF6, \8BF7\5355\51FB<a href="%0">\53D6\6D88\8BA2\9605</a>\4EE5\7BA1\7406\60A8\7684\8BA2\9605\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115762399450402778)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5982\679C\4E0D\518D\5E0C\671B\63A5\6536\7535\5B50\90AE\4EF6, \8BF7\8F6C\5230\4EE5\4E0B URL \6765\7BA1\7406\60A8\7684\8BA2\9605:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115797290038402803)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\7684\6570\636E\7C7B\578B')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785339158402795)
,p_name=>'UPDATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783965554402794)
,p_name=>'UPDATED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\66F4\65B0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790623345402799)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\7684 URL \5DF2\7981\6B62\3002\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115810626144402813)
,p_name=>'USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115832293382402828)
,p_name=>'USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871894428402857)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\8FC7\957F\3002\957F\5EA6\9650\5236\4E3A %0 \4E2A\5B57\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817468077402818)
,p_name=>'USERS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115871484862402856)
,p_name=>'USER_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D\5DF2\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115886110981402868)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237 %0 \7684\6982\8981\6587\4EF6\56FE\50CF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773799763402786)
,p_name=>'VALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6709\6548')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767306852402782)
,p_name=>'VALIDATIONS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823097544402821)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866483676402853)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A%0\6307\5B9A\503C')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792901265402800)
,p_name=>'VERTICAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5782\76F4')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785220242402795)
,p_name=>'VIEW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817535540402818)
,p_name=>'VIEWS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\89C6\56FE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823873283402822)
,p_name=>'VIEW_ALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\770B\5168\90E8')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115805058378402809)
,p_name=>'WARNING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8B66\544A')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784827493402794)
,p_name=>'WEEK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781831671402792)
,p_name=>'WEEKLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6BCF\5468')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115784995491402794)
,p_name=>'WEEKS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5468')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115823171408402822)
,p_name=>'WELCOME_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B22\8FCE\4F7F\7528\FF1A%0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821383034402820)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\65E0\6548\7684\503C, \8BF7\68C0\67E5\8F93\5165\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821476735402820)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\65E0\6548\7684\503C, \8BF7\68C0\67E5\8F93\5165\7684\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764479005402780)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\65E0\6548\7684\65E5\671F\503C, \8BF7\68C0\67E5\65E5\671F\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115821294073402820)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\65E0\6548\7684\6570\5B57\503C, \8BF7\68C0\67E5\6570\5B57\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773306342402786)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230\65E0\6548\7684\65F6\95F4\6233\503C, \8BF7\9A8C\8BC1\65F6\95F4\6233\683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115795878008402802)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\7ED1\5B9A "%0"\3002\4E3A\591A\5B57\8282\9879\4F7F\7528\53CC\5F15\53F7, \6216\9A8C\8BC1\9879\7684\957F\5EA6\662F\5426\5C11\4E8E 30 \5B57\8282\3002\4F7F\7528 v() \8BED\6CD5\53EF\5F15\7528\957F\5EA6\8D85\8FC7 30 \5B57\8282\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786394986402795)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \5B89\5168\68C0\67E5\62D2\7EDD\7684\8BBF\95EE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788848369402797)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\53EF\7528\7684\5E94\7528\7A0B\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787209884402796)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1014 \672A\627E\5230\5E94\7528\7A0B\5E8F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787329134402796)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F=%0  \5DE5\4F5C\533A=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787782540402796)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BF9\6B64\5E94\7528\7A0B\5E8F\7684\8BBF\95EE\53D7\5230\9650\5236, \8BF7\7A0D\540E\91CD\8BD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787674146402796)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EA\5141\8BB8\5E94\7528\7A0B\5E8F\5F00\53D1\4EBA\5458\8BBF\95EE\6B64\5E94\7528\7A0B\5E8F\FF0C\8BF7\7A0D\540E\91CD\8BD5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786881489402796)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-7744 \65E0\6CD5\5904\7406\5206\652F\5230\8FD4\56DE URL \7684\51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786794984402796)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-7744 \65E0\6CD5\5904\7406\5206\652F\5230\8FD4\56DE\9875\7684\51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787028024402796)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1430 \4E0D\652F\6301\4ECE\9875\5904\7406\8C03\7528\4EE5\663E\793A: G_FLOW_STEP_ID (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788130918402797)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1018 \6E05\9664\6B65\9AA4\9AD8\901F\7F13\5B58\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786540479402796)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1005 \672A\77E5\7684\8BA1\7B97\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787457844402796)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1201 \5728\5B9A\5236\9A8C\8BC1\65F6\672A\8BBE\7F6E\4F1A\8BDD ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787532357402796)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115787152261402796)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-7620 \65E0\6CD5\786E\5B9A\5E94\7528\7A0B\5E8F (%0) \7684\5DE5\4F5C\533A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769525434402784)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7F16\8F91')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786292574402795)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1802 \672A\627E\5230\9879 ID "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785975467402795)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1002 \5728\5E94\7528\7A0B\5E8F "%1" \4E2D\672A\627E\5230\9879 "%0" \7684\9879 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786021783402795)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\610F\5916\9519\8BEF, \5728\5E94\7528\7A0B\5E8F\7EA7\522B\6216\9875\7EA7\522B\4E0A\672A\627E\5230\9879\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786401348402795)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\5728\6570\636E\7684\7B2C\4E00\9875\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115801920542402807)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879 ID (%0) \4E0D\662F\5728\5F53\524D\9875\4E0A\5B9A\4E49\7684\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764046272402780)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\901A\8FC7\5C06\53C2\6570\4F20\9012\5230\5E94\7528\7A0B\5E8F\6765\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764387765402780)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('(\672A\63D0\4F9B\6821\9A8C\548C)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763842477402780)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\5728\9879\5177\6709 "\7528\6237\7EA7\4E66\7B7E" \6821\9A8C\548C\65F6\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763789669402779)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\5728\9879\5177\6709 "\5E94\7528\7A0B\5E8F\7EA7\4E66\7B7E" \6821\9A8C\548C\65F6\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763902056402780)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\5728\9879\5177\6709 "\4F1A\8BDD" \6821\9A8C\548C\65F6\8BBE\7F6E\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763696681402779)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9879\6CA1\6709\4FDD\62A4\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788298601402797)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\53EF\7528\7684\9875\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115777367380402789)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A %0 \6CA1\6709\4F5C\4E3A\65B9\6848 %1 \8FDB\884C\8BED\6CD5\5206\6790\7684\6743\9650\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786608220402796)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1010 \5DF2\8D85\8FC7\5206\652F\5230\9875\63A5\53D7\7684\5904\7406\9012\5F52\9650\5236\503C\3002%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764255179402780)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4F7F\7528 URL, GET \6216 POST \6765\8C03\7528\6B64\9875\4EE5\663E\793A\8FC7\7A0B, \5FC5\987B\4F7F\7528 "\5206\652F\5230\9875" \5206\652F\7C7B\578B\624D\80FD\8C03\7528\5B83\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115840909353402834)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BD5\56FE\5728\9879 %0 \4E2D\4FDD\5B58\975E\6570\5B57\503C\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779076164402790)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\7684\8BED\6CD5\5206\6790\65B9\6848 "%0" \5728\6570\636E\5E93\4E2D\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115779166414402790)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('INTERNAL \5DE5\4F5C\533A\4E2D\7684\8D26\6237\53EA\80FD\7528\4E8E\8BBF\95EE &PRODUCT_NAME. <a href="%0">\7BA1\7406\670D\52A1</a>\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785871177402795)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-1029 \65E0\6CD5\5B58\50A8\4F1A\8BDD\4FE1\606F\3002\4F1A\8BDD=%0 \9879=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788962256402797)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\505C\6B62\8DDF\8E2A: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115786169231402795)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\610F\5916\9519\8BEF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796127474402802)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('update_substitution_cache \4E2D\51FA\73B0\9519\8BEF: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789033218402797)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\63D0\4F9B\5E94\7528\7A0B\5E8F\548C\9875\624D\80FD\67E5\770B\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115809562839402812)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\627E\5230\81EA\52A8\5316\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790189360402798)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6E05\9664 %0 \4E2A\4F1A\8BDD\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749442800402769)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\6267\884C %0 \4EE3\7801\FF01\5B83\4E0D\53D7\6570\636E\5E93\652F\6301\6216\8005\672A\7531\5B9E\4F8B\53C2\6570 MLE_LANGUAGES \542F\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115749231950402769)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\8BED\8A00\5F15\64CE\5728\6B64\6570\636E\5E93\7248\672C\4E2D\4E0D\53EF\7528\FF01')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770015223402784)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\96C6\5408\6570\7EC4\4E0D\80FD\4E3A\7A7A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769887559402784)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\6210\5458\5C5E\6027\7F16\53F7 %0 \65E0\6548\3002\5C5E\6027\7F16\53F7\5FC5\987B\4ECB\4E8E 1 \548C %1 \4E4B\95F4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770398531402784)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5B58\5728\5E94\7528\7A0B\5E8F\96C6\5408')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770118338402784)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408\540D\4E0D\80FD\4E3A\7A7A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770236584402784)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\96C6\5408\540D\4E0D\80FD\5927\4E8E 255 \4E2A\5B57\7B26')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769647276402784)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\96C6\5408 %0 \4E0D\5B58\5728')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770491738402784)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6E38\6807\5C1A\672A\6253\5F00')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769766609402784)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E94\7528\7A0B\5E8F\96C6\5408 %1 \4E2D\4E0D\5B58\5728\6210\5458\5E8F\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115769961414402784)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F\96C6\5408 "%1" \4E2D\4E0D\5B58\5728\6210\5458\5E8F\5217 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841779244402835)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\7CFB\7EDF\4E0A\4E0D\652F\6301\52A0\5BC6\51FD\6570 "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895243512402875)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\6D4B\8BD5\53EF\8BBF\95EE\6027')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789694846402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5173\95ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789723213402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\5B9A\5236\9009\9879')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789887050402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9ED8\8BA4\503C')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789969726402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790012679402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9690\85CF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789417954402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9009\4E2D\6B64\9875\4E0A\8981\5305\542B\7684\533A\57DF\3002\5982\679C\60A8\672A\5728\6B63\786E\7684\5E94\7528\7A0B\5E8F\4E0A\4E0B\6587\4E2D\6216\672A\62E5\6709\9002\5F53\7684\6743\9650, \5219\53EF\80FD\4E0D\663E\793A\9009\4E2D\7684\533A\57DF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789553864402798)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9875\4E0D\53EF\5B9A\5236\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895564602402875)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\53EF\4EE5\901A\8FC7\66F4\6539\4E3B\9898\6837\5F0F\6765\4E2A\6027\5316\6B64\5E94\7528\7A0B\5E8F\7684\5916\89C2\3002\8BF7\4ECE\4EE5\4E0B\5217\8868\4E2D\9009\62E9\4E3B\9898\6837\5F0F, \7136\540E\5355\51FB\201C\5E94\7528\66F4\6539\201D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115896352614402876)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\533A\57DF\663E\793A')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895448782402875)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528\5E94\7528\7A0B\5E8F\9ED8\8BA4\6837\5F0F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115895353668402875)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5916\89C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838370649402832)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\805A\96C6 %0 \4E2D\5F15\7528\7684\5217\7D22\5F15\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115741605914402764)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('CLOB \8F93\51FA\4E0D\652F\6301 %0 \683C\5F0F\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838017803402832)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\5206\9694\5FC5\987B\53D1\751F\5728\5217\6570\7EC4\7684\5F00\5934\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838144940402832)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2D\5F15\7528\7684\5217\7EC4\7D22\5F15\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115755686692402774)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115760819540402777)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4F7F\7528 ORDS \4F5C\4E3A\6253\5370\670D\52A1\5668\65F6\FF0C\5BFC\51FA\683C\5F0F\5FC5\987B\4E3A XML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838453171402833)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7A81\51FA\663E\793A %0 \4E2D\5F15\7528\7684\5217\7D22\5F15\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754128050402773)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BFC\51FA\683C\5F0F\65E0\6548\FF1A%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115838275911402832)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \4E2D\5F15\7528\7684\7236\7EC4\7D22\5F15\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115863495216402851)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0 \8868\7684 %1 \5217\662F "GENERATED ALWAYS" \6807\8BC6\5217\3002\8BF7\786E\4FDD\6CA1\6709\4EFB\4F55\6E90\5217\6620\5C04\5230\201C\914D\7F6E\201D\5BF9\8BDD\6846\4E2D\7684 %1 \5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780819668402791)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\63D0\4EA4\65F6\95F4\95F4\9694\8FC7\77ED\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115780945470402792)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\63D0\4F9B\4EFB\4F55\5217\7528\4E8E\6570\636E\52A0\8F7D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782189021402792)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\53D1\73B0\884C\9009\62E9\5668 "%0" \7684\5217\3002\8BF7\5C1D\8BD5\81EA\52A8\68C0\6D4B\6216\67E5\770B JSON \7ED3\6784\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790466605402798)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 XLSX \6587\4EF6\4E2D\672A\627E\5230\5DE5\4F5C\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790317250402798)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684\5DE5\4F5C\8868\5728 XLSX \6587\4EF6\4E2D\4E0D\5B58\5728\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115770578815402784)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\7528\6237\5F00\59CB\66F4\65B0\8FC7\7A0B\4EE5\540E, \6570\636E\5E93\4E2D\6570\636E\7684\5F53\524D\7248\672C\5DF2\7ECF\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772902013402786)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\66F4\65B0\62A5\8868\5217\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877699981402861)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06 %0 \8F6C\6362\4E3A SDO_GEOMETRY\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817195011402817)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6570\636E\7C7B\578B\4E3A %1 \7684\5217 %0 \65E0\6CD5\8F6C\6362\4E3A VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824166546402822)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\6570\636E\6E90\4E2D\627E\4E0D\5230\4E3A\5C5E\6027 "%1" \6307\5B9A\7684\5217 "%0"!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765498208402781)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\503C\5217\4E0D\652F\6301\8FC7\6EE4\5668\7C7B\578B %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115881085525402864)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\201C\4ECB\4E8E\201D\8FC7\6EE4\5668\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747592303402768)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6307\5B9A\7684 LOV \7C7B\578B\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747447038402768)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\7C7B\578B\65E0\6548\3002\67E5\8BE2\7C7B\578B\5FC5\987B\662F\8868\3001SQL \67E5\8BE2\FF0C\6216\8005\662F\8FD4\56DE SQL \67E5\8BE2\7684 PL/SQL \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817269647402817)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\5BF9 SQL \67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790!'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824269008402822)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \8BED\53E5\4E2D\627E\4E0D\5230\4E3A\5C5E\6027 "%1" \6307\5B9A\7684\5217\4F4D\7F6E %0!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115746081752402767)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\591A\503C\8FC7\6EE4\5668\4E2D\4F7F\7528\7684\9879\592A\591A\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824043356402822)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\5C5E\6027 "%0" \6307\5B9A\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747393601402768)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('PL/SQL \51FD\6570\6B63\6587\672A\8FD4\56DE\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115837279825402832)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\4E0D\5305\542B\7528\4E8E\5904\7406\8BF7\6C42\7684 DML \64CD\4F5C\7684\64CD\4F5C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115743222627402765)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('GeoJSON \81F3 SDO_GEOMETRY \8F6C\6362\FF08\5217 %0\FF09\5728\6B64\6570\636E\5E93\4E2D\4E0D\53EF\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744320373402765)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('XML \6570\636E\6E90\4E0D\652F\6301 SDO_GEOMETRY \8F6C\6362\FF08\5217 %0\FF09\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115751628553402771)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\5C06\5B57\7B26 %0 \7528\4F5C\591A\503C\5206\9694\7B26\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115878991640402863)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\529F\80FD\4E0D\80FD\7528\4E8E\67E5\8BE2\4E0A\4E0B\6587\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115744481180402766)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\6570\636E\7C7B\578B\4E0D\5339\914D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747274147402768)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8D85\51FA\4E86\5185\90E8 ORDS OUT \7ED1\5B9A\9650\5236\3002\8BF7\51CF\5C11 DML \884C\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115825076110402823)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\5BF9\6765\81EA\8FDC\7A0B\670D\52A1\5668\7684 JSON \54CD\5E94\8FDB\884C\8BED\6CD5\5206\6790: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115747159420402768)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0A\4E0B\6587\7C7B\578B\672A\77E5\6216\9519\8BEF\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115841660709402835)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BED\6CD5\5206\6790\5668\4E0D\652F\6301\6B64\6587\4EF6\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796284442402802)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\672A\6388\6743\8BBF\95EE (\672A\8BBE\7F6E wwv_flow_api.set_credentials)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773235791402786)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DE5\4F5C\533A\5DF2\5B58\5728, \56E0\6B64\672A\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115773160315402786)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\7EC4\5DF2\5B58\5728, \56E0\6B64\672A\521B\5EFA\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783462030402793)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\5230 %0 \7684\91CD\590D\7528\6237\540D\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783596270402793)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\52A0\8F7D\7528\6237\65F6\51FA\9519\3002\7528\6237 %0 \5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793413103402801)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5DF2\52A0\8F7D %0 \4E2A\7528\6237\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793205697402800)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5BC6\7801')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793365033402800)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6743\9650')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793040887402800)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7528\6237\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869520712402855)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\9875\9879 #COMPONENT_NAME# \65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789182418402798)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7531\4E8E\5C1A\672A\6253\5F00 HTML \8868\5355, \65E0\6CD5\663E\793A\9875\9879\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115754411316402773)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\9875\9879 #COMPONENT_NAME# \7684\9879\9ED8\8BA4\503C\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788442375402797)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9875\9879 #COMPONENT_NAME# \7684\9879\8BA1\7B97\540E\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788355180402797)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\9875\9879 #COMPONENT_NAME# \7684\9879\6E90\503C\65F6\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768143300402783)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BBF\95EE\672A\83B7\6388\6743\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788609623402797)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301 JavaScript\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788731466402797)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5217\8868')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115789386899402798)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\521D\59CB\5316\67E5\8BE2\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796506938402803)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E0D\652F\6301\66F4\65B0 %0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115790722925402799)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6548\7684\9879 ID: %0 ')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115817005844402817)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\9879\4E0D\5B58\5728\5E2E\52A9\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781549121402792)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\751F\6210\56FE\8868\67E5\8BE2\5931\8D25\3002\8BF7\68C0\67E5\6E90\548C\5217\6620\5C04\8BBE\7F6E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876340367402860)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\5C0F\4E3A %0 MB \7684\9644\4EF6\8D85\8FC7\4E86\6700\5927\9644\4EF6\5927\5C0F (%1 MB)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782495313402793)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\53C2\6570 p_mail_id \63D0\4F9B\7684\503C\65E0\6548: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115899885842402878)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8D85\8FC7\4E86\6BCF\4E2A\5DE5\4F5C\533A\7684\6700\5927\7535\5B50\90AE\4EF6\6570\3002\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763458910402779)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4ECE\5E94\7528\7A0B\5E8F\4F1A\8BDD\4E2D\8C03\7528\6B64\8FC7\7A0B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782333854402793)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\53C2\6570 %0 \63D0\4F9B\4E86\7A7A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836399911402831)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728\5E94\7528\7A0B\5E8F %1 \4E2D\672A\627E\5230\7535\5B50\90AE\4EF6\6A21\677F "%0"\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115912879023402888)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\8BBE\7F6E SMTP_HOST_ADDRESS \5B9E\4F8B\53C2\6570\4EE5\4FBF\53D1\9001\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782097996402792)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\63D0\4F9B\6536\4EF6\4EBA\624D\80FD\53D1\9001\90AE\4EF6\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115902268867402880)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\4E0E\914D\7F6E\7684\7535\5B50\90AE\4EF6\670D\52A1\5668\5EFA\7ACB SMTP \8FDE\63A5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115876495570402860)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('Ajax \8C03\7528\65E0\6548!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767874375402782)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\63D2\4EF6%0\5B9A\4E49 Ajax \51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866804969402853)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\63D2\4EF6%0\5B9A\4E49\6267\884C\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767914607402782)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\63D2\4EF6%0\5B9A\4E49\5448\73B0\51FD\6570')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877319986402861)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\63D2\4EF6 "%0" \4E0D\5305\542B\201C\529F\80FD\201D\51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877262417402861)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\63D2\4EF6 "%0" \4E0D\5305\542B DML \51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877470901402861)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\63D2\4EF6 "%0" \4E0D\5305\542B\6267\884C\51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115877599298402861)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('REST \6570\636E\6E90\63D2\4EF6 "%0" \4E0D\5305\542B\63D0\53D6\51FD\6570\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765696638402781)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D2\4EF6\5904\7406\671F\95F4\5F15\53D1\7684 PLSQL \4EE3\7801\4E2D\51FA\9519\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772259995402785)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\6307\5B9A\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802817676402807)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5C06\6570\636E\7C7B\578B %0 \8F6C\6362\4E3A VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888493579402870)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 SQL \8BED\53E5\4E2D\627E\4E0D\5230\4E3A\5C5E\6027 "%1" \6307\5B9A\7684\5217 "%0"!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864756778402851)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5FC5\987B\4E3A%0\6307\5B9A\503C\5217\8868 (LOV) \67E5\8BE2\6216\547D\540D\7684\503C\5217\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115866385680402853)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728%0\7684 LOV SQL \67E5\8BE2\4E2D\9009\62E9\4E86\9519\8BEF\7684\5217\6570\3002\8BF7\53C2\9605\793A\4F8B\4EE5\4E86\89E3\6709\6548\7684\8BED\53E5\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888266109402870)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6CA1\6709\4E3A\5C5E\6027 "%0" \6307\5B9A\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917953091402891)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\5C5E\6027 "%1" \8F93\5165\7684\503C %0 \4E0D\662F\6570\5B57\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115869891679402855)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('%0\7684 SQL \8BED\53E5\4E2D\7684\6570\636E\7C7B\578B\9519\8BEF\3002\5217\53F7 %1 \4E3A %2, \4F46\5E94\4E3A %3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115888393616402870)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\4E3A\5C5E\6027 "%1" \6307\5B9A\7684\5217 "%0" \5177\6709\6570\636E\7C7B\578B %2, \4F46\5E94\4E3A %3\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115764973794402780)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\627E\4E0D\5230\62A5\8868\5E03\5C40\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824927159402823)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BA1\7B97\603B\548C\529F\80FD\65E0\6CD5\7528\4E8E\57FA\4E8E REST \6570\636E\6E90\7684\62A5\8868\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115788534015402797)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('ERR-2904 \65E0\6CD5\8BBE\7F6E\5FEB\6377\65B9\5F0F\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115792856508402800)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9519\8BEF: \672A\77E5\7684\5FEB\6377\65B9\5F0F\7C7B\578B\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115782839455402793)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\63D0\53D6\5E94\7528\7A0B\5E8F %0 \4E2D\7684 authentication_scheme\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115856343972402845)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\4F1A\8BDD\5DF2\5B58\5728\8BE5\79DF\6237 ID\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115793176350402800)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\7535\5B50\90AE\4EF6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917314490402891)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\9A8C\8BC1\5931\8D25\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115819666392402819)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5728 apex_util.g_request_cookies \4E2D\8BBE\7F6E\7684\4E00\4E2A\6216\591A\4E2A cookie \5305\542B\65E0\6548\503C\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115802139898402807)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6765\81EA UDDI \6CE8\518C\8868\7684\54CD\5E94\65E0\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115765740029402781)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\4F9B\7684 URL \672A\8FD4\56DE\6709\6548\7684 WSDL \6587\6863\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115768226087402783)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('WSDL \6587\6863\5305\542B\591A\4E2A SOAP \7ED1\5B9A\3002&PRODUCT_NAME. \53EA\652F\6301 WSDL \5177\6709\4E00\4E2A SOAP \7ED1\5B9A\3002\5355\51FB\201C\624B\52A8\521B\5EFA Web \670D\52A1\5F15\7528\201D\53EF\7EE7\7EED\4E3A\6B64\670D\52A1\521B\5EFA\5F15\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115836657093402831)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6765\81EA\670D\52A1\7684\54CD\5E94\4E0D\662F XML\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917231591402891)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('OAuth \8BBF\95EE\4EE4\724C\4E0D\53EF\7528\6216\5DF2\5931\6548\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115880454934402864)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\60A8\5DF2\8D85\8FC7\4E86\6BCF\4E2A\5DE5\4F5C\533A\7684\6700\5927 Web \670D\52A1\8BF7\6C42\6570\3002\8BF7\4E0E\7BA1\7406\5458\8054\7CFB\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115917407612402891)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\670D\52A1\5668\4F7F\7528\4E0D\652F\6301\7684 OAuth \4EE4\724C\7C7B\578B\505A\51FA\4E86\54CD\5E94\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767662286402782)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('WSDL \6587\6863\4E0D\5305\542B SOAP \7ED1\5B9A, \800C\5B83\662F\6DFB\52A0\5F15\7528\6240\5FC5\9700\7684\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115763538141402779)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64 WSDL \9700\8981\9A8C\8BC1\8EAB\4EFD\8BC1\660E\3002\8BF7\5728\4E0B\9762\63D0\4F9B\7528\6237\540D\548C\5BC6\7801\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115772369378402786)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5448\73B0\5F15\64CE\65E0\6CD5\7406\89E3 WSDL \6587\6863\3002\5355\51FB\201C\624B\52A8\521B\5EFA Web \670D\52A1\5F15\7528\201D\53EF\7EE7\7EED\4E3A\6B64\670D\52A1\521B\5EFA\5F15\7528\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115839279851402833)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\65E0\6CD5\5904\7406\66F4\65B0\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115865014741402852)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\7684\8FD4\56DE\5217\548C\663E\793A\5217\76F8\540C!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115864979983402852)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\503C\5217\8868\6CA1\6709\8FD4\56DE\5217\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796447670402803)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\63D0\53D6\5217\503C\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820400927402820)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5F53\524D\8868\683C\5F0F\8868\5355\6570\636E\592A\65E7; \6E90\6570\636E\5DF2\7ECF\8FC7\4FEE\6539\3002<br/>\5355\51FB<strong><a href="%0">\6B64\5904</a></strong>\53EF\653E\5F03\6240\505A\7684\66F4\6539\5E76\4ECE\6570\636E\5E93\4E2D\91CD\65B0\52A0\8F7D\6570\636E\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778547941402790)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\786E\5B9A\9875\7801\5B57\7B26\4E32\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778439225402790)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\786E\5B9A\67E5\8BE2\6807\9898:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778601566402790)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6267\884C\62A5\8868\9875\811A\66FF\6362\65F6\51FA\9519')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778794145402790)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\65E0\6CD5\5BF9 SQL \67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783766213402794)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\8BF7\6C42\7684\6700\5C0F\884C\6570\FF1A%0\FF0C\627E\5230\4F46\672A\663E\793A\884C\6570\FF1A%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781249710402792)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\5217 #%0 (%1) \65E0\6548, \4F7F\7528 HTML \7684\5217\9700\8981\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115796371856402803)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\83B7\53D6\67E5\8BE2\6807\9898\65F6\51FA\9519: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778869897402790)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\62A5\8868\9519\8BEF\FF1A'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115816519693402817)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6309\6B64\5217\6392\5E8F')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781378434402792)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'zh-cn'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\65E0\6CD5\5BF9\67E5\8BE2\8FDB\884C\8BED\6CD5\5206\6790, \8BF7\68C0\67E5\67E5\8BE2\7684\8BED\6CD5\3002(%0)'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820564620402820)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6B64\8868\5355\5305\542B\672A\4FDD\5B58\7684\66F4\6539\3002\6309 "\786E\5B9A" \53EF\7EE7\7EED\800C\4E0D\4FDD\5B58\6240\505A\7684\66F4\6539\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115824843924402823)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\6240\9009\6570\636E\6E90\4E0D\652F\6301\62A5\8868\5206\9875\65B9\6848 (%0)\3002')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115781188870402792)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\67E5\8BE2\5217 #%0 (%1) \65E0\6548, \8BF7\4F7F\7528\5217\522B\540D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783893263402794)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\4E8E %2 \7684\884C %0 - %1 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115822518654402821)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5927\4E8E %2 \7684 %0 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115783638051402794)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\884C %0 - %1\FF08\5171 %2 \884C\FF09')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115767504535402782)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'zh-cn'
,p_message_text=>'%0 - %1/%2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778922460402790)
,p_name=>'Y'
,p_message_language=>'zh-cn'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115785048976402795)
,p_name=>'YEAR'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115778172386402790)
,p_name=>'YEARS'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\5E74')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(115820663959402820)
,p_name=>'YES'
,p_message_language=>'zh-cn'
,p_message_text=>unistr('\662F')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4476)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4476)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>unistr('\684C\9762')
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4476
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4476)
,p_name=>unistr('\6D88\606F')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\6D88\606F')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
